//@ui5-bundle sap/m/library-preload.js
/*
 * ! OpenUI5
 * (c) Copyright 2009-2019 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/ColumnHeaderPopover',['sap/ui/core/Control','sap/ui/model/base/ManagedObjectModel','sap/m/Toolbar','sap/m/ResponsivePopover','sap/m/Button','sap/m/ToggleButton','sap/m/ToolbarSpacer','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/dom/containsOrEquals','sap/m/ColumnPopoverItem','sap/m/StandardListItem','sap/m/List'],function(C,M,T,R,B,a,b,F,c,d,e,S,L){"use strict";
var f=C.extend("sap.m.ColumnHeaderPopover",{
library:"sap.m",
metadata:{properties:{},aggregations:{items:{type:"sap.m.ColumnPopoverItem",multiple:true,singularName:"item",bindable:true},_popover:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},defaultAggregation:"items",associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}
});
f.prototype.init=function(){this._bPopoverCreated=false;this._oShownCustomContent=null;};
f.prototype.exit=function(){this._oToolbar=null;};
f.prototype._createPopover=function(){var t=this;this._oShownCustomContent=null;var o=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=o.getText("COLUMNHEADERPOPOVER_CLOSE_BUTTON");var p=new R(this.getId()+"-popover",{showArrow:false,showHeader:false,placement:"Bottom",verticalScrolling:true,horizontalScrolling:false,ariaLabelledBy:this.getAriaLabelledBy(),beforeClose:function(E){if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);t._oShownCustomContent=null;}t._cleanSelection(this);}});this.setAggregation("_popover",p);var g=new T(this.getId()+"-tb");p.addContent(g);var h=new F({path:"visible",operator:c.EQ,value1:true});var i=function(j,k){var I=k.getObject();var l;if(I.isA("sap.m.ColumnPopoverActionItem")){l=t._createActionItem(j,I);}else if(I.isA("sap.m.ColumnPopoverCustomItem")){l=t._createCustomItem(j,I);}else if(I.isA("sap.m.ColumnPopoverSortItem")){l=t._createSortItem(j,I);}I._sRelatedId=l.sId;l._sContentId=I._sContentId;l.destroy=function(){var D=this.getDomRef();if(D&&d(D,document.activeElement)){p.focus();p.removeContent(t._oShownCustomContent);}this.constructor.prototype.destroy.apply(this,arguments);};return l;};g.bindAggregation("content",{path:'/items',filters:[h],length:5,factory:i});g.updateAggregation=function(A){if(this._oShownCustomContent){this._oShownCustomContent=null;}T.prototype.updateAggregation.apply(this,arguments);var j=this.getContent();if(j.length<=2||!(j[j.length-2]instanceof b)){this.addContent(new b());this.addContent(new B({type:"Transparent",icon:"sap-icon://decline",tooltip:s,press:[p.close,p]}));}};var m=new M(this);g.setModel(m);this._oToolbar=g;};
f.prototype._createActionItem=function(i,I){var t=this;return new B(i,{icon:"{icon}",tooltip:"{text}",type:"Transparent",visible:"{visible}",press:function(){var p=t.getAggregation("_popover");if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);t._oShownCustomContent=null;t._cleanSelection(p,this);}I.firePress();}});};
f.prototype._createCustomItem=function(i,I){var t=this;var p=this.getAggregation("_popover");var o=I.getContent();if(o){o.setVisible(false);I._sContentId=o.sId;}p.addContent(o);return new a(i,{icon:"{icon}",type:"Transparent",tooltip:"{text}",visible:"{visible}",press:function(){if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);}if(this.getPressed()){t._cleanSelection(p,this);I.fireBeforeShowContent();if(o){o.setVisible(true);t._oShownCustomContent=o;}}else{if(o){o.setVisible(false);t._oShownCustomContent=null;}}}});};
f.prototype._createSortItem=function(g,I){var t=this;var o=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=o.getText("COLUMNHEADERPOPOVER_SORT_BUTTON");var h=I.getSortChildren();if(h.length>1){var p=this.getAggregation("_popover");var l=new L();for(var i=0;i<h.length;i++){var j=new S({title:h[i].getText(),type:"Active"});l.addItem(j);j.data("key",h[i].getKey());}l.attachEvent("itemPress",function(E){p.close();var j=E.getParameter("listItem");I.fireSort({property:j.data("key")});});l.setVisible(false);p.addContent(l);return new a(g,{icon:"sap-icon://sort",type:"Transparent",tooltip:s,visible:"{visible}",press:function(){if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);}if(this.getPressed()){t._cleanSelection(p,this);if(l){l.setVisible(true);t._oShownCustomContent=l;}}else{if(l){l.setVisible(false);t._oShownCustomContent=null;}}}});}else{return new B(g,{icon:"sap-icon://sort",type:"Transparent",tooltip:s,visible:"{visible}",press:function(){var p=t.getAggregation("_popover");if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);t._oShownCustomContent=null;t._cleanSelection(p,this);}p.close();I.fireSort({property:h[0]?h[0].getKey():null});}});}};
f.prototype._cleanSelection=function(p,o){var g=p.getContent()[0],h;h=g.getContent();if(h){h.forEach(function(i){if((!o||i!==o)&&i.getPressed&&i.getPressed()){i.setPressed(false);}});}};
f.prototype.openBy=function(o){if(!this._bPopoverCreated){this._createPopover();this._bPopoverCreated=true;}else{this._oToolbar.getBinding("content").refresh(true);}var p=this.getAggregation("_popover");if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}var O=o.getFocusDomRef();if(O){p.setOffsetY(-O.clientHeight);p.setContentWidth(O.clientWidth>128?O.clientWidth+"px":"128px");}p.openBy(o);};
f.prototype.invalidate=function(o){var p=this.getAggregation("_popover");if(o===p){C.prototype.invalidate.apply(this,arguments);}return this;};
f.prototype.addAssociation=function(A,i,s){if(A==="ariaLabelledBy"){var r=this.getAggregation("_popover");r&&r.addAssociation(A,i,s);}return C.prototype.addAssociation.apply(this,arguments);};
f.prototype.removeAssociation=function(A,o,s){if(A==="ariaLabelledBy"){var r=this.getAggregation("_popover");r&&r.removeAssociation(A,o,s);}return C.prototype.removeAssociation.apply(this,arguments);};
f.prototype.removeAllAssociation=function(A,s){if(A==="ariaLabelledBy"){var r=this.getAggregation("_popover");r&&r.removeAllAssociation(A,s);}return C.prototype.removeAllAssociation.apply(this,arguments);};
return f;});
sap.ui.predefine('sap/m/ColumnPopoverActionItem',['./ColumnPopoverItem'],function(C){"use strict";
var a=C.extend("sap.m.ColumnPopoverActionItem",{
library:"sap.m",
metadata:{properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null}},events:{press:{}}}
});
return a;});
sap.ui.predefine('sap/m/ColumnPopoverCustomItem',['./ColumnPopoverItem'],function(C){"use strict";
var a=C.extend("sap.m.ColumnPopoverCustomItem",{
library:"sap.m",
metadata:{properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:false,singularName:"content"}},events:{beforeShowContent:{}}}
});
return a;});
sap.ui.predefine('sap/m/ColumnPopoverItem',['sap/ui/core/Element'],function(E){"use strict";
var C=E.extend("sap.m.ColumnPopoverItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Misc",defaultValue:true}}}});
return C;});
sap.ui.predefine('sap/m/ColumnPopoverSortItem',['./ColumnPopoverItem'],function(C){"use strict";
var a=C.extend("sap.m.ColumnPopoverSortItem",{
library:"sap.m",
metadata:{properties:{label:{type:"string",group:"Misc",defaultValue:null}},events:{sort:{parameters:{property:{type:"string"}}}},aggregations:{sortChildren:{type:"sap.ui.core.Item",multiple:true,singularName:"sortChild",bindable:true}}}
});
return a;});
sap.ui.predefine('sap/m/CustomTreeItem',['./TreeItemBase','./ListItemBase','./library',"./CustomTreeItemRenderer"],function(T,L,l,C){"use strict";
var a=T.extend("sap.m.CustomTreeItem",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}}}});
a.prototype.getContentAnnouncement=function(){return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return a;});
sap.ui.predefine('sap/m/CustomTreeItemRenderer',['./TreeItemBaseRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var C=R.extend(T);
C.renderLIAttributes=function(r,l){r.addClass("sapMCTI");T.renderLIAttributes.apply(this,arguments);};
C.renderLIContent=function(r,l){l.getContent().forEach(function(c){r.renderControl(c);});};
return C;},true);
sap.ui.predefine('sap/m/P13nAnyFilterItem',['./library','sap/m/P13nFilterItem'],function(l,P){"use strict";
var a=P.extend("sap.m.P13nAnyFilterItem",{metadata:{library:"sap.m",properties:{value1:{type:"any",group:"Misc",defaultValue:null},value2:{type:"any",group:"Misc",defaultValue:null}}}});
return a;});
sap.ui.predefine('sap/m/P13nColumnsItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nColumnsItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Misc"},index:{type:"int",group:"Appearance"},visible:{type:"boolean",group:"Appearance"},width:{type:"string",group:"Misc"},total:{type:"boolean"}}}});
return P;});
sap.ui.predefine('sap/m/P13nColumnsPanel',['sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler','sap/ui/core/IconPool','./library','./Table','./Column','./ColumnListItem','./P13nPanel','./P13nColumnsItem','./SearchField','./ScrollContainer','./Text','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./OverflowToolbarButton','./ToolbarSpacer',"sap/ui/thirdparty/jquery"],function(C,c,J,B,R,I,l,T,d,e,P,f,S,g,h,i,O,j,k,m,q){"use strict";var n=l.OverflowToolbarPriority;var o=l.ButtonType;var p=l.ToolbarDesign;var L=l.ListType;var r=l.ListMode;var s=l.P13nPanelType;
var t=P.extend("sap.m.P13nColumnsPanel",{
metadata:{library:"sap.m",properties:{visibleItemsThreshold:{type:"int",group:"Behavior",defaultValue:-1}},aggregations:{columnsItems:{type:"sap.m.P13nColumnsItem",multiple:true,singularName:"columnsItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{addColumnsItem:{parameters:{newItem:{type:"sap.m.P13nColumnsItem"}}},changeColumnsItems:{parameters:{newItems:{type:"sap.m.P13nColumnsItem[]"},existingItems:{type:"sap.m.P13nColumnsItem[]"},items:{type:"object[]"}}},setData:{}}},
renderer:function(a,b){a.write("<div");a.writeControlData(b);a.addClass("sapMP13nColumnsPanel");a.writeClasses();a.write(">");var u=b.getAggregation("content");if(u){u.forEach(function(v){a.renderControl(v);});}a.write("</div>");}
});
t.prototype.init=function(){this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bTableItemsChanged=false;this._bOnAfterRenderingFirstTimeExecuted=false;var M=new J({items:[],columnKeyOfMarkedItem:undefined,isMoveDownButtonEnabled:undefined,isMoveUpButtonEnabled:undefined,showOnlySelectedItems:undefined,countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(B.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nColumnsPanel");this.setType(s.columns);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("COLUMSPANEL_TITLE"));this._createTable();this._createToolbar();this.setVerticalScrolling(false);var a=new g({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",a);var b=this;this._fnHandleResize=function(){var u=false,v,w;if(b.getParent){var $=null,x,H;var y=b.getParent();var z=b._getToolbar();if(y&&y.$){$=y.$("cont");if($.children().length>0&&z.$().length>0){v=a.$()[0].clientHeight;x=$.children()[0].clientHeight;H=z?z.$()[0].clientHeight:0;w=x-H;if(v!==w){a.setHeight(w+'px');u=true;}}}}return u;};this._sContainerResizeListener=R.register(a,this._fnHandleResize);};
t.prototype.reInitialize=function(){};
t.prototype.onBeforeRendering=function(){this._updateInternalModel();if(!this._getInternalModel().getProperty("/columnKeyOfMarkedItem")){this._setColumnKeyOfMarkedItem(this._getColumnKeyByTableItem(this._getVisibleTableItems()[0]));}this._switchMarkedTableItemTo(this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem")));this._updateControlLogic();};
t.prototype.onAfterRendering=function(){if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);var a=this;this._iLiveChangeTimer=window.setTimeout(function(){a._fnHandleResize();},0);}};
t.prototype.getOkPayload=function(){this._updateInternalModel();var M=this._getInternalModel().getProperty("/items");return{tableItems:M.map(function(a){return{columnKey:a.columnKey,index:a.persistentIndex===-1?undefined:a.persistentIndex,visible:a.persistentSelected,width:a.width};}),tableItemsChanged:this._bTableItemsChanged,selectedItems:M.filter(function(a){return a.persistentSelected;}).map(function(a){return{columnKey:a.columnKey};})};};
t.prototype.getResetPayload=function(){return{oPanel:this};};
t.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
t.prototype.addItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",a);return this;};
t.prototype.insertItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",a,b);return this;};
t.prototype.removeItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}a=this.removeAggregation("items",a);return a;};
t.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
t.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
t.prototype.addColumnsItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("columnsItems",a);return this;};
t.prototype.insertColumnsItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("columnsItems",a,b);return this;};
t.prototype.updateColumnsItems=function(a){this.updateAggregation("columnsItems");if(a===c.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
t.prototype.removeColumnsItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("columnsItems",a);};
t.prototype.removeAllColumnsItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("columnsItems");};
t.prototype.destroyColumnsItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("columnsItems");return this;};
t.prototype.onBeforeNavigationFrom=function(){var M=this._getSelectedModelItems();var v=this.getVisibleItemsThreshold();return!(M&&v!==-1&&M.length>v);};
t.prototype._notifyChange=function(){this._bTableItemsChanged=true;var a=this.getChangeNotifier();if(a){a(this);}};
t.prototype._scrollToSelectedItem=function(a){if(!a){return;}sap.ui.getCore().applyChanges();};
t.prototype._getInternalModel=function(){return this.getModel("$sapmP13nColumnsPanel");};
t.prototype._createTable=function(){this._oTable=new T({mode:r.MultiSelect,rememberSelections:false,itemPress:q.proxy(this._onItemPressed,this),selectionChange:q.proxy(this._onSelectionChange,this),columns:[new d({vAlign:C.VerticalAlign.Middle,header:new h({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(a,b){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[a,b]);}}})})],items:{path:"/items",templateShareable:false,template:new e({cells:[new h({text:"{text}"})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:L.Active})}});this._oTable.setModel(this._getInternalModel());};
t.prototype._createToolbar=function(){var a=this;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var u=new O(this.getId()+"-toolbar",{design:p.Auto,content:[new m(),new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(a._iSearchTimer);if(D){a._iSearchTimer=window.setTimeout(function(){a._onExecuteSearch();},D);}else{a._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new j({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})}),new i({text:{path:'/showOnlySelectedItems',formatter:function(v){return v?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},tooltip:{path:'/showOnlySelectedItems',formatter:function(v){return v?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},type:o.Transparent,press:q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new j({moveToOverflow:true,priority:n.High})}),new k({icon:I.getIconURI("collapse-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),type:o.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:q.proxy(this.onPressButtonMoveToTop,this),layoutData:new j({moveToOverflow:true,priority:n.Low,group:2})}),new k({icon:I.getIconURI("slim-arrow-up"),text:b.getText('COLUMNSPANEL_MOVE_UP'),tooltip:b.getText('COLUMNSPANEL_MOVE_UP'),type:o.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:q.proxy(this.onPressButtonMoveUp,this),layoutData:new j({moveToOverflow:true,priority:n.High,group:1})}),new k({icon:I.getIconURI("slim-arrow-down"),text:b.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:b.getText('COLUMNSPANEL_MOVE_DOWN'),type:o.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:q.proxy(this.onPressButtonMoveDown,this),layoutData:new j({moveToOverflow:true,priority:n.High,group:1})}),new k({icon:I.getIconURI("expand-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),type:o.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:q.proxy(this.onPressButtonMoveToBottom,this),layoutData:new j({moveToOverflow:true,priority:n.Low,group:2})})]});u.setModel(this._getInternalModel());this.addAggregation("content",u);};
t.prototype.onPressButtonMoveToTop=function(){this._moveMarkedTableItem(this._getMarkedTableItem(),this._getVisibleTableItems()[0]);};
t.prototype.onPressButtonMoveUp=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.indexOf(this._getMarkedTableItem())-1]);};
t.prototype.onPressButtonMoveDown=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.indexOf(this._getMarkedTableItem())+1]);};
t.prototype.onPressButtonMoveToBottom=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.length-1]);};
t.prototype._onSwitchButtonShowSelected=function(){this._getInternalModel().setProperty("/showOnlySelectedItems",!this._getInternalModel().getProperty("/showOnlySelectedItems"));this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fnHandleResize();};
t.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
t.prototype._switchVisibilityOfUnselectedModelItems=function(){var b=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(a){if(a.persistentSelected){a.visible=true;return;}a.visible=!b;});this._getInternalModel().setProperty("/items",M);};
t.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
t.prototype._moveMarkedTableItem=function(a,b){var M=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(a));var u=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(b));var v=this._getModelItemIndexByColumnKey(M.columnKey);var w=this._getModelItemIndexByColumnKey(u.columnKey);this._moveModelItems(v,w);this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fireChangeColumnsItems();this._fireSetData();this._notifyChange();};
t.prototype._moveModelItems=function(a,b){var M=this._getInternalModel().getProperty("/items");if(a<0||b<0||a>M.length-1||b>M.length-1){return false;}this._removeStyleOfMarkedTableItem();var u=M.splice(a,1);M.splice(b,0,u[0]);this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());return true;};
t.prototype._getModelItemByColumnKey=function(a){var M=this._getInternalModel().getProperty("/items").filter(function(b){return b.columnKey===a;});return M[0];};
t.prototype._updateCounts=function(M){var a=0;var b=0;M.forEach(function(u){a++;if(u.persistentSelected){b++;}});this._getInternalModel().setProperty("/countOfItems",a);this._getInternalModel().setProperty("/countOfSelectedItems",b);};
t.prototype._sortModelItemsByPersistentIndex=function(M){var u;var v;try{v=sap.ui.getCore().getConfiguration().getLocale().toString();if(typeof window.Intl!=='undefined'){u=window.Intl.Collator(v,{numeric:true});}}catch(E){}M.forEach(function(a,b){a.localIndex=b;});M.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex>-1&&a.persistentIndex<b.persistentIndex){return-1;}else if(b.persistentIndex>-1&&a.persistentIndex>b.persistentIndex){return 1;}else{return a.localIndex-b.localIndex;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){return u?u.compare(a.text,b.text):a.text.localeCompare(b.text,v,{numeric:true});}});M.forEach(function(a){delete a.localIndex;});};
t.prototype._getColumnKeyByTableItem=function(a){var b=this._oTable.indexOfItem(a);if(b<0){return null;}return this._oTable.getBinding("items").getContexts()[b].getObject().columnKey;};
t.prototype._getModelItemIndexByColumnKey=function(a){var b=-1;this._getInternalModel().getProperty("/items").some(function(M,u){if(M.columnKey===a){b=u;return true;}});return b;};
t.prototype._getSelectedModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return M.persistentSelected;});};
t.prototype._getVisibleTableItems=function(){return this._oTable.getItems().filter(function(a){return a.getVisible();});};
t.prototype._getTableItemByColumnKey=function(a){var b=this._oTable.getBinding("items").getContexts();var u=this._oTable.getItems().filter(function(v,w){return b[w].getObject().columnKey===a;});return u[0];};
t.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
t.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
t.prototype._getSearchText=function(){var a=this._getSearchField();return a?a.getValue():"";};
t.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
t.prototype._isFilteredByShowSelected=function(){return this._getInternalModel().getData().showOnlySelectedItems;};
t.prototype._updateControlLogic=function(){var b=this._isFilteredBySearchText();var a=this._isFilteredByShowSelected();var v=this._getVisibleTableItems();this._getInternalModel().setProperty("/isMoveUpButtonEnabled",v.indexOf(this._getMarkedTableItem())>0);this._getInternalModel().setProperty("/isMoveDownButtonEnabled",v.indexOf(this._getMarkedTableItem())>-1&&v.indexOf(this._getMarkedTableItem())<v.length-1);var u=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(u){u.setEnabled(!b&&!a);}};
t.prototype._updateModelItemsPersistentIndex=function(M){var a=-1;M.forEach(function(b){b.persistentIndex=-1;if(b.persistentSelected){a++;b.persistentIndex=a;}});};
t.prototype._fireSetData=function(){this._bIgnoreUpdateInternalModel=true;this.fireSetData();this._bIgnoreUpdateInternalModel=false;};
t.prototype._fireChangeColumnsItems=function(){this._bIgnoreUpdateInternalModel=true;var M=this._getInternalModel().getProperty("/items");var E={newItems:[],existingItems:[],items:M.map(function(a){return{columnKey:a.columnKey,visible:a.persistentSelected,index:a.persistentIndex===-1?undefined:a.persistentIndex,width:a.width,total:a.total};})};M.forEach(function(a){var b=this._getColumnsItemByColumnKey(a.columnKey);if(b){b.setVisible(a.persistentSelected);b.setIndex(a.persistentIndex===-1?undefined:a.persistentIndex);if(a.width!==undefined){b.setWidth(a.width);}if(a.total!==undefined){b.setTotal(a.total);}E.existingItems.push(b);}else{E.newItems.push(new f({columnKey:a.columnKey,visible:a.persistentSelected,index:a.persistentIndex===-1?undefined:a.persistentIndex,width:a.width,total:a.total}));}},this);this.fireChangeColumnsItems(E);this._bIgnoreUpdateInternalModel=false;};
t.prototype._getColumnsItemByColumnKey=function(a){var b=this.getColumnsItems().filter(function(u){return u.getColumnKey()===a;});return b[0];};
t.prototype._getMarkedTableItem=function(){return this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem"));};
t.prototype._setColumnKeyOfMarkedItem=function(a){this._getInternalModel().setProperty("/columnKeyOfMarkedItem",a);};
t.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));this._updateControlLogic();};
t.prototype._onSelectionChange=function(E){if(!E.getParameter("selectAll")&&E.getParameter("listItems").length===1){this._switchMarkedTableItemTo(E.getParameter("listItem"));}this._selectTableItem();};
t.prototype._selectTableItem=function(){this._updateControlLogic();var M=this._getInternalModel().getProperty("/items");this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeColumnsItems();this._fireSetData();this._notifyChange();var v=this.getValidationExecutor();if(v){v();}};
t.prototype._switchMarkedTableItemTo=function(a){this._removeStyleOfMarkedTableItem();var b=this._getColumnKeyByTableItem(a);if(b){this._setColumnKeyOfMarkedItem(b);a.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
t.prototype._removeStyleOfMarkedTableItem=function(){if(this._getMarkedTableItem()){this._getMarkedTableItem().removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
t.prototype._filterModelItemsBySearchText=function(){var a=this._getSearchText();a=a.replace(/(^\s+)|(\s+$)/g,'');a=a.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var b=new RegExp(a,'igm');if(!b){return;}this._getVisibleModelItems().forEach(function(M){M.visible=false;if(typeof M.text==="string"&&M.text.match(b)){M.visible=true;}if(typeof M.tooltip==="string"&&M.tooltip.match(b)){M.visible=true;}});this._getInternalModel().refresh();};
t.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._removeStyleOfMarkedTableItem();var M=this._getInternalModel().getProperty("/items");this._getInternalModel().setProperty("/items",this.getItems().map(function(b){return{columnKey:b.getColumnKey(),visible:true,text:b.getText(),tooltip:b.getTooltip(),persistentIndex:-1,persistentSelected:b.getVisible(),width:undefined,total:undefined};},this));this.getColumnsItems().forEach(function(b){var u=this._getModelItemByColumnKey(b.getColumnKey());if(!u){return;}if(b.getIndex()!==undefined){u.persistentIndex=b.getIndex();}if(b.getVisible()!==undefined){u.persistentSelected=b.getVisible();}if(b.getWidth()!==undefined){u.width=b.getWidth();}if(b.getTotal()!==undefined){u.total=b.getTotal();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var a=this._getInternalModel().getProperty("/items");this._sortModelItemsByPersistentIndex(a);this._updateCounts(a);this._getInternalModel().setProperty("/items",a);this._switchMarkedTableItemTo(this._getMarkedTableItem());if(q(a).not(M).length!==0||q(M).not(a).length!==0){this._bTableItemsChanged=true;}};
return t;});
sap.ui.predefine('sap/m/P13nConditionPanel',['./library','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/Item','sap/ui/core/ListItem','sap/ui/model/odata/type/Boolean','sap/ui/model/type/String','sap/ui/model/odata/type/String','sap/ui/model/type/Date','sap/ui/model/type/Time','sap/ui/model/odata/type/DateTime','sap/ui/model/type/Float','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./ToolbarSpacer','./Text','./SearchField','./CheckBox','./ComboBox','./Select','./Label','./Input','./DatePicker','./TimePicker','./DateTimePicker','sap/base/Log','sap/ui/thirdparty/jquery'],function(a,c,C,I,D,b,R,d,L,B,S,e,f,T,g,F,h,O,k,m,o,q,r,s,t,u,v,x,y,z,A,Q){"use strict";var V=c.ValueState;var E=a.ButtonType;var G=a.ToolbarDesign;var H=c.TextAlign;var J=a.OverflowToolbarPriority;var K;var M;var N;var P;
var U=C.extend("sap.m.P13nConditionPanel",{
metadata:{library:"sap.m",properties:{maxConditions:{type:"string",group:"Misc",defaultValue:'-1'},exclude:{type:"boolean",group:"Misc",defaultValue:false},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},autoAddNewRow:{type:"boolean",group:"Misc",defaultValue:false},disableFirstRemoveIcon:{type:"boolean",group:"Misc",defaultValue:false},alwaysShowAddIcon:{type:"boolean",group:"Misc",defaultValue:true},usePrevConditionSetting:{type:"boolean",group:"Misc",defaultValue:true},autoReduceKeyFieldItems:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},showLabel:{type:"boolean",group:"Misc",defaultValue:false},displayFormat:{type:"string",group:"Misc",defaultValue:null},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{dataChange:{}}},
renderer:function(j,l){j.write("<section");j.writeControlData(l);j.addClass("sapMConditionPanel");j.writeClasses();j.writeStyles();j.write(">");j.write("<div");j.addClass("sapMConditionPanelContent");j.addClass("sapMConditionPanelBG");j.writeClasses();j.write(">");var n=l.getAggregation("content");var p=n.length;for(var i=0;i<p;i++){j.renderControl(n[i]);}j.write("</div>");j.write("</section>");}
});
U.prototype.setConditions=function(j){if(!j){A.error("sap.m.P13nConditionPanel : aCondition is not defined");}if(this._bIgnoreSetConditions){return;}this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;for(var i=0;i<j.length;i++){this._addCondition2Map(j[i]);}this._clearConditions();this._fillConditions();};
U.prototype.removeAllConditions=function(){this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._clearConditions();this._fillConditions();};
U.prototype.addCondition=function(i){if(this._bIgnoreSetConditions){return;}i.index=this._iConditions;this._addCondition2Map(i);this._addCondition(i);};
U.prototype.insertCondition=function(i,j){if(this._bIgnoreSetConditions){return;}if(j!==undefined){i.index=j;}this._addCondition2Map(i);this._addCondition(i);};
U.prototype.removeCondition=function(i){this._clearConditions();if(typeof i=="string"){this._removeConditionFromMap(i);}if(typeof i=="object"){this._removeConditionFromMap(i.key);}this._fillConditions();};
U.prototype._addCondition2Map=function(i){if(!i.key){i.key="condition_"+this._iConditions;if(this.getExclude()){i.key="x"+i.key;}}this._iConditions++;this._oConditionsMap[i.key]=i;this._aConditionKeys.push(i.key);};
U.prototype._removeConditionFromMap=function(j){this._iConditions--;delete this._oConditionsMap[j];var i=this._aConditionKeys.indexOf(j);if(i>=0){this._aConditionKeys.splice(i,1);}};
U.prototype.getConditions=function(){var i;var j=[];if(this._oConditionsMap){for(var l in this._oConditionsMap){i=this._oConditionsMap[l];var n=i.value;if(!n){n=this._getFormatedConditionText(i.operation,i.value1,i.value2,i.exclude,i.keyField,i.showIfGrouped);}if(!i._oGrid||i._oGrid.select.getSelected()){j.push({"key":l,"text":n,"exclude":i.exclude,"operation":i.operation,"keyField":i.keyField,"value1":i.value1,"value2":i.operation===W.BT?i.value2:null,"showIfGrouped":i.showIfGrouped});}}}return j;};
U.prototype.setOperations=function(i,j){j=j||"default";this._oTypeOperations[j]=i;this._updateAllOperations();};
U.prototype.setValues=function(i,j){j=j||"default";this._oTypeValues[j]=i;};
U.prototype.addOperation=function(i,j){j=j||"default";this._oTypeOperations[j].push(i);this._updateAllOperations();};
U.prototype.removeAllOperations=function(i){i=i||"default";this._oTypeOperations[i]=[];this._updateAllOperations();};
U.prototype.getOperations=function(i){i=i||"default";return this._oTypeOperations[i];};
U.prototype.setKeyFields=function(i){this._aKeyFields=i;this._aKeyFields.forEach(function(j){U._createKeyFieldTypeInstance(j);},this);this._updateKeyFieldItems(this._oConditionsGrid,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
U.prototype.addKeyField=function(i){this._aKeyFields.push(i);U._createKeyFieldTypeInstance(i);this._updateKeyFieldItems(this._oConditionsGrid,true,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
U._createKeyFieldTypeInstance=function(i){var j;if(!i.typeInstance){switch(i.type){case"boolean":i.typeInstance=new B();break;case"numc":if(!(i.formatSettings&&i.formatSettings.isDigitSequence)){A.error("sap.m.P13nConditionPanel","NUMC type support requires isDigitSequence==true!");i.formatSettings=Object.assign({},i.formatSettings,{isDigitSequence:true});}j=i.formatSettings;if(i.maxLength){j=Object.assign({},j,{maxLength:i.maxLength});}if(!j.maxLength){A.error("sap.m.P13nConditionPanel","NUMC type suppport requires maxLength!");}i.typeInstance=new e({},j);break;case"date":i.typeInstance=new f(Object.assign({},i.formatSettings,{strictParsing:true}),{});break;case"time":i.typeInstance=new T(Object.assign({},i.formatSettings,{strictParsing:true}),{});break;case"datetime":i.typeInstance=new g(Object.assign({},i.formatSettings,{strictParsing:true}),{displayFormat:"Date"});var n=i.typeInstance;if(!n.oFormat){n.formatValue(new Date(),"string");}if(n.oFormat){n.oFormat.oFormatOptions.UTC=false;}break;case"stringdate":sap.ui.getCore().loadLibrary("sap.ui.comp");P=P||sap.ui.requireSync("sap/ui/comp/odata/type/StringDate");i.typeInstance=new P(Object.assign({},i.formatSettings,{strictParsing:true}));break;case"numeric":if(i.precision||i.scale){j={};if(i.precision){j["maxIntegerDigits"]=parseInt(i.precision);}if(i.scale){j["maxFractionDigits"]=parseInt(i.scale);}}i.typeInstance=new F(j);break;default:var l=i.formatSettings;if(i.maxLength){l=Object.assign({},l,{maxLength:i.maxLength});}i.typeInstance=new S({},l);break;}}};
U.prototype.removeAllKeyFields=function(){this._aKeyFields=[];this._updateKeyFieldItems(this._oConditionsGrid,true);};
U.prototype.getKeyFields=function(){return this._aKeyFields;};
U.prototype.setAlwaysShowAddIcon=function(i){this.setProperty("alwaysShowAddIcon",i);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");}return this;};
U.prototype.setLayoutMode=function(l){this.setProperty("layoutMode",l);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",l!=="Desktop");}this._updateConditionFieldSpans(l);this._clearConditions();this._fillConditions();return this;};
U.prototype.setContainerQuery=function(i){this._unregisterResizeHandler();this.setProperty("containerQuery",i);this._registerResizeHandler();this._clearConditions();this._fillConditions();return this;};
U.prototype._updateConditionFieldSpans=function(i){if(this._aConditionsFields){var j=i==="Desktop";if(j){this._aConditionsFields[2].SpanFilter="L3 M3 S3";this._aConditionsFields[4].SpanFilter="L2 M2 S2";this._aConditionsFields[5].SpanFilter="L3 M3 S3";this._aConditionsFields[6].SpanFilter="L2 M2 S2";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}var l=i==="Tablet";if(l){this._aConditionsFields[2].SpanFilter="L5 M5 S5";this._aConditionsFields[4].SpanFilter="L5 M5 S5";this._aConditionsFields[5].SpanFilter="L10 M10 S10";this._aConditionsFields[6].SpanFilter="L10 M10 S10";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}}};
U.prototype.init=function(){sap.ui.getCore().loadLibrary("sap.ui.layout");K=K||sap.ui.requireSync("sap/ui/layout/Grid");M=M||sap.ui.requireSync("sap/ui/layout/GridData");N=N||sap.ui.requireSync("sap/ui/layout/HorizontalLayout");this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sFromLabelText=this._oRb.getText("CONDITIONPANEL_LABELFROM");this._sToLabelText=this._oRb.getText("CONDITIONPANEL_LABELTO");this._sValueLabelText=this._oRb.getText("CONDITIONPANEL_LABELVALUE");this._sShowIfGroupedLabelText=this._oRb.getText("CONDITIONPANEL_LABELGROUPING");this._sValidationDialogFieldMessage=this._oRb.getText("CONDITIONPANEL_FIELDMESSAGE");this._oTypeOperations={"default":[]};this._oTypeValues={"default":[]};this._aKeyFields=[];this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._sLayoutMode="Desktop";this._sConditionType="Filter";this._sAddRemoveIconTooltip="FILTER";this._iBreakPointTablet=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD].points[0];this._iBreakPointDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD].points[1];this._oConditionsGrid=new K({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:0,vSpacing:0}).toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");this._oConditionsGrid.addStyleClass("sapUiRespGridOverflowHidden");this._iFirstConditionIndex=0;this._iConditionPageSize=10;this._oInvisibleTextField=new b({text:this._oRb.getText("CONDITIONPANEL_FIELD_LABEL")});this._oInvisibleTextOperator=new b({text:this._oRb.getText("CONDITIONPANEL_OPERATOR_LABEL")});this.addAggregation("content",this._oInvisibleTextField);this.addAggregation("content",this._oInvisibleTextOperator);this.addAggregation("content",this._oConditionsGrid);this._registerResizeHandler();this._aConditionsFields=[{"ID":"select","Label":"","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"CheckBox","Value":""},{"ID":"keyFieldLabel","Text":"Sort By","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"keyField","Label":"","SpanFilter":"L3 M5 S10","SpanSort":"L5 M5 S12","SpanGroup":"L4 M4 S12","Control":"ComboBox"},{"ID":"operationLabel","Text":"Sort Order","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"operation","Label":"","SpanFilter":"L2 M5 S10","SpanSort":D.system.phone?"L5 M5 S8":"L5 M5 S9","SpanGroup":"L2 M5 S10","Control":"ComboBox"},{"ID":"value1","Label":this._sFromLabelText,"SpanFilter":"L3 M10 S10","SpanSort":"L3 M10 S10","SpanGroup":"L3 M10 S10","Control":"TextField","Value":""},{"ID":"value2","Label":this._sToLabelText,"SpanFilter":"L2 M10 S10","SpanSort":"L2 M10 S10","SpanGroup":"L2 M10 S10","Control":"TextField","Value":""},{"ID":"showIfGrouped","Label":this._sShowIfGroupedLabelText,"SpanFilter":"L1 M10 S10","SpanSort":"L1 M10 S10","SpanGroup":"L3 M4 S9","Control":"CheckBox","Value":"false"}];this._oButtonGroupSpan={"SpanFilter":"L2 M2 S2","SpanSort":D.system.phone?"L2 M2 S4":"L2 M2 S3","SpanGroup":"L2 M2 S3"};this._updateConditionFieldSpans(this.getLayoutMode());this._fillConditions();};
U.prototype._createPaginatorToolbar=function(){this._bPaginatorButtonsVisible=false;var i=this;this._oPrevButton=new h({icon:I.getIconURI("navigation-left-arrow"),tooltip:this._oRb.getText("WIZARD_FINISH"),visible:true,press:function(j){i._iFirstConditionIndex=Math.max(0,i._iFirstConditionIndex-i._iConditionPageSize);i._clearConditions();i._fillConditions();},layoutData:new k({priority:J.NeverOverflow})});this._oNextButton=new h({icon:I.getIconURI("navigation-right-arrow"),tooltip:this._oRb.getText("WIZARD_NEXT"),visible:true,press:function(j){i._iFirstConditionIndex+=i._iConditionPageSize;i._clearConditions();i._fillConditions();},layoutData:new k({priority:J.NeverOverflow})});this._oRemoveAllButton=new h({text:this._oRb.getText("CONDITIONPANEL_REMOVE_ALL"),visible:true,press:function(j){i._aConditionKeys.forEach(function(l,n){if(n>=0){this.fireDataChange({key:l,index:n,operation:"remove",newData:null});}},i);this._iFirstConditionIndex=0;i.removeAllConditions();},layoutData:new k({priority:J.Low})});this._oAddButton=new h({icon:I.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),visible:true,press:function(j){var l=i._createConditionRow(i._oConditionsGrid,undefined,null,0);i._changeField(l);setTimeout(function(){l.keyField.focus();});i._updatePaginatorToolbar();},layoutData:new k({priority:J.Low})});this._oHeaderText=new o({wrapping:false,layoutData:new k({priority:J.NeverOverflow})});this._oPageText=new o({wrapping:false,textAlign:H.Center,layoutData:new k({priority:J.NeverOverflow})});this._oFilterField=new q({width:"12rem",layoutData:new k({priority:J.High})});this._oPaginatorToolbar=new O({height:"3rem",design:G.Transparent,content:[this._oHeaderText,new m(),this._oFilterField,this._oPrevButton,this._oPageText,this._oNextButton,this._oRemoveAllButton,this._oAddButton]});};
U.prototype._updatePaginatorToolbar=function(){if(this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"){return;}var i=this._aConditionKeys.length;var p=1+Math.floor(Math.max(0,i-1)/this._iConditionPageSize);var j=1+Math.floor(this._iFirstConditionIndex/this._iConditionPageSize);var l=this.getParent();if(!this._oPaginatorToolbar){if(i>this._iConditionPageSize){this._createPaginatorToolbar();this.insertAggregation("content",this._oPaginatorToolbar,0);this._onGridResize();}else{if(l&&l.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=l.getHeaderText();}l.setHeaderText(this._sOrgHeaderText+(i>0?" ("+i+")":""));}return;}}this._oPrevButton.setEnabled(this._iFirstConditionIndex>0);this._oNextButton.setEnabled(this._iFirstConditionIndex+this._iConditionPageSize<i);if(l&&l.setHeaderToolbar){if(!l.getHeaderToolbar()){this.removeAggregation("content",this._oPaginatorToolbar);l.setHeaderToolbar(this._oPaginatorToolbar);l.attachExpand(function(X){this._setToolbarElementVisibility(X.getSource().getExpanded()&&this._bPaginatorButtonsVisible);}.bind(this));}}if(l&&l.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=l.getHeaderText();}var n=this._sOrgHeaderText+(i>0?" ("+i+")":"");l.setHeaderText(n);this._oHeaderText.setText(n);}else{this._oHeaderText.setText(i+" Conditions");}this._oPageText.setText(j+"/"+p);this._bPaginatorButtonsVisible=this._bPaginatorButtonsVisible||p>1;this._setToolbarElementVisibility(this._bPaginatorButtonsVisible);if(j>p){this._iFirstConditionIndex-=Math.max(0,this._iConditionPageSize);this._clearConditions();this._fillConditions();}var w=0;this._oConditionsGrid.getContent().forEach(function(X){if(X.select.getSelected()){w++;}},this);if(p==j&&(i-this._iFirstConditionIndex)>w){this._clearConditions();this._fillConditions();}};
U.prototype._setToolbarElementVisibility=function(i){this._oPrevButton.setVisible(i);this._oNextButton.setVisible(i);this._oPageText.setVisible(i);this._oFilterField.setVisible(false);this._oAddButton.setVisible(i);this._oRemoveAllButton.setVisible(i);};
U.prototype.exit=function(){this._clearConditions();this._unregisterResizeHandler();this._aConditionsFields=null;this._aKeys=null;this._aKeyFields=null;this._oTypeOperations=null;this._oRb=null;this._sFromLabelText=null;this._sToLabelText=null;this._sValueLabelText=null;this._sValidationDialogFieldMessage=null;this._oConditionsMap=null;this._aConditionKeys=[];};
U.prototype._clearConditions=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){for(var l in this._aConditionsFields){var n=this._aConditionsFields[l];if(j[n["ID"]]&&j.getContent().indexOf(j[n["ID"]])===-1){j[n["ID"]].destroy();}}},this);this._oConditionsGrid.destroyContent();};
U.prototype._fillConditions=function(){var j,l;var i=0,p=this._getMaxConditionsAsNumber(),n=this._aConditionKeys.length;if(this._oConditionsMap){var w=this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"?9999:this._iConditionPageSize;n=Math.min(n,Math.min(p,this._iFirstConditionIndex+w));for(i=this._iFirstConditionIndex;i<n;i++){l=this._aConditionKeys[i];j=this._oConditionsMap[l];this._createConditionRow(this._oConditionsGrid,j,l);}}this._updatePaginatorToolbar();if((this.getAutoAddNewRow()||this._oConditionsGrid.getContent().length===0)&&this._oConditionsGrid.getContent().length<p){this._createConditionRow(this._oConditionsGrid);}};
U.prototype._addCondition=function(j){var i=0;var l=this._getMaxConditionsAsNumber();if(this._oConditionsMap){for(var n in this._oConditionsMap){if(i<l&&j===this._oConditionsMap[n]){this._createConditionRow(this._oConditionsGrid,j,n,i);}i++;}}this._updatePaginatorToolbar();};
U.prototype._getMaxConditionsAsNumber=function(){return this.getMaxConditions()==="-1"?9999:parseInt(this.getMaxConditions());};
U.prototype.onAfterRendering=function(){if(this.getLayoutMode()){this._sLayoutMode=this.getLayoutMode();return;}};
U.prototype._handleMediaChange=function(p){this._sLayoutMode=p.name;this._updateLayout(p);};
U.prototype._unregisterResizeHandler=function(){if(this._sContainerResizeListener){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;}D.media.detachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);};
U.prototype._registerResizeHandler=function(){if(this.getContainerQuery()){this._sContainerResizeListener=R.register(this._oConditionsGrid,this._onGridResize.bind(this));this._onGridResize();}else{D.media.attachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);}};
U.prototype._getKeyFromConditionGrid=function(i){var j=i.data("_key");if(!j){j=this._createConditionKey();}return j;};
U.prototype._createConditionKey=function(){var i=0;var j;do{j="condition_"+i;if(this.getExclude()){j="x"+j;}i++;}while(this._oConditionsMap[j]);return j;};
U.prototype._createConditionRow=function(i,j,l,p,n){var w=null;var X;var Y=this;if(p===undefined){p=i.getContent().length;}var Z=new K({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:1,vSpacing:0,containerQuery:this.getContainerQuery()}).data("_key",l);Z.addStyleClass("sapUiRespGridOverflowHidden");for(var $ in this._aConditionsFields){var _;var a1=this._aConditionsFields[$];switch(a1["Control"]){case"CheckBox":_=new r({enabled:false,visible:false,layoutData:new M({span:a1["Span"+this._sConditionType]})});if(a1["ID"]==="showIfGrouped"){_.setEnabled(true);_.setText(a1["Label"]);_.attachSelect(function(){Y._changeField(Z);});_.setSelected(j?j.showIfGrouped:true);}else{if(j){_.setSelected(true);_.setEnabled(true);}}break;case"ComboBox":if(a1["ID"]==="keyField"){_=new s({width:"100%",ariaLabelledBy:this._oInvisibleTextField});var b1=_.setSelectedKey.bind(_);_.setSelectedKey=function(l){b1(l);var o1=Y.getValidationExecutor();if(o1){o1();}};var c1=_.setSelectedItem.bind(_);_.setSelectedItem=function(o1){c1(o1);var p1=Y.getValidationExecutor();if(p1){p1();}};_.setLayoutData(new M({span:a1["Span"+this._sConditionType]}));this._fillKeyFieldListItems(_,this._aKeyFields);if(_.attachSelectionChange){_.attachSelectionChange(function(o1){var p1=Y.getValidationExecutor();if(p1){p1();}Y._handleSelectionChangeOnKeyField(i,Z);});}if(_.attachChange){_.attachChange(function(o1){Z.keyField.close();Y._handleChangeOnKeyField(i,Z);});}if(_.setSelectedItem){if(j){_.setSelectedKey(j.keyField);this._aKeyFields.forEach(function(d1,o1){var p1=d1.key;if(p1===undefined){p1=d1;}if(j.keyField===p1){_.setSelectedItem(_.getItems()[o1]);}},this);}else{if(this.getUsePrevConditionSetting()&&!this.getAutoReduceKeyFieldItems()){if(p>0&&!l&&n){X=i.getContent()[p-1];if(X.keyField.getSelectedKey()){_.setSelectedKey(X.keyField.getSelectedKey());}else{if(!_.getSelectedItem()&&_.getItems().length>0){_.setSelectedItem(_.getItems()[0]);}}}else{this._aKeyFields.some(function(d1,o1){if(d1.isDefault){_.setSelectedItem(_.getItems()[o1]);return true;}if(!_.getSelectedItem()&&d1.type!=="boolean"){_.setSelectedItem(_.getItems()[o1]);}},this);if(!_.getSelectedItem()&&_.getItems().length>0){_.setSelectedItem(_.getItems()[0]);}}}else{this._aKeyFields.forEach(function(d1,o1){if(d1.isDefault){_.setSelectedItem(_.getItems()[o1]);}},this);}}}}if(a1["ID"]==="operation"){_=new t({width:"100%",ariaLabelledBy:this._oInvisibleTextOperator,layoutData:new M({span:a1["Span"+this._sConditionType]})});_.attachChange(function(){Y._handleChangeOnOperationField(i,Z);});Z[a1["ID"]]=_;this._updateOperationItems(i,Z);if(j){var d1=this._getCurrentKeyFieldItem(Z.keyField);var e1=this._oTypeOperations["default"];if(d1){if(d1.type&&this._oTypeOperations[d1.type]){e1=this._oTypeOperations[d1.type];}if(d1.operations){e1=d1.operations;}}e1.some(function(o1,p1){if(j.operation===o1){_.setSelectedKey(o1);return true;}},this);}else{if(this.getUsePrevConditionSetting()){if(p>0&&l===null){var X=i.getContent()[p-1];_.setSelectedKey(X.operation.getSelectedKey());}}}}if(_.getSelectedItem&&_.getSelectedItem()){_.setTooltip(_.getSelectedItem().getTooltip()||_.getSelectedItem().getText());}break;case"TextField":var f1=this._getCurrentKeyFieldItem(Z.keyField);_=this._createValueField(f1,a1,Z);_.oTargetGrid=i;if(j&&j[a1["ID"]]!==undefined){var g1=j[a1["ID"]];if(_ instanceof t){if(typeof g1==="boolean"){_.setSelectedIndex(g1?2:1);}}else if(g1!==null&&Z.oType){if(typeof g1==="string"&&Z.oType.getName()==="sap.ui.comp.odata.type.StringDate"){_.setValue(g1);}else{if(typeof g1==="string"&&["String","sap.ui.model.odata.type.String","sap.ui.model.odata.type.Decimal"].indexOf(Z.oType.getName())==-1){try{g1=Z.oType.parseValue(g1,"string");_.setValue(Z.oType.formatValue(g1,"string"));}catch(h1){A.error("sap.m.P13nConditionPanel","Value '"+g1+"' does not have the expected type format for "+Z.oType.getName()+".parseValue()");}}else{_.setValue(Z.oType.formatValue(g1,"string"));}}}else{_.setValue(g1);}}break;case"Label":_=new u({text:a1["Text"]+":",visible:this.getShowLabel(),layoutData:new M({span:a1["Span"+this._sConditionType]})}).addStyleClass("conditionLabel");_.oTargetGrid=i;break;}Z[a1["ID"]]=_;Z.addContent(_);}w=new N({layoutData:new M({span:this.getLayoutMode()==="Desktop"?"L2 M2 S2":this._oButtonGroupSpan["Span"+this._sConditionType]})}).addStyleClass("floatRight");Z.addContent(w);Z["ButtonContainer"]=w;var i1=new h({type:E.Transparent,icon:I.getIconURI("sys-cancel"),tooltip:this._oRb.getText("CONDITIONPANEL_REMOVE"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){Y._handleRemoveCondition(this.oTargetGrid,Z);},layoutData:new M({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M2 S2"})});i1.oTargetGrid=i;w.addContent(i1);Z["remove"]=i1;var j1=new h({type:E.Transparent,icon:I.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){Y._handleAddCondition(this.oTargetGrid,Z,true);},layoutData:new M({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M10 S10"})});j1.oTargetGrid=i;j1.addStyleClass("conditionAddBtnFloatRight");w.addContent(j1);Z["add"]=j1;i.insertContent(Z,p);this._updateOperationItems(i,Z);this._changeOperationValueFields(i,Z);this._updateAllConditionsEnableStates();this._updateConditionButtons(i);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false);}if(this._sLayoutMode){this._updateLayout({name:this._sLayoutMode});}if(j){var k1=this._getFormatedConditionText(j.operation,j.value1,j.value2,j.exclude,j.keyField,j.showIfGrouped);j._oGrid=Z;j.value=k1;this._oConditionsMap[l]=j;}var l1=Z.operation.getSelectedKey();if(l1==="BT"&&Z.value1.setMinDate&&Z.value2.setMaxDate){var m1=Z.value1.getDateValue();var n1=Z.value2.getDateValue();this._updateMinMaxDate(Z,m1,n1);}else{this._updateMinMaxDate(Z,null,null);}return Z;};
U.prototype._handleRemoveCondition=function(i,j){var l=i.getContent().indexOf(j);this._removeCondition(i,j);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false);}if(l>=0){l=Math.min(l,i.getContent().length-1);var j=i.getContent()[l];setTimeout(function(){j.remove.focus();});}this._updatePaginatorToolbar();};
U.prototype._handleAddCondition=function(i,j,l){var p=i.getContent().indexOf(j);var n=this._createConditionRow(i,undefined,null,p+1,l);this._changeField(n);setTimeout(function(){n.keyField.focus();});this._updatePaginatorToolbar();};
U.prototype._getCurrentKeyFieldItem=function(i){if(i.getSelectedKey&&i.getSelectedKey()){var j=i.getSelectedKey();var l=this._aKeyFields;for(var n in l){var p=l[n];if(p.key===j){return p;}}}return null;};
U.prototype._createValueField=function(j,n,p){var w;var X;var Y=this;var Z={value:n["Value"],width:"100%",placeholder:n["Label"],change:function(i){Y._validateAndFormatFieldValue(i);Y._changeField(p,i);},layoutData:new M({span:n["Span"+this._sConditionType]})};if(j&&j.typeInstance){var $=j.typeInstance;X=this._findConfig($,"ctrl");if(X==="DateTimePicker"&&$.getMetadata().getName()==="sap.ui.model.odata.type.DateTime"){if(!($.oConstraints&&$.oConstraints.isDateOnly)){A.error("sap.m.P13nConditionPanel","sap.ui.model.odata.type.DateTime without displayFormat = Date is not supported!");$.oConstraints=Object.assign({},$.oConstraints,{isDateOnly:true});}X="DatePicker";}p.oType=$;if(X=="select"){var _=[];var a1=j.values||this._oTypeValues[X]||["",$.formatValue(false,"string"),$.formatValue(true,"string")];a1.forEach(function(i,c1){_.push(new d({key:c1.toString(),text:i.toString()}));});Z={width:"100%",items:_,change:function(){Y._changeField(p);},layoutData:new M({span:n["Span"+this._sConditionType]})};w=new t(Z);}else if(X=="TimePicker"){if($.oFormatOptions&&$.oFormatOptions.style){Z.displayFormat=$.oFormatOptions.style;}w=new y(Z);}else if(X=="DateTimePicker"){if($.oFormatOptions&&$.oFormatOptions.style){Z.displayFormat=$.oFormatOptions.style;}w=new z(Z);}else if(X==="DatePicker"){if($.oFormatOptions){Z.displayFormat=$.oFormatOptions.style||$.oFormatOptions.pattern;if($.isA("sap.ui.comp.odata.type.StringDate")){Z.valueFormat="yyyyMMdd";}}w=new x(Z);}else{w=new v(Z);if(this._fSuggestCallback){j=this._getCurrentKeyFieldItem(p.keyField);if(j&&j.key){var b1=this._fSuggestCallback(w,j.key);if(b1){w._oSuggestProvider=b1;}}}}}else{p.oType=null;w=new v(Z);}if(X!=="boolean"&&X!=="enum"&&w){w.onpaste=function(c1){var d1;if(window.clipboardData){d1=window.clipboardData.getData("Text");}else{d1=c1.originalEvent.clipboardData.getData('text/plain');}var p=c1.srcControl.getParent();var e1=d1.split(/\r\n|\r|\n/g);var f1=p.operation;var op=f1.getSelectedKey();if(e1&&e1.length>1&&op!=="BT"){setTimeout(function(){var g1=e1?e1.length:0;var h1=Y._getCurrentKeyFieldItem(p.keyField);var f1=p.operation;for(var i=0;i<g1;i++){if(Y._aConditionKeys.length>=Y._getMaxConditionsAsNumber()){break;}var i1=e1[i].trim();if(i1){var j1;if(h1.typeInstance){try{j1=h1.typeInstance.parseValue(i1,"string");h1.typeInstance.validateValue(j1);}catch(k1){A.error("sap.m.P13nConditionPanel.onPaste","not able to parse value "+i1+" with type "+h1.typeInstance.getName());i1="";j1=null;}if(!j1){continue;}}var l1={"key":Y._createConditionKey(),"exclude":Y.getExclude(),"operation":f1.getSelectedKey(),"keyField":h1.key,"value1":j1,"value2":null};Y._addCondition2Map(l1);Y.fireDataChange({key:l1.key,index:l1.index,operation:"add",newData:l1});}}Y._clearConditions();Y._fillConditions();},0);}};}if(j&&j.maxLength&&w.setMaxLength){var l=-1;if(typeof j.maxLength==="string"){l=parseInt(j.maxLength);}if(typeof j.maxLength==="number"){l=j.maxLength;}if(l>0&&(!w.getShowSuggestion||!w.getShowSuggestion())){w.setMaxLength(l);}}return w;};
U.prototype._fillOperationListItems=function(i,j,l){if(l==="_STRING_"){l="";}if(l==="_TIME_"||l==="_DATETIME_"){l="_DATE_";}if(l==="_BOOLEAN_"||l==="_NUMC_"){l="";}i.destroyItems();j.forEach(function(n){var p=this._oRb.getText("CONDITIONPANEL_OPTION"+l+n);if(p.startsWith("CONDITIONPANEL_OPTION")){p=this._oRb.getText("CONDITIONPANEL_OPTION"+n);}i.addItem(new L({key:n,text:p,tooltip:p}));}.bind(this));};
U.prototype._fillKeyFieldListItems=function(i,j){i.destroyItems();for(var l in j){var n=j[l];i.addItem(new L({key:n.key,text:n.text,tooltip:n.tooltip?n.tooltip:n.text}));}i.setEditable(i.getItems().length>1);};
U.prototype._handleChangeOnOperationField=function(i,j){this._changeOperationValueFields(i,j);this._changeField(j);};
U.prototype._handleSelectionChangeOnKeyField=function(i,j){if(this._sConditionType==="Filter"){this._updateOperationItems(i,j);this._createAndUpdateValueFields(i,j);this._changeOperationValueFields(i,j);}this._changeField(j);};
U.prototype._handleChangeOnKeyField=function(i,j){if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false,false,j.keyField);}};
U.prototype._createAndUpdateAllKeyFields=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){this._createAndUpdateValueFields(this._oConditionsGrid,j);this._changeOperationValueFields(this._oConditionsGrid,j);},this);};
U.prototype._createAndUpdateValueFields=function(i,j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=function(j,p,w){var X=p.getValue?p.getValue():"";var Y=j.indexOfContent(p);j.removeContent(p);if(p._oSuggestProvider){p._oSuggestProvider.destroy();p._oSuggestProvider=null;}p.destroy();var Z=this._aConditionsFields[w];p=this._createValueField(l,Z,j);j[Z["ID"]]=p;j.insertContent(p,Y===-1?j.indexOfContent(j.operation)+1:Y);var $,_;if(j.oType&&X){try{$=j.oType.parseValue(X,"string");j.oType.validateValue($);_=j.oType.formatValue($,"string");p.setValue(_);}catch(a1){var b1=a1.message;this._makeFieldValid(p,false,b1);p.setValue(X);}}};n.bind(this)(j,j.value1,5);n.bind(this)(j,j.value2,6);};
U.prototype._updateAllOperations=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){this._updateOperationItems(this._oConditionsGrid,j);this._changeOperationValueFields(this._oConditionsGrid,j);},this);};
U.prototype._updateOperationItems=function(i,j){var l="";var n=this._getCurrentKeyFieldItem(j.keyField);var p=j.operation;var w=this._oTypeOperations["default"];var X=p.getSelectedItem();if(n){if(n.type&&n.type!==""&&this._oTypeOperations[n.type]){l=n.type;w=this._oTypeOperations[l];}if(n.operations){w=n.operations;}}this._fillOperationListItems(p,w,l?"_"+l.toUpperCase()+"_":"");if(X&&p.getItemByKey(X.getKey())){p.setSelectedKey(X.getKey());}else{p.setSelectedItem(p.getItems()[0]);}this._sConditionType="Filter";if(w[0]===W.Ascending||w[0]===W.Descending){this._sConditionType="Sort";}if(w[0]===W.GroupAscending||w[0]===W.GroupDescending){this._sConditionType="Group";}this._adjustValue1Span(j);};
U.prototype._updateKeyFieldItems=function(l,p,w,X){var n=l.getContent().length;var i;var Y={};if(!p){for(i=0;i<n;i++){var Z=l.getContent()[i].keyField;var $=Z.getSelectedKey();if($!=null&&$!==""){Y[$]=true;}}}for(i=0;i<n;i++){var Z=l.getContent()[i].keyField;var _=l.getContent()[i].select;var a1=Z.getSelectedKey();var j=0;var b1=this._aKeyFields;if(Z!==X){if(w){j=b1.length-1;}else{Z.destroyItems();}for(j;j<b1.length;j++){var c1=b1[j];if(c1.key==null||c1.key===""||!Y[c1.key]||c1.key===a1){Z.addItem(new L({key:c1.key,text:c1.text,tooltip:c1.tooltip?c1.tooltip:c1.text}));}}Z.setEditable(Z.getItems().length>1);}if(a1){Z.setSelectedKey(a1);}else if(Z.getItems().length>0){Z.setSelectedItem(Z.getItems()[0]);}if(!_.getSelected()){this._aKeyFields.some(function(d1,e1){if(d1.isDefault){Z.setSelectedItem(Z.getItems()[e1]);return true;}if(!Z.getSelectedItem()){if(d1.type!=="boolean"){Z.setSelectedItem(Z.getItems()[e1]);}}},this);}if(Z.getSelectedItem()){Z.setTooltip(Z.getSelectedItem().getTooltip()||Z.getSelectedItem().getText());}}};
U.prototype._changeOperationValueFields=function(i,j){var l=j.operation;var n=l.getSelectedKey();var p=j.value1;var w=j.value2;var X=j.showIfGrouped;if(!n){return;}if(n===W.BT){if(p.setPlaceholder&&p.getPlaceholder()!==this._sFromLabelText){p.setPlaceholder(this._sFromLabelText);}if(!p.getVisible()){p.setVisible(true);j.insertContent(p,j.getContent().length-1);}if(w.setPlaceholder&&w.getPlaceholder()!==this._sToLabelText){w.setPlaceholder(this._sToLabelText);}if(!w.getVisible()){w.setVisible(true);j.insertContent(w,j.getContent().length-1);}}else{if(n===W.GroupAscending||n===W.GroupDescending){if(p.getVisible()){p.setVisible(false);j.removeContent(p);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}if(l.getVisible()){l.setVisible(false);j.removeContent(l);}X.setVisible(this._getMaxConditionsAsNumber()!=1);}else{if(n===W.NotEmpty||n===W.Empty||n===W.Initial||n===W.Ascending||n===W.Descending||n===W.Total||n===W.Average||n===W.Minimum||n===W.Maximum){if(p.getVisible()){p.setVisible(false);j.removeContent(p);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}j.removeContent(X);}else{if(p.setPlaceholder&&p.getPlaceholder()!==this._sValueLabelText){p.setPlaceholder(this._sValueLabelText);}if(!p.getVisible()){p.setVisible(true);j.insertContent(p,j.getContent().length-1);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}}}}this._adjustValue1Span(j);};
U.prototype._adjustValue1Span=function(i){if(this._sConditionType==="Filter"&&i.value1&&i.operation){var j=i.operation;var n=this._aConditionsFields[5]["Span"+this._sConditionType];if(j.getSelectedKey()!=="BT"){n="L5 M10 S10";}var l=i.value1.getLayoutData();if(l.getSpan()!==n){l.setSpan(n);}}};
U.prototype._getIndexOfCondition=function(i){var j=-1;i.getParent().getContent().some(function(l){if(l.select.getSelected()){j++;}return(l===i);},this);return j+this._iFirstConditionIndex;};
U.prototype._makeFieldValid=function(i,j,l){if(j){i.setValueState(V.None);i.setValueStateText("");}else{i.setValueState(V.Warning);i.setValueStateText(l?l:this._sValidationDialogFieldMessage);}};
U.prototype._validateAndFormatFieldValue=function(i){var j=i.oSource;var l=j.getParent();var n;if(j.getDateValue&&i){n=i.getParameter("value");var p=i.getParameter("valid");this._makeFieldValid(j,p);return;}else{n=j.getValue&&j.getValue();}if(!l){return;}if(this.getDisplayFormat()==="UpperCase"&&n){n=n.toUpperCase();j.setValue(n);}if(l.oType&&n){try{var w=l.oType.parseValue(n,"string");l.oType.validateValue(w);this._makeFieldValid(j,true);n=l.oType.formatValue(w,"string");j.setValue(n);}catch(X){var Y=X.message;this._makeFieldValid(j,false,Y);}}else{this._makeFieldValid(j,true);}};
U.prototype._updateMinMaxDate=function(i,j,l){if(i.value1.setMinDate&&i.value2.setMaxDate){if(i.value1&&i.value1.setMaxDate){i.value1.setMaxDate(l instanceof Date?l:null);}if(i.value2&&i.value2.setMinDate){i.value2.setMinDate(j instanceof Date?j:null);}}};
U.prototype._changeField=function(i,j){var l=i.keyField.getSelectedKey();if(i.keyField.getSelectedItem()){i.keyField.setTooltip(i.keyField.getSelectedItem().getTooltip()||i.keyField.getSelectedItem().getText());}else{i.keyField.setTooltip(null);}var n=i.operation.getSelectedKey();if(i.operation.getSelectedItem()){i.operation.setTooltip(i.operation.getSelectedItem().getTooltip()||i.operation.getSelectedItem().getText());}else{i.operation.setTooltip(null);}var p=function(h1,i1){var d1;var j1;if(h1.getDateValue&&!(h1.isA("sap.m.TimePicker"))&&i1.getName()!=="sap.ui.comp.odata.type.StringDate"){j1=h1.getDateValue();if(i1&&j1){if(j&&j.getParameter("valid")){d1=i1.formatValue(j1,"string");}else{d1="";}}}else{d1=this._getValueTextFromField(h1);j1=d1;if(i1&&i1.getName()==="sap.ui.comp.odata.type.StringDate"){d1=i1.formatValue(j1,"string");}else if(i1&&d1){try{j1=i1.parseValue(d1,"string");i1.validateValue(j1);}catch(k1){A.error("sap.m.P13nConditionPanel","not able to parse value "+d1+" with type "+i1.getName());d1="";}}}return[j1,d1];}.bind(this);var w=p(i.value1,i.oType);var X=w[0],Y=w[1];w=p(i.value2,i.oType);var Z=w[0],$=w[1];if(n==="BT"){this._updateMinMaxDate(i,X,Z);}else{this._updateMinMaxDate(i,null,null);}var _=this._getCurrentKeyFieldItem(i.keyField);if(_&&_.type==="numc"){if([W.Contains,W.EndsWith].indexOf(n)!=-1){X=i.oType.formatValue(X,"string");}}var a1=i.showIfGrouped.getSelected();var b1=this.getExclude();var c1=i.select;var d1="";var e1;if(l===""||l==null){l=null;e1=this._getKeyFromConditionGrid(i);this._removeConditionFromMap(e1);this._enableCondition(i,false);var f1=this._getIndexOfCondition(i);if(c1.getSelected()){c1.setSelected(false);c1.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:e1,index:f1,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}return;}this._enableCondition(i,true);d1=this._getFormatedConditionText(n,Y,$,b1,l,a1);var g1={"value":d1,"exclude":b1,"operation":n,"keyField":l,"value1":X,"value2":n===W.BT?Z:null,"showIfGrouped":a1};e1=this._getKeyFromConditionGrid(i);if(d1!==""){c1.setSelected(true);c1.setEnabled(true);var n="update";if(!this._oConditionsMap[e1]){n="add";}this._oConditionsMap[e1]=g1;if(n==="add"){this._aConditionKeys.splice(this._getIndexOfCondition(i),0,e1);}i.data("_key",e1);this.fireDataChange({key:e1,index:this._getIndexOfCondition(i),operation:n,newData:g1});}else if(this._oConditionsMap[e1]!==undefined){this._removeConditionFromMap(e1);i.data("_key",null);var f1=this._getIndexOfCondition(i);if(c1.getSelected()){c1.setSelected(false);c1.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:e1,index:f1,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}}this._updatePaginatorToolbar();};
U.prototype._getValueTextFromField=function(i){if(i instanceof t){return i.getSelectedItem()?i.getSelectedItem().getText():"";}return i.getValue();};
U.prototype._updateAllConditionsEnableStates=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=l&&l.key!==undefined?l.key:l;var p=n!==""&&n!==null;this._enableCondition(j,p);},this);};
U.prototype._enableCondition=function(i,j){i.operation.setEnabled(j);i.value1.setEnabled(j);i.value2.setEnabled(j);i.showIfGrouped.setEnabled(j);};
U.prototype._removeCondition=function(i,j){var l=this._getKeyFromConditionGrid(j);var n=-1;if(j.select.getSelected()){n=this._getIndexOfCondition(j);}this._removeConditionFromMap(l);j.destroy();if(i.getContent().length<1){this._createConditionRow(i);}else{this._updateConditionButtons(i);}if(n>=0){this.fireDataChange({key:l,index:n,operation:"remove",newData:null});}};
U.prototype._updateConditionButtons=function(j){var l=this._getMaxConditionsAsNumber();var n=j.getContent().length;for(var i=0;i<n;i++){var p=j.getContent()[i].add;if((this.getAlwaysShowAddIcon()&&(n<l))||(i===n-1&&i<l-1)){p.removeStyleClass("displayNone");}else{p.addStyleClass("displayNone");}var w=j.getContent()[i].remove;if(l===1||(i===0&&n===1&&this.getDisableFirstRemoveIcon())){w.addStyleClass("displayNone");}else{w.removeStyleClass("displayNone");}}};
U.prototype.validateConditions=function(){var j=this;var l=function(n){var p=true;for(var i=0;i<n.length;i++){var w=n[i];var X=j._checkCondition(w,i===n.length-1);p=p&&X;}return p;};return l(this._oConditionsGrid.getContent());};
U.prototype.removeValidationErrors=function(){this._oConditionsGrid.getContent().forEach(function(i){var j=i.value1;var l=i.value2;j.setValueState(V.None);j.setValueStateText("");l.setValueState(V.None);l.setValueStateText("");},this);};
U.prototype.removeInvalidConditions=function(){var i=[];this._oConditionsGrid.getContent().forEach(function(j){if(j.value1.getValueState()!==V.None||j.value2.getValueState()!==V.None){i.push(j);}},this);i.forEach(function(j){this._removeCondition(this._oConditionsGrid,j);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(this._oConditionsGrid,false);}},this);};
U.prototype._checkCondition=function(i,j){var l=true;var n=i.value1;var p=i.value2;var w=n&&(n.getVisible()&&!this._getValueTextFromField(n));var X=n&&n.getVisible()&&n.getValueState?n.getValueState():V.None;var Y=p&&(p.getVisible()&&!this._getValueTextFromField(p));var Z=p&&p.getVisible()&&p.getValueState?p.getValueState():V.None;var $=i.operation.getSelectedKey();if($===W.BT){if(!w?Y:!Y){if(w){n.setValueState(V.Warning);n.setValueStateText(this._sValidationDialogFieldMessage);}if(Y){p.setValueState(V.Warning);p.setValueStateText(this._sValidationDialogFieldMessage);}l=false;}else if(X!==V.None||Z!==V.None){l=false;}else{n.setValueState(V.None);n.setValueStateText("");p.setValueState(V.None);p.setValueStateText("");}}if((n.getVisible()&&n.getValueState&&n.getValueState()!==V.None)||(p.getVisible()&&p.getValueState&&p.getValueState()!==V.None)){l=false;}return l;};
U.prototype._getFormatedConditionText=function(j,l,n,p,w,X){var Y=U.getFormatedConditionText(j,l,n,p);if(!Y){switch(j){case W.Initial:Y="=''";break;case W.NotEmpty:Y="!''";break;case W.Ascending:Y="ascending";break;case W.GroupAscending:Y="ascending";Y+=" showIfGrouped:"+X;break;case W.Descending:Y="descending";break;case W.GroupDescending:Y="descending";Y+=" showIfGrouped:"+X;break;case W.Total:Y="total";break;case W.Average:Y="average";break;case W.Minimum:Y="minimum";break;case W.Maximum:Y="maximum";break;}if(p&&Y!==""){Y="!("+Y+")";}}if(this._aKeyFields&&this._aKeyFields.length>1){var Z=null;for(var i=0;i<this._aKeyFields.length;i++){var $=this._aKeyFields[i];if(typeof $!=="string"){if($.key===w&&$.text){Z=$.text;}}}if(Z&&Y!==""){Y=Z+": "+Y;}}return Y;};
var W=sap.m.P13nConditionOperation={BT:"BT",EQ:"EQ",Contains:"Contains",StartsWith:"StartsWith",EndsWith:"EndsWith",LT:"LT",LE:"LE",GT:"GT",GE:"GE",Initial:"Initial",Empty:"Empty",NotEmpty:"NotEmpty",Ascending:"Ascending",Descending:"Descending",GroupAscending:"GroupAscending",GroupDescending:"GroupDescending",Total:"Total",Average:"Average",Minimum:"Minimum",Maximum:"Maximum"};U._oConditionMap={"EQ":"=$0","GT":">$0","GE":">=$0","LT":"<$0","LE":"<=$0","Contains":"*$0*","StartsWith":"$0*","EndsWith":"*$0","BT":"$0...$1","Empty":"<$r>"};(function(){var _=sap.ui.getCore().getLibraryResourceBundle("sap.m");U._oConditionMap[W.Empty]=U._oConditionMap[W.Empty].replace("$r",_.getText("CONDITIONPANEL_OPTIONEmpty"));})();
U._templateReplace=function(i,j){return i.replace(/\$\d/g,function(l){return j[parseInt(l.substr(1))];});};
U.getFormatedConditionText=function(i,j,l,n){var p="";switch(i){case W.Empty:p=U._templateReplace(U._oConditionMap[i],[]);break;case W.EQ:case W.GT:case W.GE:case W.LT:case W.LE:case W.Contains:case W.StartsWith:case W.EndsWith:if(j!==""&&j!==undefined){p=U._templateReplace(U._oConditionMap[i],[j]);}break;case W.BT:if(j!==""&&j!==undefined){if(l!==""&&l!==undefined){p=U._templateReplace(U._oConditionMap[i],[j,l]);}}break;default:break;}if(n&&p!==""){p="!("+p+")";}return p;};
U.prototype._updateLayout=function(j){if(!this._oConditionsGrid){return;}var l=this._oConditionsGrid.getContent();var n=this._aConditionsFields.length;var p=n;if(j.name==="Tablet"){p=5;}if(j.name==="Phone"){p=3;}if(this._sConditionType==="Filter"){for(var i=0;i<l.length;i++){var w=l[i];w.ButtonContainer.removeStyleClass("floatRight");w.removeContent(w.ButtonContainer);w.insertContent(w.ButtonContainer,p);if(!this.getAlwaysShowAddIcon()){if(p!==n){w.ButtonContainer.removeContent(w.add);w.addContent(w.add);}else{w.removeContent(w.add);w.ButtonContainer.addContent(w.add);}}}}};
U.prototype._onGridResize=function(){var w;if(this._oPaginatorToolbar&&this._oConditionsGrid&&this._oConditionsGrid.getContent().length>0){var i=this._oConditionsGrid.getContent()[0];if(i.remove&&i.remove.$().position()){w=0;if(this._oPaginatorToolbar.getParent()&&this._oPaginatorToolbar.getParent().getExpandable&&this._oPaginatorToolbar.getParent().getExpandable()){w=48-4;}var j=i.remove.$().position().left-w+i.remove.$().width();this._oPaginatorToolbar.setWidth(j+"px");}}var l=this._oConditionsGrid.getDomRef();if(!l){return;}if(!Q(l).is(":visible")){return;}w=l.clientWidth;var n={};if(w<=this._iBreakPointTablet){n.name="Phone";}else if((w>this._iBreakPointTablet)&&(w<=this._iBreakPointDesktop)){n.name="Tablet";}else{n.name="Desktop";}if(n.name==="Phone"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}if(n.name==="Tablet"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}if(n.name==="Desktop"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}};
U.prototype._findConfig=function(i,j){if(typeof i==="object"){i=i.getMetadata().getName();}var l;while(i&&!(l=this._getConfig(i,j))){i=this._getParentType(i);}return l;};
U.prototype._getConfig=function(i,j){var l=this._mOpsForType[i];if(l){return l[j];}};
U.prototype._getParentType=function(i){return this._mTypes[i];};
U.prototype._mTypes={"base":undefined,"string":"base","numeric":"base","date":"base","time":"base","boolean":"base","int":"numeric","float":"numeric","sap.ui.model.type.Boolean":"boolean","sap.ui.model.type.Date":"date","sap.ui.model.type.FileSize":"string","sap.ui.model.type.Float":"float","sap.ui.model.type.Integer":"int","sap.ui.model.type.String":"string","sap.ui.model.type.Time":"time","sap.ui.comp.odata.type.StringDate":"date","sap.ui.model.odata.type.Boolean":"boolean","sap.ui.model.odata.type.Byte":"int","sap.ui.model.odata.type.Date":"date","sap.ui.model.odata.type.DateTime":"datetime","sap.ui.model.odata.type.DateTimeOffset":"datetime","sap.ui.model.odata.type.Decimal":"float","sap.ui.model.odata.type.Double":"float","sap.ui.model.odata.type.Single":"float","sap.ui.model.odata.type.Guid":"string","sap.ui.model.odata.type.Int16":"int","sap.ui.model.odata.type.Int32":"int","sap.ui.model.odata.type.Int64":"int","sap.ui.model.odata.type.Raw":"string","sap.ui.model.odata.type.SByte":"int","sap.ui.model.odata.type.String":"string","sap.ui.model.odata.type.Time":"time","sap.ui.model.odata.type.TimeOfDay":"time","Edm.Boolean":"sap.ui.model.odata.type.Boolean","Edm.Byte":"sap.ui.model.odata.type.Byte","Edm.Date":"sap.ui.model.odata.type.Date","Edm.DateTime":"sap.ui.model.odata.type.DateTime","Edm.DateTimeOffset":"sap.ui.model.odata.type.DateTimeOffset","Edm.Decimal":"sap.ui.model.odata.type.Decimal","Edm.Double":"sap.ui.model.odata.type.Double","Edm.Single":"sap.ui.model.odata.type.Single","Edm.Guid":"sap.ui.model.odata.type.Guid","Edm.Int16":"sap.ui.model.odata.type.Int16","Edm.Int32":"sap.ui.model.odata.type.Int32","Edm.Int64":"sap.ui.model.odata.type.Int64","Edm.SByte":"sap.ui.model.odata.type.SByte","Edm.String":"sap.ui.model.odata.type.String","Edm.Time":"sap.ui.model.odata.type.Time","Edm.TimeOfDay":"sap.ui.model.odata.type.TimeOfDay"};U.prototype._mOpsForType={"base":{ctrl:"input"},"string":{ctrl:"input"},"date":{ctrl:"DatePicker"},"datetime":{ctrl:"DateTimePicker"},"numeric":{ctrl:"input"},"time":{ctrl:"TimePicker"},"boolean":{ctrl:"select"}};return U;});
sap.ui.predefine('sap/m/P13nDialog',['./Dialog','./library','sap/ui/core/EnabledPropagator','./DialogRenderer','sap/ui/core/library','sap/ui/Device','./Bar','./Button','./Title','sap/m/OverflowToolbarLayoutData','sap/ui/base/ManagedObjectObserver',"sap/ui/thirdparty/jquery","sap/base/Log","sap/base/util/isEmptyObject"],function(D,l,E,a,c,b,B,d,T,O,M,q,L,e){"use strict";var f=l.OverflowToolbarPriority;var g=l.ListType;var P=l.P13nPanelType;var h=l.ListMode;var j=c.MessageType;var k=l.ButtonType;var N;var m;
var n=D.extend("sap.m.P13nDialog",{
metadata:{library:"sap.m",properties:{initialVisiblePanelType:{type:"string",group:"Misc",defaultValue:null},showReset:{type:"boolean",group:"Appearance",defaultValue:false},showResetEnabled:{type:"boolean",group:"Appearance",defaultValue:false},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{panels:{type:"sap.m.P13nPanel",multiple:true,singularName:"panel",bindable:"bindable"}},events:{ok:{},cancel:{},reset:{}}},
renderer:function(r,C){a.render.apply(this,arguments);var i=C._getVisiblePanelID();var p=C.getVisiblePanel();if(i&&p){r.write("<div");r.writeAttribute("id",i);r.write(">");r.renderControl(p);r.write("</div>");}}
});
E.apply(n.prototype,[true]);
n.prototype.init=function(o){this.addStyleClass("sapMP13nDialog");D.prototype.init.apply(this,arguments);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._mValidationListener={};this._createDialog();this._mVisibleNavigationItems={};this._bNavigationControlsPromiseResolved=false;this._oNavigationControlsPromise=this._requestRequiredNavigationControls();this._oObserver=new M(_.bind(this));this._oObserver.observe(this,{properties:["showReset","showResetEnabled"],aggregations:["panels"]});};
n.prototype.setShowResetEnabled=function(i){return this.setProperty("showResetEnabled",i,true);};
n.prototype._createDialog=function(){if(b.system.phone){var t=this;this.setStretch(true);this.setVerticalScrolling(false);this.setHorizontalScrolling(false);this.setCustomHeader(new B(this.getId()+"-phoneHeader",{contentLeft:new d(this.getId()+"-backToList",{visible:false,type:k.Back,press:function(){t._backToList();}}),contentMiddle:new T(this.getId()+"-phoneTitle",{text:this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"),level:"H2"})}));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}else{this.setHorizontalScrolling(false);this.setContentWidth("65rem");this.setContentHeight("40rem");this.setDraggable(true);this.setResizable(true);this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}};
n.prototype._showValidationDialog=function(C,F,v){var w=[];var i=[];this._prepareMessages(F,v,w,i);var t=this;return new Promise(function(r){sap.ui.require(["sap/m/MessageBox"],function(o){var s="";if(i.length){i.forEach(function(p,I,u){s=(u.length>1?"• ":"")+p.messageText+"\n"+s;});o.show(s,{icon:o.Icon.ERROR,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE_ERROR"),actions:[o.Action.CLOSE],styleClass:t.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}else if(w.length){w.forEach(function(p,I,u){s=(u.length>1?"• ":"")+p.messageText+"\n"+s;});s=s+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE_QUESTION");o.show(s,{icon:o.Icon.WARNING,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE"),actions:[sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_FIX"),o.Action.IGNORE],onClose:function(A){if(A===o.Action.IGNORE){C();}},styleClass:t.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}r();});});};
n.prototype._prepareMessages=function(F,v,w,o){if(!F.length&&!v.length){return;}F.forEach(function(p){switch(p){case P.filter:v.push({messageType:j.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE")});break;case P.columns:v.push({messageType:j.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VISIBLE_ITEMS_THRESHOLD_MESSAGE")});break;default:L.error("Panel type '"+p+"' is not supported jet.");}});var u=v.filter(function(p,I,r){for(var i=++I;i<r.length;i++){if(p.messageText===r[i].messageText){return false;}}return true;});u.forEach(function(i){if(i.messageType===j.Warning){w.push(i);}else if(i.messageType===j.Error){o.push(i);}});};
n.prototype._mapPanelToNavigationItem=function(p){if(!p){return null;}return b.system.phone?new m(p.getId()+"-navItem",{type:g.Navigation,title:p.getTitle()}):new m(p.getId()+"-navItem",{text:p.getTitle()});};
n.prototype._switchPanel=function(o){var p=this._getPanelByNavigationItem(o);this.setVerticalScrolling(p.getVerticalScrolling());if(b.system.phone){var i=this._getNavigationControl();if(i){i.setVisible(false);p.beforeNavigationTo();p.setVisible(true);this.getCustomHeader().getContentMiddle()[0].setText(p.getTitle());this.getCustomHeader().getContentLeft()[0].setVisible(true);}}else{this.getPanels().forEach(function(r){if(r===p){r.beforeNavigationTo();r.setVisible(true);}else{r.setVisible(false);}},this);}this.invalidate();this.rerender();};
n.prototype._backToList=function(){var o=this._getNavigationControl();if(o){o.setVisible(true);var p=this.getVisiblePanel();p.setVisible(false);this._updateDialogTitle();this.getCustomHeader().getContentLeft()[0].setVisible(false);}};
n.prototype.getVisiblePanel=function(){var p=null;this.getPanels().some(function(o){if(o.getVisible()){p=o;return true;}});return p;};
n.prototype._getVisiblePanelID=function(){var p=this.getVisiblePanel();if(p){return this.getId()+"-panel_"+p.getId();}return null;};
n.prototype._getPanelByNavigationItem=function(o){for(var i=0,p=this.getPanels(),r=p.length;i<r;i++){if(this._getNavigationItemByPanel(p[i])===o){return p[i];}}return null;};
n.prototype._getNavigationItemByPanel=function(p){return p?p.data("sapMP13nDialogNavigationItem"):null;};
n.prototype.onAfterRendering=function(){D.prototype.onAfterRendering.apply(this,arguments);var C=q(this.getFocusDomRef()).find(".sapMDialogScrollCont");var i=this._getVisiblePanelID();if(i&&C){var p=q(document.getElementById(i));p.appendTo(q(C));}};
n.prototype._updateDialogTitle=function(){var p=this.getVisiblePanel();var t=this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");if(!this._isNavigationControlExpected()&&p){switch(p.getType()){case P.filter:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_FILTER");break;case P.sort:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_SORT");break;case P.group:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_GROUP");break;case P.columns:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_COLUMNS");break;case P.dimeasure:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_DIMEASURE");break;default:t=p.getTitleLarge()||this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");}}if(b.system.phone){this.getCustomHeader().getContentMiddle()[0].setText(t);}else{this.setTitle(t);}};
n.prototype._registerValidationListener=function(p,C){if(this.getPanels().indexOf(p)&&C&&this._mValidationListener[p.getType()]===undefined){this._mValidationListener[p.getType()]=C;}};
n.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v&&!e(this._mValidationListener)){var t=this;v(this._getPayloadOfPanels()).then(function(V){var r=t._distributeValidationResult(V);for(var s in t._mValidationListener){var C=t._mValidationListener[s];C(r[s]||[]);}});}};
n.prototype._distributeValidationResult=function(r){var o={};r.forEach(function(R){R.panelTypes.forEach(function(t){if(o[t]===undefined){o[t]=[];}o[t].push({columnKey:R.columnKey,messageType:R.messageType,messageText:R.messageText});});});return o;};
n.prototype._createOKButton=function(){var t=this;return new d(this.getId()+"-ok",{type:k.Emphasized,text:this._oResourceBundle.getText("P13NDIALOG_OK"),layoutData:new O({priority:f.NeverOverflow}),press:function(){t.setBusy(true);var p=t._getPayloadOfPanels();var F=function(){t.setBusy(false);t.fireOk({payload:p});};var i=[];var C=function(){t.getPanels().forEach(function(o){if(i.indexOf(o.getType())>-1){o.onAfterNavigationFrom();}});F();};t.getPanels().forEach(function(o){if(!o.onBeforeNavigationFrom()){i.push(o.getType());}});var v=[];var V=t.getValidationExecutor();if(V){V(p).then(function(v){if(i.length||v.length){t.setBusy(false);t._showValidationDialog(C,i,v);}else{F();}});}else{if(i.length||v.length){t.setBusy(false);t._showValidationDialog(C,i,v);}else{F();}}}});};
n.prototype._createCancelButton=function(){var t=this;return new d(this.getId()+"-cancel",{text:this._oResourceBundle.getText("P13NDIALOG_CANCEL"),layoutData:new O({priority:f.NeverOverflow}),press:function(){t.fireCancel();}});};
n.prototype._createResetButton=function(){var t=this;return new d(this.getId()+"-reset",{text:this._oResourceBundle.getText("P13NDIALOG_RESET"),layoutData:new O({priority:f.NeverOverflow}),visible:this.getShowReset(),enabled:this.getShowResetEnabled(),press:function(){sap.ui.getCore().byId(t.getId()+"-ok").focus();t.setShowResetEnabled(false);var p={};t.getPanels().forEach(function(o){p[o.getType()]=o.getResetPayload();});t.fireReset({payload:p});}});};
n.prototype._getPayloadOfPanels=function(){var p={};this.getPanels().forEach(function(o){p[o.getType()]=o.getOkPayload();});return p;};
n.prototype.exit=function(){D.prototype.exit.apply(this,arguments);this._oObserver.disconnect();this._oObserver=undefined;this._mValidationListener={};this._mVisibleNavigationItems={};this._oNavigationControlsPromise=null;};
n.prototype._isInstanceOf=function(o,s){var C=sap.ui.require(s);return o&&typeof C==='function'&&(o instanceof C);};
function _(C){if(this._isInstanceOf(C.object,"sap/m/P13nDialog")){var i;switch(C.name){case"panels":var p=C.child?[C.child]:C.children;p.forEach(function(o){switch(C.mutation){case"insert":this._mVisibleNavigationItems[o.sId]=o.getVisible();o.setVisible(false);o.beforeNavigationTo();this._oObserver.observe(o,{properties:["title"]});o.setValidationExecutor(q.proxy(this._callValidationExecutor,this));o.setValidationListener(q.proxy(this._registerValidationListener,this));break;case"remove":delete this._mVisibleNavigationItems[o.sId];this._oObserver.unobserve(o);o.setValidationExecutor();o.setValidationListener();break;default:L.error("Mutation '"+C.mutation+"' is not supported jet.");}},this);if(this._bNavigationControlsPromiseResolved){this._updateDialog();}else{this._oNavigationControlsPromise.then(function(){this._updateDialog();}.bind(this));}break;case"showReset":i=this.getButtons();if(i.length>1){i[2].setVisible(C.current);}break;case"showResetEnabled":i=this.getButtons();if(i.length>1){i[2].setEnabled(C.current);i[2].invalidate();}break;default:L.error("The property or aggregation '"+C.name+"' has not been registered.");}}else if(this._isInstanceOf(C.object,"sap/m/P13nPanel")){if(C.name==="title"){var I=this._getNavigationItemByPanel(C.object);if(I){if(b.system.phone){I.setTitle(C.current);}else{I.setText(C.current);}}}}}
n.prototype._isNavigationControlExpected=function(){return this._getCountOfVisibleNavigationItems()>1;};
n.prototype._getCountOfVisibleNavigationItems=function(){var C=0;for(var i in this._mVisibleNavigationItems){C=this._mVisibleNavigationItems[i]?C+1:C;}return C;};
n.prototype._isNavigationControlExists=function(){return b.system.phone?this.getContent().length>0:(!!this.getSubHeader()&&this.getSubHeader().getContentLeft().length>0);};
n.prototype._getNavigationControl=function(){if(!this._isNavigationControlExists()){this._createNavigationControl();}return b.system.phone?this.getContent()[0]:this.getSubHeader().getContentLeft()[0];};
n.prototype._setVisibleOfNavigationControl=function(v){if(!this._isNavigationControlExists()){return;}return b.system.phone?this.getContent()[0].setVisible(v):this.getSubHeader().setVisible(v);};
n.prototype._createNavigationControl=function(){if(b.system.phone){this.addContent(new N(this.getId()+"-navigationItems",{mode:h.None,itemPress:function(o){this._switchPanel(o.getParameter("listItem"));}.bind(this)}));}else{this.setSubHeader(new B(this.getId()+"-navigationBar",{contentLeft:new N(this.getId()+"-navigationItems",{width:'100%',selectionChange:function(o){this._switchPanel(o.getParameter("item"));}.bind(this)})}));}return this._getNavigationControl();};
n.prototype._updateDialog=function(){var o=this._getNavigationControl();o.destroyItems();var i=this._determineInitialVisiblePanel();this.getPanels().forEach(function(p){var r=this._mapPanelToNavigationItem(p);p.data("sapMP13nDialogNavigationItem",r);o.addItem(r);var v=b.system.phone?this._mVisibleNavigationItems[p.sId]&&this._getCountOfVisibleNavigationItems()===1:this._mVisibleNavigationItems[p.sId]&&i===p.sId;p.setVisible(v);if(v){if(!b.system.phone){this.setVerticalScrolling(p.getVerticalScrolling());}}r.setVisible(this._mVisibleNavigationItems[p.sId]);if(v&&o.setSelectedItem){o.setSelectedItem(r);}}.bind(this));this._updateDialogTitle();this._setVisibleOfNavigationControl(this._isNavigationControlExpected());};
n.prototype._determineInitialVisiblePanel=function(){if(this.getInitialVisiblePanelType()){for(var i=0;i<this.getPanels().length;i++){if(this.getPanels()[i].getType()==this.getInitialVisiblePanelType()){return this.getPanels()[i].sId;}}}var I;this.getPanels().some(function(p){if(this._mVisibleNavigationItems[p.sId]){I=p.sId;return true;}}.bind(this));return I;};
n.prototype._requestRequiredNavigationControls=function(){var s=b.system.phone?"sap/m/List":"sap/m/SegmentedButton";var i=b.system.phone?"sap/m/StandardListItem":"sap/m/SegmentedButtonItem";N=sap.ui.require(s);m=sap.ui.require(i);if(N&&m){this._bNavigationControlsPromiseResolved=true;return Promise.resolve();}if(!this._oNavigationControlsPromise){this._oNavigationControlsPromise=new Promise(function(r){sap.ui.require([s,i],function(o,p){N=o;m=p;this._bNavigationControlsPromiseResolved=true;return r();}.bind(this));}.bind(this));}return this._oNavigationControlsPromise;};
return n;});
sap.ui.predefine('sap/m/P13nDimMeasureItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nDimMeasureItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string"},index:{type:"int",defaultValue:-1},visible:{type:"boolean"},role:{type:"string"}}}});
return P;});
sap.ui.predefine('sap/m/P13nDimMeasurePanel',['./library','./P13nPanel','./P13nDimMeasureItem','./SearchField','./Table','./Column','./ColumnListItem','./ScrollContainer','./Text','./Select','./ComboBox','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./OverflowToolbarButton','./ToolbarSpacer','sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler','sap/ui/core/Item','sap/ui/core/InvisibleText','sap/ui/core/IconPool',"sap/ui/thirdparty/jquery"],function(l,P,c,S,T,C,d,e,f,g,h,B,O,i,j,k,m,n,J,o,R,I,p,q,Q){"use strict";var r=l.OverflowToolbarPriority;var s=l.ButtonType;var t=l.ToolbarDesign;var L=l.ListType;var u=l.ListMode;var v=l.P13nPanelType;
var w=P.extend("sap.m.P13nDimMeasurePanel",{
metadata:{library:"sap.m",properties:{chartTypeKey:{type:"string",defaultValue:""}},aggregations:{dimMeasureItems:{type:"sap.m.P13nDimMeasureItem",multiple:true,singularName:"dimMeasureItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},availableChartTypes:{type:"sap.ui.core.Item",multiple:true,singularName:"availableChartType"}},events:{changeDimMeasureItems:{},changeChartType:{}}},
renderer:function(a,b){a.write("<div");a.writeControlData(b);a.addClass("sapMP13nColumnsPanel");a.writeClasses();a.write(">");var x=b.getAggregation("content");if(x){x.forEach(function(y){a.renderControl(y);});}a.write("</div>");}
});
w.prototype.init=function(){var a=this;this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bOnAfterRenderingFirstTimeExecuted=false;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.oAvailableRoleTypes={Dimension:[{key:"category",text:b.getText('COLUMNSPANEL_CHARTROLE_CATEGORY')},{key:"category2",text:b.getText('COLUMNSPANEL_CHARTROLE_CATEGORY2')},{key:"series",text:b.getText('COLUMNSPANEL_CHARTROLE_SERIES')}],Measure:[{key:"axis1",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS1')},{key:"axis2",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS2')},{key:"axis3",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS3')},{key:"axis4",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS4')}]};var M=new J({availableChartTypes:[],selectedChartTypeKey:null,items:[],columnKeyOfMarkedItem:undefined,isMoveDownButtonEnabled:undefined,isMoveUpButtonEnabled:undefined,showOnlySelectedItems:undefined,countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(o.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nDimMeasurePanel");this.setType(v.dimeasure);this.setTitle(b.getText("CHARTPANEL_TITLE"));this._createTable();this._createToolbar();this.setVerticalScrolling(false);var x=new e({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",x);this._fnHandleResize=function(){var y=false,z,A;if(a.getParent){var $=null,D,H;var E=a.getParent();var F=a._getToolbar();if(E&&E.$){$=E.$("cont");if($.children().length>0&&F.$().length>0){z=x.$()[0].clientHeight;D=$.children()[0].clientHeight;H=F?F.$()[0].clientHeight:0;A=D-H;if(z!==A){x.setHeight(A+'px');y=true;}}}}return y;};this._sContainerResizeListener=R.register(x,this._fnHandleResize);};
w.prototype.onBeforeRendering=function(){this._updateInternalModel();if(!this._getInternalModel().getProperty("/columnKeyOfMarkedItem")){this._setColumnKeyOfMarkedItem(this._getColumnKeyByTableItem(this._getVisibleTableItems()[0]));}this._switchMarkedTableItemTo(this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem")));this._updateControlLogic();};
w.prototype.onAfterRendering=function(){var a=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){a._fnHandleResize();a._getToolbar()._resetAndInvalidateToolbar();},0);}};
w.prototype.getOkPayload=function(){this._updateInternalModel();this._getInternalModel().getProperty("/items").forEach(function(M){if(this._getDimMeasureItemByColumnKey(M.columnKey)){return;}if(!M.persistentSelected){return;}this.addAggregation("dimMeasureItems",new c({columnKey:M.columnKey,visible:M.persistentSelected,index:M.persistentIndex===-1?undefined:M.persistentIndex,role:M.role}));},this);return{dimMeasureItems:this.getDimMeasureItems(),chartTypeKey:this.getChartTypeKey()};};
w.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}if(this.oInvisibleChartTypeText){this.oInvisibleChartTypeText.destroy();this.oInvisibleChartTypeText=null;}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
w.prototype.addItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",a);return this;};
w.prototype.insertItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",a,b);return this;};
w.prototype.removeItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}a=this.removeAggregation("items",a);return a;};
w.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
w.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
w.prototype.addDimMeasureItem=function(D){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("dimMeasureItems",D);return this;};
w.prototype.insertDimMeasureItem=function(D,a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("dimMeasureItems",D,a);return this;};
w.prototype.updateDimMeasureItems=function(a){this.updateAggregation("dimMeasureItems");if(a===n.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
w.prototype.removeDimMeasureItem=function(D){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("dimMeasureItems",D);};
w.prototype.removeAllDimMeasureItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("dimMeasureItems");};
w.prototype.destroyDimMeasureItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("dimMeasureItems");return this;};
w.prototype.setChartTypeKey=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.setProperty("chartTypeKey",a);return this;};
w.prototype.addAvailableChartType=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("availableChartTypes",a);return this;};
w.prototype.insertAvailableChartType=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("availableChartTypes",a,b);return this;};
w.prototype.removeAvailableChartType=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("availableChartTypes",a);};
w.prototype.removeAllAvailableChartType=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("availableChartTypes");};
w.prototype.destroyAvailableChartType=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("availableChartTypes");return this;};
w.prototype._notifyChange=function(){var a=this.getChangeNotifier();if(a){a(this);}};
w.prototype._scrollToSelectedItem=function(a){if(!a){return;}sap.ui.getCore().applyChanges();if(!!a.getDomRef()){a.focus();}};
w.prototype._getInternalModel=function(){return this.getModel("$sapmP13nDimMeasurePanel");};
w.prototype._createTable=function(){var a=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T({mode:u.MultiSelect,rememberSelections:false,itemPress:Q.proxy(this._onItemPressed,this),selectionChange:Q.proxy(this._onSelectionChange,this),columns:[new C({vAlign:m.VerticalAlign.Middle,header:new f({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(b,x){return a.getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[b,x]);}}})}),new C({vAlign:m.VerticalAlign.Middle,header:new f({text:a.getText('COLUMNSPANEL_COLUMN_TYPE')})}),new C({vAlign:m.VerticalAlign.Middle,header:new f({text:a.getText('COLUMNSPANEL_COLUMN_ROLE')})})],items:{path:"/items",templateShareable:false,template:new d({cells:[new f({text:"{text}"}),new f({text:{path:'',formatter:function(M){if(M.aggregationRole==="Dimension"){return a.getText('COLUMNSPANEL_TYPE_DIMENSION');}if(M.aggregationRole==="Measure"){return a.getText('COLUMNSPANEL_TYPE_MEASURE');}}}}),new g({selectedKey:"{role}",items:{path:'availableRoleTypes',factory:function(b,x){var A=x.getObject();return new I({key:A.key,text:A.text});}},change:Q.proxy(this._onRoleChange,this)})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:L.Active})}});this._oTable.setModel(this._getInternalModel());};
w.prototype._createToolbar=function(){var a=this;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var x=new p({text:b.getText('COLUMNSPANEL_CHARTTYPE')});this.oInvisibleChartTypeText=x;var y=new h({placeholder:x.getText(),selectedKey:{path:'/selectedChartTypeKey'},ariaLabelledBy:x,items:{path:'/availableChartTypes',templateShareable:false,template:new I({key:"{key}",text:"{text}"})},selectionChange:Q.proxy(this._onChartTypeChange,this),layoutData:new i({moveToOverflow:false,stayInOverflow:false})});var z=new O(this.getId()+"-toolbar",{design:t.Auto,content:[x,y,new k(),new S(this.getId()+"-searchField",{liveChange:function(E){var V=E.getSource().getValue(),D=(V?300:0);window.clearTimeout(a._iSearchTimer);if(D){a._iSearchTimer=window.setTimeout(function(){a._onExecuteSearch();},D);}else{a._onExecuteSearch();}},search:Q.proxy(this._onExecuteSearch,this),layoutData:new i({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})}),new B({text:{path:'/showOnlySelectedItems',formatter:function(A){return A?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},tooltip:{path:'/showOnlySelectedItems',formatter:function(A){return A?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},type:s.Transparent,press:Q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new i({moveToOverflow:true,priority:r.High})}),new j({icon:q.getIconURI("collapse-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),type:s.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:Q.proxy(this.onPressButtonMoveToTop,this),layoutData:new i({moveToOverflow:true,priority:r.Low,group:2})}),new j({icon:q.getIconURI("slim-arrow-up"),text:b.getText('COLUMNSPANEL_MOVE_UP'),tooltip:b.getText('COLUMNSPANEL_MOVE_UP'),type:s.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:Q.proxy(this.onPressButtonMoveUp,this),layoutData:new i({moveToOverflow:true,priority:r.High,group:1})}),new j({icon:q.getIconURI("slim-arrow-down"),text:b.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:b.getText('COLUMNSPANEL_MOVE_DOWN'),type:s.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:Q.proxy(this.onPressButtonMoveDown,this),layoutData:new i({moveToOverflow:true,priority:r.High,group:1})}),new j({icon:q.getIconURI("expand-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),type:s.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:Q.proxy(this.onPressButtonMoveToBottom,this),layoutData:new i({moveToOverflow:true,priority:r.Low,group:2})})]});z.setModel(this._getInternalModel());this.addAggregation("content",z);};
w.prototype.onPressButtonMoveToTop=function(){this._moveMarkedTableItem(this._getMarkedTableItem(),this._getVisibleTableItems()[0]);};
w.prototype.onPressButtonMoveUp=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.indexOf(this._getMarkedTableItem())-1]);};
w.prototype.onPressButtonMoveDown=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.indexOf(this._getMarkedTableItem())+1]);};
w.prototype.onPressButtonMoveToBottom=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.length-1]);};
w.prototype._onSwitchButtonShowSelected=function(){this._getInternalModel().setProperty("/showOnlySelectedItems",!this._getInternalModel().getProperty("/showOnlySelectedItems"));this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fnHandleResize();};
w.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
w.prototype._switchVisibilityOfUnselectedModelItems=function(){var b=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(a){if(a.persistentSelected){a.visible=true;return;}a.visible=!b;});this._getInternalModel().setProperty("/items",M);};
w.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
w.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
w.prototype._moveMarkedTableItem=function(a,b){var M=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(a));var x=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(b));var y=this._getModelItemIndexByColumnKey(M.columnKey);var z=this._getModelItemIndexByColumnKey(x.columnKey);this._moveModelItems(y,z);this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._moveModelItems=function(a,b){var M=this._getInternalModel().getProperty("/items");if(a<0||b<0||a>M.length-1||b>M.length-1){return false;}this._removeStyleOfMarkedTableItem();var x=M.splice(a,1);M.splice(b,0,x[0]);this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());return true;};
w.prototype._getModelItemByColumnKey=function(a){var M=this._getInternalModel().getProperty("/items").filter(function(b){return b.columnKey===a;});return M[0];};
w.prototype._updateCounts=function(M){var a=0;var b=0;M.forEach(function(x){a++;if(x.persistentSelected){b++;}});this._getInternalModel().setProperty("/countOfItems",a);this._getInternalModel().setProperty("/countOfSelectedItems",b);};
w.prototype._sortModelItemsByPersistentIndex=function(M){var x;var y=sap.ui.getCore().getConfiguration().getLocale().toString();try{if(typeof window.Intl!=='undefined'){x=window.Intl.Collator(y,{numeric:true});}}catch(E){}M.forEach(function(a,b){a.localIndex=b;});M.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex>-1&&a.persistentIndex<b.persistentIndex){return-1;}else if(b.persistentIndex>-1&&a.persistentIndex>b.persistentIndex){return 1;}else{return a.localIndex-b.localIndex;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){return x?x.compare(a.text,b.text):a.text.localeCompare(b.text,y,{numeric:true});}});M.forEach(function(a){delete a.localIndex;});};
w.prototype._getColumnKeyByTableItem=function(a){var b=this._oTable.indexOfItem(a);if(b<0){return null;}return this._oTable.getBinding("items").getContexts()[b].getObject().columnKey;};
w.prototype._getModelItemIndexByColumnKey=function(a){var b=-1;this._getInternalModel().getData().items.some(function(M,x){if(M.columnKey===a){b=x;return true;}});return b;};
w.prototype._getSelectedModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return M.persistentSelected;});};
w.prototype._getVisibleTableItems=function(){return this._oTable.getItems().filter(function(a){return a.getVisible();});};
w.prototype._getTableItemByColumnKey=function(a){var b=this._oTable.getBinding("items").getContexts();var x=this._oTable.getItems().filter(function(y,z){return b[z].getObject().columnKey===a;});return x[0];};
w.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
w.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
w.prototype._getSearchText=function(){var a=this._getSearchField();return a?a.getValue():"";};
w.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
w.prototype._isFilteredByShowSelected=function(){return this._getInternalModel().getData().showOnlySelectedItems;};
w.prototype._updateControlLogic=function(){var b=this._isFilteredBySearchText();var a=this._isFilteredByShowSelected();var V=this._getVisibleTableItems();this._getInternalModel().setProperty("/isMoveUpButtonEnabled",V.indexOf(this._getMarkedTableItem())>0);this._getInternalModel().setProperty("/isMoveDownButtonEnabled",V.indexOf(this._getMarkedTableItem())>-1&&V.indexOf(this._getMarkedTableItem())<V.length-1);var x=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(x){x.setEnabled(!b&&!a);}};
w.prototype._updateModelItemsPersistentIndex=function(M){var a=-1;M.forEach(function(b){b.persistentIndex=-1;if(b.persistentSelected){a++;b.persistentIndex=a;}});};
w.prototype._fireChangeDimMeasureItems=function(){this._bIgnoreUpdateInternalModel=true;this.fireChangeDimMeasureItems({items:this._getInternalModel().getProperty("/items").map(function(M){return{columnKey:M.columnKey,visible:M.persistentSelected,index:M.persistentIndex===-1?undefined:M.persistentIndex,role:M.role};})});this._bIgnoreUpdateInternalModel=false;};
w.prototype._fireChangeChartType=function(){this._bIgnoreUpdateInternalModel=true;this.fireChangeChartType({chartTypeKey:this._getInternalModel().getProperty("/selectedChartTypeKey")});this._bIgnoreUpdateInternalModel=false;};
w.prototype._getDimMeasureItemByColumnKey=function(a){var D=this.getDimMeasureItems().filter(function(b){return b.getColumnKey()===a;});return D[0];};
w.prototype._getMarkedTableItem=function(){return this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem"));};
w.prototype._setColumnKeyOfMarkedItem=function(a){this._getInternalModel().setProperty("/columnKeyOfMarkedItem",a);};
w.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));this._updateControlLogic();};
w.prototype._onChartTypeChange=function(E){this._fireChangeChartType();this._notifyChange();};
w.prototype._onRoleChange=function(E){this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._onSelectionChange=function(E){if(!E.getParameter("selectAll")&&E.getParameter("listItems").length===1){this._switchMarkedTableItemTo(E.getParameter("listItem"));}this._selectTableItem();};
w.prototype._selectTableItem=function(){this._updateControlLogic();var M=this._getInternalModel().getProperty("/items");this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._switchMarkedTableItemTo=function(a){this._removeStyleOfMarkedTableItem();var b=this._getColumnKeyByTableItem(a);if(b){this._setColumnKeyOfMarkedItem(b);a.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
w.prototype._removeStyleOfMarkedTableItem=function(){if(this._getMarkedTableItem()){this._getMarkedTableItem().removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
w.prototype._filterModelItemsBySearchText=function(){var a=this._getSearchText();a=a.replace(/(^\s+)|(\s+$)/g,'');a=a.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var b=new RegExp(a,'igm');if(!b){return;}this._getVisibleModelItems().forEach(function(M){var x=this._getTableItemByColumnKey(M.columnKey);var y=x.getCells();M.visible=false;if(y[0]&&y[0].getText().match(b)){M.visible=true;}if(y[1]&&y[1].getText().match(b)){M.visible=true;}if(y[2]&&y[2].getSelectedItem()&&y[2].getSelectedItem().getText().match(b)){M.visible=true;}if(M.tooltip&&M.tooltip.match(b)){M.visible=true;}},this);this._getInternalModel().refresh();};
w.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._removeStyleOfMarkedTableItem();this._getInternalModel().setProperty("/items",this.getItems().map(function(a){return{columnKey:a.getColumnKey(),visible:true,text:a.getText(),tooltip:a.getTooltip(),aggregationRole:a.getAggregationRole(),availableRoleTypes:this.oAvailableRoleTypes[a.getAggregationRole()],role:a.getRole(),persistentIndex:-1,persistentSelected:undefined};},this));this._getInternalModel().setProperty("/selectedChartTypeKey",this.getChartTypeKey());this._getInternalModel().setProperty("/availableChartTypes",this.getAvailableChartTypes().map(function(a){return{key:a.getKey(),text:a.getText()};},this));this.getDimMeasureItems().forEach(function(D){var a=this._getModelItemByColumnKey(D.getColumnKey());if(!a){return;}if(D.getIndex()!==undefined){a.persistentIndex=D.getIndex();}if(D.getVisible()!==undefined){a.persistentSelected=D.getVisible();}if(D.getRole()!==undefined){a.role=D.getRole();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var M=this._getInternalModel().getProperty("/items");this._sortModelItemsByPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());};
return w;});
sap.ui.predefine('sap/m/P13nFilterItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nFilterItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},value1:{type:"string",group:"Misc",defaultValue:null},value2:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},exclude:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setOperation=function(o){return this.setProperty("operation",o,true);};
P.prototype.setColumnKey=function(k){return this.setProperty("columnKey",k,true);};
P.prototype.setValue1=function(v){return this.setProperty("value1",v,true);};
P.prototype.setValue2=function(v){return this.setProperty("value2",v,true);};
P.prototype.setExclude=function(e){return this.setProperty("exclude",e,true);};
return P;});
sap.ui.predefine('sap/m/P13nFilterPanel',['./P13nConditionPanel','./P13nPanel','./library','sap/m/Panel','./P13nFilterItem'],function(P,a,l,b,c){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nFilterPanel",{
metadata:{library:"sap.m",properties:{maxIncludes:{type:"string",group:"Misc",defaultValue:'-1'},maxExcludes:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},enableEmptyOperations:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},filterItems:{type:"sap.m.P13nFilterItem",multiple:true,singularName:"filterItem",bindable:"bindable"}},events:{addFilterItem:{},removeFilterItem:{},updateFilterItem:{},filterItemChanged:{parameters:{reason:{type:"string"},key:{type:"string"},index:{type:"int"},itemData:{type:"object"}}}}},
renderer:function(r,C){r.write("<section");r.writeControlData(C);r.addClass("sapMFilterPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMFilterPanelContent");r.addClass("sapMFilterPanelBG");r.writeClasses();r.write(">");var g=C.getAggregation("content");var L=g.length;for(var i=0;i<L;i++){r.renderControl(g[i]);}r.write("</div>");r.write("</section>");}
});
f.prototype.setConditions=function(C){var I=[];var E=[];if(C.length){for(var i=0;i<C.length;i++){var o=C[i];if(!o.exclude){I.push(o);}else{E.push(o);}}}this._oIncludeFilterPanel.setConditions(I);this._oExcludeFilterPanel.setConditions(E);if(E.length>0){this._oExcludePanel.setExpanded(true);}return this;};
f.prototype.getConditions=function(){var i=this._oIncludeFilterPanel.getConditions();var E=this._oExcludeFilterPanel.getConditions();return i.concat(E);};
f.prototype.setContainerQuery=function(C){this.setProperty("containerQuery",C);this._oIncludeFilterPanel.setContainerQuery(C);this._oExcludeFilterPanel.setContainerQuery(C);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oIncludeFilterPanel.setLayoutMode(m);this._oExcludeFilterPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oIncludeFilterPanel.validateConditions()&&this._oExcludeFilterPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oIncludeFilterPanel.removeInvalidConditions();this._oExcludeFilterPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oIncludeFilterPanel.removeValidationErrors();this._oExcludeFilterPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setIncludeOperations=function(o,t){t=t||"default";this._aIncludeOperations[t]=o;if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}};
f.prototype.getIncludeOperations=function(t){if(this._oIncludeFilterPanel){return this._oIncludeFilterPanel.getOperations(t);}};
f.prototype.setExcludeOperations=function(o,t){t=t||"default";this._aExcludeOperations[t]=o;if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}};
f.prototype.getExcludeOperations=function(t){if(this._oExcludeFilterPanel){return this._oExcludeFilterPanel.getOperations(t);}};
f.prototype.setKeyFields=function(k,K){this._aKeyFields=k;if(this._oIncludeFilterPanel){k.some(function(o){if(o.isDefault){this._oIncludeFilterPanel.setAutoAddNewRow(true);}}.bind(this));this._oIncludeFilterPanel.setKeyFields(k);}if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setKeyFields((Array.isArray(K)&&K.length>0)?K:k);}};
f.prototype.getKeyFields=function(){return this._aKeyFields;};
f.prototype.setMaxIncludes=function(m){this.setProperty("maxIncludes",m);if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
f.prototype.setMaxExcludes=function(m){this.setProperty("maxExcludes",m);if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
f.prototype._updatePanel=function(){var m=this.getMaxIncludes()==="-1"?1000:parseInt(this.getMaxIncludes());var M=this.getMaxExcludes()==="-1"?1000:parseInt(this.getMaxExcludes());if(m>0){if(M<=0){this._oIncludePanel.setHeaderText(null);this._oIncludePanel.setExpandable(false);this._oIncludePanel.addStyleClass("panelTopMargin");this._oIncludePanel.addStyleClass("panelNoHeader");}}if(M===0){this._oExcludePanel.setHeaderText(null);this._oExcludePanel.setExpandable(false);this._oExcludePanel.addStyleClass("panelNoHeader");}};
f.prototype.init=function(){this.setType(d.filter);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FILTERPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");this._aKeyFields=[];this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aIncludeOperations={};if(!this._aIncludeOperations["default"]){this.setIncludeOperations([e.EQ,e.BT,e.LT,e.LE,e.GT,e.GE]);}if(!this._aIncludeOperations["string"]){this.setIncludeOperations([e.Contains,e.EQ,e.BT,e.StartsWith,e.EndsWith,e.LT,e.LE,e.GT,e.GE],"string");}if(!this._aIncludeOperations["date"]){this.setIncludeOperations([e.EQ,e.BT,e.LT,e.LE,e.GT,e.GE],"date");}if(!this._aIncludeOperations["time"]){this.setIncludeOperations([e.EQ,e.BT,e.LT,e.LE,e.GT,e.GE],"time");}if(!this._aIncludeOperations["datetime"]){this.setIncludeOperations([e.EQ,e.BT,e.LT,e.LE,e.GT,e.GE],"datetime");}if(!this._aIncludeOperations["numeric"]){this.setIncludeOperations([e.EQ,e.BT,e.LT,e.LE,e.GT,e.GE],"numeric");}if(!this._aIncludeOperations["numc"]){this.setIncludeOperations([e.Contains,e.EQ,e.BT,e.EndsWith,e.LT,e.LE,e.GT,e.GE],"numc");}if(!this._aIncludeOperations["boolean"]){this.setIncludeOperations([e.EQ],"boolean");}this._aExcludeOperations={};if(!this._aExcludeOperations["default"]){this.setExcludeOperations([e.EQ]);}this._oIncludePanel=new b({expanded:true,expandable:true,headerText:this._oRb.getText("FILTERPANEL_INCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oIncludeFilterPanel=new P({maxConditions:this.getMaxIncludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oIncludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";for(var t in this._aIncludeOperations){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}this._oIncludePanel.addContent(this._oIncludeFilterPanel);this.addAggregation("content",this._oIncludePanel);this._oExcludePanel=new b({expanded:false,expandable:true,headerText:this._oRb.getText("FILTERPANEL_EXCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oExcludeFilterPanel=new P({exclude:true,maxConditions:this.getMaxExcludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oExcludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";for(var t in this._aExcludeOperations){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}this._oExcludePanel.addContent(this._oExcludeFilterPanel);this.addAggregation("content",this._oExcludePanel);this._updatePanel();};
f.prototype.exit=function(){var g=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=g(this._aKeyFields);this._aIncludeOperations=g(this._aIncludeOperations);this._aExcludeOperations=g(this._aExcludeOperations);this._oRb=g(this._oRb);};
f.prototype.onBeforeRendering=function(){var k=[],K,m,E=this.getEnableEmptyOperations();if(this._bUpdateRequired){this._bUpdateRequired=false;K=[];m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var B=i.getBinding(n),M;if(B&&o){return o.getObject()[B.getPath()];}M=i.getMetadata();return M.hasProperty(n)?M.getProperty(n).get(i):M.getAggregation(n).get(i);};this.getItems().forEach(function(i){var o=i.getBindingContext(m),F,n,h;if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}K.push(F={key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i),maxLength:g("maxLength",o,i),type:g("type",o,i),typeInstance:g("typeInstance",o,i),formatSettings:g("formatSettings",o,i),precision:g("precision",o,i),scale:g("scale",o,i),isDefault:g("isDefault",o,i),values:g("values",o,i)});if(E){n=i.getNullable();h={};Object.keys(F).forEach(function(s){h[s]=F[s];});k.push(h);this._enhanceFieldOperationsWithEmpty(h,n,true);this._enhanceFieldOperationsWithEmpty(F,n);this._modifyFieldOperationsBasedOnMaxLength(h);}this._modifyFieldOperationsBasedOnMaxLength(F);},this);this.setKeyFields(K,k);var C=[];m=(this.getBindingInfo("filterItems")||{}).model;this.getFilterItems().forEach(function(F){var o=F.getBindingContext(m);if(F.getBinding("key")&&o){o.getObject()[F.getBinding("key").getPath()]=F.getKey();}C.push({key:F.getKey(),keyField:g("columnKey",o,F),operation:g("operation",o,F),value1:g("value1",o,F),value2:g("value2",o,F),exclude:g("exclude",o,F)});});this.setConditions(C);}};
f.prototype._modifyFieldOperationsBasedOnMaxLength=function(F){var o;if(F.maxLength===1||F.maxLength==="1"){o=F.operations?F.operations:this._oIncludeFilterPanel.getOperations(F.type);F.operations=[];o.forEach(function(O){if([e.Contains,e.StartsWith,e.EndsWith].indexOf(O)===-1){F.operations.push(O);}},this);}};
f.prototype._enhanceFieldOperationsWithEmpty=function(F,n,E){var o,O;if(["string","stringdate"].indexOf(F.type)>-1||(["date","datetime"].indexOf(F.type)>-1&&n)){o=this[E?"_oExcludeFilterPanel":"_oIncludeFilterPanel"];O=o.getOperations(F.type);if(!O){O=o.getOperations();}if(!Array.isArray(F.operations)){F.operations=[];}O.forEach(function(s){F.operations.push(s);});if(F.operations.indexOf(e.Empty)===-1){F.operations.push(e.Empty);}}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);this._bUpdateRequired=true;return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addFilterItem=function(F){this.addAggregation("filterItems",F,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertFilterItem=function(F,i){this.insertAggregation("filterItems",F,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateFilterItems=function(r){this.updateAggregation("filterItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeFilterItem=function(F){F=this.removeAggregation("filterItems",F,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return F;};
f.prototype.removeAllFilterItems=function(){var F=this.removeAllAggregation("filterItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return F;};
f.prototype.destroyFilterItems=function(){this.destroyAggregation("filterItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var C=E.getParameter("index");var F;var I=-1;var g=E.getSource()===t._oExcludeFilterPanel;t.getFilterItems().some(function(h,i){if((!h.getExclude()&&!g)||(h.getExclude()&&g)){C--;}I=i;return C<0;},this);switch(o){case"update":F=t.getFilterItems()[I];if(F){F.setExclude(n.exclude);F.setColumnKey(n.keyField);F.setOperation(n.operation);F.setValue1(n.value1);F.setValue2(n.value2);}t.fireUpdateFilterItem({key:k,index:I,filterItemData:F});t.fireFilterItemChanged({reason:"updated",key:k,index:I,itemData:{columnKey:n.keyField,operation:n.operation,exclude:n.exclude,value1:n.value1,value2:n.value2}});break;case"add":if(C>=0){I++;}F=new c({columnKey:n.keyField,exclude:n.exclude,operation:n.operation});F.setValue1(n.value1);F.setValue2(n.value2);t._bIgnoreBindCalls=true;t.fireAddFilterItem({key:k,index:I,filterItemData:F});t.fireFilterItemChanged({reason:"added",key:k,index:I,itemData:{columnKey:n.keyField,operation:n.operation,exclude:n.exclude,value1:n.value1,value2:n.value2}});t._bIgnoreBindCalls=false;break;case"remove":t._bIgnoreBindCalls=true;t.fireRemoveFilterItem({key:k,index:I});t.fireFilterItemChanged({reason:"removed",key:k,index:I});t._bIgnoreBindCalls=false;break;default:throw"Operation'"+o+"' is not supported yet";}t._notifyChange();};};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/P13nGroupItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nGroupItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},showIfGrouped:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
P.prototype.setShowIfGrouped=function(v){return this.setProperty("showIfGrouped",v,true);};
return P;});
sap.ui.predefine('sap/m/P13nGroupPanel',['./library','./P13nConditionPanel','./P13nPanel','./P13nGroupItem',"sap/ui/thirdparty/jquery"],function(l,P,a,c,q){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nGroupPanel",{
metadata:{library:"sap.m",properties:{maxGroups:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},groupItems:{type:"sap.m.P13nGroupItem",multiple:true,singularName:"groupItem",bindable:"bindable"}},events:{addGroupItem:{parameters:{}},removeGroupItem:{},updateGroupItem:{}}},
renderer:function(r,C){r.write("<section");r.writeControlData(C);r.addClass("sapMGroupPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMGroupPanelContent");r.addClass("sapMGroupPanelBG");r.writeClasses();r.write(">");var b=C.getAggregation("content");var L=b.length;for(var i=0;i<L;i++){r.renderControl(b[i]);}r.write("</div>");r.write("</section>");}
});
f.prototype.setMaxGroups=function(m){this.setProperty("maxGroups",m);if(this._oGroupPanel){this._oGroupPanel.setMaxConditions(m);}return this;};
f.prototype._getConditions=function(){return this._oGroupPanel.getConditions();};
f.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oGroupPanel.setContainerQuery(b);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oGroupPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oGroupPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oGroupPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oGroupPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setOperations=function(o){this._aOperations=o;if(this._oGroupPanel){this._oGroupPanel.setOperations(this._aOperations);}};
f.prototype.init=function(){this.setType(d.group);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("GROUPPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");this._aKeyFields=[];if(!this._aOperations){this.setOperations([e.GroupAscending,e.GroupDescending]);}this._oGroupPanel=new P({maxConditions:this.getMaxGroups(),autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange(),validationExecutor:q.proxy(this._callValidationExecutor,this)});this._oGroupPanel.setOperations(this._aOperations);this._oGroupPanel._sAddRemoveIconTooltipKey="GROUP";this.addAggregation("content",this._oGroupPanel);};
f.prototype.exit=function(){var b=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=b(this._aKeyFields);this._aOperations=b(this._aOperations);};
f.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var b=i.getBinding(n);if(b&&o){return o.getObject()[b.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i)});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oGroupPanel.setKeyFields(k);var C=[];m=(this.getBindingInfo("groupItems")||{}).model;this.getGroupItems().forEach(function(G){var o=G.getBindingContext(m);if(G.getBinding("key")){o.getObject()[G.getBinding("key").getPath()]=G.getKey();}C.push({key:G.getKey(),keyField:g("columnKey",o,G),operation:g("operation",o,G),showIfGrouped:g("showIfGrouped",o,G)});});this._oGroupPanel.setConditions(C);}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addGroupItem=function(g){this.addAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertGroupItem=function(g,i){this.insertAggregation("groupItems",g,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateGroupItems=function(r){this.updateAggregation("groupItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeGroupItem=function(g){g=this.removeAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
f.prototype.removeAllGroupItems=function(){var g=this.removeAllAggregation("groupItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
f.prototype.destroyGroupItems=function(){this.destroyAggregation("groupItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var i=E.getParameter("index");var g;if(o==="update"){g=t.getGroupItems()[i];if(g){g.setColumnKey(n.keyField);g.setOperation(n.operation);g.setShowIfGrouped(n.showIfGrouped);}t.fireUpdateGroupItem({key:k,index:i,groupItemData:g});t._notifyChange();}if(o==="add"){g=new c({key:k,columnKey:n.keyField,operation:n.operation,showIfGrouped:n.showIfGrouped});t._bIgnoreBindCalls=true;t.fireAddGroupItem({key:k,index:i,groupItemData:g});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveGroupItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
f.prototype.getOkPayload=function(){if(!this.getModel()){return null;}var s=[];this._oGroupPanel._oConditionsGrid.getContent().forEach(function(C){var o=C.keyField;s.push(o.getSelectedKey());});return{selectedColumnKeys:s};};
f.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v){v();}};
f.prototype._updateValidationResult=function(v){this._oGroupPanel._oConditionsGrid.getContent().forEach(function(C){var o=C.keyField;o.setValueStateText("");o.setValueState("None");var s=o.getSelectedKey();v.forEach(function(r){if(r.columnKey===s){o.setValueStateText(r.messageText);o.setValueState(r.messageType);}});});};
f.prototype.setValidationListener=function(L){this.setProperty("validationListener",L);if(L){L(this,q.proxy(this._updateValidationResult,this));}return this;};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/P13nItem',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var P=E.extend("sap.m.P13nItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},visible:{type:"boolean",group:"Misc",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:"text"},typeInstance:{type:"object",group:"Misc",defaultValue:null,since:"1.56"},precision:{type:"string",group:"Misc",defaultValue:null},formatSettings:{type:"object",group:"Misc",defaultValue:null,since:"1.52"},scale:{type:"string",group:"Misc",defaultValue:null},maxLength:{type:"string",group:"Misc",defaultValue:null},width:{type:"string",group:"Misc",defaultValue:null},isDefault:{type:"boolean",group:"Misc",defaultValue:false},values:{type:"string[]",group:"Misc",defaultValue:null},role:{type:"string",defaultValue:null},aggregationRole:{type:"string",defaultValue:null},href:{type:"string",defaultValue:null},target:{type:"string",defaultValue:null},press:{type:"object",defaultValue:null},description:{type:"string",defaultValue:null},nullable:{type:"boolean",group:"Misc",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/P13nPanel',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var P=C.extend("sap.m.P13nPanel",{
metadata:{"abstract":true,library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},titleLarge:{type:"string",group:"Appearance",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:null},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},validationExecutor:{type:"object",group:"Misc",defaultValue:null},validationListener:{type:"object",group:"Misc",defaultValue:null},changeNotifier:{type:"object",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.P13nItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{beforeNavigationTo:{}}},
renderer:function(r,c){r.write("<span");r.writeControlData(c);r.addClass("sapMP13nPanel");r.writeClasses();r.write(">");r.write("</span>");}
});
P.prototype.getOkPayload=function(){return{};};
P.prototype.getResetPayload=function(){return{};};
P.prototype.beforeNavigationTo=function(){this.fireBeforeNavigationTo();};
P.prototype.onBeforeNavigationFrom=function(){return true;};
P.prototype.onAfterNavigationFrom=function(){};
return P;});
sap.ui.predefine('sap/m/P13nSelectionItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nSelectionItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",defaultValue:undefined},selected:{type:"boolean",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/P13nSelectionPanel',['./library','./ColumnListItem','./P13nPanel','./SearchField','./Text','./Table','./Column','./ScrollContainer','./P13nSelectionItem','./VBox','./Link','./OverflowToolbar','./OverflowToolbarLayoutData','./ToolbarSpacer','sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery"],function(l,C,P,S,T,a,b,c,d,V,L,O,e,f,g,h,J,B,R,q){"use strict";var i=l.ToolbarDesign;var j=l.ListType;var k=l.ListMode;var m=l.P13nPanelType;
var n=P.extend("sap.m.P13nSelectionPanel",{
metadata:{library:"sap.m",aggregations:{selectionItems:{type:"sap.m.P13nSelectionItem",multiple:true,singularName:"selectionItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{changeSelectionItems:{parameters:{items:{type:"object[]"}}}}},
renderer:function(r,o){r.write("<div");r.writeControlData(o);r.addClass("sapMP13nColumnsPanel");r.writeClasses();r.write(">");var p=o.getAggregation("content");if(p){p.forEach(function(s){r.renderControl(s);});}r.write("</div>");}
});
n.prototype.init=function(){this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bOnAfterRenderingFirstTimeExecuted=false;var M=new J({items:[],countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(B.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nSelectionPanel");this.setType(m.selection);this._createTable();this._createToolbar();this.setVerticalScrolling(false);var s=new c({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",s);var t=this;this._fnHandleResize=function(){var o=false,p,r;if(t.getParent){var $=null,u,H;var v=t.getParent();var w=t._getToolbar();if(v&&v.$){$=v.$("cont");if($.children().length>0&&w.$().length>0){p=s.$()[0].clientHeight;u=$.children()[0].clientHeight;H=w?w.$()[0].clientHeight:0;r=u-H;if(p!==r){s.setHeight(r+'px');o=true;}}}}return o;};this._sContainerResizeListener=R.register(s,this._fnHandleResize);};
n.prototype.onBeforeRendering=function(){this._updateInternalModel();};
n.prototype.onAfterRendering=function(){var t=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){t._fnHandleResize();},0);}};
n.prototype.getOkPayload=function(){this._updateInternalModel();var M=this._getInternalModel().getProperty("/items");return{selectionItems:M.map(function(o){return{columnKey:o.columnKey,selected:o.persistentSelected};})};};
n.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
n.prototype.addItem=function(I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",I);return this;};
n.prototype.insertItem=function(I,o){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",I,o);return this;};
n.prototype.removeItem=function(I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}I=this.removeAggregation("items",I);return I;};
n.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
n.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
n.prototype.addSelectionItem=function(s){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("selectionItems",s);return this;};
n.prototype.insertSelectionItem=function(s,I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("selectionItems",s,I);return this;};
n.prototype.updateSelectionItems=function(r){this.updateAggregation("selectionItems");if(r===h.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
n.prototype.removeSelectionItem=function(s){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("selectionItems",s);};
n.prototype.removeAllSelectionItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("selectionItems");};
n.prototype.destroySelectionItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("selectionItems");return this;};
n.prototype.onBeforeNavigationFrom=function(){return true;};
n.prototype._notifyChange=function(){var o=this.getChangeNotifier();if(o){o(this);}};
n.prototype._getInternalModel=function(){return this.getModel("$sapmP13nSelectionPanel");};
n.prototype._createTable=function(){var t=this;this._oTable=new a({mode:k.MultiSelect,rememberSelections:false,selectionChange:q.proxy(this._onSelectionChange,this),columns:[new b({vAlign:g.VerticalAlign.Middle,header:new T({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(o,p){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[o,p]);}}})})],items:{path:"/items",templateShareable:false,template:new C({cells:new V({items:[new L({href:"{href}",text:"{text}",target:"{target}",enabled:{path:'href',formatter:function(v){if(!v){this.addStyleClass("sapUiCompSmartLink");}return!!v;}},press:function(E){var H=E.getSource().getHref();var I=t.getItems().filter(function(o){return o.getHref()===H&&!!o.getPress();});if(!I.length){return;}var p=I[0].getPress();p(E);}}),new T({visible:{path:'description',formatter:function(D){return!!D;}},text:"{description}"})]}),visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:j.Active})}});this._oTable.setModel(this._getInternalModel());};
n.prototype._createToolbar=function(){var t=this;var o=new O(this.getId()+"-toolbar",{design:i.Auto,content:[new f(),new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(t._iSearchTimer);if(D){t._iSearchTimer=window.setTimeout(function(){t._onExecuteSearch();},D);}else{t._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new e({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})})]});o.setModel(this._getInternalModel());this.addAggregation("content",o);};
n.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
n.prototype._switchVisibilityOfUnselectedModelItems=function(){var s=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(o){if(o.persistentSelected){o.visible=true;return;}o.visible=!s;});this._getInternalModel().setProperty("/items",M);};
n.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
n.prototype._getModelItemByColumnKey=function(s){var M=this._getInternalModel().getProperty("/items").filter(function(o){return o.columnKey===s;});return M[0];};
n.prototype._updateCounts=function(M){var o=0;var p=0;M.forEach(function(r){o++;if(r.persistentSelected){p++;}});this._getInternalModel().setProperty("/countOfItems",o);this._getInternalModel().setProperty("/countOfSelectedItems",p);};
n.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
n.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
n.prototype._getSearchText=function(){var s=this._getSearchField();return s?s.getValue():"";};
n.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
n.prototype._isFilteredByShowSelected=function(){return false;};
n.prototype._updateControlLogic=function(){var I=this._isFilteredBySearchText();var s=this._isFilteredByShowSelected();var t=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(t){t.setEnabled(!I&&!s);}};
n.prototype._fireChangeSelectionItems=function(){this._bIgnoreUpdateInternalModel=true;var M=this._getInternalModel().getProperty("/items");this.fireChangeSelectionItems({items:M.map(function(o){return{columnKey:o.columnKey,selected:o.persistentSelected};})});this._bIgnoreUpdateInternalModel=false;};
n.prototype._onSelectionChange=function(){this._selectTableItem();};
n.prototype._selectTableItem=function(){var M=this._getInternalModel().getProperty("/items");this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeSelectionItems();this._notifyChange();};
n.prototype._filterModelItemsBySearchText=function(){var s=this._getSearchText();s=s.replace(/(^\s+)|(\s+$)/g,'');s=s.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var r=new RegExp(s,'igm');this._getVisibleModelItems().forEach(function(M){M.visible=false;if(M.text&&M.text.match(r)){M.visible=true;}if(M.tooltip&&M.tooltip.match(r)){M.visible=true;}});this._getInternalModel().refresh();};
n.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._getInternalModel().setProperty("/items",this.getItems().map(function(I){return{columnKey:I.getColumnKey(),visible:true,text:I.getText(),tooltip:I.getTooltip(),href:I.getHref(),target:I.getTarget(),persistentSelected:I.getVisible(),description:I.getDescription()};},this));this.getSelectionItems().forEach(function(s){var o=this._getModelItemByColumnKey(s.getColumnKey());if(!o){return;}if(s.getSelected()!==undefined){o.persistentSelected=s.getSelected();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var M=this._getInternalModel().getProperty("/items");this._updateCounts(M);this._getInternalModel().setProperty("/items",M);};
return n;});
sap.ui.predefine('sap/m/P13nSortItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nSortItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
return P;});
sap.ui.predefine('sap/m/P13nSortPanel',['./library','./P13nConditionPanel','./P13nPanel','./P13nSortItem'],function(l,P,a,c){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nSortPanel",{
metadata:{library:"sap.m",properties:{containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},sortItems:{type:"sap.m.P13nSortItem",multiple:true,singularName:"sortItem",bindable:"bindable"}},events:{addSortItem:{},removeSortItem:{},updateSortItem:{}}},
renderer:function(r,C){if(!C.getVisible()){return;}r.write("<section");r.writeControlData(C);r.addClass("sapMSortPanel");r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapMSortPanelContent");r.addClass("sapMSortPanelBG");r.writeClasses();r.write(">");var b=C.getAggregation("content");var L=b.length;for(var i=0;i<L;i++){r.renderControl(b[i]);}r.write("</div>");r.write("</section>");}
});
f.prototype._getConditions=function(){return this._oSortPanel.getConditions();};
f.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oSortPanel.setContainerQuery(b);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oSortPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oSortPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oSortPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oSortPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setOperations=function(o){this._aOperations=o;if(this._oSortPanel){this._oSortPanel.setOperations(this._aOperations);}return this;};
f.prototype.init=function(){this.setType(d.sort);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SORTPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");this._aKeyFields=[];if(!this._aOperations){this.setOperations([e.Ascending,e.Descending]);}this._oSortPanel=new P({autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oSortPanel.setOperations(this._aOperations);this._oSortPanel._sAddRemoveIconTooltipKey="SORT";this.addAggregation("content",this._oSortPanel);};
f.prototype.exit=function(){var b=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=b(this._aKeyFields);this._aOperations=b(this._aOperations);};
f.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var b=i.getBinding(n);if(b&&o){return o.getObject()[b.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i)});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oSortPanel.setKeyFields(k);var C=[];m=(this.getBindingInfo("sortItems")||{}).model;this.getSortItems().forEach(function(s){var o=s.getBindingContext(m);if(s.getBinding("key")){o.getObject()[s.getBinding("key").getPath()]=s.getKey();}C.push({key:s.getKey(),keyField:g("columnKey",o,s),operation:g("operation",o,s)});});this._oSortPanel.setConditions(C);}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addSortItem=function(s){this.addAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertSortItem=function(s,i){this.insertAggregation("sortItems",s,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateSortItems=function(r){this.updateAggregation("sortItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeSortItem=function(s){s=this.removeAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
f.prototype.removeAllSortItems=function(){var s=this.removeAllAggregation("sortItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
f.prototype.destroySortItems=function(){this.destroyAggregation("sortItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var i=E.getParameter("index");var s;if(o==="update"){s=t.getSortItems()[i];if(s){s.setColumnKey(n.keyField);s.setOperation(n.operation);}t.fireUpdateSortItem({key:k,index:i,sortItemData:s});t._notifyChange();}if(o==="add"){s=new c({key:k,columnKey:n.keyField,operation:n.operation});t._bIgnoreBindCalls=true;t.fireAddSortItem({key:k,index:i,sortItemData:s});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveSortItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/QuickView',['./library','sap/ui/Device','sap/ui/core/IconPool','./QuickViewBase','./ResponsivePopover','./NavContainer','./Page','./Bar','./Button','./QuickViewRenderer'],function(l,D,I,Q,R,N,P,B,a,b){"use strict";var c=l.PlacementType;
var d=Q.extend("sap.m.QuickView",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:c.Right},width:{type:'sap.ui.core.CSSSize',group:'Dimension',defaultValue:'320px'}},aggregations:{},designtime:"sap/m/designtime/QuickView.designtime",events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}}});
d.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);var t=this;this._oPopover=new R(this.getId()+'-quickView',{placement:this.getPlacement(),content:[this._oNavContainer],contentWidth:this.getWidth(),showHeader:false,showCloseButton:false,afterOpen:function(e){t._afterOpen(e);t.fireAfterOpen({openBy:e.getParameter("openBy")});},afterClose:function(e){t.fireAfterClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});},beforeOpen:function(e){t.fireBeforeOpen({openBy:e.getParameter("openBy")});},beforeClose:function(e){t.fireBeforeClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});t._bRendered=false;}});this._oPopover.addStyleClass('sapMQuickView');var p=this._oPopover.getAggregation("_popup");p.addEventDelegate({onBeforeRendering:this._initializeQuickView,onAfterRendering:this._setLinkWidth,onkeydown:this._onPopupKeyDown},this);var t=this;var s=p._fnAdjustPositionAndArrow;if(s){p._fnAdjustPositionAndArrow=function(){s.apply(p,arguments);t._adjustContainerHeight();};}this._bItemsChanged=true;this._oPopover.addStyleClass("sapMQuickView");};
d.prototype._initializeQuickView=function(){this._bRendered=true;if(this._bItemsChanged){this._clearContainerHeight();this._initPages();var p=this._oNavContainer.getCurrentPage();if(p){var h=p.getCustomHeader();if(h){this._oPopover.addAriaDescribedBy(h.getId());}}var e=this.getAggregation("pages");if(!e&&D.system.phone){this._addEmptyPage();}this._bItemsChanged=false;}};
d.prototype.exit=function(){this._bRendered=false;this._bItemsChanged=true;if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
d.prototype.invalidate=function(){};
d.prototype._createPage=function(q){return q._createPage();};
d.prototype._onPopupKeyDown=function(e){this._processKeyboard(e);};
d.prototype._afterOpen=function(e){if(D.system.phone){this._restoreFocus();}};
d.prototype._addEmptyPage=function(){var p=new P({customHeader:new B().addStyleClass("sapMQuickViewHeader")});var t=this;var C=p.getCustomHeader();C.addContentRight(new a({icon:I.getIconURI("decline"),press:function(){t._oPopover.close();}}));p.addStyleClass('sapMQuickViewPage');this._oNavContainer.addPage(p);};
d.prototype._clearContainerHeight=function(){var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&$[0].style.height){$[0].style.height='';}};
d.prototype._adjustContainerHeight=function(){if(this.getPages().length<=1){return;}var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&!$[0].style.height){$[0].style.height=$.height()+'px';}};
d.prototype._setLinkWidth=function(){this._oPopover.$().find(".sapMLnk").css("width","auto");};
d.prototype.getCloseButton=function(){if(!D.system.phone){return undefined;}var p=this._oNavContainer.getCurrentPage();var o=p.getCustomHeader().getContentRight()[0];return o;};
d.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._oPopover.setPlacement(p);return this;};
d.prototype.setWidth=function(w){if(this._oPopover){this._oPopover.setContentWidth(w);this.setProperty('width',w,true);}return this;};
d.prototype.openBy=function(C){this._bItemsChanged=true;this._oPopover.openBy(C);return this;};
d.prototype.close=function(){this._oPopover.close();return this;};
d.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getFieldGroupIds","setFieldGroupIds","getBusy","setBusy","setTooltip","getTooltip"].forEach(function(n){d.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var r=this._oPopover.getAggregation("_popup")[n].apply(this._oPopover.getAggregation("_popup"),arguments);return r===this._oPopover.getAggregation("_popup")?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){d.prototype["_"+f+"Old"]=d.prototype[f];d.prototype[f]=function(){var n=[],r,i;for(i=0;i<arguments.length;i++){n.push(arguments[i]);}if(["setModel","bindAggregation"].indexOf(f)===-1){n.push(true);}r=d.prototype["_"+f+"Old"].apply(this,n);this._bItemsChanged=true;if(this._oPopover){if(arguments[0]!=="pages"){this._oPopover[f].apply(this._oPopover,arguments);}if(this._bRendered){this._initializeQuickView();}}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});return d;});
sap.ui.predefine('sap/m/QuickViewBase',['./library','sap/ui/core/Control',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,K,q){"use strict";
var Q=C.extend("sap.m.QuickViewBase",{metadata:{library:"sap.m",properties:{},defaultAggregation:"pages",aggregations:{pages:{type:"sap.m.QuickViewPage",multiple:true,singularName:"page",bindable:"bindable"}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},navOrigin:{type:"sap.ui.core.Control"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},isTopPage:{type:"boolean"},navOrigin:{type:"sap.ui.core.Control"}}}}}});
Q.prototype.navigateBack=function(){if(!this._oNavContainer.currentPageIsTopPage()){this._setNavOrigin(null);this._oNavContainer.back();}};
Q.prototype.getNavContainer=function(){return this._oNavContainer;};
Q.prototype._initPages=function(){var n=this._oNavContainer;n.destroyPages();n.init();var p=this.getAggregation("pages");if(!p){return;}var I=this.getId();for(var i=0;i<p.length;i++){var o=p[i];o._oPage=null;var N={hasBackButton:i>0,popover:this._oPopover,navContainer:n,quickViewId:I,quickView:this};o.setNavContext(N);var P=this._createPage(o);this._oNavContainer.addPage(P);}};
Q.prototype._processKeyboard=function(e){if(e.shiftKey&&e.which===K.ENTER){this.navigateBack();e.preventDefault();}};
Q.prototype._createPage=function(o){return o;};
Q.prototype._navigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q(document.getElementById(F)).index();var a=q(document.getElementById(T)).index();if(a==-1||a>i){t.addStyleClass('sapMNavItemOffset');}else{f.addStyleClass('sapMNavItemOffset');}f.$().parents('.sapMPanelContent').scrollTop(0);var p=e.getParameters();if(this._navOrigin){p.navOrigin=this._navOrigin;}this.fireNavigate(p);};
Q.prototype._afterNavigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q(document.getElementById(F)).index();var a=q(document.getElementById(T)).index();if(a>i){t.removeStyleClass('sapMNavItemOffset');}else{f.removeStyleClass('sapMNavItemOffset');}var p=e.getParameters();p.isTopPage=this._oNavContainer.currentPageIsTopPage();if(this._navOrigin){p.navOrigin=this._navOrigin;}this.fireAfterNavigate(p);this._setLinkWidth();setTimeout(this._restoreFocus.bind(this),0);};
Q.prototype._restoreFocus=function(){var p=this._oNavContainer.getCurrentPage();var f=this._oNavContainer._mFocusObject[p.getId()];if(!f){var c=p.getContent();if(c&&c.length>1){f=c[1].$().firstFocusableDomRef();}}if(f){f.focus();}};
Q.prototype._setLinkWidth=function(){};
Q.prototype._setNavOrigin=function(c){this._navOrigin=c;};
return Q;});
sap.ui.predefine('sap/m/QuickViewCard',['./library','./QuickViewBase','./NavContainer','./Page','./ScrollContainer','./QuickViewCardRenderer'],function(l,Q,N,P,S,a){"use strict";
var b=Q.extend("sap.m.QuickViewCard",{metadata:{library:"sap.m",properties:{showVerticalScrollBar:{type:"boolean",group:"Behavior",defaultValue:true}},designtime:"sap/m/designtime/QuickViewCard.designtime"}});
b.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);};
b.prototype.onBeforeRendering=function(){this._initPages();};
b.prototype.onAfterRendering=function(){this._setLinkWidth();};
b.prototype.exit=function(){if(this._oNavContainer){this._oNavContainer.destroy();}};
b.prototype.onkeydown=function(e){this._processKeyboard(e);};
b.prototype._createPage=function(q){var c=q._createPageContent();q._mPageContent=null;var C=new S(this.getId()+'-'+q.getPageId(),{horizontal:false,vertical:false});if(c.header){C.addContent(c.header);}C.addContent(c.form);C.addStyleClass('sapMQuickViewPage');return C;};
b.prototype._setLinkWidth=function(){this.$().find(".sapMLnk").css("width","auto");};
return b;});
sap.ui.predefine('sap/m/QuickViewGroupElement',['./library','sap/ui/core/Element','./Link','./Text','sap/ui/core/CustomData'],function(l,E,L,T,C){"use strict";var G=l.QuickViewGroupElementType;
var a=E.extend("sap.m.QuickViewGroupElement",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},label:{type:"string",group:"Misc",defaultValue:""},value:{type:"string",group:"Misc",defaultValue:""},url:{type:"string",group:"Misc",defaultValue:""},target:{type:"string",group:"Misc",defaultValue:"_blank"},type:{type:"sap.m.QuickViewGroupElementType",group:"Misc",defaultValue:G.text},pageLinkId:{type:"string",group:"Misc",defaultValue:""},emailSubject:{type:"string",group:"Misc",defaultValue:""}}}});
a.prototype._getGroupElementValue=function(q){if(!this.getValue()){return null;}switch(this.getType()){case G.email:var h="mailto:"+this.getValue();var s=this.getEmailSubject();if(s){h+='?subject='+s;}return new L({href:h,text:this.getValue(),wrapping:true});case G.phone:case G.mobile:return new L({href:"tel:"+this.getValue(),text:this.getValue()});case G.link:return new L({href:this.getUrl(),text:this.getValue(),target:this.getTarget()});case G.pageLink:var b=this.getPageLinkId();if(q){b=q+'-'+b;}return new L({href:"#",text:this.getValue(),customData:[new C({key:"pageNumber",value:b})]});default:return new T({text:this.getValue()});}};
a.prototype.setProperty=function(n,v){var q=this.getQuickViewBase(),s=false;if(q&&q.isA("sap.m.QuickView")){s=true;}E.prototype.setProperty.call(this,n,v,s);var g=this.getParent();if(!g){return this;}var p=g.getParent();if(p){p._updatePage();}return this;};
a.prototype.getQuickViewBase=function(){var p=this.getParent();if(p&&p.getQuickViewBase){return p.getQuickViewBase();}return null;};
return a;});
sap.ui.predefine('sap/m/QuickViewPage',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/layout/form/SimpleForm','sap/ui/layout/VerticalLayout','sap/ui/layout/HorizontalLayout','./Page','./Button','./Bar','./Title','./Image','./Link','./Text','./Label','./HBox','sap/ui/core/Icon','sap/ui/core/Title','sap/ui/core/CustomData','sap/ui/core/library','sap/ui/layout/library','sap/ui/Device','sap/ui/layout/form/ResponsiveGridLayout','./QuickViewPageRenderer',"sap/base/security/encodeURL","sap/ui/dom/jquery/Focusable"],function(l,C,I,S,V,H,P,B,a,T,b,L,c,d,f,g,h,i,m,n,D,R,Q,o){"use strict";var U=l.URLHelper;var p=n.form.SimpleFormLayout;var q=m.TitleLevel;var r=l.QuickViewGroupElementType;var s=l.ButtonType;
var t=C.extend("sap.m.QuickViewPage",{metadata:{library:"sap.m",properties:{pageId:{type:"string",group:"Misc",defaultValue:""},header:{type:"string",group:"Misc",defaultValue:""},title:{type:"string",group:"Misc",defaultValue:""},titleUrl:{type:"string",group:"Misc",defaultValue:""},crossAppNavCallback:{type:"object",group:"Misc"},description:{type:"string",group:"Misc",defaultValue:""},icon:{type:"string",group:"Misc",defaultValue:""},fallbackIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null}},defaultAggregation:"groups",aggregations:{groups:{type:"sap.m.QuickViewGroup",multiple:true,singularName:"group",bindable:"bindable"}}}});
t.prototype.init=function(){this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');var G=sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getService;if(G){this.oCrossAppNavigator=G("CrossApplicationNavigation");}};
t.prototype.onBeforeRendering=function(){this._destroyPageContent();this._createPageContent();};
t.prototype.getPageContent=function(){return this._mPageContent;};
t.prototype.setNavContext=function(e){this._mNavContext=e;};
t.prototype.getNavContext=function(){return this._mNavContext;};
t.prototype.setPageTitleControl=function(e){this._oPageTitle=e;};
t.prototype.getPageTitleControl=function(){return this._oPageTitle;};
t.prototype._createPage=function(){var e=this._createPageContent();var N=this.getNavContext();var j;if(this._oPage){j=this._oPage;j.destroyContent();j.setCustomHeader(new a());}else{j=this._oPage=new P(N.quickViewId+'-'+this.getPageId(),{customHeader:new a()});j.addEventDelegate({onAfterRendering:this.onAfterRenderingPage},this);}if(this.getHeader()===""&&N.quickView.getPages().length===1&&!D.system.phone){j.setShowHeader(false);j.addStyleClass('sapMQuickViewPageWithoutHeader');}if(e.header){j.addContent(e.header);}j.addContent(e.form);var k=j.getCustomHeader();k.addContentMiddle(new T({text:this.getHeader()}).addStyleClass("sapMQuickViewTitle"));if(N.hasBackButton){k.addContentLeft(new B({type:s.Back,tooltip:this._oResourceBundle.getText("PAGE_NAVBUTTON_TEXT"),press:function(){if(N.navContainer){N.quickView._setNavOrigin(null);N.navContainer.back();}}}));}if(N.popover&&D.system.phone){k.addContentRight(new B({icon:I.getIconURI("decline"),press:function(){N.popover.close();}}));}j.addStyleClass('sapMQuickViewPage');return j;};
t.prototype.onAfterRenderingPage=function(){var e=this.getParent(),j=e instanceof C&&e.isA('sap.m.QuickView');if(j&&!this._oPage.$().firstFocusableDomRef()){this._oPage.$('cont').attr('tabindex',0);}if(this._bItemsChanged){var N=this.getNavContext();if(N){N.quickView._restoreFocus();}this._bItemsChanged=false;}};
t.prototype._createPageContent=function(){var F=this._createForm();var e=this._getPageHeaderContent();var j=this.getPageTitleControl();if(e&&j){F.addAriaLabelledBy(j);}this._mPageContent={form:F,header:e};return this._mPageContent;};
t.prototype._createForm=function(){var G=this.getAggregation("groups"),F=new S({maxContainerCols:1,editable:false,layout:p.ResponsiveGridLayout});if(G){for(var j=0;j<G.length;j++){if(G[j].getVisible()){this._renderGroup(G[j],F);}}}return F;};
t.prototype._getPageHeaderContent=function(){var e,F,j=this.getFallbackIcon(),v=new V(),k=new H(),u=this.getIcon(),w=this.getTitle(),x=this.getDescription(),y=this.getTitleUrl();if(!u&&!w&&!x){return null;}if(u){if(this.getIcon().indexOf("sap-icon")==0){e=this._createIcon(u,!y,w);}else{e=new b({src:u,decorative:false,tooltip:w}).addStyleClass("sapUiIcon sapMQuickViewPageImage");if(I.isIconURI(j)){F=this._createIcon(j,!y,w);F.addStyleClass("sapMQuickViewThumbnail sapMQuickViewPageFallbackIconHidden");e.attachError(this._onImageLoadError.bind(this));k.addContent(F);}}e.addStyleClass("sapMQuickViewThumbnail");if(y){e.attachPress(this._crossApplicationNavigation(this));if(F){F.attachPress(this._crossApplicationNavigation(this));}}k.addContent(e);}var z;if(y){z=new L({text:w,href:y,target:"_blank"});}else if(this.getCrossAppNavCallback()){z=new L({text:w});z.attachPress(this._crossApplicationNavigation(this));}else{z=new T({text:w,level:q.H1});}this.setPageTitleControl(z);var A=new c({text:x});v.addContent(z);v.addContent(A);k.addContent(v);return k;};
t.prototype._createIcon=function(e,j,k){return new g({src:e,decorative:j,useIconTooltip:false,tooltip:k});};
t.prototype._renderGroup=function(G,F){var e=G.getAggregation("elements");var j,u,v;if(G.getHeading()){F.addContent(new h({text:G.getHeading(),level:q.H2}));}if(!e){return;}var N=this.getNavContext();for(var k=0;k<e.length;k++){j=e[k];if(!j.getVisible()){continue;}v=new d({text:j.getLabel()});var w;if(N){w=N.quickViewId;}u=j._getGroupElementValue(w);F.addContent(v);if(!u){F.addContent(new c({text:""}));continue;}v.setLabelFor(u.getId());if(j.getType()==r.pageLink){u.attachPress(this._attachPressLink(this));}if(j.getType()==r.mobile&&!D.system.desktop){var x=new g({src:I.getIconURI("post"),tooltip:this._oResourceBundle.getText("QUICKVIEW_SEND_SMS"),decorative:false,customData:[new i({key:"phoneNumber",value:j.getValue()})],press:this._mobilePress});var y=new f({items:[u,x]});F.addContent(y);}else{F.addContent(u);}}};
t.prototype._crossApplicationNavigation=function(e){return function(){if(e.getCrossAppNavCallback()&&e.oCrossAppNavigator){var j=e.getCrossAppNavCallback();if(typeof j=="function"){var k=j();var u=e.oCrossAppNavigator.hrefForExternal({target:{semanticObject:k.target.semanticObject,action:k.target.action},params:k.params});U.redirect(u);}}else if(e.getTitleUrl()){window.open(e.getTitleUrl(),"_blank");}};};
t.prototype._destroyPageContent=function(){if(!this._mPageContent){return;}if(this._mPageContent.form){this._mPageContent.form.destroy();}if(this._mPageContent.header){this._mPageContent.header.destroy();}this._mPageContent=null;};
t.prototype.exit=function(){this._oResourceBundle=null;if(this._oPage){this._oPage.destroy();this._oPage=null;}else{this._destroyPageContent();}this._mNavContext=null;};
t.prototype._attachPressLink=function(j){var N=j.getNavContext();return function(e){e.preventDefault();var k=this.getCustomData()[0].getValue();if(N.navContainer&&k){N.quickView._setNavOrigin(this);N.navContainer.to(k);}};};
t.prototype._mobilePress=function(){var e="sms://"+o(this.getCustomData()[0].getValue());window.location.replace(e);};
t.prototype._updatePage=function(){var N=this.getNavContext();if(N&&N.quickView._bRendered){this._bItemsChanged=true;N.popover.focus();if(N.quickView.indexOfPage(this)==0){N.quickView._clearContainerHeight();}this._createPage();N.popover.$().css('display','block');N.quickView._adjustContainerHeight();N.quickView._restoreFocus();}};
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){t.prototype["_"+F+"Old"]=t.prototype[F];t.prototype[F]=function(){var e=t.prototype["_"+F+"Old"].apply(this,arguments);this._updatePage();if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return e;}return this;};});
t.prototype.setProperty=function(N,v){var e=this.getQuickViewBase(),j=false;if(e&&e.isA("sap.m.QuickView")){j=true;}C.prototype.setProperty.call(this,N,v,j);this._updatePage();return this;};
t.prototype.getQuickViewBase=function(){var e=this.getParent();if(e&&e.isA("sap.m.QuickViewBase")){return e;}return null;};
t.prototype._onImageLoadError=function(e){var F=0,j=this._mPageContent.header.getContent()[F],k=e.getSource(),u=document.activeElement===k.getDomRef();j.$().removeClass("sapMQuickViewPageFallbackIconHidden");k.$().addClass("sapMQuickViewPageFailedImage");if(u){j.focus();}};
return t;});
/*!
 * @copyright@
 */
sap.ui.predefine('sap/m/NumericContentRenderer',['./library'],function(l){"use strict";var N={};
N.render=function(r,c){var v=c.getValue();var i=c.getIndicator();var s=c.getScale();var S=c.getState();var I=l.DeviationIndicator.None!==i&&v!=="";var w=c.getWithMargin();var W;if(w){W="";}else{W="WithoutMargin";}if(c.getFormatterValue()){var f=c._parseFormattedValue(v);s=f.scale;v=f.value;}var b=s&&v;r.write("<div");r.writeControlData(c);var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.writeAttributeEscaped("aria-label",t);r.writeAttribute("role","img");if(S==l.LoadState.Failed||S==l.LoadState.Loading){r.writeAttribute("aria-disabled","true");}if(c.getAnimateTextChange()){r.addClass("sapMNCAnimation");}if(c.getWidth()){r.addStyle("width",c.getWidth());}r.writeStyles();r.addClass("sapMNC");r.addClass(W);if(c.hasListeners("press")){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMNCInner");r.addClass(W);r.writeClasses();r.write(">");if(w){this._renderScaleAndIndicator(r,c,I,b,W,i,s);this._renderValue(r,c,W,v);}else{this._renderValue(r,c,W,v);this._renderScaleAndIndicator(r,c,I,b,W,i,s);}r.write("</div>");r.write("</div>");};
N._prepareAndRenderIcon=function(r,c,i,n){if(i){var s,L=l.LoadState,C=c.getState();for(s in L){if(L.hasOwnProperty(s)&&s!==C){i.removeStyleClass(s);}else if(L.hasOwnProperty(s)&&s===C){i.addStyleClass(s);}}i.addStyleClass("sapMNCIconImage");i.removeStyleClass("sapMNCIconImageMediumTopMargin");i.removeStyleClass("sapMNCIconImageSmallTopMargin");if(n==="sapMNCMediumFontSize"){i.addStyleClass("sapMNCIconImageMediumTopMargin");}else if(n==="sapMNCSmallFontSize"){i.addStyleClass("sapMNCIconImageSmallTopMargin");}r.renderControl(i);}};
N._renderScaleAndIndicator=function(r,c,i,a,w,t,b){if(i||a){var s=c.getState();var C=c.getValueColor();r.write("<div");r.addClass("sapMNCIndScale");r.addClass(w);r.addClass(s);r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-indicator");r.addClass("sapMNCIndicator");r.addClass(t);r.addClass(s);r.addClass(C);r.writeClasses();r.write("></div>");if(a){r.write("<div");r.writeAttribute("id",c.getId()+"-scale");r.addClass("sapMNCScale");r.addClass(s);r.addClass(C);r.writeClasses();r.write(">");r.writeEscaped(b);r.write("</div>");}r.write("</div>");}};
N._renderValue=function(r,c,w,v){var e;if(c.getNullifyValue()){e="0";}else{e="";}r.write("<div");r.writeAttribute("id",c.getId()+"-value");r.addClass("sapMNCValue");r.addClass(w);r.addClass(c.getValueColor());r.addClass(c.getState());r.writeClasses();r.write(">");var m=c._getMaxDigitsData();r.write("<div");r.writeAttribute("id",c.getId()+"-value-scr");r.addClass("sapMNCValueScr");r.addClass(w);if(m.fontClass){r.addClass(m.fontClass);}r.writeClasses();r.write(">");this._prepareAndRenderIcon(r,c,c._oIcon,m.fontClass);var C=m.maxLength||c.getTruncateValueTo();r.write("<span id=\""+c.getId()+"-value-inner\">");if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.writeEscaped(v.substring(0,C-1));}else{r.writeEscaped(v?v.substring(0,C):e);}r.write("</span>");r.write("</div>");r.write("</div>");};
return N;},true);
/*!
 * OpenUI5
 * (c) Copyright 2009-2019 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/AccButton',['./Button','./AccButtonRenderer'],function(B,A){"use strict";
var a=B.extend("sap.m.AccButton",{metadata:{library:"sap.m",properties:{"tabIndex":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHidden":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHaspopup":{type:"string",defaultValue:null,bindable:"bindable"}}}});
return a;});
sap.ui.predefine('sap/m/AccButtonRenderer',['./ButtonRenderer','sap/ui/core/Renderer'],function(B,R){"use strict";var A=R.extend(B);
A.renderAccessibilityAttributes=function(r,c){if(c.getTabIndex()){r.writeAttribute("tabindex",c.getTabIndex());}if(c.getAriaHidden()){r.writeAttribute("aria-hidden",c.getAriaHidden());}if(c.getAriaHaspopup()){r.writeAttribute("aria-haspopup",c.getAriaHaspopup());}};
return A;},true);
sap.ui.predefine('sap/m/ActionListItem',['./ListItemBase','./library','./ActionListItemRenderer'],function(L,l,A){"use strict";var a=l.ListMode;var b=l.ListType;
var c=L.extend("sap.m.ActionListItem",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
c.prototype.init=function(){this.setType(b.Active);L.prototype.init.apply(this,arguments);};
c.prototype.getMode=function(){return a.None;};
c.prototype.onsapspace=c.prototype.onsapenter;
c.prototype.getContentAnnouncement=function(){return this.getText();};
return c;});
sap.ui.predefine('sap/m/ActionListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var A=R.extend(L);A.apiVersion=2;
A.renderLIAttributes=function(r,l){r.class("sapMALI");};
A.renderLIContent=function(r,l){var t=l.getText();if(t){r.openStart("div").class("sapMALIText").openEnd();r.text(t);r.close("div");}};
return A;},true);
sap.ui.predefine('sap/m/ActionSelect',['./Select','sap/ui/core/InvisibleText','sap/ui/core/Core','./ActionSelectRenderer'],function(S,I,C,A){"use strict";
var a=S.extend("sap.m.ActionSelect",{metadata:{library:"sap.m",associations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"}}}});
a.prototype.init=function(){S.prototype.init.call(this);this.getList().addEventDelegate({onfocusin:this.onfocusinList},this);};
a.prototype.hasContent=function(){return S.prototype.hasContent.call(this)||!!this.getButtons().length;};
a.prototype.addContentToFlex=function(){var s=this.getSimpleFixFlex();this.getButtons().forEach(function(b){s.addFlexContent(C.byId(b));});};
a.prototype._onBeforeRenderingPopover=function(){S.prototype._onBeforeRenderingPopover.call(this);this._updateTutorMessage();};
a.prototype.onAfterRenderingPicker=function(){S.prototype.onAfterRenderingPicker.call(this);var p=this.getPicker(),r=this.getRenderer();p.addStyleClass(r.CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker-CTX");};
a.prototype.createPickerCloseButton=function(){};
a.prototype.removeButton=function(b){var s=this.getSimpleFixFlex();if(s){if(typeof b==="number"){b=this.getButtons()[b];}s.removeFlexContent(b);}return this.removeAssociation("buttons",b);};
a.prototype.removeAllButtons=function(){var s=this.getSimpleFixFlex();if(s){this.getButtons().forEach(function(b){s.removeFlexContent(C.byId(b));});}return this.removeAllAssociation("buttons");};
a.prototype.onsaptabprevious=function(e){var b=this.getButtons(),p=this.getPicker(),i;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=b.length-1;i>=0;i--){if(C.byId(b[i]).getEnabled()){C.byId(b[i]).focus();e.preventDefault();break;}}}};
a.prototype.onsaptabnext=function(e){var b=this.getButtons(),p=this.getPicker(),i;this._bProcessChange=false;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=0;i<b.length;i++){if(C.byId(b[i]).getEnabled()){C.byId(b[i]).focus();e.preventDefault();break;}}}};
a.prototype.onsapfocusleave=function(e){var b=this.getButtons();var k=(b.indexOf(e.relatedControlId)===-1);if(k){S.prototype.onsapfocusleave.apply(this,arguments);}this._toggleListFocusIndication(true);};
a.prototype.onfocusinList=function(e){if(document.activeElement!==this.getList().getDomRef()){this.focus();}};
a.prototype.onfocusin=function(){S.prototype.onfocusin.apply(this,arguments);this._toggleListFocusIndication(false);};
a.prototype._toggleListFocusIndication=function(r){var s=this.getSelectedItem();if(this.isOpen()&&s){s.$().toggleClass("sapMActionSelectItemWithoutFocus",r);}};
a.prototype._updateTutorMessage=function(){var p=this.getPicker(),b=p.getAriaLabelledBy(),h=!!this.getButtons().length,t;if(!this._sTutorMessageId){this._sTutorMessageId=this._getTutorMessageId();this._oTutorMessageText=new I(this._sTutorMessageId,{text:C.getLibraryResourceBundle("sap.m").getText("ACTION_SELECT_TUTOR_MESSAGE")}).toStatic();}t=(b.indexOf(this._sTutorMessageId)===-1);if(t&&h){p.addAriaLabelledBy(this._sTutorMessageId);}else{if(!h){p.removeAriaLabelledBy(this._sTutorMessageId);}}};
a.prototype._getTutorMessageId=function(){return this.getId()+"-tutorMessage";};
a.prototype.exit=function(){if(this._oTutorMessageText){this._oTutorMessageText.destroy();this._oTutorMessageText=null;}};
return a;});
sap.ui.predefine('sap/m/ActionSelectRenderer',['sap/ui/core/Renderer','./SelectRenderer'],function(R,S){"use strict";var A=R.extend(S);A.ACTION_SELECT_CSS_CLASS="sapMActionSelect";
A.addClass=function(r,a){r.addClass(A.ACTION_SELECT_CSS_CLASS);};
return A;},true);
sap.ui.predefine('sap/m/ActionSheet',['./Dialog','./Popover','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText','sap/ui/base/ManagedObject','sap/ui/Device','./ActionSheetRenderer','./Button',"sap/ui/thirdparty/jquery"],function(D,P,l,C,I,a,M,b,A,B,q){"use strict";var c=l.ButtonType;var d=l.DialogType;var e=l.PlacementType;
var f=C.extend("sap.m.ActionSheet",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:e.Bottom},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:true},cancelButtonText:{type:"string",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null}},aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_cancelButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_invisibleAriaTexts:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},defaultAggregation:"buttons",events:{cancelButtonTap:{deprecated:true},beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}},cancelButtonPress:{}},designtime:"sap/m/designtime/ActionSheet.designtime"}});
f.prototype.init=function(){this._fnOrientationChange=this._orientationChange.bind(this);this._actionSelected=null;};
f.prototype.exit=function(){b.resize.detachHandler(this._fnOrientationChange);if(this._parent){this._parent.destroy();this._parent=null;}if(this._oCancelButton){this._oCancelButton.destroy();this._oCancelButton=null;}this._clearItemNavigation();};
f.prototype._clearItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
f.prototype._setItemNavigation=function(){var g=this._getAllButtons(),h=[],o=this.getDomRef();if(o){this._oItemNavigation.setRootDomRef(o);for(var i=0;i<g.length;i++){if(g[i].getEnabled()&&g[i].getVisible()){h.push(g[i].getFocusDomRef());}}if(this._oCancelButton){h.push(this._oCancelButton.getFocusDomRef());}this._oItemNavigation.setItemDomRefs(h);this._oItemNavigation.setSelectedIndex(0);this._oItemNavigation.setPageSize(5);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});}};
f.prototype.onmousedown=function(E){if(E.srcControl.isA("sap.m.Button")&&this.getButtons().indexOf(E.srcControl)!==-1){this._actionSelected=E.srcControl;}};
f.prototype.onBeforeRendering=function(){this._clearItemNavigation();};
f.prototype.onAfterRendering=function(){this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigation();};
f.prototype.sapfocusleave=function(){this.close();};
f.prototype.openBy=function(o){var t=this;if(!this._parent){var O=this.getParent();if(O){this.setParent(null);}if(!b.system.phone){this._parent=new P({placement:this.getPlacement(),showHeader:false,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(){t.fireBeforeClose();},afterClose:function(){if(t.getShowCancelButton()){t.fireCancelButtonTap();t.fireCancelButtonPress();}t._onAfterClose(t._actionSelected);t._actionSelected=null;},ariaLabelledBy:this.getPopupHiddenLabelId()||undefined}).addStyleClass("sapMActionSheetPopover");if(b.browser.internet_explorer){this._parent._fnAdjustPositionAndArrow=q.proxy(function(){P.prototype._adjustPositionAndArrow.apply(this);var $=this.$(),g=$.children(".sapMPopoverCont")[0].getBoundingClientRect().width;q.each($.find(".sapMActionSheet > .sapMBtn"),function(i,h){var j=q(h),k;j.css("width","");k=h.getBoundingClientRect().width;if(k<=g){j.css("width","100%");}});},this._parent);}}else{this._parent=new D({title:this.getTitle(),type:d.Standard,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(E){t.fireBeforeClose({origin:E.getParameter("origin")});},afterClose:function(E){t._actionSelected=E.getParameter("origin");t._onAfterClose(t._actionSelected);t._actionSelected=null;b.resize.detachHandler(t._fnOrientationChange);}}).addStyleClass("sapMActionSheetDialog");if(this.getTitle()){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.addAriaLabelledBy(this.getPopupHiddenLabelId()||undefined);}if(!b.system.phone){this._parent.setBeginButton(this._getCancelButton());}if(b.system.phone){this._parent.oPopup.setModal(true);this._parent._setDimensions=function(){D.prototype._setDimensions.apply(this);this.$("cont").css("max-height","");};this._parent._adjustScrollingPane=function(){var h=this.$().height();this.$("cont").css("max-height",h);if(this._oScroller){this._oScroller.refresh();}};}}if(O){O.addDependent(this._parent);}}if(!b.system.phone){this._parent.openBy(o);}else{this._parent.open();b.resize.attachHandler(this._fnOrientationChange);}};
f.prototype.close=function(){if(this._parent){this._parent.close();}};
f.prototype.isOpen=function(){return!!this._parent&&this._parent.isOpen();};
f.prototype._createCancelButton=function(){if(!this._oCancelButton){var s=(this.getCancelButtonText())?this.getCancelButtonText():sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACTIONSHEET_CANCELBUTTON_TEXT"),t=this;this._oCancelButton=new B(this.getId()+'-cancelBtn',{text:s,type:c.Reject,press:function(){if(b.system.phone&&t._parent){t._parent._oCloseTrigger=this;}t.close();t.fireCancelButtonTap();t.fireCancelButtonPress();}}).addStyleClass("sapMActionSheetButton sapMActionSheetCancelButton sapMBtnTransparent sapMBtnInverted");if(b.system.phone){this.setAggregation("_cancelButton",this._oCancelButton,true);}}return this;};
f.prototype._getCancelButton=function(){if(b.system.phone&&this.getShowCancelButton()){this._createCancelButton();return this._oCancelButton;}return null;};
f.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,true);if(this._oCancelButton){this._oCancelButton.setText(t);}return this;};
f.prototype._preProcessActionButton=function(o){var t=o.getType();if(t!==c.Accept&&t!==c.Reject){o.setType(c.Transparent);}o.addStyleClass("sapMBtnInverted");this._parent&&this._parent.invalidate();return this;};
f.prototype.setShowCancelButton=function(v){if(this._parent){if(b.system.phone){this.setProperty("showCancelButton",v,false);}}else{this.setProperty("showCancelButton",v,true);}return this;};
f.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this._parent&&b.system.phone){this._parent.setTitle(t);this._parent.toggleStyleClass("sapMDialog-NoHeader",!t);}if(this._parent){if(t){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.removeStyleClass("sapMActionSheetDialogWithTitle");}}return this;};
f.prototype.setPlacement=function(p){this.setProperty("placement",p,true);if(!b.system.phone){if(this._parent){this._parent.setPlacement(p);}}return this;};
f.prototype._buttonSelected=function(){if(b.system.phone&&this._parent){this._parent._oCloseTrigger=this;}this.close();};
f.prototype._orientationChange=function(){this._parent._adjustScrollingPane();};
f.prototype._addAriaHiddenTexts=function(o){var s=o.getId(),i;if(sap.ui.getCore().getConfiguration().getAccessibility()){i=new a(s+"-actionSheetHiddenText");this.addAggregation("_invisibleAriaTexts",i,false);o.addAriaLabelledBy(i.getId());}};
f.prototype._removeAriaHiddenTexts=function(o){o.getAriaLabelledBy().forEach(function(i){var g=sap.ui.getCore().byId(i);if(g instanceof a&&i.indexOf("actionSheetHiddenText")>-1){this.removeAggregation("_invisibleAriaTexts",g,false);o.removeAriaLabelledBy(g);g.destroy();}},this);};
f.prototype.addButton=function(o){this.addAggregation("buttons",o,false);this._addAriaHiddenTexts(o);this._preProcessActionButton(o);o.attachPress(this._buttonSelected,this);return this;};
f.prototype.insertButton=function(o,i){this.insertAggregation("buttons",o,i,false);this._addAriaHiddenTexts(o);this._preProcessActionButton(o);o.attachPress(this._buttonSelected,this);return this;};
f.prototype.removeButton=function(o){var r=this.removeAggregation("buttons",o,false);if(r){r.detachPress(this._buttonSelected,this);this._removeAriaHiddenTexts(r);}return r;};
f.prototype.removeAllButtons=function(){var r=this.removeAllAggregation("buttons",false),t=this;q.each(r,function(i,o){o.detachPress(t._buttonSelected,t);t._removeAriaHiddenTexts(o);});return r;};
f.prototype.clone=function(){var g=this.getButtons();for(var i=0;i<g.length;i++){g[i].detachPress(this._buttonSelected,this);}var o=C.prototype.clone.apply(this,arguments);for(var j=0;j<g.length;j++){g[j].attachPress(this._buttonSelected,this);}return o;};
f.prototype._getAllButtons=function(){return this.getButtons();};
f.prototype.getPopupHiddenLabelId=function(){return a.getStaticId("sap.m","ACTIONSHEET_AVAILABLE_ACTIONS");};
f.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
f.prototype._onAfterClose=function(o){this.fireAfterClose({origin:o});};
return f;});
sap.ui.predefine('sap/m/ActionSheetRenderer',["sap/ui/Device"],function(D){"use strict";var A={};
A.render=function(r,c){var a=c._getAllButtons(),I=c.getAggregation("_invisibleAriaTexts"),R=sap.ui.getCore().getLibraryResourceBundle('sap.m'),b=a.length,d=sap.ui.getCore().getConfiguration().getAccessibility(),v=a.filter(function(B){return B.getVisible();}).length,C,i,m,B,V=1,g=function(o){return I.filter(function(e){return e.getId().indexOf(o.getId())>-1;})[0];};for(i=0;i<b;i++){B=a[i];B.removeStyleClass("sapMActionSheetButtonNoIcon");if(B.getIcon()&&B.getVisible()){m=true;}else{B.addStyleClass("sapMActionSheetButtonNoIcon");}}r.write("<div");r.writeControlData(c);r.addClass("sapMActionSheet");if(m){r.addClass("sapMActionSheetMixedButtons");}r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}d&&r.writeAttributeEscaped("role","presentation");r.write(">");for(i=0;i<b;i++){B=a[i];r.renderControl(a[i].addStyleClass("sapMActionSheetButton"));if(d&&B.getVisible()){C=g(B);if(C){C.setText(R.getText('ACTIONSHEET_BUTTON_INDEX',[V,v]));r.renderControl(C);}V++;}}if(D.system.phone&&c.getShowCancelButton()){r.renderControl(c._getCancelButton());}r.write("</div>");};
return A;},true);
sap.ui.predefine('sap/m/App',['./NavContainer','./library','./AppRenderer','sap/ui/base/DataType',"sap/ui/util/Mobile","sap/base/Log","sap/ui/thirdparty/jquery"],function(N,l,A,D,M,L,q){"use strict";
var a=N.extend("sap.m.App",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},mobileWebAppCapable:{type:"boolean",group:"Appearance",defaultValue:true}},events:{orientationChange:{deprecated:true,parameters:{landscape:{type:"boolean"}}}}}});
a.prototype.init=function(){N.prototype.init.apply(this,arguments);this.addStyleClass("sapMApp");M.init({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});q(window).bind("resize",q.proxy(this._handleOrientationChange,this));};
a.prototype.onBeforeRendering=function(){if(N.prototype.onBeforeRendering){N.prototype.onBeforeRendering.apply(this,arguments);}M.init({homeIcon:this.getHomeIcon(),mobileWebAppCapable:this.getMobileWebAppCapable()});};
a.prototype.onAfterRendering=function(){if(N.prototype.onAfterRendering){N.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}};
a.prototype.exit=function(){q(window).unbind("resize",this._handleOrientationChange);if(this._sInitTimer){clearTimeout(this._sInitTimer);}};
a.prototype._handleOrientationChange=function(){var $=q(window);var i=$.width()>$.height();if(this._oldIsLandscape!==i){this.fireOrientationChange({landscape:i});this._oldIsLandscape=i;}};
a.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for App.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
return a;});
sap.ui.predefine('sap/m/AppRenderer',['./NavContainerRenderer','sap/ui/core/Renderer','sap/m/library'],function(N,R,l){"use strict";var B=l.BackgroundHelper;var A={};var A=R.extend(N);
A.renderAttributes=function(r,c){B.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
A.renderBeforeContent=function(r,c){B.renderBackgroundImageTag(r,c,"sapMAppBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return A;},true);
sap.ui.predefine('sap/m/AssociativeOverflowToolbar',['sap/base/Log','./OverflowToolbar','./OverflowToolbarRenderer','./Toolbar','sap/ui/Device'],function(L,O,a,T,D){"use strict";
var A=O.extend("sap.m.AssociativeOverflowToolbar",{
metadata:{associations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}},
renderer:a
});
A.prototype.getContent=function(){var b=this.getAssociation("content")||[];return b.map(function(c){return sap.ui.getCore().byId(c);});};
A.prototype.insertContent=function(c,I){var s=c.getId(),b=this.getAssociation("content").filter(function(d){return d!==s;});var i;if(I<0){i=0;}else if(I>b.length){i=b.length;}else{i=I;}if(i!==I){L.warning("AssociativeOverflowToolbar.insertContent: index '"+I+"' out of range [0,"+b.length+"], forced to "+i);}b.splice(i,0,s);this.removeAllAssociation("content");b.forEach(function(d){this.addAssociation("content",d);},this);return this;};
A.prototype.exit=function(){O.prototype.exit.apply(this,arguments);return this._callToolbarMethod('destroyContent',[true]);};
A.prototype.indexOfContent=function(c){var b=this.getAssociation("content")||[];return b.indexOf(c.getId());};
A.prototype._handleResize=function(){if(D.system.phone){this._resetAndInvalidateToolbar();}else{this._bControlsInfoCached=false;O.prototype._handleResize.apply(this,arguments);}};
A.prototype._callToolbarMethod=function(f,b){switch(f){case'addContent':return this.addAssociation("content",b[0]);case'getContent':return this.getContent();case'insertContent':return this.insertContent(b[0],b[1]);case'removeContent':return sap.ui.getCore().byId(this.removeAssociation("content",b[0],b[1],b[2]))||null;case'destroyContent':this.removeAllAssociation("content",b[0]);return this;case'removeAllContent':return this.removeAllAssociation("content",b[0]).map(function(c){return sap.ui.getCore().byId(c);});default:return T.prototype[f].apply(this,b);}};
return A;});
sap.ui.predefine('sap/m/Bar',['./BarInPageEnabler','./library','sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/ui/Device','./BarRenderer',"sap/ui/thirdparty/jquery"],function(B,l,C,R,D,a,q){"use strict";var b=l.BarDesign;
var c=C.extend("sap.m.Bar",{metadata:{interfaces:["sap.m.IBar"],library:"sap.m",properties:{enableFlexBox:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},translucent:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},design:{type:"sap.m.BarDesign",group:"Appearance",defaultValue:b.Auto}},aggregations:{contentLeft:{type:"sap.ui.core.Control",multiple:true,singularName:"contentLeft"},contentMiddle:{type:"sap.ui.core.Control",multiple:true,singularName:"contentMiddle"},contentRight:{type:"sap.ui.core.Control",multiple:true,singularName:"contentRight"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/m/designtime/Bar.designtime",dnd:{draggable:false,droppable:true}}});
c.prototype.onBeforeRendering=function(){this._removeAllListeners();};
c.prototype.onAfterRendering=function(){this._handleResize();};
c.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);};
c.prototype.exit=function(){this._removeAllListeners();if(this._oflexBox){this._oflexBox.destroy();this._oflexBox=null;}this._$MidBarPlaceHolder=null;this._$RightBar=null;this._$LeftBar=null;};
c._aResizeHandlers=["_sResizeListenerId","_sResizeListenerIdMid","_sResizeListenerIdRight","_sResizeListenerIdLeft"];
c.prototype._removeAllListeners=function(){var t=this;c._aResizeHandlers.forEach(function(i){t._removeListenerFailsave(i);});};
c.prototype._removeListenerFailsave=function(L){if(this[L]){R.deregister(this[L]);this[L]=null;}};
c.prototype._handleResize=function(){this._removeAllListeners();var e=!!this.getContentLeft().length,f=!!this.getContentMiddle().length,g=!!this.getContentRight().length;if(!this.getVisible()){return;}if(!e&&!f&&!g){return;}this._$LeftBar=this.$("BarLeft");this._$RightBar=this.$("BarRight");this._$MidBarPlaceHolder=this.$("BarPH");this._updatePosition(e,f,g);this._sResizeListenerId=R.register(this.getDomRef(),q.proxy(this._handleResize,this));if(this.getEnableFlexBox()){return;}if(e){this._sResizeListenerIdLeft=R.register(this._$LeftBar[0],q.proxy(this._handleResize,this));}if(f){this._sResizeListenerIdMid=R.register(this._$MidBarPlaceHolder[0],q.proxy(this._handleResize,this));}if(g){this._sResizeListenerIdRight=R.register(this._$RightBar[0],q.proxy(this._handleResize,this));}};
c.prototype._updatePosition=function(e,f,g){if(!e&&!g&&f){return;}if(e&&!f&&!g){return;}if(!e&&!f&&g){return;}var i=this.$().outerWidth(true);this._$RightBar.css({width:""});this._$LeftBar.css({width:""});this._$MidBarPlaceHolder.css({position:"",width:"",visibility:'hidden'});var r=this._$RightBar.outerWidth(true);if(r>i){if(e){this._$LeftBar.css({width:"0px"});}if(f){this._$MidBarPlaceHolder.css({width:"0px"});}this._$RightBar.css({width:i+"px"});return;}var L=this._getBarContainerWidth(this._$LeftBar);if(i<(L+r)){L=i-r;this._$LeftBar.css({width:L+"px"});this._$MidBarPlaceHolder.css({width:"0px"});return;}this._$MidBarPlaceHolder.css(this._getMidBarCss(r,i,L));};
c.prototype._getMidBarCss=function(r,i,L){var m=this._$MidBarPlaceHolder.outerWidth(true),e=sap.ui.getCore().getConfiguration().getRTL(),s=e?"right":"left",M={visibility:""};if(this.getEnableFlexBox()){m=i-L-r-parseInt(this._$MidBarPlaceHolder.css('margin-left'))-parseInt(this._$MidBarPlaceHolder.css('margin-right'));M.position="absolute";M.width=m+"px";M[s]=L;return M;}var S=i-L-r,f=(i/2)-(m/2),g=L>f,h=(i/2)+(m/2),j=(i-r)<h;if(this._$MidBarPlaceHolder.closest(".sapMBarTitleStart").length>0||(S>0&&(g||j))){M.position="absolute";M.width=S+"px";M.left=e?r:L;}return M;};
c.prototype._getBarContainerWidth=function($){var i,e=0,f=$.children(),g=0;if(D.browser.webkit||D.browser.firefox||D.browser.edge){for(i=0;i<f.length;i++){g+=q(f[i]).outerWidth(true);}e=$.outerWidth(true);}else{var o;for(i=0;i<f.length;i++){o=window.getComputedStyle(f[i]);if(o.width=="auto"){g+=q(f[i]).width()+1;}else{g+=parseFloat(o.width);}g+=parseFloat(o.marginLeft);g+=parseFloat(o.marginRight);g+=parseFloat(o.paddingLeft);g+=parseFloat(o.paddingRight);}var h=window.getComputedStyle($[0]);e+=parseFloat(h.width);e+=parseFloat(h.marginLeft);e+=parseFloat(h.marginRight);e+=parseFloat(h.paddingLeft);e+=parseFloat(h.paddingRight);}if(e<g){e=g;}return e;};
var d=B.extend("sap.m.BarInAnyContentEnabler",{});
d.mContexts={dialogFooter:{contextClass:"sapMFooter-CTX",tag:"Footer"}};
d.prototype.getContext=function(){var p=B.prototype.getContext.call();for(var k in d.mContexts){p[k]=d.mContexts[k];}return p;};
c.prototype.getContext=d.prototype.getContext;c.prototype.isContextSensitive=d.prototype.isContextSensitive;c.prototype.setHTMLTag=d.prototype.setHTMLTag;c.prototype.getHTMLTag=d.prototype.getHTMLTag;c.prototype.applyTagAndContextClassFor=d.prototype.applyTagAndContextClassFor;c.prototype._applyContextClassFor=d.prototype._applyContextClassFor;c.prototype._applyTag=d.prototype._applyTag;c.prototype._getContextOptions=d.prototype._getContextOptions;c.prototype._setRootAccessibilityRole=d.prototype._setRootAccessibilityRole;c.prototype._getRootAccessibilityRole=d.prototype._getRootAccessibilityRole;c.prototype._setRootAriaLevel=d.prototype._setRootAriaLevel;c.prototype._getRootAriaLevel=d.prototype._getRootAriaLevel;return c;});
sap.ui.predefine('sap/m/BarInPageEnabler',['sap/ui/base/Object','sap/m/library',"sap/base/Log"],function(O,l,L){"use strict";var I=l.IBarHTMLTag;var c={footer:{contextClass:"sapMFooter-CTX sapContrast sapContrastPlus",tag:"Footer",internalAriaLabel:"BAR_ARIA_DESCRIPTION_FOOTER"},header:{contextClass:"sapMHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_HEADER"},subheader:{contextClass:"sapMSubHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_SUBHEADER"}};var a="sapMIBar";
var B=O.extend("sap.m.BarInPageEnabler",{
isContextSensitive:function(){return this.getDesign&&this.getDesign()==="Auto";},
setHTMLTag:function(n){if(n===this.sTag){return this;}this.sTag=n;return this;},
getHTMLTag:function(){if(!this.hasOwnProperty("sTag")){this.sTag=I.Div;}return this.sTag;},
getContext:function(){return c;},
_getRootAccessibilityRole:function(){var r=this._sRootAccessibilityRole||"toolbar";return r;},
_setRootAccessibilityRole:function(r){this._sRootAccessibilityRole=r;return this;},
_getRootAriaLevel:function(){var A=this.sAriaLevel;return A;},
_setRootAriaLevel:function(s){this.sAriaLevel=s;return this;},
applyTagAndContextClassFor:function(C){this._applyTag(C);return this._applyContextClassFor(C);},
_applyContextClassFor:function(C){var o=this._getContextOptions(C);if(!o){return this;}if(!this.isContextSensitive){L.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}if(!this.getRenderer().shouldAddIBarContext()){this.addStyleClass(a+"-CTX");}if(this.isContextSensitive()){this.addStyleClass(o.contextClass);}return this;},
_applyTag:function(C){var o=this._getContextOptions(C);if(!o){return this;}if(!this.setHTMLTag){L.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}this.setHTMLTag(o.tag);return this;},
_getContextOptions:function(C){var o;if(this.getContext){o=this.getContext();}else{o=c;}var b=o[C];if(!b){L.error("The context "+C+" is not known",this);return null;}return b;},
render:function(r,C){var t=C.getHTMLTag().toLowerCase();r.openStart(t,C);r.class(a);if(this.shouldAddIBarContext(C)){r.class(a+"-CTX");}B.renderTooltip(r,C);this.decorateRootElement(r,C);r.openEnd();this.renderBarContent(r,C);r.close(t);}
});
B.renderTooltip=function(r,C){var t=C.getTooltip_AsString();if(t){r.attr("title",t);}};
B.addChildClassTo=function(C){C.addStyleClass("sapMBarChild");};
return B;});
sap.ui.predefine('sap/m/BarRenderer',['./BarInPageEnabler','sap/ui/Device',"sap/base/Log",'sap/m/HBox'],function(B,D,L,H){"use strict";var a={apiVersion:2};a.render=B.prototype.render;
a.decorateRootElement=function(r,c){r.class("sapMBar");r.class(this.getContext(c));r.accessibilityState(c,{"role":c._getRootAccessibilityRole(),"level":c._getRootAriaLevel()});if(c.getTranslucent()&&D.support.touch){r.class("sapMBarTranslucent");}r.class("sapMBar-CTX");};
a.shouldAddIBarContext=function(){return true;};
a.renderBarContent=function(r,c){r.openStart("div",c.getId()+"-BarLeft");r.class("sapMBarLeft");r.class("sapMBarContainer");w("left",r,c);r.openEnd();this.renderAllControls(c.getContentLeft(),r,c);r.close("div");r.openStart("div",c.getId()+"-BarMiddle");r.class("sapMBarMiddle");r.openEnd();if(c.getEnableFlexBox()){c._oflexBox=c._oflexBox||new H(c.getId()+"-BarPH",{alignItems:"Center"}).addStyleClass("sapMBarPH").setParent(c,null,true);var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;if(b&&!C&&!d){c._oflexBox.addStyleClass("sapMBarFlexBoxWidth100");}c.getContentMiddle().forEach(function(m){c._oflexBox.addItem(m);});r.renderControl(c._oflexBox);}else{r.openStart("div",c.getId()+"-BarPH");r.class("sapMBarPH");r.class("sapMBarContainer");w("middle",r,c);r.openEnd();this.renderAllControls(c.getContentMiddle(),r,c);r.close("div");}r.close("div");r.openStart("div",c.getId()+"-BarRight");r.class("sapMBarRight");r.class("sapMBarContainer");if(sap.ui.getCore().getConfiguration().getRTL()){r.class("sapMRTL");}w("right",r,c);r.openEnd();this.renderAllControls(c.getContentRight(),r,c);r.close("div");};
a.renderAllControls=function(c,r,b){c.forEach(function(C){B.addChildClassTo(C,b);r.renderControl(C);});};
a._mContexts={Header:"sapMHeader-CTX",SubHeader:"sapMSubHeader-CTX",Footer:"sapMFooter-CTX",Default:"sapMContent-CTX"};
a.getContext=function(c){var d=c.getDesign(),C=a._mContexts;return C[d]||C.Default;};
function w(A,r,c){var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;switch(A.toLowerCase()){case"left":if(C&&!b&&!d){r.style("width","100%");}break;case"middle":if(b&&!C&&!d){r.style("width","100%");}break;case"right":if(d&&!C&&!b){r.style("width","100%");}break;default:L.error("Cannot determine which of the three content aggregations is alone");}}
return a;},true);
sap.ui.predefine('sap/m/Breadcrumbs',["sap/ui/core/Control","sap/m/Text","sap/m/Link","sap/m/Select","sap/ui/core/Item","sap/ui/core/delegate/ItemNavigation","sap/ui/core/ResizeHandler","sap/ui/core/IconPool","sap/ui/Device","sap/m/library","./BreadcrumbsRenderer"],function(C,T,L,S,I,a,R,b,D,l,B){"use strict";var c=l.SelectType,d=l.BreadcrumbsSeparatorStyle;
var e=C.extend("sap.m.Breadcrumbs",{metadata:{library:"sap.m",interfaces:["sap.m.IBreadcrumbs"],designtime:"sap/m/designtime/Breadcrumbs.designtime",properties:{currentLocationText:{type:"string",group:"Behavior",defaultValue:null},separatorStyle:{type:"sap.m.BreadcrumbsSeparatorStyle",group:"Appearance",defaultValue:d.Slash}},aggregations:{links:{type:"sap.m.Link",multiple:true,singularName:"link"},_currentLocation:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},defaultAggregation:"links"}});
e.STYLE_MAPPER={Slash:"&#047;",BackSlash:"&#092;",DoubleSlash:"&#047;&#047;",DoubleBackSlash:"&#092;&#092;",GreaterThan:"&gt;",DoubleGreaterThan:"&#187;"};
e.prototype.init=function(){this._sSeparatorSymbol=e.STYLE_MAPPER[this.getSeparatorStyle()];};
e.prototype.onBeforeRendering=function(){this.bRenderingPhase=true;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._bControlsInfoCached){this._updateSelect(true);}};
e.prototype.onAfterRendering=function(){if(!this._sResizeListenerId){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}if(!this._bControlsInfoCached){this._updateSelect(true);return;}this._configureKeyboardHandling();this.bRenderingPhase=false;};
e.prototype.onThemeChanged=function(){this._resetControl();};
e.prototype.exit=function(){this._resetControl();this._destroyItemNavigation();};
e.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
e.prototype._getAugmentedId=function(s){return this.getId()+"-"+s;};
e.prototype._getSelect=function(){if(!this.getAggregation("_select")){this.setAggregation("_select",this._decorateSelect(new S({id:this._getAugmentedId("select"),change:this._selectChangeHandler.bind(this),forceSelection:false,autoAdjustWidth:true,icon:b.getIconURI("slim-arrow-down"),type:c.IconOnly,tooltip:B._getResourceBundleText("BREADCRUMB_SELECT_TOOLTIP")})));}return this.getAggregation("_select");};
e.prototype._getCurrentLocation=function(){if(!this.getAggregation("_currentLocation")){this.setAggregation("_currentLocation",new T({id:this._getAugmentedId("currentText"),text:this.getCurrentLocationText(),wrapping:false}).addStyleClass("sapMBreadcrumbsCurrentLocation"));}return this.getAggregation("_currentLocation");};
function f(A,g){var h=Array.prototype.slice.apply(g);h.unshift(A);return h;}
e.prototype.insertLink=function(o,i){var r=this.insertAggregation.apply(this,f("links",arguments));this._registerControlListener(o);this._resetControl();return r;};
e.prototype.addLink=function(o){var r=this.addAggregation.apply(this,f("links",arguments));this._registerControlListener(o);this._resetControl();return r;};
e.prototype.removeLink=function(o){var r=this.removeAggregation.apply(this,f("links",arguments));this._deregisterControlListener(r);this._resetControl();return r;};
e.prototype.removeAllLinks=function(){var g=this.getAggregation("links",[]);var r=this.removeAllAggregation.apply(this,f("links",arguments));g.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
e.prototype.destroyLinks=function(){var g=this.getAggregation("links",[]);var r=this.destroyAggregation.apply(this,f("links",arguments));g.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
e.prototype._decorateSelect=function(s){s.getPicker().attachAfterOpen(this._removeItemNavigation,this).attachBeforeClose(this._restoreItemNavigation,this);s._onBeforeOpenDialog=this._onSelectBeforeOpenDialog.bind(this);s._onBeforeOpenPopover=this._onSelectBeforeOpenPopover.bind(this);s.onsapescape=this._onSelectEscPress.bind(this);return s;};
e.prototype._removeItemNavigation=function(){this.removeDelegate(this._getItemNavigation());};
e.prototype._onSelectBeforeOpenDialog=function(){var s=this._getSelect();if(this.getCurrentLocationText()&&D.system.phone){s.setSelectedIndex(0);}else{s.setSelectedItem(null);}S.prototype._onBeforeOpenDialog.call(s);this._removeItemNavigation();};
e.prototype._onSelectBeforeOpenPopover=function(){this._getSelect().setSelectedItem(null);this._removeItemNavigation();};
e.prototype._restoreItemNavigation=function(){this.addDelegate(this._getItemNavigation());};
e.prototype._onSelectEscPress=function(){this._getSelect().close();};
e.prototype._createSelectItem=function(i){return new I({key:i.getId(),text:i.getText()});};
e.prototype._selectChangeHandler=function(E){var o,s,g,h=E.getParameter("selectedItem");if(!h){return;}if(!this._getSelect().isOpen()){return;}o=sap.ui.getCore().byId(h.getKey());if(!(o instanceof L)){return;}s=o.getHref();g=o.getTarget();o.firePress();if(s){if(g){window.open(s,g);}else{window.location.href=s;}}};
e.prototype._getItemsForMobile=function(){var i=this.getLinks();if(this.getCurrentLocationText()){i.push(this._getCurrentLocation());}return i;};
e.prototype._updateSelect=function(i){var s=this._getSelect(),g,o=this._getControlDistribution();if(!this._bControlDistributionCached||i){s.destroyItems();g=D.system.phone?this._getItemsForMobile():o.aControlsForSelect;g.map(this._createSelectItem).reverse().forEach(s.insertItem,s);this._bControlDistributionCached=true;this.invalidate(this);}s.setVisible(!!o.aControlsForSelect.length);if(!this._sResizeListenerId&&!this.bRenderingPhase){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}};
e.prototype._getControlsForBreadcrumbTrail=function(){var v;if(this._bControlDistributionCached&&this._oDistributedControls){return this._oDistributedControls.aControlsForBreadcrumbTrail;}v=this.getLinks().filter(function(o){return o.getVisible();});if(this.getCurrentLocationText()){return v.concat([this._getCurrentLocation()]);}return v;};
e.prototype._getControlInfo=function(o){return{id:o.getId(),control:o,width:o.$().parent().outerWidth(true),bCanOverflow:o instanceof L};};
e.prototype._getControlDistribution=function(m){m=m||this._iContainerSize;this._iContainerSize=m;this._oDistributedControls=this._determineControlDistribution(m);return this._oDistributedControls;};
e.prototype._getSelectWidth=function(){return this._getSelect().getVisible()&&this._iSelectWidth||0;};
e.prototype._determineControlDistribution=function(m){var i,o,g=this._getControlsInfo().aControlInfo,s=this._getSelectWidth(),h=[],j=[],u=s;for(i=g.length-1;i>=0;i--){o=g[i];u+=o.width;if(g.length-1===i){j.push(o.control);continue;}if(i===0){u-=s;}if(u>m&&o.bCanOverflow){h.unshift(o.control);}else{j.unshift(o.control);}}return{aControlsForBreadcrumbTrail:j,aControlsForSelect:h};};
e.prototype._getControlsInfo=function(){if(!this._bControlsInfoCached){this._iSelectWidth=this._getSelect().$().parent().outerWidth(true)||0;this._aControlInfo=this._getControlsForBreadcrumbTrail().map(this._getControlInfo);this._iContainerSize=this.$().outerWidth(true);this._bControlsInfoCached=true;}return{aControlInfo:this._aControlInfo,iSelectWidth:this._iSelectWidth,iContentSize:this._iContainerSize};};
e.prototype._handleScreenResize=function(E){var i=this._oDistributedControls.aControlsForBreadcrumbTrail.length,o=this._getControlDistribution(E.size.width),g=o.aControlsForBreadcrumbTrail.length;if(i!==g){this._updateSelect(true);}return this;};
e.prototype._getItemsToNavigate=function(){var i=this._getControlsForBreadcrumbTrail().slice(),s=this._getSelect();if(s.getVisible()){i.unshift(s);}return i;};
e.prototype._getItemNavigation=function(){if(!this._itemNavigation){this._itemNavigation=new a();}return this._itemNavigation;};
e.prototype._destroyItemNavigation=function(){if(this._itemNavigation){this.removeEventDelegate(this._itemNavigation);this._itemNavigation.destroy();this._itemNavigation=null;}};
e.prototype._configureKeyboardHandling=function(){var i=this._getItemNavigation(),s=-1,g=this._getItemsToNavigate(),n=[];if(g.length===0){return;}g.forEach(function(o,h){if(h===0){o.$().attr("tabindex","0");}o.$().attr("tabindex","-1");n.push(o.getDomRef());});this.addDelegate(i);i.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});i.setCycling(false);i.setPageSize(e.PAGEUP_AND_PAGEDOWN_JUMP_SIZE);i.setRootDomRef(this.getDomRef());i.setItemDomRefs(n);i.setSelectedIndex(s);return this;};
e.prototype._registerControlListener=function(o){if(o){o.attachEvent("_change",this._resetControl,this);}};
e.prototype._deregisterControlListener=function(o){if(o){o.detachEvent("_change",this._resetControl,this);}};
e.prototype.setCurrentLocationText=function(t){var o=this._getCurrentLocation(),r=this.setProperty("currentLocationText",t,true);if(o.getText()!==t){o.setText(t);this._resetControl();}return r;};
e.prototype.setSeparatorStyle=function(s){var g=e.STYLE_MAPPER[s];if(!g){return this;}this._sSeparatorSymbol=g;return this.setProperty("separatorStyle",s);};
e.prototype._resetControl=function(){this._aControlInfo=null;this._iContainerSize=null;this._bControlsInfoCached=null;this._bControlDistributionCached=null;this._oDistributedControls=null;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.removeDelegate(this._getItemNavigation());this.invalidate(this);return this;};
return e;});
sap.ui.predefine('sap/m/BreadcrumbsRenderer',["sap/m/Text"],function(T){"use strict";var B={apiVersion:2};var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
B.render=function(R,c){var C=c._getControlsForBreadcrumbTrail(),s=c._getSelect(),S=c._sSeparatorSymbol;R.openStart("nav",c);R.class("sapMBreadcrumbs");R.attr("aria-label",B._getResourceBundleText("BREADCRUMB_LABEL"));R.openEnd();R.openStart("ol");R.openEnd();if(s.getVisible()){this._renderControlInListItem(R,s,S,false,"sapMBreadcrumbsSelectItem");}C.forEach(function(o){this._renderControlInListItem(R,o,S,o instanceof T);},this);R.close("ol");R.close("nav");};
B._renderControlInListItem=function(R,c,s,S,a){R.openStart("li");R.class("sapMBreadcrumbsItem");R.class(a);R.openEnd();R.renderControl(c);if(!S){R.openStart("span").class("sapMBreadcrumbsSeparator").openEnd().unsafeHtml(s).close("span");}R.close("li");};
B._getResourceBundleText=function(t){return r.getText(t);};
return B;},true);
sap.ui.predefine('sap/m/BusyDialog',['./library','sap/ui/core/Control','sap/m/Dialog','sap/m/BusyIndicator','sap/m/Label','sap/m/Button',"sap/base/Log"],function(l,C,D,B,L,a,b){"use strict";
var c=C.extend("sap.m.BusyDialog",{
metadata:{library:"sap.m",properties:{text:{type:"string",group:"Appearance",defaultValue:''},title:{type:"string",group:"Appearance",defaultValue:''},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},cancelButtonText:{type:"string",group:"Misc",defaultValue:''},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{close:{parameters:{cancelPressed:{type:"boolean"}}}},designtime:"sap/m/designtime/BusyDialog.designtime"},
renderer:function(r,o){}
});
c.prototype.init=function(){this._busyIndicator=new B(this.getId()+'-busyInd',{visible:true});function o(){if(sap.ui.getCore().getConfiguration().getAccessibility()){this._$content.attr('role','application');}}this._oDialog=new D(this.getId()+'-Dialog',{content:this._busyIndicator,showHeader:false,afterOpen:o,afterClose:this._fnCloseHandler.bind(this),initialFocus:this._busyIndicator.getId()+'-busyIndicator'}).addStyleClass('sapMBusyDialog');this._oDialog.close=function(){};this._oDialog.addEventDelegate({onBeforeRendering:function(){var t=this.getText(),d=this.getTitle(),s=this.getShowCancelButton()||this.getCancelButtonText();if(!t&&!d&&!s){this._oDialog.addStyleClass('sapMBusyDialog-Light');}else{this._oDialog.removeStyleClass('sapMBusyDialog-Light');}}},this);this._oDialog.oPopup.onsapescape=function(e){this.close(true);}.bind(this);};
c.prototype.exit=function(){this._busyIndicator.destroy();this._busyIndicator=null;if(this._cancelButton){this._cancelButton.destroy();this._cancelButton=null;}if(this._oLabel){this._oLabel.destroy();this._oLabel=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}};
c.prototype.open=function(){b.debug("sap.m.BusyDialog.open called at "+new Date().getTime());if(this.getAriaLabelledBy()&&!this._oDialog._$dialog){var t=this;this.getAriaLabelledBy().forEach(function(i){t._oDialog.addAriaLabelledBy(i);});}if(!document.body||!sap.ui.getCore().isInitialized()){setTimeout(function(){this.open();}.bind(this),50);}else{this._oDialog.open();}return this;};
c.prototype.close=function(i){this._isClosedFromUserInteraction=i;D.prototype.close.call(this._oDialog);return this;};
c.prototype._fnCloseHandler=function(){this.fireClose({cancelPressed:this._isClosedFromUserInteraction||false});};
c.prototype.setTitle=function(t){this.setProperty('title',t,true);this._oDialog.setTitle(t).setShowHeader(!!t);return this;};
c.prototype.setTooltip=function(t){this._oDialog.setTooltip(t);return this;};
c.prototype.getTooltip=function(){this._oDialog.getTooltip();return this;};
c.prototype.setText=function(t){this.setProperty('text',t,true);if(!this._oLabel){if(t){this._oLabel=new L(this.getId()+'-TextLabel',{text:t}).addStyleClass('sapMBusyDialogLabel');this._oDialog.insertAggregation('content',this._oLabel,0);this._oDialog.addAriaLabelledBy(this._oLabel.getId());}}else{if(t){this._oLabel.setText(t).setVisible(true);}else{this._oLabel.setVisible(false);}}return this;};
c.prototype.setCustomIcon=function(i){this.setProperty("customIcon",i,true);this._busyIndicator.setCustomIcon(i);return this;};
c.prototype.setCustomIconRotationSpeed=function(s){this.setProperty("customIconRotationSpeed",s,true);this._busyIndicator.setCustomIconRotationSpeed(s);return this;};
c.prototype.setCustomIconDensityAware=function(i){this.setProperty("customIconDensityAware",i,true);this._busyIndicator.setCustomIconDensityAware(i);return this;};
c.prototype.setCustomIconWidth=function(w){this.setProperty("customIconWidth",w,true);this._busyIndicator.setCustomIconWidth(w);return this;};
c.prototype.setCustomIconHeight=function(h){this.setProperty("customIconHeight",h,true);this._busyIndicator.setCustomIconHeight(h);return this;};
c.prototype.setShowCancelButton=function(i){this.setProperty("showCancelButton",i,false);if(i){this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
c.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,false);if(t){this._getCancelButton().setText(t);this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
c.prototype.getDomRef=function(){return this._oDialog&&this._oDialog.getDomRef();};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass"].forEach(function(A){c.prototype[A]=function(){if(this._oDialog&&this._oDialog[A]){this._oDialog[A].apply(this._oDialog,arguments);return this;}};});
c.prototype._destroyTheCancelButton=function(){this._oDialog.destroyEndButton();this._cancelButton=null;};
c.prototype._getCancelButton=function(){var d=this.getCancelButtonText();d=d?d:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("BUSYDIALOG_CANCELBUTTON_TEXT");return this._cancelButton?this._cancelButton:this._cancelButton=new a(this.getId()+'busyCancelBtn',{text:d,press:function(){this.close(true);}.bind(this)});};
return c;});
sap.ui.predefine('sap/m/BusyIndicator',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Image','sap/m/Label',"./BusyIndicatorRenderer"],function(l,C,c,I,L,B){"use strict";var T=c.TextDirection;
var a=C.extend("sap.m.BusyIndicator",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Data",defaultValue:""},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},customIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:""},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},size:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"1rem"},design:{type:"string",group:"Appearance",defaultValue:"auto"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
a.prototype.init=function(){this.setBusyIndicatorDelay(0);};
a.prototype.setText=function(t){this.setProperty("text",t,true);this._createLabel("setText",t);return this;};
a.prototype.setTextDirection=function(d){this.setProperty("textDirection",d,true);this._createLabel("setTextDirection",d);return this;};
a.prototype.setCustomIcon=function(s){this.setProperty("customIcon",s,false);this._createCustomIcon("setSrc",s);return this;};
a.prototype.setCustomIconRotationSpeed=function(s){if(isNaN(s)||s<0){s=0;}if(s!==this.getCustomIconRotationSpeed()){this.setProperty("customIconRotationSpeed",s,true);this._setRotationSpeed();}return this;};
a.prototype.setCustomIconDensityAware=function(A){this.setProperty("customIconDensityAware",A,true);this._createCustomIcon("setDensityAware",A);return this;};
a.prototype.setCustomIconWidth=function(w){this.setProperty("customIconWidth",w,true);this._createCustomIcon("setWidth",w);this._iconImage.$().css("width",w);return this;};
a.prototype.setCustomIconHeight=function(h){this.setProperty("customIconHeight",h,true);this._createCustomIcon("setHeight",h);this._iconImage.$().css("height",h);return this;};
a.prototype.setSize=function(s){this.setProperty("size",s,true);var d=this.getDomRef();if(d){d.style.fontSize=s;}return this;};
a.prototype.onBeforeRendering=function(){if(this.getCustomIcon()){this.setBusy(false);}else{this.setBusy(true,"busy-area");}};
a.prototype.exit=function(){if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._busyLabel){this._busyLabel.destroy();this._busyLabel=null;}};
a.prototype._createCustomIcon=function(n,v){if(!this._iconImage){this._iconImage=new I(this.getId()+"-icon",{width:"44px",height:"44px"}).addStyleClass("sapMBsyIndIcon");this._iconImage.addEventDelegate({onAfterRendering:function(){this._setRotationSpeed();}},this);}this._iconImage[n](v);this._setRotationSpeed();};
a.prototype._createLabel=function(n,v){if(!this._busyLabel){this._busyLabel=new L(this.getId()+"-label",{labelFor:this.getId(),textAlign:"Center"});}this._busyLabel[n](v);};
a.prototype._setRotationSpeed=function(){if(!this._iconImage){return;}var $=this._iconImage.$();var r=this.getCustomIconRotationSpeed()+"ms";$.css("-webkit-animation-duration",r).css("animation-duration",r);$.css("display","none");setTimeout(function(){$.css("display","inline");},0);};
return a;});
sap.ui.predefine('sap/m/BusyIndicatorRenderer',[],function(){"use strict";var B={};
B.render=function(r,b){this.startBusyIndicator(r,b);this.renderBusyIndication(r,b);this.renderLabel(r,b);this.endBusyIndicator(r);};
B.startBusyIndicator=function(r,b){r.write("<div ");r.writeControlData(b);r.addClass("sapMBusyIndicator");r.writeClasses();r.addStyle("font-size",b.getSize());r.writeStyles();r.writeAccessibilityState(b);this.renderTooltip(r,b.getTooltip_AsString());r.write(">");};
B.renderTooltip=function(r,t){if(t){r.writeAttributeEscaped("title",t);}};
B.renderBusyIndication=function(r,b){if(b.getCustomIcon()){r.renderControl(b._iconImage);}else{r.write("<div class='sapMBusyIndicatorBusyArea'");r.writeAttribute("id",b.getId()+"-busy-area");r.write("></div>");}};
B.renderLabel=function(r,b){if(b.getText()){r.renderControl(b._busyLabel);}};
B.endBusyIndicator=function(r){r.write("</div>");};
return B;},true);
sap.ui.predefine('sap/m/Button',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/ContextMenuSupport','sap/ui/core/library','./ButtonRenderer',"sap/ui/events/KeyCodes","sap/ui/core/LabelEnablement"],function(l,C,E,I,D,a,c,B,K,L){"use strict";var T=c.TextDirection;var b=l.ButtonType;
var d=C.extend("sap.m.Button",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:b.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},iconFirst:{type:"boolean",group:"Appearance",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},press:{}},designtime:"sap/m/designtime/Button.designtime",dnd:{draggable:true,droppable:false}}});
E.call(d.prototype);a.apply(d.prototype);
d.prototype.init=function(){this._onmouseenter=this._onmouseenter.bind(this);this._buttonPressed=false;};
d.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._iconBtn){this._iconBtn.destroy();}this.$().off("mouseenter",this._onmouseenter);};
d.prototype.onBeforeRendering=function(){this._bRenderActive=this._bActive;this.$().off("mouseenter",this._onmouseenter);};
d.prototype.onAfterRendering=function(){if(this._bRenderActive){this._activeButton();this._bRenderActive=this._bActive;}this.$().on("mouseenter",this._onmouseenter);};
d.prototype.ontouchstart=function(e){e.setMarked();if(this._bRenderActive){delete this._bRenderActive;}if(e.targetTouches.length===1){this._buttonPressed=true;this._activeButton();}if(this.getEnabled()&&this.getVisible()){if(D.browser.safari&&(e.originalEvent&&e.originalEvent.type==="mousedown")){this.focus();e.preventDefault();}if(!sap.ui.Device.browser.msie){this._sStartingTagId=e.target.id.replace(this.getId(),'');}}else{if(!sap.ui.Device.browser.msie){this._sStartingTagId='';}}};
d.prototype.ontouchend=function(e){this._buttonPressed=e.originalEvent&&e.originalEvent.buttons&1;this._inactiveButton();if(this._bRenderActive){delete this._bRenderActive;if(e.originalEvent&&e.originalEvent.type in{mouseup:1,touchend:1}){this.ontap(e);}}if(!sap.ui.Device.browser.msie){this._sEndingTagId=e.target.id.replace(this.getId(),'');if(this._buttonPressed===0&&((this._sStartingTagId==="-BDI-content"&&(this._sEndingTagId==='-content'||this._sEndingTagId==='-inner'||this._sEndingTagId==='-img'))||(this._sStartingTagId==="-content"&&(this._sEndingTagId==='-inner'||this._sEndingTagId==='-img'))||(this._sStartingTagId==='-img'&&this._sEndingTagId!=='-img'))){this.ontap(e);}}};
d.prototype.ontouchcancel=function(){this._buttonPressed=false;this._inactiveButton();};
d.prototype.ontap=function(e){e.setMarked();if(this.getEnabled()&&this.getVisible()){if((e.originalEvent&&e.originalEvent.type==="touchend")){this.focus();}this.fireTap({});this.firePress({});}};
d.prototype.onkeydown=function(e){if(e.which===K.SPACE||e.which===K.ENTER||e.which===K.ESCAPE||e.which===K.SHIFT){if(e.which===K.SPACE||e.which===K.ENTER){e.setMarked();this._activeButton();}if(e.which===K.ENTER){this.firePress({});}if(e.which===K.SPACE){this._bPressedSpace=true;}if(this._bPressedSpace){if(e.which===K.SHIFT||e.which===K.ESCAPE){this._bPressedEscapeOrShift=true;this._inactiveButton();}}}else{if(this._bPressedSpace){e.preventDefault();}}};
d.prototype.onkeyup=function(e){if(e.which===K.ENTER){e.setMarked();this._inactiveButton();}if(e.which===K.SPACE){if(!this._bPressedEscapeOrShift){e.setMarked();this._inactiveButton();this.firePress({});}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}if(e.which===K.ESCAPE){this._bPressedSpace=false;}};
d.prototype._onmouseenter=function(e){if(this._buttonPressed&&e.originalEvent&&e.originalEvent.buttons&1){this._activeButton();}};
d.prototype.onfocusout=function(){this._inactiveButton();};
d.prototype._activeButton=function(){if(!this._isUnstyled()){this.$("inner").addClass("sapMBtnActive");}this._bActive=this.getEnabled();if(this._bActive){if(this.getIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this.getActiveIcon());}}};
d.prototype._inactiveButton=function(){if(!this._isUnstyled()){this.$("inner").removeClass("sapMBtnActive");}this._bActive=false;if(this.getEnabled()){if(this.getIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this.getIcon());}}};
d.prototype._isHoverable=function(){return this.getEnabled()&&D.system.desktop;};
d.prototype._getImage=function(i,s,A,e){var f=I.isIconURI(s),g;if(this._image instanceof sap.m.Image&&f||this._image instanceof sap.ui.core.Icon&&!f){this._image.destroy();this._image=undefined;}g=this.getIconFirst();if(this._image){this._image.setSrc(s);if(this._image instanceof sap.m.Image){this._image.setActiveSrc(A);this._image.setDensityAware(e);}}else{this._image=I.createControlByURI({id:i,src:s,activeSrc:A,densityAware:e,useIconTooltip:false},sap.m.Image).addStyleClass("sapMBtnCustomIcon").setParent(this,null,true);}this._image.addStyleClass("sapMBtnIcon");this._image.toggleStyleClass("sapMBtnIconLeft",g);this._image.toggleStyleClass("sapMBtnIconRight",!g);return this._image;};
d.prototype._getInternalIconBtn=function(i,s){var o=this._iconBtn;if(o){o.setSrc(s);}else{o=I.createControlByURI({id:i,src:s,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}o.addStyleClass("sapMBtnIcon");o.addStyleClass("sapMBtnIconLeft");this._iconBtn=o;return this._iconBtn;};
d.prototype._isUnstyled=function(){var u=false;if(this.getType()===b.Unstyled){u=true;}return u;};
d.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("inner");};
d.prototype._getText=function(){return this.getText();};
d.prototype._getTooltip=function(){var t=this.getTooltip_AsString();if(!t&&!this.getText()){var i=I.getIconInfo(this.getIcon());if(i&&i.text){t=i.text;}}return t;};
d.prototype.getAccessibilityInfo=function(){var s=this.getText()||this.getTooltip_AsString();if(!s&&this.getIcon()){var i=I.getIconInfo(this.getIcon());if(i){s=i.text||i.name;}}return{role:"button",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON"),description:s,focusable:this.getEnabled(),enabled:this.getEnabled()};};
d.prototype._determineSelfReferencePresence=function(){var A=this.getAriaLabelledBy(),e=A.indexOf(this.getId())!==-1,h=L.getReferencingLabels(this).length>0,p=this.getParent(),f=!!(p&&p.enhanceAccessibilityState);return!e&&this._getText()&&(A.length>0||h||f);};
return d;});
sap.ui.predefine('sap/m/ButtonRenderer',['sap/ui/Device','sap/ui/core/library','sap/ui/core/IconPool','sap/m/library','sap/ui/core/InvisibleText'],function(D,c,I,l,a){"use strict";var B=l.ButtonType;var T=c.TextDirection;var b={apiVersion:2};
b.render=function(R,o){var t=o.getType();var e=o.getEnabled();var w=o.getWidth();var s=o._getTooltip();var d=o._getText();var f=o.getTextDirection();var i=D.browser.internet_explorer||D.browser.edge;var g=(f===T.Inherit)&&!i;var h=I.getIconURI("nav-back");R.openStart("button",o);R.class("sapMBtnBase");if(!o._isUnstyled()){R.class("sapMBtn");if((t===B.Back||t===B.Up)&&o.getIcon()&&!d){R.class("sapMBtnBack");}}var m={};var j=o.getId()+"-tooltip";var k=b.getButtonTypeAriaLabelId(t);if(k&&s){m["describedby"]={value:j+" "+k,append:true};}else if(k){m["describedby"]={value:k,append:true};}else if(s){m["describedby"]={value:j,append:true};}if(o._determineSelfReferencePresence()){m["labelledby"]={value:o.getId()+"-content",append:true};}m["disabled"]=null;if(this.renderAccessibilityAttributes){this.renderAccessibilityAttributes(R,o,m);}R.accessibilityState(o,m);if(!e){R.attr("disabled","disabled");if(!o._isUnstyled()){R.class("sapMBtnDisabled");}}else{switch(t){case B.Accept:case B.Reject:case B.Emphasized:R.class("sapMBtnInverted");break;default:break;}}if(s){R.attr("title",s);}if(w!=""||w.toLowerCase()==="auto"){R.style("width",w);}r(o,R);R.openEnd();R.openStart("span",o.getId()+"-inner");if(!o._isUnstyled()){R.class("sapMBtnInner");}if(o._isHoverable()){R.class("sapMBtnHoverable");}if(e){R.class("sapMFocusable");if(i){R.class("sapMIE");}}if(!o._isUnstyled()){if(d){R.class("sapMBtnText");}if(t===B.Back||t===B.Up){R.class("sapMBtnBack");}if(o.getIcon()){if(o.getIconFirst()){R.class("sapMBtnIconFirst");}else{R.class("sapMBtnIconLast");}}}if(this.renderButtonAttributes){this.renderButtonAttributes(R,o);}if(!o._isUnstyled()&&t!==""){R.class("sapMBtn"+t);}r(o,R);R.openEnd();if(t===B.Back||t===B.Up){this.writeInternalIconPoolHtml(R,o,h);}if(o.getIcon()){this.writeImgHtml(R,o);}if(d){R.openStart("span",o.getId()+"-content");R.class("sapMBtnContent");if(f!==T.Inherit){R.attr("dir",f.toLowerCase());}R.openEnd();if(g){R.openStart("bdi",o.getId()+"-BDI-content");R.openEnd();}R.text(d);if(g){R.close("bdi");}R.close("span");}if(i&&e){R.openStart("span");R.class("sapMBtnFocusDiv");R.openEnd();R.close("span");}R.close("span");if(s){R.openStart("span",j);R.class("sapUiInvisibleText");R.openEnd();R.text(s);R.close("span");}R.close("button");};
b.writeImgHtml=function(R,o){R.renderControl(o._getImage((o.getId()+"-img"),o.getIcon(),o.getActiveIcon(),o.getIconDensityAware()));};
b.writeInternalIconPoolHtml=function(R,o,u){R.renderControl(o._getInternalIconBtn((o.getId()+"-iconBtn"),u));};
function r(o,R){if(o._bExcludeFromTabChain){R.attr("tabindex",-1);}}
var A={Accept:"BUTTON_ARIA_TYPE_ACCEPT",Reject:"BUTTON_ARIA_TYPE_REJECT",Emphasized:"BUTTON_ARIA_TYPE_EMPHASIZED"};
b.getButtonTypeAriaLabelId=function(t){return a.getStaticId("sap.m",A[t]);};
return b;},true);
sap.ui.predefine('sap/m/Carousel',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/Device','sap/ui/core/ResizeHandler','sap/ui/core/library','sap/ui/core/HTML','sap/m/ScrollContainer','sap/m/MessagePage','sap/ui/core/theming/Parameters','sap/ui/dom/units/Rem','./CarouselRenderer','./CarouselLayout',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/events/F6Navigation","sap/ui/thirdparty/jquery",'sap/ui/thirdparty/mobify-carousel','sap/ui/core/IconPool'],function(l,C,a,D,R,c,H,S,M,P,b,d,f,K,L,F,q){"use strict";var B=c.BusyIndicatorSize;var I=l.ImageHelper;var g=l.CarouselArrowsPlacement;var h=l.PlacementType;
var j=a.extend("sap.m.Carousel",{metadata:{library:"sap.m",designtime:"sap/m/designtime/Carousel.designtime",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},loop:{type:"boolean",group:"Misc",defaultValue:false},showPageIndicator:{type:"boolean",group:"Appearance",defaultValue:true},pageIndicatorPlacement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:h.Bottom},showBusyIndicator:{type:"boolean",group:"Appearance",defaultValue:true,deprecated:true},arrowsPlacement:{type:"sap.m.CarouselArrowsPlacement",group:"Appearance",defaultValue:g.Content}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"},customLayout:{type:"sap.m.CarouselLayout",multiple:false}},associations:{activePage:{type:"sap.ui.core.Control",multiple:false}},events:{loadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},unloadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},pageChanged:{parameters:{oldActivePageId:{type:"string"},newActivePageId:{type:"string"},activePages:{type:"array"}}},beforePageChanged:{parameters:{activePages:{type:"array"}}}}}});
j._INNER_SELECTOR=".sapMCrslInner";j._PAGE_INDICATOR_SELECTOR=".sapMCrslBulleted";j._PAGE_INDICATOR_ARROWS_SELECTOR=".sapMCrslIndicatorArrow";j._CONTROLS=".sapMCrslControls";j._ITEM_SELECTOR=".sapMCrslItem";j._LEFTMOST_CLASS="sapMCrslLeftmost";j._RIGHTMOST_CLASS="sapMCrslRightmost";j._LATERAL_CLASSES="sapMCrslLeftmost sapMCrslRightmost";j._MODIFIERNUMBERFORKEYBOARDHANDLING=10;j._BULLETS_TO_NUMBERS_THRESHOLD=9;j._PREVIOUS_CLASS_ARROW="sapMCrslPrev";j._NEXT_CLASS_ARROW="sapMCrslNext";
j.prototype.init=function(){this._aScrollContainers=[];this._fnAdjustAfterResize=q.proxy(function(){var $=this.$().find(j._INNER_SELECTOR);this._oMobifyCarousel.resize($);this._setWidthOfPages(this._getNumberOfItemsToShow());},this);this._aOrderOfFocusedElements=[];this._aAllActivePages=[];this._aAllActivePagesIndexes=[];this._onBeforePageChangedRef=this._onBeforePageChanged.bind(this);this._onAfterPageChangedRef=this._onAfterPageChanged.bind(this);this.data("sap-ui-fastnavgroup","true",true);this._oRb=C.getLibraryResourceBundle("sap.m");};
j.prototype.exit=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.destroy();delete this._oMobifyCarousel;}if(this._oArrowLeft){this._oArrowLeft.destroy();delete this._oArrowLeft;}if(this._oArrowRight){this._oArrowRight.destroy();delete this._oArrowRight;}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this.oMessagePage){this.oMessagePage.destroy();this.oMessagePage=null;}this.$().off('afterSlide');this._cleanUpScrollContainer();this._fnAdjustAfterResize=null;this._aScrollContainers=null;this._$InnerDiv=null;this._aOrderOfFocusedElements=null;this._aAllActivePages=null;this._aAllActivePagesIndexes=null;};
j.prototype._cleanUpScrollContainer=function(){var s;while(this._aScrollContainers&&this._aScrollContainers.length>0){s=this._aScrollContainers.pop();s.destroyContent();if(s&&typeof s.destroy==='function'){s.destroy();}}};
j.prototype.ontouchstart=function(e){if(this._oMobifyCarousel){this._oMobifyCarousel.touchstart(e);}};
j.prototype.ontouchmove=function(e){if(this._oMobifyCarousel){this._oMobifyCarousel.touchmove(e);}};
j.prototype.ontouchend=function(e){if(this._oMobifyCarousel){if(this._oMobifyCarousel.hasActiveTransition()){this._oMobifyCarousel.onTransitionComplete();}this._oMobifyCarousel.touchend(e);}};
j.prototype.onBeforeRendering=function(){var A=this.getActivePage();if(!A&&this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}return this;};
j.prototype._getNumberOfItemsToShow=function(){var p=this.getPages().length,o=this.getCustomLayout(),n=1;if(o&&o.isA("sap.m.CarouselLayout")){n=Math.max(o.getVisiblePagesCount(),1);}if(n>1&&p<n){return p;}return n;};
j.prototype.onAfterRendering=function(){var n=this._getNumberOfItemsToShow();if(this._oMobifyCarousel){this._oMobifyCarousel.unbind();}this.$().carousel(undefined,{numberOfItemsToShow:n});this._oMobifyCarousel=this.getDomRef()._carousel;this._oMobifyCarousel.setLoop(this.getLoop());this._oMobifyCarousel.setRTL(C.getConfiguration().getRTL());if(n>1){this._setWidthOfPages(n);}var A=this.getActivePage();if(A){this._updateActivePages(A);var i=this._getPageNumber(A);if(isNaN(i)||i==0){if(this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);this._adjustHUDVisibility(1);}}else{if(C.isThemeApplied()){this._moveToPage(i+1);}else{C.attachThemeChanged(this._handleThemeLoad,this);}if(this.getParent()&&this.getParent().isA("sap.zen.commons.layout.PositionContainer")){if(this._isCarouselUsedWithCommonsLayout===undefined){setTimeout(this["invalidate"].bind(this),0);this._isCarouselUsedWithCommonsLayout=true;}}}}this.$().on('beforeSlide',this._onBeforePageChangedRef);this.$().on('afterSlide',this._onAfterPageChangedRef);this._$InnerDiv=this.$().find(j._INNER_SELECTOR)[0];this._sResizeListenerId=R.register(this._$InnerDiv,this._fnAdjustAfterResize);this.$().find('.sapMCrslItemTableCell').focus(function(e){e.preventDefault();q(e.target).parents('.sapMCrsl').focus();return false;});var s='sap.m.IconTabBar';var p=this.getParent();while(p){if(p.getMetadata().getName()==s){var t=this;p.attachExpand(function(e){var E=e.getParameter('expand');if(E&&i>0){t._moveToPage(i+1);}});break;}p=p.getParent();}};
j.prototype._onBeforePageChanged=function(e,p,n){if(e.target!==this.getDomRef()){return;}var N=this.getPages()[n-1].getId();this._updateActivePages(N);this.fireBeforePageChanged({activePages:this._aAllActivePagesIndexes});};
j.prototype._onAfterPageChanged=function(e,p,n){if(e.target!==this.getDomRef()){return;}if(n>0){this._changePage(p,n);}};
j.prototype._setWidthOfPages=function(n){var i=this._calculatePagesWidth(n);this.$().find(".sapMCrslItem").each(function(e,p){p.style.width=i+"%";});};
j.prototype._calculatePagesWidth=function(n){var w=this.$().width(),m=b.toPx(P.get("_sap_m_Carousel_PagesMarginRight")),i=(w-(m*(n-1)))/n,e=(i/w)*100;return e;};
j.prototype._handleThemeLoad=function(){var A=this.getActivePage();if(A){var i=this._getPageNumber(A);if(i>0){this._moveToPage(i+1);}}C.detachThemeChanged(this._handleThemeLoad,this);};
j.prototype._moveToPage=function(i){this._oMobifyCarousel.changeAnimation('sapMCrslNoTransition');this._oMobifyCarousel.move(i);this._changePage(undefined,i);};
j.prototype._changePage=function(o,n){this._adjustHUDVisibility(n);var O=this.getActivePage();if(o){O=this.getPages()[o-1].getId();}var N=this.getPages()[n-1].getId();this.setAssociation("activePage",N,true);var t=this._getPageIndicatorText(n);L.debug("sap.m.Carousel: firing pageChanged event: old page: "+O+", new page: "+N);if(!D.system.desktop){q(document.activeElement).blur();}this.firePageChanged({oldActivePageId:O,newActivePageId:N,activePages:this._aAllActivePagesIndexes});this.$('slide-number').text(t);};
j.prototype._getPageIndicatorText=function(n){return this._oRb.getText("CAROUSEL_PAGE_INDICATOR_TEXT",[n,this.getPages().length-this._getNumberOfItemsToShow()+1]);};
j.prototype._adjustHUDVisibility=function(n){var N=this._getNumberOfItemsToShow();if(D.system.desktop&&!this.getLoop()&&this.getPages().length>1){var $=this.$('hud');$.removeClass(j._LATERAL_CLASSES);if(n===1){$.addClass(j._LEFTMOST_CLASS);this._focusCarouselContainer($,j._PREVIOUS_CLASS_ARROW);}if((n+N-1)===this.getPages().length){$.addClass(j._RIGHTMOST_CLASS);this._focusCarouselContainer($,j._NEXT_CLASS_ARROW);}}};
j.prototype._focusCarouselContainer=function($,A){if($.find('.'+A)[0]===document.activeElement){this.focus();}};
j.prototype.setActivePage=function(p){var s=null;if(typeof(p)=='string'){s=p;}else if(p instanceof a){s=p.getId();}if(s){if(s===this.getActivePage()){return this;}var i=this._getPageNumber(s);if(!isNaN(i)){if(this._oMobifyCarousel){this._oMobifyCarousel.move(i+1);}}}this.setAssociation("activePage",s,true);return this;};
j.prototype.setHeight=function(o){this.setProperty("height",o,true);this.$().css("height",o);return this;};
j.prototype.setWidth=function(w){this.setProperty("width",w,true);this.$().css("width",w);return this;};
j.prototype.setLoop=function(e){this.setProperty("loop",e,true);if(this._oMobifyCarousel){this._oMobifyCarousel.setLoop(e);}return this;};
j.prototype._getNavigationArrow=function(n){var p={src:"sap-icon://slim-arrow-"+n,useIconTooltip:false};if(n==="left"){if(!this._oArrowLeft){this._oArrowLeft=I.getImageControl(this.getId()+"-arrowScrollLeft",this._oArrowLeft,this,p);}return this._oArrowLeft;}else if(n==="right"){if(!this._oArrowRight){this._oArrowRight=I.getImageControl(this.getId()+"-arrowScrollRight",this._oArrowRight,this,p);}return this._oArrowRight;}};
j.prototype._createScrollContainer=function(p){var i;var s=D.system.desktop&&this.getArrowsPlacement()===g.PageIndicator;if(s){i="sapMCrslImg";}else{i="sapMCrslImgNoArrows";}var k=p.isA("sap.m.Image")?"sapMCrslItemTableCell "+i:"sapMCrslItemTableCell",o=new H({content:"<div class='sapMCrslItemTable'>"+"<div class='"+k+"'></div>"+"</div>",afterRendering:function(e){var r=C.createRenderManager();p.addStyleClass("sapMCrsPage");r.render(p,this.getDomRef().firstChild);r.destroy();p=null;}});var m=new S({horizontal:false,vertical:false,content:[o],width:'100%',height:'100%'});m.setParent(this,null,true);this._aScrollContainers.push(m);return m;};
j.prototype._getErrorPage=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var e=r.getText("CAROUSEL_ERROR_MESSAGE");if(!this.oMessagePage){this.oMessagePage=new M({text:e,description:"",icon:"sap-icon://document",showHeader:false});}return this.oMessagePage;};
j.prototype.previous=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.prev();}else{L.warning("Unable to execute sap.m.Carousel.previous: carousel must be rendered first.");}return this;};
j.prototype.next=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.next();}else{L.warning("Unable to execute sap.m.Carousel.next: carousel must be rendered first.");}return this;};
j.prototype._getPageNumber=function(p){var i,r;for(i=0;i<this.getPages().length;i++){if(this.getPages()[i].getId()==p){r=i;break;}}return r;};
j.prototype.onsaptabprevious=function(e){this._bDirection=false;this._fnOnTabPress(e);};
j.prototype.onsaptabnext=function(e){this._bDirection=true;this._fnOnTabPress(e);};
j.prototype.onfocusin=function(e){this.saveLastFocusReference(e);this._bDirection=undefined;};
j.prototype.onsapskipforward=function(e){e.preventDefault();this._handleGroupNavigation(e,false);};
j.prototype.onsapskipback=function(e){e.preventDefault();this._handleGroupNavigation(e,true);};
j.prototype.onkeydown=function(e){if(e.keyCode==K.F7){this._handleF7Key(e);return;}if(e.target!=this.getDomRef()){return;}switch(e.keyCode){case 189:case K.NUMPAD_MINUS:this._fnSkipToIndex(e,-1);break;case K.PLUS:case K.NUMPAD_PLUS:this._fnSkipToIndex(e,1);break;}};
j.prototype.onsapescape=function(e){var i;if(e.target===this.$()[0]&&this._lastActivePageNumber){i=this._lastActivePageNumber+1;this._oMobifyCarousel.move(i);this._changePage(undefined,i);}};
j.prototype.onsapright=function(e){this._fnSkipToIndex(e,1);};
j.prototype.onsapup=function(e){this._fnSkipToIndex(e,-1);};
j.prototype.onsapleft=function(e){this._fnSkipToIndex(e,-1);};
j.prototype.onsapdown=function(e){this._fnSkipToIndex(e,1);};
j.prototype.onsaphome=function(e){this._fnSkipToIndex(e,0);};
j.prototype.onsapend=function(e){this._fnSkipToIndex(e,this.getPages().length);};
j.prototype.onsaprightmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsapupmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsappageup=function(e){this._fnSkipToIndex(e,j._MODIFIERNUMBERFORKEYBOARDHANDLING);};
j.prototype.onsapleftmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,-j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsapdownmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,-j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsappagedown=function(e){this._fnSkipToIndex(e,-j._MODIFIERNUMBERFORKEYBOARDHANDLING);};
j.prototype._fnOnTabPress=function(e){if(e.target===this.$()[0]){this._lastActivePageNumber=this._getPageNumber(this.getActivePage());}};
j.prototype._handleGroupNavigation=function(e,s){var E=q.Event("keydown");e.preventDefault();this.$().focus();E.target=e.target;E.key='F6';E.shiftKey=s;F.handleF6GroupNavigation(E);};
j.prototype.saveLastFocusReference=function(e){var o=q(e.target).closest(".sapMCrsPage").control(0),s;if(this._bDirection===undefined){return;}if(this._lastFocusablePageElement===undefined){this._lastFocusablePageElement={};}if(o){s=o.getId();this._lastFocusablePageElement[s]=e.target;this._updateFocusedPagesOrder(s);}};
j.prototype._getActivePageLastFocusedElement=function(){if(this._lastFocusablePageElement){return this._lastFocusablePageElement[this._getLastFocusedActivePage()];}};
j.prototype._updateFocusedPagesOrder=function(s){var i=this._aOrderOfFocusedElements.indexOf(s);if(i>-1){this._aOrderOfFocusedElements.splice(0,0,this._aOrderOfFocusedElements.splice(i,1)[0]);}else{this._aOrderOfFocusedElements.unshift(s);}};
j.prototype._updateActivePages=function(n){var N=this._getPageNumber(n),e=this._getNumberOfItemsToShow(),k=N+e,A=this.getPages();if(k>A.length){k=A.length-e;}this._aAllActivePages=[];this._aAllActivePagesIndexes=[];for(var i=N;i<k;i++){this._aAllActivePages.push(A[i].getId());this._aAllActivePagesIndexes.push(i);}};
j.prototype._getLastFocusedActivePage=function(){for(var i=0;i<this._aOrderOfFocusedElements.length;i++){var p=this._aOrderOfFocusedElements[i];if(this._aAllActivePages.indexOf(p)>-1){return p;}}return this.getActivePage();};
j.prototype._fnSkipToIndex=function(e,n){var i=n;if(e.target!==this.getDomRef()){return;}e.preventDefault();if(this._oMobifyCarousel.hasActiveTransition()){this._oMobifyCarousel.onTransitionComplete();}if(n!==0){i=this._getPageNumber(this.getActivePage())+1+n;}this._oMobifyCarousel.move(i);};
j.prototype._handleF7Key=function(e){var A;e.preventDefault();A=this._getActivePageLastFocusedElement();if(e.target===this.$()[0]&&A){A.focus();}else{this.$().focus();}};
j.prototype.setShowBusyIndicator=function(){L.warning("sap.m.Carousel: Deprecated function 'setShowBusyIndicator' called. Does nothing.");return this;};
j.prototype.getShowBusyIndicator=function(){L.warning("sap.m.Carousel: Deprecated function 'getShowBusyIndicator' called. Does nothing.");return false;};
j.prototype.setBusyIndicatorSize=function(s){if(!(s in B)){s=B.Medium;}return a.prototype.setBusyIndicatorSize.call(this,s);};
return j;});
sap.ui.predefine('sap/m/CarouselLayout',["sap/ui/base/ManagedObject"],function(M){"use strict";
var C=M.extend("sap.m.CarouselLayout",{metadata:{library:"sap.m",properties:{visiblePagesCount:{type:"int",group:"Misc",defaultValue:1}}}});
return C;});
sap.ui.predefine('sap/m/CarouselRenderer',["sap/m/library","sap/ui/core/Core","sap/ui/Device"],function(l,C,D){"use strict";var a=l.CarouselArrowsPlacement;var P=l.PlacementType;var r=C.getLibraryResourceBundle('sap.m');var b={};b._BULLETS_TO_NUMBERS_THRESHOLD=9;
b.render=function(c,o){var p=o.getPages(),i=p.length,s=o.getPageIndicatorPlacement(),A=o.getArrowsPlacement(),I=o.getId(),B=b._BULLETS_TO_NUMBERS_THRESHOLD,d=o._getPageNumber(o.getActivePage());this._renderOpeningDiv(c,o);if(s===P.Top){this._renderPageIndicatorAndArrows({rm:c,iPageCount:i,sId:I,iIndex:d,iBulletsToNumbersThreshold:B,sArrowsPlacement:A,bBottom:false,bShowPageIndicator:o.getShowPageIndicator()},o);}this._renderInnerDiv(c,o,p,s);if(D.system.desktop&&i>o._getNumberOfItemsToShow()&&A===a.Content){this._renderHudArrows(c,o);}if(s===P.Bottom){this._renderPageIndicatorAndArrows({rm:c,iPageCount:i,sId:I,iIndex:d,iBulletsToNumbersThreshold:B,sArrowsPlacement:A,bBottom:true,bShowPageIndicator:o.getShowPageIndicator()},o);}this._renderClosingDiv(c);};
b._renderOpeningDiv=function(c,o){var t=o.getTooltip_AsString();c.write("<div");c.writeControlData(o);c.writeAttribute("data-sap-ui-customfastnavgroup","true");c.addStyle("width",o.getWidth());c.addStyle("height",o.getHeight());c.writeStyles();c.addClass("sapMCrsl");c.addClass("sapMCrslFluid");c.writeClasses();if(t){c.writeAttributeEscaped("title",t);}c.writeAttributeEscaped("tabindex","0");c.writeAccessibilityState(o,{role:"list"});c.write(">");};
b._renderInnerDiv=function(c,o,p,s){c.write("<div class='sapMCrslInner");o._cleanUpScrollContainer();if(p.length>1&&(o.getShowPageIndicator()||o.getArrowsPlacement()===a.PageIndicator)){if(s===P.Bottom){c.write(" sapMCrslBottomOffset");if(o.getArrowsPlacement()===a.PageIndicator){c.write(" sapMCrslBottomArrowsOffset");}}else{c.write(" sapMCrslTopOffset");if(o.getArrowsPlacement()===a.PageIndicator){c.write(" sapMCrslTopArrowsOffset");}}}c.write("'>");var R=function(d,i,A){c.write("<div class='sapMCrslItem");c.write("' id='"+o.sId+"-"+d.sId+"-slide'");c.writeAccessibilityState(d,{role:"listitem",posinset:i+1,setsize:A.length});c.write(">");c.renderControl(o._createScrollContainer(d,i));c.write("</div>");};if(p.length!==0){p.forEach(R);}else{c.renderControl(o._getErrorPage());}c.write("</div>");};
b._renderClosingDiv=function(c){c.write('</div>');};
b._renderPageIndicatorAndArrows=function(s,c){var d=s.rm,p=s.iPageCount,S=D.system.desktop&&s.sArrowsPlacement===a.PageIndicator,B=s.bBottom,I=s.sId,e=s.iIndex,f=s.iBulletsToNumbersThreshold,g=s.bShowPageIndicator,h=g?'':'opacity: 0',o="",n=c._getNumberOfItemsToShow(),t=r.getText("CAROUSEL_PAGE_INDICATOR_TEXT",[e+1,p-n+1]),j=1;if(p<=c._getNumberOfItemsToShow()){return;}if(!g&&!S){return;}if(B){o+=" sapMCrslControlsBottom";}else{o+=" sapMCrslControlsTop";}if(S){d.write('<div');d.addClass("sapMCrslControls");d.addClass(o);d.writeClasses();d.write('>');d.write('<div class="sapMCrslControlsContainer'+o+'">');}else{d.write('<div class="sapMCrslControlsNoArrows'+o+'">');}if(S){this._renderPrevArrow(d,c);}var k=I+'-pageIndicator';d.write('<div id="'+k+'" style="'+h+'"');if(p<f){d.write(' class="sapMCrslBulleted">');for(var i=1;i<=p-n+1;i++){d.write("<span role='img' data-slide="+j+" aria-label='"+r.getText('CAROUSEL_POSITION',[i,p])+"'>"+i+"</span>");j++;}}else{d.write(' class="sapMCrslNumeric">');d.write('<span id='+I+'-'+'slide-number>'+t+'</span>');}d.write('</div>');if(S){this._renderNextArrow(d,c);}if(!S){d.write('</div>');}if(S){d.write('</div>');d.write('</div>');}};
b._renderHudArrows=function(c,o){var d;if(o.getShowPageIndicator()){if(o.getPageIndicatorPlacement()===P.Top){d="sapMCrslHudTop";}else if(o.getPageIndicatorPlacement()===P.Bottom){d="sapMCrslHudBottom";}}else{d="sapMCrslHudMiddle";}var h=o.getId()+'-hud';c.write('<div id="'+h+'" class="sapMCrslHud '+d+'">');this._renderPrevArrow(c,o);this._renderNextArrow(c,o);c.write("</div>");};
b._renderPrevArrow=function(c,o){var t=r.getText("PAGINGBUTTON_PREVIOUS");c.write("<a class='sapMCrslPrev' title='"+t+"' href='#' data-slide='prev' tabindex='-1'><div class='sapMCrslArrowInner'>");c.renderControl(o._getNavigationArrow('left'));c.write("</div></a>");};
b._renderNextArrow=function(c,o){var t=r.getText("PAGINGBUTTON_NEXT");c.write("<a class='sapMCrslNext' title='"+t+"' href='#' data-slide='next' tabindex='-1'><div class='sapMCrslArrowInner'>");c.renderControl(o._getNavigationArrow('right'));c.write("</div></a>");};
return b;},true);
sap.ui.predefine('sap/m/CheckBox',['./Label','./library','sap/ui/Device','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/EnabledPropagator','sap/ui/core/library','./CheckBoxRenderer',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes",'sap/ui/core/LabelEnablement'],function(L,l,D,C,I,E,c,a,q,K,b){"use strict";var V=c.ValueState;var T=c.TextAlign;var d=c.TextDirection;
var e=C.extend("sap.m.CheckBox",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{selected:{type:"boolean",group:"Data",defaultValue:false},partiallySelected:{type:"boolean",group:"Data",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Misc",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{_label:{type:"sap.m.Label",group:"Behavior",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selected:{type:"boolean"}}}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/CheckBox.designtime"}});
E.call(e.prototype);
e.prototype.init=function(){this.addActiveState(this);I.insertFontFaceStyle();this._handleReferencingLabels();};
e.prototype.exit=function(){this._oLabel=null;delete this._iTabIndex;};
e.prototype.setText=function(t){var o=this._getLabel();this.setProperty("text",t);o.setText(t);return this;};
e.prototype.setWidth=function(w){this.setProperty("width",w,true);this._setWidth();return this;};
e.prototype.setUseEntireWidth=function(u){this.setProperty("useEntireWidth",u,true);this._setWidth();return this;};
e.prototype.setTextDirection=function(s){var o=this._getLabel();this.setProperty("textDirection",s);o.setTextDirection(s);return this;};
e.prototype.setTextAlign=function(A){var o=this._getLabel();this.setProperty("textAlign",A);o.setTextAlign(A);return this;};
e.prototype.setWrapping=function(w){var o=this._getLabel();this.setProperty("wrapping",w);o.setWrapping(w);return this;};
e.prototype.addActiveState=function(o){if(D.os.blackberry){o.addDelegate({ontouchstart:function(f){q(o.getDomRef()).addClass("sapMActive");},ontouchend:function(f){q(o.getDomRef()).removeClass("sapMActive");}});}};
e.prototype.ontouchstart=function(o){o.originalEvent._sapui_handledByControl=true;};
e.prototype.ontap=function(o){var s;if(this.getEnabled()&&this.getEditable()&&!this.getDisplayOnly()){this.$().focus();s=this._getSelectedState();this.setSelected(s);this.setPartiallySelected(false);this.fireSelect({selected:s});o&&o.setMarked();}};
e.prototype.onkeyup=function(o){if(o&&o.which===K.SPACE&&!o.shiftKey){this.ontap(o);o.preventDefault();o.stopPropagation();}};
e.prototype.onsapspace=function(o){o.preventDefault();};
e.prototype.onsapenter=function(o){this.ontap(o);};
e.prototype.setTabIndex=function(t){this._iTabIndex=t;this.$("CbBg").attr("tabindex",t);return this;};
e.prototype.getTabIndex=function(){if(this.hasOwnProperty("_iTabIndex")){return this._iTabIndex;}return(this.getEnabled()&&!this.getDisplayOnly())?0:-1;};
e.prototype._getLabel=function(){if(!this._oLabel){this._oLabel=new L(this.getId()+"-label",{labelFor:this.getId()}).addStyleClass("sapMCbLabel");this.setAggregation("_label",this._oLabel,true);}return this.getAggregation("_label");};
e.prototype._setWidth=function(){var o=this._getLabel(),$=this.$(),w=this.getWidth();if(this.getUseEntireWidth()){o.setWidth("");$.outerWidth(w);}else{$.outerWidth("");o.setWidth(w);}};
e.prototype._getSelectedState=function(){var s=this.getSelected(),p=this.getPartiallySelected();return(s===p)||(!s&&p);};
e.prototype._getAriaChecked=function(){var s=this.getSelected();if(this.getPartiallySelected()&&s){return"mixed";}return s;};
e.prototype._fnLabelTapHandler=function(){this.$().focus();};
e.prototype._handleReferencingLabels=function(){var f=b.getReferencingLabels(this),t=this;if(f.length>0){f.forEach(function(s){sap.ui.getCore().byId(s).addEventDelegate({ontap:function(){t._fnLabelTapHandler();}});});}};
e.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"checkbox",type:B.getText("ACC_CTR_TYPE_CHECKBOX"),description:(this.getText()||"")+(this.getSelected()?(" "+B.getText("ACC_CTR_STATE_CHECKED")):""),focusable:this.getEnabled()&&!this.getDisplayOnly(),enabled:this.getEnabled(),editable:this.getEditable()};};
e.prototype.getFormDoNotAdjustWidth=function(){return this.getText()?false:true;};
return e;});
sap.ui.predefine('sap/m/CheckBoxRenderer',['sap/ui/core/library','sap/ui/core/ValueStateSupport','sap/ui/Device'],function(c,V,D){"use strict";var a=c.ValueState;var C={apiVersion:2};
C.render=function(r,o){var i=o.getId(),e=o.getEnabled(),d=o.getDisplayOnly(),E=o.getEditable(),I=e&&!d,b=e&&d,f=o.getAggregation("_label"),v=o.getValueState(),g=a.Error===v,h=a.Warning===v,j=a.Success===v,k=a.Information===v,u=o.getUseEntireWidth();r.openStart("div",o);r.class("sapMCb");if(!E){r.class("sapMCbRo");}if(b){r.class("sapMCbDisplayOnly");}if(!e){r.class("sapMCbBgDis");}if(o.getText()){r.class("sapMCbHasLabel");}if(o.getWrapping()){r.class("sapMCbWrapped");}if(g){r.class("sapMCbErr");}else if(h){r.class("sapMCbWarn");}else if(j){r.class("sapMCbSucc");}else if(k){r.class("sapMCbInfo");}if(u){r.style("width",o.getWidth());}var t=V.enrichTooltip(o,o.getTooltip_AsString());if(t){r.attr("title",t);}if(I){r.attr("tabindex",o.getTabIndex());}r.accessibilityState(o,{role:"checkbox",selected:null,checked:o._getAriaChecked(),describedby:t?i+"-Descr":undefined});if(b){r.attr("aria-readonly",true);}r.openEnd();r.openStart("div",o.getId()+"-CbBg");r.class("sapMCbBg");if(I&&E&&D.system.desktop){r.class("sapMCbHoverable");}if(!o.getActiveHandling()){r.class("sapMCbActiveStateOff");}r.class("sapMCbMark");if(o.getSelected()){r.class("sapMCbMarkChecked");}if(o.getPartiallySelected()){r.class("sapMCbMarkPartiallyChecked");}r.openEnd();r.voidStart("input",o.getId()+"-CB");r.attr("type","CheckBox");if(o.getSelected()){r.attr("checked","checked");}if(o.getName()){r.attr("name",o.getName());}if(!e){r.attr("disabled","disabled");}if(!E){r.attr("readonly","readonly");}r.voidEnd();r.close("div");r.renderControl(f);if(t&&sap.ui.getCore().getConfiguration().getAccessibility()){r.openStart("span",i+"-Descr");r.class("sapUiHidden");r.openEnd();r.text(t);r.close("span");}r.close("div");};
return C;},true);
sap.ui.predefine('sap/m/ColorPalette',['sap/ui/core/Control','sap/ui/Device','sap/ui/base/DataType','sap/ui/core/library','sap/ui/core/delegate/ItemNavigation','./Button','./Dialog','./library','./ColorPaletteRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/unified/ColorPickerDisplayMode"],function(C,D,a,c,I,B,b,l,d,e,K,q,f){"use strict";var g=c.CSSColor;var h;var i;var j=l.ButtonType;var k=a.getType("boolean");var m="sapMColorPaletteSquare";var S=5;var M=2;var n=15;var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var o=C.extend("sap.m.ColorPalette",{metadata:{library:"sap.m",properties:{colors:{type:"sap.ui.core.CSSColor[]",group:"Appearance",defaultValue:["gold","darkorange","indianred","darkmagenta","cornflowerblue","deepskyblue","darkcyan","olivedrab","darkslategray","azure","white","lightgray","darkgray","dimgray","black"]}},aggregations:{_defaultColorButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_moreColorsButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{colorSelect:{parameters:{"value":{type:"sap.ui.core.CSSColor"},"defaultAction":{type:"boolean"}}}}}});
o.prototype.init=function(){this._oDefaultColor=null;this._bShowDefaultColorButton=false;this._bShowMoreColorsButton=false;this._oDisplayMode=f.Default;this._oMoreColorsDialog=null;this._oItemNavigation=null;};
o.prototype.exit=function(){if(this._oMoreColorsDialog){this._oMoreColorsDialog.destroy();delete this._oMoreColorsDialog;}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
o.prototype.setColors=function(r){r=this.validateProperty("colors",r);if(r.length<M||r.length>n){throw new Error("Cannot set property 'colors' - array must has minimum 2 and maximum 15 elements");}return this.setProperty("colors",r);};
o.prototype._setDisplayMode=function(r){var s=this._getColorPicker();s.setDisplayMode(r);this._oDisplayMode=r;return this;};
o.prototype._getDisplayMode=function(){return this._oDisplayMode;};
o.prototype._getColorPicker=function(){return this._ensureMoreColorsDialog()._oColorPicker;};
o.prototype.ontap=function(E){var t=q(E.target),s,$;$=t.closest("."+m);if(!$.length){return;}s=$.attr("data-sap-ui-color");this._fireColorSelect(s,false,E);};
o.prototype.onsaptabnext=o.prototype.onsaptabprevious=function(E){var r=this._getElementInfo(E.target);if(r.bIsMoreColorsButton){this.fireEvent("_colorNotSelected",{_originalEvent:E});return;}if(r.bIsDefaultColorButton){this._fireColorSelect(this._getDefaultColor(),true,E);return;}o.prototype.ontap.apply(this,arguments);};o.prototype.onsapenter=o.prototype.ontap;
o.prototype.onsapspace=function(E){E.preventDefault();};
o.prototype.onkeyup=function(E){if(E.which===K.SPACE){E.preventDefault();o.prototype.ontap.apply(this,arguments);}};
o.prototype.onsaphome=o.prototype.onsapend=function(E){var r=this._getElementInfo(E.target);if(r.bIsDefaultColorButton||r.bIsMoreColorsButton){E.preventDefault();E.stopImmediatePropagation(true);}};
o.prototype.onAfterRendering=function(){this._ensureItemNavigation();};
o.prototype._createDefaultColorButton=function(){return new B(this.getId()+"-btnDefaultColor",{width:"100%",type:j.Transparent,text:L.getText("COLOR_PALETTE_DEFAULT_COLOR"),visible:this._getShowDefaultColorButton(),press:function(E){this._fireColorSelect(this._getDefaultColor(),true,E);}.bind(this)});};
o.prototype._getDefaultColor=function(){return this._oDefaultColor;};
o.prototype._setDefaultColor=function(r){if(!g.isValid(r)){throw new Error("Cannot set internal property '_defaultColor' - invalid value: "+r);}this._oDefaultColor=r;return this;};
o.prototype._getShowDefaultColorButton=function(){return this._bShowDefaultColorButton;};
o.prototype._setShowDefaultColorButton=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showDefaultColorButton' - invalid value: "+v);}this._bShowDefaultColorButton=v;if(v&&!this._getDefaultColorButton()){this.setAggregation("_defaultColorButton",this._createDefaultColorButton());}if(this._getDefaultColorButton()){this._getDefaultColorButton().setVisible(v);}return this;};
o.prototype._getDefaultColorButton=function(){return this.getAggregation("_defaultColorButton");};
o.prototype._createMoreColorsButton=function(){return new B(this.getId()+"-btnMoreColors",{width:"100%",type:j.Transparent,text:L.getText("COLOR_PALETTE_MORE_COLORS"),visible:this._getShowMoreColorsButton(),press:this._openColorPicker.bind(this)});};
o.prototype._getShowMoreColorsButton=function(){return this._bShowMoreColorsButton;};
o.prototype._setShowMoreColorsButton=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showMoreColorsButton' - invalid value: "+v);}this._bShowMoreColorsButton=v;if(v&&!this._getMoreColorsButton()){this.setAggregation("_moreColorsButton",this._createMoreColorsButton());}if(this._getMoreColorsButton()){this._getMoreColorsButton().setVisible(v);}return this;};
o.prototype._getMoreColorsButton=function(){return this.getAggregation("_moreColorsButton");};
o.prototype._openColorPicker=function(){this.fireEvent("_beforeOpenColorPicker");this._ensureMoreColorsDialog().open();};
o.prototype._ensureMoreColorsDialog=function(){if(!this._oMoreColorsDialog){this._oMoreColorsDialog=this._createMoreColorsDialog();}return this._oMoreColorsDialog;};
o.prototype._createMoreColorsDialog=function(){var r=new b(this.getId()+"-moreColorsDialog",{stretch:!!D.system.phone,title:L.getText("COLOR_PALETTE_MORE_COLORS_TITLE")}).addStyleClass("CPDialog");this._ensureUnifiedLibrary();r.addContent(r._oColorPicker=new h({mode:i.HSL,displayMode:this._oDisplayMode}));r.setBeginButton(new B({text:L.getText("COLOR_PALETTE_MORE_COLORS_CONFIRM"),press:function(E){r.close();if(r._oColorPicker.getColorString()){this._fireColorSelect(r._oColorPicker.getColorString(),false,E);}}.bind(this)}));r.setEndButton(new B({text:L.getText("COLOR_PALETTE_MORE_COLORS_CANCEL"),press:function(){r.close();}}));return r;};
o.prototype._ensureUnifiedLibrary=function(){var u;if(!h){sap.ui.getCore().loadLibrary("sap.ui.unified");u=sap.ui.require("sap/ui/unified/library");h=sap.ui.requireSync("sap/ui/unified/ColorPicker");i=u.ColorPickerMode;}};
o.prototype._focusFirstElement=function(){var F=this._getShowDefaultColorButton()?this._getDefaultColorButton().getDomRef():this._getAllSwatches()[0];F.focus();};
o.prototype._fireColorSelect=function(r,s,O){this.fireColorSelect({value:r,defaultAction:s,_originalEvent:O});};
o.prototype._ensureItemNavigation=function(){var r=[];if(!this._oItemNavigation){this._oItemNavigation=new p(this);this._oItemNavigation.setColumns(S);this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._onSwatchContainerBorderReached,this);}r=r.concat(this._getAllSwatches());this._oItemNavigation.setRootDomRef(this.getDomRef("swatchCont"));this._oItemNavigation.setItemDomRefs(r);};
o.prototype._onSwatchContainerBorderReached=function(E){var N,s,H=["saphome","sapend"].indexOf(E.getParameter("event").type)>-1;if(E.getParameter(p.BorderReachedDirection)===p.BorderReachedDirectionForward){if(this._getShowMoreColorsButton()){N=this._getMoreColorsButton();}else if(!H&&this._getShowDefaultColorButton()){N=this._getDefaultColorButton();}else if(!H){N=this._getAllSwatches()[0];}}else{if(this._getShowDefaultColorButton()){N=this._getDefaultColorButton();}else if(!H&&this._getShowMoreColorsButton()){N=this._getMoreColorsButton();}else if(!H&&!this._getShowDefaultColorButton()){s=this._getAllSwatches();N=s[s.length-1];}else if(!H){s=this._getAllSwatches();N=s[this._oItemNavigation._getIndexOfTheFirstItemInLastRow()];}}if(N){N.focus();}return N;};
o.prototype.onsapnext=function(E){var N,r=this._getElementInfo(E.target);if(!(r.bIsDefaultColorButton||r.bIsMoreColorsButton)){return;}E.preventDefault();E.stopImmediatePropagation(true);if(r.bIsDefaultColorButton){N=this._getAllSwatches()[0];}else{N=this._getShowDefaultColorButton()?this._getDefaultColorButton():this._getAllSwatches()[0];}N.focus();};
o.prototype.onsapprevious=function(E){var N,F=this._getElementInfo(E.target),A;if(!(F.bIsDefaultColorButton||F.bIsMoreColorsButton)){return;}E.preventDefault();E.stopImmediatePropagation(true);A=this._getAllSwatches();if(F.bIsMoreColorsButton){N=E.keyCode===K.ARROW_UP?A[this._oItemNavigation._getIndexOfTheFirstItemInLastRow()]:A[A.length-1];}else{N=this._getShowMoreColorsButton()?this._getMoreColorsButton():A[this._oItemNavigation._getIndexOfTheFirstItemInLastRow()];}N.focus();};
o.prototype._getAllSwatches=function(){return this.$().find("."+m).get();};
o.prototype._getElementInfo=function(E){var r=this._getShowDefaultColorButton()&&e(E,this._getDefaultColorButton().getDomRef()),s=!r&&this._getShowMoreColorsButton()&&e(E,this._getMoreColorsButton().getDomRef()),t=!s&&!r&&q(E).hasClass(m);return{bIsDefaultColorButton:r,bIsMoreColorsButton:s,bIsASwatch:t};};
var p=I.extend("sap.m.ItemNavigationHomeEnd",{constructor:function(){I.apply(this,arguments);this.setHomeEndColumnMode(true);this.fireEvent=function(N,E){var s;if(N===I.Events.BorderReached){s=p.BorderReachedDirectionBackward;if(["sapnext","sapend"].indexOf(E.event.type)>-1){s=p.BorderReachedDirectionForward;}E[p.BorderReachedDirection]=s;}I.prototype.fireEvent.apply(this,arguments);};}});
p.BorderReachedDirection="direction";p.BorderReachedDirectionForward="BorderReachedDirectionForward";p.BorderReachedDirectionBackward="BorderReachedDirectionBackward";
p.prototype.getColumns=function(){return this.iColumns;};
p.prototype.onsapprevious=function(E){var r=e(this.getRootDomRef(),E.target),A=E.keyCode===K.ARROW_UP&&this.getFocusedIndex()===0;if(!r){return;}if(!A){I.prototype.onsapprevious.apply(this,arguments);return;}E.preventDefault();this.fireEvent(I.Events.BorderReached,{index:0,event:E});};
p.prototype.onsapnext=function(E){var r=e(this.getRootDomRef(),E.target),s,t,u;if(!r){return;}if(E.keyCode!==K.ARROW_DOWN){I.prototype.onsapnext.apply(this,arguments);return;}t=this.getFocusedIndex();u=this._getItemInfo(t);if(u.bIsLastItem&&u.bIsInTheLastColumn){E.preventDefault();this.fireEvent(I.Events.BorderReached,{index:t,event:E});return;}if(u.bNextRowExists&&!u.bItemSameColumnNextRowExists){E.preventDefault();s=this.getItemDomRefs();s[s.length-1].focus();return;}I.prototype.onsapnext.apply(this,arguments);};
p.prototype.onsaphome=function(E){var r=e(this.getRootDomRef(),E.target),s;if(!r){return;}s=this._getItemInfo(this.getFocusedIndex());if(!s.bIsInTheFirstColumn){I.prototype.onsaphome.apply(this,arguments);return;}E.preventDefault();if(s.bIsFirstItem){this.fireEvent(I.Events.BorderReached,{index:0,event:E});}else{this.getItemDomRefs()[0].focus();}};
p.prototype.onsapend=function(E){var r=e(this.getRootDomRef(),E.target),s;if(!r){return;}s=this._getItemInfo(this.getFocusedIndex());if(!(s.bIsLastItem||s.bIsInTheLastColumn)){I.prototype.onsapend.apply(this,arguments);return;}E.preventDefault();if(s.bIsLastItem){this.fireEvent(I.Events.BorderReached,{index:this.getItemDomRefs().length-1,event:E});}else{this.getItemDomRefs()[this.getItemDomRefs().length-1].focus();}};
p.prototype._getItemInfo=function(r){var s=this.getItemDomRefs().length,t=r===(s-1),u=s>this.getColumns()?this.getColumns():s,v=r%this.getColumns()===0,w=(r+1)%u===0,x=Math.floor(r/this.getColumns())+1,N,y;N=x*this.getColumns()<s;y=N&&(r+this.getColumns())<s;return{bIsFirstItem:r===0,bIsLastItem:t,bIsInTheLastColumn:w,bIsInTheFirstColumn:v,bNextRowExists:N,bItemSameColumnNextRowExists:y};};
p.prototype._getIndexOfTheFirstItemInLastRow=function(){return Math.floor((this.getItemDomRefs().length-1)/this.getColumns())*this.getColumns();};
o.prototype._ItemNavigation=p;o.prototype._ColorsHelper={RGB_TO_NAMED_COLORS_MAP:{"#FFB200":"gold","#FF8C00":"darkorange","#CD5C5C":"indianred","#8B008B":"darkmagenta","#6495ED":"cornflowerblue","#00BFFF":"deepskyblue","#008B8B":"darkcyan","#6B8E23":"olivedrab","#2F4F4F":"darkslategray","#F0FFFF":"azure","#FFFFFF":"white","#D3D3D3":"lightgray","#A9A9A9":"darkgray","#696969":"dimgray","#000000":"black"},NAME_COLORS_TO_RGB_MAP:{"gold":"#FFB200","darkorange":"#FF8C00","indianred":"#CD5C5C","darkmagenta":"#8B008B","cornflowerblue":"#6495ED","deepskyblue":"#00BFFF","darkcyan":"#008B8B","olivedrab":"#6B8E23","darkslategray":"#2F4F4F","azure":"#F0FFFF","white":"#FFFFFF","lightgray":"#D3D3D3","darkgray":"#A9A9A9","dimgray":"#696969","black":"#000000"},getNamedColor:function(s){var H="";if(!s||s.toLowerCase().indexOf("hsl")!==-1){return undefined;}if(s.indexOf("#")===-1){return this.NAME_COLORS_TO_RGB_MAP[s.toLowerCase()]?s.toLowerCase():undefined;}if(s.length===4){H=["#",s[1],s[1],s[2],s[2],s[3],s[3]].join("");}else{H=s;}H=H.toUpperCase();return this.RGB_TO_NAMED_COLORS_MAP[H];}};return o;});
sap.ui.predefine('sap/m/ColorPalettePopover',['sap/ui/core/Control','sap/ui/Device','sap/ui/unified/ColorPickerDisplayMode','./Button','./ResponsivePopover','./ColorPalette','./library'],function(C,D,a,B,R,b,l){"use strict";var P=l.PlacementType;
var c=C.extend("sap.m.ColorPalettePopover",{
metadata:{library:"sap.m",publicMethods:["openBy","close"],properties:{defaultColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},colors:{type:"sap.ui.core.CSSColor[]",group:"Appearance",defaultValue:["gold","darkorange","indianred","darkmagenta","cornflowerblue","deepskyblue","darkcyan","olivedrab","darkslategray","azure","white","lightgray","darkgray","dimgray","black"]},showDefaultColorButton:{type:"boolean",group:"Appearance",defaultValue:true},showMoreColorsButton:{type:"boolean",group:"Appearance",defaultValue:true},displayMode:{type:"sap.ui.unified.ColorPickerDisplayMode",group:"Appearance",defaultValue:a.Default}},events:{colorSelect:{parameters:{"value":{type:"sap.ui.core.CSSColor"},"defaultAction":{type:"boolean"}}}}},
renderer:{}
});
var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");var F={COLOR_PALETTE_PROPS:{colors:"setColors",defaultColor:"_setDefaultColor",showDefaultColorButton:"_setShowDefaultColorButton",showMoreColorsButton:"_setShowMoreColorsButton",displayMode:"_setDisplayMode"},POPOVER_METHODS:{getDomRef:"",close:"",openBy:""}};
c.prototype.init=function(){this._oPopover=null;this._bPopoverDestroying=null;};
c.prototype.exit=function(){this._bPopoverDestroying=true;if(this._oPopover){this._oPopover.removeDelegate(this._oPopover._onAfterRenderingDelegate);this._oPopover.destroy();this._oPopover=null;}};
c.prototype._getPalette=function(){return this._ensurePopover().getContent()[0];};
c.prototype._ensurePopover=function(){if(!this._oPopover){this._oPopover=this._createPopover();}return this._oPopover;};
c.prototype._createPopover=function(){var p,o=this._createColorPalette(),d;p=new R(this.getId()+"-colorPalettePopover",{showHeader:D.system.phone,placement:P.VerticalPreferredBottom,showArrow:false,showCloseButton:false,title:L.getText("COLOR_PALETTE_TITLE"),content:o,afterOpen:o._focusFirstElement.bind(o)}).addStyleClass("sapMColorPaletteContainer");if(D.system.phone){p.setEndButton(new B({text:L.getText("COLOR_PALETTE_CANCEL"),press:function(){p.close();}}));}o.attachEvent("_beforeOpenColorPicker",function(){p.close();});o.attachEvent("_colorNotSelected",function(e){this._handleNextOrPreviousUponPaletteClose(e);p.close();}.bind(this));o.attachEvent("colorSelect",function(e){this._handleNextOrPreviousUponPaletteClose(e);p.close();this.fireColorSelect({"value":e.getParameter("value"),"defaultAction":e.getParameter("defaultAction")});}.bind(this));d={onAfterRendering:function(){var $=this.$();$.attr("aria-modal","true");$.attr("aria-label",this.getTitle());}};p.addEventDelegate(d,p);p._onAfterRenderingDelegate=d;return p;};
c.prototype._createColorPalette=function(){var o=new b(this.getId()+"-palette");o._setShowDefaultColorButton(this.getShowDefaultColorButton());o._setShowMoreColorsButton(this.getShowMoreColorsButton());return o;};
c.prototype._handleNextOrPreviousUponPaletteClose=function(e){var o=e.getParameter("_originalEvent");if(!o){return;}if(o.type==="saptabnext"||o.type==="saptabprevious"){o.stopPropagation();o.preventDefault();}};
c.prototype.setProperty=function(p,v,s){var t;if(F.COLOR_PALETTE_PROPS[p]!==undefined){t=F.COLOR_PALETTE_PROPS[p]||p;b.prototype[t].call(this._getPalette(),v);}return C.prototype.setProperty.apply(this,arguments);};
Object.keys(F.POPOVER_METHODS).forEach(function(s){var t=F.COLOR_PALETTE_PROPS[s]||s;c.prototype[s]=function(){if(this._bPopoverDestroying){return null;}var p=this._ensurePopover();return p[t].apply(p,arguments);};});return c;});
sap.ui.predefine('sap/m/ColorPaletteRenderer',['sap/ui/Device'],function(D){"use strict";var C={};var l=sap.ui.getCore().getLibraryResourceBundle("sap.m");
C.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMColorPalette");r.writeClasses();r.write(">");if(c._getShowDefaultColorButton()){this.renderDefaultColorButton(r,c);this.renderSeparator(r);}this.renderSwatches(r,c);if(c._getShowMoreColorsButton()){this.renderSeparator(r);this.renderMoreColorsButton(r,c);if(D.system.phone){this.renderSeparator(r);}}r.write("</div>");};
C.renderSwatches=function(r,c){var s=c.getColors();r.write("<div id='"+c.getId()+"-swatchCont'");r.addClass("sapMColorPaletteContent");r.writeClasses();r.writeAccessibilityState(c,{"role":"region","label":l.getText("COLOR_PALETTE_SWATCH_CONTAINER_TITLE")});r.write(">");s.forEach(function(a,i){this.renderSquare(r,c,a,i);},this);r.write("</div>");};
C.renderSquare=function(r,c,s,i){var n=c._ColorsHelper.getNamedColor(s),a=(n===undefined)?l.getText("COLOR_PALETTE_PREDEFINED_COLOR_CUSTOM"):l.getText("COLOR_PALETTE_PREDEFINED_COLOR_"+n.toUpperCase()),b=l.getText("COLOR_PALETTE_PREDEFINED_COLOR",[i+1,a]);r.write("<div");r.addClass("sapMColorPaletteSquare");r.writeClasses();r.writeAttribute("data-sap-ui-color",s);r.writeAttribute("tabindex","-1");r.writeAttribute("title",b);r.writeAccessibilityState(c,{"role":"button","label":b});r.write(">");r.write("<div");r.addStyle("background-color",s);r.writeStyles();r.write("></div>");r.write("</div>");};
C.renderSeparator=function(r){r.write("<div");r.addClass("sapMColorPaletteSeparator");r.writeClasses();r.write(">");r.write("<hr/>");r.write("</div>");};
C.renderDefaultColorButton=function(r,c){r.renderControl(c._getDefaultColorButton());};
C.renderMoreColorsButton=function(r,c){r.renderControl(c._getMoreColorsButton());};
return C;},true);
sap.ui.predefine('sap/m/Column',['./library','sap/ui/core/Element','sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device',"sap/ui/thirdparty/jquery"],function(l,E,R,c,D,q){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var T=c.TextAlign;var S=c.SortOrder;
var C=E.extend("sap.m.Column",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},hAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit},styleClass:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},minScreenWidth:{type:"string",group:"Behavior",defaultValue:null},demandPopin:{type:"boolean",group:"Behavior",defaultValue:false},popinHAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin,deprecated:true},popinDisplay:{type:"sap.m.PopinDisplay",group:"Appearance",defaultValue:P.Block},mergeDuplicates:{type:"boolean",group:"Behavior",defaultValue:false},mergeFunctionName:{type:"string",group:"Misc",defaultValue:'getText'},sortIndicator:{type:"sap.ui.core.SortOrder",group:"Appearance",defaultValue:S.None}},defaultAggregation:"header",aggregations:{header:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/m/designtime/Column.designtime"}});
C.prototype._index=-1;C.prototype._screen="";C.prototype._media=null;C.prototype._bForcedColumn=false;
C.prototype.exit=function(){this._clearMedia();};
C.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
C.prototype.informTable=function(e,p,v){var t=this.getTable();if(t){var m="onColumn"+e;if(t[m]){t[m](this,p,v);}}};
C.prototype.ontouchstart=function(e){this._bTouchStartMarked=e.isMarked();};
C.prototype.ontap=function(e){if(!this._bTouchStartMarked&&!e.isMarked()){this.informTable("Press");}};
C.prototype.onsapspace=function(e){if(e.srcControl===this){this.informTable("Press");e.preventDefault();}};
C.prototype.onsapenter=C.prototype.onsapspace;
C.prototype.invalidate=function(){var p=this.getParent();if(!p||!p.bOutput){return;}E.prototype.invalidate.apply(this,arguments);};
C.prototype._clearMedia=function(){if(this._media&&this._minWidth){this._detachMediaContainerWidthChange(this._notifyResize,this,this.getId());D.media.removeRangeSet(this.getId());this._media=null;}};
C.prototype._addMedia=function(){delete this._bShouldAddMedia;if(this._minWidth){D.media.initRangeSet(this.getId(),[parseFloat(this._minWidth)]);this._attachMediaContainerWidthChange(this._notifyResize,this,this.getId());this._media=this._getCurrentMediaContainerRange(this.getId());if(this._media){this._media.matches=!!this._media.from;}}};
C.prototype._notifyResize=function(m){if(this._media.from===m.from){return;}this._media=m;this._media.matches=!!m.from;setTimeout(function(){this.fireEvent("media",this);this.informTable("Resize");}.bind(this),0);};
C.prototype._validateMinWidth=function(w){if(!w){return;}if(Object.prototype.toString.call(w)!="[object String]"){throw new Error('expected string for property "minScreenWidth" of '+this);}if(Object.keys(l.ScreenSizes).indexOf(w.toLowerCase())!=-1){return;}if(!/^\d+(\.\d+)?(px|em|rem)$/i.test(w)){throw new Error('invalid CSS size("px", "em", "rem" required) or sap.m.ScreenSize enumeration for property "minScreenWidth" of '+this);}};
C.prototype._isWidthPredefined=function(w){var t=this,u=w.replace(/[^a-z]/ig,""),b=parseFloat(l.BaseFontSize)||16;q.each(l.ScreenSizes,function(s,a){if(u!="px"){a/=b;}if(a+u==w){t._minWidth=this+"px";t._screen=s;return false;}});if(this._minWidth){return true;}if(u=="px"){this._minWidth=w;}else{this._minWidth=parseFloat(w)*b+"px";}};
C.prototype.getCssAlign=function(a){a=a||this.getHAlign();if(a===T.Begin||a===T.End||a===T.Initial){a=R.getTextAlign(a);}return a.toLowerCase();};
C.prototype.getStyleClass=function(r){var a=this.getProperty("styleClass");if(!r){return a;}if(this._screen&&(!this.getDemandPopin()||!window.matchMedia)){a+=" sapMSize-"+this._screen;}else if(this._media&&!this._media.matches){a+=" sapMListTblNone";}return a.trim();};
C.prototype.setIndex=function(n){this._index=+n;};
C.prototype.setOrder=function(n){this._order=+n;};
C.prototype.getOrder=function(){return this.hasOwnProperty("_order")?this._order:this.getInitialOrder();};
C.prototype.setInitialOrder=function(n){this._initialOrder=+n;};
C.prototype.getInitialOrder=function(){if(this.hasOwnProperty("_initialOrder")){return this._initialOrder;}var t=this.getTable();if(!t){return-1;}return t.indexOfColumn(this);};
C.prototype.setDisplay=function(t,d){if(!t||this._index<0){return;}var i=this._index+1,p=this.getParent(),a=d?"table-cell":"none",h=t.querySelector("tr > th:nth-child("+i+")"),b=t.querySelectorAll("tr > td:nth-child("+i+")"),e=b.length;h.style.display=a;h.setAttribute("aria-hidden",!d);for(i=0;i<e;i++){b[i].style.display=a;b[i].setAttribute("aria-hidden",!d);}if(p&&p.setTableHeaderVisibility){setTimeout(function(){p.setTableHeaderVisibility(d);},0);}};
C.prototype.setDisplayViaMedia=function(t){var p=this.getParent(),d=this._media&&this._media.matches;if(!this.getDemandPopin()&&this._screen&&p&&p.setTableHeaderVisibility){setTimeout(function(){p.setTableHeaderVisibility(d);},0);}else{this.setDisplay(t,d);}};
C.prototype.setVisible=function(v){if(v==this.getVisible()){return this;}var p=this.getParent(),t=p&&p.getTableDomRef&&p.getTableDomRef(),s=t&&this._index>=0;this.setProperty("visible",v,s);if(s){this.setDisplay(t,v);}return this;};
C.prototype._setMinScreenWidth=function(w){this._clearMedia();this._minWidth=0;this._screen="";if(w){w=w.toLowerCase();var a=l.ScreenSizes[w];if(a){this._screen=w;this._minWidth=a+"px";}else{this._isWidthPredefined(w);}var p=this.getTable();if(p&&p.isActive()){this._addMedia();}else{this._bShouldAddMedia=true;}}};
C.prototype.setMinScreenWidth=function(w){if(w==this.getMinScreenWidth()){return this;}this._validateMinWidth(w);this._setMinScreenWidth(w);return this.setProperty("minScreenWidth",w);};
C.prototype.setDemandPopin=function(v){if(v==this.getDemandPopin()){return this;}if(!this.getMinScreenWidth()){return this.setProperty("demandPopin",v,true);}return this.setProperty("demandPopin",v);};
C.prototype.setSortIndicator=function(s){this.setProperty("sortIndicator",s,true);this.$().attr("aria-sort",this.getSortIndicator().toLowerCase());return this;};
C.prototype.isPopin=function(){if(!this.getDemandPopin()){return false;}if(this._media){return!this._media.matches;}return false;};
C.prototype.isHidden=function(){if(this._media){return!this._media.matches;}if(this._screen&&this._minWidth){return parseFloat(this._minWidth)>window.innerWidth;}return false;};
C.prototype.setLastValue=function(v){if(this.getMergeDuplicates()){this._lastValue=v;}return this;};
C.prototype.clearLastValue=function(){return this.setLastValue(NaN);};
C.prototype.getLastValue=function(){return this._lastValue;};
C.prototype.onItemsRemoved=function(){this.clearLastValue();};
C.prototype.getFocusDomRef=function(){var p=this.getParent();if(p&&p.bActiveHeaders){var o=this.getDomRef();if(o){return o.firstChild;}}return E.prototype.getFocusDomRef.apply(this,arguments);};
C.prototype.getCalculatedMinScreenWidth=function(){return parseInt(this._minWidth)||0;};
C.prototype.setForcedColumn=function(f){if(this._bForcedColumn==f){return;}this._bForcedColumn=f;this._setMinScreenWidth(f?"":this.getMinScreenWidth());};
return C;});
sap.ui.predefine('sap/m/ColumnListItem',["sap/ui/core/Element","sap/ui/core/library","./library","./ListItemBase","./ColumnListItemRenderer","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(E,c,l,L,C,q){"use strict";var a=l.ListType;var V=c.VerticalAlign;
var b=L.extend("sap.m.ColumnListItem",{metadata:{library:"sap.m",properties:{vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit}},defaultAggregation:"cells",aggregations:{cells:{type:"sap.ui.core.Control",multiple:true,singularName:"cell",bindable:"bindable"}}}});
var T=E.extend("sap.m.TablePopin",{ontap:function(e){if(e.isMarked()||L.detectTextSelection(this.getDomRef())){return e.stopImmediatePropagation(true);}if(e.srcControl===this||!q(e.target).is(":sapFocusable")){this.getParent().focus();}}});
b.prototype.TagName="tr";
b.prototype.init=function(){L.prototype.init.call(this);this._bNeedsTypeColumn=false;this._aClonedHeaders=[];};
b.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this._checkTypeColumn();};
b.prototype.exit=function(){L.prototype.exit.call(this);this._checkTypeColumn(false);this._destroyClonedHeaders();if(this._oPopin){this._oPopin.destroy(true);this._oPopin=null;}};
b.prototype.setVisible=function(v){L.prototype.setVisible.call(this,v);if(!v&&this.hasPopin()){this.removePopin();}return this;};
b.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
b.prototype.getPopin=function(){if(!this._oPopin){this._oPopin=new T({id:this.getId()+"-sub"}).addDelegate({ontouchstart:this.ontouchstart,ontouchmove:this.ontouchmove,ontap:this.ontap,ontouchend:this.ontouchend,ontouchcancel:this.ontouchcancel,onsaptabnext:this.onsaptabnext,onsaptabprevious:this.onsaptabprevious,onsapup:this.onsapup,onsapdown:this.onsapdown,oncontextmenu:this.oncontextmenu},this).setParent(this,null,true);}return this._oPopin;};
b.prototype.$Popin=function(){return this.$("sub");};
b.prototype.hasPopin=function(){return this._oPopin;};
b.prototype.removePopin=function(){this._oPopin&&this.$Popin().remove();};
b.prototype.getTabbables=function(){return this.$().add(this.$Popin()).find(":sapTabbable");};
b.prototype.getAccessibilityType=function(B){return B.getText("ACC_CTR_TYPE_ROW");};
b.prototype.getContentAnnouncement=function(B){var t=this.getTable();if(!t){return;}var A="",d=this.getCells(),e=t.getColumns(true);e.forEach(function(o){var f=d[o.getInitialOrder()];if(!f||!o.getVisible()||(o.isHidden()&&!o.isPopin())){return;}var h=o.getHeader();if(h&&h.getVisible()){A+=L.getAccessibilityText(h)+" ";}A+=L.getAccessibilityText(f,true)+" ";});return A;};
b.prototype.updateSelectedDOM=function(s,t){L.prototype.updateSelectedDOM.apply(this,arguments);if(this.hasPopin()){this.$Popin().attr("aria-selected",s);}};
b.prototype.onfocusin=function(e){if(e.isMarked()){return;}if(e.srcControl===this){this.$().children(".sapMListTblCellDup").find(":sapTabbable").attr("tabindex",-1);}L.prototype.onfocusin.apply(this,arguments);};
b.prototype._checkTypeColumn=function(n){if(n==undefined){n=this._needsTypeColumn();}if(this._bNeedsTypeColumn!=n){this._bNeedsTypeColumn=n;this.informList("TypeColumnChange",n);}};
b.prototype._needsTypeColumn=function(){var t=this.getType();return this.getVisible()&&(t==a.Detail||t==a.Navigation||t==a.DetailAndActive);};
b.prototype._addClonedHeader=function(h){return this._aClonedHeaders.push(h);};
b.prototype._destroyClonedHeaders=function(){if(this._aClonedHeaders.length){this._aClonedHeaders.forEach(function(o){o.destroy("KeepDom");});this._aClonedHeaders=[];}};
b.prototype._activeHandlingInheritor=function(){this._toggleActiveClass(true);};
b.prototype._inactiveHandlingInheritor=function(){this._toggleActiveClass(false);};
b.prototype._toggleActiveClass=function(s){if(this.hasPopin()){this.$Popin().toggleClass("sapMLIBActive",s);}};
return b;});
sap.ui.predefine('sap/m/ColumnListItemRenderer',["sap/ui/core/Renderer","sap/ui/core/library","sap/ui/core/Core","sap/ui/Device","sap/base/Log","./library","./ListItemBaseRenderer"],function(R,c,C,D,L,l,a){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var b=l.PopinLayout;var d=R.extend(a);d.apiVersion=2;
d.render=function(r,o){var t=o.getTable();if(!t){return;}a.render.apply(this,arguments);if(o.getVisible()&&t.hasPopin()){this.renderPopin(r,o,t);}};
d.renderHighlight=function(r,o){r.openStart("td");r.class("sapMListTblHighlightCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderHighlight.apply(this,arguments);r.close("td");};
d.renderNavigated=function(r,o){r.openStart("td");r.class("sapMListTblNavigatedCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderNavigated.apply(this,arguments);r.close("td");};
d.renderType=function(r,o){r.openStart("td");r.class("sapMListTblNavCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderType.apply(this,arguments);r.close("td");};
d.renderModeContent=function(r,o){r.openStart("td");r.class("sapMListTblSelCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderModeContent.apply(this,arguments);r.close("td");};
d.renderCounter=function(r,o){};
d.getAriaRole=function(o){return"";};
d.renderLIAttributes=function(r,o){r.class("sapMListTblRow");var A=o.getVAlign();if(A!=V.Inherit){r.class("sapMListTblRow"+A);}var t=o.getTable();if(t&&t.getAlternateRowColors()){var p=t.indexOfItem(o);if(p%2==0){r.class("sapMListTblRowAlternate");}}};
d.renderLIContentWrapper=function(r,o){var t=o.getTable();if(!t){return;}var e=t.getColumns(true),f=o.getCells();o._destroyClonedHeaders();e.forEach(function(g,i){var h,j=true,k=f[g.getInitialOrder()];if(!k||!g.getVisible()||g.isPopin()){g.setIndex(-1);return;}r.openStart("td",o.getId()+"_cell"+i);r.class("sapMListTblCell");r.attr("data-sap-ui-column",g.getId());if(g){r.class(g.getStyleClass(true));h=g.getHeader();if(h){r.attr("headers",h.getId());}if(!t.hasPopin()&&g.getMergeDuplicates()){var F=g.getMergeFunctionName(),m=F.split("#"),s=m[1],n=m[0];if(typeof k[n]!="function"){L.warning("mergeFunctionName property is defined on "+g+" but this is not function of "+k);}else if(t._bRendering||!k.bOutput){var p=g.getLastValue(),q=k[n](s);if(p===q){j=C.getConfiguration().getAccessibility();k.addStyleClass("sapMListTblCellDupCnt");r.class("sapMListTblCellDup");}else{g.setLastValue(q);}}else if(k.hasStyleClass("sapMListTblCellDupCnt")){r.class("sapMListTblCellDup");}}g.getVAlign()!="Inherit"&&r.style("vertical-align",g.getVAlign().toLowerCase());r.style("text-align",g.getCssAlign());}r.openEnd();if(j){this.applyAriaLabelledBy(h,k);r.renderControl(k);}r.close("td");},this);};
d.applyAriaLabelledBy=function(h,o){if(h&&h.getText&&h.getVisible()&&o.getAriaLabelledBy&&(o.getAriaLabelledBy()||[]).indexOf(h.getId())==-1){o.addAriaLabelledBy(h);}};
d.renderPopin=function(r,o,t){o.removePopin();r.openStart("tr",o.getPopin());r.class("sapMListTblSubRow");r.attr("tabindex","-1");if(o.isSelectable()){r.attr("aria-selected",o.getSelected());}r.openEnd();this.renderHighlight(r,o);r.openStart("td",o.getId()+"-subcell");r.attr("colspan",t.getColSpan());var p=t.getPopinLayout();if(D.browser.msie||(D.browser.edge&&D.browser.version<16)){p=b.Block;}r.attr("aria-labelledby",this.getAriaAnnouncement(null,"TABLE_POPIN_ROLE_DESCRIPTION"));r.openEnd();r.openStart("div");r.class("sapMListTblSubCnt");r.class("sapMListTblSubCnt"+p);r.openEnd();var e=o.getCells(),f=t.getColumns(true);f.forEach(function(g){if(!g.getVisible()||!g.isPopin()){return;}var h=e[g.getInitialOrder()],H=g.getHeader();if(!H&&!h){return;}var s=g.getStyleClass(),i=g.getPopinDisplay();r.openStart("div");r.class("sapMListTblSubCntRow");s&&r.class(s);r.openEnd();if(H&&i!=P.WithoutHeader){r.openStart("div").class("sapMListTblSubCntHdr").openEnd();H=H.clone();g.addDependent(H);o._addClonedHeader(H);r.renderControl(H);r.close("div");r.openStart("div").class("sapMListTblSubCntSpr").openEnd();r.text(":");r.close("div");}if(h){r.openStart("div");r.class("sapMListTblSubCntVal");r.class("sapMListTblSubCntVal"+i);r.openEnd();this.applyAriaLabelledBy(H,h);r.renderControl(h);r.close("div");}r.close("div");},this);r.close("div");r.close("td");this.renderNavigated(r,o);r.close("tr");};
d.addLegacyOutlineClass=function(r,o){};
return d;},true);
sap.ui.predefine('sap/m/ComboBox',['./InputBase','./ComboBoxTextField','./ComboBoxBase','./List','./library','sap/ui/Device','sap/ui/core/Item','./StandardListItem','./ComboBoxRenderer','sap/ui/base/ManagedObjectObserver',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","./Toolbar","sap/base/assert","sap/base/security/encodeXML","sap/ui/core/Core","sap/ui/dom/jquery/control"],function(I,C,a,L,l,D,b,S,c,M,d,K,T,e,f,g,q){"use strict";var h=l.ListType;var j=l.ListMode;
var k=a.extend("sap.m.ComboBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ComboBox.designtime",properties:{selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},filterSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{value:{type:"string"},itemPressed:{type:"boolean"}}},selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}},dnd:{draggable:false,droppable:true}}});
function H(o,i){if(!i){return;}var n=o.getFocusDomRef(),p=o._getSelectionRange().start,t=n.value.substring(0,n.selectionStart),r=o._shouldResetSelectionStart(i),u=o.getSelectedItem(),G=i.isA("sap.ui.core.SeparatorItem"),v;o.setSelection(i);if(i!==u&&!G){o.updateDomValue(i.getText());o.fireSelectionChange({selectedItem:i});i=o.getSelectedItem();if(r){p=0;}o.selectText(p,n.value.length);o._bIsLastFocusedItemHeader=false;}if(G){o.setSelectedItem(null);o.fireSelectionChange({selectedItem:null});o.updateDomValue(t);o._bIsLastFocusedItemHeader=true;o._handleAriaActiveDescendant(i);o._getGroupHeaderInvisibleText().setText(o._oRb.getText("LIST_ITEM_GROUP_HEADER")+" "+i.getText());}v=this.getListItem(i);o.handleListItemsVisualFocus(v);if(o.isOpen()){o.removeStyleClass("sapMFocus");o._getList().addStyleClass("sapMListFocus");}else{o.addStyleClass("sapMFocus");}o.scrollToItem(i);}
k.prototype.scrollToItem=function(i){var p=this.getPicker(),P=p.getDomRef("cont"),o=this.getListItem(i),n=i&&o&&o.getDomRef();if(!p||!P||!n){return;}var r=P.scrollTop,t=n.offsetTop,u=P.clientHeight,v=n.offsetHeight;if(r>t){P.scrollTop=t;}else if((t+v)>(r+u)){P.scrollTop=Math.ceil(t+v-u);}};
function s(i,E){if(document.activeElement===this.getFocusDomRef()){this.selectText(i,E);}}
function m(i){var o=this.getSelectedItem(),n=this.getListItem(o),p=o&&n&&n.getDomRef(),r=p&&p.offsetTop,t=p&&p.offsetHeight,P=this.getPicker(),u=P.getDomRef("cont"),v=u.clientHeight;if(o&&((r+t)>(v))){if(!i){this._getList().$().css("visibility","hidden");}else{u.scrollTop=r-t/2;this._getList().$().css("visibility","visible");}}}
k.prototype._handleAriaActiveDescendant=function(i){var o=this.getFocusDomRef(),n=this.getListItem(i),A="aria-activedescendant";if(o){if(i&&n&&n.getDomRef()&&this.isOpen()){o.setAttribute(A,n.getId());}else{o.removeAttribute(A);}}};
k.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
k.prototype._setItemVisibility=function(i,v){var o=i&&this.getListItem(i).$(),n="sapMSelectListItemBaseInvisible";if(v){i.bVisible=true;o.length&&o.removeClass(n);}else{i.bVisible=false;o.length&&o.addClass(n);}};
k.prototype.setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
k.prototype.revertSelection=function(){var p,P=this.getPickerTextField();this.setSelectedItem(this._oSelectedItemBeforeOpen);this.setValue(this._sValueBeforeOpen);if(this.getSelectedItem()===null){p=this._sValueBeforeOpen;}else{p=this._oSelectedItemBeforeOpen.getText();}P&&P.setValue(p);};
k.prototype.filterItems=function(o){var i=this.getItems(),F=[],n=[],p=o.properties.indexOf("additionalText")>-1,r=this.fnFilter||a.DEFAULT_TEXT_FILTER,G=[],t=false;this._oFirstItemTextMatched=null;i.forEach(function(u){if(u.isA("sap.ui.core.SeparatorItem")){if(!u.getText()){this.getListItem(u).setVisible(false);return;}G.push({separator:u,show:false});t=true;this.getListItem(u).setVisible(false);return;}var v=r.call(this,o.value,u,"getText");var w=r.call(this,o.value,u,"getAdditionalText");if((v||w)&&t){G[G.length-1].show=true;t=false;}if(v){n.push(u);F.push(u);}else if(w&&p){F.push(u);}}.bind(this));i.forEach(function(u){if(u.isA("sap.ui.core.SeparatorItem")){return;}var v=F.indexOf(u)>-1;var w=n.indexOf(u)>-1;if(!this._oFirstItemTextMatched&&w){this._oFirstItemTextMatched=u;}this.getListItem(u).setVisible(v);},this);G.forEach(function(u){if(u.show){this.getListItem(u.separator).setVisible(true);}}.bind(this));return F;};
k.prototype._filterStartsWithItems=function(i,n){var o=i.toLowerCase();var p=this.getItems(),F=p.filter(function(r){return r[n]&&r[n]().toLowerCase().startsWith(o);});return F;};
k.prototype._getFilters=function(){return this.getFilterSecondaryValues()?["text","additionalText"]:["text"];};
k.prototype.getNextFocusableItem=function(i){var A=this.getSelectableItems(),n=this.getNonSeparatorSelectableItems(A),F=this.hasStyleClass("sapMFocus"),o=this.getSelectedItem()||this._getItemByListItem(this._oLastFocusedListItem),N;if(F&&this.isOpen()){N=A[0];}else if(F){N=n[n.indexOf(o)+(i?1:-1)];}else{N=A[A.indexOf(o)+(i?1:-1)];}return N;};
k.prototype.getNonSeparatorSelectableItems=function(i){return i.filter(function(o){return!o.isA("sap.ui.core.SeparatorItem");});};
k.prototype._itemsTextStartsWithTypedValue=function(i,t){if(!i||typeof t!="string"||t==""){return false;}return i.getText().toLowerCase().startsWith(t.toLowerCase());};
k.prototype._shouldResetSelectionStart=function(i){var o=this.getFocusDomRef(),n=this._getSelectionRange(),p=n.start!==n.end,t=o.value.substring(0,n.start),r=this._itemsTextStartsWithTypedValue(i,t);return!(r&&(p||this._bIsLastFocusedItemHeader));};
k.prototype._getSelectionRange=function(){var o=this.getFocusDomRef(),v=this.getValue(),i=o.selectionStart,n=o.selectionEnd,r={start:i,end:n};if(!(D.browser.msie||D.browser.edge)){return r;}if(this._bIsLastFocusedItemHeader){r.start=v.length;r.end=v.length;}return r;};
k.prototype.handleListItemsVisualFocus=function(o){if(this._oLastFocusedListItem){this._oLastFocusedListItem.removeStyleClass("sapMLIBFocused");this._oLastFocusedListItem=null;}if(o){this._oLastFocusedListItem=o;o.addStyleClass("sapMLIBFocused");}};
k.prototype.init=function(){this._oRb=g.getLibraryResourceBundle("sap.m");a.prototype.init.apply(this,arguments);this.bOpenValueStateMessage=true;this._sValueBeforeOpen="";this._sInputValueBeforeOpen="";this._oSelectedItemBeforeOpen=null;this._oFirstItemTextMatched=null;this.bIsFocused=false;if(D.system.phone){this.attachEvent("_change",this.onPropertyChange,this);}this._oLastFocusedListItem=null;this._bIsLastFocusedItemHeader=null;this._oItemObserver=new M(this._forwardItemProperties.bind(this));};
k.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this.synchronizeSelection();};
k.prototype._fillList=function(){var o=this._getList(),n,p,r,i,t;if(!o){return;}if(this._oLastFocusedListItem){t=this._getItemByListItem(this._oLastFocusedListItem);}o.destroyItems();n=this.getItems();if(this._sInputValueBeforeOpen){n=this.filterItems({properties:this._getFilters(),value:this._sInputValueBeforeOpen});}for(i=0,r=n.length;i<r;i++){p=this._mapItemToListItem(n[i]);o.addAggregation("items",p,true);}if(t){this._oLastFocusedListItem=this.getListItem(t);}};
k.prototype.exit=function(){a.prototype.exit.apply(this,arguments);this._oRb=null;this._oSelectedItemBeforeOpen=null;this._oFirstItemTextMatched=null;this._oLastFocusedListItem=null;if(this._oSuggestionPopover){if(this._oPickerCustomHeader){this._oPickerCustomHeader.destroy();this._oPickerCustomHeader=null;}this._oSuggestionPopover.destroy();this._oSuggestionPopover=null;}if(this._oItemObserver){this._oItemObserver.disconnect();this._oItemObserver=null;}};
k.prototype.onBeforeRenderingPicker=function(){var o=this["onBeforeRendering"+this.getPickerType()];o&&o.call(this);};
k.prototype.onBeforeRenderingDropdown=function(){var p=this.getPicker(),w=(this.$().outerWidth()/parseFloat(l.BaseFontSize))+"rem";if(p){p.setContentMinWidth(w);}};
k.prototype.onBeforeRenderingList=function(){if(this.bProcessingLoadItemsEvent){var o=this._getList(),F=this.getFocusDomRef();if(o){o.setBusy(true);}if(F){F.setAttribute("aria-busy","true");}}};
k.prototype.onAfterRenderingPicker=function(){var o=this["onAfterRendering"+this.getPickerType()];o&&o.call(this);m.call(this,false);};
k.prototype.onAfterRenderingList=function(){var o=this.getSelectedItem(),i=this.getListItem(o);if(this.bProcessingLoadItemsEvent&&(this.getItems().length===0)){return;}var n=this._getList(),F=this.getFocusDomRef();this._highlightList(this._sInputValueBeforeOpen);if(o){n.setSelectedItem(i);this.handleListItemsVisualFocus(i);}if(n){n.setBusy(false);}if(F){F.removeAttribute("aria-busy");}};
k.prototype.oninput=function(E){a.prototype.oninput.apply(this,arguments);this.syncPickerContent();if(E.isMarked("invalid")){return;}this.loadItems(function(){this.handleInputValidation(E,this.isComposingCharacter());},{name:"input",busyIndicator:false});if(this.bProcessingLoadItemsEvent&&(this.getPickerType()==="Dropdown")){this.open();}this.addStyleClass("sapMFocus");this._getList().removeStyleClass("sapMListFocus");};
k.prototype.handleInputValidation=function(E,i){var o=this.getSelectedItem(),v=E.target.value,n=v==="",p=E.srcControl,V,t=(this.getPickerType()==="Dropdown");if(n&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){V=this.getItems();}else{V=this.filterItems({properties:this._getFilters(),value:v});}var r=!!V.length;var F=V[0];if(!n&&F&&F.getEnabled()){this.handleTypeAhead(p,V,v,i);}if(n||!r||(!p._bDoTypeAhead&&(this._getSelectedItemText()!==v))){this.setSelection(null);if(o!==this.getSelectedItem()){this.fireSelectionChange({selectedItem:this.getSelectedItem()});}}this._sInputValueBeforeOpen=v;if(this.isOpen()){setTimeout(function(){this._highlightList(v);}.bind(this));}if(r){if(n&&!this.bOpenedByKeyboardOrButton){this.close();}else if(t){this.open();this.scrollToItem(this.getSelectedItem());}}else if(this.isOpen()){if(t&&!this.bOpenedByKeyboardOrButton){this.close();}}else{this.clearFilter();}};
k.prototype.handleTypeAhead=function(i,n,v,o){var p=this.intersectItems(this._filterStartsWithItems(v,'getText'),n);var r=this.getFilterSecondaryValues();var t=D.system.desktop;var u=this.getSelectedItem();if(i._bDoTypeAhead){var w=this.intersectItems(this._filterStartsWithItems(v,'getAdditionalText'),n);if(r&&!p[0]&&w[0]){!o&&i.updateDomValue(w[0].getAdditionalText());this.setSelection(w[0]);}else if(p[0]){!o&&i.updateDomValue(p[0].getText());this.setSelection(p[0]);}}else{this.setSelection(p[0]);}if(u!==this.getSelectedItem()){this.fireSelectionChange({selectedItem:this.getSelectedItem()});}if(i._bDoTypeAhead){if(t){s.call(i,v.length,i.getValue().length);}else{setTimeout(s.bind(i,v.length,i.getValue().length),0);}}this.addStyleClass("sapMFocus");this._getList().removeStyleClass("sapMListFocus");};
k.prototype.onSelectionChange=function(o){var i=this._getItemByListItem(o.getParameter("listItem")),p=this.getChangeEventParams(),n=(i!==this.getSelectedItem());this.updateDomValue(i.getText());this.setSelection(i);this.fireSelectionChange({selectedItem:this.getSelectedItem()});if(n){p.itemPressed=true;this.onChange(null,p);}};
k.prototype.onItemPress=function(o){var i=o.getParameter("listItem"),t=i.getTitle(),p=this.getChangeEventParams(),n=(i!==this.getListItem(this.getSelectedItem()));if(i.isA("sap.m.GroupHeaderListItem")){return;}this.handleListItemsVisualFocus(i);this.updateDomValue(t);if(!n){p.itemPressed=true;this.onChange(null,p);}this.setProperty("value",t,true);if(this.getPickerType()==="Dropdown"&&!this.isPlatformTablet()){this.selectText.bind(this,this.getValue().length,this.getValue().length);}this.close();};
k.prototype.onBeforeOpen=function(){var p=this["onBeforeOpen"+this.getPickerType()],o=this.getFocusDomRef();if(this.hasLoadItemsEventListeners()&&!this.bProcessingLoadItemsEvent){this.loadItems();}this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);if(o){this.getRoleComboNodeDomRef().setAttribute("aria-owns",this._getList().getId());}this.addContent();p&&p.call(this);};
k.prototype.onBeforeOpenDialog=function(){var p=this.getPickerTextField();this._oSelectedItemBeforeOpen=this.getSelectedItem();this._sValueBeforeOpen=this.getValue();if(this.getSelectedItem()){this.filterItems({properties:this._getFilters(),value:""});}p.setValue(this._sValueBeforeOpen);};
k.prototype.onAfterOpen=function(){var o=this.getFocusDomRef(),i=this.getSelectedItem(),n=this.getListItem(i),p=this._getSelectionRange();this.closeValueStateMessage();if(o){this.getRoleComboNodeDomRef().setAttribute("aria-expanded","true");n&&o.setAttribute("aria-activedescendant",n.getId());}m.call(this,true);if(i&&p.start===p.end){setTimeout(function(){this.selectText(0,p.end);}.bind(this),0);}};
k.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);var o=this.getFocusDomRef();if(o){this.getRoleComboNodeDomRef().removeAttribute("aria-owns");o.removeAttribute("aria-activedescendant");}this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);};
k.prototype.onAfterClose=function(){var o=this.getFocusDomRef();if(o){this.getRoleComboNodeDomRef().setAttribute("aria-expanded","false");}this.clearFilter();this._sInputValueBeforeOpen="";if(this.shouldValueStateMessageBeOpened()&&(document.activeElement===o)){this.openValueStateMessage();}};
k.prototype.onItemChange=function(o){var i=this.getAssociation("selectedItem"),n=o.getParameter("newValue"),p=o.getParameter("name");if(i===o.getParameter("id")){switch(p){case"text":if(!this.isBound("value")){this.setValue(n);}break;case"key":if(!this.isBound("selectedKey")){this.setSelectedKey(n);}break;}}};
k.prototype.onkeydown=function(E){var o=E.srcControl;a.prototype.onkeydown.apply(o,arguments);if(!o.getEnabled()||!o.getEditable()){return;}var i=K;o._bDoTypeAhead=(E.which!==i.BACKSPACE)&&(E.which!==i.DELETE);};
k.prototype.oncut=function(E){var o=E.srcControl;a.prototype.oncut.apply(o,arguments);o._bDoTypeAhead=false;};
k.prototype.onsapenter=function(E){var o=E.srcControl,i=o.getSelectedItem();if(i&&this.getFilterSecondaryValues()){o.updateDomValue(i.getText());}a.prototype.onsapenter.apply(o,arguments);if(!o.getEnabled()||!o.getEditable()){return;}if(o.isOpen()&&!this.isComposingCharacter()){o.close();}};
k.prototype.onsapdown=function(E){var o=E.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();E.setMarked();E.preventDefault();this.loadItems(function navigateToNextSelectableItem(){H.call(this,o,this.getNextFocusableItem(true));});};
k.prototype.onsapup=function(E){var o=E.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();E.setMarked();E.preventDefault();this.loadItems(function navigateToPrevSelectableItem(){H.call(this,o,this.getNextFocusableItem(false));});};
k.prototype.onsaphome=function(E){var o=E.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();E.setMarked();E.preventDefault();this.loadItems(function navigateToFirstSelectableItem(){var F=this.getSelectableItems()[0];H.call(this,o,F);});};
k.prototype.onsapend=function(E){var o=E.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();E.setMarked();E.preventDefault();this.loadItems(function navigateToLastSelectableItem(){var i=this.findLastEnabledItem(this.getSelectableItems());H.call(this,o,i);});};
k.prototype.onsappagedown=function(E){var o=E.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();E.setMarked();E.preventDefault();this.loadItems(function(){var i=this.getNonSeparatorSelectableItems(this.getSelectableItems()),n=i.indexOf(this.getSelectedItem())+10,p;n=(n>i.length-1)?i.length-1:Math.max(0,n);p=i[n];H.call(this,o,p);});};
k.prototype.onsappageup=function(E){var o=E.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();E.setMarked();E.preventDefault();this.loadItems(function(){var i=this.getNonSeparatorSelectableItems(this.getSelectableItems()),n=i.indexOf(this.getSelectedItem())-10,p;n=(n>i.length-1)?i.length-1:Math.max(0,n);p=i[n];H.call(this,o,p);});};
k.prototype.onsapshow=function(E){var i,o,n=this.getEditable();a.prototype.onsapshow.apply(this,arguments);this.syncPickerContent();if(!this.getValue()&&n){i=this.getSelectableItems();o=this.getNonSeparatorSelectableItems(i)[0];if(o){this.setSelection(o);this.updateDomValue(o.getText());this.fireSelectionChange({selectedItem:o});setTimeout(function(){this.selectText(0,o.getText().length);}.bind(this),0);}}};
k.prototype.onsaphide=k.prototype.onsapshow;
k.prototype.onfocusin=function(E){var i=this.getPickerType()==="Dropdown";if(this._bIsBeingDestroyed){return;}if(E.target===this.getOpenArea()){this.bOpenValueStateMessage=false;if(i&&!this.isPlatformTablet()){this.focus();}}else{if(i){setTimeout(function(){if(document.activeElement===this.getFocusDomRef()&&!this.bIsFocused&&!this.bFocusoutDueRendering&&!this.getSelectedText()){this.selectText(0,this.getValue().length);}this.bIsFocused=true;}.bind(this),0);}if(!this.isOpen()&&this.bOpenValueStateMessage&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}this.bOpenValueStateMessage=true;}if(this.getEnabled()&&(!this.isOpen()||!this.getSelectedItem()||!this._getList().hasStyleClass("sapMListFocus"))){this.addStyleClass("sapMFocus");}};
k.prototype.onsapfocusleave=function(E){this.bIsFocused=false;var t,p,r,F,i=this.getSelectedItem();if(i&&this.getFilterSecondaryValues()){this.updateDomValue(i.getText());}a.prototype.onsapfocusleave.apply(this,arguments);if(this.isPickerDialog()){return;}p=this.getPicker();if(!E.relatedControlId||!p){return;}t=this.isPlatformTablet();r=g.byId(E.relatedControlId);F=r&&r.getFocusDomRef();if(d(p.getFocusDomRef(),F)&&!t){this.focus();}};
k.prototype.setSelection=function(i){var o=this._getList(),n,p;this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof b)?i.getId():i,true);if(typeof i==="string"){i=g.byId(i);}if(o){n=this.getListItem(i);if(n){o.setSelectedItem(n,true);}else{o.removeSelections(true);}}p=i?i.getKey():"";this.setProperty("selectedKey",p,true);this._handleAriaActiveDescendant(i);if(this._oSuggestionPopover){this._oSuggestionPopover._iPopupListSelectedIndex=this.getItems().indexOf(i);}};
k.prototype.isSelectionSynchronized=function(){var i=this.getSelectedItem();return this.getSelectedKey()===(i&&i.getKey());};
k.prototype.synchronizeSelection=function(){if(this.isSelectionSynchronized()){return;}var i=this.getSelectedKey(),v=this.getItemByKey(""+i);if(v&&(i!=="")){this.setAssociation("selectedItem",v,true);this.setProperty("selectedItemId",v.getId(),true);if(this._sValue===this.getValue()){this.setValue(v.getText());this._sValue=this.getValue();}}};
k.prototype.isFiltered=function(){var o=this._getList();return o&&(o.getVisibleItems().length!==this.getItems().length);};
k.prototype.isItemVisible=function(i){return i&&(i.bVisible===undefined||i.bVisible);};
k.prototype.configPicker=function(p){var r=this.getRenderer(),i=r.CSS_CLASS_COMBOBOXBASE;p.setHorizontalScrolling(false).addStyleClass(i+"Picker").addStyleClass(i+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this);};
k.prototype._configureList=function(o){var r=this.getRenderer();if(!o){return;}o.setMode(j.SingleSelectMaster).addStyleClass(r.CSS_CLASS_COMBOBOXBASE+"List").addStyleClass(r.CSS_CLASS_COMBOBOX+"List");o.attachSelectionChange(this.onSelectionChange,this).attachItemPress(this.onItemPress,this);o.addEventDelegate({onBeforeRendering:this.onBeforeRenderingList,onAfterRendering:this.onAfterRenderingList},this);};
k.prototype.destroyItems=function(){this.destroyAggregation("items");if(this._getList()){this._getList().destroyItems();}return this;};
k.prototype._mapItemToListItem=function(i){var o,n,p,A;var r=this.getRenderer();if(!i){return null;}A=(i.getAdditionalText&&this.getShowSecondaryValues())?i.getAdditionalText():"";n=r.CSS_CLASS_COMBOBOXBASE+"Item";p=(this.isItemSelected(i))?n+"Selected":"";if(i.isA("sap.ui.core.SeparatorItem")){o=this._mapSeparatorItemToGroupHeader(i,r);}else{o=new S({type:h.Active,info:A,visible:i.getEnabled()}).addStyleClass(n+" "+p);}o.setTitle(i.getText());this.setSelectable(i,i.getEnabled());o.setTooltip(i.getTooltip());i.data(r.CSS_CLASS_COMBOBOXBASE+"ListItem",o);i.getCustomData().forEach(function(t){o.addCustomData(t.clone());});this._oItemObserver.observe(i,{properties:["text","additionalText","enabled","tooltip"]});return o;};
k.prototype._forwardItemProperties=function(p){var i=p.object,o=i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"ListItem"),n={text:"title",enabled:"visible",tooltip:"tooltip"},A,P,r;if(Object.keys(n).indexOf(p.name)>-1){P=n[p.name];r="set"+P.charAt(0).toUpperCase()+P.slice(1);o[r](p.current);}if(p.name==="additionalText"){A=this.getShowSecondaryValues()?p.current:"";o.setInfo(A);}};
k.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
k.prototype.getDefaultSelectedItem=function(){return null;};
k.prototype.getChangeEventParams=function(){return{itemPressed:false};};
k.prototype.clearSelection=function(){this.setSelection(null);};
k.prototype.selectText=function(i,n){a.prototype.selectText.apply(this,arguments);this.textSelectionStart=i;this.textSelectionEnd=n;return this;};
k.prototype.setAssociation=function(A,i,n){var o=this._getList();if(o&&(A==="selectedItem")){if(!(i instanceof b)){i=this.findItem("id",i);}o.setSelectedItem(this.getListItem(i),true);}return a.prototype.setAssociation.apply(this,arguments);};
k.prototype.removeAllAssociation=function(A,i){var o=this._getList();if(o&&(A==="selectedItem")){L.prototype.removeAllAssociation.apply(o,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
k.prototype.removeAllItems=function(){var i=a.prototype.removeAllItems.apply(this,arguments);this._fillList();return i;};
k.prototype.clone=function(i){var o=a.prototype.clone.apply(this,arguments),n=this._getList();if(!this.isBound("items")&&n){o.syncPickerContent();o.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));}return o;};
k.prototype.open=function(){this.syncPickerContent();var o=this._getList();a.prototype.open.call(this);if(this.getSelectedItem()){o.addStyleClass("sapMListFocus");this.removeStyleClass("sapMFocus");}return this;};
k.prototype.syncPickerContent=function(){var p,P=this.getPicker(),i=this.getInputForwardableProperties();if(!P){var n,G;P=this.createPicker(this.getPickerType());p=this.getPickerTextField();this._updateSuggestionsPopoverValueState();this._fillList();if(p){i.forEach(function(o){o=o.charAt(0).toUpperCase()+o.slice(1);n="set"+o;G="get"+o;if(p[n]){p[n](this[G]());}},this);}}this.synchronizeSelection();return P;};
k.prototype.close=function(){var o=this._getList();a.prototype.close.call(this);this.addStyleClass("sapMFocus");o&&o.removeStyleClass("sapMListFocus");return this;};
k.prototype.findAggregatedObjects=function(){var o=this._getList();if(o){return L.prototype.findAggregatedObjects.apply(o,arguments);}return[];};
k.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=g.byId(i);}if(!(i instanceof b)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));return this;};
k.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);i=this.getSelectedItem();this.setValue(this._getSelectedItemText(i));return this;};
k.prototype.setSelectedKey=function(i){i=this.validateProperty("selectedKey",i);var n=(i===""),o=this.isBound("selectedKey")&&this.isBound("value")&&this.getBindingInfo("selectedKey").skipModelUpdate;if(n){this.setSelection(null);if(!o){this.setValue("");}return this;}var p=this.getItemByKey(i);if(p){this.setSelection(p);if(!o){this.setValue(this._getSelectedItemText(p));}return this;}this._sValue=this.getValue();return this.setProperty("selectedKey",i);};
k.prototype.getSelectedItem=function(){var v=this.getAssociation("selectedItem");return(v===null)?null:g.byId(v)||null;};
k.prototype.updateItems=function(){var r,o=this.getSelectedItem(),r=a.prototype.updateItems.apply(this,arguments);clearTimeout(this._debounceItemsUpdate);this._debounceItemsUpdate=setTimeout(this["_syncItemsSelection"].bind(this,o),0);return r;};
k.prototype._syncItemsSelection=function(o){var i,n,p=this.getSelectedKey();if(!o||o===this.getSelectedItem()){return;}n=this.getItems();i=n.some(function(r){return p===r.getKey();});this.setSelectedItem(i&&p?this.getItemByKey(p):null);};
k.prototype.removeItem=function(i){i=a.prototype.removeItem.apply(this,arguments);var o;if(this._getList()){this._getList().removeItem(i&&this.getListItem(i));}if(this.isBound("items")&&!this.bItemsUpdated){return i;}var v=this.getValue();if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){o=this.getDefaultSelectedItem();this.setSelection(o);this.setValue(v);}return i;};
k.prototype._modifyPopupInput=function(i){a.prototype._modifyPopupInput.apply(this,arguments);i.addEventDelegate({onsapenter:function(){var t=i.getValue();this.updateDomValue(t);this.onChange();if(t){this.updateDomValue(t);this.onChange();this.close();}}},this);return i;};
k.prototype.applyShowItemsFilters=function(){var p,P;this.syncPickerContent();p=this.getPicker();P=function(){p.detachBeforeOpen(P,this);p=null;this.filterItems({value:this.getValue()||"_",properties:this._getFilters()});};p.attachBeforeOpen(P,this);};
return k;});
sap.ui.predefine('sap/m/ComboBoxBase',['./Dialog','./ComboBoxTextField','./Input','./GroupHeaderListItem','./SuggestionsPopover','sap/ui/core/SeparatorItem','sap/ui/core/InvisibleText','sap/base/Log','./library','sap/ui/Device','sap/ui/core/library','./ComboBoxBaseRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/security/encodeXML","sap/base/strings/escapeRegExp"],function(D,C,I,G,S,a,b,L,l,c,d,e,f,K,q,g,h){"use strict";var P=l.PlacementType;var j=["value","enabled","name","placeholder","editable","textAlign","textDirection","valueState","valueStateText"];
var k=C.extend("sap.m.ComboBoxBase",{metadata:{library:"sap.m","abstract":true,defaultAggregation:"items",properties:{showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"}},events:{loadItems:{}},dnd:{draggable:false,droppable:true}}});
k.DEFAULT_TEXT_FILTER=function(i,o,p){var s,m,M;if(!o[p]){return false;}s=o[p]().toLowerCase();m=i.toLowerCase();M=new RegExp('(^|\\s)'+h(m)+".*",'g');return M.test(s);};
k.prototype.oncompositionstart=function(){this._bIsComposingCharacter=true;};
k.prototype.oncompositionend=function(E){this._bIsComposingCharacter=false;this._sComposition=E.target.value;if(!c.browser.edge&&!c.browser.firefox){C.prototype.handleInput.apply(this,arguments);this.handleInputValidation(E,this.isComposingCharacter());}};
k.prototype.isComposingCharacter=function(){return this._bIsComposingCharacter;};
k.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;if(this.hasLoadItemsEventListeners()){this.onItemsLoaded();}};
k.prototype.setFilterFunction=function(F){if(F===null||F===undefined){this.fnFilter=null;return this;}if(typeof(F)!=="function"){L.warning("Passed filter is not a function and the default implementation will be used");}else{this.fnFilter=F;}return this;};
k.prototype.highLightList=function(v,i,B){if(B&&typeof B==="function"){B(i,v);}else{this._oSuggestionPopover.highlightSuggestionItems(i,v,true);}};
k.prototype._highlightList=function(v){var i=[],m=[],o,n,p;this._getList().getItems().forEach(function(r){n=r.getDomRef();p=n&&n.getElementsByClassName("sapMSLITitleOnly")[0];if(p){i.push(p);o=n.querySelector(".sapMSLIInfo");if(o&&r.getInfo){m.push(o);}}});this.highLightList(v,i);this.highLightList(v,m);};
k.prototype._modifyPopupInput=function(i){this.setTextFieldHandler(i);return i;};
k.prototype.setTextFieldHandler=function(t){var i=this,T=t._handleEvent;t._handleEvent=function(E){T.apply(this,arguments);if(/keydown|sapdown|sapup|saphome|sapend|sappagedown|sappageup|input/.test(E.type)){i._handleEvent(E);}};};
k.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
k.prototype.loadItems=function(i,o){var m=typeof i==="function";if(this.hasLoadItemsEventListeners()&&(this.getItems().length===0)){this._bOnItemsLoadedScheduled=false;if(m){o=q.extend({action:i,busyIndicator:true,busyIndicatorDelay:300},o);this.aMessageQueue.push(o);if((this.iLoadItemsEventInitialProcessingTimeoutID===-1)&&(o.busyIndicator)){this.iLoadItemsEventInitialProcessingTimeoutID=setTimeout(function onItemsNotLoadedAfterDelay(){this.setInternalBusyIndicatorDelay(0);this.setInternalBusyIndicator(true);}.bind(this),o.busyIndicatorDelay);}}if(!this.bProcessingLoadItemsEvent){this.bProcessingLoadItemsEvent=true;this.fireLoadItems();}}else if(m){i.call(this);}};
k.prototype.onItemsLoaded=function(){this.bProcessingLoadItemsEvent=false;clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);if(this.bInitialBusyIndicatorState!==this.getBusy()){this.setInternalBusyIndicator(this.bInitialBusyIndicatorState);}if(this.iInitialBusyIndicatorDelay!==this.getBusyIndicatorDelay()){this.setInternalBusyIndicatorDelay(this.iInitialBusyIndicatorDelay);}for(var i=0,m,n,o;i<this.aMessageQueue.length;i++){m=this.aMessageQueue.shift();i--;o=(i+1)===this.aMessageQueue.length;n=o?null:this.aMessageQueue[i+1];if(typeof m.action==="function"){if((m.name==="input")&&!o&&(n.name==="input")){continue;}m.action.call(this);}}};
k.prototype.hasLoadItemsEventListeners=function(){return this.hasListeners("loadItems");};
k.prototype._scheduleOnItemsLoadedOnce=function(){if(!this._bOnItemsLoadedScheduled&&!this.isBound("items")&&this.hasLoadItemsEventListeners()&&this.bProcessingLoadItemsEvent){this._bOnItemsLoadedScheduled=true;setTimeout(this.onItemsLoaded.bind(this),0);}};
k.prototype.getPickerInvisibleTextId=function(){return b.getStaticId("sap.m","COMBOBOX_AVAILABLE_OPTIONS");};
k.prototype._getGroupHeaderInvisibleText=function(){if(!this._oGroupHeaderInvisibleText){this._oGroupHeaderInvisibleText=new b();this._oGroupHeaderInvisibleText.toStatic();}return this._oGroupHeaderInvisibleText;};
k.prototype._getItemByListItem=function(o){return this._getItemBy(o,"ListItem");};
k.prototype._getItemBy=function(o,s){s=this.getRenderer().CSS_CLASS_COMBOBOXBASE+s;for(var i=0,m=this.getItems(),n=m.length;i<n;i++){if(m[i].data(s)===o){return m[i];}}return null;};
k.prototype._isListInSuggestMode=function(){return this._getList().getItems().some(function(o){return!o.getVisible()&&this._getItemByListItem(o).getEnabled();},this);};
k.prototype.getListItem=function(i){return i?i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"ListItem"):null;};
k.prototype.getSelectable=function(i){return i._bSelectable;};
k.prototype.init=function(){C.prototype.init.apply(this,arguments);this.setPickerType(c.system.phone?"Dialog":"Dropdown");this.bItemsUpdated=false;this.bOpenedByKeyboardOrButton=false;this._bShouldClosePicker=false;this._oPickerValueStateText=null;this.bProcessingLoadItemsEvent=false;this.iLoadItemsEventInitialProcessingTimeoutID=-1;this.aMessageQueue=[];this.bInitialBusyIndicatorState=this.getBusy();this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();this._bOnItemsLoadedScheduled=false;this._bDoTypeAhead=true;this.getIcon().addEventDelegate({onmousedown:function(E){this._bShouldClosePicker=this.isOpen();}},this);this.getIcon().attachPress(this._handlePopupOpenAndItemsLoad.bind(this,true));this._sComposition="";this.fnFilter=null;};
k.prototype._handlePopupOpenAndItemsLoad=function(o){var p;if(!this.getEnabled()||!this.getEditable()){return;}if(this._bShouldClosePicker){this._bShouldClosePicker=false;this.close();return;}this.loadItems();this.bOpenedByKeyboardOrButton=o;if(this.isPlatformTablet()){this.syncPickerContent();p=this.getPicker();p.setInitialFocus(p);}this.open();};
k.prototype.exit=function(){C.prototype.exit.apply(this,arguments);if(this._getList()){this._getList().destroy();this._oList=null;}if(this._getGroupHeaderInvisibleText()){this._getGroupHeaderInvisibleText().destroy();this._oGroupHeaderInvisibleText=null;}clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);this.aMessageQueue=null;this.fnFilter=null;};
k.prototype.onsapshow=function(E){if(!this.getEnabled()||!this.getEditable()){return;}E.setMarked();if(E.keyCode===K.F4){this.onF4(E);}if(this.isOpen()){this.close();return;}this.selectText(0,this.getValue().length);this.loadItems();this.bOpenedByKeyboardOrButton=true;this.open();};
k.prototype.onF4=function(E){E.preventDefault();};
k.prototype.onsapescape=function(E){if(this.getEnabled()&&this.getEditable()&&this.isOpen()){E.setMarked();E.preventDefault();this.close();}else{C.prototype.onsapescape.apply(this,arguments);}};
k.prototype.onsaphide=k.prototype.onsapshow;
k.prototype.onsapfocusleave=function(E){if(!E.relatedControlId){C.prototype.onsapfocusleave.apply(this,arguments);return;}var r=sap.ui.getCore().byId(E.relatedControlId);if(r===this){return;}var p=this.getPicker(),F=r&&r.getFocusDomRef();if(p&&f(p.getFocusDomRef(),F)){return;}C.prototype.onsapfocusleave.apply(this,arguments);};
k.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
k.prototype.addContent=function(p){};
k.prototype.getList=function(){L.warning("[Warning]:","You are attempting to use deprecated method 'getList()', please refer to SAP note 2746748.",this);return this._getList();};
k.prototype._getList=function(){if(this.bIsDestroyed){return null;}return this._oList;};
k.prototype.setPickerType=function(p){this._sPickerType=p;};
k.prototype.getPickerType=function(){return this._sPickerType;};
k.prototype._updateSuggestionsPopoverValueState=function(){var s=this._getSuggestionsPopover();if(s){s.updateValueState(this.getValueState(),this.getValueStateText(),this.getShowValueStateMessage());}};
k.prototype.setValueState=function(v){C.prototype.setValueState.apply(this,arguments);this._updateSuggestionsPopoverValueState();return this;};
k.prototype.setValueStateText=function(v){C.prototype.setValueStateText.apply(this,arguments);this._updateSuggestionsPopoverValueState();return this;};
k.prototype.setShowValueStateMessage=function(s){C.prototype.setShowValueStateMessage.apply(this,arguments);this._updateSuggestionsPopoverValueState();return this;};
k.prototype.shouldValueStateMessageBeOpened=function(){var s=C.prototype.shouldValueStateMessageBeOpened.apply(this,arguments);return(s&&!this.isOpen());};
k.prototype.onPropertyChange=function(o,i){var n=o.getParameter("newValue"),p=o.getParameter("name"),m="set"+p.charAt(0).toUpperCase()+p.slice(1),r=(i&&i.srcControl)||this.getPickerTextField();if(this.getInputForwardableProperties().indexOf(p)>-1&&r&&(typeof r[m]==="function")){r[m](n);}};
k.prototype.getInputForwardableProperties=function(){return j;};
k.prototype.isPickerDialog=function(){return this.getPickerType()==="Dialog";};
k.prototype.isPlatformTablet=function(){var n=!c.system.combi,t=c.system.tablet&&n;return t;};
k.prototype.createPickerTextField=function(){var i=new I({width:"100%",showValueStateMessage:false});return i;};
k.prototype.getDropdownSettings=function(){return{showArrow:false,placement:P.VerticalPreferredBottom,offsetX:0,offsetY:0,bounce:false,ariaLabelledBy:this.getPickerInvisibleTextId()||undefined};};
k.prototype._configureList=function(){};
k.prototype.createPicker=function(p){var o=this.getAggregation("picker");if(o){return o;}this._oSuggestionPopover=this._createSuggestionsPopover();o=this._oSuggestionPopover._oPopover;this.setAggregation("picker",o,true);this.configPicker(o);return o;};
k.prototype.configPicker=function(p){};
k.prototype._hasShowSelectedButton=function(){return false;};
k.prototype._createSuggestionsPopover=function(){var u=this.isPickerDialog(),s;s=new S(this);if(u){var i=this.createPickerTextField();s._oPopupInput=this._modifyPopupInput(i);}s._createSuggestionPopup({showSelectedButton:this._hasShowSelectedButton()});s._createSuggestionPopupContent(false,false,false);this.forwardEventHandlersToSuggPopover(s);this._updateSuggestionsPopoverValueState();this._oList=s._oList;this._configureList(this._oList);return s;};
k.prototype.forwardEventHandlersToSuggPopover=function(s){s.setOkPressHandler(this._handleOkPress.bind(this));s.setCancelPressHandler(this._handleCancelPress.bind(this));s.setInputLabels(this.getLabels.bind(this));};
k.prototype._handleOkPress=function(){var t=this,T=t.getPickerTextField();t.updateDomValue(T.getValue());t.onChange();t.close();};
k.prototype._handleCancelPress=function(){this.close();this.revertSelection();};
k.prototype.setSelectable=function(i,s){if(this.indexOfItem(i)<0){return;}i._bSelectable=s;var o=this.getListItem(i);if(o){o.setVisible(s);}};
k.prototype.onBeforeClose=function(){this.bOpenedByKeyboardOrButton=false;};
k.prototype.getPicker=function(){var p=this.getAggregation("picker");if(p&&!p.bIsDestroyed&&!this.bIsDestroyed){return p;}return null;};
k.prototype._getSuggestionsPopover=function(){return this._oSuggestionPopover;};
k.prototype.getPickerTextField=function(){var p=this.getPicker(),s=p&&p.getSubHeader();return s&&s.getContent()[0]||null;};
k.prototype.getPickerTitle=function(){var p=this.getPicker(),H=p&&p.getCustomHeader();if(this.isPickerDialog()&&H){return H.getContentMiddle()[0];}return null;};
k.prototype.getRoleComboNodeDomRef=function(){var F=this.getFocusDomRef();if(!F){return null;}return F.parentNode;};
k.prototype.revertSelection=function(){};
k.prototype.hasContent=function(){return this.getItems().length>0;};
k.prototype.syncPickerContent=function(){};
k.prototype.findFirstEnabledItem=function(m){m=m||this.getItems();for(var i=0;i<m.length;i++){if(m[i].getEnabled()){return m[i];}}return null;};
k.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
k.prototype.open=function(){var p=this.getPicker();if(p){this._updateSuggestionsPopoverValueState();p.open();}return this;};
k.prototype.getVisibleItems=function(){for(var i=0,o,m=this.getItems(),v=[];i<m.length;i++){o=this.getListItem(m[i]);if(o&&o.getVisible()){v.push(m[i]);}}return v;};
k.prototype.isItemSelected=function(){};
k.prototype.getKeys=function(m){m=m||this.getItems();for(var i=0,n=[];i<m.length;i++){n[i]=m[i].getKey();}return n;};
k.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems());};
k.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,n=this.getItems();i<n.length;i++){if(n[i][m]()===v){return n[i];}}return null;};
k.prototype.getItemByText=function(t){return this.findItem("text",t);};
k.prototype.scrollToItem=function(i){var p=this.getPicker(),o=p.getDomRef("cont"),m=i&&i.getDomRef();if(!p||!o||!m){return;}var n=o.scrollTop,r=m.offsetTop,s=o.clientHeight,t=m.offsetHeight;if(n>r){o.scrollTop=r;}else if((r+t)>(n+s)){o.scrollTop=Math.ceil(r+t-s);}};
k.prototype.clearFilter=function(){this.getItems().forEach(function(i){var o=this.getListItem(i);if(o){o.setVisible(i.getEnabled()&&this.getSelectable(i));}},this);};
k.prototype.onItemChange=function(o){};
k.prototype.clearSelection=function(){};
k.prototype.setInternalBusyIndicator=function(B){this.bInitialBusyIndicatorState=this.getBusy();return this.setBusy.apply(this,arguments);};
k.prototype.setInternalBusyIndicatorDelay=function(i){this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();return this.setBusyIndicatorDelay.apply(this,arguments);};
k.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this._getList()){this._getList().addItem(this._mapItemToListItem(i));}return this;};
k.prototype.insertItem=function(i,m){this.insertAggregation("items",i,m,true);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this._getList()){this._getList().insertItem(this._mapItemToListItem(i),m);}this._scheduleOnItemsLoadedOnce();return this;};
k.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
k.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
k.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
k.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
k.prototype.getItemByKey=function(s){return this.findItem("key",s);};
k.prototype.addItemGroup=function(o,H,s){H=H||new a({text:o.text||o.key});this.addAggregation("items",H,s);if(this._getList()&&H.isA("sap.ui.core.SeparatorItem")){this._getList().addItem(this._mapItemToListItem(H));}return H;};
k.prototype._mapSeparatorItemToGroupHeader=function(s,o){var i=new G({title:s.getText(),ariaLabelledBy:this._getGroupHeaderInvisibleText().getId()});i.addStyleClass(o.CSS_CLASS_COMBOBOXBASE+"NonInteractiveItem");if(s.getText&&!s.getText()){i.addStyleClass(o.CSS_CLASS_COMBOBOXBASE+"SeparatorItemNoText");}return i;};
k.prototype.isOpen=function(){var p=this.getPicker();return!!(p&&p.isOpen());};
k.prototype.close=function(){var p=this.getPicker();if(p){p.close();}return this;};
k.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
k.prototype.removeAllItems=function(){var m=this.removeAllAggregation("items");this.clearSelection();for(var i=0;i<m.length;i++){m[i].detachEvent("_change",this.onItemChange,this);}return m;};
k.prototype.intersectItems=function(i,o){return i.filter(function(m){return o.map(function(O){return O.getId();}).indexOf(m.getId())!==-1;});};
k.prototype.showItems=function(F){var i=this.fnFilter,m=function(){if(!this.getItems().length){return;}this.detachLoadItems(m);this.setFilterFunction(F||function(){return true;});this.applyShowItemsFilters();this._handlePopupOpenAndItemsLoad(false);this.setFilterFunction(i);}.bind(this);if(!this.getEnabled()||!this.getEditable()){return;}this.attachLoadItems(m);this.loadItems(m);};
k.prototype.applyShowItemsFilters=function(){};
return k;});
sap.ui.predefine('sap/m/ComboBoxBaseRenderer',['./ComboBoxTextFieldRenderer','sap/ui/core/Renderer','sap/ui/core/Core'],function(C,R,a){"use strict";var b=R.extend(C);b.CSS_CLASS_COMBOBOXBASE="sapMComboBoxBase";
b.getAccessibilityState=function(c){var A=C.getAccessibilityState.call(this,c),l=c._getList();if(l){A.controls=l.getId();}return A;};
b.writeAccAttributes=function(r,c){C.writeAccAttributes.apply(this,arguments);if(a.getConfiguration().getAccessibility()){r.writeAttribute("aria-expanded",c.isOpen());}};
b.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);var d=b.CSS_CLASS_COMBOBOXBASE;r.addClass(d);if(!c.getEnabled()){r.addClass(d+"Disabled");}if(!c.getEditable()){r.addClass(d+"Readonly");}};
b.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.addClass(b.CSS_CLASS_COMBOBOXBASE+"Arrow");};
return b;},true);
sap.ui.predefine('sap/m/ComboBoxRenderer',['./ComboBoxBaseRenderer','sap/ui/core/Renderer'],function(C,R){"use strict";var a=R.extend(C);a.CSS_CLASS_COMBOBOX="sapMComboBox";
a.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX);};
a.addInnerClasses=function(r,c){C.addInnerClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX+"Inner");};
a.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX+"Arrow");};
a.addPlaceholderClasses=function(r,c){C.addPlaceholderClasses.apply(this,arguments);r.addClass(a.CSS_CLASS_COMBOBOX+"Placeholder");};
return a;},true);
sap.ui.predefine('sap/m/ComboBoxTextField',['./InputBase','./library','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/Device','sap/ui/core/LabelEnablement',"./ComboBoxTextFieldRenderer"],function(I,l,a,c,D,L,C){"use strict";
var b=I.extend("sap.m.ComboBoxTextField",{metadata:{library:"sap.m",properties:{maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},showButton:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_buttonLabelText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
b.prototype.init=function(){I.prototype.init.apply(this,arguments);var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var i=this.addEndIcon({id:this.getId()+"-arrow",src:"sap-icon://slim-arrow-down",noTabStop:true,alt:r.getText("COMBOBOX_BUTTON"),decorative:false});i.addAriaLabelledBy("");};
b.prototype.getIcon=function(){return this.getAggregation("_endIcon")[0];};
b.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.apply(this,arguments);var R=L.getReferencingLabels(this)||[];R.forEach(function(s){if(this.getIcon().getAriaLabelledBy().indexOf(s)===-1){this.getIcon().addAssociation("ariaLabelledBy",s,true);}},this);if(!this.oInvisibleText&&D.browser.msie){this.oInvisibleText=new a(this.getId()+'-describedby',{text:r.getText("ACC_CTR_TYPE_COMBO")}).toStatic();}};
b.prototype.setShowButton=function(s){this.getIcon().setVisible(s);return this.setProperty("showButton",s,true);};
b.prototype.getOpenArea=function(){var d=this.getIcon().getDomRef();return d?d.parentNode:d;};
b.prototype.onsapenter=function(e){I.prototype.onsapenter.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();var v=this.getValue(),V=v.length;this.setValue(v);this.selectText(V,V);};
b.prototype.getValue=function(){var d=this.getFocusDomRef();if(d){return d.value;}return this.getProperty("value");};
b.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
b.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_COMBO");return i;};
b.prototype.exit=function(){I.prototype.exit.apply(this,arguments);if(this.oInvisibleText){this.oInvisibleText.destroy();this.oInvisibleText=null;}};
return b;});
sap.ui.predefine('sap/m/ComboBoxTextFieldRenderer',['./InputBaseRenderer','sap/ui/core/Renderer','sap/ui/core/LabelEnablement','sap/ui/Device'],function(I,R,L,D){"use strict";var C=R.extend(I);C.CSS_CLASS_COMBOBOXTEXTFIELD="sapMComboBoxTextField";
C.writeInnerAttributes=function(r,c){r.writeAttribute("autocomplete","off");r.writeAttribute("autocorrect","off");r.writeAttribute("autocapitalize","off");r.writeAttribute("type","text");};
C.writeAccAttributes=function(r,c){if(sap.ui.getCore().getConfiguration().getAccessibility()){r.writeAttribute("aria-haspopup","listbox");r.writeAttribute("aria-autocomplete","inline");r.writeAttribute("role","combobox");}};
C.getAriaRole=function(){};
C.getAriaDescribedBy=function(c){var a=I.getAriaDescribedBy.apply(this,arguments);if(D.browser.msie){return(a||"")+" "+c.oInvisibleText.getId();}return a;};
C.addOuterStyles=function(r,c){r.addStyle("max-width",c.getMaxWidth());};
return C;},true);
sap.ui.predefine('sap/m/CustomListItem',['./ListItemBase','./library','./CustomListItemRenderer'],function(L,l,C){"use strict";
var a=L.extend("sap.m.CustomListItem",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designtime:"sap/m/designtime/CustomListItem.designtime"}});
a.prototype.getContentAnnouncement=function(){return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return a;});
sap.ui.predefine('sap/m/CustomListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var C=R.extend(L);C.apiVersion=2;
C.renderLIAttributes=function(r,l){r.class("sapMCLI");};
C.renderLIContent=function(r,l){l.getContent().forEach(r.renderControl,r);};
return C;},true);
sap.ui.predefine('sap/m/CustomTile',['./Tile','./library','./CustomTileRenderer'],function(T,l,C){"use strict";
var a=T.extend("sap.m.CustomTile",{metadata:{library:"sap.m",designtime:"sap/m/designtime/CustomTile.designtime",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:false}}}});
return a;});
sap.ui.predefine('sap/m/CustomTileRenderer',['./TileRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var C=R.extend(T);
C.render=function(r,c){var t,v;r.write("<div tabindex=\"0\"");r.writeControlData(c);r.addClass("sapMCustomTile");r.writeClasses();if(c._invisible){r.addStyle("visibility","hidden");r.writeStyles();}if(c.getParent()instanceof sap.m.TileContainer){t=c.getParent();v=t._getVisibleTiles();r.writeAccessibilityState(c,{role:"option",posinset:t._indexOfVisibleTile(c,v)+1,setsize:v.length});}r.write(">");r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCRemove\"></div>");r.write("<div class=\"sapMCustomTileContent\">");this._renderContent(r,c);r.write("</div></div>");};
C._renderContent=function(r,t){r.renderControl(t.getContent());};
return C;},true);
sap.ui.predefine('sap/m/DatePicker',['sap/ui/thirdparty/jquery','sap/ui/Device','./InputBase','./DateTimeField','./Button','./ResponsivePopover','sap/ui/core/date/UniversalDate','./library','sap/ui/core/Control','sap/ui/core/library',"./DatePickerRenderer","sap/base/util/deepEqual","sap/base/assert","sap/base/Log","sap/ui/core/IconPool","./InstanceManager","sap/ui/unified/Calendar","sap/ui/unified/DateRange","sap/ui/unified/calendar/CustomMonthPicker","sap/ui/unified/calendar/CustomYearPicker","sap/ui/dom/jquery/cursorPos"],function(q,D,I,a,B,R,U,l,C,c,b,d,e,L,f,g,h,i,j,k){"use strict";var m=c.CalendarType;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var n=a.extend("sap.m.DatePicker",{metadata:{library:"sap.m",properties:{displayFormatType:{type:"string",group:"Appearance",defaultValue:""},secondaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance",defaultValue:null},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null},showFooter:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{specialDates:{type:"sap.ui.core.Element",multiple:true,singularName:"specialDate"},_popup:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},associations:{legend:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{parameters:{dateRange:{type:"sap.ui.unified.DateRange"},afterPopupOpened:{type:"boolean"}}}},designtime:"sap/m/designtime/DatePicker.designtime",dnd:{draggable:false,droppable:true}}});
n.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=false;this._bOnlyCalendar=true;this._bValid=true;this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);this._oMaxDate=new Date(9999,11,31,23,59,59,999);var x=this.addEndIcon({id:this.getId()+"-icon",src:this.getIconSrc(),noTabStop:true,tooltip:r.getText("OPEN_PICKER_TEXT")});this._bShouldClosePicker=false;x.addEventDelegate({onmousedown:function(E){this._bShouldClosePicker=!!this.isOpen();}},this);x.attachPress(function(){this.toggleOpen(this._bShouldClosePicker);},this);};
n.prototype.isValidValue=function(){return this._bValid;};
n.prototype.isOpen=function(){return this._oPopup&&this._oPopup.isOpen();};
n.prototype.toggleOpen=function(O){if(this.getEditable()&&this.getEnabled()){if(O){o.call(this);}else{_.call(this);}}};
n.prototype.getIconSrc=function(){return f.getIconURI("appointment-2");};
n.prototype.exit=function(){I.prototype.exit.apply(this,arguments);if(this._oPopup){if(this._oPopup.isOpen()){this._oPopup.close();}delete this._oPopup;}if(this._getCalendar()){this._getCalendar().destroy();delete this._getCalendar();}if(this._iInvalidateCalendar){clearTimeout(this._iInvalidateCalendar);}this._sUsedDisplayPattern=undefined;this._sUsedDisplayCalendarType=undefined;this._oDisplayFormat=undefined;this._sUsedValuePattern=undefined;this._sUsedValueCalendarType=undefined;this._oValueFormat=undefined;};
n.prototype.invalidate=function(O){if(!O||O!=this._getCalendar()){C.prototype.invalidate.apply(this,arguments);this._iInvalidateCalendar=setTimeout(w.bind(this),0);}};
n.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this._checkMinMaxDate();var V=this._getValueHelpIcon();if(V){V.setProperty("visible",this.getEditable(),true);}};
n.prototype.setWidth=function(W){return I.prototype.setWidth.call(this,W||"100%");};
n.prototype.getWidth=function(W){return this.getProperty("width")||"100%";};
n.prototype.applyFocusInfo=function(F){this._bFocusNoPopup=true;if(!D.support.touch||D.system.desktop){I.prototype.applyFocusInfo.apply(this,arguments);}};
n.prototype.onfocusin=function(E){if(!q(E.target).hasClass("sapUiIcon")){I.prototype.onfocusin.apply(this,arguments);}this._bFocusNoPopup=undefined;};
n.prototype.onsapshow=function(E){this.toggleOpen(this.isOpen());E.preventDefault();};
n.prototype.onsaphide=n.prototype.onsapshow;
n.prototype.onsappageup=function(E){p.call(this,1,"day");E.preventDefault();};
n.prototype.onsappageupmodifiers=function(E){if(!E.ctrlKey&&E.shiftKey){p.call(this,1,"month");}else{p.call(this,1,"year");}E.preventDefault();};
n.prototype.onsappagedown=function(E){p.call(this,-1,"day");E.preventDefault();};
n.prototype.onsappagedownmodifiers=function(E){if(!E.ctrlKey&&E.shiftKey){p.call(this,-1,"month");}else{p.call(this,-1,"year");}E.preventDefault();};
n.prototype.onkeypress=function(E){if(!E.charCode||E.metaKey||E.ctrlKey){return;}var F=this._getFormatter(true);var x=String.fromCharCode(E.charCode);if(x&&F.sAllowedCharacters&&F.sAllowedCharacters.indexOf(x)<0){E.preventDefault();}};
n.prototype._getValueHelpIcon=function(){var V=this.getAggregation("_endIcon");return V&&V[0];};
n.prototype._dateValidation=function(x){this._bValid=true;if(x&&(x.getTime()<this._oMinDate.getTime()||x.getTime()>this._oMaxDate.getTime())){this._bValid=false;e(this._bValid,"Date must be in valid range");}this.setProperty("dateValue",x);return x;};
n.prototype.setMinDate=function(x){if(this._isValidDate(x)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getMinDate(),x)){return this;}if(x){var y=x.getFullYear();if(y<1||y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMinDate=new Date(x.getTime());var z=this.getDateValue();if(z&&z.getTime()<x.getTime()){this._bValid=false;L.warning("DateValue not in valid date range",this);}}else{this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);}this.setProperty("minDate",x);if(this._getCalendar()){this._getCalendar().setMinDate(x);}this._oMinDate.setHours(0,0,0,0);return this;};
n.prototype.setMaxDate=function(x){if(this._isValidDate(x)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getMaxDate(),x)){return this;}if(x){var y=x.getFullYear();if(y<1||y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMaxDate=new Date(x.getTime());var z=this.getDateValue();if(z&&z.getTime()>x.getTime()){this._bValid=false;L.warning("DateValue not in valid date",this);}}else{this._oMaxDate=new Date(9999,11,31,23,59,59,999);}this.setProperty("maxDate",x);if(this._getCalendar()){this._getCalendar().setMaxDate(x);}this._oMaxDate.setHours(23,59,59,999);return this;};
n.prototype._checkMinMaxDate=function(){if(this._oMinDate.getTime()>this._oMaxDate.getTime()){L.warning("minDate > MaxDate -> dates switched",this);var M=new Date(this._oMinDate.getTime());var x=new Date(this._oMaxDate.getTime());this._oMinDate=new Date(x.getTime());this._oMaxDate=new Date(M.getTime());this.setProperty("minDate",x,true);this.setProperty("maxDate",M,true);if(this._getCalendar()){this._getCalendar().setMinDate(x);this._getCalendar().setMaxDate(M);}}var y=this.getDateValue();if(y&&(y.getTime()<this._oMinDate.getTime()||y.getTime()>this._oMaxDate.getTime())){this._bValid=false;L.error("dateValue "+y.toString()+"(value="+this.getValue()+") does not match "+"min/max date range("+this._oMinDate.toString()+" - "+this._oMaxDate.toString()+"). App. "+"developers should take care to maintain dateValue/value accordingly.",this);}};
n.prototype.getDisplayFormatType=function(){return this.getProperty("displayFormatType");};
n.prototype._handleDateValidation=function(x){this._bValid=true;if(!x||x.getTime()<this._oMinDate.getTime()||x.getTime()>this._oMaxDate.getTime()){this._bValid=false;L.warning("Value can not be converted to a valid date",this);}this.setProperty("dateValue",x);};
n.prototype.setDisplayFormatType=function(x){if(x){var F=false;for(var T in m){if(T==x){F=true;break;}}if(!F){throw new Error(x+" is not a valid calendar type"+this);}}this.setProperty("displayFormatType",x,true);this.setDisplayFormat(this.getDisplayFormat());return this;};
n.prototype.setSecondaryCalendarType=function(x){this._bSecondaryCalendarTypeSet=true;this.setProperty("secondaryCalendarType",x,true);if(this._getCalendar()){this._getCalendar().setSecondaryCalendarType(x);}return this;};
n.prototype.setShowFooter=function(F){var P=this._oPopup,x=this._getCalendar();this.setProperty("showFooter",F);if(!P||!x){return this;}P._getButtonFooter().setVisible(F);return this;};
n.prototype.addSpecialDate=function(S){v.call(this,S);this.addAggregation("specialDates",S,true);w.call(this);return this;};
n.prototype.insertSpecialDate=function(S,x){v.call(this,S);this.insertAggregation("specialDates",S,x,true);w.call(this);return this;};
n.prototype.removeSpecialDate=function(S){var x=this.removeAggregation("specialDates",S,true);w.call(this);return x;};
n.prototype.removeAllSpecialDates=function(){var x=this.removeAllAggregation("specialDates",true);w.call(this);return x;};
n.prototype.destroySpecialDates=function(){this.destroyAggregation("specialDates",true);w.call(this);return this;};
n.prototype.setLegend=function(x){this.setAssociation("legend",x,true);var y=this.getLegend();if(y){var z=sap.ui.require("sap/ui/unified/CalendarLegend");x=sap.ui.getCore().byId(y);if(x&&!(typeof z=="function"&&x instanceof z)){throw new Error(x+" is not an sap.ui.unified.CalendarLegend. "+this);}}if(this._getCalendar()){this._getCalendar().setLegend(y);}return this;};
n.prototype.onChange=function(E){if(!this.getEditable()||!this.getEnabled()){return;}var V=this._$input.val(),O=this._formatValue(this.getDateValue()),x;if(V==O&&this._bValid){return;}if(this.getShowFooter()&&this._oPopup&&!V){this._oPopup.getBeginButton().setEnabled(false);}this._bValid=true;if(V!=""){x=this._parseValue(V,true);if(!x||x.getTime()<this._oMinDate.getTime()||x.getTime()>this._oMaxDate.getTime()){this._bValid=false;x=undefined;}else{V=this._formatValue(x);}}if(this.getDomRef()&&(this._$input.val()!==V)){this._$input.val(V);this._curpos=this._$input.cursorPos();}if(x){V=this._formatValue(x,true);}if(this._lastValue!==V||(x&&this.getDateValue()&&x.getFullYear()!==this.getDateValue().getFullYear())){this._lastValue=V;this.setProperty("value",V,true);var N=this.getValue();if(this._bValid&&V==N){this.setProperty("dateValue",x,true);}V=N;if(this.isOpen()){if(this._bValid){x=this.getDateValue();}this._getCalendar().focusDate(x);var S=this._oDateRange.getStartDate();if((!S&&x)||(S&&x&&S.getTime()!=x.getTime())){this._oDateRange.setStartDate(new Date(x.getTime()));}else if(S&&!x){this._oDateRange.setStartDate(undefined);}}this.fireChangeEvent(V,{valid:this._bValid});}};
n.prototype._getInputValue=function(V){V=(typeof V=="undefined")?this._$input.val():V.toString();var x=this._parseValue(V,true);V=this._formatValue(x,true);return V;};
n.prototype.updateDomValue=function(V){if(this.isActive()&&(this._$input.val()!==V)){this._bCheckDomValue=true;V=(typeof V=="undefined")?this._$input.val():V.toString();this._curpos=this._$input.cursorPos();var x=this._parseValue(V,true);V=this._formatValue(x);this._$input.val(V);this._$input.cursorPos(this._curpos);}return this;};
n.prototype._storeInputSelection=function(x){if((D.browser.msie||D.browser.edge)&&!D.support.touch){this._oInputSelBeforePopupOpen={iStart:x.selectionStart,iEnd:x.selectionEnd};x.selectionStart=0;x.selectionEnd=0;}};
n.prototype._restoreInputSelection=function(x){if((D.browser.msie||D.browser.edge)&&!D.support.touch){x.selectionStart=this._oInputSelBeforePopupOpen.iStart;x.selectionEnd=this._oInputSelBeforePopupOpen.iEnd;}};
function _(){this._createPopup();this._createPopupContent();var x;var y=this.getBinding("value");if(y&&y.oType&&y.oType.oOutputFormat){x=y.oType.oOutputFormat.oFormatOptions.calendarType;}else if(y&&y.oType&&y.oType.oFormat){x=y.oType.oFormat.oFormatOptions.calendarType;}if(!x){x=this.getDisplayFormatType();}if(x){this._getCalendar().setPrimaryCalendarType(x);}var V=this._bValid?this._formatValue(this.getDateValue()):this.getValue();if(V!=this._$input.val()){this.onChange();}this._fillDateRange();this._openPopup();this.fireNavigate({dateRange:this._getVisibleDatesRange(this._getCalendar()),afterPopupOpened:true});}
n.prototype._createPopup=function(){var A,x;if(!this._oPopup){this._oPopup=new R(this.getId()+"-RP",{showCloseButton:false,showArrow:false,showHeader:false,placement:l.PlacementType.VerticalPreferedBottom}).addStyleClass("sapMRPCalendar");this._oPopup._getPopup().setAutoClose(true);this._oPopup.attachAfterOpen(s,this);this._oPopup.attachAfterClose(t,this);this._oPopup.setBeginButton(new B({text:r.getText("DATEPICKER_SELECTION_CONFIRM"),press:this._handleOKButton.bind(this)}));if(D.system.phone){A=this.$("inner").attr("aria-labelledby");x=A?document.getElementById(A).getAttribute("aria-label"):"";this._oPopup.setTitle(x);this._oPopup.setShowHeader(true);this._oPopup.setShowCloseButton(true);}else{this._oPopup._getPopup().setDurations(0,0);this._oPopup.getBeginButton().setType(l.ButtonType.Emphasized);this._oPopup.setEndButton(new B({text:r.getText("DATEPICKER_SELECTION_CANCEL"),press:this._handleCancelButton.bind(this)}));}this.setAggregation("_popup",this._oPopup,true);}};
n.prototype._openPopup=function(){if(!this._oPopup){return;}this._storeInputSelection(this._$input.get(0));this._oPopup._getPopup().setAutoCloseAreas([this.getDomRef()]);this._oPopup.openBy(this);};
n.prototype._getVisibleDatesRange=function(x){var V=x._getVisibleDays();return new i({startDate:V[0].toLocalJSDate(),endDate:V[V.length-1].toLocalJSDate()});};
n.prototype._createPopupContent=function(){var P=this._getFormatter(true).aFormatArray.map(function(A){return A.type.toLowerCase();}),x=P.indexOf("day")>=0,M=P.indexOf("month")>=0,y=P.indexOf("year")>=0,z;if(!this._getCalendar()){if(x&&M&&y){z=h;}else if(M&&y){z=j;}else if(y){z=k;}else{z=h;L.warning("Not valid date pattern! Openning default Calendar",this);}this._oCalendar=new z(this.getId()+"-cal",{intervalSelection:this._bIntervalSelection,minDate:this.getMinDate(),maxDate:this.getMaxDate(),legend:this.getLegend(),startDateChange:function(){this.fireNavigate({dateRange:this._getVisibleDatesRange(this._getCalendar())});}.bind(this)});this._oDateRange=new i();this._getCalendar().addSelectedDate(this._oDateRange);this._getCalendar()._setSpecialDatesControlOrigin(this);if(this.$().closest(".sapUiSizeCompact").length>0){this._getCalendar().addStyleClass("sapUiSizeCompact");}if(this._bSecondaryCalendarTypeSet){this._getCalendar().setSecondaryCalendarType(this.getSecondaryCalendarType());}if(this._bOnlyCalendar){this._getCalendar().attachSelect(this._handleCalendarSelect,this);this._getCalendar().attachCancel(o,this);this._getCalendar().attachEvent("_renderMonth",u,this);this._oPopup._getButtonFooter().setVisible(this.getShowFooter());this._getCalendar()._bSkipCancelButtonRendering=true;this._oPopup.addContent(this._getCalendar());if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}}}};
n.prototype._fillDateRange=function(){var x=this.getDateValue();if(x&&x.getTime()>=this._oMinDate.getTime()&&x.getTime()<=this._oMaxDate.getTime()){this._getCalendar().focusDate(new Date(x.getTime()));if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=x.getTime()){this._oDateRange.setStartDate(new Date(x.getTime()));}}else{var y=this.getInitialFocusedDateValue();var F=y?y:new Date();var M=this._oMaxDate.getTime();if(F.getTime()<this._oMinDate.getTime()||F.getTime()>M){F=this._oMinDate;}this._getCalendar().focusDate(F);if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}};
n.prototype.getAccessibilityInfo=function(){var x=this.getRenderer();var y=I.prototype.getAccessibilityInfo.apply(this,arguments);var V=this.getValue()||"";if(this._bValid){var z=this.getDateValue();if(z){V=this._formatValue(z);}}y.type=r.getText("ACC_CTR_TYPE_DATEINPUT");y.description=[V,x.getLabelledByAnnouncement(this),x.getDescribedByAnnouncement(this)].join(" ").trim();return y;};
n.prototype._selectDate=function(){var x=this.getDateValue(),y=this._getSelectedDate(),V="";if(!d(y,x)){this.setDateValue(new Date(y.getTime()));V=this.getValue();this.fireChangeEvent(V,{valid:true});this._focusInput();}else if(!this._bValid){V=this._formatValue(y);if(V!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(V);this._lastValue=V;}V=this._formatValue(y,true);this.setProperty("value",V,true);this.fireChangeEvent(V,{valid:true});this._focusInput();}}else if(D.system.desktop||!D.support.touch){this.focus();}this._oPopup.close();};
n.prototype._handleCalendarSelect=function(){if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(true);return;}this._selectDate();};
n.prototype._focusInput=function(){if(this.getDomRef()&&(D.system.desktop||!D.support.touch)){this._curpos=this._$input.val().length;this._$input.cursorPos(this._curpos);}return this;};
n.prototype._getCalendar=function(){return this._oCalendar;};
n.prototype._getSelectedDate=function(){var S=this._getCalendar().getSelectedDates(),x;if(S.length>0){x=S[0].getStartDate();}return x;};
n.prototype._handleOKButton=function(){this._selectDate();};
n.prototype._handleCancelButton=function(){if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}this._oPopup.close();};
function o(E){if(this.isOpen()){this._oPopup.close();if((D.system.desktop||!D.support.touch)){this.focus();}}}
function p(N,x){var O=this.getDateValue();var y=this._$input.cursorPos();if(O&&this.getEditable()&&this.getEnabled()){var z;var A=this.getBinding("value");if(A&&A.oType&&A.oType.oOutputFormat){z=A.oType.oOutputFormat.oFormatOptions.calendarType;}else if(A&&A.oType&&A.oType.oFormat){z=A.oType.oFormat.oFormatOptions.calendarType;}if(!z){z=this.getDisplayFormatType();}var E=U.getInstance(new Date(O.getTime()),z);O=U.getInstance(new Date(O.getTime()),z);switch(x){case"day":E.setDate(E.getDate()+N);break;case"month":E.setMonth(E.getMonth()+N);var M=(O.getMonth()+N)%12;if(M<0){M=12+M;}while(E.getMonth()!=M){E.setDate(E.getDate()-1);}break;case"year":E.setFullYear(E.getFullYear()+N);while(E.getMonth()!=O.getMonth()){E.setDate(E.getDate()-1);}break;default:break;}if(E.getTime()<this._oMinDate.getTime()){E=new U(this._oMinDate.getTime());}else if(E.getTime()>this._oMaxDate.getTime()){E=new U(this._oMaxDate.getTime());}if(!d(this.getDateValue(),E.getJSDate())){this.setDateValue(new Date(E.getTime()));this._curpos=y;this._$input.cursorPos(this._curpos);var V=this.getValue();this.fireChangeEvent(V,{valid:true});}}}
function s(){this._getCalendar().focus();this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);this._renderedDays=this._getCalendar().$("-Month0-days").find(".sapUiCalItem").length;this.$("inner").attr("aria-owns",this.getId()+"-cal");this.$("inner").attr("aria-expanded",true);g.addPopoverInstance(this._oPopup);}
function t(){if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.$("inner").attr("aria-expanded",false);this._restoreInputSelection(this._$input.get(0));this._getCalendar()._closedPickers();g.removePopoverInstance(this._oPopup);}
function u(E){var x=E.getParameter("days"),P=this._oPopup._getPopup();if(x>this._renderedDays){this._renderedDays=x;P._applyPosition(P._oLastPosition);}}
function v(S){var x=sap.ui.require("sap/ui/unified/DateTypeRange");if(S&&!(x&&S instanceof x)){throw new Error(S+"is not valid for aggregation \"specialDates\" of "+this);}}
function w(){if(this.isOpen()){this._getCalendar()._bDateRangeChanged=false;this._getCalendar().invalidate();}}
return n;});
sap.ui.predefine('sap/m/DatePickerRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var D=R.extend(I);D.apiVersion=2;
D.writeInnerValue=function(r,d){if(d._bValid){r.attr("value",d._formatValue(d.getDateValue()));}else{r.attr("value",d.getValue());}};
D.writeInnerAttributes=function(r,d){r.attr("type","text");if(d._bMobile){r.attr("readonly","readonly");}};
D.getAriaRole=function(d){return"combobox";};
D.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATEPICKER_DATE_TYPE")+" "+b;};
D.getAccessibilityState=function(d){var a=I.getAccessibilityState.apply(this,arguments);a["autocomplete"]="none";a["haspopup"]=true;a["expanded"]=false;a["disabled"]=null;if(d._bMobile&&d.getEnabled()&&d.getEditable()){a["readonly"]=false;}return a;};
return D;},true);
sap.ui.predefine('sap/m/DateRangeSelection',['sap/ui/Device','./DatePicker','./library','sap/ui/core/LocaleData','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate','./DateRangeSelectionRenderer',"sap/base/util/deepEqual","sap/base/Log","sap/base/assert","sap/ui/dom/jquery/cursorPos"],function(D,a,l,L,b,U,c,d,f,g){"use strict";
var h=a.extend("sap.m.DateRangeSelection",{metadata:{library:"sap.m",properties:{delimiter:{type:"string",group:"Misc",defaultValue:'-'},secondDateValue:{type:"object",group:"Data",defaultValue:null},from:{type:"object",group:"Misc",defaultValue:null,deprecated:true},to:{type:"object",group:"Misc",defaultValue:null,deprecated:true}},designtime:"sap/m/designtime/DateRangeSelection.designtime",dnd:{draggable:false,droppable:true}}});
var H=String.fromCharCode(45),E=String.fromCharCode(8211),j=String.fromCharCode(8212);
h.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=true;};
h.prototype.onkeypress=function(e){if(!e.charCode||e.metaKey||e.ctrlKey){return;}var F=q.call(this);var i=p.call(this);var A=F.sAllowedCharacters+i+" ";var C=String.fromCharCode(e.charCode);if(C&&F.sAllowedCharacters&&A.indexOf(C)<0){e.preventDefault();}};
h.prototype._getPlaceholder=function(){var P=this.getPlaceholder(),B,e,i,u;if(!P){B=this.getBinding("value");i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();u=L.getInstance(i);if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){e=B.getType();if(e.oFormatOptions&&e.oFormatOptions.format){P=u.getCustomDateTimePattern(e.oFormatOptions.format);}else{P=u.getDatePattern("medium");}}else{P=this.getDisplayFormat();if(!P){P="medium";}if(this._checkStyle(P)){P=u.getDatePattern(P);}}var v=p.call(this);if(v&&v!==""){P=P+" "+v+" "+P;}}return P;};
h.prototype.setValue=function(v){if(v!==this.getValue()){this._lastValue=v;}else{return this;}this.setProperty("value",v);this._bValid=true;var e=[undefined,undefined];if(v){e=this._parseValue(v);if(!n.call(this,e[0],e[1])[0]){this._bValid=false;f.warning("Value can not be converted to a valid dates",this);}}this.setProperty("dateValue",_(e[0]));this.setProperty("secondDateValue",_(e[1]));if(this.getDomRef()){var O=this._formatValue(e[0],e[1]);if(this._$input.val()!==O){this._$input.val(O);this._curpos=this._$input.cursorPos();}}return this;};
function _(B){return(typeof B==='number')?new Date(B):B;}
function k(B){return(B&&B.getTime)?B.getTime():B;}
h.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);f.warning("Property valueFormat is not supported in sap.m.DateRangeSelection control.",this);return this;};
h.prototype.setDisplayFormat=function(e){this.setProperty("displayFormat",e,true);var O=this._formatValue(this.getDateValue(),this.getSecondDateValue());this.setProperty("value",O,true);if(this.getDomRef()&&(this._$input.val()!==O)){this._$input.val(O);this._curpos=this._$input.cursorPos();}return this;};
h.prototype.setFrom=function(F){this.setDateValue(F);return this;};
h.prototype.getFrom=function(){return this.getDateValue();};
h.prototype.setTo=function(T){this.setSecondDateValue(T);return this;};
h.prototype.getTo=function(){return this.getSecondDateValue();};
h.prototype.setDateValue=function(e){if(this._isValidDate(e)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getDateValue(),e)){return this;}a.prototype._dateValidation.call(this,e);this._syncDateObjectsToValue(e,this.getSecondDateValue());return this;};
h.prototype.setSecondDateValue=function(S){if(this._isValidDate(S)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getSecondDateValue(),S)){return this;}this._bValid=true;if(S&&(S.getTime()<this._oMinDate.getTime()||S.getTime()>this._oMaxDate.getTime())){this._bValid=false;g(this._bValid,"Date must be in valid range");}this.setProperty("secondDateValue",S);this._syncDateObjectsToValue(this.getDateValue(),S);return this;};
h.prototype.setMinDate=function(e){a.prototype.setMinDate.apply(this,arguments);if(e){var S=this.getSecondDateValue();if(S&&S.getTime()<this._oMinDate.getTime()){f.warning("SecondDateValue not in valid date range",this);}}return this;};
h.prototype.setMaxDate=function(e){a.prototype.setMaxDate.apply(this,arguments);if(e){var S=this.getSecondDateValue();if(S&&S.getTime()>this._oMaxDate.getTime()){f.warning("SecondDateValue not in valid date range",this);}}return this;};
h.prototype._checkMinMaxDate=function(){a.prototype._checkMinMaxDate.apply(this,arguments);var S=this.getSecondDateValue();if(S&&(S.getTime()<this._oMinDate.getTime()||S.getTime()>this._oMaxDate.getTime())){f.error("secondDateValue "+S.toString()+"(value="+this.getValue()+") does not match "+"min/max date range("+this._oMinDate.toString()+" - "+this._oMaxDate.toString()+"). App. "+"developers should take care to maintain secondDateValue/value accordingly.",this);}};
h.prototype._parseValue=function(v){var F;var i=[];var u,w;var B=this.getBinding("value");if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){try{i=B.getType().parseValue(v,"string");}catch(e){return[undefined,undefined];}if(B.getType().oFormatOptions&&B.getType().oFormatOptions.UTC){i=i.map(function(z){return new Date(z.getUTCFullYear(),z.getUTCMonth(),z.getUTCDate(),z.getUTCHours(),z.getUTCMinutes(),z.getUTCSeconds());});}return i;}var x=p.call(this);if(x&&v){v=v.trim();v=t(v,[x," "]);i=this._splitValueByDelimiter(v,x);if(i.length===2){if(i[0].slice(i[0].length-1,i[0].length)==" "){i[0]=i[0].slice(0,i[0].length-1);}if(i[1].slice(0,1)==" "){i[1]=i[1].slice(1);}}else{i=v.split(" "+x+" ");}if(v.indexOf(x)===-1){var y=v.split(" ");if(y.length===2){i=y;}}}if(v&&i.length<=2){F=q.call(this);if((!x||x==="")||i.length===1){u=F.parse(v);}else if(i.length===2){u=F.parse(i[0]);w=F.parse(i[1]);if(!u||!w){u=undefined;w=undefined;}}}return[u,w];};
h.prototype._splitValueByDelimiter=function(v,e){var u=[H,E,j],i;if(e){if(u.indexOf(e)===-1){return v.split(e);}}for(i=0;i<u.length;i++){if(v.indexOf(u[i])>0){return v.split(u[i]);}}return v?v.split(" "):[];};
h.prototype._formatValue=function(e,S){var v="",i=p.call(this),F,B,u,w;u=e;w=S;if(u){B=this.getBinding("value");if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){if(B.getType().oFormatOptions&&B.getType().oFormatOptions.source&&B.getType().oFormatOptions.source.pattern==="timestamp"){v=B.getType().formatValue([k(e),k(S)],"string");}else{if(B.getType().oFormatOptions&&B.getType().oFormatOptions.UTC){u=new Date(Date.UTC(e.getFullYear(),e.getMonth(),e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()));if(S){w=new Date(Date.UTC(S.getFullYear(),S.getMonth(),S.getDate(),S.getHours(),S.getMinutes(),S.getSeconds()));}}v=B.getType().formatValue([u,w],"string");}}else{F=q.call(this);if(i&&i!==""&&w){v=F.format(u)+" "+i+" "+F.format(w);}else{v=F.format(u);}}}return v;};
h.prototype.onChange=function(){if(!this.getEditable()||!this.getEnabled()){return;}var v=this._$input.val();var e=[undefined,undefined];if(this.getShowFooter()&&this._oPopup&&!v){this._oPopup.getBeginButton().setEnabled(false);}this._bValid=true;if(v!=""){e=this._parseValue(v);e[1]&&e[1].setHours(23,59,59,999);e=n.call(this,e[0],e[1]);if(e[0]){v=this._formatValue(e[0],e[1]);}else{this._bValid=false;}}if(v!==this._lastValue){if(this.getDomRef()&&(this._$input.val()!==v)){this._$input.val(v);this._curpos=this._$input.cursorPos();}this._lastValue=v;this.setProperty("value",v,true);if(this._bValid){this.setProperty("dateValue",_(e[0]),true);this.setProperty("secondDateValue",_(e[1]),true);}if(this._oPopup&&this._oPopup.isOpen()){var S=this.getDateValue();if(S){if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!==S.getTime()){this._oDateRange.setStartDate(new Date(S.getTime()));this._getCalendar().focusDate(S);}}else{if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}var i=this.getSecondDateValue();if(i){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==i.getTime()){this._oDateRange.setEndDate(new Date(i.getTime()));this._getCalendar().focusDate(i);}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}}m.call(this,this._bValid);}};
h.prototype._getInputValue=function(v){v=(typeof v=="undefined")?this._$input.val():v.toString();var e=this._parseValue(v);v=this._formatValue(e[0],e[1]);return v;};
h.prototype.updateDomValue=function(v){this._bCheckDomValue=true;v=(typeof v=="undefined")?this._$input.val():v.toString();this._curpos=this._$input.cursorPos();var e=this._parseValue(v);v=this._formatValue(e[0],e[1]);if(this.isActive()&&(this._$input.val()!==v)){this._$input.val(v);this._$input.cursorPos(this._curpos);}return this;};
h.prototype.onsappageup=function(e){this._increaseDateRange(1,"day");e.preventDefault();};
h.prototype.onsappageupmodifiers=function(e){if(e.shiftKey&&!e.ctrlKey){this._increaseDateRange(1,"month");}else if(e.shiftKey&&e.ctrlKey){this._increaseDateRange(1,"year");}e.preventDefault();};
h.prototype.onsappagedown=function(e){this._increaseDateRange(-1,"day");e.preventDefault();};
h.prototype.onsappagedownmodifiers=function(e){if(e.shiftKey&&!e.ctrlKey){this._increaseDateRange(-1,"month");}else if(e.shiftKey&&e.ctrlKey){this._increaseDateRange(-1,"year");}e.preventDefault();};
h.prototype._fillDateRange=function(){a.prototype._fillDateRange.apply(this,arguments);var e=this.getSecondDateValue();if(e&&e.getTime()>=this._oMinDate.getTime()&&e.getTime()<=this._oMaxDate.getTime()){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==e.getTime()){this._oDateRange.setEndDate(new Date(e.getTime()));}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}};
h.prototype._selectDate=function(){var S=this._getCalendar().getSelectedDates();if(S.length>0){var e=S[0].getStartDate();var i=S[0].getEndDate();if(e&&i){var u=this.getDateValue();var v=this.getSecondDateValue();i.setHours(23,59,59,999);var V;if(!d(e,u)||!d(i,v)){if(d(i,v)){this.setDateValue(e);}else{this.setProperty("dateValue",e,true);this.setSecondDateValue(i);}V=this.getValue();m.call(this,true);if(D.system.desktop||!D.support.touch){this._curpos=V.length;this._$input.cursorPos(this._curpos);}}else if(!this._bValid){V=this._formatValue(e,i);if(V!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(V);}m.call(this,true);}}this._oPopup.close();}}};
h.prototype._handleCalendarSelect=function(){var S=this._getCalendar().getSelectedDates(),e=S[0].getStartDate(),i=S[0].getEndDate();if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(!!(e&&i));return;}this._selectDate();};
h.prototype.getAccessibilityInfo=function(){var R=this.getRenderer();var i=a.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var e=this.getDateValue();if(e){v=this._formatValue(e,this.getSecondDateValue());}}i.description=[v,R.getLabelledByAnnouncement(this),R.getDescribedByAnnouncement(this)].join(" ").trim();return i;};
h.prototype._syncDateObjectsToValue=function(e,S){var v=this._formatValue(e,S);if(v!==this.getValue()){this._lastValue=v;}this.setProperty("value",v);if(this.getDomRef()){var O=this._formatValue(e,S);if(this._$input.val()!==O){this._$input.val(O);this._curpos=this._$input.cursorPos();}}};
function m(v){this.fireChangeEvent(this.getValue(),{from:this.getDateValue(),to:this.getSecondDateValue(),valid:v});}
function n(e,S){var F,i;if(e&&e.getTime){F=e.getTime();}else if(typeof e==='number'){F=e;}if(S&&S.getTime){i=S.getTime();}else if(typeof S==='number'){i=S;}if(e&&S&&F>i){var T=e;e=S;S=T;}if((e&&(F<this._oMinDate.getTime()||F>this._oMaxDate.getTime()))||(S&&(i<this._oMinDate.getTime()||i>this._oMaxDate.getTime()))){return[undefined,undefined];}else{return[e,S];}}
h.prototype._increaseDateRange=function(N,u){var v=this._$input.val(),e=this._parseValue(v),F=e[0],S=e[1],i=q.call(this),w=p.call(this),C,x,y,V,z,A,B;if(!this.getEditable()||!this.getEnabled()){return;}if(!n.call(this,F,S)[0]){f.warning("Value can not be converted to a valid dates or dates are outside of the min/max range",this);this._bValid=false;m.call(this,this._bValid);return;}v=t(v,[w," "]);C=this._$input.cursorPos();x=i.format(F).length;y=i.format(S).length;V=v.length;z=C<=x+1;A=C>=V-y-1&&C<=V;if(z&&F){B=o.call(this,F,N,u);if(!d(this.getDateValue(),B.getJSDate())){this.setDateValue(new Date(B.getTime()));this._curpos=C;this._$input.cursorPos(this._curpos);this.fireChangeEvent(this.getValue(),{valid:this._bValid});}}else if(A&&S){B=o.call(this,S,N,u);if(!d(this.getSecondDateValue(),B.getJSDate())){this.setSecondDateValue(new Date(B.getTime()));this._curpos=C;this._$input.cursorPos(this._curpos);this.fireChangeEvent(this.getValue(),{valid:this._bValid});}}};
function o(O,N,u){var B=this.getBinding("value"),C,M,e,i;if(B&&B.oType&&B.oType.oOutputFormat){C=B.oType.oOutputFormat.oFormatOptions.calendarType;}else if(B&&B.oType&&B.oType.oFormat){C=B.oType.oFormat.oFormatOptions.calendarType;}if(!C){C=this.getDisplayFormatType();}e=U.getInstance(new Date(O.getTime()),C);i=e.getMonth();switch(u){case"day":e.setDate(e.getDate()+N);break;case"month":e.setMonth(e.getMonth()+N);M=(i+N)%12;if(M<0){M=12+M;}while(e.getMonth()!=M){e.setDate(e.getDate()-1);}break;case"year":e.setFullYear(e.getFullYear()+N);while(e.getMonth()!=i){e.setDate(e.getDate()-1);}break;default:break;}if(e.getTime()<this._oMinDate.getTime()){e=new U(this._oMinDate.getTime());}else if(e.getTime()>this._oMaxDate.getTime()){e=new U(this._oMaxDate.getTime());}return e;}
function p(){var e=this.getDelimiter();if(!e){if(!this._sLocaleDelimiter){var i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var u=L.getInstance(i);var P=u.getIntervalPattern();var I=P.indexOf("{0}")+3;var v=P.indexOf("{1}");e=P.slice(I,v);if(e.length>1){if(e.slice(0,1)==" "){e=e.slice(1);}if(e.slice(e.length-1,e.length)==" "){e=e.slice(0,e.length-1);}}this._sLocaleDelimiter=e;}else{e=this._sLocaleDelimiter;}}return e;}
function q(){var P=(this.getDisplayFormat()||"medium");var F;var C=this.getDisplayFormatType();if(P==this._sUsedDisplayPattern&&C==this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}else{if(this._checkStyle(P)){F=b.getInstance({style:P,strictParsing:true,calendarType:C});}else{F=b.getInstance({pattern:P,strictParsing:true,calendarType:C});}this._sUsedDisplayPattern=P;this._sUsedDisplayCalendarType=C;this._oDisplayFormat=F;}return F;}
function r(v,e){return v&&e&&v.lastIndexOf(e)===v.length-e.length;}
function s(v,S){return v&&S&&v.indexOf(S)===0;}
function t(v,P){var i=0,T=P;if(!T){T=[" "];}while(i<T.length){if(r(v,T[i])){v=v.substring(0,v.length-T[i].length);i=0;continue;}i++;}i=0;while(i<T.length){if(s(v,T[i])){v=v.substring(T[i].length);i=0;continue;}i++;}return v;}
return h;});
sap.ui.predefine('sap/m/DateRangeSelectionRenderer',['sap/ui/core/Renderer','./DatePickerRenderer'],function(R,D){"use strict";var a=R.extend(D);
a.writeInnerValue=function(r,c){if(c._bValid){r.writeAttributeEscaped("value",c._formatValue(c.getDateValue(),c.getSecondDateValue()));}else{r.writeAttributeEscaped("value",c.getValue());}};
return a;},true);
sap.ui.predefine('sap/m/DateTimeField',['sap/ui/model/type/Date','sap/ui/model/odata/type/ODataType','sap/ui/model/odata/type/DateTimeBase','./InputBase','sap/ui/core/LocaleData','sap/ui/core/library','sap/ui/core/format/DateFormat','./DateTimeFieldRenderer',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos"],function(S,O,D,I,L,c,a,b,d,f,q){"use strict";var C=c.CalendarType;
var g=I.extend("sap.m.DateTimeField",{metadata:{"abstract":true,library:"sap.m",properties:{displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null},initialFocusedDateValue:{type:"object",group:"Data",defaultValue:null}}}});
g.prototype.setValue=function(v){v=this.validateProperty("value",v);var o=this.getValue();if(v===o){return this;}else{this._lastValue=v;}this.setProperty("value",v);this._bValid=true;var e;if(v){e=this._parseValue(v);if(!e||e.getTime()<this._oMinDate.getTime()||e.getTime()>this._oMaxDate.getTime()){this._bValid=false;f.warning("Value can not be converted to a valid date",this);}}this.setProperty("dateValue",e);if(this.getDomRef()){var s;if(e){s=this._formatValue(e);}else{s=v;}if(this._$input.val()!==s){this._$input.val(s);this._curpos=this._$input.cursorPos();}}return this;};
g.prototype.setDateValue=function(o){if(this._isValidDate(o)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getDateValue(),o)){return this;}o=this._dateValidation(o);var v=this._formatValue(o,true);if(v!==this.getValue()){this._lastValue=v;}this.setProperty("value",v);if(this.getDomRef()){var s=this._formatValue(o);if(this._$input.val()!==s){this._$input.val(s);this._curpos=this._$input.cursorPos();}}return this;};
g.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var V=this.getValue();if(V){this._handleDateValidation(this._parseValue(V));}return this;};
g.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);this.updateDomValue(this._formatValue(this.getDateValue()));this._updateDomPlaceholder(this._getPlaceholder());return this;};
g.prototype.getDisplayFormatType=function(){return null;};
g.prototype._dateValidation=function(o){this._bValid=true;this.setProperty("dateValue",o);return o;};
g.prototype._handleDateValidation=function(o){this._bValid=true;this.setProperty("dateValue",o);};
g.prototype._getPlaceholder=function(){var p=this.getPlaceholder();if(!p){p=this._getDisplayFormatPattern();if(!p){p=this._getDefaultDisplayStyle();}if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}}return p;};
g.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getDatePattern(p);};
g.prototype._parseValue=function(v,h){var B=this.getBinding("value"),o=B&&B.getType&&B.getType(),F,i,j;if(o&&this._isSupportedBindingType(o)){try{j=o.parseValue(v,"string");if(typeof(j)==="string"&&o instanceof D){j=D.prototype.parseValue.call(o,v,"string");}F=o.oFormatOptions;if(F&&F.source&&F.source.pattern=="timestamp"){j=new Date(j);}else if(F&&F.source&&typeof F.source.pattern==="string"){j=o.oInputFormat.parse(v);}}catch(e){}if(j&&((o.oFormatOptions&&this._isFormatOptionsUTC(o.oFormatOptions))||(o.oConstraints&&o.oConstraints.isDateOnly))){i=new Date(j.getUTCFullYear(),j.getUTCMonth(),j.getUTCDate(),j.getUTCHours(),j.getUTCMinutes(),j.getUTCSeconds(),j.getUTCMilliseconds());i.setFullYear(j.getUTCFullYear());j=i;}return j;}return this._getFormatter(h).parse(v);};
g.prototype._formatValue=function(o,v){if(!o){return"";}var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),F,h;if(e&&this._isSupportedBindingType(e)){if((e.oFormatOptions&&e.oFormatOptions.UTC)||(e.oConstraints&&e.oConstraints.isDateOnly)){h=new Date(Date.UTC(o.getFullYear(),o.getMonth(),o.getDate(),o.getHours(),o.getMinutes(),o.getSeconds(),o.getMilliseconds()));h.setUTCFullYear(o.getFullYear());o=h;}F=e.oFormatOptions;if(F&&F.source&&F.source.pattern=="timestamp"){o=o.getTime();}else if(e.oOutputFormat){return e.oOutputFormat.format(o);}return e.formatValue(o,"string");}return this._getFormatter(!v).format(o);};
g.prototype._isSupportedBindingType=function(B){return B.isA(["sap.ui.model.type.Date","sap.ui.model.odata.type.DateTime","sap.ui.model.odata.type.DateTimeOffset"]);};
g.prototype._isFormatOptionsUTC=function(B){return(B.UTC||(B.source&&B.source.UTC));};
g.prototype._getDefaultDisplayStyle=function(){return"medium";};
g.prototype._getDefaultValueStyle=function(){return"short";};
g.prototype._getFormatter=function(e){var p=this._getBoundValueTypePattern(),r=false,F,B=this.getBinding("value"),s;if(B&&B.oType&&B.oType.oOutputFormat){r=!!B.oType.oOutputFormat.oFormatOptions.relative;s=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){if(e){p=(this.getDisplayFormat()||this._getDefaultDisplayStyle());s=this.getDisplayFormatType();}else{p=(this.getValueFormat()||this._getDefaultValueStyle());s=C.Gregorian;}}if(!s){s=sap.ui.getCore().getConfiguration().getCalendarType();}if(e){if(p===this._sUsedDisplayPattern&&s===this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}}else{if(p===this._sUsedValuePattern&&s===this._sUsedValueCalendarType){F=this._oValueFormat;}}if(F){return F;}return this._getFormatterInstance(F,p,r,s,e);};
g.prototype._getFormatterInstance=function(F,p,r,s,e){if(this._checkStyle(p)){F=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:s},e);}else{F=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:s},e);}if(e){this._sUsedDisplayPattern=p;this._sUsedDisplayCalendarType=s;this._oDisplayFormat=F;}else{this._sUsedValuePattern=p;this._sUsedValueCalendarType=s;this._oValueFormat=F;}return F;};
g.prototype._getFormatInstance=function(A,e){return a.getInstance(A);};
g.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
g.prototype._getDisplayFormatPattern=function(){var p=this._getBoundValueTypePattern();if(p){return p;}p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
g.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),o=B&&B.getType&&B.getType();if(o instanceof S){return o.getOutputPattern();}if(o instanceof O&&o.oFormat){return o.oFormat.oFormatOptions.pattern;}return undefined;};
g.prototype._isValidDate=function(o){return o&&q.type(o)!=="date";};
g.prototype._updateDomPlaceholder=function(v){if(this.getDomRef()){this._$input.attr("placeholder",v);}};
return g;});
sap.ui.predefine('sap/m/DateTimeFieldRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var D=R.extend(I);D.apiVersion=2;return D;},true);
sap.ui.predefine('sap/m/DateTimeInput',["sap/ui/thirdparty/jquery",'sap/ui/core/Control','./library','./DatePicker','./DateTimePicker','./TimePicker','sap/ui/model/type/Date','sap/ui/model/type/Time','sap/ui/model/type/DateTime','sap/ui/model/odata/type/ODataType','sap/ui/core/library','sap/ui/Device',"./DateTimeInputRenderer"],function(q,C,l,D,a,T,b,c,d,O,e,f,g){"use strict";var h=l.DateTimeInputType;var j=e.TextDirection;var k=e.TextAlign;var V=e.ValueState;
var m=C.extend("sap.m.DateTimeInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/DateTimeInput.designtime",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:k.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:j.Inherit},type:{type:"sap.m.DateTimeInputType",group:"Data",defaultValue:h.Date},displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null}},aggregations:{_picker:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"},dateValue:{type:"object"},valid:{type:"boolean"}}}}}});
!(function(P,$,i){var r=l.getLocaleData();q.extend(P,{_types:{Date:{valueFormat:r.getDatePattern("short"),displayFormat:r.getDatePattern("medium")},Time:{valueFormat:r.getTimePattern("short"),displayFormat:r.getTimePattern("short")},DateTime:{valueFormat:r.getDateTimePattern("short"),displayFormat:r.getDateTimePattern("short")}}});["Time","Date"].forEach(function(t,s){["valueFormat","displayFormat"].forEach(function(F){var u=P._types;u.DateTime[F]=u.DateTime[F].replace("{"+s+"}",u[t][F]);});});}(m.prototype,q,f));
m.prototype.init=function(){this.setType(h.Date);};
m.prototype.onBeforeRendering=function(){o.call(this);};
m.prototype.getFocusDomRef=function(){var P=_.call(this);return P.getFocusDomRef();};
m.prototype.getIdForLabel=function(){var P=_.call(this);return P.getIdForLabel();};
function n(t){var P;switch(t){case h.DateTime:P=new a(this.getId()+"-Picker");break;case h.Time:P=new T(this.getId()+"-Picker",{localeId:sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()});break;default:P=new D(this.getId()+"-Picker");break;}P.setDisplayFormat(this.getDisplayFormat()||this._types[t].displayFormat);P.setValueFormat(this.getValueFormat()||this._types[t].valueFormat);if(this.getDateValue()){P.setDateValue(this.getDateValue());}P.setEnabled(this.getEnabled());P.setEditable(this.getEditable());P.setValueState(this.getValueState());P.setValueStateText(this.getValueStateText());P.setShowValueStateMessage(this.getShowValueStateMessage());P.setName(this.getName());P.setPlaceholder(this.getPlaceholder());P.setTextAlign(this.getTextAlign());P.setTextDirection(this.getTextDirection());P.setWidth("100%");P.attachChange(p,this);var A=this.getAriaLabelledBy();for(var i=0;i<A.length;i++){P.addAriaLabelledBy(A[i]);}return P;}
m.prototype.setType=function(t){if(t==this.getType()&&_.call(this)){return this;}this.destroyAggregation("_picker");var P=n.call(this,t);this.setAggregation("_picker",P);this.setProperty("type",t);return this;};
m.prototype.setWidth=function(w){this.setProperty("width",w);if(this.getDomRef()){w=this.getWidth();this.$().css("width",w);}return this;};
m.prototype.setValue=function(v){o.call(this);v=this.validateProperty("value",v);if(v.toLowerCase()=="now"){return this.setDateValue(new Date());}if(v===this.getValue()){return this;}this.setProperty("value",v,true);var P=_.call(this);P.setValue(v);var i=P.getDateValue();this.setProperty("dateValue",i,true);return this;};
m.prototype.setDateValue=function(i){if(this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}o.call(this);this.setProperty("dateValue",i,true);var P=_.call(this);P.setDateValue(i);var v=P.getValue();this.setProperty("value",v,true);return this;};
m.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);var P=_.call(this);P.setDisplayFormat(s||this._types[this.getType()].displayFormat);return this;};
m.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var P=_.call(this);P.setValueFormat(v||this._types[this.getType()].ValueFormat);return this;};
m.prototype.setEnabled=function(E){this.setProperty("enabled",E,true);var P=_.call(this);P.setEnabled(E);return this;};
m.prototype.setEditable=function(E){this.setProperty("editable",E,true);var P=_.call(this);P.setEditable(E);return this;};
m.prototype.setValueState=function(v){this.setProperty("valueState",v,true);var P=_.call(this);P.setValueState(v);return this;};
m.prototype.setValueStateText=function(v){this.setProperty("valueStateText",v,true);var P=_.call(this);P.setValueStateText(v);return this;};
m.prototype.setShowValueStateMessage=function(s){this.setProperty("showValueStateMessage",s,true);var P=_.call(this);P.setShowValueStateMessage(s);return this;};
m.prototype.setName=function(N){this.setProperty("name",N,true);var P=_.call(this);P.setName(N);return this;};
m.prototype.setPlaceholder=function(P){this.setProperty("placeholder",P,true);var i=_.call(this);i.setPlaceholder(P);return this;};
m.prototype.setTextAlign=function(t){this.setProperty("textAlign",t,true);var P=_.call(this);P.setTextAlign(t);return this;};
m.prototype.setTextDirection=function(t){this.setProperty("textDirection",t,true);var P=_.call(this);P.setTextDirection(t);return this;};
m.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var P=_.call(this);P.addAriaLabelledBy(i);return this;};
m.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var P=_.call(this);P.removeAriaLabelledBy(i);return this;};
m.prototype.removeAllAriaLabelledBy=function(){this.removeAssociation("ariaLabelledBy",true);var P=_.call(this);P.removeAllAriaLabelledBy();return this;};
m.prototype.getAccessibilityInfo=function(){var P=_.call(this);return P&&P.getAccessibilityInfo?P.getAccessibilityInfo():null;};
m.prototype._getPickerByTypeAndPattern=function(t,i,r){var R=/[DdYyMLWwGQUur]/,s=/[HhKkmsa]/,u=s.test(r),v=R.test(r),w=u&&!v,x=v&&!u,y=v&&u,N,z;switch(t){case h.Time:case h.Date:case h.DateTime:if(w&&i.getMetadata().getName()!=="sap.m.TimePicker"){N=h.Time;}else if(x&&i.getMetadata().getName()!=="sap.m.DatePicker"){N=h.Date;}else if(y&&i.getMetadata().getName()!=="sap.m.DateTimePicker"){N=h.DateTime;}break;default:{throw"Invalid type: "+t+". Expected is one of the sap.m.DateTimeInputType";}}if(N){this.destroyAggregation("_picker");z=n.call(this,N);this.setAggregation("_picker",z);}return z||i;};
m.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),i=B&&B.getType()&&B.getType();if(i instanceof b||i instanceof c||i instanceof d){return i.getOutputPattern();}if(i instanceof O&&i.oFormat){return i.oFormat.oFormatOptions.pattern;}return undefined;};
function _(){return this.getAggregation("_picker");}
m.prototype._isValidDate=function(i){return i&&q.type(i)!=="date";};
function o(){if(this._getBoundValueTypePattern()){var P=this._getBoundValueTypePattern();var i=_.call(this);i=this._getPickerByTypeAndPattern(this.getType(),i,P);if(i.getValueFormat()!=P){i.setValueFormat(P);}if(i.getDisplayFormat()!=P){i.setDisplayFormat(P);}}}
function p(E){var v=E.getParameter("value");var i;var r=E.getParameter("valid");this.setProperty("value",v,true);if(r){i=E.oSource.getDateValue();this.setProperty("dateValue",i,true);}this.fireChange({value:v,newValue:v,valid:r,dateValue:i,newDateValue:i});}
return m;});
sap.ui.predefine('sap/m/DateTimeInputRenderer',[],function(){"use strict";var D={};
D.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMDTI");var w=c.getWidth();if(w){r.addStyle("width",w);}r.writeStyles();r.writeClasses();r.write(">");var p=c.getAggregation("_picker");if(p){r.renderControl(p);}r.write("</div>");};
return D;},true);
sap.ui.predefine('sap/m/DateTimePicker',["sap/ui/thirdparty/jquery",'./InputBase','./DatePicker','sap/ui/model/type/Date','sap/ui/unified/DateRange','./library','sap/ui/core/Control','sap/ui/Device','sap/ui/core/format/DateFormat','sap/ui/core/LocaleData','./DateTimePickerRenderer','./TimePickerSliders','./SegmentedButton','./SegmentedButtonItem','./ResponsivePopover','./Button',"sap/ui/events/KeyCodes","sap/ui/core/IconPool"],function(q,I,D,a,b,l,C,c,d,L,e,T,S,f,R,B,K,g){"use strict";var P=l.PlacementType,h=l.ButtonType,k="Phone";
var m=D.extend("sap.m.DateTimePicker",{metadata:{library:"sap.m",properties:{minutesStep:{type:"int",group:"Misc",defaultValue:1},secondsStep:{type:"int",group:"Misc",defaultValue:1}},designtime:"sap/m/designtime/DateTimePicker.designtime",dnd:{draggable:false,droppable:true}}});
var n=C.extend("sap.m.internal.DateTimePickerPopup",{
metadata:{library:"sap.m",aggregations:{_switcher:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},calendar:{type:"sap.ui.core.Control",multiple:false},timeSliders:{type:"sap.ui.core.Control",multiple:false}}},
renderer:function(i,j){i.write("<div");i.writeControlData(j);i.addClass("sapMDateTimePopupCont");i.addClass("sapMTimePickerDropDown");i.writeClasses();i.write(">");var u=j.getAggregation("_switcher");if(u){i.write("<div");i.addClass("sapMTimePickerSwitch");i.writeClasses();i.write(">");i.renderControl(u);i.write("</div>");}var v=j.getCalendar();if(v){i.renderControl(v);}i.write("<div");i.addClass("sapMTimePickerSep");i.writeClasses();i.write(">");i.write("</div>");var w=j.getTimeSliders();if(w){i.renderControl(w);}i.write("</div>");},
init:function(){},
onBeforeRendering:function(){var i=this.getAggregation("_switcher");if(!i){var j=sap.ui.getCore().getLibraryResourceBundle("sap.m");var u=j.getText("DATETIMEPICKER_DATE");var v=j.getText("DATETIMEPICKER_TIME");i=new S(this.getId()+"-Switch",{selectedKey:"Cal",items:[new f(this.getId()+"-Switch-Cal",{key:"Cal",text:u}),new f(this.getId()+"-Switch-Sli",{key:"Sli",text:v})]});i.attachSelect(this._handleSelect,this);this.setAggregation("_switcher",i,true);}if(c.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){i.setVisible(true);i.setSelectedKey("Cal");}else{i.setVisible(false);}},
onAfterRendering:function(){if(c.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){var i=this.getAggregation("_switcher");var j=i.getSelectedKey();this._switchVisibility(j);}},
_handleSelect:function(E){this._switchVisibility(E.getParameter("key"));},
_switchVisibility:function(i){var j=this.getCalendar();var u=this.getTimeSliders();if(!j||!u){return;}if(i=="Cal"){j.$().css("display","");u.$().css("display","none");}else{j.$().css("display","none");u.$().css("display","");u._updateSlidersValues();u._onOrientationChanged();u.openFirstSlider();}},
switchToTime:function(){var i=this.getAggregation("_switcher");if(i&&i.getVisible()){i.setSelectedKey("Sli");this._switchVisibility("Sli");}},
getSpecialDates:function(){return this._oDateTimePicker.getSpecialDates();}
});
m.prototype.init=function(){D.prototype.init.apply(this,arguments);this._bOnlyCalendar=false;};
m.prototype.getIconSrc=function(){return g.getIconURI("date-time");};
m.prototype.exit=function(){D.prototype.exit.apply(this,arguments);if(this._oSliders){this._oSliders.destroy();delete this._oSliders;}this._oPopupContent=undefined;c.media.detachHandler(this._handleWindowResize,this);};
m.prototype.setDisplayFormat=function(i){D.prototype.setDisplayFormat.apply(this,arguments);if(this._oSliders){this._oSliders.setDisplayFormat(s.call(this));}return this;};
m.prototype.setMinutesStep=function(M){this.setProperty('minutesStep',M,true);if(this._oSliders){this._oSliders.setMinutesStep(M);}return this;};
m.prototype.setMinDate=function(i){D.prototype.setMinDate.call(this,i);if(i){this._oMinDate.setHours(i.getHours(),i.getMinutes(),i.getSeconds());}return this;};
m.prototype.setMaxDate=function(i){D.prototype.setMaxDate.call(this,i);if(i){this._oMaxDate.setHours(i.getHours(),i.getMinutes(),i.getSeconds());}return this;};
m.prototype.setSecondsStep=function(i){this.setProperty('secondsStep',i,true);if(this._oSliders){this._oSliders.setSecondsStep(i);}return this;};
m.prototype._getFormatInstance=function(A,i){var M=q.extend({},A);var j=-1;if(M.style){j=M.style.indexOf("/");}if(i){var u=q.extend({},M);if(j>0){u.style=u.style.substr(0,j);}this._oDisplayFormatDate=d.getInstance(u);}return d.getDateTimeInstance(M);};
m.prototype._checkStyle=function(u){if(D.prototype._checkStyle.apply(this,arguments)){return true;}else if(u.indexOf("/")>0){var v=["short","medium","long","full"];var w=false;for(var i=0;i<v.length;i++){var x=v[i];for(var j=0;j<v.length;j++){var y=v[j];if(u==x+"/"+y){w=true;break;}}if(w){break;}}return w;}return false;};
m.prototype._parseValue=function(v,i){var j=D.prototype._parseValue.apply(this,arguments);if(i&&!j){j=this._oDisplayFormatDate.parse(v);if(j){var O=this.getDateValue();if(!O){O=new Date();}j.setHours(O.getHours());j.setMinutes(O.getMinutes());j.setSeconds(O.getSeconds());j.setMilliseconds(O.getMilliseconds());}}return j;};
m.prototype._getLocaleBasedPattern=function(i){var j=L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()),u=i.indexOf("/");if(u>0){return j.getCombinedDateTimePattern(i.substr(0,u),i.substr(u+1));}else{return j.getCombinedDateTimePattern(i,i);}};
m.prototype._createPopup=function(){if(!this._oPopup){var i=sap.ui.getCore().getLibraryResourceBundle("sap.m");var O=i.getText("TIMEPICKER_SET");var j=i.getText("TIMEPICKER_CANCEL");this._oPopupContent=new n(this.getId()+"-PC");this._oPopupContent._oDateTimePicker=this;this._oPopup=new R(this.getId()+"-RP",{showCloseButton:false,showHeader:false,placement:P.VerticalPreferedBottom,beginButton:new B(this.getId()+"-OK",{text:O,type:h.Emphasized,press:q.proxy(_,this)}),endButton:new B(this.getId()+"-Cancel",{text:j,press:q.proxy(o,this)}),content:this._oPopupContent});this._oPopup.addStyleClass("sapMDateTimePopup");var u=this._oPopup.getAggregation("_popup");if(u.setShowArrow){u.setShowArrow(false);}this._oPopup.attachAfterOpen(p,this);this._oPopup.attachAfterClose(r,this);if(c.system.desktop){this._oPopoverKeydownEventDelegate={onkeydown:function(E){var v=K,w=E.which||E.keyCode,A=E.altKey;if((A&&(w===v.ARROW_UP||w===v.ARROW_DOWN))||w===v.F4){_.call(this,E);this.focus();E.preventDefault();}}};this._oPopup.addEventDelegate(this._oPopoverKeydownEventDelegate,this);}this.setAggregation("_popup",this._oPopup,true);}};
m.prototype._openPopup=function(){if(!this._oPopup){return;}this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);this._storeInputSelection(this._$input.get(0));var i=this._oPopup.getAggregation("_popup");i.oPopup.setAutoCloseAreas([this.getDomRef()]);this._oPopup.openBy(this);var j=this._oPopup.getContent()[0]&&this._oPopup.getContent()[0].getTimeSliders();if(j){setTimeout(j._updateSlidersValues.bind(j),0);}};
m.prototype._createPopupContent=function(){var N=!this._oCalendar;D.prototype._createPopupContent.apply(this,arguments);if(N){this._oPopupContent.setCalendar(this._oCalendar);this._oCalendar.attachSelect(t,this);var i=this,H=this._oCalendar._hideMonthPicker,j=this._oCalendar._hideYearPicker;this._oCalendar._hideMonthPicker=function(u){H.apply(this,arguments);if(!u){i._selectFocusedDateValue(new b().setStartDate(this._getFocusedDate().toLocalJSDate()));}};this._oCalendar._hideYearPicker=function(u){j.apply(this,arguments);if(!u){i._selectFocusedDateValue(new b().setStartDate(this._getFocusedDate().toLocalJSDate()));}};}if(!this._oSliders){this._oSliders=new T(this.getId()+"-Sliders",{minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep(),displayFormat:s.call(this),localeId:this.getLocaleId()})._setShouldOpenSliderAfterRendering(true);this._oPopupContent.setTimeSliders(this._oSliders);}};
m.prototype._selectFocusedDateValue=function(i){var j=this._oCalendar;j.removeAllSelectedDates();j.addSelectedDate(i);return this;};
m.prototype._fillDateRange=function(){var i=this.getDateValue();if(i){i=new Date(i.getTime());}else{i=this._getInitialFocusedDateValue();var M=this._oMaxDate.getTime();if(i.getTime()<this._oMinDate.getTime()||i.getTime()>M){i=this._oMinDate;}}this._oCalendar.focusDate(i);if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=i.getTime()){this._oDateRange.setStartDate(i);}this._oSliders._setTimeValues(i);};
m.prototype._getSelectedDate=function(){var i=D.prototype._getSelectedDate.apply(this,arguments);if(i){var j=this._oSliders.getTimeValues();var u=this._oSliders._getDisplayFormatPattern();if(u.search("h")>=0||u.search("H")>=0){i.setHours(j.getHours());}if(u.search("m")>=0){i.setMinutes(j.getMinutes());}if(u.search("s")>=0){i.setSeconds(j.getSeconds());}if(i.getTime()<this._oMinDate.getTime()){i=new Date(this._oMinDate.getTime());}else if(i.getTime()>this._oMaxDate.getTime()){i=new Date(this._oMaxDate.getTime());}}return i;};
m.prototype._getInitialFocusedDateValue=function(){return this.getInitialFocusedDateValue()||new Date();};
m.prototype.getLocaleId=function(){return sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();};
m.prototype.getAccessibilityInfo=function(){var i=D.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATETIMEINPUT");return i;};
function _(E){this._handleCalendarSelect();}
function o(E){this.onsaphide(E);this._oCalendar.removeAllSelectedDates();this._oCalendar.addSelectedDate(new b().setStartDate(this._getInitialFocusedDateValue()));}
m.prototype._handleWindowResize=function(i){var j=this.getAggregation("_popup").getContent()[0].getAggregation("_switcher"),u=this.getAggregation("_popup").getContent()[0].getCalendar(),v=this.getAggregation("_popup").getContent()[0].getTimeSliders();if(i.name===k){j.setVisible(true);this.getAggregation("_popup").getContent()[0]._switchVisibility(j.getSelectedKey());}else{j.setVisible(false);v.$().css("display","");u.$().css("display","");}};
function p(E){this.$("inner").attr("aria-expanded",true);this._oCalendar.focus();this._oSliders._onOrientationChanged();c.media.attachHandler(this._handleWindowResize,this);}
function r(){this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.$("inner").attr("aria-expanded",false);this._restoreInputSelection(this._$input.get(0));this._oCalendar._closedPickers();c.media.detachHandler(this._handleWindowResize,this);}
function s(){var i=this.getDisplayFormat();var j;var u=this.getBinding("value");if(u&&u.oType&&(u.oType instanceof a)){i=u.oType.getOutputPattern();}else if(u&&u.oType&&u.oType.oFormat){i=u.oType.oFormat.oFormatOptions.pattern;}else{i=this.getDisplayFormat();}if(!i){i="medium";}var v=i.indexOf("/");if(v>0&&this._checkStyle(i)){i=i.substr(v+1);}if(i=="short"||i=="medium"||i=="long"||i=="full"){var w=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var x=L.getInstance(w);j=x.getTimePattern(i);}else{j=i;}return j;}
function t(E){this._oPopupContent.switchToTime();}
return m;});
sap.ui.predefine('sap/m/DateTimePickerRenderer',['sap/ui/core/Renderer','./DatePickerRenderer','./InputBaseRenderer'],function(R,D,I){"use strict";var a=R.extend(D);
a.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATETIMEPICKER_TYPE")+" "+b;};
return a;},true);
sap.ui.predefine('sap/m/Dialog',['./Bar','./InstanceManager','./AssociativeOverflowToolbar','./ToolbarSpacer','./Title','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/Popup','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/RenderManager','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/Device','sap/ui/base/ManagedObject','sap/ui/core/library','./TitlePropagationSupport','./DialogRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/core/Core","sap/ui/core/Configuration","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Focusable"],function(B,I,A,T,a,l,b,C,c,P,S,R,d,f,D,M,g,h,j,L,q,k,m){"use strict";var O=g.OpenState;var n=l.DialogType;var o=l.DialogRoleType;var V=g.ValueState;var p=l.TitleAlignment;var s=k.getConfiguration().getAnimationMode();var u=s!==m.AnimationMode.none&&s!==m.AnimationMode.minimal;var r=u?300:10;var t=17;
var v=C.extend("sap.m.Dialog",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},type:{type:"sap.m.DialogType",group:"Appearance",defaultValue:n.Standard},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},stretchOnPhone:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},stretch:{type:"boolean",group:"Appearance",defaultValue:false},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},verticalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},resizable:{type:"boolean",group:"Behavior",defaultValue:false},draggable:{type:"boolean",group:"Behavior",defaultValue:false},escapeHandler:{type:"any",group:"Behavior",defaultValue:null},role:{type:"sap.m.DialogRoleType",group:"Data",defaultValue:o.Dialog,visibility:"hidden"},closeOnNavigation:{type:"boolean",group:"Behavior",defaultValue:true},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:p.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},subHeader:{type:"sap.m.IBar",multiple:false},customHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_title:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_icon:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_toolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_valueState:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}}},designtime:"sap/m/designtime/Dialog.designtime"}});
h.call(v.prototype,"content",function(){return this._headerTitle?this._headerTitle.getId():false;});v._bPaddingByDefault=(sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMDialogWithPadding").compareTo("1.16")<0);v._mIcons={};v._mIcons[V.Success]=c.getIconURI("message-success");v._mIcons[V.Warning]=c.getIconURI("message-warning");v._mIcons[V.Error]=c.getIconURI("message-error");v._mIcons[V.Information]=c.getIconURI("hint");
v.prototype.init=function(){var e=this;this._externalIcon=undefined;this._oManuallySetSize=null;this._oManuallySetPosition=null;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._scrollContentList=["sap.m.NavContainer","sap.m.Page","sap.m.ScrollContainer","sap.m.SplitContainer","sap.m.MultiInput","sap.m.SimpleFixFlex"];this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setNavigationMode("SCOPE");if(D.os.ios&&D.system.phone&&!this._bMessageType){this.oPopup.setModal(true,"sapMDialogTransparentBlk");}else{this.oPopup.setModal(true,"sapMDialogBlockLayerInit");}this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this.oPopup._applyPosition=function(i,F){var x;var y;e._setDimensions();e._adjustScrollingPane();i.at={};if(e._oManuallySetPosition){i.at.left=e._oManuallySetPosition.x;i.at.top=e._oManuallySetPosition.y;}else{if(window.scrollY===undefined){x=window.pageYOffset;}else{x=window.scrollY;}if(D.os.ios||x<0){x=0;}i.at.top='calc(50% + '+x+'px)';if(e._bRTL){i.at.left='auto';}else{if(window.scrollX===undefined){y=window.pageXOffset;}else{y=window.scrollX;}if(D.os.ios||y<0){y=0;}i.at.left='calc(50% + '+y+'px)';}}e._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,i);e._registerContentResizeHandler();};if(v._bPaddingByDefault){this.addStyleClass("sapUiPopupWithPadding");}this._initTitlePropagationSupport();};
v.prototype.onBeforeRendering=function(){if(this._hasSingleScrollableContent()){this.setProperty("verticalScrolling",false);this.setProperty("horizontalScrolling",false);L.info("VerticalScrolling and horizontalScrolling in sap.m.Dialog with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:this.getHorizontalScrolling(),vertical:this.getVerticalScrolling()});}this._createToolbarButtons();if(sap.ui.getCore().getConfiguration().getAccessibility()&&this.getState()!=V.None){var e=new d({text:this.getValueStateString(this.getState())});this.setAggregation("_valueState",e);this.addAriaLabelledBy(e.getId());}};
v.prototype.onAfterRendering=function(){this._$scrollPane=this.$("scroll");this._$content=this.$("cont");this._$dialog=this.$();if(this.isOpen()){this._setInitialFocus();}};
v.prototype.exit=function(){I.removeDialogInstance(this);this._deregisterContentResizeHandler();this._deregisterResizeHandler();if(this.oPopup){this.oPopup.detachOpened(this._handleOpened,this);this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._header){this._header.destroy();this._header=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._toolbarSpacer){this._toolbarSpacer.destroy();this._toolbarSpacer=null;}};
v.prototype.open=function(){var e=this.oPopup;e.setInitialFocusId(this.getId());var i=e.getOpenState();switch(i){case O.OPEN:case O.OPENING:return this;case O.CLOSING:this._bOpenAfterClose=true;break;default:}this._oCloseTrigger=null;this.fireBeforeOpen();e.attachOpened(this._handleOpened,this);this._iLastWidthAndHeightWithScroll=null;e.setContent(this);e.open();this._registerResizeHandler();I.addDialogInstance(this);return this;};
v.prototype.close=function(){this._bOpenAfterClose=false;this.$().removeClass('sapDialogDisableTransition');this._deregisterResizeHandler();var e=this.oPopup;var i=this.oPopup.getOpenState();if(!(i===O.CLOSED||i===O.CLOSING)){l.closeKeyboard();this.fireBeforeClose({origin:this._oCloseTrigger});e.attachClosed(this._handleClosed,this);this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;e.close();this._deregisterContentResizeHandler();}return this;};
v.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen();};
v.prototype._handleOpened=function(){this.oPopup.detachOpened(this._handleOpened,this);this._setInitialFocus();this.fireAfterOpen();};
v.prototype._handleClosed=function(){if(!this.oPopup){return;}this.oPopup.detachClosed(this._handleClosed,this);if(this.getDomRef()){R.preserveContent(this.getDomRef());this.$().remove();}I.removeDialogInstance(this);this.fireAfterClose({origin:this._oCloseTrigger});if(this._bOpenAfterClose){this._bOpenAfterClose=false;this.open();}};
v.prototype.onfocusin=function(e){var i=e.target;if(i.id===this.getId()+"-firstfe"){var x=this.$("footer").lastFocusableDomRef()||this.$("cont").lastFocusableDomRef()||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||(this._getAnyHeader()&&this._getAnyHeader().$().lastFocusableDomRef());if(x){x.focus();}}else if(i.id===this.getId()+"-lastfe"){var F=(this._getAnyHeader()&&this._getAnyHeader().$().firstFocusableDomRef())||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||this.$("cont").firstFocusableDomRef()||this.$("footer").firstFocusableDomRef();if(F){F.focus();}}};
v.prototype._getPromiseWrapper=function(){var e=this;return{reject:function(){e.currentPromise.reject();},resolve:function(){e.currentPromise.resolve();}};};
v.prototype.onsapescape=function(e){var E=this.getEscapeHandler(),i={},x=this;if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this._oCloseTrigger=null;if(typeof E==='function'){new window.Promise(function(y,z){i.resolve=y;i.reject=z;x.currentPromise=i;E(x._getPromiseWrapper());}).then(function(y){x.close();}).catch(function(){L.info("Disallow dialog closing");});}else{this.close();}e.stopPropagation();};
v.prototype._openAnimation=function($,i,e){$.addClass("sapMDialogOpen");$.css("display","block");setTimeout(e,r);};
v.prototype._closeAnimation=function($,i,e){$.removeClass("sapMDialogOpen");setTimeout(e,r);};
v.prototype._setDimensions=function(){var $=this.$(),e=this.getStretch(),i=this.getStretchOnPhone()&&D.system.phone,x=this._bMessageType,y={};if(!e){if(!this._oManuallySetSize){y.width=this.getContentWidth()||undefined;y.height=this.getContentHeight()||undefined;}else{y.width=this._oManuallySetSize.width;y.height=this._oManuallySetSize.height;}}if(y.width=='auto'){y.width=undefined;}if(y.height=='auto'){y.height=undefined;}if((e&&!x)||(i)){this.$().addClass('sapMDialogStretched');}$.css(y);if(!e&&!this._oManuallySetSize&&!this._bDisableRepositioning){this._applyCustomTranslate();}if(window.navigator.userAgent.toLowerCase().indexOf("chrome")!==-1&&this.getStretch()){$.find('> footer').css({bottom:'0.001px'});}};
v.prototype._adjustScrollingPane=function(){if(this._oScroller){this._oScroller.refresh();}};
v.prototype._reposition=function(){};
v.prototype._repositionAfterOpen=function(){};
v.prototype._reapplyPosition=function(){this._adjustScrollingPane();};
v.prototype._onResize=function(){var $=this.$(),e=this.$('cont'),i,x=this.getContentHeight(),y=this.getContentWidth(),z,E=Math.floor(window.innerWidth*0.9),F=2,G=D.browser,H=0;if(this._oManuallySetSize){e.css({width:'auto'});return;}if(!x||x=='auto'){i=e.scrollTop();e.css({height:'auto'});$.children().each(function(){H+=q(this).outerHeight(true);});if(this.getStretch()||H>$.innerHeight()){z=parseFloat($.height())+F;e.height(Math.round(z));}e.scrollTop(i);}if(D.system.desktop&&!G.chrome){var J=e.width()+"x"+e.height(),K=$.css("min-width")!==$.css("width");if(J!==this._iLastWidthAndHeightWithScroll&&K){if(this._hasVerticalScrollbar()&&(!y||y=='auto')&&!this.getStretch()&&e.width()<E){$.addClass("sapMDialogVerticalScrollIncluded");e.css({"padding-right":t});this._iLastWidthAndHeightWithScroll=J;}else{$.removeClass("sapMDialogVerticalScrollIncluded");e.css({"padding-right":""});this._iLastWidthAndHeightWithScroll=null;}}}if(!this.getStretch()&&!this._oManuallySetSize&&!this._bDisableRepositioning){this._applyCustomTranslate();}};
v.prototype._hasVerticalScrollbar=function(){var $=this.$('cont');if(D.browser.msie){return $[0].clientWidth<$.outerWidth();}return $[0].clientHeight<$[0].scrollHeight;};
v.prototype._applyCustomTranslate=function(){if(D.browser.msie){return;}var $=this.$(),e,i,x=$.innerWidth(),y=$.innerHeight();if(D.system.desktop&&(x%2!==0||y%2!==0)){if(!this._bRTL){e='-'+Math.floor(x/2)+"px";}else{e=Math.floor(x/2)+"px";}i='-'+Math.floor(y/2)+"px";var z='translate('+e+','+i+') scale(1) ';$.css('transform',z);$.css('-webkit-transform',z+' translateZ(0px)');}else{$.css('transform','');$.css('-webkit-transform','');}};
v.prototype._createHeader=function(){if(!this._header){this._header=new B(this.getId()+"-header");this._header._setRootAccessibilityRole("heading");this._header._setRootAriaLevel("2");this._setupBarTitleAlignment(this._header,this.getId()+"_header");this.setAggregation("_header",this._header,false);}};
v.prototype._hasSingleScrollableContent=function(){var e=this.getContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA(this._scrollContentList)){return true;}return false;};
v.prototype._initBlockLayerAnimation=function(){this.oPopup._hideBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup");$.removeClass("sapMDialogTransparentBlk");P.prototype._hideBlockLayer.call(this);};};
v.prototype._clearBlockLayerAnimation=function(){if(D.os.ios&&D.system.phone&&!this._bMessageType){delete this.oPopup._showBlockLayer;this.oPopup._hideBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup");$.removeClass("sapMDialogTransparentBlk");P.prototype._hideBlockLayer.call(this);};}};
v.prototype._getFocusId=function(){return this.getInitialFocus()||this._getFirstFocusableContentSubHeader()||this._getFirstFocusableContentElementId()||this._getFirstVisibleButtonId()||this.getId();};
v.prototype._getFirstVisibleButtonId=function(){var e=this.getBeginButton(),E=this.getEndButton(),x=this.getButtons(),y="";if(e&&e.getVisible()){y=e.getId();}else if(E&&E.getVisible()){y=E.getId();}else if(x&&x.length>0){for(var i=0;i<x.length;i++){if(x[i].getVisible()){y=x[i].getId();break;}}}return y;};
v.prototype._getFirstFocusableContentSubHeader=function(){var $=this.$().find('.sapMDialogSubHeader');var e;var F=$.firstFocusableDomRef();if(F){e=F.id;}return e;};
v.prototype._getFirstFocusableContentElementId=function(){var e="";var $=this.$("cont");var F=$.firstFocusableDomRef();if(F){e=F.id;}return e;};
v.prototype._setInitialFocus=function(){var F=this._getFocusId();var e=sap.ui.getCore().byId(F);var i;if(e){if(e.getVisible&&!e.getVisible()){this.focus();return;}i=e.getFocusDomRef();}i=i||((F?window.document.getElementById(F):null));if(!i){this.setInitialFocus("");i=sap.ui.getCore().byId(this._getFocusId());}if(!this.getInitialFocus()){this.setAssociation('initialFocus',i?i.id:this.getId(),true);}if(D.system.desktop||(i&&!/input|textarea|select/i.test(i.tagName))){if(i){i.focus();}}else{this.focus();}};
v.prototype.getScrollDelegate=function(){return this._oScroller;};
v.prototype._composeAggreNameInHeader=function(e){var H;if(e==="Begin"){H="contentLeft";}else if(e==="End"){H="contentRight";}else{H="content"+e;}return H;};
v.prototype._isToolbarEmpty=function(){var e=this._oToolbar.getContent().filter(function(i){return i.getMetadata().getName()!=='sap.m.ToolbarSpacer';});return e.length===0;};
v.prototype._setButton=function(e,i,x){return this;};
v.prototype._getButton=function(e){var i=e.toLowerCase()+"Button",x="_o"+this._firstLetterUpperCase(e)+"Button";if(D.system.phone){return this.getAggregation(i,null,true);}else{return this[x];}};
v.prototype._getButtonFromHeader=function(e){if(this._header){var H=this._composeAggreNameInHeader(this._firstLetterUpperCase(e)),i=this._header.getAggregation(H);return i&&i[0];}else{return null;}};
v.prototype._firstLetterUpperCase=function(e){return e.charAt(0).toUpperCase()+e.slice(1);};
v.prototype._getAnyHeader=function(){var e=this.getCustomHeader();if(e){e._setRootAriaLevel("2");return e._setRootAccessibilityRole("heading");}else{var i=this.getShowHeader();if(!i){return null;}this._createHeader();return this._header;}};
v.prototype._deregisterResizeHandler=function(){if(this._resizeListenerId){f.deregister(this._resizeListenerId);this._resizeListenerId=null;}D.resize.detachHandler(this._onResize,this);};
v.prototype._registerResizeHandler=function(){var _=this.$("scroll");this._resizeListenerId=f.register(_.get(0),q.proxy(this._onResize,this));D.resize.attachHandler(this._onResize,this);this._onResize();};
v.prototype._deregisterContentResizeHandler=function(){if(this._sContentResizeListenerId){f.deregister(this._sContentResizeListenerId);this._sContentResizeListenerId=null;}};
v.prototype._registerContentResizeHandler=function(){if(!this._sContentResizeListenerId){this._sContentResizeListenerId=f.register(this.getDomRef("scrollCont"),q.proxy(this._onResize,this));}this._onResize();};
v.prototype._attachHandler=function(e){var i=this;if(!this._oButtonDelegate){this._oButtonDelegate={ontap:function(){i._oCloseTrigger=this;},onkeyup:function(){i._oCloseTrigger=this;},onkeydown:function(){i._oCloseTrigger=this;}};}if(e){e.addDelegate(this._oButtonDelegate,true,e);}};
v.prototype._createToolbarButtons=function(){var e=this._getToolbar();var i=this.getButtons();var x=this.getBeginButton();var y=this.getEndButton(),z=this,E=[x,y];E.forEach(function(F){if(F&&z._oButtonDelegate){F.removeDelegate(z._oButtonDelegate);}});e.removeAllContent();if(!("_toolbarSpacer"in this)){this._toolbarSpacer=new T();}e.addContent(this._toolbarSpacer);E.forEach(function(F){z._attachHandler(F);});if(i&&i.length){i.forEach(function(F){e.addContent(F);});}else{if(x){e.addContent(x);}if(y){e.addContent(y);}}};
v.prototype._getToolbar=function(){if(!this._oToolbar){this._oToolbar=new A(this.getId()+"-footer").addStyleClass("sapMTBNoBorders");this._oToolbar.addDelegate({onAfterRendering:function(){if(this.getType()===n.Message){this.$("footer").removeClass("sapContrast sapContrastPlus");}}},false,this);this.setAggregation("_toolbar",this._oToolbar);}return this._oToolbar;};
v.prototype.getValueStateString=function(e){var i=sap.ui.getCore().getLibraryResourceBundle("sap.m");switch(e){case(V.Success):return i.getText("LIST_ITEM_STATE_SUCCESS");case(V.Warning):return i.getText("LIST_ITEM_STATE_WARNING");case(V.Error):return i.getText("LIST_ITEM_STATE_ERROR");case(V.Information):return i.getText("LIST_ITEM_STATE_INFORMATION");default:return"";}};
v.prototype.setSubHeader=function(e){this.setAggregation("subHeader",e);if(e){e.setVisible=function(i){this.$().toggleClass('sapMDialogWithSubHeader',i);e.setProperty("visible",i);}.bind(this);}return this;};
v.prototype.setLeftButton=function(e){if(typeof e==="string"){e=sap.ui.getCore().byId(e);}this.setBeginButton(e);return this.setAssociation("leftButton",e);};
v.prototype.setRightButton=function(e){if(typeof e==="string"){e=sap.ui.getCore().byId(e);}this.setEndButton(e);return this.setAssociation("rightButton",e);};
v.prototype.getLeftButton=function(){var e=this.getBeginButton();return e?e.getId():null;};
v.prototype.getRightButton=function(){var e=this.getEndButton();return e?e.getId():null;};
v.prototype.setBeginButton=function(e){if(e&&e.isA("sap.m.Button")){e.addStyleClass("sapMDialogBeginButton");}return this.setAggregation("beginButton",e);};
v.prototype.setEndButton=function(e){if(e&&e.isA("sap.m.Button")){e.addStyleClass("sapMDialogEndButton");}return this.setAggregation("endButton",e);};
v.prototype.getAggregation=function(e,i,x){var y=C.prototype.getAggregation.apply(this,Array.prototype.slice.call(arguments,0,2));if(e==='buttons'&&y.length===0){this.getBeginButton()&&y.push(this.getBeginButton());this.getEndButton()&&y.push(this.getEndButton());}return y;};
v.prototype.getAriaLabelledBy=function(){var e=this._getAnyHeader(),i=this.getAssociation("ariaLabelledBy",[]).slice();var x=this.getSubHeader();if(x){i.unshift(x.getId());}if(e){var y=e.findAggregatedObjects(true,function(z){return z.isA("sap.m.Title");});if(y.length){i=y.map(function(z){return z.getId();}).concat(i);}else{i.unshift(e.getId());}}return i;};
v.prototype.setTitle=function(e){this.setProperty("title",e,true);if(this._headerTitle){this._headerTitle.setText(e);}else{this._headerTitle=new a(this.getId()+"-title",{text:e,level:"H2"}).addStyleClass("sapMDialogTitle");this._createHeader();this._header.addContentMiddle(this._headerTitle);}return this;};
v.prototype.setState=function(e){var F={},$=this.$(),N;F[e]=true;this.setProperty("state",e,true);for(N in j._mStateClasses){$.toggleClass(j._mStateClasses[N],!!F[N]);}this.setIcon(v._mIcons[e],true);return this;};
v.prototype.setIcon=function(i,e){if(!e){this._externalIcon=i;}else{if(this._externalIcon){i=this._externalIcon;}}if(i){if(i!==this.getIcon()){if(this._iconImage){this._iconImage.setSrc(i);}else{this._iconImage=c.createControlByURI({id:this.getId()+"-icon",src:i,useIconTooltip:false},sap.m.Image).addStyleClass("sapMDialogIcon");this._createHeader();this._header.insertAggregation("contentMiddle",this._iconImage,0);}}}else{var x=this.getState();if(!e&&x!==V.None){if(this._iconImage){this._iconImage.setSrc(v._mIcons[x]);}}else{if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}}}this.setProperty("icon",i,true);return this;};
v.prototype.setType=function(e){var i=this.getType();if(i===e){return this;}this._bMessageType=(e===n.Message);return this.setProperty("type",e,false);};
v.prototype.setStretch=function(e){this._bStretchSet=true;return this.setProperty("stretch",e);};
v.prototype.setStretchOnPhone=function(e){if(this._bStretchSet){L.warning("sap.m.Dialog: stretchOnPhone property is deprecated. Setting stretchOnPhone property is ignored when there's already stretch property set.");return this;}this.setProperty("stretchOnPhone",e);return this.setProperty("stretch",e&&D.system.phone);};
v.prototype.setVerticalScrolling=function(e){var i=this.getVerticalScrolling(),H=this._hasSingleScrollableContent();if(H){L.warning("sap.m.Dialog: property verticalScrolling automatically reset to false. See documentation.");e=false;}if(i===e){return this;}this.$().toggleClass("sapMDialogVerScrollDisabled",!e);this.setProperty("verticalScrolling",e);if(this._oScroller){this._oScroller.setVertical(e);}return this;};
v.prototype.setHorizontalScrolling=function(e){var i=this.getHorizontalScrolling(),H=this._hasSingleScrollableContent();if(H){L.warning("sap.m.Dialog: property horizontalScrolling automatically reset to false. See documentation.");e=false;}if(i===e){return this;}this.$().toggleClass("sapMDialogHorScrollDisabled",!e);this.setProperty("horizontalScrolling",e);if(this._oScroller){this._oScroller.setHorizontal(e);}return this;};
v.prototype.setInitialFocus=function(i){return this.setAssociation("initialFocus",i,true);};
v.prototype.forceInvalidate=C.prototype.invalidate;
v.prototype.invalidate=function(e){if(this.isOpen()){this.forceInvalidate(e);}};
function w(e){var $=q(e);var i=$.control(0);if($.parents('.sapMDialogSection').length){return false;}if(!i||i.getMetadata().getInterfaces().indexOf("sap.m.IBar")>-1){return true;}return $.hasClass('sapMDialogTitle');}
if(D.system.desktop){v.prototype.ondblclick=function(e){if(w(e.target)){var $=this.$('cont');this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;this.oPopup&&this.oPopup._applyPosition(this.oPopup._oLastPosition,true);this._$dialog.removeClass('sapMDialogTouched');$.css({height:'100%'});}};v.prototype.onmousedown=function(e){if(e.which===3){return;}if(this.getStretch()||(!this.getDraggable()&&!this.getResizable())){return;}var i;var x=this;var $=q(document);var y=q(e.target);var z=y.hasClass('sapMDialogResizeHandler')&&this.getResizable();var E=function(X){i=i?clearTimeout(i):setTimeout(function(){X();},0);};var F=window.innerWidth;var G=window.innerHeight;var H={x:e.pageX,y:e.pageY,width:x._$dialog.width(),height:x._$dialog.height(),outerHeight:x._$dialog.outerHeight(),offset:{x:e.offsetX?e.offsetX:e.originalEvent.layerX,y:e.offsetY?e.offsetY:e.originalEvent.layerY},position:{x:x._$dialog.offset().left,y:x._$dialog.offset().top}};function J(){var X=x.$(),Y=x.$('cont'),Z,_;$.off("mouseup mousemove");if(z){x._$dialog.removeClass('sapMDialogResizing');Z=parseInt(X[0].style.height)||parseInt(X.height());_=parseInt(X.css("border-top-width"))+parseInt(X.css("border-bottom-width"));Y.height(Z+_);}}if((w(e.target)&&this.getDraggable())||z){x._bDisableRepositioning=true;x._$dialog.addClass('sapDialogDisableTransition');x._$dialog.addClass('sapMDialogTouched');x._oManuallySetPosition={x:H.position.x,y:H.position.y};x._$dialog.css({left:Math.min(Math.max(0,x._oManuallySetPosition.x),F-H.width),top:Math.min(Math.max(0,x._oManuallySetPosition.y),G-H.height),width:H.width,transform:""});}if(w(e.target)&&this.getDraggable()){$.on("mousemove",function(X){if(X.buttons===0){J();return;}E(function(){x._bDisableRepositioning=true;x._oManuallySetPosition={x:X.pageX-e.pageX+H.position.x,y:X.pageY-e.pageY+H.position.y};x._$dialog.css({left:Math.min(Math.max(0,x._oManuallySetPosition.x),F-H.width),top:Math.min(Math.max(0,x._oManuallySetPosition.y),G-H.outerHeight),transform:""});});});}else if(z){x._$dialog.addClass('sapMDialogResizing');var K={};var N=parseInt(x._$dialog.css('min-width'));var Q=H.x+H.width-N;var U=y.width()-e.offsetX;var W=y.height()-e.offsetY;$.on("mousemove",function(X){E(function(){x._bDisableRepositioning=true;x.$('cont').height('').width('');if(X.pageY+W>G){X.pageY=G-W;}if(X.pageX+U>F){X.pageX=F-U;}x._oManuallySetSize={width:H.width+X.pageX-H.x,height:H.height+X.pageY-H.y};if(x._bRTL){K.left=Math.min(Math.max(X.pageX,0),Q);K.transform="";x._oManuallySetSize.width=H.width+H.x-Math.max(X.pageX,0);}K.width=x._oManuallySetSize.width;K.height=x._oManuallySetSize.height;x._$dialog.css(K);});});}else{return;}$.on("mouseup",J);e.preventDefault();e.stopPropagation();};}
v.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
b.mixInto(v.prototype);return v;});
sap.ui.predefine('sap/m/DialogRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/library"],function(l,D,c){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var V=c.ValueState;var d={};d._mStateClasses={};d._mStateClasses[V.None]="";d._mStateClasses[V.Success]="sapMDialogSuccess";d._mStateClasses[V.Warning]="sapMDialogWarning";d._mStateClasses[V.Error]="sapMDialogError";d._mStateClasses[V.Information]="sapMDialogInformation";
d.render=function(r,C){var e=C.getId(),t=C.getType(),h=C._getAnyHeader(),s=C.getSubHeader(),m=(t===a.Message),L=C.getBeginButton(),R=C.getEndButton(),H=C.getHorizontalScrolling(),v=C.getVerticalScrolling(),S=C.getState(),f=C.getStretch(),g=C.getStretchOnPhone()&&D.system.phone,j=C.getResizable(),k=C.getDraggable(),o=C.getAggregation("_valueState");var n=C.getContentWidth()&&C.getContentWidth()!='auto'?' width: '+C.getContentWidth()+';':'';var p=C.getContentHeight()&&C.getContentHeight()!='auto'?' height: '+C.getContentHeight()+';':'';var q="style='"+n+p+"'";r.write('<div '+q);r.writeControlData(C);r.addClass("sapMDialog");r.addClass("sapMDialog-CTX");r.addClass("sapMPopup-CTX");if(C.isOpen()){r.addClass("sapMDialogOpen");}if(window.devicePixelRatio>1){r.addClass("sapMDialogHighPixelDensity");}if(C._bDisableRepositioning){r.addClass("sapMDialogTouched");}if(f||(g)){r.addClass("sapMDialogStretched");}r.addClass(d._mStateClasses[S]);var u=!C._oToolbar&&!L&&!R;var w=C._oToolbar&&C._isToolbarEmpty()&&!L&&!R;if(u||w){r.addClass("sapMDialog-NoFooter");}if(!h){r.addClass("sapMDialog-NoHeader");}var x=C.getProperty("role");if(S===V.Error||S===V.Warning){x=b.AlertDialog;}r.writeAccessibilityState(C,{role:x,modal:true});if(C._forceDisableScrolling){r.addClass("sapMDialogWithScrollCont");}if(s&&s.getVisible()){r.addClass("sapMDialogWithSubHeader");if(s.getDesign()==l.ToolbarDesign.Info){r.addClass("sapMDialogSubHeaderInfoBar");}}if(m){r.addClass("sapMMessageDialog");}if(!v){r.addClass("sapMDialogVerScrollDisabled");}if(!H){r.addClass("sapMDialogHorScrollDisabled");}if(D.system.phone){r.addClass("sapMDialogPhone");}if(k&&!f){r.addClass("sapMDialogDraggable");}if(l._bSizeCompact){r.addClass("sapUiSizeCompact");}r.writeClasses();var T=C.getTooltip_AsString();if(T){r.writeAttributeEscaped("title",T);}r.writeAttribute("tabindex","-1");r.write(">");if(D.system.desktop){if(j&&!f){r.writeIcon("sap-icon://resize-corner",["sapMDialogResizeHandler"],{"title":""});}r.write('<span id="'+C.getId()+'-firstfe" tabindex="0" class="sapMDialogFirstFE"></span>');}if(h){h._applyContextClassFor("header");r.write("<header");r.addClass("sapMDialogTitle");r.writeClasses();r.write(">");r.renderControl(h);r.write("</header>");}if(s){s._applyContextClassFor("subheader");r.write("<header");r.addClass("sapMDialogSubHeader");r.writeClasses();r.write(">");r.renderControl(s);r.write("</header>");}if(o){r.renderControl(o);}r.write('<section id="'+e+'-cont" class="sapMDialogSection">');r.write('<div id="'+e+'-scroll" class="sapMDialogScroll">');r.write('<div id="'+e+'-scrollCont" class="sapMDialogScrollCont');if(C.getStretch()||p){r.write(' sapMDialogStretchContent');}r.write('">');var y=C.getContent();for(var i=0;i<y.length;i++){r.renderControl(y[i]);}r.write("</div>");r.write("</div>");r.write("</section>");if(!(u||w)){r.write("<footer");r.addClass("sapMDialogFooter");r.writeClasses();r.write(">");C._oToolbar._applyContextClassFor("footer");r.renderControl(C._oToolbar);r.write("</footer>");}if(D.system.desktop){r.write('<span id="'+C.getId()+'-lastfe" tabindex="0" class="sapMDialogLastFE"></span>');}r.write("</div>");};
return d;},true);
sap.ui.predefine('sap/m/DisplayListItem',["sap/ui/core/library","./library","./ListItemBase","./DisplayListItemRenderer"],function(c,l,L,D){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.DisplayListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null},valueTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}}}});
a.prototype.getContentAnnouncement=function(){return this.getLabel()+" "+this.getValue();};
return a;});
sap.ui.predefine('sap/m/DisplayListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var D=R.extend(L);D.apiVersion=2;
D.renderLIAttributes=function(r,l){r.class("sapMDLI");};
D.renderLIContent=function(r,l){var s=l.getLabel();if(s){r.openStart("label");r.attr("for",l.getId()+"-value");r.class("sapMDLILabel");r.openEnd();r.text(s);r.close("label");}var v=l.getValue();if(v){r.openStart("div",l.getId()+"-value");r.class("sapMDLIValue");var V=l.getValueTextDirection();if(V!=T.Inherit){r.attr("dir",V.toLowerCase());}r.openEnd();r.text(v);r.close("div");}};
return D;},true);
sap.ui.predefine('sap/m/DraftIndicator',["sap/ui/core/Control","sap/m/Label","sap/m/library","./DraftIndicatorRenderer"],function(C,L,l,D){"use strict";var a=l.DraftIndicatorState;
var b=C.extend("sap.m.DraftIndicator",{metadata:{library:"sap.m",designtime:"sap/m/designtime/DraftIndicator.designtime",properties:{state:{type:"sap.m.DraftIndicatorState",group:"Behavior",defaultValue:a.Clear},minDisplayTime:{type:"int",group:"Behavior",defaultValue:1500}},aggregations:{_label:{type:"sap.m.Label",multiple:false,visibility:"hidden"}}}});
var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");b._oTEXTS={};b._oTEXTS[a.Saving]=B.getText("DRAFT_INDICATOR_SAVING_DRAFT");b._oTEXTS[a.Saved]=B.getText("DRAFT_INDICATOR_DRAFT_SAVED");b._oTEXTS[a.Clear]="";
b.prototype.init=function(){this.aQueue=[];this.iDelayedCallId=null;};
b.prototype.exit=function(){this._resetDraftTimer();};
b.prototype.setState=function(s){this.setProperty("state",s);this._addToQueue(s);if(s===a.Saving){this._addToQueue(a.Clear);}return this;};
b.prototype._getLabel=function(){var c=this.getAggregation('_label');if(!c){var c=new L({id:this.getId()+"-label"});this.setAggregation('_label',c,true);c=this.getAggregation('_label');}return c;};
b.prototype.showDraftSaving=function(){this._addToQueue(a.Saving);this._addToQueue(a.Clear);};
b.prototype.showDraftSaved=function(){this._addToQueue(a.Saved);};
b.prototype.clearDraftState=function(){this._addToQueue(a.Clear);};
b.prototype._addToQueue=function(s){this.aQueue.push(s);this._processQueue();};
b.prototype._processQueue=function(){if(this.iDelayedCallId){return;}var n=this.aQueue.shift();var t=this.getMinDisplayTime();if(!n){return;}this._applyState(n);if(n===a.Clear){this._proceed();return;}this.iDelayedCallId=setTimeout(this._proceed.bind(this),t);};
b.prototype._proceed=function(){this._resetDraftTimer();this._processQueue();};
b.prototype._applyState=function(s){this._getLabel().setText(b._oTEXTS[s]);};
b.prototype._resetDraftTimer=function(){clearTimeout(this.iDelayedCallId);this.iDelayedCallId=null;};
return b;});
sap.ui.predefine('sap/m/DraftIndicatorRenderer',[],function(){"use strict";var D={};
D.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMDraftIndicator");r.writeClasses();r.write(">");var l=c._getLabel();r.renderControl(l);r.write("</div>");};
return D;},true);
sap.ui.predefine('sap/m/FacetFilter',['./NavContainer','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText','sap/ui/core/IntervalTrigger','sap/ui/Device','sap/ui/base/ManagedObject','sap/ui/core/Icon','sap/ui/model/Filter','./FacetFilterRenderer',"sap/ui/events/KeyCodes","sap/base/assert","sap/base/Log","sap/ui/events/jquery/EventSimulation","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/scrollRightRTL","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/Selectors"],function(N,l,C,I,a,b,c,D,M,d,F,e,K,f,L,E,q){"use strict";var T=l.ToolbarDesign;var g=l.ListType;var h=l.ListMode;var m=l.FacetFilterListDataType;var B=l.ButtonType;var P=l.PlacementType;var n=l.FacetFilterType;
var o=C.extend("sap.m.FacetFilter",{metadata:{interfaces:["sap.ui.core.IShrinkable"],library:"sap.m",properties:{showPersonalization:{type:"boolean",group:"Appearance",defaultValue:false},type:{type:"sap.m.FacetFilterType",group:"Appearance",defaultValue:n.Simple},liveSearch:{type:"boolean",group:"Behavior",defaultValue:true},showSummaryBar:{type:"boolean",group:"Behavior",defaultValue:false},showReset:{type:"boolean",group:"Behavior",defaultValue:true},showPopoverOKButton:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"lists",aggregations:{lists:{type:"sap.m.FacetFilterList",multiple:true,singularName:"list"},buttons:{type:"sap.m.Button",multiple:true,singularName:"button",visibility:"hidden"},removeFacetIcons:{type:"sap.ui.core.Icon",multiple:true,singularName:"removeFacetIcon",visibility:"hidden"},popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"},addFacetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},summaryBar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},resetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},arrowLeft:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},arrowRight:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{reset:{},confirm:{}}}});
o.SCROLL_STEP=264;
o.prototype.setType=function(t){var s=this.getAggregation("summaryBar");if(D.system.phone){this.setProperty("type",n.Light);s.setActive(true);}else{this.setProperty("type",t);s.setActive(t===n.Light);}if(t===n.Light){if(this.getShowReset()){this._addResetToSummary(s);}else{this._removeResetFromSummary(s);}}return this;};
o.prototype.setShowReset=function(v){this.setProperty("showReset",v);var s=this.getAggregation("summaryBar");if(v){if(this.getShowSummaryBar()||this.getType()===n.Light){this._addResetToSummary(s);}}else{if(this.getShowSummaryBar()||this.getType()===n.Light){this._removeResetFromSummary(s);}}return this;};
o.prototype.setShowSummaryBar=function(v){this.setProperty("showSummaryBar",v);if(v){var s=this.getAggregation("summaryBar");if(this.getShowReset()){this._addResetToSummary(s);}else{this._removeResetFromSummary(s);}s.setActive(this.getType()===n.Light);}return this;};
o.prototype.setLiveSearch=function(v){this.setProperty("liveSearch",v);if(this._displayedList){var i=this._displayedList;var s=sap.ui.getCore().byId(i.getAssociation("search"));s.detachLiveChange(i._handleSearchEvent,i);if(v){s.attachLiveChange(i._handleSearchEvent,i);}}return this;};
o.prototype.getLists=function(){var i=this.getAggregation("lists");if(!i){i=[];}if(this._displayedList){i.splice(this._listAggrIndex,0,this._displayedList);}return i;};
o.prototype.removeList=function(O){var i=M.prototype.removeAggregation.call(this,"lists",O);this._removeList(i);return i;};
o.prototype.removeAggregation=function(){var i=M.prototype.removeAggregation.apply(this,arguments);if(arguments[0]==="lists"){this._removeList(i);}return i;};
o.prototype.openFilterDialog=function(){var i=this._getFacetDialog();var j=this._getFacetDialogNavContainer();i.addContent(j);this.getLists().forEach(function(k){if(k.getMode()===h.MultiSelect){k._preserveOriginalActiveState();}});i.setInitialFocus(j.getPages()[0].getContent()[0].getItems()[0]);i.open();return this;};
o.prototype.init=function(){this._pageSize=5;this._addDelegateFlag=false;this._invalidateFlag=false;this._lastCategoryFocusIndex=0;this._aDomRefs=null;this._previousTarget=null;this._addTarget=null;this._aRows=null;this._bundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.data("sap-ui-fastnavgroup","true",true);this._buttons={};this._aOwnedLabels=[];this._removeFacetIcons={};this._listAggrIndex=-1;this._displayedList=null;this._lastScrolling=false;this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;this._getAddFacetButton();this._getSummaryBar();this.setAggregation("resetButton",this._createResetButton());if(E.touchEventMode==="ON"&&!D.system.phone){this._enableTouchSupport();}if(D.system.phone){this.setType(n.Light);}};
o.prototype.exit=function(){var i;c.removeListener(this._checkOverflow,this);if(this.oItemNavigation){this.removeDelegate(this.oItemNavigation);this.oItemNavigation.destroy();}if(this._aOwnedLabels){this._aOwnedLabels.forEach(function(s){i=sap.ui.getCore().byId(s);if(i){i.destroy();}});this._aOwnedLabels=null;}};
o.prototype.onBeforeRendering=function(){if(this.getShowSummaryBar()||this.getType()===n.Light){var s=this.getAggregation("summaryBar");var t=s.getContent()[0];t.setText(this._getSummaryText());}c.removeListener(this._checkOverflow,this);};
o.prototype.onAfterRendering=function(){if(this.getType()!==n.Light&&!D.system.phone){c.addListener(this._checkOverflow,this);}if(this.getType()!==n.Light){this._startItemNavigation();}};
o.prototype._startItemNavigation=function(){var j=this.getDomRef(),r=j.getElementsByClassName("sapMFFHead"),k=[];if(r.length>0){for(var i=0;i<r[0].childNodes.length;i++){if(r[0].childNodes[i].id.indexOf("ff")<0&&r[0].childNodes[i].id.indexOf("icon")<0&&r[0].childNodes[i].id.indexOf("add")<0){k.push(r[0].childNodes[i]);}if(r[0].childNodes[i].id.indexOf("add")>=0){k.push(r[0].childNodes[i]);}}}if(k!=""){this._aDomRefs=k;}if((!this.oItemNavigation)||this._addDelegateFlag==true){this.oItemNavigation=new a();this.addDelegate(this.oItemNavigation);this._addDelegateFlag=false;}this._aRows=r;for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].id.indexOf("add")>=0){this._addTarget=this.$().find(":sapTabbable")[i];break;}}this.oItemNavigation.setRootDomRef(j);this.oItemNavigation.setItemDomRefs(k);this.oItemNavigation.setCycling(false);this.oItemNavigation.setPageSize(this._pageSize);};
o.prototype.onsapdelete=function(i){var j,p;if(this.getType()===n.Light){return;}if(!this.getShowPersonalization()){return;}j=sap.ui.getCore().byId(i.target.id);if(!j){return;}p=sap.ui.getCore().byId(j.getAssociation("list"));if(!p){return;}if(!p.getShowRemoveFacetIcon()){return;}p.removeSelections(true);p.setSelectedKeys();p.setProperty("active",false,true);this.invalidate();var t=this.$().find(":sapTabbable");q(t[t.length-1]).focus();var r=this.oItemNavigation.getFocusedIndex();q(i.target).blur();this.oItemNavigation.setFocusedIndex(r+1);this.focus();if(this.oItemNavigation.getFocusedIndex()==0){for(var k=0;k<this.$().find(":sapTabbable").length-1;k++){if(t[k].id.indexOf("add")>=0){q(t[k]).focus();}}}};
o.prototype.onsaptabnext=function(j){if(this.getType()===n.Light){return;}this._previousTarget=j.target;if(j.target.parentNode.className=="sapMFFHead"){for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].parentNode.className=="sapMFFResetDiv"){q(this.$().find(":sapTabbable")[i]).focus();this._invalidateFlag=false;j.preventDefault();j.setMarked();return;}}}this._lastCategoryFocusIndex=this.oItemNavigation.getFocusedIndex();if(this._invalidateFlag==true){this.oItemNavigation.setFocusedIndex(-1);this.focus();this._invalidateFlag=false;}};
o.prototype.onsaptabprevious=function(i){if(this.getType()===n.Light){return;}if(i.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget==null){q(this.$().find(":sapTabbable")[0]).focus();i.preventDefault();i.setMarked();return;}if(i.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget!=null&&this._previousTarget.id!=i.target.id){q(this._previousTarget).focus();i.preventDefault();i.setMarked();return;}if(i.target.id.indexOf("add")>=0||i.target.parentNode.className=="sapMFFHead"){this._previousTarget=i.target;q(this.$().find(":sapTabbable")[0]).focus();}};
o.prototype.onsapend=function(i){if(this.getType()===n.Light){return;}if(this._addTarget!=null){q(this._addTarget).focus();i.preventDefault();i.setMarked();}else{q(this._aRows[this._aRows.length-1]).focus();i.preventDefault();i.setMarked();}this._previousTarget=i.target;};
o.prototype.onsaphome=function(i){if(this.getType()===n.Light){return;}q(this._aRows[0]).focus();i.preventDefault();i.setMarked();this._previousTarget=i.target;};
o.prototype.onsappageup=function(i){this._previousTarget=i.target;};
o.prototype.onsappagedown=function(i){this._previousTarget=i.target;};
o.prototype.onsapincreasemodifiers=function(i){if(this.getType()===n.Light){return;}if(i.which==K.ARROW_RIGHT){this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()-1;var k=j+this._pageSize;q(i.target).blur();this.oItemNavigation.setFocusedIndex(k);this.focus();}};
o.prototype.onsapdecreasemodifiers=function(i){if(this.getType()===n.Light){return;}var j=0;if(i.which==K.ARROW_LEFT){this._previousTarget=i.target;j=this.oItemNavigation.getFocusedIndex()+1;var k=j-this._pageSize;q(i.target).blur();this.oItemNavigation.setFocusedIndex(k);this.focus();}};
o.prototype.onsapdownmodifiers=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;var j=0;j=this.oItemNavigation.getFocusedIndex()-1;var k=j+this._pageSize;q(i.target).blur();this.oItemNavigation.setFocusedIndex(k);this.focus();};
o.prototype.onsapupmodifiers=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;var j=0;j=this.oItemNavigation.getFocusedIndex();if(j!=0){j=j+1;}var k=j-this._pageSize;q(i.target).blur();this.oItemNavigation.setFocusedIndex(k);this.focus();};
o.prototype.onsapexpand=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()+1;q(i.target).blur();this.oItemNavigation.setFocusedIndex(j);this.focus();};
o.prototype.onsapcollapse=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()-1;q(i.target).blur();this.oItemNavigation.setFocusedIndex(j);this.focus();};
o.prototype.onsapdown=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).focus();i.preventDefault();i.setMarked();return;}};
o.prototype.onsapup=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).focus();i.preventDefault();i.setMarked();}};
o.prototype.onsapleft=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).focus();i.preventDefault();i.setMarked();}};
o.prototype.onsapright=function(i){if(this.getType()===n.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).focus();i.preventDefault();i.setMarked();}};
o.prototype.onsapescape=function(i){if(this.getType()===n.Light){return;}if(i.target.parentNode.className=="sapMFFResetDiv"){return;}var j=this._lastCategoryFocusIndex;q(i.target).blur();this.oItemNavigation.setFocusedIndex(j);this.focus();};
o.prototype._getPopover=function(){var p=this.getAggregation("popover");if(!p){var t=this;p=new sap.m.Popover({placement:P.Bottom,beforeOpen:function(j){if(t._displayedList){t._displayedList._setSearchValue("");}this.setCustomHeader(t._createFilterItemsSearchFieldBar(t._displayedList));var s=this.getSubHeader();if(!s){this.setSubHeader(t._createSelectAllCheckboxBar(t._displayedList));}i(t._displayedList);},afterClose:function(j){t._addDelegateFlag=true;t._handlePopoverAfterClose();},horizontalScrolling:false});this.setAggregation("popover",p,true);p.setContentWidth("30%");p.addStyleClass("sapMFFPop");var i=function(j){if(!j){return;}var k=t._getFacetRemoveIcon(j);if(k){k._bTouchStarted=false;}};}if(this.getShowPopoverOKButton()){this._addOKButtonToPopover(p);}else{p.destroyAggregation("footer");}return p;};
o.prototype._handlePopoverAfterClose=function(){var p=this.getAggregation("popover"),i=this._displayedList;if(!p){return;}var j=this._getFacetRemoveIcon(i);if(j&&j._bTouchStarted){return;}this._restoreListFromDisplayContainer(p);this._displayRemoveIcon(false,i);i._fireListCloseEvent();this._fireConfirmEvent();this.destroyAggregation("popover");if(this._oOpenPopoverDeferred){setTimeout(function(){this._oOpenPopoverDeferred.resolve();this._oOpenPopoverDeferred=undefined;}.bind(this),0);}};
o.prototype._fireConfirmEvent=function(){this.fireEvent('confirm');};
o.prototype._openPopover=function(p,i){if(!p.isOpen()){var j=sap.ui.getCore().byId(i.getAssociation("list"));f(j,"The facet filter button should be associated with a list.");j.fireListOpen({});this._moveListToDisplayContainer(j,p);p.openBy(i);if(j.getShowRemoveFacetIcon()){this._displayRemoveIcon(true,j);}if(j.getWordWrap()){p.setContentWidth("30%");}j._applySearch();}return this;};
o.prototype._getAddFacetButton=function(){var i=this.getAggregation("addFacetButton");if(!i){var t=this;var i=new sap.m.Button(this.getId()+"-add",{icon:I.getIconURI("add-filter"),type:B.Transparent,tooltip:this._bundle.getText("FACETFILTER_ADDFACET"),press:function(j){t.openFilterDialog();}});this.setAggregation("addFacetButton",i,true);}return i;};
o.prototype._getButtonForList=function(i){if(this._buttons[i.getId()]){this._setButtonText(i);return this._buttons[i.getId()];}var t=this;var j=new sap.m.Button({type:B.Transparent,press:function(k){var p=this;var O=function(){var r=t._getPopover();t._openPopover(r,p);};if(i.getMode()===h.MultiSelect){i._preserveOriginalActiveState();}var r=t._getPopover();if(r.isOpen()){setTimeout(function(){if(r.isOpen()){return;}t._oOpenPopoverDeferred=q.Deferred();t._oOpenPopoverDeferred.promise().done(O);},100);}else{setTimeout(O.bind(this),100);}}});this._buttons[i.getId()]=j;this.addAggregation("buttons",j);j.setAssociation("list",i.getId(),true);this._setButtonText(i);return j;};
o.prototype._setButtonText=function(i){var j=this._buttons[i.getId()];if(i._iAllItemsCount===undefined&&i.getMaxItemsCount()){i._iAllItemsCount=i.getMaxItemsCount();}if(j){var t="";var s=Object.getOwnPropertyNames(i._oSelectedKeys);var k=s.length;if(k===1){var S=i._oSelectedKeys[s[0]];t=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[i.getTitle(),S]);}else if(k>0&&k===(i._iAllItemsCount?i._iAllItemsCount:0)){t=this._bundle.getText("FACETFILTER_ALL_SELECTED",[i.getTitle()]);}else if(k>0){t=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[i.getTitle(),k]);}else{t=i.getTitle();}j.setText(t);}};
o.prototype._getFacetRemoveIcon=function(i){var t=this,j=this._removeFacetIcons[i.getId()];if(!j){j=new d({src:I.getIconURI("sys-cancel"),tooltip:this._bundle.getText("FACETFILTER_REMOVE"),press:function(){j._bPressed=true;}});j.addDelegate({ontouchstart:function(){j._bTouchStarted=true;j._bPressed=false;},ontouchend:function(){t._displayRemoveIcon(false,i);j._bTouchStarted=false;setTimeout(p.bind(this),100);}},true);var p=function(){if(j._bPressed){i.removeSelections(true);i.setSelectedKeys();i.setProperty("active",false,true);}t._handlePopoverAfterClose();};j.setAssociation("list",i.getId(),true);j.addStyleClass("sapMFFLRemoveIcon");this._removeFacetIcons[i.getId()]=j;this.addAggregation("removeFacetIcons",j);this._displayRemoveIcon(false,i);}return j;};
o.prototype._displayRemoveIcon=function(i,j){if(this.getShowPersonalization()){var k=this._removeFacetIcons[j.getId()];if(i){k.removeStyleClass("sapMFFLHiddenRemoveIcon");k.addStyleClass("sapMFFLVisibleRemoveIcon");}else{k.removeStyleClass("sapMFFLVisibleRemoveIcon");k.addStyleClass("sapMFFLHiddenRemoveIcon");}}};
o.prototype._getFacetDialogNavContainer=function(){var i=new N({autoFocus:false});var j=this._createFacetPage();i.addPage(j);i.setInitialPage(j);var t=this;i.attachAfterNavigate(function(k){var p=k.getParameters()["to"];var r=k.getParameters()['from'];if(r===j){var s=(t._displayedList.getMode()===h.MultiSelect)?p.getContent(0)[1].getItems()[0]:p.getContent(0)[0].getItems()[0];if(s){s.focus();}}if(p===j){r.destroySubHeader();f(t._displayedList===null,"Filter items list should have been placed back in the FacetFilter aggregation before page content is destroyed.");r.destroyContent();t._selectedFacetItem.invalidate();p.invalidate();t._selectedFacetItem.focus();t._selectedFacetItem=null;}});return i;};
o.prototype._createFacetPage=function(){var i=this._createFacetList();var j=new sap.m.SearchField({width:"100%",tooltip:this._bundle.getText("FACETFILTER_SEARCH"),liveChange:function(k){var r=i.getBinding("items");if(r){var s=new F("text",sap.ui.model.FilterOperator.Contains,k.getParameters()["newValue"]);r.filter([s]);}}});var p=new sap.m.Page({enableScrolling:true,title:this._bundle.getText("FACETFILTER_TITLE"),subHeader:new sap.m.Bar({contentMiddle:j}),content:[i]});return p;};
o.prototype._createFilterItemsPage=function(){var t=this;var p=new sap.m.Page({showNavButton:true,enableScrolling:true,navButtonPress:function(i){var j=i.getSource().getParent();t._navFromFilterItemsPage(j);}});return p;};
o.prototype._getFilterItemsPage=function(i){var O=i.getPages()[1];if(O){i.removePage(O);O.destroy();}var p=this._createFilterItemsPage();i.addPage(p);return p;};
o.prototype._createFilterItemsSearchFieldBar=function(i){var t=this;var s=true;if(i.getDataType()!=m.String){s=false;}var S=new sap.m.SearchField({value:i._getSearchValue(),width:"100%",enabled:s,tooltip:this._bundle.getText("FACETFILTER_SEARCH"),search:function(k){t._displayedList._handleSearchEvent(k);}});if(this.getLiveSearch()){S.attachLiveChange(i._handleSearchEvent,i);}var j=new sap.m.Bar({contentMiddle:S});i.setAssociation("search",S);return j;};
o.prototype._getFacetDialog=function(){var i=this.getAggregation("dialog");if(!i){var t=this;i=new sap.m.Dialog({showHeader:false,stretch:D.system.phone?true:false,afterClose:function(){t._addDelegateFlag=true;t._invalidateFlag=true;var j=this.getContent()[0];var k=j.getPages()[1];if(j.getCurrentPage()===k){var p=t._restoreListFromDisplayContainer(k);if(p.getMode()===h.MultiSelect){p._updateActiveState();t._bCheckForAddListBtn=true;}p._fireListCloseEvent();p._search("");}this.destroyAggregation("content",true);t.invalidate();},beginButton:new sap.m.Button({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),press:function(){t._closeDialog();}}),contentHeight:"500px",ariaLabelledBy:[b.getStaticId("sap.m","FACETFILTER_AVAILABLE_FILTER_NAMES")]});i.addStyleClass("sapMFFDialog");i.onsapentermodifiers=function(j){if(j.shiftKey&&!j.ctrlKey&&!j.altKey){var k=this.getContent()[0];t._navFromFilterItemsPage(k);}};this.setAggregation("dialog",i,true);}return i;};
o.prototype._closeDialog=function(){var i=this.getAggregation("dialog");if(i&&i.isOpen()){i.close();this._fireConfirmEvent();}};
o.prototype._closePopover=function(){var p=this.getAggregation("popover");if(p&&p.isOpen()){p.close();}};
o.prototype._createFacetList=function(){var j=this._oFacetList=new sap.m.List({mode:h.None,items:{path:"/items",template:new sap.m.StandardListItem({title:"{text}",counter:"{count}",type:g.Navigation,customData:[new sap.ui.core.CustomData({key:"index",value:"{index}"})]})}});var k=this._getMapFacetLists();var p=new sap.ui.model.json.JSONModel({items:k});if(k.length>100){p.setSizeLimit(k.length);}var t=this;j.attachUpdateFinished(function(){for(var i=0;i<j.getItems().length;i++){var r=this.getItems()[i];r.detachPress(t._handleFacetListItemPress,t);r.attachPress(t._handleFacetListItemPress,t);}});j.setModel(p);return j;};
o.prototype.refreshFacetList=function(){this._oFacetList.getModel().setData({items:this._getMapFacetLists()});return this;};
o.prototype._getMapFacetLists=function(){return this.getLists().map(function(i,j){return{text:i.getTitle(),count:i.getAllCount(),index:j};});};
o.prototype._createSelectAllCheckboxBar=function(i){if(!i.getMultiSelect()){return null;}var s=i.getActive()&&i.getItems().length>0&&Object.getOwnPropertyNames(i._oSelectedKeys).length===i.getItems().length;var j=new sap.m.CheckBox(i.getId()+"-selectAll",{text:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),tooltip:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),selected:s,select:function(p){j.setSelected(p.getParameter("selected"));i._handleSelectAllClick(p.getParameter("selected"));}});i.setAssociation("allcheckbox",j);var k=new sap.m.Bar();k.addEventDelegate({ontap:function(p){if(p.srcControl===this){i._handleSelectAllClick(j.getSelected());}}},k);k.addContentLeft(j);k.addStyleClass("sapMFFCheckbar");return k;};
o.prototype._handleFacetListItemPress=function(i){this._navToFilterItemsPage(i.getSource());};
o.prototype._navToFilterItemsPage=function(i){this._selectedFacetItem=i;var j=this.getAggregation("dialog").getContent()[0];var k=i.getCustomData();f(k.length===1,"There should be exactly one custom data for the original facet list item index");var p=k[0].getValue();var r=this.getLists()[p];this._listIndexAgg=this.indexOfAggregation("lists",r);if(this._listIndexAgg==p){var s=this._getFilterItemsPage(j);r.fireListOpen({});this._moveListToDisplayContainer(r,s);s.setSubHeader(this._createFilterItemsSearchFieldBar(r));var t=this._createSelectAllCheckboxBar(r);if(t){s.insertContent(t,0);}s.setTitle(r.getTitle());j.to(s);}};
o.prototype._navFromFilterItemsPage=function(i){var j=i.getPages()[1];var k=this._restoreListFromDisplayContainer(j);if(k.getMode()===h.MultiSelect){k._updateActiveState();}k._fireListCloseEvent();k._search("");this._selectedFacetItem.setCounter(k.getAllCount());i.backToTop();};
o.prototype._moveListToDisplayContainer=function(i,j){this._listAggrIndex=this.indexOfAggregation("lists",i);f(this._listAggrIndex>-1,"The lists index should be valid.");M.prototype.removeAggregation.call(this,"lists",i,true);j.addAggregation("content",i,false);i.setAssociation("facetFilter",this,true);this._displayedList=i;};
o.prototype._restoreListFromDisplayContainer=function(i){var j=i.removeAggregation("content",this._displayedList,true);this.insertAggregation("lists",j,this._listAggrIndex,j.getActive());this._listAggrIndex=-1;this._displayedList=null;return j;};
o.prototype._getSequencedLists=function(){var k=-1;var s=[];var p=this.getLists();if(p.length>0){for(var i=0;i<p.length;i++){if(p[i].getActive()){if(p[i].getSequence()<-1){p[i].setSequence(-1);}else if(p[i].getSequence()>k){k=p[i].getSequence();}s.push(p[i]);}else if(!p[i].getRetainListSequence()){p[i].setSequence(-1);}}for(var j=0;j<s.length;j++){if(s[j].getSequence()<=-1){k+=1;s[j].setSequence(k);}}if(s.length>1){s.sort(function(r,t){return r.getSequence()-t.getSequence();});}}return s;};
o.prototype._getSummaryBar=function(){var s=this.getAggregation("summaryBar");if(!s){var t=new sap.m.Text({maxLines:1});var i=this;s=new sap.m.Toolbar({content:[t],active:this.getType()===n.Light?true:false,design:T.Info,ariaLabelledBy:[b.getStaticId("sap.m","FACETFILTER_TITLE"),t],press:function(j){i.openFilterDialog();}});s._setRootAccessibilityRole("button");this.setAggregation("summaryBar",s);}return s;};
o.prototype._createResetButton=function(){var t=this;var j=new sap.m.Button({type:B.Transparent,icon:I.getIconURI("undo"),tooltip:this._bundle.getText("FACETFILTER_RESET"),press:function(k){t._addDelegateFlag=true;t._invalidateFlag=true;t.fireReset();var p=t.getLists();for(var i=0;i<p.length;i++){p[i]._searchValue="";p[i]._applySearch();var r=p[i].getItems()[0];if(r){r.focus();}}t.invalidate();}});return j;};
o.prototype._addOKButtonToPopover=function(p){var i=p.getFooter();if(!i){var t=this;var i=new sap.m.Button({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),width:"100%",press:function(){t._closePopover();}});p.setFooter(i);}return i;};
o.prototype._getSummaryText=function(){var k=", ";var S=" ";var s="";var p=true;var r=this.getLists();if(r.length>0){for(var i=0;i<r.length;i++){var t=r[i];if(t.getActive()){var u=this._getSelectedItemsText(t);var v="";for(var j=0;j<u.length;j++){v=v+u[j]+k;}if(v){v=v.substring(0,v.lastIndexOf(k)).trim();if(p){s=this._bundle.getText("FACETFILTER_INFOBAR_FILTERED_BY",[t.getTitle(),v]);p=false;}else{s=s+S+this._bundle.getText("FACETFILTER_INFOBAR_AND")+S+this._bundle.getText("FACETFILTER_INFOBAR_AFTER_AND",[t.getTitle(),v]);}}}}}if(!s){s=this._bundle.getText("FACETFILTER_INFOBAR_NO_FILTERS");}return s;};
o.prototype._getSelectedItemsText=function(i){var t=i.getSelectedItems().map(function(v){return v.getText();});i._oSelectedKeys&&Object.getOwnPropertyNames(i._oSelectedKeys).forEach(function(v){t.indexOf(i._oSelectedKeys[v])===-1&&t.push(i._oSelectedKeys[v]);});return t;};
o.prototype._addResetToSummary=function(s){if(s.getContent().length===1){s.addContent(new sap.m.ToolbarSpacer({width:""}));var i=this._createResetButton();s.addContent(i);i.addStyleClass("sapUiSizeCompact");i.addStyleClass("sapMFFRefresh");i.addStyleClass("sapMFFBtnHoverable");}};
o.prototype._removeResetFromSummary=function(s){if(s.getContent().length===3){var S=s.removeAggregation("content",1);S.destroy();var i=s.removeAggregation("content",1);i.destroy();}};
o.prototype._removeList=function(i){if(i){var j=this._buttons[i.getId()];if(j){this.removeAggregation("buttons",j);j.destroy();}var r=this._removeFacetIcons[i.getId()];if(r){this.removeAggregation("removeIcons",r);r.destroy();}delete this._buttons[i.getId()];delete this._removeFacetIcons[i.getId()];}};
o.prototype._getScrollingArrow=function(s){var A=null;var p={src:"sap-icon://navigation-"+s+"-arrow"};if(s==="left"){A=this.getAggregation("arrowLeft");if(!A){p.id=this.getId()+"-arrowScrollLeft";A=I.createControlByURI(p);var j=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollLeft"];for(var i=0;i<j.length;i++){A.addStyleClass(j[i]);A.setTooltip(this._bundle.getText("FACETFILTER_PREVIOUS"));}this.setAggregation("arrowLeft",A);}}else if(s==="right"){A=this.getAggregation("arrowRight");if(!A){p.id=this.getId()+"-arrowScrollRight";A=I.createControlByURI(p);var k=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollRight"];for(var i=0;i<k.length;i++){A.addStyleClass(k[i]);A.setTooltip(this._bundle.getText("FACETFILTER_NEXT"));}this.setAggregation("arrowRight",A);}}else{L.error("Scrolling arrow name "+s+" is not valid");}return A;};
o.prototype._checkOverflow=function(){var i=this.getDomRef("head"),$=q(i),j=this.$(),s=false,S=false,k=false,p=null,r=null,t=null;if(i){p=i.scrollLeft;r=i.scrollWidth;t=i.clientWidth;if(r>t){if(r-t==1){r=t;}else{k=true;}}j.toggleClass("sapMFFScrolling",k);j.toggleClass("sapMFFNoScrolling",!k);this._lastScrolling=k;if(!this._bRtl){s=p>0;S=(r>t)&&(r>p+t);}else{S=$.scrollLeftRTL()>0;s=$.scrollRightRTL()>0;}if((S!=this._bPreviousScrollForward)||(s!=this._bPreviousScrollBack)){j.toggleClass("sapMFFNoScrollBack",!s);j.toggleClass("sapMFFNoScrollForward",!S);}}};
o.prototype.onclick=function(i){var t=i.target.id;if(t){var s=this.getId(),j=i.target;i.preventDefault();if(t==s+"-arrowScrollLeft"){j.tabIndex=-1;j.focus();this._scroll(-o.SCROLL_STEP,500);}else if(t==s+"-arrowScrollRight"){j.tabIndex=-1;j.focus();this._scroll(o.SCROLL_STEP,500);}}};
o.prototype._scroll=function(i,j){var k=this.getDomRef("head");var s=k.scrollLeft;if(!D.browser.internet_explorer&&this._bRtl){i=-i;}var S=s+i;q(k).stop(true,true).animate({scrollLeft:S},j);};
o.prototype._enableTouchSupport=function(){var t=this;var i=function(p){var s=t.getType();if(s===n.Light){return;}p.preventDefault();if(t._iInertiaIntervalId){window.clearInterval(t._iInertiaIntervalId);}t.startScrollX=t.getDomRef("head").scrollLeft;t.startTouchX=p.touches[0].pageX;t._bTouchNotMoved=true;t._lastMoveTime=new Date().getTime();};var j=function(p){var s=t.getType();if(s===n.Light){return;}var r=p.touches[0].pageX-t.startTouchX;var u=t.getDomRef("head");var v=u.scrollLeft;var w=t.startScrollX-r;u.scrollLeft=w;t._bTouchNotMoved=false;var x=new Date().getTime()-t._lastMoveTime;t._lastMoveTime=new Date().getTime();if(x>0){t._velocity=(w-v)/x;}p.preventDefault();};var k=function(p){var s=t.getType();if(s===n.Light){return;}if(t._bTouchNotMoved===false){p.preventDefault();var r=t.getDomRef("head");var u=50;var v=Math.abs(t._velocity/10);t._iInertiaIntervalId=window.setInterval(function(){t._velocity=t._velocity*0.80;var w=t._velocity*u;r.scrollLeft=r.scrollLeft+w;if(Math.abs(t._velocity)<v){window.clearInterval(t._iInertiaIntervalId);t._iInertiaIntervalId=undefined;}},u);}else if(t._bTouchNotMoved===true){t.onclick(p);p.preventDefault();}t._bTouchNotMoved=undefined;t._lastMoveTime=undefined;};this.addEventDelegate({ontouchstart:i},this);this.addEventDelegate({ontouchend:k},this);this.addEventDelegate({ontouchmove:j},this);};
return o;});
sap.ui.predefine('sap/m/FacetFilterItem',['./ListItemBase','./library','./FacetFilterItemRenderer'],function(L,l,F){"use strict";
var a=L.extend("sap.m.FacetFilterItem",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},count:{type:"int",group:"Misc",defaultValue:null,deprecated:true}}}});
a.prototype.setCount=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
a.prototype.setCounter=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
a.prototype.init=function(){this.attachEvent("_change",this._itemTextChange);L.prototype.init.apply(this);this.addStyleClass("sapMFFLI");};
a.prototype.exit=function(){L.prototype.exit.apply(this);this.detachEvent("_change",this._itemTextChange);};
a.prototype._itemTextChange=function(e){if(e.getParameter("name")==="text"){this.informList("TextChange",e.getParameter("newValue"));}};
return a;});
sap.ui.predefine('sap/m/FacetFilterItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer'],function(L,R){"use strict";var F=R.extend(L);
F.renderLIContent=function(r,c){r.write("<div");if(c.getParent()&&c.getParent().getWordWrap()){r.addClass("sapMFFLITitleWrap");}else{r.addClass("sapMFFLITitle");}r.writeClasses();r.write(">");r.writeEscaped(c.getText());r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterList',['./List','./library','sap/ui/model/ChangeReason','sap/ui/model/Filter','./FacetFilterListRenderer','./FacetFilterItem',"sap/base/Log","sap/ui/model/FilterOperator","sap/ui/model/FilterType"],function(L,l,C,F,a,b,c,d,e){"use strict";var f=l.ListMode;var g=l.FacetFilterListDataType;
var h=L.extend("sap.m.FacetFilterList",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},wordWrap:{type:"boolean",group:"Appearance",defaultValue:false},multiSelect:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},active:{type:"boolean",group:"Behavior",defaultValue:true},enableCaseInsensitiveSearch:{type:"boolean",group:"Behavior",defaultValue:false,deprecated:false},allCount:{type:"int",group:"Appearance",defaultValue:null},sequence:{type:"int",group:"Behavior",defaultValue:-1},key:{type:"string",group:"Identification",defaultValue:null},showRemoveFacetIcon:{type:"boolean",group:"Misc",defaultValue:true},retainListSequence:{type:"boolean",group:"Misc",defaultValue:false},dataType:{type:"sap.m.FacetFilterListDataType",group:"Misc",defaultValue:g.String}},events:{listOpen:{},listClose:{parameters:{selectedItems:{type:"sap.m.FacetFilterItem[]"},allSelected:{type:"boolean"},selectedKeys:{type:"object"}}}}}});
h.prototype.setTitle=function(t){this.setProperty("title",t,true);this._updateFacetFilterButtonText();return this;};
h.prototype.setMultiSelect=function(v){this.setProperty("multiSelect",v,true);var m=v?f.MultiSelect:f.SingleSelectMaster;this.setMode(m);return this;};
h.prototype.setMode=function(m){if(m===f.MultiSelect||m===f.SingleSelectMaster){L.prototype.setMode.call(this,m);this.setProperty("multiSelect",m===f.MultiSelect?true:false,true);}return this;};
h.prototype._applySearch=function(){var s=this._getSearchValue();if(s!=null){this._search(s,true);this._updateSelectAllCheckBox();}};
h.prototype.getSelectedItems=function(){var s=[];var o={};var i=L.prototype.getSelectedItems.apply(this,arguments);i.forEach(function(I){s.push(new b({text:I.getText(),key:I.getKey(),selected:true}));o[I.getKey()]=true;});var S=this.getSelectedKeys();var j=Object.getOwnPropertyNames(S);if(i.length<j.length){j.forEach(function(k){if(!o[k]){s.push(new b({text:S[k],key:k,selected:true}));}});}return s;};
h.prototype.getSelectedItem=function(){var i=L.prototype.getSelectedItem.apply(this,arguments);var s=Object.getOwnPropertyNames(this.getSelectedKeys());if(!i&&s.length>0){i=new b({text:this.getSelectedKeys()[s[0]],key:s[0],selected:true});}return i;};
h.prototype.removeSelections=function(A){if(this._allowRemoveSelections){A?this.setSelectedKeys():L.prototype.removeSelections.call(this,A);}return this;};
h.prototype.getSelectedKeys=function(){var r={};var k=this._oSelectedKeys;Object.getOwnPropertyNames(k).forEach(function(i){r[i]=k[i];});return r;};
h.prototype.setSelectedKeys=function(k){this._oSelectedKeys={};var K=false;k&&Object.getOwnPropertyNames(k).forEach(function(i){this._addSelectedKey(i,k[i]);K=true;},this);if(K){if(this.getMode()===f.MultiSelect){this.setActive(true);}this._selectItemsByKeys();}else{L.prototype.removeSelections.call(this);}};
h.prototype._getNonGroupItems=function(){var i=[];this.getItems().forEach(function(I){if(I.getMode()!==f.None){i.push(I);}});return i;};
h.prototype.removeSelectedKey=function(k,t){if(this._removeSelectedKey(k,t)){this._getNonGroupItems().forEach(function(i){var I=i.getKey()||i.getText();k===I&&i.setSelected(false);});}};
h.prototype.removeSelectedKeys=function(){this._oSelectedKeys={};L.prototype.removeSelections.call(this,true);};
h.prototype.removeItem=function(i){var I=L.prototype.removeItem.apply(this,arguments);if(!this._filtering){I&&I.getSelected()&&this.removeSelectedKey(I.getKey(),I.getText());return I;}};
h.prototype.init=function(){this._firstTime=true;this._saveBindInfo;this._oSelectedKeys={};L.prototype.init.call(this);this.setMode(f.MultiSelect);this.setIncludeItemInSelection(true);this.setGrowing(true);this.setRememberSelections(false);this._searchValue="";this.attachUpdateFinished(function(E){var u=E.getParameter("reason");u=u?u.toLowerCase():u;if(u==="change"){var B=this.getBinding("items"),m=B?B.getModel():null;if(m&&m.getProperty(B.getPath())){this._iAllItemsCount=m.getProperty(B.getPath()).length||0;}}if(u!=="growing"&&u!==C.Filter.toLowerCase()){this._oSelectedKeys={};this._getNonGroupItems().forEach(function(i){if(i.getSelected()){this._addSelectedKey(i.getKey(),i.getText());}},this);}if(u!==C.Filter.toLowerCase()){this._selectItemsByKeys();}this._updateFacetFilterButtonText();this._updateSelectAllCheckBox();});this._allowRemoveSelections=true;this._bOriginalActiveState;this._iAllItemsCount;};
h.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._searchValue="";this._allowRemoveSelections=false;L.prototype._resetItemsBinding.apply(this,arguments);this._allowRemoveSelections=true;}};
h.prototype._fireListCloseEvent=function(){var s=this.getSelectedItems();var S=this.getSelectedKeys();var A=s.length===0;this._firstTime=true;this.fireListClose({selectedItems:s,selectedKeys:S,allSelected:A});};
h.prototype._updateActiveState=function(){var o=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));if(Object.getOwnPropertyNames(this._oSelectedKeys).length>0||(o&&o.getSelected())){this.setActive(true);}};
h.prototype._handleSearchEvent=function(E){var s=E.getParameters()["query"];if(s===undefined){s=E.getParameters()["newValue"];}this._search(s);this._updateSelectAllCheckBox();};
h.prototype._search=function(s,j){var k;var n=0;function m(M){return M instanceof sap.ui.model.odata.ODataModel||M instanceof sap.ui.model.odata.v2.ODataModel;}if(j||(s!==this._searchValue)){this._searchValue=s;var B=this.getBinding("items");var o=this.getBindingInfo("items");if(o&&o.binding){k=o.binding.aFilters;if(k.length>0){n=k[0].aFilters.length;if(this._firstTime){this._saveBindInfo=k[0].aFilters[0][0];this._firstTime=false;}}}if(B){if(s||n>0){var p=this.getBindingInfo("items").template.getBindingInfo("text").parts;var q=p[0].path;if(q||q===""){var u=new F(q,d.Contains,s);var U=[u];for(var i=1;i<p.length;i++){U.push(new F(p[i].path,d.Contains,s));}if(this.getEnableCaseInsensitiveSearch()&&m(B.getModel())){var E="'"+String(s).replace(/'/g,"''")+"'";E=E.toLowerCase();u=new F("tolower("+q+")",d.Contains,E);U=[u];for(var i=1;i<p.length;i++){U.push(new F("tolower("+p[i].path+")",d.Contains,s));}}var P=new F(U,false);if(n>1){var r=new F([P,this._saveBindInfo],true);}else{if(this._saveBindInfo>""&&u.sPath!=this._saveBindInfo.sPath){var r=new F([P,this._saveBindInfo],true);}else{if(s==""){var r=[];}else{var r=new F([P],true);}}}B.filter(r,e.Control);}}else{B.filter([],e.Control);}}else{c.warning("No filtering performed","The list must be defined with a binding for search to work",this);}}};
h.prototype._getSearchValue=function(){return this._searchValue;};
h.prototype._updateSelectAllCheckBox=function(){var i=this._getNonGroupItems(),I=i.length,o,A,s;function j(k){return k.getSelected();}if(this.getMultiSelect()){o=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));A=I>0&&I===i.filter(j).length;s=this.getActive()&&A;o&&o.setSelected(s);}};
h.prototype._addSelectedKey=function(k,t){if(!k&&!t){c.error("Both sKey and sText are not defined. At least one must be defined.");return;}if(this.getMode()===f.SingleSelectMaster){this.removeSelectedKeys();}if(!k){k=t;}this._oSelectedKeys[k]=t||k;};
h.prototype._removeSelectedKey=function(k,t){if(!k&&!t){c.error("Both sKey and sText are not defined. At least one must be defined.");return false;}if(!k){k=t;}delete this._oSelectedKeys[k];return true;};
h.prototype._setSearchValue=function(v){this._searchValue=v;};
h.prototype._isItemSelected=function(i){return!!(this._oSelectedKeys[i&&(i.getKey()||i.getText())]);};
h.prototype._updateFacetFilterButtonText=function(){if(this.getParent()&&this.getParent()._setButtonText){this.getParent()._setButtonText(this);}};
h.prototype._selectItemsByKeys=function(){this._getNonGroupItems().forEach(function(i){i.setSelected(this._isItemSelected(i));},this);this._updateFacetFilterButtonText();};
h.prototype._handleSelectAllClick=function(s){var A;this._getNonGroupItems().forEach(function(i){if(s){this._addSelectedKey(i.getKey(),i.getText());}else{this._removeSelectedKey(i.getKey(),i.getText());}i.setSelected(s,true);},this);if(this.getMode()===f.MultiSelect){A=this._getOriginalActiveState()||s;this.setActive(A);}setTimeout(this._updateSelectAllCheckBox.bind(this),0);};
h.prototype.onItemTextChange=function(i,n){var k=i.getKey();if(this._oSelectedKeys[k]&&n&&!this._filtering){this._oSelectedKeys[k]=n;}};
h.prototype.onItemSelectedChange=function(i,s){var A;if(s){this._addSelectedKey(i.getKey(),i.getText());}else{this._removeSelectedKey(i.getKey(),i.getText());}L.prototype.onItemSelectedChange.apply(this,arguments);if(this.getMode()===f.MultiSelect){A=this._getOriginalActiveState()||s||this.getSelectedItems().length>1;this.setActive(A);}!this.getDomRef()&&this.getParent()&&this.getParent().getDomRef()&&this.getParent().invalidate();setTimeout(this._updateSelectAllCheckBox.bind(this),0);};
h.prototype.updateItems=function(r){this._filtering=r===C.Filter;L.prototype.updateItems.apply(this,arguments);this._filtering=false;if(!this.getGrowing()||r===C.Filter){this._selectItemsByKeys();}};
h.prototype._getOriginalActiveState=function(){return this._bOriginalActiveState;};
h.prototype._preserveOriginalActiveState=function(){this._bOriginalActiveState=this.getActive();};
return h;});
sap.ui.predefine('sap/m/FacetFilterListRenderer',['./ListRenderer','sap/ui/core/Renderer'],function(L,R){"use strict";var F=R.extend(L);return F;},true);
sap.ui.predefine('sap/m/FacetFilterRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/InvisibleText"],function(l,D,I){"use strict";var F=l.FacetFilterType;var a={};
a.render=function(r,c){switch(c.getType()){case F.Simple:a.renderSimpleFlow(r,c);break;case F.Light:a.renderSummaryBar(r,c);break;}};
a.renderSimpleFlow=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMFF");r.writeAccessibilityState(c,{"role":"toolbar"});if(c.getShowSummaryBar()){r.write(">");a.renderSummaryBar(r,c);}else{if(c._lastScrolling){r.addClass("sapMFFScrolling");}else{r.addClass("sapMFFNoScrolling");}if(c.getShowReset()){r.addClass("sapMFFResetSpacer");}r.writeClasses();r.write(">");if(D.system.desktop){r.renderControl(c._getScrollingArrow("left"));}r.write("<div");r.writeAttribute("id",c.getId()+"-head");r.addClass("sapMFFHead");r.writeClasses();r.write(">");a.renderFacetFilterListButtons(c,r);if(c.getShowPersonalization()){r.renderControl(c.getAggregation("addFacetButton"));}r.write("</div>");if(D.system.desktop){r.renderControl(c._getScrollingArrow("right"));}if(c.getShowReset()){r.write("<div");r.addClass("sapMFFResetDiv");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("resetButton"));r.write("</div>");}}r.write("</div>");};
a.renderSummaryBar=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMFF");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("summaryBar"));r.write("</div>");};
a.getAriaAnnouncement=function(k,b){return I.getStaticId("sap.m",b||"FACETFILTER_"+k.toUpperCase());};
a.getAriaDescribedBy=function(c){var d=[];if(c.getShowPersonalization()){d.push(this.getAriaAnnouncement("ARIA_REMOVE"));}d=d.concat(c._aAriaPositionTextIds);return d.join(" ");};
a.getAccessibilityState=function(c){return{describedby:{value:this.getAriaDescribedBy(c),append:true}};};
a.renderFacetFilterListButtons=function(c,r){var L=c._getSequencedLists(),b=L.length,B,i,p,A,o=[],n=[],f=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FACETFILTER_ARIA_FACET_FILTER"),R=this.getAriaAnnouncement("ARIA_REMOVE");for(i=0;i<b;i++){var d=L[i].getItems().length>0,P=c.getShowPersonalization(),e=(c._bCheckForAddListBtn&&d)||!P;if(!c._bCheckForAddListBtn||e){B=c._getButtonForList(L[i]);o=B.removeAllAriaDescribedBy();o.forEach(g);p=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FACETFILTERLIST_ARIA_POSITION",[(i+1),b]);A=new I({text:f+" "+p}).toStatic();c._aOwnedLabels.push(A.getId());B.addAriaDescribedBy(A);n.push(A.getId());if(c.getShowPersonalization()){B.addAriaDescribedBy(a.getAriaAnnouncement("ARIA_REMOVE"));}r.renderControl(B);if(c.getShowPersonalization()){r.renderControl(c._getFacetRemoveIcon(L[i]));}}}c._aAriaPositionTextIds=n;function g(s){if(R!==s){var h=sap.ui.getCore().byId(s);if(h){h.destroy();}}}};
return a;},true);
sap.ui.predefine('sap/m/FeedContent',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/Device','./FeedContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,T,D,F,K){"use strict";var S=l.Size;
var a=C.extend("sap.m.FeedContent",{metadata:{library:"sap.m",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:S.Auto},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null},"value":{type:"string",group:"Misc",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Misc",defaultValue:null},"truncateValueTo":{type:"int",group:"Misc",defaultValue:4}},defaultAggregation:"_contentTextAgr",aggregations:{"_contentTextAgr":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
a.prototype.init=function(){this._oContentText=new T(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("_contentTextAgr",this._oContentText,true);this.setTooltip("{AltText}");};
a.prototype.onBeforeRendering=function(){this.$().unbind("mouseenter");this.$().unbind("mouseleave");};
a.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._addTooltip.bind(this));this.$().bind("mouseleave",this._removeTooltip.bind(this));};
a.prototype.exit=function(){this._oContentText=null;};
a.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
a.prototype._removeTooltip=function(){this.$().attr("title",null);};
a.prototype.getAltText=function(){var A="";var i=true;if(this.getAggregation("_contentTextAgr").getText()){A+=this.getAggregation("_contentTextAgr").getText();i=false;}if(this.getSubheader()){if(i){A+=""+this.getSubheader();}else{A+="\n"+this.getSubheader();}i=false;}if(this.getValue()){if(i){A+=""+this.getValue();}else{A+="\n"+this.getValue();}}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
a.prototype.setContentText=function(t){this._oContentText.setText(t);return this;};
a.prototype.ontap=function(e){if(D.browser.msie){this.$().focus();}this.firePress();};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
a.prototype.attachEvent=function(e,d,f,b){C.prototype.attachEvent.call(this,e,d,f,b);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");}return this;};
a.prototype.detachEvent=function(e,f,b){C.prototype.detachEvent.call(this,e,f,b);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");}return this;};
return a;});
sap.ui.predefine('sap/m/FeedContentRenderer',[],function(){"use strict";var F={};
F.render=function(r,c){var s=c.getSubheader();var v=c.getValue();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.write("<div");r.writeControlData(c);r.writeAttribute("role","presentation");r.writeAttributeEscaped("aria-label",t);r.addClass("sapMFC");if(c.hasListeners("press")){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");}r.writeClasses();r.write(">");if(v){r.write("<div");r.writeAttribute("id",c.getId()+"-value");r.addClass("sapMFCValue");r.addClass(c.getValueColor());r.writeClasses();r.write(">");var C=c.getTruncateValueTo();if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.writeEscaped(v.substring(0,C-1));}else if(v){r.writeEscaped(v.substring(0,C));}else{r.writeEscaped("");}r.write("</div>");}r.write("<div");r.addClass("sapMFCCTxt");r.writeClasses();r.write(">");r.renderControl(c._oContentText);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-subheader");r.addClass("sapMFCSbh");r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/FeedInput',["./library","sap/ui/core/Control","sap/ui/core/IconPool","sap/m/TextArea","sap/m/Button","./FeedInputRenderer","sap/ui/thirdparty/jquery"],function(l,C,I,T,B,F,q){"use strict";var a=l.ButtonType;var M=15,b=2,U=0;
var c=C.extend("sap.m.FeedInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/FeedInput.designtime",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},rows:{type:"int",group:"Appearance",defaultValue:2},showExceededText:{type:"boolean",group:"Behavior",defaultValue:false},maxLength:{type:"int",group:"Behavior",defaultValue:0},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Appearance",defaultValue:"Post something here"},value:{type:"string",group:"Data",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},buttonTooltip:{type:"sap.ui.core.TooltipBase",group:"Accessibility",defaultValue:"Submit"},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null}},events:{post:{parameters:{value:{type:"string"}}}}}});
c.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setProperty("placeholder",o.getText("FEEDINPUT_PLACEHOLDER"),true);this.setProperty("buttonTooltip",o.getText("FEEDINPUT_SUBMIT"),true);};
c.prototype.exit=function(){if(this._oTextArea){this._oTextArea.destroy();}if(this._oButton){this._oButton.destroy();}if(this._oImageControl){this._oImageControl.destroy();}};
c.prototype.setIconDensityAware=function(i){this.setProperty("iconDensityAware",i,true);var f=sap.ui.require("sap/m/Image");if(this._getImageControl()instanceof f){this._getImageControl().setDensityAware(i);}return this;};
c.prototype.setRows=function(r){var m=this.getProperty("growingMaxLines");if(r>M){r=M;}else if(r<b){r=b;}if(r>m&&m!==0){this.setProperty("growingMaxLines",r,true);this._getTextArea().setGrowingMaxLines(r);}this.setProperty("rows",r,true);this._getTextArea().setRows(r);return this;};
c.prototype.setShowExceededText=function(v){this.setProperty("showExceededText",v,true);this._getTextArea().setShowExceededText(v);return this;};
c.prototype.setMaxLength=function(m){this.setProperty("maxLength",m,true);this._getTextArea().setMaxLength(m);return this;};
c.prototype.setGrowing=function(g){this.setProperty("growing",g,true);this._getTextArea().setGrowing(g);return this;};
c.prototype.setGrowingMaxLines=function(m){var r=this.getProperty("rows");if(m!==U){if(m<r){m=r;}else if(m>M){m=M;}}this.setProperty("growingMaxLines",m,true);this._getTextArea().setGrowingMaxLines(m);return this;};
c.prototype.setValue=function(v){this.setProperty("value",v,true);this._getTextArea().setValue(v);this._enablePostButton();return this;};
c.prototype.setPlaceholder=function(v){this.setProperty("placeholder",v,true);this._getTextArea().setPlaceholder(v);return this;};
c.prototype.setEnabled=function(e){this.setProperty("enabled",e,true);this._getTextArea().setEnabled(e);this._enablePostButton();return this;};
c.prototype.setButtonTooltip=function(v){this.setProperty("buttonTooltip",v,true);this._getPostButton().setTooltip(v);return this;};
c.prototype._getTextArea=function(){var t=this;if(!this._oTextArea){this._oTextArea=new T(this.getId()+"-textArea",{value:this.getValue(),maxLength:this.getMaxLength(),placeholder:this.getPlaceholder(),growing:this.getGrowing(),growingMaxLines:this.getGrowingMaxLines(),showExceededText:this.getShowExceededText(),rows:this.getRows(),liveChange:q.proxy(function(e){var v=e.getParameter("value");this.setProperty("value",v,true);this._enablePostButton();},this)});this._oTextArea.setParent(this);this._oTextArea.addEventDelegate({onAfterRendering:function(){t.$("counterContainer").empty();t.$("counterContainer").html(t._oTextArea.getAggregation("_counter").$());}});}return this._oTextArea;};
c.prototype._getPostButton=function(){if(!this._oButton){this._oButton=new B(this.getId()+"-button",{enabled:false,type:a.Default,icon:"sap-icon://feeder-arrow",tooltip:this.getButtonTooltip(),press:q.proxy(function(){this._oTextArea.focus();this.firePost({value:this.getValue()});this.setValue(null);},this)});this._oButton.setParent(this);}return this._oButton;};
c.prototype._enablePostButton=function(){var p=this._isControlEnabled();var o=this._getPostButton();o.setEnabled(p);};
c.prototype._isControlEnabled=function(){var v=this.getValue();return this.getEnabled()&&q.type(v)==="string"&&v.trim().length>0;};
c.prototype._getImageControl=function(){var i=this.getIcon()||I.getIconURI("person-placeholder"),s=this.getId()+'-icon',p={src:i,alt:this.getAriaLabelForPicture(),densityAware:this.getIconDensityAware(),decorative:false,useIconTooltip:false},d=['sapMFeedInImage'];this._oImageControl=l.ImageHelper.getImageControl(s,this._oImageControl,this,p,d);return this._oImageControl;};
return c;});
sap.ui.predefine('sap/m/FeedInputRenderer',[],function(){"use strict";var F={};
F.render=function(r,c){var m=c.getId();r.write("<div");r.writeControlData(c);r.addClass("sapMFeedInBase");r.writeClasses();r.write(">");r.write('<div id="'+m+'-outerContainer"');r.addClass("sapMFeedIn");if(!c.getShowIcon()){r.addClass("sapMFeedInNoIcon");}if(!c.getEnabled()){r.addClass("sapMFeedInDisabled");}r.writeClasses();r.write(">");if(!!c.getShowIcon()){this._addImage(r,c,m);}r.write('<div id="'+m+'-container"');r.addClass("sapMFeedInContainer");r.writeClasses();r.write(">");var t=c._getTextArea();r.renderControl(t);r.renderControl(c._getPostButton());r.write("</div>");r.write("</div>");r.write('<div id="'+m+'-counterContainer"');r.addClass("sapMFeedInCounter");r.writeClasses();r.write(">");r.write("</div>");r.write("</div>");};
F._addImage=function(r,c,m){r.write('<figure id="'+m+'-figure" class ="sapMFeedInFigure');if(!!c.getIcon()){r.write('">');}else{r.write(' sapMFeedListItemIsDefaultIcon">');}r.renderControl(c._getImageControl());r.write('</figure>');};
return F;},true);
sap.ui.predefine('sap/m/FeedListItem',["./ListItemBase","./Link","./library","./FormattedText","sap/ui/core/Control","sap/ui/core/IconPool","sap/m/Button","sap/ui/Device","./FeedListItemRenderer"],function(L,a,l,F,C,I,B,D,b){"use strict";var c=l.ListType;var d=l.ImageHelper;var e=l.LinkConversion;var f=l.ButtonType;
var g=L.extend("sap.m.FeedListItem",{metadata:{library:"sap.m",designtime:"sap/m/designtime/FeedListItem.designtime",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},sender:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Data",defaultValue:null},moreLabel:{type:"string",group:"Data",defaultValue:null},lessLabel:{type:"string",group:"Data",defaultValue:null},info:{type:"string",group:"Data",defaultValue:null},timestamp:{type:"string",group:"Data",defaultValue:null},senderActive:{type:"boolean",group:"Behavior",defaultValue:true},iconActive:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",defaultValue:true},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},convertLinksToAnchorTags:{type:"sap.m.LinkConversion",group:"Behavior",defaultValue:e.None},convertedLinksDefaultTarget:{type:"string",group:"Behavior",defaultValue:"_blank"},maxCharacters:{type:"int",group:"Behavior",defaultValue:null}},defaultAggregation:"actions",aggregations:{actions:{type:"sap.m.FeedListItemAction",multiple:true},_text:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"},_actionButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{senderPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}},iconPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}}}}});
g._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");g._nMaxCharactersMobile=300;g._nMaxCharactersDesktop=500;g._sTextShowMore=g._oRb.getText("TEXT_SHOW_MORE");g._sTextShowLess=g._oRb.getText("TEXT_SHOW_LESS");
g.prototype.init=function(){L.prototype.init.apply(this);this.setAggregation("_text",new F(this.getId()+"-formattedText"),true);this.setAggregation("_actionButton",new B({id:this.getId()+"-actionButton",type:f.Transparent,icon:"sap-icon://overflow",press:[this._onActionButtonPress,this]}),true);};
g.prototype._onActionButtonPress=function(){sap.ui.require(["sap/m/ActionSheet"],this._openActionSheet.bind(this));};
g.prototype._openActionSheet=function(A){var o=this.getAggregation("_actionSheet");var h=this.getActions();var j;if(!(o&&o instanceof A)){o=new A({id:this.getId()+"-actionSheet",beforeOpen:[this._onBeforeOpenActionSheet,this]});this.setAggregation("_actionSheet",o,true);}o.destroyAggregation("buttons",true);for(var i=0;i<h.length;i++){j=h[i];o.addButton(new B({icon:j.getIcon(),text:j.getText(),press:j.firePress.bind(j,{"item":this})}));}o.openBy(this.getAggregation("_actionButton"));};
g.prototype._onBeforeOpenActionSheet=function(h){var A,t;if(D.system.phone){return;}t=sap.ui.getCore().getConfiguration().getTheme();A=h.getSource().getParent();A.removeStyleClass("sapContrast sapContrastPlus");if(t==="sap_belize"){A.addStyleClass("sapContrast");}else if(t==="sap_belize_plus"){A.addStyleClass("sapContrastPlus");}};
g.prototype.invalidate=function(){C.prototype.invalidate.apply(this,arguments);var m=g._sTextShowMore;if(this.getMoreLabel()){m=this.getMoreLabel();}delete this._bTextExpanded;if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.setProperty("text",m,true);}};
g.prototype.onBeforeRendering=function(){this.$("realtext").find('a[target="_blank"]').off("click");var o=this.getAggregation("_text");o.setProperty("convertLinksToAnchorTags",this.getConvertLinksToAnchorTags(),true);o.setProperty("convertedLinksDefaultTarget",this.getConvertedLinksDefaultTarget(),true);if(this.getConvertLinksToAnchorTags()===l.LinkConversion.None){o.setHtmlText(this.getText());}else{o.setProperty("htmlText",this.getText(),true);}this._sFullText=o._getDisplayHtml().replace(/\n/g,"<br>");this._sShortText=this._getCollapsedText();if(this._sShortText){this._sShortText=this._sShortText.replace(/<br>/g," ");}this._bEmptyTagsInShortTextCleared=false;};
g.prototype.onAfterRendering=function(){if(this._checkTextIsExpandable()&&!this._bTextExpanded){this._clearEmptyTagsInCollapsedText();}var r=this.$("realtext");F.prototype.onAfterRendering.apply({$:function(){return r;}});};
g.prototype.exit=function(){this.$("realtext").find('a[target="_blank"]').off("click");if(this._oLinkControl){this._oLinkControl.destroy();}if(this._oImageControl){this._oImageControl.destroy();}if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.destroy();}L.prototype.exit.apply(this);};
g.prototype.ontap=function(E){if(E.srcControl){if((!this.getIconActive()&&this._oImageControl&&E.srcControl.getId()===this._oImageControl.getId())||(!this.getSenderActive()&&this._oLinkControl&&E.srcControl.getId()===this._oLinkControl.getId())||(!this._oImageControl||(E.srcControl.getId()!==this._oImageControl.getId())&&(!this._oLinkControl||(E.srcControl.getId()!==this._oLinkControl.getId()))&&(!this._oLinkExpandCollapse||(E.srcControl.getId()!==this._oLinkExpandCollapse.getId())))){L.prototype.ontap.apply(this,[E]);}}};
g.prototype.onfocusin=function(E){if(this._oImageControl){var $=this.$("icon");if(E.target.id===this.getId()){$.removeAttr("alt");}else{$.attr("alt"," ");}}var i=E.srcControl,o=i.getDomRef(),p=this.getParent().getAccessbilityPosition(i);if(i instanceof sap.m.FeedListItem){o.setAttribute("aria-posinset",p.posInset);o.setAttribute("aria-setsize",p.setSize);}};
g.prototype._getImageControl=function(){var i=this.getIcon();var s=i?i:I.getIconURI("person-placeholder");var h=this.getId()+'-icon';var p={src:s,alt:this.getSender(),densityAware:this.getIconDensityAware(),decorative:false,useIconTooltip:false};var j;if(this.getIconActive()){j=['sapMFeedListItemImage'];}else{j=['sapMFeedListItemImageInactive'];}var t=this;this._oImageControl=d.getImageControl(h,this._oImageControl,this,p,j);if(this.getIconActive()){this._oImageControl.attachPress(function(){t.fireIconPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});});}return this._oImageControl;};
g.prototype._getLinkSender=function(w){if(!this._oLinkControl){var t=this;this._oLinkControl=new a({press:function(){t.fireSenderPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});}});this._oLinkControl.setParent(this,null,true);}if(w){this._oLinkControl.setProperty("text",this.getSender()+g._oRb.getText("COLON"),true);}else{this._oLinkControl.setProperty("text",this.getSender(),true);}this._oLinkControl.setProperty("enabled",this.getSenderActive(),true);return this._oLinkControl;};
g.prototype._activeHandlingInheritor=function(){var A=this.getActiveIcon();if(this._oImageControl&&A){this._oImageControl.setSrc(A);}};
g.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon()?this.getIcon():I.getIconURI("person-placeholder");if(this._oImageControl){this._oImageControl.setSrc(s);}};
g.prototype._getCollapsedText=function(){this._nMaxCollapsedLength=this.getMaxCharacters();if(this._nMaxCollapsedLength===0){if(D.system.phone){this._nMaxCollapsedLength=g._nMaxCharactersMobile;}else{this._nMaxCollapsedLength=g._nMaxCharactersDesktop;}}var p=this._convertHtmlToPlainText(this._sFullText);var t=null;if(p&&p.length>this._nMaxCollapsedLength){var s=p.substring(0,this._nMaxCollapsedLength);var n=s.lastIndexOf(" ");if(n>0){s=s.substr(0,n);}if(p.length===this._sFullText.length){t=s;}else{t=this._convertPlainToHtmlText(s);}}return t;};
g.prototype._clearEmptyTagsInCollapsedText=function(){var r;if(this._bEmptyTagsInShortTextCleared){return;}this._bEmptyTagsInShortTextCleared=true;do{r=this.$("realtext").find(":empty").remove();}while(r.length>0);this._sShortText=this.$("realtext").html();};
g.prototype._toggleTextExpanded=function(){var $=this.$("realtext");var h=this.$("threeDots");var m=g._sTextShowMore;var s=g._sTextShowLess;if(this.getMoreLabel()){m=this.getMoreLabel();}if(this.getLessLabel()){s=this.getLessLabel();}if(this._bTextExpanded){$.html(this._sShortText.replace(/&#xa;/g,"<br>"));h.text(" ... ");this._oLinkExpandCollapse.setText(m);this._bTextExpanded=false;this._clearEmptyTagsInCollapsedText();}else{$.html(this._sFullText.replace(/&#xa;/g,"<br>"));h.text("  ");this._oLinkExpandCollapse.setText(s);this._bTextExpanded=true;}};
g.prototype._getLinkExpandCollapse=function(){var m=g._sTextShowMore;if(this.getMoreLabel()){m=this.getMoreLabel();}if(!this._oLinkExpandCollapse){this._oLinkExpandCollapse=new a({text:m,press:[this._toggleTextExpanded,this]});this._bTextExpanded=false;this._oLinkExpandCollapse.setParent(this,null,true);}return this._oLinkExpandCollapse;};
g.prototype._convertHtmlToPlainText=function(h){var r=/(<([^>]+)>)/ig;return h.replace(r,"");};
g.prototype._convertPlainToHtmlText=function(h){var s=this._sFullText;var r=/(<([^>]+)>)/ig;var E=s.split(r);var t="";for(var i=0;i<E.length;i++){if(E[i].length===0){continue;}if(h.length>0&&E[i].indexOf(h.trim())!==-1){E[i]=h;}if(/^<.+>$/.test(E[i])){t=t+E[i];E[i+1]="";continue;}if(h.indexOf(E[i].trim())===-1){continue;}else{h=h.replace(E[i],"");}t=t+E[i];}return t;};
g.prototype._checkTextIsExpandable=function(){return this._sShortText!==null;};
g.prototype.setType=function(t){if(this.getType()!==t){if(t===c.Navigation){this.setProperty("type",c.Active);}else{this.setProperty("type",t);}}return this;};
return g;});
sap.ui.predefine('sap/m/FeedListItemAction',["sap/ui/core/Element"],function(E){"use strict";
var F=E.extend("sap.m.FeedListItemAction",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},key:{type:"string",group:"Misc",defaultValue:""}},events:{press:{}}}});
return F;});
sap.ui.predefine('sap/m/FeedListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer","sap/ui/Device"],function(L,R,D){"use strict";var F=R.extend(L);
F.renderLIAttributes=function(r,c){r.addClass("sapMFeedListItemTitleDiv");r.addClass("sapMFeedListShowSeparatorsAll");};
F.renderLIContent=function(r,c){var m=c.getId(),i=D.system.phone;r.write('<div');r.addClass('sapMFeedListItem');r.writeClasses();r.write('>');if(c.getShowIcon()){this._writeImageControl(r,c,m);}if(c.getActions().length>0){r.write("<div");r.writeAttributeEscaped("id",m+"-action-button");r.addClass('sapMFeedListItemActionButton');r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_actionButton"));r.write("</div>");}if(i){r.write('<div class= "sapMFeedListItemHeader sapUiSelectable ');if(c.getShowIcon()){r.write('sapMFeedListItemHasFigure ');}if(c.getSender()&&c.getTimestamp()){r.write('sapMFeedListItemFullHeight');}r.write('" >');if(c.getSender()){r.write('<p id="'+m+'-name" class="sapMFeedListItemTextName sapUiSelectable">');r.renderControl(c._getLinkSender(false));r.write('</p>');}if(c.getTimestamp()){r.write('<p id="'+m+'-timestamp" class="sapMFeedListItemTimestamp sapUiSelectable">');r.writeEscaped(c.getTimestamp());r.write('</p>');}r.write('</div>');r.write('<div class="sapMFeedListItemText sapUiSelectable">');this._writeText(r,c,m,i);if(c._checkTextIsExpandable()){this._writeCollapsedText(r,c,m);}else{r.write(c._sFullText);r.write('</span>');}r.write('</div>');if(c.getInfo()){r.write('<p class="sapMFeedListItemFooter sapUiSelectable">');if(c.getInfo()){r.write('<span id="'+m+'-info" class="sapMFeedListItemInfo sapUiSelectable">');r.writeEscaped(c.getInfo());r.write('</span>');}r.write('</p>');}}else{r.write('<div class= "sapMFeedListItemText ');if(c.getShowIcon()){r.write('sapMFeedListItemHasFigure');}r.write('" >');r.write('<div id="'+m+'-text" class="sapMFeedListItemTextText sapUiSelectable">');if(c.getSender()){r.write('<span id="'+m+'-name" class="sapMFeedListItemTextName sapUiSelectable">');r.renderControl(c._getLinkSender(true));r.write('</span>');}this._writeText(r,c,m,i);if(c._checkTextIsExpandable()){this._writeCollapsedText(r,c,m);}else{r.write(c._sFullText);r.write('</span>');}r.write('</div>');if(c.getInfo()||c.getTimestamp()){r.write('<p class="sapMFeedListItemFooter sapUiSelectable">');if(!sap.ui.getCore().getConfiguration().getRTL()){if(c.getInfo()){this._writeInfo(r,c,m);if(c.getTimestamp()){r.write("<span>&#160&#160&#x00B7&#160&#160</span>");}}if(c.getTimestamp()){this._writeTimestamp(r,c,m);}}else{if(c.getTimestamp()){this._writeTimestamp(r,c,m);}if(c.getInfo()){if(c.getTimestamp()){r.write("<span>&#160&#160&#x00B7&#160&#160</span>");}this._writeInfo(r,c,m);}}r.write('</p>');}r.write('</div>');}r.write('</div>');};
F._writeImageControl=function(r,c,i){r.write('<figure id="'+i+'-figure"');r.addClass('sapMFeedListItemFigure');if(!c.getIcon()){r.addClass('sapMFeedListItemIsDefaultIcon');}r.writeClasses();r.write('>');r.renderControl(c._getImageControl());r.write('</figure>');};
F._writeCollapsedText=function(r,c,i){if(c._bTextExpanded){r.write(c._sFullText);r.write('</span>');r.write('<span id="'+i+'-threeDots" class ="sapMFeedListItemTextString">');r.write("&#32");r.write('</span>');}else{r.write(c._sShortText);r.write('</span>');r.write('<span id="'+i+'-threeDots" class ="sapMFeedListItemTextString">');r.write("&#32&#46&#46&#46&#32");r.write('</span>');}var l=c._getLinkExpandCollapse();l.addStyleClass("sapMFeedListItemLinkExpandCollapse");r.renderControl(l);};
F._writeTimestamp=function(r,c,i){r.write('<span id="'+i+'-timestamp"');r.addClass('sapMFeedListItemTimestampText');r.addClass('sapUiSelectable');if(c.getUnread()){r.addClass('sapMFeedListItem-Unread');}r.writeClasses();r.write(">");r.writeEscaped(c.getTimestamp());r.write('</span>');};
F._writeInfo=function(r,c,i){r.write('<span id="'+i+'-info"');r.addClass('sapMFeedListItemInfoText');r.addClass('sapUiSelectable');if(c.getUnread()){r.addClass('sapMFeedListItem-Unread');}r.writeClasses();r.write(">");r.writeEscaped(c.getInfo());r.write('</span>');};
F._writeText=function(r,c,i,I){r.write('<span id="'+i+'-realtext"');I?r.addClass('sapMFeedListItemText'):r.addClass('sapMFeedListItemTextString');r.addClass('sapMFeedListItemText');r.addClass('sapUiSelectable');if(c.getUnread()){r.addClass('sapMFeedListItem-Unread');}r.writeClasses();r.write(">");};
return F;},true);
sap.ui.predefine('sap/m/Fiori20Adapter',['sap/ui/base/Object','sap/ui/base/EventProvider','sap/ui/base/ManagedObjectObserver','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(O,E,M,D,L,q){"use strict";var e=new E(),i,c;
var H=O.extend("HeaderAdapter",{constructor:function(o,A){if(!o||!A){L.error("Cannot initialize: Invalid arguments.");return;}this._oHeader=o;this._oStyledPage=null;this._oTitleInfo=null;this._oSubTitleInfo=null;this._oBackButtonInfo=null;this._oAdaptOptions=A;}});
H.prototype.adapt=function(){var s=this._oAdaptOptions.bStylePage,C=this._oAdaptOptions.bCollapseHeader;if(s){this._toggleStyle("sapF2Adapted",true,true);}this._adaptTitle();this._adaptBackButton();if(C){this._collapseHeader();}return this.getAdaptedContent();};
H.prototype.getAdaptedContent=function(){return{oTitleInfo:this._oTitleInfo,oSubTitleInfo:this._oSubTitleInfo,oBackButtonInfo:this._oBackButtonInfo,oStyledPage:this._oStyledPage};};
H.prototype._adaptTitle=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bMoveTitle!==true){return false;}this._oTitleInfo=this._detectTitle();this._oSubTitleInfo=this._detectSubTitle();var s=!!this._oTitleInfo||!!this._oSubTitleInfo;if(this._oTitleInfo){this._oTitleInfo.oControl.toggleStyleClass("sapF2AdaptedTitle",true);}return s;};
H.prototype._adaptBackButton=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bHideBackButton!==true){return false;}var j,B=false;this._oBackButtonInfo=this._detectBackButton();if(this._oBackButtonInfo){j=this._oBackButtonInfo.oControl.getVisible();this._oBackButtonInfo.oControl.toggleStyleClass("sapF2AdaptedNavigation",j);B=true;}return B;};
H.prototype._toggleStyle=function(s,A,S){var p=this._oHeader.getParent();if(!p){return;}this._oStyledPage=p;if(A===true){p.addStyleClass(s,S);}else if(A===false){p.removeStyleClass(s,S);}else if(A===undefined){p.hasStyleClass(s)?p.removeStyleClass(s,S):p.addStyleClass(s,S);}};
H._isAdaptableHeader=function(o){if(!o||!f(o,"sap/m/Bar")){return false;}var p=o.getParent();return p&&(f(p,"sap/m/Page")||f(p,"sap/m/MessagePage")||f(p,"sap/uxap/ObjectPageHeader"));};
H.prototype._detectTitle=function(){var t;if(H._isAdaptableHeader(this._oHeader)){var m=this._oHeader.getContentMiddle();if(m.length===1&&a(m[0])){var T=m[0];t={id:T.getId(),text:T.getText(),oControl:T,sChangeEventId:"_change",sPropertyName:"text"};}}return t;};
H.prototype._detectSubTitle=function(p){if(f(p,"sap/uxap/ObjectPageHeader")){var o=p.getHeaderTitle();if(o){return{id:o.getId(),text:o.getObjectTitle(),oControl:o,sChangeEventId:"_titleChange",sPropertyName:"objectTitle"};}}};
H.prototype._detectBackButton=function(){var B,o;if(H._isAdaptableHeader(this._oHeader)){B=this._oHeader.getContentLeft();if(B.length>0&&f(B[0],"sap/m/Button")&&(B[0].getType()==="Back"||B[0].getType()==="Up"||B[0].getIcon()==="sap-icon://nav-back")){o=B[0];return{id:o.getId(),oControl:o,sChangeEventId:"_change",sPropertyName:"visible"};}}};
H.prototype._collapseHeader=function(){var t=this._oTitleInfo,B=this._oBackButtonInfo,j,m,k,l,n,o,A;if(H._isAdaptableHeader(this._oHeader)){j=this._oHeader.getContentLeft();m=this._oHeader.getContentMiddle();k=this._oHeader.getContentRight();l=(j.length===1)&&(h(j[0])||B);n=(m.length===1)&&(h(m[0])||t);o=(k.length===1)&&h(k[0]);A=(j.length===0||l)&&(m.length===0||n)&&((k.length===0)||o);this._toggleStyle("sapF2CollapsedHeader",A,true);}};
var F=O.extend("sap.m.Fiori20Adapter",{});
F.attachViewChange=function(l,o){e.attachEvent("adaptedViewChange",l,o);};
F.detachViewChange=function(l,o){e.detachEvent("adaptedViewChange",l,o);};
F.traverse=function(C,A){i={aViewTitles:{},aViewSubTitles:{},aViewBackButtons:{},aChangeListeners:{}};c=null;this._doBFS([{oNode:C,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}};
F._doBFS=function(Q){var n=Q.shift();if(!n){return;}var N=n.oNode,A=n.oAdaptOptions,s=A.iSearchDepth;A=this._applyRules(A,N);if(!this._isAdaptationRequired(N,A)||(s<=0)){return;}var I=this._isTopNavigableView(N);if(I){this._setAsCurrentlyAdaptedTopViewId(N.getId());}var o=this._processNode(N,A);var C=this._getNodeChildren(N),j=q.extend({},A,{iSearchDepth:this._updateSearchDepth(s,N)});if(o){var t=!!o.oTitleInfo,B=!!o.oBackButton,p=!!o.oStyledPage;j=q.extend(j,{bMoveTitle:A.bMoveTitle&&!t,bHideBackButton:A.bHideBackButton&&!B,bStylePage:A.bStylePage&&!p});}C.forEach(function(k){if(k){Q.push({oNode:k,oAdaptOptions:j});}});this._doBFS(Q);};
F._processNode=function(C,A){this._attachDefferedAdaptationListeners(C,A);if(H._isAdaptableHeader(C)){return this._adaptHeader(C,A);}if(C.getParent()&&f(C.getParent(),"sap/m/NavContainer")){return this._getCachedViewInfoToMerge(C.getId());}};
F._attachDefferedAdaptationListeners=function(C,A){this._attachAdaptableContentChange(C,A);this._attachNavigablePageChange(C,A);if(f(C,"sap/m/Page")||f(C,"sap/ui/core/mvc/XMLView")){this._attachModifyAggregation(C,"content",A);}if((A.bLateAdaptation===true)&&f(C,"sap/m/Bar")){this._attachModifyAggregation(C,"contentLeft",A,C);this._attachModifyAggregation(C,"contentMiddle",A,C);this._attachModifyAggregation(C,"contentRight",A,C);}if(f(C,"sap/ui/core/ComponentContainer")){var o=C.getComponentInstance();if(!o&&C.getName()&&!C.getDomRef()){var t=this;var j={onBeforeRendering:function(){C.removeEventDelegate(j);t._doBFS([{oNode:C.getComponentInstance(),oAdaptOptions:A}]);if(t._getCurrentlyAdaptedTopViewId()){t._fireViewChange(t._getCurrentlyAdaptedTopViewId(),A);}}};C.addEventDelegate(j,this);}}};
F._checkHasListener=function(k){return i.aChangeListeners[k];};
F._setHasListener=function(k,v){i.aChangeListeners[k]=v;};
F._attachAdaptableContentChange=function(C,A){if(!C._getAdaptableContent||!q.isFunction(C._getAdaptableContent)){return;}var k=C.getId()+"_adaptableContentChange";if(this._checkHasListener(k)){return;}var o=this._getCurrentlyAdaptedTopViewId();var j=function(l){var m=l.getParameter("adaptableContent");this._setAsCurrentlyAdaptedTopViewId(o);this._doBFS([{oNode:m,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);C.attachEvent("_adaptableContentChange",j);this._setHasListener(k,j);};
F._attachNavigablePageChange=function(C,A){if(!f(C,"sap/m/NavContainer")){return;}var k=C.getId()+"navigate";if(this._checkHasListener(k)){return;}var o=function(j){var n=j.getParameter("to");A=this._applyRules(A,n);this._doBFS([{oNode:n,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);C.attachNavigate(o);this._setHasListener(k,o);};
F._attachModifyAggregation=function(C,A,o,j){var k=C.getId()+A;if(this._checkHasListener(k)){return;}var l=this._getCurrentlyAdaptedTopViewId(),m=function(p){var s=p.mutation,r=p.object;if((s==="add")||(s==="insert")){this._setAsCurrentlyAdaptedTopViewId(l);this._doBFS([{oNode:j?j:r,oAdaptOptions:o}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),o);}}}.bind(this),n=new M(m);n.observe(C,{aggregations:[A]});this._setHasListener(k,n);};
F._getNodeChildren=function(C){if(C._getAdaptableContent&&q.isFunction(C._getAdaptableContent)){var j=[C._getAdaptableContent()];if(f(C,"sap/m/Page")){j=j.concat(C.getContent());}return j;}if(f(C,"sap/m/SplitContainer")){return[].concat(C.getAggregation("_navMaster"),C.getAggregation("_navDetail"));}if(f(C,"sap/uxap/ObjectPageLayout")){return[C.getHeaderTitle()];}if(f(C,"sap/ui/core/ComponentContainer")){return[C.getComponentInstance()];}if(f(C,"sap/ui/core/UIComponent")){return[C.getAggregation("rootControl")];}return C.findAggregatedObjects(false,g);};
F._updateSearchDepth=function(s,C){if(f(C,"sap/ui/core/mvc/View")||f(C,"sap/ui/core/Component")||f(C,"sap/ui/core/ComponentContainer")){return s;}return s-1;};
F._getTotalCachedInfoToMerge=function(v){var V=sap.ui.getCore().byId(v),C=this._getCachedViewInfoToMerge(v),j,k,s,S,o,p,l;if(!D.system.phone&&this._isTopSplitContainerSubView(V)){p=V.getParent();o=p&&p.getParent();if(o){j=o._oMasterNav&&(o._oMasterNav.getId()===p.getId());k=o._oDetailNav&&(o._oDetailNav.getId()===p.getId());}}if(j){s=o.getCurrentDetailPage();S=s&&s.getId();l=this._getCachedViewInfoToMerge(S);C=this._mergeSplitViewInfos(C,l);}if(k){s=o.getCurrentMasterPage();S=s&&s.getId();l=this._getCachedViewInfoToMerge(S);C=this._mergeSplitViewInfos(l,C);}C.sViewId=(j||k)?o.getId():v;return C;};
F._isTopSplitContainerSubView=function(C){var p=C&&C.getParent();return this._isTopmostNavContainer(p)&&f(p.getParent(),"sap/m/SplitContainer");};
F._mergeSplitViewInfos=function(m,o){q.each(m,function(k,v){m[k]=v||o[k];});return m;};
F._getCachedViewInfoToMerge=function(v){var B=(i.aViewBackButtons[v])?i.aViewBackButtons[v].oControl:undefined;return{oTitleInfo:i.aViewTitles[v],oSubTitleInfo:i.aViewSubTitles[v],oBackButton:B};};
F._applyRules=function(A,C){var p=C.getParent();if(f(p,"sap/m/SplitContainer")){var I=D.system.phone,m=A.bMoveTitle,j=A.bHideBackButton;if(m){m=I;}if(j&&!D.system.phone){j='initialPage';}return q.extend({},A,{bMoveTitle:m,bHideBackButton:j});}if(f(p,"sap/m/NavContainer")){if(A.bHideBackButton==='initialPage'){var k=p._getActualInitialPage()&&(p._getActualInitialPage().getId()===C.getId());return q.extend({},A,{bHideBackButton:k});}}if((A.bMoveTitle===false)||(A.bHideBackButton===false)){return q.extend({},A,{bCollapseHeader:false});}return A;};
F._getCurrentlyAdaptedTopViewId=function(){return c;};
F._setAsCurrentlyAdaptedTopViewId=function(v){c=v;};
F._isTopNavigableView=function(n){var p=n.getParent();return p&&this._isTopmostNavContainer(p);};
F._isTopmostNavContainer=function(C){var o,n=C;while(n){if(f(n,"sap/m/NavContainer")){o=n;}n=n.getParent();}return o&&(o.getId()===C.getId());};
F._adaptHeader=function(o,A){if(!o||!A){return;}var j=new H(o,A),k=j.adapt();var t=this._getCurrentlyAdaptedTopViewId();if(k.oTitleInfo){i.aViewTitles[t]=k.oTitleInfo;this._registerTextChangeListener(i.aViewTitles,t,A);}if(k.oSubTitleInfo){i.aViewSubTitles[t]=k.oSubTitleInfo;this._registerTextChangeListener(i.aViewSubTitles,t,A);}if(k.oBackButtonInfo){if(k.oBackButtonInfo.oControl.getVisible()){i.aViewBackButtons[t]=k.oBackButtonInfo;}this._registerVisibilityChangeListener(k.oBackButtonInfo,i.aViewBackButtons,t,A);}return k;};
F._registerTextChangeListener=function(t,v,A){var T=t[v];if(T&&T.oControl&&T.sChangeEventId&&!i.aChangeListeners[T.id]){var C=function(o){var T=t[v];if(o.getParameter("name")!==T.sPropertyName){return;}T.text=o.getParameter("newValue");this._fireViewChange(v,A);}.bind(this);T.oControl.attachEvent(T.sChangeEventId,C);i.aChangeListeners[T.id]=C;}};
F._registerVisibilityChangeListener=function(C,j,v,A){var V;if(C&&C.oControl&&C.sChangeEventId&&!i.aChangeListeners[C.id]){var k=function(o){if(o.getParameter("name")!==C.sPropertyName){return;}V=o.getParameter("newValue");if(!V){q.each(j,function(I,l){if(l.oControl.getId()===C.oControl.getId()){delete j[I];}});}var p=C.oControl.getParent();if(H._isAdaptableHeader(p)){F._adaptHeader(p,A);this._fireViewChange(v,A);}}.bind(this);C.oControl.attachEvent(C.sChangeEventId,k);i.aChangeListeners[C.id]=k;}};
F._fireViewChange=function(v,A){var t=this._getTotalCachedInfoToMerge(v);t.oAdaptOptions=A;e.fireEvent("adaptedViewChange",t);};
F._isAdaptationRequired=function(n,A){if(!n||this._isNonAdaptableControl(n)){return false;}for(var o in A){if(A.hasOwnProperty(o)&&((A[o]===true)||(A[o]==="initialPage"))){return true;}}return false;};
F._isNonAdaptableControl=function(C){return b(C);};
function a(C){return d(C,["sap/m/Label","sap/m/Text","sap/m/Title"]);}
function b(C){return d(C,["sap/m/List","sap/m/Table","sap/ui/table/Table","sap/ui/table/TreeTable"]);}
function d(C,t){if(!C||!t){return;}return t.some(function(T){return f(C,T);});}
function f(C,t){var T=sap.ui.require(t);return T&&(C instanceof T);}
function g(o){return o&&(o.sParentAggregationName!=="dependents");}
function h(o){return o&&(typeof o.getVisible==="function")&&(o.getVisible()===false);}
return F;});
sap.ui.predefine('sap/m/FlexBox',['./FlexBoxStylingHelper','./FlexItemData','./library','sap/ui/core/Control','sap/ui/core/InvisibleRenderer','./FlexBoxRenderer','sap/ui/thirdparty/jquery'],function(F,a,l,C,I,b,q){"use strict";var B=l.BackgroundDesign;var c=l.FlexAlignContent;var d=l.FlexWrap;var e=l.FlexAlignItems;var f=l.FlexJustifyContent;var g=l.FlexRendertype;var h=l.FlexDirection;
var j=C.extend("sap.m.FlexBox",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},displayInline:{type:"boolean",group:"Appearance",defaultValue:false},direction:{type:"sap.m.FlexDirection",group:"Appearance",defaultValue:h.Row},fitContainer:{type:"boolean",group:"Appearance",defaultValue:false},renderType:{type:"sap.m.FlexRendertype",group:"Misc",defaultValue:g.Div},justifyContent:{type:"sap.m.FlexJustifyContent",group:"Appearance",defaultValue:f.Start},alignItems:{type:"sap.m.FlexAlignItems",group:"Appearance",defaultValue:e.Stretch},wrap:{type:"sap.m.FlexWrap",group:"Appearance",defaultValue:d.NoWrap},alignContent:{type:"sap.m.FlexAlignContent",group:"Appearance",defaultValue:c.Stretch},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Transparent}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Control",multiple:true,singularName:"item"}},designtime:"sap/m/designtime/FlexBox.designtime",dnd:{draggable:false,droppable:true}}});
j.prototype.init=function(){if(this instanceof sap.m.HBox&&(this.getDirection()!==h.Row||this.getDirection()!==h.RowReverse)){this.setDirection('Row');}if(this instanceof sap.m.VBox&&(this.getDirection()!==h.Column||this.getDirection()!==h.ColumnReverse)){this.setDirection('Column');}this._oItemDelegate={onAfterRendering:this._onAfterItemRendering};};
j.prototype.addItem=function(i){this.addAggregation("items",i);this._onItemInserted(i);return this;};
j.prototype.insertItem=function(i,k){this.insertAggregation("items",i,k);this._onItemInserted(i);return this;};
j.prototype.removeItem=function(i){var o=this.removeAggregation("items",i);this._onItemRemoved(o);return o;};
j.prototype.removeAllItems=function(){var k=this.getItems();for(var i=0;i<k.length;i++){this._onItemRemoved(k[i]);}return this.removeAllAggregation("items");};
j.prototype._onItemInserted=function(i){if(i&&!(i instanceof j)){i.attachEvent("_change",this._onItemChange,this);if(this.getRenderType()===g.Bare){i.addEventDelegate(this._oItemDelegate,i);}}};
j.prototype._onItemRemoved=function(i){if(i&&!(i instanceof j)){i.detachEvent("_change",this._onItemChange,this);if(this.getRenderType()===g.Bare){i.removeEventDelegate(this._oItemDelegate,i);}}};
j.prototype._onItemChange=function(o){if(o.getParameter("name")!=="visible"||(this.getRenderType()!==g.List&&this.getRenderType()!==g.Div)){return;}var i=sap.ui.getCore().byId(o.getParameter("id")),w=null;if(i.getLayoutData()){w=q(document.getElementById(i.getLayoutData().getId()));}else{w=q(document.getElementById(I.createInvisiblePlaceholderId(i))).parent();}if(o.getParameter("newValue")){w.removeClass("sapUiHiddenPlaceholder").removeAttr("aria-hidden");}else{w.addClass("sapUiHiddenPlaceholder").attr("aria-hidden","true");}};
j.prototype._onAfterItemRendering=function(){var L=this.getLayoutData();if(L instanceof a){F.setFlexItemStyles(null,L);}};
j.prototype.setRenderType=function(v){var o=this.getRenderType(),i=this.getItems();if(v===o){return this;}this.setProperty("renderType",v);if(o==="Bare"){i.forEach(this._onItemRemoved,this);}if(v==="Bare"){i.forEach(this._onItemInserted,this);}return this;};
j.prototype.setDisplayInline=function(i){this.setProperty("displayInline",i,true);this.$().toggleClass("sapMFlexBoxInline",this.getDisplayInline());return this;};
j.prototype.setDirection=function(v){this.setProperty("direction",v,true);if(this.getDirection()===h.Column||this.getDirection()===h.ColumnReverse){this.$().removeClass("sapMHBox").addClass("sapMVBox");}else{this.$().removeClass("sapMVBox").addClass("sapMHBox");}if(this.getDirection()===h.RowReverse||this.getDirection()===h.ColumnReverse){this.$().addClass("sapMFlexBoxReverse");}else{this.$().removeClass("sapMFlexBoxReverse");}return this;};
j.prototype.setFitContainer=function(v){this.setProperty("fitContainer",v,true);this.$().toggleClass("sapMFlexBoxFit",this.getFitContainer());return this;};
j.prototype.setWrap=function(v){var o=this.getWrap();this.setProperty("wrap",v,true);this.$().removeClass("sapMFlexBoxWrap"+o).addClass("sapMFlexBoxWrap"+this.getWrap());return this;};
j.prototype.setJustifyContent=function(v){var o=this.getJustifyContent();this.setProperty("justifyContent",v,true);this.$().removeClass("sapMFlexBoxJustify"+o).addClass("sapMFlexBoxJustify"+this.getJustifyContent());return this;};
j.prototype.setAlignItems=function(v){var o=this.getAlignItems();this.setProperty("alignItems",v,true);this.$().removeClass("sapMFlexBoxAlignItems"+o).addClass("sapMFlexBoxAlignItems"+this.getAlignItems());return this;};
j.prototype.setAlignContent=function(v){var o=this.getAlignContent();this.setProperty("alignContent",v,true);this.$().removeClass("sapMFlexBoxAlignContent"+o).addClass("sapMFlexBoxAlignContent"+this.getAlignContent());return this;};
j.prototype.setHeight=function(v){this.setProperty("height",v,true);this.$().css("height",this.getHeight());return this;};
j.prototype.setWidth=function(v){this.setProperty("width",v,true);this.$().css("width",this.getWidth());return this;};
j.prototype.setBackgroundDesign=function(v){var o=this.getBackgroundDesign();this.setProperty("backgroundDesign",v,true);this.$().removeClass("sapMFlexBoxBG"+o).addClass("sapMFlexBoxBG"+this.getBackgroundDesign());return this;};
j.prototype.getAccessibilityInfo=function(){return{children:this.getItems()};};
return j;});
sap.ui.predefine('sap/m/FlexBoxCssPropertyMap',[],function(){"use strict";var F={'specie10':{'order':{'<number>':{'flex-order':'<number>'}},'flex-grow':{'<number>':{'flex-positive':'<number>','flex-preferred-size':'auto'}},'flex-shrink':{'<number>':{'flex-negative':'<number>'}},'flex-basis':{'<number>':{'flex-preferred-size':'<number>'}}}};return F;},true);
sap.ui.predefine('sap/m/FlexBoxRenderer',['./FlexBoxStylingHelper','sap/m/library',"sap/base/Log","sap/m/FlexItemData"],function(F,l,L,a){"use strict";var b=l.FlexDirection;var c=l.FlexRendertype;var d={apiVersion:2};
d.render=function(r,C){r.openStart(C.getRenderType()==c.List?"ul":"div",C);var p=C.getParent();if(p&&p.isA("sap.m.FlexBox")){if(!C.hasStyleClass("sapMFlexItem")){r.class("sapMFlexItem");}var o=C.getLayoutData();if(o instanceof a){F.setFlexItemStyles(r,o);}}else if(C.getFitContainer()){r.class("sapMFlexBoxFit");}r.class("sapMFlexBox");if(C.getDisplayInline()){r.class("sapMFlexBoxInline");}if(C.getDirection()===b.Column||C.getDirection()===b.ColumnReverse){r.class("sapMVBox");}else{r.class("sapMHBox");}if(C.getDirection()===b.RowReverse||C.getDirection()===b.ColumnReverse){r.class("sapMFlexBoxReverse");}r.class("sapMFlexBoxJustify"+C.getJustifyContent());r.class("sapMFlexBoxAlignItems"+C.getAlignItems());r.class("sapMFlexBoxWrap"+C.getWrap());r.class("sapMFlexBoxAlignContent"+C.getAlignContent());var B="sapMFlexBoxBG"+C.getBackgroundDesign();if(!C.hasStyleClass(B)){r.class(B);}r.style("height",C.getHeight());r.style("width",C.getWidth());var t=C.getTooltip_AsString();if(t){r.attr("title",t);}r.openEnd();d.renderItems(C,r);if(C.getRenderType()===c.List){r.close("ul");}else{r.close("div");}};
d.renderItems=function(C,r){var e=C.getItems(),w='';for(var i=0;i<e.length;i++){if(e[i].isA('sap.m.FlexBox')||C.getRenderType()===c.Bare){w="";}else if(C.getRenderType()===c.List){w="li";}else{w="div";}d.renderItem(e[i],w,r);}};
d.renderItem=function(i,w,r){var o=i.getLayoutData();if(w&&!o){i.setAggregation("layoutData",new a(),true);o=i.getLayoutData();}if(!(o instanceof a)){if(o){L.warning(o+" set on "+i+" is not of type sap.m.FlexItemData");}if(w){r.openStart(w);}}else{if(w){r.openStart(w,o.getId());}if(o.getStyleClass()){d.addItemClass(o.getStyleClass(),i,w,r);}d.addItemClass("sapMFlexItemAlign"+o.getAlignSelf(),i,w,r);d.addItemClass("sapMFlexBoxBG"+o.getBackgroundDesign(),i,w,r);if(w){F.setFlexItemStyles(r,o);}}d.addItemClass("sapMFlexItem",i,w,r);if(w){if(i.isA("sap.m.ScrollContainer")){r.class("sapMFlexBoxScroll");}if(!i.getVisible()){r.class("sapUiHiddenPlaceholder");}r.openEnd();}r.renderControl(i);if(w){r.close(w);}};
d.addItemClass=function(C,i,w,r){if(w){r.class(C);}else{i.addStyleClass(C);}};
return d;},true);
sap.ui.predefine('sap/m/FlexBoxStylingHelper',['./FlexBoxCssPropertyMap','sap/ui/Device'],function(F,D){"use strict";var a={};
a.setFlexItemStyles=function(r,l){r=r||null;var o=''+l.getOrder(),g=''+l.getGrowFactor(),s=''+l.getShrinkFactor(),b=l.getBaseSize().toLowerCase(),m=l.getMinHeight(),M=l.getMaxHeight(),c=l.getMinWidth(),d=l.getMaxWidth();if(typeof o!=='undefined'){a.setStyle(r,l,"order",o);}if(typeof g!=='undefined'){a.setStyle(r,l,"flex-grow",g);}if(typeof s!=='undefined'){a.setStyle(r,l,"flex-shrink",s);}if(typeof b!=='undefined'){a.setStyle(r,l,"flex-basis",b);}if(typeof m!=='undefined'){a.setStyle(r,l,"min-height",m);}if(typeof M!=='undefined'){a.setStyle(r,l,"max-height",M);}if(typeof c!=='undefined'){a.setStyle(r,l,"min-width",c);}if(typeof d!=='undefined'){a.setStyle(r,l,"max-width",d);}};
a.setStyle=function(r,l,p,v){if(typeof(v)==="string"){v=v.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();}a.writeStyle(r,l,p,v);};
a.writeStyle=function(r,l,p,v){if(D.browser.internet_explorer&&(p==="flex-basis"||p==="flex-preferred-size")){if(l.getParent()){if(l.getParent().getParent().getDirection().indexOf("Row")>-1){p="width";}else{p="height";}}}if(r){if(v==="0"||v){r.style(p,v);}}else{if(l.$().length){if(v!=="0"&&!v){l.$().css(p,null);}else{l.$().css(p,v);}}else{if(l.getParent()){if(v!=="0"&&!v){l.getParent().$().css(p,null);}else{l.getParent().$().css(p,v);}}}}};
return a;},true);
sap.ui.predefine('sap/m/FlexItemData',['./FlexBoxStylingHelper','./library','sap/ui/core/LayoutData'],function(F,l,L){"use strict";var B=l.BackgroundDesign;var a=l.FlexAlignSelf;
var b=L.extend("sap.m.FlexItemData",{metadata:{library:"sap.m",properties:{alignSelf:{type:"sap.m.FlexAlignSelf",group:"Misc",defaultValue:a.Auto},order:{type:"int",group:"Misc",defaultValue:0},growFactor:{type:"float",group:"Misc",defaultValue:0},shrinkFactor:{type:"float",group:"Misc",defaultValue:1},baseSize:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"auto"},minHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},maxHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},styleClass:{type:"string",group:"Misc",defaultValue:''},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Transparent}}}});
b.prototype.setAlignSelf=function(v){var o=this.getAlignSelf();this.setProperty("alignSelf",v,true);this.$().removeClass("sapMFlexItemAlign"+o).addClass("sapMFlexItemAlign"+this.getAlignSelf());return this;};
b.prototype.setOrder=function(v){this.setProperty("order",v,true);F.setStyle(null,this,"order",this.getOrder());return this;};
b.prototype.setGrowFactor=function(v){this.setProperty("growFactor",v,true);F.setStyle(null,this,"flex-grow",this.getGrowFactor());return this;};
b.prototype.setShrinkFactor=function(v){this.setProperty("shrinkFactor",v,true);F.setStyle(null,this,"flex-shrink",this.getShrinkFactor());return this;};
b.prototype.setBaseSize=function(v){this.setProperty("baseSize",v,true);F.setStyle(null,this,"flex-basis",this.getBaseSize());return this;};
b.prototype.setMinHeight=function(v){this.setProperty("minHeight",v,true);this.$().css("min-height",this.getMinHeight());return this;};
b.prototype.setMaxHeight=function(v){this.setProperty("maxHeight",v,true);this.$().css("max-height",this.getMaxHeight());return this;};
b.prototype.setMinWidth=function(v){this.setProperty("minWidth",v,true);this.$().css("min-width",this.getMinWidth());return this;};
b.prototype.setMaxWidth=function(v){this.setProperty("maxWidth",v,true);this.$().css("max-width",this.getMaxWidth());return this;};
b.prototype.setBackgroundDesign=function(v){var o=this.getBackgroundDesign();this.setProperty("backgroundDesign",v,true);this.$().removeClass("sapMFlexBoxBG"+o).addClass("sapMFlexBoxBG"+this.getBackgroundDesign());return this;};
b.prototype.setStyleClass=function(v){var o=this.getStyleClass();this.setProperty("styleClass",v,true);this.$().removeClass(o).addClass(this.getStyleClass());return this;};
b.prototype.getDomRef=function(s){var p,i=L.prototype.getDomRef.call(this,s);if(i){return i;}p=this.getParent();if(!p){return null;}return p.getDomRef(s);};
return b;});
sap.ui.predefine('sap/m/FormattedText',['./library','sap/ui/core/Control','./FormattedTextAnchorGenerator','./FormattedTextRenderer',"sap/base/Log","sap/base/security/URLWhitelist","sap/base/security/sanitizeHTML"],function(l,C,F,a,L,U,s){"use strict";var b=l.LinkConversion;
var c=C.extend("sap.m.FormattedText",{metadata:{library:"sap.m",properties:{htmlText:{type:"string",group:"Misc",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},convertLinksToAnchorTags:{type:"sap.m.LinkConversion",group:"Behavior",defaultValue:b.None},convertedLinksDefaultTarget:{type:"string",group:"Behavior",defaultValue:"_blank"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}}}});
var _={ATTRIBS:{'style':1,'class':1,'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'abbr':1,'blockquote':1,'br':1,'cite':1,'code':1,'em':1,'h1':{cssClass:'sapMTitle sapMTitleStyleH1'},'h2':{cssClass:'sapMTitle sapMTitleStyleH2'},'h3':{cssClass:'sapMTitle sapMTitleStyleH3'},'h4':{cssClass:'sapMTitle sapMTitleStyleH4'},'h5':{cssClass:'sapMTitle sapMTitleStyleH5'},'h6':{cssClass:'sapMTitle sapMTitleStyleH6'},'p':1,'pre':1,'strong':1,'span':1,'u':1,'dl':1,'dt':1,'dd':1,'ol':1,'ul':1,'li':1}},d={ATTRIBS:{'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'em':1,'strong':1,'u':1}};c.prototype._renderingRules=_;
c.prototype.init=function(){};
function S(t,f){var w;var g,v,h=t==="a";var j=this._renderingRules.ELEMENTS[t].cssClass||"";for(var i=0;i<f.length;i+=2){g=f[i];v=f[i+1];if(!this._renderingRules.ATTRIBS[g]&&!this._renderingRules.ATTRIBS[t+"::"+g]){w='FormattedText: <'+t+'> with attribute ['+g+'="'+v+'"] is not allowed';L.warning(w,this);f[i+1]=null;continue;}if(g=="href"){if(!U.validate(v)){L.warning("FormattedText: incorrect href attribute:"+v,this);f[i+1]="#";h=false;}}if(g=="target"){h=false;}if(j&&g.toLowerCase()=="class"){f[i+1]=j+" "+v;j="";}}if(h){f.push("target");f.push("_blank");}if(j){f.push("class");f.push(j);}return f;}
function p(t,f){if(this._renderingRules.ELEMENTS[t]){return S.call(this,t,f);}else{var w='<'+t+'> is not allowed';L.warning(w,this);}}
function e(t){return s(t,{tagPolicy:p.bind(this),uriRewriter:function(u){if(U.validate(u)){return u;}}});}
function o(E){var n=window.open();n.opener=null;n.location=E.currentTarget.href;E.preventDefault();}
c.prototype.onAfterRendering=function(){this.$().find('a[target="_blank"]').on("click",o);};
c.prototype._getDisplayHtml=function(){var t=this.getHtmlText(),A=this.getConvertLinksToAnchorTags();if(A===l.LinkConversion.None){return t;}t=F.generateAnchors(t,A,this.getConvertedLinksDefaultTarget());return e.call(this,t);};
c.prototype.setHtmlText=function(t){return this.setProperty("htmlText",e.call(this,t));};
c.prototype._setUseLimitedRenderingRules=function(f){this._renderingRules=f?d:_;};
return c;});
sap.ui.predefine('sap/m/FormattedTextAnchorGenerator',["sap/ui/base/Metadata","sap/m/library","sap/base/security/URLWhitelist"],function(M,l,U){"use strict";var L=l.LinkConversion;var A=M.createClass("sap.m.FormattedTextAnchorGenerator",{});var c=/(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;()$]*[-A-Z0-9+&@#\/%=~_|])/gim;var W=/(www\.[^\s><]+(\b|$))/gim;var d="//";var D=/<(?:"[^"]*"['"]*|'[^']*'['"]*|[^'">])+(?!\/\s\*)>/gim;var E=/<a[^>]*>([^<]+)<\/a>/gim;var e=[D,E];
A.generateAnchors=function(t,s,T){if(s===L.ProtocolOnly){t=A._createAnchors(t,c,T);}if(s===L.All){t=A._createAnchors(t,c,T);t=A._createAnchors(t,W,T,d);}return t;};
A._createPositionObject=function(i,a){return{iStartPos:i,iEndPos:i+a};};
A._isNested=function(f,s){return f.iStartPos<s.iStartPos&&f.iEndPos>s.iEndPos;};
A._isAllowed=function(b,C){return b.some(function(B){return A._isNested(B,C);});};
A._shouldBeProcessed=function(u,C,b){return U.validate(u)&&!A._isAllowed(b,C);};
A._scanForEntitiesToSkip=function(r,t){var a=[],C;while((C=r.exec(t))!==null){a.push(A._createPositionObject(C.index,C[0].length));}return a;};
A._getEntitiesToSkipWhileSearchingForLinks=function(t){return e.map(function(s){return A._scanForEntitiesToSkip(s,t);}).reduce(function(a,b){return a.concat(b);});};
A._createAnchors=function(t,r,T,p){var a=A._getEntitiesToSkipWhileSearchingForLinks(t),C;p=p||'';C=function(P){var o=A._createPositionObject(arguments[3],P.length);if(!A._shouldBeProcessed(P,o,a)){return P;}return"<a href=\""+p+P+"\" target=\""+T+"\">"+P+"</a>";};return t.replace(r,C);};
return A;},false);
sap.ui.predefine('sap/m/FormattedTextRenderer',[],function(){"use strict";var F={};
F.render=function(r,c){var w=c.getWidth();var h=c.getHeight();r.write("<div");r.writeControlData(c);r.addClass("sapMFT");if(w){r.addClass("sapMFTOverflowWidth");}if(h){r.addClass("sapMFTOverflowHeight");}r.writeClasses();if(c.getTooltip_AsString()){r.writeAttributeEscaped("title",c.getTooltip_AsString());}r.addStyle("width",w||null);r.addStyle("height",h||null);r.writeStyles();r.write(">");r.write(c._getDisplayHtml());r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/GenericTag',["sap/ui/core/Control","sap/ui/events/KeyCodes",'./library',"sap/ui/core/library","sap/ui/core/Icon","./GenericTagRenderer"],function(C,K,l,c,I){"use strict";var G=l.GenericTagDesign,a=l.GenericTagValueState,V=c.ValueState,b={Error:"sap-icon://message-error",Warning:"sap-icon://message-warning",Success:"sap-icon://message-success",Information:"sap-icon://hint"};
var d=C.extend("sap.m.GenericTag",{metadata:{library:"sap.m",interfaces:["sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent"],properties:{text:{type:"string",defaultValue:""},status:{type:"sap.ui.core.ValueState",defaultValue:V.None},design:{type:"sap.m.GenericTagDesign",defaultValue:G.Full},valueState:{type:"sap.m.GenericTagValueState",defaultValue:a.None}},defaultAggregation:"value",aggregations:{value:{type:"sap.m.ObjectNumber",multiple:false},_statusIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_errorIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{press:{}}}});
d.CLASSNAME_OVERFLOW_TOOLBAR="sapMGenericTagOverflowToolbar";
d.prototype.setStatus=function(s){this.setProperty("status",s,false);this._getStatusIcon().setSrc(s!==V.None?b[s]:null);return this;};
d.prototype._getStatusIcon=function(){var s=this.getAggregation("_statusIcon");if(!s){s=new I(this.getId()+"-statusIcon").addStyleClass("sapMGenericTagIcon");this.setAggregation("_statusIcon",s);}return s;};
d.prototype._getErrorIcon=function(){var e=this.getAggregation("_errorIcon");if(!e){e=new I(this.getId()+"-errorIcon",{src:b[V.Error]}).addStyleClass("sapMGenericTagErrorIcon");this.setAggregation("_errorIcon",e);}return e;};
d.prototype.ontouchstart=function(){this._toggleActiveGenericTag(true);};
d.prototype.ontouchend=function(){this._toggleActiveGenericTag(false);};
d.prototype.ontouchcancel=function(){this._toggleActiveGenericTag(false);};
d.prototype.onkeydown=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._toggleActiveGenericTag(true);}if(e.which===K.SPACE){e.preventDefault();}if(e.which===K.ENTER){this.firePress();}};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._toggleActiveGenericTag(false);}if(e.which===K.SPACE){this.firePress();}};
d.prototype.onclick=function(){this.firePress();};
d.prototype.onfocusout=function(){this._toggleActiveGenericTag(false);};
d.prototype._toggleActiveGenericTag=function(t){this.toggleStyleClass("sapMGenericTagActive",t);};
d.prototype._onBeforeEnterOverflow=function(o){o.addStyleClass(d.CLASSNAME_OVERFLOW_TOOLBAR);};
d.prototype._onAfterExitOverflow=function(o){o.removeStyleClass(d.CLASSNAME_OVERFLOW_TOOLBAR);};
d.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true};o.onBeforeEnterOverflow=this._onBeforeEnterOverflow;o.onAfterExitOverflow=this._onAfterExitOverflow;return o;};
return d;});
sap.ui.predefine('sap/m/GenericTagRenderer',["./library","sap/ui/core/library"],function(l,c){"use strict";var G=l.GenericTagDesign,a=l.GenericTagValueState,V=c.ValueState,C=sap.ui.getCore(),b={apiVersion:2};
b.render=function(r,o){var L=this._getAriaLabelledBy(o),R=C.getLibraryResourceBundle("sap.m"),t=o.getTooltip_AsString();r.openStart("div",o);r.class("sapMGenericTag");r.attr("tabindex",0);r.class("sapMGenericTag"+o.getStatus());r.accessibilityState(o,{role:"button",roledescription:R.getText("GENERICTAG_ROLEDESCRIPTION"),labelledby:L.join(" ")});if(t){r.attr("title",t);}r.openEnd();r.openStart("div");r.class("sapMGenericTagWrap");r.openEnd();this.renderElements(r,o);r.close("div");r.close("div");};
b.renderElements=function(r,o){var s=o.getDesign()===G.StatusIconHidden,S=o.getValueState()===a.Error,v=o.getValue();if(!s&&o.getStatus()!==V.None){r.renderControl(o._getStatusIcon());}this.renderText(r,o);if(S){r.renderControl(o._getErrorIcon());}else if(v){r.renderControl(v.addStyleClass("sapMGenericTagValue"));}this.renderHiddenARIAElement(r,o);};
b.renderText=function(r,o){r.openStart("span");r.class("sapMGenericTagText");r.attr("id",o.getId()+"-text");r.openEnd();r.text(o.getText());r.close("span");};
b.renderHiddenARIAElement=function(r,o){if(o.getStatus()===V.None){return;}r.openStart("span");r.class("sapUiInvisibleText");r.attr("id",o.getId()+"-status");r.attr("aria-hidden","true");r.openEnd();r.text(this._getGenericTagStatusText(o));r.close("span");};
b._getAriaLabelledBy=function(o){var L=[],i=o.getId(),t=this._getTagValueId(o),T=this._getTagValueState(o);if(o.getStatus()!==V.None){L.push(i+"-status");}L.push(i+"-text");L.push(o.getValueState()===a.Error?i+"-errorIcon":t);if(T&&T!==V.None){L.push(t+'-state');}return L;};
b._getGenericTagStatusText=function(o){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),A;switch(o.getStatus()){case V.Error:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_ERROR");break;case V.Warning:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_WARNING");break;case V.Success:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_SUCCESS");break;case V.Information:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_INFORMATION");break;default:}return A;};
b._getTagValueId=function(o){var v=o.getValue();return v?v.getId():"";};
b._getTagValueState=function(o){var v=o.getValue();return v?v.getState():"";};
return b;},true);
sap.ui.predefine('sap/m/GenericTile',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/core/HTML','sap/ui/core/Icon','sap/ui/core/IconPool','sap/m/Button','sap/m/GenericTileRenderer','sap/m/GenericTileLineModeRenderer','sap/ui/Device','sap/ui/core/ResizeHandler',"sap/base/strings/camelize","sap/base/util/deepEqual","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery"],function(l,C,T,H,I,a,B,G,L,D,R,c,d,P,q){"use strict";var b=l.GenericTileScope,e=l.LoadState,F=l.FrameType,S=l.Size,f=l.GenericTileMode,g=l.TileSizeBehavior,W=l.WrappingType;var h="GenericTileDeviceSet";
var j=C.extend("sap.m.GenericTile",{
metadata:{library:"sap.m",properties:{mode:{type:"sap.m.GenericTileMode",group:"Appearance",defaultValue:f.ContentMode},header:{type:"string",group:"Appearance",defaultValue:null},subheader:{type:"string",group:"Appearance",defaultValue:null},failedText:{type:"string",group:"Appearance",defaultValue:null},size:{type:"sap.m.Size",group:"Misc",defaultValue:S.Auto},frameType:{type:"sap.m.FrameType",group:"Misc",defaultValue:F.OneByOne},backgroundImage:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},headerImage:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},state:{type:"sap.m.LoadState",group:"Misc",defaultValue:e.Loaded},imageDescription:{type:"string",group:"Accessibility",defaultValue:null},scope:{type:"sap.m.GenericTileScope",group:"Misc",defaultValue:b.Display},sizeBehavior:{type:"sap.m.TileSizeBehavior",defaultValue:g.Responsive},ariaLabel:{type:"string",group:"Accessibility",defaultValue:null},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},width:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"tileContent",aggregations:{tileContent:{type:"sap.m.TileContent",multiple:true,bindable:"bindable"},icon:{type:"sap.ui.core.Control",multiple:false},_titleText:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_failedMessageText:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{press:{parameters:{scope:{type:"sap.m.GenericTileScope"},action:{type:"string"},domRef:{type:"any"}}}}},
renderer:function(r,o){if(o.getMode()===l.GenericTileMode.LineMode){L.render(r,o);}else{G.render(r,o);}}
});
j._Action={Press:"Press",Remove:"Remove"};j.LINEMODE_SIBLING_PROPERTIES=["state","subheader","header","scope"];
j.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!D.media.hasRangeSet(h)){D.media.initRangeSet(h,[450],"px",["small","large"]);}this._oTitle=new T(this.getId()+"-title");this._oTitle.addStyleClass("sapMGTTitle");this._oTitle.cacheLineHeight=false;this.setAggregation("_titleText",this._oTitle,true);this._oSubTitle=new T(this.getId()+"-subTitle");this._oSubTitle.cacheLineHeight=false;this.addDependent(this._oSubTitle);this._sFailedToLoad=this._oRb.getText("INFOTILE_CANNOT_LOAD_TILE");this._sLoading=this._oRb.getText("INFOTILE_LOADING");this._oFailedText=new T(this.getId()+"-failed-txt",{maxLines:2});this._oFailedText.cacheLineHeight=false;this._oFailedText.addStyleClass("sapMGTFailed");this.setAggregation("_failedMessageText",this._oFailedText,true);this._oWarningIcon=new I(this.getId()+"-warn-icon",{src:"sap-icon://notification",size:"1.375rem"});this._oWarningIcon.addStyleClass("sapMGTFtrFldIcnMrk");this._oBusy=new H(this.getId()+"-overlay");this._oBusy.setBusyIndicatorDelay(0);this._bTilePress=true;this._bThemeApplied=true;if(!sap.ui.getCore().isInitialized()){this._bThemeApplied=false;sap.ui.getCore().attachInit(this._handleCoreInitialized.bind(this));}else{this._handleCoreInitialized();}};
j.prototype.setWrappingType=function(w){this.setProperty("wrappingType",w,true);this._oTitle.setWrappingType(w);this._oFailedText.setWrappingType(w);this._oSubTitle.setWrappingType(w);return this;};
j.prototype.setSubheader=function(s){this.setProperty("subheader",s);this._oSubTitle.setText(s);return this;};
j.prototype._handleCoreInitialized=function(){this._bThemeApplied=sap.ui.getCore().isThemeApplied();if(!this._bThemeApplied){sap.ui.getCore().attachThemeChanged(this._handleThemeApplied,this);}};
j.prototype._handleThemeApplied=function(){this._bThemeApplied=true;this._oTitle.clampHeight();sap.ui.getCore().detachThemeChanged(this._handleThemeApplied,this);};
j.prototype._initScopeContent=function(t){switch(this.getScope()){case l.GenericTileScope.Actions:if(this.getState&&this.getState()===l.LoadState.Disabled){break;}this._oMoreIcon=this._oMoreIcon||a.createControlByURI({id:this.getId()+"-action-more",size:"1rem",useIconTooltip:false,src:"sap-icon://overflow"}).addStyleClass("sapMPointer").addStyleClass(t+"MoreIcon");this._oRemoveButton=this._oRemoveButton||new B({id:this.getId()+"-action-remove",icon:"sap-icon://decline",tooltip:this._oRb.getText("GENERICTILE_REMOVEBUTTON_TEXT")}).addStyleClass("sapUiSizeCompact").addStyleClass(t+"RemoveButton");this._oRemoveButton._bExcludeFromTabChain=true;break;default:}};
j.prototype._isSmall=function(){return this.getSizeBehavior()===g.Small||window.matchMedia("(max-width: 374px)").matches;};
j.prototype.exit=function(){if(this._sParentResizeListenerId){R.deregister(this._sResizeListenerId);this._sParentResizeListenerId=null;}D.media.detachHandler(this._handleMediaChange,this,h);if(this._$RootNode){this._$RootNode.off(this._getAnimationEvents());this._$RootNode=null;}this._clearAnimationUpdateQueue();this._oWarningIcon.destroy();if(this._oImage){this._oImage.destroy();}this._oBusy.destroy();if(this._oMoreIcon){this._oMoreIcon.destroy();}if(this._oRemoveButton){this._oRemoveButton.destroy();}};
j.prototype.onBeforeRendering=function(){var s=!!this.getSubheader();if(this.getMode()===l.GenericTileMode.HeaderMode){this._applyHeaderMode(s);}else{this._applyContentMode(s);}var t=this.getTileContent().length;for(var i=0;i<t;i++){this.getTileContent()[i].setProperty("disabled",this.getState()===l.LoadState.Disabled,true);}this._initScopeContent("sapMGT");this._generateFailedText();this.$().unbind("mouseenter");this.$().unbind("mouseleave");if(this._sParentResizeListenerId){R.deregister(this._sResizeListenerId);this._sParentResizeListenerId=null;}D.media.detachHandler(this._handleMediaChange,this,h);if(this._$RootNode){this._$RootNode.off(this._getAnimationEvents());}if(this.getFrameType()===l.FrameType.Auto){this.setProperty("frameType",l.FrameType.OneByOne,true);}};
j.prototype.onAfterRendering=function(){this._setupResizeClassHandler();this.$().bind("mouseenter",this._updateAriaAndTitle.bind(this));this.$().bind("mouseleave",this._removeTooltipFromControl.bind(this));var m=this.getMode();if(m===l.GenericTileMode.LineMode&&this._isScreenLarge()){this.$().parent().addClass("sapMGTLineModeContainer");this._updateHoverStyle(true);if(this.getParent()instanceof C){this._sParentResizeListenerId=R.register(this.getParent(),this._handleResize.bind(this));}else{this._sParentResizeListenerId=R.register(this.$().parent(),this._handleResize.bind(this));}}if(m===l.GenericTileMode.LineMode&&this._bUpdateLineTileSiblings){this._updateLineTileSiblings();this._bUpdateLineTileSiblings=false;}if(m===l.GenericTileMode.LineMode){D.media.attachHandler(this._handleMediaChange,this,h);}};
j.prototype._handleResize=function(){if(this.getMode()===l.GenericTileMode.LineMode&&this._isScreenLarge()&&this.getParent()){this._queueAnimationEnd();}};
j.prototype._setupResizeClassHandler=function(){var i=function(){if(this.getSizeBehavior()===g.Small||window.matchMedia("(max-width: 374px)").matches){this.$().addClass("sapMTileSmallPhone");}else{this.$().removeClass("sapMTileSmallPhone");}}.bind(this);q(window).resize(i);i();};
j.prototype._isCompact=function(){return q("body").hasClass("sapUiSizeCompact")||this.$().is(".sapUiSizeCompact")||this.$().closest(".sapUiSizeCompact").length>0;};
j.prototype._calculateStyleData=function(){this.$("lineBreak").remove();if(!this._isScreenLarge()||!this.getDomRef()||this.$().is(":hidden")){return null;}var $=this.$(),E=this.$("endMarker"),s=this.$("startMarker");if(E.length===0||s.length===0){return null;}var k=this._getLineCount(),m,n,o=Math.ceil(L._getCSSPixelValue(this,"margin-top")),p,A=this.$().parent().innerWidth(),r=Math.ceil(L._getCSSPixelValue(this,"min-height")),t=L._getCSSPixelValue(this,"line-height"),u=this.$().is(":not(:first-child)")&&k>1,v=q("<span><br /></span>"),i=0,w=sap.ui.getCore().getConfiguration().getRTL(),x=E.position();if(u){v.attr("id",this.getId()+"-lineBreak");$.prepend(v);k=this._getLineCount();x=E.position();}var y={rtl:w,lineBreak:u,startOffset:s.offset(),endOffset:E.offset(),availableWidth:A,lines:[]};var z;if(D.browser.msie||D.browser.edge){z=v.find("br").position();}else{z=v.position();}var J=z;if(!(D.browser.mozilla||D.browser.msie||D.browser.edge)&&z.left<x.left){J=x;}y.positionLeft=u?z.left:$.position().left;y.positionRight=u?$.width()-J.left:y.availableWidth-$.position().left;if(!u&&k>1){y.positionRight=s.parent().innerWidth()-(s.position().left+s.width());}for(i;i<k;i++){if(u&&i===0){continue;}if(k===1){m=w?y.availableWidth-y.positionLeft:y.positionLeft;p=$.width();}else if(i===k-1){m=0;p=w?$.width()-x.left:x.left;}else if(u&&i===1){m=0;p=A;}else{m=0;p=A;}n=i*t+o;y.lines.push({offset:{x:m,y:n},width:p,height:r});}return y;};
j.prototype._getStyleData=function(){var s=this._calculateStyleData();if(!d(this._oStyleData,s)){delete this._oStyleData;this._oStyleData=s;return true;}return false;};
j.prototype._getAnimationEvents=function(){return"transitionend.sapMGT$id animationend.sapMGT$id".replace(/\$id/g,c(this.getId()));};
j.prototype._updateHoverStyle=function(i){if(!this._getStyleData()&&!i){return;}this._clearAnimationUpdateQueue();this._cHoverStyleUpdates=-1;this._oAnimationEndCallIds={};if(this._oStyleData&&this._oStyleData.lineBreak&&this.getUIArea()){this._$RootNode=q(this.getUIArea().getRootNode());this._$RootNode.on(this._getAnimationEvents(),this._queueAnimationEnd.bind(this));}this._queueAnimationEnd();};
j.prototype._queueAnimationEnd=function(E){if(E){var t=q(E.target);if(t.is(".sapMGT, .sapMGT *")){return false;}}if(typeof this._cHoverStyleUpdates!=="number"){this._cHoverStyleUpdates=-1;}if(!this._oAnimationEndCallIds){this._oAnimationEndCallIds={};}this._cHoverStyleUpdates++;this._oAnimationEndCallIds[this._cHoverStyleUpdates]=setTimeout(this._handleAnimationEnd.bind(this,this._cHoverStyleUpdates),10);};
j.prototype._handleAnimationEnd=function(i){delete this._oAnimationEndCallIds[i];if(this._cHoverStyleUpdates===i){this._getStyleData();L._updateHoverStyle.call(this);}};
j.prototype._clearAnimationUpdateQueue=function(){for(var k in this._oAnimationEndCallIds){clearTimeout(this._oAnimationEndCallIds[k]);delete this._oAnimationEndCallIds[k];}};
j.prototype._getLineCount=function(){var o=this.getDomRef().getBoundingClientRect(),i=L._getCSSPixelValue(this,"line-height");return Math.round(o.height/i);};
j.prototype.getBoundingRects=function(){var p=this.$().offset();if(this.getMode()===l.GenericTileMode.LineMode&&this._isScreenLarge()){this._getStyleData();var r=[],s,o;this.$().find(".sapMGTLineStyleHelper").each(function(){s=q(this);o=s.offset();r.push({offset:{x:o.left,y:o.top},width:s.width(),height:s.height()});});return r;}else{return[{offset:{x:p.left,y:p.top},width:this.$().width(),height:this.$().height()}];}};
j.prototype._updateLineTileSiblings=function(){var p=this.getParent();if(this.getMode()===l.GenericTileMode.LineMode&&this._isScreenLarge()&&p){var i=p.indexOfAggregation(this.sParentAggregationName,this);var s=p.getAggregation(this.sParentAggregationName).splice(i+1);for(i=0;i<s.length;i++){var o=s[i];if(o instanceof l.GenericTile&&o.getMode()===l.GenericTileMode.LineMode){o._updateHoverStyle();}}}};
j.prototype.ontouchstart=function(){if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}if(this.getMode()===l.GenericTileMode.LineMode){this.addStyleClass("sapMGTLineModePress");}};
j.prototype.ontouchcancel=function(){if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}};
j.prototype.ontouchend=function(){if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}if(this.getMode()===l.GenericTileMode.LineMode){this.removeStyleClass("sapMGTLineModePress");}};
j.prototype.ontap=function(i){var p;if(this._bTilePress&&this.getState()!==l.LoadState.Disabled){this.$().focus();p=this._getEventParams(i);this.firePress(p);i.preventDefault();}};
j.prototype.onkeydown=function(i){if(P.events.sapselect.fnCheck(i)&&this.getState()!==l.LoadState.Disabled){if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}i.preventDefault();}};
j.prototype._updateAriaLabel=function(){var A=this._getAriaText(),t=this.$(),i=false;if(t.attr("aria-label")!==A){t.attr("aria-label",A);i=true;}return i;};
j.prototype.onkeyup=function(i){var p,k=false,s=this.getScope(),A=s===l.GenericTileScope.Actions;if(A&&(P.events.sapdelete.fnCheck(i)||P.events.sapbackspace.fnCheck(i))){p={scope:s,action:j._Action.Remove,domRef:this._oRemoveButton.getPopupAnchorDomRef()};k=true;}if(P.events.sapselect.fnCheck(i)&&this.getState()!==l.LoadState.Disabled){if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}p=this._getEventParams(i);k=true;}if(k){this.firePress(p);i.preventDefault();}this._updateAriaLabel();};
j.prototype.setProperty=function(p){C.prototype.setProperty.apply(this,arguments);if(this.getMode()===l.GenericTileMode.LineMode&&j.LINEMODE_SIBLING_PROPERTIES.indexOf(p)!==-1){this._bUpdateLineTileSiblings=true;}return this;};
j.prototype.getHeader=function(){return this._oTitle.getText();};
j.prototype.setHeader=function(t){this.setProperty("header",t);this._oTitle.setText(t);return this;};
j.prototype.setHeaderImage=function(u){var v=!d(this.getHeaderImage(),u);if(v){if(this._oImage){this._oImage.destroy();this._oImage=undefined;}if(u){this._oImage=a.createControlByURI({id:this.getId()+"-icon-image",src:u},l.Image);this._oImage.addStyleClass("sapMGTHdrIconImage");}}return this.setProperty("headerImage",u);};
j.prototype._applyHeaderMode=function(s){if(s){this._oTitle.setProperty("maxLines",4,true);}else{this._oTitle.setProperty("maxLines",5,true);}this._changeTileContentContentVisibility(false);};
j.prototype._applyContentMode=function(s){if(s){this._oTitle.setProperty("maxLines",2,true);}else{this._oTitle.setProperty("maxLines",3,true);}this._changeTileContentContentVisibility(true);};
j.prototype._changeTileContentContentVisibility=function(v){var t;t=this.getTileContent();for(var i=0;i<t.length;i++){t[i].setRenderContent(v);}};
j.prototype._getHeaderAriaAndTooltipText=function(){var t="";var i=true;if(this.getHeader()){t+=this.getHeader();i=false;}if(this.getSubheader()){t+=(i?"":"\n")+this.getSubheader();i=false;}if(this.getImageDescription()){t+=(i?"":"\n")+this.getImageDescription();}return t;};
j.prototype._getContentAriaAndTooltipText=function(){var t="";var k=true;var m=this.getTileContent();for(var i=0;i<m.length;i++){if(q.isFunction(m[i]._getAriaAndTooltipText)){t+=(k?"":"\n")+m[i]._getAriaAndTooltipText();}else if(m[i].getTooltip_AsString()){t+=(k?"":"\n")+m[i].getTooltip_AsString();}k=false;}return t;};
j.prototype._getAriaAndTooltipText=function(){var A=(this.getTooltip_AsString()&&!this._isTooltipSuppressed())?this.getTooltip_AsString():(this._getHeaderAriaAndTooltipText()+"\n"+this._getContentAriaAndTooltipText());switch(this.getState()){case l.LoadState.Disabled:return"";case l.LoadState.Loading:return A+"\n"+this._sLoading;case l.LoadState.Failed:return A+"\n"+this._oFailedText.getText();default:if(A.trim().length===0){return"";}else{return A;}}};
j.prototype._getAriaText=function(){var A=this.getTooltip_Text();var s=this.getAriaLabel();if(!A||this._isTooltipSuppressed()){A=this._getAriaAndTooltipText();}if(this.getScope()===l.GenericTileScope.Actions){A=this._oRb.getText("GENERICTILE_ACTIONS_ARIA_TEXT")+" "+A;}if(s){A=s+" "+A;}return A;};
j.prototype._getTooltipText=function(){var t=this.getTooltip_Text();if(this._isTooltipSuppressed()===true){t=null;}return t;};
j.prototype._checkFooter=function(t,i){var s=i.getState();var A=this.getScope()===l.GenericTileScope.Actions||this._bShowActionsView===true;if(s===l.LoadState.Failed||A&&s!==l.LoadState.Disabled){t.setRenderFooter(false);}else{t.setRenderFooter(true);}};
j.prototype._generateFailedText=function(){var s=this.getFailedText();var i=s?s:this._sFailedToLoad;this._oFailedText.setProperty("text",i,true);this._oFailedText.setAggregation("tooltip",i,true);};
j.prototype._isTooltipSuppressed=function(){var t=this.getTooltip_Text();if(t&&t.length>0&&t.trim().length===0){return true;}else{return false;}};
j.prototype._isHeaderTextTruncated=function(){var o,m,$,w;if(this.getMode()===l.GenericTileMode.LineMode){$=this.$("hdr-text");if($.length>0){w=Math.ceil($[0].getBoundingClientRect().width);return($[0]&&w<$[0].scrollWidth);}else{return false;}}else{o=this.getAggregation("_titleText").getDomRef("inner");m=this.getAggregation("_titleText").getClampHeight(o);return(m<o.scrollHeight);}};
j.prototype._isSubheaderTextTruncated=function(){var s;if(this.getMode()===l.GenericTileMode.LineMode){s=this.$("subHdr-text");}else{s=this.$("subTitle");}if(s.length>0){var w=Math.ceil(s[0].getBoundingClientRect().width);return(s[0]&&w<s[0].scrollWidth);}else{return false;}};
j.prototype._setTooltipFromControl=function(){var t="";var i=true;var k=this.getTileContent();if(this._oTitle.getText()){t=this._oTitle.getText();i=false;}if(this.getSubheader()){t+=(i?"":"\n")+this.getSubheader();i=false;}if(this.getScope()!==l.GenericTileScope.Actions&&this.getMode()!==l.GenericTileMode.LineMode){if(k[0]&&k[0].getTooltip_AsString()&&k[0].getTooltip_AsString()!==""){t+=(i?"":"\n")+k[0].getTooltip_AsString();i=false;}if(this.getFrameType()==="TwoByOne"&&k[1]&&k[1].getTooltip_AsString()&&k[1].getTooltip_AsString()!==""){t+=(i?"":"\n")+k[1].getTooltip_AsString();}}if(t&&!this._getTooltipText()&&!this._isTooltipSuppressed()){this.$().attr("title",t.trim());this._bTooltipFromControl=true;}};
j.prototype._updateAriaAndTitle=function(){var A=this._getAriaAndTooltipText();var s=this._getAriaText();var t=this.$();if(t.attr("title")!==A){t.attr("aria-label",s);}if(this.getScope()===l.GenericTileScope.Actions){t.find('*:not(.sapMGTRemoveButton)').removeAttr("aria-label").removeAttr("title").unbind("mouseenter");}else{t.find('*').removeAttr("aria-label").removeAttr("title").unbind("mouseenter");}this._setTooltipFromControl();};
j.prototype._removeTooltipFromControl=function(){if(this._bTooltipFromControl){this.$().removeAttr("title");this._bTooltipFromControl=false;}};
j.prototype._isScreenLarge=function(){return this._getCurrentMediaContainerRange(h).name==="large";};
j.prototype._getEventParams=function(E){var p,A=j._Action.Press,s=this.getScope(),o=this.getDomRef();if(s===l.GenericTileScope.Actions&&E.target.id.indexOf("-action-remove")>-1){A=j._Action.Remove;o=this._oRemoveButton.getPopupAnchorDomRef();}else if(s===l.GenericTileScope.Actions){o=this._oMoreIcon.getDomRef();}p={scope:s,action:A,domRef:o};return p;};
j.prototype._handleMediaChange=function(){this._bUpdateLineTileSiblings=true;this.invalidate();};
j.prototype.setPressEnabled=function(v){this._bTilePress=v;};
j.prototype.showActionsView=function(v){if(this._bShowActionsView!==v){this._bShowActionsView=v;this.invalidate();}};
return j;});
sap.ui.predefine('sap/m/GenericTileLineModeRenderer',["sap/m/library","sap/base/security/encodeCSS","sap/ui/thirdparty/jquery"],function(l,e,q){"use strict";var G=l.GenericTileScope;var L=l.LoadState;var a={};
a.render=function(r,c){var t=c._getTooltipText(),i=c._isScreenLarge(),A=c._getAriaText(),s=e("sapMGTScope"+c.getScope()),h=c.hasListeners("press");this._bRTL=sap.ui.getCore().getConfiguration().getRTL();r.write("<span");r.writeControlData(c);r.writeAttributeEscaped("aria-label",A);if(h){r.writeAttribute("role","button");}else{r.writeAttribute("role","presentation");}r.addClass("sapMGT");r.addClass(s);r.addClass("sapMGTLineMode");this._writeDirection(r);if(t){r.writeAttributeEscaped("title",t);}var S=c.getState();if(S!==L.Disabled){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}else{r.addClass("sapMGTDisabled");}if(S===L.Failed){r.addClass("sapMGTFailed");}r.writeClasses();r.write(">");if(i){r.write("<div");r.writeAttribute("id",c.getId()+"-startMarker");r.addClass("sapMGTStartMarker");r.writeClasses();r.write("></div>");this._renderFailedIcon(r,c);this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("<div");r.writeAttribute("id",c.getId()+"-endMarker");r.addClass("sapMGTEndMarker");r.writeClasses();r.write(">");if(c.getScope()===G.Actions){this._renderActionsScope(r,c);}r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-styleHelper");r.addClass("sapMGTStyleHelper");r.writeClasses();r.write("></div>");}else{if(c.getState()!==L.Disabled){this._renderFocusDiv(r,c);}r.write("<div");r.writeAttribute("id",c.getId()+"-touchArea");r.addClass("sapMGTTouchArea");r.writeClasses();r.write(">");this._renderFailedIcon(r,c);r.write("<span");r.writeAttribute("id",c.getId()+"-lineModeHelpContainer");r.addClass("sapMGTLineModeHelpContainer");r.writeClasses();r.write(">");this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("</span>");if(c.getScope()===G.Actions){this._renderActionsScope(r,c);}r.write("</div>");}r.write("</span>");};
a._writeDirection=function(r){if(this._bRTL){r.writeAttribute("dir","rtl");}};
a._renderFailedIcon=function(r,c){if(c.getState()===L.Failed){if(c._isCompact()){c._oWarningIcon.setSize("1.25rem");}else{c._oWarningIcon.setSize("1.375rem");}r.renderControl(c._oWarningIcon.addStyleClass("sapMGTLineModeFailedIcon"));}};
a._renderHeader=function(r,c){r.write("<span");this._writeDirection(r);r.addClass("sapMGTHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-hdr-text");r.write(">");r.writeEscaped(c._oTitle.getText());r.write("</span>");};
a._renderSubheader=function(r,c){r.write("<span");this._writeDirection(r);r.addClass("sapMGTSubHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-subHdr-text");r.write(">");r.writeEscaped(c._oSubTitle.getText());r.write("</span>");};
a._renderActionsScope=function(r,c){if(c.getState()!==L.Disabled){r.write("<span");r.writeAttribute("id",c.getId()+"-actions");r.addClass("sapMGTActionsContainer");r.writeClasses();r.write(">");r.renderControl(c._oMoreIcon);r.renderControl(c._oRemoveButton);r.write("</span>");}};
a._updateHoverStyle=function(){var s=this.$("styleHelper"),o,i=0,h="";s.empty();if(!this._oStyleData||this.$().is(":hidden")){return;}if(this._oStyleData.rtl){s.css("right",-this._oStyleData.positionRight);}else{s.css("left",-this._oStyleData.positionLeft);}for(i;i<this._oStyleData.lines.length;i++){o=this._oStyleData.lines[i];var r=q("<div class='sapMGTLineStyleHelper'><div class='sapMGTLineStyleHelperInner' /></div>");if(this._oStyleData.rtl){r.css("right",o.offset.x+"px");}else{r.css("left",o.offset.x+"px");}r.css({top:o.offset.y+"px",width:o.width+"px",height:o.height});h+=r.get(0).outerHTML.trim();}s.html(h);};
a._renderFocusDiv=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-focus");r.addClass("sapMGTFocusDiv");r.writeClasses();r.write(">");r.write("</div>");};
a._getCSSPixelValue=function(o,p){var O=o instanceof q?o:o.$(),m=(O.css(p)||"").match(/([^a-zA-Z\%]*)(.*)/),v=parseFloat(m[1]),u=m[2];return(u==="px")?v:v*16;};
return a;},true);
sap.ui.predefine('sap/m/GenericTileRenderer',["sap/m/library","sap/base/security/encodeCSS"],function(l,e){"use strict";var G=l.GenericTileMode;var a=l.GenericTileScope;var L=l.LoadState;var b={};
b.render=function(r,c){var t=c._getTooltipText();var A=c._getAriaText();A="GenericTile"+"\n"+A;var h=c.getHeaderImage();var H=c.hasListeners("press");var s=c.getState();var S=c.getScope();var d=e("sapMGTState"+s);var f=e("sapMGTScope"+S);r.write("<div");r.writeControlData(c);if(t){r.writeAttributeEscaped("title",t);}r.addClass("sapMGT");r.addClass(d);r.addClass(f);if(S!==a.Actions&&c._bShowActionsView){r.addClass("sapMGTScopeActions");}r.addClass(c.getFrameType());if(H){r.writeAttribute("role","button");}else{r.writeAttribute("role","presentation");}r.writeAttributeEscaped("aria-label",A);if(s!==L.Disabled){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}if(c.getWidth()){r.write(" style=\"width: "+c.getWidth()+";");}if(c.getBackgroundImage()){r.write(c.getWidth()?" background-image:url('":" style=\"background-image:url('");r.writeEscaped(c.getBackgroundImage());r.write("');\"");r.addClass("sapMGTBackgroundImage");}else{r.write("\"");}if(c.getMode()===G.HeaderMode){r.addClass("sapMGTHeaderMode");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMGTHdrContent");r.addClass(c.getFrameType());if(t){r.writeAttributeEscaped("title",t);}r.writeClasses();r.write(">");if(h){r.renderControl(c._oImage);}this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("</div>");r.write("<div");r.addClass("sapMGTContent");r.writeClasses();r.writeAttribute("id",c.getId()+"-content");r.write(">");var T=c.getTileContent();var g=T.length;for(var i=0;i<g;i++){c._checkFooter(T[i],c);r.renderControl(T[i]);}r.write("</div>");if(s!==L.Loaded){this._renderStateOverlay(r,c,t);}if(s!==L.Disabled){this._renderHoverOverlay(r,c);this._renderFocusDiv(r,c);}if(S===a.Actions){this._renderActionsScope(r,c);}r.write("</div>");};
b._renderFocusDiv=function(r,c){r.write("<div");r.addClass("sapMGTFocusDiv");r.writeClasses();r.writeAttribute("id",c.getId()+"-focus");r.write(">");r.write("</div>");};
b._renderStateOverlay=function(r,c,t){var s=c.getState();r.write("<div");r.addClass("sapMGTOverlay");r.writeClasses();r.writeAttribute("id",c.getId()+"-overlay");if(t){r.writeAttributeEscaped("title",t);}r.write(">");switch(s){case L.Loading:c._oBusy.setBusy(s==L.Loading);r.renderControl(c._oBusy);break;case L.Failed:r.write("<div");r.writeAttribute("id",c.getId()+"-failed-ftr");r.addClass("sapMGenericTileFtrFld");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-failed-icon");r.addClass("sapMGenericTileFtrFldIcn");r.writeClasses();r.write(">");r.renderControl(c._oWarningIcon);r.write("</div>");if(c.getScope()!==a.Actions&&!c._bShowActionsView){r.write("<div");r.writeAttribute("id",c.getId()+"-failed-text");r.addClass("sapMGenericTileFtrFldTxt");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_failedMessageText"));r.write("</div>");}r.write("</div>");break;default:}r.write("</div>");};
b._renderActionsScope=function(r,c){if(c.getState()!==L.Disabled){r.renderControl(c._oRemoveButton);r.renderControl(c._oMoreIcon);}};
b._renderHoverOverlay=function(r,c){r.write("<div");if(c.getBackgroundImage()){r.addClass("sapMGTWithImageHoverOverlay");}else{r.addClass("sapMGTWithoutImageHoverOverlay");}r.writeClasses();r.writeAttribute("id",c.getId()+"-hover-overlay");r.write(">");r.write("</div>");};
b._renderHeader=function(r,c){r.write("<div");r.addClass("sapMGTHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-hdr-text");r.write(">");r.renderControl(c._oTitle);r.write("</div>");};
b._renderSubheader=function(r,c){r.write("<div");r.addClass("sapMGTSubHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-subHdr-text");r.write(">");r.renderControl(c._oSubTitle);r.write("</div>");};
return b;},true);
sap.ui.predefine('sap/m/GroupHeaderListItem',["sap/ui/core/library","./library","./ListItemBase","./GroupHeaderListItemRenderer"],function(c,l,L,G){"use strict";var a=l.ListMode;var T=c.TextDirection;
var b=L.extend("sap.m.GroupHeaderListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},count:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}}}});
b.prototype.getMode=function(){return a.None;};
b.prototype.shouldClearLastValue=function(){return true;};
b.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
b.prototype.onBeforeRendering=function(){var t=this.getTable();if(t){t.getColumns().forEach(function(C){C.clearLastValue();});this.TagName="tr";}};
b.prototype.getAccessibilityType=function(B){var t=this.getTable()?"ROW":"OPTION";return B.getText("LIST_ITEM_GROUP_HEADER")+" "+B.getText("ACC_CTR_TYPE_"+t);};
b.prototype.getContentAnnouncement=function(){return this.getTitle();};
b.prototype.getGroupAnnouncement=function(){};
return b;});
sap.ui.predefine('sap/m/GroupHeaderListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var G=R.extend(L);
G.renderType=function(r,l){var t=l.getTable();t&&r.write('<td class="sapMListTblNavCol">');L.renderType.apply(this,arguments);t&&r.write('</td>');};
G.renderCounter=function(r,l){};
G.renderLIAttributes=function(r,l){r.addClass("sapMGHLI");if(l.getUpperCase()){r.addClass("sapMGHLIUpperCase");}};
G.renderLIContentWrapper=function(r,l){var t=l.getTable();if(t){r.write('<td class="sapMGHLICell"');r.writeAttribute("colspan",t.getColSpan());r.write(">");}L.renderLIContentWrapper.apply(this,arguments);if(t){r.write("</td>");}};
G.renderLIContent=function(r,l){var t=l.getTitleTextDirection();r.write("<span class='sapMGHLITitle'");if(t!=T.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");r.writeEscaped(l.getTitle());r.write("</span>");var C=l.getCount()||l.getCounter();if(C){r.write("<span class='sapMGHLICounter'>");r.writeEscaped(" ("+C+")");r.write("</span>");}};
G.addLegacyOutlineClass=function(r,l){if(!l.getTable()){L.addLegacyOutlineClass.apply(this,arguments);}};
G.getAriaRole=function(l){if(l.getTable()){return"row";}return L.getAriaRole.apply(this,arguments);};
return G;},true);
sap.ui.predefine('sap/m/GrowingEnablement',['sap/ui/base/Object','sap/ui/core/format/NumberFormat','sap/m/library','sap/ui/model/ChangeReason','sap/ui/base/ManagedObjectMetadata','sap/ui/core/HTML','sap/m/CustomListItem',"sap/base/security/encodeXML"],function(B,N,l,C,M,H,a,e){"use strict";var L=l.ListType;var b=l.ListGrowingDirection;
var G=B.extend("sap.m.GrowingEnablement",{
constructor:function(c){B.apply(this);this._oControl=c;this._oControl.bUseExtendedChangeDetection=true;this._oControl.addDelegate(this);var r=this._oControl.getItems(true).length;this._iRenderedDataItems=r;this._iLimit=r;this._bLoading=false;this._sGroupingPath="";this._bDataRequested=false;this._oContainerDomRef=null;this._iLastItemsCount=0;this._iTriggerTimer=0;this._aChunk=[];this._oRM=null;},
destroy:function(){if(this._oTrigger){this._oTrigger.destroy();this._oTrigger=null;}if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(this._oRM){this._oRM.destroy();this._oRM=null;}this._oControl.$("triggerList").remove();this._oControl.bUseExtendedChangeDetection=false;this._oControl.removeDelegate(this);this._oContainerDomRef=null;this._oControl=null;},
render:function(r){r.openStart("div",this._oControl.getId()+"-triggerList");r.class("sapMListUl").class("sapMGrowingList");r.style("display","none");r.openEnd();r.renderControl(this._getTrigger());r.close("div");},
onAfterRendering:function(){var c=this._oControl;if(c.getGrowingScrollToLoad()){var s=l.getScrollDelegate(c);if(s){this._oScrollDelegate=s;s.setGrowingList(this.onScrollToLoad.bind(this),c.getGrowingDirection());}}else if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(!this._bLoading){this._updateTriggerDelayed(false);}},
setTriggerText:function(t){this._oControl.$("triggerText").text(t);},
reset:function(){this._iLimit=0;var o=this._oControl.getBindingInfo("items");this._oControl.oExtendedChangeDetectionConfig=(!o||!o.template)?null:{replace:true};},
shouldReset:function(c){var m=C;return c==m.Sort||c==m.Filter||c==m.Context;},
getInfo:function(){return{total:this._oControl.getMaxItemsCount(),actual:this._iRenderedDataItems};},
onScrollToLoad:function(){var t=this._oControl.getDomRef("triggerList");if(this._bLoading||!t||t.style.display!="none"){return;}if(this._oControl.getGrowingDirection()==b.Upwards){var s=this._oScrollDelegate;this._oScrollPosition={left:s.getScrollLeft(),top:s.getScrollHeight()};}this.requestNewPage();},
requestNewPage:function(){if(!this._oControl||this._bLoading){return;}var o=this._oControl.getBinding("items");if(o&&!o.isLengthFinal()||this._iLimit<this._oControl.getMaxItemsCount()){if(this._oControl.getMetadata().hasProperty("enableBusyIndicator")){this._bParentEnableBusyIndicator=this._oControl.getEnableBusyIndicator();this._oControl.setEnableBusyIndicator(false);}this._iLimit+=this._oControl.getGrowingThreshold();this._updateTriggerDelayed(true);this.updateItems("Growing");}},
_onBeforePageLoaded:function(c){this._bLoading=true;this._oControl.onBeforePageLoaded(this.getInfo(),c);},
_onAfterPageLoaded:function(c){this._bLoading=false;this._updateTriggerDelayed(false);this._oControl.onAfterPageLoaded(this.getInfo(),c);if(this._oControl.setEnableBusyIndicator){this._oControl.setEnableBusyIndicator(this._bParentEnableBusyIndicator);}},
_getTrigger:function(){var t=this._oControl.getId()+"-trigger",T=this._oControl.getGrowingTriggerText();T=T||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LOAD_MORE_DATA");this._oControl.addNavSection(t);if(this._oTrigger){this.setTriggerText(T);return this._oTrigger;}this._oTrigger=new a({id:t,busyIndicatorDelay:0,type:L.Active,content:new H({content:'<div class="sapMGrowingListTrigger">'+'<div class="sapMSLIDiv sapMGrowingListTriggerText">'+'<span class="sapMSLITitle" id="'+t+'Text">'+e(T)+'</span>'+'</div>'+'<div class="sapMGrowingListDescription sapMSLIDescription" id="'+t+'Info"></div>'+'</div>'})}).setParent(this._oControl,null,true).attachPress(this.requestNewPage,this).addDelegate({onsapenter:function(E){this.requestNewPage();E.preventDefault();},onsapspace:function(E){this.requestNewPage();E.preventDefault();},onAfterRendering:function(E){this._oTrigger.$().attr({"tabindex":0,"role":"button","aria-labelledby":t+"Text"+" "+t+"Info"});}},this);this._oTrigger.getList=function(){};this._oTrigger.TagName="div";return this._oTrigger;},
_getListItemInfo:function(){return("[ "+this._iRenderedDataItems+" / "+N.getFloatInstance().format(this._oControl.getMaxItemsCount())+" ]");},
_getGroupingPath:function(o){var s=o.aSorters||[];var S=s[0]||{};return(S.fnGroup)?S.sPath||"":"";},
_getDomIndex:function(i){if(typeof i!="number"){return i;}if(this._oControl.hasPopin&&this._oControl.hasPopin()){return(i*2);}return i;},
_getHasScrollbars:function(){if(!this._oScrollDelegate){return false;}if(this._iRenderedDataItems>=40){return true;}return this._oScrollDelegate.getMaxScrollTop()>this._oControl.getDomRef("triggerList").clientHeight;},
destroyListItems:function(s){this._oControl.destroyItems(s);this._iRenderedDataItems=0;this._aChunk=[];},
addListItem:function(c,o,s){var d=this._oControl,f=o.binding,i=this.createListItem(c,o);if(f.isGrouped()){var I=d.getItems(true),g=I[I.length-1],m=o.model,h=f.getGroup(i.getBindingContext(m));if(g&&g.isGroupHeader()){d.removeAggregation("items",g,true);this._fnAppendGroupItem=this.appendGroupItem.bind(this,h,g,s);g=I[I.length-1];}if(!g||h.key!==f.getGroup(g.getBindingContext(m)).key){var j=(o.groupHeaderFactory)?o.groupHeaderFactory(h):null;if(d.getGrowingDirection()==b.Upwards){this.applyPendingGroupItem();this._fnAppendGroupItem=this.appendGroupItem.bind(this,h,j,s);}else{this.appendGroupItem(h,j,s);}}}d.addAggregation("items",i,s);if(s){this._aChunk.push(i);}},
applyPendingGroupItem:function(){if(this._fnAppendGroupItem){this._fnAppendGroupItem();this._fnAppendGroupItem=undefined;}},
appendGroupItem:function(g,o,s){o=this._oControl.addItemGroup(g,o,s);if(s){this._aChunk.push(o);}},
createListItem:function(c,o){this._iRenderedDataItems++;var i=o.factory(M.uid("clone"),c);return i.setBindingContext(c,o.model);},
updateItemsBindingContext:function(d,m){if(!d.length){return;}var I=this._oControl.getItems(true);for(var i=0,c=0,o;i<I.length;i++){o=I[i];if(!o.isGroupHeader()){o.setBindingContext(d[c++],m);}}},
applyChunk:function(I,d){this.applyPendingGroupItem();var c=this._aChunk.length;if(!c){return;}if(this._oControl.getGrowingDirection()==b.Upwards){this._aChunk.reverse();if(I===true){I=0;}else if(typeof I=="number"){I=this._iRenderedDataItems-c-I;}}d=d||this._oContainerDomRef;this._oRM=this._oRM||sap.ui.getCore().createRenderManager();for(var i=0;i<c;i++){this._oRM.renderControl(this._aChunk[i]);}this._oRM.flush(d,false,this._getDomIndex(I));this._aChunk=[];},
addListItems:function(c,o,s){for(var i=0;i<c.length;i++){this.addListItem(c[i],o,s);}},
rebuildListItems:function(c,o,s){this.destroyListItems(s);this.addListItems(c,o,s);if(s){var h=this._oContainerDomRef.contains(document.activeElement);this.applyChunk(false);h&&this._oControl.focus();}else{this.applyPendingGroupItem();}},
insertListItem:function(c,o,i){var I=this.createListItem(c,o);this._oControl.insertAggregation("items",I,i,true);this._aChunk.push(I);},
deleteListItem:function(i){this._oControl.getItems(true)[i].destroy(true);this._iRenderedDataItems--;},
refreshItems:function(c){if(!this._bDataRequested){this._bDataRequested=true;this._onBeforePageLoaded(c);}if(!this._iLimit||this.shouldReset(c)||!this._oControl.getItems(true).length){this._iLimit=this._oControl.getGrowingThreshold();}this._oControl.getBinding("items").getContexts(0,this._iLimit);},
updateItems:function(c){var o=this._oControl,d=o.getBinding("items"),f=o.getBindingInfo("items"),I=o.getItems(true);if(!this._iLimit||this.shouldReset(c)||!I.length){this._iLimit=o.getGrowingThreshold();}if(this._bDataRequested){this._bDataRequested=false;}else{this._onBeforePageLoaded(c);}var g=d.getContexts(0,this._iLimit)||[];if(g.dataRequested){this._bDataRequested=true;if(g.diff&&!g.diff.length){return;}}this._oContainerDomRef=o.getItemsContainerDomRef();var D=g.diff,F=false,v;if(!g.length){this.destroyListItems();}else if(!this._oContainerDomRef){this.rebuildListItems(g,f);}else if(!D||!I.length&&D.length){this.rebuildListItems(g,f,true);}else if(d.isGrouped()||o.checkGrowingFromScratch()){if(this._sGroupingPath!=this._getGroupingPath(d)){F=true;}else{for(var i=0;i<D.length;i++){var h=D[i],j=g[h.index];if(h.type=="delete"||h.type=="replace"){F=true;break;}else if(h.index!=this._iRenderedDataItems){F=true;break;}else{this.addListItem(j,f,true);v=true;}}}}else{if(this._sGroupingPath){o.removeGroupHeaders(true);}v=-1;var k=-1;for(var i=0;i<D.length;i++){var h=D[i],m=h.index,j=g[m];if(h.type=="delete"){if(v!=-1){this.applyChunk(v);k=-1;v=-1;}this.deleteListItem(m);}else if(h.type=="insert"){if(v==-1){v=m;}else if(k>-1&&m!=k+1){this.applyChunk(v);v=m;}this.insertListItem(j,f,m);k=m;}}}if(F){this.rebuildListItems(g,f,true);}else if(this._oContainerDomRef&&D){this.updateItemsBindingContext(g,f.model);this.applyChunk(v);}this._oContainerDomRef=null;this._sGroupingPath=this._getGroupingPath(d);if(!this._bDataRequested){this._onAfterPageLoaded(c);}},
_updateTriggerDelayed:function(c){if(this._oControl.getGrowingScrollToLoad()){this._iTriggerTimer&&window.cancelAnimationFrame(this._iTriggerTimer);this._iTriggerTimer=window.requestAnimationFrame(this._updateTrigger.bind(this,c));}else{this._updateTrigger(c);}},
_updateTrigger:function(c){var t=this._oTrigger,o=this._oControl;if(!t||!o||!o.shouldRenderItems()||!o.getDomRef()){return;}var d=o.getBinding("items");if(!d){return;}t.setBusy(c);t.$().toggleClass("sapMGrowingListBusyIndicatorVisible",c);if(c){t.setActive(false);o.$("triggerList").css("display","");}else{var i=o.getItems(true),I=i.length,f=d.getLength()||0,g=d.isLengthFinal(),h=o.getGrowingScrollToLoad(),T=t.getDomRef();if(T&&T.contains(document.activeElement)){(i[this._iLastItemsCount]||o).focus();}if(!I||!this._iLimit||(g&&this._iLimit>=f)||(h&&this._getHasScrollbars())){o.$("triggerList").css("display","none");}else{if(g){o.$("triggerInfo").css("display","block").text(this._getListItemInfo());}t.$().removeClass("sapMGrowingListBusyIndicatorVisible");o.$("triggerList").css("display","");}this._iLastItemsCount=this._oControl.getItems(true).length;if(h&&this._oScrollPosition===undefined&&o.getGrowingDirection()==b.Upwards){this._oScrollPosition={left:0,top:0};}if(I>0&&this._oScrollPosition){var s=this._oScrollDelegate,S=this._oScrollPosition;s.scrollTo(S.left,s.getScrollHeight()-S.top);this._oScrollPosition=null;}}}
});
return G;});
sap.ui.predefine('sap/m/GrowingList',['./List','./library','./GrowingListRenderer'],function(L,l,G){"use strict";
var a=L.extend("sap.m.GrowingList",{metadata:{deprecated:true,library:"sap.m",properties:{threshold:{type:"int",group:"Misc",defaultValue:20},triggerText:{type:"string",group:"Appearance",defaultValue:null},scrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false}}}});
a.prototype._isIncompatible=function(){return sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMGrowingList").compareTo("1.16")>=0;};
a.prototype.init=function(){L.prototype.init.call(this);if(!this._isIncompatible()){this.setGrowing();}};
a.prototype.setGrowing=function(){return L.prototype.setGrowing.call(this,true);};
!(function(g,o){["Threshold","TriggerText","ScrollToLoad"].forEach(function(p){g["set"+p]=o["setGrowing"+p];g["get"+p]=o["getGrowing"+p];});}(a.prototype,L.prototype));return a;});
sap.ui.predefine('sap/m/GrowingListRenderer',['./ListRenderer','sap/ui/core/Renderer',"sap/base/Log"],function(L,R,a){"use strict";var G=R.extend(L);G.apiVersion=2;
G.render=function(r,c){if(c._isIncompatible()){a.warning("Does not render sap.m.GrowingList#"+c.getId()+" when compatibility version is 1.16 or higher. Instead use sap.m.List/Table control with growing feature!");}else{L.render.call(this,r,c);}};
return G;},true);
sap.ui.predefine('sap/m/HBox',['./FlexBox','./library','./HBoxRenderer'],function(F,l,H){"use strict";
var a=F.extend("sap.m.HBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/HBox.designtime"}});
return a;});
sap.ui.predefine('sap/m/HBoxRenderer',['./FlexBoxRenderer'],function(F){"use strict";var H={apiVersion:2};
H.render=function(r,c){F.render.apply(this,[r,c]);};
return H;},true);
sap.ui.predefine('sap/m/HeaderContainer',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/Device','sap/m/HeaderContainerItemNavigator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/library','sap/ui/core/IntervalTrigger','sap/ui/base/ManagedObject','sap/ui/core/Icon','./HeaderContainerRenderer',"sap/base/Log","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/scrollRightRTL","sap/ui/dom/jquery/Selectors"],function(l,C,a,D,H,I,c,b,M,d,e,L,P,q){"use strict";var O=c.Orientation;
var f=a.extend("sap.m.HeaderContainerItemContainer",{
metadata:{defaultAggregation:"item",properties:{position:{type:"int",defaultValue:null},setSize:{type:"int",defaultValue:null},ariaLabelledBy:{type:"string",defaultValue:null}},aggregations:{item:{type:"sap.ui.core.Control",multiple:false}}},
renderer:function(r,o){var i=o.getAggregation("item");if(!i||!i.getVisible()){return;}r.write("<div");r.writeControlData(o);r.addClass("sapMHdrCntrItemCntr");r.addClass("sapMHrdrCntrInner");r.writeAttribute("aria-setsize",o.getSetSize());r.writeAttribute("aria-posinset",o.getPosition());r.writeAttribute("role","listitem");if(o.getAriaLabelledBy()){r.writeAttributeEscaped("aria-labelledby",o.getAriaLabelledBy());}r.writeClasses();r.write(">");r.renderControl(i);r.write("</div>");}
});
var g=a.extend("sap.m.HeaderContainer",{metadata:{interfaces:["sap.m.ObjectHeaderContainer"],library:"sap.m",properties:{scrollStep:{type:"int",defaultValue:300,group:"Behavior"},scrollStepByItem:{type:"int",defaultValue:1,group:"Behavior"},scrollTime:{type:"int",defaultValue:500,group:"Behavior"},showOverflowItem:{type:"boolean",defaultValue:true,group:"Behavior"},showDividers:{type:"boolean",defaultValue:true,group:"Appearance"},orientation:{type:"sap.ui.core.Orientation",defaultValue:O.Horizontal,group:"Appearance"},backgroundDesign:{type:"sap.m.BackgroundDesign",defaultValue:l.BackgroundDesign.Transparent,group:"Appearance"},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true},_scrollContainer:{type:"sap.m.ScrollContainer",multiple:false,visibility:"hidden"},_prevButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
g.prototype.init=function(){this._aItemEnd=[];this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oScrollCntr=new l.ScrollContainer(this.getId()+"-scrl-cntnr",{width:"100%",height:"100%",horizontal:!D.system.desktop});this.setAggregation("_scrollContainer",this._oScrollCntr,true);if(D.system.desktop){this._oArrowPrev=new l.Button({id:this.getId()+"-scrl-prev-button",type:l.ButtonType.Transparent,tooltip:this._oRb.getText("HEADERCONTAINER_BUTTON_PREV_SECTION"),press:function(E){E.cancelBubble();this._scroll(this._getScrollValue(false),this.getScrollTime());}.bind(this)}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrLeft");this._oArrowPrev._bExcludeFromTabChain=true;this.setAggregation("_prevButton",this._oArrowPrev,true);this._oArrowNext=new l.Button({id:this.getId()+"-scrl-next-button",type:l.ButtonType.Transparent,tooltip:this._oRb.getText("HEADERCONTAINER_BUTTON_NEXT_SECTION"),press:function(E){E.cancelBubble();this._scroll(this._getScrollValue(true),this.getScrollTime());}.bind(this)}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrRight");this._oArrowNext._bExcludeFromTabChain=true;this.setAggregation("_nextButton",this._oArrowNext,true);}else if(D.system.phone||D.system.tablet){this._oArrowPrev=new d({id:this.getId()+"-scrl-prev-button"}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrLeft");this.setAggregation("_prevButton",this._oArrowPrev,true);this._oArrowNext=new d({id:this.getId()+"-scrl-next-button"}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrRight");this.setAggregation("_nextButton",this._oArrowNext,true);}this._oScrollCntr.addDelegate({onAfterRendering:function(){if(D.system.desktop){var F=this._oScrollCntr.getDomRef("scroll");var o=this._oScrollCntr.$("scroll");var h=o.find(".sapMHrdrCntrInner").attr("tabindex","0");if(!this._oItemNavigation){this._oItemNavigation=new H();this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._handleBorderReached,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleBorderReached,this);this._oItemNavigation.attachEvent(I.Events.BeforeFocus,this._handleBeforeFocus,this);if(D.browser.msie||D.browser.edge){this._oItemNavigation.attachEvent(I.Events.FocusAgain,this._handleFocusAgain,this);}}this._oItemNavigation.setRootDomRef(F);this._oItemNavigation.setItemDomRefs(h);this._oItemNavigation.setTabIndex0();this._oItemNavigation.setCycling(false);this._handleMobileScrolling();}}.bind(this)});b.addListener(this._checkOverflow,this);};
g.prototype.onBeforeRendering=function(){if(!this.getHeight()){L.warning("No height provided",this);}if(!this.getWidth()){L.warning("No width provided",this);}if(D.system.desktop){this._oArrowPrev.setIcon(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-left":"sap-icon://slim-arrow-up");this._oArrowNext.setIcon(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-right":"sap-icon://slim-arrow-down");}else if(D.system.phone||D.system.tablet){this._oArrowPrev.setSrc(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-left":"sap-icon://slim-arrow-up");this._oArrowNext.setSrc(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-right":"sap-icon://slim-arrow-down");}};
g.prototype.onAfterRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._checkOverflow();};
g.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}b.removeListener(this._checkOverflow,this);};
g.prototype.onsaptabnext=function(E){var F=this.$().find(":focusable");var t=F.index(E.target);var n=F.eq(t+1).get(0);var o=this._getParentCell(E.target);var T;if(n){T=this._getParentCell(n);}if((o&&T&&o.id!==T.id)||(n&&n.id===this.getId()+"-after")||(n&&n.id===this.getId()+"-scrl-prev-button")||(n&&n.id===this.getId()+"-scrl-next-button")){var h=F.last().get(0);if(h){this._bIgnoreFocusIn=true;h.focus();}}};
g.prototype.onsaptabprevious=function(E){this.$().find(".sapMHdrCntrItemCntr").css("border-color","");var F=this.$().find(":focusable");var t=F.index(E.target);var p=F.eq(t-1).get(0);var o=this._getParentCell(E.target);var T;if(p){T=this._getParentCell(p);}if(!T||o&&o.id!==T.id){var s=this.$().attr("tabindex");this.$().attr("tabindex","0");this.$().focus();if(!s){this.$().removeAttr("tabindex");}else{this.$().attr("tabindex",s);}}};
g.prototype.setOrientation=function(v){this.setProperty("orientation",v);if(v===O.Horizontal&&!D.system.desktop){this._oScrollCntr.setHorizontal(true);this._oScrollCntr.setVertical(false);}else if(!D.system.desktop){this._oScrollCntr.setHorizontal(false);this._oScrollCntr.setVertical(true);}return this;};
g.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
g.prototype.getAggregation=function(A,o,s){return this._callMethodInManagedObject("getAggregation",A,o,s);};
g.prototype.setAggregation=function(A,o,s){return this._callMethodInManagedObject("setAggregation",A,o,s);};
g.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
g.prototype.insertAggregation=function(A,o,i,s){return this._callMethodInManagedObject("insertAggregation",A,o,i,s);};
g.prototype.addAggregation=function(A,o,s){return this._callMethodInManagedObject("addAggregation",A,o,s);};
g.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
g.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
g.prototype.destroyAggregation=function(A,s){return this._callMethodInManagedObject("destroyAggregation",A,s);};
g.prototype._setScrollInProcess=function(v){this.bScrollInProcess=v;};
g.prototype._scroll=function(i,h){this._setScrollInProcess(true);setTimeout(this._setScrollInProcess.bind(this,false),h+300);if(this.getOrientation()===O.Horizontal){this._hScroll(i,h);}else{this._vScroll(i,h);}};
g.prototype._vScroll=function(h,i){var o=this._oScrollCntr.getDomRef(),s=o.scrollTop,S=o.scrollHeight,j=s+h,k=o.clientHeight,p=parseFloat(this.$("scroll-area").css("padding-top")),r;if(j<=0){r=this._calculateRemainingScrolling(h,i,s);this.$("scroll-area").css("transition","padding "+r+"s");this.$().removeClass("sapMHrdrTopPadding");}else if(j+k+p>=S){r=this._calculateRemainingScrolling(h,i,S-k-s);this.$("scroll-area").css("transition","padding "+r+"s");if(k+h>S&&k!==S){this.$().removeClass("sapMHrdrBottomPadding");this.$().addClass("sapMHrdrTopPadding");}else{this.$().removeClass("sapMHrdrBottomPadding");}}else{this.$("scroll-area").css("transition","padding "+i/1000+"s");}this._oScrollCntr.scrollTo(0,j,i);};
g.prototype._hScroll=function(h,i){var o=this._oScrollCntr.getDomRef();var s,S,j,k,p,r;if(!this._bRtl){S=o.scrollLeft;k=o.scrollWidth;j=o.clientWidth+(D.browser.msie?1:0);s=S+h;p=parseFloat(this.$("scroll-area").css("padding-left"));if(s<=0){r=this._calculateRemainingScrolling(h,i,S);this.$("scroll-area").css("transition","padding "+r+"s");this.$().removeClass("sapMHrdrLeftPadding");}else if(s+o.clientWidth+p>=k){r=this._calculateRemainingScrolling(h,i,k-j-S);this.$("scroll-area").css("transition","padding "+r+"s");if(j+h>k&&j!==k){this.$().removeClass("sapMHrdrRightPadding");this.$().addClass("sapMHrdrLeftPadding");}else{this.$().removeClass("sapMHrdrRightPadding");}}else{this.$("scroll-area").css("transition","padding "+i/1000+"s");}this._oScrollCntr.scrollTo(s,0,i);}else{s=q(o).scrollRightRTL()+h;this._oScrollCntr.scrollTo((s>0)?s:0,0,i);}};
g.prototype._collectItemSize=function(){var s=0,h=this._filterVisibleItems(),F=this.getOrientation()===O.Horizontal?"outerWidth":"outerHeight";this._aItemEnd=[];h.forEach(function(o,i){s+=o.$().parent()[F](true);this._aItemEnd[i]=s;},this);};
g.prototype._getScrollValue=function(F){if(!this._oScrollCntr){return 0;}var h=this.getOrientation()===O.Horizontal,$=this._oScrollCntr.$(),j=this.$("prev-button-container"),m=this.$("next-button-container"),s=h?$[0].scrollLeft:$[0].scrollTop,t=0,S=0,n,o=this._filterVisibleItems();var G=function(k){var S=0,B=0;var r=10;if(this._bRtl&&h){if(!j.is(":visible")){B=j.width();}if(!m.is(":visible")){B=m.width();}}for(var i=0;i<o.length&&i<k;i++){S+=p(o[i]);}return S!==0?S+r-B:0;}.bind(this);var p=function(k){return h?k.$().parent().outerWidth(true):k.$().parent().outerHeight(true);};var E=function(){var S=this._getSize(true),r,A=0;for(var i=t;i<o.length;i++){if(!o[i].$().is(":visible")){r=p(o[i])+G(i)-S-s;for(var k=t;k<o.length&&k<i;k++){if(n+A>r){break;}t++;A+=p(o[k]);}n+=A;break;}}}.bind(this);if(this.getScrollStepByItem()>0){s=h&&this._bRtl?$.scrollRightRTL():s;for(var i=0;i<o.length;i++){S+=p(o[i]);if(S>=s){t=i;break;}}t=(F?1:-1)*this.getScrollStepByItem()+t;if(t<0){t=0;}if(t>=o.length){t=o.length-1;}n=G(t)-s;if(F&&!this.getShowOverflowItem()){E();}return n;}return F?this.getScrollStep():-this.getScrollStep();};
g.prototype._calculateRemainingScrolling=function(h,i,j){return Math.abs(j*i/(1000*h));};
g.prototype._checkOverflow=function(){if(this.getOrientation()===O.Horizontal){this._checkHOverflow();}else{this._checkVOverflow();}};
g.prototype._filterVisibleItems=function(){return this.getContent().filter(function(i){return i.getVisible();});};
g.prototype._getFirstItemOffset=function(t){var F=this._filterVisibleItems()[0],$=F&&F.$(),h=$&&$.parent(),i=h&&h[0]&&h[0][t];return i||0;};
g.prototype._checkVOverflow=function(){var B=this._oScrollCntr.getDomRef(),o,$;if(B){var F=this._getFirstItemOffset("offsetTop");var s=Math.ceil(B.scrollTop);var S=false;var h=false;var r=B.scrollHeight;var i=B.clientHeight;if(Math.abs(r-i)===1){r=i;}if(s>F){S=true;}if((r>i)&&(s+i<r)){h=true;}h=this._checkForOverflowItem(h);$=this.$("prev-button-container");o=$.is(":visible");if(o&&!S){$.hide();this.$().removeClass("sapMHrdrTopPadding");}if(!o&&S){$.show();this.$().addClass("sapMHrdrTopPadding");}$=this.$("next-button-container");var j=$.is(":visible");if(j&&!h){$.hide();this.$().removeClass("sapMHrdrBottomPadding");}if(!j&&h){$.show();this.$().addClass("sapMHrdrBottomPadding");}}};
g.prototype._handleMobileScrolling=function(){if(C.isMobile()){var $=this.$("scrl-cntnr-scroll"),i=this.getOrientation()===O.Horizontal,p=i?"clientX":"clientY",h=0,t=this,s=false;$.on("touchstart",function(E){s=true;h=E.targetTouches[0][p];});$.on("touchmove",function(E){if(s){var j=E.targetTouches[0][p],k=h-j,S=t._oScrollCntr.getDomRef();i?S.scrollLeft+=k:S.scrollTop+=k;h=j;E.preventDefault();}});$.on("touchend",function(){s=false;});}};
g.prototype._checkHOverflow=function(){var B=this._oScrollCntr.getDomRef(),$;if(B){var F=this._getFirstItemOffset("offsetLeft");var s=Math.ceil(B.scrollLeft);var S=false;var h=false;var r=B.scrollWidth;var i=B.clientWidth;if(Math.abs(r-i)===1){r=i;}if(this._bRtl){var j=q(B).scrollLeftRTL();if(j>((D.browser.msie||D.browser.edge)?1:0)){h=true;}}else if(s>F){S=true;}if(r-5>i){if(this._bRtl){if(q(B).scrollRightRTL()>1){S=true;}}else if(s+i<r){h=true;}}$=this.$("prev-button-container");h=this._checkForOverflowItem(h);var o=$.is(":visible");if(o&&!S){$.hide();this.$().removeClass("sapMHrdrLeftPadding");}if(!o&&S){$.show();this.$().addClass("sapMHrdrLeftPadding");}$=this.$("next-button-container");var k=$.is(":visible");if(k&&!h){$.hide();this.$().removeClass("sapMHrdrRightPadding");}if(!k&&h){$.show();this.$().addClass("sapMHrdrRightPadding");}}};
g.prototype._getSize=function(A){var $=this._oScrollCntr.$(),h=this.getOrientation()===O.Horizontal,i=this.$("next-button-container"),j=!i.is(":visible")&&A,F=h?"width":"height";return $[F]()-(j?i[F]():0);};
g.prototype._checkForOverflowItem=function(s){if(this._oScrollCntr&&!this.getShowOverflowItem()){var $=this._oScrollCntr.$(),h=this.getOrientation()===O.Horizontal,S=!h?$[0].scrollTop:(this._bRtl?$.scrollRightRTL():$[0].scrollLeft),F=h?"width":"height",j=this._getSize(s),k=this._filterVisibleItems();this._collectItemSize();this._aItemEnd.forEach(function(E,i){var m=k[i].$(),n=m.parent(),v=m.is(":visible");if(s&&E>S+j){if(i===0||this._aItemEnd[i-1]<=S){n.css(F,"auto");m.show();}else if(v){n[F](n[F]());m.hide();s=true;}}else{if(!v){n.css(F,"auto");m.show();}}},this);}return s;};
g.prototype._handleBorderReached=function(E){if(D.browser.msie&&this.bScrollInProcess){return;}var i=E.getParameter("index");if(i===0){this._scroll(this._getScrollValue(false),this.getScrollTime());}else if(i===this._filterVisibleItems().length-1){this._scroll(this._getScrollValue(true),this.getScrollTime());}};
g.prototype._handleFocusAgain=function(E){E.getParameter("event").preventDefault();};
g.prototype._handleBeforeFocus=function(E){var o=E.getParameter("event");if(q(o.target).hasClass("sapMHdrCntrItemCntr")||q(o.target).hasClass("sapMScrollContScroll")||P.events.sapprevious.fnCheck(o)||P.events.sapnext.fnCheck(o)){this.$().find(".sapMHdrCntrItemCntr").css("border-color","");}else{this.$().find(".sapMHdrCntrItemCntr").css("border-color","transparent");}};
g.prototype._unWrapHeaderContainerItemContainer=function(w){if(w instanceof f){w=w.getItem();}else if(Array.isArray(w)){for(var i=0;i<w.length;i++){if(w[i]instanceof f){w[i]=w[i].getItem();}}}return w;};
g._AGGREGATION_FUNCTIONS=["validateAggregation","validateAggregation","getAggregation","setAggregation","indexOfAggregation","removeAggregation"];g._AGGREGATION_FUNCTIONS_FOR_INSERT=["insertAggregation","addAggregation"];
g.prototype._callMethodInManagedObject=function(F,A){var h=Array.prototype.slice.call(arguments);if(A==="content"){var o=h[2];h[1]="content";if(o instanceof a){if(((g._AGGREGATION_FUNCTIONS?Array.prototype.indexOf.call(g._AGGREGATION_FUNCTIONS,F):-1))>-1&&o.getParent()instanceof f){h[2]=o.getParent();}else if(((g._AGGREGATION_FUNCTIONS_FOR_INSERT?Array.prototype.indexOf.call(g._AGGREGATION_FUNCTIONS_FOR_INSERT,F):-1))>-1){h[2]=new f({item:o});}}var r=this._oScrollCntr[F].apply(this._oScrollCntr,h.slice(1));if(F!=="removeAllAggregation"){var j=this._oScrollCntr.getContent();var k=this.getAriaLabelledBy();for(var i=0;i<j.length;i++){var m=j[i];m.setPosition(i+1);m.setSetSize(j.length);m.setAriaLabelledBy(k[i]);}}return this._unWrapHeaderContainerItemContainer(r);}else{return M.prototype[F].apply(this,h.slice(1));}};
g.prototype._getParentCell=function(o){return q(o).parents(".sapMHrdrCntrInner").andSelf(".sapMHrdrCntrInner").get(0);};
g.prototype.onfocusin=function(E){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;return;}if(E.target.id===this.getId()+"-after"){this._restoreLastFocused();}};
g.prototype._restoreLastFocused=function(){if(!this._oItemNavigation){return;}var n=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(n[i]);var r=$.control(0)||{};var t=r.getTabbables?r.getTabbables():$.find(":sapTabbable");t.eq(-1).add($).eq(-1).focus();};
return g;});
sap.ui.predefine('sap/m/HeaderContainerItemNavigator',["sap/ui/core/delegate/ItemNavigation","sap/base/assert","sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes"],function(I,a,c,K){"use strict";
var H=I.extend("sap.m.HeaderContainerItemNavigator");
H.prototype._callParent=function(f,A){if(typeof I.prototype[f]==="function"){I.prototype[f].apply(this,A);}};
H.prototype.onsaphome=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsaphome",arguments);};
H.prototype.onsapend=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsapend",arguments);};
H.prototype.onsapnext=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsapnext",arguments);};
H.prototype.onsapprevious=function(e){if(this._skipNavigation(e,true,false)){return;}this._callParent("onsapprevious",arguments);};
H.prototype._skipNavigation=function(e){return Array.prototype.indexOf.call(this.aItemDomRefs,e.target)===-1;};
return H;});
sap.ui.predefine('sap/m/HeaderContainerRenderer',['sap/ui/core/library',"sap/base/security/encodeCSS"],function(c,e){"use strict";var O=c.Orientation;var H={};
H.render=function(r,C){var t=C.getTooltip_AsString();var o=C.getOrientation();if(o){o=e(o);}var b=e("sapMHdrCntrBG"+C.getBackgroundDesign());r.write("<div");r.writeControlData(C);if(t&&(typeof t==="string")){r.writeAttributeEscaped("title",t);}r.addClass("sapMHdrCntr");r.addClass(o);if(C.getShowDividers()){r.addClass("sapMHrdrCntrDvdrs");}r.writeClasses();if(C.getHeight()){r.addStyle("height",C.getHeight());}else{r.addStyle("height",(C.getOrientation()===O.Horizontal)?"auto":"100%");}if(C.getWidth()){r.addStyle("width",C.getWidth());}else{r.addStyle("width",(C.getOrientation()===O.Horizontal)?"100%":"auto");}r.writeStyles();var d="";var a=C.getContent();for(var i=0;a&&i<a.length;i++){d+=a[i].getId()+" ";}r.writeAttribute("aria-labelledby",d);r.write(">");r.write("<div");r.writeAttributeEscaped("id",C.getId()+"-scroll-area");r.addClass("sapMHdrCntrCntr");r.addClass(o);r.addClass(b);r.writeClasses();r.write(">");r.renderControl(C.getAggregation("_scrollContainer"));r.write("</div>");var B=C.getAggregation("_prevButton");if(B){r.write("<div");r.writeAttributeEscaped("id",C.getId()+"-prev-button-container");r.addClass("sapMHdrCntrBtnCntr");r.addClass("sapMHdrCntrLeft");r.addClass(o);r.writeClasses();r.write(">");r.renderControl(B);r.write("</div>");}B=C.getAggregation("_nextButton");if(B){r.write("<div");r.writeAttributeEscaped("id",C.getId()+"-next-button-container");r.addClass("sapMHdrCntrBtnCntr");r.addClass("sapMHdrCntrRight");r.addClass(o);r.writeClasses();r.write(">");r.renderControl(B);r.write("</div>");}r.write("<div");r.writeAttribute("id",C.getId()+"-after");r.writeAttribute("tabindex","0");r.write("></div>");r.write("</div>");};
return H;},true);
sap.ui.predefine('sap/m/HyphenationSupport',["sap/ui/core/Core","./library","sap/ui/core/hyphenation/Hyphenation","sap/base/Log"],function(C,l,H,L){"use strict";var W=l.WrappingType;
function i(o){if(!o.isA("sap.m.IHyphenation")){L.error("[UI5 Hyphenation] The given control does not implement interface sap.m.IHyphenation and can not use HyphenationSupport mixin.");return false;}return true;}
function a(o,k){var t=o.getTextsToBeHyphenated();if(typeof t!=="object"){L.error("[UI5 Hyphenation] The result of getTextsToBeHyphenated method is not a map object.",o.getId());return false;}if(Object.keys(t).indexOf(k)<0){L.error("[UI5 Hyphenation] The key "+k+" is not found in the result of getTextsToBeHyphenated method.",o.getId());return false;}return true;}
function s(D,n){n=n||"";var f=D.childNodes;if(f.length===1&&f[0].nodeType===window.Node.TEXT_NODE){f[0].nodeValue=n;}else{D.textContent=n;}}
function d(t,T){var D=[];Object.keys(t).forEach(function(k){if(!(k in T&&t[k]===T[k])){D.push(k);}});return D;}
function b(){var f=C.getConfiguration().getHyphenation(),o=H.getInstance();if(f==="native"||f==="disable"){return false;}if(f==="thirdparty"){return true;}return o.isLanguageSupported()&&!o.canUseNativeHyphenation()&&o.canUseThirdPartyHyphenation();}
function c(o){var f=C.getConfiguration().getHyphenation();if(f==='disable'){return false;}if(o.getWrappingType()===W.Hyphenated&&!o.getWrapping()){L.warning("[UI5 Hyphenation] The property wrappingType=Hyphenated will not take effect unless wrapping=true.",o.getId());}return o.getWrapping()&&o.getWrappingType()===W.Hyphenated;}
function h(o){if(!c(o)||!b()){o._mHyphenatedTexts={};o._mUnhyphenatedTexts={};return;}var t=o.getTextsToBeHyphenated(),f=d(t,o._mUnhyphenatedTexts);if(f.length>0){o._mUnhyphenatedTexts=t;f.forEach(function(k){delete o._mHyphenatedTexts[k];});var g=H.getInstance();if(!g.isLanguageInitialized()){g.initialize().then(function(){var D=o.isActive()?o.getDomRefsForHyphenatedTexts():null,n=false;f.forEach(function(k){o._mHyphenatedTexts[k]=g.hyphenate(t[k]);if(D&&k in D){s(D[k],o._mHyphenatedTexts[k]);}else{n=true;}});if(n){o.invalidate();}});}else{f.forEach(function(k){o._mHyphenatedTexts[k]=g.hyphenate(t[k]);});}}}
var e={};
e.mixInto=function(o){if(!i(o)){return;}var I=o.init;o.init=function(f){var r=I.apply(this,arguments);this._mHyphenatedTexts={};this._mUnhyphenatedTexts={};return r;};var O=o.onBeforeRendering;o.onBeforeRendering=function(){var r=O.apply(this,arguments);h(this);return r;};};
e.writeHyphenationClass=function(r,o){if(!i(o)){return;}if(c(o)&&!b()){r.class("sapUiHyphenation");}};
e.getTextForRender=function(o,k){if(!i(o)){return null;}if(!a(o,k)){return null;}var t=o.getTextsToBeHyphenated();if(c(o)&&b()){if(t[k]!==o._mUnhyphenatedTexts[k]){h(o);}if(k in o._mHyphenatedTexts){return o._mHyphenatedTexts[k];}}return t[k];};
return e;});
sap.ui.predefine('sap/m/IconTabBar',['./library','sap/ui/core/Control','sap/ui/base/ManagedObject','./IconTabBarRenderer','./IconTabHeader',"sap/ui/thirdparty/jquery"],function(l,C,M,I,a,q){"use strict";var b=l.IconTabHeaderMode;var B=l.BackgroundDesign;var c=l.IconTabDensityMode;
var d=C.extend("sap.m.IconTabBar",{metadata:{interfaces:["sap.m.ObjectHeaderContainer","sap.f.IDynamicPageStickyContent"],library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},expandable:{type:"boolean",group:"Misc",defaultValue:true},expanded:{type:"boolean",group:"Misc",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},stretchContentHeight:{type:"boolean",group:"Appearance",defaultValue:false},applyContentPadding:{type:"boolean",group:"Appearance",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid},headerMode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:b.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false},headerBackgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid},enableTabReordering:{type:"boolean",group:"Behavior",defaultValue:false},tabDensityMode:{type:"sap.m.IconTabDensityMode",group:"Appearance",defaultValue:c.Cozy}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",forwarding:{getter:"_getIconTabHeader",aggregation:"items",forwardBinding:true}},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_header:{type:"sap.m.IconTabHeader",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"},selectedItem:{type:"sap.m.IconTabFilter"},selectedKey:{type:"string"}}},expand:{parameters:{expand:{type:"boolean"},collapse:{type:"boolean"}}}},designtime:"sap/m/designtime/IconTabBar.designtime"}});
d.prototype.setExpanded=function(e){this.setProperty("expanded",e,true);if(this.$().length){this._toggleExpandCollapse(e);}return this;};
d.prototype.setExpandable=function(e){this.setProperty("expandable",e,true);return this;};
d.prototype.setHeaderMode=function(m){this.setProperty("headerMode",m,true);this._getIconTabHeader().setMode(m);return this;};
d.prototype.setTabDensityMode=function(m){this.setProperty("tabDensityMode",m);this._getIconTabHeader().setTabDensityMode(m);return this;};
d.prototype.setHeaderBackgroundDesign=function(h){this.setProperty("headerBackgroundDesign",h,true);this._getIconTabHeader().setBackgroundDesign(h);return this;};
d.prototype.setShowOverflowSelectList=function(v){this.setProperty("showOverflowSelectList",v,true);this._getIconTabHeader().setShowOverflowSelectList(v);return this;};
d.prototype.setEnableTabReordering=function(v){this.setProperty("enableTabReordering",v,true);this._getIconTabHeader().setEnableTabReordering(v);return this;};
d.prototype._rerenderContent=function(o){var $=this.$("content");if(o&&($.length>0)){var r=sap.ui.getCore().createRenderManager();for(var i=0;i<o.length;i++){r.renderControl(o[i]);}r.flush($[0]);r.destroy();}};
d.prototype._toggleExpandCollapse=function(e){var $=this.$("content");var s=this._getIconTabHeader().oSelectedItem;if(e===undefined){e=!this.getExpanded();}if(s){s.$().toggleClass("sapMITBSelected",e);s.$().attr({'aria-expanded':e});if(e){s.$().attr({'aria-selected':e});}else{s.$().removeAttr('aria-selected');}}this._iAnimationCounter=(this._iAnimationCounter===undefined?1:++this._iAnimationCounter);if(e){if(s){if(this.$("content").children().length===0){var S=s.getContent();if(S.length>0){this._rerenderContent(S);}else{this._rerenderContent(this.getContent());}}$.stop(true,true).slideDown('400',q.proxy(this.onTransitionEnded,this,e));this.$("containerContent").toggleClass("sapMITBContentClosed",!e);}}else{this.$("contentArrow").hide();$.stop(true,true).slideUp('400',q.proxy(this.onTransitionEnded,this,e));}if(!e||s){this.setProperty("expanded",e,true);}this.fireExpand({expand:e,collapse:!e});return this;};
d.prototype.onTransitionEnded=function(e){var $=this.$("content"),f=this.$("containerContent"),g=this.$("contentArrow");if(this._iAnimationCounter===1){f.toggleClass("sapMITBContentClosed",!e);if(e){g.show();$.css("display","block");}else{g.hide();$.css("display","none");}}this._iAnimationCounter=(this._iAnimationCounter>0?--this._iAnimationCounter:0);return this;};
d.prototype._getIconTabHeader=function(){var o=this.getAggregation("_header");if(!o){o=new a(this.getId()+"--header",{});this.setAggregation("_header",o,true);}return o;};
d.prototype._getStickyContent=function(){var i=this._getIconTabHeader();d._CLASSES_TO_COPY.forEach(function(s){if(this.hasStyleClass(s)){i.addStyleClass(s);}}.bind(this));return i;};
d.prototype._returnStickyContent=function(){if(this.bIsDestroyed){return;}this._getStickyContent().$().prependTo(this.$());};
d.prototype._setStickySubheaderSticked=function(i){this._bStickyContentSticked=i;};
d.prototype._getStickySubheaderSticked=function(){return this._bStickyContentSticked;};
d.prototype.onBeforeRendering=function(){var e=this._getIconTabHeader().$();if(this._bStickyContentSticked&&e){delete this._bStickyContentSticked;this._getIconTabHeader().$().remove();}};
d.prototype.setShowSelection=function(v){this._getIconTabHeader().setShowSelection(v);return this;};
d.prototype.getShowSelection=function(){return this._getIconTabHeader().getShowSelection();};
d.prototype.setSelectedKey=function(v){this._getIconTabHeader().setSelectedKey(v);return this;};
d.prototype.getSelectedKey=function(){return this._getIconTabHeader().getSelectedKey();};
d.prototype.setSelectedItem=function(i,A){return this._getIconTabHeader().setSelectedItem(i,A);};
d._CLASSES_TO_COPY=["sapUiResponsiveContentPadding","sapUiNoContentPadding","sapUiContentPadding"];return d;});
sap.ui.predefine('sap/m/IconTabBarDragAndDropUtil',['sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo',"sap/ui/events/KeyCodes"],function(D,a,K){"use strict";var I="Before",b="insertBefore",c="insertAfter",i,d="IconTabReorder";var e={_insertControl:function(i,$,f){if(i===c){$.insertAfter(f);}else{$.insertBefore(f);}},handleDrop:function(f,s,o,g,h){var B=f.indexOfItem(o),j=f.indexOfItem(g),$=o.$(),k=g.$(),A=0,r=sap.ui.getCore().getConfiguration().getRTL(),l=s===I;if(r&&!h){if(l){A=B<j?j:j+1;i=c;}else{A=B<j?j-1:j;i=b;}}else{if(l){A=B<j?j-1:j;i=b;}else{A=B<j?j:j+1;i=c;}}e._insertControl(i,$,k);e._handleConfigurationAfterDragAndDrop.call(f,o,A);},_updateAccessibilityInfo:function(){var o=this.getItems(),A=1,f;o.forEach(function(g){f=g.getDomRef();if(f&&f.getAttribute("aria-posinset")!==null){f.setAttribute("aria-posinset",A++);}});},_handleConfigurationAfterDragAndDrop:function(o,f){this.removeAggregation('items',o,true);this.insertAggregation('items',o,f,true);e._updateAccessibilityInfo.call(this);},_decreaseDropIndex:function(B){if(B===0){i=c;return B;}i=b;return B-1;},_increaseDropIndex:function(B,C){if(B===C-1){i=b;return B;}i=c;return B+1;},moveItem:function(o,k){var $=o.$(),f=this.getItems(),B=this.indexOfItem(o),r=sap.ui.getCore().getConfiguration().getRTL(),n,g,h=K;switch(k){case h.HOME:n=0;i=b;break;case h.END:n=f.length-1;i=c;break;case h.ARROW_LEFT:if(r){n=e._increaseDropIndex(B,f.length);}else{n=e._decreaseDropIndex(B);}break;case h.ARROW_RIGHT:if(r){n=e._decreaseDropIndex(B);}else{n=e._increaseDropIndex(B,f.length);}break;case h.ARROW_DOWN:n=e._increaseDropIndex(B,f.length);break;case h.ARROW_UP:n=e._decreaseDropIndex(B);break;default:return;}g=f[n].$();e._insertControl(i,$,g);e._handleConfigurationAfterDragAndDrop.call(this,o,n);return true;},getDraggedDroppedItemsFromList:function(f,o,g){var h,j,s,k,l;l=o._tabFilter?o._tabFilter.getId():o.getId();k=g._tabFilter?g._tabFilter.getId():g.getId();if(!f&&!o&&!g){return;}f.forEach(function(m){s=m._tabFilter.getId();if(!s){return;}if(s===k){h=m;}if(s===l){j=m;}});return{oDraggedControlFromList:j,oDroppedControlFromList:h};},setDragDropAggregations:function(f,s){var o=f._iconTabHeader?f._iconTabHeader:f;var g=o.getId();f.addDragDropConfig(new D({sourceAggregation:"items",groupName:d+g}));f.addDragDropConfig(new a({targetAggregation:"items",dropPosition:"Between",dropLayout:s,drop:f._handleDragAndDrop.bind(f),groupName:d+g}));}};return e;});
sap.ui.predefine('sap/m/IconTabBarRenderer',[],function(){"use strict";var I={};I._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault'];
I.render=function(r,c){var C=c.getContent(),h=c._getIconTabHeader();r.write("<div ");r.writeControlData(c);r.addClass("sapMITB");if(c.getStretchContentHeight()){r.addClass("sapMITBStretch");}if(!c.getApplyContentPadding()){r.addClass("sapMITBNoContentPadding");}r.addClass("sapMITBBackgroundDesign"+c.getBackgroundDesign());r.writeClasses();r.write(">");if(!c._bHideHeader){r.renderControl(h);}r.write("<div id='"+c.getId()+"-containerContent' ");r.addClass("sapMITBContainerContent");if(!c.getExpanded()){r.addClass("sapMITBContentClosed");}r.writeClasses();r.write(">");r.write("<div id='"+c.getId()+"-content' class='sapMITBContent' role='tabpanel' ");if(!c.getExpanded()){r.write("style='display: none'");}if(h.oSelectedItem){r.writeAttribute('aria-labelledby',h.oSelectedItem.getId());}r.write(">");if(c.getExpanded()){if(h.oSelectedItem&&h.oSelectedItem.getContent()){var o=h.oSelectedItem.getContent();if(o.length>0){C=o;}}if(C.length>0){for(var i=0;i<C.length;i++){r.renderControl(C[i]);}}}r.write("</div>");r.write("</div>");r.write("</div>");};
return I;},true);
sap.ui.predefine('sap/m/IconTabBarSelectList',['./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','./IconTabBarDragAndDropUtil','./IconTabBarSelectListRenderer',"sap/ui/thirdparty/jquery"],function(l,C,I,a,b,q){"use strict";
var c=C.extend("sap.m.IconTabBarSelectList",{metadata:{library:"sap.m",aggregations:{items:{type:"sap.m.IconTabFilter",multiple:true,singularName:"item",dnd:true}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.m.IconTabFilter"}}}}}});
c.prototype.init=function(){this._itemNavigation=new I();this._itemNavigation.setCycling(false);this.addEventDelegate(this._itemNavigation);this._itemNavigation.setPageSize(10);};
c.prototype.exit=function(){if(this._itemNavigation){this._itemNavigation.destroy();this._itemNavigation=null;}};
c.prototype.onAfterRendering=function(){this._initItemNavigation();};
c.prototype._setsDragAndConfiguration=function(){if(!this._iconTabHeader.getEnableTabReordering()&&this.getDragDropConfig().length){this.destroyDragDropConfig();}else if(this._iconTabHeader.getEnableTabReordering()&&!this.getDragDropConfig().length){a.setDragDropAggregations(this,"Vertical");}};
c.prototype.onBeforeRendering=function(){if(!this._iconTabHeader){return;}this._setsDragAndConfiguration();};
c.prototype._initItemNavigation=function(){var d,e=this.getItems(),f=[];for(var i=0;i<e.length;i++){d=e[i];f.push(d.getDomRef());}this._itemNavigation.setRootDomRef(this.getDomRef());this._itemNavigation.setItemDomRefs(f);};
c.prototype.getVisibleItems=function(){var d=this.getItems(),v=[],e;for(var i=0;i<d.length;i++){e=d[i];if(e.getVisible()){v.push(e);}}return v;};
c.prototype.setSelectedItem=function(i){if(this._selectedItem){this._deselectItem(this._selectedItem);}if(i){this._selectItem(i);}this._selectedItem=i;};
c.prototype.getSelectedItem=function(){return this._selectedItem;};
c.prototype._deselectItem=function(i){var $=i.$();if($){$.removeClass('sapMITBSelectItemSelected');$.removeAttr('aria-selected');}};
c.prototype._selectItem=function(i){var $=i.$();if($){$.addClass('sapMITBSelectItemSelected');$.attr('aria-selected',true);}};
c.prototype.ontap=function(e){var $=q(e.target);if(!$.hasClass('sapMITBSelectItem')){$=$.parent(".sapMITBSelectItem");}var s=sap.ui.getCore().byId($[0].id);if(s&&s.getEnabled()){e.preventDefault();if(s!=this.getSelectedItem()){this._selectItem(s);this.fireSelectionChange({selectedItem:s});}}if(this._iconTabHeader){this._iconTabHeader._closeOverflow();}};
c.prototype.onsapenter=c.prototype.ontap;c.prototype.onsapspace=c.prototype.ontap;
c.prototype.checkIconOnly=function(d){var e,f=d.length;for(var i=0;i<f;i++){e=d[i];if(e.getText()||e.getCount()){return false;}}return true;};
c.prototype._handleDragAndDrop=function(e){var d=e.getParameter("dropPosition"),D=e.getParameter("draggedControl"),o=e.getParameter("droppedControl"),f=D.getParent().getMetadata().getName()==="sap.m.IconTabHeader",g;if(f){g=a.getDraggedDroppedItemsFromList(this.getAggregation("items"),D,o);this._handleDropOfListAndHeaderItems(d,g.oDraggedControlFromList,g.oDroppedControlFromList,D,o._tabFilter);}else{this._handleDropOfListAndHeaderItems(d,D,o,D._tabFilter,o._tabFilter);}this._initItemNavigation();D.$().focus();};
c.prototype._handleDropOfListAndHeaderItems=function(d,D,o,e,f,i){a.handleDrop(this,d,D,o,true);a.handleDrop(this._iconTabHeader,d,e,f,true);this._iconTabHeader._initItemNavigation();};
c.prototype.ondragrearranging=function(e){if(!this._iconTabHeader.getEnableTabReordering()){return;}var t=e.srcControl,k=e.keyCode;a.moveItem.call(this,t,k);this._initItemNavigation();t.$().focus();this._iconTabHeader._moveTab(t._tabFilter,k);};
c.prototype.onsaphomemodifiers=c.prototype.ondragrearranging;c.prototype.onsapendmodifiers=c.prototype.ondragrearranging;c.prototype.onsapincreasemodifiers=c.prototype.ondragrearranging;c.prototype.onsapdecreasemodifiers=c.prototype.ondragrearranging;return c;});
sap.ui.predefine('sap/m/IconTabBarSelectListRenderer',[],function(){'use strict';var I={};
I.render=function(r,c){var i,a,b=c.getVisibleItems(),d=b.length,e=c._iconTabHeader,f=true;if(e){e._checkTextOnly(b);f=e._bTextOnly;c._bIconOnly=c.checkIconOnly(b);}r.write('<ul');r.writeAttribute('role','listbox');r.writeControlData(c);r.addClass('sapMITBSelectList');if(f){r.addClass('sapMITBSelectListTextOnly');}r.writeClasses();r.write('>');for(i=0;i<d;i++){a=b[i];a.renderInSelectList(r,c,i,d);}r.write('</ul>');};
return I;},true);
sap.ui.predefine('sap/m/IconTabFilter',['./library','sap/ui/core/Item','sap/ui/core/Renderer','sap/ui/core/IconPool','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/core/Control'],function(l,I,R,a,b,c,C){"use strict";var T=c.TextAlign;var d=c.TextDirection;var e=l.ImageHelper;var f=l.IconTabFilterDesign;var g=c.IconColor;
var h=I.extend("sap.m.IconTabFilter",{metadata:{interfaces:["sap.m.IconTab","sap.ui.core.PopupInterface"],library:"sap.m",designtime:"sap/m/designtime/IconTabFilter.designtime",properties:{count:{type:"string",group:"Data",defaultValue:''},showAll:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},iconColor:{type:"sap.ui.core.IconColor",group:"Appearance",defaultValue:g.Default},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},visible:{type:"boolean",group:"Behavior",defaultValue:true},design:{type:"sap.m.IconTabFilterDesign",group:"Appearance",defaultValue:f.Vertical}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
h._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault','sapMITBFilterNeutral'];
h.prototype._getImageControl=function(i,p,j){var P={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(P.src){this._oImageControl=e.getImageControl(this.getId()+"-icon",this._oImageControl,p,P,i,j);}else if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}return this._oImageControl;};
h.prototype.exit=function(E){if(this._oImageControl){this._oImageControl.destroy();}if(I.prototype.exit){I.prototype.exit.call(this,E);}if(this._invisibleText){this._invisibleText.destroy();this._invisibleText=null;}};
h.prototype.invalidate=function(){var i=this.getParent(),o,O;if(!i){return;}o=i.getParent();if(!(o instanceof sap.m.IconTabBar)){i.invalidate();return;}O=o.getParent();if(O instanceof sap.m.ObjectHeader){O.invalidate();}else{o.invalidate();}};
h.prototype.setProperty=function(p,v,s){switch(p){case'enabled':case'textDirection':case'text':case'count':case'showAll':case'icon':case'iconColor':case'iconDensityAware':case'design':if(this.getProperty(p)===v){return this;}C.prototype.setProperty.call(this,p,v,true);if(!s){var i=this.getParent();if(i instanceof sap.m.IconTabHeader){i.invalidate();}}break;default:C.prototype.setProperty.apply(this,arguments);break;}return this;};
h.prototype._getNonEmptyKey=function(){var k=this.getKey();if(k){return k;}return this.getId();};
h.prototype.render=function(r,v,i){var t=this;if(!t.getVisible()){return;}var j=this.getParent(),k=j.getParent(),m=k instanceof sap.m.IconTabBar,n=sap.ui.getCore().getLibraryResourceBundle('sap.m'),o='role="tab"',p=t.getId(),q=t.getCount(),s=t.getText(),u=t.getIcon(),w=t.getDesign(),x=t.getIconColor(),y=x==='Positive'||x==='Critical'||x==='Negative',z=w===f.Horizontal,A=m&&k.getUpperCase(),B=j._bTextOnly,D=j._bInLine||j.isInlineMode();if(m){o+=' aria-controls="'+k.sId+'-content" ';}if(s.length||q!==''||u){o+='aria-labelledby="';var E=[];if(q!==''){E.push(p+'-count');}if(s.length){E.push(p+'-text');}if(u){E.push(p+'-icon');}if(y){E.push(p+'-iconColor');}o+=E.join(' ');o+='"';}r.write('<div '+o+' ');if(v!==undefined&&i!==undefined){r.writeAccessibilityState({posinset:v+1,setsize:i});}r.writeElementData(t);r.addClass('sapMITBItem');if(!q){r.addClass('sapMITBItemNoCount');}if(z){r.addClass('sapMITBHorizontal');}else{r.addClass('sapMITBVertical');}if(t.getShowAll()){r.addClass('sapMITBAll');}else{r.addClass('sapMITBFilter');r.addClass('sapMITBFilter'+x);}if(!t.getEnabled()){r.addClass('sapMITBDisabled');r.writeAttribute('aria-disabled',true);}r.writeAttribute('aria-selected',false);var F=t.getTooltip_AsString();if(F){r.writeAttributeEscaped('title',F);}r.writeClasses();r.write('>');if(!D){r.write('<div id="'+p+'-tab" class="sapMITBTab">');if(!t.getShowAll()||!u){if(y){r.write('<div id="'+p+'-iconColor" style="display: none;">'+n.getText('ICONTABBAR_ICONCOLOR_'+x.toUpperCase())+'</div>');}r.renderControl(t._getImageControl(['sapMITBFilterIcon','sapMITBFilter'+x],j,h._aAllIconColors));}if(!t.getShowAll()&&!u&&!B){r.write('<span class="sapMITBFilterNoIcon"> </span>');}if(z&&!t.getShowAll()){r.write('</div>');r.write('<div class="sapMITBHorizontalWrapper">');}r.write('<span id="'+p+'-count" ');r.addClass('sapMITBCount');r.writeClasses();r.write('>');if(q===''&&z){r.write('&nbsp;');}else{r.writeEscaped(q);}r.write('</span>');if(!z){r.write('</div>');}}if(s.length){r.write('<div id="'+p+'-text" ');r.addClass('sapMITBText');if(A){r.addClass('sapMITBTextUpperCase');}if(D){r.writeAttribute('dir','ltr');}r.writeClasses();r.write('>');r.writeEscaped(j._getDisplayText(t));r.write('</div>');}if(!D&&z){r.write('</div>');}r.write('<div class="sapMITBContentArrow"></div>');r.write('</div>');};
h.prototype.renderInSelectList=function(r,s,v,i){var t=this;if(this._invisibleText){this._invisibleText.destroy();this._invisibleText=null;}if(!t.getVisible()){return;}var j=true,k,m=s._iconTabHeader,n=sap.ui.getCore().getLibraryResourceBundle('sap.m');if(m){j=m._bTextOnly;k=s._bIconOnly;}r.write('<li');r.writeElementData(t);r.writeAttribute('tabindex','-1');r.writeAttribute('role','option');if(v!==undefined&&i!==undefined){r.writeAttribute('aria-posinset',v+1);r.writeAttribute('aria-setsize',i);}var o=t.getTooltip_AsString();if(o){r.writeAttributeEscaped('title',o);}if(!t.getEnabled()){r.addClass('sapMITBDisabled');r.writeAttribute('aria-disabled',true);}r.addClass('sapMITBSelectItem');if(s.getSelectedItem()==t){r.addClass('sapMITBSelectItemSelected');r.writeAttribute('aria-selected',true);}var p=t.getIconColor();r.addClass('sapMITBFilter'+p);r.writeClasses();var q=t.getId(),u=p=='Positive'||p=='Critical'||p=='Negative';var w=' aria-labelledby="';if(!k){w+=q+'-text ';}if(!j&&t.getIcon()){w+=q+'-icon ';}if(u){this._invisibleText=new b({text:n.getText('ICONTABBAR_ICONCOLOR_'+p.toUpperCase())});w+=this._invisibleText.getId();}w+='"';r.write(w+'>');if(this._invisibleText){r.renderControl(this._invisibleText);}if(!j){this._renderIcon(r);}if(!k){this._renderText(r);}r.write('</li>');};
h.prototype._renderIcon=function(r){var i=this.getIcon();if(i){var j=a.getIconInfo(i);var k=['sapMITBSelectItemIcon'];if(j&&!j.suppressMirroring){k.push('sapUiIconMirrorInRTL');}r.writeIcon(i,k,{id:this.getId()+'-icon','aria-hidden':true});}else{r.write('<span class="sapUiIcon"></span>');}};
h.prototype._renderText=function(r){var t=this.getText(),i=this.getCount(),j=sap.ui.getCore().getConfiguration().getRTL(),k=this.getTextDirection();r.write('<span');r.writeAttribute('id',this.getId()+'-text');r.writeAttribute('dir','ltr');r.addClass('sapMText');r.addClass('sapMTextNoWrap');r.addClass('sapMITBText');r.writeClasses();if(k!==d.Inherit){r.writeAttribute('dir',k.toLowerCase());}var m=R.getTextAlign(T.Begin,k);if(m){r.addStyle('text-align',m);r.writeStyles();}if(i){if(j){t='('+i+') '+t;}else{t+=' ('+i+')';}}r.write('>');r.writeEscaped(t);r.write('</span>');};
return h;});
sap.ui.predefine('sap/m/IconTabHeader',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/IconPool','sap/ui/core/delegate/ScrollEnablement','./IconTabBarSelectList','./Button','./ResponsivePopover','./IconTabFilter','sap/ui/Device','sap/ui/core/ResizeHandler','sap/ui/core/Icon','./IconTabBarDragAndDropUtil','./IconTabHeaderRenderer',"sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/events/KeyCodes"],function(l,C,E,I,a,S,b,B,R,c,D,d,e,f,g,q,L,K){"use strict";var t=l.touch;var h=l.ImageHelper;var P=l.PlacementType;var j=l.ButtonType;var k=l.BackgroundDesign;var m=l.IconTabHeaderMode;var n=l.IconTabDensityMode;
var o=C.extend("sap.m.IconTabHeader",{metadata:{library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},selectedKey:{type:"string",group:"Data",defaultValue:null},visible:{type:"boolean",group:"Behavior",defaultValue:true},mode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:m.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:k.Solid},enableTabReordering:{type:"boolean",group:"Behavior",defaultValue:false},tabDensityMode:{type:"sap.m.IconTabDensityMode",group:"Appearance",defaultValue:n.Cozy}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",dnd:{draggable:true,droppable:true,layout:"Horizontal"}},_overflowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"}}}}}});
E.apply(o.prototype,[true]);o.SCROLL_STEP=264;
o.prototype.init=function(){this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;this._iCurrentScrollLeft=0;this.startScrollX=0;this.startTouchX=0;this._scrollable=null;this._aTabKeys=[];this._oItemNavigation=new I().setCycling(false);this._oItemNavigation.attachEvent(I.Events.FocusLeave,this._onItemNavigationFocusLeave,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._onItemNavigationAfterFocus,this);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addDelegate(this._oItemNavigation);this._oScroller=new S(this,this.getId()+"-head",{horizontal:true,vertical:false,nonTouchScrolling:true});};
o.prototype.isTouchScrollingDisabled=function(){return this.getShowOverflowSelectList()&&this.getParent().getMetadata().getName()=='sap.tnt.ToolHeader';};
o.prototype._getSelectList=function(){var i=this;if(!this._oSelectList){this._oSelectList=new b({selectionChange:function(p){var T=p.getParameter('selectedItem');i.setSelectedItem(T._tabFilter);}});this._oSelectList._iconTabHeader=this;}return this._oSelectList;};
o.prototype._getOverflowButton=function(){var O=this.getAggregation("_overflowButton");if(!O){O=new B({id:this.getId()+'-overflow',icon:"sap-icon://slim-arrow-down",type:j.Transparent,press:this._overflowButtonPress.bind(this)});O.addEventDelegate(this._onOverflowButtonEventDelegate);this.setAggregation("_overflowButton",O);}return O;};
o.prototype._overflowButtonPress=function(i){if(!this._oPopover){this._oPopover=new R({showArrow:false,showHeader:false,placement:P.Vertical,offsetX:0,offsetY:0}).addStyleClass('sapMITBPopover');if(D.system.phone){this._oPopover._oControl.addButton(this._createPopoverCloseButton());}this.addDependent(this._oPopover);this._oPopover._oControl._adaptPositionParams=function(){var p=q("body").hasClass("sapUiSizeCompact");this._arrowOffset=0;if(p){this._offsets=["0 0","0 0","0 2","0 0"];}else{this._offsets=["0 0","0 0","0 3","0 0"];}this._myPositions=["end bottom","begin top","end top","end top"];this._atPositions=["end top","end top","end bottom","begin top"];};}var s=this._getSelectList();this._setSelectListItems();this._oPopover.removeAllContent();this._oPopover.addContent(s);this._oPopover.setInitialFocus(s.getSelectedItem());this._oPopover.openBy(this._getOverflowButton());};
o.prototype._createPopoverCloseButton=function(){var i=this;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("SELECT_CANCEL_BUTTON"),press:function(){i._closeOverflow();}});};
o.prototype._closeOverflow=function(){if(!D.system.desktop){this._oPopover.close();}if(this.oSelectedItem){this.oSelectedItem.$().focus();}};
o.prototype._setSelectListItems=function(){if(!this.getShowOverflowSelectList()){return;}var s,T,p=this._getSelectList(),r=this.getTabFilters();p.destroyItems();for(var i=0;i<r.length;i++){T=r[i];s=T.clone(undefined,undefined,{bCloneChildren:false,bCloneBindings:true});s._tabFilter=T;p.addItem(s);if(T==this.oSelectedItem){p.setSelectedItem(s);}}};
o.prototype._findSelectItem=function(T){var s=this._getSelectList(),p=s.getItems(),r;for(var i=0;i<p.length;i++){r=p[i];if(r._tabFilter==T){return r;}}};
o.prototype._onItemNavigationFocusLeave=function(){if(!this.oSelectedItem){return;}var p=this.getItems();var r=-1;var s;for(var i=0;i<p.length;i++){s=p[i];if(s instanceof c==false){continue;}r++;if(this.oSelectedItem==s){break;}}this._oItemNavigation.setFocusedIndex(r);};
o.prototype._onItemNavigationAfterFocus=function(i){var H=this.getDomRef("head"),p=i.getParameter("index"),$=i.getParameter('event');if($.keyCode===undefined){return;}this._iCurrentScrollLeft=H.scrollLeft;this._checkOverflow();if(p!==null&&p!==undefined){this._scrollIntoView(this.getTabFilters()[p],0);}};
o.prototype.getTabFilters=function(){var i=this.getItems();var T=[];i.forEach(function(p){if(p instanceof c){T.push(p);}});return T;};
o.prototype.exit=function(){if(this._oArrowLeft){this._oArrowLeft.destroy();}if(this._oArrowRight){this._oArrowRight.destroy();}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._aTabKeys){this._aTabKeys=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
o.prototype._handleOnLongDragOver=function(){if(!this._oPopover||!this._oPopover.isOpen()){this._overflowButtonPress();}};
o.prototype._handleOnDragOver=function(i){this._getOverflowButton().addStyleClass("sapMBtnDragOver");i.preventDefault();};
o.prototype._handleOnDrop=function(){this._getOverflowButton().removeStyleClass("sapMBtnDragOver");};
o.prototype._handleOnDragLeave=function(){this._getOverflowButton().removeStyleClass("sapMBtnDragOver");};
o.prototype._setsDragAndDropConfigurations=function(){if(!this.getEnableTabReordering()&&this.getDragDropConfig().length){this.destroyDragDropConfig();}else if(this.getEnableTabReordering()&&!this.getDragDropConfig().length){f.setDragDropAggregations(this,"Horizontal");}};
o.prototype.onBeforeRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._onOverflowButtonEventDelegate={onlongdragover:this._handleOnLongDragOver.bind(this),ondragover:this._handleOnDragOver.bind(this),ondragleave:this._handleOnDragLeave.bind(this),ondrop:this._handleOnDrop.bind(this)};if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._updateSelection();this._isTouchScrollingDisabled=this.isTouchScrollingDisabled();this._oScroller.setHorizontal(!this._isTouchScrollingDisabled&&(!this.getEnableTabReordering()||!D.system.desktop));this._setsDragAndDropConfigurations();};
o.prototype.setSelectedKey=function(s){var p=this.getTabFilters(),i=0,r=this._isInsideIconTabBar(),u;if(p.length>0){s=s||p[0]._getNonEmptyKey();}if(this.$().length){for(;i<p.length;i++){if(p[i]._getNonEmptyKey()===s){this.setSelectedItem(p[i],true);u=true;break;}}if(!u&&!r&&s){this.setSelectedItem(null);}}this.setProperty("selectedKey",s,true);return this;};
o.prototype.setSelectedItem=function(i,A){if(!i){if(this.oSelectedItem){this.oSelectedItem.$().removeClass("sapMITBSelected");this.oSelectedItem=null;}return this;}if(!i.getEnabled()){return this;}if(this.getShowOverflowSelectList()){var s=this._findSelectItem(i);if(s){this._getSelectList().setSelectedItem(s);}}var p=this.getParent();var r=this._isInsideIconTabBar();var u=false;if(i.getContent().length===0&&this.oSelectedItem&&this.oSelectedItem.getContent().length===0){u=true;}if(this.oSelectedItem&&this.oSelectedItem.getVisible()&&(!A&&r&&p.getExpandable()||this.oSelectedItem!==i)){this.oSelectedItem.$().removeClass("sapMITBSelected").attr('aria-selected',false).removeAttr('aria-expanded');}if(i.getVisible()){if(this.oSelectedItem===i){if(!A&&r&&p.getExpandable()){p._toggleExpandCollapse();}}else{if(r){p.$("content").attr('aria-labelledby',i.sId);}this.oSelectedItem=i;this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);if(!r){this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});}if(r&&(p.getExpandable()||p.getExpanded())){this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});var v=this.oSelectedItem.getContent();if(v.length>0){p._rerenderContent(v);}else{if(!u){p._rerenderContent(p.getContent());}}if(!A&&p.getExpandable()&&!p.getExpanded()){p._toggleExpandCollapse(true);}}}if(this.oSelectedItem.$().length>0){this._scrollIntoView(i,500);}else{this._scrollAfterRendering=true;}}this.oSelectedItem=i;var w=this.oSelectedItem._getNonEmptyKey();this.setProperty("selectedKey",w,true);if(r){p.setProperty("selectedKey",w,true);}if(!A){if(r){p.fireSelect({selectedItem:this.oSelectedItem,selectedKey:w,item:this.oSelectedItem,key:w});}else{this.fireSelect({selectedItem:this.oSelectedItem,selectedKey:w,item:this.oSelectedItem,key:w});}}return this;};
o.prototype.getVisibleTabFilters=function(){var p=this.getTabFilters(),v=[],r;for(var i=0;i<p.length;i++){r=p[i];if(r.getVisible()){v.push(r);}}return v;};
o.prototype._getFirstVisibleItem=function(p){for(var i=0;i<p.length;i++){if(p[i].getVisible()){return p[i];}}return null;};
o.prototype._initItemNavigation=function(){var i=this,H=this.getDomRef("head"),p=this.getItems(),T=[],s=-1;p.forEach(function(r){if(r instanceof c){var u=i.getFocusDomRef(r);q(u).attr("tabindex","-1");T.push(u);if(r===i.oSelectedItem){s=T.indexOf(u);}}});if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.FocusLeave,this._onItemNavigationFocusLeave,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._onItemNavigationAfterFocus,this);this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(H);this._oItemNavigation.setItemDomRefs(T);this._oItemNavigation.setPageSize(T.length);this._oItemNavigation.setSelectedIndex(s);};
o.prototype.onThemeChanged=function(){this._applyTabDensityMode();};
o.prototype._applyTabDensityMode=function(){var T=this.getTabDensityMode();this.$().removeClass("sapUiSizeCompact");switch(T){case n.Compact:this.$().addClass("sapUiSizeCompact");break;case n.Inherit:if(this.$().closest(".sapUiSizeCompact").length){this.$().addClass("sapUiSizeCompact");}break;}};
o.prototype.onAfterRendering=function(){this._applyTabDensityMode();if(this._oScroller){this._oScroller.setIconTabBar(this,q.proxy(this._afterIscroll,this),q.proxy(this._scrollPreparation,this));}var p=this.getParent();var i=this._isInsideIconTabBar();if(this.oSelectedItem&&(!i||i&&p.getExpanded())){this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});}setTimeout(this["_checkOverflow"].bind(this),350);if(this.oSelectedItem){this._scrollIntoView(this.oSelectedItem,500);}this._initItemNavigation();if(this.getShowOverflowSelectList()){this.$('overflow').attr('tabindex',-1);}this._sResizeListenerId=d.register(this.getDomRef(),q.proxy(this._fnResize,this));this._bCheckIfIntoView=true;};
o.prototype.destroyItems=function(){this.oSelectedItem=null;this._aTabKeys=[];this.destroyAggregation("items");return this;};
o.prototype.addItem=function(i){if(!(i instanceof sap.m.IconTabSeparator)){var s=i.getKey();if(this._aTabKeys.indexOf(s)!==-1){L.warning("sap.m.IconTabHeader: duplicate key '"+s+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(s);}this.addAggregation("items",i);this._invalidateParentIconTabBar();};
o.prototype.insertItem=function(i,p){if(!(i instanceof sap.m.IconTabSeparator)){var s=i.getKey();if(this._aTabKeys.indexOf(s)!==-1){L.warning("sap.m.IconTabHeader: duplicate key '"+s+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(s);}this.insertAggregation("items",i,p);this._invalidateParentIconTabBar();};
o.prototype.removeAllItems=function(){var r=this.removeAllAggregation("items");this._aTabKeys=[];this.oSelectedItem=null;this._invalidateParentIconTabBar();return r;};
o.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(i&&!(i instanceof sap.m.IconTabSeparator)){var s=i.getKey();this._aTabKeys.splice(this._aTabKeys.indexOf(s),1);}if(this.oSelectedItem===i){this.oSelectedItem=null;}this._invalidateParentIconTabBar();return i;};
o.prototype.updateAggregation=function(){this.oSelectedItem=null;C.prototype.updateAggregation.apply(this,arguments);this.invalidate();};
o.prototype.removeAggregation=function(A,O,s){var i=this.getTabFilters();var p=C.prototype.removeAggregation.apply(this,arguments);if(s){return p;}if(p&&p==this.oSelectedItem&&A=='items'){var r=(i?Array.prototype.indexOf.call(i,p):-1);i=this.getTabFilters();r=Math.max(0,Math.min(r,i.length-1));var u=i[r];if(u){this.setSelectedItem(u,true);}else{var v=this.getParent();if(this._isInsideIconTabBar()&&v.getExpanded()){v.$("content").children().remove();}}}return p;};
o.prototype.removeAllAggregation=function(A,s){if(A=='items'){var i=this.getParent();if(this._isInsideIconTabBar()&&i.getExpanded()){i.$("content").children().remove();}}return C.prototype.removeAllAggregation.apply(this,arguments);};
o.prototype._getDisplayText=function(i){var T=i.getText();if(this.isInlineMode()){var s=i.getCount();if(s){if(this._bRtl){T='('+s+') '+T;}else{T+=' ('+s+')';}}}return T;};
o.prototype.isInlineMode=function(){return this._bTextOnly&&this.getMode()==m.Inline;};
o.prototype._checkTextOnly=function(p){if(p.length>0){for(var i=0;i<p.length;i++){if(!(p[i]instanceof sap.m.IconTabSeparator)){if(p[i].getIcon()){this._bTextOnly=false;return false;}}}}this._bTextOnly=true;return true;};
o.prototype._checkNoText=function(p){if(p.length>0){for(var i=0;i<p.length;i++){if(!(p[i]instanceof sap.m.IconTabSeparator)){if(p[i].getText().length>0){return false;}}}}return true;};
o.prototype._checkInLine=function(p){var r;if(p.length>0){for(var i=0;i<p.length;i++){r=p[i];if(!(r instanceof sap.m.IconTabSeparator)){if(r.getIcon()||r.getCount()){this._bInLine=false;return false;}}}}this._bInLine=true;return true;};
o.prototype._checkScrolling=function(H){var $=this.$();var s=false;var i=this.getDomRef("scrollContainer");var p=this.getDomRef("head");if(p&&i){if(p.offsetWidth>i.offsetWidth){s=true;}}if(this._scrollable!==s){$.toggleClass("sapMITBScrollable",s);$.toggleClass("sapMITBNotScrollable",!s);this._scrollable=s;}this._setTabsVisibility();return s;};
o.prototype._getScrollingArrow=function(N){var s=a.getIconURI("slim-arrow-"+N);var p={src:s,useIconTooltip:false};var i=this._bTextOnly?"TextOnly":"";var r="sapMITBArrowScrollLeft"+i;var u="sapMITBArrowScrollRight"+i;var v=["sapMITBArrowScroll",r,"sapMITHVerticallyCenteredArrow"];var w=["sapMITBArrowScroll",u,"sapMITHVerticallyCenteredArrow"];if(this._bInLine||this.isInlineMode()){v.push('sapMITBArrowScrollLeftInLine');w.push('sapMITBArrowScrollRightInLine');}if(N==="left"){if(!this._oArrowLeft){this._oArrowLeft=h.getImageControl(this.getId()+"-arrowScrollLeft",this._oArrowLeft,this,p,v);}return this._oArrowLeft;}if(N==="right"){if(!this._oArrowRight){this._oArrowRight=h.getImageControl(this.getId()+"-arrowScrollRight",this._oArrowRight,this,p,w);}return this._oArrowRight;}};
o.prototype._checkOverflow=function(){if(this.bIsDestroyed){return;}var i=this.getDomRef("head");var $=this.$();if(this._checkScrolling(i)&&i){var s=false;var p=false;var r=this.getDomRef("scrollContainer");var u=this.getDomRef("head");if(this._oScroller.getScrollLeft()>0){s=true;}if((this._oScroller.getScrollLeft()+r.offsetWidth)<u.offsetWidth){p=true;}if((p!=this._bPreviousScrollForward)||(s!=this._bPreviousScrollBack)){this._bPreviousScrollForward=p;this._bPreviousScrollBack=s;$.toggleClass("sapMITBScrollBack",s);$.toggleClass("sapMITBNoScrollBack",!s);$.toggleClass("sapMITBScrollForward",p);$.toggleClass("sapMITBNoScrollForward",!p);}}else{this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;}};
o.prototype._handleActivation=function(i){var T=i.target.id,p=i.srcControl,s,$=q(i.target);if(p instanceof B){return;}var r=q(document.getElementById(T));if(r.parents()&&Array.prototype.indexOf.call(r.parents(),this.$("content")[0])>-1){}else{if(T){var u=this.getId();i.preventDefault();if(T==u+"-arrowScrollLeft"&&D.system.desktop){var v=this._oScroller.getScrollLeft()-o.SCROLL_STEP;if(v<0){v=0;}this._scrollPreparation();setTimeout(this._oScroller["scrollTo"].bind(this._oScroller,v,0,500),0);setTimeout(this["_afterIscroll"].bind(this),500);}else if(T==u+"-arrowScrollRight"&&D.system.desktop){var v=this._oScroller.getScrollLeft()+o.SCROLL_STEP;var w=this.$("scrollContainer").width();var H=this.$("head").width();if(v>(H-w)){v=H-w;}this._scrollPreparation();setTimeout(this._oScroller["scrollTo"].bind(this._oScroller,v,0,500),0);setTimeout(this["_afterIscroll"].bind(this),500);}else{if($.hasClass('sapMITBFilterIcon')||$.hasClass('sapMITBCount')||$.hasClass('sapMITBText')||$.hasClass('sapMITBTab')||$.hasClass('sapMITBContentArrow')||$.hasClass('sapMITBSep')||$.hasClass('sapMITBSepIcon')){s=i.srcControl.getId().replace(/-icon$/,"");p=sap.ui.getCore().byId(s);if(p.getMetadata().isInstanceOf("sap.m.IconTab")&&!(p instanceof sap.m.IconTabSeparator)){this.setSelectedItem(p);}}else if(p.getMetadata().isInstanceOf("sap.m.IconTab")&&!(p instanceof sap.m.IconTabSeparator)){this.setSelectedItem(p);}}}else{if(p.getMetadata().isInstanceOf("sap.m.IconTab")&&!(p instanceof sap.m.IconTabSeparator)){this.setSelectedItem(p);}}}};
o.prototype._scrollIntoView=function(i,p){if(this.bIsDestroyed){return;}var $=i.$(),s,N,r;if($.length>0){var u=this.$('head');var H=u.innerWidth()-u.width();var v=$.outerWidth(true);var w=$.position().left-H/2;s=this._oScroller.getScrollLeft();r=this.$("scrollContainer").width();N=0;if(w-s<0||w-s>r-v){if(w-s<0){N+=w;}else{N+=Math.min(w,w+v-r);N=Math.round(N);}this._scrollPreparation();this._iCurrentScrollLeft=N;setTimeout(this._oScroller["scrollTo"].bind(this._oScroller,N,0,p),0);setTimeout(this["_afterIscroll"].bind(this),p);}}return this;};
o.prototype._scroll=function(i,p){this._scrollPreparation();var r=this.getDomRef("head");var s=r.scrollLeft;var u=D.browser.msie||D.browser.edge;if(!u&&this._bRtl){i=-i;}var v=s+i;q(r).stop(true,true).animate({scrollLeft:v},p,q.proxy(this._adjustAndShowArrow,this));this._iCurrentScrollLeft=v;};
o.prototype._adjustAndShowArrow=function(){this._$bar&&this._$bar.toggleClass("sapMITBScrolling",false);this._$bar=null;if(D.system.desktop){this._checkOverflow();}};
o.prototype._scrollPreparation=function(){if(!this._$bar){this._$bar=this.$().toggleClass("sapMITBScrolling",true);}};
o.prototype._afterIscroll=function(){this._checkOverflow();this._adjustAndShowArrow();this._setTabsVisibility();};
o.prototype._fnResize=function(){this._checkOverflow();if(this.oSelectedItem&&this._bCheckIfIntoView){this._scrollIntoView(this.oSelectedItem,0);if(!this._isTouchScrollingDisabled){this._bCheckIfIntoView=false;}}this._setTabsVisibility();};
o.prototype._isInsideIconTabBar=function(){var p=this.getParent();return p instanceof C&&p.isA('sap.m.IconTabBar');};
o.prototype._invalidateParentIconTabBar=function(){if(this._isInsideIconTabBar()){this.getParent().invalidate();}};
o.prototype._setTabsVisibility=function(){if(!this._isTouchScrollingDisabled){return;}var T=this.getItems(),p,$,H,i;for(i=0;i<T.length;i++){p=T[i];$=p.$();if(!$.hasClass('sapMITBSelected')&&!this._isTabIntoView($)){$.addClass('sapMITBFilterHidden');}else{H=true;$.removeClass('sapMITBFilterHidden');}}if(!H){for(i=0;i<T.length;i++){p=T[i];$=p.$();if(this._isTabIntoView($,true)){$.removeClass('sapMITBFilterHidden');break;}}}this._moveVisibleTabs();};
o.prototype._isTabIntoView=function($,s){if(!$.length){return false;}var i=this._oScroller.getScrollLeft(),p=this.$("scrollContainer").width(),r=this.$('head'),H=r.innerWidth()-r.width(),u=$.css('padding-left'),v=$.width()+parseFloat(u),w=Math.ceil($.position().left-H/2);if(w-i<0||(!s&&(w+v-i>p))){return false;}return true;};
o.prototype._moveVisibleTabs=function(){if(!this._oScroller){return;}var s=this._oScroller.getScrollLeft(),$=this.$('head'),H=$.innerWidth()-$.width(),i=this.$().find('.sapMITBFilter:not(.sapMITBFilterHidden)').first(),p,r;if(!i.length){return;}r=i.position().left-H/2;if(!this._bRtl&&r-s>2){p=s-r;$.css('transform','translate('+p+'px)');}else{$.css('transform','');}return true;};
o.prototype.getFocusDomRef=function(F){var T=F||this.oSelectedItem;if(!T){return null;}return T.getDomRef();};
o.prototype.applyFocusInfo=function(F){if(F.focusDomRef){q(F.focusDomRef).focus();}};
o.prototype._updateSelection=function(){var p=this.getItems(),s=this.getSelectedKey(),i=0,r=this.getParent(),u=this._isInsideIconTabBar(),v=r&&r.getMetadata().getName()=='sap.tnt.ToolHeader';if(p.length>0){if(!this.oSelectedItem||s&&s!==this.oSelectedItem._getNonEmptyKey()){if(s){for(;i<p.length;i++){if(!(p[i]instanceof sap.m.IconTabSeparator)&&p[i]._getNonEmptyKey()===s){this.oSelectedItem=p[i];break;}}}if(!this.oSelectedItem&&(u||!s)){for(i=0;i<p.length;i++){if(!(p[i]instanceof sap.m.IconTabSeparator)&&p[i].getVisible()){this.oSelectedItem=p[i];break;}}}}if(!v&&this.oSelectedItem&&!this.oSelectedItem.getVisible()){for(i=0;i<p.length;i++){if(!(p[i]instanceof sap.m.IconTabSeparator)&&p[i].getVisible()){this.oSelectedItem=p[i];break;}}}if(this.oSelectedItem){this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);}}};
o.prototype.ontouchstart=function(i){var T=i.targetTouches[0];this._iActiveTouch=T.identifier;this._iTouchStartPageX=T.pageX;this._iTouchStartPageY=T.pageY;this._iTouchDragX=0;this._iTouchDragY=0;var $=q(i.target);if($.hasClass('sapMITBArrowScroll')){i.preventDefault();}};
o.prototype.ontouchmove=function(i){if(this._iActiveTouch===undefined){return;}var T=t.find(i.changedTouches,this._iActiveTouch);if(!T||T.pageX===this._iTouchStartPageX){return;}this._iTouchDragX+=Math.abs(this._iTouchStartPageX-T.pageX);this._iTouchDragY+=Math.abs(this._iTouchStartPageY-T.pageY);this._iTouchStartPageX=T.pageX;this._iTouchStartPageY=T.pageY;};
o.prototype.ontouchend=function(i){if(this._iActiveTouch===undefined){return;}var M=D.system.desktop?5:15;if((this._scrollable&&this._iTouchDragX>M)||this._iTouchDragY>M){return;}var p=0;var r=1;var s;if(i.which===s||i.which===p||i.which===r){this._handleActivation(i);}this._iActiveTouch=undefined;};
o.prototype.ontouchcancel=o.prototype.ontouchend;
o.prototype.onkeydown=function(i){switch(i.which){case K.ENTER:this._handleActivation(i);i.preventDefault();break;case K.SPACE:i.preventDefault();break;}};
o.prototype.onkeyup=function(i){if(i.which===K.SPACE){this._handleActivation(i);i.preventDefault();}};
o.prototype._handleDragAndDrop=function(i){var s=i.getParameter("dropPosition"),p=i.getParameter("draggedControl"),r=i.getParameter("droppedControl"),u=p.getParent().getMetadata().getName()==="sap.m.IconTabBarSelectList";if(u){this._handleDragAndDropBetweenHeaderAndList(s,r,p);}else{f.handleDrop(this,s,p,r,false);}this._initItemNavigation();p.$().focus();};
o.prototype._handleDragAndDropBetweenHeaderAndList=function(s,i,p){var r=this._getSelectList(),u=f.getDraggedDroppedItemsFromList(r.getAggregation("items"),p,i);if(!u){return;}f.handleDrop(this,s,p._tabFilter,i,false);f.handleDrop(r,s,p,u.oDroppedControlFromList,false);r._initItemNavigation();};
o.prototype._moveTab=function(T,i){var r=f.moveItem.call(this,T,i);this._initItemNavigation();if(r){this._scrollIntoView(T,0);}};
o.prototype.ondragrearranging=function(i){if(!this.getEnableTabReordering()){return;}var T=i.srcControl;this._moveTab(T,i.keyCode);T.$().focus();};
o.prototype.onsaphomemodifiers=o.prototype.ondragrearranging;o.prototype.onsapendmodifiers=o.prototype.ondragrearranging;o.prototype.onsapincreasemodifiers=o.prototype.ondragrearranging;o.prototype.onsapdecreasemodifiers=o.prototype.ondragrearranging;return o;});
sap.ui.predefine('sap/m/IconTabHeaderRenderer',['sap/m/library','sap/ui/Device'],function(l,D){"use strict";var I=l.IconTabFilterDesign;var a={};
a.render=function(r,c){if(!c.getVisible()){return;}var b=c.getItems(),d=b.length,v=c.getVisibleTabFilters(),V=v.length,e=0,t=c._checkTextOnly(b),n=c._checkNoText(b),f=c._checkInLine(b)||c.isInlineMode(),s=c.getShowOverflowSelectList(),o,g,h;var j=c.getParent();var u=j&&j instanceof sap.m.IconTabBar&&j.getUpperCase();r.write("<div");r.addClass("sapMITH");r.addClass("sapContrastPlus");r.addClass("sapMITHBackgroundDesign"+c.getBackgroundDesign());if(s){r.addClass("sapMITHOverflowList");}if(c._scrollable){r.addClass("sapMITBScrollable");if(c._bPreviousScrollForward){r.addClass("sapMITBScrollForward");}else{r.addClass("sapMITBNoScrollForward");}if(c._bPreviousScrollBack){r.addClass("sapMITBScrollBack");}else{r.addClass("sapMITBNoScrollBack");}}else{r.addClass("sapMITBNotScrollable");}if(u){r.addClass("sapMITBTextUpperCase");}r.writeControlData(c);r.writeClasses();r.write(">");r.renderControl(c._getScrollingArrow("left"));r.write("<div id='"+c.getId()+"-scrollContainer' class='sapMITBScrollContainer'>");r.write("<div id='"+c.getId()+"-head' role='tablist' ");r.addClass("sapMITBHead");if(t){r.addClass("sapMITBTextOnly");}if(n){r.addClass("sapMITBNoText");}if(f){r.addClass("sapMITBInLine");}r.writeClasses();r.write(">");for(var i=0;i<d;i++){o=b[i];o.render(r,e,V);if(o instanceof sap.m.IconTabFilter){g=o.getDesign()===I.Horizontal;if(g){h=true;}if(o.getVisible()){e++;}}}r.write("</div>");r.write("</div>");r.renderControl(c._getScrollingArrow("right"));if(s){var O=c._getOverflowButton();if(f){O.addStyleClass('sapMBtnInline');}else if(t){O.addStyleClass('sapMBtnTextOnly');}else if(n||h){O.addStyleClass('sapMBtnNoText');}O.addStyleClass("sapMITHVerticallyCenteredArrow");r.renderControl(O);}r.write("</div>");};
return a;},true);
sap.ui.predefine('sap/m/IconTabSeparator',['./library','sap/ui/core/Element','sap/ui/core/Item'],function(l,E,I){"use strict";var a=l.ImageHelper;
var b=E.extend("sap.m.IconTabSeparator",{metadata:{interfaces:["sap.m.IconTab"],library:"sap.m",designtime:"sap/m/designtime/IconTabSeparator.designtime",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},visible:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}}}});
b.prototype._getImageControl=function(c,p){var P={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=a.getImageControl(this.getId()+"-icon",this._oImageControl,p,P,c);return this._oImageControl;};
b.prototype.exit=function(e){if(this._oImageControl){this._oImageControl.destroy();}if(I.prototype.exit){I.prototype.exit.call(this,e);}};
b.prototype.render=function(r){if(!this.getVisible()){return;}var i=this.getIcon(),c=this.getParent(),d=sap.ui.getCore().getLibraryResourceBundle('sap.m'),e='';if(i){e+='role="img" aria-label="'+d.getText("ICONTABBAR_NEXTSTEP")+'"';}else{e+='role="separator"';}r.write('<div '+e+' ');r.writeElementData(this);r.addClass("sapMITBItem");r.addClass("sapMITBSep");if(!i){r.addClass("sapMITBSepLine");}r.writeClasses();r.write(">");if(i){r.renderControl(this._getImageControl(['sapMITBSepIcon'],c));}r.write("</div>");};
b.prototype.renderInSelectList=function(r,s){};
return b;});
sap.ui.predefine('sap/m/Image',['./library','sap/ui/core/Control','sap/ui/base/DataType','./ImageRenderer',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/security/encodeCSS"],function(l,C,D,I,K,q,e){"use strict";var a=l.ImageMode;
var b=C.extend("sap.m.Image",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/Image.designtime",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},useMap:{type:"string",group:"Misc",defaultValue:null},densityAware:{type:"boolean",group:"Misc",defaultValue:false},activeSrc:{type:"sap.ui.core.URI",group:"Data",defaultValue:""},mode:{type:"sap.m.ImageMode",group:"Misc",defaultValue:"Image"},backgroundSize:{type:"string",group:"Appearance",defaultValue:"cover"},backgroundPosition:{type:"string",group:"Appearance",defaultValue:"initial"},backgroundRepeat:{type:"string",group:"Appearance",defaultValue:"no-repeat"}},aggregations:{detailBox:{type:'sap.m.LightBox',multiple:false,bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{},press:{},load:{},error:{}},dnd:{draggable:true,droppable:false}}});
b._currentDevicePixelRatio=(function(){var r=(window.devicePixelRatio===undefined?1:window.devicePixelRatio);if(r<=1){r=1;}else{r*=2;r=Math.round(r);r/=2;}if(r>2){r=2;}return r;}());
b.prototype.onload=function(E){var w,h;if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}this._bVersion2Tried=false;var d=this.$(),o=d[0];if(this.getMode()===a.Background){d.css("background-image","url(\""+e(this._oImage.src)+"\")");}if(!this._isWidthOrHeightSet()){if(this._iLoadImageDensity>1){w=Math.round(o.getBoundingClientRect().width);h=Math.round(o.getBoundingClientRect().height);if((w===o.naturalWidth)&&(h===o.naturalHeight)){d.width(w/this._iLoadImageDensity);}}}d.removeClass("sapMNoImg");this.fireLoad();};
b.prototype.onerror=function(E){if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}var $=this.$(),m=this.getMode(),s=(m===a.Image)?this._getDomImg().attr("src"):this._oImage.src,d=b._currentDevicePixelRatio,c=this._isActiveState?this.getActiveSrc():this.getSrc();$.addClass("sapMNoImg");if(!s||this._iLoadImageDensity===1){if(this.getAlt()&&!this.getDecorative()){$.removeClass("sapMNoImg");}this.fireError();return;}if(d===2||d<1){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(c,1));}else if(d===1.5){if(this._bVersion2Tried){setTimeout(q.proxy(function(){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(c,1));},this),0);}else{setTimeout(q.proxy(function(){this._iLoadImageDensity=2;this._updateDomSrc(this._generateSrcByDensity(c,2));this._bVersion2Tried=true;},this),0);}}};
b.prototype.setDetailBox=function(L){var c=this.getDetailBox();if(L){if(L===c){return this;}if(c){this.detachPress(this._fnLightBoxOpen,c);}this._fnLightBoxOpen=L.open;this.attachPress(this._fnLightBoxOpen,L);}else if(this._fnLightBoxOpen){this.detachPress(this._fnLightBoxOpen,c);this._fnLightBoxOpen=null;}return this.setAggregation("detailBox",L);};
b.prototype.clone=function(){var c=C.prototype.clone.apply(this,arguments),o=c.getDetailBox();if(o){c.detachPress(this._fnLightBoxOpen,this.getDetailBox());c._fnLightBoxOpen=o.open;c.attachPress(c._fnLightBoxOpen,o);}return c;};
b.prototype.onBeforeRendering=function(){this._defaultEventTriggered=false;if(this.getMode()==a.Image){var d=this.getDetailBox()?this.$().find(".sapMImg"):this.$();d.off("load").off("error");}};
b.prototype.onAfterRendering=function(){var d=this.getDetailBox()?this.$().find(".sapMImg"):this.$(),m=this.getMode(),o;if(m===a.Image){d.on("load",q.proxy(this.onload,this));d.on("error",q.proxy(this.onerror,this));o=d[0];}if(m===a.Background){o=this._oImage;}if(o&&o.complete&&!this._defaultEventTriggered){if(o.naturalWidth>0){this.onload({});}else{this.onerror({});}}};
b.prototype.exit=function(){if(this._oImage){q(this._oImage).off("load",this.onload).off("error",this.onerror);this._oImage=null;}else{this.$().off("load",this.onload).off("error",this.onerror);}if(this._fnLightBoxOpen){this._fnLightBoxOpen=null;}};
b.prototype.ontouchstart=function(E){if(E.srcControl.mEventRegistry["press"]||E.srcControl.mEventRegistry["tap"]){E.setMarked();}if(E.targetTouches.length===1&&this.getActiveSrc()){this._updateDomSrc(this._getDensityAwareActiveSrc());this._isActiveState=true;}};
b.prototype.ontouchend=function(E){if(E.targetTouches.length===0&&this.getActiveSrc()){this._isActiveState=false;this._updateDomSrc(this._getDensityAwareSrc());this.$().removeClass("sapMNoImg");}};
b.prototype.attachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")){this.$().attr("tabindex","0");this.$().attr("role","button");}return this;};
b.prototype.detachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")){this.$().removeAttr("tabindex");if(this.getDecorative()){this.$().attr("role","presentation");}else{this.$().removeAttr("role");}}return this;};
b.prototype.ontap=function(E){this.fireTap({});this.firePress({});};
b.prototype.onkeyup=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this.firePress({});E.stopPropagation();}};
b.prototype.onsapspace=function(E){E.preventDefault();};
b.prototype._updateDomSrc=function(s){var d=this.$(),m=this.getMode();if(d.length){if(m===a.Image){this._getDomImg().attr("src",s);}else{d.addClass("sapMNoImg");q(this._oImage).attr("src",s);}}};
b.prototype._getDomImg=function(){var d=this.$();return this.getDetailBox()?d.children("img"):d;};
b.prototype._preLoadImage=function(s){if(this.getMode()!==a.Background){return;}var $=q(this._oImage);if(!this._oImage){this._oImage=new window.Image();$=q(this._oImage);$.on("load",q.proxy(this.onload,this)).on("error",q.proxy(this.onerror,this));}this._oImage.src=s;};
b.prototype._isWidthOrHeightSet=function(){return(this.getWidth()&&this.getWidth()!=='')||(this.getHeight()&&this.getHeight()!=='');};
b.prototype._getDensityAwareSrc=function(){var s=this.getSrc(),c=this.getDensityAware(),d=c?b._currentDevicePixelRatio:1;this._iLoadImageDensity=d;return this._generateSrcByDensity(s,d);};
b.prototype._getDensityAwareActiveSrc=function(){var A=this.getActiveSrc(),c=this.getDensityAware(),d=c?b._currentDevicePixelRatio:1;this._iLoadImageDensity=d;return this._generateSrcByDensity(A,d);};
b.prototype._generateSrcByDensity=function(s,d){if(!s){return"";}if(this._isDataUri(s)){this._iLoadImageDensity=1;return s;}if(d===1){return s;}var L=s.lastIndexOf("."),c=s.lastIndexOf("/"),n=s.substring(0,L),E=s.substring(L);if(L===-1||(c>L)){return s+"@"+d;}n=n+"@"+d;return n+E;};
b.prototype._isDataUri=function(s){return s?s.indexOf("data:")===0:false;};
b.prototype._isValidBackgroundSizeValue=function(v){var w=/\s+/g;v=q.trim(v).replace(w," ");return i(v.split(" "),["auto","cover","contain","initial"])||D.getType("sap.ui.core.CSSSizeShortHand").isValid(v);};
b.prototype._isValidBackgroundPositionValue=function(v){var w=/\s+/g;v=q.trim(v).replace(w," ");return i(v.split(" "),["left","right","top","center","bottom","initial"])||D.getType("sap.ui.core.CSSSizeShortHand").isValid(v);};
b.prototype.getAccessibilityInfo=function(){var h=this.hasListeners("press");if(this.getDecorative()&&!this.getUseMap()&&!h){return null;}return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||"",focusable:h};};
b.prototype.getFocusDomRef=function(){return this.getDomRef("inner")||this.getDomRef();};
b.prototype.getFormDoNotAdjustWidth=function(){return true;};
function i(t,r){function c(T){return r.indexOf(T)<0;}return t&&r&&!t.some(c);}
return b;});
sap.ui.predefine('sap/m/ImageContent',['./library','sap/ui/core/Control','sap/m/Image','sap/ui/core/IconPool','sap/ui/Device','./ImageContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,I,a,D,b,K){"use strict";
var c=C.extend("sap.m.ImageContent",{metadata:{library:"sap.m",properties:{src:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},description:{type:"string",group:"Accessibility",defaultValue:null}},defaultAggregation:"_content",aggregations:{_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{}}}});
c.prototype.onBeforeRendering=function(){var i,u,d;i=this.getAggregation("_content");u=this.getSrc();d=this.getDescription();if(!i||u!==i.getSrc()||d!==i.getAlt()){if(i){i.destroy();i=null;}i=a.createControlByURI({id:this.getId()+"-icon-image",src:u,alt:d,decorative:true},I);this.setAggregation("_content",i,true);this._setPointerOnImage();}if(d){this.setTooltip(d.trim());}};
c.prototype._setPointerOnImage=function(){var i=this.getAggregation("_content");if(i&&this.hasListeners("press")){i.addStyleClass("sapMPointer");}else if(i&&i.hasStyleClass("sapMPointer")){i.removeStyleClass("sapMPointer");}};
c.prototype.ontap=function(e){if(D.browser.msie){this.$().focus();}this.firePress();};
c.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
c.prototype.attachEvent=function(e,d,f,g){C.prototype.attachEvent.call(this,e,d,f,g);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnImage();}return this;};
c.prototype.detachEvent=function(e,f,d){C.prototype.detachEvent.call(this,e,f,d);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnImage();}return this;};
c.prototype.getAltText=function(){var o=this.getAggregation("_content");if(o&&o.getAlt()!==""){return o.getAlt();}else if(o&&o.getAccessibilityInfo()){return o.getAccessibilityInfo().description;}else{return"";}};
return c;});
sap.ui.predefine('sap/m/ImageContentRenderer',[],function(){"use strict";var I={};
I.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMImageContent");var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(c.hasListeners("press")){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}r.writeClasses();r.write(">");var C=c.getAggregation("_content");if(C){C.addStyleClass("sapMImageContentImageIcon");r.renderControl(C);}r.write("</div>");};
return I;},true);
sap.ui.predefine('sap/m/ImageRenderer',['sap/m/library',"sap/base/security/encodeCSS"],function(l,e){"use strict";var I=l.ImageMode;var a={apiVersion:2};
a.render=function(r,i){var m=i.getMode(),b=i.getAlt(),t=i.getTooltip_AsString(),h=i.hasListeners("press"),L=i.getDetailBox(),u=i.getUseMap(),c=i.getAriaLabelledBy(),d=i.getAriaDescribedBy(),f=m===I.Image;if(L){r.openStart("span",i);r.class("sapMLightBoxImage");r.openEnd();r.openStart("span").class("sapMLightBoxMagnifyingGlass").openEnd().close("span");}if(f){r.voidStart("img",!L?i:i.getId()+"-inner");}else{r.openStart("span",!L?i:i.getId()+"-inner");}if(!i.getDecorative()&&c&&c.length>0){r.attr("aria-labelledby",c.join(" "));}if(!i.getDecorative()&&d&&d.length>0){r.attr("aria-describedby",d.join(" "));}if(f){r.attr("src",i._getDensityAwareSrc());}else{i._preLoadImage(i._getDensityAwareSrc());if(i._isValidBackgroundSizeValue(i.getBackgroundSize())){r.style("background-size",i.getBackgroundSize());}if(i._isValidBackgroundPositionValue(i.getBackgroundPosition())){r.style("background-position",i.getBackgroundPosition());}r.style("background-repeat",e(i.getBackgroundRepeat()));}r.class("sapMImg");if(i.hasListeners("press")||i.hasListeners("tap")){r.class("sapMPointer");}if(u||!i.getDecorative()||h){r.class("sapMImgFocusable");}if(u){if(!(u.startsWith("#"))){u="#"+u;}r.attr("usemap",u);}if(i.getDecorative()&&!u&&!h){r.attr("role","presentation");r.attr("aria-hidden","true");r.attr("alt","");}else if(b||t){r.attr("alt",b||t);}if(b||t){r.attr("aria-label",b||t);}if(t){r.attr("title",t);}if(h){r.attr("role","button");r.attr("tabindex",0);}r.style("width",i.getWidth());r.style("height",i.getHeight());f?r.voidEnd():r.openEnd().close("span");if(L){r.close("span");}};
return a;},true);
sap.ui.predefine('sap/m/Input',['./InputBase','./Popover','sap/ui/core/Item','./ColumnListItem','./GroupHeaderListItem','./DisplayListItem','./StandardListItem','sap/ui/core/SeparatorItem','./List','./Table','./library','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/Control','./SuggestionsPopover','./Toolbar','./ToolbarSpacer','./Button',"sap/ui/dom/containsOrEquals","sap/base/assert","sap/base/util/deepEqual","./InputRenderer","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/selectText"],function(I,P,a,C,G,D,S,b,L,T,l,c,d,e,f,g,h,B,j,k,m,n,q){"use strict";var o=l.ListType;var p=l.InputTextFormatMode;var r=l.InputType;
var s=I.extend("sap.m.Input",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.InputType",group:"Data",defaultValue:r.Text},maxLength:{type:"int",group:"Behavior",defaultValue:0},dateFormat:{type:"string",group:"Misc",defaultValue:'YYYY-MM-dd',deprecated:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:false},showSuggestion:{type:"boolean",group:"Behavior",defaultValue:false},valueHelpOnly:{type:"boolean",group:"Behavior",defaultValue:false},filterSuggests:{type:"boolean",group:"Behavior",defaultValue:true},maxSuggestionWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},startSuggestion:{type:"int",group:"Behavior",defaultValue:1},showTableSuggestionValueHelp:{type:"boolean",group:"Behavior",defaultValue:true},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},selectedKey:{type:"string",group:"Data",defaultValue:""},textFormatMode:{type:"sap.m.InputTextFormatMode",group:"Misc",defaultValue:p.Value},textFormatter:{type:"any",group:"Misc",defaultValue:""},suggestionRowValidator:{type:"any",group:"Misc",defaultValue:""},enableSuggestionsHighlighting:{type:"boolean",group:"Behavior",defaultValue:true},autocomplete:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"suggestionItems",aggregations:{suggestionItems:{type:"sap.ui.core.Item",multiple:true,singularName:"suggestionItem"},suggestionColumns:{type:"sap.m.Column",multiple:true,singularName:"suggestionColumn",bindable:"bindable",forwarding:{getter:"_getSuggestionsTable",aggregation:"columns"}},suggestionRows:{type:"sap.m.ColumnListItem",altTypes:["sap.m.GroupHeaderListItem"],multiple:true,singularName:"suggestionRow",bindable:"bindable",forwarding:{getter:"_getSuggestionsTable",aggregation:"items"}},_suggestionPopup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_valueHelpIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},selectedRow:{type:"sap.m.ColumnListItem",multiple:false}},events:{liveChange:{parameters:{value:{type:"string"},escPressed:{type:"boolean"},previousValue:{type:"string"}}},valueHelpRequest:{parameters:{fromSuggestions:{type:"boolean"}}},suggest:{parameters:{suggestValue:{type:"string"},suggestionColumns:{type:"sap.m.ListBase"}}},suggestionItemSelected:{parameters:{selectedItem:{type:"sap.ui.core.Item"},selectedRow:{type:"sap.m.ColumnListItem"}}},submit:{parameters:{value:{type:"string"}}}},designtime:"sap/m/designtime/Input.designtime"}});
c.insertFontFaceStyle();
s.prototype.init=function(){I.prototype.init.call(this);this._fnFilter=f._DEFAULTFILTER;this._bUseDialog=d.system.phone;this._bFullScreen=d.system.phone;this._iSetCount=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");};
s.prototype.exit=function(){I.prototype.exit.call(this);this._deregisterEvents();this.cancelPendingSuggest();if(this._iRefreshListTimeout){clearTimeout(this._iRefreshListTimeout);this._iRefreshListTimeout=null;}if(this._oSuggPopover){this._oSuggPopover.destroy();this._oSuggPopover=null;}if(this._oShowMoreButton){this._oShowMoreButton.destroy();this._oShowMoreButton=null;}if(this._oButtonToolbar){this._oButtonToolbar.destroy();this._oButtonToolbar=null;}};
s.prototype.onBeforeRendering=function(){var i=this.getSelectedKey(),t=this.getShowValueHelp()&&this.getEnabled()&&this.getEditable(),E=this.getAggregation("_endIcon")||[],u=E[0],v;I.prototype.onBeforeRendering.call(this);this._deregisterEvents();if(i){this.setSelectedKey(i);}if(this.getShowSuggestion()){this._oSuggPopover._bAutocompleteEnabled=this.getAutocomplete();if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}else{this._removeShowMoreButton();}v=this._oSuggPopover._oPopupInput;if(v){v.setType(this.getType());}}if(t){u=this._getValueHelpIcon();u.setProperty("visible",true,true);}else{if(u){u.setProperty("visible",false,true);}}};
s.prototype.onAfterRendering=function(){I.prototype.onAfterRendering.call(this);if(this._oSuggPopover){this._oSuggPopover._resetTypeAhead();}if(this._bUseDialog&&this.getEditable()&&this.getEnabled()){this.$().on("click",q.proxy(function(E){if(this._onclick){this._onclick(E);}if(this.getShowSuggestion()&&this._oSuggPopover&&E.target.id!=this.getId()+"-vhi"){this._openSuggestionsPopover();}},this));}};
s.prototype._getDisplayText=function(i){var t=this.getTextFormatter();if(t){return t(i);}var u=i.getText(),K=i.getKey(),v=this.getTextFormatMode();switch(v){case p.Key:return K;case p.ValueKey:return u+' ('+K+')';case p.KeyValue:return'('+K+') '+u;default:return u;}};
s.prototype._onValueUpdated=function(i){if(this._bSelectingItem||i===this._sSelectedValue){return;}var K=this.getSelectedKey(),H;if(K===''){return;}if(this._hasTabularSuggestions()){H=this._oSuggPopover._oSuggestionTable&&!!this._oSuggPopover._oSuggestionTable.getSelectedItem();}else{H=this._oSuggPopover._oList&&!!this._oSuggPopover._oList.getSelectedItem();}if(H){return;}this.setProperty("selectedKey",'',true);this.setAssociation("selectedRow",null,true);this.setAssociation("selectedItem",null,true);this.fireSuggestionItemSelected({selectedItem:null,selectedRow:null});};
s.prototype._updateSelectionFromList=function(){if(this._oSuggPopover._iPopupListSelectedIndex<0){return false;}var i=this._oSuggPopover._oList.getSelectedItem();if(i){if(this._hasTabularSuggestions()){this.setSelectionRow(i,true);}else{this.setSelectionItem(i._oItem,true);}}return true;};
s.prototype.setSelectionItem=function(i,t){this._bSelectingItem=true;if(!i){this.setAssociation("selectedItem",null,true);this.setValue('');return;}this._oSuggPopover._iPopupListSelectedIndex=-1;var u=this._iSetCount,N;this.setAssociation("selectedItem",i,true);this.setProperty("selectedKey",i.getKey(),true);if(t){this.fireSuggestionItemSelected({selectedItem:i});}if(u!==this._iSetCount){N=this.getValue();}else{N=this._getDisplayText(i);}this._sSelectedValue=N;this.updateInputField(N);if(this.bIsDestroyed){return;}if(!(this._bUseDialog&&this instanceof sap.m.MultiInput)){this._closeSuggestionPopup();}this._bSelectingItem=false;};
s.prototype.addSuggestionRowGroup=function(i,H,t){H=H||new G({title:i.text||i.key});this.addAggregation("suggestionRows",H,t);return H;};
s.prototype.addSuggestionItemGroup=function(i,H,t){H=H||new b({text:i.text||i.key});this.addAggregation("suggestionItems",H,t);return H;};
s.prototype.setSelectedItem=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(i!==null&&!(i instanceof a)){return this;}this.setSelectionItem(i);return this;};
s.prototype.setSelectedKey=function(K){K=this.validateProperty("selectedKey",K);this.setProperty("selectedKey",K,true);if(this._hasTabularSuggestions()){return this;}if(!K){this.setSelectionItem();return this;}var i=this.getSuggestionItemByKey(K);this.setSelectionItem(i);return this;};
s.prototype.getSuggestionItemByKey=function(K){var t=this.getSuggestionItems()||[],u,i;for(i=0;i<t.length;i++){u=t[i];if(u.getKey()===K){return u;}}};
s.prototype.setSelectionRow=function(i,t){if(!i){this.setAssociation("selectedRow",null,true);return;}this._oSuggPopover._iPopupListSelectedIndex=-1;this._bSelectingItem=true;var u,v=this.getSuggestionRowValidator();if(v){u=v(i);if(!(u instanceof a)){u=null;}}var w=this._iSetCount,K="",N;this.setAssociation("selectedRow",i,true);if(u){K=u.getKey();}this.setProperty("selectedKey",K,true);if(t){this.fireSuggestionItemSelected({selectedRow:i});}if(w!==this._iSetCount){N=this.getValue();}else{if(u){N=this._getDisplayText(u);}else{N=this._fnRowResultFilter?this._fnRowResultFilter(i):f._DEFAULTRESULT_TABULAR(i);}}this._sSelectedValue=N;this.updateInputField(N);if(this.bIsDestroyed){return;}if(!(this._bUseDialog&&this instanceof sap.m.MultiInput&&this._isMultiLineMode)){this._closeSuggestionPopup();}this._bSelectingItem=false;};
s.prototype.setSelectedRow=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(i!==null&&!(i instanceof C)){return this;}this.setSelectionRow(i);return this;};
s.prototype._getValueHelpIcon=function(){var t=this,E=this.getAggregation("_endIcon")||[],v=E[0];if(!v){v=this.addEndIcon({id:this.getId()+"-vhi",src:c.getIconURI("value-help"),useIconTooltip:false,noTabStop:true,press:function(i){if(!t.getValueHelpOnly()){var u=this.getParent(),$;if(d.support.touch){$=u.$('inner');$.attr('readonly','readonly');u.focus();$.removeAttr('readonly');}else{u.focus();}t.bValueHelpRequested=true;t.fireValueHelpRequest({fromSuggestions:false});}}});}return v;};
s.prototype._fireValueHelpRequestForValueHelpOnly=function(){if(this.getEnabled()&&this.getEditable()&&this.getShowValueHelp()&&this.getValueHelpOnly()){if(d.system.phone){this.focus();}this.fireValueHelpRequest({fromSuggestions:false});}};
s.prototype.ontap=function(E){I.prototype.ontap.call(this,E);this._fireValueHelpRequestForValueHelpOnly();};
s.prototype.setWidth=function(w){return I.prototype.setWidth.call(this,w||"100%");};
s.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
s.prototype.setFilterFunction=function(F){if(F===null||F===undefined){this._fnFilter=f._DEFAULTFILTER;return this;}k(typeof(F)==="function","Input.setFilterFunction: first argument fnFilter must be a function on "+this);this._fnFilter=F;return this;};
s.prototype.setRowResultFunction=function(F){var i;if(F===null||F===undefined){this._fnRowResultFilter=f._DEFAULTRESULT_TABULAR;return this;}k(typeof(F)==="function","Input.setRowResultFunction: first argument fnFilter must be a function on "+this);this._fnRowResultFilter=F;i=this.getSelectedRow();if(i){this.setSelectedRow(i);}return this;};
s.prototype.closeSuggestions=function(){this._closeSuggestionPopup();};
s.prototype._doSelect=function(i,E){if(d.support.touch){return;}var t=this._$input[0];if(t){var R=this._$input;t.focus();R.selectText(i?i:0,E?E:R.val().length);}return this;};
s.prototype._isIncrementalType=function(){var t=this.getType();if(t==="Number"||t==="Date"||t==="Datetime"||t==="Month"||t==="Time"||t==="Week"){return true;}return false;};
s.prototype.onsapescape=function(E){var i;if(this._isSuggestionsPopoverOpen()){E.originalEvent._sapui_handledByControl=true;this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();if(this._sBeforeSuggest!==undefined){if(this._sBeforeSuggest!==this.getValue()){i=this._lastValue;this.setValue(this._sBeforeSuggest);this._lastValue=i;}this._sBeforeSuggest=undefined;}return;}if(this.getValueLiveUpdate()){this.setProperty("value",this._lastValue,true);}if(I.prototype.onsapescape){I.prototype.onsapescape.apply(this,arguments);}};
s.prototype.onsapenter=function(E){this.cancelPendingSuggest();if(this._isSuggestionsPopoverOpen()){if(!this._updateSelectionFromList()&&!this.isComposingCharacter()){this._closeSuggestionPopup();}}if(I.prototype.onsapenter){I.prototype.onsapenter.apply(this,arguments);}if(this.getEnabled()&&this.getEditable()&&!(this.getValueHelpOnly()&&this.getShowValueHelp())){this.fireSubmit({value:this.getValue()});}};
s.prototype.onsapfocusleave=function(E){var i=this._oSuggPopover,t=i&&i._oPopover,F=E.relatedControlId&&sap.ui.getCore().byId(E.relatedControlId),u=F&&F.getFocusDomRef(),H=i&&i._sProposedItemText&&this.getAutocomplete(),v=t&&u&&j(t.getDomRef(),u);if(t instanceof P){if(v){this._bPopupHasFocus=true;if(d.system.desktop&&m(t.getFocusDomRef(),u)){this.focus();}}else{if(this.getDOMValue()===this._sSelectedSuggViaKeyboard){this._sSelectedSuggViaKeyboard=null;}}}if(!v&&!H){I.prototype.onsapfocusleave.apply(this,arguments);}this.bValueHelpRequested=false;};
s.prototype.onmousedown=function(E){var i=this._oSuggPopover&&this._oSuggPopover._oPopover;if((i instanceof P)&&i.isOpen()){E.stopPropagation();}};
s.prototype._deregisterEvents=function(){if(this._oSuggPopover){this._oSuggPopover._deregisterResize();}if(this._bUseDialog&&this._oSuggPopover&&this._oSuggPopover._oPopover){this.$().off("click");}};
s.prototype.updateSuggestionItems=function(){this._bSuspendInvalidate=true;this.updateAggregation("suggestionItems");this._synchronizeSuggestions();this._bSuspendInvalidate=false;return this;};
s.prototype.invalidate=function(){if(!this._bSuspendInvalidate){e.prototype.invalidate.apply(this,arguments);}};
s.prototype.cancelPendingSuggest=function(){if(this._iSuggestDelay){clearTimeout(this._iSuggestDelay);this._iSuggestDelay=null;}};
s.prototype._triggerSuggest=function(v){this.cancelPendingSuggest();this._bShouldRefreshListItems=true;if(!v){v="";}if(v.length>=this.getStartSuggestion()){this._iSuggestDelay=setTimeout(function(){if(this._sPrevSuggValue!==v){this._bBindingUpdated=false;this.fireSuggest({suggestValue:v});if(!this._bBindingUpdated){this._refreshItemsDelayed();}this._sPrevSuggValue=v;}}.bind(this),300);}else if(this._bUseDialog){if(this._oSuggPopover._oList instanceof T){this._oSuggPopover._oList.addStyleClass("sapMInputSuggestionTableHidden");}else if(this._oSuggPopover._oList&&this._oSuggPopover._oList.destroyItems){this._oSuggPopover._oList.destroyItems();}}else if(this._isSuggestionsPopoverOpen()){setTimeout(function(){var N=this.getDOMValue()||'';if(N<this.getStartSuggestion()){this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}}.bind(this),0);}};
(function(){
s.prototype.setShowSuggestion=function(v){this.setProperty("showSuggestion",v,true);if(v){this._oSuggPopover=this._getSuggestionsPopover();this._oSuggPopover._iPopupListSelectedIndex=-1;if(!this._oSuggPopover._oPopover){this._createSuggestionsPopoverPopup();this._synchronizeSuggestions();this._createSuggestionPopupContent();}}else{if(this._oSuggPopover){this._oSuggPopover._destroySuggestionPopup();this._oSuggPopover._iPopupListSelectedIndex=-1;}}return this;};
s.prototype.setShowTableSuggestionValueHelp=function(v){this.setProperty("showTableSuggestionValueHelp",v,true);if(!(this._oSuggPopover&&this._oSuggPopover._oPopover)){return this;}if(v){this._addShowMoreButton();}else{this._removeShowMoreButton();}return this;};
s.prototype.oninput=function(E){I.prototype.oninput.call(this,E);if(E.isMarked("invalid")){return;}var v=this.getDOMValue();if(this.getValueLiveUpdate()){this.setProperty("value",v,true);this._onValueUpdated(v);}this.fireLiveChange({value:v,newValue:v});if(this.getShowSuggestion()&&!this._bUseDialog){this._triggerSuggest(v);}};
s.prototype.getValue=function(){return this.getDomRef("inner")&&this._$input?this.getDOMValue():this.getProperty("value");};
s.prototype._refreshItemsDelayed=function(){clearTimeout(this._iRefreshListTimeout);this._iRefreshListTimeout=setTimeout(function(){if(this._oSuggPopover){this._refreshListItems();}}.bind(this),0);};
s.prototype._filterListItems=function(t,u){var i,v,w,x=[],H=[],F=this.getFilterSuggests(),y=false;for(i=0;i<t.length;i++){w=t[i];if(t[i].isA("sap.ui.core.SeparatorItem")){v=new G({id:w.getId()+"-ghli",title:t[i].getText()});x.push({header:v,visible:false});this._configureListItem(w,v);H.push(v);}else if(!F||this._fnFilter(u,w)){if(t[i].isA("sap.ui.core.ListItem")){v=new D(w.getId()+"-dli");v.setLabel(w.getText());v.setValue(w.getAdditionalText());}else{v=new S(w.getId()+"-sli");v.setTitle(w.getText());}if(!y&&(this._oSuggPopover._sProposedItemText===t[i].getText())){v.setSelected(true);y=true;}if(x.length){x[x.length-1].visible=true;}this._configureListItem(w,v);H.push(v);}}x.forEach(function(z){z.header.setVisible(z.visible);});return{hitItems:H,groups:x};};
s.prototype._filterTabularItems=function(t,u){var i,v,F=this.getFilterSuggests(),H=[],w=[],x=false;for(i=0;i<t.length;i++){if(t[i].isA("sap.m.GroupHeaderListItem")){w.push({header:t[i],visible:false});}else{v=!F||this._fnFilter(u,t[i]);t[i].setVisible(v);v&&H.push(t[i]);if(!x&&v&&this._oSuggPopover._sProposedItemText===this._fnRowResultFilter(t[i])){t[i].setSelected(true);x=true;}if(w.length&&v){w[w.length-1].visible=true;}}}w.forEach(function(y){y.header.setVisible(y.visible);});this._getSuggestionsTable().invalidate();return{hitItems:H,groups:w};};
s.prototype._clearSuggestionPopupItems=function(){if(!this._oSuggPopover._oList){return;}if(this._oSuggPopover._oList instanceof T){this._oSuggPopover._oList.removeSelections(true);}else{this._oSuggPopover._oList.destroyItems();}};
s.prototype._hideSuggestionPopup=function(){var i=this._oSuggPopover._oPopover;if(!this._bUseDialog){if(i.isOpen()){this._sCloseTimer=setTimeout(function(){this._oSuggPopover._iPopupListSelectedIndex=-1;this.cancelPendingSuggest();if(this._oSuggPopover._sTypedInValue){this.setDOMValue(this._oSuggPopover._sTypedInValue);}this._oSuggPopover._oProposedItem=null;i.close();}.bind(this),0);}}else if(this._hasTabularSuggestions()&&this._oSuggPopover._oList){this._oSuggPopover._oList.addStyleClass("sapMInputSuggestionTableHidden");}this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-haspopup");this.$("inner").removeAttr("aria-activedescendant");};
s.prototype._openSuggestionPopup=function(O){var i=this._oSuggPopover._oPopover;if(!this._bUseDialog){if(this._sCloseTimer){clearTimeout(this._sCloseTimer);this._sCloseTimer=null;}if(!i.isOpen()&&!this._sOpenTimer&&O!==false){this._sOpenTimer=setTimeout(function(){this._sOpenTimer=null;this._openSuggestionsPopover();}.bind(this),0);}}this.$("inner").attr("aria-haspopup","true");};
s.prototype._getFilteredSuggestionItems=function(t){var F,i=this.getSuggestionItems(),u=this.getSuggestionRows();if(this._hasTabularSuggestions()){if(this._bUseDialog&&this._oSuggPopover._oList){this._oSuggPopover._oList.removeStyleClass("sapMInputSuggestionTableHidden");}F=this._filterTabularItems(u,t);}else{F=this._filterListItems(i,t);}return F;};
s.prototype._fillSimpleSuggestionPopupItems=function(F){var i,H=F.hitItems,t=F.groups,u=H.length,v=u;if(!this._hasTabularSuggestions()){for(i=0;i<u;i++){this._oSuggPopover._oList.addItem(H[i]);}v-=t.length;}return v;};
s.prototype._applySuggestionAcc=function(N){var A="",R=this._oRb;if(N===1){A=R.getText("INPUT_SUGGESTIONS_ONE_HIT");}else if(N>1){A=R.getText("INPUT_SUGGESTIONS_MORE_HITS",N);}else{A=R.getText("INPUT_SUGGESTIONS_NO_HIT");}this.$("SuggDescr").text(A);};
s.prototype._refreshListItems=function(){var i=this.getShowSuggestion(),t=this._oSuggPopover._sTypedInValue||this.getDOMValue()||"",F,u;this._oSuggPopover._iPopupListSelectedIndex=-1;if(!i||!this._bShouldRefreshListItems||!this.getDomRef()||(!this._bUseDialog&&!this.$().hasClass("sapMInputFocused"))){return null;}this._clearSuggestionPopupItems();if(t.length<this.getStartSuggestion()){this._hideSuggestionPopup();return false;}F=this._getFilteredSuggestionItems(t);u=this._fillSimpleSuggestionPopupItems(F);if(u>0){this._openSuggestionPopup(this.getValue().length>=this.getStartSuggestion());}else{this._hideSuggestionPopup();}this._applySuggestionAcc(u);};
s.prototype._configureListItem=function(i,t){var u=o.Active;if(!i.getEnabled()||t.isA("sap.m.GroupHeaderListItem")){u=o.Inactive;}t.setType(u);t._oItem=i;t.addEventDelegate({ontouchstart:function(E){(E.originalEvent||E)._sapui_cancelAutoClose=true;}});return t;};
s.prototype.addSuggestionItem=function(i){this.addAggregation("suggestionItems",i,true);if(!this._oSuggPopover){this._getSuggestionsPopover();}this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
s.prototype.insertSuggestionItem=function(i,t){this.insertAggregation("suggestionItems",t,i,true);if(!this._oSuggPopover){this._getSuggestionsPopover();}this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
s.prototype.removeSuggestionItem=function(i){var t=this.removeAggregation("suggestionItems",i,true);this._synchronizeSuggestions();return t;};
s.prototype.removeAllSuggestionItems=function(){var i=this.removeAllAggregation("suggestionItems",true);this._synchronizeSuggestions();return i;};
s.prototype.destroySuggestionItems=function(){this.destroyAggregation("suggestionItems",true);this._synchronizeSuggestions();return this;};
s.prototype.addSuggestionRow=function(i){i.setType(o.Active);this.addAggregation("suggestionRows",i);this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
s.prototype.insertSuggestionRow=function(i,t){i.setType(o.Active);this.insertAggregation("suggestionRows",i,t);this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
s.prototype.removeSuggestionRow=function(i){var t=this.removeAggregation("suggestionRows",i);this._synchronizeSuggestions();return t;};
s.prototype.removeAllSuggestionRows=function(){var i=this.removeAllAggregation("suggestionRows");this._synchronizeSuggestions();return i;};
s.prototype.destroySuggestionRows=function(){this.destroyAggregation("suggestionRows");this._synchronizeSuggestions();return this;};
s.prototype.bindAggregation=function(){if(arguments[0]==="suggestionRows"||arguments[0]==="suggestionColumns"||arguments[0]==="suggestionItems"){this._createSuggestionPopupContent(arguments[0]==="suggestionRows"||arguments[0]==="suggestionColumns");this._bBindingUpdated=true;}return I.prototype.bindAggregation.apply(this,arguments);};
s.prototype._closeSuggestionPopup=function(){if(this._oSuggPopover){this._bShouldRefreshListItems=false;this.cancelPendingSuggest();this._oSuggPopover._oPopover.close();if(!this._bUseDialog&&this.$().hasClass("sapMInputFocused")){this.openValueStateMessage();}this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-haspopup");this.$("inner").removeAttr("aria-activedescendant");this._sPrevSuggValue=null;}};
s.prototype._synchronizeSuggestions=function(){this._bShouldRefreshListItems=true;this._refreshItemsDelayed();if(!this.getDomRef()||this._isSuggestionsPopoverOpen()){return;}this._synchronizeSelection();};
s.prototype._synchronizeSelection=function(){var i=this.getSelectedKey();if(!i){return;}if(this.getValue()&&!this.getSelectedItem()&&!this.getSelectedRow()){return;}this.setSelectedKey(i);};
})();
s.prototype.onfocusin=function(E){I.prototype.onfocusin.apply(this,arguments);this.addStyleClass("sapMInputFocused");if(!this._bUseDialog&&this._isSuggestionsPopoverOpen()){this.closeValueStateMessage();}if(!this._bPopupHasFocus&&!this.getStartSuggestion()&&!this.getValue()&&this.getShowSuggestion()){this._triggerSuggest(this.getValue());}this._bPopupHasFocus=undefined;this._sPrevSuggValue=null;};
s.prototype.oncompositionend=function(E){I.prototype.oncompositionend.apply(this,arguments);if(this._oSuggPopover&&!d.browser.edge&&!d.browser.firefox){this._oSuggPopover._handleTypeAhead();}};
s.prototype.onsapshow=function(E){if(!this.getEnabled()||!this.getEditable()||!this.getShowValueHelp()){return;}this.bValueHelpRequested=true;this.fireValueHelpRequest({fromSuggestions:false});E.preventDefault();E.stopPropagation();};
s.prototype.onsaphide=s.prototype.onsapshow;
s.prototype.onsapselect=function(E){this._fireValueHelpRequestForValueHelpOnly();};
s.prototype.onfocusout=function(E){I.prototype.onfocusout.apply(this,arguments);this.removeStyleClass("sapMInputFocused");this.closeValueStateMessage(this);this.$("SuggDescr").text("");};
s.prototype._hasTabularSuggestions=function(){return!!(this.getAggregation("suggestionColumns")&&this.getAggregation("suggestionColumns").length);};
s.prototype._getSuggestionsTable=function(){return this._getSuggestionsPopover()._getSuggestionsTable();};
s.prototype.clone=function(){var i=e.prototype.clone.apply(this,arguments),t;t=this.getBindingInfo("suggestionColumns");if(t){i.bindAggregation("suggestionColumns",q.extend({},t));}t=this.getBindingInfo("suggestionRows");if(t){i.bindAggregation("suggestionRows",q.extend({},t));}i.setRowResultFunction(this._fnRowResultFilter);i.setValue(this.getValue());return i;};
s.prototype.setValue=function(v){this._iSetCount++;I.prototype.setValue.call(this,v);this._onValueUpdated(v);return this;};
s.prototype.setDOMValue=function(v){this._$input.val(v);};
s.prototype.getDOMValue=function(){return this._$input.val();};
s.prototype.updateInputField=function(N){if(this._isSuggestionsPopoverOpen()&&this._bUseDialog){this._oSuggPopover._oPopupInput.setValue(N);this._oSuggPopover._oPopupInput._doSelect();}else{N=this._getInputValue(N);this.setDOMValue(N);this.onChange(null,null,N);}};
s.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.description=((i.description||"")+" "+this.getDescription()).trim();return i;};
s.prototype.preventChangeOnFocusLeave=function(E){return this.bFocusoutDueRendering||this.bValueHelpRequested;};
s.prototype._getShowMoreButton=function(){return this._oShowMoreButton||(this._oShowMoreButton=new B({text:this._oRb.getText("INPUT_SUGGESTIONS_SHOW_ALL"),press:function(){if(this.getShowTableSuggestionValueHelp()){if(this._oSuggPopover._sTypedInValue){this.updateDomValue(this._oSuggPopover._sTypedInValue);this._oSuggPopover._resetTypeAhead();}this.fireValueHelpRequest({fromSuggestions:true});this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}}.bind(this)}));};
s.prototype._addShowMoreButton=function(t){var i=this._oSuggPopover&&this._oSuggPopover._oPopover;if(!i||!t&&!this._hasTabularSuggestions()){return;}if(i.isA("sap.m.Dialog")){var u=this._getShowMoreButton();i.setEndButton(u);}else{var v=this._getButtonToolbar();i.setFooter(v);}};
s.prototype._removeShowMoreButton=function(){var i=this._oSuggPopover&&this._oSuggPopover._oPopover;if(!i||!this._hasTabularSuggestions()){return;}if(i.isA("sap.m.Dialog")){i.setEndButton(null);}else{i.setFooter(null);}};
s.prototype._getButtonToolbar=function(){var i=this._getShowMoreButton();return this._oButtonToolbar||(this._oButtonToolbar=new g({content:[new h(),i]}));};
s.prototype._hasShowSelectedButton=function(){return false;};
s.prototype._createSuggestionPopupContent=function(t){if(this._bIsBeingDestroyed||this._getSuggestionsPopover()._oList){return;}this._oSuggPopover._createSuggestionPopupContent(t,this._hasTabularSuggestions());if(!this._hasTabularSuggestions()&&!t){this._oSuggPopover._oList.attachItemPress(function(E){if(d.system.desktop){this.focus();}var i=E.getParameter("listItem");if(!i.isA("sap.m.GroupHeaderListItem")){this._oSuggPopover._bSuggestionItemTapped=true;this.setSelectionItem(i._oItem,true);}},this);}else{if(this._fnFilter===f._DEFAULTFILTER){this._fnFilter=f._DEFAULTFILTER_TABULAR;}if(!this._fnRowResultFilter){this._fnRowResultFilter=f._DEFAULTRESULT_TABULAR;}if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton(t);}}};
s.prototype._createPopupInput=function(){var i=new s(this.getId()+"-popup-input",{width:"100%",valueLiveUpdate:true,showValueStateMessage:false,valueState:this.getValueState(),showValueHelp:this.getShowValueHelp(),valueHelpRequest:function(E){this.fireValueHelpRequest({fromSuggestions:true});this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}.bind(this),liveChange:function(E){var v=E.getParameter("newValue");this.setDOMValue(this._getInputValue(this._oSuggPopover._oPopupInput.getValue()));this._triggerSuggest(v);this.fireLiveChange({value:v,newValue:v});}.bind(this)});return i;};
s.prototype._modifyPopupInput=function(i){i.addEventDelegate({onsapenter:function(){if(this.getAutocomplete()){this._oSuggPopover._finalizeAutocomplete();}this._closeSuggestionPopup();}},this);return i;};
s.prototype.forwardEventHandlersToSuggPopover=function(i){i.setOkPressHandler(this._closeSuggestionPopup.bind(this));i.setCancelPressHandler(this._closeSuggestionPopup.bind(this));};
s.prototype._getSuggestionsPopover=function(){if(!this._oSuggPopover){var i=this._oSuggPopover=new f(this);if(this._bUseDialog){var t=this._createPopupInput();i._oPopupInput=this._modifyPopupInput(t);}this._oSuggPopover.setInputLabels(this.getLabels.bind(this));this._createSuggestionsPopoverPopup();this.forwardEventHandlersToSuggPopover(i);this._updateSuggestionsPopoverValueState();i._bAutocompleteEnabled=this.getAutocomplete();i.attachEvent(f.M_EVENTS.SELECTION_CHANGE,function(E){var N=E.getParameter("newValue");this.setDOMValue(N);this._sSelectedSuggViaKeyboard=N;this._doSelect();},this);if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}}return this._oSuggPopover;};
s.prototype._createSuggestionsPopoverPopup=function(){if(!this._oSuggPopover){return;}var i=this._oSuggPopover;i._createSuggestionPopup({showSelectedButton:this._hasShowSelectedButton()});var t=i._oPopover;if(this._bUseDialog){t.attachBeforeClose(function(){this.setDOMValue(this._getInputValue(i._oPopupInput.getValue()));this.onChange();if(this instanceof sap.m.MultiInput&&this._bUseDialog){this._onDialogClose();}},this).attachAfterClose(function(){var u=i._oList;if(!u){return;}if(T&&!(u instanceof T)){u.destroyItems();}else{u.removeSelections(true);}}).attachAfterOpen(function(){this._triggerSuggest(this.getValue());this._refreshListItems();},this).attachBeforeOpen(function(){i._oPopupInput.setPlaceholder(this.getPlaceholder());i._oPopupInput.setMaxLength(this.getMaxLength());i._oPopupInput.setValue(this.getValue());},this);}else{t.attachAfterClose(function(){this._updateSelectionFromList();var u=i._oList;if(u instanceof T){u.removeSelections(true);}else{u.destroyItems();}i._deregisterResize();},this).attachBeforeOpen(function(){i._sPopoverContentWidth=this.getMaxSuggestionWidth();i._bEnableHighlighting=this.getEnableSuggestionsHighlighting();i._bAutocompleteEnabled=this.getAutocomplete();i._bIsInputIncrementalType=this._isIncrementalType();this._sBeforeSuggest=this.getValue();i._resizePopup();i._registerResize();},this);}this.setAggregation("_suggestionPopup",t);this._oSuggestionPopup=t;};
s.prototype.showItems=function(F){var i,t,u=this._fnFilter;if(!this.getEnabled()||!this.getEditable()){return;}this.setFilterFunction(F||function(){return true;});this._clearSuggestionPopupItems();i=this._getFilteredSuggestionItems(this.getDOMValue());t=this._fillSimpleSuggestionPopupItems(i);if(t>0){this._openSuggestionPopup();}else{this._hideSuggestionPopup();}this._applySuggestionAcc(t);this.setFilterFunction(u);};
s.prototype.shouldValueStateMessageBeOpened=function(){var i=I.prototype.shouldValueStateMessageBeOpened.apply(this,arguments);if(!i||this._isSuggestionsPopoverOpen()){return false;}return true;};
s.prototype._isSuggestionsPopoverOpen=function(){return this._oSuggPopover&&this._oSuggPopover.isOpen();};
s.prototype._openSuggestionsPopover=function(){this.closeValueStateMessage();this._updateSuggestionsPopoverValueState();this._oSuggPopover._oPopover.open();};
s.prototype._updateSuggestionsPopoverValueState=function(){var i=this._oSuggPopover,v=this.getValueState();if(i){i.updateValueState(v,this.getValueStateText(),this.getShowValueStateMessage());if(this._bUseDialog){i._oPopupInput.setValueState(v);}}};
s.prototype.setShowValueHelp=function(i){this.setProperty("showValueHelp",i);if(this._oSuggPopover&&this._oSuggPopover._oPopupInput){this._oSuggPopover._oPopupInput.setShowValueHelp(i);}return this;};
s.prototype.setValueState=function(v){I.prototype.setValueState.apply(this,arguments);this._updateSuggestionsPopoverValueState();return this;};
s.prototype.setValueStateText=function(v){I.prototype.setValueStateText.apply(this,arguments);this._updateSuggestionsPopoverValueState();return this;};
s.prototype.setShowValueStateMessage=function(i){I.prototype.setShowValueStateMessage.apply(this,arguments);this._updateSuggestionsPopoverValueState();return this;};
return s;});
sap.ui.predefine('sap/m/InputBase',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./delegate/ValueStateMessage','sap/ui/core/message/MessageMixin','sap/ui/core/library','sap/ui/Device','./InputBaseRenderer','sap/base/Log',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/getSelectedText","sap/ui/dom/jquery/selectText"],function(l,C,E,I,V,M,c,D,a,b,K,q){"use strict";var T=c.TextDirection;var d=c.TextAlign;var f=c.ValueState;
var g=C.extend("sap.m.InputBase",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:f.None},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:d.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},required:{type:"boolean",group:"Misc",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"}}}},aggregations:{_endIcon:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"},_beginIcon:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"}},designtime:"sap/m/designtime/InputBase.designtime"}});
E.call(g.prototype);I.insertFontFaceStyle();M.call(g.prototype);g.ICON_PRESSED_CSS_CLASS="sapMInputBaseIconPressed";g.ICON_CSS_CLASS="sapMInputBaseIcon";g.prototype.bShowLabelAsPlaceholder=!D.support.input.placeholder;
g.prototype.handleInput=function(e){if(this._bIgnoreNextInput||this._bIgnoreNextInputNonASCII){this._bIgnoreNextInput=false;this._bIgnoreNextInputNonASCII=false;e.setMarked("invalid");return;}this._bIgnoreNextInput=false;this._bIgnoreNextInputNonASCII=false;if(!this.getEditable()){e.setMarked("invalid");return;}if(document.activeElement!==e.target&&D.browser.msie&&this.getValue()===this._lastValue){e.setMarked("invalid");return;}this._bCheckDomValue=true;};
g.prototype._getPlaceholder=function(){return this.getPlaceholder()||"";};
g.prototype._getInputValue=function(v){v=(v===undefined)?this.$("inner").val()||"":v.toString();if(this.getMaxLength&&this.getMaxLength()>0){v=v.substring(0,this.getMaxLength());}return v;};
g.prototype._getInputElementTagName=function(){if(!this._sInputTagElementName){this._sInputTagElementName=this._$input&&this._$input.get(0)&&this._$input.get(0).tagName;}return this._sInputTagElementName;};
g.prototype.init=function(){this._lastValue="";this.bRenderingPhase=false;this.bFocusoutDueRendering=false;this._oValueStateMessage=new V(this);this._bIsComposingCharacter=false;};
g.prototype.oncompositionstart=function(){this._bIsComposingCharacter=true;};
g.prototype.oncompositionend=function(e){this._bIsComposingCharacter=false;if(!D.browser.edge&&!D.browser.firefox){this.handleInput(e);}};
g.prototype.isComposingCharacter=function(){return this._bIsComposingCharacter;};
g.prototype.onBeforeRendering=function(){if(D.browser.msie&&D.browser.version>9&&!/^[\x00-\x7F]*$/.test(this.getValue())){this._bIgnoreNextInputNonASCII=true;this._oDomRefBeforeRendering=this.getDomRef();}if(this._bCheckDomValue&&!this.bRenderingPhase){this._sDomValue=this._getInputValue();}this.bRenderingPhase=true;};
g.prototype.onAfterRendering=function(){if(this._bCheckDomValue&&this._sDomValue!==this._getInputValue()){this.$("inner").val(this._sDomValue);}this._bIgnoreNextInputNonASCII=this._bIgnoreNextInputNonASCII&&this._oDomRefBeforeRendering!==this.getDomRef();this._bCheckDomValue=false;this.bRenderingPhase=false;};
g.prototype.exit=function(){if(this._oValueStateMessage){this._oValueStateMessage.destroy();}this._oValueStateMessage=null;this._oDomRefBeforeRendering=null;};
g.prototype.ontouchstart=function(e){e.setMarked();};
g.prototype.onfocusin=function(e){this._bIgnoreNextInput=!this.bShowLabelAsPlaceholder&&D.browser.msie&&D.browser.version>9&&!!this.getPlaceholder()&&!this._getInputValue()&&this._getInputElementTagName()==="INPUT";this.addStyleClass("sapMFocus");this.openValueStateMessage();};
g.prototype.onfocusout=function(e){this.bFocusoutDueRendering=this.bRenderingPhase;this.removeStyleClass("sapMFocus");if(this.bRenderingPhase){return;}this.closeValueStateMessage();};
g.prototype.onsapfocusleave=function(e){if(!this.preventChangeOnFocusLeave(e)){this.onChange(e);}};
g.prototype.preventChangeOnFocusLeave=function(e){return this.bFocusoutDueRendering;};
g.prototype.getChangeEventParams=function(){return{};};
g.prototype.ontap=function(e){return;};
g.prototype.onChange=function(e,p,n){p=p||this.getChangeEventParams();if(!this.getEditable()||!this.getEnabled()){return;}var v=this._getInputValue(n);if(v!==this._lastValue){this.setValue(v);v=this.getValue();this._lastValue=v;this.fireChangeEvent(v,p);return true;}else{this._bCheckDomValue=false;}};
g.prototype.fireChangeEvent=function(v,p){var o=q.extend({value:v,newValue:v},p);this.fireChange(o);};
g.prototype.onValueRevertedByEscape=function(v,p){this.fireEvent("liveChange",{value:v,escPressed:true,previousValue:p,newValue:v});};
g.prototype.onsapenter=function(e){this.onChange(e);};
g.prototype.onsapescape=function(e){var v=this._getInputValue();if(v!==this._lastValue){e.setMarked();e.preventDefault();this.updateDomValue(this._lastValue);this.onValueRevertedByEscape(this._lastValue,v);}};
g.prototype.oninput=function(e){this.handleInput(e);};
g.prototype.onkeydown=function(e){if(this.getDomRef("inner").getAttribute("readonly")&&e.keyCode==K.BACKSPACE){e.preventDefault();}};
g.prototype.oncut=function(e){};
g.prototype.selectText=function(s,S){this.$("inner").selectText(s,S);return this;};
g.prototype.getSelectedText=function(){return this.$("inner").getSelectedText();};
g.prototype.setProperty=function(p,v,s){if(p=="value"){this._bCheckDomValue=false;}return C.prototype.setProperty.apply(this,arguments);};
g.prototype.getFocusInfo=function(){var F=C.prototype.getFocusInfo.call(this),o=this.getFocusDomRef();q.extend(F,{cursorPos:0,selectionStart:0,selectionEnd:0});if(o){F.cursorPos=q(o).cursorPos();try{F.selectionStart=o.selectionStart;F.selectionEnd=o.selectionEnd;}catch(e){}}return F;};
g.prototype.applyFocusInfo=function(F){C.prototype.applyFocusInfo.call(this,F);this.$("inner").cursorPos(F.cursorPos);this.selectText(F.selectionStart,F.selectionEnd);return this;};
g.prototype.bindToInputEvent=function(e){if(this._oInputEventDelegate){this.removeEventDelegate(this._oInputEventDelegate);}this._oInputEventDelegate={oninput:e};return this.addEventDelegate(this._oInputEventDelegate);};
g.prototype.updateDomValue=function(v){if(!this.isActive()){return this;}v=this._getInputValue(v);if(this._getInputValue()!==v){this.$("inner").val(v);this._bCheckDomValue=true;}return this;};
g.prototype.closeValueStateMessage=function(){if(this._oValueStateMessage){this._oValueStateMessage.close();}};
g.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef("content");};
g.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
g.prototype.iOpenMessagePopupDuration=0;
g.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
g.prototype.getLabels=function(){var L=this.getAriaLabelledBy().map(function(s){return sap.ui.getCore().byId(s);});var o=sap.ui.require("sap/ui/core/LabelEnablement");if(o){L=L.concat(o.getReferencingLabels(this).map(function(s){return sap.ui.getCore().byId(s);}));}return L;};
g.prototype.openValueStateMessage=function(){if(this._oValueStateMessage&&this.shouldValueStateMessageBeOpened()){if(D.browser.msie){setTimeout(function(){this._oValueStateMessage.open();}.bind(this),0);}else{this._oValueStateMessage.open();}}};
g.prototype.updateValueStateClasses=function(v,o){var $=this.$(),e=this.$("content"),m=f;if(o!==m.None){$.removeClass("sapMInputBaseState");e.removeClass("sapMInputBaseContentWrapperState sapMInputBaseContentWrapper"+o);}if(v!==m.None){$.addClass("sapMInputBaseState");e.addClass("sapMInputBaseContentWrapperState sapMInputBaseContentWrapper"+v);}};
g.prototype.shouldValueStateMessageBeOpened=function(){return(this.getValueState()!==f.None)&&this.getEditable()&&this.getEnabled()&&this.getShowValueStateMessage();};
g.prototype._calculateIconsSpace=function(){var e=this.getAggregation("_endIcon")||[],B=this.getAggregation("_beginIcon")||[],i=e.concat(B),h;return i.reduce(function(A,o){h=o&&o.getDomRef()?o.getDomRef().offsetWidth:0;return A+h;},0);};
g.prototype.setValueState=function(v){var o=this.getValueState();this.setProperty("valueState",v,true);v=this.getValueState();if(v===o){return this;}var e=this.getDomRef();if(!e){return this;}var i=this.$("inner"),m=f;if(v===m.Error){i.attr("aria-invalid","true");}else{i.removeAttr("aria-invalid");}this.updateValueStateClasses(v,o);if(i[0]===document.activeElement){if(v===m.None){this.closeValueStateMessage();}else{this.openValueStateMessage();}}return this;};
g.prototype.setValueStateText=function(t){this.setProperty("valueStateText",t,true);this.$("message").text(this.getValueStateText());return this;};
g.prototype.setValue=function(v){v=this.validateProperty("value",v);v=this._getInputValue(v);this.updateDomValue(v);if(v!==this.getProperty("value")){this._lastValue=v;}this.setProperty("value",v,true);return this;};
g.prototype.getFocusDomRef=function(){return this.getDomRef("inner");};
g.prototype.getIdForLabel=function(){return this.getId()+"-inner";};
g.prototype.getAccessibilityInfo=function(){var r=this.getRequired()?'Required':'',R=this.getRenderer();return{role:R.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_INPUT"),description:[this.getValue()||"",R.getLabelledByAnnouncement(this),R.getDescribedByAnnouncement(this),r].join(" ").trim(),focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEnabled()&&this.getEditable()};};
g.prototype._addIcon=function(i,o){if(["begin","end"].indexOf(i)===-1){b.error('icon position is not "begin", neither "end", please check again the passed setting');return null;}var e=I.createControlByURI(o).addStyleClass(g.ICON_CSS_CLASS);this.addAggregation("_"+i+"Icon",e);return e;};
g.prototype.addBeginIcon=function(i){return this._addIcon("begin",i);};
g.prototype.addEndIcon=function(i){return this._addIcon("end",i);};
Object.defineProperty(g.prototype,"_$input",{get:function(){return this.$("inner");}});return g;});
sap.ui.predefine('sap/m/InputBaseRenderer',['sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device'],function(R,c,D){"use strict";var T=c.TextDirection;var V=c.ValueState;var I={apiVersion:2};
I.render=function(r,C){var v=C.getValueState(),t=C.getTextDirection(),s=R.getTextAlign(C.getTextAlign(),t),a=sap.ui.getCore().getConfiguration().getAccessibility(),b=C.getAggregation("_beginIcon")||[],e=C.getAggregation("_endIcon")||[],d,f;r.openStart("div",C);this.addOuterStyles(r,C);this.addControlWidth(r,C);r.class("sapMInputBase");this.addPaddingClass(r,C);this.addCursorClass(r,C);this.addOuterClasses(r,C);if(!C.getEnabled()){r.class("sapMInputBaseDisabled");}if(!C.getEditable()){r.class("sapMInputBaseReadonly");}if(v!==V.None){r.class("sapMInputBaseState");}if(b.length){d=b.filter(function(i){return i.getVisible();});d.length&&r.class("sapMInputBaseHasBeginIcons");}if(e.length){f=e.filter(function(i){return i.getVisible();});f.length&&r.class("sapMInputBaseHasEndIcons");}this.writeOuterAttributes(r,C);var g=C.getTooltip_AsString();if(g){r.attr("title",g);}r.openEnd();r.openStart("div",C.getId()+"-content");r.class("sapMInputBaseContentWrapper");if(!C.getEnabled()){r.class("sapMInputBaseDisabledWrapper");}else if(!C.getEditable()){r.class("sapMInputBaseReadonlyWrapper");}if(v!==V.None){this.addValueStateClasses(r,C);}this.writeAccAttributes(r,C);this.addWrapperStyles(r,C);r.openEnd();if(b.length){this.writeIcons(r,b);}this.prependInnerContent(r,C);this.openInputTag(r,C);if(C.getName()){r.attr("name",C.getName());}if(!C.bShowLabelAsPlaceholder&&C._getPlaceholder()){r.attr("placeholder",C._getPlaceholder());}if(C.getMaxLength&&C.getMaxLength()>0){r.attr("maxlength",C.getMaxLength());}if(!C.getEnabled()){r.attr("disabled","disabled");}else if(!C.getEditable()){r.attr("readonly","readonly");}if(C.getRequired()){r.attr("required","required");}if(t!=T.Inherit){r.attr("dir",t.toLowerCase());}this.writeInnerValue(r,C);if(a){this.writeAccessibilityState(r,C);}if(D.browser.mozilla){if(g){r.attr("x-moz-errormessage",g);}else{r.attr("x-moz-errormessage"," ");}}this.writeInnerAttributes(r,C);r.class("sapMInputBaseInner");this.addInnerClasses(r,C);r.style("text-align",s);this.addInnerStyles(r,C);this.endInputTag(r,C);this.writeInnerContent(r,C);this.closeInputTag(r,C);if(e.length){this.writeIcons(r,e);}r.close("div");this.writeDecorations(r,C);if(a){this.renderAriaLabelledBy(r,C);this.renderAriaDescribedBy(r,C);}r.close("div");};
I.getAriaRole=function(C){return"textbox";};
I.getAriaLabelledBy=function(C){if(this.getLabelledByAnnouncement(C)){return C.getId()+"-labelledby";}};
I.getLabelledByAnnouncement=function(C){return"";};
I.renderAriaLabelledBy=function(r,C){var a=this.getLabelledByAnnouncement(C);if(a){r.openStart("span",C.getId()+"-labelledby");r.attr("aria-hidden","true");r.class("sapUiInvisibleText");r.openEnd();r.text(a.trim());r.close("span");}};
I.getAriaDescribedBy=function(C){if(this.getDescribedByAnnouncement(C)){return C.getId()+"-describedby";}};
I.getDescribedByAnnouncement=function(C){return"";};
I.renderAriaDescribedBy=function(r,C){var a=this.getDescribedByAnnouncement(C);if(a){r.openStart("span",C.getId()+"-describedby");r.attr("aria-hidden","true");r.class("sapUiInvisibleText");r.openEnd();r.text(a.trim());r.close("span");}};
I.getAccessibilityState=function(C){var a=this.getAriaLabelledBy(C),A=this.getAriaDescribedBy(C),r=this.getAriaRole(C),m={};if(r){m.role=r;}if(C.getValueState()===V.Error){m.invalid=true;}if(a){m.labelledby={value:a.trim(),append:true};}if(A){m.describedby={value:A.trim(),append:true};}m.disabled=null;m.readonly=null;m.required=null;return m;};
I.writeAccessibilityState=function(r,C){r.accessibilityState(C,this.getAccessibilityState(C));};
I.openInputTag=function(r,C){r.voidStart("input",C.getId()+"-"+this.getInnerSuffix());};
I.endInputTag=function(r,C){r.voidEnd();};
I.writeInnerValue=function(r,C){r.attr("value",C.getValue());};
I.addCursorClass=function(r,C){};
I.addPaddingClass=function(r,C){r.class("sapMInputBaseHeightMargin");};
I.addOuterStyles=function(r,C){};
I.addControlWidth=function(r,C){if(!C.getProperty('width')){r.class("sapMInputBaseNoWidth");}r.style("width",C.getWidth());};
I.addOuterClasses=function(r,C){};
I.writeOuterAttributes=function(r,C){};
I.writeAccAttributes=function(r,C){};
I.addInnerStyles=function(r,C){};
I.addWrapperStyles=function(r,C){r.style("width","100%");};
I.addInnerClasses=function(r,C){};
I.writeInnerAttributes=function(r,C){};
I.prependInnerContent=function(r,C){};
I.writeInnerContent=function(r,C){};
I.writeIcons=function(r,i){r.openStart("div");r.attr("tabindex","-1");r.class("sapMInputBaseIconContainer");r.openEnd();i.forEach(r.renderControl,r);r.close("div");};
I.writeDecorations=function(r,C){};
I.closeInputTag=function(r,C){};
I.addPlaceholderStyles=function(r,C){};
I.addPlaceholderClasses=function(r,C){};
I.addValueStateClasses=function(r,C){r.class("sapMInputBaseContentWrapperState");r.class("sapMInputBaseContentWrapper"+C.getValueState());};
I.getInnerSuffix=function(){return"inner";};
return I;},true);
sap.ui.predefine('sap/m/InputListItem',["sap/ui/core/library","./library","./ListItemBase","./InputListItemRenderer"],function(c,l,L,I){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.InputListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},labelTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designtime:"sap/m/designtime/InputListItem.designtime"}});
a.prototype.getContentAnnouncement=function(){var A=this.getLabel();this.getContent().forEach(function(C){A+=L.getAccessibilityText(C)+" ";});return A;};
return a;});
sap.ui.predefine('sap/m/InputListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var I=R.extend(L);I.apiVersion=2;
I.renderLIAttributes=function(r,l){r.class("sapMILI");};
I.renderLIContent=function(r,l){var s=l.getLabel();if(s){r.openStart("span",l.getId()+"-label");r.class("sapMILILabel");var a=l.getLabelTextDirection();if(a!==T.Inherit){r.attr("dir",a.toLowerCase());}r.openEnd();r.text(s);r.close("span");}r.openStart("div").class("sapMILIDiv").class("sapMILI-CTX").openEnd();l.getContent().forEach(r.renderControl,r);r.close("div");};
return I;},true);
sap.ui.predefine('sap/m/InputRenderer',['sap/ui/core/InvisibleText','sap/ui/core/Renderer','./InputBaseRenderer','sap/m/library'],function(I,R,a,l){"use strict";var b=l.InputType;var c=R.extend(a);c.apiVersion=2;
c.addOuterClasses=function(r,C){r.class("sapMInput");if(C.getDescription()){r.class("sapMInputWithDescription");}};
c.writeInnerAttributes=function(r,C){r.attr("type",C.getType().toLowerCase());if(C.getType()==b.Number){r.attr("step","any");}if(C.getType()==b.Number&&sap.ui.getCore().getConfiguration().getRTL()){r.attr("dir","ltr");r.style("text-align","right");}if(C.getShowSuggestion()||C.getShowValueStateMessage()){r.attr("autocomplete","off");}if((!C.getEnabled()&&C.getType()=="Password")||(C.getShowSuggestion()&&C._bUseDialog)||(C.getValueHelpOnly()&&C.getEnabled()&&C.getEditable()&&C.getShowValueHelp())){r.attr("readonly","readonly");}};
c.addInnerClasses=function(r,C){};
c.writeDescription=function(r,C){r.openStart("div");r.class("sapMInputDescriptionWrapper");r.style("width","calc(100% - "+C.getFieldWidth()+")");r.openEnd();r.openStart("span",C.getId()+"-descr");r.class("sapMInputDescriptionText");r.openEnd();r.text(C.getDescription());r.close("span");r.close("div");};
c.writeDecorations=function(r,C){if(C.getDescription()){this.writeDescription(r,C);}if(sap.ui.getCore().getConfiguration().getAccessibility()){if(C.getShowSuggestion()&&C.getEnabled()&&C.getEditable()){r.openStart("span",C.getId()+"-SuggDescr").class("sapUiPseudoInvisibleText").attr("role","status").attr("aria-live","polite").openEnd().close("span");}}};
c.addWrapperStyles=function(r,C){r.style("width",C.getDescription()?C.getFieldWidth():"100%");};
c.getAriaLabelledBy=function(C){var d=a.getAriaLabelledBy.call(this,C)||"";if(C.getDescription()){d=d+" "+C.getId()+"-descr";}return d;};
c.getAriaDescribedBy=function(C){var A=a.getAriaDescribedBy.apply(this,arguments);function d(s){A=A?A+" "+s:s;}if(C.getShowValueHelp()&&C.getEnabled()&&C.getEditable()){d(I.getStaticId("sap.m","INPUT_VALUEHELP"));if(C.getValueHelpOnly()){d(I.getStaticId("sap.m","INPUT_DISABLED"));}}if(C.getShowSuggestion()&&C.getEnabled()&&C.getEditable()){d(C.getId()+"-SuggDescr");}return A;};
c.getAriaRole=function(C){return"";};
c.getAccessibilityState=function(C){var A=a.getAccessibilityState.apply(this,arguments);return A;};
return c;},true);
sap.ui.predefine('sap/m/InstanceManager',["sap/base/assert","sap/base/Log","sap/ui/thirdparty/jquery"],function(a,L,q){"use strict";var I={};var r={},e=[];var p="_POPOVER_",d="_DIALOG_",l="_LIGHTBOX_";
I.addInstance=function(c,i){a(c,"In sap.m.InstanceManager.addInstance method, the parameter sCategoryId can't be null or empty string");a(i instanceof Object,"In sap.m.InstanceManager.addInstance method, the parameter oInstance should be an object");if(!r[c]){r[c]=[];}if(r[c].indexOf(i)===-1){r[c].push(i);}return this;};
I.removeInstance=function(c,o){var C=r[c],i;a(c,"In sap.m.InstanceManager.removeInstance method, the parameter sCategoryId can't be null or empty string");a(o instanceof Object,"In sap.m.InstanceManager.removeInstance method, the parameter oInstance should be an object");if(!C){L.warning("Can't remove control from a non-managed category id: "+c);return null;}i=C.indexOf(o);return(i===-1)?null:C.splice(i,1);};
I.getInstancesByCategoryId=function(c){a(c,"In sap.m.InstanceManager.getInstancesByCategoryId method, the parameter sCategoryId can't be null or empty string");return r[c]||e;};
I.isInstanceManaged=function(c,i){a(c,"In sap.m.InstanceManager.isInstanceManaged method, the parameter sCategoryId can't be null or empty string");a(i instanceof Object,"In sap.m.InstanceManager.isInstanceManaged method, the parameter oInstance should be an object");var C=r[c];if(!C||!i){return false;}return C.indexOf(i)!==-1;};
I.isCategoryEmpty=function(c){a(c,"In sap.m.InstanceManager.isCategoryEmpty method, the parameter sCategoryId can't be null or empty string");var C=r[c];return!C||C.length===0;};
I.addPopoverInstance=function(P){if(typeof P.close==="function"){I.addInstance(p,P);}else{L.warning("In method addPopoverInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addDialogInstance=function(D){if(typeof D.close==="function"){I.addInstance(d,D);}else{L.warning("In method addDialogInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addLightBoxInstance=function(o){if(typeof o.close==="function"){I.addInstance(l,o);}else{L.warning("In method addLightBoxInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.removePopoverInstance=function(P){return I.removeInstance(p,P);};
I.removeDialogInstance=function(D){return I.removeInstance(d,D);};
I.removeLightBoxInstance=function(o){return I.removeInstance(l,o);};
I.hasOpenPopover=function(){return!I.isCategoryEmpty(p);};
I.hasOpenDialog=function(){return!I.isCategoryEmpty(d);};
I.hasOpenLightBox=function(){return!I.isCategoryEmpty(l);};
I.isDialogOpen=function(D){return I.isInstanceManaged(d,D);};
I.isPopoverOpen=function(P){return I.isInstanceManaged(p,P);};
I.isLightBoxOpen=function(o){return I.isInstanceManaged(l,o);};
I.getOpenPopovers=function(){return I.getInstancesByCategoryId(p);};
I.getOpenDialogs=function(){return I.getInstancesByCategoryId(d);};
I.getOpenLightBoxes=function(){return I.getInstancesByCategoryId(l);};
I.closeAllPopovers=function(){var b=I.getOpenPopovers(),i;for(i=0;i<b.length;i++){b[i].close();}return this;};
I.closeAllDialogs=function(c){var D,b=[],f=I.getOpenDialogs(),g,i;for(i=0;i<f.length;i++){g=f[i];if(!g.getCloseOnNavigation()){continue;}if(c){D=new q.Deferred().done();b.push(D);g.attachEvent("afterClose",(function(h){return function(){h.resolve();};}(D)));}g.close();}if(c){q.when.apply(this,b).then(c);}return this;};
I.closeAllLightBoxes=function(){var i=I.getOpenLightBoxes(),b=i.length,c;for(c=0;c<b;c+=1){i[c].close();}return this;};
return I;},true);
sap.ui.predefine('sap/m/Label',['./library','sap/ui/core/Control','sap/ui/core/LabelEnablement','sap/m/HyphenationSupport','sap/ui/core/library','./LabelRenderer'],function(l,C,L,H,c,a){"use strict";var T=c.TextDirection;var b=c.TextAlign;var d=l.LabelDesign;var V=c.VerticalAlign;var W=l.WrappingType;
var e=C.extend("sap.m.Label",{metadata:{interfaces:["sap.ui.core.Label","sap.ui.core.IShrinkable","sap.m.IOverflowToolbarContent","sap.m.IHyphenation"],library:"sap.m",properties:{design:{type:"sap.m.LabelDesign",group:"Appearance",defaultValue:d.Standard},text:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Begin},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},required:{type:"boolean",group:"Misc",defaultValue:false},displayOnly:{type:"boolean",group:"Appearance",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit}},associations:{labelFor:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/m/designtime/Label.designtime"}});
e.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,propsUnrelatedToSize:["design","required","displayOnly"]};function g(f){var h=f&&f.getLayoutData();if(i(h,"sap/m/OverflowToolbarLayoutData")){return h.getGroup();}}o.onBeforeEnterOverflow=function(f){var I=false,t,s,h,j,k;t=f.getParent();if(!i(t,"sap/m/OverflowToolbar")){return;}s=f.getLabelFor();h=s&&sap.ui.getCore().byId(s);if(!h||(t.indexOfContent(h)<0)){return;}j=g(f);k=g(h);I=j&&(j===k);f.toggleStyleClass("sapMLabelMediumMarginTop",I,true);};o.onAfterExitOverflow=function(f){f.toggleStyleClass("sapMLabelMediumMarginTop",false,true);};return o;};
e.prototype.getTextsToBeHyphenated=function(){return{"main":this.getText()};};
e.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.$("bdi")[0]};};
L.enrich(e.prototype);H.mixInto(e.prototype);
function i(o,m){if(o&&m){var f=sap.ui.require(m);return(typeof f==='function')&&(o instanceof f);}}
return e;});
sap.ui.predefine('sap/m/LabelRenderer',['sap/ui/core/Renderer','sap/m/library','sap/ui/core/library','sap/m/HyphenationSupport',"sap/ui/core/LabelEnablement"],function(R,l,c,H,L){"use strict";var T=c.TextDirection;var V=c.VerticalAlign;var a=l.LabelDesign;var b={apiVersion:2};
b.render=function(d,o){var r=b,t=o.getTextDirection(),s=o.getTextAlign(),w=o.getWidth(),e=o.getText(),f=o.getTooltip_AsString(),g=o.getLabelForRendering(),h=g?"label":"span",D=o.isDisplayOnly(),v=o.getVAlign();d.openStart(h,o);d.class("sapMLabel");d.class("sapUiSelectable");if(o.isWrapping()){d.class("sapMLabelWrapped");}if(o.getDesign()==a.Bold){d.style("font-weight","bold");}if(o.isRequired()){d.class("sapMLabelRequired");}if(g){L.writeLabelForAttribute(d,o);}else if(o.getParent()instanceof sap.m.Toolbar){d.class("sapMLabelTBHeader");}d.accessibilityState({label:o.getText()});if(t!==T.Inherit){d.attr("dir",t.toLowerCase());}if(w){d.style("width",w);}else{d.class("sapMLabelMaxWidth");}if(s){s=r.getTextAlign(s,t);if(s){d.style("text-align",s);}}if(e==""){d.class("sapMLabelNoText");}if(D){d.class("sapMLabelDisplayOnly");}if(v!=V.Inherit){d.style("vertical-align",v.toLowerCase());}H.writeHyphenationClass(d,o);if(f){d.attr("title",f);}d.openEnd();d.openStart("bdi");d.attr("id",o.getId()+"-bdi");d.openEnd();if(e){e=H.getTextForRender(o,"main");d.text(e);}d.close("bdi");d.close(h);};
b.getTextAlign=R.getTextAlign;return b;},true);
sap.ui.predefine('sap/m/LightBox',['./library','sap/ui/core/Control','sap/ui/core/Popup','sap/m/Text','sap/m/Button','sap/ui/core/ResizeHandler','sap/ui/Device','sap/ui/core/Icon','sap/ui/layout/VerticalLayout','./InstanceManager','sap/ui/core/InvisibleText','sap/ui/core/library','./LightBoxRenderer','sap/m/BusyIndicator',"sap/ui/thirdparty/jquery",'sap/ui/core/Core'],function(l,C,P,T,B,R,D,I,V,a,b,c,L,d,q,e){'use strict';var O=c.OpenState;var f=c.TextAlign;var g=l.ButtonType;var h=l.LightBoxLoadingStates;
var i=C.extend('sap.m.LightBox',{metadata:{interfaces:['sap.ui.core.PopupInterface'],library:'sap.m',aggregations:{imageContent:{type:'sap.m.LightBoxItem',multiple:true,bindable:"bindable"},_closeButton:{type:'sap.m.Button',multiple:false,visibility:'hidden'},_errorIcon:{type:'sap.ui.core.Icon',multiple:false,visibility:'hidden'},_errorTitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_errorSubtitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_verticalLayout:{type:'sap.ui.layout.VerticalLayout',multiple:false,visibility:'hidden'},_invisiblePopupText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"},_busy:{type:"sap.m.BusyIndicator",multiple:false,visibility:"hidden"}},events:{},defaultAggregation:'imageContent',designtime:"sap/m/designtime/LightBox.designtime"}});
i.prototype.init=function(){this._createPopup();this._width=0;this._height=0;this._isRendering=true;this._resizeListenerId=null;this._$lightBox=null;this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._closeButtonText=this._rb.getText("LIGHTBOX_CLOSE_BUTTON");if(sap.ui.getCore().getConfiguration().getAccessibility()){this.setAggregation("_invisiblePopupText",new b());}};
i.prototype.onBeforeRendering=function(){var o=this._getImageContent(),n=o._getNativeImage(),s=o.getImageSrc(),S=o._getImageState(),k=this.getAggregation('_invisiblePopupText'),m=this._rb.getText("LIGHTBOX_ARIA_ENLARGED",[o.getTitle(),o.getSubtitle()]),p=this._rb.getText('LIGHTBOX_IMAGE_ERROR'),r=this._rb.getText('LIGHTBOX_IMAGE_ERROR_DETAILS');this._createErrorControls();if(n.getAttribute('src')!==s){n.src=s;}if(this._resizeListenerId){D.resize.detachHandler(this._onResizeHandler);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}switch(S){case h.Loading:this._timeoutId=setTimeout(function(){o._setImageState(h.TimeOutError);},10000);break;case h.Loaded:clearTimeout(this._timeoutId);this._calculateSizes(n);break;case h.Error:clearTimeout(this._timeoutId);m+=" "+p+" "+r;break;default:break;}if(o&&k){k.setText(m);}this._isRendering=true;};
i.prototype.onAfterRendering=function(){this._isRendering=false;this._$lightBox=this.$();if(!this._resizeListenerId){this._onResizeHandler=this._onResize.bind(this);D.resize.attachHandler(this._onResizeHandler);this._resizeListenerId=R.register(this,this._onResizeHandler);}};
i.prototype.forceInvalidate=C.prototype.invalidate;
i.prototype.invalidate=function(o){var k=this._getImageContent();if(this.isOpen()){if(k&&k.getImageSrc()){this.forceInvalidate(o);}else{this.close();}}return this;};
i.prototype.exit=function(){if(this._oPopup){this._oPopup.detachOpened(this._fnOpened,this);this._oPopup.detachClosed(this._fnClosed,this);this._oPopup.destroy();this._oPopup=null;}if(this._resizeListenerId){D.resize.detachHandler(this._onResizeHandler);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}a.removeLightBoxInstance(this);};
i.prototype.open=function(){var k=this._getImageContent();this._oPopup.setContent(this);if(k&&k.getImageSrc()){this._oPopup.open(300,'center center','center center',document.body,null);a.addLightBoxInstance(this);}return this;};
i.prototype.isOpen=function(){if(this._oPopup&&this._oPopup.isOpen()){return true;}return false;};
i.prototype.close=function(){if(this._resizeListenerId){D.resize.detachHandler(this._onResizeHandler);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}this._oPopup.close();a.removeLightBoxInstance(this);return this;};
i.prototype._getCloseButton=function(){var k=this.getAggregation('_closeButton');if(!k){k=new B({id:this.getId()+'-closeButton',text:this._closeButtonText,type:g.Transparent,press:function(){this.close();}.bind(this)});this.setAggregation('_closeButton',k,true);}return k;};
i.prototype._getBusyIndicator=function(){var k=this.getAggregation("_busy");if(!k){k=new d();this.setAggregation("_busy",k,true);}return k;};
i.prototype._imageStateChanged=function(n){var s=n===h.Loaded||n===h.Error;if(s&&!this._isRendering){this.rerender();}};
i.prototype._createPopup=function(){this._oPopup=new P(this,true,true);this._oPopup.attachOpened(this._fnOpened,this);this._oPopup.attachClosed(this._fnClosed,this);};
i.prototype._fnOpened=function(){var t=this;t._onResize();q('#sap-ui-blocklayer-popup').on("click",function(){t.close();});};
i.prototype._fnClosed=function(){q('#sap-ui-blocklayer-popup').off("click");};
i.prototype._createErrorControls=function(){var r=this._rb;var k;var m;if(this._getImageContent()._getImageState()===h.TimeOutError){k=r.getText('LIGHTBOX_IMAGE_TIMED_OUT');m=r.getText('LIGHTBOX_IMAGE_TIMED_OUT_DETAILS');}else{k=r.getText('LIGHTBOX_IMAGE_ERROR');m=r.getText('LIGHTBOX_IMAGE_ERROR_DETAILS');}if(!this.getAggregation('_verticalLayout')){var n=new T({text:k,textAlign:f.Center}).addStyleClass("sapMLightBoxErrorTitle"),o=new T({text:m,textAlign:f.Center}).addStyleClass("sapMLightBoxErrorSubtitle"),p=new I({src:"sap-icon://picture"}).addStyleClass("sapMLightBoxErrorIcon");this.setAggregation('_verticalLayout',new V({content:[p,n,o]}).addStyleClass('sapMLightBoxVerticalLayout'));}};
i.prototype._onResize=function(){var m=j()/2+'px',t=m,k=m,n='',o='',p=this._getImageContent(),r=this.getDomRef(),s,u,v=j(),w=2;if(p._getImageState()===h.Loaded){this._calculateSizes(p._getNativeImage());s=this._width;u=this._height;this._$lightBox.width(s);this._$lightBox.height(u);}else{s=r.clientWidth;u=r.clientHeight;}if(window.innerWidth>s+v){k='50%';o=Math.round(-s/2);}if(window.innerHeight>u+v){t='50%';n=Math.round(-u/2);}if(sap.ui.getCore().getConfiguration().getTheme()==='sap_hcb'){n-=w;o-=w;}this._$lightBox.css({'top':t,'margin-top':n,'left':k,'margin-left':o});};
i.prototype._calculateSizes=function(k){var F=this._calculateFooterHeightInPx(),m=288-F,n=this._getImageContent().getAggregation("_image"),o;this._setImageSize(n,k.naturalWidth,k.naturalHeight);this._calculateAndSetLightBoxSize(n);o=this._pxToNumber(n.getHeight());this.toggleStyleClass('sapMLightBoxMinSize',(o<m));this._isBusy=false;};
i.prototype._calculateFooterHeightInPx=function(){var k=this.$().parents().hasClass('sapUiSizeCompact');var s=this._getImageContent().getSubtitle();var m=2.5;if(!k){m+=0.5;}if(s){m+=1.5;}return m*16;};
i.prototype._calculateAndSetLightBoxSize=function(k){var m,n,o=(20*16),p=(18*16),F=this._calculateFooterHeightInPx();m=this._pxToNumber(k.getHeight());n=this._pxToNumber(k.getWidth());this._width=Math.max(o,n);this._height=Math.max(p,m+F);this._isLightBoxBiggerThanMinDimensions=(n>=o)&&(m>=(p-F));};
i.prototype._setImageSize=function(k,m,n){var o=this._calculateFooterHeightInPx(),p=this._getDimensions(m,n,o),w=p.width+'px',r=p.height+'px',s=k.getDomRef();k.setProperty('width',w,true);k.setProperty('height',r,true);if(s){s.style.width=w;s.style.height=r;}};
i.prototype._getDimensions=function(k,m,n){var o=20*16,p=18*16,$=q(window),w=$.height(),r=$.width(),s=j(),t=Math.max(r-s,o),u=Math.max(w-s,p),v;u-=n;if(m<=u){if(k<=t){}else{m*=t/k;k=t;}}else{if(k<=t){k*=u/m;m=u;}else{v=Math.max(k/t,m/u);k/=v;m/=v;}}return{width:Math.round(k),height:Math.round(m)};};
i.prototype._pxToNumber=function(s){return(s.substring(0,(s.length-2)))*1;};
i.prototype._getImageContent=function(){var r=this.getAggregation('imageContent');return r&&r[0];};
function j(){var s=D.system;if(s.desktop){return 4*16;}if(s.tablet){return 2*16;}return 0;}
i.prototype.onsapescape=function(E){var k=this._oPopup.getOpenState();if(k!==O.CLOSED&&k!==O.CLOSING){this.close();E.stopPropagation();}};
return i;});
sap.ui.predefine('sap/m/LightBoxItem',['./library','sap/ui/core/Element','./Image','./Text','sap/ui/core/library'],function(l,E,I,T,c){"use strict";var O=c.OpenState;var L=l.LightBoxLoadingStates;
var a=E.extend("sap.m.LightBoxItem",{metadata:{library:"sap.m",properties:{imageSrc:{type:'sap.ui.core.URI',group:'Appearance',multiple:false,defaultValue:''},alt:{type:'string',group:'Appearance',multiple:false,defaultValue:''},title:{type:'string',group:'Appearance',multiple:false,defaultValue:''},subtitle:{type:'string',group:'Appearance',multiple:false,defaultValue:''}},aggregations:{_image:{type:'sap.m.Image',multiple:false,visibility:'hidden'},_title:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_subtitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'}}}});
a.prototype.init=function(){this._createNativeImage();this.setAggregation('_image',new I({decorative:false,densityAware:false}),true);this.setAggregation('_title',new T({wrapping:false}),true);this.setAggregation('_subtitle',new T({wrapping:false}),true);};
a.prototype._createNativeImage=function(){var t=this;this._imageState=L.Loading;this._oImage=new window.Image();this._oImage.onload=function(e){if(this.complete&&t._imageState===L.Loading){t._setImageState(L.Loaded);}};this._oImage.onerror=function(e){t._setImageState(L.Error);};};
a.prototype.exit=function(){this._oImage=null;};
a.prototype._setImageState=function(i){if(i!==this._imageState){this._imageState=i;if(this.getParent()){this.getParent()._imageStateChanged(i);}}};
a.prototype._getImageState=function(){return this._imageState;};
a.prototype._getNativeImage=function(){return this._oImage;};
a.prototype.setImageSrc=function(i){var o=this.getAggregation("_image"),b=this.getParent();if(this.getImageSrc()===i){return this;}this._imageState=L.Loading;if(b&&b._oPopup.getOpenState()===O.OPEN){this._oImage.src=i;}this.setProperty("imageSrc",i,false);o.setSrc(i);return this;};
a.prototype.setAlt=function(b){var i=this.getAggregation("_image");this.setProperty("alt",b,false);i.setAlt(b);return this;};
a.prototype.setTitle=function(t){var o=this.getAggregation("_title");this.setProperty("title",t,false);o.setText(t);return this;};
a.prototype.setSubtitle=function(s){var b=this.getAggregation("_subtitle");this.setProperty("subtitle",s,false);b.setText(s);return this;};
return a;});
sap.ui.predefine('sap/m/LightBoxRenderer',["sap/m/library"],function(l){'use strict';var L=l.LightBoxLoadingStates;var a={};var c='sapMLightBox';var b='sapMLightBoxTwoLines';var d='sapMLightBoxImageContainer';var e='sapMLightBoxImageContainerTwoHeaders';var f='sapMLightBoxError';var g='sapMLightBoxErrorContainer';var h='sapMLightBoxErrorContainerTwoHeaders';var i='sapMLightBoxFooter';var j='sapContrast';var k='sapContrastPlus';var m='sapMLightBoxTitleSection';var n='sapMLightBoxTitle';var o='sapMLightBoxSubtitle';var p='sapMLightBoxFooterTwoLines';var q='sapMLightBoxTopCornersRadius';
a.render=function(r,C){var s=C._getImageContent();var t=s._getImageState();var u=C.getAggregation('_invisiblePopupText');r.write('<div');r.writeControlData(C);r.writeAttribute("tabindex","-1");r.addClass(c);if(s.getSubtitle()){r.addClass(b);}if(C._isLightBoxBiggerThanMinDimensions){r.addClass(q);}if(t!==L.Error){r.addStyle('width',C._width+'px');r.addStyle('height',C._height+'px');}else{r.addClass(f);}r.writeAccessibilityState({role:'dialog',modal:true,labelledby:u&&u.getId()});r.writeClasses();r.writeStyles();r.write('>');r.renderControl(u);if(t===L.Loading){this.renderBusyState(r,C);}else if(t===L.TimeOutError||t===L.Error){this.renderError(r,C);}else{this.renderImage(r,C);}this.renderFooter(r,C,s);r.write('</div>');C._isRendering=false;};
a.renderImage=function(r,C){var s=C._getImageContent();if(s.getSubtitle()){r.write('<div class="'+e+'">');}else{r.write('<div class="'+d+'">');}r.renderControl(s.getAggregation('_image'));r.write('</div>');};
a.renderError=function(r,C){var s=C._getImageContent(),v=C.getAggregation('_verticalLayout');if(s.getSubtitle()){r.write('<div class="'+h+'">');}else{r.write('<div class="'+g+'">');}r.renderControl(v);r.write('</div>');};
a.renderBusyState=function(r,C){r.renderControl(C._getBusyIndicator());};
a.renderFooter=function(r,C,I){var t=I.getAggregation("_title"),s=I.getAggregation("_subtitle");r.write('<div');r.addClass(i);r.addClass(j);r.addClass(k);if(I.getSubtitle()){r.addClass(p);}r.writeClasses();r.write('>');r.write('<div class="'+m+'">');if(t){r.renderControl(t.addStyleClass(n));}if(s&&s.getText()){r.renderControl(s.addStyleClass(o));}r.write('</div>');r.renderControl(C._getCloseButton());r.write('</div>');};
return a;},true);
sap.ui.predefine('sap/m/Link',['./library','sap/ui/core/Control','sap/ui/core/InvisibleText','sap/ui/core/EnabledPropagator','sap/ui/core/LabelEnablement','sap/ui/core/library','sap/ui/Device','./LinkRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/base/security/URLWhitelist"],function(l,C,I,E,L,c,D,a,K,b,U){"use strict";var T=c.TextDirection;var d=c.TextAlign;
var e=C.extend("sap.m.Link",{metadata:{interfaces:["sap.ui.core.IShrinkable","sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/Link.designtime",properties:{text:{type:"string",group:"Data",defaultValue:''},enabled:{type:"boolean",group:"Behavior",defaultValue:true},target:{type:"string",group:"Behavior",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},href:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},validateUrl:{type:"boolean",group:"Data",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:d.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},subtle:{type:"boolean",group:"Behavior",defaultValue:false},emphasized:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{allowPreventDefault:true,parameters:{ctrlKey:{type:"boolean"},metaKey:{type:"boolean"}}}},dnd:{draggable:true,droppable:false}}});
E.call(e.prototype);
e.prototype.onBeforeRendering=function(){};
e.prototype.onkeydown=function(o){if(o.which===K.SPACE||o.which===K.SHIFT||o.which===K.ESCAPE){if(o.which===K.SPACE){if(this.getEnabled()||this.getHref()){o.setMarked();o.preventDefault();this._bPressedSpace=true;}}if(this._bPressedSpace&&(o.which===K.ESCAPE||o.which===K.SHIFT)){this._bPressedEscapeOrShift=true;}}else{if(this._bPressedSpace){o.preventDefault();}}};
e.prototype.onkeyup=function(o){if(o.which===K.SPACE){if(!this._bPressedEscapeOrShift){this._handlePress(o);if(this.getHref()&&!o.isDefaultPrevented()){o.preventDefault();o.setMarked();var f=document.createEvent('MouseEvents');f.initEvent('click',false,true);this.getDomRef().dispatchEvent(f);}}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}};
e.prototype._handlePress=function(o){if(this.getEnabled()){o.setMarked();if(!this.firePress({ctrlKey:!!o.ctrlKey,metaKey:!!o.metaKey})||!this.getHref()){o.preventDefault();}}else{o.preventDefault();}};
e.prototype.onsapenter=e.prototype._handlePress;if(D.support.touch){e.prototype.ontap=e.prototype._handlePress;}else{e.prototype.onclick=e.prototype._handlePress;}
e.prototype.ontouchstart=function(o){if(this.getEnabled()){o.setMarked();}};
e.prototype.setSubtle=function(s){this.setProperty("subtle",s);if(s&&!e.prototype._sAriaLinkSubtleId){e.prototype._sAriaLinkSubtleId=I.getStaticId("sap.m","LINK_SUBTLE");}return this;};
e.prototype.setEmphasized=function(f){this.setProperty("emphasized",f);if(f&&!e.prototype._sAriaLinkEmphasizedId){e.prototype._sAriaLinkEmphasizedId=I.getStaticId("sap.m","LINK_EMPHASIZED");}return this;};
e.prototype._isHrefValid=function(u){return this.getValidateUrl()?U.validate(u):true;};
e.prototype.getAccessibilityInfo=function(){return{role:"link",type:this.getText()?sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_LINK"):undefined,description:this.getText()||this.getHref()||"",focusable:this.getEnabled(),enabled:this.getEnabled()};};
e.prototype.getFormDoNotAdjustWidth=function(){return true;};
e.prototype._getTabindex=function(){return this.getText()?"0":"-1";};
e.prototype._determineSelfReferencePresence=function(){var A=this.getAriaLabelledBy(),B=D.browser.msie,f=A.indexOf(this.getId())!==-1,h=L.getReferencingLabels(this).length>0,p=this.getParent(),g=!!(p&&p.enhanceAccessibilityState);return!B&&!f&&(A.length>0||h||g);};
return e;});
sap.ui.predefine('sap/m/LinkRenderer',['sap/ui/core/Renderer','sap/ui/core/library'],function(R,c){"use strict";var T=c.TextDirection;var L={apiVersion:2};
L.render=function(r,C){var t=C.getTextDirection(),s=R.getTextAlign(C.getTextAlign(),t),S=C._determineSelfReferencePresence(),h=C.getHref(),a={role:h?"":"button",labelledby:S?{value:C.getId(),append:true}:undefined},i=h&&C._isHrefValid(h),e=C.getEnabled();r.openStart("a",C);r.class("sapMLnk");if(C.getSubtle()){r.class("sapMLnkSubtle");if(a.describedby){a.describedby+=" "+C._sAriaLinkSubtleId;}else{a.describedby=C._sAriaLinkSubtleId;}}if(C.getEmphasized()){r.class("sapMLnkEmphasized");if(a.describedby){a.describedby+=" "+C._sAriaLinkEmphasizedId;}else{a.describedby=C._sAriaLinkEmphasizedId;}}if(!e){r.class("sapMLnkDsbl");r.attr("disabled","true");a.disabled=null;}else{r.attr("tabindex",C._getTabindex());}if(C.getWrapping()){r.class("sapMLnkWrapping");}if(C.getTooltip_AsString()){r.attr("title",C.getTooltip_AsString());}if(i&&e){r.attr("href",h);}if(C.getTarget()){r.attr("target",C.getTarget());}if(C.getWidth()){r.style("width",C.getWidth());}else{r.class("sapMLnkMaxWidth");}if(s){r.style("text-align",s);}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.accessibilityState(C,a);r.openEnd();if(this.writeText){this.writeText(r,C);}else{this.renderText(r,C);}r.close("a");};
L.renderText=function(r,C){r.text(C.getText());};
return L;},true);
sap.ui.predefine('sap/m/List',["./library","./ListBase","./ListRenderer"],function(l,L,a){"use strict";var B=l.BackgroundDesign;
var b=L.extend("sap.m.List",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid}}}});
return b;});
sap.ui.predefine('sap/m/ListBase',["sap/ui/events/KeyCodes","sap/ui/Device","sap/ui/core/Control","sap/ui/core/InvisibleText","sap/ui/core/LabelEnablement","sap/ui/core/delegate/ItemNavigation","./library","./InstanceManager","./GrowingEnablement","./GroupHeaderListItem","./ListItemBase","./ListBaseRenderer","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Selectors","sap/ui/dom/jquery/Aria"],function(K,D,C,I,L,a,l,b,G,c,d,f,g,q,h){"use strict";var j=l.ListType;var k=l.ListKeyboardMode;var m=l.ListGrowingDirection;var S=l.SwipeDirection;var n=l.ListSeparators;var o=l.ListMode;var p=l.ListHeaderDesign;var r=l.Sticky;
var s=C.extend("sap.m.ListBase",{metadata:{library:"sap.m",dnd:true,properties:{inset:{type:"boolean",group:"Appearance",defaultValue:false},headerText:{type:"string",group:"Misc",defaultValue:null},headerDesign:{type:"sap.m.ListHeaderDesign",group:"Appearance",defaultValue:p.Standard,deprecated:true},footerText:{type:"string",group:"Misc",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:o.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},includeItemInSelection:{type:"boolean",group:"Behavior",defaultValue:false},showUnread:{type:"boolean",group:"Misc",defaultValue:false},noDataText:{type:"string",group:"Misc",defaultValue:null},showNoData:{type:"boolean",group:"Misc",defaultValue:true},enableBusyIndicator:{type:"boolean",group:"Behavior",defaultValue:true},modeAnimationOn:{type:"boolean",group:"Misc",defaultValue:true},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:n.All},swipeDirection:{type:"sap.m.SwipeDirection",group:"Misc",defaultValue:S.Both},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:20},growingTriggerText:{type:"string",group:"Appearance",defaultValue:null},growingScrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false},growingDirection:{type:"sap.m.ListGrowingDirection",group:"Behavior",defaultValue:m.Downwards},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:true},keyboardMode:{type:"sap.m.ListKeyboardMode",group:"Behavior",defaultValue:k.Navigation},sticky:{type:"sap.m.Sticky[]",group:"Appearance"}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",bindable:"bindable",selector:"#{id} .sapMListItems",dnd:true},swipeContent:{type:"sap.ui.core.Control",multiple:false},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false},contextMenu:{type:"sap.ui.core.IContextMenu",multiple:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}},selectionChange:{parameters:{listItem:{type:"sap.m.ListItemBase"},listItems:{type:"sap.m.ListItemBase[]"},selected:{type:"boolean"},selectAll:{type:"boolean"}}},"delete":{parameters:{listItem:{type:"sap.m.ListItemBase"}}},swipe:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"},swipeContent:{type:"sap.ui.core.Control"},srcControl:{type:"sap.ui.core.Control"},swipeDirection:{type:"sap.m.SwipeDirection"}}},growingStarted:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},growingFinished:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},updateStarted:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},updateFinished:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},itemPress:{parameters:{listItem:{type:"sap.m.ListItemBase"},srcControl:{type:"sap.ui.core.Control"}}},beforeOpenContextMenu:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}}},designtime:"sap/m/designtime/ListBase.designtime"}});
s.prototype.bAnnounceDetails=true;s.prototype.bPreventMassSelection=false;
s.getInvisibleText=function(){return this.oInvisibleText||(this.oInvisibleText=new I().toStatic());};
s.prototype.sNavItemClass="sapMLIB";
s.prototype.init=function(){this._aNavSections=[];this._aSelectedPaths=[];this._iItemNeedsHighlight=0;this._iItemNeedsNavigated=0;this.data("sap-ui-fastnavgroup","true",true);};
s.prototype.onBeforeRendering=function(){this._bRendering=true;this._bActiveItem=false;this._aNavSections=[];this._removeSwipeContent();};
s.prototype.onAfterRendering=function(){this._bRendering=false;this._sLastMode=this.getMode();if(D.system.desktop){this._startItemNavigation(true);}};
s.prototype.exit=function(){this._oSelectedItem=null;this._aNavSections=[];this._aSelectedPaths=[];this._destroyGrowingDelegate();this._destroyItemNavigation();};
s.prototype.refreshItems=function(R){if(this._oGrowingDelegate){this._oGrowingDelegate.refreshItems(R);}else{if(!this._bReceivingData){this._updateStarted(R);this._bReceivingData=true;}this.refreshAggregation("items");}};
s.prototype.updateItems=function(R){if(this._oGrowingDelegate){this._oGrowingDelegate.updateItems(R);}else{if(this._bReceivingData){this._bReceivingData=false;}else{this._updateStarted(R);}this.updateAggregation("items");this._updateFinished();}};
s.prototype.setBindingContext=function(e,M){var i=(this.getBindingInfo("items")||{}).model;if(i===M){this._resetItemsBinding();}return C.prototype.setBindingContext.apply(this,arguments);};
s.prototype._bindAggregation=function(N,B){function e(B,E,H){B.events=B.events||{};if(!B.events[E]){B.events[E]=H;}else{var O=B.events[E];B.events[E]=function(){H.apply(this,arguments);O.apply(this,arguments);};}}if(N==="items"){this._resetItemsBinding();e(B,"dataRequested",this._onBindingDataRequestedListener.bind(this));e(B,"dataReceived",this._onBindingDataReceivedListener.bind(this));}C.prototype._bindAggregation.call(this,N,B);};
s.prototype._onBindingDataRequestedListener=function(e){this._showBusyIndicator();if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}};
s.prototype._onBindingDataReceivedListener=function(e){if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}this._dataReceivedHandlerId=setTimeout(function(){this._hideBusyIndicator();delete this._dataReceivedHandlerId;}.bind(this),0);};
s.prototype.unbindAggregation=function(N){return C.prototype.unbindAggregation.call(this,N,this.getGrowing());};
s.prototype.destroyItems=function(e){if(!this.getItems(true).length){return this;}this._oSelectedItem=null;this.destroyAggregation("items","KeepDom");if(!e){this.invalidate();}return this;};
s.prototype.removeAllItems=function(A){this._oSelectedItem=null;return this.removeAllAggregation("items");};
s.prototype.removeItem=function(i){var e=this.removeAggregation("items",i);if(e&&e===this._oSelectedItem){this._oSelectedItem=null;}return e;};
s.prototype.getItems=function(R){if(R){return this.mAggregations["items"]||[];}return this.getAggregation("items",[]);};
s.prototype.getId=function(e){var i=this.sId;return e?i+"-"+e:i;};
s.prototype.setGrowing=function(e){e=!!e;if(this.getGrowing()!=e){this.setProperty("growing",e,!e);if(e){this._oGrowingDelegate=new G(this);}else if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}}return this;};
s.prototype.setGrowingThreshold=function(t){return this.setProperty("growingThreshold",t,true);};
s.prototype.setEnableBusyIndicator=function(e){this.setProperty("enableBusyIndicator",e,true);if(!this.getEnableBusyIndicator()){this._hideBusyIndicator();}return this;};
s.prototype.setNoDataText=function(N){this.setProperty("noDataText",N,true);this.$("nodata-text").text(this.getNoDataText());return this;};
s.prototype.getNoDataText=function(e){if(e&&this._bBusy){return"";}var N=this.getProperty("noDataText");N=N||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_NO_DATA");return N;};
s.prototype.getSelectedItem=function(){var e=this.getItems(true);for(var i=0;i<e.length;i++){if(e[i].getSelected()){return e[i];}}return null;};
s.prototype.setSelectedItem=function(e,i,F){if(this.indexOfItem(e)<0){h.warning("setSelectedItem is called without valid ListItem parameter on "+this);return;}if(this._bSelectionMode){e.setSelected((i===undefined)?true:!!i);F&&this._fireSelectionChangeEvent([e]);}};
s.prototype.getSelectedItems=function(){return this.getItems(true).filter(function(i){return i.getSelected();});};
s.prototype.setSelectedItemById=function(i,e){var t=sap.ui.getCore().byId(i);return this.setSelectedItem(t,e);};
s.prototype.getSelectedContexts=function(A){var B=this.getBindingInfo("items"),M=(B||{}).model,e=this.getModel(M);if(!B||!e){return[];}if(A&&this.getRememberSelections()){return this._aSelectedPaths.map(function(P){return e.getContext(P);});}return this.getSelectedItems().map(function(i){return i.getBindingContext(M);});};
s.prototype.removeSelections=function(A,F,e){var i=[];this._oSelectedItem=null;A&&(this._aSelectedPaths=[]);this.getItems(true).forEach(function(t){if(!t.getSelected()){return;}if(e&&t.isSelectedBoundTwoWay()){return;}t.setSelected(false,true);i.push(t);!A&&this._updateSelectedPaths(t);},this);if(F&&i.length){this._fireSelectionChangeEvent(i);}return this;};
s.prototype.selectAll=function(F){if(this.getMode()!="MultiSelect"){return this;}var e=[];this.getItems(true).forEach(function(i){if(!i.getSelected()){i.setSelected(true,true);e.push(i);this._updateSelectedPaths(i);}},this);if(F&&e.length){this._fireSelectionChangeEvent(e,F);}return this;};
s.prototype.getLastMode=function(M){return this._sLastMode;};
s.prototype.setMode=function(M){M=this.validateProperty("mode",M);var O=this.getMode();if(O==M){return this;}this._bSelectionMode=M.indexOf("Select")>-1;if(!this._bSelectionMode){this.removeSelections(true);}else{var e=this.getSelectedItems();if(e.length>1){this.removeSelections(true);}else if(O===o.MultiSelect){this._oSelectedItem=e[0];}}return this.setProperty("mode",M);};
s.prototype.getGrowingInfo=function(){return this._oGrowingDelegate?this._oGrowingDelegate.getInfo():null;};
s.prototype.setRememberSelections=function(R){this.setProperty("rememberSelections",R,true);!this.getRememberSelections()&&(this._aSelectedPaths=[]);return this;};
s.prototype.setSelectedContextPaths=function(e){this._aSelectedPaths=e||[];};
s.prototype.getSelectedContextPaths=function(A){if(!A||(A&&this.getRememberSelections())){return this._aSelectedPaths.slice(0);}return this.getSelectedItems().map(function(i){return i.getBindingContextPath();});};
s.prototype.isAllSelectableSelected=function(){if(this.getMode()!=o.MultiSelect){return false;}var i=this.getItems(true),e=this.getSelectedItems().length,t=i.filter(function(u){return u.isSelectable();}).length;return(i.length>0)&&(e==t);};
s.prototype.getVisibleItems=function(){return this.getItems(true).filter(function(i){return i.getVisible();});};
s.prototype.getActiveItem=function(){return this._bActiveItem;};
s.prototype.onItemDOMUpdate=function(e){if(!this._bRendering&&this.bOutput){this._startItemNavigation(true);}};
s.prototype.onItemActiveChange=function(e,A){this._bActiveItem=A;};
s.prototype.onItemHighlightChange=function(i,N){this._iItemNeedsHighlight+=(N?1:-1);if(this._iItemNeedsHighlight==1&&N){this.$("listUl").addClass("sapMListHighlight");}else if(this._iItemNeedsHighlight==0){this.$("listUl").removeClass("sapMListHighlight");}};
s.prototype.onItemNavigatedChange=function(i,N){this._iItemNeedsNavigated+=(N?1:-1);if(this._iItemNeedsNavigated==1&&N){this.$("listUl").addClass("sapMListNavigated");}else if(this._iItemNeedsNavigated==0){this.$("listUl").removeClass("sapMListNavigated");}};
s.prototype.onItemSelectedChange=function(e,i){if(this.getMode()==o.MultiSelect){this._updateSelectedPaths(e,i);return;}if(i){this._aSelectedPaths=[];this._oSelectedItem&&this._oSelectedItem.setSelected(false,true);this._oSelectedItem=e;}else if(this._oSelectedItem===e){this._oSelectedItem=null;}this._updateSelectedPaths(e,i);};
s.prototype.getItemsContainerDomRef=function(){return this.getDomRef("listUl");};
s.prototype.checkGrowingFromScratch=function(){};
s.prototype.onBeforePageLoaded=function(e,i){this._fireUpdateStarted(i,e);this.fireGrowingStarted(e);};
s.prototype.onAfterPageLoaded=function(e,i){this._fireUpdateFinished(e);this.fireGrowingFinished(e);};
s.prototype.addNavSection=function(i){this._aNavSections.push(i);return i;};
s.prototype.getMaxItemsCount=function(){var B=this.getBinding("items");if(B&&B.getLength){return B.getLength()||0;}return this.getItems(true).length;};
s.prototype.shouldRenderItems=function(){return true;};
s.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._bUpdating=false;this._bReceivingData=false;this.removeSelections(true,false,true);this._oGrowingDelegate&&this._oGrowingDelegate.reset();this._hideBusyIndicator();if(this._oItemNavigation){this._oItemNavigation.iFocusedIndex=-1;}}};
s.prototype._updateStarted=function(R){if(!this._bReceivingData&&!this._bUpdating){this._bUpdating=true;this._fireUpdateStarted(R);}};
s.prototype._fireUpdateStarted=function(R,i){this._sUpdateReason=g(R||"Refresh");this.fireUpdateStarted({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});};
s.prototype.onThemeChanged=function(){if(this._oGrowingDelegate){this._oGrowingDelegate._updateTrigger();}};
s.prototype._updateFinished=function(){if(!this._bReceivingData&&this._bUpdating){this._fireUpdateFinished();this._bUpdating=false;}};
s.prototype._fireUpdateFinished=function(i){this._hideBusyIndicator();setTimeout(function(){this._bItemNavigationInvalidated=true;this.fireUpdateFinished({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});}.bind(this),0);};
s.prototype._showBusyIndicator=function(){if(this.getEnableBusyIndicator()&&!this.getBusy()&&!this._bBusy){this._bBusy=true;this._sBusyTimer=setTimeout(function(){this.$("nodata-text").text("");}.bind(this),this.getBusyIndicatorDelay());this.setBusy(true,"listUl");}};
s.prototype._hideBusyIndicator=function(){if(this._bBusy){this._bBusy=false;this.setBusy(false,"listUl");clearTimeout(this._sBusyTimer);if(!this.getItems(true).length){this.$("nodata-text").text(this.getNoDataText());}}};
s.prototype.onItemBindingContextSet=function(i){if(!this._bSelectionMode||!this.getRememberSelections()||!this.isBound("items")){return;}if(i.isSelectedBoundTwoWay()){return;}var P=i.getBindingContextPath();if(P){var e=(this._aSelectedPaths.indexOf(P)>-1);i.setSelected(e);}};
s.prototype.onItemInserted=function(i,e){if(e){this.onItemSelectedChange(i,true);}if(!this._bSelectionMode||!this._aSelectedPaths.length||!this.getRememberSelections()||!this.isBound("items")||i.isSelectedBoundTwoWay()||i.getSelected()){return;}var P=i.getBindingContextPath();if(P&&this._aSelectedPaths.indexOf(P)>-1){i.setSelected(true);}};
s.prototype.onItemSelect=function(e,t){var M=this.getMode();if(this._mRangeSelection&&!this.bPreventMassSelection){if(!this._mRangeSelection.selected){this._fireSelectionChangeEvent([e]);this._mRangeSelection.index=this.getVisibleItems().indexOf(e);this._mRangeSelection.selected=t;return;}if(!t){e.setSelected(true);return;}var u=this.indexOfItem(e),v=this.getItems(),w,x,y=[],z;if(u<this._mRangeSelection.index){w=this._mRangeSelection.index-u;z=-1;}else{w=u-this._mRangeSelection.index;z=1;}for(var i=1;i<=w;i++){x=v[this._mRangeSelection.index+(i*z)];if(x.isSelectable()&&x.getVisible()&&!x.getSelected()){x.setSelected(true);y.push(x);}else if(x===e){y.push(x);}}this._fireSelectionChangeEvent(y);return;}if(M===o.MultiSelect){this._fireSelectionChangeEvent([e]);}else if(this._bSelectionMode&&t){this._fireSelectionChangeEvent([e]);}};
s.prototype._fireSelectionChangeEvent=function(e,i){var t=e&&e[0];if(!t){return;}this.fireSelectionChange({listItem:t,listItems:e,selected:t.getSelected(),selectAll:!!i});this.fireSelect({listItem:t});};
s.prototype.onItemDelete=function(e){this.fireDelete({listItem:e});};
s.prototype.onItemPress=function(e,i){if(e.getType()==j.Inactive){return;}setTimeout(function(){this.fireItemPress({listItem:e,srcControl:i});}.bind(this),0);};
s.prototype.onItemKeyDown=function(i,e){if(!e.shiftKey||this.getMode()!==o.MultiSelect||!i.isSelectable()||this.bPreventMassSelection){return;}var v=this.getVisibleItems(),H=v.some(function(V){return!!V.getSelected();});if(!H){return;}if(!this._mRangeSelection){this._mRangeSelection={index:v.indexOf(i),selected:i.getSelected()};}};
s.prototype.onItemKeyUp=function(i,e){if(e.which===K.SHIFT){this._mRangeSelection=null;}};
s.prototype._updateSelectedPaths=function(i,e){if(!this.getRememberSelections()||!this.isBound("items")){return;}var P=i.getBindingContextPath();if(!P){return;}e=(e===undefined)?i.getSelected():e;var t=this._aSelectedPaths.indexOf(P);if(e){t<0&&this._aSelectedPaths.push(P);}else{t>-1&&this._aSelectedPaths.splice(t,1);}};
s.prototype._destroyGrowingDelegate=function(){if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}};
s.prototype._destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
s.prototype._getTouchBlocker=function(){return this.$().children();};
s.prototype._getSwipeContainer=function(){return this._$swipeContainer||(this._$swipeContainer=q("<div>",{"id":this.getId("swp"),"class":"sapMListSwp"}));};
s.prototype._setSwipePosition=function(){if(this._isSwipeActive){return this._getSwipeContainer().css("top",this._swipedItem.$().position().top);}};
s.prototype._renderSwipeContent=function(){var $=this._swipedItem.$(),e=this._getSwipeContainer();this.$().prepend(e.css({top:$.position().top,height:$.outerHeight(true)}));if(this._bRerenderSwipeContent){this._bRerenderSwipeContent=false;var i=sap.ui.getCore().createRenderManager();i.render(this.getSwipeContent(),e.empty()[0]);i.destroy();}return this;};
s.prototype._swipeIn=function(){var t=this,$=t._getTouchBlocker(),i=t._getSwipeContainer();t._isSwipeActive=true;t._renderSwipeContent();b.addDialogInstance(t);window.document.activeElement.blur();q(window).on("resize.swp",function(){t._setSwipePosition();});$.css("pointer-events","none").on("touchstart.swp mousedown.swp",function(e){if(!i[0].firstChild.contains(e.target)){e.preventDefault();e.stopPropagation();}});i.bind("webkitAnimationEnd animationend",function(){q(this).unbind("webkitAnimationEnd animationend");i.css("opacity",1).focus();$.parent().on("touchend.swp touchcancel.swp mouseup.swp",function(e){if(!i[0].firstChild.contains(e.target)){t.swipeOut();}});}).removeClass("sapMListSwpOutAnim").addClass("sapMListSwpInAnim");};
s.prototype._onSwipeOut=function(e){this._getSwipeContainer().css("opacity",0).remove();q(window).off("resize.swp");this._getTouchBlocker().css("pointer-events","auto").off("touchstart.swp mousedown.swp");if(typeof e=="function"){e.call(this,this._swipedItem,this.getSwipeContent());}this._isSwipeActive=false;b.removeDialogInstance(this);};
s.prototype.swipeOut=function(e){if(!this._isSwipeActive){return this;}var t=this,$=this._getSwipeContainer();this._getTouchBlocker().parent().off("touchend.swp touchend.swp touchcancel.swp mouseup.swp");$.bind("webkitAnimationEnd animationend",function(){q(this).unbind("webkitAnimationEnd animationend");t._onSwipeOut(e);}).removeClass("sapMListSwpInAnim").addClass("sapMListSwpOutAnim");return this;};
s.prototype._removeSwipeContent=function(){if(this._isSwipeActive){this.swipeOut()._onSwipeOut();}};
s.prototype.close=s.prototype._removeSwipeContent;
s.prototype._onSwipe=function(e,i){var t=this.getSwipeContent(),u=e.srcControl;if(t&&u&&!this._isSwipeActive&&this!==u&&!this._eventHandledByControl&&D.support.touch){for(var v=u;v&&!(v instanceof d);v=v.oParent);if(v instanceof d){this._swipedItem=v;this.fireSwipe({listItem:this._swipedItem,swipeContent:t,srcControl:u,swipeDirection:i},true)&&this._swipeIn();}}};
s.prototype.ontouchstart=function(e){this._eventHandledByControl=e.isMarked();};
s.prototype.onswipeleft=function(e){var R=sap.ui.getCore().getConfiguration().getRTL();var i=R?S.EndToBegin:S.BeginToEnd;var t=this.getSwipeDirection();if(t===S.LeftToRight){t=S.BeginToEnd;}else if(t===S.RightToLeft){t=S.EndToBegin;}if(t!=i){if(t==S.Both){t=R?S.BeginToEnd:S.EndToBegin;}this._onSwipe(e,t);}};
s.prototype.onswiperight=function(e){var R=sap.ui.getCore().getConfiguration().getRTL();var i=R?S.BeginToEnd:S.EndToBegin;var t=this.getSwipeDirection();if(t===S.LeftToRight){t=S.BeginToEnd;}else if(t===S.RightToLeft){t=S.EndToBegin;}if(t!=i){if(t==S.Both){t=R?S.EndToBegin:S.BeginToEnd;}this._onSwipe(e,t);}};
s.prototype.setSwipeDirection=function(e){return this.setProperty("swipeDirection",e,true);};
s.prototype.getSwipedItem=function(){return(this._isSwipeActive?this._swipedItem:null);};
s.prototype.setSwipeContent=function(e){this._bRerenderSwipeContent=true;this.toggleStyleClass("sapMListSwipable",!!e);return this.setAggregation("swipeContent",e,!this._isSwipeActive);};
s.prototype.invalidate=function(O){if(O&&O===this.getSwipeContent()){this._bRerenderSwipeContent=true;this._isSwipeActive&&this._renderSwipeContent();return;}return C.prototype.invalidate.apply(this,arguments);};
s.prototype.addItemGroup=function(e,H,i){if(!H){H=new c();H.setTitle(e.text||e.key);}H._bGroupHeader=true;this.addAggregation("items",H,i);return H;};
s.prototype.removeGroupHeaders=function(e){this.getItems(true).forEach(function(i){if(i.isGroupHeader()){i.destroy(e);}});};
s.prototype.getAccessibilityType=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_LIST");};
s.prototype.getAccessibilityStates=function(){if(!this.getItems(true).length){return"";}var e="",M=o,i=this.getMode(),B=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(L.isRequired(this)){e+=B.getText("LIST_REQUIRED")+" ";}if(i==M.MultiSelect){e+=B.getText("LIST_MULTISELECTABLE")+" ";}else if(i==M.Delete){e+=B.getText("LIST_DELETABLE")+" ";}else if(i!=M.None){e+=B.getText("LIST_SELECTABLE")+" ";}if(this.isGrouped()){e+=B.getText("LIST_GROUPED")+" ";}return e;};
s.prototype.getAccessibilityDescription=function(){var e="";var H=this.getHeaderToolbar();if(H){var t=H.getTitleControl();if(t){e+=t.getText()+" ";}}else{e+=this.getHeaderText()+" ";}e+=this.getAccessibilityStates()+" ";return e;};
s.prototype.getAccessibilityInfo=function(){return{description:this.getAccessibilityDescription().trim(),focusable:true};};
s.prototype.getAccessbilityPosition=function(i){var e=0,t=this.getVisibleItems(),P=t.indexOf(i)+1,B=this.getBinding("items");if(this.getGrowing()&&this.getGrowingScrollToLoad()&&B&&B.isLengthFinal()){e=B.getLength();if(B.isGrouped()){e+=t.filter(function(i){return i.isGroupHeader()&&i.getVisible();}).length;}}else{e=t.length;}return{setSize:e,posInset:P};};
s.prototype.onItemFocusIn=function(i,F){this._handleStickyItemFocus(i.getDomRef());if(i!==F||!sap.ui.getCore().getConfiguration().getAccessibility()){return;}var e=i.getDomRef(),P=this.getAccessbilityPosition(i);if(!i.getContentAnnouncement){this.getNavigationRoot().setAttribute("aria-activedescendant",e.id);e.setAttribute("aria-posinset",P.posInset);e.setAttribute("aria-setsize",P.setSize);}else{var A=i.getAccessibilityInfo(),B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),t=A.type+" ";if(!D.browser.chrome||this.isA("sap.m.Table")){t+=B.getText("LIST_ITEM_POSITION",[P.posInset,P.setSize])+" ";}else{e.setAttribute("aria-posinset",P.posInset);e.setAttribute("aria-setsize",P.setSize);}t+=A.description;this.updateInvisibleText(t,e);return t;}};
s.prototype.updateInvisibleText=function(t,i,P){var e=s.getInvisibleText(),F=q(i||document.activeElement);if(this.bAnnounceDetails){this.bAnnounceDetails=false;t=this.getAccessibilityInfo().description+" "+t;}e.setText(t.trim());F.addAriaLabelledBy(e.getId(),P);};
s.prototype.getNavigationRoot=function(){return this.getDomRef("listUl");};
s.prototype.getFocusDomRef=function(){return this.getNavigationRoot();};
s.prototype._startItemNavigation=function(i){if(!D.system.desktop){return;}var e=this.getKeyboardMode(),t=k;if(e==t.Edit&&!this.getItems(true).length){return;}var N=this.getNavigationRoot();var T=(e==t.Edit)?-1:0;if(i&&N&&!N.contains(document.activeElement)){this._bItemNavigationInvalidated=true;if(!N.getAttribute("tabindex")){N.tabIndex=T;}return;}if(!this._oItemNavigation){this._oItemNavigation=new a();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigationTabIndex(T);this._oItemNavigation.setTableMode(true,true).setColumns(1);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});}this._oItemNavigation.setPageSize(this.getGrowingThreshold());this._oItemNavigation.setRootDomRef(N);this.setNavigationItems(this._oItemNavigation,N);this._bItemNavigationInvalidated=false;};
s.prototype.setNavigationItems=function(i,N){var e=q(N).children(".sapMLIB").get();i.setItemDomRefs(e);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==m.Upwards){i.setFocusedIndex(e.length-1);}else{i.setFocusedIndex(0);}}};
s.prototype.getItemNavigation=function(){return this._oItemNavigation;};
s.prototype._setItemNavigationTabIndex=function(t){if(this._oItemNavigation){this._oItemNavigation.iActiveTabIndex=t;this._oItemNavigation.iTabIndex=t;}};
s.prototype.setKeyboardMode=function(e){this.setProperty("keyboardMode",e,true);if(this.isActive()){var t=(e==k.Edit)?-1:0;this.$("nodata").prop("tabIndex",~t);this.$("listUl").prop("tabIndex",t);this.$("after").prop("tabIndex",t);this._setItemNavigationTabIndex(t);}return this;};
s.prototype.setItemFocusable=function(e){if(!this._oItemNavigation){return;}var i=this._oItemNavigation.getItemDomRefs();var t=i.indexOf(e.getDomRef());if(t>=0){this._oItemNavigation.setFocusedIndex(t);}};
s.prototype.forwardTab=function(F){this._bIgnoreFocusIn=true;this.$(F?"after":"before").focus();};
s.prototype.onsaptabnext=function(e){if(e.isMarked()||this.getKeyboardMode()==k.Edit){return;}if(e.target.id==this.getId("nodata")){this.forwardTab(true);e.setMarked();}};
s.prototype.onsaptabprevious=function(e){if(e.isMarked()||this.getKeyboardMode()==k.Edit){return;}var t=e.target.id;if(t==this.getId("nodata")){this.forwardTab(false);}else if(t==this.getId("trigger")){this.focusPrevious();e.preventDefault();}};
s.prototype._navToSection=function(F){var t;var i=0;var e=F?1:-1;var u=this._aNavSections.length;this._aNavSections.some(function(w,x){var y=(w?window.document.getElementById(w):null);if(y&&y.contains(document.activeElement)){i=x;return true;}});var v=this.getItemsContainerDomRef();var $=q(document.getElementById(this._aNavSections[i]));if($[0]===v&&this._oItemNavigation){$.data("redirect",this._oItemNavigation.getFocusedIndex());}this._aNavSections.some(function(){i=(i+e+u)%u;t=q(document.getElementById(this._aNavSections[i]));if(t[0]===v&&this._oItemNavigation){var R=t.data("redirect");var w=this._oItemNavigation.getItemDomRefs();var T=w[R]||v.children[0];t=q(T);}if(t.is(":focusable")){t.focus();return true;}},this);return t;};
s.prototype.onsapshow=function(e){if(e.isMarked()||e.which==K.F4||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(true)){e.preventDefault();e.setMarked();}};
s.prototype.onsaphide=function(e){if(e.isMarked()||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(false)){e.preventDefault();e.setMarked();}};
s.prototype.onkeydown=function(e){var i=(e.which==K.A)&&(e.metaKey||e.ctrlKey);if(e.isMarked()||!i||!q(e.target).hasClass(this.sNavItemClass)||this.bPreventMassSelection){return;}e.preventDefault();if(this.getMode()!==o.MultiSelect){return;}if(this.isAllSelectableSelected()){this.removeSelections(false,true);}else{this.selectAll(true);}e.setMarked();};
s.prototype.onmousedown=function(e){if(this._bItemNavigationInvalidated){this._startItemNavigation();}if(e.shiftKey&&this._mRangeSelection&&e.srcControl.getId().includes("-selectMulti")){e.preventDefault();}};
s.prototype.focusPrevious=function(){if(!this._oItemNavigation){return;}var N=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(N[i]);var R=$.control(0)||{};var t=R.getTabbables?R.getTabbables():$.find(":sapTabbable");var F=t.eq(-1).add($).eq(-1);this.bAnnounceDetails=true;F.focus();};
s.prototype.onfocusin=function(e){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;e.stopImmediatePropagation(true);return;}if(this._bItemNavigationInvalidated){this._startItemNavigation();}var t=e.target;if(t.id==this.getId("nodata")){this.updateInvisibleText(this.getNoDataText(),t);}if(e.isMarked()||!this._oItemNavigation||this.getKeyboardMode()==k.Edit||t.id!=this.getId("after")){return;}this.focusPrevious();e.setMarked();};
s.prototype.onsapfocusleave=function(e){if(this._oItemNavigation&&!this.bAnnounceDetails&&!this.getNavigationRoot().contains(document.activeElement)){this.bAnnounceDetails=true;}};
s.prototype.onItemArrowUpDown=function(e,E){var i=this.getItems(true),t=i.indexOf(e)+(E.type=="sapup"?-1:1),u=i[t];if(u&&u.isGroupHeader()){u=i[t+(E.type=="sapup"?-1:1)];}if(!u){return;}var T=u.getTabbables(),F=e.getTabbables().index(E.target),$=T.eq(T[F]?F:-1);$[0]?$.focus():u.focus();E.preventDefault();E.setMarked();};
s.prototype.onItemContextMenu=function(e,E){var i=this.getContextMenu();if(!i){return;}var t=this.fireBeforeOpenContextMenu({listItem:e,column:sap.ui.getCore().byId(q(E.target).closest(".sapMListTblCell",this.getNavigationRoot()).attr("data-sap-ui-column"))});if(t){E.setMarked();E.preventDefault();var B,u=this.getBindingInfo("items");if(u){B=e.getBindingContext(u.model);i.setBindingContext(B,u.model);}i.openAsContextMenu(E,e);}};
s.prototype.onItemUpDownModifiers=function(i,e,t){if(!this._mRangeSelection||this.bPreventMassSelection){return;}var v=this.getVisibleItems(),u=v.indexOf(i),w=v[u+t];if(!w){if(this._mRangeSelection){this._mRangeSelection=null;}e.setMarked();return;}var x=w.getSelected();if(this._mRangeSelection.direction===undefined){this._mRangeSelection.direction=t;}else if(this._mRangeSelection.direction!==t){if(this._mRangeSelection.index!==v.indexOf(i)){w=i;x=w.getSelected();if(this._mRangeSelection.selected&&x){this.setSelectedItem(w,false,true);return;}}else{this._mRangeSelection.direction=t;}}if(this._mRangeSelection.selected!==x&&w.isSelectable()){this.setSelectedItem(w,this._mRangeSelection.selected,true);}};
s.prototype.isGrouped=function(){var B=this.getBinding("items");return B&&B.isGrouped();};
s.prototype.setContextMenu=function(e){this.setAggregation("contextMenu",e,true);return this;};
s.prototype.destroyContextMenu=function(){this.destroyAggregation("contextMenu",true);return this;};
s.getStickyBrowserSupport=function(){var B=D.browser;return(B.safari||B.chrome||(B.firefox&&B.version>=59)||(B.edge&&B.version>=16));};
s.prototype.getStickyStyleValue=function(){var e=this.getSticky();if(!e||!e.length||!s.getStickyBrowserSupport()){return(this._iStickyValue=0);}var i=0,H=this.getHeaderText(),t=this.getHeaderToolbar(),u=H||(t&&t.getVisible()),v=this.getInfoToolbar(),w=v&&v.getVisible(),x=false;if(this.isA("sap.m.Table")){x=this.getColumns().some(function(y){return y.getVisible()&&y.getHeader();});}e.forEach(function(y){if(y===r.HeaderToolbar&&u){i+=1;}else if(y===r.InfoToolbar&&w){i+=2;}else if(y===r.ColumnHeaders&&x){i+=4;}});return(this._iStickyValue=i);};
s.prototype._handleStickyItemFocus=function(i){if(!this._iStickyValue||this._sLastFocusedStickyItemId===i.id){return;}var e=l.getScrollDelegate(this,true);if(!e){return;}var t=0,T=0,u=0,v=0,H=0,w=0;if(this._iStickyValue&4){var x=this.getDomRef("tblHeader").firstChild;var y=x.getBoundingClientRect();T=parseInt(y.bottom);t=parseInt(y.height);}if(this._iStickyValue&2){var z=this.getDomRef().querySelector(".sapMListInfoTBarContainer");if(z){var A=z.getBoundingClientRect();v=parseInt(A.bottom);u=parseInt(A.height);}}if(this._iStickyValue&1){var B=this.getDomRef().querySelector(".sapMListHdr");if(B){var E=B.getBoundingClientRect();w=parseInt(E.bottom);H=parseInt(E.height);}}var F=Math.round(i.getBoundingClientRect().top);if(T>F||v>F||w>F){window.requestAnimationFrame(function(){e.scrollToElement(i,0,[0,-t-u-H]);});}this._sLastFocusedStickyItemId=i.id;};
s.prototype.setHeaderToolbar=function(H){return this._setToolbar("headerToolbar",H);};
s.prototype.setInfoToolbar=function(i){return this._setToolbar("infoToolbar",i);};
s.prototype._setToolbar=function(A,t){var O=this.getAggregation(A);if(O){O.detachEvent("_change",this._onToolbarPropertyChanged,this);}this.setAggregation(A,t);if(t){t.attachEvent("_change",this._onToolbarPropertyChanged,this);}return this;};
s.prototype._onToolbarPropertyChanged=function(e){if(e.getParameter("name")!=="visible"){return;}var O=this._iStickyValue,N=this.getStickyStyleValue();if(O!==N){var i=this.getDomRef();if(i){var t=i.classList;t.toggle("sapMSticky",!!N);t.remove("sapMSticky"+O);t.toggle("sapMSticky"+N,!!N);}}};
return s;});
sap.ui.predefine('sap/m/ListBaseRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/InvisibleText","./ListItemBaseRenderer"],function(l,D,I,L){"use strict";var a=l.ListGrowingDirection;var b=l.ListKeyboardMode;var T=l.ToolbarDesign;var c={apiVersion:2};c.ModeOrder={None:0,Delete:1,MultiSelect:-1,SingleSelect:1,SingleSelectLeft:-1,SingleSelectMaster:0};
c.render=function(r,C){r.openStart("div",C);r.class("sapMList");if(C.getInset()){r.class("sapMListInsetBG");}r.style("width",C.getWidth());if(C.getBackgroundDesign){r.class("sapMListBG"+C.getBackgroundDesign());}var t=C.getTooltip_AsString();if(t){r.attr("title",t);}this.renderContainerAttributes(r,C);r.openEnd();var h=C.getHeaderText();var H=C.getHeaderToolbar();if(H){H.setDesign(T.Transparent,true);H.addStyleClass("sapMListHdr");H.addStyleClass("sapMListHdrTBar");H.addStyleClass("sapMTBHeader-CTX");r.renderControl(H);}else if(h){r.openStart("header",C.getId("header"));r.class("sapMListHdr").class("sapMListHdrText").openEnd();r.text(h);r.close("header");}var o=C.getInfoToolbar();if(o){o.setDesign(T.Info,true);o.addStyleClass("sapMListInfoTBar");r.openStart("div").class("sapMListInfoTBarContainer").openEnd();r.renderControl(o);r.close("div");}var d=C.getItems(),s=C.getShowNoData(),R=C.shouldRenderItems()&&d.length,e=C.getKeyboardMode()==b.Edit?-1:0,u=C.getGrowingDirection()==a.Upwards&&C.getGrowing();if(u){this.renderGrowing(r,C);}if(R||s){this.renderDummyArea(r,C,"before",-1);}this.renderListStartAttributes(r,C);r.accessibilityState(C,this.getAccessibilityState(C));r.class("sapMListUl");if(C._iItemNeedsHighlight){r.class("sapMListHighlight");}if(R||s){r.attr("tabindex",e);}r.class("sapMListShowSeparators"+C.getShowSeparators());r.class("sapMListMode"+C.getMode());if(C._iItemNeedsNavigated){r.class("sapMListNavigated");}r.openEnd();this.renderListHeadAttributes(r,C);if(R){if(u){d.reverse();}for(var i=0;i<d.length;i++){r.renderControl(d[i]);}}if(!R&&s){this.renderNoData(r,C);}this.renderListEndAttributes(r,C);if(R||s){this.renderDummyArea(r,C,"after",e);}if(!u){this.renderGrowing(r,C);}if(C.getFooterText()){r.openStart("footer",C.getId("footer")).class("sapMListFtr").openEnd();r.text(C.getFooterText());r.close("footer");}r.close("div");};
c.renderContainerAttributes=function(r,C){var s=C.getStickyStyleValue();if(s){r.class("sapMSticky");r.class("sapMSticky"+s);}};
c.renderListHeadAttributes=function(r,C){};
c.renderListStartAttributes=function(r,C){r.openStart("ul",C.getId("listUl"));r.class("sapMListItems");C.addNavSection(C.getId("listUl"));};
c.getAriaRole=function(C){return"listbox";};
c.getAriaLabelledBy=function(C){};
c.getAriaDescribedBy=function(C){if(C.getFooterText()){return C.getId("footer");}};
c.getAccessibilityState=function(C){var r=this.getAriaRole(C);return{role:r,multiselectable:(r&&C._bSelectionMode)?C.getMode()=="MultiSelect":undefined,labelledby:{value:this.getAriaLabelledBy(C),append:true},describedby:{value:this.getAriaDescribedBy(C),append:true}};};
c.renderListEndAttributes=function(r,C){r.close("ul");};
c.renderNoData=function(r,C){r.openStart("li",C.getId("nodata"));r.attr("tabindex",C.getKeyboardMode()==b.Navigation?-1:0);r.class("sapMLIB").class("sapMListNoData").class("sapMLIBTypeInactive");L.addFocusableClasses.call(L,r);r.openEnd();r.openStart("div",C.getId("nodata-text")).class("sapMListNoDataText").openEnd();r.text(C.getNoDataText(true));r.close("div");r.close("li");};
c.renderDummyArea=function(r,C,A,t){r.openStart("div",C.getId(A)).attr("tabindex",t);if(D.system.desktop){r.class("sapMListDummyArea");}r.openEnd().close("div");};
c.renderGrowing=function(r,C){var g=C._oGrowingDelegate;if(g){g.render(r);}};
c.getAriaAnnouncement=function(B){return I.getStaticId("sap.m",B);};
return c;},true);
sap.ui.predefine('sap/m/ListItemBase',["sap/ui/base/DataType","sap/ui/events/KeyCodes","sap/ui/model/BindingMode","sap/ui/Device","sap/ui/core/library","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/Icon","sap/ui/core/theming/Parameters","./library","./Button","./CheckBox","./RadioButton","./ListItemBaseRenderer","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(D,K,B,a,c,C,I,b,T,l,d,e,R,L,f,q){"use strict";var g=l.ListKeyboardMode;var h=l.ListMode;var i=l.ListType;var j=l.ButtonType;var M=c.MessageType;
var k=C.extend("sap.m.ListItemBase",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.ListType",group:"Misc",defaultValue:i.Inactive},visible:{type:"boolean",group:"Appearance",defaultValue:true},unread:{type:"boolean",group:"Misc",defaultValue:false},selected:{type:"boolean",defaultValue:false},counter:{type:"int",group:"Misc",defaultValue:null},highlight:{type:"string",group:"Appearance",defaultValue:"None"},highlightText:{type:"string",group:"Misc",defaultValue:""},navigated:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},detailTap:{deprecated:true},press:{},detailPress:{}},designtime:"sap/m/designtime/ListItemBase.designtime"}});
k.getAccessibilityText=function(o,m){if(!o||!o.getVisible||!o.getVisible()){return"";}var A;if(o.getAccessibilityInfo){A=o.getAccessibilityInfo();}if(!A||!o.getAccessibilityInfo){A=this.getDefaultAccessibilityInfo(o.getDomRef());}A=q.extend({type:"",description:"",children:[]},A);var n=sap.ui.getCore().getLibraryResourceBundle("sap.m"),t=A.type+" "+A.description+" ",s=o.getTooltip_AsString();if(A.enabled===false){t+=n.getText("CONTROL_DISABLED")+" ";}if(A.editable===false){t+=n.getText("CONTROL_READONLY")+" ";}if(!A.type&&s&&t.indexOf(s)==-1){t=s+" "+t;}A.children.forEach(function(p){t+=k.getAccessibilityText(p)+" ";});t=t.trim();if(m&&!t){t=n.getText("CONTROL_EMPTY");}return t;};
k.getDefaultAccessibilityInfo=function(o){if(!o){return null;}var N=window.Node,m=window.NodeFilter,t=document.createTreeWalker(o,m.SHOW_TEXT+m.SHOW_ELEMENT,function(p){if(p.type===N.ELEMENT_NODE){if(p.classList.contains("sapUiInvisibleText")){return m.FILTER_SKIP;}if(p.getAttribute("aria-hidden")=="true"||p.style.visibility=="hidden"||p.style.display=="none"){return m.FILTER_REJECT;}return m.FILTER_SKIP;}return m.FILTER_ACCEPT;},false);var n=[];while(t.nextNode()){var p=t.currentNode;if(p.nodeType===N.TEXT_NODE){var s=(p.nodeValue||"").trim();if(s){n.push(s);}}}return{description:n.join(" ")};};
k.prototype.DetailIconURI=I.getIconURI("edit");k.prototype.NavigationIconURI=I.getIconURI("slim-arrow-right");k.prototype.TagName="li";
k.prototype.init=function(){this._active=false;this._bGroupHeader=false;this._bNeedsHighlight=false;this._bNeedsNavigated=false;};
k.prototype.onAfterRendering=function(){this.informList("DOMUpdate",true);this._checkHighlight();this._checkNavigated();};
k.prototype.invalidate=function(){if(!this.bOutput){return;}C.prototype.invalidate.apply(this,arguments);};
k.prototype.getBindingContextPath=function(m){var o=this.getList();if(o&&!m){m=(o.getBindingInfo("items")||{}).model;}var n=this.getBindingContext(m);if(n){return n.getPath();}};
k.prototype.isSelectedBoundTwoWay=function(){var o=this.getBinding("selected");if(o&&o.getBindingMode()==B.TwoWay){return true;}};
k.prototype.getList=function(){var p=this.getParent();if(p&&p.isA("sap.m.ListBase")){return p;}};
k.prototype.getListProperty=function(p,F){var o=this.getList();if(o){p=f(p);return o["get"+p]();}return F;};
k.prototype.informList=function(E,p,P){var o=this.getList();if(o){var m="onItem"+E;if(o[m]){o[m](this,p,P);}}};
k.prototype.informSelectedChange=function(s){var o=this.getList();if(o){o.onItemSelectedChange(this,s);this.bSelectedDelayed=undefined;}else{this.bSelectedDelayed=s;}};
k.prototype.getAccessibilityType=function(o){return o.getText("ACC_CTR_TYPE_OPTION");};
k.prototype.getGroupAnnouncement=function(){return this.$().prevAll(".sapMGHLI:first").text();};
k.prototype.getAccessibilityDescription=function(o){var O=[],t=this.getType(),H=this.getHighlight(),s=this.getTooltip_AsString();if(this.getSelected()){O.push(o.getText("LIST_ITEM_SELECTED"));}if(H!==M.None){var m=this.getHighlightText();if(H in M&&!m){m=o.getText("LIST_ITEM_STATE_"+H.toUpperCase());}O.push(m);}if(this.getUnread()&&this.getListProperty("showUnread")){O.push(o.getText("LIST_ITEM_UNREAD"));}if(this.getCounter()){O.push(o.getText("LIST_ITEM_COUNTER",this.getCounter()));}if(t==i.Navigation){O.push(o.getText("LIST_ITEM_NAVIGATION"));}else{if(t==i.Detail||t==i.DetailAndActive){O.push(o.getText("LIST_ITEM_DETAIL"));}if(t==i.Active||t==i.DetailAndActive){O.push(o.getText("LIST_ITEM_ACTIVE"));}}O.push(this.getGroupAnnouncement()||"");if(this.getContentAnnouncement){O.push((this.getContentAnnouncement(o)||"").trim());}if(s){O.push(s);}if(this.getNavigated()){O.push(o.getText("LIST_ITEM_NAVIGATED"));}return O.join(" ");};
k.prototype.getAccessibilityInfo=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{type:this.getAccessibilityType(o),description:this.getAccessibilityDescription(o),focusable:true};};
k.prototype.getMode=function(){return this.getListProperty("mode","");};
k.prototype.updateAccessibilityState=function(A){var t=this.$();if(!t.length){return;}var $=t.parent().children(".sapMLIB");t.attr(q.extend({"aria-setsize":$.length,"aria-posinset":$.index(t)+1},A));};
k.prototype.getDeleteControl=function(m){if(!m||this._oDeleteControl){return this._oDeleteControl;}if(!this.DeleteIconURI){k.prototype.DeleteIconURI=I.getIconURI(T.get("_sap_m_ListItemBase_DeleteIcon"));}this._oDeleteControl=new d({id:this.getId()+"-imgDel",icon:this.DeleteIconURI,type:j.Transparent,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_DELETE")}).addStyleClass("sapMLIBIconDel sapMLIBSelectD").setParent(this,null,true).attachPress(function(E){this.informList("Delete");},this);this._oDeleteControl._bExcludeFromTabChain=true;return this._oDeleteControl;};
k.prototype.onThemeChanged=function(){k.prototype.DeleteIconURI=I.getIconURI(T.get("_sap_m_ListItemBase_DeleteIcon"));if(this._oDeleteControl){this._oDeleteControl.setIcon(this.DeleteIconURI);}};
k.prototype.getDetailControl=function(m){if(!m||this._oDetailControl){return this._oDetailControl;}this._oDetailControl=new d({id:this.getId()+"-imgDet",icon:this.DetailIconURI,type:j.Transparent,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_EDIT")}).addStyleClass("sapMLIBType sapMLIBIconDet").setParent(this,null,true).attachPress(function(){this.fireDetailTap();this.fireDetailPress();},this);this._oDetailControl._bExcludeFromTabChain=true;return this._oDetailControl;};
k.prototype.getNavigationControl=function(m){if(!m||this._oNavigationControl){return this._oNavigationControl;}this._oNavigationControl=new b({id:this.getId()+"-imgNav",src:this.NavigationIconURI,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMLIBType sapMLIBImgNav");return this._oNavigationControl;};
k.prototype.getSingleSelectControl=function(m){if(!m||this._oSingleSelectControl){m&&this._oSingleSelectControl.setSelected(this.getSelected());return this._oSingleSelectControl;}this._oSingleSelectControl=new R({id:this.getId()+"-selectSingle",groupName:this.getListProperty("id")+"_selectGroup",activeHandling:false,selected:this.getSelected()}).addStyleClass("sapMLIBSelectS").setParent(this,null,true).setTabIndex(-1).attachSelect(function(E){var s=E.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);return this._oSingleSelectControl;};
k.prototype.getMultiSelectControl=function(m){if(!m||this._oMultiSelectControl){m&&this._oMultiSelectControl.setSelected(this.getSelected());return this._oMultiSelectControl;}this._oMultiSelectControl=new e({id:this.getId()+"-selectMulti",activeHandling:false,selected:this.getSelected()}).addStyleClass("sapMLIBSelectM").setParent(this,null,true).setTabIndex(-1).addEventDelegate({onkeydown:function(E){this.informList("KeyDown",E);},onkeyup:function(E){this.informList("KeyUp",E);}},this).attachSelect(function(E){var s=E.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);return this._oMultiSelectControl;};
k.prototype.getModeControl=function(m){var s=this.getMode();if(!s||s==h.None){return;}if(s==h.Delete){return this.getDeleteControl(m);}if(s==h.MultiSelect){return this.getMultiSelectControl(m);}return this.getSingleSelectControl(m);};
k.prototype.getTypeControl=function(m){var t=this.getType();if(t==i.Detail||t==i.DetailAndActive){return this.getDetailControl(m);}if(t==i.Navigation){return this.getNavigationControl(m);}};
k.prototype.destroyControls=function(m){m.forEach(function(s){s="_o"+s+"Control";if(this[s]){this[s].destroy("KeepDom");this[s]=null;}},this);};
k.prototype.isActionable=function(){return this.isIncludedIntoSelection()||(this.getType()!=i.Inactive&&this.getType()!=i.Detail);};
k.prototype.exit=function(){this._oLastFocused=null;this._checkHighlight(false);this._checkNavigated(false);this.setActive(false);this.destroyControls(["Delete","SingleSelect","MultiSelect","Detail","Navigation"]);};
k.prototype.setHighlight=function(v){if(v==null){v=M.None;}else if(!D.getType("sap.ui.core.MessageType").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error('"'+v+'" is not a value of the enums sap.ui.core.MessageType or sap.ui.core.IndicationColor for property "highlight" of '+this);}return this.setProperty("highlight",v);};
k.prototype.isSelectable=function(){var m=this.getMode();return!(m==h.None||m==h.Delete);};
k.prototype.getSelected=function(){if(this.isSelectable()){return this.getProperty("selected");}return false;};
k.prototype.isSelected=k.prototype.getSelected;
k.prototype.setSelected=function(s,m){s=this.validateProperty("selected",s);if(!this.isSelectable()||s==this.getSelected()){return this;}if(!m){this.informSelectedChange(s);}var S=this.getModeControl();if(S){S.setSelected(s);}this.updateSelectedDOM(s,this.$());this.setProperty("selected",s,true);return this;};
k.prototype.updateSelectedDOM=function(s,t){t.toggleClass("sapMLIBSelected",s);t.attr("aria-selected",s);};
k.prototype.setParent=function(p){C.prototype.setParent.apply(this,arguments);if(!p){this._bGroupHeader=false;return;}this.informList("Inserted",this.bSelectedDelayed);return this;};
k.prototype.setBindingContext=function(){C.prototype.setBindingContext.apply(this,arguments);this.informList("BindingContextSet");return this;};
k.prototype.isGroupHeader=function(){return this._bGroupHeader;};
k.prototype.isIncludedIntoSelection=function(){if(!this.isSelectable()){return false;}var m=this.getMode();return m==h.SingleSelectMaster||(this.getListProperty("includeItemInSelection")&&(m==h.SingleSelectLeft||m==h.SingleSelect||m==h.MultiSelect));};
k.prototype._checkHighlight=function(n){if(n==undefined){n=(this.getVisible()&&this.getHighlight()!=M.None);}if(this._bNeedsHighlight!=n){this._bNeedsHighlight=n;this.informList("HighlightChange",n);}};
k.prototype._checkNavigated=function(n){if(n==undefined){n=(this.getVisible()&&this.getNavigated());}if(this._bNeedsNavigated!=n){this._bNeedsNavigated=n;this.informList("NavigatedChange",n);}};
k.prototype.hasActiveType=function(){var t=this.getType();return(t==i.Active||t==i.Navigation||t==i.DetailAndActive);};
k.prototype.setActive=function(A){if(A==this._active){return this;}if(A&&this.getListProperty("activeItem")){return this;}var t=this.$();this._active=A;this._activeHandling(t);if(this.getType()==i.Navigation){this._activeHandlingNav(t);}if(A){this._activeHandlingInheritor(t);}else{this._inactiveHandlingInheritor(t);}this.informList("ActiveChange",A);};
k.detectTextSelection=function(o){var s=window.getSelection(),t=s.toString().replace("\n","");return t&&q.contains(o,s.focusNode);};
k.prototype.ontap=function(E){if(this._eventHandledByControl){return E.setMarked();}if(k.detectTextSelection(this.getDomRef())){return;}if(this.isIncludedIntoSelection()){if(this.getMode()==h.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}}else if(this.hasActiveType()){window.clearTimeout(this._timeoutIdStart);window.clearTimeout(this._timeoutIdEnd);this.setActive(true);if(a.os.ios){this.focus();}setTimeout(function(){this.setActive(false);}.bind(this),180);setTimeout(function(){this.fireTap();this.firePress();}.bind(this),0);}this.informList("Press",E.srcControl);};
k.prototype.ontouchstart=function(E){this._eventHandledByControl=E.isMarked();var t=E.targetTouches[0];this._touchedY=t.clientY;this._touchedX=t.clientX;if(this._eventHandledByControl||E.touches.length!=1||!this.hasActiveType()){return;}this._timeoutIdStart=setTimeout(function(){this.setActive(true);}.bind(this),100);};
k.prototype.ontouchmove=function(E){if((this._active||this._timeoutIdStart)&&(Math.abs(this._touchedY-E.targetTouches[0].clientY)>10||Math.abs(this._touchedX-E.targetTouches[0].clientX)>10)){clearTimeout(this._timeoutIdStart);this._timeoutIdStart=null;this._timeoutIdEnd=null;this.setActive(false);}};
k.prototype.ontouchend=function(E){if(E.targetTouches.length==0&&this.hasActiveType()){this._timeoutIdEnd=setTimeout(function(){this.setActive(false);}.bind(this),100);}};
k.prototype.ontouchcancel=k.prototype.ontouchend;
k.prototype._activeHandlingNav=function(){};
k.prototype._activeHandlingInheritor=function(){};
k.prototype._inactiveHandlingInheritor=function(){};
k.prototype._activeHandling=function(t){t.toggleClass("sapMLIBActive",this._active);if(a.system.desktop&&this.isActionable()){t.toggleClass("sapMLIBHoverable",!this._active);}};
k.prototype.onsapspace=function(E){if(E.srcControl!==this){return;}E.preventDefault();if(E.isMarked()||!this.isSelectable()){return;}if(this.getMode()==h.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}E.setMarked();};
k.prototype.onsapenter=function(E){var o=this.getList();if(E.isMarked()||!o){return;}if(E.srcControl!==this&&o.getKeyboardMode()==g.Edit){o.setKeyboardMode(g.Navigation);this._switchFocus(E);return;}if(E.srcControl!==this){return;}if(this.isIncludedIntoSelection()){this.onsapspace(E);}else if(this.hasActiveType()){E.setMarked();this.setActive(true);setTimeout(function(){this.setActive(false);}.bind(this),180);setTimeout(function(){this.fireTap();this.firePress();}.bind(this),0);}o.onItemPress(this,E.srcControl);};
k.prototype.onsapdelete=function(E){if(E.isMarked()||E.srcControl!==this||this.getMode()!=h.Delete){return;}this.informList("Delete");E.preventDefault();E.setMarked();};
k.prototype._switchFocus=function(E){var o=this.getList();if(!o){return;}var t=this.getTabbables();if(E.srcControl!==this){o._iLastFocusPosOfItem=t.index(E.target);this.focus();}else if(t.length){var F=o._iLastFocusPosOfItem||0;F=t[F]?F:-1;t.eq(F).focus();}E.preventDefault();E.setMarked();};
k.prototype.onkeydown=function(E){if(E.isMarked()){return;}if(E.which==K.F7){this._switchFocus(E);return;}if(E.which==K.F2){if(E.srcControl===this&&this.getType().indexOf("Detail")==0&&this.hasListeners("detailPress")||this.hasListeners("detailTap")){this.fireDetailTap();this.fireDetailPress();E.preventDefault();E.setMarked();}else{var o=this.getList();if(o){this.$().prop("tabIndex",-1);o.setKeyboardMode(o.getKeyboardMode()==g.Edit?g.Navigation:g.Edit);this._switchFocus(E);}}}if(E.srcControl!==this){return;}this.informList("KeyDown",E);};
k.prototype.onkeyup=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("KeyUp",E);};
k.prototype.onsapupmodifiers=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("UpDownModifiers",E,-1);};
k.prototype.onsapdownmodifiers=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("UpDownModifiers",E,1);};
k.prototype.getTabbables=function(){return this.$().find(":sapTabbable");};
k.prototype.onsaptabnext=function(E){var o=this.getList();if(!o||E.isMarked()||o.getKeyboardMode()==g.Edit){return;}var m=this.getTabbables().get(-1)||this.getDomRef();if(E.target===m){o.forwardTab(true);E.setMarked();}};
k.prototype.onsaptabprevious=function(E){var o=this.getList();if(!o||E.isMarked()||o.getKeyboardMode()==g.Edit){return;}if(E.target===this.getDomRef()){o.forwardTab(false);E.setMarked();}};
k.prototype.onfocusin=function(E){var o=this.getList();if(!o||E.isMarked()){return;}this.informList("FocusIn",E.srcControl);if(E.srcControl===this){return;}if(o.getKeyboardMode()==g.Edit||!q(E.target).is(":sapFocusable")){return;}setTimeout(o["setItemFocusable"].bind(o,this),0);E.setMarked();};
k.prototype.onsapup=function(E){if(E.isMarked()||E.srcControl===this||this.getListProperty("keyboardMode")===g.Navigation){return;}this.informList("ArrowUpDown",E);};
k.prototype.oncontextmenu=function(E){if(this._bGroupHeader){return;}if(q(document.activeElement).is(":focusable")&&document.activeElement!==this.getDomRef()&&E.srcControl!==this.getModeControl()){return;}this.informList("ContextMenu",E);};
k.prototype.onsapdown=k.prototype.onsapup;return k;});
sap.ui.predefine('sap/m/ListItemBaseRenderer',["./library","sap/ui/core/Core","sap/ui/Device","sap/ui/core/InvisibleText","sap/ui/core/InvisibleRenderer"],function(l,C,D,I,a){"use strict";var L=l.ListType;var b=l.ListMode;var c={apiVersion:2};
c.renderInvisible=function(r,o){a.render(r,o,o.TagName);};
c.renderHighlight=function(r,o){var h=o.getHighlight();if(h=="None"){return;}r.openStart("div");r.class("sapMLIBHighlight");r.class("sapMLIBHighlight"+h);r.openEnd();r.close("div");};
c.isModeMatched=function(m,o){var O=(sap.ui.require("sap/m/ListBaseRenderer")||{}).ModeOrder||{};return O[m]==o;};
c.renderMode=function(r,o,O){var m=o.getMode();if(!this.isModeMatched(m,O)){return;}var M=o.getModeControl(true);if(M){this.renderModeContent(r,o,M);}};
c.renderModeContent=function(r,o,m){this.decorateMode(m,o);r.renderControl(m);};
c.decorateMode=function(m,o){m.removeStyleClass("sapMLIBSelectAnimation sapMLIBUnselectAnimation");if(!C.getConfiguration().getAnimation()||!o.getListProperty("modeAnimationOn")){return;}var M=o.getMode(),s=o.getListProperty("lastMode");if(!s||s==M){return;}if(M==b.None){m.addStyleClass("sapMLIBUnselectAnimation");}else{m.addStyleClass("sapMLIBSelectAnimation");}};
c.renderCounter=function(r,o){var i=o.getCounter();if(i){this.renderCounterContent(r,o,i);}};
c.renderCounterContent=function(r,o,i){r.openStart("div",o.getId()+"-counter");r.attr("aria-label",C.getLibraryResourceBundle("sap.m").getText("LIST_ITEM_COUNTER",i));r.class("sapMLIBCounter");r.openEnd();r.text(i);r.close("div");};
c.renderType=function(r,o){var t=o.getTypeControl(true);if(t){r.renderControl(t);}};
c.openItemTag=function(r,o){r.openStart(o.TagName,o);};
c.closeItemTag=function(r,o){r.close(o.TagName);};
c.renderTabIndex=function(r,o){r.attr("tabindex","-1");};
c.renderTooltip=function(r,o){var t=o.getTooltip_AsString();if(t){r.attr("title",t);}};
c.addFocusableClasses=function(r,o){if(D.system.desktop){r.class("sapMLIBFocusable");this.addLegacyOutlineClass(r,o);}};
c.addLegacyOutlineClass=function(r,o){if(D.browser.msie||D.browser.edge){r.class("sapMLIBLegacyOutline");}};
c.getAriaAnnouncement=function(k,B){return I.getStaticId("sap.m",B||"LIST_ITEM_"+k.toUpperCase());};
c.getAriaRole=function(o){return"option";};
c.getAriaLabelledBy=function(o){if(!o.getContentAnnouncement&&o.getAriaLabelledBy().length){return o.getId();}};
c.getAriaDescribedBy=function(o){if(o.getContentAnnouncement){return"";}var d=[],t=o.getType();if(o.getListProperty("showUnread")&&o.getUnread()){d.push(this.getAriaAnnouncement("unread"));}if(o.getMode()==b.Delete){d.push(this.getAriaAnnouncement("delete"));}if(t==L.Navigation){d.push(this.getAriaAnnouncement("navigation"));}else{if(t==L.Detail||t==L.DetailAndActive){d.push(this.getAriaAnnouncement("detail"));}if(t==L.Active||t==L.DetailAndActive){d.push(this.getAriaAnnouncement("active"));}}return d.join(" ");};
c.getAccessibilityState=function(o){var A=this.getAriaLabelledBy(o),s=this.getAriaDescribedBy(o),m={role:this.getAriaRole(o)};if(o.isSelectable()){m.selected=o.getProperty("selected");}if(A){m.labelledby={value:A.trim(),append:true};}if(s){m.describedby={value:s.trim(),append:true};}return m;};
c.renderLIContent=function(r,o){};
c.renderLIAttributes=function(r,o){};
c.renderContentFormer=function(r,o){this.renderHighlight(r,o);this.renderMode(r,o,-1);};
c.renderContentLatter=function(r,o){this.renderCounter(r,o);this.renderType(r,o);this.renderMode(r,o,1);this.renderNavigated(r,o);};
c.renderLIContentWrapper=function(r,o){r.openStart("div",o.getId()+"-content").class("sapMLIBContent").openEnd();this.renderLIContent(r,o);r.close("div");};
c.renderNavigated=function(r,o){if(!o.getNavigated()){return;}r.openStart("div");r.class("sapMLIBNavigated");r.openEnd();r.close("div");};
c.render=function(r,o){if(!o.getVisible()){this.renderInvisible(r,o);return false;}this.openItemTag(r,o);r.class("sapMLIB");r.class("sapMLIB-CTX");r.class("sapMLIBShowSeparator");r.class("sapMLIBType"+o.getType());if(D.system.desktop&&o.isActionable()){r.class("sapMLIBActionable");r.class("sapMLIBHoverable");}if(o.getSelected()){r.class("sapMLIBSelected");}if(o.getListProperty("showUnread")&&o.getUnread()){r.class("sapMLIBUnread");}this.addFocusableClasses(r,o);this.renderTooltip(r,o);this.renderTabIndex(r,o);if(C.getConfiguration().getAccessibility()){r.accessibilityState(o,this.getAccessibilityState(o));}this.renderLIAttributes(r,o);r.openEnd();this.renderContentFormer(r,o);this.renderLIContentWrapper(r,o);this.renderContentLatter(r,o);this.closeItemTag(r,o);};
return c;},true);
sap.ui.predefine('sap/m/ListRenderer',["sap/ui/core/Renderer","./ListBaseRenderer"],function(R,L){"use strict";var a=R.extend(L);a.apiVersion=2;return a;},true);
sap.ui.predefine('sap/m/MaskEnabler',['sap/ui/core/Control','./InputBase','sap/ui/Device','sap/ui/core/library',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/thirdparty/jquery","sap/m/MaskInputRule","sap/ui/dom/jquery/cursorPos"],function(C,I,D,c,K,L,q,M){"use strict";var T=c.TextDirection;var a=function(){var E='^';this.init=a.init=function(){I.prototype.init.call(this);this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;this._setDefaultRules();this._setupMaskVariables();};this.exit=a.exit=function(){this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;};this.onBeforeRendering=function(){if(this._isMaskEnabled()){var v=this._validateDependencies();if(v){L.warning("Invalid mask input: "+v);}}I.prototype.onBeforeRendering.apply(this,arguments);};this.onAfterRendering=function(){I.prototype.onAfterRendering.apply(this,arguments);};this.onfocusin=a.onfocusin=function(e){this._sOldInputValue=this._getInputValue();I.prototype.onfocusin.apply(this,arguments);if(this._isMaskEnabled()){if(!this._oTempValue.differsFromOriginal()||!this._isValidInput(this._sOldInputValue)){this._applyMask();}this._positionCaret(true);}};this.onfocusout=function(e){if(this._isMaskEnabled()){this.bFocusoutDueRendering=this.bRenderingPhase;this.$().toggleClass("sapMFocus",false);q(document).off('.sapMIBtouchstart');if(this.bRenderingPhase){return;}this.closeValueStateMessage();this._inputCompletedHandler();}else{this._inputCompletedHandlerNoMask();I.prototype.onfocusout.apply(this,arguments);}};this.oninput=function(e){if(this._isChromeOnAndroid()){this._onInputForAndroidHandler(e);return;}I.prototype.oninput.apply(this,arguments);if(this._isMaskEnabled()){this._applyMask();this._positionCaret(false);}};this.onkeypress=function(e){if(this._isMaskEnabled()){this._keyPressHandler(e);}};this.onkeydown=a.onkeydown=function(e){if(this._isMaskEnabled()){var k=this._parseKeyBoardEvent(e);I.prototype.onkeydown.apply(this,arguments);this._keyDownHandler(e,k);}else{var k=this._parseKeyBoardEvent(e);if(k.bEnter){this._inputCompletedHandlerNoMask();}I.prototype.onkeydown.apply(this,arguments);}};this.onsapenter=function(e){};this.onsapfocusleave=function(e){};this.setValue=a.setValue=function(v){v=this.validateProperty('value',v);I.prototype.setValue.call(this,v);this._sOldInputValue=v;if(this._isMaskEnabled()){if(!this._oTempValue){this._setupMaskVariables();}if(this._oTempValue._aInitial.join('')!==v){this._applyRules(v);}}return this;};this.addAggregation=function(A,o,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.addAggregation.apply(this,arguments);if(!this._bSkipSetupMaskVariables){this._setupMaskVariables();}return this;}return C.prototype.addAggregation.apply(this,arguments);};this.insertAggregation=function(A,o,i,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.insertAggregation.apply(this,arguments);this._setupMaskVariables();return this;}return C.prototype.insertAggregation.apply(this,arguments);};this._validateRegexAgainstPlaceHolderSymbol=function(r){if(new RegExp(r.getRegex()).test(this.getPlaceholderSymbol())){L.error("Rejecting input mask rule because it includes the currently set placeholder symbol.");return false;}return true;};this.setPlaceholderSymbol=function(s){var S;if(!/^.$/i.test(s)){L.error("Invalid placeholder symbol string given");return this;}S=this.getRules().some(function(r){return new RegExp(r.getRegex()).test(s);});if(S){L.error("Rejecting placeholder symbol because it is included as a regex in an existing mask input rule.");}else{this.setProperty("placeholderSymbol",s);this._setupMaskVariables();}return this;};this.setMask=function(m){if(!m){var e="Setting an empty mask is pointless. Make sure you set it with a non-empty value.";L.warning(e);return this;}this.setProperty("mask",m,true);this._setupMaskVariables();return this;};this._isCharAllowed=function(s,i){return this._oRules.applyCharAt(s,i);};this._feedReplaceChar=function(s,p,e){return s;};this._inputCompletedHandlerNoMask=function(){var v=this._getInputValue();if(this._sOldInputValue!==v){I.prototype.setValue.call(this,this._getAlteredUserInputValue?this._getAlteredUserInputValue(v):v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};var b=function(e){this._aInitial=e.slice(0);this._aContent=e;};b.prototype.setCharAt=function(s,p){this._aContent[p]=s;};b.prototype.charAt=function(p){return this._aContent[p];};b.prototype.toString=function(){return this._aContent.join('');};b.prototype.differsFromOriginal=function(){return this.differsFrom(this._aInitial);};b.prototype.differsFrom=function(v){var i=0;if(v.length!==this._aContent.length){return true;}for(;i<v.length;i++){if(v[i]!==this._aContent[i]){return true;}}return false;};b.prototype.getSize=function(){return this._aContent.length;};var d=function(r){this._aRules=r;};d.prototype.nextTo=function(i){if(typeof i==="undefined"){i=-1;}do{i++;}while(i<this._aRules.length&&!this._aRules[i]);return i;};d.prototype.previousTo=function(i){do{i--;}while(!this._aRules[i]&&i>0);return i;};d.prototype.hasRuleAt=function(i){return!!this._aRules[i];};d.prototype.applyCharAt=function(s,i){return this._aRules[i].test(s);};this._setDefaultRules=function(){this._bSkipSetupMaskVariables=true;this.addRule(new M({maskFormatSymbol:"a",regex:"[A-Za-z]"}),true);this.addRule(new M({maskFormatSymbol:"9",regex:"[0-9]"}),true);this._bSkipSetupMaskVariables=false;};this._validateDependencies=function(){var p=this.getPlaceholderSymbol(),r=this.getRules(),m=[],e=[];if(!this.getMask()){e.push("Empty mask");}if(r.length){m=[];r.every(function(R){var s=R.getMaskFormatSymbol(),f=s!==p,g;g=!m.some(function(S){return s===S;});m.push(s);if(!f){e.push("Placeholder symbol is the  same as the existing rule's mask format symbol");}if(!g){e.push("Duplicated rule's maskFormatSymbol ["+s+"]");}return f&&g;});}return e.length?e.join(". "):null;};this._removeRuleWithSymbol=function(s){var S=this._findRuleBySymbol(s,this.getRules());if(S){this.removeAggregation('rules',S.oRule);S.oRule.destroy();}};this._findRuleBySymbol=function(m,r){var R=null;if(typeof m!=="string"||m.length!==1){L.error(m+" is not a valid mask rule symbol");return null;}q.each(r,function(i,o){if(o.getMaskFormatSymbol()===m){R={oRule:o,iIndex:i};return false;}});return R;};this._getTextSelection=function(){var _=q(this.getFocusDomRef());if(!_&&(_.length===0||_.is(":hidden"))){return{};}return{iFrom:_[0].selectionStart,iTo:_[0].selectionEnd,bHasSelection:(_[0].selectionEnd-_[0].selectionStart!==0)};};this._setCursorPosition=function(p){if(p<0){p=0;}q(this.getFocusDomRef()).cursorPos(p);return this;};this._getCursorPosition=function(){return q(this.getFocusDomRef()).cursorPos();};this._setupMaskVariables=function(){var r=this.getRules(),m=this.getMask(),s=this._getSkipIndexes(m),e=this._getMaskArray(m,s),p=this.getPlaceholderSymbol(),i=this._buildMaskValueArray(e,p,r,s),t=this._buildRules(e,r,s);this._oTempValue=new b(i);this._iMaskLength=t.length;this._oRules=new d(t);this._iUserInputStartPosition=this._oRules.nextTo();};this._getMaskArray=function(m,s){var l=Array.isArray(s)?s.length:0,e=(m)?m.split(""):[],i;for(i=0;i<l;i++){e.splice(s[i],1);}return e;};this._getSkipIndexes=function(m){var l=(m)?m.length:0,i,s=[],p=0,e=false;for(i=0;i<l;i++){if(m[i]===E&&!e){s.push(i-p);e=true;p++;}else{e=false;}}return s;};this._applyMask=function(){var m=this._getInputValue();if(!this.getEditable()){return;}this._applyAndUpdate(m);};this._resetTempValue=function(f,t){var i,p=this.getPlaceholderSymbol();if(typeof f==="undefined"||f===null){f=0;t=this._oTempValue.getSize()-1;}for(i=f;i<=t;i++){if(this._oRules.hasRuleAt(i)){this._oTempValue.setCharAt(p,i);}}};this._applyAndUpdate=function(m){this._applyRules(m);this.updateDomValue(this._oTempValue.toString());};this._findFirstPlaceholderPosition=function(){return this._oTempValue.toString().indexOf(this.getPlaceholderSymbol());};this._applyRules=function(i){var s,e=0,m,p=this.getPlaceholderSymbol(),f;if(this._oTempValue.toString()===i){return;}for(m=0;m<this._iMaskLength;m++){if(this._oRules.hasRuleAt(m)){this._oTempValue.setCharAt(p,m);f=false;if(i.length){do{s=i.charAt(e);e++;if(this._oRules.applyCharAt(s,m)){this._oTempValue.setCharAt(s,m);f=true;}}while(!f&&(e<i.length));}if(!f){this._resetTempValue(m+1,this._iMaskLength-1);break;}}else{if(this._oTempValue.charAt(m)===i.charAt(e)){e++;}}}};this._keyPressHandler=function(e,k){var s,p,f;if(!this.getEditable()){return;}k=k||this._parseKeyBoardEvent(e);if(k.bCtrlKey||k.bAltKey||k.bMetaKey||k.bBeforeSpace){return;}s=this._getTextSelection();if(!k.bEnter&&!k.bShiftLeftOrRightArrow&&!k.bHome&&!k.bEnd&&!(k.bShift&&k.bDelete)&&!(k.bCtrlKey&&k.bInsert)&&!(k.bShift&&k.bInsert)){if(s.bHasSelection){this._resetTempValue(s.iFrom,s.iTo-1);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,s.iFrom));}p=this._oRules.nextTo(s.iFrom-1);if(p<this._iMaskLength){f=this._feedReplaceChar(k.sChar,p,this._getInputValue());this._feedNextString(f,p);}e.preventDefault();}};this.oncut=function(e){var s=this._getTextSelection(),m=this._getMinBrowserDelay(),B=s.iFrom,i=s.iTo;I.prototype.oncut(e);if(!s.bHasSelection||!this._isMaskEnabled()){return;}i=i-1;this._resetTempValue(B,i);setTimeout(function updateDomAndCursor(v,p,o){this._oTempValue._aContent=o;this.updateDomValue(v);setTimeout(this._setCursorPosition.bind(this,p),m);}.bind(this,this._oTempValue.toString(),Math.max(this._iUserInputStartPosition,B),this._oTempValue._aContent.slice(0)),m);};this._keyDownHandler=function(e,k){var s,S,i,n,k=k||this._parseKeyBoardEvent(e);if(!this.getEditable()){return;}if(!k.bShift&&(k.bArrowRight||k.bArrowLeft)){i=this._getCursorPosition();S=this._getTextSelection();s=this._determineArrowKeyDirection(k,S);if(this._isRtlMode()&&S.bHasSelection){n=this._determineRtlCaretPositionFromSelection(s);}else{n=this._oRules[s](i);}if(this._isWebkitProblematicCase()){n=this._fixWebkitBorderPositions(n,s);}this._setCursorPosition(n);e.preventDefault();}else if(k.bEscape){this._applyAndUpdate(this._sOldInputValue);this._positionCaret(true);e.preventDefault();}else if(k.bEnter){this._inputCompletedHandler(e);}else if((k.bCtrlKey&&k.bInsert)||(k.bShift&&k.bInsert)){I.prototype.onkeydown.apply(this,arguments);}else if((!k.bShift&&k.bDelete)||k.bBackspace){this._revertKey(k);e.preventDefault();}else if(this._isChromeOnAndroid()){this._oKeyDownStateAndroid={sValue:this._oTempValue.toString(),iCursorPosition:this._getCursorPosition(),oSelection:this._getTextSelection()};}};this._revertKey=function(k,s){s=s||this._getTextSelection();var B=s.iFrom,e=s.iTo;if(!s.bHasSelection){if(k.bBackspace){B=this._oRules.previousTo(B);}}if(k.bBackspace||(k.bDelete&&s.bHasSelection)){e=e-1;}this._resetTempValue(B,e);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,B));};this._feedNextString=function(n,p){var N,A=false,e=n.split(""),s;while(e.length){s=e.splice(0,1)[0];if(this._oRules.applyCharAt(s,p)){A=true;this._oTempValue.setCharAt(s,p);p=this._oRules.nextTo(p);}}if(A){N=p;this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(N);}};this._inputCompletedHandler=function(){var n=this._getInputValue(),t,v,e,f;if(this._oTempValue.differsFrom(n)){this._applyAndUpdate(n);}t=this._oTempValue.differsFromOriginal();v=t?this._oTempValue.toString():"";e=!this._sOldInputValue||!this.getValue();f=!n;if(e&&(f||!t)){this.updateDomValue("");return;}if(this._sOldInputValue!==this._oTempValue.toString()){I.prototype.setValue.call(this,this._getAlteredUserInputValue?this._getAlteredUserInputValue(v):v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};this._buildMaskValueArray=function(m,p,r,s){return m.map(function(e,i){var n=s.indexOf(i)===-1,R=this._findRuleBySymbol(e,r);return(n&&R)?p:e;},this);};this._buildRules=function(m,r,s){var t=[],S,l=m.length,i=0;for(;i<l;i++){if(s.indexOf(i)===-1){S=this._findRuleBySymbol(m[i],r);t.push(S?new RegExp(S.oRule.getRegex()):null);}else{t.push(null);}}return t;};this._parseKeyBoardEvent=function(e){var p=e.which||e.keyCode,k=K,A=p===k.ARROW_RIGHT,f=p===k.ARROW_LEFT,s=e.shiftKey;return{iCode:p,sChar:String.fromCharCode(p),bCtrlKey:e.ctrlKey,bAltKey:e.altKey,bMetaKey:e.metaKey,bShift:s,bInsert:p===K.INSERT,bBackspace:p===k.BACKSPACE,bDelete:p===k.DELETE,bEscape:p===k.ESCAPE,bEnter:p===k.ENTER,bIphoneEscape:(D.system.phone&&D.os.ios&&p===127),bArrowRight:A,bArrowLeft:f,bHome:p===K.HOME,bEnd:p===K.END,bShiftLeftOrRightArrow:s&&(f||A),bBeforeSpace:p<k.SPACE};};this._positionCaret=function(s){var m=this.getMask(),i=this._getMinBrowserDelay(),e;clearTimeout(this._iCaretTimeoutId);e=this._findFirstPlaceholderPosition();if(e<0){e=m.length;}this._iCaretTimeoutId=setTimeout(function(){if(this.getFocusDomRef()!==document.activeElement){return;}if(s&&(e===(m.length))){this.selectText(0,e);}else{this._setCursorPosition(e);}}.bind(this),i);};this._getMinBrowserDelay=function(){return!D.browser.msie?4:50;};this._isValidInput=function(s){var l=s.length,i=0,e;for(;i<l;i++){e=s[i];if(this._oRules.hasRuleAt(i)&&(!this._oRules.applyCharAt(e,i)&&e!==this.getPlaceholderSymbol())){return false;}if(!this._oRules.hasRuleAt(i)&&e!==this._oTempValue.charAt(i)){return false;}}return true;};this._isRtlChar=function(s){var l='A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02B8\u0300-\u0590\u0800-\u1FFF'+'\u2C00-\uFB1C\uFDFE-\uFE6F\uFEFD-\uFFFF',r='\u0591-\u07FF\uFB1D-\uFDFD\uFE70-\uFEFC',e=new RegExp('^[^'+l+']*['+r+']');return e.test(s);};this._fixWebkitBorderPositions=function(i,s){var t=this._oTempValue.toString().length;if(s==='nextTo'){if(i===0||i===t||i===1){i=0;}else if(i===t+1){i=1;}}else{if(i===0||i===t-1){i=t;}else if(i===-1||i===t){i=t-1;}}return i;};this._containsRtlChars=function(){var t=this._oTempValue.toString(),e=false;for(var i=0;i<t.length;i++){e=this._isRtlChar(t[i]);}return e;};this._isRtlMode=function(){return sap.ui.getCore().getConfiguration().getRTL()||(this.getTextDirection()===T.RTL);};this._isWebkitProblematicCase=function(){return D.browser.webkit&&this._isRtlMode()&&!this._containsRtlChars();};this._determineArrowKeyDirection=function(k,s){var e;if(!this._isRtlMode()||!this._containsRtlChars()||s.bHasSelection){if(k.bArrowRight){e='nextTo';}else{e='previousTo';}}else{if(k.bArrowRight){e='previousTo';}else{e='nextTo';}}return e;};this._determineRtlCaretPositionFromSelection=function(s,w){var n,S=this._getTextSelection();if(w){if(s==='nextTo'){if(!this._containsRtlChars()){n=S.iFrom;}else{n=S.iTo;}}else{if(!this._containsRtlChars()){n=S.iTo;}else{n=S.iFrom;}}}else{if(s==='nextTo'){if(!this._containsRtlChars()){n=S.iTo;}else{n=S.iFrom;}}else{if(!this._containsRtlChars()){n=S.iFrom;}else{n=S.iTo;}}}return n;};this._onInputForAndroidHandler=function(e){var k;if(!this._oKeyDownStateAndroid){return;}k=this._buildKeyboardEventInfo(this._oKeyDownStateAndroid.sValue,this._getInputValue(),this._oKeyDownStateAndroid.oSelection);this.updateDomValue(this._oKeyDownStateAndroid.sValue);setTimeout(function(i,o,f){this._setCursorPosition(o.iCursorPosition);if(f.bBackspace){this._revertKey(f,o.oSelection);if(o.oSelection.bHasSelection&&f.sChar){this._keyPressHandler(i,f);}}else{this._keyPressHandler(i,f);}}.bind(this,e,this._oKeyDownStateAndroid,k),0);delete this._oKeyDownStateAndroid;e.preventDefault();};this._buildKeyboardEventInfo=function(o,n,O){var N="",i,r={},e;if(!o&&!n){return{};}if(o&&n&&n.length<o.length){r.bBackspace=true;}for(i=0;i<n.length;i++){e=O.bHasSelection&&O.iFrom===i;if(e||o[i]!==n[i]){N=n[i];break;}}r.sChar=N;return r;};this._isChromeOnAndroid=function(){return D.browser.chrome&&D.os.android;};};return a;},true);
sap.ui.predefine('sap/m/MaskInput',['./InputBase','./MaskEnabler','./MaskInputRenderer'],function(I,M,a){"use strict";
var b=I.extend("sap.m.MaskInput",{metadata:{library:"sap.m",properties:{placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"}},dnd:{draggable:false,droppable:true}}});
M.call(b.prototype);
b.prototype._isMaskEnabled=function(){return true;};
return b;});
sap.ui.predefine('sap/m/MaskInputRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var M=R.extend(I);
M.getLabelledByAnnouncement=function(c){var m=c.getMask(),p=c.getPlaceholder()||"",r,s,a="";if(m&&m.length){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");s=r.getText("MASKINPUT_SCREENREADER_TAG");if(p){p=" "+p+" ";}a=s+p;return a;}return I.getLabelledByAnnouncement.apply(this,arguments);};
M.getDescribedByAnnouncement=function(c){var m=c.getMask(),s=c.getPlaceholderSymbol(),r,a="";if(m.length&&s){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a=r.getText("MASKINPUT_SCREENREADER_DESCRIPTION",[s,m]);return a.trim();}return I.getDescribedByAnnouncement.apply(this,arguments);};
return M;},true);
sap.ui.predefine('sap/m/MaskInputRule',['sap/ui/core/Element',"sap/base/Log"],function(E,L){"use strict";
var M=E.extend("sap.m.MaskInputRule",{metadata:{library:"sap.m",properties:{maskFormatSymbol:{type:"string",group:"Misc",defaultValue:"*"},regex:{type:"string",group:"Misc",defaultValue:"[a-zA-Z0-9]"}}}});
M.prototype.setMaskFormatSymbol=function(n){var i=v.call(this,n);if(i){this.setProperty("maskFormatSymbol",n);}return this;};
M.prototype.setRegex=function(n){var i=a.call(this,n);if(i){this.setProperty("regex",n);}return this;};
M.prototype.toString=function(){return this.getMaskFormatSymbol()+":"+this.getRegex();};
function v(n){if(/^.$/i.test(n)){return true;}L.error("The mask format symbol '"+n+"' is not valid");return false;}
function a(r){if(/.+/i.test(r)){return true;}L.error("The regex value '"+r+"' is not valid");return false;}
return M;});
sap.ui.predefine('sap/m/Menu',['./library','sap/ui/core/Control','./Button','./Dialog','./NavContainer','./List','./Page','./MenuListItem','sap/ui/unified/Menu','sap/ui/unified/MenuItem','sap/ui/Device','sap/ui/core/EnabledPropagator',"sap/ui/thirdparty/jquery","sap/ui/core/Popup"],function(l,C,B,D,N,L,P,M,U,a,b,E,q,c){"use strict";var d=c.Dock;var e=l.ListType;var f=l.ListMode;
var g=C.extend("sap.m.Menu",{metadata:{interfaces:["sap.ui.core.IContextMenu"],library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"},_dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},_menu:{type:"sap.ui.unified.Menu",multiple:false,visibility:"hidden"}},events:{itemSelected:{parameters:{item:{type:"sap.m.MenuItem"}}},closed:{}}}});
E.call(g.prototype);g.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';g.UNFIFIED_MENU_ITEMS_PROPS=a.getMetadata().getAllProperties();g.LIST_ITEMS_ID_SUFFIX='-menuinnerlist';g.MENU_LIST_ITEMS_PROPS=M.getMetadata().getAllProperties();
g.prototype.init=function(){if(b.system.phone){this._initDialog();}this._bIsInitialized=false;};
g.prototype.exit=function(){if(this._navContainerId){this._navContainerId=null;}if(this._bIsInitialized){this._bIsInitialized=null;}if(this._getMenu()&&this._getMenu().getPopup()){this._getMenu().getPopup().detachClosed(this._menuClosed,this);}};
g.prototype.invalidate=function(){};
g.prototype.setTitle=function(t){var n=this._getNavContainer();this.setProperty("title",t,true);if(n&&n.getPages().length){n.getPages()[0].setTitle(t);}return this;};
g.prototype.openBy=function(o,w,s,i,O){if(b.system.phone){this._openDialog();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}if(!s){s=d.BeginTop;}if(!i){i=d.BeginBottom;}if(!O){O="0 -2";}this._getMenu().open(w,o,s,i,o,O);}};
g.prototype.close=function(){if(b.system.phone){this._getDialog().close();}else{this._getVisualParent().close();}};
g.prototype._initDialog=function(){var o=new D({showHeader:false,stretch:true,content:this._initNavContainer(),buttons:[this._initCloseButton()]});o.addStyleClass("sapMRespMenuDialog");o.removeStyleClass("sapUiPopupWithPadding");this.setAggregation("_dialog",o,true);o.attachAfterClose(this._menuClosed,this);};
g.prototype._getDialog=function(){return this.getAggregation("_dialog");};
g.prototype._openDialog=function(){if(!this._bIsInitialized){this._initAllPages();this._bIsInitialized=true;}this._getNavContainer().to(this._getNavContainer().getPages()[0]);this._getDialog().open();};
g.prototype._initAllMenuItems=function(){this._initMenuForItems(this.getItems());};
g.prototype._setCustomEnhanceAccStateFunction=function(i){this._fnEnhanceUnifiedMenuAccState=i;};
g.prototype._initMenuForItems=function(i,p){var m=new U();m._setCustomEnhanceAccStateFunction(this._fnEnhanceUnifiedMenuAccState);m.isCozy=this._isMenuCozy.bind(this,m);this.addStyleClass('sapMMenu');m.aCustomStyleClasses=this.aCustomStyleClasses;m.mCustomStyleClassMap=this.mCustomStyleClassMap;i.forEach(function(I){this._addVisualMenuItemFromItem(I,m);}.bind(this));if(p){p.setSubmenu(m);}else{m.getPopup().attachClosed(this._menuClosed,this);this.setAggregation('_menu',m,true);}m.attachItemSelect(this._handleMenuItemSelect,this);};
g.prototype._menuClosed=function(){this.fireClosed();};
g.prototype._getMenu=function(){return this.getAggregation("_menu");};
g.prototype._initCloseButton=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("MENU_CLOSE"),press:h.bind(this)});};
function h(){this._getDialog().close();}
g.prototype._initNavContainer=function(){var n=new N();this._navContainerId=n.getId();return n;};
g.prototype._getNavContainer=function(){return sap.ui.getCore().byId(this._navContainerId);};
g.prototype._initAllPages=function(){this._initPageForParent(this);};
g.prototype._initPageForParent=function(p){var i=p.getItems(),k=p instanceof g,s=k?p.getTitle():p.getText(),o=new L({mode:f.None}),m=new P({title:s,showNavButton:!k,content:o});if(!k){this._setBackButtonTooltipForPageWithParent(p,m);}m.attachNavButtonPress(function(){this._getNavContainer().back();},this);this._getNavContainer().addPage(m);i.forEach(function(I){this._addListItemFromItem(I,m);},this);this._updateListInset(o);o.attachEvent("itemPress",this._handleListItemPress,this);return m;};
g.prototype._handleListItemPress=function(o){var i=o.getParameter("listItem"),m=sap.ui.getCore().byId(i.getMenuItem()),p=m._getVisualChild();if(p){this._getNavContainer().to(p);}else{this._getDialog().close();this.fireItemSelected({item:m});}m.firePress();};
g.prototype._setBackButtonTooltipForPageWithParent=function(p,o){var i=p.getParent(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s;s=i instanceof g?i.getTitle():i.getText();s=r.getText("MENU_PAGE_BACK_BUTTON")+" "+s;o.setNavButtonTooltip(s);};
g.prototype._createMenuListItemFromItem=function(i){return new M({id:this._generateListItemId(i.getId()),type:e.Active,icon:i.getIcon(),title:i.getText(),startsSection:i.getStartsSection(),menuItem:i,tooltip:i.getTooltip(),visible:i.getVisible()});};
g.prototype._createVisualMenuItemFromItem=function(I){var u=new a({id:this._generateUnifiedMenuItemId(I.getId()),icon:I.getIcon(),text:I.getText(),startsSection:I.getStartsSection(),tooltip:I.getTooltip(),visible:I.getVisible(),enabled:I.getEnabled()}),i,k=I.getCustomData();for(i=0;i<k.length;i++){I._addCustomData(u,k[i]);}return u;};
g.prototype._addVisualMenuItemFromItem=function(i,m,I){var o=this._createVisualMenuItemFromItem(i);i._setVisualParent(m);i._setVisualControl(o);var k=['aggregationChanged','propertyChanged'];k.forEach(function(s){var n='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[n],this);},this);if(i.getItems().length!==0){this._initMenuForItems(i.getItems(),o);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){m.addItem(o);}else{m.insertItem(o,I);}};
g.prototype._addListItemFromItem=function(i,p,I){var m=this._createMenuListItemFromItem(i),o=p.getContent()[0];i._setVisualParent(p);i._setVisualControl(m);var k=['aggregationChanged','propertyChanged'];k.forEach(function(s){var n='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[n],this);},this);if(i.getItems().length!==0){this._initPageForParent(i);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){o.addItem(m);}else{o.insertItem(m,I);}o.rerender();};
g.prototype._connectVisualItem=function(i,o,I){if(!o||sap.ui.getCore().byId(i._getVisualControl())){return;}if(b.system.phone){this._addListItemFromItem(i,o,I);var k=o.getContent()[0];this._updateListInset(k);}else{this._addVisualMenuItemFromItem(i,o,I);}};
g.prototype._updateListInset=function(o){var H=false,I="sapMListIcons",k=o.getItems();for(var i=0;i<k.length;i++){if(k[i].getIcon()){H=true;break;}}if(H){o.addStyleClass(I);}else{o.removeStyleClass(I);}};
g.prototype._handleMenuItemSelect=function(o){var u=o.getParameter("item"),m;if(!u){return;}m=this._findMenuItemByUnfdMenuItem(u);if(m&&!m.getItems().length){this.fireItemSelected({item:m});}if(m){m.firePress();}};
g.prototype._generateListItemId=function(m){return m+g.LIST_ITEMS_ID_SUFFIX;};
g.prototype._generateUnifiedMenuItemId=function(m){return m+g.UNIFIED_MENU_ITEMS_ID_SUFFIX;};
g.prototype._findMenuItemByUnfdMenuItem=function(u){var k=[],o=u,I,m,i;do{k.push(o.getId());o=o.getParent().getParent();}while(o instanceof a);I=this.getItems();do{m=k.pop();for(i=0;i<I.length;i++){if(I[i]._getVisualControl()===m){if(k.length===0){return I[i];}else{I=I[i].getItems();break;}}}}while(k.length);return null;};
g.prototype._isMenuCozy=function(m){if(!m.bCozySupported){return false;}if(m.hasStyleClass("sapUiSizeCozy")){return true;}if(j(m.oOpenerRef)){return true;}return false;};
function j(r){if(!r){return false;}r=r.$?r.$():q(r);var $=r.closest(".sapUiSizeCompact,.sapUiSizeCondensed,.sapUiSizeCozy");return(!$.hasClass("sapUiSizeCompact")&&!$.hasClass("sapUiSizeCondensed"))||$.hasClass("sapUiSizeCozy");}
g.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.apply(this,arguments);if(A==="items"){this._connectVisualItem(o,this._getVisualParent());}return this;};
g.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.apply(this,arguments);if(A==="items"){this._connectVisualItem(o,this._getVisualParent(),i);}return this;};
g.prototype.removeAggregation=function(A,o,s){var i=C.prototype.removeAggregation.apply(this,arguments);if(A==="items"){this._removeVisualItem(i);}return i;};
g.prototype.removeAllAggregation=function(A,s){var I=C.prototype.removeAllAggregation.apply(this,arguments);if(A==="items"){for(var i=0;i<I.length;i++){this._removeVisualItem(I[i]);}}return I;};
g.prototype._removeVisualItem=function(i,p){var v=sap.ui.getCore().byId(i._getVisualControl()),m;if(v){m=v.getParent();m.removeItem(v);if(b.system.phone){this._removeSubPageForItem(i);if(m.getItems().length===0){if(p){p._setVisualChild(null);sap.ui.getCore().byId(p._getVisualControl()).rerender();}}if(m){m.rerender();}}}};
g.prototype.destroyAggregation=function(A,s){if(A==="items"){for(var i=0;i<this.getItems().length;i++){this._removeVisualItem(this.getItems()[i]);}}return C.prototype.destroyAggregation.apply(this,arguments);};
g.prototype._removeSubPageForItem=function(I,s){var S;if(!s){for(var i=0;i<I.getItems().length;i++){this._removeSubPageForItem(I.getItems()[i]);}}if(I._getVisualChild()){S=sap.ui.getCore().byId(I._getVisualChild());if(this._getNavContainer()&&S){this._getNavContainer().removePage(S);}!!S&&S.destroy();}};
g.prototype._getVisualParent=function(){var n=this._getNavContainer(),m=this._getMenu();if(n&&n.getPages().length){return n.getPages()[0];}else{return m;}};
g.prototype._onPropertyChanged=function(o){var p=o.getParameter("propertyKey"),i=o.getParameter("propertyValue"),t=b.system.phone?g.MENU_LIST_ITEMS_PROPS:g.UNFIFIED_MENU_ITEMS_PROPS,G=b.system.phone?this._generateListItemId:this._generateUnifiedMenuItemId,T;if(b.system.phone&&p==='text'){p='title';}if(!t[p]){return;}T=G(o.getSource().getId());if(T){sap.ui.getCore().byId(T).setProperty(p,i);if(b.system.phone&&this._getDialog().isOpen()){this._getDialog().close();}}};
g.prototype._onAggregationChanged=function(o){var A=o.getParameter("aggregationName");switch(A){case'items':this._onItemsAggregationChanged(o);break;case'tooltip':this._onTooltipAggregationChanged(o);break;}};
g.prototype._onTooltipAggregationChanged=function(o){var v=o.getSource()._getVisualControl(),m=o.getParameter("methodName"),i=o.getParameter("methodParams"),V;if(!v){return;}V=sap.ui.getCore().byId(v);if(m==="set"){V.setTooltip(i.item);}if(m==="destroy"){V.destroyTooltip();}};
g.prototype._onItemsAggregationChanged=function(o){var I=o.getSource(),m=o.getParameter("methodName"),k=o.getParameter("methodParams"),n;if(m==="add"||m==="insert"){if(m==="insert"){n=k.index;}this._addOrInsertItem(I,k.item,n);}if(m==="remove"){this._removeVisualItem(k.item,I);}if(m==="removeall"){for(var i=0;i<k.items.length;i++){this._removeVisualItem(k.items[i],I);}}if(m==="destroy"){this._destroyItem(I);}};
g.prototype._addOrInsertItem=function(p,n,i){var o;if(p._getVisualChild()){this._connectVisualItem(n,sap.ui.getCore().byId(p._getVisualChild()),i);}else{if(b.system.phone){this._initPageForParent(p);p._setVisualChild(p.getItems()[0]._getVisualParent());o=sap.ui.getCore().byId(p._getVisualControl());o.rerender();}else{this._initMenuForItems(p.getItems(),sap.ui.getCore().byId(p._getVisualControl()));p._setVisualChild(p.getItems()[0]._getVisualParent());}}};
g.prototype._destroyItem=function(i){var v=sap.ui.getCore().byId(i._getVisualControl());if(v&&v.setMenuItem){v.setMenuItem(null);}this._removeSubPageForItem(i,true);i._setVisualChild(null);if(v&&v.setMenuItem){v.rerender();v.setMenuItem(i);}};
g.prototype.getDomRefId=function(){if(b.system.phone){return this._getDialog().getId();}else{return this._getMenu().getId();}};
g.prototype.openAsContextMenu=function(o,O){if(b.system.phone){this._openDialog();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}this._getMenu().openAsContextMenu(o,O);}};
["addStyleClass","removeStyleClass","toggleStyleClass"].forEach(function(m){g.prototype[m]=function(s,S){var o=this._getDialog();C.prototype[m].apply(this,arguments);if(o){o[m].apply(o,arguments);}return this;};});return g;});
sap.ui.predefine('sap/m/MenuButton',['./library','sap/ui/core/Control','./Button','./SplitButton','sap/ui/Device','sap/ui/core/EnabledPropagator','sap/ui/core/library','sap/ui/core/Popup','sap/ui/core/LabelEnablement','sap/m/Menu',"./MenuButtonRenderer"],function(l,C,B,S,D,E,c,P,L,M,a){"use strict";var b=l.MenuButtonMode;var T=c.TextDirection;var d=l.ButtonType;var e=P.Dock;var n=["buttonMode","useDefaultActionOnly","width","menuPosition"];
var f=C.extend("sap.m.MenuButton",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:d.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},buttonMode:{type:"sap.m.MenuButtonMode",group:"Misc",defaultValue:b.Regular},menuPosition:{type:"sap.ui.core.Popup.Dock",group:"Misc",defaultValue:e.BeginBottom},useDefaultActionOnly:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{menu:{type:"sap.m.Menu",multiple:false,singularName:"menu"},_button:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{defaultAction:{}},defaultAggregation:"menu",designtime:"sap/m/designtime/MenuButton.designtime",dnd:{draggable:true,droppable:false}}});
E.call(f.prototype);
f.prototype.init=function(){this._initButtonControl();};
f.prototype.exit=function(){if(this._sDefaultText){this._sDefaultText=null;}if(this._sDefaultIcon){this._sDefaultIcon=null;}if(this._iInitialTextBtnContentWidth){this._iInitialTextBtnContentWidth=null;}if(this._lastActionItemId){this._lastActionItemId=null;}if(this.getMenu()){this.getMenu().detachClosed(this._menuClosed,this);}};
f.prototype.onBeforeRendering=function(){if(!this._sDefaultText){this._sDefaultText=this.getText();}if(!this._sDefaultIcon){this._sDefaultIcon=this.getIcon();}this._updateButtonControl();this._attachMenuEvents();};
f.prototype._needsWidth=function(){return this._isSplitButton()&&this.getWidth()==="";};
f.prototype._getTextBtnContentDomRef=function(){return this._getButtonControl()._getTextButton().getDomRef("content");};
f.prototype.onAfterRendering=function(){if(this._needsWidth()&&sap.ui.getCore().isThemeApplied()&&this._getTextBtnContentDomRef()&&this._getInitialTextBtnWidth()>0){this._getTextBtnContentDomRef().style.width=this._getInitialTextBtnWidth()+'px';}this._setAriaHasPopup();};
f.prototype.onThemeChanged=function(o){if(this._needsWidth()&&this.getDomRef()&&!this._iInitialTextBtnContentWidth&&this._getTextBtnContentDomRef()&&this._getInitialTextBtnWidth()>0){this._getTextBtnContentDomRef().style.width=this._getInitialTextBtnWidth()+'px';}};
f.prototype._getInitialTextBtnWidth=function(){if(!this._iInitialTextBtnContentWidth){this._iInitialTextBtnContentWidth=Math.ceil(this._getTextBtnContentDomRef().getBoundingClientRect().width);}return this._iInitialTextBtnContentWidth;};
f.prototype._setAriaHasPopup=function(){if(this._isSplitButton()){this._getButtonControl()._getArrowButton().$().attr("aria-haspopup","true");}else{this._getButtonControl().$().attr("aria-haspopup","true");}};
f.prototype.setButtonMode=function(m){var t=this.getTooltip();C.prototype.setProperty.call(this,"buttonMode",m,true);this._getButtonControl().destroy();this._initButtonControl();for(var k in this.mProperties){if(this.mProperties.hasOwnProperty(k)&&n.indexOf(k)<0){this._getButtonControl().setProperty(k,this.mProperties[k],true);}}if(t){this._getButtonControl().setTooltip(t);}if(!this._isSplitButton()&&this._sDefaultText){this.setText(this._sDefaultText);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setText(sap.ui.getCore().byId(this._getLastSelectedItem()).getText());}if(!this._isSplitButton()&&this._sDefaultIcon){this.setIcon(this._sDefaultIcon);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setIcon(sap.ui.getCore().byId(this._getLastSelectedItem()).getIcon());}this.invalidate();return this;};
f.prototype._initButton=function(){var o=new B(this.getId()+"-internalBtn",{width:"100%"});o.attachPress(this._handleButtonPress,this);return o;};
f.prototype._initSplitButton=function(){var o=new S(this.getId()+"-internalSplitBtn",{width:"100%"});o.attachPress(this._handleActionPress,this);o.attachArrowPress(this._handleButtonPress,this);return o;};
f.prototype._initButtonControl=function(){var o;if(this._isSplitButton()){o=this._initSplitButton();}else{o=this._initButton();}this.setAggregation("_button",o,true);};
f.prototype._updateButtonControl=function(){this._getButtonControl().setText(this.getText());};
f.prototype._getButtonControl=function(){return this.getAggregation("_button");};
f.prototype._handleButtonPress=function(w){var m=this.getMenu(),o={zero:"0 0",plus2_right:"0 +2",minus2_right:"0 -2",plus2_left:"+2 0",minus2_left:"-2 0"};if(this._bPopupOpen){this.getMenu().close();return;}if(!m){return;}if(!m.getTitle()){m.setTitle(this.getText());}var p=[this,w];switch(this.getMenuPosition()){case e.BeginTop:p.push(e.BeginBottom,e.BeginTop,o.plus2_right);break;case e.BeginCenter:p.push(e.BeginCenter,e.BeginCenter,o.zero);break;case e.LeftTop:p.push(e.RightBottom,e.LeftBottom,o.plus2_left);break;case e.LeftCenter:p.push(e.RightCenter,e.LeftCenter,o.plus2_left);break;case e.LeftBottom:p.push(e.RightTop,e.LeftTop,o.plus2_left);break;case e.CenterTop:p.push(e.CenterBottom,e.CenterTop,o.plus2_left);break;case e.CenterCenter:p.push(e.CenterCenter,e.CenterCenter,o.zero);break;case e.CenterBottom:p.push(e.CenterTop,e.CenterBottom,o.minus2_right);break;case e.RightTop:p.push(e.LeftBottom,e.RightBottom,o.minus2_left);break;case e.RightCenter:p.push(e.LeftCenter,e.RightCenter,o.minus2_left);break;case e.RightBottom:p.push(e.LeftTop,e.RightTop,o.minus2_left);break;case e.EndTop:p.push(e.EndBottom,e.EndTop,o.plus2_right);break;case e.EndCenter:p.push(e.EndCenter,e.EndCenter,o.zero);break;case e.EndBottom:p.push(e.EndTop,e.EndBottom,o.minus2_right);break;default:case e.BeginBottom:p.push(e.BeginTop,e.BeginBottom,o.minus2_right);break;}M.prototype.openBy.apply(m,p);this._writeAriaAttributes();if(this._isSplitButton()&&!D.system.phone){this._getButtonControl().setArrowState(true);}};
f.prototype._handleActionPress=function(){var s=this._getLastSelectedItem(),o;if(!this.getUseDefaultActionOnly()&&s){o=sap.ui.getCore().byId(s);this.getMenu().fireItemSelected({item:o});}else{this.fireDefaultAction();}};
f.prototype._menuClosed=function(){if(this._isSplitButton()){this._getButtonControl().setArrowState(false);}this.$().removeAttr("aria-controls");};
f.prototype._menuItemSelected=function(o){var m=o.getParameter("item");this.fireEvent("_menuItemSelected",{item:m});this._bPopupOpen=false;if(!this._isSplitButton()||this.getUseDefaultActionOnly()||!m){return;}this._lastActionItemId=m.getId();!!this._sDefaultText&&this.setText(m.getText());!!this._sDefaultIcon&&this.setIcon(m.getIcon());};
f.prototype._getLastSelectedItem=function(){return this._lastActionItemId;};
f.prototype._attachMenuEvents=function(){if(this.getMenu()){this.getMenu().attachClosed(this._menuClosed,this);this.getMenu().attachItemSelected(this._menuItemSelected,this);}};
f.prototype._isSplitButton=function(){return this.getButtonMode()===b.Split;};
f.prototype.setProperty=function(p,v,s){function i(t){var g=[d.Up,d.Back,d.Unstyled];return g.indexOf(t)!==-1;}if(p==="type"&&i(v)){return this;}if(p==='text'){this._sDefaultText=v;}switch(p){case'activeIcon':case'iconDensityAware':case'textDirection':case'enabled':this._getButtonControl().setProperty(p,v);break;}return C.prototype.setProperty.apply(this,arguments);};
f.prototype.setTooltip=function(t){this._getButtonControl().setTooltip(t);return C.prototype.setTooltip.apply(this,arguments);};
f.prototype.setText=function(v){B.prototype.setProperty.call(this,'text',v);this._getButtonControl().setText(v);return this;};
f.prototype.setType=function(v){B.prototype.setProperty.call(this,'type',v);this._getButtonControl().setType(v);return this;};
f.prototype.setIcon=function(v){B.prototype.setProperty.call(this,'icon',v);this._getButtonControl().setIcon(v);return this;};
f.prototype.getFocusDomRef=function(){return this._getButtonControl().getDomRef();};
f.prototype.onsapup=function(o){this.openMenuByKeyboard();};
f.prototype.onsapdown=function(o){this.openMenuByKeyboard();};
f.prototype.onsapupmodifiers=function(o){this.openMenuByKeyboard();};
f.prototype.onsapdownmodifiers=function(o){this.openMenuByKeyboard();};
f.prototype.onsapshow=function(o){this.openMenuByKeyboard();!!o&&o.preventDefault();};
f.prototype.ontouchstart=function(){this._bPopupOpen=this.getMenu()&&this.getMenu()._getMenu()&&this.getMenu()._getMenu().getPopup().isOpen();};
f.prototype.openMenuByKeyboard=function(){if(!this._isSplitButton()){this._handleButtonPress(true);}};
f.prototype._writeAriaAttributes=function(){if(this.getMenu()){this.$().attr("aria-controls",this.getMenu().getDomRefId());}};
f.prototype.getIdForLabel=function(){return this.getId()+"-internalBtn";};
f.prototype._ensureBackwardsReference=function(){var i=this._getButtonControl(),I=i.getAriaLabelledBy(),r=L.getReferencingLabels(this);r.forEach(function(s){if(I&&I.indexOf(s)===-1){i.addAriaLabelledBy(s);}});return this;};
return f;});
sap.ui.predefine('sap/m/MenuButtonRenderer',[],function(){"use strict";var M={};M.CSS_CLASS="sapMMenuBtn";
M.render=function(r,m){var w=m.getWidth();r.write("<div");r.writeControlData(m);r.addClass(M.CSS_CLASS);r.addClass(M.CSS_CLASS+m.getButtonMode());r.writeClasses();if(w!=""){r.addStyle("width",w);}r.writeStyles();r.write(">");m._ensureBackwardsReference();r.renderControl(m._getButtonControl());r.write("</div>");};
return M;},true);
sap.ui.predefine('sap/m/MenuItem',['./library','sap/ui/core/Item','sap/ui/base/ManagedObjectObserver'],function(l,I,M){"use strict";
var a=I.extend("sap.m.MenuItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{press:{},propertyChanged:{parameters:{propertyKey:{type:"string"},propertyValue:{type:"any"}}},aggregationChanged:{parameters:{aggregationName:{type:"String"},methodName:{type:"String"},methodParams:{type:"Object"}}}}}});
a.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';
a.prototype.exit=function(){if(this._sVisualChild){this._sVisualChild=null;}if(this._sVisualParent){this._sVisualParent=null;}if(this._sVisualControl){this._sVisualControl=null;}};
a.prototype.setProperty=function(p,P){I.prototype.setProperty.apply(this,arguments);this.fireEvent("propertyChanged",{propertyKey:p,propertyValue:P});};
a.prototype.setAggregation=function(A,o,s){I.prototype.setAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"set",methodParams:{item:o}});return this;};
a.prototype.addAggregation=function(A,o,s){var v=this._getVisualControl(),V;I.prototype.addAggregation.apply(this,arguments);if(A==='customData'&&v){V=sap.ui.getCore().byId(v);this._addCustomData(V,o);}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"add",methodParams:{item:o}});return this;};
a.prototype.insertAggregation=function(A,o,i,s){var v=this._getVisualControl(),V;I.prototype.insertAggregation.apply(this,arguments);if(A==='customData'&&v){V=sap.ui.getCore().byId(v);V.insertCustomData(o.clone(a.UNIFIED_MENU_ITEMS_ID_SUFFIX),i);this._observeCustomDataChanges(o);}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"insert",methodParams:{item:o,index:i}});return this;};
a.prototype.removeAggregation=function(A,o,s){var O=I.prototype.removeAggregation.apply(this,arguments);if(A==="customData"){if(this.getCustomData().length===1){this._disconnectAndDestroyCustomDataObserver();}else if(o&&this._oCustomDataObserver){this._oCustomDataObserver.unobserve(o,{properties:["value"]});}}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"remove",methodParams:{item:O}});return O;};
a.prototype.removeAllAggregation=function(A,s){var o=I.prototype.removeAllAggregation.apply(this,arguments);if(A==='customData'){this._disconnectAndDestroyCustomDataObserver();}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"removeall",methodParams:{items:o}});return o;};
a.prototype.destroyAggregation=function(A,s){if(A==='customData'){this._disconnectAndDestroyCustomDataObserver();}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"destroy"});return I.prototype.destroyAggregation.apply(this,arguments);};
a.prototype.destroy=function(){var v=sap.ui.getCore().byId(this._getVisualControl());if(v){v.destroy();}return I.prototype.destroy.apply(this,arguments);};
a.prototype._addCustomData=function(v,c){v.addCustomData(c.clone(a.UNIFIED_MENU_ITEMS_ID_SUFFIX,undefined,{bCloneChildren:false,bCloneBindings:true}));this._observeCustomDataChanges(c);};
a.prototype._observeCustomDataChanges=function(c){this._getCustomDataObserver().observe(c,{properties:["value"]});};
a.prototype._customDataObserverCallbackFunction=function(c){sap.ui.getCore().byId(c.object.getId()+"-"+a.UNIFIED_MENU_ITEMS_ID_SUFFIX).setValue(c.current);};
a.prototype._getCustomDataObserver=function(){if(!this._oCustomDataObserver){this._oCustomDataObserver=new M(this._customDataObserverCallbackFunction);}return this._oCustomDataObserver;};
a.prototype._disconnectAndDestroyCustomDataObserver=function(){if(this._oCustomDataObserver){this._oCustomDataObserver.disconnect();this._oCustomDataObserver.destroy();this._oCustomDataObserver=null;}};
a.prototype._setVisualChild=function(c){this._setInternalRef(c,"_sVisualChild");};
a.prototype._setVisualParent=function(c){this._setInternalRef(c,"_sVisualParent");};
a.prototype._setVisualControl=function(c){this._setInternalRef(c,"_sVisualControl");};
a.prototype._setInternalRef=function(c,i){if(!c||typeof c==="string"){this[i]=c;}else if(c.getId){this[i]=c.getId();}};
a.prototype._getVisualChild=function(){return this._sVisualChild;};
a.prototype._getVisualParent=function(){return this._sVisualParent;};
a.prototype._getVisualControl=function(){return this._sVisualControl;};
return a;});
sap.ui.predefine('sap/m/MenuListItem',['./ListItemBase','./library','sap/ui/core/IconPool','sap/ui/core/library','./MenuListItemRenderer'],function(L,l,I,c,M){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.MenuListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{menuItem:{type:"sap.m.MenuItem",multiple:false}}}});
a.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._imageRightArrow){this._imageRightArrow.destroy();}L.prototype.exit.apply(this,arguments);};
a.prototype._getImage=function(i,s,S,b){var o=this._image;if(o){o.setSrc(S);if(o instanceof sap.m.Image){o.setDensityAware(b);}}else{o=I.createControlByURI({id:i,src:S,densityAware:b,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}if(o instanceof sap.m.Image){o.addStyleClass(s,true);}else{o.addStyleClass(s+"Icon",true);}this._image=o;return this._image;};
a.prototype._getIconArrowRight=function(){if(!this._imageRightArrow){this._imageRightArrow=I.createControlByURI({id:this.getId()+"-arrowRight",src:"sap-icon://slim-arrow-right",useIconTooltip:false},sap.m.Image).setParent(this,null,true);this._imageRightArrow.addStyleClass("sapMMenuLIArrowRightIcon",true);}return this._imageRightArrow;};
a.prototype._hasSubItems=function(){return!!(this.getMenuItem()&&sap.ui.getCore().byId(this.getMenuItem()).getItems().length);};
return a;});
sap.ui.predefine('sap/m/MenuListItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library'],function(L,R,l,c){"use strict";var T=c.TextDirection;var a=l.ListType;var M=R.extend(L);
M.openItemTag=function(r,o){if(o.getStartsSection()){r.write("<li ");r.write("role=\"separator\" ");r.write("class=\"sapUiMnuDiv\"><div class=\"sapUiMnuDivL\"></div><hr><div class=\"sapUiMnuDivR\"></div></li>");}L.openItemTag(r,o);};
M.renderLIAttributes=function(r,o){r.addClass("sapMSLI");if(o.getIcon()){r.addClass("sapMSLIIcon");}if(o.getType()==a.Detail||o.getType()==a.DetailAndActive){r.addClass("sapMSLIDetail");}if(o._hasSubItems()){r.addClass("sapMMenuLIHasChildren");}};
M.renderLIContent=function(r,o){var t=o.getTitleTextDirection();if(o.getIcon()){r.renderControl(o._getImage((o.getId()+"-img"),"sapMMenuLIImgThumb",o.getIcon(),o.getIconDensityAware()));}r.write("<div");r.addClass("sapMSLIDiv");r.addClass("sapMSLITitleDiv");r.writeClasses();r.write(">");if(o._bNoFlex){r.write('<div class="sapMLIBNoFlex">');}r.write("<div");r.addClass("sapMSLITitleOnly");r.writeClasses();if(t!==T.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");r.writeEscaped(o.getTitle());r.write("</div>");if(o._bNoFlex){r.write('</div>');}r.write("</div>");if(o._hasSubItems()){r.renderControl(o._getIconArrowRight());}};
return M;},true);
sap.ui.predefine('sap/m/MessageBox',['./Button','./Dialog','./Text','./FormattedText','./Link','./VBox','sap/ui/core/IconPool','sap/ui/core/ElementMetadata','sap/ui/core/library','sap/ui/core/Control','sap/m/library',"sap/ui/thirdparty/jquery",'sap/ui/core/theming/Parameters'],function(B,D,T,F,L,V,I,E,c,C,l,q,P){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var d=c.TextDirection;var e=l.ButtonType;var M={};M.Action={OK:"OK",CANCEL:"CANCEL",YES:"YES",NO:"NO",ABORT:"ABORT",RETRY:"RETRY",IGNORE:"IGNORE",CLOSE:"CLOSE",DELETE:"DELETE"};M.Icon={NONE:undefined,INFORMATION:"INFORMATION",WARNING:"WARNING",ERROR:"ERROR",SUCCESS:"SUCCESS",QUESTION:"QUESTION"};(function(){var A=M.Action,f=M.Icon;var _=function(){if(M._rb!==sap.ui.getCore().getLibraryResourceBundle("sap.m")){M._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}};var g=function(o){if(o&&o.actions&&o.actions.length>0){return true;}return false;};
M.show=function(m,o){var h,j,v,r=null,k=[],i,s,t,n,p,u,w,x={id:E.uid("mbox"),initialFocus:null,textDirection:d.Inherit,verticalScrolling:true,horizontalScrolling:true,details:"",contentWidth:null},y=P.get("_sap_m_Message_Box_Information_Icon")==="true",S=y?"message-information":"hint",z={"INFORMATION":"sapMMessageBoxInfo","WARNING":"sapMMessageBoxWarning","ERROR":"sapMMessageBoxError","SUCCESS":"sapMMessageBoxSuccess","QUESTION":"sapMMessageBoxQuestion","STANDARD":"sapMMessageBoxStandard"},G={"INFORMATION":I.getIconURI(S),"WARNING":I.getIconURI("message-warning"),"ERROR":I.getIconURI("message-error"),"SUCCESS":I.getIconURI("message-success"),"QUESTION":I.getIconURI("question-mark")};_();if(typeof o==="string"||arguments.length>2){s=arguments[1];t=arguments[2];n=arguments[3];p=arguments[4];u=arguments[5];w=arguments[6];o={icon:s,title:t,actions:n,onClose:p,id:u,styleClass:w};}if(o&&o.isCustomAction===undefined){o.isCustomAction=g(o);}if(o&&o.hasOwnProperty("details")){x.icon=f.INFORMATION;x.actions=[A.OK,A.CANCEL];o=q.extend({},x,o);}o=q.extend({},x,o);if(typeof o.actions!=="undefined"&&!Array.isArray(o.actions)){o.actions=[o.actions];}if(!o.actions||o.actions.length===0){o.actions=[A.OK];o.isCustomAction=false;}function H(Q,J){var R;if(M.Action.hasOwnProperty(Q)){R=M._rb.getText("MSGBOX_"+Q);}var U=new B({id:E.uid("mbox-btn-"),text:R||Q,type:J,press:function(){r=Q;h.close();}});return U;}var J;for(i=0;i<o.actions.length;i++){J=!o.isCustomAction&&A.OK===o.actions[i]?e.Emphasized:e.Default;k.push(H(o.actions[i],J));}function K(o,j){var Q,R,U=new V({items:[j]});if(!o.details){return U;}if(typeof o.details=='object'){o.details="<pre>"+JSON.stringify(o.details,null,'\t').replace(/{/gi,"\\{")+"</pre>";}Q=new F().setVisible(false).setHtmlText(o.details);R=new L({text:M._rb.getText("MSGBOX_LINK_TITLE"),press:function(){var W=h.getInitialFocus();h.addAriaLabelledBy(Q);Q.setVisible(true);R.setVisible(false);if(W&&W!==R.getId()){h._setInitialFocus();}else{k[0].focus();}}});R.addStyleClass("sapMMessageBoxLinkText");Q.addStyleClass("sapMMessageBoxDetails");U.addItem(R);U.addItem(Q);return U;}function N(){if(typeof o.onClose==="function"){o.onClose(r);}h.detachAfterClose(N);h.destroy();}function O(){var i=0;var Q=null;if(o.initialFocus){if(o.initialFocus instanceof C){Q=o.initialFocus;}if(typeof o.initialFocus==="string"){for(i=0;i<k.length;i++){if(M.Action.hasOwnProperty(o.initialFocus)){if(M._rb.getText("MSGBOX_"+o.initialFocus).toLowerCase()===k[i].getText().toLowerCase()){Q=k[i];break;}}else{if(o.initialFocus.toLowerCase()===k[i].getText().toLowerCase()){Q=k[i];break;}}}}}return Q;}if(typeof(m)==="string"){v=new T({textDirection:o.textDirection}).setText(m).addStyleClass("sapMMsgBoxText");j=v;}else if(m instanceof C){v=m.addStyleClass("sapMMsgBoxText");}if(o&&o.hasOwnProperty("details")&&o.details!==""){v=K(o,v);}h=new D({id:o.id,type:a.Message,title:o.title,content:v,icon:G[o.icon],initialFocus:O(),verticalScrolling:o.verticalScrolling,horizontalScrolling:o.horizontalScrolling,afterClose:N,buttons:k,ariaLabelledBy:j?j.getId():undefined,contentWidth:o.contentWidth,closeOnNavigation:o.closeOnNavigation});h.setProperty("role",b.AlertDialog);if(z[o.icon]){h.addStyleClass(z[o.icon]);}else{h.addStyleClass(z.STANDARD);}if(o.styleClass){h.addStyleClass(o.styleClass);}h.open();};
M.alert=function(m,o){_();var h={icon:f.NONE,title:M._rb.getText("MSGBOX_TITLE_ALERT"),actions:A.OK,id:E.uid("alert"),initialFocus:null},i,t,s,S;if(typeof o==="function"||arguments.length>2){i=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:i,title:t,id:s,styleClass:S};}if(o){o.isCustomAction=g(o);}o=q.extend({},h,o);return M.show(m,o);};
M.confirm=function(m,o){_();var h={icon:f.QUESTION,title:M._rb.getText("MSGBOX_TITLE_CONFIRM"),actions:[A.OK,A.CANCEL],id:E.uid("confirm"),initialFocus:null},i,t,s,S;if(typeof o==="function"||arguments.length>2){i=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:i,title:t,id:s,styleClass:S};}if(o){o.isCustomAction=g(o);}o=q.extend({},h,o);return M.show(m,o);};
M.error=function(m,o){_();var h={icon:f.ERROR,title:M._rb.getText("MSGBOX_TITLE_ERROR"),actions:[A.CLOSE],id:E.uid("error"),initialFocus:null};if(o){o.isCustomAction=g(o);}o=q.extend({},h,o);return M.show(m,o);};
M.information=function(m,o){_();var h={icon:f.INFORMATION,title:M._rb.getText("MSGBOX_TITLE_INFO"),actions:[A.OK],id:E.uid("info"),initialFocus:null};if(o){o.isCustomAction=g(o);}o=q.extend({},h,o);return M.show(m,o);};
M.warning=function(m,o){_();var h={icon:f.WARNING,title:M._rb.getText("MSGBOX_TITLE_WARNING"),actions:[A.OK],id:E.uid("warning"),initialFocus:null};if(o){o.isCustomAction=g(o);}o=q.extend({},h,o);return M.show(m,o);};
M.success=function(m,o){_();var h={icon:f.SUCCESS,title:M._rb.getText("MSGBOX_TITLE_SUCCESS"),actions:[A.OK],id:E.uid("success"),initialFocus:null};if(o){o.isCustomAction=g(o);}o=q.extend({},h,o);return M.show(m,o);};
}());return M;},true);
sap.ui.predefine('sap/m/MessageItem',["./library","sap/ui/core/Item","sap/ui/core/library","sap/base/Log","sap/base/security/sanitizeHTML"],function(l,I,c,L,s){"use strict";var M=c.MessageType;
var a=I.extend("sap.m.MessageItem",{metadata:{library:"sap.m",properties:{type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:M.Error},title:{type:"string",group:"Appearance",defaultValue:""},subtitle:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Appearance",defaultValue:""},markupDescription:{type:"boolean",group:"Appearance",defaultValue:false},longtextUrl:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},counter:{type:"int",group:"Misc",defaultValue:null},groupName:{type:"string",group:"Misc",defaultValue:""},activeTitle:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"}}}});
a.prototype.setProperty=function(p,v,S){var P=this.getParent(),t=this.getType().toLowerCase(),b=["description","type","groupName"],u=function(n,i){if(i._oMessagePopoverItem.getId()===this.getId()&&i.getMetadata().getProperty(n)){i.setProperty(n,v);}};if(b.indexOf(p)===-1&&P&&("_bItemsChanged"in P)&&!P._bItemsChanged){P._oLists&&P._oLists.all&&P._oLists.all.getItems&&P._oLists.all.getItems().forEach(u.bind(this,p));P._oLists&&P._oLists[t]&&P._oLists[t].getItems&&P._oLists[t].getItems().forEach(u.bind(this,p));}if(typeof this._updatePropertiesFn==="function"){this._updatePropertiesFn();}return I.prototype.setProperty.apply(this,arguments);};
a.prototype._updateProperties=function(b){this._updatePropertiesFn=b;};
a.prototype.setDescription=function(d){if(typeof d==='undefined'){d='';}if(this.getMarkupDescription()){d=s(d);}this.setProperty("description",d,true);return this;};
a.prototype.setType=function(t){if(t===M.None){t=M.Information;L.warning("The provided None type is handled and rendered as Information type");}return this.setProperty("type",t,true);};
return a;});
sap.ui.predefine('sap/m/MessageListItem',["sap/ui/core/library","sap/ui/core/InvisibleText","./library",'./StandardListItem','./Link',"./MessageListItemRenderer"],function(c,I,l,S,L,M){"use strict";var a=c.MessageType;
var b=S.extend("sap.m.MessageListItem",{metadata:{library:"sap.m",properties:{activeTitle:{type:"boolean",group:"Misc",defaultValue:false},messageType:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:a.Error}},aggregations:{link:{type:"sap.m.Link",group:"Misc",multiple:false},linkAriaDescribedBy:{type:"sap.ui.core.Control",group:"Misc",multiple:false}},events:{activeTitlePress:{}}}});
b.prototype.setActiveTitle=function(A){this.setProperty("activeTitle",A);var o=this.getLink();if(!o&&A){o=new L({press:[this.fireActiveTitlePress,this]});this.setLink(o);}return this;};
b.prototype.onBeforeRendering=function(){S.prototype.onBeforeRendering.apply(this,arguments);var o=this.getLink(),d;if(!o){return;}if(!o.getAriaDescribedBy().length){d=this._getLinkAriaDescribedBy();o.setProperty("text",this.getTitle(),true);o.addAssociation('ariaDescribedBy',d.getId(),true);this.setAggregation("linkAriaDescribedBy",d,true);}};
b.prototype._getLinkAriaDescribedBy=function(){var A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("MESSAGE_VIEW_LINK_FOCUS_TEXT",[this.getMessageType()]);return new I(this.getId()+"-link",{text:A});};
b.prototype.onkeydown=function(e){if(this.getActiveTitle()&&e.altKey&&e.key==='Enter'){this.fireActiveTitlePress(this);}};
b.prototype.getContentAnnouncement=function(B){var A=S.prototype.getContentAnnouncement.apply(this,arguments),s,m;if(this.getActiveTitle()){m=B.getText("MESSAGEVIEW_BUTTON_TOOLTIP_"+this.getMessageType().toUpperCase());s=B.getText("MESSAGE_LIST_ITEM_FOCUS_TEXT",[m]);A+=" ".concat(s);}return A;};
return b;});
sap.ui.predefine('sap/m/MessageListItemRenderer',["./StandardListItemRenderer","sap/ui/core/Renderer"],function(S,R){"use strict";var M=R.extend(S);
M.renderTitle=function(r,c){if(c.getActiveTitle()){r.renderControl(c.getLink());r.renderControl(c.getLinkAriaDescribedBy());}else{S.renderTitle.apply(this,arguments);}};
return M;},true);
sap.ui.predefine('sap/m/MessagePage',['./library','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/base/ManagedObject','sap/m/Text','sap/m/Image','sap/m/Button','sap/m/Title','sap/m/Bar','sap/m/FormattedText','./MessagePageRenderer',"sap/ui/thirdparty/jquery"],function(l,c,C,I,M,T,a,B,b,d,F,e,q){"use strict";var f=c.TextAlign;var g=c.TextDirection;var h=l.ButtonType;var i=l.BarDesign;
var j=C.extend("sap.m.MessagePage",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:"No matching items found."},description:{type:"string",group:"Misc",defaultValue:"Check the filter settings."},title:{type:"string",group:"Misc",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://documents"},iconAlt:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{customText:{type:"sap.m.Link",multiple:false},customDescription:{type:"sap.m.Link",multiple:false},buttons:{type:"sap.m.Button",multiple:true},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_description:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{navButtonPress:{}},designtime:"sap/m/designtime/MessagePage.designtime"}});
j.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTitle=null;this._oNavButton=new B(this.getId()+"-navButton",{type:h.Back,press:q.proxy(function(){this.fireNavButtonPress();},this)});this.setAggregation("_internalHeader",new d(this.getId()+"-intHeader",{design:i.Header}));this.setProperty("text",o.getText("MESSAGE_PAGE_TEXT"),true);this.setProperty("description",o.getText("MESSAGE_PAGE_DESCRIPTION"),true);};
j.prototype.exit=function(){if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}if(this._oIconControl){this._oIconControl.destroy();this._oIconControl=null;}};
j.prototype.setTitle=function(t){this.setProperty("title",t,true);if(!this._oTitle){this._oTitle=new b(this.getId()+"-title");this._getInternalHeader().addContentMiddle(this._oTitle);}this._oTitle.setText(t);return this;};
j.prototype.setText=function(t){this.setProperty("text",t,true);var o=this.getAggregation("_text");o&&o.setText(t);return this;};
j.prototype.setDescription=function(D){this.setProperty("description",D,true);var o=this.getAggregation("_formattedText"),k=this.getAggregation("_description");o&&o.setHtmlText(D);k&&k.setText(D);return this;};
j.prototype.setShowNavButton=function(s){this.setProperty("showNavButton",s,true);var H=this._getInternalHeader();if(s){H.addContentLeft(this._oNavButton);}else{H.removeAllContentLeft();}return this;};
j.prototype.setIcon=function(s){var v=this.getIcon()||"";s=s||"";if(v!==s){var S=!!v&&!!s&&I.isIconURI(s)===I.isIconURI(v);this.setProperty("icon",s,S);if(S&&this._oIconControl){this._oIconControl.setSrc(s);}}return this;};
j.prototype.setEnableFormattedText=function(E){var o;if(E){o=this._getFormattedText();o.setHtmlText(this.getDescription());}return this.setProperty("enableFormattedText",E);};
j.prototype._getIconControl=function(){if(this._oIconControl){this._oIconControl.destroy();this._oIconControl=null;}this._oIconControl=I.createControlByURI({id:this.getId()+"-pageIcon",src:this.getIcon(),height:"8rem",width:"8rem",useIconTooltip:true,decorative:false,alt:this.getIconAlt()},a).addStyleClass("sapMMessagePageIcon");return this._oIconControl;};
j.prototype._getText=function(){if(this.getAggregation("customText")){return this.getAggregation("customText");}if(!this.getAggregation("_text")){var t=new T(this.getId()+"-text",{id:this.getId()+"-customText",text:M.escapeSettingsValue(this.getText()),textAlign:f.Center,textDirection:this.getTextDirection()});this.setAggregation("_text",t);}return this.getAggregation("_text");};
j.prototype._getDescription=function(){if(this.getAggregation("customDescription")){return this.getAggregation("customDescription");}if(this.getEnableFormattedText()){return this._getFormattedText();}if(!this.getAggregation("_description")){var D=new T(this.getId()+"-description",{id:this.getId()+"-customDescription",text:M.escapeSettingsValue(this.getDescription()),textAlign:f.Center,textDirection:this.getTextDirection()});this.setAggregation("_description",D);}return this.getAggregation("_description");};
j.prototype._getAnyHeader=function(){return this._getInternalHeader();};
j.prototype._getInternalHeader=function(){return this.getAggregation("_internalHeader");};
j.prototype._getFormattedText=function(){var o=this.getAggregation("_formattedText");if(!o){o=new F(this.getId()+"-formattedText");this.setAggregation("_formattedText",o);}return o;};
return j;});
sap.ui.predefine('sap/m/MessagePageRenderer',['sap/ui/core/library'],function(c){"use strict";var T=c.TextDirection;var M={apiVersion:2};
M.render=function(r,m){this.startOpeningDiv(r,m);this.renderHeader(r,m);this.startInnerDivs(r);this.renderContent(r,m);this.endInnerDivs(r);this.endOpeningDiv(r);};
M.startOpeningDiv=function(r,m){r.openStart("div",m);r.class("sapMMessagePage");if(m.getTextDirection()!==T.Inherit){r.attr("dir",m.getTextDirection().toLowerCase());}r.openEnd();};
M.renderHeader=function(r,m){if(m.getShowHeader()){r.renderControl(m.getAggregation("_internalHeader"));}};
M.startInnerDivs=function(r){r.openStart("div");r.class("sapMMessagePageInner");r.openEnd();r.openStart("div");r.class("sapMMessagePageContentWrapper");r.openEnd();};
M.renderContent=function(r,m){if(m.getIcon()){r.renderControl(m._getIconControl());}r.renderControl(m._getText().addStyleClass("sapMMessagePageMainText"));r.renderControl(m._getDescription().addStyleClass("sapMMessagePageDescription"));this.renderButtons(r,m);};
M.renderButtons=function(r,m){var b=m.getButtons();if(b.length>0){r.openStart("div");r.class("sapMMessagePageButtonsWrapper");r.openEnd();for(var i=0;i<b.length;i++){r.renderControl(b[i]);}r.close("div");}};
M.endInnerDivs=function(r){r.close("div");r.close("div");};
M.endOpeningDiv=function(r){r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MessagePopover',["./ResponsivePopover","./Button","./Toolbar","./Bar","sap/ui/core/Control","sap/ui/core/IconPool","./semantic/SemanticPage","./Popover","./MessageView","sap/ui/Device","./MessagePopoverRenderer","sap/base/Log","sap/ui/thirdparty/jquery"],function(R,B,T,a,C,I,S,P,M,D,b,L,q){"use strict";
var c=C.extend("sap.m.MessagePopover",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},placement:{type:"sap.m.VerticalPlacementType",group:"Behavior",defaultValue:"Vertical"},initiallyExpanded:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessageItem",altTypes:["sap.m.MessagePopoverItem"],multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false,forwarding:{idSuffix:"-messageView",aggregation:"headerButton"}}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},itemSelect:{parameters:{item:{type:"sap.m.MessagePopoverItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{},activeTitlePress:{parameters:{item:{type:"sap.m.MessageItem"}}}}}});
function d(n){return n.charAt(0).toUpperCase()+n.slice(1);}
var e="sapMMsgPopover",f="320px",g="440px",h={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("message-information"),warning:I.getIconURI("message-warning"),error:I.getIconURI("message-error"),success:I.getIconURI("message-success")},A=["asyncDescriptionHandler","asyncURLHandler"],i={asyncDescriptionHandler:function(j){var l=j.item.getLongtextUrl();if(l){q.ajax({type:"GET",url:l,success:function(k){j.item.setDescription(k);j.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+l;L.error(E);j.promise.reject(E);}});}}};
c.setDefaultHandlers=function(m){A.forEach(function(F){if(m.hasOwnProperty(F)){i[F]=m[F];}});};
c.prototype.init=function(){var t=this;var p;this._oOpenByControl=null;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oMessageView=this._initMessageView();this._oMessageView.addEventDelegate({onBeforeRendering:function(){var s=t._oMessageView._oSegmentedButton.getVisible(),j=!t.getInitiallyExpanded()||s;t._oMessageView._oSegmentedButton.setVisible(j);t._oMessageView._listPage.setShowHeader(true);}});this._insertCloseBtn(this._oMessageView._oListHeader);this._insertCloseBtn(this._oMessageView._oDetailsHeader);this._oMessageView._oSegmentedButton.attachEvent("select",this._onSegButtonSelect,this);this._oPopover=new R(this.getId()+"-messagePopover",{showHeader:false,contentWidth:g,contentHeight:f,placement:this.getPlacement(),showCloseButton:false,verticalScrolling:false,horizontalScrolling:false,modal:false,afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter("openBy")});},afterClose:function(E){t._oMessageView._navContainer.backToTop();t.fireAfterClose({openBy:E.getParameter("openBy")});},beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter("openBy")});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter("openBy")});}}).addStyleClass(e);this._oPopover._setAriaModal(false);this._oPopover.addContent(this._oMessageView);this._oPopover.addAssociation("ariaLabelledBy",this.getId()+"-messageView-HeadingDescr",true);p=this._oPopover.getAggregation("_popup");p.oPopup.setAutoClose(false);p.addEventDelegate({onBeforeRendering:this.onBeforeRenderingPopover,onAfterRendering:this.onAfterRenderingPopover},this);if(D.system.phone){this._oPopover.setBeginButton(new B({text:this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),press:this.close.bind(this)}));}A.forEach(function(F){if(i.hasOwnProperty(F)){this['set'+d(F)](i[F]);}},this);};
c.prototype.onBeforeRendering=function(){if(this.getDependents().indexOf(this._oPopover)===-1){this.addDependent(this._oPopover);}};
c.prototype.onBeforeRenderingPopover=function(){if(this._bItemsChanged){var j=this.getItems();var t=this;this._oMessageView.destroyItems();j.forEach(function(k){k._updateProperties(function(){t._bItemsChanged=true;});this._oMessageView.addItem(k.clone("","",{cloneChildren:true,cloneBinding:true}));},this);this._bItemsChanged=false;}this._setInitialFocus();if(this._oOpenByControl&&!this._oOpenByControl.getVisible()){this._oPopover.close();}};
c.prototype.onAfterRenderingPopover=function(){if(this._oPopover._oControl._sFocusControlId){this._oPopover._oControl._sFocusControlId=null;}};
c.prototype.exit=function(){this._oResourceBundle=null;this._oOpenByControl=null;if(this._oMessageView){this._oMessageView.destroy();this._oMessageView=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
c.prototype.openBy=function(o){var r=this._oPopover.getAggregation("_popup"),p=o.getParent();this._oOpenByControl=o;if(r instanceof P){if((p instanceof T||p instanceof a||p instanceof S)){r._minDimensions={width:400,height:128};r.setShowArrow(false);r.setResizable(true);}else{r.setShowArrow(true);}}if(this._oPopover){this._restoreExpansionDefaults();this._oPopover.openBy(o);}return this;};
c.prototype.close=function(){if(this._oPopover){this._oPopover.close();}return this;};
c.prototype.isOpen=function(){return this._oPopover.isOpen();};
c.prototype.toggle=function(o){if(this.isOpen()){this.close();}else{this.openBy(o);}return this;};
c.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._oPopover.setPlacement(p);return this;};
c.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
c.prototype._initMessageView=function(){var t=this,m;m=new M(this.getId()+"-messageView",{activeTitlePress:function(E){if(D.system.phone){t.close();}t.fireActiveTitlePress({item:E.getParameter("item")});},listSelect:function(E){t.fireListSelect({messageTypeFilter:E.getParameter('messageTypeFilter')});},itemSelect:function(E){t.fireItemSelect({messageTypeFilter:E.getParameter('messageTypeFilter'),item:E.getParameter('item')});},longtextLoaded:function(){t.fireLongtextLoaded();},urlValidated:function(){t.fireUrlValidated();}});m._makeAutomaticBinding=function(){var j=t.getItems();if(!t.getBindingInfo("items")&&!j.length){this._bindToMessageModel();}};return m;};
c.prototype._onSegButtonSelect=function(){if(this.isOpen()&&!this.getInitiallyExpanded()&&this._oPopover.hasStyleClass(e+"-init")){this._expandMsgPopover();}};
c.prototype._restoreExpansionDefaults=function(){if(!this.getInitiallyExpanded()&&this.getItems().length!=1){this._collapseMsgPopover();this._oMessageView._oSegmentedButton.setSelectedButton("none");}else{this._expandMsgPopover();}};
c.prototype._expandMsgPopover=function(){var s,H=f,s=this._oPopover.$("cont").css("height");if(this.getInitiallyExpanded()&&s!=="0px"){H=parseFloat(s)?s:H;}this._oPopover.setContentHeight(H).removeStyleClass(e+"-init");};
c.prototype._collapseMsgPopover=function(){this._oPopover.addStyleClass(e+"-init").setContentHeight("auto");};
c.prototype._insertCloseBtn=function(o){var s=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),j=new B({icon:h["close"],visible:!D.system.phone,tooltip:s,press:this.close.bind(this)}).addStyleClass(e+"CloseBtn");o.insertContent(j,3,true);};
c.prototype._setInitialFocus=function(){if(this._oMessageView._isListPage()&&this.getInitiallyExpanded()){this._oPopover.setInitialFocus(this._oMessageView._oLists[this._sCurrentList||'all']);}};
c.prototype.setAsyncDescriptionHandler=function(j){this.setProperty('asyncDescriptionHandler',j,true);this._oMessageView.setProperty('asyncDescriptionHandler',j,true);return this;};
c.prototype.setAsyncURLHandler=function(j){this.setProperty('asyncURLHandler',j,true);this._oMessageView.setProperty('asyncURLHandler',j,true);return this;};
c.prototype.setModel=function(m,n){this._oMessageView.setModel(m,n);return C.prototype.setModel.apply(this,arguments);};
["invalidate","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getBusy","setBusy"].forEach(function(n){c.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var p=this._oPopover;var r=p[n].apply(p,arguments);return r===p?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){c.prototype["_"+F+"Old"]=c.prototype[F];c.prototype[F]=function(){var r=c.prototype["_"+F+"Old"].apply(this,arguments);this._bItemsChanged=true;if(this._oPopover){this._oPopover.invalidate();}if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return r;}return this;};});return c;});
sap.ui.predefine('sap/m/MessagePopoverItem',["./library","./MessageItem"],function(l,M){"use strict";
var a=M.extend("sap.m.MessagePopoverItem",{});
return a;});
sap.ui.predefine('sap/m/MessagePopoverRenderer',[],function(){"use strict";var M={};
M.render=function(r,c){};
return M;},true);
sap.ui.predefine('sap/m/MessageStrip',["./library","sap/ui/core/Control","./MessageStripUtilities","./Text","./Link","./FormattedText","sap/ui/core/library","./MessageStripRenderer","sap/base/Log"],function(l,C,M,T,L,F,c,a,b){"use strict";var d=c.MessageType;
var e=C.extend("sap.m.MessageStrip",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MessageStrip.designtime",properties:{text:{type:"string",group:"Appearance",defaultValue:""},type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:d.Information},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},showCloseButton:{type:"boolean",group:"Appearance",defaultValue:false},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{close:{}},dnd:{draggable:true,droppable:false}}});
e.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this.setAggregation("_text",new T());};
e.prototype.setText=function(t){var f=this.getAggregation("_formattedText");if(f){f.setHtmlText(t);}this.getAggregation("_text").setText(t);return this.setProperty("text",t);};
e.prototype.setType=function(t){if(t===d.None){b.warning(M.MESSAGES.TYPE_NOT_SUPPORTED);t=d.Information;}return this.setProperty("type",t);};
e.prototype.setEnableFormattedText=function(E){var f=this.getAggregation("_formattedText");if(E){if(!f){f=new F();f._setUseLimitedRenderingRules(true);this.setAggregation("_formattedText",f);}f.setHtmlText(this.getText());}return this.setProperty("enableFormattedText",E);};
e.prototype.setAggregation=function(n,o,s){if(n==="link"&&o instanceof L){o.addAriaLabelledBy(this.getId());}C.prototype.setAggregation.call(this,n,o,s);return this;};
a.getAccessibilityState=function(){var A=M.getAccessibilityState.call(this),o=this.getLink();if(!o){A.labelledby=this.getId();}return A;};
e.prototype.ontap=M.handleMSCloseButtonInteraction;e.prototype.onsapenter=M.handleMSCloseButtonInteraction;e.prototype.onsapspace=M.handleMSCloseButtonInteraction;
e.prototype.ontouchmove=function(E){E.setMarked();};
e.prototype.close=function(){var f=function(){this.fireClose();this.setVisible(false);}.bind(this);if(!sap.ui.getCore().getConfiguration().getAnimation()){f();return;}M.closeTransitionWithCSS.call(this,f);};
return e;});
sap.ui.predefine('sap/m/MessageStripRenderer',["./MessageStripUtilities","sap/ui/core/InvisibleText"],function(M,I){"use strict";var a={apiVersion:2};
a.render=function(r,c){this.startMessageStrip(r,c);this.renderAriaTypeText(r,c);if(c.getShowIcon()){this.renderIcon(r,c);}this.renderTextAndLink(r,c);if(c.getShowCloseButton()){this.renderCloseButton(r,c);}this.endMessageStrip(r);};
a.startMessageStrip=function(r,c){r.openStart("div",c);r.class(M.CLASSES.ROOT);r.class(M.CLASSES.ROOT+c.getType());r.attr(M.ATTRIBUTES.CLOSABLE,c.getShowCloseButton());r.accessibilityState(c,this.getAccessibilityState.call(c));r.openEnd();};
a.renderAriaTypeText=function(r,c){r.openStart("span");r.class("sapUiPseudoInvisibleText");r.openEnd();r.text(M.getAriaTypeText.call(c));r.close("span");};
a.renderIcon=function(r,c){r.openStart("div");r.class(M.CLASSES.ICON);r.openEnd();r.icon(M.getIconURI.call(c),null,{"title":null,"aria-hidden":true});r.close("div");};
a.renderTextAndLink=function(r,c){var f=c.getAggregation("_formattedText");r.openStart("div");r.class(M.CLASSES.MESSAGE);r.openEnd();if(c.getEnableFormattedText()&&f){r.renderControl(f);}else{r.renderControl(c.getAggregation("_text"));}r.renderControl(c.getLink());r.close("div");};
a.renderCloseButton=function(r,c){var R=sap.ui.getCore().getLibraryResourceBundle("sap.m");var b=R.getText("MESSAGE_STRIP_"+c.getType().toUpperCase()+"_CLOSE_BUTTON"),d=R.getText("MESSAGE_STRIP_TITLE"),A=new I({text:b}).toStatic().getId();r.openStart("button");r.class(M.CLASSES.CLOSE_BUTTON);r.attr("title",d);r.attr("aria-labelledby",A);r.openEnd();r.close("button");};
a.endMessageStrip=function(r){r.close("div");};
return a;},true);
sap.ui.predefine('sap/m/MessageStripUtilities',function(){"use strict";var M={};M.MESSAGES={TYPE_NOT_SUPPORTED:"Value 'sap.ui.core.MessageType.None' for property 'type' is not supported."+"Defaulting to 'sap.ui.core.MessageType.Information'"};M.CLASSES={ROOT:"sapMMsgStrip",ICON:"sapMMsgStripIcon",MESSAGE:"sapMMsgStripMessage",CLOSE_BUTTON:"sapMMsgStripCloseButton",CLOSING_TRANSITION:"sapMMsgStripClosing"};M.ATTRIBUTES={CLOSABLE:"data-sap-ui-ms-closable"};M.RESOURCE_BUNDLE=sap.ui.getCore().getLibraryResourceBundle("sap.m");
M.getIconURI=function(){var t=this.getType(),c=this.getCustomIcon(),i="sap-icon://message-"+t.toLowerCase();return c||i;};
M.getAriaTypeText=function(){var b="MESSAGE_STRIP_"+this.getType().toUpperCase(),a=M.RESOURCE_BUNDLE.getText(b);if(this.getShowCloseButton()){a+=" "+M.RESOURCE_BUNDLE.getText("MESSAGE_STRIP_CLOSABLE");}return a;};
M.handleMSCloseButtonInteraction=function(e){if(M.isMSCloseButtonPressed(e.target)){this.close();}};
M.isMSCloseButtonPressed=function(t){return t.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1||t.parentNode.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1;};
M.closeTransitionWithCSS=function(c){this.$().addClass(M.CLASSES.CLOSING_TRANSITION).one("webkitTransitionEnd transitionend",c);};
M.getAccessibilityState=function(){return{role:"alert",live:"assertive"};};
return M;});
sap.ui.predefine('sap/m/MessageToast',['./InstanceManager','sap/ui/core/Popup','sap/ui/core/library','sap/ui/core/Control','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(I,P,c,C,D,L,q){"use strict";var a=c.Dock;var d=c.CSSSize;var M={};var O="0 -64",e="sapMMessageToast",E="sapUiSelectable",B="sapContrast",f="sapContrastPlus";M._mSettings={duration:3000,width:"15em",my:"center bottom",at:"center bottom",of:document.defaultView,offset:"0 0",collision:"fit fit",onClose:null,animationTimingFunction:"ease",animationDuration:1000,autoClose:true,closeOnBrowserNavigation:true};M._aPopups=[];M._iOpenedPopups=0;M._bBoundedEvents=false;
M._validateSettings=function(s){M._isFiniteInteger(s.duration);M._validateWidth(s.width);M._validateDockPosition(s.my);M._validateDockPosition(s.at);M._validateOf(s.of);M._validateOffset(s.offset);M._validateCollision(s.collision);M._validateOnClose(s.onClose);M._validateAutoClose(s.autoClose);M._validateAnimationTimingFunction(s.animationTimingFunction);M._isFiniteInteger(s.animationDuration);};
M._isFiniteInteger=function(N){if(typeof N!=="number"||!isFinite(N)||!(Math.floor(N)===N)||N<=0){L.error('"iNumber" needs to be a finite positive nonzero integer on '+M+"._isFiniteInteger");}};
M._validateWidth=function(w){if(!d.isValid(w)){L.error(w+' is not of type '+'"sap.ui.core.CSSSize" for property "width" on '+M+"._validateWidth");}};
M._validateDockPosition=function(s){if(!a.isValid(s)){L.error('"'+s+'"'+' is not of type '+'"sap.ui.core.Popup.Dock" on '+M+"._validateDockPosition");}};
M._validateOf=function(v){if(!(v instanceof q)&&!(v&&v.nodeType===1)&&!(v instanceof C)&&v!==window){L.error('"of" needs to be an instance of sap.ui.core.Control or an Element or a jQuery object or the window on '+M+"._validateOf");}};
M._validateOffset=function(o){if(typeof o!=="string"){L.error(o+' is of type '+typeof o+', expected "string" for property "offset" on '+M+"._validateOffset");}};
M._validateCollision=function(s){var r=/^(fit|flip|none|flipfit|flipflip|flip flip|flip fit|fitflip|fitfit|fit fit|fit flip)$/i;if(!r.test(s)){L.error('"collision" needs to be a single value “fit”, “flip”, or “none”, or a pair for horizontal and vertical e.g. "fit flip”, "fit none", "flipfit" on '+M+"._validateOffset");}};
M._validateOnClose=function(b){if(typeof b!=="function"&&b!==null){L.error('"onClose" should be a function or null on '+M+"._validateOnClose");}};
M._validateAutoClose=function(b){if(typeof b!=="boolean"){L.error('"autoClose" should be a boolean on '+M+"._validateAutoClose");}};
M._validateAnimationTimingFunction=function(t){var r=/^(ease|linear|ease-in|ease-out|ease-in-out)$/i;if(!r.test(t)){L.error('"animationTimingFunction" should be a string, expected values: '+"ease, linear, ease-in, ease-out, ease-in-out on "+M+"._validateAnimationTimingFunction");}};
function h(o){for(var p=["my","at","of","offset"],i=0;i<p.length;i++){if(o[p[i]]!==undefined){return false;}}return true;}
function g(s){var m=document.createElement("div");m.className=e+" "+E+" "+B+" "+f;if(sap.ui.getCore().getConfiguration().getAccessibility()){m.setAttribute("role","alert");m.setAttribute("aria-label"," ");}m.style.width=s.width;m.appendChild(document.createTextNode(s.message));return m;}
function n(o){if(o){if(h(o)){o.offset=O;}if(o.of&&o.of.nodeType===9){o.of=document.defaultView;}}else{o={offset:O};}return o;}
M._handleResizeEvent=function(){if(D.system.phone||D.system.tablet){M._resetPosition(M._aPopups);}setTimeout(M["_applyPositions"].bind(M,M._aPopups),0);};
M._handleMouseDownEvent=function(o){var i=o.target.hasAttribute("class")&&o.target.getAttribute("class").indexOf(e)!==-1;if(i||o.isMarked("delayedMouseEvent")){return;}M._aPopups.forEach(function(p){p&&p.__bAutoClose&&p.close();});};
M._resetPosition=function(p){for(var i=0,m;i<p.length;i++){m=p[i]&&p[i].getContent();if(m){m.style.visibility="hidden";m.style.left=0;}}};
M._applyPositions=function(p){for(var i=0,o,m;i<p.length;i++){o=p[i];if(o){m=o._oPosition;if(D.system.phone||D.system.tablet){setTimeout(M["_applyPosition"].bind(M,o,m),0);}else{o.setPosition(m.my,m.at,m.of,m.offset);}}}};
M._applyPosition=function(p,m){m=m||p._oPosition;var o=p.getContent();p.setPosition(m.my,m.at,m.of,m.offset);o.style.visibility="visible";};
M._setCloseAnimation=function(m,i,b,s){var j="opacity "+s.animationTimingFunction+" "+s.animationDuration+"ms",t="webkitTransitionEnd."+e+" transitionend."+e;if(sap.ui.getCore().getConfiguration().getAnimation()&&s.animationDuration>0){m[0].style.webkitTransition=j;m[0].style.transition=j;m[0].style.opacity=0;m.on(t,function handleMTTransitionEnd(){m.off(t);b();});}else{b();}};
M.show=function(m,o){var t=M,s=q.extend({},M._mSettings,{message:m}),p=new P(),i,b,j="mousedown."+e+" touchstart."+e,k,l;o=n(o);q.extend(s,o);M._validateSettings(s);b=g(s);i=M._aPopups.push(p)-1;p.setContent(b);p.setPosition(s.my,s.at,s.of,s.offset,s.collision);p.setAnimations(function fnMessageToastOpen($,v,w){w();},function fnMessageToastClose($,v,w){t._setCloseAnimation($,v,w,s);});p.setShadow(false);p.__bAutoClose=s.autoClose;if(s.closeOnBrowserNavigation){I.addPopoverInstance(p);}if(!M._bBoundedEvents){q(window).on("resize."+e,M._handleResizeEvent.bind(M));q(document).on(j,M._handleMouseDownEvent.bind(M));M._bBoundedEvents=true;}p.open();M._iOpenedPopups++;function r(){I.removePopoverInstance(t._aPopups[i]);q(t._aPopups[i].getContent()).remove();t._aPopups[i].detachClosed(r);t._aPopups[i].destroy();t._aPopups[i]=null;t._iOpenedPopups--;if(t._iOpenedPopups===0){t._aPopups=[];q(window).off("resize."+e);q(document).off(j);t._bBoundedEvents=false;}if(typeof s.onClose==="function"){s.onClose.call(t);}}p.attachClosed(r);k=setTimeout(p["close"].bind(p),s.duration);function u(){clearTimeout(k);k=null;function v(){l=setTimeout(p["close"].bind(p),s.duration);p.getContent().removeEventListener("mouseleave",v);}p.getContent().addEventListener("mouseleave",v);clearTimeout(l);l=null;}p.getContent().addEventListener("touchstart",u);p.getContent().addEventListener("mouseover",u);if(D.system.desktop){p.getContent().addEventListener("mouseleave",function(){k=setTimeout(p["close"].bind(p),s.duration);});}};
M.toString=function(){return"sap.m.MessageToast";};
return M;},true);
sap.ui.predefine('sap/m/MessageView',["sap/ui/thirdparty/jquery","sap/ui/core/Control","sap/ui/core/CustomData","sap/ui/core/IconPool","sap/ui/core/HTML","sap/ui/core/Icon","./Button","./Toolbar","./ToolbarSpacer","./List","./MessageListItem","./library","./Text","./SegmentedButton","./Page","./NavContainer","./Link","./MessageItem","./GroupHeaderListItem","sap/ui/core/library","sap/ui/base/ManagedObject","./MessageViewRenderer","sap/ui/events/KeyCodes","sap/base/Log","sap/base/security/URLWhitelist","sap/ui/thirdparty/caja-html-sanitizer"],function(q,C,a,I,H,b,B,T,c,L,M,l,d,S,P,N,e,f,G,g,h,j,K,k,U){"use strict";var V=g.ValueState;var m=g.MessageType;var n=l.ListType;
var o=C.extend("sap.m.MessageView",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},groupItems:{type:"boolean",group:"Behavior",defaultValue:false},showDetailsPageHeader:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessageItem",multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false},_navContainer:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},itemSelect:{parameters:{item:{type:"sap.m.MessageItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{},activeTitlePress:{parameters:{item:{type:"sap.m.MessageItem"}}}}}});
var p="sapMMsgView";var r={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("message-information"),warning:I.getIconURI("message-warning"),error:I.getIconURI("message-error"),success:I.getIconURI("message-success")};var s=["all","error","warning","success","information"];var A=["asyncDescriptionHandler","asyncURLHandler"];var D={asyncDescriptionHandler:function(i){var t=i.item.getLongtextUrl();if(t){q.ajax({type:"GET",url:t,success:function(u){i.item.setDescription(u);i.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+t;k.error(E);i.promise.reject(E);}});}}};
o.setDefaultHandlers=function(i){A.forEach(function(F){if(i.hasOwnProperty(F)){D[F]=i[F];}});};
o.prototype.init=function(){var t=this;this._bHasHeaderButton=false;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._createNavigationPages();this._createLists();A.forEach(function(F){if(D.hasOwnProperty(F)){t.setProperty(F,D[F]);}});};
o.prototype._afterNavigate=function(){setTimeout(this["_restoreFocus"].bind(this),0);setTimeout(this["_restoreItemsType"].bind(this),0);};
o.prototype._restoreFocus=function(){if(this._isListPage()&&this.getItems().length){this._oLists[this._sCurrentList||'all'].focus();}else if(this._oBackButton){this._oBackButton.focus();}};
o.prototype._restoreItemsType=function(){if(this._isListPage()&&this.getItems().length>1){var t=this;this._oLists[this._sCurrentList||'all'].getItems().forEach(function(i){t._setItemType(i);});}};
o.prototype._setItemType=function(i){var t,u=i.getActiveTitle();if(!i.getTitle()||!i.getDescription()){if(u){t=".sapMSLITitleOnly a";}else{t=".sapMSLITitleOnly";}}else if(u){t=".sapMSLITitle a";}else{t=".sapMSLITitle";}var v=i.getDomRef().querySelector(t);if(v.offsetWidth<v.scrollWidth){i.setType(n.Navigation);if(this.getItems().length===1){this._fnHandleForwardNavigation(i,"show");}}};
o.prototype.onBeforeRendering=function(){var i,t=this.getItems();this._clearLists();this._detailsPage.setShowHeader(this.getShowDetailsPageHeader());if(this.getGroupItems()){i=this._groupItems(t);this._fillGroupedLists(i);}else{this._fillLists(t);}var u=this.getHeaderButton();if(u){this._bHasHeaderButton=true;this._oListHeader.insertContent(u,2);}this._clearSegmentedButton();this._fillSegmentedButton();this._fnFilterList(this._getCurrentMessageTypeFilter()||"all");if(t.length===1&&this._oLists.all.getItems()[0].getType()===n.Navigation){this._fnHandleForwardNavigation(this._oLists.all.getItems()[0],"show");this._navContainer._pageStack[this._navContainer._pageStack.length-1].transition="slide";}this._makeAutomaticBinding();};
o.prototype._fillGroupedLists=function(i){var t=Object.keys(i),u=t.indexOf(""),v,w;if(u!==-1){v=i[""];w=Object.keys(v);w.forEach(function(x){var y=v[x];this._fillLists(y);delete i[""];t.splice(u,1);},this);}t.forEach(function(x){this._fillListsWithGroups(x,i[x]);},this);};
o.prototype._fillListsWithGroups=function(i,t){var u=Object.keys(t),v=new G({title:i}),w;this._oLists["all"].addAggregation("items",v,true);u.forEach(function(x){this._oLists[x.toLowerCase()].addAggregation("items",v.clone(),true);w=t[x];this._fillLists(w);},this);};
o.prototype.exit=function(){if(this._oLists){this._destroyLists();}if(this._oMessageItemTemplate){this._oMessageItemTemplate.destroy();}this._oResourceBundle=null;this._oListHeader=null;this._oDetailsHeader=null;this._oSegmentedButton=null;this._oBackButton=null;this._navContainer=null;this._listPage=null;this._detailsPage=null;this._sCurrentList=null;};
o.prototype._makeAutomaticBinding=function(){var i=this.getItems();if(!this.getBindingInfo("items")&&!i.length){this._bindToMessageModel();}};
o.prototype._bindToMessageModel=function(){var t=this;this.setModel(sap.ui.getCore().getMessageManager().getMessageModel(),"message");this._oMessageItemTemplate=new f({type:"{message>type}",title:"{message>message}",description:"{message>description}",longtextUrl:"{message>longtextUrl}"});this.bindAggregation("items",{path:"message>/",template:t._oMessageItemTemplate});};
o.prototype._groupItems=function(i){var t={},u,v;i.forEach(function(w){u=w.getGroupName();v=w.getType();t[u]=t[u]||{};var x=t[u];if(x[v]){x[v].push(w);}else{x[v]=[w];}});return t;};
o.prototype._onkeypress=function(E){if(E.shiftKey&&E.keyCode==K.ENTER){this.navigateBack();}};
o.prototype._getListHeader=function(){return this._oListHeader||this._createListHeader();};
o.prototype._getDetailsHeader=function(){return this._oDetailsHeader||this._createDetailsHeader();};
o.prototype._createListHeader=function(){var i=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var t=this.getId()+"-CloseBtnDescr";var u=new H(t,{content:"<span id=\""+t+"\" style=\"display: none;\">"+i+"</span>"});var v=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_HEADING");var w=this.getId()+"-HeadingDescr";var x=new H(w,{content:"<span id=\""+w+"\" style=\"display: none;\" role=\"heading\">"+v+"</span>"});this._oSegmentedButton=new S(this.getId()+"-segmented",{}).addStyleClass("sapMSegmentedButtonNoAutoWidth");this._oListHeader=new T({content:[this._oSegmentedButton,new c(),u,x]});return this._oListHeader;};
o.prototype._createDetailsHeader=function(){var i=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var t=this.getId()+"-CloseBtnDetDescr";var u=new H(t,{content:"<span id=\""+t+"\" style=\"display: none;\">"+i+"</span>"});var v=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON_TOOLTIP");var w=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON");var x=this.getId()+"-BackBtnDetDescr";var y=new H(x,{content:"<span id=\""+x+"\" style=\"display: none;\">"+w+"</span>"});this._oBackButton=new B({icon:r["back"],press:this.navigateBack.bind(this),ariaLabelledBy:y,tooltip:v}).addStyleClass(p+"BackBtn");this._oDetailsHeader=new T({content:[this._oBackButton,new c(),u,y]});return this._oDetailsHeader;};
o.prototype._createNavigationPages=function(){this._listPage=new P(this.getId()+"listPage",{customHeader:this._getListHeader()});this._detailsPage=new P(this.getId()+"-detailsPage",{customHeader:this._getDetailsHeader()});this._detailsPage.addEventDelegate({onclick:function(E){var t=E.target;if(t.nodeName.toUpperCase()==="A"&&(t.className.indexOf("sapMMsgPopoverItemDisabledLink")!==-1||t.className.indexOf("sapMMsgPopoverItemPendingLink")!==-1)){E.preventDefault();}}});this._navContainer=new N(this.getId()+"-navContainer",{initialPage:this.getId()+"listPage",pages:[this._listPage,this._detailsPage],afterNavigate:this._afterNavigate.bind(this)});this.setAggregation("_navContainer",this._navContainer);return this;};
o.prototype._createLists=function(){this._oLists={};s.forEach(function(i){this._oLists[i]=new L({itemPress:this._fnHandleItemPress.bind(this),visible:false});this._listPage.addAggregation("content",this._oLists[i],true);},this);return this;};
o.prototype._clearLists=function(){s.forEach(function(i){if(this._oLists[i]){this._oLists[i].destroyAggregation("items",true);}},this);return this;};
o.prototype._destroyLists=function(){s.forEach(function(i){this._oLists[i]=null;},this);this._oLists=null;};
o.prototype._fillLists=function(i){i.forEach(function(t){var u=this._mapItemToListItem(t),v=this._mapItemToListItem(t);this._oLists["all"].addAggregation("items",u,true);this._oLists[t.getType().toLowerCase()].addAggregation("items",v,true);},this);};
o.prototype._mapItemToListItem=function(i){if(!i){return null;}var t=i.getType(),u=this,v=this._getItemType(i),w=new M({title:h.escapeSettingsValue(i.getTitle()),description:h.escapeSettingsValue(i.getSubtitle()),counter:i.getCounter(),icon:this._mapIcon(t),infoState:this._mapInfoState(t),info:"\r",type:v,messageType:i.getType(),activeTitle:i.getActiveTitle(),activeTitlePress:function(){u.fireActiveTitlePress({item:i});}}).addStyleClass(p+"Item").addStyleClass(p+"Item"+t).toggleStyleClass(p+"ItemActive",i.getActiveTitle());if(v!==n.Navigation){w.addEventDelegate({onAfterRendering:function(){u._setItemType(w);}},this);}w._oMessageItem=i;return w;};
o.prototype._mapInfoState=function(t){if(!t){return null;}switch(t){case m.Warning:return V.Warning;case m.Error:return V.Error;case m.Success:return V.Success;case m.Information:case m.None:return V.None;default:k.warning("The provided MessageType is not mapped to a specific ValueState",t);return null;}};
o.prototype._mapIcon=function(i){if(!i){return null;}return r[i.toLowerCase()];};
o.prototype._getItemType=function(i){return(i.getDescription()||i.getMarkupDescription()||i.getLongtextUrl())?n.Navigation:n.Inactive;};
o.prototype._clearSegmentedButton=function(){if(this._oSegmentedButton){this._oSegmentedButton.destroyAggregation("buttons",true);}return this;};
o.prototype._fillSegmentedButton=function(){var t=this;var i=function(w){return function(){t._fnFilterList(w);};};s.forEach(function(w){var x=this._oLists[w],y=w=="all"?"MESSAGEPOPOVER_ALL":"MESSAGEVIEW_BUTTON_TOOLTIP_"+w.toUpperCase(),z=x.getItems().filter(function(F){return(F instanceof M);}).length,E;if(z>0){E=new B(this.getId()+"-"+w,{text:w=="all"?this._oResourceBundle.getText(y):z,tooltip:this._oResourceBundle.getText(y),icon:r[w],press:i(w)}).addStyleClass(p+"Btn"+w.charAt(0).toUpperCase()+w.slice(1));this._oSegmentedButton.addButton(E,true);}},this);var u=this._oSegmentedButton.getButtons().length>2;this._oSegmentedButton.setVisible(u);if(!u){this._oSegmentedButton.setSelectedButton(this._oSegmentedButton.getButtons()[0]);this._fnFilterList('all');}var v=u||this._bHasHeaderButton;this._listPage.setShowHeader(v);return this;};
o.prototype._setIcon=function(i,t){this._previousIconTypeClass=p+"DescIcon"+i.getType();this._oMessageIcon=new b({src:t.getIcon()}).addStyleClass(p+"DescIcon").addStyleClass(this._previousIconTypeClass);this._detailsPage.addContent(this._oMessageIcon);};
o.prototype._setTitle=function(i,t){var u=i.getActiveTitle(),v,w=this,x=h.escapeSettingsValue(i.getTitle()),y=this.getId()+"MessageTitleText";if(u){v=new e(y,{text:x,ariaDescribedBy:t.getId()+"-link",press:function(){w.fireActiveTitlePress({item:i});}});}else{v=new d(y,{text:x});}v.addStyleClass("sapMMsgViewTitleText");this._detailsPage.addAggregation("content",v);};
o.prototype._setDescription=function(i){var t=i.getLink();this._oLastSelectedItem=i;if(i.getMarkupDescription()){this._oMessageDescriptionText=new H(this.getId()+"MarkupDescription",{content:"<div class='sapMMsgViewDescriptionText'>"+h.escapeSettingsValue(i.getDescription())+"</div>"});}else{this._oMessageDescriptionText=new d(this.getId()+"MessageDescriptionText",{text:h.escapeSettingsValue(i.getDescription())}).addStyleClass("sapMMsgViewDescriptionText");}this._detailsPage.addContent(this._oMessageDescriptionText);if(t){var u=this._createLinkCopy(t);this._detailsPage.addContent(u);u.addStyleClass("sapMMsgViewDescriptionLink");}};
o.prototype._createLinkCopy=function(i){var t,u=i.clone("","",{cloneChildren:false,cloneBindings:false}),v=i.getCustomData()||[];t=Object.keys(i.getMetadata().getProperties());t.forEach(function(w){u.setProperty(w,i.getProperty(w));});u.destroyCustomData();v.forEach(function(w){var x=new a({key:w.getKey(),value:w.getValue()});u.addCustomData(x);});return u;};
o.prototype._iNextValidationTaskId=0;
o.prototype._validateURL=function(u){if(U.validate(u)){return u;}k.warning("You have entered invalid URL");return"";};
o.prototype._queueValidation=function(i){var t=this.getAsyncURLHandler();var v=++this._iNextValidationTaskId;var u={};var w=new window.Promise(function(x,y){u.resolve=x;u.reject=y;var z={url:i,id:v,promise:u};t(z);});w.id=v;return w;};
o.prototype._getTagPolicy=function(){var t=this,i;var u=html.makeTagPolicy(this._validateURL());return function customTagPolicy(v,w){var x,y=false;if(v.toUpperCase()==="A"){for(i=0;i<w.length;){if(w[i]==="href"){y=true;x=w[i+1];w.splice(0,2);continue;}i+=2;}}w=u(v,w);if(y&&typeof t.getAsyncURLHandler()==="function"){w=w||[];var z="sapMMsgViewItemDisabledLink sapMMsgViewItemPendingLink";var E=w.indexOf("class");if(E>-1){w[E+1]+=z;}else{w.unshift(z);w.unshift("class");}var F=w.indexOf("id");if(F>-1){w.splice(F+1,1);w.splice(F,1);}var J=t._queueValidation(x);w.push("href");w.push(x);w.push("target");w.push("_blank");w.push("id");w.push("sap-ui-"+t.getId()+"-link-under-validation-"+J.id);J.then(function(O){var $=q(document.getElementById("sap-ui-"+t.getId()+"-link-under-validation-"+O.id));if(O.allowed){k.info("Allow link "+x);}else{k.info("Disallow link "+x);}$.removeClass("sapMMsgViewItemPendingLink");$.toggleClass("sapMMsgViewItemDisabledLink",!O.allowed);t.fireUrlValidated();}).catch(function(){k.warning("Async URL validation could not be performed.");});}return w;};};
o.prototype._sanitizeDescription=function(i){var t=i.getDescription();if(i.getMarkupDescription()){var u=this._getTagPolicy();t=html.sanitizeWithPolicy(t,u);}i.setDescription(t);this._setDescription(i);};
o.prototype._fnHandleForwardNavigation=function(i,t){var u=i._oMessageItem,v=this._detailsPage.getContent()||[],w=this.getAsyncDescriptionHandler();this._previousIconTypeClass=this._previousIconTypeClass||"";this.fireItemSelect({item:u,messageTypeFilter:this._getCurrentMessageTypeFilter()});this._clearDetailsPage.call(this,v);if(typeof w==="function"&&!!u.getLongtextUrl()){u.setMarkupDescription(true);var x={};var y=new window.Promise(function(E,F){x.resolve=E;x.reject=F;});var z=function(){this._detailsPage.setBusy(false);this._navigateToDetails.call(this,u,i,t,true);}.bind(this);y.then(z).catch(function(){k.warning("Async description loading could not be performed.");z();});this._navContainer.to(this._detailsPage);this._detailsPage.setBusy(true);w({promise:x,item:u});}else{this._navigateToDetails.call(this,u,i,t,false);}this._listPage.$().attr("aria-hidden","true");};
o.prototype._fnHandleItemPress=function(E){this._fnHandleForwardNavigation(E.getParameter("listItem"),"slide");};
o.prototype._navigateToDetails=function(i,t,u,v){this._setTitle(i,t);this._sanitizeDescription(i);this._setIcon(i,t);this._detailsPage.rerender();this.fireLongtextLoaded();if(!v){this._navContainer.to(this._detailsPage,u);}};
o.prototype._clearDetailsPage=function(i){i.forEach(function(t){t.destroy();},this);};
o.prototype.navigateBack=function(){this._listPage.$().removeAttr("aria-hidden");this._navContainer.back();};
o.prototype._fnFilterList=function(i){s.forEach(function(t){if(t!=i&&this._oLists[t].getVisible()){this._oLists[t].setVisible(false);}},this);this._sCurrentList=i;this._oLists[i].setVisible(true);this.fireListSelect({messageTypeFilter:this._getCurrentMessageTypeFilter()});};
o.prototype._getCurrentMessageTypeFilter=function(){return this._sCurrentList=="all"?"":this._sCurrentList;};
o.prototype._isListPage=function(){return this._navContainer.getCurrentPage()==this._listPage;};
return o;});
sap.ui.predefine('sap/m/MessageViewRenderer',function(){"use strict";var M={};var C="sapMMsgView";
M.render=function(r,c){r.write("<div");r.writeControlData(c);r.writeStyles();r.addClass(C);r.writeClasses();r.write(">");r.renderControl(c._navContainer);r.write("</div>");};
return M;},true);
sap.ui.predefine('sap/m/MultiComboBox',['./InputBase','./ComboBoxTextField','./ComboBoxBase','./Tokenizer','./Token','./List','./StandardListItem','./Popover','./GroupHeaderListItem','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/ui/core/Item','sap/ui/core/SeparatorItem','sap/ui/core/ResizeHandler','./MultiComboBoxRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/base/util/deepEqual","sap/base/assert","sap/base/Log","sap/ui/core/Core",'sap/ui/core/InvisibleText',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/control"],function(I,C,a,T,b,L,S,P,G,l,E,c,d,D,e,f,R,M,g,K,h,j,k,m,n,q){"use strict";var o=l.ListType;var p=l.ListMode;var V=d.ValueState;var O=d.OpenState;var r=l.PlacementType;
var s=a.extend("sap.m.MultiComboBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MultiComboBox.designtime",properties:{selectedKeys:{type:"string[]",group:"Data",defaultValue:[]}},associations:{selectedItems:{type:"sap.ui.core.Item",multiple:true,singularName:"selectedItem"}},events:{selectionChange:{parameters:{changedItem:{type:"sap.ui.core.Item"},selected:{type:"boolean"}}},selectionFinish:{parameters:{selectedItems:{type:"sap.ui.core.Item[]"}}}},dnd:{draggable:false,droppable:true}}});
c.insertFontFaceStyle();E.apply(s.prototype,[true]);
s.prototype.clone=function(i){var t=a.prototype.clone.apply(this,arguments),u=this._getList();if(u){t.syncPickerContent();}return t;};
s.prototype.open=function(){if(!this.isOpen()){this._bPickerIsOpening=true;}this.syncPickerContent();return a.prototype.open.apply(this,arguments);};
s.prototype.onsapend=function(i){if(i.isMarked("forwardFocusToParent")){this.focus();}};
s.prototype.onsaphome=function(i){if(!this.getFocusDomRef().selectionStart){T.prototype.onsaphome.apply(this._oTokenizer,arguments);}i.setMarked();};
s.prototype.onsapdown=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();this.syncPickerContent();var t=this.getSelectableItems();var u=t[0];var v=this;if(u&&this.isOpen()){setTimeout(function(){v.getListItem(u).focus();},0);return;}if(this.isFocusInTokenizer()){return;}this._oTraversalItem=this._getNextTraversalItem();if(this._oTraversalItem&&!this.isComposingCharacter()){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}};
s.prototype.onsapup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();if(this.isFocusInTokenizer()){return;}this._oTraversalItem=this._getPreviousTraversalItem();if(this._oTraversalItem){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}};
s.prototype.isFocusInTokenizer=function(){return q.contains(this._oTokenizer.getFocusDomRef(),document.activeElement);};
s.prototype.onsapshow=function(i){var t,u,v,w,x,y,z,A;this.syncPickerContent();w=this.getPicker();x=this._getList();y=this.getSelectableItems();z=this.getSelectedItems();A=x.getItemNavigation();v=q(document.activeElement).control()[0];if(v instanceof sap.m.Token){t=this._getItemByToken(v);}else{t=z.length?this._getItemByListItem(this._getList().getSelectedItems()[0]):y[0];}u=this.getItems().indexOf(t);if(A){A.setSelectedIndex(u);}else{this._bListItemNavigationInvalidated=true;this._iInitialItemFocus=u;}w.setInitialFocus(x);a.prototype.onsapshow.apply(this,arguments);};
s.prototype.onsaphide=s.prototype.onsapshow;
s.prototype._selectItemByKey=function(t){var v,u,w,i,x,y=this.isOpen();if(!this.getEnabled()||!this.getEditable()){return;}if(t){t.setMarked();}v=this._getUnselectedItems(y?"":this.getValue());for(i=0;i<v.length;i++){if(v[i].getText().toUpperCase()===this.getValue().toUpperCase()){w=v[i];x=true;break;}}if(x){u={item:w,id:w.getId(),key:w.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false};this._bPreventValueRemove=false;if(this.getValue()===""||(typeof this.getValue()==="string"&&w.getText().toLowerCase().startsWith(this.getValue().toLowerCase()))){if(this.getListItem(w).isSelected()){this.setValue('');}else{this.setSelection(u);}}}else{if(this.isPickerDialog()){this._showAlreadySelectedVisualEffect();}this._bPreventValueRemove=true;!this.isComposingCharacter()&&this._showWrongValueVisualEffect();}if(t){this.close();}};
s.prototype.onsapenter=function(i){I.prototype.onsapenter.apply(this,arguments);this._showAlreadySelectedVisualEffect();if(this.getValue()){this._selectItemByKey(i);}if(!this.getEditable()&&this._oTokenizer._hasMoreIndicator()&&i.target===this.getFocusDomRef()){this._handleIndicatorPress(i);}};
s.prototype.onsaptabnext=function(i){var t=this.getValue();if(t){var u=this._getUnselectedItemsStartingText(t);if(u.length===1){this._selectItemByKey(i);}else{this._showWrongValueVisualEffect();}}};
s.prototype.onsapfocusleave=function(i){var t=this.isPlatformTablet(),u=m.byId(i.relatedControlId),F=u&&u.getFocusDomRef(),v=this.getValue(),w=this.getPicker();if(!this._bPickerIsOpening&&(!w||!w.getFocusDomRef()||!F||!q.contains(w.getFocusDomRef(),F))){this.setValue(null);if(v){this.fireChangeEvent("",{value:v});}if(!(u instanceof b||i.srcControl instanceof b)){this._oTokenizer.scrollToEnd();}if(!q.contains(this.getDomRef(),document.activeElement)){this._oTokenizer._useCollapsedMode(true);}}if(w&&F){if(h(w.getFocusDomRef(),F)&&!t&&!this.isPickerDialog()){this.focus();}}};
s.prototype.onfocusin=function(i){var t=this.getPicker();var u=false;var v=t&&t.getFocusDomRef();var w=(t&&t.oPopup.getOpenState())||O.CLOSED;var x=w===O.CLOSING||w===O.CLOSED;var y=this.getPickerType()==="Dropdown";if(y){u=v&&q.contains(v,i.relatedTarget);}if(this.getEditable()){this._oTokenizer._useCollapsedMode(false);this._oTokenizer.scrollToEnd();}if(i.target===this.getFocusDomRef()){this.getEnabled()&&this.addStyleClass("sapMFocus");!x&&u&&this.handleInputValidation(i,false);}if(i.target===this.getOpenArea()&&y&&!this.isPlatformTablet()){this.focus();}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}};
s.prototype._handleItemTap=function(i){var t=q(i.target).control(0);if(!t.isA("sap.m.CheckBox")&&!t.isA("sap.m.GroupHeaderListItem")){this._bCheckBoxClicked=false;}};
s.prototype._handleItemPress=function(i){if(this.isOpen()&&this._isListInSuggestMode()&&this.getPicker().oPopup.getOpenState()!==O.CLOSING){this.clearFilter();var t=this._getLastSelectedItem();if(t){this.getListItem(t).focus();}}};
s.prototype._handleSelectionLiveChange=function(i){var t=i.getParameter("listItem");var u=i.getParameter("selected");var N=this._getItemByListItem(t);var v=this.isPickerDialog()?this.getPickerTextField():this;if(t.getType()==="Inactive"){return;}j(N,"The corresponding mapped item was not found on "+this);if(!N){return;}var w={item:N,id:N.getId(),key:N.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:true};if(u){this.fireChangeEvent(N.getText());this.setSelection(w);}else{this.fireChangeEvent(N.getText());this.removeSelection(w);}if(this._bCheckBoxClicked){v.setValue(this._sOldInput);if(this.isOpen()&&this.getPicker().oPopup.getOpenState()!==O.CLOSING){t.focus();}}else{this._bCheckBoxClicked=true;this.setValue("");this.close();}};
s.prototype.onkeydown=function(i){a.prototype.onkeydown.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}this._bIsPasteEvent=(i.ctrlKey||i.metaKey)&&(i.which===K.V);if(this.getValue().length===0&&(i.ctrlKey||i.metaKey)&&(i.which===K.A)&&this._hasTokens()){this._oTokenizer.focus();this._oTokenizer.selectAllTokens(true);i.preventDefault();}if(this.isPickerDialog()){this._sOldValue=this.getPickerTextField().getValue();this._iOldCursorPos=q(this.getFocusDomRef()).cursorPos();}this._bDoTypeAhead=(i.which!==K.BACKSPACE)&&(i.which!==K.DELETE);};
s.prototype.oninput=function(i){a.prototype.oninput.apply(this,arguments);var t=i.srcControl,u=this.getPickerTextField();if(this.isPickerDialog()&&u.getValueState()===V.Error){u.setValueState(V.None);}else if(this.getValueState()===V.Error){this.setValueState(V.None);}if(!this.getEnabled()||!this.getEditable()){return;}this.syncPickerContent();if(this._bIsPasteEvent){t.updateDomValue(this._sOldValue||"");return;}this.handleInputValidation(i,this.isComposingCharacter());if(this.isOpen()){setTimeout(this._highlightList.bind(this,this._sOldInput));}};
s.prototype.filterItems=function(i){var F=this.fnFilter?this.fnFilter:a.DEFAULT_TEXT_FILTER;var t=[];var u=false;var v=[];i.items.forEach(function(w){if(w.isA("sap.ui.core.SeparatorItem")){v.push({separator:w});this.getListItem(w).setVisible(false);u=true;return;}var x=!!F(i.value,w,"getText");if(i.value===""){x=true;if(!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){return;}}if(u&&x){this.getListItem(v[v.length-1].separator).setVisible(true);}var y=this.getListItem(w);if(y){y.setVisible(x);x&&t.push(w);}},this);return t;};
s.prototype.onkeyup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}this._sOldValue=this.getValue();this._iOldCursorPos=q(this.getFocusDomRef()).cursorPos();};
s.prototype._showWrongValueVisualEffect=function(){var i=this.getPickerTextField(),t=this._getSuggestionsPopover(),u=this.isPickerDialog()?i.getValueState():this.getValueState(),v=this._sOriginalValueStateText||this._oRbC.getText("VALUE_STATE_ERROR");if(u===V.Error){return;}if(t){t.updateValueState(V.Error,v,true);setTimeout(t.updateValueState.bind(t,u,v,true),1000);}if(!this.isPickerDialog()){this.setValueState(V.Error);this.setValueStateText(v);setTimeout(this["setValueState"].bind(this,u),1000);}this._syncInputWidth(this._oTokenizer);};
s.prototype._showAlreadySelectedVisualEffect=function(){var i=this.isPickerDialog(),t=this.getPickerTextField(),v=i?t.getValueState():this.getValueState(),u=this.getValue().toLowerCase(),w=this.getSelectedItems().map(function(x){return x.getText().toLowerCase();}),A=this._oRbM.getText("VALUE_STATE_ERROR_ALREADY_SELECTED");if(w.indexOf(u)>-1&&v!==V.Error&&!this.isComposingCharacter()){if(i){t.setValueState(V.Error);t.setValueStateText(A);t.selectText(0,this.getValue().length);}else{this.setValueState(V.Error);this.setValueStateText(A);this.selectText(0,this.getValue().length);}}else{i?t.setValueState(V.None):this.setValueState(V.None);}};
s.prototype._hasShowSelectedButton=function(){return true;};
s.prototype.forwardEventHandlersToSuggPopover=function(i){a.prototype.forwardEventHandlersToSuggPopover.apply(this,arguments);i.setShowSelectedPressHandler(this._filterSelectedItems.bind(this));};
s.prototype._getReadOnlyPopover=function(){if(!this._oReadOnlyPopover){this._oReadOnlyPopover=this._createReadOnlyPopover();}return this._oReadOnlyPopover;};
s.prototype._createReadOnlyPopover=function(){return new P({showArrow:true,placement:r.Auto,showHeader:false,contentMinWidth:"auto"}).addStyleClass("sapMMultiComboBoxReadOnlyPopover");};
s.prototype.configPicker=function(i){var t=this.getRenderer(),u=t.CSS_CLASS_MULTICOMBOBOX;i.setHorizontalScrolling(false).addStyleClass(t.CSS_CLASS_COMBOBOXBASE+"Picker").addStyleClass(u+"Picker").addStyleClass(u+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this);};
s.prototype._configureList=function(i){if(!i){return;}i.setMode(p.MultiSelect);i.setIncludeItemInSelection(true);i.attachBrowserEvent("tap",this._handleItemTap,this).attachSelectionChange(this._handleSelectionLiveChange,this).attachItemPress(this._handleItemPress,this);i.addEventDelegate({onAfterRendering:this.onAfterRenderingList,onfocusin:this.onFocusinList},this);};
s.prototype._modifyPopupInput=function(i){a.prototype._modifyPopupInput.apply(this,arguments);i.attachSubmit(function(t){var v=i.getValue();if(v){this.setValue(v);this._selectItemByKey();this.setValue(this._sOldInput);this.close();}}.bind(this));i.addEventDelegate({onfocusout:this._handleInputFocusOut},this);return i;};
s.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this._bInitialSelectedKeysSettersCompleted=true;this._oTokenizer.setEnabled(this.getEnabled());this.setEditable(this.getEditable());this._deregisterResizeHandler();this._synchronizeSelectedItemAndKey();};
s.prototype.syncPickerContent=function(F){var i,t,u=this.getPicker();if(!u){u=this.createPicker(this.getPickerType());this._updateSuggestionsPopoverValueState();F=true;}if(F){i=this.getItems();t=this._getList();this._synchronizeSelectedItemAndKey();t.destroyItems();this._clearTokenizer();this._fillList(i);if(t.getItemNavigation()){this._iFocusedIndex=t.getItemNavigation().getFocusedIndex();}}return u;};
s.prototype._registerResizeHandler=function(){j(!this._iResizeHandlerId,"Resize handler already registered");this._iResizeHandlerId=R.register(this,this._onResize.bind(this));};
s.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
s.prototype._onResize=function(){this._oTokenizer.setMaxWidth(this._calculateSpaceForTokenizer());this._syncInputWidth(this._oTokenizer);this._handleNMoreAccessibility();};
s.prototype.onBeforeRenderingPicker=function(){var i=this["_onBeforeRendering"+this.getPickerType()];if(i){i.call(this);}};
s.prototype.onAfterRenderingPicker=function(){var i=this["_onAfterRendering"+this.getPickerType()];if(i){i.call(this);}};
s.prototype.onBeforeOpen=function(){var i=this["_onBeforeOpen"+this.getPickerType()];this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);this._resetCurrentItem();this.addContent();this._aInitiallySelectedItems=this.getSelectedItems();this._synchronizeSelectedItemAndKey();if(i){i.call(this);}};
s.prototype.onAfterOpen=function(){var i=this.getFocusDomRef();i&&this.getRoleComboNodeDomRef().setAttribute("aria-expanded","true");this._bPickerIsOpening=false;if(!this.isPlatformTablet()){this.getPicker().setInitialFocus(this);}this.closeValueStateMessage();};
s.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);};
s.prototype.onAfterClose=function(){var u=!q.contains(this.getDomRef(),document.activeElement)||this.isPickerDialog(),i=this.getFocusDomRef();i&&this.getRoleComboNodeDomRef().setAttribute("aria-expanded","false");this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.clearFilter();!this.isComposingCharacter()&&!this._bPreventValueRemove&&this.setValue("");this._sOldValue="";this._sOldInput="";this._getSuggestionsPopover()._sTypedInValue="";if(this.isPickerDialog()){this._showAlreadySelectedVisualEffect();this.getPickerTextField().setValue("");this.getFilterSelectedButton()&&this.getFilterSelectedButton().setPressed(false);}this.fireSelectionFinish({selectedItems:this.getSelectedItems()});this._oTokenizer._useCollapsedMode(u);if(this.getValueState()==V.Error&&document.activeElement===this.getFocusDomRef()){this.selectText(0,this.getValue().length);this.openValueStateMessage();}};
s.prototype._onBeforeOpenDialog=function(){};
s.prototype._onBeforeOpenDropdown=function(){var i=this.getPicker(),t=this.getDomRef(),w;if(t&&i){w=(t.offsetWidth/parseFloat(l.BaseFontSize))+"rem";i.setContentMinWidth(w);}};
s.prototype.getFilterSelectedButton=function(){return this._getSuggestionsPopover().getFilterSelectedButton();};
s.prototype._filterSelectedItems=function(i,F){var t=i.oSource,u,v,w=this.getPickerTextField()?this.getPickerTextField().getValue():"",x=(t&&t.getPressed&&t.getPressed())||F,y=this.getVisibleItems(),z=this.getItems(),A=this.getSelectedItems(),B=null;if(x){y.forEach(function(H){v=A.indexOf(H)>-1?true:false;u=this.getListItem(H);if(!u){return;}if(u.isA("sap.m.GroupHeaderListItem")){u.setVisible(false);B=u;}else{u.setVisible(v);if(v&&B){B.setVisible(true);}}},this);}else{this.filterItems({value:w,items:z});}};
s.prototype.revertSelection=function(){this.setSelectedItems(this._aInitiallySelectedItems);};
s.prototype.setSelection=function(i){var t=this._getList();if(i.item&&this.isItemSelected(i.item)){return;}if(!i.item){return;}if(!i.listItemUpdated&&this.getListItem(i.item)&&t){t.setSelectedItem(this.getListItem(i.item),true);}var u=new b({key:i.key});u.setText(i.item.getText());i.item.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",u);this._oTokenizer.addToken(u);this.$().toggleClass("sapMMultiComboBoxHasToken",this._hasTokens());this.setValue('');this.addAssociation("selectedItems",i.item,i.suppressInvalidate);var v=this.getSelectedKeys();var w=this.getKeys([i.item])[0];if(w===""||v.indexOf(w)===-1){v.push(w);this.setProperty("selectedKeys",v,i.suppressInvalidate);}if(i.fireChangeEvent){this.fireSelectionChange({changedItem:i.item,selected:true});}if(i.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
s.prototype.removeSelection=function(i){if(i.item&&!this.isItemSelected(i.item)){return;}if(!i.item){return;}this.removeAssociation("selectedItems",i.item,i.suppressInvalidate);var t=this.getSelectedKeys();var u=t.indexOf(i.item.getKey());t.splice(u,1);this.setProperty("selectedKeys",t,i.suppressInvalidate);if(!i.listItemUpdated&&this.getListItem(i.item)){var v=this.getListItem(i.item);this._getList().setSelectedItem(v,false);}if(!i.tokenUpdated){var w=this._getTokenByItem(i.item);i.item.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",null);this._oTokenizer.removeToken(w);}this.$().toggleClass("sapMMultiComboBoxHasToken",this._hasTokens());if(i.fireChangeEvent){this.fireSelectionChange({changedItem:i.item,selected:false});}if(i.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
s.prototype.setValueStateText=function(v){var i=[this._oRbC.getText("VALUE_STATE_ERROR"),this._oRbM.getText("VALUE_STATE_ERROR_ALREADY_SELECTED")];if(i.indexOf(v)===-1){this._sOriginalValueStateText=v;}a.prototype.setValueStateText.apply(this,arguments);return this;};
s.prototype._synchronizeSelectedItemAndKey=function(){var t=this.getSelectedKeys();var u=this.getKeys(this.getSelectedItems());if(!t.length){k.info("Info: _synchronizeSelectedItemAndKey() the MultiComboBox control does not contain any item on ",this);return;}for(var i=0,v=null,w=null,x=t.length;i<x;i++){v=t[i];if(u.indexOf(v)>-1){continue;}w=this.getItemByKey(""+v);if(w){this.setSelection({item:w,id:w.getId(),key:w.getKey(),fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:false});}}};
s.prototype._getTokenByItem=function(i){return i?i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token"):null;};
s.prototype.updateItems=function(i){var t=function(x){return x&&x.getKey&&x.getKey();},u,v=this.getSelectedItems().map(t),w=this.getSelectedKeys();var U=a.prototype.updateItems.apply(this,arguments);v=this.getSelectedItems().map(t).filter(function(x){return v.indexOf(x)>-1;});u=w.concat(v);this.setSelectedKeys(u);return U;};
s.prototype._getSelectedItemsOf=function(t){for(var i=0,u=t.length,v=[];i<u;i++){if(this.getListItem(t[i]).isSelected()){v.push(t[i]);}}return v;};
s.prototype._getLastSelectedItem=function(){var t=this._oTokenizer.getTokens();var i=t.length?t[t.length-1]:null;if(!i){return null;}return this._getItemByToken(i);};
s.prototype._getOrderedSelectedItems=function(){var t=[];for(var i=0,u=this._oTokenizer.getTokens(),v=u.length;i<v;i++){t[i]=this._getItemByToken(u[i]);}return t;};
s.prototype._getFocusedListItem=function(){if(!document.activeElement){return null;}var F=m.byId(document.activeElement.id);if(this._getList()&&g(this._getList().getFocusDomRef(),F.getFocusDomRef())){return F;}return null;};
s.prototype._getFocusedItem=function(){var i=this._getFocusedListItem();return this._getItemByListItem(i);};
s.prototype._isRangeSelectionSet=function(i){var $=i.getDomRef();return $.indexOf(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"ItemRangeSelection")>-1?true:false;};
s.prototype._hasTokens=function(){return this._oTokenizer.getTokens().length>0;};
s.prototype._getCurrentItem=function(){if(!this._oCurrentItem){return this._getFocusedItem();}return this._oCurrentItem;};
s.prototype._setCurrentItem=function(i){this._oCurrentItem=i;};
s.prototype._resetCurrentItem=function(){this._oCurrentItem=null;};
s.prototype._decorateListItem=function(i){i.addDelegate({onkeyup:function(t){var u=null;if(t.which==K.SPACE&&this.isOpen()&&this._isListInSuggestMode()){this.open();u=this._getLastSelectedItem();if(u){this.getListItem(u).focus();}return;}},onkeydown:function(t){var u=null,v=null;if(t.shiftKey&&t.which==K.ARROW_DOWN){v=this._getCurrentItem();u=this._getNextVisibleItemOf(v);}if(t.shiftKey&&t.which==K.ARROW_UP){v=this._getCurrentItem();u=this._getPreviousVisibleItemOf(v);}if(t.shiftKey&&t.which===K.SPACE){v=this._getCurrentItem();this._selectPreviousItemsOf(v);}if(u&&u!==v){if(this.getListItem(v).isSelected()){this.setSelection({item:u,id:u.getId(),key:u.getKey(),fireChangeEvent:true,suppressInvalidate:true});this._setCurrentItem(u);}else{this.removeSelection({item:u,id:u.getId(),key:u.getKey(),fireChangeEvent:true,suppressInvalidate:true});this._setCurrentItem(u);}return;}this._resetCurrentItem();if((t.ctrlKey||t.metaKey)&&t.which==K.A){t.setMarked();t.preventDefault();var w=this.getSelectableItems();var x=this._getSelectedItemsOf(w);if(x.length!==w.length){w.forEach(function(u){this.setSelection({item:u,id:u.getId(),key:u.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}else{w.forEach(function(u){this.removeSelection({item:u,id:u.getId(),key:u.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}}}},true,this);i.addEventDelegate({onsapbackspace:function(t){t.preventDefault();},onsapshow:function(t){t.setMarked();if(this.isOpen()){this.close();return;}if(this.hasContent()){this.open();}},onsaphide:function(t){this.onsapshow(t);},onsapenter:function(t){t.setMarked();this.close();},onsaphome:function(t){t.setMarked();t.preventDefault();var v=this.getSelectableItems();var u=v[0];this.getListItem(u).focus();},onsapend:function(t){t.setMarked();t.preventDefault();var v=this.getSelectableItems();var u=v[v.length-1];this.getListItem(u).focus();},onsapup:function(t){t.setMarked();t.preventDefault();var v=this.getSelectableItems();var u=v[0];var w=q(document.activeElement).control()[0];if(w===this.getListItem(u)){this.focus();t.stopPropagation(true);}},onfocusin:function(t){this.addStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onfocusout:function(t){this.removeStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onsapfocusleave:function(t){var u=this.getAggregation("picker");var v=m.byId(t.relatedControlId);if(u&&v&&h(u.getFocusDomRef(),v.getFocusDomRef())){if(t.srcControl){t.srcControl.focus();}}}},this);if(D.support.touch){i.addEventDelegate({ontouchstart:function(t){t.setMark("cancelAutoClose");}});}};
s.prototype._handleInputFocusOut=function(){var i=this.isPickerDialog()?this.getPickerTextField():this,u=this._sOldInput||this._sOldValue||"";i.updateDomValue(u);};
s.prototype.onItemChange=function(i){var v=a.prototype.onItemChange.apply(this,arguments);this._forwardItemInfoToToken(i);return v;};
s.prototype._forwardItemInfoToToken=function(i){var t=i.getSource(),u=i.getParameters(),v=this._getTokenByItem(t);if(!v){return;}if(u.name==="enabled"){v.setVisible(u.newValue);}else if(v.getMetadata().hasProperty(u.name)){v.setProperty(u.name,u.newValue,false);}};
s.prototype._handleIndicatorPress=function(i){var t;this.syncPickerContent();this._filterSelectedItems(i,true);this.focus();if(this.getEditable()){t=this.getPicker();t.open();}else{this._updatePopoverBasedOnEditMode(false);this._getReadOnlyPopover().openBy(this._oTokenizer);}if(this.isPickerDialog()){this.getFilterSelectedButton().setPressed(true);this.bOpenedByKeyboardOrButton=true;}else{setTimeout(this._oTokenizer["scrollToEnd"].bind(this._oTokenizer),0);}};
s.prototype._createTokenizer=function(){var t=new T({tokens:[]}).attachTokenChange(this._handleTokenChange,this);t._setAdjustable(true);t._handleNMoreIndicatorPress(this._handleIndicatorPress.bind(this));t.setParent(this);t.addEventDelegate({onAfterRendering:this._onAfterRenderingTokenizer,onfocusin:function(i){if(this.getEditable()&&q(i.target).hasClass("sapMToken")){t._useCollapsedMode(false);}}},this);return t;};
s.prototype._onAfterRenderingTokenizer=function(){setTimeout(this._syncInputWidth.bind(this,this._oTokenizer),0);setTimeout(this._handleNMoreAccessibility.bind(this),0);setTimeout(this._oTokenizer["scrollToEnd"].bind(this._oTokenizer),0);};
s.prototype._handleTokenChange=function(i){var t=i.getParameter("type");var u=i.getParameter("token");var v=null;if(t!==T.TokenChangeType.Removed&&t!==T.TokenChangeType.Added){return;}if(t===T.TokenChangeType.Removed){v=(u&&this._getItemByToken(u));if(v&&this.isItemSelected(v)){this.removeSelection({item:v,id:v.getId(),key:v.getKey(),tokenUpdated:true,fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true});!this.isPickerDialog()&&!this.isFocusInTokenizer()&&this.focus();this.fireChangeEvent("");}}};
s.prototype.onAfterRenderingList=function(){var i=this._getList();if(this._iFocusedIndex!=null&&i.getItems().length>this._iFocusedIndex){i.getItems()[this._iFocusedIndex].focus();this._iFocusedIndex=null;}};
s.prototype.onFocusinList=function(){if(this._bListItemNavigationInvalidated){this._getList().getItemNavigation().setSelectedIndex(this._iInitialItemFocus);this._bListItemNavigationInvalidated=false;}};
s.prototype.onAfterRendering=function(){a.prototype.onAfterRendering.apply(this,arguments);this._oTokenizer.setMaxWidth(this._calculateSpaceForTokenizer());this._registerResizeHandler();};
s.prototype.onfocusout=function(i){this.isOpen()&&this._handleInputFocusOut();this.removeStyleClass("sapMFocus");if(this.getValueState()===V.Error&&this.getValueStateText()===this._oRbM.getText("VALUE_STATE_ERROR_ALREADY_SELECTED")){this.setValueState(V.None);}a.prototype.onfocusout.apply(this,arguments);};
s.prototype.onpaste=function(i){var t;if(window.clipboardData){t=window.clipboardData.getData("Text");}else{t=i.originalEvent.clipboardData.getData('text/plain');}var u=this._oTokenizer._parseString(t);if(u&&u.length>0){this.getSelectableItems().forEach(function(v){if(u.indexOf(v.getText())>-1){this.setSelection({item:v,id:v.getId(),key:v.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false});}},this);}};
s.prototype.onsapbackspace=function(i){this._showAlreadySelectedVisualEffect();if(!this.getEnabled()||!this.getEditable()){i.preventDefault();return;}if(this.getCursorPosition()>0||this.getValue().length>0){return;}if(!i.isMarked()){T.prototype.onsapbackspace.apply(this._oTokenizer,arguments);}if(i.isMarked("forwardFocusToParent")){this.focus();}i.preventDefault();};
s.prototype.onsapdelete=function(i){this._showAlreadySelectedVisualEffect();if(!this.getEnabled()||!this.getEditable()){return;}if(this.getValue()&&!this._isCompleteTextSelected()){return;}if(!i.isMarked()){T.prototype.onsapbackspace.apply(this._oTokenizer,arguments);}if(i.isMarked("forwardFocusToParent")){this.focus();}};
s.prototype.onsapnext=function(i){if(i.isMarked()){return;}var F=q(document.activeElement).control()[0];if(!F){return;}if(F===this._oTokenizer||this._oTokenizer.$().find(F.$()).length>0&&this.getEditable()){this.focus();}};
s.prototype.onsapprevious=function(i){if(this.getCursorPosition()===0&&!this._isCompleteTextSelected()){if(i.srcControl===this){T.prototype.onsapprevious.apply(this._oTokenizer,arguments);}}};
s.prototype.ontap=function(i){a.prototype.ontap.apply(this,arguments);var t=this.getOpenArea();if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();if(this.isPickerDialog()&&t.contains(i.target)){this.open();}};
s.prototype.getOpenArea=function(){if(this.isPickerDialog()){return this.getDomRef();}else{return a.prototype.getOpenArea.apply(this,arguments);}};
s.prototype._getItemsStartingWithPerTerm=function(t,i){var u=[],v=i?this.getEnabledItems():this.getSelectableItems(),F=this.fnFilter?this.fnFilter:a.DEFAULT_TEXT_FILTER;v.forEach(function(w){if(F(t,w,"getText")){u.push(w);}},this);return u;};
s.prototype._getItemsStartingWith=function(t,i){var u=[],v=i?this.getEnabledItems():this.getSelectableItems();v.forEach(function(w){if(typeof t==="string"&&t!==""&&w.getText().toLowerCase().startsWith(t.toLowerCase())){u.push(w);}},this);return u;};
s.prototype._getUnselectedItemsStartingText=function(t){var i=[];this._getUnselectedItems().forEach(function(u){if(typeof t==="string"&&t!==""&&u.getText().toLowerCase().startsWith(t.toLowerCase())){i.push(u);}},this);return i;};
s.prototype.getCursorPosition=function(){return this._$input.cursorPos();};
s.prototype._isCompleteTextSelected=function(){if(!this.getValue().length){return false;}var i=this._$input[0];if(i.selectionStart!==0||i.selectionEnd!==this.getValue().length){return false;}return true;};
s.prototype._selectPreviousItemsOf=function(i){var t;do{t=true;var u=this._getPreviousVisibleItemOf(i);if(u){var v=this.getListItem(u);if(v){t=this.getListItem(u).getSelected();}}this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true});i=u;}while(!t);};
s.prototype._getNextVisibleItemOf=function(i){var t=this.getSelectableItems();var u=t.indexOf(i)+1;if(u<=0||u>t.length-1){return null;}return t[u];};
s.prototype._getPreviousVisibleItemOf=function(i){var t=this.getSelectableItems();var u=t.indexOf(i)-1;if(u<0){return null;}return t[u];};
s.prototype._getNextUnselectedItemOf=function(i){var t=this._getUnselectedItems();var u=t.indexOf(i)+1;if(u<=0||u>t.length-1){return null;}return t[u];};
s.prototype._getPreviousUnselectedItemOf=function(i){var t=this._getUnselectedItems();var u=t.indexOf(i)-1;if(u<0){return null;}return t[u];};
s.prototype._getNextTraversalItem=function(){var v=this.getValue();var i=v?this._getItemsStartingWithPerTerm(v):[];var t=this._getUnselectedItems();if(i.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getNextUnselectedItemOf(this._oTraversalItem);}if(i.length&&i[0].getText()===this.getValue()){return this._getNextUnselectedItemOf(i[0]);}return i.length?i[0]:t[0];};
s.prototype._getPreviousTraversalItem=function(){var v=this.getValue();var i=v?this._getItemsStartingWithPerTerm(v):[];if(i.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getPreviousUnselectedItemOf(this._oTraversalItem);}if(i.length&&i[i.length-1].getText()===this.getValue()){return this._getPreviousUnselectedItemOf(i[i.length-1]);}if(i.length){return i[i.length-1];}else{var t=this._getUnselectedItems();if(t.length>0){return t[t.length-1];}else{return null;}}};
s.prototype.setSelectedItems=function(i){this.removeAllSelectedItems();if(!i||!i.length){return this;}if(!Array.isArray(i)){k.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return this;}i.forEach(function(t){if(!(t instanceof e)&&(typeof t!=="string")){k.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return;}if(typeof t==="string"){t=m.byId(t);}this.setSelection({item:t?t:null,id:t?t.getId():"",key:t?t.getKey():"",suppressInvalidate:true});},this);return this;};
s.prototype.addSelectedItem=function(i){if(!i){return this;}if(typeof i==="string"){i=m.byId(i);}this.setSelection({item:i?i:null,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true});return this;};
s.prototype.removeSelectedItem=function(i){if(!i){return null;}if(typeof i==="string"){i=m.byId(i);}if(!this.isItemSelected(i)){return null;}this.removeSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:false,suppressInvalidate:true});return i;};
s.prototype.removeAllSelectedItems=function(){var i=[];var t=this.getAssociation("selectedItems",[]);t.forEach(function(u){var v=this.removeSelectedItem(u);if(v){i.push(v.getId());}},this);return i;};
s.prototype.removeSelectedKeys=function(i){var t,u=[];if(!i||!i.length||!Array.isArray(i)){return u;}i.forEach(function(v){t=this.getItemByKey(v);if(t){this.removeSelection({item:t?t:null,id:t?t.getId():"",key:t?t.getKey():"",fireChangeEvent:false,suppressInvalidate:true});u.push(t);}},this);return u;};
s.prototype.setSelectedKeys=function(i){if(this._bInitialSelectedKeysSettersCompleted){this.setProperty("selectedKeys",[],true);this.removeAllSelectedItems();}this.addSelectedKeys(i);this._bInitialSelectedKeysSettersCompleted=true;return this;};
s.prototype.addSelectedKeys=function(i){var t,u=[];i=this.validateProperty("selectedKeys",i);i.forEach(function(v){var w=this.getItemByKey(v);if(w){this.addSelectedItem(w);}else if(v!=null){u.push(v);}},this);if(u.length>0){t=this.getProperty("selectedKeys").filter(function(v){return u.indexOf(v)===-1;});u=t.concat(u);this.setProperty("selectedKeys",u,true);}return this;};
s.prototype._getUnselectedItems=function(){var i=q(this.getSelectableItems()).not(this.getSelectedItems()).get();if(!this.isOpen()){return i.filter(function(t){return!t.isA("sap.ui.core.SeparatorItem");});}return i;};
s.prototype.getSelectedItems=function(){var i=[],t=this.getAssociation("selectedItems")||[];t.forEach(function(u){var v=m.byId(u);if(v){i.push(v);}},this);return i;};
s.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
s.prototype.setEditable=function(i){var t=this._getList();a.prototype.setEditable.apply(this,arguments);this._oTokenizer.setEditable(i);if(t){this.syncPickerContent(true);this._updatePopoverBasedOnEditMode(i);}return this;};
s.prototype._updatePopoverBasedOnEditMode=function(i){var t=this._getList(),u=this._getSuggestionsPopover(),v=this._getReadOnlyPopover();if(!t){return;}if(i){t.setMode(p.MultiSelect);u.addFlexContent(t);}else if(!v.getContent().length){t.setMode(p.None);v.addContent(t);}};
s.prototype._mapItemToListItem=function(i){var t,u,v,A;var w=this.getRenderer();if(!i){return null;}A=(i.getAdditionalText&&this.getShowSecondaryValues())?i.getAdditionalText():"";if(i.isA("sap.ui.core.SeparatorItem")){t=this._mapSeparatorItemToGroupHeader(i,w);i.data(w.CSS_CLASS_COMBOBOXBASE+"ListItem",t);this._decorateListItem(t);return t;}u=w.CSS_CLASS_MULTICOMBOBOX+"Item";v=(this.isItemSelected(i))?u+"Selected":"";t=new S({type:o.Active,visible:i.getEnabled()}).addStyleClass(u+" "+v);t.setTooltip(i.getTooltip());i.data(w.CSS_CLASS_COMBOBOXBASE+"ListItem",t);t.setTitle(i.getText());t.setInfo(A);if(v){var x=new b({key:i.getKey()});x.setText(i.getText());i.data(w.CSS_CLASS_COMBOBOXBASE+"Token",x);this._oTokenizer.addToken(x,true);}this.setSelectable(i,i.getEnabled());this._decorateListItem(t);return t;};
s.prototype.setSelectable=function(i,t){a.prototype.setSelectable.call(this,i,t);var u=this._getTokenByItem(i);if(u){u.setVisible(t);}};
s.prototype._fillList=function(t){if(!t){return null;}if(!this._oListItemEnterEventDelegate){this._oListItemEnterEventDelegate={onsapenter:function(w){if(w.srcControl.isSelected()){w.setMarked();}}};}for(var i=0,u,v=t.length;i<v;i++){u=this._mapItemToListItem(t[i]);u.removeEventDelegate(this._oListItemEnterEventDelegate);u.addDelegate(this._oListItemEnterEventDelegate,true,this,true);this._getList().addAggregation("items",u,true);if(this.isItemSelected(t[i])){this._getList().setSelectedItem(u,true);}}};
s.prototype.handleInputValidation=function(i,t){var v=i.target.value,u=this._sOldInput&&this._sOldInput.length>v.length,w=this.isValueValid(v),x,y,z;var A=i.srcControl;if(!w&&v!==""&&!t){this._handleFieldValidationState(A);return;}z=this._getItemsStartingWith(v,true);!t&&this._handleTypeAhead(v,z,A);x=this.getEnabledItems();if(this.isPickerDialog()){y=this.getFilterSelectedButton();if(y!=null&&y.getPressed()){y.setPressed(false);}}if(u){x=this.getItems();}this.filterItems({value:v,items:x});this._sOldInput=v;if((!this.getValue()||!w)&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){this.close();}else{this.open();}};
s.prototype.isValueValid=function(v){var i=this._getItemsStartingWith(v,true);var t=this._getItemsStartingWithPerTerm(v,true);return i.length||t.length;};
s.prototype._handleTypeAhead=function(v,i,t){var u=this.getSelectedItems();var w=i.filter(function(x){if(x.isA("sap.ui.core.SeparatorItem")){return false;}return u.indexOf(x)===-1;});if(this._bDoTypeAhead&&w.length){t.updateDomValue(w[0].getText());if(document.activeElement===t.getFocusDomRef()){t.selectText(v.length,t.getValue().length);}}};
s.prototype._handleFieldValidationState=function(i){if(this._sOldInput&&this.isValueValid(this._sOldInput)){i.updateDomValue(this._sOldInput);}else if(this._sOldValue&&this.isValueValid(this._sOldValue)){i.updateDomValue(this._sOldValue);}else{i.updateDomValue("");}if(this._iOldCursorPos){q(i.getFocusDomRef()).cursorPos(this._iOldCursorPos);}this._showWrongValueVisualEffect();};
s.prototype.init=function(){this._oRb=m.getLibraryResourceBundle("sap.m");a.prototype.init.apply(this,arguments);this._bInitialSelectedKeysSettersCompleted=false;this._bListItemNavigationInvalidated=false;this._iInitialItemFocus=-1;this._bCheckBoxClicked=true;this._bPreventValueRemove=false;this._oTokenizer=this._createTokenizer();this._aInitiallySelectedItems=[];this._oRbM=m.getLibraryResourceBundle("sap.m");this._oRbC=m.getLibraryResourceBundle("sap.ui.core");this._fillList();};
s.prototype.clearSelection=function(){this.removeAllSelectedItems();};
s.prototype.insertItem=function(i,t){this.insertAggregation("items",i,t,true);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this._getList()){this._getList().insertItem(this._mapItemToListItem(i),t);}return this;};
s.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this._getList()){this._getList().removeItem(i&&this.getListItem(i));}this.removeSelection({item:i,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:true});return i;};
s.prototype.isItemSelected=function(i){return this.getSelectedItems().indexOf(i)>-1;};
s.prototype._clearTokenizer=function(){this._oTokenizer.destroyAggregation("tokens");};
s.prototype.exit=function(){var i=["_oTokenizer","_oSuggestionPopover","_oToggleButton","_oPickerCustomHeader","_oCustomHeaderToolbar","_oPickerCloseButton"],t=this;a.prototype.exit.apply(this,arguments);this._deregisterResizeHandler();i.forEach(function(u){if(t[u]){t[u].destroy();t[u]=null;}});};
s.prototype.destroyItems=function(){this.destroyAggregation("items");this.setProperty("selectedKeys",[],true);if(this._getList()){this._getList().destroyItems();}this._oTokenizer.destroyTokens();return this;};
s.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items");this.removeAllSelectedItems();if(this._getList()){this._getList().removeAllItems();}return i;};
s.prototype._getItemByToken=function(t){return this._getItemBy(t,"Token");};
s.prototype.getAccessibilityInfo=function(){var t=this.getSelectedItems().map(function(u){return u.getText();}).join(" ");var i=a.prototype.getAccessibilityInfo.apply(this,arguments);i.type=m.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_MULTICOMBO");i.description=((i.description||"")+" "+t).trim();return i;};
s.prototype._calculateSpaceForTokenizer=function(){if(this.getDomRef()){var i,t=this.getDomRef().offsetWidth,u=this._calculateIconsSpace(),v=this.$().find(".sapMInputBaseInner"),w=["min-width","padding-right","padding-left"],x=w.reduce(function(A,y){return A+(parseInt(v.css(y))||0);},0);i=t-(u+x);i=i<0?0:i;return i+"px";}else{return null;}};
s.prototype._syncInputWidth=function(t){var F=this.getDomRef('inner'),i,u;if(!F||(t&&!t.getDomRef())){return;}i=this._calculateIconsSpace();u=Math.ceil(t.getDomRef().getBoundingClientRect().width);F.style.width='calc(100% - '+Math.floor(i+u)+"px";};
s.prototype._handleNMoreAccessibility=function(){var i=n.getStaticId("sap.m","MULTICOMBOBOX_OPEN_NMORE_POPOVER");var H=this.getAriaLabelledBy().indexOf(i)!==-1;if(!this.getEditable()&&this._oTokenizer._hasMoreIndicator()){!H&&this.addAriaLabelledBy(i);}else{H&&this.removeAriaLabelledBy(i);}};
s.prototype.applyShowItemsFilters=function(){this.syncPickerContent();this.filterItems({value:this.getValue()||"_",items:this.getItems()});};
return s;});
sap.ui.predefine('sap/m/MultiComboBoxRenderer',['./ComboBoxBaseRenderer','./ComboBoxTextFieldRenderer','sap/ui/core/Renderer','sap/ui/Device'],function(C,a,R,D){"use strict";var M=R.extend(C);M.CSS_CLASS_MULTICOMBOBOX="sapMMultiComboBox";
M.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.addClass(M.CSS_CLASS_MULTICOMBOBOX);if(c._hasTokens()){r.addClass("sapMMultiComboBoxHasToken");}};
M.getAriaDescribedBy=function(c){var A=a.getAriaDescribedBy.apply(this,arguments),i=c._oTokenizer&&c._oTokenizer.getTokensInfoId();return(A||"")+" "+i;};
M.prependInnerContent=function(r,c){r.renderControl(c._oTokenizer);};
return M;},true);
sap.ui.predefine('sap/m/MultiEditField',["sap/ui/core/XMLComposite","./library","sap/ui/core/Item"],function(X,l,I){"use strict";
var M=X.extend("sap.m.MultiEditField",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{selectedItem:{type:"sap.ui.core.Item",group:"Data",defaultValue:null,invalidate:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:true,invalidate:true},nullable:{type:"boolean",group:"Behavior",defaultValue:true,invalidate:true},required:{type:"boolean",group:"Behavior",defaultValue:false,invalidate:true}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,bindable:"bindable"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
M.prototype.init=function(){if(!M.prototype._oRb){M.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}var k=new I({key:"keep",text:"< "+this._oRb.getText("MULTI_EDIT_KEEP_TEXT")+" >"}),b=new I({key:"blank",text:"< "+this._oRb.getText("MULTI_EDIT_BLANK_TEXT")+" >"}),n=new I({key:"new",text:"< "+this._oRb.getText("MULTI_EDIT_NEW_TEXT")+" >"});this._getKeepAll=function(){return k;};this._getBlank=function(){return b;};this._getValueHelp=function(){return n;};this.byId("select").getParent=this.getParent.bind(this);this._oLastSelectedItem=this._getKeepAll();};
M.prototype.onBeforeRendering=function(){this.insertAggregation("items",this._getKeepAll(),0,true);if(this.getNullable()){this.insertAggregation("items",this._getBlank(),1,true);}else{this.removeAggregation("items",this._getBlank(),true);}if(this.getShowValueHelp()){this.insertAggregation("items",this._getValueHelp(),this.getNullable()?2:1,true);}else{this.removeAggregation("items",this._getValueHelp(),true);}var s=this.getSelectedItem();if(s){s=this._getInternalItem(s);this.byId("select").setSelectedItem(s);}};
M.prototype.setSelectedItem=function(s){var i=this._getExternalItem(s)||s;var o;if(i&&this.indexOfItem(i)>=0&&!this._isSpecialValueItem(i)){o=this._getInternalItem(s);if(o){this.byId("select").setSelectedItem(o);}this._oLastSelectedItem=i;return this.setProperty("selectedItem",i);}return this;};
M.prototype.exit=function(){this._getKeepAll().destroy();this._getBlank().destroy();this._getValueHelp().destroy();var i=this.byId("itemTemplate");if(i){i.destroy();}};
M.prototype.getFormDoNotAdjustWidth=function(){return true;};
M.prototype.isBlankSelected=function(){return this._getExternalItem(this.byId("select").getSelectedItem())===this._getBlank();};
M.prototype.isKeepExistingSelected=function(){return this._getExternalItem(this.byId("select").getSelectedItem())===this._getKeepAll();};
M.prototype._isSpecialValueItem=function(i){return i===this._getKeepAll()||i===this._getBlank()||i===this._getValueHelp();};
M.prototype._handleSelectionChange=function(e){var i=this._getExternalItem(e.getParameter("selectedItem"));if(i&&!this._isSpecialValueItem(i)){this.fireChange({selectedItem:i});}else if(i===this._getValueHelp()){this.fireEvent("_valueHelpRequest");}if(i!==this._getValueHelp()){this._oLastSelectedItem=i;this.setProperty("selectedItem",i,true);}};
M.prototype.resetSelection=function(){this.byId("select").setSelectedItem(this._getInternalItem(this._oLastSelectedItem));};
M.prototype._getExternalItem=function(i){var a=this.byId("select").indexOfItem(i);if(a>=0){return this.getItems()[a];}return null;};
M.prototype._getInternalItem=function(i){var a=this.indexOfItem(i);if(a>=0){return this.byId("select").getItems()[a];}return null;};
M.prototype._getInternalDomRef=function(){var s=this.byId("select");return s&&s.getDomRef();};
M.prototype._getInternalUIArea=function(){return this.byId("select").getUIArea();};
return M;});
sap.ui.predefine('sap/m/MultiInput',['./Input','./Tokenizer','./Token','./library','sap/ui/core/EnabledPropagator','sap/ui/base/ManagedObjectMetadata','sap/ui/Device','./Popover','./List','./Title','./Bar','./Toolbar','./StandardListItem','sap/ui/core/ResizeHandler','sap/ui/core/IconPool','./MultiInputRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes",'sap/ui/core/InvisibleText',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/control"],function(I,T,a,l,E,M,D,P,L,b,B,c,S,R,d,f,g,K,h,q){"use strict";var j=l.PlacementType,k=l.ListMode;
var m=I.extend("sap.m.MultiInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MultiInput.designtime",properties:{enableMultiLineMode:{type:"boolean",group:"Behavior",defaultValue:false},maxTokens:{type:"int",group:"Behavior"}},aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},tokenizer:{type:"sap.m.Tokenizer",multiple:false,visibility:"hidden"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{allowPreventDefault:true,parameters:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}},dnd:{draggable:false,droppable:true}}});
E.apply(m.prototype,[true]);var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
m.prototype.init=function(){this._bShowListWithTokens=false;I.prototype.init.call(this);this._bIsValidating=false;this._tokenizer=new T();this._tokenizer._setAdjustable(true);this.setAggregation("tokenizer",this._tokenizer);this._tokenizer.attachTokenChange(this._onTokenChange,this);this._tokenizer.attachTokenUpdate(this._onTokenUpdate,this);this._tokenizer._handleNMoreIndicatorPress(this._handleIndicatorPress.bind(this));this._tokenizer.addEventDelegate({onThemeChanged:this._handleInnerVisibility.bind(this)},this);this.setShowValueHelp(true);this.setShowSuggestion(true);this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);this.attachValueHelpRequest(this._onValueHelpRequested,this);this._getValueHelpIcon().setProperty("visible",true,true);this._modifySuggestionPicker();};
m.prototype.exit=function(){I.prototype.exit.call(this);if(this._oSelectedItemPicker){this._oSelectedItemPicker.destroy();this._oSelectedItemPicker=null;}if(this._oSelectedItemsList){this._oSelectedItemsList.destroy();this._oSelectedItemsList=null;}if(this._getReadOnlyPopover()){var o=this._getReadOnlyPopover();o.destroy();o=null;}this._deregisterResizeHandler();};
m.prototype.onBeforeRendering=function(){I.onBeforeRendering.apply(this,arguments);this._tokenizer.setEnabled(this.getEnabled());};
m.prototype.onAfterRendering=function(){this._tokenizer.scrollToEnd();this._registerResizeHandler();this._tokenizer.setMaxWidth(this._calculateSpaceForTokenizer());this._handleNMoreAccessibility();this._handleInnerVisibility();this._syncInputWidth(this._tokenizer);I.prototype.onAfterRendering.apply(this,arguments);};
m.prototype._handleInnerVisibility=function(){var H=this._tokenizer._hasMoreIndicator();this[H?"_setValueInvisible":"_setValueVisible"].call(this);};
m.prototype.oninput=function(e){I.prototype.oninput.call(this,e);this._manageListsVisibility(false);this._getSelectedItemsPicker().close();};
m.prototype._registerResizeHandler=function(){if(!this._iResizeHandlerId){this._iResizeHandlerId=R.register(this,this._onResize.bind(this));}};
m.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
m.prototype._onResize=function(){this._deregisterResizeHandler();this._tokenizer.setMaxWidth(this._calculateSpaceForTokenizer());this._handleInnerVisibility();this._syncInputWidth(this._tokenizer);this._handleNMoreAccessibility();this._registerResizeHandler();};
m.prototype._onTokenChange=function(e){this.fireTokenChange(e.getParameters());this.invalidate();if(e.getParameter("type")==="removed"){this._tokenizer._useCollapsedMode(false);}this._fillList();if(this._bUseDialog){this._manageListsVisibility(true);}};
m.prototype._onTokenUpdate=function(e){var i=this.fireTokenUpdate(e.getParameters());if(!this.getTokens().length){this.$().find("input").focus();}if(!i){e.preventDefault();}else{this.invalidate();}};
m.prototype._onSuggestionItemSelected=function(e){var i=null,t=null,n=this,o=this._tokenizer.getTokens().length;if(this.getMaxTokens()&&o>=this.getMaxTokens()||this._bValueHelpOpen){return;}if(this._hasTabularSuggestions()){i=e.getParameter("selectedRow");}else{i=e.getParameter("selectedItem");if(i){t=new a({text:i.getText(),key:i.getKey()});}}if(i){var p=this.getValue();this._tokenizer._addValidateToken({text:p,token:t,suggestionObject:i,validationCallback:function(v){if(v){n.setValue("");}}});}if(this._bUseDialog){var N=this._tokenizer.getTokens().length;if(o<N){this.setValue("");}if(this._getSuggestionsList()instanceof sap.m.Table){this._getSuggestionsList().addStyleClass("sapMInputSuggestionTableHidden");}else{this._getSuggestionsList().destroyItems();}var s=this._oSuggestionPopup.getScrollDelegate();if(s){s.scrollTo(0,0,0);}this._oSuggPopover._oPopupInput.focus();}};
m.prototype._onValueHelpRequested=function(){this._bValueHelpOpen=true;};
m.prototype._onLiveChange=function(e){this._tokenizer._removeSelectedTokens();};
m.prototype._setValueInvisible=function(){this.$("inner").css("opacity","0");};
m.prototype._setValueVisible=function(){this.$("inner").css("opacity","1");};
m.prototype.setEnableMultiLineMode=function(e){return this.setProperty("enableMultiLineMode",e,true);};
m.prototype.onmousedown=function(e){if(e.target==this.getDomRef('content')){e.preventDefault();e.stopPropagation();}};
m.prototype._openMultiLineOnDesktop=function(){};
m.prototype.openMultiLine=function(){};
m.prototype.closeMultiLine=function(){};
m.prototype.getScrollDelegate=function(){return this._tokenizer._oScroller;};
m.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.apply(this,arguments);this._deregisterResizeHandler();};
m.prototype.addValidator=function(v){this._tokenizer.addValidator(v);};
m.prototype.removeValidator=function(v){this._tokenizer.removeValidator(v);};
m.prototype.removeAllValidators=function(){this._tokenizer.removeAllValidators();};
m.prototype.onsapnext=function(e){if(e.isMarked()){return;}var F=q(document.activeElement).control()[0];if(!F){return;}if(this._tokenizer===F||this._tokenizer.$().find(F.$()).length>0){this._scrollAndFocus();}};
m.prototype.onsapbackspace=function(e){if(this.getCursorPosition()>0||!this.getEditable()||this.getValue().length>0){return;}if(!e.isMarked()){T.prototype.onsapbackspace.apply(this._tokenizer,arguments);}if(e.isMarked("forwardFocusToParent")){this.focus();}e.preventDefault();e.stopPropagation();};
m.prototype.onsapdelete=function(e){if(!this.getEditable()){return;}if(this.getValue()&&!this._completeTextIsSelected()){return;}if(e.isMarked("forwardFocusToParent")){this.focus();}};
m.prototype.onkeydown=function(e){if(!this.getEnabled()){return;}if(e.which===K.TAB){this._tokenizer._changeAllTokensSelection(false);}if((e.ctrlKey||e.metaKey)&&e.which===K.A){if(this._tokenizer.getTokens().length>0){this._tokenizer.focus();this._tokenizer._changeAllTokensSelection(true);e.preventDefault();}}if((e.ctrlKey||e.metaKey)&&(e.which===K.C||e.which===K.INSERT)){this._tokenizer._copy();}if(((e.ctrlKey||e.metaKey)&&e.which===K.X)||(e.shiftKey&&e.which===K.DELETE)){if(this.getEditable()){this._tokenizer._cut();}else{this._tokenizer._copy();}}};
m.prototype.onpaste=function(e){var o,i,v=[],A=[];if(this.getValueHelpOnly()){return;}if(window.clipboardData){o=window.clipboardData.getData("Text");}else{o=e.originalEvent.clipboardData.getData('text/plain');}var s=this._tokenizer._parseString(o);if(s.length<=1){return;}setTimeout(function(){if(s){if(this.fireEvent("_validateOnPaste",{texts:s},true)){var n="";for(i=0;i<s.length;i++){if(s[i]){var t=this._convertTextToToken(s[i],true);if(t){v.push(t);}else{n=s[i];}}}this.updateDomValue(n);for(i=0;i<v.length;i++){if(this._tokenizer._addUniqueToken(v[i])){A.push(v[i]);}}if(A.length>0){this.fireTokenUpdate({addedTokens:A,removedTokens:[],type:T.TokenUpdateType.Added});}}if(A.length){this.cancelPendingSuggest();}}}.bind(this),0);};
m.prototype._convertTextToToken=function(t,C){var e=null,i=null,n=null,o=this._tokenizer.getTokens().length;if(!this.getEditable()){return null;}t=t.trim();if(!t){return null;}if(this._getIsSuggestionPopupOpen()||C){if(this._hasTabularSuggestions()){i=this._oSuggestionTable._oSelectedItem;}else{i=this._getSuggestionItem(t);}}if(i&&i.getText&&i.getKey){n=new a({text:i.getText(),key:i.getKey()});}var p=this;e=this._tokenizer._validateToken({text:t,token:n,suggestionObject:i,validationCallback:function(v){p._bIsValidating=false;if(v){p.setValue("");if(p._bUseDialog&&p._isMultiLineMode&&p._oSuggestionTable.getItems().length===0){var N=p._tokenizer.getTokens().length;if(o<N){p._oSuggPopover._oPopupInput.setValue("");}p._setAllTokenVisible();}}}});return e;};
m.prototype.onsapprevious=function(e){if(this._getIsSuggestionPopupOpen()){return;}if(this.getCursorPosition()===0){if(e.srcControl===this){T.prototype.onsapprevious.apply(this._tokenizer,arguments);}}if(e.keyCode===K.ARROW_UP){e.preventDefault();}};
m.prototype._scrollAndFocus=function(){this._tokenizer.scrollToEnd();this.$().find("input").focus();};
m.prototype.onsaphome=function(e){if(!this.getFocusDomRef().selectionStart){T.prototype.onsaphome.apply(this._tokenizer,arguments);}};
m.prototype.onsapend=function(e){if(e.isMarked("forwardFocusToParent")){this.focus();}};
m.prototype.onsapenter=function(e){if(I.prototype.onsapenter){I.prototype.onsapenter.apply(this,arguments);}var v=true;if(this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()){if(this._hasTabularSuggestions()){v=!this._oSuggestionTable.getSelectedItem();}else{v=!this._getSuggestionsList().getSelectedItem();}}if(v){this._validateCurrentText();}if(!this.getEditable()&&this._tokenizer._hasMoreIndicator()&&e.target===this.getFocusDomRef()){this._handleIndicatorPress();}this.focus();};
m.prototype._checkFocus=function(){return this.getDomRef()&&g(this.getDomRef(),document.activeElement);};
m.prototype.onsapfocusleave=function(e){var p=this._oSuggestionPopup,s=this._oSelectedItemPicker,n=false,N=false,i=this._checkFocus(),o,F;if(p instanceof sap.m.Popover){if(e.relatedControlId){o=sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef();n=g(p.getFocusDomRef(),o);N=g(this._tokenizer.getFocusDomRef(),o);if(s){F=g(s.getFocusDomRef(),o);}}}if(!N&&!n){this._tokenizer.scrollToEnd();}I.prototype.onsapfocusleave.apply(this,arguments);if(this._bIsValidating||this._bValueHelpOpen){return;}if(!this._bUseDialog&&!n&&e.relatedControlId!==this.getId()&&!N){this._validateCurrentText(true);}if(!this._bUseDialog&&this.getEditable()){if(i||n){return;}}if(!F&&!N){this._tokenizer._useCollapsedMode(true);}this._handleInnerVisibility();};
m.prototype._onDialogClose=function(){this._validateCurrentText();this.setAggregation("tokenizer",this._tokenizer);this._tokenizer.setReverseTokens(false);this._tokenizer.invalidate();};
m.prototype.ontap=function(e){if(document.activeElement===this._$input[0]||document.activeElement===this._tokenizer.getDomRef()){this._tokenizer.selectAllTokens(false);}if(e&&e.isMarked("tokenDeletePress")){return;}I.prototype.ontap.apply(this,arguments);};
m.prototype._onclick=function(e){if(this._bUseDialog&&this.getTokens().length){this._openSuggestionsPopover();}};
m.prototype.onfocusin=function(e){this._bValueHelpOpen=false;if(e.target===this.getFocusDomRef()){I.prototype.onfocusin.apply(this,arguments);}if(!this._bUseDialog&&this.getEditable()&&(!e.target.classList.contains("sapMInputValHelp")&&!e.target.classList.contains("sapMInputValHelpInner"))){if(this._oSuggestionPopup&&this._oSuggestionPopup.isOpen()){return;}this._tokenizer._useCollapsedMode(false);this._setValueVisible();this._tokenizer.scrollToEnd();}};
m.prototype.onsapescape=function(e){this._tokenizer.selectAllTokens(false);this.selectText(0,0);I.prototype.onsapescape.apply(this,arguments);};
m.prototype._validateCurrentText=function(e){var t=this.getValue();if(!t||!this.getEditable()){return;}t=t.trim();if(!t){return;}var i=null;if(e||this._getIsSuggestionPopupOpen()){if(this._hasTabularSuggestions()){i=this._oSuggestionTable._oSelectedItem;}else{i=this._getSuggestionItem(t,e);}}var n=null;if(i&&i.getText&&i.getKey){n=new a({text:i.getText(),key:i.getKey()});}var o=this;if(!this.getMaxTokens()||this.getTokens().length<this.getMaxTokens()){this._bIsValidating=true;this._tokenizer._addValidateToken({text:t,token:n,suggestionObject:i,validationCallback:function(v){o._bIsValidating=false;if(v){o.setValue("");}}});}};
m.prototype.getCursorPosition=function(){return this._$input.cursorPos();};
m.prototype._completeTextIsSelected=function(){var i=this._$input[0];if(i.selectionStart!==0){return false;}if(i.selectionEnd!==this.getValue().length){return false;}return true;};
m.prototype._getIsSuggestionPopupOpen=function(){return this._oSuggPopover&&this._oSuggPopover._oPopover.isOpen();};
m.prototype.setEditable=function(e){e=this.validateProperty("editable",e);var t=this._getTokensList();if(e===this.getEditable()){return this;}if(I.prototype.setEditable){I.prototype.setEditable.apply(this,arguments);}this._tokenizer.setEditable(e);if(e){if(this._bUseDialog){this._oSuggPopover._oPopover.addContent(t);}else{this._getSelectedItemsPicker().addContent(t);}t.setMode(k.Delete);}else{t.setMode(k.None);this._getReadOnlyPopover().addContent(t);}return this;};
m.prototype._findItem=function(t,e,n,G){if(!t){return;}if(!(e&&e.length)){return;}t=t.toLowerCase();var o=e.length;for(var i=0;i<o;i++){var p=e[i];var s=G(p);if(!s){continue;}s=s.toLowerCase();if(s===t){return p;}if(!n&&s.indexOf(t)===0){return p;}}};
m.prototype._getSuggestionItem=function(t,e){var n=null;var o=null;if(this._hasTabularSuggestions()){n=this.getSuggestionRows();o=this._findItem(t,n,e,function(p){var s=p.getCells();var u=null;if(s){var i;for(i=0;i<s.length;i++){if(s[i].getText){u=s[i].getText();break;}}}return u;});}else{n=this.getSuggestionItems();o=this._findItem(t,n,e,function(o){return o.getText();});}return o;};
m.prototype.clone=function(){var C;this.detachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.detachLiveChange(this._onLiveChange,this);this._tokenizer.detachTokenChange(this._onTokenChange,this);this._tokenizer.detachTokenUpdate(this._onTokenUpdate,this);this.detachValueHelpRequest(this._onValueHelpRequested,this);C=I.prototype.clone.apply(this,arguments);this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);this._tokenizer.attachTokenChange(this._onTokenChange,this);this._tokenizer.attachTokenUpdate(this._onTokenUpdate,this);this.attachValueHelpRequest(this._onValueHelpRequested,this);return C;};
m.getMetadata().forwardAggregation("tokens",{getter:function(){return this._tokenizer;},aggregation:"tokens",forwardBinding:true});
m.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("content");};
m.prototype.setTokens=function(t){var v,V=[],i;if(Array.isArray(t)){for(i=0;i<t.length;i++){v=this.validateAggregation("tokens",t[i],true);M.addAPIParentInfoBegin(t[i],this,"tokens");V.push(v);}this._tokenizer.setTokens(V);for(i=0;i<t.length;i++){M.addAPIParentInfoEnd(t[i]);}}else{throw new Error("\""+t+"\" is of type "+typeof t+", expected array for aggregation tokens of "+this);}return this;};
m.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};m.WaitForAsyncValidation="sap.m.Tokenizer.WaitForAsyncValidation";m.prototype.getDomRefForValueStateMessage=m.prototype.getPopupAnchorDomRef;
m.prototype.updateInputField=function(n){I.prototype.updateInputField.call(this,n);this.setDOMValue('');if(this._oSuggPopover._oPopupInput){this._oSuggPopover._oPopupInput.setDOMValue('');}};
m.prototype.getAccessibilityInfo=function(){var t=this.getTokens().map(function(o){return o.getText();}).join(" ");var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=r.getText("ACC_CTR_TYPE_MULTIINPUT");i.description=((i.description||"")+" "+t).trim();return i;};
m.prototype._modifySuggestionPicker=function(){var t=this,e,s;if(!this._bUseDialog){return;}this._oSuggPopover._oPopover.addContent(this._getTokensList());this._oSuggPopover._oPopover.attachBeforeOpen(function(){e=t.getTokens();s=e.length?true:false;t._manageListsVisibility(s);t._fillList();t._updatePickerHeaderTitle();}).attachAfterClose(function(){t._tokenizer._useCollapsedMode(true);t._bShowListWithTokens=false;});};
m.prototype._modifyPopupInput=function(p){var t=this;p.addEventDelegate({oninput:t._manageListsVisibility.bind(t,false),onsapenter:function(e){t._validateCurrentText();t._setValueInvisible();t.onChange(e,null,p.getValue());if(p.getValue()){t._closeSuggestionPopup();}}});return p;};
m.prototype._hasShowSelectedButton=function(){return true;};
m.prototype.forwardEventHandlersToSuggPopover=function(s){I.prototype.forwardEventHandlersToSuggPopover.apply(this,arguments);s.setShowSelectedPressHandler(this._handleShowSelectedPress.bind(this));};
m.prototype._handleShowSelectedPress=function(e){this._bShowListWithTokens=e.getSource().getPressed();this._manageListsVisibility(this._bShowListWithTokens);};
m.prototype._onBeforeOpenTokensPicker=function(){var p=this._getSelectedItemsPicker(),o=this.getDomRef(),w;this._setValueInvisible();this._fillList();if(o&&p){w=(o.offsetWidth/parseFloat(l.BaseFontSize))+"rem";p.setContentMinWidth(w);}};
m.prototype._onAfterCloseTokensPicker=function(){if(this._oSuggPopover&&!this.getValue()){this._tokenizer._useCollapsedMode(true);this._setValueInvisible();}};
m.prototype.getDialogTitle=function(){var p=this._oSuggPopover._oPopover,H=p&&p.getCustomHeader();if(H){return H.getContentMiddle()[0];}return null;};
m.prototype._updatePickerHeaderTitle=function(){var o,e;e=this.getLabels();if(e.length){o=e[0];if(o&&(typeof o.getText==="function")){this.getDialogTitle().setText(o.getText());}}else{this.getDialogTitle().setText(r.getText("COMBOBOX_PICKER_TITLE"));}};
m.prototype._openSelectedItemsPicker=function(){if(this._bUseDialog){this._oSuggPopover._oPopover.open();}else{var p=this._getSelectedItemsPicker();if(p){p.open();}}this._manageListsVisibility(true);this._setValueVisible();return this;};
m.prototype._getTokensList=function(){if(!this._oSelectedItemsList){this._oSelectedItemsList=this._createTokensList();}return this._oSelectedItemsList;};
m.prototype._getSuggestionsList=function(){return this._oSuggPopover&&this._oSuggPopover._oList;};
m.prototype._createTokensList=function(){return new L({width:"auto",mode:k.Delete}).attachDelete(this._handleNMoreItemDelete,this);};
m.prototype._filterTokens=function(v){this._getTokensList().getItems().forEach(function(i){if(i.getTitle().toLowerCase().indexOf(v)>-1){i.setVisible(true);}else{i.setVisible(false);}});};
m.prototype.getFilterSelectedButton=function(){return this._getSuggestionsPopover().getFilterSelectedButton();};
m.prototype._manageListsVisibility=function(s){this._getTokensList().setVisible(s);this._getSuggestionsList()&&this._getSuggestionsList().setVisible(!s);if(this._bUseDialog){this.getFilterSelectedButton().setPressed(s);}};
m.prototype._mapTokenToListItem=function(t){if(!t){return null;}var o=new S({selected:true});o.setTitle(t.getText());o.data("tokenId",t.getId());return o;};
m.prototype._fillList=function(){var t=this.getTokens(),o;if(!t){return;}this._getTokensList().removeAllItems();for(var i=0,e=t.length;i<e;i++){var n=t[i],o=this._mapTokenToListItem(n);this._getTokensList().addItem(o);}};
m.prototype._handleIndicatorPress=function(){this._bShowListWithTokens=true;if(this.getEditable()){this._openSelectedItemsPicker();}else{this._fillList();this._manageListsVisibility(true);this._getReadOnlyPopover().openBy(this._tokenizer._oIndicator[0]);}};
m.prototype._handleNMoreItemDelete=function(e){var o=e.getParameter("listItem"),s=o.data("tokenId"),t;t=this.getTokens().filter(function(i){return i.getId()===s;})[0];if(t.getEditable()){this._tokenizer._onTokenDelete(t);this._getTokensList().removeItem(o);}this.focus();};
m.prototype._handleNMoreAccessibility=function(){var i=h.getStaticId("sap.m","MULTICOMBOBOX_OPEN_NMORE_POPOVER");var H=this.getAriaLabelledBy().indexOf(i)!==-1;if(!this.getEditable()&&this._tokenizer._hasMoreIndicator()){!H&&this.addAriaLabelledBy(i);}else{H&&this.removeAriaLabelledBy(i);}};
m.prototype._getSelectedItemsPicker=function(){if(this._oSelectedItemPicker){return this._oSelectedItemPicker;}this._oSelectedItemPicker=this._createDropdown();if(!this._bUseDialog){this._oSelectedItemPicker.setHorizontalScrolling(false).attachBeforeOpen(this._onBeforeOpenTokensPicker,this).attachAfterClose(this._onAfterCloseTokensPicker,this).addContent(this._getTokensList());}return this._oSelectedItemPicker;};
m.prototype._createDropdown=function(){var o=new P(this._getDropdownSettings());o.setInitialFocus(this);this._decoratePopover(o);return o;};
m.prototype._getReadOnlyPopover=function(){if(!this._oReadOnlyPopover){this._oReadOnlyPopover=this._createReadOnlyPopover();}return this._oReadOnlyPopover;};
m.prototype._createReadOnlyPopover=function(){return new P({showArrow:true,placement:j.Auto,showHeader:false,contentMinWidth:"auto"}).addStyleClass("sapMMultiInputReadOnlyPopover");};
m.prototype._decoratePopover=function(p){var t=this;p.open=function(){return this.openBy(t);};};
m.prototype._getDropdownSettings=function(){return{showArrow:false,showHeader:false,placement:j.VerticalPreferredBottom,offsetX:0,offsetY:0,bounce:false};};
m.prototype._calculateSpaceForTokenizer=function(){if(this.getDomRef()){var s,C=this.getDomRef().offsetWidth,i=this.$().find(".sapMInputDescriptionWrapper").width(),e=this._calculateIconsSpace(),o=this.$().find(".sapMInputBaseInner"),n=["min-width","padding-right","padding-left"],p=n.reduce(function(A,t){return A+(parseInt(o.css(t))||0);},0);s=C-(e+p+i);s=s<0?0:s;return s+"px";}else{return null;}};
m.prototype._syncInputWidth=function(t){var F=this.getDomRef('inner'),s,i;if(!F||(t&&!t.getDomRef())){return;}s=this._calculateIconsSpace();i=Math.ceil(t.getDomRef().getBoundingClientRect().width);F.style.width='calc(100% - '+Math.floor(s+i)+"px";};
return m;});
sap.ui.predefine('sap/m/MultiInputRenderer',['./InputRenderer','sap/ui/core/Renderer'],function(I,R){"use strict";var M=R.extend(I);
M.prependInnerContent=function(r,c){r.renderControl(c._tokenizer);};
M.addOuterClasses=function(r,c){I.addOuterClasses.apply(this,arguments);r.addClass("sapMMultiInput");if(c.getTokens().length>0){r.addClass("sapMMultiInputHasTokens");}};
M.getAriaDescribedBy=function(c){var a=I.getAriaDescribedBy.apply(this,arguments),i=c.getAggregation("tokenizer")&&c.getAggregation("tokenizer").getTokensInfoId();if(a){a=a+" "+i;}else{a=i;}return a;};
return M;},true);
sap.ui.predefine('sap/m/NavContainer',['./library','sap/ui/core/Control','sap/ui/core/RenderManager','sap/ui/Device','./NavContainerRenderer',"sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/dom/jquery/Focusable"],function(a,C,R,D,N,q,L){"use strict";
var b=C.extend("sap.m.NavContainer",{metadata:{library:"sap.m",properties:{autoFocus:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},visible:{type:"boolean",group:"Appearance",defaultValue:true},defaultTransitionName:{type:"string",group:"Appearance",defaultValue:"slide"}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"}},associations:{initialPage:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}}}});
var u=sap.ui.getCore().getConfiguration().getAnimation(),g=function(d){return u?d:0;},h=function(c){return!!(c&&c.getParent());};b.TransitionDirection={BACK:"back",TO:"to"};
b.prototype.init=function(){this._pageStack=[];this._aQueue=[];this._mVisitedPages={};this._mFocusObject={};this._iTransitionsCompleted=0;this._bNeverRendered=true;this._bNavigating=false;this._bRenderingInProgress=false;};
b.prototype.exit=function(){this._mFocusObject=null;};
b.prototype.onBeforeRendering=function(){var p=this.getCurrentPage();if(this._bNeverRendered&&p){var c=p.getId();if(!this._mVisitedPages[c]){this._mVisitedPages[c]=true;var n={from:null,fromId:null,to:p,toId:c,firstTime:true,isTo:false,isBack:false,isBackToPage:false,isBackToTop:false,direction:"initial"};var e=q.Event("BeforeFirstShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);e=q.Event("BeforeShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);}}};
b.prototype.onAfterRendering=function(){var p=this.getCurrentPage(),f,n,c,e;if(this._bNeverRendered&&p){this._bNeverRendered=false;delete this._bNeverRendered;c=p.getId();if(!this._isInsideAPopup()&&this.getAutoFocus()){f=b._applyAutoFocusTo(c);if(f){this._mFocusObject[c]=f;}}n={from:null,fromId:null,to:p,toId:c,firstTime:true,isTo:false,isBack:false,isBackToTop:false,isBackToPage:false,direction:"initial"};e=q.Event("AfterShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);}};
b.prototype._getActualInitialPage=function(){var p=this.getInitialPage();if(p){var c=sap.ui.getCore().byId(p);if(c){return c;}else{L.error("NavContainer: control with ID '"+p+"' was set as 'initialPage' but was not found as a DIRECT child of this NavContainer (number of current children: "+this.getPages().length+").");}}var d=this.getPages();return(d.length>0?d[0]:null);};
b.prototype.getPage=function(p){var P=this.getPages();for(var i=0;i<P.length;i++){if(P[i]&&(P[i].getId()==p)){return P[i];}}return null;};
b.prototype._ensurePageStackInitialized=function(d){if(this._pageStack.length===0){var p=this._getActualInitialPage();if(p){this._pageStack.push({id:p.getId(),isInitial:true,data:d||{}});}}return this._pageStack;};
b.prototype.getCurrentPage=function(){var s=this._ensurePageStackInitialized();if(s.length>=1){return this.getPage(s[s.length-1].id);}else{L.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");return undefined;}};
b.prototype.getPreviousPage=function(){var s=this._ensurePageStackInitialized();if(s.length>1){return this.getPage(s[s.length-2].id);}else if(s.length==1){return undefined;}else{L.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");}};
b.prototype.currentPageIsTopPage=function(){var s=this._ensurePageStackInitialized();return(s.length===1);};
b.prototype.insertPreviousPage=function(p,t,d){var s=this._ensurePageStackInitialized();if(this._pageStack.length>0){var i=s.length-1;var c={id:p,transition:t,data:d};if(i===0){c.isInitial=true;delete s[s.length-1].isInitial;}s.splice(i,0,c);}else{L.warning(this+": insertPreviousPage called with empty page stack; ignoring");}return this;};
b._applyAutoFocusTo=function(i){var f=q(document.getElementById(i)).firstFocusableDomRef();if(f){f.focus();}return f;};
b.prototype._applyAutoFocus=function(n){var p=n.toId,d,c=n.isBack||n.isBackToPage||n.isBackToTop;if(!n.bFocusInsideFromPage){return;}if(c){d=this._mFocusObject!=null?this._mFocusObject[p]:null;if(d){d.focus();}else{b._applyAutoFocusTo(p);}}else if(n.isTo){b._applyAutoFocusTo(p);}};
b.prototype._afterTransitionCallback=function(n,d,B){var e=q.Event("AfterShow",n);e.data=d||{};e.backData=B||{};e.srcControl=this;n.to._handleEvent(e);e=q.Event("AfterHide",n);e.srcControl=this;n.from._handleEvent(e);this._iTransitionsCompleted++;this._bNavigating=false;if(this.getAutoFocus()){this._applyAutoFocus(n);}this.fireAfterNavigate(n);L.info(this+": _afterTransitionCallback called, to: "+n.toId);if(n.to.hasStyleClass("sapMNavItemHidden")){L.warning(this.toString()+": target page '"+n.toId+"' still has CSS class 'sapMNavItemHidden' after transition. This should not be the case, please check the preceding log statements.");n.to.removeStyleClass("sapMNavItemHidden");}this._dequeueNavigation();};
b.prototype._dequeueNavigation=function(){var n=this._aQueue.shift();if(typeof n==="function"){n();}};
b.prototype._isInPageStack=function(p){return this._pageStack.some(function(P){return P.id===p;});};
b.prototype._safeBackToPage=function(p,t,d,T){var c;if(!this.getPage(p)){return this;}c=this.getCurrentPage();if(c&&c.getId()===p){return this;}if(this._isInPageStack(p)){return this.backToPage(p,d,T);}else{d=d||{};d.safeBackToPage=true;return this.to(p,t,d,T);}};
b.prototype._isFocusInControl=function(c){return q(document.activeElement).closest(c.$()).length>0;};
b.prototype.to=function(p,t,d,T,f){if(p instanceof C){p=p.getId();}if(typeof(t)!=="string"){T=d;d=t;}t=t||this.getDefaultTransitionName();T=T||{};d=d||{};var F={id:p,transition:t,data:d};this._ensurePageStackInitialized(d);if(this._bNavigating){L.info(this.toString()+": Cannot navigate to page "+p+" because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this.to(p,t,d,T,true);},this));return this;}if(this._bNeverRendered){this._oToDataBeforeRendering=d;}var o=this.getCurrentPage();if(o&&(o.getId()===p)){L.warning(this.toString()+": Cannot navigate to page "+p+" because this is the current page.");if(f){this._dequeueNavigation();}if(this._pageStack.length===1){this._pageStack[0].transition=F.transition;}return this;}var c=this.getPage(p);if(c){if(!o){L.warning("Navigation triggered to page with ID '"+p+"', but the current page is not known/aggregated by "+this);return this;}var n={from:o,fromId:o.getId(),to:c,toId:p,firstTime:!this._mVisitedPages[p],isTo:true,isBack:false,isBackToTop:false,isBackToPage:false,direction:"to",bFocusInsideFromPage:this._isFocusInControl(o)};if(n.bFocusInsideFromPage){this._mFocusObject[o.getId()]=document.activeElement;}var e=this.fireNavigate(n);if(e){a.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;o._handleEvent(E);if(!this._mVisitedPages[p]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.data=d||{};E.backData={};c._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.data=d||{};E.backData={};c._handleEvent(E);this._pageStack.push(F);L.info(this.toString()+": navigating to page '"+p+"': "+c.toString());this._mVisitedPages[p]=true;if(!this.getDomRef()){L.info("'Hidden' 'to' navigation in not-rendered NavContainer "+this.toString());if(this._bRenderingInProgress){setTimeout(this.invalidate.bind(this),0);}return this;}var i;if(!(i=c.getDomRef())||i.parentNode!=this.getDomRef()||R.isPreservedContent(i)){c.addStyleClass("sapMNavItemRendering");L.debug("Rendering 'to' page '"+c.toString()+"' for 'to' navigation");var r=sap.ui.getCore().createRenderManager();r.render(c,this.getDomRef());r.destroy();c.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}var j=b.transitions[t]||b.transitions["slide"];var k=this._iTransitionsCompleted;var l=this;window.setTimeout(function(){if(l&&(l._iTransitionsCompleted<k+1)){L.warning("Transition '"+t+"' 'to' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var s=(d.safeBackToPage||T.safeBackToPage)?"back":"to";this._cacheTransitionInfo(t,s);j[s].call(this,o,c,q.proxy(function(){this._afterTransitionCallback(n,d);},this),T);}else{L.info("Navigation to page with ID '"+p+"' has been aborted by the application");}}else{L.warning("Navigation triggered to page with ID '"+p+"', but this page is not known/aggregated by "+this);}return this;};
b.prototype.back=function(c,t){this._backTo("back",c,t);return this;};
b.prototype.backToPage=function(p,c,t){this._backTo("backToPage",c,t,p);return this;};
b.prototype.backToTop=function(c,t){this._backTo("backToTop",c,t);return this;};
b.prototype._backTo=function(t,c,T,r){if(this._bNavigating){L.warning(this.toString()+": Cannot navigate back because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this._backTo(t,c,T,r);},this));return this;}if(this._pageStack.length<=1){if(this._pageStack.length===1&&!this._pageStack[0].isInitial){throw new Error("Initial page not found on the stack. How did this happen?");}this._aQueue=[];return this;}else{if(r instanceof C){r=r.getId();}var f=this._pageStack[this._pageStack.length-1];var d=f.transition;var F=this.getPage(f.id);var o;var e;if(t==="backToTop"){o=this._getActualInitialPage();e=null;}else if(t==="backToPage"){var i=this._findClosestPreviousPageInfo(r);if(!i){L.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page was not found among the previous pages.");return this;}o=sap.ui.getCore().byId(i.id);if(!o){L.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page does not exist anymore.");return this;}e=i.data;}else{o=this.getPreviousPage();e=this._pageStack[this._pageStack.length-2].data;}if(!o){L.error("NavContainer back navigation: target page is not defined or not aggregated by this NavContainer. Aborting navigation.");return;}var j=o.getId();c=c||{};T=T||{};var n={from:F,fromId:F.getId(),to:o,toId:j,firstTime:!this._mVisitedPages[j],isTo:false,isBack:(t==="back"),isBackToPage:(t==="backToPage"),isBackToTop:(t==="backToTop"),direction:t,bFocusInsideFromPage:this._isFocusInControl(F)};var k=this.fireNavigate(n);if(k){a.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;F._handleEvent(E);if(!this._mVisitedPages[j]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.backData=c||{};E.data={};o._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.backData=c||{};E.data=e||{};o._handleEvent(E);this._pageStack.pop();L.info(this.toString()+": navigating back to page "+o.toString());this._mVisitedPages[j]=true;if(t==="backToTop"){this._pageStack=[];L.info(this.toString()+": navigating back to top");this.getCurrentPage();}else if(t==="backToPage"){var p=[],l;while(this._pageStack[this._pageStack.length-1].id!==r){l=this._pageStack.pop();p.push(l.id);}L.info(this.toString()+": navigating back to specific page "+o.toString()+" across the pages: "+p.join(", "));}if(!this.getDomRef()){L.info("'Hidden' back navigation in not-rendered NavContainer "+this.toString());return this;}var m=b.transitions[d]||b.transitions["slide"];var s=this._iTransitionsCompleted;var v=this;window.setTimeout(function(){if(v&&(v._iTransitionsCompleted<s+1)){L.warning("Transition '"+d+"' 'back' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var w;if(!(w=o.getDomRef())||w.parentNode!=this.getDomRef()||R.isPreservedContent(w)){o.addStyleClass("sapMNavItemRendering");L.debug("Rendering 'to' page '"+o.toString()+"' for back navigation");var x=sap.ui.getCore().createRenderManager();var y=this.$().children().index(F.getDomRef());x.renderControl(o);x.flush(this.getDomRef(),false,y);x.destroy();o.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}if(F.getId()===o.getId()){L.info("Transition is skipped when navigating back to the same page instance"+o.toString());this._afterTransitionCallback(n,e,c);return this;}this._cacheTransitionInfo(d,b.TransitionDirection.BACK);m.back.call(this,F,o,q.proxy(function(){this._afterTransitionCallback(n,e,c);},this),T);}}return this;};
b.prototype._findClosestPreviousPageInfo=function(r){for(var i=this._pageStack.length-2;i>=0;i--){var c=this._pageStack[i];if(c.id===r){return c;}}return null;};
b.prototype._cacheTransitionInfo=function(t,T){this._sTransitionName=t;this._sTransitionDirection=T;};
b.prototype._fadeTransition=function(f,t,c){this.oFromPage=f;this.oToPage=t;this.fCallback=c;this._fadeOutAnimation();};
b.prototype._fadeOutAnimation=function(){var t=this,f=this.oFromPage,T=this.oToPage;T.addStyleClass("sapMNavItemTransparent");if(this._sTransitionName==="slide"){if(this._sTransitionDirection===b.TransitionDirection.TO){T.addStyleClass("sapMNavItemSlideLeft");f.addStyleClass("sapMNavItemSlideRight");}else{T.addStyleClass("sapMNavItemSlideRight");f.addStyleClass("sapMNavItemSlideLeft");}}T.removeStyleClass("sapMNavItemHidden");f.addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){f.$().bind("webkitTransitionEnd transitionend",t._fadeOutAnimationEnd.bind(t));t.bTransition1EndPending=true;f.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque").addStyleClass("sapMNavItemTransparent");window.setTimeout(function(){if(t.bTransition1EndPending){t._fadeOutAnimationEnd();}},g(150));},g(10));};
b.prototype._fadeOutAnimationEnd=function(e){var f=this.oFromPage;this.bTransition1EndPending=false;if(e&&e.originalEvent&&e.originalEvent.propertyName!=="opacity"){return;}q(f.$()).unbind("webkitTransitionEnd transitionend");f.removeStyleClass("sapMNavItemSlideLeft").removeStyleClass("sapMNavItemSlideRight");this._fadeInAnimation();};
b.prototype._fadeInAnimation=function(){var t=this,T=this.oToPage;window.setTimeout(function(){T.$().bind("webkitTransitionEnd transitionend",t._fadeInAnimationEnd.bind(t));t.bTransition2EndPending=true;T.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent").addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){if(t.bTransition2EndPending){t._fadeInAnimationEnd();}},g(150));},g(10));};
b.prototype._fadeInAnimationEnd=function(e){var t=this.oToPage,f=this.oFromPage;this.bTransition2EndPending=false;if(e&&e.originalEvent&&e.originalEvent.propertyName!=="opacity"){return;}if(h(f)){f.addStyleClass("sapMNavItemHidden");f.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent");}q(t.$()).unbind("webkitTransitionEnd transitionend");if(h(t)){t.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque").removeStyleClass("sapMNavItemSlideLeft").removeStyleClass("sapMNavItemSlideRight");}this.fCallback();};
b.transitions=b.transitions||{};b.transitions["show"]={to:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();},back:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();}};b.transitions["slide"]={to:b.prototype._fadeTransition,back:b.prototype._fadeTransition};b.transitions["fade"]={to:b.prototype._fadeTransition,back:b.prototype._fadeTransition};b.transitions["flip"]={to:function(f,t,c){var d=this;window.setTimeout(function(){d.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemFlipping");}if(h(f)){f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipPrevious");}d.$().removeClass("sapMNavFlip");c();}};f.$().bind("webkitTransitionEnd transitionend",A);t.$().bind("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipNext");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));},0);},back:function(f,t,c){var d=this;d.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipPrevious");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemFlipping");}if(h(f)){f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipNext");}d.$().removeClass("sapMNavFlip");c();}};f.$().bind("webkitTransitionEnd transitionend",A);t.$().bind("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipPrevious");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipNext");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));}};b.transitions["door"]={to:function(f,t,c){var d=this;window.setTimeout(function(){d.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorInNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorInNext");}if(h(f)){f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorInPrevious");}d.$().removeClass("sapMNavDoor");c();}};f.$().bind("webkitAnimationEnd animationend",A);t.$().bind("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorInPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));},0);},back:function(f,t,c){var d=this;d.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorOutNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).unbind("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorOutNext");}if(h(f)){f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorOutPrevious");}d.$().removeClass("sapMNavDoor");c();}};f.$().bind("webkitAnimationEnd animationend",A);t.$().bind("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorOutPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));}};
b.prototype.addCustomTransition=function(n,t,B){if(b.transitions[n]){L.warning("Transition with name "+n+" already exists in "+this+". It is now being replaced by custom transition.");}b.transitions[n]={to:t,back:B};return this;};
b.addCustomTransition=b.prototype.addCustomTransition;b.prototype.forceInvalidation=b.prototype.invalidate;
b.prototype.invalidate=function(s){if(s==this){}else if(!s){this.forceInvalidation();}else if(s instanceof C){var I=false,p=this.getPages(),l=p.length;for(var i=0;i<l;i++){if(p[i]===s){I=true;break;}}if((!I||s===this.getCurrentPage())&&!this._isInsideAPopup()){this.forceInvalidation();}}else{this.forceInvalidation();}};
b.prototype._isInsideAPopup=function(){var s;s=function(c){if(!c){return false;}if(c.getMetadata().isInstanceOf("sap.ui.core.PopupInterface")){return true;}return s(c.getParent());};return s(this);};
b.prototype.removePage=function(p){var P;if(typeof(p)=="number"){P=this.getPages()[p];}else if(typeof(p)=="string"){P=sap.ui.getCore().byId(p);}else{P=p;}P=this.removeAggregation("pages",P,P!==this.getCurrentPage());this._onPageRemoved(P);return P;};
b.prototype._onPageRemoved=function(p){if(!p){return;}p.$().remove();p.removeStyleClass("sapMNavItemHidden");p.removeStyleClass("sapMNavItem");var s=this._ensurePageStackInitialized();this._pageStack=s.filter(function(P){return p.getId()!==P.id;});};
b.prototype.removeAllPages=function(){var p=this.getPages();if(!p){return[];}for(var i=0;i<p.length;i++){this._onPageRemoved(p[i]);}return this.removeAllAggregation("pages");};
b.prototype.addPage=function(p){var P=this.getPages();if(P.indexOf(p)>-1){return this;}this.addAggregation("pages",p,true);p.addStyleClass("sapMNavItem");var i=P.length;if(i===0&&this.getPages().length===1){this._fireAdaptableContentChange(p);if(this.getDomRef()){this._ensurePageStackInitialized();this.rerender();}}return this;};
b.prototype.insertPage=function(p,i){var P=this.getPages().length;this.insertAggregation("pages",p,i,true);p.addStyleClass("sapMNavItem");if(P===0&&this.getPages().length===1){this._fireAdaptableContentChange(p);if(this.getDomRef()){this._ensurePageStackInitialized();this.rerender();}}return this;};
b.prototype._getAdaptableContent=function(){return this.getCurrentPage();};
b.prototype._fireAdaptableContentChange=function(p){if(p&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":p});}};
return b;});
sap.ui.predefine('sap/m/NavContainerRenderer',[],function(){"use strict";var N={apiVersion:2};
N.render=function(r,c){c._bRenderingInProgress=true;if(!c.getVisible()){return;}var h=c.getHeight(),t=c.getTooltip_AsString(),C=c.getCurrentPage();r.openStart("div",c);r.class("sapMNav");r.style("width",c.getWidth());if(h&&h!="100%"){r.style("height",h);}if(this.renderAttributes){this.renderAttributes(r,c);}if(t){r.attr("title",t);}r.openEnd();if(this.renderBeforeContent){this.renderBeforeContent(r,c);}if(C){C.removeStyleClass("sapMNavItemHidden");r.renderControl(C);}r.close("div");c._bRenderingInProgress=false;};
return N;},true);
sap.ui.predefine('sap/m/NewsContent',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/Device','./NewsContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,T,D,N,K){"use strict";
var a=C.extend("sap.m.NewsContent",{metadata:{library:"sap.m",designtime:"sap/m/designtime/NewsContent.designtime",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:"Auto"},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"_contentText",aggregations:{"_contentText":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
a.prototype.init=function(){this._oContentText=new T(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("_contentText",this._oContentText,true);this.setTooltip("{AltText}");};
a.prototype.onBeforeRendering=function(){this._setPointerOnContentText();this.$().unbind("mouseenter");this.$().unbind("mouseleave");};
a.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._addTooltip.bind(this));this.$().bind("mouseleave",this._removeTooltip.bind(this));};
a.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
a.prototype._removeTooltip=function(){this.$().attr("title",null);};
a.prototype._setPointerOnContentText=function(){var t=this.getAggregation("_contentText");if(t&&this.hasListeners("press")){t.addStyleClass("sapMPointer");}else if(t&&t.hasStyleClass("sapMPointer")){t.removeStyleClass("sapMPointer");}};
a.prototype.getAltText=function(){var A="";var i=true;if(this.getAggregation("_contentText").getText()){A+=this.getAggregation("_contentText").getText();i=false;}if(this.getSubheader()){if(i){A+=""+this.getSubheader();}else{A+="\n"+this.getSubheader();}}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
a.prototype.setContentText=function(t){this._oContentText.setText(t);return this.setProperty("contentText",t,true);};
a.prototype.ontap=function(e){if(D.browser.msie){this.$().focus();}this.firePress();};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
a.prototype.attachEvent=function(e,d,f,b){C.prototype.attachEvent.call(this,e,d,f,b);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnContentText();}return this;};
a.prototype.detachEvent=function(e,f,b){C.prototype.detachEvent.call(this,e,f,b);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnContentText();}return this;};
return a;});
sap.ui.predefine('sap/m/NewsContentRenderer',[],function(){"use strict";var N={};
N.render=function(r,c){var s=c.getSubheader();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.write("<div");r.writeControlData(c);r.writeAttribute("role","presentation");r.writeAttributeEscaped("aria-label",t);r.addClass("sapMNwC");if(c.hasListeners("press")){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMNwCCTxt");r.writeClasses();r.write(">");r.renderControl(c._oContentText);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-subheader");r.addClass("sapMNwCSbh");r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");r.write("</div>");};
return N;},true);
sap.ui.predefine('sap/m/NotificationListBase',['./library','sap/ui/core/Control','./ListItemBase','./Text','./Image','./OverflowToolbar','sap/ui/core/Icon','sap/ui/core/library','sap/ui/core/Element'],function(l,C,L,T,I,O,a,c,E){'use strict';var P=c.Priority;
var N=L.extend('sap.m.NotificationListBase',{metadata:{library:'sap.m',properties:{priority:{type:'sap.ui.core.Priority',group:'Appearance',defaultValue:P.None},title:{type:'string',group:'Appearance',defaultValue:''},datetime:{type:'string',group:'Appearance',defaultValue:''},showButtons:{type:'boolean',group:'Behavior',defaultValue:true},showCloseButton:{type:'boolean',group:'Behavior',defaultValue:true},authorName:{type:'string',group:'Appearance',defaultValue:''},authorPicture:{type:'sap.ui.core.URI',multiple:false}},aggregations:{buttons:{type:'sap.m.Button',multiple:true},_headerTitle:{type:'sap.m.Text',multiple:false,visibility:"hidden"},_dateTime:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_authorName:{type:'sap.m.Text',multiple:false,visibility:"hidden"},_authorImage:{type:'sap.ui.core.Control',multiple:false,visibility:"hidden"},_overflowToolbar:{type:'sap.m.OverflowToolbar',multiple:false,visibility:"hidden"},_closeButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"},_collapseButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"}},events:{close:{}}}});
N.prototype.init=function(){this.setAggregation('_overflowToolbar',new O());};
N.prototype.setTitle=function(t){var r=this.setProperty('title',t);this._getHeaderTitle().setText(t);return r;};
N.prototype.setDatetime=function(d){var r=this.setProperty('datetime',d);this._getDateTimeText().setText(d);return r;};
N.prototype.setAuthorName=function(b){var r=this.setProperty('authorName',b);this._getAuthorName().setText(b);return r;};
N.prototype.close=function(){var p=this.getParent();this.fireClose();var h=!!this.getParent();if(!h&&p&&p instanceof E){var d={onAfterRendering:function(){p.focus();p.removeEventDelegate(d);}};p.addEventDelegate(d);}};
N.prototype.clone=function(){var b=C.prototype.clone.apply(this,arguments);b.destroyAggregation('_overflowToolbar');var o=this.getAggregation('_overflowToolbar');b.setAggregation("_overflowToolbar",o.clone(),true);return b;};
N.getMetadata().forwardAggregation("buttons",{getter:function(){return this.getAggregation('_overflowToolbar');},aggregation:"content",forwardBinding:true});
N.prototype._getHeaderTitle=function(){var t=this.getAggregation("_headerTitle");if(!t){t=new T({id:this.getId()+'-title',text:this.getTitle(),maxLines:2});this.setAggregation("_headerTitle",t,true);}return t;};
N.prototype._getDateTimeText=function(){var d=this.getAggregation('_dateTime');if(!d){d=new T({id:this.getId()+'-datetime',text:this.getDatetime()}).addStyleClass('sapMNLI-Datetime');this.setAggregation('_dateTime',d,true);}return d;};
N.prototype._getAuthorName=function(){var b=this.getAggregation('_authorName');if(!b){b=new T({text:this.getAuthorName()}).addStyleClass('sapMNLI-Text');this.setAggregation('_authorName',b,true);}return b;};
N.prototype._getAuthorImage=function(){var b=this.getAggregation('_authorImage');if(!b){var d=this.getAuthorPicture();var e=this.getAuthorName();if(i(d)){b=new a({src:d,alt:e});}else{b=new I({src:d,alt:e});}this.setAggregation('_authorImage',b,true);}return b;};
N.prototype._getToolbar=function(){var t=this.getAggregation("_overflowToolbar");if(!t){t=new O();this.setAggregation("_overflowToolbar",t,true);}return t;};
function i(s){if(!s){return false;}var r=window.URI.parse(s);return(r.protocol&&r.protocol=='sap-icon');}
return N;});
sap.ui.predefine('sap/m/NotificationListGroup',['./library','./NotificationListBase','sap/ui/core/InvisibleText','./ListItemBase','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/m/Button','./NotificationListGroupRenderer',"sap/ui/events/KeyCodes"],function(l,N,I,L,a,c,D,B,b,K){'use strict';var P=c.Priority;var d=l.ButtonType;
var e=N.extend('sap.m.NotificationListGroup',{metadata:{library:'sap.m',properties:{collapsed:{type:'boolean',group:'Behavior',defaultValue:false},autoPriority:{type:'boolean',group:'Behavior',defaultValue:true},showEmptyGroup:{type:'boolean',group:'Behavior',defaultValue:false},enableCollapseButtonWhenEmpty:{type:'boolean',group:'Behavior',defaultValue:false}},defaultAggregation:'items',aggregations:{items:{type:'sap.m.NotificationListItem',multiple:true,singularName:'item'},_ariaDetailsText:{type:'sap.ui.core.InvisibleText',multiple:false,visibility:'hidden'}},events:{onCollapse:{parameters:{collapsed:{type:'boolean'}}}}}});
e.prototype.init=function(){N.prototype.init.call(this);var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._closeText=r.getText('NOTIFICATION_LIST_BASE_CLOSE');var _=new B(this.getId()+'-closeButton',{type:d.Transparent,icon:a.getIconURI('decline'),tooltip:this._closeText,press:function(){this.close();}.bind(this)});this.setAggregation('_closeButton',_,true);var g=new B({type:d.Transparent,press:function(){this.setCollapsed(!this.getCollapsed());}.bind(this)});this.setAggregation('_collapseButton',g,true);this._maxNumberReached=false;this._ariaLabbeledByIds='';this.setAggregation('_ariaDetailsText',new I());this._resourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');};
e.prototype.setCollapsed=function(C){this._toggleCollapsed(C);this.setProperty('collapsed',C,true);this.fireOnCollapse({collapsed:C});return this;};
e.prototype.getPriority=function(){if(!this.getAutoPriority()){return this.getProperty('priority');}var n=this.getAggregation('items');var p=P.None;if(n){n.forEach(function(i){p=f(p,i.getPriority());});}else{p=this.getProperty('priority');}return p;};
e.prototype.getUnread=function(){var n=this.getItems();if(n.length){return n.some(function(i){return i.getUnread();});}return this.getProperty('unread');};
e.prototype.onBeforeRendering=function(){var n=this.getItems();var g=n.length;var h=this.getAggregation('_collapseButton');this._maxNumberOfNotifications=D.system.desktop?400:100;h.setEnabled(this._getCollapseButtonEnabled(),true);this._maxNumberReached=g>this._maxNumberOfNotifications;n.forEach(function(i){i.addEventDelegate({onfocusin:this._notificationFocusHandler},this);i.addEventDelegate({onkeydown:this._notificationNavigationHandler},this);}.bind(this));this._updateAccessibilityInfo();this._updateCollapseButtonText(this.getCollapsed());var A=this.getAuthorPicture();this._getAuthorImage().setSrc(A);this._maxNumberOfNotificationsTitle=this._resourceBundle.getText('NOTIFICATION_LIST_GROUP_MAX_NOTIFICATIONS_TITLE',g-this._maxNumberOfNotifications);this._maxNumberOfNotificationsBody=this._resourceBundle.getText('NOTIFICATION_LIST_GROUP_MAX_NOTIFICATIONS_BODY');};
e.prototype._getHeaderTitle=function(){var t=N.prototype._getHeaderTitle.call(this);t.addStyleClass('sapMNLG-Title');if(this.getUnread()){t.addStyleClass('sapMNLGTitleUnread');}return t;};
e.prototype._getDateTimeText=function(){var g=N.prototype._getDateTimeText.call(this);g.setTextAlign('End');return g;};
e.prototype._toggleCollapsed=function(C){this._updateCollapseButtonText(C);this.$().toggleClass('sapMNLG-Collapsed',C);this.$().toggleClass('sapMNLG-NoNotifications',this._getVisibleItemsCount()<=0);};
e.prototype._getVisibleItemsCount=function(){var i=this.getItems();var r=0;i.forEach(function(g){if(g.getVisible()){r+=1;}});return r;};
e.prototype._getCollapseButtonEnabled=function(){if(this._getVisibleItemsCount()>0){return true;}return this.getEnableCollapseButtonWhenEmpty();};
e.prototype._notificationFocusHandler=function(g){L.prototype.onfocusin.call(this,g);var t=g.srcControl;if(t.getMetadata().getName()!='sap.m.NotificationListItem'){return;}var n=t.getParent();var v=n.getItems().filter(function(j){return j.getVisible();});var h=v.indexOf(t);var i=t.getDomRef();i.setAttribute('aria-posinset',h+1);i.setAttribute('aria-setsize',v.length);};
e.prototype._notificationNavigationHandler=function(g){L.prototype.onkeydown.call(this,g);var t=g.srcControl;if(t.getMetadata().getName()!='sap.m.NotificationListItem'){return;}var n=t.getParent();var h=n.indexOfItem(t);switch(g.which){case K.ARROW_UP:if(h==0){return;}var p=h-1;n.getItems()[p].focus();break;case K.ARROW_DOWN:var i=h+1;if(i==n.getItems().length){return;}n.getItems()[i].focus();break;default:return;}};
e.prototype._updateAccessibilityInfo=function(){var g=this.getAuthorName();var i=this._resourceBundle.getText('NOTIFICATION_LIST_ITEM_DATETIME_PRIORITY',[this.getDatetime(),this.getPriority()]);var u=this.getUnread()?this._resourceBundle.getText('NOTIFICATION_LIST_GROUP_UNREAD'):this._resourceBundle.getText('NOTIFICATION_LIST_GROUP_READ');var h='';var j=this.getAggregation('_ariaDetailsText');if(g){h+=this._resourceBundle.getText('NOTIFICATION_LIST_ITEM_CREATED_BY')+' '+g+' ';}h+=i+' '+u;j.setText(h);this._ariaLabbeledByIds=this._getHeaderTitle().getId()+' '+j.getId();};
e.prototype._updateCollapseButtonText=function(g){var h=g?this._resourceBundle.getText('NOTIFICATION_LIST_GROUP_EXPAND'):this._resourceBundle.getText('NOTIFICATION_LIST_GROUP_COLLAPSE');this.getAggregation('_collapseButton').setText(h,true);};
function f(g,s){if(g==s){return g;}if((g=='None')){return s;}if((g=='Low')&&(s!='None')){return s;}if((g=='Medium')&&(s!='None'&&s!='Low')){return s;}return g;}
return e;});
sap.ui.predefine('sap/m/NotificationListGroupRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer"],function(c,I){'use strict';var P=c.Priority;var N={};var a='sapMNLG';var b='sapMNLB';var d='sapMLIB';var e='sapMNLB-AuthorPicture';var f='sapMNLG-GroupHeader';var g='sapMNLB-Header';var h='sapMNLG-Header';var i='sapMNLG-Body';var j='sapMNLB-SubHeader';var k='sapMNLG-SubHeader';var l='sapMNLB-CloseButton';var m='sapMNLB-Priority';var n='sapMNLG-Details';var o='sapMNLB-Bullet';var p='sapMNLG-Description';var q='sapMNLG-Collapsed';var r='sapMNLGNoHdrFooter';var s='sapMNLG-MaxNotifications';var t='sapMNLG-NoNotifications';
N.render=function(R,C){if(C.getVisible()){var v=C._getVisibleItemsCount();var _=C.getShowEmptyGroup()||(v>0);R.write('<li');R.addClass(a);R.addClass(b);R.addClass(d);if(!_){R.addClass(r);}if(C.getCollapsed()){R.addClass(q);}if(v==0){R.addClass(t);}R.writeClasses();R.writeControlData(C);R.writeAttribute('tabindex','0');R.writeAccessibilityState(C,{labelledby:C._ariaLabbeledByIds,role:"option"});R.write('>');if(_){R.write('<div');R.addClass(f);R.writeClasses();R.write('>');this.renderHeader(R,C);this.renderSubHeader(R,C);R.write('</div>');this.renderBody(R,C);}R.write('</li>');}else{this.renderInvisibleItem(R,C);}};
N.renderHeader=function(R,C){R.write('<div');R.addClass(g);R.addClass(h);R.writeClasses();R.write('>');this.renderInvisibleInfoText(R,C);this.renderPriorityArea(R,C);this.renderCloseButton(R,C);this.renderTitle(R,C);R.write('</div>');this.renderDetails(R,C);};
N.renderTitle=function(R,C){R.renderControl(C._getHeaderTitle());};
N.renderCloseButton=function(R,C){if(C.getShowCloseButton()){R.renderControl(C.getAggregation('_closeButton').addStyleClass(l));}};
N.renderAuthorPicture=function(R,C){if(!C.getAuthorPicture()){return;}R.write('<div');R.addClass(e);R.writeClasses();R.write('>');R.renderControl(C._getAuthorImage());R.write('</div>');};
N.renderDetails=function(R,C){R.write('<div class="'+n+'">');this.renderPriorityArea(R,C);this.renderAuthorPicture(R,C);R.write('<div class="'+p+'">');this.renderAuthorName(R,C);if(C.getAuthorName()!=""&&C.getDatetime()!=""){R.write('<span class="'+o+'">&#x00B7</span>');}this.renderDatetime(R,C);R.write('</div></div>');};
N.renderInvisibleInfoText=function(R,C){R.renderControl(C.getAggregation('_ariaDetailsText'));};
N.renderAuthorName=function(R,C){R.renderControl(C._getAuthorName());};
N.renderSubHeader=function(R,C){var u=C.getButtons();R.write('<div');R.addClass(k);R.addClass(j);R.writeClasses();R.write('>');this.renderPriorityArea(R,C);this.renderCollapseGroupButton(R,C);if(u&&u.length&&C.getShowButtons()){R.renderControl(C.getAggregation('_overflowToolbar'));}R.write('</div>');};
N.renderPriorityArea=function(R,C){R.write('<div');var u='';var v=C.getPriority();switch(v){case(P.Low):u='sapMNLB-Low';break;case(P.Medium):u='sapMNLB-Medium';break;case(P.High):u='sapMNLB-High';break;default:u='sapMNLB-None';break;}R.addClass(m);R.addClass(u);R.writeClasses();R.write('>');R.write('</div>');};
N.renderCollapseGroupButton=function(R,C){R.renderControl(C.getAggregation('_collapseButton'));};
N.renderInvisibleItem=function(R,C){I.render(R,C,"li");};
N.renderBody=function(R,C){R.write('<ul');R.addClass(i);R.writeAttribute('role','listbox');R.writeClasses();R.write('>');this.renderNotifications(R,C);if(C._maxNumberReached){this.renderMaxNumberReachedMessage(R,C);}R.write('</ul>');};
N.renderDatetime=function(R,C){R.renderControl(C._getDateTimeText());};
N.renderNotifications=function(R,C){var u=C.getItems();var v=u.length;if(v){for(var w=0;w<C._maxNumberOfNotifications;w++){R.renderControl(u[w]);}}};
N.renderMaxNumberReachedMessage=function(R,C){var u='<span>'+C._maxNumberOfNotificationsTitle+'</span> <br>'+C._maxNumberOfNotificationsBody;R.write('<div');R.addClass(s);R.writeClasses();R.write('>');R.write(u);R.write('</div>');};
return N;},true);
sap.ui.predefine('sap/m/NotificationListItem',['./library','sap/ui/Device','./NotificationListBase','sap/ui/core/InvisibleText','sap/ui/core/IconPool','sap/ui/core/ResizeHandler','sap/m/Button','sap/m/Text','./NotificationListItemRenderer'],function(l,D,N,I,a,R,B,T,b){'use strict';var c=l.ButtonType;
var d=N.extend('sap.m.NotificationListItem',{metadata:{library:'sap.m',properties:{description:{type:'string',group:'Appearance',defaultValue:''},truncate:{type:'boolean',group:'Appearance',defaultValue:true},hideShowMoreButton:{type:'boolean',group:'Appearance',defaultValue:false}},aggregations:{processingMessage:{type:'sap.m.MessageStrip',multiple:false},_bodyText:{type:'sap.m.Text',multiple:false,visibility:"hidden"}}}});
d.prototype.init=function(){N.prototype.init.call(this);var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._expandText=r.getText('NOTIFICATION_LIST_ITEM_SHOW_MORE');this._collapseText=r.getText('NOTIFICATION_LIST_ITEM_SHOW_LESS');this._closeText=r.getText('NOTIFICATION_LIST_BASE_CLOSE');this.setType('Active');var _=new B(this.getId()+'-closeButton',{type:c.Transparent,icon:a.getIconURI('decline'),tooltip:this._closeText,press:function(){this.close();}.bind(this)});this.setAggregation("_closeButton",_,true);var e=new B({type:c.Transparent,text:this.getTruncate()?this._expandText:this._collapseText,id:this.getId()+'-expandCollapseButton',press:function(){this._deregisterResize();this.setProperty("truncate",!this.getTruncate(),true);e.setText(this.getTruncate()?this._expandText:this._collapseText);this.$().find('.sapMNLI-Header').toggleClass('sapMNLI-TitleWrapper--is-expanded');this.$().find('.sapMNLI-TextWrapper').toggleClass('sapMNLI-TextWrapper--is-expanded',!!this.getDescription());this._registerResize();}.bind(this)});e.addEventDelegate({onfocusin:function(){this.getDomRef().setAttribute("aria-hidden",true);},onfocusout:function(){this.getDomRef().setAttribute("aria-hidden",false);}},this);this.setAggregation("_collapseButton",e,true);this._ariaDetailsText=new I({id:this.getId()+'-info'}).toStatic();};
d.prototype.setDescription=function(e){var r=this.setProperty('description',e);this._getDescriptionText().setText(e);return r;};
d.prototype.setDatetime=function(e){var r=N.prototype.setDatetime.call(this,e);this._updateAriaAdditionalInfo();return r;};
d.prototype.setUnread=function(u){var r=this.setProperty('unread',u,true);var t=this.getAggregation('_headerTitle');if(t){t.toggleStyleClass('sapMNLI-Unread',this.getUnread());}return r;};
d.prototype.setPriority=function(p,s){var r=this.setProperty('priority',p,s);this._updateAriaAdditionalInfo();return r;};
d.prototype.setAuthorPicture=function(e,s){var r=this.setProperty('authorPicture',e,s);this._getAuthorImage().setSrc(e);return r;};
d.prototype.onBeforeRendering=function(){this._updateAriaAdditionalInfo();this._deregisterResize();};
d.prototype.onAfterRendering=function(){this._registerResize();};
d.prototype.onfocusin=function(e){N.prototype.onfocusin.apply(this,arguments);if(!D.browser.msie){return;}var t=e.target;if(t!==this.getDomRef()&&!t.classList.contains('sapMBtn')){e.preventDefault();e.stopImmediatePropagation();this.focus();}};
d.prototype.exit=function(){this._deregisterResize();if(this._ariaDetailsText){this._ariaDetailsText.destroy();this._ariaDetailsText=null;}};
d.prototype._getDescriptionText=function(){var e=this.getAggregation('_bodyText');if(!e){e=new T({id:this.getId()+'-body',text:this.getDescription(),maxLines:2}).addStyleClass('sapMNLI-Text');this.setAggregation("_bodyText",e,true);}return e;};
d.prototype._activeHandling=function(){this.$().toggleClass("sapMNLIActive",this._active);};
d.prototype._updateAriaAdditionalInfo=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var e=this.getUnread()?r.getText('NOTIFICATION_LIST_ITEM_UNREAD'):r.getText('NOTIFICATION_LIST_ITEM_READ');var f=r.getText('NOTIFICATION_LIST_ITEM_DATETIME_PRIORITY',[this.getDatetime(),this.getPriority()]);var g=this.getAuthorName();var h=e+' ';if(g){h+=r.getText('NOTIFICATION_LIST_ITEM_CREATED_BY')+' '+this.getAuthorName()+' ';}h+=f;this._ariaDetailsText.setText(h);};
d.prototype._canTruncate=function(){var t=this.getDomRef('title-inner').scrollHeight,i=this.$('title').parent().height();if(t>i){return true;}if(this.getDomRef('body-inner')){var e=this.getDomRef('body-inner').scrollHeight,f=this.$('body').parent().height();if(e>f){return true;}}return false;};
d.prototype._showHideTruncateButton=function(){var n=this.getDomRef(),C=sap.ui.getCore(),h,t,o;if(!n){return;}h=n.querySelector('.sapMNLI-Header');t=n.querySelector('.sapMNLI-TextWrapper');o=this.getDomRef('expandCollapseButton');if(this._canTruncate()&&(!this.getHideShowMoreButton())){if(o){o.classList.remove('sapMNLI-CollapseButtonHide');}if(this.getTruncate()){this.getAggregation('_collapseButton').setText(this._expandText);if(h){h.classList.remove('sapMNLI-TitleWrapper--is-expanded');}if(this.getDescription()&&t){t.classList.remove('sapMNLI-TextWrapper--is-expanded');}}else{this.getAggregation('_collapseButton').setText(this._collapseText);this.$().find('.sapMNLI-TextWrapper').toggleClass('sapMNLI-TextWrapper--is-expanded',!!this.getDescription());if(h){h.classList.add('sapMNLI-TitleWrapper--is-expanded');}}}else if(o){o.classList.add('sapMNLI-CollapseButtonHide');}if(this.getDescription()&&t){t.classList.remove('sapMNLI-TextWrapper--initial-overwrite');}if(this.getTitle()&&h){h.classList.remove('sapMNLI-TitleWrapper--initial-overwrite');}C.detachThemeChanged(this._showHideTruncateButton,this);};
d.prototype._deregisterResize=function(){if(this._sNotificationResizeHandler){R.deregister(this._sNotificationResizeHandler);this._sNotificationResizeHandler=null;}};
d.prototype._registerResize=function(){var t=this;var n=this.getDomRef();if(!n){return;}t._resizeNotification();this._sNotificationResizeHandler=R.register(n,function(){t._resizeNotification();});};
d.prototype._resizeNotification=function(){var n=this.getDomRef(),o=n.querySelector('.sapMNLI-TextWrapper'),h=n.querySelector('.sapMNLI-Header'),e=sap.ui.getCore();if(n.offsetWidth>=640){n.classList.add('sapMNLI-LSize');}else{n.classList.remove('sapMNLI-LSize');}if(o){o.classList.remove('sapMNLI-TextWrapper--is-expanded');o.classList.add('sapMNLI-TextWrapper--initial-overwrite');}h.classList.remove('sapMNLI-TitleWrapper--is-expanded');h.classList.add('sapMNLI-TitleWrapper--initial-overwrite');if(e.isThemeApplied()){this._showHideTruncateButton();}else{e.attachThemeChanged(this._showHideTruncateButton,this);}};
return d;});
sap.ui.predefine('sap/m/NotificationListItemRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer"],function(c,I){'use strict';var P=c.Priority;var N={};var a='sapMNLI';var b='sapMNLB';var d='sapMNLI-TextWrapper';var e='sapMLIB';var f='sapMNLB-AuthorPicture';var g='sapMNLB-Priority';var h='sapMNLB-Header';var i='sapMNLI-Header';var j='sapMNLI-Body';var k='sapMNLI-Description';var l='sapMNLI-Details';var m='sapMNLB-Bullet';var n='sapMNLB-Footer';var o='sapMNLI-Footer';var p='sapMNLI-No-Footer';var q='sapMNLB-CloseButton';var r='sapMNLI-CollapseButton';var s='sapMNLI-TitleWrapper--initial-overwrite';var t='sapMNLI-TextWrapper--initial-overwrite';
N.render=function(R,C){if(C.getVisible()){var v=C.getId();var w=(v+'-title')+' '+(v+'-body')+' '+(v+'-info');R.write('<li');R.addClass(a);R.addClass(b);R.addClass(e);R.writeControlData(C);R.writeAttribute('tabindex','0');R.writeAccessibilityState(C,{role:"option",labelledby:w});R.writeClasses();R.write('>');this.renderCloseButton(R,C);this.renderPriorityArea(R,C);this.renderMessageStrip(R,C);this.renderHeader(R,C);this.renderBody(R,C);this.renderFooter(R,C);R.write('</li>');}else{this.renderInvisibleItem(R,C);}};
N.renderPriorityArea=function(R,C){R.write('<div');var v='';switch(C.getPriority()){case(P.Low):v='sapMNLB-Low';break;case(P.Medium):v='sapMNLB-Medium';break;case(P.High):v='sapMNLB-High';break;default:v='sapMNLB-None';break;}R.addClass(g);R.addClass(v);R.writeClasses();R.write('>');R.write('</div>');};
N.renderMessageStrip=function(R,C){R.renderControl(C.getProcessingMessage());};
N.renderAuthorPicture=function(R,C){if(!C.getAuthorPicture()){return;}R.write('<div');R.addClass(f);R.writeClasses();R.write('>');R.renderControl(C._getAuthorImage());R.write('</div>');};
N.renderCloseButton=function(R,C){if(C.getShowCloseButton()){R.renderControl(C.getAggregation('_closeButton').addStyleClass(q));}};
N.renderCollapseButton=function(R,C){R.renderControl(C.getAggregation('_collapseButton').addStyleClass(r));};
N.renderHeader=function(R,C){R.write('<div');R.addClass(h);R.addClass(i);R.addClass(s);if(u(C)){R.addClass(p);}R.writeClasses();R.write('>');this.renderTitle(R,C);R.write('</div>');};
N.renderTitle=function(R,C){R.renderControl(C._getHeaderTitle());};
N.renderBody=function(R,C){if(!C._getDescriptionText().getText()&&!C.getAuthorName()&&!C.getDatetime()&&!C.getAuthorPicture()){return;}R.write('<div');R.addClass(j);if(u(C)){R.addClass(p);}R.writeClasses();R.write('>');this.renderAuthorPicture(R,C);R.write('<div class='+k+'>');this.renderDescription(R,C);this.renderDetails(R,C);R.write('</div>');this.renderAriaText(R,C);R.write('</div>');};
N.renderDescription=function(R,C){if(!C._getDescriptionText().getText()){return;}R.write('<div');R.addClass(d);R.addClass(t);R.writeClasses();R.write('>');R.renderControl(C._getDescriptionText());R.write('</div>');};
N.renderDetails=function(R,C){if(!C.getAuthorName()&&!C.getDatetime()){return;}R.write('<div class="'+l+'">');this.renderAuthorName(R,C);if(C.getAuthorName()){R.write('<span class="'+m+'">&#x00B7</span>');}this.renderDatetime(R,C);R.write('</div>');};
N.renderDatetime=function(R,C){R.renderControl(C._getDateTimeText());};
N.renderAuthorName=function(R,C){R.renderControl(C._getAuthorName());};
N.renderAriaText=function(R,C){R.renderControl(C._ariaDetailsText);};
N.renderFooter=function(R,C){var B=C.getButtons();R.write('<div');R.addClass(o);R.addClass(n);R.writeClasses();R.write('>');this.renderCollapseButton(R,C);if(B&&B.length&&C.getShowButtons()){R.renderControl(C.getAggregation('_overflowToolbar'));}R.write('</div>');};
N.renderInvisibleItem=function(R,C){I.render(R,C,"li");};
function u(C){return C.getHideShowMoreButton()&&(!C.getShowButtons()||!C.getButtons());}
return N;},true);
sap.ui.predefine('sap/m/NumericContent',["./library","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/ResizeHandler","sap/m/Image","./NumericContentRenderer","sap/ui/events/KeyCodes","sap/base/util/deepEqual"],function(l,C,I,R,a,N,K,d){"use strict";var L={"ar":4,"ar_EG":4,"ar_SA":4,"bg":4,"ca":6,"cs":4,"da":4,"de":8,"de_AT":8,"de_CH":8,"el":4,"el_CY":4,"en":4,"en_AU":4,"en_GB":4,"en_HK":4,"en_IE":4,"en_IN":4,"en_NZ":4,"en_PG":4,"en_SG":4,"en_ZA":4,"es":6,"es_AR":4,"es_BO":4,"es_CL":4,"es_CO":4,"es_MX":6,"es_PE":4,"es_UY":4,"es_VE":4,"et":4,"fa":4,"fi":4,"fr":4,"fr_BE":4,"fr_CA":4,"fr_CH":4,"fr_LU":4,"he":4,"hi":4,"hr":4,"hu":4,"id":4,"it":8,"it_CH":8,"ja":6,"kk":4,"ko":6,"lt":4,"lv":4,"ms":4,"nb":4,"nl":4,"nl_BE":4,"pl":4,"pt":4,"pt_PT":4,"ro":4,"ru":4,"ru_UA":4,"sk":4,"sl":4,"sr":4,"sv":4,"th":4,"tr":4,"uk":4,"vi":4,"zh_CN":6,"zh_HK":6,"zh_SG":6,"zh_TW":6};
var b=C.extend("sap.m.NumericContent",{metadata:{library:"sap.m",properties:{"animateTextChange":{type:"boolean",group:"Behavior",defaultValue:true},"formatterValue":{type:"boolean",group:"Data",defaultValue:false},"icon":{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},"iconDescription":{type:"string",group:"Accessibility",defaultValue:null},"indicator":{type:"sap.m.DeviationIndicator",group:"Appearance",defaultValue:"None"},"nullifyValue":{type:"boolean",group:"Behavior",defaultValue:true},"scale":{type:"string",group:"Appearance",defaultValue:null},"size":{type:"sap.m.Size",group:"Appearance",defaultValue:"Auto"},"truncateValueTo":{type:"int",group:"Appearance",defaultValue:4},"value":{type:"string",group:"Data",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},"width":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"withMargin":{type:"boolean",group:"Appearance",defaultValue:true},"state":{type:"sap.m.LoadState",group:"Behavior",defaultValue:"Loaded"}},events:{"press":{}}}});
b.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setTooltip("{AltText}");sap.ui.getCore().attachInit(this._registerResizeHandler.bind(this));};
b.prototype._getParentTile=function(){var p=this.getParent();while(p){if(p.isA("sap.m.GenericTile")){return p;}p=p.getParent();}return null;};
b.prototype._getMaxDigitsData=function(){var t=this._getParentTile(),m=null,f=null;if(t){var s=sap.ui.getCore().getConfiguration().getLanguage(),i=t._isSmall();m=L[s]||m;if(!i){switch(m){case 6:f="sapMNCMediumFontSize";break;case 8:f="sapMNCSmallFontSize";break;default:f="sapMNCLargeFontSize";break;}}}return{fontClass:f,maxLength:m};};
b.prototype._registerResizeHandler=function(){R.register(this,this.invalidate.bind(this));};
b.prototype.onBeforeRendering=function(){this.$().unbind("mouseenter");this.$().unbind("mouseleave");this._iMaxLength=null;};
b.prototype.onAfterRendering=function(){this.$().bind("mouseenter",this._addTooltip.bind(this));this.$().bind("mouseleave",this._removeTooltip.bind(this));if(!sap.ui.getCore().isThemeApplied()){sap.ui.getCore().attachThemeChanged(this._checkIfIconFits,this);}else{this._checkIfIconFits();}};
b.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
b.prototype._checkIfIconFits=function(){var p=this._getParentTile();if(p&&(p.isA("sap.m.GenericTile")||p.isA("sap.m.SlideTile"))){p._setupResizeClassHandler();}var $=this.$("icon-image"),c=this.$("value-inner"),e=this.$("value-scr");var s=$.outerWidth()+c.width(),w=e.width();s>w?$.hide():$.show();};
b.prototype._removeTooltip=function(){this.$().attr("title",null);};
b.prototype.exit=function(){if(this._oIcon){this._oIcon.destroy();}};
b.prototype.getAltText=function(){var v=this.getValue();var s=this.getScale();var e;var m=this._rb.getText(("SEMANTIC_COLOR_"+this.getValueColor()).toUpperCase());var A="";if(this.getNullifyValue()){e="0";}else{e="";}if(this.getIconDescription()){A=A.concat(this.getIconDescription());A=A.concat("\n");}if(v){A=A.concat(v+s);}else{A=A.concat(e);}A=A.concat("\n");if(this.getIndicator()&&this.getIndicator()!==l.DeviationIndicator.None){A=A.concat(this._rb.getText(("NUMERICCONTENT_DEVIATION_"+this.getIndicator()).toUpperCase()));A=A.concat("\n");}A=A.concat(m);return A;};
b.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var T=this.getAltText();if(typeof t==="string"||t instanceof String){T=t.split("{AltText}").join(T).split("((AltText))").join(T);return T;}if(t){return t;}else{return"";}};
b.prototype.setIcon=function(u){var v=!d(this.getIcon(),u);if(v){if(this._oIcon){this._oIcon.destroy();this._oIcon=undefined;}if(u){this._oIcon=I.createControlByURI({id:this.getId()+"-icon-image",src:u},a);}}this._setPointerOnIcon();return this.setProperty("icon",u);};
b.prototype._setPointerOnIcon=function(){if(this._oIcon&&this.hasListeners("press")){this._oIcon.addStyleClass("sapMPointer");}else if(this._oIcon&&this._oIcon.hasStyleClass("sapMPointer")){this._oIcon.removeStyleClass("sapMPointer");}};
b.prototype.ontap=function(e){this.$().focus();this.firePress();e.preventDefault();};
b.prototype.onkeyup=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
b.prototype.onkeydown=function(e){if(e.which===K.SPACE){e.preventDefault();}};
b.prototype.attachEvent=function(e,c,f,g){C.prototype.attachEvent.call(this,e,c,f,g);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnIcon();}return this;};
b.prototype.detachEvent=function(e,f,c){C.prototype.detachEvent.call(this,e,f,c);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnIcon();}return this;};
b.prototype._parseFormattedValue=function(v){var t=v.replace(String.fromCharCode(8206),"").replace(String.fromCharCode(8207),"");return{scale:t.replace(/[+-., \d]*(.*)$/g,"$1").trim().replace(/\.$/,""),value:t.replace(/([+-., \d]*).*$/g,"$1").trim()};};
return b;});
sap.ui.predefine('sap/m/ObjectAttribute',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Text','sap/ui/events/KeyCodes','./ObjectAttributeRenderer',"sap/base/Log"],function(l,C,c,T,K,O,L){"use strict";var a=c.TextDirection;
var b=C.extend("sap.m.ObjectAttribute",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectAttribute.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:a.Inherit}},aggregations:{customContent:{type:"sap.ui.core.Control",multiple:false},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{parameters:{domRef:{type:"string"}}}},dnd:{draggable:true,droppable:false}}});
b.prototype.init=function(){this.setAggregation('_textControl',new T());};
b.prototype._getUpdatedTextControl=function(){var A=this.getAggregation('customContent')||this.getAggregation('_textControl'),t=this.getTitle(),s=this.getAggregation('customContent')?this.getAggregation('customContent').getText():this.getText(),d=this.getTextDirection(),p=this.getParent(),P=sap.ui.getCore().getConfiguration().getRTL(),m,w=true,o='';if(d===a.LTR&&P){o='\u200e';}if(d===a.RTL&&!P){o='\u200f';}s=o+s+o;if(t){s=t+": "+s;}A.setProperty('text',s,true);if(p instanceof sap.m.ObjectListItem){w=false;m=O.MAX_LINES.SINGLE_LINE;}this._setControlWrapping(A,w,m);return A;};
b.prototype._setControlWrapping=function(A,w,m){if(A.isA("sap.m.Link")){A.setProperty('wrapping',w,true);}if(A.isA("sap.m.Text")){A.setProperty('maxLines',m,true);}};
b.prototype.ontap=function(e){if(this._isSimulatedLink()&&(e.target.id===this.getId()+"-text")){this.firePress({domRef:this.getDomRef()});}};
b.prototype.onsapenter=function(e){if(this._isSimulatedLink()){this.firePress({domRef:this.getDomRef()});e.setMarked();}};
b.prototype.onsapspace=function(e){e.preventDefault();};
b.prototype.onkeyup=function(e){if(e.which===K.SPACE){this.onsapenter(e);}};
b.prototype._isEmpty=function(){if(this.getAggregation('customContent')&&!(this.getAggregation('customContent').isA("sap.m.Link")||this.getAggregation('customContent').isA("sap.m.Text"))){L.warning("Only sap.m.Link or sap.m.Text are allowed in \"sap.m.ObjectAttribute.customContent\" aggregation");return true;}return!(this.getText().trim()||this.getTitle().trim());};
b.prototype.ontouchstart=function(e){if(this._isSimulatedLink()){e.originalEvent._sapui_handledByControl=true;}};
b.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("text");};
b.prototype._isSimulatedLink=function(){return(this.getActive()&&this.getText()!=="")&&!this.getAggregation('customContent');};
b.prototype.setCustomContent=function(o){if(o&&o.isA('sap.m.Link')){o._getTabindex=function(){return"-1";};}return this.setAggregation('customContent',o);};
b.prototype._isClickable=function(){return(this.getActive()&&this.getText()!=="")||(this.getAggregation('customContent')&&this.getAggregation('customContent').isA('sap.m.Link'));};
return b;});
sap.ui.predefine('sap/m/ObjectAttributeRenderer',["sap/ui/core/library"],function(c){"use strict";var T=c.TextDirection;var O={apiVersion:2,MAX_LINES:{SINGLE_LINE:1}};
O.render=function(r,o){var p=o.getParent(),t=o.getTooltip_AsString();r.openStart("div",o);if(o._isEmpty()){r.class("sapMObjectAttributeDiv");r.class("sapUiHidden");r.openEnd();r.close("div");return;}r.class("sapMObjectAttributeDiv");if(o._isClickable()){r.class("sapMObjectAttributeActive");r.attr("tabindex","0");r.accessibilityState(o,{role:"link"});}if(t){r.attr("title",t);}r.openEnd();if(o._isClickable()||p instanceof sap.m.ObjectHeader){this.renderActiveTitle(r,o);this.renderActiveText(r,o,p);}else{r.renderControl(o._getUpdatedTextControl());}r.close("div");};
O.renderActiveTitle=function(r,o){if(!o.getProperty("title")){return;}r.openStart("span",o.getId()+"-title");r.class("sapMObjectAttributeTitle");r.openEnd();r.text(o.getProperty("title"));r.close("span");r.openStart("span",o.getId()+"-colon");r.class("sapMObjectAttributeColon");r.openEnd();r.unsafeHtml(":&nbsp;");r.close("span");};
O.renderActiveText=function(r,o,p){var t=o.getTextDirection(),a=o.getAggregation("customContent");r.openStart("span",o.getId()+"-text");r.class("sapMObjectAttributeText");if(t&&t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(a&&p){if((p instanceof sap.m.ObjectHeader)&&!o.getParent().getResponsive()){o._setControlWrapping(a,true);}else{o._setControlWrapping(a,false,O.MAX_LINES.SINGLE_LINE);}r.renderControl(a);}else{r.text(o.getProperty("text"));}r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectHeader',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/m/Text','sap/ui/events/KeyCodes','./ObjectHeaderRenderer','./ObjectMarker','./ObjectNumber',"sap/ui/thirdparty/jquery"],function(l,C,I,c,D,T,K,O,a,b,q){"use strict";var B=l.BackgroundDesign;var d=c.TextAlign;var e=l.ImageHelper;var f=l.ObjectMarkerType;var g=c.TitleLevel;var h=c.TextDirection;var V=c.ValueState;var j=l.ObjectHeaderPictureShape;
var k=C.extend("sap.m.ObjectHeader",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectHeader.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},introActive:{type:"boolean",group:"Misc",defaultValue:null},titleActive:{type:"boolean",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconActive:{type:"boolean",group:"Misc",defaultValue:null},iconAlt:{type:"string",group:"Accessibility",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},imageShape:{type:"sap.m.ObjectHeaderPictureShape",group:"Appearance",defaultValue:j.Square},markFavorite:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showTitleSelector:{type:"boolean",group:"Misc",defaultValue:false},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},condensed:{type:"boolean",group:"Appearance",defaultValue:false},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance"},responsive:{type:"boolean",group:"Behavior",defaultValue:false},fullScreenOptimized:{type:"boolean",group:"Appearance",defaultValue:false},titleHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},titleTarget:{type:"string",group:"Behavior",defaultValue:null},introHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},introTarget:{type:"string",group:"Behavior",defaultValue:null},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},titleSelectorTooltip:{type:"string",group:"Misc",defaultValue:"Options"},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:g.H1}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},secondStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},statuses:{type:"sap.ui.core.Control",multiple:true,singularName:"status"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"},additionalNumbers:{type:"sap.m.ObjectNumber",multiple:true,singularName:"additionalNumber"},headerContainer:{type:"sap.m.ObjectHeaderContainer",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{titlePress:{parameters:{domRef:{type:"object"}}},introPress:{parameters:{domRef:{type:"object"}}},iconPress:{parameters:{domRef:{type:"object"}}},titleSelectorPress:{parameters:{domRef:{type:"object"}}}},dnd:{draggable:false,droppable:true}}});
k._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
k.prototype.init=function(){this._oTitleArrowIcon=I.createControlByURI({id:this.getId()+"-titleArrow",src:I.getIconURI("arrow-down"),decorative:false,visible:false,tooltip:k._getResourceBundle().getText("OH_SELECT_ARROW_TOOLTIP"),size:"1.375rem",press:function(E){}});this._fNumberWidth=undefined;this._titleText=new T(this.getId()+"-titleText");this._titleText.setMaxLines(3);};
k.prototype.insertAttribute=function(A,i){var r=this.insertAggregation("attributes",A,i);this._registerControlListener(A);return r;};
k.prototype.addAttribute=function(A){var r=this.addAggregation("attributes",A);this._registerControlListener(A);return r;};
k.prototype.removeAttribute=function(A){var r=this.removeAggregation("attributes",A);this._deregisterControlListener(r);return r;};
k.prototype.removeAllAttributes=function(){var A=this.removeAllAggregation("attributes");A.forEach(this._deregisterControlListener,this);return A;};
k.prototype.destroyAttributes=function(){var A=this.getAggregation("attributes");if(A!==null){A.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("attributes");};
k.prototype.insertStatus=function(s,i){var r=this.insertAggregation("statuses",s,i);this._registerControlListener(s);return r;};
k.prototype.addStatus=function(s){var r=this.addAggregation("statuses",s);this._registerControlListener(s);return r;};
k.prototype.removeStatus=function(s){var r=this.removeAggregation("statuses",s);this._deregisterControlListener(r);return r;};
k.prototype.removeAllStatuses=function(){var s=this.removeAllAggregation("statuses");s.forEach(this._deregisterControlListener,this);return s;};
k.prototype.destroyStatuses=function(){var s=this.getAggregation("statuses");if(s!==null){s.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("statuses");};
k.prototype._registerControlListener=function(o){if(o){o.attachEvent("_change",this.invalidate,this);}};
k.prototype._deregisterControlListener=function(o){if(o){o.detachEvent("_change",this.invalidate,this);}};
k.prototype.setCondensed=function(i){this.setProperty("condensed",i);if(this.getCondensed()){this._oTitleArrowIcon.setSize("1rem");}else{this._oTitleArrowIcon.setSize("1.375rem");}return this;};
k.prototype.setNumber=function(n){this.setProperty("number",n);this._getObjectNumber().setNumber(n);return this;};
k.prototype.setNumberUnit=function(u){this.setProperty("numberUnit",u);this._getObjectNumber().setUnit(u);return this;};
k.prototype.setNumberState=function(s){this.setProperty("numberState",s,true);this._getObjectNumber().setState(s);return this;};
k.prototype.setTitleSelectorTooltip=function(t){this.setProperty("titleSelectorTooltip",t,false);this._oTitleArrowIcon.setTooltip(t);return this;};
k.prototype.setMarkFavorite=function(m){return this._setOldMarkers(f.Favorite,m);};
k.prototype.setMarkFlagged=function(m){return this._setOldMarkers(f.Flagged,m);};
k.prototype.setShowMarkers=function(m){var M,A=this.getMarkers(),i;this.setProperty("showMarkers",m,false);for(i=0;i<A.length;i++){M=A[i].getType();if((M===f.Flagged&&this.getMarkFlagged())||(M===f.Favorite&&this.getMarkFavorite())){A[i].setVisible(m);}}return this;};
k.prototype._setOldMarkers=function(m,M){var A=this.getMarkers(),H=false,i,o={Flagged:"-flag",Favorite:"-favorite"};this.setProperty("mark"+m,M,false);if(!this.getShowMarkers()){M=false;}for(i=0;i<A.length;i++){if(A[i].getType()===m){H=true;A[i].setVisible(M);break;}}if(!H){this.insertAggregation("markers",new a({id:this.getId()+o[m],type:m,visible:M}));}return this;};
k.prototype._getVisibleMarkers=function(){var A=this.getMarkers(),v=[],i;for(i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
k.prototype._getObjectNumber=function(){var o=this.getAggregation("_objectNumber");if(!o){o=new b(this.getId()+"-number",{emphasized:false});this.setAggregation("_objectNumber",o,true);}return o;};
k.prototype.getFocusDomRef=function(){if(this.getResponsive()){return this.$("txt");}else{return this.$("title");}};
k.prototype.ontap=function(E){var s=E.target.id;if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:window.document.getElementById(s)});}}else if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(E.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){if(!this.getTitleHref()){E.preventDefault();s=this.getId()+"-title";this.fireTitlePress({domRef:window.document.getElementById(s)});}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(E.target).parent().attr('id')===this.getId()+"-txt")){if(!this.getTitleHref()){E.preventDefault();s=this.getId()+"-txt";this.fireTitlePress({domRef:window.document.getElementById(s)});}}else if(s===this.getId()+"-titleArrow"){this.fireTitleSelectorPress({domRef:window.document.getElementById(s)});}else if(s.indexOf(this.getId())!==-1){E.setMarked();E.preventDefault();}};
k.prototype._handleSpaceOrEnter=function(E){var s=E.target.id;E.setMarked();if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(E.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){s=this.getId()+"-title";if(!this.getTitleHref()){E.preventDefault();this.fireTitlePress({domRef:(s?window.document.getElementById(s):null)});}else{if(E.type==="sapspace"){this._linkClick(E,s);}}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(E.target).parent().attr('id')===this.getId()+"-txt")){s=this.getId()+"-txt";if(!this.getTitleHref()){E.preventDefault();this.fireTitlePress({domRef:(s?window.document.getElementById(s):null)});}else{if(E.type==="sapspace"){this._linkClick(E,s);}}}else if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:(s?window.document.getElementById(s):null)});}}else if(s===this.getId()+"-titleArrow"){this.fireTitleSelectorPress({domRef:(s?window.document.getElementById(s):null)});}};
k.prototype.onkeyup=function(E){if(E.which===K.SPACE){this._handleSpaceOrEnter(E);}};
k.prototype.onsapenter=k.prototype._handleSpaceOrEnter;
k.prototype._linkClick=function(E,s){E.setMarked();var o=document.createEvent('MouseEvents');o.initEvent('click',false,true);((s?window.document.getElementById(s):null)).dispatchEvent(o);};
k.prototype._onOrientationChange=function(){var i=this.getId();if(D.system.tablet&&this.getFullScreenOptimized()&&(this._hasAttributes()||this._hasStatus())){this._rerenderStates();}if(D.system.phone){if(D.orientation.portrait){if(this.getTitle().length>50){this._rerenderTitle(50);}if(this.getIcon()){q(document.getElementById(i+"-titlediv")).removeClass("sapMOHRTitleIcon");q(document.getElementById(i+"-titleIcon")).addClass("sapMOHRHideIcon");}}else{if(D.orientation.landscape){if(this.getTitle().length>80){this._rerenderTitle(80);}if(this.getIcon()){q(document.getElementById(i+"-titlediv")).addClass("sapMOHRTitleIcon");q(document.getElementById(i+"-titleIcon")).removeClass("sapMOHRHideIcon");}}}this._adjustNumberDiv();}this._adjustIntroDiv();};
k.prototype._rerenderTitle=function(n){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderTitle(r,this,n);r.destroy();};
k.prototype._rerenderStates=function(){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderResponsiveStates(r,this);r.destroy();};
k.prototype.exit=function(){if(!D.system.phone){this._detachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._onOrientationChange,this);}if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=undefined;}if(this._oTitleArrowIcon){this._oTitleArrowIcon.destroy();this._oTitleArrowIcon=undefined;}if(this._titleText){this._titleText.destroy();this._titleText=undefined;}if(this._introText){this._introText.destroy();this._introText=undefined;}};
k.prototype._getImageControl=function(){var i=this.getId()+"-img";var s="2.5rem";var p=q.extend({src:this.getIcon(),tooltip:this.getIconTooltip(),alt:this.getIconAlt()||k._getResourceBundle().getText("OH_ARIA_ICON"),useIconTooltip:false,densityAware:this.getIconDensityAware()},I.isIconURI(this.getIcon())?{size:s}:{});if(this.getIconActive()){p.press=function(E){this.fireIconPress({domRef:E.getSource().getDomRef()});}.bind(this);p.decorative=false;}this._oImageControl=e.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
k.prototype.onBeforeRendering=function(){if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._onOrientationChange,this);}if(!D.system.phone){this._detachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}if(this._introText){this._introText.destroy();this._introText=undefined;}};
k.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();var $=this.$("titleArrow");$.attr("role","button");if(this.getResponsive()){this._adjustIntroDiv();if(o&&o.getNumber()){if(D.system.desktop&&q('html').hasClass("sapUiMedia-Std-Desktop")&&this.getFullScreenOptimized()&&this._iCountVisAttrStat>=1&&this._iCountVisAttrStat<=3){o.setTextAlign(p?d.Right:d.Left);}else{o.setTextAlign(p?d.Left:d.Right);}}this._adjustNumberDiv();if(D.system.tablet||D.system.phone){D.orientation.attachHandler(this._onOrientationChange,this);}if(!D.system.phone){this._attachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}}else{var t=p?d.Left:d.Right;if(o&&o.getNumber()){o.setTextAlign(t);}if(this.getAdditionalNumbers()){this._setTextAlignANum(t);}}};
k.prototype._rerenderOHR=function(){this.invalidate();};
k.prototype._adjustNumberDiv=function(){var i=this.getId();var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();if(o&&o.getNumber()){var $=q(document.getElementById(i+"-number"));var m=q(document.getElementById(i+"-titlediv"));if(this._isMediaSize("Phone")){if($.hasClass("sapMObjectNumberBelowTitle")){o.setTextAlign(p?d.Left:d.Right);$.removeClass("sapMObjectNumberBelowTitle");m.removeClass("sapMOHRTitleDivFull");}var n=$.parent().width()*0.4;if($.outerWidth()>n){o.setTextAlign(p?d.Right:d.Left);$.addClass("sapMObjectNumberBelowTitle");m.addClass("sapMOHRTitleDivFull");}}}};
k.prototype._adjustIntroDiv=function(){var i=this.getId();var $=q(document.getElementById(i+"-txt"));var m=q(document.getElementById(i+"-titleArrow"));var n=q(document.getElementById(i+"-intro"));if(n.parent().hasClass("sapMOHRIntroMargin")){n.parent().removeClass("sapMOHRIntroMargin");}if(m.height()!==null&&($.height()<m.height())){n.parent().addClass("sapMOHRIntroMargin");}};
k._escapeId=function(i){return i?"#"+i.replace(/(:|\.)/g,'\\$1'):"";};
k.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this._hasMarkers());};
k.prototype._hasIcon=function(){return!!this.getIcon().trim();};
k.prototype._hasAttributes=function(){var m=this.getAttributes();if(m&&m.length>0){for(var i=0;i<m.length;i++){if(!m[i]._isEmpty()){return true;}}}return false;};
k.prototype._hasStatus=function(){var H=((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));if(!H&&this.getStatuses()&&this.getStatuses().length>0){var s=this.getStatuses();for(var i=0;i<s.length;i++){if(s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty()){H=true;break;}else if(s[i]instanceof sap.m.ProgressIndicator){H=true;break;}}}return H;};
k.prototype._hasMarkers=function(){var m=this.getMarkers(),H=this.getShowMarkers()&&(this.getMarkFavorite()||this.getMarkFlagged()),i=m&&m.length;return(H||i);};
k.prototype._getDefaultBackgroundDesign=function(){if(this.getCondensed()){return B.Solid;}else{if(this.getResponsive()){return B.Translucent;}else{return B.Transparent;}}};
k.prototype._getBackground=function(){if(this.getBackgroundDesign()===undefined){return this._getDefaultBackgroundDesign();}else{return this.getBackgroundDesign();}};
k.prototype._setTextAlignANum=function(t){var n=this.getAdditionalNumbers();for(var i=0;i<n.length;i++){n[i].setTextAlign(t);}};
k.prototype._isMediaSize=function(r){return this._getCurrentMediaContainerRange(D.media.RANGESETS.SAP_STANDARD).name===r;};
return k;});
sap.ui.predefine('sap/m/ObjectHeaderRenderer',['sap/ui/core/Control','sap/ui/core/library','sap/m/library','sap/ui/Device',"sap/base/Log",'sap/m/Link','sap/m/Text',"sap/ui/thirdparty/jquery"],function(C,c,l,D,L,a,T,q){"use strict";var b=c.TextDirection;var B=l.BackgroundDesign;var d=c.TitleLevel;var O={};
O._isEmptyObject=function(o){if(!o){return true;}if((!o._isEmpty||!o._isEmpty())&&(!o.getVisible||o.getVisible())){return false;}return true;};
O._isEmptyArray=function(A){if(A){for(var i=0;i<A.length;i++){if(!O._isEmptyObject(A[i])){return false;}}}return true;};
O._isEmptyRow=function(o,r){return O._isEmptyObject(o)&&O._isEmptyArray(r);};
O._renderObjects=function(r,o,e){for(var i=0;i<o.length;i++){if(o[i]instanceof C){this._renderChildControl(r,e,o[i]);}}};
O._computeChildControlsToBeRendered=function(o){o.__controlsToBeRendered={};var e=o.getAttributes();for(var i=0;i<e.length;i++){o.__controlsToBeRendered[e[i].getId()]=e[i];}e=o.getStatuses();for(var i=0;i<e.length;i++){o.__controlsToBeRendered[e[i].getId()]=e[i];}var f=o.getFirstStatus();if(f){o.__controlsToBeRendered[f.getId()]=f;}f=o.getSecondStatus();if(f){o.__controlsToBeRendered[f.getId()]=f;}f=o.getAggregation("_objectNumber");if(f){o.__controlsToBeRendered[f.getId()]=f;}};
O._cleanupNotRenderedChildControls=function(r,o){for(var i in o.__controlsToBeRendered){r.cleanupControlWithoutRendering(o.__controlsToBeRendered[i]);}delete o.__controlsToBeRendered;};
O._getMarkers=function(o){return o._getVisibleMarkers();};
O._renderIntro=function(r,o,i,I){if(o.getIntroActive()){o._introText=new a(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setHref(o.getIntroHref());o._introText.setTarget(o.getIntroTarget());o._introText.press=o.introPress;}else{o._introText=new T(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setMaxLines(3);}o._introText.setTextDirection(o.getIntroTextDirection());r.write("<div");r.addClass(i);if(o.getIntroActive()){r.addClass(I);}r.writeClasses();r.write(">");this._renderChildControl(r,o,o._introText);r.write("</div>");};
O._renderAttribute=function(r,o,A,f){r.write("<div");r.addClass("sapMOHAttr");r.writeClasses();if(f){r.addStyle("width","100%");r.writeStyles();}r.write(">");this._renderChildControl(r,o,A);r.write("</div>");};
O._getVisibleStatuses=function(o){var v=[];if(o.getFirstStatus()&&o.getFirstStatus().getVisible()){v.push([o.getFirstStatus()]);}if(o.getSecondStatus()&&o.getSecondStatus().getVisible()){v.push([o.getSecondStatus()]);}if(o.getStatuses()){var s=o.getStatuses();for(var i=0;i<s.length;i++){if(!s[i].getVisible||s[i].getVisible()){if((s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty())||s[i]instanceof sap.m.ProgressIndicator){v.push([s[i]]);}else{L.warning("Only sap.m.ObjectStatus or sap.m.ProgressIndicator are allowed in \"sap.m.ObjectHeader.statuses\" aggregation."+" Current object is "+s[i].constructor.getMetadata().getName()+" with id \""+s[i].getId()+"\"");}}}}return v;};
O._getVisibleAttribsAndStatuses=function(o){var r=[],A=o.getAttributes(),v=[];for(var j=0;j<A.length;j++){if(A[j].getVisible()&&!A[j]._isEmpty()){v.push(A[j]);}}var V=this._getVisibleStatuses(o);r[0]=v;r[1]=V;return r;};
O._renderRow=function(r,o,e,R){if(O._isEmptyRow(e,R)){return;}r.write("<div");r.addClass("sapMOHAttrRow");r.writeClasses();r.write(">");if(!O._isEmptyObject(e)){this._renderAttribute(r,o,e,O._isEmptyArray(R));}else if(O._isEmptyObject(e)&&!O._isEmptyArray(R)){if(R[0]instanceof sap.m.ProgressIndicator){r.write("<div");r.addClass("sapMOHAttr");r.writeClasses();r.write(">");r.write("</div>");}}if(!O._isEmptyArray(R)){r.write("<div");if(R[0]instanceof sap.m.ProgressIndicator){r.addClass("sapMOHStatusFixedWidth");}else if(R[0]instanceof sap.m.ObjectMarker){r.addClass("sapMOHStatusFixedWidth");r.addClass("sapMObjStatusMarker");}else{r.addClass("sapMOHStatus");}r.writeClasses();r.write(">");O._renderObjects(r,R,o);r.write("</div>");}r.write("</div>");};
O._renderAttributesAndStatuses=function(r,o){var A=o.getAttributes();var v=[];for(var j=0;j<A.length;j++){if(A[j].getVisible()){v.push(A[j]);}}var i=v.length;var m=[];var M=O._getMarkers(o);if(!o.getResponsive()&&!O._isEmptyArray(M)){m.push(M);}var V=this._getVisibleStatuses(o);m=m.concat(V);var e=m.length;var n=i>e?i:e;if(!o.getResponsive()){for(var f=0;f<n;f++){this._renderRow(r,o,v[f],m[f]);}}};
O._renderNumber=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){return;}r.write("<div");r.writeAttribute("id",o.getId()+"-numberdiv");r.addClass("sapMOHNumberDiv");r.writeClasses();r.write(">");var e=o.getAggregation("_objectNumber");if(e&&e.getNumber()){e.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,e);}r.write("</div>");if(!o.getCondensed()){this._renderAdditionalNumbers(r,o);}};
O._renderAdditionalNumbers=function(r,o){var n=o.getAdditionalNumbers();if(n&&!n.length){return;}if(n.length===1){r.write("<div");r.addClass("additionalOHNumberSeparatorDiv");r.writeClasses();r.write("></div>");}for(var i=0;i<n.length;i++){r.write("<div");r.writeAttribute("id",o.getId()+"-additionalNumber"+i);r.addClass("sapMOHNumberDiv additionalOHNumberDiv");if(n.length===1){r.addClass("sapMOHOnlyANumber");}r.writeClasses();r.write(">");n[i].setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,n[i]);r.write("</div>");}};
O._renderTitle=function(r,o){o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.write("<div");r.addClass("sapMOHTitleAndArrow");r.writeClasses();r.write(">");}if(o.getTitle()){var t=(o.getTitleLevel()===d.Auto)?d.H1:o.getTitleLevel();o._titleText.setText(o.getTitle());o._titleText.setTextDirection(o.getTitleTextDirection());if(o.getTitleActive()){r.write("<a");if(o.getTitleHref()){r.writeAttributeEscaped("href",o.getTitleHref());if(o.getTitleTarget()){r.writeAttributeEscaped("target",o.getTitleTarget());}}r.writeAccessibilityState({role:"link",haspopup:!o.getTitleHref()});}else{r.write("<div");}r.writeAttribute("id",o.getId()+"-title");r.addClass("sapMOHTitle");if(o.getTitleActive()){r.writeAttribute("tabindex","0");r.addClass("sapMOHTitleActive");}if(o.getShowTitleSelector()){r.addClass("sapMOHTitleFollowArrow");}r.writeClasses();r.write(">");r.write("<"+t+">");this._renderChildControl(r,o,o._titleText);r.write("</"+t+">");if(o.getTitleActive()){r.write("</a>");}else{r.write("</div>");}}if(o.getShowTitleSelector()){r.write("<span");r.addClass("sapMOHTitleArrow");r.writeClasses();r.write(">");this._renderChildControl(r,o,o._oTitleArrowIcon);r.write("</span>");}if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.write("</div>");}};
O._renderFullTitle=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){r.addClass("sapMOHTitleDivFull");}};
O._renderFullOH=function(r,o){if(o.getIntro()){this._renderIntro(r,o,"sapMOHIntro","sapMOHIntroActive");}r.write("<div");r.addClass("sapMOHTopRow");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",o.getId()+"-titlediv");r.addClass("sapMOHTitleDiv");if(o._hasIcon()){r.addClass("sapMOHTitleIcon");}this._renderFullTitle(r,o);r.writeClasses();r.write(">");if(o._hasIcon()){r.write("<div");r.addClass("sapMOHIcon");r.addClass('sapMOHIcon'+o.getImageShape());if(o.getIconActive()){r.addClass("sapMPointer");}r.writeClasses();r.write(">");this._renderChildControl(r,o,o._getImageControl());r.write("</div>");}this._renderTitle(r,o);r.write("</div>");this._renderNumber(r,o);r.write("<div class=\"sapMOHDivider\"></div>");r.write("</div>");if(o._hasBottomContent()){r.write("<div");r.addClass("sapMOHBottomRow");r.writeClasses();r.write(">");this._renderAttributesAndStatuses(r,o);r.write("<div class=\"sapMOHDivider\"></div>");r.write("</div>");}};
O._renderCondensedOH=function(r,o){r.write("<div");r.writeAttribute("id",o.getId()+"-titlediv");r.addClass("sapMOHTitleDiv");this._renderFullTitle(r,o);r.writeClasses();r.write(">");this._renderTitle(r,o);r.write("</div>");this._renderNumber(r,o);var f=o.getAttributes()[0];if(f&&!f._isEmpty()){this._renderAttribute(r,o,f);}};
O.render=function(r,o){if(o.getResponsive()){this._renderResponsive(r,o);return;}this._computeChildControlsToBeRendered(o);var e=o.getCondensed();r.write("<div");r.writeControlData(o);r.addClass("sapMOH");if(o._getBackground()!==B.Transparent){r.addClass("sapContrastPlus");}if(e){r.addClass("sapMOHC");}r.addClass("sapMOHBg"+o._getBackground());r.writeClasses();var t=o.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState({role:"region",labelledby:{value:o.getId()+"-titleText-inner",append:true}});r.write(">");if(e){this._renderCondensedOH(r,o);}else{this._renderFullOH(r,o);}r.write("<div class=\"sapMOHLastDivider\"></div>");r.write("</div>");this._cleanupNotRenderedChildControls(r,o);};
O._renderChildControl=function(r,o,e){r.renderControl(e);if(!o.getResponsive()&&o.__controlsToBeRendered){o.__controlsToBeRendered[e.getId()]=undefined;}};
O._renderResponsive=function(r,o){var s=this._hasResponsiveStates(o),t=this._hasResponsiveTabs(o),h=o.getHeaderContainer();r.write("<div");r.addClass("sapMOHROuter");r.writeClasses();var e=o.getTooltip_AsString();if(e){r.writeAttributeEscaped("title",e);}r.writeAccessibilityState({role:"region",labelledby:{value:o.getId()+"-txt",append:true}});r.writeControlData(o);r.write(">");r.write("<div");r.addClass("sapMOHR");if(o._getBackground()!==B.Transparent){r.addClass("sapContrastPlus");}if(t){r.addClass("sapMOHRNoBorder");}r.addClass("sapMOHRBg"+o._getBackground());r.writeClasses();r.write(">");r.write("<div");if(D.system.desktop&&o._isMediaSize("Desktop")&&o.getFullScreenOptimized()&&o._iCountVisAttrStat>=1&&o._iCountVisAttrStat<=3){r.addClass("sapMOHRStatesOneOrThree");}r.writeClasses();r.write(">");this._renderResponsiveTitleBlock(r,o);if(s){this._renderResponsiveStates(r,o);}r.write("</div>");if(t){this._renderResponsiveTabs(r,o);}r.write("</div>");if(h&&h instanceof sap.m.IconTabBar){this._renderChildControl(r,o,h);}r.write("</div>");if(!o.getTitle()){if(!o.getBinding("title")){L.warning("The title shouldn't be empty!");}}};
O._renderResponsiveTitleBlock=function(r,o){r.write("<div");r.writeAttribute("id",o.getId()+"-titlenumdiv");r.addClass("sapMOHRTitleNumberDiv");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",o.getId()+"-titlediv");r.addClass("sapMOHRTitleDiv");if(o._hasIcon()){if(D.system.phone||o._isMediaSize("Phone")){if(D.orientation.landscape||(o._isMediaSize("Phone")&&!D.system.phone)){r.addClass("sapMOHRTitleIcon");}}else{r.addClass("sapMOHRTitleIcon");}}if(!o.getNumber()){r.addClass("sapMOHRTitleDivFull");}r.writeClasses();r.write(">");this._renderResponsiveTitle(r,o);if(o._hasIcon()){r.write("<div");r.writeAttribute("id",o.getId()+"-titleIcon");r.addClass("sapMOHRIcon");r.addClass('sapMOHRIcon'+o.getImageShape());if((D.system.phone&&D.orientation.portrait)){r.addClass("sapMOHRHideIcon");}if(o.getIconActive()){r.addClass("sapMPointer");}r.writeClasses();r.write(">");this._renderChildControl(r,o,o._getImageControl());r.write("</div>");}r.write("</div>");this._renderResponsiveNumber(r,o);r.write("</div>");};
O._renderResponsiveStates=function(r,o){r.write("<div");r.writeAttribute("id",o.getId()+"-states");r.addClass("sapMOHRStates");r.writeClasses();r.write(">");this._renderResponsiveRow(r,o);r.write("</div>");};
O._renderResponsiveRow=function(r,o){var v=[];v=this._getVisibleAttribsAndStatuses(o);var V=v[0].concat(v[1]),i=v[0].length,e=V.length,R=1,s='';if(e===0){return;}if(D.system.desktop){if(!o.getFullScreenOptimized()){if(e>=1&&e<=4){R=2;s='sapMOHRTwoCols';}if(e>=5){R=3;s='sapMOHRThreeCols';}}else{if(e>=1&&e<=3){R=1;s='sapMOHROneCols';}if(e>=4){R=4;s='sapMOHRFourCols';}}}if((D.system.tablet&&!D.system.desktop)||(D.system.desktop&&o._isMediaSize("Tablet"))){if(!o.getFullScreenOptimized()||(D.orientation.portrait&&o.getFullScreenOptimized())){R=2;s='sapMOHRTwoCols';}else{if(o.getFullScreenOptimized()&&(D.orientation.landscape||(D.system.desktop&&o._isMediaSize("Tablet")))){if(e>=1&&e<=2){R=2;s='sapMOHRTwoCols';}if(e>=3){R=3;s='sapMOHRThreeCols';}}}}if(D.system.phone||(D.system.desktop&&o._isMediaSize("Phone"))){R=1;s='sapMOHROneCols';}this._renderResponsiveStatesColumn(r,o,R,V,i,s);};
O._renderResponsiveStatesColumn=function(r,o,R,v,e,s){var f=Math.floor(v.length/R);var g=v.length%R;var h=0;var j=1;for(var i=0;i<v.length;i++){if(h==0){r.write("<div");r.addClass("sapMOHRStatesCont"+j);r.addClass(s);r.writeClasses();r.write(">");}if(i<e){this._renderResponsiveAttribute(r,o,v[i]);}else{this._renderResponsiveStatus(r,o,v[i]);}h++;if((h==f&&j>g)||(h==(f+1)&&j<=g)||i==v.length-1){r.write("</div>");h=0;j++;}}};
O._renderResponsiveAttribute=function(r,o,A){r.write("<div");r.addClass("sapMOHRAttr");r.writeClasses();r.write(">");this._renderChildControl(r,o,A);r.write("</div>");};
O._renderResponsiveStatus=function(r,o,s){r.write("<div");r.addClass("sapMOHRStatus");r.writeClasses();r.write(">");this._renderChildControl(r,o,s[0]);r.write("</div>");};
O._renderResponsiveMarkers=function(r,o){var m=[],t=o.getTitleTextDirection(),p=sap.ui.getCore().getConfiguration().getRTL();m=o._getVisibleMarkers();r.write("<span");r.addClass("sapMObjStatusMarker");if((t===b.LTR&&p)||(t===b.RTL&&!p)){r.addClass("sapMObjStatusMarkerOpposite");}r.writeClasses();r.writeAttribute("id",o.getId()+"-markers");r.write(">");for(var i=0;i<m.length;i++){this._renderChildControl(r,o,m[i]);}r.write("</span>");};
O._renderResponsiveNumber=function(r,o){var e=o.getAggregation("_objectNumber");if(e&&e.getNumber()){e.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,e);}};
O._hasResponsiveStates=function(o){var A=o.getAttributes(),v=[];if(!(o._hasAttributes()||o._hasStatus())){o._iCountVisAttrStat=0;return false;}for(var j=0;j<A.length;j++){if(A[j].getVisible()){v.push(A[j]);}}var V=this._getVisibleStatuses(o);o._iCountVisAttrStat=v.length+V.length;return!!(v.length+V.length);};
O._hasResponsiveTabs=function(o){var h=o.getHeaderContainer(),i;if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();if(i.getVisible()){o._iCountVisTabs=i.getItems().length;return!!i.getItems().length;}}else if(h.getMetadata().getName()==="sap.m.HeaderContainer"){return!!h.getContent().length;}else if(h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){return!!h.getItems().length;}}return false;};
O._renderResponsiveTabs=function(r,o){var h=o.getHeaderContainer(),i;r.write("<div class=\"sapMOHRTabs"+(h instanceof sap.m.IconTabBar?" sapMOHRTabsITB":"")+"\">");if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();this._renderChildControl(r,o,i);h._bHideHeader=true;}else if(h.getMetadata().getName()==="sap.m.HeaderContainer"||h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){this._renderChildControl(r,o,h);}else{L.warning("The control "+h+" is not supported for aggregation \"headerContainer\"");}}r.write("</div>");};
O._renderResponsiveTitle=function(r,o){var n;o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());r.write("<div");r.writeAttribute("id",o.getId()+"-title");r.addClass("sapMOHRTitle");if(o.getTitle().length&&o.getTitleActive()){r.addClass("sapMOHRTitleActive");}if(o.getShowTitleSelector()){r.addClass("sapMOHRTitleFollowArrow");}r.writeClasses();r.write(">");if((D.system.phone&&D.orientation.portrait)){n=50;}else{n=80;}r.write("<div");r.writeAttribute("id",o.getId()+"-title-arrow");r.addStyle("display","inline-block");r.writeStyles();r.write(">");this._renderResponsiveTitleAndArrow(r,o,n);r.write("</div>");if(o.getIntro()){this._renderIntro(r,o,"sapMOHRIntro","sapMOHRIntroActive");}r.write("</div>");};
O._rerenderTitle=function(r,o,n){var i=o.getId();this._renderResponsiveTitleAndArrow(r,o,n);r.flush(q(document.getElementById(i+"-title-arrow")));};
O._renderResponsiveTitleAndArrow=function(r,o,n){var s,e='',t=o.getTitleTextDirection();var m=!!o._getVisibleMarkers().length;var f=(o.getTitleLevel()===d.Auto)?d.H1:o.getTitleLevel();r.write("<"+f+">");r.write("<span");r.addClass("sapMOHRTitleTextContainer");r.writeClasses();if(t!=b.Inherit){r.writeAttribute("dir",t.toLowerCase());}r.write(">");if(o.getTitle().length&&o.getTitleActive()){r.write("<a");if(o.getTitleHref()){r.writeAttributeEscaped("href",o.getTitleHref());if(o.getTitleTarget()){r.writeAttributeEscaped("target",o.getTitleTarget());}}r.writeAttribute("tabindex","0");r.writeAccessibilityState({role:"link",haspopup:!o.getTitleHref()});}else{r.write("<span");}r.writeAttribute("id",o.getId()+"-txt");r.addClass("sapMOHRTitleText");r.writeClasses();r.write(">");r.write("<span");r.writeAttribute("id",o.getId()+"-titletxtwrap");r.addClass("sapMOHRTitleTextWrappable");r.writeClasses();r.write(">");if(o.getTitle().length>n){s=o.getTitle().substr(0,n).trim();e='...';}else{s=o.getTitle();}if(m){var g=s.substr(s.lastIndexOf(" ")+1);var h=s.substr(0,s.lastIndexOf(" ")+1);if(g.length===1){g=s;h='';}r.writeEscaped(h);r.write("</span>");r.writeEscaped(g);r.write(e);if(o.getTitleActive()){r.write("</a>");}else{r.write("</span>");}this._renderResponsiveMarkers(r,o);r.write("</span>");}else{if(!e){r.writeEscaped(s);}else{r.writeEscaped(s+e);}if(o.getTitleActive()){r.write("</span></a></span>");}else{r.write("</span></span></span>");}}if(o.getShowTitleSelector()){r.write("<span");r.addClass("sapMOHRTitleArrow");r.writeClasses();r.write(">");this._renderChildControl(r,o,o._oTitleArrowIcon);r.write("</span>");}r.write("</"+f+">");};
O._rerenderResponsiveStates=function(r,o){var i=o.getId(),v=this._getVisibleAttribsAndStatuses(o),V=v[0].concat(v[1]),e=v[0].length,f=V.length,R=1,s='';if(f===0){return;}if(D.orientation.portrait){R=2;s='sapMOHRTwoCols';}else{if(f>=1&&f<=2){R=2;s='sapMOHRTwoCols';}if(f>=3){R=3;s='sapMOHRThreeCols';}}this._renderResponsiveStatesColumn(r,o,R,V,e,s);r.flush(q(document.getElementById(i+"-states"))[0]);};
return O;},true);
sap.ui.predefine('sap/m/ObjectIdentifier',['./library','./Link','./Text','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/Device','sap/ui/base/ManagedObject','./ObjectIdentifierRenderer'],function(l,L,T,C,I,a,c,D,M,O){"use strict";var b=c.TextDirection;
var d=C.extend("sap.m.ObjectIdentifier",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectIdentifier.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},badgeNotes:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgePeople:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgeAttachments:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},titleActive:{type:"boolean",group:"Misc",defaultValue:false},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit}},aggregations:{_titleControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{titlePress:{parameters:{domRef:{type:"object"}}}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},dnd:{draggable:true,droppable:false}}});
d.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(sap.ui.getCore().getConfiguration().getAccessibility()){d.OI_ARIA_ROLE=o.getText("OI_ARIA_ROLE");this._createAriaInfoTextControl();}};
d.prototype.exit=function(){if(this._attachmentsIcon){this._attachmentsIcon.destroy();this._attachmentsIcon=null;}if(this._peopleIcon){this._peopleIcon.destroy();this._peopleIcon=null;}if(this._notesIcon){this._notesIcon.destroy();this._notesIcon=null;}if(this._oAriaCustomRole){this._oAriaCustomRole.destroy();this._oAriaCustomRole=null;}};
d.prototype._getAttachmentsIcon=function(){if(!this._attachmentsIcon){this._attachmentsIcon=this._getIcon(I.getIconURI("attachment"),this.getId()+"-attachments");}return this._attachmentsIcon;};
d.prototype._getPeopleIcon=function(){if(!this._peopleIcon){this._peopleIcon=this._getIcon(I.getIconURI("group"),this.getId()+"-people");}return this._peopleIcon;};
d.prototype._getNotesIcon=function(){if(!this._notesIcon){this._notesIcon=this._getIcon(I.getIconURI("notes"),this.getId()+"-notes");}return this._notesIcon;};
d.prototype._getIcon=function(u,i){var s=D.system.phone?"1em":"1em";var o;o=this._icon||I.createControlByURI({src:u,id:i+"-icon",size:s,useIconTooltip:false},sap.m.Image);o.setSrc(u);return o;};
d.prototype._getTitleControl=function(){var t=this.getAggregation("_titleControl"),i=this.getId();if(!t){if(this.getProperty("titleActive")){t=new L({id:i+"-link",text:M.escapeSettingsValue(this.getProperty("title")),ariaLabelledBy:this._oAriaCustomRole});t.addAssociation("ariaLabelledBy",i+"-text",true);}else{t=new T({id:i+"-txt",text:M.escapeSettingsValue(this.getProperty("title"))});}this.setAggregation("_titleControl",t,true);}t.setVisible(!!this.getTitle());return t;};
d.prototype._getTextControl=function(){var t=this.getAggregation("_textControl");if(!t){t=new T({text:M.escapeSettingsValue(this.getProperty("text"))});this.setAggregation("_textControl",t,true);}t.setTextDirection(this.getTextDirection());t.setVisible(!!this.getText());return t;};
d.prototype.setTitle=function(t){var o=this._getTitleControl();o.setProperty("text",t);o.setVisible(!!o.getText());return this.setProperty("title",t);};
d.prototype.setText=function(t){this._getTextControl().setProperty("text",t);return this.setProperty("text",t);};
d.prototype.setTitleActive=function(v){var p=this.getTitleActive();this.setProperty("titleActive",v);if(p!=v){this.destroyAggregation("_titleControl");this._getTitleControl();}return this;};
d.prototype._handlePress=function(e){var o=e.target;if(this.getTitleActive()&&this.$("title")[0].firstChild==o){this.fireTitlePress({domRef:o});e.setMarked();}};
d.prototype.onsapenter=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.onsapspace=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.ontap=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.addAssociation=function(A,i,s){var t=this.getAggregation("_titleControl");if(A==="ariaLabelledBy"){if(this.getTitleActive()&&t instanceof sap.m.Link){t.addAssociation("ariaLabelledBy",i,true);}}return C.prototype.addAssociation.apply(this,arguments);};
d.prototype.removeAssociation=function(A,o,s){var t=this.getAggregation("_titleControl");if(A==="ariaLabelledBy"){if(this.getTitleActive()&&t instanceof sap.m.Link){t.removeAssociation("ariaLabelledBy",o,true);}}return C.prototype.removeAssociation.apply(this,arguments);};
d.prototype._createAriaInfoTextControl=function(){if(!this._oAriaCustomRole){this._oAriaCustomRole=new a(this.getId()+"-oIHiddenText",{text:d.OI_ARIA_ROLE});}return this._oAriaCustomRole;};
d.prototype.getAccessibilityInfo=function(){var t=this.getAggregation("_titleControl").getAccessibilityInfo(),o=(d.OI_ARIA_ROLE+" "+(t.type||"")).trim();t.type=o;t.description=t.description+" "+this.getText();return t;};
d.prototype._hasTopRow=function(){return this.getTitle()||this.getBadgeNotes()||this.getBadgePeople()||this.getBadgeAttachments();};
return d;});
sap.ui.predefine('sap/m/ObjectIdentifierRenderer',[],function(){"use strict";var O={apiVersion:2};
O.render=function(r,o){var t;if(!o.getVisible()){return;}r.openStart("div",o);r.class("sapMObjectIdentifier");t=o.getTooltip_AsString();if(t){r.attr("title",t);}r.openEnd();r.openStart("div");r.class("sapMObjectIdentifierTopRow");if(!o._hasTopRow()){r.style("display","none");}r.openEnd();r.openStart("div",o.getId()+"-title");r.class("sapMObjectIdentifierTitle");r.openEnd();r.renderControl(o._getTitleControl());r.renderControl(o._oAriaCustomRole);r.close("div");r.openStart("div");r.class("sapMObjectIdentifierIcons");r.openEnd();if(o.getBadgeAttachments()){r.openStart("span");r.class("sapMObjectIdentifierIconSpan");r.openEnd();r.renderControl(o._getAttachmentsIcon());r.close("span");}if(o.getBadgeNotes()){r.openStart("span");r.class("sapMObjectIdentifierIconSpan");r.openEnd();r.renderControl(o._getNotesIcon());r.close("span");}if(o.getBadgePeople()){r.openStart("span");r.class("sapMObjectIdentifierIconSpan");r.openEnd();r.renderControl(o._getPeopleIcon());r.close("span");}r.close("div");r.close("div");r.openStart("div",o.getId()+"-text");r.class("sapMObjectIdentifierText");if(!!o.getProperty("text")&&!!o.getProperty("title")){r.class("sapMObjectIdentifierTextBellow");}r.openEnd();r.renderControl(o._getTextControl());r.close("div");r.close("div");};
return O;},true);
sap.ui.predefine('sap/m/ObjectListItem',['sap/ui/core/Control','sap/ui/base/ManagedObjectObserver','./ListItemBase','./library','sap/ui/core/IconPool','sap/m/ObjectNumber','sap/ui/core/library','./ObjectMarker','./Text','./ObjectListItemRenderer'],function(C,M,L,l,I,O,c,a,T,b){"use strict";var d=l.ObjectMarkerType;var e=l.ImageHelper;var f=c.TextAlign;var g=c.TextDirection;var V=c.ValueState;
var h=L.extend("sap.m.ObjectListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},markFavorite:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},markLocked:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false},secondStatus:{type:"sap.m.ObjectStatus",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/ObjectListItem.designtime",dnd:{draggable:true,droppable:true}}});
h.prototype.init=function(E){this._generateObjectNumber();this._observerObjectMarkerChanges=this._observerObjectMarkerChanges.bind(this);this._oMarkersObservers={};};
h.prototype.exit=function(E){if(this._oImageControl){this._oImageControl.destroy();}if(this._oTitleText){this._oTitleText.destroy();this._oTitleText=undefined;}L.prototype.exit.apply(this);};
h.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber"),p=sap.ui.getCore().getConfiguration().getRTL(),t=p?f.Left:f.Right;if(o&&o.getNumber()){o.setTextAlign(t);}};
h.prototype._generateObjectNumber=function(){var n=this.getNumber(),N=this.getNumberUnit(),s=this.getNumberState(),t=this.getNumberTextDirection();this.setAggregation("_objectNumber",new O(this.getId()+"-ObjectNumber",{number:n,unit:N,state:s,textDirection:t}),true);};
h.prototype._hasAttributes=function(){var j=this.getAttributes();if(j.length>0){for(var i=0;i<j.length;i++){if(!j[i]._isEmpty()){return true;}}}return false;};
h.prototype._hasStatus=function(){return((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));};
h.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this.getShowMarkers()||this.getMarkLocked()||this._getVisibleMarkers().length>0);};
h.prototype._getVisibleAttributes=function(){var A=this.getAttributes();var v=[];for(var i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
h.prototype._getVisibleMarkers=function(){var A=this.getMarkers();var v=[];for(var i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
h.prototype._getImageControl=function(){var i=this.getId()+'-img';var s="2.5rem";var p;if(I.isIconURI(this.getIcon())){p={src:this.getIcon(),height:s,width:s,size:s,useIconTooltip:false,densityAware:this.getIconDensityAware()};}else{p={src:this.getIcon(),useIconTooltip:false,densityAware:this.getIconDensityAware()};}var j=['sapMObjLIcon'];this._oImageControl=e.getImageControl(i,this._oImageControl,this,p,j);return this._oImageControl;};
h.prototype._activeHandlingInheritor=function(){var A=this.getActiveIcon();if(!!this._oImageControl&&!!A){this._oImageControl.setSrc(A);}};
h.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon();if(!!this._oImageControl){this._oImageControl.setSrc(s);}};
h.prototype.setNumber=function(n){this.setProperty('number',n,true);this.getAggregation("_objectNumber").setNumber(n);return this;};
h.prototype.setNumberUnit=function(n){this.setProperty('numberUnit',n,true);this.getAggregation('_objectNumber').setUnit(n);return this;};
h.prototype.setNumberTextDirection=function(t){this.setProperty('numberTextDirection',t,true);this.getAggregation("_objectNumber").setTextDirection(t);return this;};
h.prototype.setNumberState=function(v){this.setProperty('numberState',v,true);this.getAggregation("_objectNumber").setState(v);return this;};
h.prototype.setMarkFavorite=function(m){return this._setOldMarkers(d.Favorite,m);};
h.prototype.setMarkFlagged=function(m){return this._setOldMarkers(d.Flagged,m);};
h.prototype.setMarkLocked=function(m){return this._setOldMarkers(d.Locked,m);};
h.prototype.setShowMarkers=function(m){var s;var A=this.getMarkers();this.setProperty("showMarkers",m,false);for(var i=0;i<A.length;i++){s=A[i].getType();if((s===d.Flagged&&this.getMarkFlagged())||(s===d.Favorite&&this.getMarkFavorite())||(s===d.Locked&&this.getMarkLocked())){A[i].setVisible(m);}}return this;};
h.prototype.addMarker=function(o){this._startObservingMarker(o);return C.prototype.addAggregation.call(this,"markers",o);};
h.prototype.insertMarker=function(o,i){this._startObservingMarker(o);return C.prototype.insertAggregation.call(this,"markers",o,i);};
h.prototype.removeMarker=function(o){var i=C.prototype.removeAggregation.call(this,"markers",o);this._stopObservingMarker(i);return i;};
h.prototype.removeAllMarkers=function(){var j=C.prototype.removeAllAggregation.call(this,"markers");for(var i=0;i<j.length;i++){this._stopObservingMarker(j[i]);}return j;};
h.prototype.destroyMarkers=function(){this.getMarkers().forEach(function(m){this._stopObservingMarker(m);},this);return C.prototype.destroyAggregation.call(this,"markers");};
h.prototype._observerObjectMarkerChanges=function(o){if(o.current!==o.old){this.invalidate();}};
h.prototype._startObservingMarker=function(m){var o=new M(this._observerObjectMarkerChanges);this._oMarkersObservers[m.getId()]=o;o.observe(m,{properties:true});return this;};
h.prototype._stopObservingMarker=function(m){var s=m.getId();this._oMarkersObservers[s].disconnect();delete this._oMarkersObservers[s];return this;};
h.prototype._setOldMarkers=function(m,j){var A=this.getMarkers();var H=false;var o={Flagged:"-flag",Favorite:"-favorite",Locked:"-lock"};this.setProperty("mark"+m,j,false);if(!this.getShowMarkers()){j=false;}for(var i=0;i<A.length;i++){if(A[i].getType()===m){H=true;A[i].setVisible(j);break;}}if(!H){this.insertAggregation("markers",new a({id:this.getId()+o[m],type:m,visible:j}));}return this;};
h.prototype._getTitleText=function(){if(!this._oTitleText){this._oTitleText=new T(this.getId()+"-titleText",{maxLines:2});this._oTitleText.setParent(this,null,true);}return this._oTitleText;};
return h;});
sap.ui.predefine('sap/m/ObjectListItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device'],function(L,R,c,D){"use strict";var T=c.TextDirection;var O=R.extend(L);O.apiVersion=2;
O.renderAttributeStatus=function(r,l,a,s){if(!a&&!s||(a&&a._isEmpty()&&s&&s._isEmpty())){return;}r.openStart("div");r.class("sapMObjLAttrRow");r.openEnd();if(a&&!a._isEmpty()){r.openStart("div");r.class("sapMObjLAttrDiv");if(s&&(!s._isEmpty())){if(s instanceof Array){r.class("sapMObjAttrWithMarker");}}if(!s||s._isEmpty()){r.style("width","100%");}r.openEnd();r.renderControl(a);r.close("div");}if(s&&!s._isEmpty()){r.openStart("div");r.class("sapMObjLStatusDiv");if(s instanceof Array&&s.length>0){r.class("sapMObjStatusMarker");}if(!a||a._isEmpty()){r.style("width","100%");}r.openEnd();if(s instanceof Array){while(s.length>0){r.renderControl(s.shift());}}else{r.renderControl(s);}r.close("div");}r.close("div");};
O.renderLIAttributes=function(r,l){r.class("sapMObjLItem");r.class("sapMObjLListModeDiv");};
O.renderLIContent=function(r,l){var o=l.getAggregation("_objectNumber"),t=l.getTitleTextDirection(),i=l.getIntroTextDirection();if(l.getIntro()){r.openStart("div",l.getId()+"-intro");r.class("sapMObjLIntro");r.openEnd();r.openStart("span");if(i!==T.Inherit){r.attr("dir",i.toLowerCase());}r.openEnd();r.text(l.getIntro());r.close("span");r.close("div");}r.openStart("div");r.class("sapMObjLTopRow");r.openEnd();if(!!l.getIcon()){r.openStart("div");r.class("sapMObjLIconDiv");r.openEnd();r.renderControl(l._getImageControl());r.close("div");}r.openStart("div");r.class("sapMObjLNumberDiv");r.openEnd();if(o&&o.getNumber()){o.setTextDirection(l.getNumberTextDirection());r.renderControl(o);}r.close("div");r.openStart("div");r.style("display","-webkit-box");r.style("overflow","hidden");r.openEnd();var a=l._getTitleText();if(a){a.setTextDirection(t);a.setText(l.getTitle());a.addStyleClass("sapMObjLTitle");r.renderControl(a);}r.close("div");r.close("div");r.openStart("div");r.style("clear","both;");r.openEnd();r.close("div");if(l._hasBottomContent()){r.openStart("div");r.class("sapMObjLBottomRow");r.openEnd();var A=l._getVisibleAttributes();var s=[];var m=l._getVisibleMarkers();m._isEmpty=function(){return!(m.length);};if(!m._isEmpty()){s.push(m);}s.push(l.getFirstStatus());s.push(l.getSecondStatus());while(A.length>0){this.renderAttributeStatus(r,l,A.shift(),s.shift());}while(s.length>0){this.renderAttributeStatus(r,l,null,s.shift());}r.close("div");}};
O.getAriaLabelledBy=function(l){var a=[],f=l.getFirstStatus(),s=l.getSecondStatus();if(l.getIntro()){a.push(l.getId()+"-intro");}if(l.getTitle()){a.push(l.getId()+"-titleText");}if(l.getNumber()){a.push(l.getId()+"-ObjectNumber");}if(l.getAttributes()){l.getAttributes().forEach(function(b){if(!b._isEmpty()){a.push(b.getId());}});}if(f&&!f._isEmpty()){a.push(f.getId());}if(s&&!s._isEmpty()){a.push(s.getId());}if(l.getMarkers()){l.getMarkers().forEach(function(m){a.push(m.getId()+"-text");});}return a.join(" ");};
return O;},true);
sap.ui.predefine('sap/m/ObjectMarker',["sap/ui/core/Control","sap/ui/core/Renderer","sap/ui/Device","sap/m/library","sap/ui/core/library","sap/ui/core/Icon","sap/m/TextRenderer","sap/m/Text","sap/m/LinkRenderer","sap/m/Link","./ObjectMarkerRenderer"],function(C,R,D,l,c,I,T,a,L,b,O){"use strict";var d=c.TextAlign;var e=l.ObjectMarkerVisibility;
var f=C.extend("sap.m.ObjectMarker",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectMarker.designtime",properties:{type:{type:"sap.m.ObjectMarkerType",group:"Misc"},visibility:{type:"sap.m.ObjectMarkerVisibility",group:"Misc"},additionalInfo:{type:"string",group:"Misc",defaultValue:""}},aggregations:{_innerControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{type:{type:"sap.m.ObjectMarkerType"}}},dnd:{draggable:true,droppable:false}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");f.M_PREDEFINED_TYPES={Flagged:{icon:{src:"sap-icon://flag",visibility:{small:true,large:true}},text:{value:r.getText("OM_FLAG"),visibility:{small:false,large:false}}},Favorite:{icon:{src:"sap-icon://favorite",visibility:{small:true,large:true}},text:{value:r.getText("OM_FAVORITE"),visibility:{small:false,large:false}}},Draft:{icon:{src:"sap-icon://request",visibility:{small:false,large:false}},text:{value:r.getText("OM_DRAFT"),visibility:{small:true,large:true}}},Locked:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:r.getText("OM_LOCKED"),visibility:{small:false,large:true}}},Unsaved:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:r.getText("OM_UNSAVED"),visibility:{small:false,large:true}}},LockedBy:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:r.getText("OM_LOCKED_BY"),visibility:{small:false,large:true}}},UnsavedBy:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:r.getText("OM_UNSAVED_BY"),visibility:{small:false,large:true}}}};
f.prototype.init=function(){D.media.initRangeSet("DeviceSet",[600],"px",["small","large"]);};
f.prototype.onAfterRendering=function(){this._attachMediaContainerWidthChange(this._handleMediaChange,this,"DeviceSet");};
f.prototype.onBeforeRendering=function(){this._cleanup();this._adjustControl(true);};
f.prototype.exit=function(){this._cleanup();};
f.prototype.attachPress=function(){var o=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")&&o&&o instanceof h){o.destroy();this.setAggregation("_innerControl",this._createCustomLink(),true);this._adjustControl();}return this;};
f.prototype.detachPress=function(){var o=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")&&o&&o instanceof j){o.destroy();this.setAggregation("_innerControl",this._createCustomText(),true);this._adjustControl();}return this;};
f.prototype._cleanup=function(){this._detachMediaContainerWidthChange(this._handleMediaChange,this,"DeviceSet");};
f.prototype._handleMediaChange=function(){this._adjustControl();};
f.prototype._adjustControl=function(s){var t=f.M_PREDEFINED_TYPES[this.getType()],o=this._getInnerControl(),A=this.getAdditionalInfo(),k=this.getType(),m;if(!o){return false;}if(t){m=this._getMarkerText(t,k,A);}if(this._isIconVisible()){o.setIcon(t.icon.src,s);this.addStyleClass("sapMObjectMarkerIcon");}else{o.setIcon(null,s);this.removeStyleClass("sapMObjectMarkerIcon");}if(this._isTextVisible()){o.setAggregation("tooltip",null,s);o.setText(m,s);this.addStyleClass("sapMObjectMarkerText");}else{if(o.getIcon()){o.setAggregation("tooltip",m,s);}o.setText(null,s);this.removeStyleClass("sapMObjectMarkerText");}return true;};
f.prototype._getMarkerText=function(t,s,A){switch(s){case"LockedBy":return(A==="")?r.getText('OM_LOCKED_BY_ANOTHER_USER'):r.getText('OM_LOCKED_BY',[A]);case"UnsavedBy":return(A==="")?r.getText('OM_UNSAVED_BY_ANOTHER_USER'):r.getText('OM_UNSAVED_BY',[A]);default:return(A==="")?t.text.value:t.text.value+" "+A;}};
f.prototype._isIconVisible=function(){var t=f.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),s=this._getDeviceType(),k=t&&t.icon.visibility[s]||false;return v===e.IconOnly||v===e.IconAndText||(v!==e.TextOnly&&k);};
f.prototype._isTextVisible=function(){var t=f.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),s=this._getDeviceType(),k=t&&t.text.visibility[s]||false;return v===e.TextOnly||v===e.IconAndText||(v!==e.IconOnly&&k);};
f.prototype._getDeviceType=function(){return this._getCurrentMediaContainerRange("DeviceSet").name.toLowerCase();};
f.prototype._getInnerControl=function(){var o=this.getAggregation("_innerControl");if(!o&&this.getType()){o=this._createInnerControl();this.setAggregation("_innerControl",o,true);this._adjustControl(true);}return o;};
f.prototype._createInnerControl=function(){if(this.hasListeners("press")){return this._createCustomLink();}else{return this._createCustomText();}};
f.prototype._createCustomLink=function(){var o=new j(this.getId()+"-link",{wrapping:true});o.attachPress(function(E){this.firePress({type:this.getType()});},this);return o;};
f.prototype._createCustomText=function(){return new h(this.getId()+"-text",{textAlign:d.Initial});};
["getAriaLabelledBy","addAriaLabelledBy","removeAriaLabelledBy","removeAllAriaLabelledBy","getAriaDescribedBy","addAriaDescribedBy","removeAriaDescribedBy","removeAllAriaDescribedBy","getAccessibilityInfo"].map(function(F){var k=/^add/.test(F);f.prototype[F]=function(){var o=this._getInnerControl(),m;if(o&&o[F]){m=o[F].apply(o,arguments);}return k?this:m;};});var g=R.extend(T);
g.renderText=function(o,k){o.renderControl(k._getIconAggregation());T.renderText(o,k);};
var h=a.extend("sap.m.internal.ObjectMarkerCustomText",{
metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:g
});
h.prototype.setIcon=function(s,S){var o=this._getIconAggregation();this.setProperty("icon",s,S);o.setSrc(s);return this;};
h.prototype._getIconAggregation=function(){var o=this.getAggregation("_iconControl");if(!o){o=new I();this.setAggregation("_iconControl",o,true);}return o;};
h.prototype.setText=function(t,s){this.setProperty("text",t,s);return this;};
var i=R.extend(L);
i.renderText=function(o,k){o.renderControl(k._getIconAggregation());L.renderText(o,k);};
var j=b.extend("sap.m.internal.ObjectMarkerCustomLink",{
metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:i
});
j.prototype.setIcon=function(s,S){var o=this._getIconAggregation();this.setProperty("icon",s,S);o.setSrc(s);return this;};
j.prototype._getTabindex=function(){return"0";};
j.prototype._getIconAggregation=function(){var o=this.getAggregation("_iconControl");if(!o){o=new I();this.setAggregation("_iconControl",o,true);}return o;};
j.prototype.setText=function(t,s){this.setProperty("text",t,s);return this;};
return f;});
sap.ui.predefine('sap/m/ObjectMarkerRenderer',[],function(){"use strict";var O={};
O.render=function(r,c){r.write("<span ");r.writeControlData(c);r.addClass("sapMObjectMarker");r.writeClasses();r.write(">");r.renderControl(c._getInnerControl());r.write("</span>");};
return O;},true);
sap.ui.predefine('sap/m/ObjectNumber',['./library','sap/ui/core/Control','sap/ui/core/Renderer','sap/ui/core/library','./ObjectNumberRenderer'],function(l,C,R,c,O){"use strict";var T=c.TextAlign;var a=c.TextDirection;var V=c.ValueState;
var b=C.extend("sap.m.ObjectNumber",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/ObjectNumber.designtime",properties:{number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null,deprecated:true},emphasized:{type:"boolean",group:"Appearance",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},unit:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:a.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},dnd:{draggable:true,droppable:false}}});
b.prototype._getStateText=function(){var s=this.getState(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return r.getText("OBJECTNUMBER_ARIA_VALUE_STATE_"+s.toUpperCase(),[],true);};
return b;});
sap.ui.predefine('sap/m/ObjectNumberRenderer',['sap/ui/core/Renderer','sap/ui/core/library'],function(R,c){"use strict";var V=c.ValueState;var T=c.TextDirection;var _='sapMObjectNumberStatus';var O={apiVersion:2};
O.render=function(r,o){var t=o.getTooltip_AsString(),s=o.getTextDirection(),a=o.getTextAlign();r.openStart("div",o);r.class("sapMObjectNumber");r.class(_+o.getState());if(o.getEmphasized()){r.class("sapMObjectNumberEmph");}if(t){r.attr("title",t);}if(s!==T.Inherit){r.attr("dir",s.toLowerCase());}a=R.getTextAlign(a,s);if(a){r.style("text-align",a);}if(o.getState()!==V.None){r.accessibilityState({describedby:o.getId()+"-state"});}r.openEnd();this.renderText(r,o);r.text("  ");this.renderUnit(r,o);this.renderHiddenARIAElement(r,o);r.close("div");};
O.renderText=function(r,o){r.openStart("span");r.class("sapMObjectNumberText");r.openEnd();r.text(o.getNumber());r.close("span");};
O.renderUnit=function(r,o){var u=o.getUnit()||o.getNumberUnit();if(u!==""){r.openStart("span");r.class("sapMObjectNumberUnit");r.openEnd();r.text(u);r.close("span");}};
O.renderHiddenARIAElement=function(r,o){if(o.getState()==V.None){return;}r.openStart("span",o.getId()+"-state");r.class("sapUiInvisibleText");r.attr("aria-hidden",false);r.openEnd();r.text(o._getStateText());r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectStatus',['./library','sap/ui/core/Control','sap/ui/core/ValueStateSupport','sap/ui/core/IndicationColorSupport','sap/ui/core/library','sap/ui/base/DataType','./ObjectStatusRenderer'],function(l,C,V,I,c,D,O){"use strict";var a=l.ImageHelper;var T=c.TextDirection;var b=c.ValueState;
var d=C.extend("sap.m.ObjectStatus",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/ObjectStatus.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:false},state:{type:"string",group:"Misc",defaultValue:b.None},inverted:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{press:{}},dnd:{draggable:true,droppable:false}}});
d.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
d.prototype._getImageControl=function(){var i=this.getId()+'-icon',e=!this.getText()&&!this.getTitle(),p={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(e){p.decorative=false;p.alt=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS_ICON");}this._oImageControl=a.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
d.prototype.setState=function(v){if(v==null){v=b.None;}else if(!D.getType("sap.ui.core.ValueState").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error('"'+v+'" is not a value of the enums sap.ui.core.ValueState or sap.ui.core.IndicationColor for property "state" of '+this);}return this.setProperty("state",v);};
d.prototype.ontap=function(e){if(this._isClickable(e)){this.firePress();}};
d.prototype.onsapenter=function(e){if(this._isActive()){this.firePress();e.setMarked();}};
d.prototype.onsapspace=function(e){this.onsapenter(e);};
d.prototype._isActive=function(){return this.getActive()&&(this.getText().trim()||this.getIcon().trim());};
d.prototype._isEmpty=function(){return!(this.getText().trim()||this.getIcon().trim()||this.getTitle().trim());};
d.prototype.ontouchstart=function(e){if(this._isClickable(e)){e.setMarked();}};
d.prototype.getAccessibilityInfo=function(){var s=V.getAdditionalText(this.getState());if(this.getState()!=b.None){s=(s!==null)?s:I.getAdditionalText(this.getState());}return{description:((this.getTitle()||"")+" "+(this.getText()||"")+" "+(s!==null?s:"")+" "+(this.getTooltip()||"")).trim()};};
d.prototype._isClickable=function(e){var s=e.target.id;return this._isActive()&&(s===this.getId()+"-link"||s===this.getId()+"-text"||s===this.getId()+"-statusIcon"||s===this.getId()+"-icon");};
return d;});
sap.ui.predefine('sap/m/ObjectStatusRenderer',['sap/ui/core/ValueStateSupport','sap/ui/core/IndicationColorSupport','sap/ui/core/InvisibleText','sap/ui/core/library'],function(V,I,a,c){"use strict";var T=c.TextDirection;var b=c.ValueState;var O={apiVersion:2};
O.render=function(r,o){r.openStart("div",o);if(o._isEmpty()){r.style("display","none");r.openEnd();}else{var s=o.getState();var i=o.getInverted();var t=o.getTextDirection();var C=sap.ui.getCore();var p=C.getConfiguration().getRTL();var A={roledescription:C.getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS")};var v;var d;if(t===T.Inherit){t=p?T.RTL:T.LTR;}var e=o.getTooltip_AsString();if(e){r.attr("title",e);}r.class("sapMObjStatus");r.class("sapMObjStatus"+s);if(i){r.class("sapMObjStatusInverted");}if(o._isActive()){r.class("sapMObjStatusActive");r.attr("tabindex","0");A.role="button";}else{A.role="group";}if(s!==b.None){A.describedby={value:o.getId()+"sapSRH",append:true};}r.accessibilityState(o,A);r.openEnd();if(o.getTitle()){r.openStart("span",o.getId()+"-title");r.class("sapMObjStatusTitle");if(t){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(o.getTitle()+":");r.close("span");}if(o._isActive()){r.openStart("span",o.getId()+"-link");r.class("sapMObjStatusLink");r.openEnd();}if(o.getIcon()){r.openStart("span",o.getId()+"-statusIcon");r.class("sapMObjStatusIcon");if(!o.getText()){r.class("sapMObjStatusIconOnly");}r.openEnd();r.renderControl(o._getImageControl());r.close("span");}if(o.getText()){r.openStart("span",o.getId()+"-text");r.class("sapMObjStatusText");if(t){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(o.getText());r.close("span");}if(o._isActive()){r.close("span");}if(s!=b.None){v=V.getAdditionalText(s);if(v){d=v;}else{d=I.getAdditionalText(s);}if(d){r.openStart("span",o.getId()+"sapSRH");r.class("sapUiPseudoInvisibleText");r.openEnd();r.text(d);r.close("span");}}}r.close("div");};
return O;},true);
sap.ui.predefine('sap/m/OverflowToolbar',["./library","sap/m/ToggleButton","sap/ui/core/InvisibleText","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData","sap/m/OverflowToolbarAssociativePopover","sap/m/OverflowToolbarAssociativePopoverControls",'sap/ui/core/ResizeHandler',"sap/ui/core/IconPool",'sap/ui/core/theming/Parameters','sap/ui/dom/units/Rem',"sap/ui/Device","./OverflowToolbarRenderer","sap/base/Log","sap/ui/dom/jquery/Focusable"],function(l,T,I,a,b,O,c,d,R,e,P,D,f,g,L){"use strict";var h=l.PlacementType;var B=l.ButtonType;var j=l.OverflowToolbarPriority;
var k=a.extend("sap.m.OverflowToolbar",{metadata:{properties:{asyncMode:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{_overflowButton:{type:"sap.m.ToggleButton",multiple:false,visibility:"hidden"},_popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/OverflowToolbar.designtime"}});
k.prototype._callToolbarMethod=function(F,A){return a.prototype[F].apply(this,A);};
k.prototype.init=function(){this._callToolbarMethod("init",arguments);this._iPreviousToolbarWidth=null;this._bOverflowButtonNeeded=false;this._bNestedInAPopover=null;this._bListenForControlPropertyChanges=false;this._bListenForInvalidationEvents=false;this._bControlsInfoCached=false;this._bSkipOptimization=false;this._bHasFlexibleContent=false;this._aControlSizes={};this._iFrameRequest=null;this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aPopoverOnlyControls=[];this._aAllCollections=[this._aMovableControls,this._aToolbarOnlyControls,this._aPopoverOnlyControls];};
k.prototype.exit=function(){var p=this.getAggregation("_popover");if(p){p.destroy();}if(this._iFrameRequest){window.cancelAnimationFrame(this._iFrameRequest);this._iFrameRequest=null;}};
k.prototype.setAsyncMode=function(v){return this.setProperty("asyncMode",v,true);};
k.prototype.onAfterRendering=function(){this._getOverflowButton().$().attr("aria-haspopup","true");if(this._bContentVisibilityChanged){this._bControlsInfoCached=false;this._bContentVisibilityChanged=false;}if(this.getAsyncMode()){this._doLayoutAsync().then(this._applyFocus.bind(this));}else{this._doLayout();this._applyFocus();}};
k.prototype.onsapfocusleave=function(){this._resetChildControlFocusInfo();};
k.prototype._doLayout=function(){var C=sap.ui.getCore(),w;if(!C.isThemeApplied()){L.debug("OverflowToolbar: theme not applied yet, skipping calculations",this);return;}w=this.$().width();this._bListenForControlPropertyChanges=false;this._bListenForInvalidationEvents=false;this._deregisterToolbarResize();if(w>0){if(!this._isControlsInfoCached()){this._cacheControlsInfo();}if(this._iPreviousToolbarWidth!==w){this._iPreviousToolbarWidth=w;this._setControlsOverflowAndShrinking(w);this.fireEvent("_controlWidthChanged");}}this._registerToolbarResize();this._bListenForControlPropertyChanges=true;this._bListenForInvalidationEvents=true;};
k.prototype._doLayoutAsync=function(){return new Promise(function(r,i){this._iFrameRequest=window.requestAnimationFrame(function(){this._doLayout();r();}.bind(this));}.bind(this));};
k.prototype._applyFocus=function(){var F,$,i=this.$().lastFocusableDomRef();if(this.sFocusedChildControlId){F=sap.ui.getCore().byId(this.sFocusedChildControlId);$=F&&F.$();}if($&&$.length){$.focus();}else if(this._bControlWasFocused){this._getOverflowButton().focus();this._bControlWasFocused=false;this._bOverflowButtonWasFocused=true;}else if(this._bOverflowButtonWasFocused&&!this._getOverflowButtonNeeded()){i&&i.focus();this._bOverflowButtonWasFocused=false;}};
k.prototype._preserveChildControlFocusInfo=function(){var A=sap.ui.getCore().getCurrentFocusedControlId();if(this._getControlsIds().indexOf(A)!==-1){this._bControlWasFocused=true;this.sFocusedChildControlId=A;}else if(A===this._getOverflowButton().getId()){this._bOverflowButtonWasFocused=true;this.sFocusedChildControlId="";}};
k.prototype._resetChildControlFocusInfo=function(){this._bControlWasFocused=false;this._bOverflowButtonWasFocused=false;this.sFocusedChildControlId="";};
k.prototype._registerToolbarResize=function(){if(a.isRelativeWidth(this.getWidth())){var r=this._handleResize.bind(this);this._sResizeListenerId=R.register(this,r);}};
k.prototype._deregisterToolbarResize=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId="";}};
k.prototype._handleResize=function(){if(this.getAsyncMode()){this._doLayoutAsync();}else{this._doLayout();}};
k.prototype._cacheControlsInfo=function(){var v,H;this._iOldContentSize=this._iContentSize;this._iContentSize=0;this._bHasFlexibleContent=false;this.getContent().forEach(this._updateControlsCachedSizes,this);if(f.system.phone){this._iContentSize-=1;}if(this._aPopoverOnlyControls.length){v=this._aPopoverOnlyControls.filter(function(C){return C.getVisible();});H=(v.length>0);if(H){this._iContentSize+=this._getOverflowButtonSize();}}this._bControlsInfoCached=true;if(this._iOldContentSize!==this._iContentSize){this.fireEvent("_contentSizeChange",{contentSize:this._iContentSize,invalidate:this._bHasFlexibleContent});}};
k.prototype._updateControlsCachedSizes=function(C){var p,i;p=k._getControlPriority(C);i=this._calculateControlSize(C);this._aControlSizes[C.getId()]=i;if(p!==j.AlwaysOverflow){this._iContentSize+=i;}this._bHasFlexibleContent=this._bHasFlexibleContent||C.isA("sap.m.IOverflowToolbarFlexibleContent");};
k.prototype._calculateControlSize=function(C){return this._getOptimalControlWidth(C,this._aControlSizes[C.getId()]);};
k.prototype._isControlsInfoCached=function(){return this._bControlsInfoCached;};
k.prototype._flushButtonsToPopover=function(){this._aButtonsToMoveToPopover.forEach(this._moveButtonToPopover,this);};
k.prototype._invalidateIfHashChanged=function(H){if(typeof H==="undefined"||this._getPopover()._getContentIdsHash()!==H){this._preserveChildControlFocusInfo();this.invalidate();}};
k.prototype._addOverflowButton=function(){if(!this._getOverflowButtonNeeded()){this._iCurrentContentSize+=this._getOverflowButtonSize();this._setOverflowButtonNeeded(true);}};
k.prototype._aggregateMovableControls=function(){var G={},A=[],C,p,s,i,m;this._aMovableControls.forEach(function(o){C=k._getControlGroup(o);p=k._oPriorityOrder;if(C){s=k._getControlPriority(o);i=this._getControlIndex(o);G[C]=G[C]||[];m=G[C];m.unshift(o);if(!m._priority||p[m._priority]<p[s]){m._priority=s;}if(!m._index||m._index<i){m._index=i;}}else{A.push(o);}},this);Object.keys(G).forEach(function(n){A.push(G[n]);});return A;};
k.prototype._extractControlsToMoveToOverflow=function(A,t){var i,m;for(i=0;i<A.length;i++){m=A[i];if(m.length){m.forEach(this._addToPopoverArrAndUpdateContentSize,this);}else{this._addToPopoverArrAndUpdateContentSize(m);}if(this._iCurrentContentSize<=t){break;}}};
k.prototype._addToPopoverArrAndUpdateContentSize=function(C){this._aButtonsToMoveToPopover.unshift(C);this._iCurrentContentSize-=this._aControlSizes[C.getId()];};
k.prototype._sortByPriorityAndIndex=function(C,v){var p=k._oPriorityOrder,s=k._getControlPriority(C),i=k._getControlPriority(v),m=p[s]-p[i];if(m!==0){return m;}else{return this._getControlIndex(v)-this._getControlIndex(C);}};
k.prototype._setControlsOverflowAndShrinking=function(t){var i;this._iCurrentContentSize=this._iContentSize;this._aButtonsToMoveToPopover=[];if(this._bSkipOptimization){this._bSkipOptimization=false;}else{i=this._getPopover()._getContentIdsHash();}this._resetToolbar();this._collectPopoverOnlyControls();this._markControlsWithShrinkableLayoutData();if(this._iCurrentContentSize<=t){this._flushButtonsToPopover();this._invalidateIfHashChanged(i);return;}this._moveControlsToPopover(t);this._flushButtonsToPopover();if(this._iCurrentContentSize>t){this._checkContents();}this._invalidateIfHashChanged(i);};
k.prototype._markControlsWithShrinkableLayoutData=function(){this.getContent().forEach(this._markControlWithShrinkableLayoutData,this);};
k.prototype._collectPopoverOnlyControls=function(){var p=this._aPopoverOnlyControls.length,i,C;if(p){for(i=p-1;i>=0;i--){C=this._aPopoverOnlyControls[i];if(C.getVisible()){this._aButtonsToMoveToPopover.unshift(C);}}if(this._aButtonsToMoveToPopover.length>0){this._setOverflowButtonNeeded(true);}}};
k.prototype._moveControlsToPopover=function(t){var A=[];if(this._aMovableControls.length){if(this._hasControlsToBeShownInPopover()){this._addOverflowButton();}A=this._aggregateMovableControls();A.sort(this._sortByPriorityAndIndex.bind(this));this._extractControlsToMoveToOverflow(A,t);}};
k.prototype._hasControlsToBeShownInPopover=function(){return this._aMovableControls.some(function(C){return k._getControlPriority(C)!==j.Disappear;});};
k.prototype._markControlWithShrinkableLayoutData=function(C){var w,o;C.removeStyleClass(a.shrinkClass);w=a.getOrigWidth(C.getId());if(!a.isRelativeWidth(w)){return;}o=C.getLayoutData();if(o&&o.isA("sap.m.ToolbarLayoutData")&&o.getShrinkable()){C.addStyleClass(a.shrinkClass);}};
k.prototype._resetToolbar=function(){this._getPopover().close();this._getPopover()._getAllContent().forEach(this._restoreButtonInToolbar,this);this._setOverflowButtonNeeded(false);this.getContent().forEach(this._removeShrinkingClass);};
k.prototype._removeShrinkingClass=function(C){C.removeStyleClass(a.shrinkClass);};
k.prototype._moveButtonToPopover=function(o){this._getPopover().addAssociatedContent(o);};
k.prototype._restoreButtonInToolbar=function(v){if(typeof v==="object"){v=v.getId();}this._getPopover().removeAssociatedContent(v);};
k.prototype._resetAndInvalidateToolbar=function(H){if(this._bIsBeingDestroyed){return;}this._resetToolbar();this._bControlsInfoCached=false;this._bNestedInAPopover=null;this._iPreviousToolbarWidth=null;if(H){this._bSkipOptimization=true;}if(this.$().length){this._preserveChildControlFocusInfo();this.invalidate();}};
k.prototype._getVisibleContent=function(){var t=this.getContent(),p=this._getPopover()._getAllContent();return t.filter(function(C){return p.indexOf(C)===-1;});};
k.prototype._getVisibleAndNonOverflowContent=function(){return this._getVisibleContent().filter(function(C){return C.getVisible();});};
k.prototype._getOverflowButton=function(){var o;if(!this.getAggregation("_overflowButton")){o=new T({id:this.getId()+"-overflowButton",icon:e.getIconURI("overflow"),press:this._overflowButtonPressed.bind(this),ariaLabelledBy:I.getStaticId("sap.ui.core","Icon.overflow"),type:B.Transparent});this.setAggregation("_overflowButton",o,true);}return this.getAggregation("_overflowButton");};
k.prototype._overflowButtonPressed=function(E){var p=this._getPopover(),s=this._getBestPopoverPlacement();if(p.getPlacement()!==s){p.setPlacement(s);}if(p.isOpen()){p.close();}else{p.openBy(E.getSource());}};
k.prototype._getPopover=function(){var p;if(!this.getAggregation("_popover")){p=new c(this.getId()+"-popover",{showHeader:false,showArrow:false,modal:false,horizontalScrolling:f.system.phone?false:true,contentWidth:f.system.phone?"100%":"auto",offsetY:this._detireminePopoverVerticalOffset(),ariaLabelledBy:I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES")});p._adaptPositionParams=function(){c.prototype._adaptPositionParams.call(this);this._myPositions=["end top","begin center","end bottom","end center"];this._atPositions=["end bottom","end center","end top","begin center"];};if(f.system.phone){p.attachBeforeOpen(this._shiftPopupShadow,this);}p.attachAfterClose(this._popOverClosedHandler,this);this.setAggregation("_popover",p,true);}return this.getAggregation("_popover");};
k.prototype._shiftPopupShadow=function(){var p=this._getPopover(),s=p.getCurrentPosition();if(s===h.Bottom){p.addStyleClass("sapMOTAPopoverNoShadowTop");p.removeStyleClass("sapMOTAPopoverNoShadowBottom");}else if(s===h.Top){p.addStyleClass("sapMOTAPopoverNoShadowBottom");p.removeStyleClass("sapMOTAPopoverNoShadowTop");}};
k.prototype._popOverClosedHandler=function(){var w=f.os.windows_phone||f.browser.edge&&f.browser.mobile;this._getOverflowButton().setPressed(false);this._getOverflowButton().$().focus();if(this._isNestedInsideAPopup()||w){return;}this._getOverflowButton().setEnabled(false);setTimeout(function(){this._getOverflowButton().setEnabled(true);setTimeout(function(){this._getOverflowButton().$().focus();}.bind(this),0);}.bind(this),0);};
k.prototype._isNestedInsideAPopup=function(){var s;if(this._bNestedInAPopover!==null){return this._bNestedInAPopover;}s=function(C){if(!C){return false;}if(C.getMetadata().isInstanceOf("sap.ui.core.PopupInterface")){return true;}return s(C.getParent());};this._bNestedInAPopover=s(this);return this._bNestedInAPopover;};
k.prototype._getOverflowButtonNeeded=function(){return this._bOverflowButtonNeeded;};
k.prototype._setOverflowButtonNeeded=function(v){if(this._bOverflowButtonNeeded!==v){this._bOverflowButtonNeeded=v;}return this;};
k.prototype._updateContentInfoInControlsCollections=function(){this.getContent().forEach(function(C){if(C){this._removeContentFromControlsCollections(C);this._moveControlInSuitableCollection(C,k._getControlPriority(C));}}.bind(this));};
k.prototype._moveControlInSuitableCollection=function(C,p){var i=p!==j.NeverOverflow,A=p===j.AlwaysOverflow;if(d.supportsControl(C)&&A){this._aPopoverOnlyControls.push(C);}else{if(d.supportsControl(C)&&i&&C.getVisible()){this._aMovableControls.push(C);}else{this._aToolbarOnlyControls.push(C);}}};
k.prototype._removeContentFromControlsCollections=function(C){var i,m,n;for(i=0;i<this._aAllCollections.length;i++){m=this._aAllCollections[i];n=m.indexOf(C);if(n!==-1){m.splice(n,1);}}};
k.prototype._clearAllControlsCollections=function(){this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aPopoverOnlyControls=[];this._aAllCollections=[this._aMovableControls,this._aToolbarOnlyControls,this._aPopoverOnlyControls];};
k.prototype.onLayoutDataChange=function(E){this._resetAndInvalidateToolbar(true);E&&this._updateContentInfoInControlsCollections();};
k.prototype.addContent=function(C){this._registerControlListener(C);this._resetAndInvalidateToolbar(false);if(C){this._moveControlInSuitableCollection(C,k._getControlPriority(C));}return this._callToolbarMethod("addContent",arguments);};
k.prototype.insertContent=function(C,i){this._registerControlListener(C);this._resetAndInvalidateToolbar(false);if(C){this._moveControlInSuitableCollection(C,k._getControlPriority(C));}return this._callToolbarMethod("insertContent",arguments);};
k.prototype.removeContent=function(){var C=this._callToolbarMethod("removeContent",arguments);if(C){this._getPopover().removeAssociatedContent(C.getId());}this._resetAndInvalidateToolbar(false);this._deregisterControlListener(C);this._removeContentFromControlsCollections(C);return C;};
k.prototype.removeAllContent=function(){var C=this._callToolbarMethod("removeAllContent",arguments);C.forEach(this._deregisterControlListener,this);C.forEach(this._removeContentFromControlsCollections,this);this._resetAndInvalidateToolbar(false);this._clearAllControlsCollections();return C;};
k.prototype.destroyContent=function(){this._resetAndInvalidateToolbar(false);setTimeout(function(){this._resetAndInvalidateToolbar(false);}.bind(this),0);this._clearAllControlsCollections();return this._callToolbarMethod("destroyContent",arguments);};
k.prototype._registerControlListener=function(C){var i;if(C){C.attachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);if(C.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1){i=C.getOverflowToolbarConfig().invalidationEvents;if(i&&Array.isArray(i)){i.forEach(function(E){C.attachEvent(E,this._onInvalidationEventFired,this);},this);}}}};
k.prototype._deregisterControlListener=function(C){var i;if(C){C.detachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);if(C.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1){i=C.getOverflowToolbarConfig().invalidationEvents;if(i&&Array.isArray(i)){i.forEach(function(E){C.detachEvent(E,this._onInvalidationEventFired,this);},this);}}}};
k.prototype._onContentPropertyChangedOverflowToolbar=function(E){var s=E.getSource(),C,p;this._updateContentInfoInControlsCollections();if(!this._bListenForControlPropertyChanges){return;}C=d.getControlConfig(s);p=E.getParameter("name");if(p!=='visible'&&!s.getVisible()){return;}if(typeof C!=="undefined"&&C.noInvalidationProps.indexOf(p)!==-1){return;}if(p==="visible"){this._bContentVisibilityChanged=true;}this._resetAndInvalidateToolbar(true);};
k.prototype._onInvalidationEventFired=function(){if(!this._bListenForInvalidationEvents){return;}this._resetAndInvalidateToolbar(true);};
k.prototype._getOverflowButtonSize=function(){var i=parseInt(l.BaseFontSize),C=this.$().parents().hasClass('sapUiSizeCompact')?2.5:3,m=D.toPx(P.get("_sap_m_Toolbar_MarginRight")),n=m===0?0.25*i:0;return parseInt(i*C)-n;};
k.prototype._getBestPopoverPlacement=function(){var H=this.getHTMLTag();if(H==="Footer"){return h.Top;}else if(H==="Header"){return h.Bottom;}return h.Vertical;};
k.prototype._getControlsIds=function(){return this.getContent().map(function(i){return i.getId();});};
k.prototype._getControlIndex=function(C){return C.length?C._index:this.indexOfContent(C);};
k.prototype._getOptimalControlWidth=function(C,o){var i,m=C.getLayoutData(),s=m&&m.isA("sap.m.ToolbarLayoutData")?m.getShrinkable():false,M=s?this._getMinWidthOfShrinkableControl(C):0,v=C.getVisible(),S;if(C.isA("sap.m.ToolbarSpacer")){S=parseInt(C.$().css('width'));M=(C.getWidth()&&S)?S:0;i=M+(C.$().outerWidth(true)-C.$().outerWidth());}else if(s&&M>0&&v){i=M+C.$().outerWidth(true)-C.$().outerWidth();}else{i=v?C.$().outerWidth(true):0;}if(i===null){i=typeof o!=="undefined"?o:0;}return i;};
k.prototype._getMinWidthOfShrinkableControl=function(C){var m=C.$().css("min-width"),M=parseInt(m),r=a.isRelativeWidth(m);if(r){return(M*this.$().width())/100;}else{return M;}};
k._getControlPriority=function(C){var i,o,p,G;if(C.length){return C._priority;}i=C.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1;G=i&&C.getOverflowToolbarConfig().getCustomImportance;if(i&&typeof G==="function"){return G();}o=C.getLayoutData&&C.getLayoutData();if(o&&o instanceof O){if(o.getMoveToOverflow()===false){return j.NeverOverflow;}if(o.getStayInOverflow()===true){return j.AlwaysOverflow;}p=o.getPriority();if(p===j.Never){return j.NeverOverflow;}if(p===j.Always){return j.AlwaysOverflow;}return p;}return j.High;};
k._getControlGroup=function(C){var o=C.getLayoutData();if(o instanceof O){return o.getGroup();}};
k._oPriorityOrder=(function(){var p={};p[j.Disappear]=1;p[j.Low]=2;p["Medium"]=3;p[j.High]=4;return p;})();
k.prototype._detireminePopoverVerticalOffset=function(){return this.$().parents().hasClass('sapUiSizeCompact')?2:3;};
k.prototype.onThemeChanged=function(){this._resetAndInvalidateToolbar();for(var C in this._aControlSizes){if(this._aControlSizes.hasOwnProperty(C)){this._aControlSizes[C]=0;}}};
k.prototype.closeOverflow=function(){this._getPopover().close();};
return k;});
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopover',['./Popover','./PopoverRenderer','./OverflowToolbarAssociativePopoverControls','./OverflowToolbarLayoutData','sap/m/library'],function(P,a,O,b,l){"use strict";var c=l.PlacementType;var d=l.OverflowToolbarPriority;
var e=P.extend("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopover",{
metadata:{associations:{associatedContent:{type:"sap.ui.core.Control",multiple:true}}},
renderer:a.render
});
e.prototype.init=function(){P.prototype.init.apply(this,arguments);this.oControlsManager=new O();};
e.prototype.onBeforeRendering=function(){P.prototype.onBeforeRendering.apply(this,arguments);this.addStyleClass("sapMOTAPopover");this.addStyleClass("sapMOverflowToolbarMenu-CTX");var h=this._getAllContent().some(function(o){return o.hasStyleClass("sapMOTAPButtonWithIcon");});if(h){this.addStyleClass("sapMOTAPButtonsWithIcons");}else{this.removeStyleClass("sapMOTAPButtonsWithIcons");}};
e.prototype.addAssociatedContent=function(o){this.addAssociation("associatedContent",o,true);this._preProcessControl(o);return this;};
e.prototype.removeAssociatedContent=function(o){var r=this.removeAssociation("associatedContent",o,true),f;if(r){f=sap.ui.getCore().byId(r);if(f){this._postProcessControl(f);}}return r;};
e.prototype._preProcessControl=function(o){var f=O.getControlConfig(o),A;f.listenForEvents.forEach(function(E){A="attach"+C(E);if(o[A]){o[A](this._closeOnInteraction.bind(this,o));}else{o.attachEvent(E,this._closeOnInteraction.bind(this,o));}},this);if(typeof f.preProcess==="function"){f.preProcess.call(this.oControlsManager,o);}var L=o.getLayoutData();if(L instanceof b&&L.getPriority()===d.Disappear){o.addStyleClass("sapMOTAPHidden");}return this;};
e.prototype._postProcessControl=function(o){var f=O.getControlConfig(o),D;f.listenForEvents.forEach(function(E){D="detach"+C(E);if(o[D]){o[D](this._closeOnInteraction,this);}else{o.detachEvent(E,this._closeOnInteraction,this);}},this);if(typeof f.postProcess==="function"){f.postProcess.call(this.oControlsManager,o);}o.removeStyleClass("sapMOTAPHidden");o.$().remove();return this;};
e.prototype._closeOnInteraction=function(o){var L=o.getLayoutData();if(!L||!(L instanceof b)||L.getCloseOverflowOnInteraction()){this.close();}};
e.prototype._getContentIdsHash=function(){return this._getAllContent().join(".");};
e.prototype._recalculateMargins=function(s,p){if(s!==c.Top){return P.prototype._recalculateMargins.apply(this,arguments);}p._fMarginBottom=p._fDocumentHeight-p._$parent.offset().top+this._arrowOffset+p._fOffsetY;};
e.prototype._getAllContent=function(){var A=this.getAssociatedContent().map(function(i){return sap.ui.getCore().byId(i);});if(this.getPlacement()===c.Top){A.reverse();}return this.getContent().concat(A);};
e.prototype.getCurrentPosition=function(){if(!this._oCalcedPos){this._calcPlacement();}return this._oCalcedPos;};
function C(n){return n.substring(0,1).toUpperCase()+n.substring(1);}
return e;});
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopoverControls',['sap/ui/base/Metadata','./OverflowToolbarButton','./OverflowToolbarToggleButton','./ToggleButton','./Button','sap/m/library',"sap/base/Log"],function(M,O,a,T,B,l,L){"use strict";var b=l.ButtonType;var c=M.createClass("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopoverControls",{constructor:function(){this._mControlsCache={};}});
c.prototype._preProcessSapMButton=function(o){var d=o.getType();this._mControlsCache[o.getId()]={buttonType:d};if(d===b.Default){o.setProperty("type",b.Transparent,true);}if(o.getIcon()){o.addStyleClass("sapMOTAPButtonWithIcon");}else{o.addStyleClass("sapMOTAPButtonNoIcon");}o.attachEvent("_change",this._onSapMButtonUpdated,this);};
c.prototype._postProcessSapMButton=function(o){var p=this._mControlsCache[o.getId()];if(o.getType()!==p.buttonType){o.setProperty("type",p.buttonType,true);}o.removeStyleClass("sapMOTAPButtonNoIcon");o.removeStyleClass("sapMOTAPButtonWithIcon");o.detachEvent("_change",this._onSapMButtonUpdated,this);};
c.prototype._onSapMButtonUpdated=function(e){var p=e.getParameter("name"),o=e.getSource(),s=o.getId();if(typeof this._mControlsCache[s]==="undefined"){return;}if(p==="type"){this._mControlsCache[s]["buttonType"]=o.getType();}};
c.prototype._preProcessSapMOverflowToolbarButton=function(o){this._preProcessSapMButton(o);o._bInOverflow=true;};
c.prototype._postProcessSapMOverflowToolbarButton=function(o){delete o._bInOverflow;this._postProcessSapMButton(o);};
c.prototype._preProcessSapMToggleButton=function(o){this._preProcessSapMButton(o);};
c.prototype._postProcessSapMToggleButton=function(o){this._postProcessSapMButton(o);};
c.prototype._preProcessSapMOverflowToolbarToggleButton=function(o){this._preProcessSapMToggleButton(o);o._bInOverflow=true;};
c.prototype._postProcessSapMOverflowToolbarToggleButton=function(o){delete o._bInOverflow;this._postProcessSapMToggleButton(o);};
c._mSupportedControls={"sap.m.Button":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.MenuButton":{canOverflow:true,listenForEvents:["defaultAction","_menuItemSelected"],noInvalidationProps:["enabled","text","icon"]},"sap.m.OverflowToolbarButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.OverflowToolbarToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type","pressed"]},"sap.m.CheckBox":{canOverflow:true,listenForEvents:["select"],noInvalidationProps:["enabled","selected"]},"sap.m.ToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","pressed"]},"sap.m.ComboBox":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value","selectedItemId","selectedKey"]},"sap.m.SearchField":{canOverflow:true,listenForEvents:["search"],noInvalidationProps:["enabled","value","selectOnFocus"]},"sap.m.Input":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.DateTimeInput":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue"]},"sap.m.DatePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.DateTimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.TimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat"]},"sap.m.RadioButton":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","selected"]},"sap.m.Slider":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.IconTabHeader":{canOverflow:false,listenForEvents:[],noInvalidationProps:["selectedKey"]},"sap.ui.comp.smartfield.SmartField":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","valueState","showValueHelp","contextEditable","clientSideMandatoryCheck","mandatory","name","placeholder","showSuggestion","tooltipLabel"]},"sap.ui.comp.smartfield.SmartLabel":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled"]}};
c.getControlConfig=function(o){var d;if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")!==-1){if(typeof o.getOverflowToolbarConfig!=="function"){L.error("Required method getOverflowToolbarConfig not implemented by: "+o.getMetadata().getName());return;}d=o.getOverflowToolbarConfig();if(typeof d!=="object"){L.error("Method getOverflowToolbarConfig implemented, but does not return an object in: "+o.getMetadata().getName());return;}return{canOverflow:!!d.canOverflow,listenForEvents:Array.isArray(d.autoCloseEvents)?d.autoCloseEvents:[],noInvalidationProps:Array.isArray(d.propsUnrelatedToSize)?d.propsUnrelatedToSize:[],preProcess:d.onBeforeEnterOverflow,postProcess:d.onAfterExitOverflow};}var s=c.getControlClass(o);d=c._mSupportedControls[s];if(d===undefined){return;}var p="_preProcess"+s.split(".").map(C).join("");if(typeof c.prototype[p]==="function"){d.preProcess=c.prototype[p];}var P="_postProcess"+s.split(".").map(C).join("");if(typeof c.prototype[P]==="function"){d.postProcess=c.prototype[P];}return d;};
c.supportsControl=function(o){var d=c.getControlConfig(o);return typeof d!=="undefined"&&d.canOverflow;};
c.getControlClass=function(o){if(o instanceof O){return"sap.m.OverflowToolbarButton";}else if(o instanceof a){return"sap.m.OverflowToolbarToggleButton";}else if(o instanceof T){return"sap.m.ToggleButton";}else if(o instanceof B){return"sap.m.Button";}return o.getMetadata().getName();};
function C(n){return n.substring(0,1).toUpperCase()+n.substr(1);}
return c;},false);
sap.ui.predefine('sap/m/OverflowToolbarButton',['sap/m/Button','sap/m/ButtonRenderer'],function(B,a){"use strict";
var O=B.extend("sap.m.OverflowToolbarButton",{
interfaces:["sap.f.IShellBar"],
renderer:a.render
});
O.prototype._getText=function(){if(this._bInOverflow){return B.prototype._getText.call(this);}return"";};
return O;});
sap.ui.predefine('sap/m/OverflowToolbarLayoutData',['sap/m/ToolbarLayoutData','sap/m/library',"sap/base/Log"],function(T,l,L){"use strict";var O=l.OverflowToolbarPriority;
var a=T.extend("sap.m.OverflowToolbarLayoutData",{metadata:{properties:{moveToOverflow:{type:"boolean",defaultValue:true,deprecated:true},stayInOverflow:{type:"boolean",defaultValue:false,deprecated:true},priority:{type:"sap.m.OverflowToolbarPriority",group:"Behavior",defaultValue:O.High},group:{type:"int",group:"Behavior",defaultValue:0},closeOverflowOnInteraction:{type:"boolean",group:"Behavior",defaultValue:true}}}});
a.prototype.invalidate=function(){var c=this.getPriority(),i=c===O.AlwaysOverflow||c===O.NeverOverflow;if(this.getGroup()&&i){L.error("It is not allowed to set AlwaysOverflow or NeverOverflow to a group items.");}return T.prototype.invalidate.call(this);};
return a;});
sap.ui.predefine('sap/m/OverflowToolbarRenderer',['sap/ui/core/Renderer','./ToolbarRenderer',"sap/m/BarInPageEnabler"],function(R,T,B){"use strict";var O=R.extend(T);
O.renderBarContent=function(r,t){t._getVisibleContent().forEach(function(c){B.addChildClassTo(c,t);r.renderControl(c);});if(t._getOverflowButtonNeeded()){O.renderOverflowButton(r,t);}};
O.renderOverflowButton=function(r,t){var o=t._getOverflowButton();B.addChildClassTo(o,t);r.renderControl(o);};
return O;},true);
sap.ui.predefine('sap/m/OverflowToolbarToggleButton',['sap/m/ToggleButton','sap/m/ToggleButtonRenderer'],function(T,a){"use strict";
var O=T.extend("sap.m.OverflowToolbarToggleButton",{renderer:a.render});
O.prototype._getText=function(){return this._bInOverflow?T.prototype._getText.call(this):"";};
return O;});
sap.ui.predefine('sap/m/PDFViewer',["./library","sap/ui/core/Control","sap/ui/Device","sap/m/PDFViewerRenderManager","sap/m/MessageBox","sap/m/PDFViewerRenderer","sap/base/Log","sap/base/assert","sap/base/security/URLWhitelist","sap/ui/thirdparty/jquery"],function(l,C,D,P,M,a,L,b,U,q){"use strict";var c=l.PDFViewerDisplayType;
var d=C.extend("sap.m.PDFViewer",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},source:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},errorMessage:{type:"string",group:"Misc",defaultValue:null,deprecated:true},errorPlaceholderMessage:{type:"string",group:"Misc",defaultValue:null},popupHeaderTitle:{type:"string",group:"Misc",defaultValue:null,deprecated:true},title:{type:"string",group:"Misc",defaultValue:null},showDownloadButton:{type:"boolean",group:"Misc",defaultValue:true},displayType:{type:"sap.m.PDFViewerDisplayType",group:"Misc",defaultValue:c.Auto}},aggregations:{errorPlaceholder:{type:"sap.ui.core.Control",multiple:false},popupButtons:{type:"sap.m.Button",multiple:true,singularName:"popupButton"}},events:{loaded:{},error:{},sourceValidationFailed:{}}}});
d.prototype.init=function(){this._objectsRegister={};this._bIsPopupOpen=false;this._initPopupControl();this._initPopupDownloadButtonControl();this._initPlaceholderMessagePageControl();this._initToolbarDownloadButtonControl();this._initOverflowToolbarControl();this._initControlState();};
d.prototype._initControlState=function(){this._bRenderPdfContent=true;this._bOnBeforeUnloadFired=false;};
d.prototype.setWidth=function(w){this.setProperty("width",w,true);var o=this.$();if(o===null){return this;}o.css("width",this._getRenderWidth());return this;};
d.prototype.setHeight=function(h){this.setProperty("height",h,true);var o=this.$();if(o===null){return this;}o.css("height",this._getRenderHeight());return this;};
d.prototype.onBeforeRendering=function(){this._bOnBeforeUnloadFired=false;};
d.prototype.onAfterRendering=function(){var i=function(){var I=this._getIframeDOMElement();var o=q(I.get(0).contentWindow);if(D.browser.internet_explorer){o.on("beforeunload",this._onBeforeUnloadListener.bind(this));o.on("readystatechange",this._onReadyStateChangeListener.bind(this));I.on("load",this._onLoadIEListener.bind(this));}else{I.on("load",this._onLoadListener.bind(this));}I.on("error",this._onErrorListener.bind(this));var p=this.getSource();var f=this.getSource().indexOf("#");if(f>-1){p=p.substr(0,f);}p+="#view=FitH";if(!U.validate(p)){p=encodeURI(p);}if(U.validate(p)){I.attr("src",p);}else{this._fireErrorEvent();}}.bind(this);try{this.setBusy(true);i();}catch(e){this.setBusy(false);}};
d.prototype._fireErrorEvent=function(){this._renderErrorState();this.fireEvent("error",{},true);};
d.prototype._renderErrorState=function(){var o=this._objectsRegister.getToolbarDownloadButtonControl();o.setEnabled(false);var o=this._objectsRegister.getPopupDownloadButtonControl();o.setEnabled(false);this.setBusy(false);this._bRenderPdfContent=false;C.prototype.invalidate.call(this);};
d.prototype._fireLoadedEvent=function(){this._bRenderPdfContent=true;this.setBusy(false);try{this._getIframeDOMElement().removeClass("sapMPDFViewerLoading");}catch(e){q.log.fatal("Iframe not founded in loaded event");q.log.fatal(e);}this.fireEvent("loaded");};
d.prototype._onLoadListener=function(e){try{var t=q(e.target),f=true;var s="application/pdf";try{var E=t[0].contentWindow.document.embeds;f=!!E&&E.length===1;if(f){s=E[0].attributes.getNamedItem("type").value;}}catch(g){if(!D.browser.firefox&&this.fireEvent("sourceValidationFailed",{},true)){this._showMessageBox();return;}}if(f&&a._isSupportedMimeType(s)&&a._isPdfPluginEnabled()){this._fireLoadedEvent();}else{this._fireErrorEvent();}}catch(g){L.fatal(false,"Fatal error during the handling of load event happened.");L.fatal(false,g.message);}};
d.prototype._onErrorListener=function(){this._fireErrorEvent();};
d.prototype._onReadyStateChangeListener=function(e){var I="interactive";var f="complete";switch(e.target.readyState){case I:case f:this._fireLoadedEvent();break;}};
d.prototype._onBeforeUnloadListener=function(){if(this._bOnBeforeUnloadFired){this._fireErrorEvent();return;}this._bOnBeforeUnloadFired=true;};
d.prototype._onLoadIEListener=function(e){try{var s=e.currentTarget.contentWindow.document.mimeType;}catch(f){return;}if(!a._isSupportedMimeType(s)){this._fireErrorEvent();}};
d.prototype.downloadPDF=function(){var w=window.open(this.getSource());w.focus();};
d.prototype._onSourceValidationErrorMessageBoxCloseListener=function(o){if(o===M.Action.CANCEL){this._renderErrorState();}else{this._fireLoadedEvent();}};
d.prototype._onAfterPopupClose=function(e){var p=this._objectsRegister.getPopup();p.removeAllContent();this._bIsPopupOpen=false;};
d.prototype._shouldRenderPdfContent=function(){return a._isPdfPluginEnabled()&&this._bRenderPdfContent&&this._isSourceValidToDisplay();};
d.prototype._isSourceValidToDisplay=function(){var s=this.getSource();return s!==null&&s!==""&&typeof s!=="undefined";};
d.prototype.invalidate=function(o){this._initControlState();C.prototype.invalidate.call(this,o);};
d.prototype.open=function(){if(!this._isSourceValidToDisplay()){b(false,"The PDF file cannot be opened with the given source. Given source: "+this.getSource());return;}else if(!a._isPdfPluginEnabled()){L.warning("The PDF plug-in is not available on this device.");}if(this._isEmbeddedModeAllowed()){this._openOnDesktop();}else{this._openOnMobile();}};
d.prototype._openOnDesktop=function(){var p=this._objectsRegister.getPopup();if(this._bIsPopupOpen){return;}this._initControlState();this._preparePopup(p);p.addContent(this);this._bIsPopupOpen=true;p.open();};
d.prototype._openOnMobile=function(){var w=window.open(this.getSource());w.focus();};
d.prototype._getIframeDOMElement=function(){var i=this.$().find("iframe");if(i.length===0){throw Error("Underlying iframe was not found in DOM.");}if(i.length>1){L.fatal("Initialization of iframe fails. Reason: the control somehow renders multiple iframes");}return i;};
d.prototype._isEmbeddedModeAllowed=function(){return this._isDisplayTypeAuto()?D.system.desktop:this._isDisplayTypeEmbedded();};
d.prototype._isDisplayTypeAuto=function(){return this.getDisplayType()===c.Auto;};
d.prototype._isDisplayTypeEmbedded=function(){return this.getDisplayType()===c.Embedded;};
d.prototype._isDisplayTypeLink=function(){return this.getDisplayType()===c.Link;};
d.prototype._isDisplayDownloadButton=function(){return this.getShowDownloadButton()||this._isDisplayTypeLink()||(this._isDisplayTypeAuto()&&!this._isEmbeddedModeAllowed());};
d.prototype._getLibraryResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
d.prototype._getMessagePageErrorMessage=function(){return this.getErrorPlaceholderMessage()?this.getErrorPlaceholderMessage():this._getLibraryResourceBundle().getText("PDF_VIEWER_PLACEHOLDER_ERROR_TEXT");};
d.prototype._getRenderWidth=function(){return this._bIsPopupOpen?'100%':this.getWidth();};
d.prototype._getRenderHeight=function(){if(this._bIsPopupOpen){return'100%';}if(!this._isEmbeddedModeAllowed()){return'auto';}return this.getHeight();};
d.prototype._showMessageBox=function(){M.show(this._getLibraryResourceBundle().getText("PDF_VIEWER_SOURCE_VALIDATION_MESSAGE_TEXT"),{icon:M.Icon.WARNING,title:this._getLibraryResourceBundle().getText("PDF_VIEWER_SOURCE_VALIDATION_MESSAGE_HEADER"),actions:[M.Action.OK,M.Action.CANCEL],defaultAction:M.Action.CANCEL,id:this.getId()+"-validationErrorSourceMessageBox",styleClass:"sapUiSizeCompact",contentWidth:'100px',onClose:this._onSourceValidationErrorMessageBoxCloseListener.bind(this)});};
d.prototype.exit=function(){q.each(this._objectsRegister,function(i,g){var o=g(true);if(o){o.destroy();}});};
P.extendPdfViewer(d);return d;});
sap.ui.predefine('sap/m/PDFViewerRenderManager',["sap/m/library","sap/m/Dialog","sap/m/Button","sap/m/MessagePage","sap/m/OverflowToolbar","sap/m/OverflowToolbarButton","sap/m/Title","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData"],function(l,D,B,M,O,a,T,b,c){"use strict";var d=l.OverflowToolbarPriority;var e=l.ButtonType;var p={extendPdfViewer:function(P){P.prototype._initPopupControl=function(){var t=this;var o={contentHeight:"100%",contentWidth:"100%",horizontalScrolling:false,verticalScrolling:false,showHeader:true,buttons:[],afterClose:t._onAfterPopupClose.bind(t)},s=t.getId()+"-popup",f=s+"-popupCloseButton",C="getPopupCloseButton",g="getPopup";this._objectsRegister[C]=function(){var h=new B(f,{text:'',press:function(){t._objectsRegister.getPopup().close();}});t._objectsRegister[C]=function(){return h;};return h;};this._objectsRegister[g]=function(i){if(i===true){return null;}var h=new D(s,o);h.addStyleClass("sapUiPopupWithPadding");t._objectsRegister[g]=function(){return h;};return h;};};P.prototype._preparePopup=function(o){var f=this.getPopupButtons().slice(),C=this._objectsRegister.getPopupCloseButton(),g=this._objectsRegister.getPopupDownloadButtonControl();C.setText(this._getLibraryResourceBundle().getText("PDF_VIEWER_POPUP_CLOSE_BUTTON"));if(this.getShowDownloadButton()){f.push(g);}f.push(C);o.removeAllButtons();f.forEach(function(h){o.addButton(h);});o.setShowHeader(true);if(!!this.getPopupHeaderTitle()){o.setTitle(this.getPopupHeaderTitle());}if(!!this.getTitle()){o.setTitle(this.getTitle());}};P.prototype._initPlaceholderMessagePageControl=function(){var t=this,s="getPlaceholderMessagePageControl";this._objectsRegister[s]=function(){var m=new M({showHeader:false,text:t._getMessagePageErrorMessage(),description:""});t._objectsRegister[s]=function(){m.setText(t._getMessagePageErrorMessage());return m;};return m;};};P.prototype._initOverflowToolbarControl=function(){var t=this,o=this.getId()+"-overflowToolbar",s=o+"-title",f="getOverflowToolbarControl";this._objectsRegister[f]=function(i){if(i===true){return null;}var g=new O(o,{}),h=new T(s,{text:t.getTitle()}),j=t._objectsRegister.getToolbarDownloadButtonControl();function k(){if(t._isDisplayDownloadButton()){g.addContent(j);}else{g.removeContent(j);}j.setEnabled(t._bRenderPdfContent);h.setText(t.getTitle());}g.addStyleClass("sapUiTinyMarginBottom");g.addContent(h);g.addContent(new b());k();j.setLayoutData(new c({priority:d.NeverOverflow}));t._objectsRegister[f]=function(i){if(!i){k();}return g;};return g;};};P.prototype._initToolbarDownloadButtonControl=function(){var t=this,s=this.getId()+"-toolbarDownloadButton",f="getToolbarDownloadButtonControl";this._objectsRegister[f]=function(i){if(i){return null;}var o=new a(s,{type:e.Transparent,icon:"sap-icon://download"});o.attachPress(t.downloadPDF.bind(t));o.setEnabled(t._bRenderPdfContent);t._objectsRegister[f]=function(){o.setEnabled(t._bRenderPdfContent);return o;};return o;};};P.prototype._initPopupDownloadButtonControl=function(){var t=this,s=this.getId()+"-popupDownloadButton",f="getPopupDownloadButtonControl";this._objectsRegister[f]=function(){var o=new B(s,{text:t._getLibraryResourceBundle().getText("PDF_VIEWER_DOWNLOAD_TEXT"),type:e.Emphasized});o.attachPress(t.downloadPDF.bind(t));o.setEnabled(t._bRenderPdfContent);t._objectsRegister[f]=function(){o.setEnabled(t._bRenderPdfContent);return o;};return o;};};}};return p;},true);
sap.ui.predefine('sap/m/PDFViewerRenderer',['sap/ui/Device',"sap/base/Log"],function(D,L){"use strict";
function s(c){return(!!c.getTitle()||c._isDisplayDownloadButton())&&!c._bIsPopupOpen;}
var a=Object.freeze(["application/pdf","application/x-google-chrome-pdf"]);var P={};
P._isSupportedMimeType=function(m){var f=a.indexOf(m);return f>-1;};
P._isPdfPluginEnabled=function(){var i=true;if(D.browser.firefox){return i;}if(D.browser.internet_explorer){try{new ActiveXObject("AcroPDF.PDF");}catch(e){i=false;}return i;}var m=navigator.mimeTypes;i=a.some(function(A){var M=m.namedItem(A);return M!==null;});return i;};
P.render=function(r,c){r.write("<div");r.writeControlData(c);r.addStyle("width",c._getRenderWidth());r.addStyle("height",c._getRenderHeight());r.writeStyles();r.writeClasses();this._writeAccessibilityTags(r,c);r.write(">");if(s(c)){r.renderControl(c._objectsRegister.getOverflowToolbarControl());}if(c._isEmbeddedModeAllowed()){this.renderPdfContent(r,c);}r.write("</div>");};
P._writeAccessibilityTags=function(r,c){r.writeAttribute("role","document");r.writeAttribute("aria-label",c._getLibraryResourceBundle().getText("PDF_VIEWER_ACCESSIBILITY_LABEL"));};
P.renderPdfContent=function(r,c){if(c._shouldRenderPdfContent()){r.write("<iframe");r.addClass("sapMPDFViewerContent");r.addClass("sapMPDFViewerLoading");if(s(c)){r.addClass("sapMPDFViewerReducedContent");}r.writeClasses();r.write(">");r.write("</iframe>");}else{this.renderErrorContent(r,c);if(!P._isPdfPluginEnabled()){L.warning("The PDF plug-in is not available on this device.");c.fireEvent("error",{},true);}}};
P.renderErrorContent=function(r,c){var e=c.getErrorPlaceholder()?c.getErrorPlaceholder():c._objectsRegister.getPlaceholderMessagePageControl();r.write("<div");r.addClass("sapMPDFViewerError");if(!c._bIsPopupOpen){r.addClass("sapMPDFViewerEmbeddedContent");}r.writeClasses();r.write(">");r.renderControl(e);r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/Page',["./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/m/Title","sap/m/Button","sap/m/Bar",'sap/m/TitleAlignmentMixin',"sap/ui/core/ContextMenuSupport","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/core/library","sap/ui/Device","sap/ui/core/Element","./TitlePropagationSupport","./PageRenderer","sap/ui/thirdparty/jquery"],function(l,C,S,T,B,a,b,c,R,d,D,E,e,P,q){"use strict";var A=d.AccessibleLandmarkRole;var f=l.ButtonType;var g=l.PageBackgroundDesign;var h=d.TitleLevel;var i=l.TitleAlignment;var j="div";var H="header";var F="footer";
var k=C.extend("sap.m.Page",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:h.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},navButtonText:{type:"string",group:"Misc",defaultValue:null,deprecated:true},navButtonTooltip:{type:"string",group:"Misc",defaultValue:null},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null,deprecated:true},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:g.Standard},navButtonType:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:f.Back,deprecated:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},contentOnlyBusy:{type:"boolean",group:"Appearance",defaultValue:false},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:i.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},footer:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent",forwarding:{getter:"_getInternalHeader",aggregation:"contentRight"}},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false},_internalHeader:{type:"sap.m.IBar",multiple:false,visibility:"hidden"}},events:{navButtonTap:{deprecated:true},navButtonPress:{}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/Page.designtime"}});
c.apply(k.prototype);R.call(k.prototype,{header:{suffix:"intHeader"},subHeader:{selector:".sapMPageSubHeader .sapMIBar"},content:{suffix:"cont"},footer:{selector:".sapMPageFooter:not(.sapMPageFloatingFooter) .sapMIBar"},floatingFooter:{selector:".sapMPageFloatingFooter.sapMPageFooter"}});e.call(k.prototype,"content",function(){return this._headerTitle?this._headerTitle.getId():false;});k.FOOTER_ANIMATION_DURATION=350;
k.prototype.init=function(){this._initTitlePropagationSupport();this._initResponsivePaddingsEnablement();};
k.prototype._hasScrolling=function(){return this.getEnableScrolling();};
k.prototype.onBeforeRendering=function(){if(this._oScroller&&!this._hasScrolling()){this._oScroller.destroy();this._oScroller=null;}else if(this._hasScrolling()&&!this._oScroller){this._oScroller=new S(this,null,{scrollContainerId:this.getId()+"-cont",horizontal:false,vertical:true});}if(this._headerTitle){this._headerTitle.setLevel(this.getTitleLevel());}};
k.prototype.onAfterRendering=function(){setTimeout(this._adjustFooterWidth.bind(this),10);};
k.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._navBtn){this._navBtn.destroy();this._navBtn=null;}if(this._appIcon){this._appIcon.destroy();this._appIcon=null;}};
k.prototype.setBackgroundDesign=function(s){var m=this.getBackgroundDesign();this.setProperty("backgroundDesign",s,true);this.$().removeClass("sapMPageBg"+m).addClass("sapMPageBg"+this.getBackgroundDesign());return this;};
k.prototype.setTitle=function(t){var w=!this._headerTitle;this._headerTitle=this._headerTitle||new T(this.getId()+"-title",{level:this.getTitleLevel()});this._headerTitle.setText(t);if(w){this._updateHeaderContent(this._headerTitle,"middle",0);}this.setProperty("title",t,true);return this;};
k.prototype._ensureNavButton=function(){var s=this.getNavButtonTooltip()||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT");if(!this._navBtn){var n=this.getNavButtonType();this._navBtn=new B(this.getId()+"-navButton",{press:q.proxy(function(){this.fireNavButtonPress();this.fireNavButtonTap();},this)});if(D.os.android&&n==f.Back){this._navBtn.setType(f.Up);}else{this._navBtn.setType(n);}}this._navBtn.setTooltip(s);};
k.prototype.setShowNavButton=function(s){var o=!!this.getShowNavButton();if(s===o){return this;}this.setProperty("showNavButton",s,true);if(s){this._ensureNavButton();if(this._appIcon){this._updateHeaderContent(this._appIcon,"left",-1);}this._updateHeaderContent(this._navBtn,"left",0);}else if(this._navBtn){this._updateHeaderContent(this._navBtn,"left",-1);}return this;};
k.prototype.setShowFooter=function(s){if(this.getDomRef()){(s)?this.$().addClass("sapMPageWithFooter"):this.$().removeClass("sapMPageWithFooter");}var $=q(this.getDomRef()).find(".sapMPageFooter").last(),u=sap.ui.getCore().getConfiguration().getAnimation();if(!this.getFloatingFooter()){this.setProperty("showFooter",s);return this;}this.setProperty("showFooter",s,true);$.removeClass("sapUiHidden");$.toggleClass("sapMPageFooterControlShow",s);$.toggleClass("sapMPageFooterControlHide",!s);if(s){return this;}if(u){setTimeout(function(){$.toggleClass("sapUiHidden",!s);},k.FOOTER_ANIMATION_DURATION);}else{$.toggleClass("sapUiHidden",!s);}return this;};
k.prototype.setNavButtonType=function(n){this._ensureNavButton();if(!D.os.ios&&n==f.Back){this._navBtn.setType(f.Up);}else{this._navBtn.setType(n);}this.setProperty("navButtonType",n,true);return this;};
k.prototype.setNavButtonText=function(t){this._ensureNavButton();this.setProperty("navButtonText",t,true);return this;};
k.prototype.setNavButtonTooltip=function(t){this.setProperty("navButtonTooltip",t,true);this._ensureNavButton();return this;};
k.prototype.setIcon=function(I){var o=this.getIcon();if(o===I){return this;}this.setProperty("icon",I,true);return this;};
k.prototype._adjustFooterWidth=function(){var m=sap.ui.getCore().getConfiguration().getRTL()?"left":"right";if(!this.getShowFooter()||!this.getFloatingFooter()||!this.getFooter()){return;}var $=q(this.getDomRef()).find(".sapMPageFooter").last();if(this._contentHasScroll()){$.css(m,q.position.scrollbarWidth()+"px");$.css("width","initial");}else{$.css(m,0);$.css("width","");}};
k.prototype._contentHasScroll=function(){var $=q(document.getElementById(this.getId()+"-cont"));return $[0].scrollHeight>$.innerHeight();};
k.prototype._updateHeaderContent=function(o,s,m){var I=this._getInternalHeader();if(I){switch(s){case"left":if(m==-1){if(I.getContentLeft()){I.removeContentLeft(o);}}else{if(I.indexOfContentLeft(o)!=m){I.insertContentLeft(o,m);I.invalidate();}}break;case"middle":if(m==-1){if(I.getContentMiddle()){I.removeContentMiddle(o);}}else{if(I.indexOfContentMiddle(o)!=m){I.insertContentMiddle(o,m);I.invalidate();}}break;case"right":if(m==-1){if(I.getContentRight()){I.removeContentRight(o);}}else{if(I.indexOfContentRight(o)!=m){I.insertContentRight(o,m);I.invalidate();}}break;default:break;}}};
k.prototype._getInternalHeader=function(){var I=this.getAggregation("_internalHeader");if(!I){this.setAggregation("_internalHeader",new a(this.getId()+"-intHeader"),true);I=this.getAggregation("_internalHeader");this._setupBarTitleAlignment(I,this.getId()+"_internalHeader");if(this.getShowNavButton()&&this._navBtn){this._updateHeaderContent(this._navBtn,"left",0);}if(this.getTitle()&&this._headerTitle){this._updateHeaderContent(this._headerTitle,"middle",0);}}return I;};
k.prototype._getAnyHeader=function(){var o=this.getCustomHeader();if(o){return o.addStyleClass("sapMPageHeader");}return this._getInternalHeader().addStyleClass("sapMPageHeader");};
k.prototype.getScrollDelegate=function(){return this._oScroller;};
k.prototype._formatLandmarkInfo=function(L,p){if(L){var r=L["get"+p+"Role"]()||"",s=L["get"+p+"Label"]()||"";if(r===A.None){r='';}return{role:r.toLowerCase(),label:s};}return{};};
k.prototype._getHeaderTag=function(L){if(L&&L.getHeaderRole()!==A.None){return j;}return H;};
k.prototype._getSubHeaderTag=function(L){if(L&&L.getSubHeaderRole()!==A.None){return j;}return H;};
k.prototype._getFooterTag=function(L){if(L&&L.getFooterRole()!==A.None){return j;}return F;};
k.prototype.scrollTo=function(y,t){if(this._oScroller){this._oScroller.scrollTo(0,y,t);}return this;};
k.prototype.scrollToElement=function(o,t,O){if(o instanceof E){o=o.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(o,t,O);}return this;};
k.prototype.setContentOnlyBusy=function(m){this.setProperty("contentOnlyBusy",m,true);this.$().toggleClass("sapMPageBusyCoversAll",!m);return this;};
k.prototype.setBusy=function(){this._sBusySection=this.getContentOnlyBusy()?'cont':null;return C.prototype.setBusy.apply(this,arguments);};
k.prototype.setCustomHeader=function(o){this.setAggregation("customHeader",o);this.toggleStyleClass("sapFShellBar-CTX",o&&o.isA("sap.f.ShellBar"));if(o&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":o});}return this;};
k.prototype._getAdaptableContent=function(){return this._getAnyHeader();};
b.mixInto(k.prototype);return k;});
sap.ui.predefine('sap/m/PageAccessibleLandmarkInfo',['sap/ui/core/Element','./library'],function(E,l){"use strict";
var P=E.extend("sap.m.PageAccessibleLandmarkInfo",{metadata:{library:"sap.m",properties:{rootRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},rootLabel:{type:"string",defaultValue:null},contentRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Main"},contentLabel:{type:"string",defaultValue:null},headerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},headerLabel:{type:"string",defaultValue:null},subHeaderRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},subHeaderLabel:{type:"string",defaultValue:null},footerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},footerLabel:{type:"string",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/m/PageRenderer',["sap/m/library"],function(a){"use strict";var P={};
P.render=function(r,p){var h=null,f=null,s=p.getShowFooter(),S=null,L=this._isLightHeader(p),o=p.getLandmarkInfo();if(p.getShowHeader()){h=p._getAnyHeader();}if(p.getShowSubHeader()){S=p.getSubHeader();}f=p.getFooter();r.write("<div");r.writeControlData(p);r.addClass("sapMPage");r.addClass("sapMPageBg"+p.getBackgroundDesign());if(h){r.addClass("sapMPageWithHeader");}if(S){r.addClass("sapMPageWithSubHeader");}if(f&&s){r.addClass("sapMPageWithFooter");}if(!p.getContentOnlyBusy()){r.addClass("sapMPageBusyCoversAll");}if(p.getFloatingFooter()){r.addClass("sapMPageWithFloatingFooter");}r.writeClasses();var t=p.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState(p,p._formatLandmarkInfo(o,"Root"));r.write(">");if(h){var H=p._getHeaderTag(o);r.write("<"+H);r.addClass("sapMPageHeader");r.writeAccessibilityState(p,p._formatLandmarkInfo(o,"Header"));r.writeClasses();r.write(">");this.renderBarControl(r,p,h,{context:"header",styleClass:L?"":"sapContrastPlus"});r.write("</"+H+">");}if(S){var b=p._getSubHeaderTag(o);r.write("<"+b);r.addClass("sapMPageSubHeader");r.writeAccessibilityState(p,p._formatLandmarkInfo(o,"SubHeader"));if(S.getDesign()==a.ToolbarDesign.Info){r.addClass("sapMPageSubHeaderInfoBar");}r.writeClasses();r.write(">");this.renderBarControl(r,p,S,{context:"subHeader",styleClass:L?"":"sapContrastPlus"});r.write("</"+b+">");}r.write('<section id="'+p.getId()+'-cont"');r.writeAccessibilityState(p,p._formatLandmarkInfo(o,"Content"));if(p.getEnableScrolling()){r.addClass("sapMPageEnableScrolling");r.writeClasses();}r.write('>');var c=p.getContent();var l=c.length;for(var i=0;i<l;i++){r.renderControl(c[i]);}r.write("</section>");if(f){var F=p._getFooterTag(o);r.write("<"+F);r.addClass("sapMPageFooter");if(!p.getShowFooter()){r.addClass("sapUiHidden");}if(p.getFloatingFooter()){r.addClass("sapMPageFloatingFooter");}r.writeAccessibilityState(p,p._formatLandmarkInfo(o,"Footer"));r.writeClasses();r.write(">");this.renderBarControl(r,p,f,{context:"footer"});r.write("</"+F+">");}r.write("</div>");};
P.renderBarControl=function(r,p,b,o){if(!b){return;}b._applyContextClassFor(o.context.toLowerCase());b.addStyleClass(o.styleClass||"");r.renderControl(b);};
P._isLightHeader=function(p){var c=p,o=p.getParent(),s,C;while(o){s=(o&&o.getMetadata().getName())||"";C=c.getMetadata().getName();if(((s==="sap.m.Popover"||s==="sap.m.Dialog")&&C==="sap.m.NavContainer")||((s==="sap.ui.comp.smartvariants.SmartVariantManagement"||s==="sap.ui.comp.smartvariants.SmartVariantManagementUi2"||s==="sap.ui.comp.variants.VariantManagement"||s==="sap.ui.fl.variants.VariantManagement")&&C==="sap.m.ResponsivePopover")){return true;}if(o&&["sap.m.SplitApp","sap.m.SplitContainer"].indexOf(s)>-1&&C==="sap.m.NavContainer"&&/\-Master$/.test(c.getId())){return true;}c=o;o=c.getParent();}return false;};
return P;},true);
sap.ui.predefine('sap/m/PagingButton',['./Button','sap/ui/core/Control','sap/ui/core/IconPool','./PagingButtonRenderer',"sap/base/Log"],function(B,C,I,P,L){"use strict";
var a=C.extend("sap.m.PagingButton",{metadata:{library:"sap.m",properties:{count:{type:"int",group:"Data",defaultValue:1},position:{type:"int",group:"Data",defaultValue:1},nextButtonTooltip:{type:"string",group:"Appearance",defaultValue:""},previousButtonTooltip:{type:"string",group:"Appearance",defaultValue:""}},aggregations:{previousButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{positionChange:{parameters:{newPosition:{type:"int"},oldPosition:{type:"int"}}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
a.prototype.init=function(){this._attachPressEvents();};
a.prototype.onBeforeRendering=function(){this._enforceValidPosition(this.getPosition());this._updateButtonState();};
a.prototype._getNextButton=function(){if(!this.getAggregation("nextButton")){this.setAggregation("nextButton",new B({tooltip:this.getNextButtonTooltip()||r.getText("PAGINGBUTTON_NEXT"),icon:I.getIconURI("slim-arrow-down"),enabled:false,id:this.getId()+"-nextButton"}));}return this.getAggregation("nextButton");};
a.prototype._getPreviousButton=function(){if(!this.getAggregation("previousButton")){this.setAggregation("previousButton",new B({tooltip:this.getPreviousButtonTooltip()||r.getText("PAGINGBUTTON_PREVIOUS"),icon:I.getIconURI("slim-arrow-up"),enabled:false,id:this.getId()+"-previousButton"}));}return this.getAggregation("previousButton");};
a.prototype._attachPressEvents=function(){this._getPreviousButton().attachPress(this._handlePositionChange.bind(this,false));this._getNextButton().attachPress(this._handlePositionChange.bind(this,true));};
a.prototype._handlePositionChange=function(i){var o=this.getPosition(),n=i?o+1:o-1;this.setPosition(n);this.firePositionChange({newPosition:n,oldPosition:o});this._updateButtonState();return this;};
a.prototype._updateButtonState=function(){var t=this.getCount(),c=this.getPosition();this._getPreviousButton().setEnabled(c>1);this._getNextButton().setEnabled(c<t);return this;};
a.prototype.setPosition=function(p){return this._validateProperty("position",p);};
a.prototype.setCount=function(c){return this._validateProperty("count",c);};
a.prototype.setPreviousButtonTooltip=function(t){this._getPreviousButton().setTooltip(t);return this.setProperty("previousButtonTooltip",t,true);};
a.prototype.setNextButtonTooltip=function(t){this._getNextButton().setTooltip(t);return this.setProperty("nextButtonTooltip",t,true);};
a.prototype._validateProperty=function(p,v){if(v<1){L.warning("Property '"+p+"' must be greater or equal to 1",this);return this;}return this.setProperty(p,v);};
a.prototype._enforceValidPosition=function(p){var c=this.getCount();if(p>c){L.warning("Property position must be less or equal to the total count");this.setPosition(c);}return this;};
return a;});
sap.ui.predefine('sap/m/PagingButtonRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,c){var n=c._getNextButton(),p=c._getPreviousButton();r.openStart("div",c);r.class("sapMPagingButton");r.openEnd();r.renderControl(p);r.renderControl(n);r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/Panel',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','./PanelRenderer'],function(l,C,I,D,P){"use strict";var a=l.PanelAccessibleRole;var B=l.BackgroundDesign;
var b=C.extend("sap.m.Panel",{metadata:{library:"sap.m",properties:{headerText:{type:"string",group:"Data",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},expandable:{type:"boolean",group:"Appearance",defaultValue:false},expanded:{type:"boolean",group:"Appearance",defaultValue:false},expandAnimation:{type:"boolean",group:"Behavior",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Translucent},accessibleRole:{type:"sap.m.PanelAccessibleRole",group:"Accessibility",defaultValue:a.Form}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false}},events:{expand:{parameters:{expand:{type:"boolean"},triggeredByInteraction:{type:"boolean"}}}},dnd:{draggable:true,droppable:true},designtime:"sap/m/designtime/Panel.designtime"}});
b.prototype.init=function(){this._bInteractiveExpand=false;this.data("sap-ui-fastnavgroup","true",true);};
b.prototype.setWidth=function(w){this.setProperty("width",w,true);var d=this.getDomRef();if(d){d.style.width=w;}return this;};
b.prototype.setHeight=function(h){this.setProperty("height",h,true);var d=this.getDomRef();if(d){d.style.height=h;if(parseFloat(h)!=0){d.querySelector(".sapMPanelContent").style.height=h;}this._setContentHeight();}return this;};
b.prototype.onThemeChanged=function(){this._setContentHeight();};
b.prototype.setExpandable=function(e){this.setProperty("expandable",e,false);if(e&&!this.oIconCollapsed){this.oIconCollapsed=this._createIcon();}return this;};
b.prototype.setExpanded=function(e){if(e===this.getExpanded()){return this;}this.setProperty("expanded",e,true);if(!this.getExpandable()){return this;}this._getIcon().$().attr("aria-expanded",this.getExpanded());this._toggleExpandCollapse();this._toggleCssClasses();this.fireExpand({expand:e,triggeredByInteraction:this._bInteractiveExpand});this._bInteractiveExpand=false;return this;};
b.prototype.setAccessibleRole=function(r){if(r===this.getAccessibleRole()){return this;}this.setProperty("accessibleRole",r,true);if(sap.ui.getCore().getConfiguration().getAccessibility()){this.$().attr("role",this.getAccessibleRole().toLowerCase());}return this;};
b.prototype.onBeforeRendering=function(){if(D.browser.msie||D.browser.edge){this._updateIconAriaLabelledBy();}};
b.prototype.onAfterRendering=function(){var $=this.$(),c,p=this.getDomRef("content");this._setContentHeight();if(this.getExpandable()){c=this.oIconCollapsed.$();p&&c.attr("aria-controls",p.id);if(this.getExpanded()){c.attr("aria-expanded","true");}else{$.children(".sapMPanelExpandablePart").css("display","none");c.attr("aria-expanded","false");}}};
b.prototype.exit=function(){if(this.oIconCollapsed){this.oIconCollapsed.destroy();this.oIconCollapsed=null;}};
b.prototype._createIcon=function(){var t=this,c=I.getIconURI("navigation-right-arrow"),T=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PANEL_ICON");return I.createControlByURI({id:t.getId()+"-CollapsedImg",src:c,decorative:false,press:function(){t._bInteractiveExpand=true;t.setExpanded(!t.getExpanded());},tooltip:T}).addStyleClass("sapMPanelExpandableIcon");};
b.prototype._getIcon=function(){return this.oIconCollapsed;};
b.prototype._setContentHeight=function(){var A,t=this.getDomRef(),p=t&&t.querySelector(".sapMPanelContent");if(this.getHeight()==="auto"||!p){return;}A='calc('+this.getHeight()+' - '+p.offsetTop+'px)';p.style.height=A;};
b.prototype._toggleExpandCollapse=function(){var o={};if(!this.getExpandAnimation()){o.duration=0;}this.$().children(".sapMPanelExpandablePart").slideToggle(o);};
b.prototype._toggleCssClasses=function(){var $=this.$();$.children(".sapMPanelWrappingDiv").toggleClass("sapMPanelWrappingDivExpanded");$.children(".sapMPanelWrappingDivTb").toggleClass("sapMPanelWrappingDivTbExpanded");$.find(".sapMPanelExpandableIcon").first().toggleClass("sapMPanelExpandableIconExpanded");};
b.prototype._updateIconAriaLabelledBy=function(){var L,A,f;if(!this.oIconCollapsed){return;}if(this.getAccessibleRole()===a.Form){f=true;}L=this._getLabellingElementId();A=this.oIconCollapsed.getAriaLabelledBy();if(A.indexOf(L)===-1){this.oIconCollapsed.removeAllAssociation("ariaLabelledBy");!f&&this.oIconCollapsed.addAriaLabelledBy(L);}};
b.prototype._getLabellingElementId=function(){var h=this.getHeaderToolbar(),i;if(h){i=h.getTitleId();}else{i=this.getId()+"-header";}return i;};
return b;});
sap.ui.predefine('sap/m/PanelRenderer',["sap/m/library","sap/ui/Device"],function(l,D){"use strict";var T=l.ToolbarDesign;var P={};
P.render=function(r,c){this.startPanel(r,c);this.renderHeader(r,c);this.renderContent(r,c);this.endPanel(r);};
P.startPanel=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMPanel");r.writeClasses();r.addStyle("width",c.getWidth());r.addStyle("height",c.getHeight());r.writeStyles();r.writeAccessibilityState(c,{role:c.getAccessibleRole().toLowerCase(),labelledby:c._getLabellingElementId()});r.write(">");};
P.renderHeader=function(r,c){var i=c.getExpandable(),I=c.getExpanded(),h=c.getHeaderToolbar(),H;if(i){r.write("<header");if(h){H="sapMPanelWrappingDivTb";}else{H="sapMPanelWrappingDiv";}r.addClass(H);if(I){r.addClass(H+"Expanded");}r.writeClasses();r.write(">");var o=c._getIcon();if(I){o.addStyleClass("sapMPanelExpandableIconExpanded");}else{o.removeStyleClass("sapMPanelExpandableIconExpanded");}r.renderControl(o);}var s=c.getHeaderText();if(h){h.setDesign(T.Transparent,true);h.addStyleClass("sapMPanelHeaderTB");r.renderControl(h);}else if(s||i){r.write("<h2");r.addClass("sapMPanelHdr");r.writeClasses();r.writeAttribute("id",c.getId()+"-header");r.write(">");r.writeEscaped(s);r.write("</h2>");}if(i){r.write("</header>");}var a=c.getInfoToolbar();if(a){a.setDesign(T.Info,true);a.addStyleClass("sapMPanelInfoTB");if(i){r.write("<div");r.addClass("sapMPanelExpandablePart");r.writeClasses();r.write(">");r.renderControl(a);r.write("</div>");}else{r.renderControl(a);}}};
P.renderContent=function(r,c){this.startContent(r,c);this.renderChildren(r,c.getContent());this.endContent(r);};
P.startContent=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-content");r.addClass("sapMPanelContent");r.addClass("sapMPanelBG"+c.getBackgroundDesign());if(c.getExpandable()){r.addClass("sapMPanelExpandablePart");}r.writeClasses();if(D.browser.firefox){r.writeAttribute('tabindex','-1');}r.write(">");};
P.renderChildren=function(r,c){c.forEach(r.renderControl,r);};
P.endContent=function(r){r.write("</div>");};
P.endPanel=function(r){r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendar',['sap/m/delegate/DateNavigation','sap/ui/core/Control','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectObserver','sap/ui/unified/library','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/DatesRow','sap/ui/unified/calendar/OneMonthDatesRow','sap/ui/unified/calendar/MonthsRow','sap/ui/unified/calendar/TimesRow','sap/ui/unified/DateRange','sap/ui/unified/CalendarAppointment','sap/ui/unified/CalendarRow','sap/ui/unified/CalendarRowRenderer','sap/ui/Device','sap/ui/core/Element','sap/ui/core/Renderer','sap/ui/core/ResizeHandler','sap/ui/core/InvisibleText','sap/ui/core/Item','sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo','sap/ui/core/dnd/DragDropInfo','sap/ui/core/format/DateFormat','sap/m/Select','sap/m/Button','sap/m/OverflowToolbar','sap/m/Toolbar','sap/m/Table','sap/m/Column','sap/m/ColumnListItem','sap/m/ColumnListItemRenderer','sap/m/SegmentedButtonItem','sap/m/StandardListItem','sap/m/StandardListItemRenderer','sap/m/PlanningCalendarHeader','sap/m/PlanningCalendarRow','sap/m/PlanningCalendarRenderer','sap/m/PlanningCalendarView','sap/m/CheckBox','sap/m/library',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(D,C,M,a,u,b,c,d,O,e,T,f,g,h,k,l,E,R,m,I,n,o,p,q,r,S,B,s,t,v,w,x,y,z,A,F,P,G,H,J,K,L,N,Q,U){"use strict";var V=L.Sticky;var W=u.CalendarDayType;var X=L.ListMode;var Y=L.ToolbarDesign;var Z=L.PlanningCalendarBuiltInView;var $=L.ScreenSize;var _=u.CalendarAppointmentVisualization;var a1=u.GroupAppointmentsMode;var b1=u.CalendarIntervalType;var c1="DragDropConfig";var d1="ResizeConfig";var e1="CreateConfig";var f1="-CLI";
var g1=C.extend("sap.m.PlanningCalendar",{
metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},viewKey:{type:"string",group:"Appearance",defaultValue:b1.Hour},singleSelection:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showEmptyIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showRowHeaders:{type:"boolean",group:"Appearance",defaultValue:true},noDataText:{type:"string",group:"Misc",defaultValue:null},groupAppointmentsMode:{type:"sap.ui.unified.GroupAppointmentsMode",group:"Appearance",defaultValue:a1.Collapsed},appointmentsReducedHeight:{type:"boolean",group:"Appearance",defaultValue:false},appointmentsVisualization:{type:"sap.ui.unified.CalendarAppointmentVisualization",group:"Appearance",defaultValue:_.Standard},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null},showDayNamesLine:{type:"boolean",group:"Appearance",defaultValue:false},showWeekNumbers:{type:"boolean",group:"Appearance",defaultValue:false},builtInViews:{type:"string[]",group:"Appearance",defaultValue:[]},stickyHeader:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{rows:{type:"sap.m.PlanningCalendarRow",multiple:true,singularName:"row"},views:{type:"sap.m.PlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},toolbarContent:{type:"sap.ui.core.Control",multiple:true,singularName:"toolbarContent",forwarding:{getter:"_getHeader",aggregation:"actions"},forwardBinding:true},table:{type:"sap.m.Table",multiple:false,visibility:"hidden"},header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"},multiSelect:{type:"boolean"},domRefId:{type:"string"}}},intervalSelect:{parameters:{startDate:{type:"object"},endDate:{type:"object"},subInterval:{type:"boolean"},row:{type:"sap.m.PlanningCalendarRow"}}},rowSelectionChange:{parameters:{rows:{type:"sap.m.PlanningCalendarRow[]"}}},startDateChange:{},viewChange:{},rowHeaderClick:{row:{type:"sap.m.PlanningCalendarRow"}}},designtime:"sap/m/designtime/PlanningCalendar.designtime"},
constructor:function(i,j){C.prototype.constructor.apply(this,arguments);if(typeof i!=="string"){j=i;}if(j&&typeof j.customAppointmentsSorterCallback==="function"){this._fnCustomSortedAppointments=j.customAppointmentsSorterCallback;}}
});
var h1=["_oTimesRow","_oDatesRow","_oMonthsRow","_oWeeksRow","_oOneMonthsRow"],i1={};i1[b1.Day]={sInstanceName:"_oDatesRow",sIdSuffix:"-DatesRow",oClass:d};i1[b1.Week]={sInstanceName:"_oWeeksRow",sIdSuffix:"-WeeksRow",oClass:d};i1[b1.OneMonth]={sInstanceName:"_oOneMonthsRow",sIdSuffix:"-OneMonthsRow",oClass:O};var j1=$.Desktop;var k1=[Z.Hour,Z.Day,Z.Month,Z.Week,Z.OneMonth];var l1={PHONE:"600",TABLET:"1024"};var m1=["sap.ui.unified.calendar.TimesRow","sap.ui.unified.calendar.DatesRow","sap.ui.unified.calendar.MonthsRow","sap.ui.unified.calendar.OneMonthDatesRow"];
var n1=C.extend("CalendarHeader",{
metadata:{aggregations:{"toolbar":{type:"sap.m.Toolbar",multiple:false},"allCheckBox":{type:"sap.m.CheckBox",multiple:false}}},
renderer:function(i,j){i.write("<div");i.writeControlData(j);i.addClass("sapMPlanCalHead");i.writeClasses();i.write(">");var O1=j.getToolbar();if(O1){i.renderControl(O1);}var P1=j.getAllCheckBox();if(P1){i.renderControl(P1);}i.write("</div>");}
});
g1.prototype.init=function(){this._dateNav=new D();this._iBreakPointTablet=l.media._predefinedRangeSets[l.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=l.media._predefinedRangeSets[l.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=l.media._predefinedRangeSets[l.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];if(l.system.phone||U('html').hasClass("sapUiMedia-Std-Phone")){this._iSize=0;this._iSizeScreen=0;}else if(l.system.tablet||U('html').hasClass("sapUiMedia-Std-Tablet")){this._iSize=1;this._iSizeScreen=1;}else{this._iSize=2;this._iSizeScreen=2;}this.setAggregation("header",this._createHeader());this._attachHeaderEvents();this._oRB=sap.ui.getCore().getLibraryResourceBundle("sap.m");var i=this.getId();this._oIntervalTypeSelect=this._getHeader()._getOrCreateViewSwitch();this._oIntervalTypeSelect.attachEvent("selectionChange",o1,this);this._oTodayButton=this._getHeader()._getTodayButton();this._oCalendarHeader=new n1(i+"-CalHead",{});this._oInfoToolbar=new t(i+"-InfoToolbar",{height:"auto",design:Y.Transparent,content:[this._oCalendarHeader,this._oTimesRow]});var j=new v(i+"-Table",{sticky:[],infoToolbar:this._oInfoToolbar,mode:X.SingleSelectMaster,columns:[new w({styleClass:"sapMPlanCalRowHead"}),new w({width:"80%",styleClass:"sapMPlanCalAppRow",minScreenWidth:j1,demandPopin:true})],ariaLabelledBy:i+"-Descr"});j.attachEvent("selectionChange",E1,this);j.addDelegate({onBeforeRendering:function(){if(this._rowHeaderClickEvent){this._rowHeaderClickEvent.off();}},onAfterRendering:function(){this._rowHeaderClickEvent=j.$().find(".sapMPlanCalRowHead > div.sapMLIB").click(function(O1){var P1=U(O1.currentTarget).control(0),Q1=A1(P1.getParent());this.fireRowHeaderClick({row:Q1});}.bind(this));this._adjustColumnHeadersTopOffset();}},false,this);this.setAggregation("table",j,true);this.setStartDate(new Date());this._resizeProxy=U.proxy(s1,this);this._fnCustomSortedAppointments=undefined;this.iWidth=0;};
g1.prototype.exit=function(){if(this._sResizeListener){m.deregister(this._sResizeListener);this._sResizeListener=undefined;}l.orientation.detachHandler(this._updateStickyHeader,this);if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}var i=this.getAggregation("table");i.removeAllItems();h1.forEach(function(O1){if(this[O1]){this[O1]._oPlanningCalendar=undefined;this[O1].destroy();this[O1]=undefined;}},this);if(this._oViews){for(var j in this._oViews){this._oViews[j].destroy();}}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.destroy();}if(this._rowHeaderClickEvent){this._rowHeaderClickEvent.off();this._rowHeaderClickEvent=null;}};
g1.prototype.onBeforeRendering=function(){this._bBeforeRendering=true;if((!this._oTimesRow&&!this._oDatesRow&&!this._oMonthsRow&&!this._oWeeksRow&&!this._oOneMonthsRow)||this._bCheckView){this.setViewKey(this.getViewKey());this._bCheckView=undefined;}H1.call(this);if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}this._updatePickerSelection();l.orientation.detachHandler(this._updateStickyHeader,this);this._bBeforeRendering=undefined;this._toggleStickyClasses();};
g1.prototype.attachEvent=function(i,j,O1,P1){C.prototype.attachEvent.call(this,i,j,O1,P1);if(this.hasListeners("intervalSelect")){h1.forEach(function(Q1){if(this[Q1]){this[Q1]._setAriaRole("button");}},this);}return this;};
g1.prototype.detachEvent=function(i,j,O1){C.prototype.detachEvent.call(this,i,j,O1);if(!this.hasListeners("intervalSelect")){h1.forEach(function(P1){if(this[P1]){this[P1]._setAriaRole("gridcell");}},this);}return this;};
g1.prototype._createHeader=function(){var i=new P(this.getId()+"-Header");i.getAggregation("_actionsToolbar").addAriaLabelledBy(I.getStaticId("sap.m","PC_FUNCTIONS_TOOLBAR"));i.getAggregation("_navigationToolbar").addAriaLabelledBy(I.getStaticId("sap.m","PC_INTERVAL_SELECTION_TOOLBAR"));return i;};
g1.prototype._attachHeaderEvents=function(){var i=this._getHeader();i.attachEvent("pressPrevious",this._handlePressArrow,this);i.attachEvent("pressToday",this._handleTodayPress,this);i.attachEvent("pressNext",this._handlePressArrow,this);i.attachEvent("dateSelect",this._handleDateSelect,this);return this;};
g1.prototype._handlePressArrow=function(i){this._applyArrowsLogic(i.getId()==="pressPrevious");};
g1.prototype._applyArrowsLogic=function(i){if(i){this._dateNav.previous();}else{this._dateNav.next();}var j=this._getRowInstanceByViewKey(this.getViewKey());this.setStartDate(this._dateNav.getStart());j.setDate(this._dateNav.getCurrent());this._updatePickerSelection();this.fireStartDateChange();};
g1.prototype._formatPickerText=function(){var i=this._getFirstAndLastRangeDate(),j=b._createLocalDate(i.oStartDate,true),O1=b._createLocalDate(i.oEndDate,true),P1=this.getViewKey(),Q1=b1[P1]?b1[P1]:this._getView(P1).getIntervalType(),R1=sap.ui.getCore().getConfiguration().getRTL(),S1,T1,U1,V1;switch(Q1){case b1.Hour:S1=r.getDateInstance({format:"yMMMMd"});U1=S1.format(j);if(j.getDate()!==O1.getDate()){V1=S1.format(O1);}break;case b1.Day:case b1.Week:S1=r.getDateInstance({format:"yMMMMd"});U1=S1.format(j);V1=S1.format(O1);break;case b1.OneMonth:S1=r.getDateInstance({format:"yMMMM"});U1=S1.format(j);break;case b1.Month:S1=r.getDateInstance({format:"y"});U1=S1.format(j);if(j.getFullYear()!==O1.getFullYear()){V1=S1.format(O1);}break;default:throw new Error("Unknown IntervalType: "+P1+"; "+this);}if(!R1){T1=U1;if(V1){T1+=" - "+V1;}}else{if(V1){T1=V1+" - "+U1;}else{T1=U1;}}return T1;};
g1.prototype._getFirstAndLastRangeDate=function(){var i=b._createUniversalUTCDate(this.getStartDate(),"Gregorian",true),j=b._createUniversalUTCDate(this._dateNav.getEnd(),"Gregorian",true);return{oStartDate:i,oEndDate:j};};
g1.prototype._getHeader=function(){return this.getAggregation("header");};
g1.prototype._toggleStickyClasses=function(){this.toggleStyleClass("sapMPCSticky",this.getStickyHeader());return this;};
g1.prototype._adjustColumnHeadersTopOffset=function(){var i=this.getStickyHeader(),j=this.getDomRef().querySelector(".sapMListInfoTBarContainer"),O1;switch(i){case true:O1=this._getHeader().$().outerHeight()+"px";break;default:O1="auto";break;}j.style.top=O1;return this;};
g1.prototype._setAriaRole=function(i){if(this.hasListeners("intervalSelect")){i._setAriaRole("button");}else{i._setAriaRole("gridcell");}};
g1.prototype._updateTodayButtonState=function(){if(this._oTodayButton){this._oTodayButton.setEnabled(!this._dateMatchesVisibleRange(new Date(),this.getViewKey()));}};
g1.prototype._dateMatchesVisibleRange=function(i,j){var O1=this._getView(j,!this._bBeforeRendering);if(!O1){return false;}var P1=O1.getIntervalType(),Q1=i1[P1],R1=Q1?this[Q1.sInstanceName]:null,S1=false;if(R1&&j==="One Month"){return b._isSameMonthAndYear(c.fromLocalJSDate(this.getStartDate()),c.fromLocalJSDate(i));}else if(R1&&j==="Week"){var T1=R1.getDays(),U1=c.fromLocalJSDate(i),V1=c.fromLocalJSDate(this.getStartDate()),W1=c.fromLocalJSDate(this.getStartDate());W1.setDate(W1.getDate()+T1);return U1.isSameOrAfter(V1)&&U1.isBefore(W1);}return S1;};
g1.prototype.onAfterRendering=function(i){i.size={width:this.getDomRef().offsetWidth};s1.call(this,i,true);if(!this._sResizeListener){this._sResizeListener=m.register(this,this._resizeProxy);}if(l.system.phone&&this.getStickyHeader()){l.orientation.attachHandler(this._updateStickyHeader,this);}this._updateCurrentTimeVisualization(false);if(this.getHeight()){var j=this.getDomRef().querySelector("table");if(this.getHeight().indexOf("%")>-1){j.style.height=this.getHeight();return;}var O1=this.$().height()-this._oInfoToolbar.$().height()+"px";j.style.height=O1;}this._adjustColumnHeadersTopOffset();};
g1.prototype.onThemeChanged=function(){this._adjustColumnHeadersTopOffset();};
g1.prototype.addToolbarContent=function(i){if(i&&i.isA("sap.m.Title")){this._getHeader().setTitle(i.getText());}else{this.addAggregation("toolbarContent",i);}return this;};
g1.prototype.insertToolbarContent=function(i,j){if(i&&i.isA("sap.m.Title")){this._getHeader().setTitle(i.getText());}else{this.insertAggregation("toolbarContent",i,j);}return this;};
g1.prototype.removeToolbarContent=function(i){var j;if(i&&i.isA("sap.m.Title")){this._getHeader().setTitle("");}else{j=this.removeAggregation("toolbarContent",i);}return j;};
g1.prototype.removeAllToolbarContent=function(){var i=this.removeAllAggregation("toolbarContent");this._getHeader().setTitle("");return i;};
g1.prototype.destroyToolbarContent=function(){var i=this.destroyAggregation("toolbarContent");this._getHeader().setTitle("");return i;};
g1.prototype.setStartDate=function(i){var j,O1,P1;if(!i){P1=new Date();}else{b._checkJSDateObject(i);P1=new Date(i.getTime());}if(this.getViewKey()===Z.Week){j=b.getFirstDateOfWeek(b._createUniversalUTCDate(P1,undefined,true));P1.setTime(b._createLocalDate(j,true).getTime());}if(this.getViewKey()===Z.OneMonth||this.getViewKey()===Z.Month){O1=b.getFirstDateOfMonth(b._createUniversalUTCDate(P1,undefined,true));P1.setTime(b._createLocalDate(O1,true).getTime());}if(N(P1,this.getStartDate())){this._updateTodayButtonState();return this;}var Q1=P1.getFullYear();b._checkYearInValidRange(Q1);var R1=this.getMinDate();if(R1&&R1.getTime()>P1.getTime()){Q.warning("StartDate < minDate -> StartDate set to minDate",this);P1=new Date(R1.getTime());}else{var S1=this.getMaxDate();if(S1&&S1.getTime()<P1.getTime()){Q.warning("StartDate > maxDate -> StartDate set to minDate",this);if(R1){P1=new Date(R1.getTime());}else{P1=new Date(1,0,1);P1.setFullYear(1);}}}this.setProperty("startDate",P1,true);this._dateNav.setStart(P1);this._getHeader().setStartDate(P1);h1.forEach(function(T1){if(this[T1]){this[T1].setStartDate(new Date(P1.getTime()));}},this);if(this.getViewKey()===Z.OneMonth&&this._oOneMonthsRow.getMode()<2&&this._oOneMonthsRow.getSelectedDates().length){this._setRowsStartDate(this._oOneMonthsRow.getSelectedDates()[0].getStartDate());}else{this._setRowsStartDate(new Date(P1.getTime()));}if(this.getViewKey()===Z.Week||this.getViewKey()===Z.OneMonth){this._updateTodayButtonState();}if(this.getDomRef()){this._updateCurrentTimeVisualization(false);this._updatePickerSelection();}return this;};
g1.prototype.setMinDate=function(i){if(N(i,this.getMinDate())){return this;}var j=this.getMaxDate(),O1=this._getHeader();if(i){b._checkJSDateObject(i);var P1=i.getFullYear();b._checkYearInValidRange(P1);this.setProperty("minDate",i,true);this._bNoStartDateChange=true;O1.getAggregation("_calendarPicker").setMinDate(new Date(i.getTime()));if(j&&j.getTime()<i.getTime()){Q.warning("minDate > maxDate -> maxDate set to end of the month",this);j=new Date(i.getTime());j.setMonth(j.getMonth()+1,0);j.setHours(23);j.setMinutes(59);j.setSeconds(59);j.setMilliseconds(0);this.setMaxDate(j);}this._bNoStartDateChange=undefined;var Q1=this.getStartDate();if(Q1&&Q1.getTime()<i.getTime()){Q.warning("StartDate < minDate -> StartDate set to minDate",this);Q1=new Date(i.getTime());this.setStartDate(Q1);O1.setPickerText(this._formatPickerText());}}else{this.setProperty("minDate",undefined,true);O1.getAggregation("_calendarPicker").setMinDate();}var R1=new Date();if(i&&R1.getTime()<i.getTime()){this._oTodayButton.setVisible(false);}else if(!j||R1.getTime()<j.getTime()){this._oTodayButton.setVisible(true);}return this;};
g1.prototype.setMaxDate=function(i){if(N(i,this.getMaxDate())){return this;}var j=this.getMinDate(),O1=this._getHeader();if(i){b._checkJSDateObject(i);var P1=i.getFullYear();b._checkYearInValidRange(P1);this.setProperty("maxDate",i,true);this._bNoStartDateChange=true;O1.getAggregation("_calendarPicker").setMaxDate(new Date(i.getTime()));if(j&&j.getTime()>i.getTime()){Q.warning("maxDate < minDate -> maxDate set to begin of the month",this);j=new Date(i.getTime());j.setDate(1);j.setHours(0);j.setMinutes(0);j.setSeconds(0);j.setMilliseconds(0);this.setMinDate(j);}this._bNoStartDateChange=undefined;var Q1=this.getStartDate();if(Q1&&Q1.getTime()>i.getTime()){Q.warning("StartDate > maxDate -> StartDate set to minDate",this);if(j){Q1=new Date(j.getTime());}else{Q1=new Date(1,0,1);Q1.setFullYear(1);}this.setStartDate(Q1);O1.setPickerText(this._formatPickerText());}}else{this.setProperty("maxDate",undefined,true);O1.getAggregation("_calendarPicker").setMaxDate();}var R1=new Date();if(i&&R1.getTime()>i.getTime()){this._oTodayButton.setVisible(false);}else if(!j||R1.getTime()>j.getTime()){this._oTodayButton.setVisible(true);}return this;};
g1.prototype.removeIntervalInstanceFromInfoToolbar=function(){var i=this._oInfoToolbar.getContent();i.forEach(function(j){if(j.isA(m1)){this._oInfoToolbar.removeContent(j);}}.bind(this));};
g1.prototype.setViewKey=function(j){var O1,P1,Q1,R1=this.getViewKey(),S1=this._getHeader(),T1;this.setProperty("viewKey",j,true);this._oIntervalTypeSelect.setSelectedKey(j);this.removeIntervalInstanceFromInfoToolbar();var U1=this.getStartDate();var V1=this.getMinDate();var W1=this.getMaxDate();var X1=this._getView(j,!this._bBeforeRendering);if(!X1){this._bCheckView=true;this.invalidate();}else{var Y1=X1.getIntervalType();var Z1=this._getIntervals(X1);this._bCheckView=false;this._dateNav.setUnit(Y1);this._dateNav.setStep(Z1);this._dateNav.setCurrent(undefined);switch(Y1){case b1.Hour:if(!this._oTimesRow){this._oTimesRow=new T(this.getId()+"-TimesRow",{startDate:new Date(U1.getTime()),items:Z1,legend:this.getLegend()});this._setAriaRole(this._oTimesRow);this._oTimesRow._setLegendControlOrigin(this);this._oTimesRow.attachEvent("focus",this._handleFocus,this);this._oTimesRow.attachEvent("select",this._handleCalendarSelect,this);this._oTimesRow._oPlanningCalendar=this;this._oTimesRow.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(this._oTimesRow.getItems()!==Z1){this._oTimesRow.setItems(Z1);this._dateNav.setStep(Z1);}this._oTimesRow.addAriaLabelledBy(I.getStaticId("sap.m","PC_INTERVAL_TOOLBAR"));this._insertInterval(this._oTimesRow);S1.setAssociation("currentPicker",S1.getAggregation("_calendarPicker"));break;case b1.Day:case b1.Week:case b1.OneMonth:Q1=i1[Y1];O1=this[Q1.sInstanceName];if(!O1){O1=new Q1.oClass(this.getId()+Q1.sIdSuffix,{startDate:new Date(U1.getTime()),days:Z1,showDayNamesLine:this.getShowDayNamesLine(),legend:this.getLegend(),showWeekNumbers:this.getShowWeekNumbers()});this._setAriaRole(O1);O1.attachEvent("select",this._handleCalendarSelect,this);O1.attachEvent("focus",this._handleFocus,this);if(j===Z.OneMonth){O1._setRowsStartDate=this._setRowsStartDate.bind(this);}O1._oPlanningCalendar=this;O1.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(O1.getDays()!==Z1){O1.setDays(Z1);this._dateNav.setStep(Z1);}O1.addAriaLabelledBy(I.getStaticId("sap.m","PC_INTERVAL_TOOLBAR"));this._insertInterval(O1);this[Q1.sInstanceName]=O1;if(Y1===b1.OneMonth){S1.setAssociation("currentPicker",S1.getAggregation("_monthPicker"));}else{S1.setAssociation("currentPicker",S1.getAggregation("_calendarPicker"));}break;case b1.Month:if(!this._oMonthsRow){this._oMonthsRow=new e(this.getId()+"-MonthsRow",{startDate:new Date(U1.getTime()),months:Z1,legend:this.getLegend()});this._setAriaRole(this._oMonthsRow);this._oMonthsRow._setLegendControlOrigin(this);this._oMonthsRow.attachEvent("focus",this._handleFocus,this);this._oMonthsRow.attachEvent("select",this._handleCalendarSelect,this);this._oMonthsRow._oPlanningCalendar=this;this._oMonthsRow.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(this._oMonthsRow.setMonths()!==Z1){this._oMonthsRow.setMonths(Z1);this._dateNav.setStep(Z1);}this._oMonthsRow.addAriaLabelledBy(I.getStaticId("sap.m","PC_INTERVAL_TOOLBAR"));this._insertInterval(this._oMonthsRow);S1.setAssociation("currentPicker",S1.getAggregation("_yearPicker"));break;default:throw new Error("Unknown IntervalType: "+Y1+"; "+this);}var $1=this.getRows();for(var i=0;i<$1.length;i++){var _1=$1[i];var a2=D1(_1);a2.setIntervalType(Y1);a2.setIntervals(Z1);a2.setShowSubIntervals(X1.getShowSubIntervals());}if(this.getDomRef()){this._updateCurrentTimeVisualization(false);q1.call(this,this.getShowWeekNumbers(),this._viewAllowsWeekNumbers(j));r1.call(this,this.getShowDayNamesLine(),!!O1);}this._updatePickerSelection();}if(j===Z.Week||j===Z.OneMonth||j===Z.Month){P1=this.getStartDate();this.setStartDate(new Date(P1.getTime()));if(P1.getTime()!==this.getStartDate().getTime()){this.fireStartDateChange();}}if(this._oOneMonthsRow&&j===Z.OneMonth){this._oOneMonthsRow.setMode(this._iSize);this._adjustSelectedDate(c.fromLocalJSDate(P1));if(this._iSize<2){this._setRowsStartDate(P1);}}else if(this._oOneMonthsRow&&R1===Z.OneMonth&&this._oOneMonthsRow.getSelectedDates().length){T1=this._oOneMonthsRow.getSelectedDates()[0].getStartDate();if(T1){this.setStartDate(T1);}}if(V1){S1.getAggregation("_calendarPicker").setMinDate(new Date(V1.getTime()));}if(W1){S1.getAggregation("_calendarPicker").setMaxDate(new Date(W1.getTime()));}this._updateTodayButtonState();return this;};
g1.prototype._handleFocus=function(i){var j=i.getParameter("date");var O1=i.getParameter("restoreOldDate");if(O1){return;}this.shiftToDate(j,i.getParameter("otherMonth"));};
g1.prototype.shiftToDate=function(i,j){var O1=this._getRowInstanceByViewKey(this.getViewKey()),P1,Q1;this._dateNav.toDate(i);P1=this._dateNav.getStart();Q1=this._dateNav.getCurrent();if(O1&&!(O1.getMode&&O1.getMode()<2&&!j)){this.setStartDate(P1);O1.setStartDate(P1);O1.setDate(Q1);}};
g1.prototype._updatePickerSelection=function(){var i=this._getFirstAndLastRangeDate(),j=this._getHeader().getAssociation("currentPicker"),O1=sap.ui.getCore().byId(j),P1;P1=new f({startDate:new Date(i.oStartDate),endDate:new Date(i.oEndDate)});O1.destroySelectedDates();O1.addSelectedDate(P1);this._getHeader().setPickerText(this._formatPickerText());this._updateTodayButtonState();};
g1.prototype._adjustSelectedDate=function(i,j){var O1=j?b._getFirstDateOfMonth(i):i,P1=O1.toLocalJSDate();if(this._oOneMonthsRow.getMode&&this._oOneMonthsRow.getMode()<2){this._oOneMonthsRow.removeAllSelectedDates();this._oOneMonthsRow.addSelectedDate(new f({startDate:P1}));this._oOneMonthsRow.selectDate(P1);}};
g1.prototype._insertInterval=function(i){if(this._iSizeScreen>1){this._oInfoToolbar.addContent(i);}else{this._oInfoToolbar.insertContent(i,1);}};
g1.prototype._viewAllowsWeekNumbers=function(i){var j=this._getView(i).getIntervalType(),O1=i1[j];return!!O1&&!!O1.oClass.prototype.setShowWeekNumbers;};
g1.prototype._viewAllowsDayNamesLine=function(i){var j=this._getView(i).getIntervalType(),O1=i1[j];return!!O1&&!!O1.oClass.prototype.setShowDayNamesLine;};
g1.prototype._getRowInstanceByViewKey=function(i){var j=this._getView(i).getIntervalType(),O1=i1[j],P1;if(O1){P1=this[O1.sInstanceName];}if(j===b1.Month){P1=this._oMonthsRow;}if(j===b1.Hour){P1=this._oTimesRow;}return P1;};
g1.prototype.setShowWeekNumbers=function(i){this.setProperty("showWeekNumbers",i,true);this._getViews().forEach(function(j){var O1=j.getKey(),P1=this._viewAllowsWeekNumbers(O1),Q1=this._getRowInstanceByViewKey(O1);if(Q1&&P1){Q1.setShowWeekNumbers(i);}if(this.getDomRef()&&this.getViewKey()===O1){q1.call(this,i,P1);}},this);return this;};
g1.prototype.setShowIntervalHeaders=function(j){this.setProperty("showIntervalHeaders",j,true);var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=O1[i];D1(P1).setShowIntervalHeaders(j);}return this;};
g1.prototype.setShowEmptyIntervalHeaders=function(j){this.setProperty("showEmptyIntervalHeaders",j,true);var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=O1[i];D1(P1).setShowEmptyIntervalHeaders(j);}return this;};
g1.prototype.setGroupAppointmentsMode=function(j){this.setProperty("groupAppointmentsMode",j,true);var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=O1[i];D1(P1).setGroupAppointmentsMode(j);}return this;};
g1.prototype.setAppointmentsReducedHeight=function(j){this.setProperty("appointmentsReducedHeight",j,true);var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=O1[i];D1(P1).setAppointmentsReducedHeight(j);}return this;};
g1.prototype.setAppointmentsVisualization=function(j){this.setProperty("appointmentsVisualization",j,true);var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=O1[i];D1(P1).setAppointmentsVisualization(j);}return this;};
g1.prototype.setShowRowHeaders=function(i){this.setProperty("showRowHeaders",i,true);var j=this.getAggregation("table");j.getColumns()[0].setVisible(i);this._toggleAppointmentsColumnPopinState(i);this.$().toggleClass("sapMPlanCalNoHead",!i);L1.call(this);M1.call(this);return this;};
g1.prototype.setShowDayNamesLine=function(i){var j,O1,P1,Q1=!!this.getDomRef(),R1=this.getViewKey();for(j in i1){O1=i1[j].sInstanceName;if(this[O1]){P1=this[O1];P1.setShowDayNamesLine(i);if(Q1&&j===R1){r1.call(this,i,true);}}}return this.setProperty("showDayNamesLine",i,false);};
g1.prototype.setStickyHeader=function(i){if(this.getStickyHeader()===i){return this;}this.setProperty("stickyHeader",i,true);if(l.system.phone){if(i){l.orientation.attachHandler(this._updateStickyHeader,this);}else{l.orientation.detachHandler(this._updateStickyHeader,this);}}this._updateStickyHeader();return this;};
g1.prototype._updateStickyHeader=function(){var i=[],j=this.getStickyHeader(),O1=this.getViewKey()===Z.OneMonth&&this._iSize<2,P1=j&&!l.system.phone&&!O1,Q1=j&&!(l.system.phone&&l.orientation.landscape)&&!O1;if(P1){i.push(V.HeaderToolbar);}if(this._oInfoToolbar&&Q1){i.push(V.InfoToolbar);}this.getAggregation("table").setSticky(i);};
g1.prototype.addRow=function(i){this.addAggregation("rows",i,true);this.getAggregation("table").addItem(this._createPlanningCalendarListItem(i));return this;};
g1.prototype.insertRow=function(i,j){this.insertAggregation("rows",i,j);this.getAggregation("table").insertItem(this._createPlanningCalendarListItem(i),j,true);return this;};
g1.prototype.removeRow=function(i){var j=this.removeAggregation("rows",i,true),O1=this.getAggregation("table");O1.removeItem(B1(j),true);this._handleRowRemoval(j);K1.call(this);M1.call(this);return j;};
g1.prototype.removeAllRows=function(){var i=this.removeAllAggregation("rows",true),j=this.getAggregation("table");j.removeAllItems(true);i.forEach(this._handleRowRemoval,this);K1.call(this);M1.call(this);return i;};
g1.prototype.destroyRows=function(){var i;var j=this.getAggregation("table");j.destroyItems(true);i=this.destroyAggregation("rows");K1.call(this);M1.call(this);return i;};
g1.prototype.setSingleSelection=function(i){this.setProperty("singleSelection",i,true);L1.call(this);M1.call(this);if(i){this.selectAllRows(false);}else{K1.call(this);}this.$().toggleClass("sapMPlanCalMultiSel",!i);return this;};
g1.prototype.setNoDataText=function(i){this.setProperty("noDataText",i,true);var j=this.getAggregation("table");j.setNoDataText(i);return this;};
g1.prototype.setLegend=function(j){this.setAssociation("legend",j,true);var O1=this.getRows(),P1=this.getLegend()&&sap.ui.getCore().byId(this.getLegend()),Q1;for(var i=0;i<O1.length;i++){var R1=O1[i];D1(R1).setLegend(j);}h1.forEach(function(S1){if(this[S1]){this[S1].setLegend(j);}},this);if(P1){Q1=new a(function(S1){this.invalidate();}.bind(this));Q1.observe(P1,{destroy:true});}return this;};
g1.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var j=this.getAggregation("table");j.addAriaLabelledBy(i);return this;};
g1.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var j=this.getAggregation("table");j.removeAriaLabelledBy(i);return this;};
g1.prototype.removeAllAriaLabelledBy=function(){this.removeAllAssociation("ariaLabelledBy",true);var i=this.getAggregation("table");i.removeAllAriaLabelledBy();i.addAriaLabelledBy(this.getId()+"-Descr");return this;};
g1.prototype.invalidate=function(i){var j=i&&i instanceof f;if(!this._bIsBeingDestroyed&&(this._bDateRangeChanged||j)){if(this.getDomRef()){var O1=this.getViewKey();var P1=this._getView(O1);var Q1=P1.getIntervalType();switch(Q1){case b1.Hour:if(this._oTimesRow){this._oTimesRow.invalidate(arguments);}break;case b1.Day:if(this._oDatesRow){this._oDatesRow.invalidate(arguments);}break;case b1.Month:if(this._oMonthsRow){this._oMonthsRow.invalidate(arguments);}break;case b1.OneMonth:if(this._oOneMonthsRow){this._oOneMonthsRow.invalidate(arguments);}break;case b1.Week:if(this._oWeeksRow){this._oWeeksRow.invalidate(arguments);}break;default:throw new Error("Unknown IntervalType: "+Q1+"; "+this);}}this._bDateRangeChanged=undefined;}else{if(i&&i instanceof sap.m.PlanningCalendarView){this._bCheckView=true;}C.prototype.invalidate.apply(this,arguments);}};
g1.prototype.addSpecialDate=function(i){this._bDateRangeChanged=true;return C.prototype.addAggregation.call(this,"specialDates",i);};
g1.prototype.insertSpecialDate=function(i,j){this._bDateRangeChanged=true;return C.prototype.insertAggregation.call(this,"specialDates",i,j);};
g1.prototype.removeSpecialDate=function(i){this._bDateRangeChanged=true;return C.prototype.removeAggregation.call(this,"specialDates",i);};
g1.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;return this.removeAllAggregation("specialDates");};
g1.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;return this.destroyAggregation("specialDates");};
g1.prototype.removeAllViews=function(){this._bCheckView=true;var i=this.removeAllAggregation("views"),j=this.getBuiltInViews();if(j.length){this.setViewKey(j[0]);}else{this.setViewKey(k1[0]);}return i;};
g1.prototype.destroyViews=function(){this._bCheckView=true;var i=this.destroyAggregation("views"),j=this.getBuiltInViews();if(j.length){this.setViewKey(j[0]);}else{this.setViewKey(k1[0]);}return i;};
g1.prototype.getSelectedRows=function(){return this.getRows().filter(function(i){return i.getSelected();});};
g1.prototype.selectAllRows=function(j){var O1=this.getRows();if(!(j&&this.getSingleSelection())){for(var i=0;i<O1.length;i++){var P1=O1[i];P1.setSelected(j);}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.setSelected(j);}}return this;};
g1.prototype.onsaphomemodifiers=function(i){if((i.metaKey||i.ctrlKey)&&!i.altKey&&!i.shiftKey){var j=this.getRows();var O1=j[0];var P1=new U.Event("saphome");P1._bPlanningCalendar=true;D1(O1).onsaphome(P1);i.preventDefault();i.stopPropagation();}};
g1.prototype.onsapendmodifiers=function(i){if((i.metaKey||i.ctrlKey)&&!i.altKey&&!i.shiftKey){var j=this.getRows();var O1=j[j.length-1];var P1=new U.Event("sapend");P1._bPlanningCalendar=true;D1(O1).onsapend(P1);i.preventDefault();i.stopPropagation();}};
g1.prototype.setBuiltInViews=function(i){this.setProperty("builtInViews",i);this.setViewKey(this._getViews()[0].getKey());return this;};
g1.prototype.removeView=function(i){var j=this.removeAggregation("views",i);if(!this.getViews().length){this.setViewKey(this._getViews()[0].getKey());}return j;};
g1.prototype._getIntervals=function(i){var j=0;switch(this._iSize){case 0:j=i.getIntervalsS();break;case 1:j=i.getIntervalsM();break;default:j=i.getIntervalsL();break;}return j;};
g1.prototype._getView=function(j,O1){var P1=this._getViews();var Q1;for(var i=0;i<P1.length;i++){Q1=P1[i];if(Q1.getKey()!=j){Q1=undefined;}else{break;}}if(!Q1&&!O1){throw new Error("PlanningCalendarView with key "+j+"not assigned "+this);}return Q1;};
g1.prototype._changeStartDate=function(i){if(this._bNoStartDateChange){return;}this.setStartDate(new Date(i.getTime()));this._updatePickerSelection();this.fireStartDateChange();};
g1.prototype._updateCurrentTimeVisualization=function(j){if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}if(j){var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=O1[i];D1(P1).updateCurrentTimeVisualization();}}var Q1=new Date();var R1=this.getStartDate();var S1=this.getViewKey();var T1=this._getView(S1);var U1=T1.getIntervalType();var V1=this._getIntervals(T1);var W1=0;var X1=0;var Y1=0;switch(U1){case b1.Hour:W1=60000;X1=R1.getTime()-3600000;Y1=R1.getTime()+V1*3600000;break;case b1.Day:case b1.Week:case b1.OneMonth:W1=1800000;X1=R1.getTime()-3600000;Y1=R1.getTime()+V1*86400000;break;default:W1=-1;break;}if(Q1.getTime()<=Y1&&Q1.getTime()>=X1&&W1>0){this._sUpdateCurrentTime=setTimeout(this['_updateCurrentTimeVisualization'].bind(this,true),W1);}};
function o1(i){this.setViewKey(i.getParameter("item").getKey());this.fireViewChange();}
g1.prototype._handleTodayPress=function(i){var j=new Date(),O1,P1=this.getViewKey();if(P1===Z.OneMonth){O1=b.getFirstDateOfMonth(b._createUniversalUTCDate(j,undefined,true));this._adjustSelectedDate(c.fromLocalJSDate(j),false);j=b._createLocalDate(O1,true);}if(P1===Z.Week){O1=this.getStartDate();j.setHours(O1.getHours());j.setMinutes(O1.getMinutes());j.setSeconds(O1.getSeconds());}this.setStartDate(j);this._dateNav.setCurrent(j);this._updatePickerSelection();this.fireStartDateChange();};
g1.prototype._handleStartDateChange=function(i){var j=i.oSource.getStartDate();if(this._getView(this.getViewKey()).getIntervalType()!==b1.Hour){var O1=this.getStartDate();j.setHours(O1.getHours());j.setMinutes(O1.getMinutes());j.setSeconds(O1.getSeconds());}this._changeStartDate(j);};
g1.prototype._handleDateSelect=function(i){var j=i.oSource.getStartDate();if(this._getView(this.getViewKey()).getIntervalType()===b1.Hour){var O1=this.getStartDate();j.setHours(O1.getHours());j.setMinutes(O1.getMinutes());j.setSeconds(O1.getSeconds());}this._changeStartDate(j);var P1=this.getViewKey(),Q1=this._getView(P1),R1=Q1.getIntervalType(),S1;if(R1==="Hour"){R1="Time";}else if(R1==="Day"){R1="Date";}else if(R1==="One Month"){R1="OneMonth";}S1="_o"+R1+"sRow";if(this[S1]){this[S1].setDate(j);}};
g1.prototype._handleCalendarSelect=function(i){var j=i.getSource().getSelectedDates();if(!j.length){return;}var O1=new Date(j[0].getStartDate());var P1=b._createUniversalUTCDate(O1,undefined,true);var Q1=this.getViewKey();var R1=this._getView(Q1);var S1=R1.getIntervalType();if(S1!==b1.OneMonth||this._iSize>1){j[0].setStartDate();}switch(S1){case b1.Hour:P1.setUTCHours(P1.getUTCHours()+1);break;case b1.Day:case b1.Week:P1.setUTCDate(P1.getUTCDate()+1);break;case b1.OneMonth:if(this._iSize<2){var T1=new Date(O1.getTime());if(b.monthsDiffer(this.getStartDate(),O1)){this.setStartDate(O1);this._getHeader().setPickerText(this._formatPickerText());}this._setRowsStartDate(T1);this._oOneMonthsRow._focusDate(c.fromLocalJSDate(T1),true);}else if(b._isNextMonth(O1,this.getStartDate())){this.shiftToDate(O1);return;}P1.setUTCDate(P1.getUTCDate()+1);break;case b1.Month:P1.setUTCMonth(P1.getUTCMonth()+1);break;default:throw new Error("Unknown IntervalType: "+S1+"; "+this);}P1.setUTCMilliseconds(P1.getUTCMilliseconds()-1);P1=b._createLocalDate(P1,true);this._formatPickerText();this.fireIntervalSelect({startDate:O1,endDate:P1,subInterval:false,row:undefined});};
function p1(i){var j=i.getParameter("startDate");var O1=this.getViewKey();var P1=this._getView(O1);var Q1=P1.getIntervalType();if(Q1===b1.OneMonth&&b._isNextMonth(j,this.getStartDate())){this.shiftToDate(j);return;}var R1=i.getParameter("endDate");var S1=i.getParameter("subInterval");var T1=A1(i.oSource.getParent());this._formatPickerText();this.fireIntervalSelect({startDate:j,endDate:R1,subInterval:S1,row:T1});}
g1.prototype._applyContextualSettings=function(i){return C.prototype._applyContextualSettings.call(this,i||M._defaultContextualSettings);};
function q1(i,j){this.$().toggleClass("sapMPlanCalWithWeekNumbers",i&&j);}
function r1(i,j){this.$().toggleClass("sapMPlanCalWithDayNamesLine",i&&j);}
function s1(j,O1){if(j.size.width<=0){return;}if(Math.abs(this.iWidth-j.size.width)<15){return;}this.iWidth=j.size.width;this._applyContextualSettings({contextualWidth:this.iWidth});var P1=this.getRows();var Q1;var i=0;var R1=this._iSize;F1.call(this,j.size.width);if(R1!=this._iSize){G1.call(this,this._iSize);var S1=this.getViewKey();var T1=this._getView(S1);var U1=T1.getIntervalType();var V1=this._getIntervals(T1);for(i=0;i<P1.length;i++){Q1=P1[i];var W1=D1(Q1);if(V1!=W1.getIntervals()){W1.setIntervals(V1);}else{W1.handleResize();}}switch(U1){case b1.Hour:if(this._oTimesRow&&this._oTimesRow.getItems()!=V1){this._oTimesRow.setItems(V1);this._dateNav.setStep(V1);}break;case b1.Day:if(this._oDatesRow&&this._oDatesRow.getDays()!=V1){this._oDatesRow.setDays(V1);this._dateNav.setStep(V1);}break;case b1.Month:if(this._oMonthsRow&&this._oMonthsRow.getMonths()!=V1){this._oMonthsRow.setMonths(V1);this._dateNav.setStep(V1);}break;case b1.Week:if(this._oWeeksRow&&this._oWeeksRow.getDays()!=V1){this._oWeeksRow.setDays(V1);this._dateNav.setStep(V1);}break;case b1.OneMonth:if(this._oOneMonthsRow&&this._oOneMonthsRow.getDays()!=V1){this._oOneMonthsRow.setDays(V1);this._dateNav.setStep(V1);if(this._iSize>1){this._setRowsStartDate(new Date(this.getStartDate().getTime()));}}break;default:throw new Error("Unknown IntervalType: "+U1+"; "+this);}L1.call(this);}else if(!O1){for(i=0;i<P1.length;i++){Q1=P1[i];D1(Q1).handleResize();}}if(this._oOneMonthsRow){this._oOneMonthsRow.setMode(this._iSize);this._adjustSelectedDate(c.fromLocalJSDate(this.getStartDate()));}if(this.getStickyHeader()){this._updateStickyHeader();}}
function t1(O1){var P1=O1.getParameter("appointment"),Q1=O1.getParameter("multiSelect"),R1=O1.getParameter("appointments"),S1=O1.getParameter("domRefId"),T1,U1,V1,W1,X1,i,j;if(!Q1){U1=this.getRows();for(i=0;i<U1.length;i++){V1=U1[i];if(O1.oSource!=D1(V1)){W1=V1.getAppointments();for(j=0;j<W1.length;j++){X1=W1[j];X1.setSelected(false);}}}}T1={appointment:P1,appointments:R1,multiSelect:Q1,domRefId:S1};this.fireAppointmentSelect(T1);}
g1.prototype._setRowsStartDate=function(j){var O1=this.getRows(),P1,i;for(i=0;i<O1.length;i++){P1=O1[i];D1(P1).setStartDate(j);}};
g1.prototype._toggleAppointmentsColumnPopinState=function(i){var j=this.getAggregation("table"),O1=j.getColumns()[1];O1.setDemandPopin(i);O1.setMinScreenWidth(i?j1:"");};
g1.prototype._getViews=function(){var i=this.getViews(),j=this.getBuiltInViews(),O1,P1=[],Q1=Z,R1=b1;if(!this._oViews){this._oViews={};}if(j.length){P1=j;}else{P1=i.length?[]:k1;}O1=P1.map(function(T1){switch(T1){case Q1.Hour:return this._oViews[Q1.Hour]||(this._oViews[Q1.Hour]=new J(this.getId()+"-HourView",{key:Q1.Hour,intervalType:R1.Hour,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_HOURS"),intervalsS:6,intervalsM:6,intervalsL:12}));case Q1.Day:return this._oViews[Q1.Day]||(this._oViews[Q1.Day]=new J(this.getId()+"-DayView",{key:Q1.Day,intervalType:R1.Day,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_DAYS"),intervalsS:7,intervalsM:7,intervalsL:14}));case Q1.Month:return this._oViews[Q1.Month]||(this._oViews[Q1.Month]=new J(this.getId()+"-MonthView",{key:Q1.Month,intervalType:R1.Month,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_MONTHS"),intervalsS:3,intervalsM:6,intervalsL:12}));case Q1.Week:return this._oViews[Q1.Week]||(this._oViews[Q1.Week]=new J(this.getId()+"-WeekView",{key:Q1.Week,intervalType:R1.Week,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_WEEK"),intervalsS:7,intervalsM:7,intervalsL:7}));case Q1.OneMonth:return this._oViews[Q1.OneMonth]||(this._oViews[Q1.OneMonth]=new J(this.getId()+"-OneMonthView",{key:Q1.OneMonth,intervalType:R1.OneMonth,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_ONE_MONTH"),intervalsS:1,intervalsM:1,intervalsL:31}));default:Q.error("Cannot get PlanningCalendar views. Invalid view key "+T1);break;}},this);for(var S1 in this._oViews){if(P1.indexOf(S1)<0){this._oViews[S1].destroy();delete this._oViews[S1];}}if(i.length){O1=O1.concat(i);}return O1;};
g1.prototype.getSelectedAppointments=function(){var i=[];this.getRows().filter(function(j){i.push.apply(i,D1(j).aSelectedAppointments);});return i;};
g1.prototype.setCustomAppointmentsSorterCallback=function(i){if(typeof i==="function"||i===null||i===undefined){this.getRows().forEach(function(j){D1(j)._setCustomAppointmentsSorterCallback(i);});this._fnCustomSortedAppointments=i;}else{Q.warning("Your custom sort function won't be used, but the old one will be preserved.",this);}return this;};
g1.prototype.getCustomAppointmentsSorterCallback=function(){return this._fnCustomSortedAppointments;};
g1.prototype._onRowDeselectAppointment=function(){var O1=this.getRows();for(var i=0;i<O1.length;i++){var P1=D1(O1[i]).aSelectedAppointments;for(var j=0;j<P1.length;j++){var Q1=sap.ui.getCore().byId(P1[j]);if(Q1){Q1.setProperty("selected",false,true);Q1.$().removeClass("sapUiCalendarAppSel");}}D1(O1[i]).aSelectedAppointments=[];}};
g1.prototype._updateRowTimeline=function(i){var j=D1(i),O1,P1,Q1,R1,S1=this.getViewKey()===Z.OneMonth&&this._iSize<2,T1=this.getStartDate();j.setNonWorkingDays(i.getNonWorkingDays());j.setNonWorkingHours(i.getNonWorkingHours());if(S1&&this._oOneMonthsRow&&this._oOneMonthsRow.getSelectedDates().length){T1=this._oOneMonthsRow.getSelectedDates()[0].getStartDate();}j.setStartDate(T1);j.setShowIntervalHeaders(this.getShowIntervalHeaders());j.setShowEmptyIntervalHeaders(this.getShowEmptyIntervalHeaders());j.setGroupAppointmentsMode(this.getGroupAppointmentsMode());j.setAppointmentsReducedHeight(this.getAppointmentsReducedHeight());j.setLegend(this.getLegend());j.setAppointmentsVisualization(this.getAppointmentsVisualization());j.attachEvent("select",t1,this);j.attachEvent("startDateChange",this._handleStartDateChange,this);j.attachEvent("leaveRow",J1,this);j.attachEvent("intervalSelect",p1,this);K1.call(this);if(N1.call(this)){O1=this.getViewKey();P1=this._getView(O1);Q1=P1.getIntervalType();R1=this._getIntervals(P1);j.setIntervalType(Q1);j.setIntervals(R1);j.setShowSubIntervals(P1.getShowSubIntervals());}M1.call(this);if(this._fnCustomSortedAppointments){j._setCustomAppointmentsSorterCallback(this._fnCustomSortedAppointments);}};
g1.prototype._observeRowChanges=function(i){var j=B1(i),O1=C1(i),P1=D1(i);var Q1={destroy:function(){j.destroy();},change:{title:function(R1){O1.setProperty(R1.name,R1.current);},icon:function(R1){O1.setProperty(R1.name,R1.current);},text:function(R1){P1.toggleStyleClass("sapMPlanCalRowLarge",!!R1.current);O1.setProperty("description",R1.current);},enableAppointmentsDragAndDrop:function(R1){this._enableAppointmentsDragAndDrop(i);}.bind(this),enableAppointmentsResize:function(R1){this._enableAppointmentsResize(i);}.bind(this),enableAppointmentsCreate:function(R1){this._enableAppointmentsCreate(i);}.bind(this),nonWorkingDays:function(R1){P1.setProperty(R1.name,R1.current);},nonWorkingHours:function(R1){P1.setProperty(R1.name,R1.current);},selected:function(R1){K1.call(this);j.setProperty(R1.name,R1.current);}.bind(this),tooltip:function(R1){if(R1.mutation==="insert"){O1.setTooltip(R1.child);}else if(R1.mutation==="remove"){O1.setTooltip();}},intervalHeaders:function(R1){P1.invalidate();},appointments:function(R1){P1.invalidate();}}};new a(function(R1){if(R1.type==="destroy"){Q1.destroy();}else if(Q1.change[R1.name]){Q1.change[R1.name](R1);}}).observe(i,{properties:["icon","text","title","nonWorkingDays","nonWorkingHours","selected","enableAppointmentsDragAndDrop","enableAppointmentsResize","enableAppointmentsCreate"],aggregations:["tooltip","appointments","intervalHeaders","headerContent"],destroy:true});i.invalidate=function(R1){if(!R1||!(R1 instanceof g)){E.prototype.invalidate.apply(this,arguments);}else if(j){P1.invalidate(R1);}};i.applyFocusInfo=function(R1){P1.applyFocusInfo(R1);return this;};};
g1.prototype._createPlanningCalendarListItem=function(i){var j,O1,P1;if(i.getHeaderContent().length||i.getBindingInfo("headerContent")){O1=i._getPlanningCalendarCustomRowHeader();}else{O1=new u1(i.getId()+"-Head",{icon:i.getIcon(),description:i.getText(),title:i.getTitle(),tooltip:i.getTooltip()});}P1=new w1(i.getId()+"-CalRow",{checkResize:false,updateCurrentTime:false,ariaLabelledBy:O1.getId()});P1.getAppointments=function(){return i.getAppointments();};P1.getIntervalHeaders=function(){return i.getIntervalHeaders();};j=new y1(i.getId()+f1,{cells:[O1,P1]});this._updateRowTimeline(i);this._observeRowChanges(i);this._enableAppointmentsDragAndDrop(i);this._enableAppointmentsResize(i);this._enableAppointmentsCreate(i);return j;};
g1.prototype._handleRowRemoval=function(i){var j=D1(i);j.detachEvent("select",t1,this);j.detachEvent("startDateChange",this._handleStartDateChange,this);j.detachEvent("leaveRow",J1,this);j.detachEvent("intervalSelect",p1,this);if(this._fnCustomSortedAppointments){j._fnCustomSortedAppointments=undefined;}B1(i).destroy();};
var u1=A.extend("PlanningCalendarRowHeader",{
renderer:R.extend(F),
TagName:"div"
});
u1.prototype.isSelectable=function(){return false;};
PlanningCalendarRowHeaderRenderer.renderTabIndex=function(i,j){};
PlanningCalendarRowHeaderRenderer.getAriaRole=function(i,j){};
var v1=R.extend(k);
v1.getLegendItems=function(i){var j=[],O1,P1=i.getLegend();if(P1){O1=sap.ui.getCore().byId(P1);if(O1){j=O1.getAppointmentItems?O1.getAppointmentItems():O1.getItems();}else{Q.error("PlanningCalendarLegend with id '"+P1+"' does not exist!",i);}}return j;};
v1.renderBeforeAppointments=function(j,O1){var P1=A1(O1.getParent()),Q1;if(!P1.getEnableAppointmentsDragAndDrop()&&!P1.getEnableAppointmentsResize()&&!P1.getEnableAppointmentsCreate()||O1._isOneMonthsRowOnSmallSizes()){return;}Q1=O1.getAggregation("_intervalPlaceholders");j.write("<div class=\"sapUiCalendarRowAppsOverlay\">");if(Q1){for(var i=0;i<Q1.length;i++){var R1=Q1[i];R1.setWidth(100/Q1.length+"%");j.renderControl(R1);}}j.write("</div>");};
v1.renderResizeHandle=function(i,j,O1){if(!A1(j.getParent()).getEnableAppointmentsResize()||j._isOneMonthsRowOnSmallSizes()||(O1._aAppointments&&O1._aAppointments.length>0)){return;}i.write("<span");i.addClass("sapUiCalendarAppResizeHandle");i.writeClasses();i.write(">");i.write("</span>");};
v1.writeCustomAttributes=function(i,j){if(A1(j.getParent()).getEnableAppointmentsCreate()){i.writeAttribute("draggable","true");}};
v1.renderInterval=function(j,O1,P1,Q1,R1,S1,T1,U1,V1,W1,X1,Y1,Z1){var $1=O1.getIntervalType();if($1===b1.Day||$1===b1.Week||$1===b1.OneMonth){var _1=A1(O1.getParent()),a2=_1.getParent(),b2=function(l2){return l2.getType()===W.NonWorking;},c2=_1.getSpecialDates().filter(b2),d2=a2.getSpecialDates().filter(b2),e2=O1.getStartDate(),f2,g2,h2,i2;if(d2&&c2){f2=d2.concat(c2);}else if(c2){f2=c2;}if(f2&&f2.length){var j2=function(l2){return l2===g2.getDay();};g2=new Date(e2.getTime());g2.setHours(0,0,0);g2.setDate(e2.getDate()+P1);for(var i=0;i<f2.length;i++){if(f2[i].getStartDate()){h2=new Date(f2[i].getStartDate().getTime());}if(f2[i].getEndDate()){i2=new Date(f2[i].getEndDate().getTime());}else{i2=new Date(f2[i].getStartDate().getTime());i2.setHours(23,59,59);}if(g2.getTime()>=h2.getTime()&&g2.getTime()<=i2.getTime()){var k2=S1.some(j2);if(!k2){j.addClass("sapUiCalendarRowAppsNoWork");}}}}}k.renderInterval(j,O1,P1,Q1,R1,S1,T1,U1,V1,W1,X1,Y1,Z1);};
var w1=h.extend("PlanningCalendarRowTimeline",{
metadata:{aggregations:{intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true},_intervalPlaceholders:{type:"IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true},
renderer:v1
});
w1.prototype._updatePlaceholders=function(){var j=this.getProperty("intervals");if(this.getIntervalType()===b1.Hour){j*=2;}this.removeAllAggregation("_intervalPlaceholders");for(var i=0;i<j;i++){this.addAggregation("_intervalPlaceholders",new x1());}};
w1.prototype.onBeforeRendering=function(){h.prototype.onBeforeRendering.call(this);this._updatePlaceholders();};
w1.prototype.onmousedown=function(i){var j=i.target.classList;this._isResizeHandleMouseDownTarget=j.contains("sapUiCalendarAppResizeHandle");this._isRowAppsIntervalMouseDownTarget=j.contains("sapUiCalendarRowAppsInt");};
w1.prototype._isResizingPerformed=function(){return this._isResizeHandleMouseDownTarget;};
w1.prototype._isDraggingPerformed=function(){return!this._isResizeHandleMouseDownTarget&&!this._isRowAppsIntervalMouseDownTarget;};
w1.prototype._isCreatingPerformed=function(){return this._isRowAppsIntervalMouseDownTarget;};
var x1=C.extend("IntervalPlaceholder",{
metadata:{properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}}},
renderer:function(i,j){i.write("<div");i.writeControlData(j);i.addStyle("width",j.getWidth());i.writeStyles();i.addClass("sapUiCalendarRowAppsPlaceholder");i.writeClasses();i.write("></div>");}
});
var y1=x.extend("sap.m.internal.PlanningCalendarRowListItem",{
metadata:{library:"sap.m"},
renderer:y
});
y1.prototype.getHeader=function(){return this.getCells()[0];};
y1.prototype.getTimeline=function(){return this.getCells()[1];};
y1.prototype.getCustomData=function(){return A1(this).getCustomData();};
g1.prototype._getSelectedDates=function(){var i=this.getViewKey(),j=this._getView(i),O1=j.getIntervalType(),P1=i1[O1];return this[P1.sInstanceName].getSelectedDates();};
g1.prototype._enableAppointmentsDragAndDrop=function(i){var j=D1(i),O1;if(i.getEnableAppointmentsDragAndDrop()){O1=i.getDragDropConfig().some(function(P1){return P1.getGroupName()===c1;});if(!O1){this._addDragDropInfo(i,D1(i));}}else{i.getDragDropConfig().forEach(function(P1){if(P1.getGroupName()===c1){i.removeDragDropConfig(P1);}});j.getDragDropConfig().forEach(function(P1){if(P1.getGroupName()===c1){j.removeDragDropConfig(P1);}});}};
g1.prototype._enableAppointmentsResize=function(i){var j=i.getEnableAppointmentsResize(),O1=this._getConfigFromDragDropConfigAggregation(i.getAggregation("dragDropConfig"),d1),P1=this._getResizeConfig(i);if(j&&!O1){i.addAggregation("dragDropConfig",P1,true);}if(!j){i.removeAggregation("dragDropConfig",O1,true);}};
g1.prototype._enableAppointmentsCreate=function(i){var j=i.getEnableAppointmentsCreate(),O1=D1(i),P1=this._getConfigFromDragDropConfigAggregation(O1.getAggregation("dragDropConfig"),e1),Q1=this._getAppointmentsCreateConfig(i);if(j&&!P1){O1.addAggregation("dragDropConfig",Q1,true);}if(!j){O1.removeAggregation("dragDropConfig",P1,true);}};
g1.prototype._addDragDropInfo=function(i,j){i.addDragDropConfig(new o({groupName:c1,sourceAggregation:"appointments",dragStart:function(O1){var P1=function(){var Q1=U(".sapUiCalendarRowAppsOverlay");setTimeout(function(){Q1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);U(document).one("dragend",function(){Q1.removeClass("sapUiCalendarRowAppsOverlayDragging");});};if(j._isOneMonthsRowOnSmallSizes()||!j._isDraggingPerformed()){O1.preventDefault();return;}P1();}}));j.addDragDropConfig(new p({groupName:c1,targetAggregation:"_intervalPlaceholders",dragEnter:function(O1){var P1=O1.getParameter("dragSession"),Q1=P1.getDragControl(),R1=j.getIntervalType(),S1=j.getStartDate(),T1=j.indexOfAggregation("_intervalPlaceholders",P1.getDropControl()),U1=j.getId(),V1,W1=function(){var Y1=U(P1.getIndicator()),Z1=P1.getDropControl().getDomRef().getBoundingClientRect(),$1=sap.ui.getCore().byId(U1).getDomRef().getBoundingClientRect(),_1=P1.getDragControl().$().outerWidth(),a2=sap.ui.getCore().getConfiguration().getRTL(),b2=a2?Math.ceil(Z1.right)-$1.left:$1.right-Math.ceil(Z1.left);Y1.css("min-width",(_1<b2)?_1:b2).css(a2?"border-left-width":"border-right-width",(_1>b2)?"0":"").css("margin-left",a2?-(Y1.outerWidth()-parseFloat(Y1.context.style.width)):"");};if(i.hasListeners("appointmentDragEnter")){if(R1===b1.Hour){V1=this._calcNewHoursAppPos(S1,Q1.getStartDate(),Q1.getEndDate(),T1);}else if(R1===b1.Day||R1===b1.Week||(R1===b1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){V1=this._calcNewDaysAppPos(S1,Q1.getStartDate(),Q1.getEndDate(),T1);}else if(R1===b1.Month){V1=this._calcNewMonthsAppPos(S1,Q1.getStartDate(),Q1.getEndDate(),T1);}var X1=i.fireAppointmentDragEnter({appointment:Q1,startDate:V1.startDate,endDate:V1.endDate,calendarRow:A1(j.getParent())});if(!X1){O1.preventDefault();return;}}else if(D1(Q1.getParent())!==j){O1.preventDefault();return;}if(j.getIntervalType()!==b1.Hour){return;}if(!P1.getIndicator()){setTimeout(W1,0);}else{W1();}}.bind(this),drop:function(O1){var P1=O1.getParameter("dragSession"),Q1=P1.getDragControl(),R1=j.getIntervalType(),S1=j.getStartDate(),T1=j.indexOfAggregation("_intervalPlaceholders",P1.getDropControl()),U1,V1=O1.getParameter("browserEvent"),W1=(V1.metaKey||V1.ctrlKey);if(R1===b1.Hour){U1=this._calcNewHoursAppPos(S1,Q1.getStartDate(),Q1.getEndDate(),T1);}else if(R1===b1.Day||R1===b1.Week||(R1===b1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){U1=this._calcNewDaysAppPos(S1,Q1.getStartDate(),Q1.getEndDate(),T1);}else if(R1===b1.Month){U1=this._calcNewMonthsAppPos(S1,Q1.getStartDate(),Q1.getEndDate(),T1);}j.$().find(".sapUiCalendarRowAppsOverlay").removeClass("sapUiCalendarRowAppsOverlayDragging");if(Q1.getStartDate().getTime()===U1.startDate.getTime()&&Q1.getParent()===A1(j.getParent())){return;}i.fireAppointmentDrop({appointment:Q1,startDate:U1.startDate,endDate:U1.endDate,calendarRow:A1(j.getParent()),copy:W1});}.bind(this)}));};
g1.prototype._calcNewHoursAppPos=function(i,j,O1,P1){var Q1=new Date(i.getFullYear(),i.getMonth(),i.getDate(),i.getHours());Q1=new Date(Q1.getTime()+(P1*30*60*1000));return{startDate:Q1,endDate:new Date(Q1.getTime()+O1.getTime()-j.getTime())};};
g1.prototype._calcNewDaysAppPos=function(i,j,O1,P1){var Q1=new Date(i);Q1.setDate(Q1.getDate()+P1);Q1=new Date(Q1.getFullYear(),Q1.getMonth(),Q1.getDate(),j.getHours(),j.getMinutes(),j.getSeconds());return{startDate:Q1,endDate:new Date(Q1.getTime()+O1.getTime()-j.getTime())};};
g1.prototype._calcNewMonthsAppPos=function(i,j,O1,P1){var Q1=new Date(i);Q1.setMonth(Q1.getMonth()+P1);Q1=new Date(Q1.getFullYear(),Q1.getMonth(),j.getDate(),j.getHours(),j.getMinutes(),j.getSeconds());return{startDate:Q1,endDate:new Date(Q1.getTime()+O1.getTime()-j.getTime())};};
g1.prototype._getResizeConfig=function(i){var j=D1(i),O1=new q({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",targetElement:D1(i),dragStart:function(P1){if(!i.getEnableAppointmentsResize()||j._isOneMonthsRowOnSmallSizes()||!j._isResizingPerformed()){P1.preventDefault();return;}var Q1=P1.getParameter("dragSession"),R1=j.$().find(".sapUiCalendarRowAppsOverlay"),S1=U(Q1.getIndicator()),T1=Q1.getDragControl().$();S1.addClass("sapUiDnDIndicatorHide");setTimeout(function(){R1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);U(document).one("dragend",function(){R1.removeClass("sapUiCalendarRowAppsOverlayDragging");S1.removeClass("sapUiDnDIndicatorHide");T1.css({width:"auto","min-width":"auto","z-index":"auto",opacity:1});});if(!l.browser.msie&&!l.browser.edge){P1.getParameter("browserEvent").dataTransfer.setDragImage(z1(),0,0);}},dragEnter:function(P1){var Q1=P1.getParameter("dragSession"),R1=this.getTargetElement(),S1=function(){var W1=U(Q1.getIndicator());W1.addClass("sapUiDnDIndicatorHide");},T1=Q1.getDropControl().getDomRef().getBoundingClientRect(),U1=sap.ui.getCore().byId(R1).getDomRef().getBoundingClientRect(),V1={width:T1.left+T1.width-(Q1.getDragControl().$().position().left+U1.left),"min-width":Math.min(Q1.getDragControl().$().outerWidth(),Q1.getDropControl().$().outerWidth()),"z-index":1,opacity:0.8};Q1.getDragControl().$().css(V1);if(!Q1.getIndicator()){setTimeout(S1,0);}else{S1();}},drop:function(P1){var j=D1(i),Q1=P1.getParameter("dragSession"),R1=Q1.getDragControl(),S1=j.getIntervalType(),T1=j.getStartDate(),U1=j.indexOfAggregation("_intervalPlaceholders",Q1.getDropControl()),V1;if(S1===b1.Hour){V1=this._calcResizeNewHoursAppPos(T1,R1.getStartDate(),R1.getEndDate(),U1);}else if(S1===b1.Day||S1===b1.Week||(S1===b1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){V1=this._calcResizeNewDaysAppPos(T1,R1.getStartDate(),R1.getEndDate(),U1);}else if(S1===b1.Month){V1=this._calcResizeNewMonthsAppPos(T1,R1.getStartDate(),R1.getEndDate(),U1);}j.$().find(".sapUiCalendarRowAppsOverlay").removeClass("sapUiCalendarRowAppsOverlayDragging");U(Q1.getIndicator()).removeClass("sapUiDnDIndicatorHide");R1.$().css({width:"auto","min-width":"auto","z-index":"auto",opacity:1});if(R1.getEndDate().getTime()===V1.endDate.getTime()){return;}i.fireAppointmentResize({appointment:R1,startDate:V1.startDate,endDate:V1.endDate,calendarRow:i});}.bind(this)});O1.setProperty("groupName",d1);return O1;};
g1.prototype._calcResizeNewHoursAppPos=function(i,j,O1,P1){var Q1=new Date(i.getFullYear(),i.getMonth(),i.getDate(),i.getHours()),R1=30*60*1000;Q1=new Date(Q1.getTime()+((P1+1)*R1));if(Q1.getTime()<=j.getTime()){Q1=new Date(j.getTime()+R1);}return{startDate:j,endDate:Q1};};
g1.prototype._calcResizeNewDaysAppPos=function(i,j,O1,P1){var Q1=new Date(i),R1=Q1.getDate()+P1+1,S1=new Date(Q1.getFullYear(),Q1.getMonth(),Q1.getDate());S1.setDate(R1);if(S1.getTime()<=j.getTime()){R1=j.getDate()+1;}Q1.setDate(R1);Q1=new Date(Q1.getFullYear(),Q1.getMonth(),Q1.getDate());return{startDate:j,endDate:Q1};};
g1.prototype._calcResizeNewMonthsAppPos=function(i,j,O1,P1){var Q1=new Date(i),R1=Q1.getMonth()+P1+1;if(R1<=j.getMonth()){R1=j.getMonth()+1;}Q1.setMonth(R1);Q1=new Date(Q1.getFullYear(),Q1.getMonth(),1);return{startDate:j,endDate:Q1};};
g1.prototype._calcCreateNewAppHours=function(i,j,O1){var P1=30*60*1000,Q1,R1;if(j<=O1){Q1=new Date(i.getTime()+(j*P1));R1=new Date(i.getTime()+((O1+1)*P1));}else{Q1=new Date(i.getTime()+(O1*P1));R1=new Date(i.getTime()+(j*P1));}return{startDate:Q1,endDate:R1};};
g1.prototype._calcCreateNewAppDays=function(i,j,O1){var P1=new Date(i),Q1=new Date(i);if(j<=O1){P1=new Date(i.getFullYear(),i.getMonth(),i.getDate()+j);Q1=new Date(i.getFullYear(),i.getMonth(),i.getDate()+O1+1);}else{P1=new Date(i.getFullYear(),i.getMonth(),i.getDate()+O1);Q1=new Date(i.getFullYear(),i.getMonth(),i.getDate()+j);}return{startDate:P1,endDate:Q1};};
g1.prototype._calcCreateNewAppMonths=function(i,j,O1){var P1=new Date(i),Q1=new Date(i);if(j<=O1){P1=new Date(i.getFullYear(),i.getMonth()+j,1);Q1=new Date(i.getFullYear(),i.getMonth()+O1+1,1);}else{P1=new Date(i.getFullYear(),i.getMonth()+O1,1);Q1=new Date(i.getFullYear(),i.getMonth()+j,1);}return{startDate:P1,endDate:Q1};};
g1.prototype._getConfigFromDragDropConfigAggregation=function(j,O1){var P1=j,Q1=P1&&P1.length;for(var i=0;i<Q1;i++){if(P1[i].getGroupName()===O1){return P1[i];}}return null;};
g1.prototype._getAppointmentsCreateConfig=function(i){var j=D1(i),O1=new q({targetAggregation:"_intervalPlaceholders",dragStart:function(P1){if(!i.getEnableAppointmentsCreate()||j._isOneMonthsRowOnSmallSizes()||!j._isCreatingPerformed()){P1.preventDefault();return;}var Q1=P1.getParameter("dragSession"),R1=j.$().find(".sapUiCalendarRowAppsOverlay"),S1=U(Q1.getIndicator());setTimeout(function(){R1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);U(document).one("dragend",function(){R1.removeClass("sapUiCalendarRowAppsOverlayDragging");S1.html("");S1.removeClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");});if(!l.browser.msie&&!l.browser.edge){P1.getParameter("browserEvent").dataTransfer.setDragImage(z1(),0,0);}},dragEnter:function(P1){var Q1=P1.getParameter("dragSession"),R1=Q1.getDropControl().getDomRef().getBoundingClientRect(),S1=function(){var U1=U(Q1.getIndicator());U1.addClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");};var T1=Q1.getData("text")?parseFloat(Q1.getData("text").split("|")[0]):0;if(T1){if(T1<=R1.left){Q1.setIndicatorConfig({left:T1,width:Math.max((R1.left+R1.width-T1),R1.width)});}else{Q1.setIndicatorConfig({left:R1.left,width:T1-R1.left});}}else{Q1.setData("text",R1.left+"|"+j.indexOfAggregation("_intervalPlaceholders",Q1.getDropControl()));}if(!Q1.getIndicator()){setTimeout(S1,0);}else{S1();}},drop:function(P1){var Q1=P1.getParameter("dragSession"),R1=U(Q1.getIndicator()),S1=j.getIntervalType(),T1=D1(i).getStartDate(),U1=parseInt(Q1.getData("text").split("|")[1]),V1=j.indexOfAggregation("_intervalPlaceholders",Q1.getDropControl()),W1;if(S1===b1.Hour){W1=this._calcCreateNewAppHours(T1,U1,V1);}else if(S1===b1.Day||S1===b1.Week||(S1===b1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){W1=this._calcCreateNewAppDays(T1,U1,V1);}else if(S1===b1.Month){W1=this._calcCreateNewAppMonths(T1,U1,V1);}i.fireAppointmentCreate({startDate:W1.startDate,endDate:W1.endDate,calendarRow:i});R1.html("");R1.removeClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");}.bind(this)});O1.setProperty("groupName",e1);return O1;};
function z1(){var i=U("<span></span>").addClass("sapUiCalAppResizeGhost");i.appendTo(document.body);setTimeout(function(){i.remove();},0);return i.get(0);}
function A1(i){var j=i.getId();return sap.ui.getCore().byId(j.substring(0,j.indexOf(f1)));}
function B1(i){return sap.ui.getCore().byId(i.getId()+f1);}
function C1(i){var j=B1(i);return j?j.getHeader():null;}
function D1(i){var j=B1(i);return j?j.getTimeline():null;}
function E1(j){var O1=[];var P1=this.getRows();for(var i=0;i<P1.length;i++){var Q1=P1[i];var R1=B1(Q1);var S1=R1.getSelected();if(Q1.getSelected()!=S1){Q1.setProperty("selected",S1,true);O1.push(Q1);}}if(!this.getSingleSelection()){K1.call(this);}if(O1.length>0){this.fireRowSelectionChange({rows:O1});}}
function F1(i){if(i<this._iBreakPointTablet){this._iSize=0;}else if(i<this._iBreakPointDesktop){this._iSize=1;}else{this._iSize=2;}if(i<l1.PHONE){this._iSizeScreen=0;}else if(i<l1.TABLET){this._iSizeScreen=1;}else{this._iSizeScreen=2;}}
function G1(j){var O1='sapMSize'+j,P1=this.$(),i,Q1;if(P1){for(i=0;i<3;i++){Q1='sapMSize'+i;if(Q1===O1){P1.addClass(Q1);}else{P1.removeClass(Q1);}}}}
function H1(){var j=this._getViews();this._oIntervalTypeSelect.destroyItems();var i;var O1;for(i=0;i<j.length;i++){var P1=j[i];O1=new z(this.getId()+"-"+i,{key:P1.getKey(),text:P1.getDescription(),tooltip:P1.getTooltip()});this._oIntervalTypeSelect.addItem(O1);}if(this._oIntervalTypeSelect.getItems().length>4){this._getHeader()._convertViewSwitchToSelect();}else{this._getHeader()._convertViewSwitchToSegmentedButton();}this._oIntervalTypeSelect.setVisible(!(j.length===1));}
function I1(i){var j=i.getParameter("selected");var O1=this.getRows();if(j){O1=this.getRows().filter(function(P1){return!P1.getSelected();});}this.selectAllRows(j);this.fireRowSelectionChange({rows:O1});}
function J1(j){var O1=j.oSource;var P1=j.getParameter("type");var Q1=this.getRows();var R1;var S1;var T1;var U1;var i=0;var V1=0;var W1;for(i=0;i<Q1.length;i++){R1=Q1[i];if(D1(R1)==O1){V1=i;break;}}switch(P1){case"sapup":T1=O1.getFocusedAppointment();U1=T1.getStartDate();if(V1>0){V1--;}S1=Q1[V1];D1(S1).focusNearestAppointment(U1);break;case"sapdown":T1=O1.getFocusedAppointment();U1=T1.getStartDate();if(V1<Q1.length-1){V1++;}S1=Q1[V1];D1(S1).focusNearestAppointment(U1);break;case"saphome":if(V1>0){S1=Q1[0];W1=new U.Event(P1);W1._bPlanningCalendar=true;D1(S1).onsaphome(W1);}break;case"sapend":if(V1<Q1.length-1){S1=Q1[Q1.length-1];W1=new U.Event(P1);W1._bPlanningCalendar=true;D1(S1).onsapend(W1);}break;default:break;}}
function K1(){if(this._oSelectAllCheckBox){var i=this.getRows();var j=this.getSelectedRows();if(i.length==j.length&&j.length>0){this._oSelectAllCheckBox.setSelected(true);}else{this._oSelectAllCheckBox.setSelected(false);}}}
function L1(){if(this.getSingleSelection()){if(this._oCalendarHeader.getAllCheckBox()){this._oCalendarHeader.setAllCheckBox();}else if(this._oInfoToolbar.getContent().length>2){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}}else{if(!this._oSelectAllCheckBox){this._oSelectAllCheckBox=new K(this.getId()+"-All",{text:this._oRB.getText("COLUMNSPANEL_SELECT_ALL")});this._oSelectAllCheckBox.attachEvent("select",I1,this);}if(this._iSizeScreen<2||!this.getShowRowHeaders()){var i=this._oInfoToolbar.indexOfContent(this._oSelectAllCheckBox);if(this._iSizeScreen<2){if(i<this._oInfoToolbar.getContent().length-1){this._oInfoToolbar.addContent(this._oSelectAllCheckBox);}}else if(i<0||i>1){if(i>1){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}this._oInfoToolbar.insertContent(this._oSelectAllCheckBox,1);}}else{this._oCalendarHeader.setAllCheckBox(this._oSelectAllCheckBox);}}}
function M1(){var i=this.getAggregation("table");var j=i.getMode();var O1;if(this.getSingleSelection()){if(!this.getShowRowHeaders()&&this.getRows().length==1){O1=X.None;}else{O1=X.SingleSelectMaster;}}else{O1=X.MultiSelect;}if(j!=O1){i.setMode(O1);}}
function N1(){return this._oTimesRow||this._oDatesRow||this._oMonthsRow||this._oWeeksRow||this._oOneMonthsRow;}
return g1;});
sap.ui.predefine('sap/m/PlanningCalendarHeader',['sap/ui/core/Control','./library','./Toolbar','./AssociativeOverflowToolbar','./Button','./AccButton','./Title','./ToolbarSpacer','./SegmentedButton','sap/ui/unified/Calendar','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CustomMonthPicker','sap/ui/unified/calendar/CustomYearPicker','sap/ui/core/format/DateFormat','sap/ui/core/Popup','sap/ui/core/IconPool','sap/ui/core/InvisibleText',"./PlanningCalendarHeaderRenderer"],function(C,l,T,A,B,a,b,c,S,d,e,f,g,D,P,I,h,j){"use strict";var k=l.ToolbarDesign;
var m=C.extend("sap.m.PlanningCalendarHeader",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:""},startDate:{type:"object",group:"Data"},pickerText:{type:"string",group:"Data"}},aggregations:{actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action"},_actionsToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_navigationToolbar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},_calendarPicker:{type:"sap.ui.unified.Calendar",multiple:false,visibility:"hidden"},_monthPicker:{type:"sap.ui.unified.internal.CustomMonthPicker",multiple:false,visibility:"hidden"},_yearPicker:{type:"sap.ui.unified.internal.CustomYearPicker",multiple:false,visibility:"hidden"}},events:{pressPrevious:{},pressToday:{},pressNext:{},dateSelect:{},cancel:{},viewChange:{}},associations:{currentPicker:{type:"sap.ui.core.Control",multiple:false}}}});
var R=3;
m.prototype.init=function(){var o=this.getId(),n=o+"-NavToolbar",r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),p,N,i,q,M,y;this.setAggregation("_actionsToolbar",new A(o+"-ActionsToolbar",{design:k.Transparent}).addStyleClass("sapMPCHeadActionsToolbar").addContent(this._getOrCreateTitleControl()).addContent(this._getOrCreateToolbarSpacer()).addContent(this._getOrCreateViewSwitch()));p=new B(n+"-PrevBtn",{icon:I.getIconURI('slim-arrow-left'),tooltip:r.getText("PCH_NAVIGATE_BACKWARDS"),press:function(){this.firePressPrevious();}.bind(this)});this._oTodayBtn=new B(n+"-TodayBtn",{text:r.getText("PLANNINGCALENDAR_TODAY"),ariaLabelledBy:h.getStaticId("sap.m","PCH_NAVIGATE_TO_TODAY"),press:function(){this.firePressToday();}.bind(this)});N=new B(n+"-NextBtn",{icon:I.getIconURI('slim-arrow-right'),tooltip:r.getText("PCH_NAVIGATE_FORWARD"),press:function(){this.firePressNext();}.bind(this)});q=new d(o+"-Cal",{ariaLabelledBy:h.getStaticId("sap.ui.unified","CALENDAR_DIALOG")});q.attachEvent("select",this._handlePickerDateSelect,this);q.attachEvent("cancel",this._handlePickerCancelEvent,this);this.setAggregation("_calendarPicker",q);this.setAssociation("currentPicker",q);M=new f(o+"-MonthCal",{ariaLabelledBy:h.getStaticId("sap.ui.unified","CALENDAR_DIALOG")});M.attachEvent("select",this._handlePickerDateSelect,this);M.attachEvent("cancel",this._handlePickerCancelEvent,this);this.setAggregation("_monthPicker",M);y=new g(o+"-YearCal",{ariaLabelledBy:h.getStaticId("sap.ui.unified","CALENDAR_DIALOG")});y.attachEvent("select",this._handlePickerDateSelect,this);y.attachEvent("cancel",this._handlePickerCancelEvent,this);this.setAggregation("_yearPicker",y);this._oPickerBtn=new a(n+"-PickerBtn",{text:this.getPickerText(),ariaHaspopup:"dialog",ariaLabelledBy:h.getStaticId("sap.m","PCH_SELECT_RANGE"),press:function(){var s=this.getStartDate()||new Date(),t=this.getAssociation("currentPicker");i=sap.ui.getCore().byId(t);i.displayDate(s);this._openCalendarPickerPopup(i);}.bind(this)});this.setAggregation("_navigationToolbar",new T(n,{design:k.Transparent,content:[p,this._oTodayBtn,N,this._oPickerBtn]}).addStyleClass("sapMPCHeadNavToolbar"));};
m.prototype.exit=function(){this._getActionsToolbar().removeAllContent();if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oToolbarSpacer){this._oToolbarSpacer.destroy();this._oToolbarSpacer=null;}if(this._oViewSwitch){this._oViewSwitch.destroy();this._oViewSwitch=null;}if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}};
m.prototype.onBeforeRendering=function(){var v=!!this.getActions().length||!!this.getTitle()||this._getOrCreateViewSwitch().getItems().length>1;this._getActionsToolbar().setProperty("visible",v,true);};
m.prototype.setTitle=function(t){this._getOrCreateTitleControl().setText(t).setVisible(!!t);return this.setProperty("title",t);};
m.prototype.addAction=function(o){if(!o){return this;}this._getActionsToolbar().addContent(o);return this.addAggregation("actions",o);};
m.prototype.insertAction=function(o,i){if(!o){return this;}this._getActionsToolbar().insertContent(o,i+R);return this.insertAggregation("actions",o,i);};
m.prototype.removeAction=function(o){if(!o){return this;}this._getActionsToolbar().removeContent(o);return this.removeAggregation("actions",o);};
m.prototype.removeAllActions=function(){var o=this._getActionsToolbar(),n=o.getContent();for(var i=R;i<n.length;i++){o.removeContent(n[i]);}return this.removeAllAggregation("actions");};
m.prototype.destroyActions=function(){var o=this._getActionsToolbar(),n=o.getContent(),r;for(var i=R;i<n.length;i++){r=o.removeContent(n[i]);r.destroy();}return this;};
m.prototype.setPickerText=function(t){this.setProperty("pickerText",t);this._oPickerBtn.setText(t);return this;};
m.prototype._getOrCreateTitleControl=function(){if(!this._oTitle){this._oTitle=new b(this.getId()+"-Title",{visible:false});}return this._oTitle;};
m.prototype._getOrCreateToolbarSpacer=function(){if(!this._oToolbarSpacer){this._oToolbarSpacer=new c(this.getId()+"-Spacer");}return this._oToolbarSpacer;};
m.prototype._getOrCreateViewSwitch=function(){if(!this._oViewSwitch){this._oViewSwitch=new S(this.getId()+"-ViewSwitch");this._oViewSwitch.attachEvent("selectionChange",this._handleViewSwitchChange,this);this.addDependent(this._oViewSwitch);}return this._oViewSwitch;};
m.prototype._convertViewSwitchToSelect=function(){this._oViewSwitch._toSelectMode();};
m.prototype._convertViewSwitchToSegmentedButton=function(){this._oViewSwitch._toNormalMode();};
m.prototype._getTodayButton=function(){return this._oTodayBtn;};
m.prototype._handlePickerDateSelect=function(){var s=this.getAssociation("currentPicker"),p=sap.ui.getCore().byId(s),o=p.getSelectedDates()[0].getStartDate();this.setStartDate(o);this._closeCalendarPickerPopup();this.fireDateSelect();};
m.prototype._handleViewSwitchChange=function(){this.fireViewChange();};
m.prototype._openCalendarPickerPopup=function(p){var i;if(!this._oPopup){this._oPopup=this._createPopup();}this._oPopup.setContent(p);i=P.Dock;this._oPopup.open(0,i.CenterTop,i.CenterTop,this._oPickerBtn,null,"flipfit",true);};
m.prototype._createPopup=function(){var p=new P();p.setAutoClose(true);p.setDurations(0,0);p.onsapescape=function(E){this.onsapescape(E);}.bind(this);return p;};
m.prototype.onsapescape=function(){if(this._oPopup){this._closeCalendarPickerPopup();if(this._oPickerBtn.getDomRef()){this._oPickerBtn.getDomRef().focus();}}};
m.prototype._closeCalendarPickerPopup=function(){if(this._oPopup&&this._oPopup.isOpen()){this._oPopup.close();}};
m.prototype._handlePickerCancelEvent=function(){var p=this._oPickerBtn.getDomRef();this.fireCancel();p&&p.focus();};
m.prototype._getActionsToolbar=function(){return this.getAggregation("_actionsToolbar");};
m.prototype._getNavigationToolbar=function(){return this.getAggregation("_navigationToolbar");};
return m;});
sap.ui.predefine('sap/m/PlanningCalendarHeaderRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,h){var a=h.getAggregation("_actionsToolbar"),n=h.getAggregation("_navigationToolbar");r.openStart("div",h);r.class("sapMPCHead");r.openEnd();if(a){r.renderControl(a);}if(n){r.renderControl(n);}r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarLegend',['sap/ui/unified/CalendarLegend','sap/ui/unified/CalendarAppointment','./PlanningCalendarLegendRenderer'],function(C,a,P){"use strict";
var b=C.extend("sap.m.PlanningCalendarLegend",{metadata:{library:"sap.m",properties:{itemsHeader:{type:"string",group:"Appearance",defaultValue:"Calendar"},appointmentItemsHeader:{type:"string",group:"Appearance",defaultValue:"Appointments"}},aggregations:{appointmentItems:{type:"sap.ui.unified.CalendarLegendItem",multiple:true,singularName:"appointmentItem"}},designtime:"sap/m/designtime/PlanningCalendarLegend.designtime"}});
b._COLUMN_WIDTH_DEFAULT="auto";
b.prototype.init=function(){C.prototype.init.call(this);this.setProperty("columnWidth",b._COLUMN_WIDTH_DEFAULT);this.addStyleClass("sapMPlanCalLegend");};
b.prototype.setColumnWidth=function(w){if(w==undefined){w=b._COLUMN_WIDTH_DEFAULT;}return this.setProperty("columnWidth",w);};
b.findLegendItemForItem=function(l,s){var L=l?l.getAppointmentItems():null,c=l?l.getItems():null,A=s instanceof a,I=A?L:c,o=A?s.getType():s.type,d,e,i;if(I&&I.length){for(i=0;i<I.length;i++){d=I[i];if(d.getType()===o){e=d.getText();break;}}}if(!e){e=o;}return e;};
return b;});
sap.ui.predefine('sap/m/PlanningCalendarLegendRenderer',['sap/ui/unified/CalendarLegendRenderer','sap/ui/core/Renderer'],function(C,R){"use strict";var P=R.extend(C);
P.renderItemsHeader=function(r,l){var i=l.getItemsHeader();if(i&&(l.getItems().length||l.getStandardItems().length)){this._renderItemsHeader(r,i);}};
P.renderAppointmentsItemsHeader=function(r,l){var a=l.getAppointmentItemsHeader();if(a&&l.getAppointmentItems().length){this._renderItemsHeader(r,a);}else if(l.getAppointmentItems().length&&(l.getItems().length||l.getStandardItems().length)){r.write("<hr/>");}};
P._renderItemsHeader=function(r,h){r.write("<div class='sapMPlanCalLegendHeader'>");r.writeEscaped(h);r.write("</div><hr/>");};
P.renderAdditionalContent=function(r,l){var a=l.getAppointmentItems(),i,c;this.renderAppointmentsItemsHeader(r,l);r.write("<div");r.addClass("sapUiUnifiedLegendItems");r.writeClasses();c=l.getColumnWidth();r.writeAttribute("style","column-width:"+c+";-moz-column-width:"+c+";-webkit-column-width:"+c+";");r.writeStyles();r.write(">");for(i=0;i<a.length;i++){this.renderLegendItem(r,"sapUiCalLegDayType"+l._getItemType(a[i],a).slice(4),a[i],["sapUiUnifiedLegendSquareColor","sapMPlanCalLegendAppCircle"]);}r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRenderer',["sap/ui/core/InvisibleText"],function(I){"use strict";var P={};
P.render=function(r,p){var i=p.getId();var t=p.getTooltip_AsString();var h=p._getHeader();r.write("<div");r.writeControlData(p);r.writeAccessibilityState({role:"region",labelledby:I.getStaticId("sap.m","PLANNINGCALENDAR")});r.addClass("sapMPlanCal");if(p._iSize!==undefined&&p._iSize!==null){r.addClass("sapMSize"+p._iSize);}if(!p.getSingleSelection()){r.addClass("sapMPlanCalMultiSel");}if(!p.getShowRowHeaders()){r.addClass("sapMPlanCalNoHead");}if(p.getShowWeekNumbers()&&p._viewAllowsWeekNumbers(p.getViewKey())){r.addClass("sapMPlanCalWithWeekNumbers");}if(p.getShowDayNamesLine()&&p._viewAllowsDayNamesLine(p.getViewKey())){r.addClass("sapMPlanCalWithDayNamesLine");}if(t){r.writeAttributeEscaped('title',t);}var w=p.getWidth();if(w){r.addStyle("width",w);}var H=p.getHeight();if(H){r.addStyle("height",H);}r.writeAccessibilityState(p);r.writeClasses();r.writeStyles();r.write(">");r.renderControl(h);var T=p.getAggregation("table");r.renderControl(T);var a=p._oRB.getText("PLANNINGCALENDAR");r.write("<span id=\""+i+"-Descr\" class=\"sapUiInvisibleText\">"+a+"</span>");a=p._oRB.getText("PLANNINGCALENDAR_VIEW");r.write("<span id=\""+i+"-SelDescr\" class=\"sapUiInvisibleText\">"+a+"</span>");r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRow',['sap/ui/core/Element','sap/m/CustomListItem'],function(E,C){"use strict";
var P=E.extend("sap.m.PlanningCalendarRow",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data"},text:{type:"string",group:"Data"},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},nonWorkingDays:{type:"int[]",group:"Misc",defaultValue:null},nonWorkingHours:{type:"int[]",group:"Misc",defaultValue:null},selected:{type:"boolean",group:"Data",defaultValue:false},key:{type:"string",group:"Data",defaultValue:null},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"intervalHeader"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent",forwarding:{getter:"_getPlanningCalendarCustomRowHeader",aggregation:"content"},forwardBinding:true}},events:{appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"},copy:{type:"boolean"}}},appointmentDragEnter:{allowPreventDefault:true,parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"}}}}}});
P.prototype.exit=function(){if(this.oRowHeader){this.oRowHeader.destroy();}};
P.prototype._getPlanningCalendarCustomRowHeader=function(){if(!this.oRowHeader){this.oRowHeader=new C(this.getId()+"-CustomHead");}return this.oRowHeader;};
return P;});
sap.ui.predefine('sap/m/PlanningCalendarView',['sap/ui/core/Element','./library','sap/ui/unified/library'],function(E,l,u){"use strict";var C=u.CalendarIntervalType;
var P=E.extend("sap.m.PlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},intervalType:{type:"sap.ui.unified.CalendarIntervalType",group:"Appearance",defaultValue:C.Hour},description:{type:"string",group:"Data"},intervalsS:{type:"int",group:"Appearance",defaultValue:6},intervalsM:{type:"int",group:"Appearance",defaultValue:8},intervalsL:{type:"int",group:"Appearance",defaultValue:12},showSubIntervals:{type:"boolean",group:"Appearance",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/Popover',['./Bar','./Button','./InstanceManager','./library','./Title','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/Popup','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/theming/Parameters','sap/ui/Device','sap/ui/base/ManagedObject',"sap/ui/core/util/ResponsivePaddingsEnablement",'sap/ui/core/library','sap/ui/core/Element','sap/ui/core/ResizeHandler','./PopoverRenderer',"sap/ui/dom/containsOrEquals","sap/ui/thirdparty/jquery","sap/ui/dom/getScrollbarSize","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/dom/jquery/Focusable","sap/ui/dom/jquery/rect","sap/ui/dom/jquery/control"],function(B,a,I,l,T,b,C,P,S,c,D,M,R,d,E,f,g,h,q,i,K,L){"use strict";var j=l.PopupHelper;var O=d.OpenState;var k=l.PlacementType;var m=l.TitleAlignment;var s=20;
var n=C.extend("sap.m.Popover",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Behavior",defaultValue:k.Right},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},title:{type:"string",group:"Appearance",defaultValue:null},modal:{type:"boolean",group:"Behavior",defaultValue:false},offsetX:{type:"int",group:"Appearance",defaultValue:0},offsetY:{type:"int",group:"Appearance",defaultValue:0},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentMinWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:""},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enableScrolling:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},bounce:{type:"boolean",group:"Behavior",defaultValue:null},resizable:{type:"boolean",group:"Dimension",defaultValue:false},ariaModal:{type:"boolean",group:"Misc",defaultValue:true,visibility:"hidden"},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:m.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.ui.core.Control",multiple:false},subHeader:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},beginButton:{type:"sap.ui.core.Control",multiple:false},endButton:{type:"sap.ui.core.Control",multiple:false}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}}},designtime:"sap/m/designtime/Popover.designtime"}});
n._bIOS7=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";R.call(n.prototype,{header:{suffix:"intHeader"},subHeader:{selector:".sapMPopoverSubHeader .sapMIBar"},content:{suffix:"cont"},footer:{selector:".sapMPopoverFooter .sapMIBar"}});
n.prototype.init=function(){this._arrowOffsetThreshold=4;this._marginTopInit=false;this._marginTop=48;this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._minDimensions={width:100,height:32};this._$window=q(window);this._initialWindowDimensions={};this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setAutoClose(true);this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this._placements=[k.Top,k.Right,k.Bottom,k.Left,k.Vertical,k.Horizontal,k.Auto,k.VerticalPreferedTop,k.VerticalPreferedBottom,k.HorizontalPreferedLeft,k.HorizontalPreferedRight,k.VerticalPreferredTop,k.VerticalPreferredBottom,k.HorizontalPreferredLeft,k.HorizontalPreferredRight,k.PreferredRightOrFlip,k.PreferredLeftOrFlip,k.PreferredTopOrFlip,k.PreferredBottomOrFlip];this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];this._offsets=["0 -18","18 0","0 18","-18 0"];this._arrowOffset=18;this._followOfTolerance=32;this._scrollContentList=["sap.m.NavContainer","sap.m.Page","sap.m.ScrollContainer","sap.m.SimpleFixFlex"];this._fnAdjustPositionAndArrow=q.proxy(this._adjustPositionAndArrow,this);this._fnOrientationChange=q.proxy(this._onOrientationChange,this);this._fnFollowOf=q.proxy(function(e){var o=e.lastOfRect,r=e.currentOfRect;if(!D.system.desktop||(Math.abs(o.top-r.top)<=this._followOfTolerance&&Math.abs(o.left-r.left)<=this._followOfTolerance)||(Math.abs(o.top+o.height-r.top-r.height)<=this._followOfTolerance&&Math.abs(o.left+o.width-r.left-r.width)<=this._followOfTolerance)){this.oPopup._applyPosition(this.oPopup._oLastPosition,true);}else{this.close();}},this);this.setFollowOf(true);this._initResponsivePaddingsEnablement();this._oRestoreFocusDelegate={onBeforeRendering:function(){var A=q(document.activeElement),o=A.control(0);this._sFocusControlId=o&&o.getId();},onAfterRendering:function(){if(this._sFocusControlId&&!h(this.getDomRef(),document.activeElement)){sap.ui.getCore().byId(this._sFocusControlId).focus();}}};var t=this;this.oPopup._applyPosition=function(p,F){var e=this.getOpenState(),o;if(e===O.CLOSING||e===O.CLOSED){return;}if(F){t._storeScrollPosition();}t._clearCSSStyles();var r=t._placements.indexOf(t.getPlacement());if(r>3&&!t._bPosCalced){t._calcPlacement();return;}t._bPosCalced=false;if(t._oOpenBy instanceof E){p.of=t._getOpenByDomRef();}if(!p.of){L.warning("sap.m.Popover: in function applyPosition, the openBy element doesn't have any DOM output. "+t);return;}if(!h(document.documentElement,p.of)&&p.of.id){o=q(document.getElementById(p.of.id));if(o){p.of=o;}else{L.warning("sap.m.Popover: in function applyPosition, the openBy element's DOM is already detached from DOM tree and can't be found again by the same id. "+t);return;}}var u=q(p.of).rect();if(F&&t._$window.height()==t._initialWindowDimensions.height&&(u.top+u.height<=0||u.top>=t._$window.height()||u.left+u.width<=0||u.left>=t._$window.width())){t.close();return;}var v=t.getDomRef("scroll");if(!D.system.desktop){q(window).scrollLeft(0);}t._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,p);t._fnAdjustPositionAndArrow();t._restoreScrollPosition();t._registerContentResizeHandler(v);};this.oPopup.close=function(e){var o=typeof e==="boolean";var p=t.oPopup.getOpenState();if(e!==true&&(this.touchEnabled||!this._isFocusInsidePopup())&&this.isOpen()&&!(p===O.CLOSED||p===O.CLOSING)){t.fireBeforeClose({openBy:t._oOpenBy});}t._deregisterContentResizeHandler();P.prototype.close.apply(this,o?[]:arguments);t.removeDelegate(t._oRestoreFocusDelegate);};};
n.prototype.onBeforeRendering=function(){var N,p;if(!this._initialWindowDimensions.width||!this._initialWindowDimensions.height){this._initialWindowDimensions={width:this._$window.width(),height:this._$window.height()};}if(!this.getHorizontalScrolling()&&!this.getVerticalScrolling()){this._forceDisableScrolling=true;}else if(!this._bVScrollingEnabled&&!this._bHScrollingEnabled&&this._hasSingleScrollableContent()){this._forceDisableScrolling=true;L.info("VerticalScrolling and horizontalScrolling in sap.m.Popover with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else{this._forceDisableScrolling=false;}if(!this._forceDisableScrolling){if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:this.getHorizontalScrolling(),vertical:this.getVerticalScrolling()});}}if(this._bContentChanged){this._bContentChanged=false;N=this._getSingleNavContent();p=this._getSinglePageContent();if(N&&!this.getModal()&&!D.system.phone&&!q.sap.simulateMobileOnDesktop){N.attachEvent("afterNavigate",function(e){var o=this.getDomRef();if(o){var F=this.$().firstFocusableDomRef()||o;F.focus();}},this);}if(N||p){p=p||N.getCurrentPage();if(p&&p._getAnyHeader){this.addStyleClass("sapMPopoverWithHeaderCont");}if(N){N.attachEvent("navigate",function(e){var o=e.getParameter("to");if(o instanceof C&&o.isA("sap.m.Page")){this.$().toggleClass("sapMPopoverWithHeaderCont",!!o._getAnyHeader());}},this);}}}};
n.prototype.onAfterRendering=function(){var $,e,o;if(!this._marginTopInit&&this.getShowArrow()){this._marginTop=2;if(this._oOpenBy){$=q(this._getOpenByDomRef());if(!($.closest("header.sapMIBar").length>0)){e=$.closest(".sapMPage");if(e.length>0){o=e.children("header.sapMIBar");if(o.length>0){this._marginTop+=o.outerHeight();}}}this._marginTopInit=true;}}};
n.prototype.exit=function(){this._deregisterContentResizeHandler();D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);this.removeDelegate(this._oRestoreFocusDelegate);this._oRestoreFocusDelegate=null;if(this.oPopup){this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._internalHeader){this._internalHeader.destroy();this._internalHeader=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}};
n.prototype.openBy=function(o,e){var p=this.oPopup,r=this.oPopup.getOpenState(),F=this._getInitialFocusId(),t,u,v,w;t=(o.getDomRef&&o.getDomRef())||o;w=q(t).closest(".sapUiSizeCompact");v=c.get("_sap_m_Popover_ForceCompactArrowOffset")==="true";this._bSizeCompact=l._bSizeCompact||!!w.length||this.hasStyleClass("sapUiSizeCompact");this._bUseCompactArrow=this._bSizeCompact||v;this._adaptPositionParams();if(r===O.OPEN||r===O.OPENING){if(this._oOpenBy===o){return this;}else{var x=function(){p.detachClosed(x,this);this.openBy(o);};p.attachClosed(x,this);this.close();return this;}}if(!o){return this;}if(D.support.touch){D.resize.attachHandler(this._fnOrientationChange);}if(!this._oOpenBy||o!==this._oOpenBy){this._oOpenBy=o;}this.fireBeforeOpen({openBy:this._oOpenBy});p.attachOpened(this._handleOpened,this);p.attachClosed(this._handleClosed,this);p.setInitialFocusId(F);u=this._placements.indexOf(this.getPlacement());if(u>-1){t=this._getOpenByDomRef();if(!t){L.error("sap.m.Popover id = "+this.getId()+": is opened by a control which isn't rendered yet.");return this;}p.setAutoCloseAreas([o]);p.setContent(this);if(u<=3){p.setPosition(this._myPositions[u],this._atPositions[u],t,this._calcOffset(this._offsets[u]),"fit");}else{p._oPosition.of=t;}var y=this;var z=function(){if(p.bIsDestroyed){return;}if(p.getOpenState()===O.CLOSING){if(y._sOpenTimeout){clearTimeout(y._sOpenTimeout);y._sOpenTimeout=null;}y._sOpenTimeout=setTimeout(z,150);}else{y._oPreviousFocus=P.getCurrentFocusInfo();p.open();y.addDelegate(y._oRestoreFocusDelegate,y);if(!e){I.addPopoverInstance(y);}}};z();}else{L.error(this.getPlacement()+"is not a valid value! It can only be top, right, bottom or left");}return this;};
n.prototype.close=function(){var e=this.oPopup.getOpenState(),o,A;if(e===O.CLOSED||e===O.CLOSING){return this;}this.fireBeforeClose({openBy:this._oOpenBy});this.oPopup.close(true);if(this._oPreviousFocus){A=document.activeElement||{};o=(this._oPreviousFocus.sFocusId===sap.ui.getCore().getCurrentFocusedControlId())||(this._oPreviousFocus.sFocusId===A.id);if(!o){P.applyFocusInfo(this._oPreviousFocus);this._oPreviousFocus=null;}}return this;};
n.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen();};
n.prototype.setFollowOf=function(v){if(v){this.oPopup.setFollowOf(this._fnFollowOf);}else{this.oPopup.setFollowOf(false);}return this;};
n.prototype._clearCSSStyles=function(){var o=this.getDomRef().style,$=this.$("cont"),e=$.children(".sapMPopoverScroll"),p=$[0].style,r=e[0].style,t=this.getContentWidth(),u=this.getContentHeight(),v=this.$("arrow"),w,W;if(t.indexOf("%")>0){w=this._$window.width();t=j.calcPercentageSize(t,w);}if(u.indexOf("%")>0){W=this._$window.height();u=j.calcPercentageSize(u,W);}p.width=t||"";p.height=u||"";p.maxWidth="";p.maxHeight="";o.left="";o.right="";o.top="";o.bottom="";o.width="";o.height="";o.overflow="";r.width="";r.display="";v.removeClass("sapMPopoverArrRight sapMPopoverArrLeft sapMPopoverArrDown sapMPopoverArrUp sapMPopoverCrossArr sapMPopoverFooterAlignArr sapMPopoverHeaderAlignArr sapContrast sapContrastPlus");v.css({left:"",top:""});};
n.prototype._onOrientationChange=function(){var e=this.oPopup.getOpenState();if(!(e===O.OPEN||e===O.OPENING)){return;}this.oPopup._applyPosition(this.oPopup._oLastPosition,true);this._includeScrollWidth();};
n.prototype._includeScrollWidth=function(){var e=this.getContentWidth(),$=this.$(),o=Math.floor(window.innerWidth*0.9),p=this.$('cont');if(!p[0]){return;}if(D.system.desktop&&!D.browser.chrome){var H=p[0].clientHeight<p[0].scrollHeight;if(H&&(!e||e==='auto')&&p.width()<o){$.addClass("sapMPopoverVerticalScrollIncluded");p.css({"padding-right":s});}else{$.removeClass("sapMPopoverVerticalScrollIncluded");p.css({"padding-right":""});}}};
n.prototype._handleOpened=function(){var t=this;this.oPopup.detachOpened(this._handleOpened,this);if(!D.support.touch){setTimeout(function(){!t.bIsDestroyed&&D.resize.attachHandler(t._fnOrientationChange);},0);}var F=this._getInitialFocusId(),o=sap.ui.getCore().byId(F),e=(F?window.document.getElementById(F):null);if(o&&o.getFocusDomRef()){o.getFocusDomRef().focus();}else if(!o&&e){e.focus();}this.fireAfterOpen({openBy:this._oOpenBy});};
n.prototype._handleClosed=function(){this.oPopup.detachClosed(this._handleClosed,this);D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);if(!this.oPopup._bModal&&!D.system.desktop&&document.activeElement&&!q(document.activeElement).is(":visible")){document.activeElement.blur();}this.fireAfterClose({openBy:this._oOpenBy});};
n.prototype.onfocusin=function(e){var o=e.target,$=this.$();if(o.id===this.getId()+"-firstfe"){var p=$.lastFocusableDomRef();if(p){p.focus();}}else if(o.id===this.getId()+"-lastfe"){var F=$.firstFocusableDomRef();if(F){F.focus();}}};
n.prototype.onkeydown=function(e){var o=K,p=e.which||e.keyCode,A=e.altKey;if(p===o.ESCAPE||(A&&p===o.F4)){if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this.close();e.stopPropagation();e.preventDefault();}};
n.prototype.onmousedown=function(o){var r=sap.ui.getCore().getConfiguration().getRTL();if(!o.target.classList.contains("sapMPopoverResizeHandle")){return;}var $=q(document);var p=this.$();var t=this;p.addClass('sapMPopoverResizing');o.preventDefault();o.stopPropagation();var u={x:o.pageX,y:o.pageY,width:p.width(),height:p.height()};$.on("mousemove.sapMPopover",function(e){var w,v;if(r){w=u.width+u.x-e.pageX;v=u.height+(u.y-e.pageY);}else{w=u.width+e.pageX-u.x;v=u.height+(u.y-e.pageY);}t.setContentWidth(Math.max(w,t._minDimensions.width)+'px');t.setContentHeight(Math.max(v,t._minDimensions.height)+'px');});$.on("mouseup.sapMPopover",function(){p.removeClass("sapMPopoverResizing");$.off("mouseup.sapMPopover, mousemove.sapMPopover");});};
n.prototype._hasSingleNavContent=function(){return!!this._getSingleNavContent();};
n.prototype._getSingleNavContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.NavContainer")){return e[0];}else{return null;}};
n.prototype._getSinglePageContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.Page")){return e[0];}else{return null;}};
n.prototype._hasSinglePageContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.Page")){return true;}else{return false;}};
n.prototype._hasSingleScrollableContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA(this._scrollContentList)){return true;}return false;};
n.prototype._getOffsetX=function(){var F=this.getPlacement(),e=0;if(this._bHorizontalFlip){var p=this._getOpenByDomRef();var H=p!==undefined;var o=H?p.getBoundingClientRect().width:0;e=F===k.PreferredRightOrFlip?Math.abs(o):-Math.abs(o);}var r=sap.ui.getCore().getConfiguration().getRTL();var t=e*(r?-1:1)+this.getOffsetX()*(r?-1:1);return t;};
n.prototype._getOffsetY=function(){var F=this.getPlacement(),e=0;if(this._bVerticalFlip){var p=this._getOpenByDomRef();var H=p!==undefined;var o=H?p.getBoundingClientRect().height:0;e=F==="PreferredTopOrFlip"?-Math.abs(o):Math.abs(o);}return e+this.getOffsetY();};
n.prototype._calcOffset=function(o){var e=this._getOffsetX(),p=this._getOffsetY();var r=o.split(" ");var o=(parseInt(r[0])+e)+" "+(parseInt(r[1])+p);return o;};
n.prototype._calcPlacement=function(){var p=this.getPlacement();var o=this._getOpenByDomRef();switch(p){case k.Auto:this._calcAuto();break;case k.Vertical:case k.VerticalPreferedTop:case k.VerticalPreferredTop:case k.VerticalPreferedBottom:case k.VerticalPreferredBottom:case k.PreferredTopOrFlip:case k.PreferredBottomOrFlip:this._calcVertical();break;case k.Horizontal:case k.HorizontalPreferedLeft:case k.HorizontalPreferredLeft:case k.HorizontalPreferedRight:case k.HorizontalPreferredRight:case k.PreferredRightOrFlip:case k.PreferredLeftOrFlip:this._calcHorizontal();break;}this._bPosCalced=true;var e=this._placements.indexOf(this._oCalcedPos);this.oPopup.setPosition(this._myPositions[e],this._atPositions[e],o,this._calcOffset(this._offsets[e]),"fit");};
n.prototype._getDocHeight=function(){var e=document.body,o=document.documentElement;return Math.max(e.scrollHeight,e.offsetHeight,o.clientHeight,o.offsetHeight);};
n.prototype._calcVertical=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=this.getPlacement()===k.VerticalPreferedTop||this.getPlacement()===k.VerticalPreferredTop;var e=this.getPlacement()===k.VerticalPreferedBottom||this.getPlacement()===k.VerticalPreferredBottom;var o=this.getPlacement()===k.PreferredTopOrFlip;var r=this.getPlacement()===k.PreferredBottomOrFlip;var t=H?$[0].getBoundingClientRect().top:0;var u=H?$[0].getBoundingClientRect().height:0;var v=this._getOffsetY();var w=t-this._marginTop+v;var x=this.$().outerHeight();var y=this._getDocHeight()-($.offset().top+u+this._marginBottom+v);if(p&&w>x+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=k.Top;}else if(o){if(w>x+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=k.Top;}else{this._bVerticalFlip=true;this._oCalcedPos=k.Bottom;}}else if(e&&y>x+this._arrowOffset){this._oCalcedPos=k.Bottom;this._bVerticalFlip=false;}else if(r){if(y>x+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=k.Bottom;}else{this._bVerticalFlip=true;this._oCalcedPos=k.Top;}}else if(w>y){this._oCalcedPos=k.Top;}else{this._oCalcedPos=k.Bottom;}};
n.prototype._calcHorizontal=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=this.getPlacement()===k.HorizontalPreferedLeft||this.getPlacement()===k.HorizontalPreferredLeft;var e=this.getPlacement()===k.HorizontalPreferedRight||this.getPlacement()===k.HorizontalPreferredRight;var o=H?$[0].getBoundingClientRect().left:0;var r=H?$[0].getBoundingClientRect().width:0;var t=this._getOffsetX();var u=o-this._marginLeft+t;var v=o+r;var w=this._$window.width()-v-this._marginRight-t;var x=this.$().outerWidth();var y=this.getPlacement()===k.PreferredLeftOrFlip;var z=this.getPlacement()===k.PreferredRightOrFlip;var A=sap.ui.getCore().getConfiguration().getRTL();if(p&&u>x+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=A?k.Right:k.Left;}else if(y){if(u>x+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=A?k.Right:k.Left;}else{this._bHorizontalFlip=true;this._oCalcedPos=A?k.Left:k.Right;}}else if(e&&w>x+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=A?k.Left:k.Right;}else if(z){if(w>x+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=A?k.Left:k.Right;}else{this._bHorizontalFlip=true;this._oCalcedPos=A?k.Right:k.Left;}}else if(u>w){this._oCalcedPos=A?k.Right:k.Left;}else{this._oCalcedPos=A?k.Left:k.Right;}};
n.prototype._calcAuto=function(){if(this._$window.width()>this._$window.height()){if(this._checkHorizontal()){this._calcHorizontal();}else if(this._checkVertical()){this._calcVertical();}else{this._calcBestPos();}}else{if(this._checkVertical()){this._calcVertical();}else if(this._checkHorizontal()){this._calcHorizontal();}else{this._calcBestPos();}}};
n.prototype._checkHorizontal=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=H?$[0].getBoundingClientRect().left:0;var e=H?$[0].getBoundingClientRect().width:0;var o=this._getOffsetX();var r=p-this._marginLeft+o;var t=p+e;var u=this._$window.width()-t-this._marginRight-o;var v=this.$();var w=v.outerWidth()+this._arrowOffset;if((w<=r)||(w<=u)){return true;}};
n.prototype._checkVertical=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=H?$[0].getBoundingClientRect().top:0;var e=H?$[0].getBoundingClientRect().height:0;var o=this._getOffsetY();var t=p-this._marginTop+o;var r=this._getDocHeight()-$.offset().top-e-this._marginBottom-o;var u=this.$();var v=u.outerHeight()+this._arrowOffset;if((v<=t)||(v<=r)){return true;}};
n.prototype._calcBestPos=function(){var $=this.$();var H=$.outerHeight();var w=$.outerWidth();var r=sap.ui.getCore().getConfiguration().getRTL();var e=q(this._getOpenByDomRef());var o=e[0]!==undefined;var p=o?e[0].getBoundingClientRect().left:0;var t=o?e[0].getBoundingClientRect().top:0;var u=o?e[0].getBoundingClientRect().width:0;var v=o?e[0].getBoundingClientRect().height:0;var x=this._getOffsetX();var y=this._getOffsetY();var z=t-this._marginTop+y;var A=this._getDocHeight()-e.offset().top-v-this._marginBottom-y;var F=p-this._marginLeft+x;var G=p+u;var J=this._$window.width()-G-this._marginRight-x;var N=H*w;var Q;var U;if((this._$window.height()-this._marginTop-this._marginBottom)>=H){Q=H;}else{Q=this._$window.height()-this._marginTop-this._marginBottom;}if((this._$window.width()-this._marginLeft-this._marginRight)>=w){U=w;}else{U=this._$window.width()-this._marginLeft-this._marginRight;}var V=(Q*(F))/N;var W=(Q*(J))/N;var X=(U*(z))/N;var Y=(U*(A))/N;var Z=Math.max(V,W);var _=Math.max(X,Y);if(Z>_){if(Z===V){this._oCalcedPos=r?k.Right:k.Left;}else if(Z===W){this._oCalcedPos=r?k.Left:k.Right;}}else if(_>Z){if(_===X){this._oCalcedPos=k.Top;}else if(_===Y){this._oCalcedPos=k.Bottom;}}else if(_===Z){if(this._$window.height()>this._$window.width()){if(_===X){this._oCalcedPos=k.Top;}else if(_===Y){this._oCalcedPos=k.Bottom;}}else{if(Z===V){this._oCalcedPos=r?k.Right:k.Left;}else if(Z===W){this._oCalcedPos=r?k.Left:k.Right;}}}};
n.outerWidth=function(e,o){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().width;}return q(e).outerWidth(!!o);};
n.outerHeight=function(e,o){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().height;}return q(e).outerHeight(!!o);};
n.prototype._getPositionParams=function($,e,o,p){var r=window.getComputedStyle($[0]),t=window.getComputedStyle(o[0]),u=this.getDomRef().clientHeight!=this.getDomRef().scrollHeight?i().width:0,v={};v._$popover=$;v._$parent=q(this._getOpenByDomRef());v._$arrow=e;v._$content=o;v._$scrollArea=p;v._$header=$.children(".sapMPopoverHeader");v._$subHeader=$.children(".sapMPopoverSubHeader");v._$footer=$.children(".sapMPopoverFooter");v._fWindowTop=this._$window.scrollTop();v._fWindowRight=this._$window.width();v._fWindowBottom=(n._bIOS7&&D.orientation.landscape&&window.innerHeight)?window.innerHeight:this._$window.height();v._fWindowLeft=this._$window.scrollLeft();v._fDocumentWidth=v._fWindowLeft+v._fWindowRight;v._fDocumentHeight=v._fWindowTop+v._fWindowBottom;v._fArrowHeight=e.outerHeight(true);v._fWidth=n.outerWidth($[0]);v._fWidthInner=v._$scrollArea?(v._$scrollArea.width()+u):0;v._fHeight=n.outerHeight($[0]);v._fHeaderHeight=v._$header.length>0?v._$header.outerHeight(true):0;v._fSubHeaderHeight=v._$subHeader.length>0?v._$subHeader.outerHeight(true):0;v._fFooterHeight=v._$footer.length>0?v._$footer.outerHeight(true):0;v._fOffset=$.offset();v._fOffsetX=this._getOffsetX();v._fOffsetY=this._getOffsetY();v._fMarginTop=v._fWindowTop+this._marginTop;v._fMarginRight=this._marginRight;v._fMarginBottom=this._marginBottom;v._fMarginLeft=v._fWindowLeft+this._marginLeft;v._fPopoverBorderTop=parseFloat(r.borderTopWidth);v._fPopoverBorderRight=parseFloat(r.borderRightWidth);v._fPopoverBorderBottom=parseFloat(r.borderBottomWidth);v._fPopoverBorderLeft=parseFloat(r.borderLeftWidth);v._fContentMarginTop=parseFloat(t.marginTop);v._fContentMarginBottom=parseFloat(t.marginBottom);return v;};
n.prototype._recalculateMargins=function(e,p){var r=sap.ui.getCore().getConfiguration().getRTL();switch(e){case k.Left:if(r){p._fMarginLeft=p._$parent.offset().left+n.outerWidth(p._$parent[0],false)+this._arrowOffset-p._fOffsetX;}else{p._fMarginRight=p._fDocumentWidth-p._$parent.offset().left+this._arrowOffset-p._fOffsetX;}break;case k.Right:if(r){p._fMarginRight=p._fDocumentWidth-n.outerWidth(p._$parent[0],false)-p._$parent.offset().left+this._arrowOffset;}else{p._fMarginLeft=p._$parent.offset().left+n.outerWidth(p._$parent[0],false)+this._arrowOffset+p._fOffsetX;}break;case k.Top:p._fMarginBottom=p._fDocumentHeight-p._$parent.offset().top+this._arrowOffset-p._fOffsetY;break;case k.Bottom:p._fMarginTop=p._$parent.offset().top+n.outerHeight(p._$parent[0],false)+this._arrowOffset+p._fOffsetY;break;}};
n.prototype._getPopoverPositionCss=function(p){var e,r,t,o,u=p._fDocumentWidth-p._fOffset.left-p._fWidth,v=p._fDocumentHeight-p._fOffset.top-p._fHeight,w=(p._fDocumentWidth-p._fMarginRight-p._fMarginLeft)<p._fWidth,x=(p._fDocumentHeight-p._fMarginTop-p._fMarginBottom)<p._fHeight,y=p._fOffset.left<p._fMarginLeft,z=this.getVerticalScrolling()&&(p._fWidth!==p._fWidthInner)?i().width:0,A=u<(p._fMarginRight+z),F=p._fOffset.top<p._fMarginTop,G=v<p._fMarginBottom,H=sap.ui.getCore().getConfiguration().getRTL();if(w){e=p._fMarginLeft;r=p._fMarginRight;}else{if(y){e=p._fMarginLeft;if(H){r="";}}else if(A){r=p._fMarginRight;e="";}}if(x){t=p._fMarginTop;o=p._fMarginBottom;}else{if(F){t=p._fMarginTop;}else if(G){o=p._fMarginBottom;t="";}}var J={top:t,bottom:o-p._fWindowTop,left:e,right:typeof r==="number"?r-p._fWindowLeft:r};return J;};
n.prototype._getContentDimensionsCss=function(p){var o={},A=p._$content.height(),e=this._getMaxContentWidth(p),r=this._getMaxContentHeight(p);r=Math.max(r,0);o["max-width"]=e+"px";if(this.getContentHeight()||(A>r)){o["height"]=Math.min(r,A)+"px";}else{o["height"]="";o["max-height"]=r+"px";}if((A>r)&&this._hasSingleScrollableContent()){o["max-height"]=Math.min(r,A)+"px";}return o;};
n.prototype._getMaxContentWidth=function(p){return p._fDocumentWidth-p._fMarginLeft-p._fMarginRight-p._fPopoverBorderLeft-p._fPopoverBorderRight;};
n.prototype._getMaxContentHeight=function(p){return p._fDocumentHeight-p._fMarginTop-p._fMarginBottom-p._fHeaderHeight-p._fSubHeaderHeight-p._fFooterHeight-p._fContentMarginTop-p._fContentMarginBottom-p._fPopoverBorderTop-p._fPopoverBorderBottom;};
n.prototype._isHorizontalScrollbarNeeded=function(p){return this.getHorizontalScrolling()&&(p._$scrollArea.outerWidth(true)<=p._$content.width());};
n.prototype._getArrowOffsetCss=function(e,p){var o,r=sap.ui.getCore().getConfiguration().getRTL();p._fWidth=p._$popover.outerWidth();p._fHeight=p._$popover.outerHeight();if(e===k.Left||e===k.Right){o=p._$parent.offset().top-p._$popover.offset().top-p._fPopoverBorderTop+p._fOffsetY+0.5*(n.outerHeight(p._$parent[0],false)-p._$arrow.outerHeight(false));o=Math.max(o,this._arrowOffsetThreshold);o=Math.min(o,p._fHeight-this._arrowOffsetThreshold-p._$arrow.outerHeight());return{"top":o};}else if(e===k.Top||e===k.Bottom){if(r){o=p._$popover.offset().left+n.outerWidth(p._$popover[0],false)-(p._$parent.offset().left+n.outerWidth(p._$parent[0],false))+p._fPopoverBorderRight+p._fOffsetX+0.5*(n.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));o=Math.max(o,this._arrowOffsetThreshold);o=Math.min(o,p._fWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"right":o};}else{o=p._$parent.offset().left-p._$popover.offset().left-p._fPopoverBorderLeft+p._fOffsetX+0.5*(n.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));o=Math.max(o,this._arrowOffsetThreshold);o=Math.min(o,p._fWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"left":o};}}};
n.prototype._getArrowPositionCssClass=function(e){switch(e){case k.Left:return"sapMPopoverArrRight";case k.Right:return"sapMPopoverArrLeft";case k.Top:return"sapMPopoverArrDown";case k.Bottom:return"sapMPopoverArrUp";}};
n.prototype._getArrowStyleCssClass=function(p){var A=p._$arrow.position(),F=p._$footer.position(),N=this._getSingleNavContent(),o=this._getSinglePageContent(),e=0;if(N||o){o=o||N.getCurrentPage();if(o){e=o._getAnyHeader().$().outerHeight();}}if((A.top+p._fArrowHeight)<(p._fHeaderHeight+p._fSubHeaderHeight)||((A.top+p._fArrowHeight)<e)){return"sapMPopoverHeaderAlignArr";}else if((A.top<(p._fHeaderHeight+p._fSubHeaderHeight))||(A.top<e)||(p._$footer.length&&((A.top+p._fArrowHeight)>F.top)&&(A.top<F.top))){return"sapMPopoverCrossArr";}else if(p._$footer.length&&(A.top>F.top)){return"sapMPopoverFooterAlignArr";}};
n.prototype._getCalculatedPlacement=function(){return this._oCalcedPos||this.getPlacement();};
n.prototype._adjustPositionAndArrow=function(){var e=this.oPopup.getOpenState();if(!(e===O.OPEN||e===O.OPENING)){return;}var $=this.$(),o=this.$("arrow"),p=this.$("cont"),r=this.$("scroll"),t=this._getCalculatedPlacement(),u=this._getPositionParams($,o,p,r);this._recalculateMargins(t,u);var v=this._getPopoverPositionCss(u),w=this._getContentDimensionsCss(u),H=this._isHorizontalScrollbarNeeded(u);$.css(v);p.css(w);if(H){r.css("display","block");}if(this.getShowArrow()){var A=this._getArrowOffsetCss(t,u),x=this._getArrowPositionCssClass(t),y,U;o.removeAttr("style");o.css(A);o.addClass(x);if(t===k.Top&&u._$footer&&u._$footer.size()){U=true;}if(t===k.Left||t===k.Right){y=this._getArrowStyleCssClass(u);if(y){o.addClass(y);if(y==="sapMPopoverFooterAlignArr"){U=true;}}}if(U){o.addClass("sapContrast sapContrastPlus");}$.css("overflow","visible");}this._afterAdjustPositionAndArrowHook();};
n.prototype._adaptPositionParams=function(){if(this.getShowArrow()){this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._arrowOffset=18;this._offsets=["0 -18","18 0","0 18","-18 0"];if(this._bUseCompactArrow){this._arrowOffset=9;this._offsets=["0 -9","9 0","0 9","-9 0"];}this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];}else{this._marginTop=0;this._marginLeft=0;this._marginRight=0;this._marginBottom=0;this._arrowOffset=0;this._offsets=["0 0","0 0","0 0","0 0"];this._myPositions=["begin bottom","begin center","begin top","end center"];this._atPositions=["begin top","end center","begin bottom","begin center"];}};
n.prototype._afterAdjustPositionAndArrowHook=function(){};
n.prototype._isPopupElement=function(o){var p=this._getOpenByDomRef();return!!(q(o).closest(sap.ui.getCore().getStaticAreaRef()).length)||!!(q(o).closest(p).length);};
n.prototype._getAnyHeader=function(){if(this.getCustomHeader()){return this.getCustomHeader();}else{if(this.getShowHeader()){this._createInternalHeader();return this._internalHeader;}}};
n.prototype._createInternalHeader=function(){if(!this._internalHeader){var t=this;this._internalHeader=new B(this.getId()+"-intHeader");this._setupBarTitleAlignment(this._internalHeader,this.getId()+"_internalHeader");this.setAggregation("_internalHeader",this._internalHeader);this._internalHeader.addEventDelegate({onAfterRendering:function(){t._restoreFocus();}});return true;}else{return false;}};
n.prototype._animation=function(A,r){var t=null;var e=function(){r.off("webkitTransitionEnd transitionend");clearTimeout(t);setTimeout(function(){A();});};r.on("webkitTransitionEnd transitionend",e);t=setTimeout(e,this._getAnimationDuration());};
n.prototype._getAnimationDuration=function(){return 300;};
n.prototype._openAnimation=function(r,e,o){var t=this;setTimeout(function(){r.css("display","block");t._includeScrollWidth();t._animation(function(){if(!t.oPopup||t.oPopup.getOpenState()!==O.OPENING){return;}o();},r);},D.browser.firefox?50:0);};
n.prototype._closeAnimation=function(r,e,o){r.addClass("sapMPopoverTransparent");this._animation(function(){o();r.removeClass("sapMPopoverTransparent");},r);};
n.prototype._getInitialFocusId=function(){return this.getInitialFocus()||this._getFirstVisibleButtonId()||this._getFirstFocusableContentElementId()||this.getId();};
n.prototype._getFirstVisibleButtonId=function(){var o=this.getBeginButton(),e=this.getEndButton(),p="";if(o&&o.getVisible()){p=o.getId();}else if(e&&e.getVisible()){p=e.getId();}return p;};
n.prototype._getFirstFocusableContentElementId=function(){var r="";var $=this.$("cont");var F=$.firstFocusableDomRef();if(F){r=F.id;}return r;};
n.prototype._restoreFocus=function(){if(this.isOpen()){var F=this._getInitialFocusId(),o=sap.ui.getCore().byId(F),e=(F?window.document.getElementById(F):null);if(o&&o.getFocusDomRef()){o.getFocusDomRef().focus();}else if(!o&&e){e.focus();}}};
n.prototype._registerContentResizeHandler=function(o){if(!this._sResizeListenerId){this._sResizeListenerId=f.register(o||this.getDomRef("scroll"),this._fnOrientationChange);}};
n.prototype._deregisterContentResizeHandler=function(){if(this._sResizeListenerId){f.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
n.prototype._storeScrollPosition=function(){var $=this.$("cont");if($.length>0){this._oScrollPosDesktop={x:$.scrollLeft(),y:$.scrollTop()};}};
n.prototype._restoreScrollPosition=function(){if(!this._oScrollPosDesktop){return;}var $=this.$("cont");if($.length>0){$.scrollLeft(this._oScrollPosDesktop.x).scrollTop(this._oScrollPosDesktop.y);this._oScrollPosDesktop=null;}};
n.prototype._repositionOffset=function(){var e=this.oPopup.getOpenState(),o,p;if(!(e===O.OPEN)){return this;}o=this.oPopup._oLastPosition;p=this._placements.indexOf(this.getPlacement());if(p===-1){return this;}if(p<4){o.offset=this._calcOffset(this._offsets[p]);this.oPopup._applyPosition(o);}else{this._calcPlacement();}return this;};
n.prototype._getOpenByDomRef=function(){if(!this._oOpenBy){return null;}if(this._oOpenBy instanceof E){return(this._oOpenBy.getPopupAnchorDomRef&&this._oOpenBy.getPopupAnchorDomRef())||this._oOpenBy.getFocusDomRef();}else{return this._oOpenBy;}};
n.prototype._getAccessibilityOptions=function(){var A,e={},H=this._getAnyHeader();e.role="dialog";e.modal=this.getProperty("ariaModal");if(this.getShowHeader()&&H&&H.getVisible()){A=Array.prototype.concat(H.getId(),this.getAssociation("ariaLabelledBy",[]));e.labelledby=A.join(' ');}return e;};
n.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._bVerticalFlip=false;this._bHorizontalFlip=false;var e=this._placements.indexOf(p);if(e<=3){this._oCalcedPos=p;}return this;};
n.prototype.setTitle=function(t){this.setProperty("title",t,true);if(this._headerTitle){this._headerTitle.setText(t);}else{this._headerTitle=new T(this.getId()+"-title",{text:this.getTitle(),level:"H2"});this._createInternalHeader();this._internalHeader.addContentMiddle(this._headerTitle);}return this;};
n.prototype.setBeginButton=function(o){var e=this.getBeginButton();if(e===o){return this;}this._createInternalHeader();this._beginButton=o;if(o){if(e){this._internalHeader.removeAggregation("contentLeft",e,true);}this._internalHeader.addAggregation("contentLeft",o);}else{this._internalHeader.removeContentLeft(e);}return this;};
n.prototype.setEndButton=function(o){var e=this.getEndButton();if(e===o){return this;}this._createInternalHeader();this._endButton=o;if(o){if(e){this._internalHeader.removeAggregation("contentRight",e,true);}this._internalHeader.insertAggregation("contentRight",o,1,true);this._internalHeader.invalidate();}else{this._internalHeader.removeContentRight(e);}return this;};
n.prototype.setLeftButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setBeginButton(v);return this.setAssociation("leftButton",v);};
n.prototype.setRightButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setEndButton(v);return this.setAssociation("rightButton",v);};
n.prototype.setShowHeader=function(v){if(v===this.getShowHeader()||this.getCustomHeader()){return this;}if(v){if(this._internalHeader){this._internalHeader.$().show();}}else{if(this._internalHeader){this._internalHeader.$().hide();}}this.setProperty("showHeader",v,true);return this;};
n.prototype.setModal=function(e,o){if(e===this.getModal()){return this;}this.oPopup.setModal(e,("sapMPopoverBLayer "+(o||"")).trim());this.setProperty("modal",e,true);return this;};
n.prototype.setOffsetX=function(v){this.setProperty("offsetX",v,true);return this._repositionOffset();};
n.prototype.setOffsetY=function(v){this.setProperty("offsetY",v,true);return this._repositionOffset();};
n.prototype.setEnableScrolling=function(v){this.setHorizontalScrolling(v);this.setVerticalScrolling(v);var o=this.getEnableScrolling();if(o===v){return this;}this.setProperty("enableScrolling",v,true);return this;};
n.prototype.setVerticalScrolling=function(v){this._bVScrollingEnabled=v;var o=this.getVerticalScrolling();if(o===v){return this;}this.$().toggleClass("sapMPopoverVerScrollDisabled",!v);this.setProperty("verticalScrolling",v,true);if(this._oScroller){this._oScroller.setVertical(v);}return this;};
n.prototype.setHorizontalScrolling=function(v){this._bHScrollingEnabled=v;var o=this.getHorizontalScrolling();if(o===v){return this;}this.$().toggleClass("sapMPopoverHorScrollDisabled",!v);this.setProperty("horizontalScrolling",v,true);if(this._oScroller){this._oScroller.setHorizontal(v);}return this;};
n.prototype.setResizable=function(v){if(!D.system.desktop){v=false;}return this.setProperty("resizable",v,true);};
n.prototype._setAriaModal=function(v){return this.setProperty("ariaModal",v);};
n.prototype.getScrollDelegate=function(){return this._oScroller;};
n.prototype.setAggregation=function(A,o,e){if(A==="beginButton"||A==="endButton"){var F="set"+A.charAt(0).toUpperCase()+A.slice(1);return this[F](o);}else{return C.prototype.setAggregation.apply(this,arguments);}};
n.prototype.getAggregation=function(A,o){if(A==="beginButton"||A==="endButton"){var e=this["_"+A];return e||o||null;}else{return C.prototype.getAggregation.apply(this,arguments);}};
n.prototype.destroyAggregation=function(A,e){var o=q(document.activeElement).control(0);if(A==="beginButton"||A==="endButton"){var p=this["_"+A];if(p){p.destroy();this["_"+A]=null;}}else{C.prototype.destroyAggregation.apply(this,arguments);}o&&o.getDomRef()?o.focus():this.focus();return this;};
n.prototype.invalidate=function(o){if(this.isOpen()){C.prototype.invalidate.apply(this,arguments);}return this;};
n.prototype.addAggregation=function(A,o,e){if(A==="content"){this._bContentChanged=true;}C.prototype.addAggregation.apply(this,arguments);};
n.prototype._getAllContent=function(){return this.getContent();};
n.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
b.mixInto(n.prototype);return n;});
sap.ui.predefine('sap/m/PopoverRenderer',['sap/ui/Device','sap/m/library',"sap/ui/dom/getScrollbarSize"],function(D,l,g){"use strict";var P=l.PlacementType;var a={};
a.render=function(r,c){var C;r.write("<div");r.writeControlData(c);C=this.generateRootClasses(c);C.forEach(function(s,i){r.addClass(s);});r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex","-1");r.writeAccessibilityState(c,c._getAccessibilityOptions());r.write(">");if(c.getResizable()){r.writeIcon("sap-icon://resize-corner",["sapMPopoverResizeHandle"],{"title":""});}this.renderContent(r,c);r.write("</div>");};
a.isButtonFooter=function(f){if(f instanceof sap.m.Bar){var c=f.getContentLeft(),C=f.getContentRight(),b=f.getContentMiddle(),L=(!c||c.length===0),r=(!C||C.length===0),m=false;if(b&&b.length===2){if((b[0]instanceof sap.m.Button)&&(b[1]instanceof sap.m.Button)){m=true;}}return L&&r&&m;}else{return false;}};
a.renderContent=function(r,c){var h,I=c.getId(),i=0,b=c._getAllContent(),f=c.getFooter(),s=c.getSubHeader(),C=c.getContentWidth(),d=c.getContentMinWidth(),e=c.getContentHeight(),F="sapMPopoverFooter ";if(c.getShowHeader()){h=c._getAnyHeader();}if(D.system.desktop){r.write("<span class='sapMPopoverHiddenFocusable' id='"+c.getId()+"-firstfe' tabindex='0'></span>");}if(h){r.write("<header");r.addClass("sapMPopoverHeader");r.writeClasses();r.write(">");if(h._applyContextClassFor){h._applyContextClassFor("header");}r.renderControl(h);r.write("</header>");}if(s){r.write("<header");r.addClass("sapMPopoverSubHeader");r.writeClasses();r.write(">");if(s._applyContextClassFor){s._applyContextClassFor("subheader");}r.renderControl(s);r.write("</header>");}r.write("<div");r.writeAttribute("id",I+"-cont");if(C){r.addStyle("width",C);}if(d){r.addStyle("min-width",d);}if(e){r.addStyle("height",e);}r.writeStyles();r.addClass("sapMPopoverCont");r.writeClasses();if(sap.ui.getCore().getConfiguration().getAccessibility()&&!sap.ui.getCore().getConfiguration().getAvoidAriaApplicationRole()){r.writeAttribute("role","application");}r.write(">");r.write('<div class="sapMPopoverScroll"');r.writeAttribute("id",c.getId()+"-scroll");if(!c.getHorizontalScrolling()){r.addStyle(sap.ui.getCore().getConfiguration().getRTL()?"margin-left":"margin-right",g().width+"px");}r.writeStyles();r.write(">");for(i=0;i<b.length;i++){r.renderControl(b[i]);}r.write("</div>");r.write("</div>");if(f){if(this.isButtonFooter(f)){F+="sapMPopoverSpecialFooter";}r.write("<footer");r.addClass(F);r.writeClasses();r.write(">");if(f._applyContextClassFor){f._applyContextClassFor("footer");f.addStyleClass("sapMTBNoBorders");}r.renderControl(f);r.write("</footer>");}if(c.getShowArrow()){r.write("<span");r.writeAttribute("id",I+"-arrow");r.addClass("sapMPopoverArr");r.writeClasses();r.write("></span>");}if(D.system.desktop){r.write("<span class='sapMPopoverHiddenFocusable' id='"+c.getId()+"-lastfe' tabindex='0'></span>");}};
a.generateRootClasses=function(c){var C=["sapMPopover"],s=c.getSubHeader(),f=c.getFooter(),v=c.getVerticalScrolling()&&!c._forceDisableScrolling,h=c.getHorizontalScrolling()&&!c._forceDisableScrolling,H;if(c.getShowHeader()){H=c._getAnyHeader();}if(H){C.push("sapMPopoverWithBar");}else{C.push("sapMPopoverWithoutBar");}if(s){C.push("sapMPopoverWithSubHeader");}else{C.push("sapMPopoverWithoutSubHeader");}if(c._hasSingleNavContent()){C.push("sapMPopoverNav");}if(c._hasSinglePageContent()){C.push("sapMPopoverPage");}if(f){C.push("sapMPopoverWithFooter");}else{C.push("sapMPopoverWithoutFooter");}if(c.getPlacement()===P.Top){C.push("sapMPopoverPlacedTop");}if(!v){C.push("sapMPopoverVerScrollDisabled");}if(!h){C.push("sapMPopoverHorScrollDisabled");}C.push("sapMPopup-CTX");if(c._bSizeCompact){C.push("sapUiSizeCompact");}return C.concat(c.aCustomStyleClasses);};
a.rerenderContentOnly=function(c){var p=c.$(),o=c.getDomRef(),C,r;if(!o){return;}p.removeClass();C=this.generateRootClasses(c);p.addClass(C.join(" "));r=sap.ui.getCore().createRenderManager();this.renderContent(r,c);r.flush(o,true);r.destroy();c._onOrientationChange();};
return a;},true);
sap.ui.predefine('sap/m/ProgressIndicator',['./library','sap/ui/core/Control','sap/ui/core/ValueStateSupport','sap/ui/core/library','./ProgressIndicatorRenderer',"sap/base/Log"],function(l,C,V,c,P,L){"use strict";var T=c.TextDirection;var a=c.ValueState;
var b=C.extend("sap.m.ProgressIndicator",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:a.None},displayValue:{type:"string",group:"Appearance",defaultValue:null},percentValue:{type:"float",group:"Data",defaultValue:0},showValue:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/m/designtime/ProgressIndicator.designtime"}});
var u=sap.ui.getCore().getConfiguration().getAnimation();
b.prototype.setPercentValue=function(p){var t=this,$,f,d=this.$(),A,o=p;p=parseFloat(p);if(!i(p)){if(p>100){p=100;}else if(p<0){p=0;}else{L.warning(this+": percentValue ("+o+") is not a valid number! The provided value will not be set!");return this;}L.warning(this+": percentValue ("+o+") is not correct! Setting the percentValue to "+p);}if(this.getPercentValue()!==p){f=this.getPercentValue()-p;this.setProperty("percentValue",p,true);if(!d.length){return this;}["sapMPIValueMax","sapMPIValueMin","sapMPIValueNormal","sapMPIValueGreaterHalf"].forEach(function(s){d.removeClass(s);});d.addClass(this._getCSSClassByPercentValue(p).join(" "));d.addClass("sapMPIAnimate").attr("aria-valuenow",p).attr("aria-valuetext",this._getAriaValueText({fPercent:p}));A=u?Math.abs(f)*20:0;$=this.$("bar");$.stop();$.animate({"flex-basis":p+"%"},A,"linear",function(){t._setText.apply(t);t.$().removeClass("sapMPIAnimate");});}return this;};
b.prototype._setText=function(){this.$().toggleClass("sapMPIValueGreaterHalf",this.getPercentValue()>50);return this;};
b.prototype._getCSSClassByPercentValue=function(p){if(p===100){return["sapMPIValueMax","sapMPIValueGreaterHalf"];}if(p===0){return["sapMPIValueMin"];}if(p<=50){return["sapMPIValueNormal"];}return["sapMPIValueNormal","sapMPIValueGreaterHalf"];};
b.prototype._getAriaValueText=function(p){p.sText=p.sText||this.getDisplayValue();p.fPercent=p.fPercent||this.getPercentValue();p.sStateText=p.sStateText||this._getStateText();var A=p.sText||p.fPercent+"%";if(p.sStateText){A+=" "+p.sStateText;}return A;};
b.prototype._getStateText=function(){return V.getAdditionalText(this.getState());};
b.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),d=this.getDisplayValue(),D=d?d:B.getText("ACC_CTR_STATE_PROGRESS",[this.getPercentValue()]);return{role:"progressbar",type:B.getText("ACC_CTR_TYPE_PROGRESS"),description:D,focusable:this.getEnabled(),enabled:this.getEnabled()};};
function i(v){return!isNaN(v)&&v>=0&&v<=100;}
return b;});
sap.ui.predefine('sap/m/ProgressIndicatorRenderer',["sap/ui/core/library"],function(c){"use strict";var V=c.ValueState;var P={apiVersion:2};
P.render=function(r,C){var p=C.getPercentValue(),w=C.getWidth(),h=C.getHeight(),a=C._getCSSClassByPercentValue(p),t=C.getDisplayValue(),s=C.getShowValue(),S=C.getState(),T=C.getTextDirection().toLowerCase(),b=C.getId();r.openStart("div",C);r.class("sapMPI");r.style("width",w);a.forEach(function(d){r.class(d);});r.style("height",h);if(C.getEnabled()){r.attr('tabindex','-1');}else{r.class("sapMPIBarDisabled");}if(C.getDisplayOnly()){r.class("sapMPIDisplayOnly");}r.accessibilityState(C,{role:"progressbar",valuemin:0,valuenow:p,valuemax:100,valuetext:C._getAriaValueText({sText:t,fPercent:p})});if(C.getTooltip_AsString()){r.attr("title",C.getTooltip_AsString());}r.openEnd();r.openStart("div",b+"-bar");r.class("sapMPIBar");switch(S){case V.Warning:r.class("sapMPIBarCritical");break;case V.Error:r.class("sapMPIBarNegative");break;case V.Success:r.class("sapMPIBarPositive");break;case V.Information:r.class("sapMPIBarInformation");break;default:r.class("sapMPIBarNeutral");break;}r.style("flex-basis",p+"%");r.openEnd();P._renderDisplayText(r,T,"Left",b);if(s){r.text(t);}r.close("span");r.close("div");r.openStart("div",b+"-remainingBar");r.class("sapMPIBarRemaining");r.openEnd();P._renderDisplayText(r,T,"Right",b);if(s){r.text(t);}r.close("span");r.close("div");r.close("div");};
P._renderDisplayText=function(r,t,T,C){r.openStart("span",C+"-text"+T);r.class("sapMPIText");r.class("sapMPIText"+T);if(t!=="inherit"){r.attr("dir",t);}r.openEnd();};
return P;},true);
sap.ui.predefine('sap/m/PullToRefresh',["sap/ui/thirdparty/jquery",'./library','sap/ui/core/Control','sap/ui/Device','./PullToRefreshRenderer',"sap/ui/events/KeyCodes","sap/base/security/encodeXML"],function(q,l,C,D,P,K,e){"use strict";var I=l.ImageHelper;
var a=C.extend("sap.m.PullToRefresh",{metadata:{library:"sap.m",properties:{description:{type:"string",group:"Misc",defaultValue:null},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},events:{refresh:{}}}});
a.prototype.init=function(){this._bTouchMode=D.support.touch&&!D.system.combi||q.sap.simulateMobileOnDesktop;this._iState=0;};
a.prototype._loadBI=function(){if(this.getVisible()&&!this._oBusyIndicator){var B=sap.ui.requireSync("sap/m/BusyIndicator");this._oBusyIndicator=new B({size:"1.7rem",design:"auto"});this._oBusyIndicator.setParent(this);}};
a.prototype.onBeforeRendering=function(){this._loadBI();if(this._bTouchMode){q(window).off("resize.sapMP2R",this.calculateTopTrigger);var p=this.getParent();this._oScroller=p&&p.getScrollDelegate?p.getScrollDelegate():null;if(this._oScroller){this._oScroller.setBounce(true);this._oScroller.setPullDown(this.getVisible()?this:null);}}};
a.prototype.calculateTopTrigger=function(){this._iTopTrigger=1;if(this._oDomRef&&this._oDomRef.parentNode&&this._oDomRef.parentNode.parentNode&&this._oDomRef.parentNode.parentNode.offsetHeight<this._oDomRef.offsetHeight*1.5){this._iTopTrigger=this.getDomRef("T").offsetTop;}};
a.prototype.onAfterRendering=function(){this._oDomRef=this.getDomRef();if(this._bTouchMode){if(this._oScroller){this._oScroller.refresh();}if(this.getVisible()&&this._oScroller&&this._oScroller._bIScroll){q(window).on("resize.sapMP2R",q.proxy(this.calculateTopTrigger,this));this.calculateTopTrigger();}}};
a.prototype.exit=function(){if(this._bTouchMode&&this._oScroller&&this._oScroller._bIScroll){q(window).off("resize.sapMP2R",this.calculateTopTrigger);}if(this._oScroller){this._oScroller.setPullDown(null);this._oScroller=null;}if(this._oCustomImage){this._oCustomImage.destroy();this._oCustomImage=null;}if(this._oBusyIndicator){this._oBusyIndicator.destroy();this._oBusyIndicator=null;}};
a.prototype.doScrollMove=function(){if(!this._oScroller){return;}var d=this._oDomRef;var _=this._oScroller._scroller;if(_.y>-this._iTopTrigger&&this._iState<1){this.setState(1);_.minScrollY=0;}else if(_.y<-this._iTopTrigger&&this._iState===1){this.setState(0);_.minScrollY=-d.offsetHeight;}};
a.prototype.doPull=function(p){if(this._bTouchMode&&this._iState<2){this.setState(p>=-1?1:0);}};
a.prototype.doRefresh=function(){this.setState(0);};
a.prototype.doScrollEnd=function(){if(this._iState===1){this.setState(2);this.fireRefresh();}};
a.prototype.setState=function(s){if(this._iState===s){return;}this._iState=s;if(!this._oDomRef){return;}var $=this.$();var b=$.find(".sapMPullDownText");var r=this._getRB();switch(s){case 0:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",false);b.html(r.getText(this._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));$.removeAttr("aria-live");$.find(".sapMPullDownInfo").html(e(this.getDescription()));break;case 1:$.toggleClass("sapMFlip",true);b.html(r.getText("PULL2REFRESH_RELEASE"));$.removeAttr("aria-live");break;case 2:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",true);this._oBusyIndicator.setVisible(true);b.html(r.getText("PULL2REFRESH_LOADING"));$.attr("aria-live","assertive");$.find(".sapMPullDownInfo").html(this._bTouchMode?r.getText("PULL2REFRESH_LOADING_LONG"):"");break;}};
a.prototype.getCustomIconImage=function(){var p={src:this.getCustomIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};var c=['sapMPullDownCIImg'];this._oCustomImage=I.getImageControl(null,this._oCustomImage,this,p,c);return this._oCustomImage;};
a.prototype.onclick=function(){if(!this._bTouchMode){this.setState(2);this.fireRefresh();}};
a.prototype.onkeydown=function(b){if(b.which===K.F5){this.onclick();b.stopPropagation();b.preventDefault();}};
a.prototype.onsapenter=function(E){if(this._iState<1){this.setState(2);this.fireRefresh();}};
a.prototype.onsapspace=function(E){E.preventDefault();if(this._iState<1){this.setState(2);this.fireRefresh();}};
a.prototype.hide=function(){this.setState(0);if(this._oScroller){this._oScroller.refresh();}};
a.prototype.setVisible=function(v){if(this.getVisible()===v){return this;}if(this._oDomRef&&this._oScroller&&this._oScroller._oControl){this._oScroller._oControl.invalidate();}return this.setProperty("visible",v);};
a.prototype._getRB=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
return a;});
sap.ui.predefine('sap/m/PullToRefreshRenderer',['sap/ui/core/IconPool'],function(I){"use strict";I.insertFontFaceStyle();var P={apiVersion:2};
P.render=function(r,c){var s=c.getShowIcon();var C=c.getCustomIcon();var t=c.getTooltip_AsString();var R=c._getRB();r.openStart("div",c);r.class("sapMPullDown");r.class(!c._bTouchMode?"sapMPullDownNontouch":"sapMPullDownTouch");if(s&&!C){r.class("sapMPullDownLogo");}if(t){r.attr("title",t);}r.attr("tabindex",0);r.attr("role","button");r.attr("aria-controls",c.getParent().sId+"-cont");r.openEnd();if(s&&C){var o=c.getCustomIconImage();if(o){r.openStart("div").class("sapMPullDownCI").openEnd();r.renderControl(o);r.close("div");}}r.openStart("span").class("sapMPullDownIcon").openEnd().close("span");r.openStart("span").class("sapMPullDownBusy").openEnd();r.renderControl(c._oBusyIndicator);r.close("span");r.openStart("span",c.getId()+"-T");r.class("sapMPullDownText");r.attr("aria-live","assertive");r.openEnd();r.text(R.getText(c._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));r.close("span");r.openStart("span",c.getId()+"-I");r.class("sapMPullDownInfo");r.openEnd();r.text(c.getDescription());r.close("span");r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/QuickViewCardRenderer',['sap/ui/core/Core'],function(C){"use strict";var Q={},r=C.getLibraryResourceBundle("sap.m");
Q.render=function(R,q){var c=q.getNavContainer();R.write("<div");R.addClass("sapMQuickViewCard");if(!q.getShowVerticalScrollBar()){R.addClass("sapMQuickViewCardNoScroll");}R.writeControlData(q);R.writeClasses();R.writeAccessibilityState(q,{label:{value:r.getText("ARIA_ROLEDESCRIPTION_CARD"),append:true}});R.write(">");R.renderControl(c);R.write("</div>");};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewGroup',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var G=E.extend("sap.m.QuickViewGroup",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},heading:{type:"string",group:"Misc",defaultValue:""}},defaultAggregation:"elements",aggregations:{elements:{type:"sap.m.QuickViewGroupElement",multiple:true,singularName:"element",bindable:"bindable"}}}});
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){G.prototype["_"+f+"Old"]=G.prototype[f];G.prototype[f]=function(){var r=G.prototype["_"+f+"Old"].apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});
G.prototype.setProperty=function(n,v){var q=this.getQuickViewBase(),s=false;if(q&&q.isA("sap.m.QuickView")){s=true;}E.prototype.setProperty.call(this,n,v,s);var p=this.getParent();if(p){p._updatePage();}return this;};
G.prototype.getQuickViewBase=function(){var p=this.getParent();if(p&&p.getQuickViewBase){return p.getQuickViewBase();}return null;};
return G;});
sap.ui.predefine('sap/m/QuickViewPageRenderer',[],function(){"use strict";var Q={};
Q.render=function(r,q){var p=q.getPageContent();r.write("<div");r.addClass("sapMQuickViewPage");r.writeControlData(q);r.writeClasses();r.write(">");if(p.header){r.renderControl(p.header);}r.renderControl(p.form);r.write("</div>");};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewRenderer',[],function(){"use strict";var Q={};
Q.render=function(r,c){};
return Q;},true);
sap.ui.predefine('sap/m/RadioButton',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','./RadioButtonGroup','./Label','sap/ui/core/library','sap/base/strings/capitalize','./RadioButtonRenderer'],function(l,C,E,R,L,c,a,b){"use strict";var T=c.TextAlign;var V=c.ValueState;var d=c.TextDirection;
var e=C.extend("sap.m.RadioButton",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selected:{type:"boolean",group:"Data",defaultValue:false},groupName:{type:"string",group:"Behavior",defaultValue:'sapMRbDefaultGroup'},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Appearance",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},editableParent:{type:"boolean",group:"Behavior",defaultValue:true,visibility:"hidden"}},events:{select:{parameters:{selected:{type:"boolean"}}}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/RadioButton.designtime"}});
E.call(e.prototype);e.prototype._groupNames={};var K={HOME:"first",END:"last",NEXT:"next",PREV:"prev"};
e.prototype.ontap=function(o){if(!this.getEnabled()||!this.getEditable()){return;}var p=this.getParent();if(p instanceof R&&(!p.getEnabled()||!p.getEditable())){return;}o&&o.setMarked();this.applyFocusInfo();if(!this.getSelected()){this.setSelected(true);var t=this;setTimeout(function(){t.fireSelect({selected:true});},0);}};
e.prototype.ontouchstart=function(o){o.originalEvent._sapui_handledByControl=true;if(this.getEnabled()&&this.getActiveHandling()){this.$().toggleClass("sapMRbBTouched",true);}};
e.prototype.ontouchend=function(o){this.$().toggleClass("sapMRbBTouched",false);};
e.prototype.onsapnext=function(o){this._keyboardHandler(K.NEXT,true);o.setMarked();return this;};
e.prototype.onsapnextmodifiers=function(o){this._keyboardHandler(K.NEXT,!o.ctrlKey);o.setMarked();return this;};
e.prototype.onsapprevious=function(o){this._keyboardHandler(K.PREV,true);o.setMarked();return this;};
e.prototype.onsappreviousmodifiers=function(o){this._keyboardHandler(K.PREV,!o.ctrlKey);o.setMarked();return this;};
e.prototype.onsaphome=function(o){this._keyboardHandler(K.HOME,true);o.setMarked();return this;};
e.prototype.onsaphomemodifiers=function(o){this._keyboardHandler(K.HOME,!o.ctrlKey);o.setMarked();return this;};
e.prototype.onsapend=function(o){this._keyboardHandler(K.END,true);o.setMarked();return this;};
e.prototype.onsapendmodifiers=function(o){this._keyboardHandler(K.END,!o.ctrlKey);o.setMarked();return this;};
e.prototype._keyboardHandler=function(p,s){if(this.getParent()instanceof R){return;}var n=this._getNextFocusItem(p);n.focus();if(s&&!n.getSelected()&&n.getEditable()&&n.getEnabled()){n.setSelected(true);setTimeout(function(){n.fireSelect({selected:true});},0);}};
e.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"radio",type:B.getText("ACC_CTR_TYPE_RADIO"),description:(this.getText()||"")+(this.getSelected()?(" "+B.getText("ACC_CTR_STATE_CHECKED")):""),enabled:this.getEnabled(),editable:this.getEditable()};};
e.prototype.getFormDoNotAdjustWidth=function(){return this.getText()?false:true;};
e.prototype._getNextFocusItem=function(n){var v=this._groupNames[this.getGroupName()].filter(function(r){return(r.getDomRef()&&r.getEnabled());});var B=v.indexOf(this),i=B,f=v.length;switch(n){case K.NEXT:i=B===f-1?B:B+1;break;case K.PREV:i=B===0?0:i-1;break;case K.HOME:i=0;break;case K.END:i=f-1;break;}return v[i]||this;};
e.prototype.onsapselect=function(o){o.preventDefault();this.ontap(o);};
e.prototype.setEnabled=function(f){this.setProperty("enabled",f,false);return this;};
e.prototype.setSelected=function(s){var o,S=this.getSelected(),g=this.getGroupName(),f=this._groupNames[g],h=f&&f.length;this.setProperty("selected",s,true);this._changeGroupName(this.getGroupName());if(!!s&&g&&g!==""){for(var i=0;i<h;i++){o=f[i];if(o instanceof e&&o!==this&&o.getSelected()){o.fireSelect({selected:false});o.setSelected(false);}}}if((S!==!!s)&&this.getDomRef()){this.$().toggleClass("sapMRbSel",s);if(s){this.getDomRef().setAttribute("aria-checked","true");this.getDomRef("RB").checked=true;this.getDomRef("RB").setAttribute("checked","checked");}else{this.getDomRef().removeAttribute("aria-checked");this.getDomRef("RB").checked=false;this.getDomRef("RB").removeAttribute("checked");}}return this;};
e.prototype.setText=function(t){this.setProperty("text",t,true);if(this._oLabel){this._oLabel.setText(this.getText());}else{this._createLabel("text",this.getText());}this.toggleStyleClass("sapMRbHasLabel",!!t);return this;};
e.prototype._setWidth=function(u){if(!u){this._setLableWidth();}else{this._setLableWidth("auto");}};
e.prototype._setLableWidth=function(w){w=w||this.getWidth();if(this._oLabel){this._oLabel.setWidth(w);}else{this._createLabel("width",w);}};
e.prototype.setTextDirection=function(D){this.setProperty("textDirection",D,true);if(this._oLabel){this._oLabel.setTextDirection(this.getTextDirection());}else{this._createLabel("textDirection",this.getTextDirection());}return this;};
e.prototype.setGroupName=function(g){this._changeGroupName(g,this.getGroupName());return this.setProperty("groupName",g,true);};
e.prototype.onBeforeRendering=function(){this._setWidth(this.getUseEntireWidth());return this._changeGroupName(this.getGroupName());};
e.prototype.exit=function(){var g=this.getGroupName(),f=this._groupNames[g],G=f&&f.indexOf(this);this._iTabIndex=null;if(this._oLabel){this._oLabel.destroy();}if(G>=-1){f.splice(G,1);}};
e.prototype._createLabel=function(p,v){this._oLabel=new L(this.getId()+"-label").addStyleClass("sapMRbBLabel").setParent(this,null,true);this._oLabel.setProperty(p,v,false);};
e.prototype.setTabIndex=function(t){var f=this.getFocusDomRef();this._iTabIndex=t;if(f){f.setAttribute("tabindex",t);}return this;};
e.prototype.setTextAlign=function(A){this.setProperty("textAlign",A,true);if(this._oLabel){this._oLabel.setTextAlign(this.getTextAlign());}else{this._createLabel("textAlign",this.getTextAlign());}return this;};
e.prototype._changeGroupName=function(n,o){var N=this._groupNames[n],O=this._groupNames[o];if(O&&O.indexOf(this)!==-1){O.splice(O.indexOf(this),1);}if(!N){N=this._groupNames[n]=[];}if(N.indexOf(this)===-1){N.push(this);}};
["editableParent"].forEach(function(p){e.prototype["_set"+a(p)]=function(v){return this.setProperty(p,v,true);};});return e;});
sap.ui.predefine('sap/m/RadioButtonGroup',['./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/library','./RadioButtonGroupRenderer',"sap/base/Log"],function(l,C,I,c,R,L){"use strict";var T=c.TextDirection;var V=c.ValueState;
var a=C.extend("sap.m.RadioButtonGroup",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/RadioButtonGroup.designtime",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},columns:{type:"int",group:"Appearance",defaultValue:1},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},selectedIndex:{type:"int",group:"Data",defaultValue:0},enabled:{type:"boolean",group:"Behavior",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.RadioButton",multiple:true,singularName:"button",bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selectedIndex:{type:"int"}}}}}});
a.prototype.exit=function(){this.destroyButtons();if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
a.prototype.onBeforeRendering=function(){var b=this.getButtons();var B=b.length;var e=this.getEditable();b.forEach(function(r){r._setEditableParent(e);});if(this.getSelectedIndex()>B){L.warning("Invalid index, set to 0");this.setSelectedIndex(0);}};
a.prototype.onAfterRendering=function(){this._initItemNavigation();};
a.prototype._initItemNavigation=function(){var d=[];var h=false;var r=this.getEnabled();for(var i=0;i<this.aRBs.length;i++){d.push(this.aRBs[i].getDomRef());h=h||this.aRBs[i].getEnabled();}if(!h||!r){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}return;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleAfterFocus,this);this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(this.getDomRef());this._oItemNavigation.setItemDomRefs(d);this._oItemNavigation.setCycling(true);this._oItemNavigation.setColumns(this.getColumns());this._oItemNavigation.setSelectedIndex(this.getSelectedIndex());this._oItemNavigation.setFocusedIndex(this.getSelectedIndex());this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});};
a.prototype.setSelectedIndex=function(s){var i=this.getSelectedIndex();var h=document.activeElement&&document.activeElement.parentNode&&document.activeElement.parentNode.parentNode===this.getDomRef();var b=!!(this.aRBs&&this.aRBs[s]);if(s<-1){L.warning("Invalid index, will not be changed");return this;}this.setProperty("selectedIndex",s,true);if(!isNaN(i)&&this.aRBs&&this.aRBs[i]){this.aRBs[i].setSelected(false);}if(this.aRBs&&this.aRBs[s]){this.aRBs[s].setSelected(true);}if(this._oItemNavigation){this._oItemNavigation.setSelectedIndex(s);this._oItemNavigation.setFocusedIndex(s);}if(b&&h){this.aRBs[s].getDomRef().focus();}return this;};
a.prototype.setSelectedButton=function(s){var b=this.getButtons();if(s){if(b){for(var i=0;i<b.length;i++){if(s.getId()==b[i].getId()){this.setSelectedIndex(i);break;}}}}else{this.setSelectedIndex(-1);}return this;};
a.prototype.getSelectedButton=function(){return this.getButtons()[this.getSelectedIndex()];};
a.prototype.addButton=function(b){if(!this._bUpdateButtons&&this.getSelectedIndex()===undefined){this.setSelectedIndex(0);}if(!this.aRBs){this.aRBs=[];}var i=this.aRBs.length;this.aRBs[i]=this._createRadioButton(b,i);this.addAggregation("buttons",this.aRBs[i]);return this;};
a.prototype.insertButton=function(b,d){if(!this.aRBs){this.aRBs=[];}var e=this.aRBs.length,m=this.getButtons().length;d=Math.max(Math.min(d,m),0);if(!this._bUpdateButtons){if(this.getSelectedIndex()===undefined||e==0){this.setSelectedIndex(0);}else if(this.getSelectedIndex()>=d){this.setProperty("selectedIndex",this.getSelectedIndex()+1,true);}}if(d>=e){this.aRBs[d]=this._createRadioButton(b,d);}else{for(var i=(e);i>d;i--){this.aRBs[i]=this.aRBs[i-1];if((i-1)==d){this.aRBs[i-1]=this._createRadioButton(b,d);}}}this.insertAggregation("buttons",b,d);return this;};
a.prototype._createRadioButton=function(b,i){if(this.iIDCount==undefined){this.iIDCount=0;}else{this.iIDCount++;}b.setValueState(this.getValueState());b.setGroupName(this.getId());if(i==this.getSelectedIndex()){b.setSelected(true);}b.attachEvent("select",this._handleRBSelect,this);return b;};
a.prototype.removeButton=function(e){var i=e;if(typeof(e)=="string"){e=sap.ui.getCore().byId(e);}if(typeof(e)=="object"){i=this.indexOfButton(e);}var b=this.removeAggregation("buttons",i);if(!this.aRBs){this.aRBs=[];}if(!this.aRBs[i]){return null;}this.aRBs.splice(i,1);if(!this._bUpdateButtons){if(this.aRBs.length==0){this.setSelectedIndex(-1);}else if(this.getSelectedIndex()==i){this.setSelectedIndex(0);}else{if(this.getSelectedIndex()>i){this.setProperty("selectedIndex",this.getSelectedIndex()-1,true);}}}return b;};
a.prototype.removeAllButtons=function(){if(!this._bUpdateButtons){this.setSelectedIndex(-1);}this.aRBs=[];return this.removeAllAggregation("buttons");};
a.prototype.destroyButtons=function(){this.destroyAggregation("buttons");if(!this._bUpdateButtons){this.setSelectedIndex(-1);}if(this.aRBs){while(this.aRBs.length>0){this.aRBs[0].destroy();this.aRBs.splice(0,1);}}return this;};
a.prototype.updateButtons=function(){this._bUpdateButtons=true;this.updateAggregation("buttons");this._bUpdateButtons=undefined;};
a.prototype.clone=function(){var b=this.getButtons();var i=0;for(i=0;i<b.length;i++){b[i].detachEvent("select",this._handleRBSelect,this);}var o=C.prototype.clone.apply(this,arguments);for(i=0;i<b.length;i++){b[i].attachEvent("select",this._handleRBSelect,this);}return o;};
a.prototype._handleRBSelect=function(o){for(var i=0;i<this.aRBs.length;i++){if(this.aRBs[i].getId()==o.getParameter("id")&&o.getParameter("selected")){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});break;}}};
a.prototype.setValueState=function(v){this.setProperty("valueState",v,false);if(this.aRBs){for(var i=0;i<this.aRBs.length;i++){this.aRBs[i].setValueState(v);}}return this;};
a.prototype._handleAfterFocus=function(o){var i=o.getParameter("index");var e=o.getParameter("event");if(e.keyCode===undefined){return;}if(i!=this.getSelectedIndex()&&!(e.ctrlKey||e.metaKey)&&this.aRBs[i].getEditable()&&this.aRBs[i].getEnabled()&&this.getEditable()&&this.getEnabled()){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});}};
return a;});
sap.ui.predefine('sap/m/RadioButtonGroupRenderer',["sap/ui/core/library"],function(a){"use strict";var T=a.TextDirection;var R={};
R.render=function(r,o){var b=r;if(!o.aRBs){return;}var v=o.aRBs.filter(function(B){return B.getVisible();});var C=o.getColumns();var s=o.getTextDirection();var g=sap.ui.getCore().getConfiguration().getRTL();b.write("<div");b.writeControlData(o);b.addClass("sapMRbG");if(!o.getEditable()){b.addClass("sapMRbGRo");}if(C>1){if(C==v.length){b.addClass("sapMRbG1Row");}else{b.addClass("sapMRbGTab");}}if(o.getWidth()&&o.getWidth()!=""){b.addStyle("width",o.getWidth());}if(o.getTooltip_AsString()){b.writeAttributeEscaped("title",o.getTooltip_AsString());}if(!g&&s!=T.Inherit){b.writeAttribute("dir",s.toLowerCase());}b.writeAccessibilityState(o,{role:"radiogroup"});b.writeClasses();b.writeStyles();b.write(">");for(var c=0;c<C;c++){if(C>1&&C!=v.length){b.write("<div");b.addClass("sapMRbGCol");b.writeClasses();b.write(">");}for(var i=c;i<v.length;i=i+C){b.renderControl(v[i]);}if(C>1&&C!=v.length){b.write("</div>");}}if(C>1&&C!=v.length){b.write('<div class="sapMRbGDummy"> </div>');}b.write("</div>");};
return R;},true);
sap.ui.predefine('sap/m/RadioButtonRenderer',['sap/ui/core/ValueStateSupport','sap/ui/core/library','sap/ui/Device'],function(V,c,D){"use strict";var a=c.ValueState;var R={};
R.render=function(r,o){this.addWOuterDivStyles(r,o);this.addInnerDivStyles(r,o);this.renderSvg(r,o);this.renderInput(r,o);this.closeDiv(r);r.renderControl(o._oLabel);this.renderTooltip(r,o);this.closeDiv(r);};
R.addWOuterDivStyles=function(r,o){var i=o.getId(),e=o.getEnabled(),n=!o.getProperty("editableParent"),N=!o.getEditable()||n,I=a.Error===o.getValueState(),b=a.Warning===o.getValueState(),d=a.Success===o.getValueState(),f=a.Information===o.getValueState(),u=o.getUseEntireWidth();r.addClass("sapMRb");r.write("<div");r.writeControlData(o);if(u){r.addStyle("width",o.getWidth());r.writeStyles();}var t=V.enrichTooltip(o,o.getTooltip_AsString());if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState(o,{role:"radio",readonly:null,selected:null,checked:o.getSelected(),disabled:N?true:undefined,labelledby:{value:i+"-label",append:true},describedby:{value:(t?i+"-Descr":undefined),append:true}});if(o.getSelected()){r.addClass("sapMRbSel");}if(!e){r.addClass("sapMRbDis");}if(N){r.addClass("sapMRbRo");}if(I){r.addClass("sapMRbErr");}if(b){r.addClass("sapMRbWarn");}if(d){r.addClass("sapMRbSucc");}if(f){r.addClass("sapMRbInfo");}r.writeClasses();if(e){r.writeAttribute("tabindex",o.hasOwnProperty("_iTabIndex")?o._iTabIndex:0);}r.write(">");};
R.addInnerDivStyles=function(r,o){var b=this.isButtonReadOnly(o);r.write("<div ");r.addClass('sapMRbB');if(!b&&D.system.desktop){r.addClass('sapMRbHoverable');}r.writeClasses();r.write(">");};
R.renderSvg=function(r,o){var i=o.getId();r.write("<svg xmlns='http://www.w3.org/2000/svg' version='1.0'");r.addClass('sapMRbSvg');r.writeClasses();r.writeAttribute("role","presentation");r.write(">");r.write('<circle stroke="black" r="50%" stroke-width="2" fill="none"');r.addClass("sapMRbBOut");r.writeAttribute("id",i+"-Button");r.writeClasses();r.write(">");r.write("</circle>");r.write('<circle r="22%" stroke-width="10"');r.addClass("sapMRbBInn");r.writeClasses();r.write(">");r.write("</circle>");r.write("</svg>");};
R.renderInput=function(r,o){var i=o.getId(),b=this.isButtonReadOnly(o);r.write("<input type='radio' tabindex='-1'");r.writeAttribute("id",i+"-RB");r.writeAttributeEscaped("name",o.getGroupName());if(o.getSelected()){r.writeAttribute("checked","checked");}if(b){r.writeAttribute("readonly","readonly");r.writeAttribute("disabled","disabled");}r.write(" />");};
R.renderTooltip=function(r,o){var i=o.getId(),t=V.enrichTooltip(o,o.getTooltip_AsString());if(t&&sap.ui.getCore().getConfiguration().getAccessibility()){r.write("<span id=\""+i+"-Descr\" style=\"display: none;\">");r.writeEscaped(t);r.write("</span>");}};
R.isButtonReadOnly=function(r){var e=r.getEnabled(),n=!r.getProperty("editableParent"),N=!r.getEditable()||n;return!e||N;};
R.closeDiv=function(r){r.write("</div>");};
return R;},true);
sap.ui.predefine('sap/m/RangeSlider',["sap/ui/core/InvisibleText","sap/base/Log","./Slider","./SliderTooltip","./SliderUtilities","./RangeSliderRenderer","sap/ui/thirdparty/jquery"],function(I,l,S,a,b,R,q){"use strict";
var c=S.extend("sap.m.RangeSlider",{metadata:{library:"sap.m",properties:{value2:{type:"float",group:"Data",defaultValue:100},range:{type:"float[]",group:"Data",defaultValue:[0,100]}},designtime:"sap/m/designtime/RangeSlider.designtime"}});
c.prototype.init=function(){var s,e,r;S.prototype.init.call(this,arguments);this._bInitialRangeChecks=true;this._aInitialFocusRange=this.getRange();this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._ariaUpdateDelay=[];s=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_LEFT_HANDLE")});e=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_RIGHT_HANDLE")});r=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_RANGE_HANDLE")});this.destroyAggregation("_handlesLabels",true);this.addAggregation("_handlesLabels",s);this.addAggregation("_handlesLabels",e);this.addAggregation("_handlesLabels",r);this._mHandleTooltip={start:{handle:null,tooltip:null,label:s},end:{handle:null,tooltip:null,label:e}};};
c.prototype.exit=function(){this._oResourceBundle=null;this._aInitialFocusRange=null;this._liveChangeLastValue=null;this._mHandleTooltip.start.handle=null;this._mHandleTooltip.start.tooltip=null;this._mHandleTooltip.start.label=null;this._mHandleTooltip.end.handle=null;this._mHandleTooltip.end.tooltip=null;this._mHandleTooltip.end.label=null;this._ariaUpdateDelay=null;};
c.prototype.onBeforeRendering=function(){this._bRTL=sap.ui.getCore().getConfiguration().getRTL();var r=this.getRange();if(this.getShowAdvancedTooltip()){this.initAndSyncTooltips(["leftTooltip","rightTooltip"]);this._storeTooltipsMetadata();}this._bInitialRangeChecks=false;this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(this.getStep());this.setRange(r);this._validateProperties();this._syncScaleUsage();};
c.prototype.onAfterRendering=function(){S.prototype.onAfterRendering.apply(this,arguments);var r=this.getRange();this._mHandleTooltip.start.handle=this.getDomRef("handle1");this._mHandleTooltip.end.handle=this.getDomRef("handle2");this._recalculateStyles();this._updateHandle(this._mHandleTooltip.start.handle,r[0]);this._updateHandle(this._mHandleTooltip.end.handle,r[1]);if(this.getShowAdvancedTooltip()&&(r[0]>r[1])){this._swapTooltips(r);}};
c.prototype._storeTooltipsMetadata=function(){var t=this.getUsedTooltips();if(!this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.tooltip=t[0];}if(!this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.tooltip=t[1];}this._mHandleTooltip.bTooltipsSwapped=false;};
c.prototype._recalculateRange=function(){var h,s,e,p,d=this._bRTL?"right":"left";h=[parseFloat(this._mHandleTooltip.start.handle.style[d]),parseFloat(this._mHandleTooltip.end.handle.style[d])];s=Math.min.apply(Math,h)+"%";e=(100-Math.max.apply(Math,h))+"%";p=this.getDomRef("progress");if(this._bRTL){p.style.left=e;p.style.right=s;}else{p.style.left=s;p.style.right=e;}};
c.prototype.getClosestHandleDomRef=function(e){var h=this._mHandleTooltip.start.handle,H=this._mHandleTooltip.end.handle,p=Math.abs(e.pageX-h.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft),C=Math.abs(e.clientX-H.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft);return p>C?H:h;};
c.prototype._getIndexOfHandle=function(h){if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="start"){return 0;}else if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="end"){return 1;}else{return-1;}};
c.prototype._getHandleForTooltip=function(t){var h=t===this._mHandleTooltip.start.tooltip?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;return h;};
c.prototype._updateHandle=function(h,v){var t=(this._mHandleTooltip.start.handle===h)?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip,r=this.getRange(),i=this._getIndexOfHandle(h),p=this._getPercentOfValue(v);r[i]=v;this._updateRangePropertyDependencies(r);this._updateHandleDom(h,r,i,v,p);if(this.getShowAdvancedTooltip()){this._updateTooltipContent(t,v);this._adjustTooltipsContainer();}this._recalculateRange();};
c.prototype._updateHandleDom=function(h,r,i,v,p){var m,C=this.getRenderer().CSS_CLASS,f=this.getDomRef("input");if(!!this.getName()){f.setAttribute(h.getAttribute("data-range-val"),this.toFixed(r[i],this._iDecimalPrecision));f.setAttribute("value",this.getValue());}if(this._bRTL){h.style.right=p+"%";}else{h.style.left=p+"%";}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=this._formatValueByCustomElement(v);}m=r[0]===r[1];this.$("handle1").toggleClass(C+"HandleOverlap",m);this.$("handle2").toggleClass(C+"HandleOverlap",m);clearTimeout(this._ariaUpdateDelay[i]);this._ariaUpdateDelay[i]=setTimeout(this["_updateHandleAria"].bind(this,h,v),100);};
c.prototype._updateHandleAria=function(h,v){var r=this.getRange(),p=this.getDomRef("progress"),n=this.toFixed(v,this._iDecimalPrecision),s=this._formatValueByCustomElement(n);r[0]=this.toFixed(r[0],this._iDecimalPrecision);r[1]=this.toFixed(r[1],this._iDecimalPrecision);this._updateHandlesAriaLabels();this._updateHandleAriaAttributeValues(h,v,s);if(p){p.setAttribute("aria-valuetext",this._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',r.map(this._formatValueByCustomElement,this)));}};
c.prototype._updateHandlesAriaLabels=function(){var r=this.getRange(),t=this._mHandleTooltip.start.label;if((r[0]>r[1]&&!this._mHandleTooltip.bAriaHandlesSwapped)||(r[0]<r[1]&&this._mHandleTooltip.bAriaHandlesSwapped)){this._mHandleTooltip.start.label=this._mHandleTooltip.end.label;this._mHandleTooltip.end.label=t;if(this._mHandleTooltip.start.handle){this._mHandleTooltip.start.handle.setAttribute("aria-labelledby",this._mHandleTooltip.start.label.getId());}if(this._mHandleTooltip.end.handle){this._mHandleTooltip.end.handle.setAttribute("aria-labelledby",this._mHandleTooltip.end.label.getId());}this._mHandleTooltip.bAriaHandlesSwapped=!this._mHandleTooltip.bAriaHandlesSwapped;}};
c.prototype._setAriaControls=function(){if(!this.getShowAdvancedTooltip()){return;}if(!this._mHandleTooltip.start.handle.getAttribute('aria-controls')&&this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.handle.setAttribute('aria-controls',this._mHandleTooltip.start.tooltip.getId());}if(!this._mHandleTooltip.end.handle.getAttribute('aria-controls')&&this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.handle.setAttribute('aria-controls',this._mHandleTooltip.end.tooltip.getId());}};
c.prototype._updateTooltipContent=function(t,n){var N=this.toFixed(n,this._iDecimalPrecision);t.setValue(parseFloat(N));};
c.prototype._swapTooltips=function(r){var t=this._mHandleTooltip.start.tooltip;if((r[0]>=r[1]&&!this._mHandleTooltip.bTooltipsSwapped)||(r[0]<=r[1]&&this._mHandleTooltip.bTooltipsSwapped)){this._mHandleTooltip.start.tooltip=this._mHandleTooltip.end.tooltip;this._mHandleTooltip.end.tooltip=t;this._updateTooltipContent(this._mHandleTooltip.start.tooltip,r[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,r[1]);if(this.getInputsAsTooltips()){this._mHandleTooltip.start.handle.setAttribute("aria-controls",this._mHandleTooltip.start.tooltip.getId());this._mHandleTooltip.end.handle.setAttribute("aria-controls",this._mHandleTooltip.end.tooltip.getId());}this._mHandleTooltip.bTooltipsSwapped=!this._mHandleTooltip.bTooltipsSwapped;}};
c.prototype._adjustTooltipsContainer=function(){var t=this.getAggregation("_tooltipContainer");if(!t.getDomRef()){return;}t.repositionTooltips(this.getMin(),this.getMax());this._swapTooltips(this.getRange());};
c.prototype.getUsedTooltips=function(){var C=this.getCustomTooltips(),d=this.getAggregation("_defaultTooltips")||[];return C.length>1?C:d;};
c.prototype.handleTooltipChange=function(e){this.updateTooltipsPositionAndState(e.getSource(),Number(e.getParameter("value")));};
c.prototype.updateTooltipsPositionAndState=function(t,v){var h,A,T=this._mHandleTooltip.bTooltipsSwapped;v=this._adjustRangeValue(v);h=this._mHandleTooltip.start.tooltip===t?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;this._updateHandle(h,v);if(T!==this._mHandleTooltip.bTooltipsSwapped){A=this._mHandleTooltip.start.tooltip!==t?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip;A.focus();}this._fireChangeAndLiveChange({range:this.getRange()});this.updateAdvancedTooltipDom();};
c.prototype._updateDOMAfterSetters=function(v,r,h){var p,H;if(this.getDomRef()){p=this._getPercentOfValue(v);H=h===1?this._mHandleTooltip.end:this._mHandleTooltip.start;this._updateHandleDom(H.handle,r,h,v,p);if(this.getShowAdvancedTooltip()){this._updateTooltipContent(H.tooltip,v);}return true;}return false;};
c.prototype.setRange=function(r){r=r.map(this._adjustRangeValue,this);this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)&&this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
c.prototype.setStep=function(s){this._validateProperties();this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(s);return this.setProperty("step",s);};
c.prototype.setValue=function(v){var r=this.getRange();if(typeof v!=="number"||!isFinite(v)){return this;}v=this._adjustRangeValue(v);r[0]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)){this._recalculateRange();}return this;};
c.prototype.setValue2=function(v){var r=this.getRange();v=this._adjustRangeValue(v);r[1]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
c.prototype._updateRangePropertyDependencies=function(r){var d=Array.isArray(r)?r.slice():[],D=this._iDecimalPrecision?this._iDecimalPrecision:0,n=Number(d[0].toFixed(D)),N=Number(d[1].toFixed(D));if(this.getProperty("value")!==n){this.setProperty("value",n,true);d[0]=n;}if(this.getProperty("value2")!==N){this.setProperty("value2",N,true);d[1]=N;}this.setProperty("range",d,true);};
c.prototype._calculateHandlePosition=function(v){var m=this.getMax(),M=this.getMin(),n;n=((v-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(m-M)+M;if(this._bRTL){n=this._convertValueToRtlMode(n);}return this._adjustRangeValue(n);};
c.prototype._adjustRangeValue=function(v){var m=this.getMax(),M=this.getMin(),s=this.getStep(),f;if(this._bInitialRangeChecks){return v;}f=Math.abs((v-M)%s);if(f!==0){v=f*2>=s?v+s-f:v-f;}if(v<M){l.warning("Warning: "+"Min value ("+v+") not in the range: ["+M+","+m+"]",this);v=M;}else if(v>m){l.warning("Warning: "+"Max value ("+v+") not in the range: ["+M+","+m+"]",this);v=m;}return v;};
c.prototype.ontouchstart=function(e){var t=e.targetTouches[0],C=this.getRenderer().CSS_CLASS,E="."+C,m,M,v,h,r,H,f,F,T,p,d,g;if(!this.getEnabled()){return;}e.setMarked();if(e.target.className.indexOf("sapMInput")===-1){e.preventDefault();}this._recalculateStyles();if(["number","text"].indexOf(e.target.type)>-1){return;}v=this._calculateHandlePosition(t.pageX);r=this.getRange();h=[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];H=this._getIndexOfHandle(e.target);f=h.reduce(function(A,o){return Math.abs(A-o.offsetLeft);},0);m=Math.min.apply(Math,r);M=Math.max.apply(Math,r);g=this.$("handle1").outerWidth()/2;T=Math.abs(this.getMin())+Math.abs(this.getMax());p=((g*100)/this.$("inner").outerWidth());d=(p/100)*T;if(v<m||v<m+d||v>M||v>(M-d)||f<=b.CONSTANTS.RANGE_MOVEMENT_THRESHOLD){h=[this.getClosestHandleDomRef(t)];this._updateHandle(h[0],v);this._fireChangeAndLiveChange({range:this.getRange()});}else if(H!==-1){h=[this.getDomRef(H===0?"handle1":"handle2")];}q(document).on("touchend"+E+" touchcancel"+E+" mouseup"+E,this._ontouchend.bind(this,h)).on("touchmove"+E+(e.originalEvent.type!=="touchstart"?" mousemove"+E:""),this._ontouchmove.bind(this,v,this.getRange(),h));h.map(function(o){if(o.className.indexOf(C+"HandlePressed")===-1){o.className+=" "+C+"HandlePressed";}});F=h.length===1?h[0]:this.getDomRef("progress");setTimeout(F["focus"].bind(F),0);};
c.prototype._ontouchmove=function(f,d,h,e){var o,r,g,j,p=e.targetTouches?e.targetTouches[0].pageX:e.pageX,m=this.getMax(),M=this.getMin(),k=[],n=[];e.preventDefault();e.setMarked();if(e.isMarked("delayedMouseEvent")||!this.getEnabled()||e.button){return;}o=this._calculateHandlePosition(p)-f;for(var i=0;i<d.length;i++){k[i]=d[i]+o;}n=this._getNormalizedRange(this.getRange(),d,h);r=k.every(function(v,s){return v===n[s];});g=k.every(function(v){return(v>=M&&v<=m);});j=n.indexOf(M)>-1||n.indexOf(m)>-1;if(!r){if((h.length===1)||g||!j){h.map(function(H){this._updateHandle(H,d[this._getIndexOfHandle(H)]+o);},this);}this.getShowAdvancedTooltip()&&this._adjustTooltipsContainer();n=this._getNormalizedRange(this.getRange(),d,h);}this._triggerLiveChange();this.setRange(n);};
c.prototype.updateAdvancedTooltipDom=function(){this.getAggregation("_tooltipContainer").repositionTooltips(this.getMin(),this.getMax());};
c.prototype._triggerLiveChange=function(){var f,r=this.getRange();this._liveChangeLastValue=this._liveChangeLastValue||[];f=r.some(function(v,i){return v!==this._liveChangeLastValue[i];},this);if(f){this._liveChangeLastValue=r.slice();this.fireLiveChange({range:r});}};
c.prototype._getNormalizedRange=function(r,d,h){var m=this.getMax(),M=this.getMin(),s=Math.abs(d[0]-d[1]),e=[],i,o;for(i=0;i<r.length;i++){e[i]=(r[i]<M?M:r[i]);e[i]=(r[i]>m?m:e[i]);if(h.length===2){if(e[0]==M){e[1]=e[0]+s;}else{o=Math.abs(i-1);e[o]=(e[i]<=M?e[i]+s:e[o]);e[o]=(e[i]>=m?e[i]-s:e[o]);}}}return e;};
c.prototype._ontouchend=function(h,e){var n=this.getRange(),C=this.getRenderer().CSS_CLASS;e.setMarked();h&&h.map(function(H){H.className=H.className.replace(new RegExp(" ?"+C+"HandlePressed","gi"),"");});q(document).off("."+C);this._recalculateRange();if(this._aInitialFocusRange[0]!==n[0]||this._aInitialFocusRange[1]!==n[1]){this._aInitialFocusRange=Array.prototype.slice.call(n);this.fireChange({range:n});}if(this.getShowAdvancedTooltip()){this._updateTooltipContent(this._mHandleTooltip.start.tooltip,n[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,n[1]);}};
c.prototype.onfocusin=function(e){var t=this.getAggregation("_tooltipContainer");if(this.getShowAdvancedTooltip()){t.show(this);this._adjustTooltipsContainer();this._setAriaControls();}if(!(document.activeElement===this.getFocusDomRef())){this._aInitialFocusRange=this.getRange();}};
c.prototype.getFocusDomRef=function(){return this.getDomRef("progress");};
c.prototype._updateSliderValues=function(o,h){var r=this.getRange(),m=this.getMax(),M=this.getMin(),f=Math.max.apply(null,r),d=Math.min.apply(null,r),i=this._getIndexOfHandle(h),O=o<0?-1:1,H=i>-1?[h]:[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];if(H.length===1){d=f=r[i];}if(f+o>m){o=O*(Math.abs(m)-Math.abs(f));}else if(d+o<M){o=O*(Math.abs(d)-Math.abs(M));}H.map(function(C){this._updateHandle(C,r[this._getIndexOfHandle(C)]+o);},this);};
c.prototype.onkeydown=function(e){var f=this.getInputsAsTooltips(),s=this.getShowAdvancedTooltip(),F=e.keyCode===b.CONSTANTS.F2_KEYCODE,d=(e.target===this._mHandleTooltip.start.handle),t=q(e.target).hasClass(b.CONSTANTS.HANDLE_CLASS);if(F&&s&&f&&t){this._mHandleTooltip[d?"start":"end"].tooltip.focus();}};
c.prototype.onsapincrease=function(e){e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapplus=c.prototype.onsapincrease;
c.prototype.onsapincreasemodifiers=function(e){if(e.altKey){return;}e.preventDefault();e.stopPropagation();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsappageup=c.prototype.onsapincreasemodifiers;
c.prototype.onsapdecrease=function(e){e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapminus=c.prototype.onsapdecrease;
c.prototype.onsapdecreasemodifiers=function(e){if(e.altKey){return;}e.preventDefault();e.stopPropagation();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsappagedown=c.prototype.onsapdecreasemodifiers;
c.prototype.onsaphome=function(e){var h=0,r,H,m;e.setMarked();e.preventDefault();h=this._getIndexOfHandle(e.target);r=this.getRange()[h];m=this.getMin();if(this.getEnabled()&&(r!==m)){H=(h===1?this._mHandleTooltip.end:this._mHandleTooltip.start);this._updateHandle(H.handle,m);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapend=function(e){e.setMarked();e.preventDefault();if(this.getEnabled()){this._updateSliderValues(this.getMax(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapescape=function(){this.setRange(this._aInitialFocusRange);this._fireChangeAndLiveChange({range:this.getRange()});};
return c;});
sap.ui.predefine('sap/m/RangeSliderRenderer',["sap/ui/core/Renderer","./SliderRenderer","sap/ui/core/InvisibleText"],function(R,S,I){"use strict";var a=R.extend(S);
a.renderHandles=function(r,c,s){this.renderHandle(r,c,{id:c.getId()+"-handle1",position:"start",forwardedLabels:s});this.renderHandle(r,c,{id:c.getId()+"-handle2",position:"end",forwardedLabels:s});r.renderControl(c._mHandleTooltip.start.label);r.renderControl(c._mHandleTooltip.end.label);r.renderControl(c.getAggregation("_handlesLabels")[2]);};
a.renderHandle=function(r,c,o){var v,b=c.getRange(),e=c.getEnabled(),d=sap.ui.getCore().getConfiguration().getRTL();r.write("<span");if(o&&(o.id!==undefined)){r.writeAttributeEscaped("id",o.id);}if(o&&(o.position!==undefined)){v=b[o.position==="start"?0:1];r.writeAttribute("data-range-val",o.position);r.writeAttribute("aria-labelledby",(o.forwardedLabels+" "+c._mHandleTooltip[o.position].label.getId()).trim());if(c.getInputsAsTooltips()){r.writeAttribute("aria-describedby",I.getStaticId("sap.m","SLIDER_INPUT_TOOLTIP"));}}if(c.getShowHandleTooltip()&&!c.getShowAdvancedTooltip()){this.writeHandleTooltip(r,c);}r.addClass(S.CSS_CLASS+"Handle");if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle1")){r.addStyle(d?"right":"left",b[0]);}if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle2")){r.addStyle(d?"right":"left",b[1]);}this.writeAccessibilityState(r,c,v);r.writeClasses();r.writeStyles();if(e){r.writeAttribute("tabindex","0");}r.write("></span>");};
a.writeAccessibilityState=function(r,s,v){var n=s._isElementsFormatterNotNumerical(v),b=s._formatValueByCustomElement(v),V;if(s._getUsedScale()&&!n){V=b;}else{V=s.toFixed(v);}r.writeAccessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:V});if(n){r.writeAccessibilityState(s,{valuetext:b});}};
a.renderStartLabel=function(r,c){r.write("<div");r.addClass(S.CSS_CLASS+"RangeLabel");r.writeClasses();r.write(">");r.write(c.getMin());r.write("</div>");};
a.renderEndLabel=function(r,c){r.write("<div");r.addClass(S.CSS_CLASS+"RangeLabel");r.addStyle("width",c._getMaxTooltipWidth()+"px");r.writeClasses();r.writeStyles();r.write(">");r.write(c.getMax());r.write("</div>");};
a.renderLabels=function(r,c){r.write("<div");r.addClass();r.addClass(S.CSS_CLASS+"Labels");r.writeClasses();r.write(">");this.renderStartLabel(r,c);this.renderEndLabel(r,c);r.write("</div>");};
a.renderProgressIndicator=function(r,s,f){var b=s.getRange();b[0]=s.toFixed(b[0],s._iDecimalPrecision);b[1]=s.toFixed(b[1],s._iDecimalPrecision);r.write("<div");r.writeAttribute("id",s.getId()+"-progress");if(s.getEnabled()){r.writeAttribute("tabindex","0");}this.addProgressIndicatorClass(r,s);r.addStyle("width",s._sProgressValue);r.writeClasses();r.writeStyles();r.writeAccessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuetext:s._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',b.map(s._formatValueByCustomElement,s)),labelledby:(f+" "+s.getAggregation("_handlesLabels")[2].getId()).trim()});r.write('></div>');};
a.addClass=function(r,s){S.addClass(r,s);r.addClass("sapMRangeSlider");};
return a;},true);
sap.ui.predefine('sap/m/RatingIndicator',['./library','sap/ui/core/Control','sap/ui/core/theming/Parameters','./RatingIndicatorRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,C,P,R,K,L,q){"use strict";var a=l.RatingIndicatorVisualMode;
var b=C.extend("sap.m.RatingIndicator",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},maxValue:{type:"int",group:"Behavior",defaultValue:5},value:{type:"float",group:"Behavior",defaultValue:0,bindable:"bindable"},iconSize:{type:"sap.ui.core.CSSSize",group:"Behavior",defaultValue:null},iconSelected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconUnselected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconHovered:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},visualMode:{type:"sap.m.RatingIndicatorVisualMode",group:"Behavior",defaultValue:a.Half},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},editable:{type:"boolean",group:"Behavior",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"int"}}},liveChange:{parameters:{value:{type:"float"}}}},designtime:"sap/m/designtime/RatingIndicator.designtime"}});
b.prototype.init=function(){this.allowTextSelection(false);this._iIconCounter=0;this._fHoverValue=0;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');};
b.prototype.setValue=function(v){v=this.validateProperty("value",v);if(v<0){return this;}if(isNaN(v)){L.warning('Ignored new rating value "'+v+'" because it is NAN');}else if(this.$().length&&(v>this.getMaxValue())){L.warning('Ignored new rating value "'+v+'" because it is out  of range (0-'+this.getMaxValue()+')');}else{v=this._roundValueToVisualMode(v);this.setProperty("value",v,true);this._fHoverValue=v;if(this.$().length){this._updateUI(v);}}return this;};
b.prototype.setIconSize=function(i){if(this.$().length){this._iPxIconSize=this._toPx(i)||16;}this.setProperty("iconSize",i,false);return this;};
b.prototype.onThemeChanged=function(e){this.invalidate();};
b.prototype.onBeforeRendering=function(){var v=this.getValue(),m=this.getMaxValue(),i;if(v>m){this.setValue(m);L.warning("Set value to maxValue because value is > maxValue ("+v+" > "+m+").");}else if(v<0){this.setValue(0);L.warning("Set value to 0 because value is < 0 ("+v+" < 0).");}if(this.getIconSize()){this._iPxIconSize=this._toPx(this.getIconSize());i="sapUiRIIconPadding"+this._getIconSizeLabel(this._iPxIconSize);this._iPxPaddingSize=this._toPx(P.get(i));}else{if(this.getDisplayOnly()){this._iPxIconSize=this._toPx(P.get("sapUiRIIconSizeDisplayOnly"));this._iPxPaddingSize=this._toPx(P.get("sapUiRIIconPaddingDisplayOnly"));}else{var d=this._getDensityMode();this._iPxIconSize=this._toPx(P.get("sapUiRIIconSize"+d));this._iPxPaddingSize=this._toPx(P.get("sapUiRIIconPadding"+d));}}};
b.prototype.onAfterRendering=function(){this._updateAriaValues();};
b.prototype.exit=function(){this._iIconCounter=null;this._fStartValue=null;this._iPxIconSize=null;this._iPxPaddingSize=null;this._fHoverValue=null;this._oResourceBundle=null;};
b.prototype._getDensityMode=function(){var d=[{name:"Cozy",style:"sapUiSizeCozy"},{name:"Compact",style:"sapUiSizeCompact"},{name:"Condensed",style:"sapUiSizeCondensed"}],D,s,i;for(i in d){D=d[i].style;if(q("html").hasClass(D)||q("."+D).length>0){s=d[i].name;}}return s||d[0].name;};
b.prototype._getIconSizeLabel=function(p){switch(true){case(p>=32):return"L";case(this._iPxIconSize>=22):return"M";case(this._iPxIconSize>=16):return"S";case(this._iPxIconSize>=12):return"XS";default:return"M";}};
b.prototype._toPx=function(c){var s=Math.round(c),d;if(isNaN(s)){if(RegExp("^(auto|0)$|^[+-]?[0-9].?([0-9]+)?(px|em|rem|ex|%|in|cm|mm|pt|pc)$").test(c)){d=q('<div style="display: none; width: '+c+'; margin: 0; padding:0; height: auto; line-height: 1; font-size: 1; border:0; overflow: hidden">&nbsp;</div>').appendTo(sap.ui.getCore().getStaticAreaRef());s=d.width();d.remove();}else{return false;}}return Math.round(s);};
b.prototype._updateUI=function(v,h){var s=this.$("sel"),u=this.$("unsel-wrapper"),H=this.$("hov"),i=this._iPxIconSize,I=this._iPxPaddingSize,c="px",S=this.getMaxValue(),d=v*i+(Math.round(v)-1)*I,w=S*(i+I)-I;this._fHoverValue=v;if(d<0){d=0;}this._updateAriaValues(v);u.width((w-d)+c);if(h){H.width(d+c);s.hide();H.show();}else{s.width(d+c);H.hide();s.show();}L.debug("Updated rating UI with value "+v+" and hover mode "+h);};
b.prototype._updateAriaValues=function(n){var $=this.$();var v;if(n===undefined){v=this.getValue();}else{v=n;}var m=this.getMaxValue();$.attr("aria-valuenow",v);$.attr("aria-valuemax",m);var V=this._oResourceBundle.getText("RATING_VALUEARIATEXT",[v,m]);$.attr("aria-valuetext",V);};
b.prototype._calculateSelectedValue=function(e){var s=-1.0,p=0.0,c=this.$(),f=(c.innerWidth()-c.width())/2,E,r=sap.ui.getCore().getConfiguration().getRTL();if(e.targetTouches){E=e.targetTouches[0];}else{E=e;}if(!E||!E.pageX){E=e;if((!E||!E.pageX)&&e.changedTouches){E=e.changedTouches[0];}}if(!E.pageX){return parseFloat(s);}if(E.pageX<c.offset().left){s=0;}else if((E.pageX-c.offset().left)>c.innerWidth()-f){s=this.getMaxValue();}else{p=(E.pageX-c.offset().left-f)/c.width();s=p*this.getMaxValue();}if(r){s=this.getMaxValue()-s;}return this._roundValueToVisualMode(s,true);};
b.prototype._roundValueToVisualMode=function(v,i){if(i){if(v<0.25){v=0;}else if(v<this.getMaxValue()-0.4){v+=0.4;}v=Math.round(v);}else{if(this.getVisualMode()===a.Full){v=Math.round(v);}else if(this.getVisualMode()===a.Half){v=Math.round(v*2)/2;}}return parseFloat(v);};
b.prototype._getIncreasedValue=function(){var m=this.getMaxValue(),v=this.getValue()+this._getValueChangeStep();if(v>m){v=m;}return v;};
b.prototype._getDecreasedValue=function(){var v=this.getValue()-this._getValueChangeStep();if(v<0){v=0;}return v;};
b.prototype._getValueChangeStep=function(){var v=this.getVisualMode(),s;switch(v){case a.Full:s=1;break;case a.Half:if(this.getValue()%1===0.5){s=0.5;}else{s=1;}break;default:L.warning("VisualMode not supported",v);}return s;};
b.prototype.ontouchstart=function(e){if(e.which==2||e.which==3||!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return;}e.setMarked();if(!this._touchEndProxy){this._touchEndProxy=q.proxy(this._ontouchend,this);}if(!this._touchMoveProxy){this._touchMoveProxy=q.proxy(this._ontouchmove,this);}q(document).on("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).on("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);this._fStartValue=this.getValue();var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}};
b.prototype._ontouchmove=function(e){if(e.isMarked("delayedMouseEvent")){return;}e.preventDefault();if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}}};
b.prototype._ontouchend=function(e){if(e.isMarked("delayedMouseEvent")){return;}if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(this.getValue()===1&&v===1){v=0;}this.setProperty("value",v,true);this._updateUI(v,false);if(this._fStartValue!==v){this.fireLiveChange({value:v});this.fireChange({value:v});}q(document).off("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).off("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);delete this._fStartValue;}};
b.prototype.ontouchcancel=b.prototype.ontouchend;
b.prototype.onsapincrease=function(e){var v=this._getIncreasedValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsapdecrease=function(e){var v=this._getDecreasedValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsaphome=function(e){var v=0;this._handleKeyboardValueChange(e,v);};
b.prototype.onsapend=function(e){var v=this.getMaxValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsapselect=function(e){var v;if(this.getValue()===this.getMaxValue()){v=0;}else{v=this._getIncreasedValue();}this._handleKeyboardValueChange(e,v);};
b.prototype.onkeyup=function(e){var m=this.getMaxValue();if(!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return false;}switch(e.which){case K.DIGIT_0:case K.NUMPAD_0:this.setValue(0);break;case K.DIGIT_1:case K.NUMPAD_1:this.setValue(1);break;case K.DIGIT_2:case K.NUMPAD_2:this.setValue(Math.min(2,m));break;case K.DIGIT_3:case K.NUMPAD_3:this.setValue(Math.min(3,m));break;case K.DIGIT_4:case K.NUMPAD_4:this.setValue(Math.min(4,m));break;case K.DIGIT_5:case K.NUMPAD_5:this.setValue(Math.min(5,m));break;case K.DIGIT_6:case K.NUMPAD_6:this.setValue(Math.min(6,m));break;case K.DIGIT_7:case K.NUMPAD_7:this.setValue(Math.min(7,m));break;case K.DIGIT_8:case K.NUMPAD_8:this.setValue(Math.min(8,m));break;case K.DIGIT_9:case K.NUMPAD_9:this.setValue(Math.min(9,m));break;}};
b.prototype._handleKeyboardValueChange=function(e,v){if(!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return;}if(v!==this.getValue()){this.setValue(v);this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
b.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"slider",type:B.getText("ACC_CTR_TYPE_RATING"),description:B.getText("ACC_CTR_STATE_RATING",[this.getValue(),this.getMaxValue()]),focusable:this.getEnabled()&&!this.getDisplayOnly(),enabled:this.getEnabled(),editable:this.getEditable()};};
return b;});
sap.ui.predefine('sap/m/RatingIndicatorRenderer',['sap/ui/core/IconPool','sap/ui/Device'],function(I,D){"use strict";var R={},s='px';
R.render=function(r,c){var t=this;this.initSharedState(c);this.renderControlContainer(r,c,function(){t.renderAriaLabel(r,c);t.renderSelectedItems(r,c);t.renderUnselectedItems(r,c);t.renderHoverItems(r,c);t.renderSelectorDiv(r,c);});};
R.renderControlContainer=function(r,c,i){var e=c.getEnabled(),E=c.getEditable(),d=c.getDisplayOnly();r.write("<div");r.writeControlData(c);r.addStyle("width",this._iWidth+"px");r.addStyle("height",this._iHeight+"px");if(e&&!d){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");if(!E){r.addClass("sapMRIReadOnly");}}else{r.writeAttribute("tabindex","-1");e?r.addClass("sapMRIDisplayOnly"):r.addClass("sapMRIDisabled");}r.addClass("sapMRI");r.addClass("sapUiRatingIndicator"+c._getIconSizeLabel(this._fIconSize));r.writeStyles();r.writeClasses();this.writeTooltip(r,c);this.writeAccessibility(r,c);r.write(">");i();r.write("</div>");};
R.initSharedState=function(c){var r=c._roundValueToVisualMode(c.getValue()),i=c._iPxIconSize,f=c._iPxPaddingSize,S=r*i+(Math.round(r)-1)*f;if(S<0){S=0;}this._bUseGradient=D.browser.chrome||D.browser.safari;this._sLabelID=c.getId()+"-ariaLabel";this._iSymbolCount=c.getMaxValue();this._iWidth=this._iSymbolCount*(i+f)-f;this._iHeight=i;this._iSelectedWidth=S;this._fIconSize=i;};
R.writeTooltip=function(r,c){var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}};
R.writeAccessibility=function(r,c){r.writeAccessibilityState(c,{"role":"slider","orientation":"horizontal","valuemin":0,"readonly":null,"disabled":!c.getEnabled()||c.getDisplayOnly(),"labelledby":{value:this._sLabelID,append:true}});};
R.renderAriaLabel=function(r,c){r.write("<span id='"+this._sLabelID+"' class='sapUiInvisibleText' aria-hidden='true'>"+c._oResourceBundle.getText("RATING_ARIA_NAME")+"</span>");};
R.renderSelectedItems=function(r,c){r.write("<div class='sapMRISel");if(this._bUseGradient){r.write(" sapMRIGrd");}r.write("'");r.writeAttribute("id",c.getId()+"-sel");r.writeAttribute("style","width: "+this._iSelectedWidth+s);r.write(">");for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("SELECTED",r,c);}r.write("</div>");};
R.renderUnselectedItems=function(r,c){r.write("<div class='sapMRIUnselWrapper'");r.writeAttribute("id",c.getId()+"-unsel-wrapper");r.writeAttribute("style","width: "+(this._iWidth-this._iSelectedWidth)+s);r.write(">");r.write("<div class='sapMRIUnsel");if(this._bUseGradient&&(c.getEnabled()||!c.getDisplayOnly())){r.write(" sapMRIGrd");}r.write("' id='"+c.getId()+"-unsel'>");for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("UNSELECTED",r,c);}r.write("</div>");r.write("</div>");};
R.renderHoverItems=function(r,c){if(c.getEnabled()||!c.getDisplayOnly()){r.write("<div class='sapMRIHov' id='"+c.getId()+"-hov'>");for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("HOVERED",r,c);}r.write("</div>");}};
R.renderSelectorDiv=function(r,c){r.write("<div class='sapMRISelector' id='"+c.getId()+"-selector'>");r.write("</div>");};
R.renderIcon=function(i,r,c){var a=this.getIconURI(i,c),t=this.getIconTag(a),b=I.isIconURI(a),d=this._fIconSize+s;r.write("<"+t+" ");if(i==="UNSELECTED"&&!c.getEditable()){i="READONLY";}r.write("class='sapUiIcon "+this.getIconClass(i)+"' ");var e="";e+="width:"+d+";";e+="height:"+d+";";e+="line-height:"+d+";";e+="font-size:"+d+";";r.writeAttribute("style",e);if(!b){r.writeAttributeEscaped("src",a);}r.write(">");if(b){r.writeEscaped(I.getIconInfo(a).content);}r.write("</"+t+">");};
R.getIconClass=function(i){switch(i){case"SELECTED":return"sapMRIIconSel";case"UNSELECTED":return"sapMRIIconUnsel";case"HOVERED":return"sapMRIIconHov";case"READONLY":return"sapMRIIconReadOnly";}};
R.getIconURI=function(S,c){if(sap.ui.getCore().getConfiguration().getTheme()==="sap_hcb"){if(S==="UNSELECTED"&&(c.getEnabled()&&!c.getDisplayOnly())){return I.getIconURI("unfavorite");}return I.getIconURI('favorite');}switch(S){case"SELECTED":return c.getIconSelected()||I.getIconURI("favorite");case"UNSELECTED":if(c.getEditable()&&!c.getDisplayOnly()){return c.getIconUnselected()||I.getIconURI("unfavorite");}else{return c.getIconUnselected()||I.getIconURI("favorite");}break;case"HOVERED":return c.getIconHovered()||I.getIconURI("favorite");}};
R.getIconTag=function(i){if(I.isIconURI(i)){return"span";}return"img";};
return R;},true);
sap.ui.predefine('sap/m/ResponsivePopover',['./Dialog','./Popover','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/base/ManagedObject','sap/ui/Device','./ResponsivePopoverRenderer','./Toolbar','./ToolbarSpacer','./Button',"sap/ui/thirdparty/jquery"],function(D,P,l,T,C,I,M,a,R,b,c,B,q){"use strict";var d=l.DialogType;var e=l.PlacementType;var f=l.TitleAlignment;
var g=C.extend("sap.m.ResponsivePopover",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:e.Right},showHeader:{type:"boolean",group:"Misc",defaultValue:true},title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},modal:{type:"boolean",group:"Misc",defaultValue:null},offsetX:{type:"int",group:"Misc",defaultValue:null},offsetY:{type:"int",group:"Misc",defaultValue:null},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},showCloseButton:{type:"boolean",group:"Misc",defaultValue:true},resizable:{type:"boolean",group:"Dimension",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:f.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},_popup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}}});
g.prototype.init=function(){var t=this;this._bAppendedToUIArea=false;var s={resizable:t.getResizable(),titleAlignment:t.getTitleAlignment(),beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter('openBy')});},afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter('openBy')});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter('openBy'),origin:E.getParameter('origin')});},afterClose:function(E){t.fireAfterClose({openBy:E.getParameter('openBy'),origin:E.getParameter('origin')});}};if(a.system.phone){this._aNotSupportedProperties=["placement","modal","offsetX","offsetY","showCloseButton"];s.stretch=true;s.type=d.Standard;this._oControl=new D(this.getId()+"-dialog",s);}else{this._aNotSupportedProperties=["icon","showCloseButton"];this._oControl=new P(this.getId()+"-popover",s);}this.setAggregation("_popup",this._oControl);this._oControl.addStyleClass("sapMResponsivePopover");this._oDelegate={onBeforeRendering:function(){var S=this.getShowCloseButton(),h=this._oControl._getAnyHeader(),n,p,r;if(!S||!a.system.phone){this._removeCloseButton(h);return;}if(!this._bContentChanged){return;}this._bContentChanged=false;if(h){this._insertCloseButton(h);}else{n=this._getSingleNavContent();if(!n){return;}p=n.getCurrentPage();r=this._getRealPage(p);if(r&&(h=r._getAnyHeader())){this._insertCloseButton(h);}n.attachEvent("navigate",this._fnOnNavigate,this);}}};this._oPageDelegate={onAfterShow:function(){var r=t._getRealPage(this),h;if(r&&(h=r._getAnyHeader())){t._insertCloseButton(h);}}};this._fnOnNavigate=function(E){var p=E.getParameter("to");if(p){p.addEventDelegate(this._oPageDelegate,p);}};this._oControl.addEventDelegate(this._oDelegate,this);this._oControl._removeChild=function(o,A,S){var p,i;if((A==="content")&&(o instanceof sap.m.NavContainer)){p=o.getPages();for(i=0;i<p.length;i++){p[i].removeEventDelegate(t._oPageDelegate);}o.detachEvent("navigate",t._fnOnNavigate,t);}C.prototype._removeChild.apply(this,arguments);};};
g.prototype.openBy=function(p){if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}if(a.system.phone){return this._oControl.open();}else{return this._oControl.openBy(p);}};
g.prototype.exit=function(){if(this._oCloseButton){this._oCloseButton.destroy();this._oCloseButton=null;}if(this._oControl){this._oControl.removeEventDelegate(this._oDelegate);this._oControl.destroy();this._oControl=null;}};
g.prototype._getCloseButton=function(){if(!this._oCloseButton){var t=this;this._oCloseButton=new B(this.getId()+"-closeButton",{icon:I.getIconURI("decline"),press:function(){t._oControl._oCloseTrigger=this;t.close();}});}return this._oCloseButton;};
g.prototype.addContent=function(o){this._bContentChanged=true;this.addAggregation("content",o);return this;};
g.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments),h=this.getAggregation('_popup').getContent();for(var i=0;i<h.length;i++){o.addContent(h[i].clone());}return o;};
g.prototype._getSingleNavContent=function(){var h=this.getContent();while(h.length===1&&h[0]instanceof sap.ui.core.mvc.View){h=h[0].getContent();}if(h.length===1&&h[0]instanceof sap.m.NavContainer){return h[0];}else{return null;}};
g.prototype._getRealPage=function(p){var r=p,h;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.ui.core.mvc.View){h=r.getContent();if(h.length===1){r=h[0];continue;}}r=null;}return r;};
g.prototype._insertCloseButton=function(h){var o=this._getCloseButton(),i;if(h&&h.addContentRight){i=h.getAggregation("contentRight",[]).length;h.insertAggregation("contentRight",o,i);}};
g.prototype._removeCloseButton=function(h){var o=this._getCloseButton();if(h){h.removeAggregation("contentRight",o);}};
g.prototype._firstLetterUpperCase=function(v){return v.charAt(0).toUpperCase()+v.slice(1);};
g.prototype._lastIndexOfUpperCaseLetter=function(v){var i,s;for(i=v.length-1;i>=0;i--){s=v.charAt(i);if(s===s.toUpperCase()){return i;}}return-1;};
g.prototype._oldSetProperty=g.prototype.setProperty;
g.prototype.setProperty=function(p,v,s){this._oldSetProperty(p,v,true);var S="set"+this._firstLetterUpperCase(p);if(this._aNotSupportedProperties.indexOf(p)===-1&&S in this._oControl){this._oControl[S](v);}return this;};
g.prototype._oldSetModel=g.prototype.setModel;
g.prototype.setModel=function(m,n){this._oControl.setModel(m,n);return this._oldSetModel(m,n);};
g.prototype._createButtonFooter=function(){if(this._oFooter){return this._oFooter;}this._oFooter=new b(this.getId()+"-footer",{content:[new c()]});return this._oFooter;};
g.prototype._getButtonFooter=function(){return a.system.phone?this._oControl._getToolbar():this._oControl.getFooter();};
g.prototype._getPopup=function(){return this._oControl.oPopup;};
g.prototype._setButton=function(p,o){if(this._oControl instanceof P){var G="get"+this._firstLetterUpperCase(p)+"Button",O=this[G](),F=this._createButtonFooter(),s="_o"+this._firstLetterUpperCase(p)+"Button",i=(p.toLowerCase()==="begin"?0:1),h=(p.toLowerCase()==="begin"?"getEndButton":"getBeginButton");if(O){F.removeContent(O);}if(o){if(!F.getParent()){this._oControl.setFooter(F);}F.insertContent(o,i+1);}else{var j=this[h]();if(!j){F.destroy();this._oFooter=null;}}this[s]=o;return this;}else{var A=p.toLowerCase()+"Button";return this.setAggregation(A,o);}};
g.prototype._getButton=function(p){if(this._oControl instanceof P){var s="_o"+this._firstLetterUpperCase(p)+"Button";return this[s];}else{var G="get"+this._firstLetterUpperCase(p)+"Button";return this._oControl[G]();}};
g.prototype.setBeginButton=function(o){this._oControl.setBeginButton(o);return this._setButton("begin",o);};
g.prototype.setEndButton=function(o){this._oControl.setEndButton(o);return this._setButton("end",o);};
g.prototype.setShowCloseButton=function(s){var h=this._oControl._getAnyHeader();if(s){this._insertCloseButton(h);}else{this._removeCloseButton(h);}this.setProperty("showCloseButton",s,true);return this;};
g.prototype.getBeginButton=function(){return this._getButton("begin");};
g.prototype.getEndButton=function(){return this._getButton("end");};
["bindAggregation","validateAggregation","setAggregation","getAggregation","indexOfAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation","setAssociation","getAssociation","addAssociation","removeAssociation","removeAllAssociation"].forEach(function(n){g.prototype[n]=function(){var L=this._lastIndexOfUpperCaseLetter(n),m,r;if(q.type(arguments[0])==="string"){if(L!==-1){m=n.substring(0,L)+this._firstLetterUpperCase(arguments[0]);if(this._oControl&&this._oControl[m]){r=this._oControl[m].apply(this._oControl,Array.prototype.slice.call(arguments,1));return r===this._oControl?this:r;}else{return C.prototype[n].apply(this,arguments);}}}r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;};});["invalidate","close","isOpen","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getDomRef","setBusy","getBusy","setBusyIndicatorDelay","getBusyIndicatorDelay","addEventDelegate","_setAriaModal"].forEach(function(n){g.prototype[n]=function(){if(this._oControl&&this._oControl[n]){if(n==="invalidate"&&arguments[0]===this._oControl){return C.prototype.invalidate.apply(this,arguments);}var r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;}};});
g.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
return g;});
sap.ui.predefine('sap/m/ResponsivePopoverRenderer',[],function(){"use strict";var R={};
R.render=function(r,c){};
return R;},true);
sap.ui.predefine('sap/m/ResponsiveScale',['./library','./SliderUtilities','sap/ui/core/Element'],function(l,S,E){"use strict";
var a=E.extend("sap.m.ResponsiveScale",{metadata:{interfaces:["sap.m.IScale"],library:"sap.m",properties:{tickmarksBetweenLabels:{type:"int",group:"Appearance",defaultValue:0}}}});
a.prototype.calcNumberOfTickmarks=function(s,f,t){var m=Math.floor(s/f)+1;m=t&&(m>t)?this._runStepsOptimization(t,m-1):m;return Math.floor(m);};
a.prototype._runStepsOptimization=function(t,m){var s=m/t;while((t>1)&&(s%1!==0)){t--;s=m/t;}return t;};
a.prototype.getHiddenTickmarksLabels=function(s,t,o,L){var j,c,h=new Array(t),i=Math.ceil(1/(o/L)),C=function(p){return p<<1;};if(i===1){return h;}i--;i|=i>>1;i|=i>>2;i|=i>>4;i|=i>>8;i|=i>>16;i++;i=i>>1;j=C(i);while(i){c=i;while(c<((t/2)+j)){h[c]=true;h[t-c-1]=true;c+=j;}i=i>>1;j=C(i);}return h;};
a.prototype.handleResize=function(e){var L,o,O,h,s,$=e.control.$(),t=$.find(".sapMSliderTick"),i=$.find(".sapMSliderTickmarks").width(),b=(i/t.size())>=S.CONSTANTS.TICKMARKS.MIN_SIZE.SMALL;t.css("visibility",b?'':'hidden');L=$.find(".sapMSliderTickLabel");o=parseFloat(L[1].style.left);O=i*o/100;h=this.getHiddenTickmarksLabels(i,L.size(),O,S.CONSTANTS.TICKMARKS.MIN_SIZE.WITH_LABEL);L.each(function(I,c){s=c.nextSibling||c.previousSibling||{style:{visibility:null}};if(h[I]&&!b){c.style.display="none";s.style.visibility='hidden';}else{c.style.display="";s.style.visibility='';}});};
return a;});
sap.ui.predefine('sap/m/ScrollBar',['sap/ui/core/Control',"./ScrollBarRenderer"],function(C,S){"use strict";
var a=C.extend("sap.m.ScrollBar",{metadata:{library:"sap.m",properties:{scrollPosition:{type:"int",group:"Behavior",defaultValue:0},contentSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{scroll:{}}}});
a.prototype.init=function(){this._onScrollHandler=this._onscroll.bind(this);};
a.prototype.onBeforeRendering=function(){if(this._$ScrollRef&&this._$ScrollRef.length){this._$ScrollRef.off("scroll",this._onScrollHandler);this._$ScrollRef=null;}};
a.prototype.onAfterRendering=function(){this._$ScrollRef=this.$("sb");this._$ScrollRef.on("scroll",this._onScrollHandler);this._setScrollPosition(this.getScrollPosition());};
a.prototype.onThemeChanged=function(){this.invalidate();};
a.prototype.setScrollPosition=function(s){var p=Math.round(Math.max(s,0));this._setScrollPosition(p);return this.setProperty("scrollPosition",p,true);};
a.prototype._onscroll=function(e){var s=Math.abs(Math.round(this._$ScrollRef.scrollTop()));this.setProperty("scrollPosition",s,true);this.fireScroll({pos:s});e.preventDefault();e.stopPropagation();return false;};
a.prototype._setScrollPosition=function(s){if(this._$ScrollRef&&this._$ScrollRef.length){this._$ScrollRef.scrollTop(s);}};
return a;});
sap.ui.predefine('sap/m/ScrollBarRenderer',['sap/ui/Device',"sap/ui/dom/getScrollbarSize"],function(D,g){"use strict";var S={apiVersion:2};
S.render=function(r,c){var s="sapMScrollBarTouch",C=c.getContentSize(),a=c.getId(),d=D.support.touch;r.openStart("div",c);r.class("sapMScrollBarOuterDiv");if(d){r.class(s);}r.openEnd();r.openStart("div",a+"-sb");r.class("sapMScrollBarInnerDiv");r.openEnd();r.openStart("div",a+"-sbcnt");r.style("width","0.75rem");r.style("height",C);r.openEnd();r.close("div");r.close("div");r.openStart("div");r.openEnd();r.openStart("span",a+"-ffsize");r.class("sapMScrollBarDistantSpan");r.openEnd();r.close("span");r.close("div");r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/ScrollContainer',["./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/ui/core/Element","./ScrollContainerRenderer","sap/ui/dom/denormalizeScrollBeginRTL"],function(l,C,S,E,a,d){"use strict";
var b=C.extend("sap.m.ScrollContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},horizontal:{type:"boolean",group:"Behavior",defaultValue:true},vertical:{type:"boolean",group:"Behavior",defaultValue:false},focusable:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/ScrollContainer.designtime"}});
b.prototype.init=function(){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:true,vertical:false});};
b.prototype.onBeforeRendering=function(){this._oScroller.setHorizontal(this.getHorizontal());this._oScroller.setVertical(this.getVertical());};
b.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}};
b.prototype.getScrollDelegate=function(){return this._oScroller;};
b.prototype.scrollTo=function(x,y,t){if(this._oScroller){var D=this.getDomRef();if(D){if(sap.ui.getCore().getConfiguration().getRTL()){x=d(x,D);}this._oScroller.scrollTo(x,y,t);}else{this._oScroller._scrollX=x;this._oScroller._scrollY=y;}}return this;};
b.prototype.scrollToElement=function(e,t){if(e instanceof E){e=e.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(e,t);}return this;};
b.prototype.setHorizontal=function(h){this._oScroller.setHorizontal(h);return this.setProperty("horizontal",h,true);};
b.prototype.setVertical=function(v){this._oScroller.setVertical(v);return this.setProperty("vertical",v,true);};
return b;});
sap.ui.predefine('sap/m/ScrollContainerRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){r.write("<div");r.writeControlData(c);var w=c.getWidth(),h=c.getHeight();if(w){r.addStyle("width",w);}if(h){r.addStyle("height",h);}r.writeStyles();if(c.getVertical()){if(!c.getHorizontal()){r.addClass("sapMScrollContV");}else{r.addClass("sapMScrollContVH");}}else if(c.getHorizontal()){r.addClass("sapMScrollContH");}r.addClass("sapMScrollCont");r.writeClasses();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(c.getFocusable()){r.writeAttributeEscaped("tabindex","0");}r.write("><div id='"+c.getId()+"-scroll' class='sapMScrollContScroll'>");var C=c.getContent(),l=C.length;for(var i=0;i<l;i++){r.renderControl(C[i]);}r.write("</div></div>");};
return S;},true);
sap.ui.predefine('sap/m/SearchField',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./Suggest','sap/ui/Device','./SearchFieldRenderer',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos"],function(l,C,E,I,S,D,a,K,q){"use strict";var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a.oSearchFieldToolTips={SEARCH_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_SEARCH_BUTTON_TOOLTIP"),RESET_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_RESET_BUTTON_TOOLTIP"),REFRESH_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_REFRESH_BUTTON_TOOLTIP")};
var b=C.extend("sap.m.SearchField",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.f.IShellBar"],library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},maxLength:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Misc",defaultValue:null},showMagnifier:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},showRefreshButton:{type:"boolean",group:"Behavior",defaultValue:false},refreshButtonTooltip:{type:"string",group:"Misc",defaultValue:null},showSearchButton:{type:"boolean",group:"Behavior",defaultValue:true},enableSuggestions:{type:"boolean",group:"Behavior",defaultValue:false},selectOnFocus:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},defaultAggregation:"suggestionItems",designtime:"sap/m/designtime/SearchField.designtime",aggregations:{suggestionItems:{type:"sap.m.SuggestionItem",multiple:true,singularName:"suggestionItem"}},events:{search:{parameters:{query:{type:"string"},suggestionItem:{type:"sap.m.SuggestionItem"},refreshButtonPressed:{type:"boolean"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{newValue:{type:"string"}}},suggest:{parameters:{suggestValue:{type:"string"}}}}}});
E.call(b.prototype);I.insertFontFaceStyle();
b.prototype.init=function(){this.setProperty("placeholder",r.getText("FACETFILTER_SEARCH"),true);};
b.prototype.getFocusDomRef=function(){return this.getInputElement();};
b.prototype.getFocusInfo=function(){var f=C.prototype.getFocusInfo.call(this),i=this.getDomRef("I");if(i){q.extend(f,{cursorPos:q(i).cursorPos()});}return f;};
b.prototype.applyFocusInfo=function(f){C.prototype.applyFocusInfo.call(this,f);if("cursorPos"in f){this.$("I").cursorPos(f.cursorPos);}return this;};
b.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
b.prototype._hasPlaceholder=(function(){return"placeholder"in document.createElement("input");}());
b.prototype.getInputElement=function(){return this.getDomRef("I");};
b.prototype.onBeforeRendering=function(){this._unregisterEventListeners();};
b.prototype.onAfterRendering=function(){var i=this.getInputElement();this._resetElement=this.getDomRef("reset");q(i).on("input",this.onInput.bind(this)).on("search",this.onSearch.bind(this)).on("focus",this.onFocus.bind(this)).on("blur",this.onBlur.bind(this));q(this.getDomRef("F")).on("click",this.onFormClick.bind(this));if(D.system.desktop||D.system.combi){this.$().on("touchstart mousedown",this.onButtonPress.bind(this));if(D.browser.firefox){this.$().find(".sapMSFB").on("mouseup mouseout",function(g){q(g.target).removeClass("sapMSFBA");});}}else if(window.PointerEvent){q(this._resetElement).on("touchstart",function(){this._active=document.activeElement;}.bind(this));}var f=sap.ui.getCore();if(!f.isThemeApplied()){f.attachThemeChanged(this._handleThemeLoad,this);}};
b.prototype._handleThemeLoad=function(){if(this._oSuggest){this._oSuggest.setPopoverMinWidth();}var f=sap.ui.getCore();f.detachThemeChanged(this._handleThemeLoad,this);};
b.prototype.clear=function(O){var v=O&&O.value||"";if(!this.getInputElement()||this.getValue()===v){return;}this.setValue(v);u(this);this.fireLiveChange({newValue:v});this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:!!(O&&O.clearButton)});};
b.prototype.exit=function(){this._unregisterEventListeners();if(this._oSuggest){this._oSuggest.destroy(true);this._oSuggest=null;}};
b.prototype.onButtonPress=function(f){if(f.originalEvent.button===2){return;}var i=this.getInputElement();if(document.activeElement===i&&f.target!==i){f.preventDefault();}if(D.browser.firefox){var g=q(f.target);if(g.hasClass("sapMSFB")){g.addClass("sapMSFBA");}}};
b.prototype.ontouchstart=function(f){this._oTouchStartTarget=f.target;};
b.prototype.ontouchend=function(f){if(f.originalEvent.button===2){return;}var g=f.target,v=true,i=this.getInputElement();if(this._oTouchStartTarget){v=this._oTouchStartTarget===g;this._oTouchStartTarget=null;}if(g.id==this.getId()+"-reset"&&v){c(this);this._bSuggestionSuppressed=true;var h=!this.getValue();this.clear({clearButton:true});var j=document.activeElement;if(((D.system.desktop||h||/(INPUT|TEXTAREA)/i.test(j.tagName)||j===this._resetElement&&this._active===i))&&(j!==i)){i.focus();}}else if(g.id==this.getId()+"-search"&&v){c(this);if(D.system.desktop&&!this.getShowRefreshButton()&&(document.activeElement!==i)){i.focus();}this.fireSearch({query:this.getValue(),refreshButtonPressed:!!(this.getShowRefreshButton()&&!this.$().hasClass("sapMFocus")),clearButtonPressed:false});}else{this.onmouseup(f);}};
b.prototype.onmouseup=function(f){if(D.system.phone&&this.getEnabled()&&f.target.tagName=="INPUT"&&document.activeElement===f.target&&!d(this)){this.onFocus(f);}};
b.prototype.onFormClick=function(f){if(this.getEnabled()&&f.target.tagName=="FORM"){this.getInputElement().focus();}};
b.prototype.onSearch=function(f){var v=this.getInputElement().value;this.setValue(v);this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:false});if(!D.system.desktop){this._blur();}};
b.prototype._blur=function(){var t=this;window.setTimeout(function(){var i=t.getInputElement();if(i){i.blur();}},13);};
b.prototype.onChange=function(f){this.setValue(this.getInputElement().value);};
b.prototype.onInput=function(f){var v=this.getInputElement().value;if(v!=this.getValue()){this.setValue(v);this.fireLiveChange({newValue:v});if(this.getEnableSuggestions()){if(this._iSuggestDelay){clearTimeout(this._iSuggestDelay);}this._iSuggestDelay=setTimeout(function(){this.fireSuggest({suggestValue:v});u(this);this._iSuggestDelay=null;}.bind(this),400);}}};
b.prototype.onkeydown=function(f){var v;if(f.which===K.F5||f.which===K.ENTER){this.$("search").toggleClass("sapMSFBA",true);f.stopPropagation();f.preventDefault();}if(f.which===K.ESCAPE){if(d(this)){c(this);f.setMarked();}else{v=this.getValue();if(v===this._sOriginalValue){this._sOriginalValue="";}this.clear({value:this._sOriginalValue});if(v!==this.getValue()){f.setMarked();}}f.preventDefault();}};
b.prototype.onkeyup=function(f){var g;var h;if(f.which===K.F5||f.which===K.ENTER){this.$("search").toggleClass("sapMSFBA",false);if(d(this)){c(this);if((g=this._oSuggest.getSelected())>=0){h=this.getSuggestionItems()[g];this.setValue(h.getSuggestionText());}}this.fireSearch({query:this.getValue(),suggestionItem:h,refreshButtonPressed:this.getShowRefreshButton()&&f.which===K.F5,clearButtonPressed:false});}};
b.prototype.onFocus=function(f){if(D.browser.internet_explorer&&!document.hasFocus()){return;}this.$().toggleClass("sapMFocus",true);this._sOriginalValue=this.getValue();if(this.getEnableSuggestions()){if(!this._bSuggestionSuppressed){this.fireSuggest({suggestValue:this.getValue()});}else{this._bSuggestionSuppressed=false;}}this._setToolTips(f.type);};
b.prototype.onBlur=function(f){this.$().toggleClass("sapMFocus",false);if(this._bSuggestionSuppressed){this._bSuggestionSuppressed=false;}this._setToolTips(f.type);};
b.prototype._setToolTips=function(t){var $=this.$("search"),f=this.$("reset");if(this.getShowRefreshButton()){if(t==="focus"){$.attr("title",a.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP);}else if(t==="blur"){var R=this.getRefreshButtonTooltip(),T=R===""?a.oSearchFieldToolTips.REFRESH_BUTTON_TOOLTIP:R;if(T){$.attr("title",T);}}}if(this.getValue()===""){f.attr("title",a.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP);}else{f.attr("title",a.oSearchFieldToolTips.RESET_BUTTON_TOOLTIP);}};
b.prototype.setValue=function(v){v=v||"";var i=this.getInputElement();if(i){if(i.value!==v){i.value=v;}var $=this.$();if($.hasClass("sapMSFVal")==!v){$.toggleClass("sapMSFVal",!!v);}}this.setProperty("value",v,true);this._setToolTips();return this;};
b.prototype._unregisterEventListeners=function(){var i=this.getInputElement();if(i){this.$().find(".sapMSFB").off();this.$().off();q(this.getDomRef("F")).off();q(i).off();}};
b.prototype.onsapshow=function(f){if(this.getEnableSuggestions()){if(d(this)){c(this);}else{this.fireSuggest({suggestValue:this.getValue()});}}};
b.prototype.onsaphide=function(f){this.suggest(false);};
function s(f,g,i,R){var h;if(d(f)){h=f._oSuggest.setSelected(i,R);if(h>=0){f.setValue(f.getSuggestionItems()[h].getSuggestionText());}g.preventDefault();}}
b.prototype.onsapdown=function(f){s(this,f,1,true);};
b.prototype.onsapup=function(f){s(this,f,-1,true);};
b.prototype.onsaphome=function(f){s(this,f,0,false);};
b.prototype.onsapend=function(f){var L=this.getSuggestionItems().length-1;s(this,f,L,false);};
b.prototype.onsappagedown=function(f){s(this,f,10,true);};
b.prototype.onsappageup=function(f){s(this,f,-10,true);};
b.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("F");};
function c(f){f._oSuggest&&f._oSuggest.close();}
function o(f){if(f.getEnableSuggestions()){if(!f._oSuggest){f._oSuggest=new S(f);}f._oSuggest.open();}}
function d(f){return f._oSuggest&&f._oSuggest.isOpen();}
b.prototype.suggest=function(f){if(this.getEnableSuggestions()){f=f===undefined||!!f;if(f&&(this.getSuggestionItems().length||D.system.phone)){o(this);}else{c(this);}}return this;};
function u(f){f._oSuggest&&f._oSuggest.update();}
var e="suggestionItems";
b.prototype.insertSuggestionItem=function(O,i,f){u(this);return C.prototype.insertAggregation.call(this,e,O,i,true);};
b.prototype.addSuggestionItem=function(O,f){u(this);return C.prototype.addAggregation.call(this,e,O,true);};
b.prototype.removeSuggestionItem=function(O,f){u(this);return C.prototype.removeAggregation.call(this,e,O,true);};
b.prototype.removeAllSuggestionItems=function(f){u(this);return C.prototype.removeAllAggregation.call(this,e,true);};
return b;});
sap.ui.predefine('sap/m/SearchFieldRenderer',["sap/ui/Device","sap/ui/core/InvisibleText"],function(D,I){"use strict";var S={};
S.render=function(r,s){if(!s.getVisible()){return;}var p=s.getPlaceholder(),v=s.getValue(),w=s.getProperty("width"),i=s.getId(),b=s.getShowRefreshButton(),a=s.getShowSearchButton(),A={},t,R=s.getRefreshButtonTooltip(),c;r.write("<div");r.writeControlData(s);if(w){r.writeAttribute("style","width:"+w+";");}r.addClass("sapMSF");if(v){r.addClass("sapMSFVal");}if(!s.getEnabled()){r.addClass("sapMSFDisabled");}r.writeClasses();r.write(">");r.write('<form');r.writeAttribute("id",i+"-F");r.addClass('sapMSFF');if(!a){r.addClass("sapMSFNS");}else if(b){r.addClass('sapMSFReload');}r.writeClasses();r.write('>');if(!s._hasPlaceholder&&p){r.write("<label ");r.writeAttribute("id",i+"-P");r.writeAttribute("for",i+"-I");r.addClass("sapMSFPlaceholder");r.writeClasses();r.write(">");r.writeEscaped(p);r.write("</label>");}r.write('<input');r.writeAttribute("type","search");r.writeAttribute("autocomplete","off");if(D.browser.safari){r.writeAttribute("autocorrect","off");}r.writeAttribute("id",s.getId()+"-I");var T=s.getTooltip_AsString();if(T){r.writeAttributeEscaped("title",T);}r.addClass("sapMSFI");if(D.os.android&&D.os.version>=4&&D.os.version<4.1){r.addClass("sapMSFIA4");}r.writeClasses();if(s.getEnableSuggestions()&&D.system.phone){r.writeAttribute("readonly","readonly");}if(!s.getEnabled()){r.writeAttribute("disabled","disabled");}if(p){r.writeAttributeEscaped("placeholder",p);}if(s.getMaxLength()){r.writeAttribute("maxLength",s.getMaxLength());}if(v){r.writeAttributeEscaped("value",v);}if(s.getEnabled()&&b){var d=I.getStaticId("sap.m","SEARCHFIELD_ARIA_F5");if(d){A.describedby={value:d,append:true};}}A.disabled=null;r.writeAccessibilityState(s,A);r.write(">");if(s.getEnabled()){r.write("<div");r.writeAttribute("id",s.getId()+"-reset");c=v===""?this.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP:this.oSearchFieldToolTips.RESET_BUTTON_TOOLTIP;r.writeAttributeEscaped("title",c);r.addClass("sapMSFR");r.addClass("sapMSFB");if(D.browser.firefox){r.addClass("sapMSFBF");}if(!a){r.addClass("sapMSFNS");}r.writeClasses();r.write("></div>");if(a){r.write("<div");r.writeAttribute("id",s.getId()+"-search");r.addClass("sapMSFS");r.addClass("sapMSFB");if(D.browser.firefox){r.addClass("sapMSFBF");}r.writeClasses();if(b){t=R===""?this.oSearchFieldToolTips.REFRESH_BUTTON_TOOLTIP:R;}else{t=this.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP;}r.writeAttributeEscaped("title",t);r.write("></div>");}}r.write("</form>");r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/SegmentedButton',['./library','./Button','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/ResizeHandler','sap/ui/core/ListItem','sap/ui/core/IconPool','./SegmentedButtonRenderer'],function(l,B,C,E,I,R,L,a,S){"use strict";
var c=C.extend("sap.m.SegmentedButton",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent"],library:"sap.m",designtime:"sap/m/designtime/SegmentedButton.designtime",publicMethods:["createButton"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:"",bindable:"bindable"}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},items:{type:"sap.m.SegmentedButtonItem",multiple:true,singularName:"item",bindable:"bindable"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},associations:{selectedButton:{deprecated:true,type:"sap.m.Button",multiple:false},selectedItem:{type:"sap.m.SegmentedButtonItem",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{button:{type:"sap.m.Button"},id:{type:"string"},key:{type:"string"}}},selectionChange:{parameters:{item:{type:"sap.m.SegmentedButtonItem"}}}},dnd:{draggable:true,droppable:false}}});
E.call(c.prototype);
c.prototype.init=function(){this._aWidths=[];this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this.addDelegate(this._oItemNavigation);this.removeButton=function(b){var r=c.prototype.removeButton.call(this,b);this.setSelectedButton(this.getButtons()[0]);this._fireChangeEvent();return r;};};
c.prototype.onBeforeRendering=function(){var b=this._getVisibleButtons();this._bCustomButtonWidth=b.some(function(o){return o.getWidth();});if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.setSelectedKey(this.getProperty("selectedKey"));if(!this.getSelectedButton()){this._selectDefaultButton();}};
c.prototype.onAfterRendering=function(){var b=this._getVisibleButtons(),p;if(!this._sResizeListenerId){p=this.getDomRef().parentNode;if(p){this._sResizeListenerId=R.register(p,this._handleContainerResize.bind(this));}}this._setItemNavigation();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
c.prototype._handleContainerResize=function(){var b=this._getVisibleButtons();this._clearAutoWidthAppliedToControl();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
c.prototype._clearAutoWidthAppliedToControl=function(){var b=this._getVisibleButtons(),d=b.length,o,i=0;if(!this.getWidth()){this.$().css("width","");}while(i<d){o=b[i];if(!o.getWidth()){o.$().css("width","");}i++;}};
c.prototype._getRenderedButtonWidths=function(b){return b.map(function(o){var d=o.getDomRef();return d&&d.getBoundingClientRect?d.getBoundingClientRect().width:o.$().outerWidth();});};
c.prototype._getButtonWidth=function(b){var d=b.length,w,n=0,s=0,e=0,p,P,i=0;if(this._bCustomButtonWidth){while(i<d){w=b[i].getWidth();if(w){if(w.indexOf("%")!==-1){s+=parseInt(w.slice(0,-1));}else{e+=parseInt(w.slice(0,-2));}}else{n++;}i++;}if(n===0){return false;}p=(100-s)/n;P=(e/n);if(p<0){p=0;}if(P<0){P=0;}if(P>0){return"calc("+p+"% - "+P+"px)";}else{return p+"%";}}else{return(100/d)+"%";}};
c.prototype._updateWidth=function(){if(this.$().length===0||this.hasStyleClass("sapMSegmentedButtonNoAutoWidth")){return;}var s=this.getWidth(),b=this._getVisibleButtons(),d=b.length,m=(this._aWidths.length>0)?Math.max.apply(Math,this._aWidths):0,e=(100/d),p=this.$().parent().innerWidth(),w=this._getButtonWidth(b),f,o,i;if(!s){if((m*d)>p){this.$().css("width","100%");}else if(m>0){this.$().width((m*d)+1);}i=0;while(i<d){o=b[i];o.$().css("width",o.getWidth()?o.getWidth():w);i++;}}else if(s&&!this._bCustomButtonWidth){i=0;while(i<d){b[i].$().css("width",e+"%");i++;}}f=this.$().width();if(this._previousWidth!==undefined&&f!==this._previousWidth&&!this._bInOverflow){this.fireEvent("_containerWidthChanged");}this._previousWidth=f;};
c.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}this._bCustomButtonWidth=null;this._aWidths=null;};
c.prototype._setItemNavigation=function(){var b,d=this.getDomRef();if(d){this._oItemNavigation.setRootDomRef(d);b=this.$().find(".sapMSegBBtn:not(.sapMSegBBtnDis)");this._oItemNavigation.setItemDomRefs(b);this._focusSelectedButton();}};
c.prototype.getOverflowToolbarConfig=function(){return{canOverflow:true,listenForEvents:["select"],autoCloseEvents:["select"],noInvalidationProps:["enabled","selectedKey"],invalidationEvents:["_containerWidthChanged"],onBeforeEnterOverflow:this._onBeforeEnterOverflow,onAfterExitOverflow:this._onAfterExitOverflow};};
c.prototype._onBeforeEnterOverflow=function(o){o._toSelectMode();};
c.prototype._onAfterExitOverflow=function(o){o._toNormalMode();};
c.prototype.getFormDoNotAdjustWidth=function(){return true;};
c.prototype.createButton=function(t,u,e,T){var b=new B();if(t!==null){b.setText(t);}if(u!==null){b.setIcon(u);}if(e||e===undefined){b.setEnabled(true);}else{b.setEnabled(false);}if(T){b.setTextDirection(T);}this.addButton(b);return b;};
(function(){
c.prototype.addButton=function(b){if(b){p(b,this);this.addAggregation('buttons',b);this._syncSelect();this._fireChangeEvent();}return this;};
c.prototype.insertButton=function(b,i){if(b){p(b,this);this.insertAggregation('buttons',b,i);this._syncSelect();this._fireChangeEvent();}return this;};
function p(b,P){b.attachPress(function(e){P._buttonPressed(e);});b.attachEvent("_change",P._syncSelect,P);b.attachEvent("_change",P._fireChangeEvent,P);var o=B.prototype.setEnabled;b.setEnabled=function(e){b.$().toggleClass("sapMSegBBtnDis",!e).toggleClass("sapMFocusable",e);o.apply(b,arguments);};b.setVisible=function(v){B.prototype.setVisible.apply(this,arguments);P.invalidate();};}
})();
c.prototype.getSelectedKey=function(){var b=this.getButtons(),d=this.getItems(),s=this.getSelectedButton(),i=0;if(d.length>0){for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this.setProperty("selectedKey",d[i].getKey(),true);return d[i].getKey();}}}return"";};
c.prototype.setSelectedKey=function(k){var b=this.getButtons(),d=this.getItems(),i=0;if(!k){this.setProperty("selectedKey",k,true);return this;}if(d.length>0&&b.length>0){for(;i<d.length;i++){if(d[i]&&d[i].getKey()===k){this.setSelectedItem(d[i]);break;}}}this.setProperty("selectedKey",k,true);return this;};
c.prototype.removeButton=function(b){var r=this.removeAggregation("buttons",b);if(r){delete r.setEnabled;r.detachEvent("_change",this._syncSelect,this);r.detachEvent("_change",this._fireChangeEvent,this);this._syncSelect();}return r;};
c.prototype.removeAllButtons=function(){var b=this.getButtons();if(b){for(var i=0;i<b.length;i++){var o=b[i];if(o){delete o.setEnabled;this.removeAggregation("buttons",o);o.detachEvent("_change",this._syncSelect,this);o.detachEvent("_change",this._fireChangeEvent,this);}}this._syncSelect();}return b;};
c.prototype.addItem=function(i){this.addAggregation("items",i);this.addButton(i.oButton);return this;};
c.prototype.removeItem=function(i){var r;if(i!==null&&i!==undefined){r=this.removeAggregation("items",i);this.removeButton(i.oButton);}if(i&&i instanceof sap.m.SegmentedButtonItem&&this.getSelectedButton()===i.oButton.getId()){this.setSelectedKey("");this.setSelectedButton("");this.setSelectedItem("");}this.setSelectedItem(this.getItems()[0]);return r;};
c.prototype.insertItem=function(i,b){this.insertAggregation("items",i,b);this.insertButton(i.oButton,b);return this;};
c.prototype.removeAllItems=function(s){var r=this.removeAllAggregation("items",s);this.removeAllButtons();this.setSelectedKey("");this.setSelectedButton("");this.setSelectedItem("");return r;};
c.prototype._buttonPressed=function(e){var b=e.getSource(),i;if(this.getSelectedButton()!==b.getId()){this.getButtons().forEach(function(o){o.$().removeClass("sapMSegBBtnSel");o.$().attr("aria-checked",false);});i=this.getItems().filter(function(o){return o.oButton===b;})[0];b.$().addClass("sapMSegBBtnSel");b.$().attr("aria-checked",true);this.setAssociation('selectedButton',b,true);this.setProperty("selectedKey",this.getSelectedKey(),true);this.setAssociation('selectedItem',i,true);this.fireSelectionChange({item:i});this.fireSelect({button:b,id:b.getId(),key:this.getSelectedKey()});}};
c.prototype._selectDefaultButton=function(){var b=this._getVisibleButtons();if(b.length>0){this.setAssociation('selectedButton',b[0],true);if(this.getItems().length>0){this.setAssociation('selectedItem',this.getItems()[0],true);}}};
c.prototype.setSelectedButton=function(b){var s=this.getSelectedButton(),d=this.getButtons();this.setAssociation("selectedButton",b);if(s!==this.getSelectedButton()){if(!this.getSelectedButton()&&d.length>1){this._selectDefaultButton();}this._focusSelectedButton();}this._syncSelect();return this;};
c.prototype.setSelectedItem=function(i){var o=typeof i==="string"&&i!==""?sap.ui.getCore().byId(i):i,b=o instanceof sap.m.SegmentedButtonItem,v=b?o.oButton:i;this.setAssociation("selectedItem",i,true);this.setSelectedButton(v);return this;};
c.prototype._focusSelectedButton=function(){var b=this.getButtons(),s=this.getSelectedButton(),i=0;for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this._oItemNavigation&&this._oItemNavigation.setFocusedIndex(i);break;}}};
c.prototype.onsappagedown=function(e){this._oItemNavigation.onsapend(e);};
c.prototype.onsappageup=function(e){this._oItemNavigation.onsaphome(e);};
c.prototype.onsapspace=function(e){e.preventDefault();};
c.prototype._lazyLoadSelectForm=function(){var s=this.getAggregation("_select");if(!s){jQuery.sap.require("sap.m.Select");var b=sap.ui.require("sap/m/Select");s=new b(this.getId()+"-select");s.attachChange(this._selectChangeHandler,this);s.addStyleClass("sapMSegBSelectWrapper");this.setAggregation("_select",s,true);}};
c.prototype._selectChangeHandler=function(e){var s=e.getParameter("selectedItem"),n=parseInt(s.getKey()),b=this.getButtons()[n],d=b.getId();b.firePress();this.setSelectedButton(d);};
c.prototype._fireChangeEvent=function(){this.fireEvent("_change");};
c.prototype._syncSelect=function(){var k=0,s=0,b,d,o=this.getAggregation("_select");if(!o){return;}o.destroyItems();this._getVisibleButtons().forEach(function(e){b=e.getText();d=e.getIcon();o.addItem(new L({key:k.toString(),icon:d?d:"",text:b?b:e.getTooltip_AsString(),enabled:e.getEnabled()}));if(e.getId()===this.getSelectedButton()){s=k;}k++;},this);o.setSelectedKey(s.toString());};
c.prototype._toSelectMode=function(){this._bInOverflow=true;this.addStyleClass("sapMSegBSelectWrapper");this._lazyLoadSelectForm();this._syncSelect();};
c.prototype._toNormalMode=function(){delete this._bInOverflow;this.removeStyleClass("sapMSegBSelectWrapper");};
c.prototype._overwriteImageOnload=function(i){var t=this;if(i.onload===sap.m.Image.prototype.onload){i.onload=function(){if(sap.m.Image.prototype.onload){sap.m.Image.prototype.onload.apply(this,arguments);}window.setTimeout(function(){t._updateWidth();},20);};}};
c.prototype._getIconAriaLabel=function(i){var o=a.getIconInfo(i.getSrc()),r="";if(o&&o.name){r=o.name;}return r;};
c.prototype._getVisibleButtons=function(){return this.getButtons().filter(function(b){return b.getVisible();});};
c.prototype.clone=function(){var s=this.getSelectedButton(),d=this.removeAllAggregation("buttons"),o=C.prototype.clone.apply(this,arguments),e=d.map(function(b){return b.getId();}).indexOf(s),i;if(e>-1){o.setSelectedButton(o.getButtons()[e]);}for(i=0;i<d.length;i++){this.addAggregation("buttons",d[i]);}return o;};
return c;});
sap.ui.predefine('sap/m/SegmentedButtonItem',['./library','sap/ui/core/Item','sap/m/Button','sap/ui/core/CustomStyleClassSupport'],function(l,I,B,C){"use strict";
var S=I.extend("sap.m.SegmentedButtonItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{press:{}}}});
C.apply(S.prototype);
S.prototype.init=function(){var b=new B(this.getId()+"-button");this.aCustomStyleClasses;this.mCustomStyleClassMap;b.aCustomStyleClasses=this.aCustomStyleClasses;b.mCustomStyleClassMap=this.mCustomStyleClassMap;b.getCustomData=this.getCustomData.bind(this);b.getLayoutData=this.getLayoutData.bind(this);b.firePress=function(){this.firePress();B.prototype.firePress.call(b);}.bind(this);this.getDomRef=b.getDomRef.bind(b);this.oButton=b;};
S.prototype.exit=function(){if(this.oButton){this.oButton.destroy();this.oButton=null;}};
S.prototype.setText=function(v){this.setProperty("text",v,true);if(this.oButton){this.oButton.setText(this.getText());}return this;};
S.prototype.setIcon=function(v){this.setProperty("icon",v,true);if(this.oButton){this.oButton.setIcon(this.getIcon());}return this;};
S.prototype.setEnabled=function(v){this.setProperty("enabled",v,true);if(this.oButton){this.oButton.setEnabled(this.getEnabled());}return this;};
S.prototype.setTextDirection=function(v){this.setProperty("textDirection",v,true);if(this.oButton){this.oButton.setTextDirection(this.getTextDirection());}return this;};
S.prototype.setVisible=function(v){this.setProperty("visible",v,true);if(this.oButton){this.oButton.setVisible(v);}return this;};
S.prototype.setWidth=function(v){this.setProperty("width",v,true);if(this.oButton){this.oButton.setWidth(this.getWidth());}return this;};
S.prototype.setTooltip=function(v){this.setAggregation("tooltip",v,true);if(this.oButton){this.oButton.setTooltip(v);}return this;};
return S;});
sap.ui.predefine('sap/m/SegmentedButtonRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer"],function(c,I){"use strict";var T=c.TextDirection;var S={apiVersion:2};
S.render=function(r,C){var b=C.getButtons(),v=b.filter(function(B){return B.getVisible();}),V=0,s=C.getSelectedButton(),B,t,a,d;if(v.length){v[v.length-1].addStyleClass("sapMSegBtnLastVisibleButton");}if(C._bInOverflow){r.openStart("div",C);r.openEnd();r.renderControl(C.getAggregation("_select"));r.close("div");return;}r.openStart("ul",C);if(S._addAllIconsClass(b)){r.class("sapMSegBIcons");}r.class("sapMSegB");r.style('width',C.getWidth());t=C.getTooltip_AsString();if(t){r.attr("title",t);}r.accessibilityState(C,{role:"radiogroup"});r.openEnd();for(var i=0;i<b.length;i++){B=b[i];if(B.getVisible()){var e=B.getText(),o=B.getIcon(),f="",g;++V;if(o){g=B._getImage((B.getId()+"-img"),o);if(g instanceof sap.m.Image){C._overwriteImageOnload(g);}else if(!B.getTooltip()){f=C._getIconAriaLabel(g);}}r.openStart("li",B);r.attr("aria-posinset",V);r.attr("aria-setsize",v.length);r.class("sapMSegBBtn");if(B.aCustomStyleClasses!==undefined&&B.aCustomStyleClasses instanceof Array){for(var j=0;j<B.aCustomStyleClasses.length;j++){r.class(B.aCustomStyleClasses[j]);}}if(B.getEnabled()){r.class("sapMSegBBtnFocusable");}else{r.class("sapMSegBBtnDis");}if(s===B.getId()){r.class("sapMSegBBtnSel");}if(o&&e!==''){r.class("sapMSegBBtnMixed");}a=B.getWidth();r.style('width',a);t=B.getTooltip_AsString();if(t){r.attr("title",t);}r.attr("tabindex",B.getEnabled()?"0":"-1");d=B.getTextDirection();if(d!==T.Inherit){r.attr("dir",d.toLowerCase());}r.accessibilityState(B,{role:"radio",checked:s===B.getId()});if(g&&f!==""){if(e!==""){f+=" "+e;}else{r.attr("title",f);}r.attr("aria-label",f);}r.openEnd();r.openStart("div");r.class("sapMSegBBtnInner");r.openEnd();if(o&&g){r.renderControl(g);}if(e!==''){r.text(e);}r.close("div");r.close("li");}else{I.render(r,B,"li");}}r.close("ul");};
S._addAllIconsClass=function(b){for(var i=0;i<b.length;i++){if(!b[i].getIcon()){return false;}}return true;};
return S;},true);
sap.ui.predefine('sap/m/Select',['./Dialog','./Popover','./SelectList','./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/Icon','sap/ui/core/IconPool','./Button','./Bar','./Title','./delegate/ValueStateMessage','sap/ui/core/message/MessageMixin','sap/ui/core/library','sap/ui/core/Item','sap/ui/Device','sap/ui/core/InvisibleText','./SelectRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes",'./Text','sap/m/SimpleFixFlex'],function(D,P,S,l,C,a,E,I,b,B,c,T,V,M,d,e,f,g,h,j,K,k,m){"use strict";var n=l.SelectListKeyboardNavigationMode;var o=l.PlacementType;var p=d.ValueState;var q=d.TextDirection;var r=d.TextAlign;var s=l.SelectType;
var t=a.extend("sap.m.Select",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent","sap.f.IShellBar"],library:"sap.m",properties:{name:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},type:{type:"sap.m.SelectType",group:"Appearance",defaultValue:s.Default},autoAdjustWidth:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:r.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:q.Inherit},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:p.None},valueStateText:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},forceSelection:{type:"boolean",group:"Behavior",defaultValue:true},wrapItemsText:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable",forwarding:{getter:"getList",aggregation:"items"}},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"},_valueIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_pickerHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},_pickerValueStateContent:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}},designtime:"sap/m/designtime/Select.designtime"}});
b.insertFontFaceStyle();E.apply(t.prototype,[true]);M.call(t.prototype);
function H(i){if(i){this.setSelection(i);this.setValue(i.getText());this.scrollToItem(i);}}
t.prototype._handleFocusout=function(i){this._bFocusoutDueRendering=this.bRenderingPhase;if(this._bFocusoutDueRendering){this._bProcessChange=false;return;}if(this._bProcessChange){if(!this.isOpen()||i.target===this.getAggregation("picker")){this._checkSelectionChange();}else{this._revertSelection();}this._bProcessChange=false;}else{this._bProcessChange=true;}};
t.prototype._checkSelectionChange=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.fireChange({selectedItem:i});}};
t.prototype._revertSelection=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.setSelection(this._oSelectionOnFocus);this.setValue(this._getSelectedItemText());}};
t.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
t.prototype.getOverflowToolbarConfig=function(){var i=["enabled","selectedKey"];if(!this.getAutoAdjustWidth()||this._bIsInOverflow){i.push("selectedItemId");}var u={canOverflow:true,autoCloseEvents:["change"],invalidationEvents:["_itemTextChange"],propsUnrelatedToSize:i};u.onBeforeEnterOverflow=function(v){var w=v.getParent();if(!w.isA("sap.m.OverflowToolbar")){return;}v._prevSelectType=v.getType();v._bIsInOverflow=true;if(v.getType()!==s.Default){v.setProperty("type",s.Default,true);}};u.onAfterExitOverflow=function(v){var w=v.getParent();if(!w.isA("sap.m.OverflowToolbar")){return;}v._bIsInOverflow=false;if(v.getType()!==v._prevSelectType){v.setProperty("type",v._prevSelectType,true);}};return u;};
t.prototype.getList=function(){if(this.bIsDestroyed){return null;}return this._oList;};
t.prototype.findFirstEnabledItem=function(i){var L=this.getList();return L?L.findFirstEnabledItem(i):null;};
t.prototype.findLastEnabledItem=function(i){var L=this.getList();return L?L.findLastEnabledItem(i):null;};
t.prototype.setSelectedIndex=function(i,_){var u;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);u=_[i];if(u){this.setSelection(u);}};
t.prototype.scrollToItem=function(i){var u=this.getPicker().getDomRef(),v=i&&i.getDomRef();if(!u||!v){return;}var w=u.querySelector('.sapUiSimpleFixFlexFlexContent'),x=u.querySelector('.sapMSltPickerValueState'),y=x?x.clientHeight:0,z=w.scrollTop,A=v.offsetTop-y,F=w.clientHeight,G=v.offsetHeight;if(z>A){w.scrollTop=A;}else if((A+G)>(z+F)){w.scrollTop=Math.ceil(A+G-F);}};
t.prototype.setValue=function(v){var i=this.getDomRef(),u=i&&i.querySelector(".sapMSelectListItemText");if(u){u.textContent=v;}this._getValueIcon();};
t.prototype._getValueIcon=function(){if(this.bIsDestroyed){return null;}var v=this.getAggregation("_valueIcon"),i=this.getSelectedItem(),u=!!(i&&i.getIcon&&i.getIcon()),w=u?i.getIcon():"sap-icon://pull-down";if(!v){v=new I(this.getId()+"-labelIcon",{src:w,visible:false});this.setAggregation("_valueIcon",v,true);}if(v.getVisible()!==u){v.setVisible(u);v.toggleStyleClass("sapMSelectListItemIcon",u);}if(u&&i.getIcon()!==v.getSrc()){v.setSrc(w);}return v;};
t.prototype._isShadowListRequired=function(){if(this.getAutoAdjustWidth()){return false;}else if(this.getWidth()==="auto"){return true;}return false;};
t.prototype._handleAriaActiveDescendant=function(i){var u=this.getDomRef(),v=i&&i.getDomRef(),A="aria-activedescendant";if(!u){return;}if(v&&this.isOpen()){u.setAttribute(A,i.getId());}else{u.removeAttribute(A);}};
t.prototype.updateItems=function(R){S.prototype.updateItems.apply(this,arguments);this._oSelectionOnFocus=this.getSelectedItem();};
t.prototype.refreshItems=function(){S.prototype.refreshItems.apply(this,arguments);};
t.prototype.onBeforeOpen=function(i){var u=this["_onBeforeOpen"+this.getPickerType()],v=this.getRenderer().CSS_CLASS;this.addStyleClass(v+"Pressed");this.addStyleClass(v+"Expanded");this.closeValueStateMessage();this.addContent();this.addContentToFlex();u&&u.call(this);};
t.prototype.onAfterOpen=function(i){var u=this.getFocusDomRef(),v=null,$=this.$("label");if(!u){return;}v=this.getSelectedItem();u.setAttribute("aria-expanded","true");$.attr("aria-live",null);u.setAttribute("aria-controls",this.getList().getId());if(v){u.setAttribute("aria-activedescendant",v.getId());this.scrollToItem(v);}};
t.prototype.onBeforeClose=function(i){var u=this.getFocusDomRef(),v=this.getRenderer().CSS_CLASS;if(u){u.removeAttribute("aria-controls");u.removeAttribute("aria-activedescendant");if(this.shouldValueStateMessageBeOpened()&&(document.activeElement===u)){this.openValueStateMessage();}}this.removeStyleClass(v+"Expanded");};
t.prototype.onAfterClose=function(i){var u=this.getFocusDomRef(),v=this.getRenderer().CSS_CLASS,w=v+"Pressed",$=this.$("label");if(u){u.setAttribute("aria-expanded","false");u.removeAttribute("aria-activedescendant");$.attr("aria-live","polite");}this.removeStyleClass(w);};
t.prototype.getPicker=function(){if(this.bIsDestroyed){return null;}return this.createPicker(this.getPickerType());};
t.prototype.getSimpleFixFlex=function(){if(this.bIsDestroyed){return null;}else if(this.oSimpleFixFlex){return this.oSimpleFixFlex;}this.oSimpleFixFlex=new m({id:this.getPickerValueStateContentId(),fixContent:this._getPickerValueStateContent().addStyleClass(this.getRenderer().CSS_CLASS+"PickerValueState"),flexContent:this.createList()});return this.oSimpleFixFlex;};
t.prototype.setPickerType=function(i){this._sPickerType=i;};
t.prototype.getPickerType=function(){return this._sPickerType;};
t.prototype._getPickerValueStateContent=function(){if(!this.getAggregation("_pickerValueStateContent")){this.setAggregation("_pickerValueStateContent",new k({wrapping:true,text:this._getTextForPickerValueStateContent()}));}return this.getAggregation("_pickerValueStateContent");};
t.prototype._updatePickerValueStateContentText=function(){var i=this.getPicker().getContent()[0].getFixContent(),u;if(i){u=this._getTextForPickerValueStateContent();i.setText(u);}};
t.prototype._getTextForPickerValueStateContent=function(){var v=this.getValueStateText(),i;if(v){i=v;}else{i=this._getDefaultTextForPickerValueStateContent();}return i;};
t.prototype._getDefaultTextForPickerValueStateContent=function(){var v=this.getValueState(),R,i;if(v===p.None){i="";}else{R=C.getLibraryResourceBundle("sap.ui.core");i=R.getText("VALUE_STATE_"+v.toUpperCase());}return i;};
t.prototype._updatePickerValueStateContentStyles=function(){var v=this.getValueState(),i=p,u=this.getRenderer().CSS_CLASS,w=u+"Picker",x=w+v+"State",y=w+"WithSubHeader",z=this.getPicker(),A=z.getContent()[0].getFixContent();if(A){this._removeValueStateClassesForPickerValueStateContent(z);A.addStyleClass(x);if(v!==i.None){z.addStyleClass(y);}else{z.removeStyleClass(y);}}};
t.prototype._removeValueStateClassesForPickerValueStateContent=function(i){var v=p,u=this.getRenderer().CSS_CLASS,w=u+"Picker",x=i.getContent()[0].getFixContent();Object.keys(v).forEach(function(y){var O=w+y+"State";x.removeStyleClass(O);});};
t.prototype._createPopover=function(){var i=this;var u=new P({showArrow:false,showHeader:false,placement:o.VerticalPreferredBottom,offsetX:0,offsetY:0,initialFocus:this,bounce:false,ariaLabelledBy:[this.getPickerValueStateContentId(),this._getPickerHiddenLabelId()]});u.addEventDelegate({ontouchstart:function(v){var w=this.getDomRef("cont");if((v.target===w)||(v.srcControl instanceof e)){i._bProcessChange=false;}}},u);this._decoratePopover(u);return u;};
t.prototype._decoratePopover=function(i){var u=this;i.open=function(){return this.openBy(u);};};
t.prototype._onBeforeRenderingPopover=function(){var i=this.getPicker(),w=this.$().outerWidth()+"px";if(i){i.setContentMinWidth(w);}};
t.prototype._createDialog=function(){var i=this;return new D({stretch:true,ariaLabelledBy:[this.getPickerValueStateContentId(),this._getPickerHiddenLabelId()],customHeader:this._getPickerHeader(),beforeOpen:function(){i.updatePickerHeaderTitle();}});};
t.prototype._getPickerTitle=function(){var i=this.getPicker(),u=i&&i.getCustomHeader();if(u){return u.getContentMiddle()[0];}return null;};
t.prototype._getPickerHeader=function(){var i=b.getIconURI("decline"),R;if(!this.getAggregation("_pickerHeader")){R=C.getLibraryResourceBundle("sap.m");this.setAggregation("_pickerHeader",new c({contentMiddle:new T({text:R.getText("SELECT_PICKER_TITLE_TEXT")}),contentRight:new B({icon:i,press:this.close.bind(this)})}));}return this.getAggregation("_pickerHeader");};
t.prototype._getPickerHiddenLabelId=function(){return g.getStaticId("sap.m","INPUT_AVALIABLE_VALUES");};
t.prototype.getPickerValueStateContentId=function(){return this.getId()+"-valueStateText";};
t.prototype.updatePickerHeaderTitle=function(){var i=this.getPicker();if(!i){return;}var L=this.getLabels();if(L.length){var u=L[0],v=this._getPickerTitle();if(u&&(typeof u.getText==="function")){v&&v.setText(u.getText());}}};
t.prototype._onBeforeOpenDialog=function(){};
t.prototype.init=function(){this.setPickerType(f.system.phone?"Dialog":"Popover");this.createPicker(this.getPickerType());this._oSelectionOnFocus=null;this.bRenderingPhase=false;this._bFocusoutDueRendering=false;this._bProcessChange=false;this.sTypedChars="";this.iTypingTimeoutID=-1;this._oValueStateMessage=new V(this);this._bValueStateMessageOpened=false;};
t.prototype.onBeforeRendering=function(){this.bRenderingPhase=true;this.synchronizeSelection({forceSelection:this.getForceSelection()});this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();};
t.prototype.onAfterRendering=function(){this.bRenderingPhase=false;};
t.prototype.exit=function(){var v=this.getValueStateMessage(),i=this._getValueIcon();this._oSelectionOnFocus=null;if(v){this.closeValueStateMessage();v.destroy();}if(i){i.destroy();}this._oValueStateMessage=null;this._bValueStateMessageOpened=false;};
t.prototype.ontouchstart=function(i){i.setMarked();if(this.getEnabled()&&this.getEditable()&&this.isOpenArea(i.target)){this.addStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
t.prototype.ontouchend=function(i){i.setMarked();if(this.getEnabled()&&this.getEditable()&&!this.isOpen()&&this.isOpenArea(i.target)){this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
t.prototype.ontap=function(i){var u=this.getRenderer().CSS_CLASS;i.setMarked();if(!this.getEnabled()||!this.getEditable()){return;}if(this.isOpenArea(i.target)){if(this.isOpen()){this.close();this.removeStyleClass(u+"Pressed");return;}if(f.system.phone){this.focus();}this.open();}if(this.isOpen()){this.addStyleClass(u+"Pressed");}};
t.prototype.onSelectionChange=function(i){var u=i.getParameter("selectedItem");this.close();this.setSelection(u);this.fireChange({selectedItem:u});this.setValue(this._getSelectedItemText());};
t.prototype.onkeypress=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();var u=String.fromCharCode(i.which),v;this.sTypedChars+=u;v=(/^(.)\1+$/i).test(this.sTypedChars)?u:this.sTypedChars;clearTimeout(this.iTypingTimeoutID);this.iTypingTimeoutID=setTimeout(function(){this.sTypedChars="";this.iTypingTimeoutID=-1;}.bind(this),1000);H.call(this,this.searchNextItemByText(v));};
t.prototype.onsapshow=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();if(i.which===K.F4){i.preventDefault();}this.toggleOpenState();};
t.prototype.onsaphide=t.prototype.onsapshow;
t.prototype.onsapescape=function(i){if(!this.getEnabled()||!this.getEditable()){return;}if(this.isOpen()){i.setMarked();this.close();this._revertSelection();}};
t.prototype.onsapenter=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();this.close();this._checkSelectionChange();};
t.prototype.onsapspace=function(i){i.preventDefault();};
t.prototype.onkeyup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}if(i.which===K.SPACE&&!i.shiftKey){i.setMarked();i.preventDefault();if(this.isOpen()){this._checkSelectionChange();}this.toggleOpenState();}};
t.prototype.onsapdown=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();var N,u=this.getSelectableItems();N=u[u.indexOf(this.getSelectedItem())+1];H.call(this,N);};
t.prototype.onsapup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();var u,v=this.getSelectableItems();u=v[v.indexOf(this.getSelectedItem())-1];H.call(this,u);};
t.prototype.onsaphome=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();var F=this.getSelectableItems()[0];H.call(this,F);};
t.prototype.onsapend=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();var L=this.findLastEnabledItem(this.getSelectableItems());H.call(this,L);};
t.prototype.onsappagedown=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();var u=this.getSelectableItems(),v=this.getSelectedItem();this.setSelectedIndex(u.indexOf(v)+10,u);v=this.getSelectedItem();if(v){this.setValue(v.getText());}this.scrollToItem(v);};
t.prototype.onsappageup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();var u=this.getSelectableItems(),v=this.getSelectedItem();this.setSelectedIndex(u.indexOf(v)-10,u);v=this.getSelectedItem();if(v){this.setValue(v.getText());}this.scrollToItem(v);};
t.prototype.onsaptabnext=function(i){if(!this.getEnabled()){return;}if(this.isOpen()){this.close();this._checkSelectionChange();}};
t.prototype.onsaptabprevious=t.prototype.onsaptabnext;
t.prototype.onfocusin=function(i){if(!this._bFocusoutDueRendering&&!this._bProcessChange){this._oSelectionOnFocus=this.getSelectedItem();}this._bProcessChange=true;setTimeout(function(){if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&(document.activeElement===this.getFocusDomRef())){this.openValueStateMessage();}}.bind(this),100);if(i.target!==this.getFocusDomRef()){this.focus();}};
t.prototype.onfocusout=function(i){this._handleFocusout(i);if(this.bRenderingPhase){return;}this.closeValueStateMessage();};
t.prototype.onsapfocusleave=function(i){var u=this.getAggregation("picker");if(!i.relatedControlId||!u){return;}var v=C.byId(i.relatedControlId),F=v&&v.getFocusDomRef();if(f.system.desktop&&j(u.getFocusDomRef(),F)){this.focus();}};
t.prototype.setSelection=function(i){var L=this.getList(),u;if(L){L.setSelection(i);}this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof e)?i.getId():i,true);if(typeof i==="string"){i=C.byId(i);}u=i?i.getKey():"";this.setProperty("selectedKey",u,true);this._handleAriaActiveDescendant(i);};
t.prototype.isSelectionSynchronized=function(){return S.prototype.isSelectionSynchronized.apply(this,arguments);};
t.prototype.synchronizeSelection=function(){S.prototype.synchronizeSelection.apply(this,arguments);};
t.prototype.addContent=function(i){};
t.prototype.addContentToFlex=function(){};
t.prototype.createPicker=function(i){var u=this.getAggregation("picker"),v=this.getRenderer().CSS_CLASS;if(u){return u;}u=this["_create"+i]();this.setAggregation("picker",u,true);u.setHorizontalScrolling(false).addStyleClass(v+"Picker").addStyleClass(v+"Picker-CTX").addStyleClass("sapUiNoContentPadding").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this).addContent(this.getSimpleFixFlex());return u;};
t.prototype.searchNextItemByText=function(u){var v=this.getItems(),w=this.getSelectedIndex(),x=v.splice(w+1,v.length-w),y=v.splice(0,v.length-1);v=x.concat(y);for(var i=0,z;i<v.length;i++){z=v[i];var A=typeof u==="string"&&u!=="";if(z.getEnabled()&&!(z instanceof sap.ui.core.SeparatorItem)&&z.getText().toLowerCase().startsWith(u.toLowerCase())&&A){return z;}}return null;};
t.prototype.createList=function(){var L=n,i=f.system.phone?L.Delimited:L.None;this._oList=new S({width:"100%",maxWidth:"600px",keyboardNavigationMode:i}).addStyleClass(this.getRenderer().CSS_CLASS+"List-CTX").addEventDelegate({ontap:function(u){this._checkSelectionChange();this.close();}},this).attachSelectionChange(this.onSelectionChange,this);this._oList.toggleStyleClass("sapMSelectListWrappedItems",this.getWrapItemsText());return this._oList;};
t.prototype.setWrapItemsText=function(w){if(this._oList){this._oList.toggleStyleClass("sapMSelectListWrappedItems",w);}return this.setProperty("wrapItemsText",w,true);};
t.prototype.hasContent=function(){return this.getItems().length>0;};
t.prototype.onBeforeRenderingPicker=function(){var O=this["_onBeforeRendering"+this.getPickerType()];O&&O.call(this);};
t.prototype.onAfterRenderingPicker=function(){var O=this["_onAfterRendering"+this.getPickerType()];O&&O.call(this);};
t.prototype.open=function(){var i=this.getPicker();if(i){i.open();}return this;};
t.prototype.toggleOpenState=function(){if(this.isOpen()){this.close();}else{this.open();}return this;};
t.prototype.getVisibleItems=function(){var L=this.getList();return L?L.getVisibleItems():[];};
t.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
t.prototype.getSelectedIndex=function(){var i=this.getSelectedItem();return i?this.indexOfItem(this.getSelectedItem()):-1;};
t.prototype.getDefaultSelectedItem=function(i){return this.getForceSelection()?this.findFirstEnabledItem():null;};
t.prototype.getSelectableItems=function(){var L=this.getList();return L?L.getSelectableItems():[];};
t.prototype.getOpenArea=function(){return this.getDomRef();};
t.prototype.isOpenArea=function(i){var O=this.getOpenArea();return O&&O.contains(i);};
t.prototype.findItem=function(i,v){var L=this.getList();return L?L.findItem(i,v):null;};
t.prototype.clearSelection=function(){this.setSelection(null);};
t.prototype.onItemChange=function(i){var u=this.getAssociation("selectedItem"),v=i.getParameter("id"),w=i.getParameter("name"),N=i.getParameter("newValue"),O,x,F,y;if(w==="key"&&!this.isBound("selectedKey")){x=this.getSelectedKey();F=this.getItemByKey(N);if(N===x&&u!==v&&F&&v===F.getId()){this.setSelection(F);return;}O=i.getParameter("oldValue");if(u===v&&x===O&&!this.getItemByKey(O)){this.setSelectedKey(N);return;}y=this.getItemByKey(x);if(u===v&&N!==x&&y){this.setSelection(y);return;}}if(w==="text"&&u===v){this.fireEvent("_itemTextChange");this.setValue(N);}};
t.prototype.fireChange=function(i){this._oSelectionOnFocus=i.selectedItem;return this.fireEvent("change",i);};
t.prototype.addAggregation=function(A,O,i){if(A==="items"&&!i&&!this.isInvalidateSuppressed()){this.invalidate(O);}return a.prototype.addAggregation.apply(this,arguments);};
t.prototype.destroyAggregation=function(A,i){if(A==="items"&&!i&&!this.isInvalidateSuppressed()){this.invalidate();}return a.prototype.destroyAggregation.apply(this,arguments);};
t.prototype.setAssociation=function(A,i,u){var L=this.getList();if(L&&(A==="selectedItem")){S.prototype.setAssociation.apply(L,arguments);}return a.prototype.setAssociation.apply(this,arguments);};
t.prototype.setProperty=function(i,v,u){var L=this.getList();if((i==="selectedKey")||(i==="selectedItemId")){L&&S.prototype.setProperty.apply(L,arguments);}return a.prototype.setProperty.apply(this,arguments);};
t.prototype.removeAllAssociation=function(A,i){var L=this.getList();if(L&&(A==="selectedItem")){S.prototype.removeAllAssociation.apply(L,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
t.prototype.clone=function(){var i=a.prototype.clone.apply(this,arguments),u=this.getSelectedItem(),v=this.getSelectedKey();if(!this.isBound("selectedKey")&&!i.isSelectionSynchronized()){if(u&&(v==="")){i.setSelectedIndex(this.indexOfItem(u));}else{i.setSelectedKey(v);}}return i;};
t.prototype.updateValueStateClasses=function(v,O){var $=this.$(),L=this.$("label"),A=this.$("arrow"),i=p,u=this.getRenderer().CSS_CLASS;if(O!==i.None){$.removeClass(u+"State");$.removeClass(u+O);L.removeClass(u+"LabelState");L.removeClass(u+"Label"+O);A.removeClass(u+"ArrowState");}if(v!==i.None){$.addClass(u+"State");$.addClass(u+v);L.addClass(u+"LabelState");L.addClass(u+"Label"+v);A.addClass(u+"ArrowState");}};
t.prototype.updateAriaLabelledBy=function(v,O){var $=this.$(),A=$.attr("aria-labelledby"),i=A?A.split(" "):[],N;if(O!==p.None&&O!==p.Error){i.pop();}if(v!==p.None&&v!==p.Error){i.push(g.getStaticId("sap.ui.core","VALUE_STATE_"+v.toUpperCase()));}N=i.join(" ");$.attr("aria-labelledby",N);};
t.prototype.getLabels=function(){var L=this.getAriaLabelledBy().map(function(u){return C.byId(u);});var i=sap.ui.require("sap/ui/core/LabelEnablement");if(i){L=L.concat(i.getReferencingLabels(this).map(function(u){return C.byId(u);}));}return L;};
t.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
t.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
t.prototype.getValueStateMessage=function(){return this._oValueStateMessage;};
t.prototype.openValueStateMessage=function(){var v=this.getValueStateMessage();if(v&&!this._bValueStateMessageOpened){this._bValueStateMessageOpened=true;v.open();}};
t.prototype.closeValueStateMessage=function(){var v=this.getValueStateMessage();if(v&&this._bValueStateMessageOpened){this._bValueStateMessageOpened=false;v.close();}};
t.prototype.shouldValueStateMessageBeOpened=function(){return(this.getValueState()!==p.None)&&this.getEnabled()&&this.getEditable()&&!this._bValueStateMessageOpened;};
t.prototype.setShowSecondaryValues=function(A){var i=!this._isShadowListRequired();this.setProperty("showSecondaryValues",A,i);var L=this.getList();if(L){L.setShowSecondaryValues(A);}return this;};
t.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
t.prototype.insertItem=function(i,u){this.insertAggregation("items",i,u);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
t.prototype.findAggregatedObjects=function(){var L=this.getList();if(L){return S.prototype.findAggregatedObjects.apply(L,arguments);}return[];};
t.prototype.getItems=function(){var L=this.getList();return L?L.getItems():[];};
t.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=C.byId(i);}if(!(i instanceof e)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));this._oSelectionOnFocus=i;return this;};
t.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText());this._oSelectionOnFocus=this.getSelectedItem();return this;};
t.prototype.setSelectedKey=function(i){i=this.validateProperty("selectedKey",i);var u=(i==="");if(!this.getForceSelection()&&u){this.setSelection(null);this.setValue("");return this;}var v=this.getItemByKey(i);if(v||u){if(!v&&u){v=this.getDefaultSelectedItem();}this.setSelection(v);this.setValue(this._getSelectedItemText(v));this._oSelectionOnFocus=v;return this;}return this.setProperty("selectedKey",i);};
t.prototype.setValueState=function(v){var O=this.getValueState();this.setProperty("valueState",v,true);v=this.getValueState();if(v===O){return this;}var i=this.getDomRefForValueState();if(!i){return this;}var u=p;if(v===u.Error){i.setAttribute("aria-invalid",true);}else{i.removeAttribute("aria-invalid");}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&document.activeElement===i){this.openValueStateMessage();}else{this.closeValueStateMessage();}this.updateValueStateClasses(v,O);this.updateAriaLabelledBy(v,O);this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();return this;};
t.prototype.setValueStateText=function(v){this.setProperty("valueStateText",v,true);if(this.getDomRefForValueState()){this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();}return this;};
t.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
t.prototype.getSelectedItem=function(){var v=this.getAssociation("selectedItem");return(v===null)?null:C.byId(v)||null;};
t.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
t.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
t.prototype.getEnabledItems=function(i){var L=this.getList();return L?L.getEnabledItems(i):[];};
t.prototype.getItemByKey=function(i){var L=this.getList();return L?L.getItemByKey(i):null;};
t.prototype.removeItem=function(i){var u;i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){u=this.findFirstEnabledItem();if(u){this.setSelection(u);}}this.setValue(this._getSelectedItemText());if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
t.prototype.removeAllItems=function(){var u=this.removeAllAggregation("items");this.setValue("");if(this._isShadowListRequired()){this.$().find(".sapMSelectListItemBase").remove();}for(var i=0;i<u.length;i++){u[i].detachEvent("_change",this.onItemChange,this);}return u;};
t.prototype.destroyItems=function(){this.destroyAggregation("items");this.setValue("");if(this._isShadowListRequired()){this.$().find(".sapMSelectListItemBase").remove();}return this;};
t.prototype.isOpen=function(){var i=this.getAggregation("picker");return!!(i&&i.isOpen());};
t.prototype.close=function(){var i=this.getAggregation("picker");if(i){i.close();}return this;};
t.prototype.getDomRefForValueState=function(){return this.getDomRef();};
t.prototype.getAccessibilityInfo=function(){var i=this.getType()==="IconOnly",u={role:this.getRenderer().getAriaRole(this),focusable:this.getEnabled(),enabled:this.getEnabled(),readonly:i?undefined:this.getEnabled()&&!this.getEditable()};if(i){var v=this.getTooltip_AsString();if(!v){var w=b.getIconInfo(this.getIcon());v=w&&w.text?w.text:"";}u.type=C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON");u.description=v;}else if(this.getType()==="Default"){u.type=C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_COMBO");u.description=this._getSelectedItemText();}return u;};
t.prototype.getIdForLabel=function(){return this.getId()+"-hiddenInput";};
return t;});
sap.ui.predefine('sap/m/SelectDialog',['./Button','./Dialog','./List','./SearchField','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/Device','sap/ui/base/ManagedObject','sap/m/Toolbar','sap/m/Label','sap/m/BusyIndicator','sap/m/Bar','sap/m/Title','sap/ui/core/theming/Parameters','./SelectDialogRenderer',"sap/base/Log"],function(B,D,L,S,l,T,C,a,M,b,c,d,e,f,P,g,h){"use strict";var i=l.ListMode;var j=l.ButtonType;var k=l.TitleAlignment;
var m=C.extend("sap.m.SelectDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:null},growing:{type:"boolean",group:"Behavior",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showClearButton:{type:"boolean",group:"Behavior",defaultValue:false},confirmButtonText:{type:"string",group:"Appearance"},draggable:{type:"boolean",group:"Behavior",defaultValue:false},resizable:{type:"boolean",group:"Behavior",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:k.Auto}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",forwarding:{idSuffix:"-list",aggregation:"items",forwardBinding:true}},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"object[]"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}}});
m.prototype.init=function(){var t=this,n=0,o=null;this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._bAfterCloseAttached=false;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=new L(this.getId()+"-list",{growing:t.getGrowing(),growingScrollToLoad:t.getGrowing(),mode:i.SingleSelectMaster,sticky:[l.Sticky.InfoToolbar],infoToolbar:new b({visible:false,active:false,content:[new c({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:this._selectionChange.bind(this)});this._oList.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oList.getInfoToolbar().$().attr('aria-live','polite');}});this._list=this._oList;this._oList.attachUpdateStarted(this._updateStarted,this);this._oList.attachUpdateFinished(this._updateFinished,this);this._oBusyIndicator=new d(this.getId()+"-busyIndicator").addStyleClass("sapMSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),q=(v?300:0);clearTimeout(n);if(q){n=setTimeout(function(){t._executeSearch(v,false,"liveChange");},q);}else{t._executeSearch(v,false,"liveChange");}},search:function(E){var v=E.getSource().getValue(),q=E.getParameters().clearButtonPressed;t._executeSearch(v,q,"search");}});this._searchField=this._oSearchField;this._oSubHeader=new e(this.getId()+"-subHeader",{contentMiddle:[this._oSearchField]});var p=new e(this.getId()+"-dialog-header",{contentMiddle:[new f(this.getId()+"-dialog-title",{level:"H2"})]});this._setupBarTitleAlignment(p,this.getId()+"_customHeader");this._oDialog=new D(this.getId()+"-dialog",{customHeader:p,stretch:a.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oList],leftButton:this._getCancelButton(),initialFocus:(a.system.desktop?this._oSearchField:null),draggable:this.getDraggable()&&a.system.desktop,resizable:this.getResizable()&&a.system.desktop}).addStyleClass("sapMSelectDialog",true);this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);o=this._oDialog.onsapescape;this._oDialog.onsapescape=function(E){if(o){o.call(t._oDialog,E);}t._onCancel();};this._oDialog._iVMargin=8*(parseInt(P.get("sapUiFontSize"))||16);this._sSearchFieldValue="";this._bFirstRequest=true;this._bLiveChange=false;this._iListUpdateRequested=0;};
m.prototype.setGrowing=function(v){this._oList.setGrowing(v);this._oList.setGrowingScrollToLoad(v);this.setProperty("growing",v,true);return this;};
m.prototype.setDraggable=function(v){this._setInteractionProperty(v,"draggable",this._oDialog.setDraggable);return this;};
m.prototype.setResizable=function(v){this._setInteractionProperty(v,"resizable",this._oDialog.setResizable);return this;};
m.prototype._setInteractionProperty=function(v,p,n){this.setProperty(p,v,true);if(!a.system.desktop&&v){h.warning(p+" property works only on desktop devices!");return;}if(a.system.desktop&&this._oDialog){n.call(this._oDialog,v);}};
m.prototype.setBusy=function(){this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
m.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
m.prototype.setBusyIndicatorDelay=function(v){this._oList.setBusyIndicatorDelay(v);this._oDialog.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
m.prototype.exit=function(){this._oList=null;this._oSearchField=null;this._oSubHeader=null;this._oClearButton=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iListUpdateRequested=0;this._bFirstRequest=false;this._bInitBusy=false;this._bFirstRender=false;this._bFirstRequest=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._list=null;this._searchField=null;this._dialog=null;};
m.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;}return this;};
m.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}return this;};
m.prototype.open=function(s){if((!this.getParent()||!this.getUIArea())&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._bFirstRequest=true;this._oSearchField.setValue(s);this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._updateSelectionIndicator();this._aInitiallySelectedContextPaths=this._oList.getSelectedContextPaths();return this;};
m.prototype.setGrowingThreshold=function(v){this._oList.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
m.prototype.setMultiSelect=function(n){this.setProperty("multiSelect",n,true);if(n){this._oList.setMode(i.MultiSelect);this._oList.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oList.setMode(i.SingleSelectMaster);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.destroyBeginButton();delete this._oOkButton;}return this;};
m.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.getCustomHeader().getAggregation("contentMiddle")[0].setText(t);return this;};
m.prototype.setConfirmButtonText=function(t){this.setProperty("confirmButtonText",t,true);this._oOkButton&&this._oOkButton.setText(t||this._oRb.getText("SELECT_CONFIRM_BUTTON"));return this;};
m.prototype.setNoDataText=function(n){this._oList.setNoDataText(n);return this;};
m.prototype.getNoDataText=function(){return this._oList.getNoDataText();};
m.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
m.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
m.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
m.prototype.setShowClearButton=function(v){this.setProperty("showClearButton",v,true);if(v){var o=this._oDialog.getCustomHeader();o.addContentRight(this._getClearButton());}if(this._oClearButton){this._oClearButton.setVisible(v);}return this;};
m.prototype.setContentHeight=function(H){this._oDialog.setContentHeight(H);return this;};
m.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
m.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
m.prototype.clearSelection=function(){this._removeSelection();this._updateSelectionIndicator();this._oDialog.focus();return this;};
m.prototype._setModel=m.prototype.setModel;
m.prototype.setModel=function(o,s){var A=Array.prototype.slice.call(arguments);this._setBusy(false);this._bInitBusy=false;this._iListUpdateRequested+=1;this._oList.setModel(o,s);m.prototype._setModel.apply(this,A);this._updateSelectionIndicator();return this;};
m.prototype._setBindingContext=m.prototype.setBindingContext;
m.prototype.setBindingContext=function(o,s){var n=Array.prototype.slice.call(arguments);this._oList.setBindingContext(o,s);m.prototype._setBindingContext.apply(this,n);return this;};
m.prototype._executeSearch=function(v,n,E){var o=this._oList,p=(o?o.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(E==="liveChange"){this._bLiveChange=true;}if(this._oDialog.isOpen()&&((s&&E==="liveChange")||E==="search")){this._sSearchFieldValue=v;if(p){this._iListUpdateRequested+=1;if(E==="search"){this.fireSearch({value:v,itemsBinding:p,clearButtonPressed:n});}else if(E==="liveChange"){this.fireLiveChange({value:v,itemsBinding:p});}}else{if(E==="search"){this.fireSearch({value:v,clearButtonPressed:n});}else if(E==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
m.prototype._setBusy=function(n){if(this._iListUpdateRequested){if(n){this._oList.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oList.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
m.prototype._updateStarted=function(E){if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iListUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
m.prototype._updateFinished=function(E){this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}if(a.system.desktop){if(this._oList.getItems()[0]){this._oDialog.setInitialFocus(this._oList.getItems()[0]);}else{this._oDialog.setInitialFocus(this._oSearchField);}if(this._bFirstRequest&&!this._bLiveChange){var F=this._oList.getItems()[0];if(!F){F=this._oSearchField;}if(F.getFocusDomRef()){F.getFocusDomRef().focus();}}}this._bFirstRequest=false;this._iListUpdateRequested=0;this._oList.getItems().forEach(function(I){I.addEventDelegate(this._getListItemsEventDelegates());},this);};
m.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._oSelectedItem=t._oList.getSelectedItem();t._aSelectedItems=t._oList.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{type:j.Emphasized,text:this.getConfirmButtonText()||this._oRb.getText("SELECT_CONFIRM_BUTTON"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
m.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(E){t._onCancel();}});}return this._oCancelButton;};
m.prototype._getClearButton=function(){if(!this._oClearButton){this._oClearButton=new B(this.getId()+"-clear",{text:this._oRb.getText("SELECTDIALOG_CLEARBUTTON"),press:this.clearSelection.bind(this)});}return this._oClearButton;};
m.prototype._onCancel=function(E){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t._resetSelection();t.fireCancel();};this._oDialog.attachAfterClose(A);this._oDialog.close();};
m.prototype._updateSelectionIndicator=function(){var s=this._oList.getSelectedContextPaths(true).length,I=this._oList.getInfoToolbar();if(this.getShowClearButton()&&this._oClearButton){this._oClearButton.setEnabled(s>0);}I.setVisible(!!s&&this.getMultiSelect());I.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
m.prototype._fireConfirmAndUpdateSelection=function(){var p={selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems};Object.defineProperty(p,"selectedContexts",{get:this._oList.getSelectedContexts.bind(this._oList,true)});this.fireConfirm(p);this._updateSelection();};
m.prototype._selectionChange=function(){if(!this._oDialog){return;}if(this.getMultiSelect()){this._updateSelectionIndicator();return;}if(!this._bAfterCloseAttached){this._oDialog.attachEventOnce("afterClose",this._resetAfterClose,this);this._bAfterCloseAttached=true;}this._oDialog.close();};
m.prototype._resetAfterClose=function(){this._oSelectedItem=this._oList.getSelectedItem();this._aSelectedItems=this._oList.getSelectedItems();this._bAfterCloseAttached=false;this._fireConfirmAndUpdateSelection();};
m.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._removeSelection();}};
m.prototype._removeSelection=function(){this._oList.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;};
m.prototype._resetSelection=function(){if(!this.bIsDestroyed){this._oList.removeSelections(true);this._oList.setSelectedContextPaths(this._aInitiallySelectedContextPaths);this._oList.getItems().forEach(function(I){var p=I.getBindingContextPath();if(p&&this._aInitiallySelectedContextPaths.indexOf(p)>-1){I.setSelected(true);}},this);}};
m.prototype._getListItemsEventDelegates=function(){var E=function(o){if(o&&o.isDefaultPrevented&&o.isMarked&&(o.isDefaultPrevented()||o.isMarked("preventSelectionChange"))){return;}this._selectionChange(o);}.bind(this);return{ontap:E,onsapselect:E};};
T.mixInto(m.prototype);return m;});
sap.ui.predefine('sap/m/SelectDialogRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){};
return S;},true);
sap.ui.predefine('sap/m/SelectList',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/Item','./SelectListRenderer','sap/base/Log',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(l,C,a,I,b,S,L,q){"use strict";var t=l.touch;var c=l.SelectListKeyboardNavigationMode;
var d=a.extend("sap.m.SelectList",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},keyboardNavigationMode:{type:"sap.m.SelectListKeyboardNavigationMode",group:"Behavior",defaultValue:c.Delimited}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}},itemPress:{parameters:{item:{type:"sap.ui.core.Item"}}}}}});
d.prototype._setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
d.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;this.synchronizeSelection({forceSelection:false});setTimeout(this.synchronizeSelection.bind(this),0);};
d.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
d.prototype._activateItem=function(i){if(i instanceof b&&i&&i.getEnabled()){this.fireItemPress({item:i});if(this.getSelectedItem()!==i){this.setSelection(i);this.fireSelectionChange({selectedItem:i});}}};
d.prototype._queryEnabledItemsDomRefs=function(D){var e="."+this.getRenderer().CSS_CLASS+"ItemBase";D=D||this.getDomRef();return D?Array.prototype.slice.call(D.querySelectorAll(e+":not("+e+"Disabled)")):[];};
d.prototype._handleARIAActivedescendant=function(){var A=q(document.activeElement).control(0),D=this.getDomRef();if(A&&D){D.setAttribute("aria-activedescendant",A.getId());}};
d.prototype.init=function(){this._iStartTimeout=0;this._iActiveTouchId=0;this._fStartX=0;this._fStartY=0;this._oItemNavigation=null;this._$ItemPressed=null;};
d.prototype.onBeforeRendering=function(){this.synchronizeSelection({forceSelection:false});};
d.prototype.onAfterRendering=function(){if(this.getKeyboardNavigationMode()===c.None){this.destroyItemNavigation();}else{this.createItemNavigation();}};
d.prototype.exit=function(){this.destroyItemNavigation();this._$ItemPressed=null;};
d.prototype.ontouchstart=function(e){if(t.countContained(e.touches,this.getId())>1||!this.getEnabled()){return;}e.setMarked();var T=e.targetTouches[0];this._iActiveTouchId=T.identifier;this._fStartX=T.pageX;this._fStartY=T.pageY;this._iStartTimeout=setTimeout(function(){var i=e.srcControl.$();if(i){i.addClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=i;}}.bind(this),100);};
d.prototype.ontouchmove=function(e){var T=null;if(!this.getEnabled()){return;}T=t.find(e.changedTouches,this._iActiveTouchId);if(T&&((Math.abs(T.pageX-this._fStartX)>10)||(Math.abs(T.pageY-this._fStartY)>10))){clearTimeout(this._iStartTimeout);if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}}};
d.prototype.ontouchend=function(e){var T=null;if(!this.getEnabled()){return;}e.setMarked();T=t.find(e.changedTouches,this._iActiveTouchId);if(T){setTimeout(function(){if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}this._iStartTimeout=null;}.bind(this),100);}};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype.ontap=function(e){if(this.getEnabled()){e.setMarked();this._activateItem(e.srcControl);}};
d.prototype.onsapselect=function(e){if(this.getEnabled()){e.setMarked();e.preventDefault();this._activateItem(e.srcControl);}};
d.prototype.onAfterFocus=function(o){this._handleARIAActivedescendant();};
d.prototype.findFirstEnabledItem=function(e){e=e||this.getItems();for(var i=0;i<e.length;i++){if(e[i].getEnabled()){return e[i];}}return null;};
d.prototype.setSelection=function(i){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof b)?i.getId():i);if(typeof i==="string"){i=C.byId(i);}this.setProperty("selectedKey",i?i.getKey():"",true);return this;};
d.prototype.synchronizeSelection=function(o){var k=this.getSelectedKey(),i=this.getItemByKey(""+k),f=true;if(o){f=!!o.forceSelection;}if(this.isSelectionSynchronized({selectedKey:k,firstItemWithKey:i,forceSelection:f})){return;}if(i&&(k!=="")){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",i.getId(),true);}else if(f&&this.getDefaultSelectedItem()&&(!this.isBound("items")||this.bItemsUpdated)){try{this.setSelection(this.getDefaultSelectedItem());}catch(e){L.warning('Update failed due to exception. Loggable in support mode log',null,null,function(){return{exception:e};});}}};
d.prototype.isSelectionSynchronized=function(o){var s=this.getSelectedItem(),e,f,F;if(o){e=o.selectedKey;f=o.firstItemWithKey;F=o.forceSelection;}else{e=this.getSelectedKey();f=this.getItemByKey(e);F=this.getForceSelection();}if(F){if(!s){return false;}if(e===""&&s.getKey()===""){return true;}return e===s.getKey()&&s===f;}else{if(s===null&&e===""){return true;}if(e===""){return false;}return e===(s&&s.getKey())&&s===f;}};
d.prototype.getForceSelection=function(){return false;};
d.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
d.prototype.getVisibleItems=function(){for(var i=0,o,e=this.getItems(),v=[];i<e.length;i++){o=e[i];if(o.bVisible||(o.bVisible===undefined)){v.push(o);}}return v;};
d.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems());};
d.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,e=this.getItems();i<e.length;i++){if(e[i][m]()===v){return e[i];}}return null;};
d.prototype.getItemByText=function(T){return this.findItem("text",T);};
d.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
d.prototype._getNonSeparatorItemsCount=function(){return this.getItems().filter(function(i){return!(i instanceof sap.ui.core.SeparatorItem);}).length;};
d.prototype.getDefaultSelectedItem=function(i){return null;};
d.prototype.clearSelection=function(){this.setSelection(null);};
d.prototype.createItemNavigation=function(){var D;if(!this._oItemNavigation){this._oItemNavigation=new I(null,null,!this.getEnabled());this._oItemNavigation.attachEvent(I.Events.AfterFocus,this.onAfterFocus,this);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addEventDelegate(this._oItemNavigation);}D=this.getDomRef();this._oItemNavigation.setRootDomRef(D);this._oItemNavigation.setItemDomRefs(this._queryEnabledItemsDomRefs(D));this._oItemNavigation.setCycling(false);this._oItemNavigation.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));this._oItemNavigation.setPageSize(10);};
d.prototype.destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
d.prototype.getItemNavigation=function(){return this._oItemNavigation;};
d.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=C.byId(i);}if(!(i instanceof b)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;};
d.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);this.setSelection(i);return this;};
d.prototype.setSelectedKey=function(k){k=this.validateProperty("selectedKey",k);var i=this.getItemByKey(k);if(i||(k==="")){if(!i&&k===""){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;}return this.setProperty("selectedKey",k);};
d.prototype.getSelectedItem=function(){var s=this.getAssociation("selectedItem");return(s===null)?null:C.byId(s)||null;};
d.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
d.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
d.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
d.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
d.prototype.getItemByKey=function(k){return this.findItem("key",k);};
d.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){this.setSelection(this.getDefaultSelectedItem());}return i;};
d.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items",true);this.$().children("li").remove();return i;};
d.prototype.destroyItems=function(){this.destroyAggregation("items",true);return this;};
d.prototype.setNoDataText=function(){};
return d;});
sap.ui.predefine('sap/m/SelectListRenderer',["sap/ui/core/Element","sap/ui/core/Icon","sap/ui/core/IconPool","sap/ui/Device"],function(E,I,a,D){"use strict";var S={apiVersion:2};S.CSS_CLASS="sapMSelectList";
S.render=function(r,l){this.writeOpenListTag(r,l,{elementData:true});this.renderItems(r,l);this.writeCloseListTag(r,l);};
S.writeOpenListTag=function(r,l,s){var C=S.CSS_CLASS;if(s.elementData){r.openStart("ul",l);}else{r.openStart("ul");}r.class(C);if(l.getShowSecondaryValues()){r.class(C+"TableLayout");}if(!l.getEnabled()){r.class(C+"Disabled");}r.style("width",l.getWidth());r.style("max-width",l.getMaxWidth());this.writeAccessibilityState(r,l);r.openEnd();};
S.writeCloseListTag=function(r,l){r.close("ul");};
S.renderItems=function(r,l){var s=l._getNonSeparatorItemsCount(),b=l.getItems(),o=l.getSelectedItem(),c=1,d;for(var i=0;i<b.length;i++){d={selected:o===b[i],setsize:s,elementData:true};if(!(b[i]instanceof sap.ui.core.SeparatorItem)){d.posinset=c++;}this.renderItem(r,l,b[i],d);}};
S.renderItem=function(r,l,i,s){if(!(i instanceof E)){return;}var e=i.getEnabled(),o=l.getSelectedItem(),C=S.CSS_CLASS,t=i.getTooltip_AsString(),b=l.getShowSecondaryValues();r.openStart("li",s.elementData?i:null);if(i.getIcon&&i.getIcon()){r.class("sapMSelectListItemWithIcon");}if(i instanceof sap.ui.core.SeparatorItem){r.class(C+"SeparatorItem");if(b){r.class(C+"Row");}}else{r.class(C+"ItemBase");if(b){r.class(C+"Row");}else{r.class(C+"Item");}if(i.bVisible===false){r.class(C+"ItemBaseInvisible");}if(!e){r.class(C+"ItemBaseDisabled");}if(e&&D.system.desktop){r.class(C+"ItemBaseHoverable");}if(i===o){r.class(C+"ItemBaseSelected");}if(e){r.attr("tabindex","0");}}r.style("max-width",l.getMaxWidth());if(t){r.attr("title",t);}this.writeItemAccessibilityState.apply(this,arguments);r.openEnd();if(b){r.openStart("span");r.class(C+"Cell");r.class(C+"FirstCell");r.attr("disabled","disabled");r.openEnd();this._renderIcon(r,i);r.text(i.getText());r.close("span");r.openStart("span");r.class(C+"Cell");r.class(C+"LastCell");r.attr("disabled","disabled");r.openEnd();if(typeof i.getAdditionalText==="function"){r.text(i.getAdditionalText());}r.close("span");}else{this._renderIcon(r,i);r.text(i.getText());}r.close("li");};
S.writeAccessibilityState=function(r,l){r.accessibilityState(l,{role:"listbox"});};
S.writeItemAccessibilityState=function(r,l,i,s){var R=(i.isA("sap.ui.core.SeparatorItem"))?"separator":"option";var d;if(!i.getText()&&i.getIcon&&i.getIcon()){var o=a.getIconInfo(i.getIcon());if(o){d=o.text||o.name;}}r.accessibilityState(i,{role:R,selected:s.selected,setsize:s.setsize,posinset:s.posinset,label:d});};
S._renderIcon=function(r,i){if(i.getIcon&&i.getIcon()){r.icon(i.getIcon(),S.CSS_CLASS+"ItemIcon",{id:i.getId()+"-icon"});}};
return S;},true);
sap.ui.predefine('sap/m/SelectRenderer',['sap/ui/core/Renderer','sap/ui/core/IconPool','sap/m/library','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/library'],function(R,I,l,D,a,c){"use strict";var T=c.TextDirection;var V=c.ValueState;var S=l.SelectType;var b={apiVersion:2};b.CSS_CLASS="sapMSlt";
b.render=function(r,s){var t=s.getTooltip_AsString(),d=s.getType(),A=s.getAutoAdjustWidth(),e=s.getEditable(),E=s.getEnabled(),C=s.getWidth(),w=C.indexOf("%")>-1,f=A||C==="auto"||w,g=b.CSS_CLASS;r.openStart("div",s);this.addClass(r,s);r.class(g);r.class(g+s.getType());if(!E){r.class(g+"Disabled");}else if(!e){r.class(g+"Readonly");}if(f&&(d===S.Default)){r.class(g+"MinWidth");}if(A){r.class(g+"AutoAdjustedWidth");}else{r.style("width",C);}if(s.getIcon()){r.class(g+"WithIcon");}if(E&&e&&D.system.desktop){r.class(g+"Hoverable");}r.class(g+"WithArrow");if(s.getValueState()!==V.None){this.addValueStateClasses(r,s);}r.style("max-width",s.getMaxWidth());this.writeAccessibilityState(r,s);if(t){r.attr("title",t);}else if(d===S.IconOnly){var i=I.getIconInfo(s.getIcon());if(i){r.attr("title",i.text);}}if(E){r.attr("tabindex","0");}r.openEnd();this.renderHiddenInput(r,s);this.renderLabel(r,s);switch(d){case S.Default:this.renderArrow(r,s);break;case S.IconOnly:this.renderIcon(r,s);break;}var L=s.getList();if(s._isShadowListRequired()&&L){this.renderShadowList(r,L);}if(s.getName()){this.renderInput(r,s);}r.close("div");};
b.renderHiddenInput=function(r,s){r.voidStart("input",s.getId()+"-hiddenInput");r.attr("aria-readonly","true");r.attr("tabindex","-1");r.class("sapUiPseudoInvisibleText");r.voidEnd();};
b.renderLabel=function(r,s){var o=s.getSelectedItem(),t=s.getTextDirection(),d=R.getTextAlign(s.getTextAlign(),t),C=b.CSS_CLASS;r.openStart("label",s.getId()+"-label");r.attr("for",s.getId());r.attr("aria-live","polite");r.class(C+"Label");if(s.getValueState()!==V.None){r.class(C+"LabelState");r.class(C+"Label"+s.getValueState());}if(s.getType()===S.IconOnly){r.class("sapUiPseudoInvisibleText");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.style("text-align",d);r.openEnd();if(s.getType()!==S.IconOnly){r.renderControl(s._getValueIcon());r.openStart("span",s.getId()+"-labelText");r.class("sapMSelectListItemText");r.openEnd();r.text(o&&o.getParent()?o.getText():null);r.close("span");}r.close("label");};
b.renderArrow=function(r,s){var C=b.CSS_CLASS;r.openStart("span",s.getId()+"-arrow");r.class(C+"Arrow");if(s.getValueState()!==V.None){r.class(C+"ArrowState");}r.openEnd().close("span");};
b.renderIcon=function(r,s){r.icon(s.getIcon(),b.CSS_CLASS+"Icon",{id:s.getId()+"-icon",title:null});};
b.renderInput=function(r,s){r.voidStart("input",s.getId()+"-input");r.attr("type","hidden");r.class(b.CSS_CLASS+"Input");r.attr("aria-hidden","true");r.attr("tabindex","-1");if(!s.getEnabled()){r.attr("disabled","disabled");}r.attr("name",s.getName());r.attr("value",s.getSelectedKey());r.voidEnd();};
b.renderShadowList=function(r,L){var o=L.getRenderer();o.writeOpenListTag(r,L,{elementData:false});this.renderShadowItems(r,L);o.writeCloseListTag(r,L);};
b.renderShadowItems=function(r,L){var o=L.getRenderer(),s=L.getItems().length,d=L.getSelectedItem();for(var i=0,e=L.getItems();i<e.length;i++){o.renderItem(r,L,e[i],{selected:d===e[i],setsize:s,posinset:i+1,elementData:false});}};
b.addClass=function(r,s){};
b.addValueStateClasses=function(r,s){r.class(b.CSS_CLASS+"State");r.class(b.CSS_CLASS+s.getValueState());};
b.getAriaRole=function(s){switch(s.getType()){case S.Default:return"combobox";case S.IconOnly:return"button";}};
b._getValueStateString=function(s){var C="sap.ui.core";switch(s.getValueState()){case V.Success:return a.getStaticId(C,"VALUE_STATE_SUCCESS");case V.Warning:return a.getStaticId(C,"VALUE_STATE_WARNING");case V.Information:return a.getStaticId(C,"VALUE_STATE_INFORMATION");}return"";};
b.writeAccessibilityState=function(r,s){var v=this._getValueStateString(s),o=s.getSelectedItem(),i=s.getType()===S.IconOnly,A,d;if(v){v=" "+v;}if(o&&!o.getText()&&o.getIcon&&o.getIcon()){var e=I.getIconInfo(o.getIcon());if(e){d=e.text||e.name;}}A={value:d?s._getValueIcon().getId():s.getId()+"-label"+v,append:true};r.accessibilityState(s,{role:this.getAriaRole(s),disabled:!s.getEnabled(),readonly:i?undefined:s.getEnabled()&&!s.getEditable(),expanded:s.isOpen(),invalid:(s.getValueState()===V.Error)?true:undefined,labelledby:i?undefined:A,haspopup:i?true:undefined});};
return b;},true);
sap.ui.predefine('sap/m/SelectionDetails',['./library','sap/ui/core/Control','sap/m/Button','sap/ui/base/Interface','sap/ui/Device','sap/ui/core/library','./SelectionDetailsRenderer',"sap/base/util/uid","sap/ui/thirdparty/jquery"],function(l,C,B,I,D,a,S,u,q){"use strict";
var b=C.extend("sap.m.SelectionDetails",{metadata:{library:"sap.m",defaultAggregation:"items",aggregations:{"items":{type:"sap.m.SelectionDetailsItem",multiple:true,bindable:"bindable"},"actions":{type:"sap.ui.core.Item",multiple:true},"actionGroups":{type:"sap.ui.core.Item",multiple:true},"_popover":{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"},"_button":{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{beforeOpen:{},beforeClose:{},navigate:{parameters:{item:{type:"sap.m.SelectionDetailsItem"},direction:{type:"string"},content:{type:"sap.ui.core.Control"}}},actionPress:{parameters:{action:{type:"sap.ui.core.Item"},items:{type:"sap.m.SelectionDetailsItem"},level:{type:"sap.m.SelectionDetailsActionLevel"}}}}}});
b._MAX_ACTIONGROUPS=5;b._POPOVER_MAX_HEIGHT=500;
b.prototype.init=function(){this._bWrapLabels=false;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_button",new B({id:this.getId()+"-button",type:l.ButtonType.Transparent,press:[this._onToolbarButtonPress,this]}),true);this._oItemFactory=null;};
b.prototype.onBeforeRendering=function(){this._updateButton();};
b.prototype.exit=function(){this.detachSelectionHandler();this._oItemFactory=null;this._oChangeHandler=null;};
b.prototype.isOpen=function(){var p=this.getAggregation("_popover");return p?p.isOpen():false;};
b.prototype.isEnabled=function(){return this.getItems().length>0;};
b.prototype.close=function(){var p=this.getAggregation("_popover");if(p){p.close();}return this;};
b.prototype.navTo=function(t,c){if(this.isOpen()){sap.ui.require(["sap/m/Page","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/Title"],this._handleNavLazy.bind(this,t,c));}return this;};
b.prototype.getWrapLabels=function(){return this._bWrapLabels;};
b.prototype.setWrapLabels=function(w){var p=this.getAggregation("_popover");this._bWrapLabels=w;if(p&&p.isOpen()){p.invalidate();}return this;};
b.prototype.setPopoverModal=function(m){this._getPopover().setModal(m);return this;};
b.prototype._handleNavLazy=function(p,c,P,T,d,e,B){var s=this.getId()+"-page-for-"+c.getId()+"-uid-"+u();this._setPopoverHeight(b._POPOVER_MAX_HEIGHT);var o=new P(s,{customHeader:this._getPageToolbar(T,d,e,true,p),content:[c]});this._oNavContainer.addPage(o);this._oNavContainer.to(s);};
b.prototype._getPageToolbar=function(T,c,d,s,p){var t=new T({design:l.ToolbarDesign.Transparent}).addStyleClass("sapMSDPageHeader");if(s){var o=new B({icon:"sap-icon://nav-back",press:this._onBackButtonPress.bind(this)});t.addAggregation("content",o,true);}var e=new c();var f=new d({text:p,titleStyle:a.TitleLevel.H5});t.addAggregation("content",e,true);t.addAggregation("content",f,true);t.addAggregation("content",e.clone(),true);if(D.system.phone){t.addAggregation("content",this._getCloseButton(),true);}return t;};
b.prototype._setPopoverHeight=function(h){if(!D.system.phone){var p=this._getPopover(),P=p.$("cont"),m=this._getMaxPopoverHeight();h=Math.min(b._POPOVER_MAX_HEIGHT,h);p._oControl._deregisterContentResizeHandler();P.animate({"height":Math.min(h,m)},sap.ui.getCore().getConfiguration().getAnimation()?100:0,function(){p.setProperty("contentHeight",h+"px",true);p._oControl._registerContentResizeHandler();});}};
b.prototype._getMaxPopoverHeight=function(){var r=this._getPopover(),R=r.$(),o,v,p;if(!R.length){return 0;}o=R.offset().top;v=D.resize.height;p=r._oControl;p._adaptPositionParams();return v-o-p._marginBottom;};
b.prototype._onBackButtonPress=function(){var c=this._oNavContainer.getCurrentPage().getContent()[0];this._oNavContainer.attachEventOnce("afterNavigate",function(){this.fireNavigate({item:this._oItemForNavigation,direction:"back",content:c});},this);this._oNavContainer.back();if(this._oNavContainer.getCurrentPage()===this._oInitialPage){this._setPopoverHeight(this._getInitialPageHeight());}};
b.prototype._getCloseButton=function(){return new B({icon:"sap-icon://decline",press:this.close.bind(this)});};
b.prototype._aFacadeMethods=["addCustomData","getCustomData","indexOfCustomData","insertCustomData","removeCustomData","removeAllCustomData","destroyCustomData","data","addEventDelegate","removeEventDelegate","close","isOpen","isEnabled","attachBeforeOpen","detachBeforeOpen","attachBeforeClose","detachBeforeClose","attachNavigate","detachNavigate","attachActionPress","detachActionPress","addAction","removeAction","removeAllActions","addActionGroup","removeActionGroup","removeAllActionGroups","navTo","getWrapLabels","setWrapLabels"];
b.prototype.getFacade=function(){var f=new I(this,b.prototype._aFacadeMethods,true);f.getItems=this._getItemFacades.bind(this);this.getFacade=function(){return f;};return f;};
b.prototype._getItemFacades=function(){var c=this.getItems();var d=[];for(var i=0;i<c.length;i++){d.push(c[i].getFacade());}return d;};
b.prototype._updateButton=function(){var t,c,o=this.getAggregation("_button");if(this._oSelectionData&&this._oSelectionData.length>=0){c=this._oSelectionData.length;}else{c=this.getItems().length;}if(c>0){t=this._oRb.getText("SELECTIONDETAILS_BUTTON_TEXT_WITH_NUMBER",[c]);o.setProperty("text",t,true);o.setProperty("enabled",true,true);}else{t=this._oRb.getText("SELECTIONDETAILS_BUTTON_TEXT");o.setProperty("text",t,true);o.setProperty("enabled",false,true);}};
b.prototype._onToolbarButtonPress=function(){sap.ui.require(['sap/m/NavContainer','sap/m/ResponsivePopover','sap/m/Page',"sap/m/Toolbar",'sap/m/OverflowToolbar','sap/m/ToolbarSpacer','sap/m/Button','sap/m/List','sap/m/StandardListItem','sap/ui/layout/FixFlex','sap/m/ScrollContainer',"sap/m/Title"],this._handlePressLazy.bind(this));};
b.prototype._handlePressLazy=function(N,R,P,T,O,c,B,L,d,F,e,f){var p=this._getPopover(N,R,T,c,P,L,F,e,f);if(this._oItemFactory){this._callFactory();}this.fireBeforeOpen();this._addMainListItems();this._addActionGroupListItems(d);this._addListActions(O,c,B);this._oNavContainer.setProperty("defaultTransitionName","show",true);this._oNavContainer.to(this._oInitialPage);this._oNavContainer.setProperty("defaultTransitionName","slide",true);p.openBy(this.getAggregation("_button"));p.invalidate();};
b.prototype._callFactory=function(){var f=this._oItemFactory.factory,d=this._oItemFactory.data,s=this._oSelectionData,r;this.fireEvent("beforeUpdate",{items:this.getItems()});this.destroyAggregation("items",true);for(var i=0;i<s.length;i++){r=f(s[i].displayData,s[i].data,s[i].context,d,s[i].shapeString);if(r){r._sMarkerShapeString=s[i].shapeString;this.addAggregation("items",r,true);}}this.fireEvent("afterUpdate",{items:this.getItems()});};
b.prototype._getInitialPage=function(P,T,c,d){if(!this._oInitialPage){this._oInitialPage=new P(this.getId()+"-page",{showHeader:false,enableScrolling:false});if(D.system.phone){this._oInitialPage.setProperty("showHeader",true,true);this._oInitialPage.setAggregation("customHeader",this._getPageToolbar(T,c,d),true);}}return this._oInitialPage;};
b.prototype._getNavContainer=function(N){return this._oNavContainer||(this._oNavContainer=new N(this.getId()+"-nav-container"));};
b.prototype._getPopover=function(N,R,T,c,P,L,F,d,e){var p=this.getAggregation("_popover"),n,o,m,A,M;if(!p){p=new R({id:this.getId()+"-popover",placement:l.PlacementType.Bottom,showHeader:false,contentWidth:"25rem",contentHeight:"500px",beforeClose:this.fireBeforeClose.bind(this)}).addStyleClass("sapMSD");p.setProperty=this._setPopoverProperty;o=this._getInitialPage(P,T,c,e);A=this._getActionGroupList(L);n=this._getNavContainer(N);M=this._getMainList(L);m=this._createMainContainer(F);m.setAggregation("flexContent",M,true);m.addAggregation("fixContent",A,true);o.addAggregation("content",m,true);n.addPage(o);p.addAggregation("content",n,true);if(!D.system.phone){p.addEventDelegate({onAfterRendering:this._updatePopoverContentHeight.bind(this)});}p.addEventDelegate({onBeforeRendering:function(){this.getWrapLabels()?p.addStyleClass("sapMSDWrapLabels"):p.removeStyleClass("sapMSDWrapLabels");}.bind(this)});this.setAggregation("_popover",p,true);}return p;};
b.prototype._setPopoverProperty=function(p,v){var P=this._oControl.getMetadata().getProperty(p);if(P&&p==="modal"&&this._oControl.setModal){this._oControl.setModal(v);}else{this._oControl.setProperty.apply(this._oControl,arguments);}return C.prototype.setProperty.apply(this,arguments);};
b.prototype._updatePopoverContentHeight=function(){var c=this._getInitialPageHeight(),p=this._getPopover();if(D.browser.edge&&this._oMainList.getDomRef()&&this._oMainList.getDomRef().getBoundingClientRect().height===0){p.setContentHeight(b._POPOVER_MAX_HEIGHT+"px");return;}if(this._oNavContainer.getCurrentPage()===this._oInitialPage&&c<b._POPOVER_MAX_HEIGHT){p.setProperty("contentHeight",c+"px",true);}else{p.setProperty("contentHeight",b._POPOVER_MAX_HEIGHT+"px",true);}};
b.prototype._getInitialPageHeight=function(){var f=this._oInitialPage&&this._oInitialPage.getFooter(),L=this._oMainList.$().outerHeight(),A=this._oActionGroupList.$().outerHeight(),t=f&&f.$().outerHeight()||0;return L+A+t;};
b.prototype._createMainContainer=function(F){return new F(this.getId()+"-mainContainer",{fixFirst:false,minFlexSize:-1});};
b.prototype._getMainList=function(L){if(!this._oMainList){this._oMainList=new L(this.getId()+"-list");}return this._oMainList;};
b.prototype._addMainListItems=function(){var i,c,L;this._oMainList.removeAllAggregation("items",true);c=this.getItems();for(i=0;i<c.length;i++){if(!c[i].hasListeners("_navigate")){c[i].attachEvent("_navigate",this._onNavigate,this);}if(!c[i].hasListeners("_actionPress")){c[i].attachEvent("_actionPress",this._onActionPress,this);}L=c[i]._getListItem();this._oMainList.addAggregation("items",L,true);}};
b.prototype._getActionGroupList=function(L){if(!this._oActionGroupList){this._oActionGroupList=new L(this.getId()+"-actionGroupList",{showNoData:false});}return this._oActionGroupList;};
b.prototype._addActionGroupListItems=function(c){this._oActionGroupList.destroyAggregation("items",true);var A=this.getActionGroups(),s,i,d=Math.min(b._MAX_ACTIONGROUPS,A.length);for(i=0;i<d;i++){s=new c(this.getId()+"-actionGroup-"+i,{title:A[i].getText(),type:l.ListType.Navigation,press:[{action:A[i],level:l.SelectionDetailsActionLevel.Group},this._onActionPress,this]});if(i===0){s.addStyleClass("sapMSDFirstActionGroup");}this._oActionGroupList.addAggregation("items",s,true);}};
b.prototype._addListActions=function(O,T,B){var o,i,A,c,t;this._oInitialPage.destroyAggregation("footer",true);if(!this.getActions().length){return;}t=new O(this.getId()+"-action-toolbar").addStyleClass("sapContrast sapContrastPlus");this._oInitialPage.setAggregation("footer",t,true);t.addAggregation("content",new T(),true);A=this.getActions();for(i=0;i<A.length;i++){c=A[i];o=new B(this.getId()+"-action-"+i,{text:c.getText(),enabled:c.getEnabled(),press:[{action:c,level:l.SelectionDetailsActionLevel.List},this._onActionPress,this]});t.addAggregation("content",o,true);}};
b.prototype._onActionPress=function(e,d){this.fireActionPress({action:d&&d.action||e.getParameter("action"),items:e.getParameter("items")||this.getItems(),level:d&&d.level||e.getParameter("level")});};
b.prototype._onNavigate=function(e){this._oItemForNavigation=e.getSource();this.fireNavigate({item:e.getSource(),direction:"to"});};
b.prototype._handleSelectionChange=function(e){var E=e.getParameter("data");if(q.type(E)==="array"){this._oSelectionData=E;this._updateButton();this.getAggregation("_button").rerender();}};
b.prototype.registerSelectionDetailsItemFactory=function(d,f){if(typeof(d)==="function"){f=d;d=undefined;}if(typeof f==="function"){this._oItemFactory={factory:f,data:d};}return this;};
b.prototype.attachSelectionHandler=function(e,c){if(this._oChangeHandler||q.type(e)!=="String"&&(q.type(c)!=="object"||q.type(c.attachEvent)!=="function")){return this;}else{this._oChangeHandler={eventId:e,listener:c};c.attachEvent(e,this._handleSelectionChange,this);}return this;};
b.prototype.detachSelectionHandler=function(){if(this._oChangeHandler){this._oChangeHandler.listener.detachEvent(this._oChangeHandler.eventId,this._handleSelectionChange,this);this._oChangeHandler=null;}return this;};
return b;});
sap.ui.predefine('sap/m/SelectionDetailsItem',["sap/ui/core/Element","sap/m/ListItemBase","./library","sap/m/Button","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/ui/base/Interface"],function(E,L,l,B,O,T,I){"use strict";
var S=L.extend("sap.m.SelectionDetailsListItem");
S.prototype.onBeforeRendering=function(){var t;if(this._getParentElement().getEnableNav()){t=l.ListType.Navigation;}else{t=l.ListType.Inactive;}this.setProperty("type",t,true);};
var a=E.extend("sap.m.SelectionDetailsItem",{metadata:{library:"sap.m",properties:{enableNav:{type:"boolean",defaultValue:false,group:"Behavior"}},aggregations:{lines:{type:"sap.m.SelectionDetailsItemLine",multiple:true,bindable:"bindable"},actions:{type:"sap.ui.core.Item",multiple:true},_overflowToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"}}}});
a.prototype.exit=function(){if(this._oListItem){this._oListItem.destroy();this._oListItem=null;}};
a.prototype._aFacadeMethods=["addCustomData","getCustomData","indexOfCustomData","insertCustomData","removeCustomData","removeAllCustomData","destroyCustomData","data","addEventDelegate","removeEventDelegate","setEnableNav","getEnableNav","addAction","removeAction"];
a.prototype.getFacade=function(){var f=new I(this,a.prototype._aFacadeMethods);this.getFacade=function(){return f;};return f;};
a.prototype._getListItem=function(){if(!this._oListItem){this._oListItem=new S({press:[this._onSelectionDetailsListItemPress,this]});this._oListItem._getParentElement=function(){return this;}.bind(this);this._addOverflowToolbar();}return this._oListItem;};
a.prototype._onSelectionDetailsListItemPress=function(){this.fireEvent("_navigate");};
a.prototype._addOverflowToolbar=function(){var b=this.getActions(),i,o;this.destroyAggregation("_overflowToolbar");if(b.length===0){return;}var t=new O(this.getId()+"-action-toolbar");this.setAggregation("_overflowToolbar",t,true);t.addAggregation("content",new T(),true);for(i=0;i<b.length;i++){o=new B(this.getId()+"-action-"+i,{text:b[i].getText(),type:l.ButtonType.Transparent,enabled:b[i].getEnabled(),press:[b[i],this._onActionPress,this]});t.addAggregation("content",o,true);}};
a.prototype._onActionPress=function(e,A){this.fireEvent("_actionPress",{action:A,items:[this],level:l.SelectionDetailsActionLevel.Item});};
return a;});
sap.ui.predefine('sap/m/SelectionDetailsItemLine',["sap/ui/core/Element","sap/base/Log","sap/base/util/isPlainObject","sap/ui/thirdparty/jquery"],function(E,L,i,q){"use strict";
var S=E.extend("sap.m.SelectionDetailsItemLine",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Data"},value:{type:"any",group:"Data"},displayValue:{type:"string",defaultValue:null,group:"Data"},unit:{type:"string",defaultValue:null,group:"Data"},lineMarker:{type:"string",defaultValue:null,group:"Data"}}}});
S.prototype._getValueToRender=function(){var v="",V=this.getValue();if(q.type(V)==="string"){v=V;}else if(q.type(V)==="number"){v=V.toString();}else if(i(V)){if(V.day&&V.day.length>0){v=V.day;}if(V.time&&V.time.length>0){v=(v.length>0)?V.time+" "+v:V.time;}}else{L.warning("Value '"+V+"' is not supported. Expected type is a string, number or a plain object, including date and time properties of type string.");}return v;};
return S;});
sap.ui.predefine('sap/m/SelectionDetailsListItemRenderer',["sap/ui/core/Renderer","sap/m/ListItemBaseRenderer"],function(R,L){"use strict";var T={"svg":{attributes:["width","height","focusable","preserveAspectRatio"]},"path":{attributes:["d","fill","transform","stroke","stroke-width"]},"line":{attributes:["x1","x2","y1","y2","stroke-width","stroke","stroke-dasharray","stroke-linecap"]}},I;try{var p=new DOMParser();I=p.parseFromString("<svg />","text/html")!==null;}catch(e){I=false;}var P;if(I){P=function(s){var p=new DOMParser(),d=p.parseFromString(s,"text/html");return d.body.childNodes;};}else{P=function(s){var d=document.implementation.createHTMLDocument("");d.body.innerHTML=s;return d.body.childNodes;};}
function a(d,c){var i;if(!d){return true;}for(i=0;i<d.length;i++){if(!c(d[i])){return false;}}return true;}
function b(n){if(n.nodeType!==window.Node.ELEMENT_NODE){return true;}var t=n.tagName.toLowerCase(),o=T[t],c;if(!o){return false;}c=a(n.attributes,function(d){if(d.value===""){return true;}var A=d.name.toLowerCase();return o.attributes.indexOf(A)>=0;});if(!c){return false;}if(!o.allowTextContenet&&n.textContent.trim().length>0){return false;}return a(n.childNodes,b);}
var S=R.extend(L);
S.renderLIAttributes=function(r,c){r.addClass("sapMSDItem");r.writeClasses();};
S.renderLIContent=function(r,c){var l=c._getParentElement().getLines();r.write("<div");r.addClass("sapMSDItemLines");r.writeClasses();r.write(">");for(var i=0;i<l.length;i++){this.renderLine(r,c,l[i]);}r.write("</div>");L.renderType(r,c);};
S._isValidSvg=function(d){try{var n=P(d);if(n.length===0){return false;}return a(n,b);}catch(e){return false;}};
S.renderLine=function(r,c,l){var u=l.getUnit().trim(),v=l._getValueToRender(),d=l.getDisplayValue(),s=l.getLineMarker();r.write("<div");r.addClass("sapMSDItemLine");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMSDItemLineMarkerContainer");r.writeClasses();r.write(">");if(s&&S._isValidSvg(s)){r.write(s);}r.write("</div>");r.write("<div");r.addClass("sapMSDItemLineLabel");r.writeClasses();r.write(">");r.writeEscaped(l.getLabel());r.write("</div>");r.write("<div");r.addClass("sapMSDItemLineValue");if(u){r.addClass("sapMSDItemLineBold");}r.writeClasses();r.write(">");if(d){r.writeEscaped(d);}else{r.writeEscaped(v);}if(u){r.write("<span");r.addClass("sapMSDItemLineUnit");r.writeClasses();r.write(">");r.write("&nbsp;");r.writeEscaped(u);r.write("</span>");}r.write("</div>");r.write("</div>");};
S.renderType=function(r,c){var t=c._getParentElement().getAggregation("_overflowToolbar");if(t){r.write("<div");r.addClass("sapMSDItemActions");r.writeClasses();r.write(">");r.renderControl(t);r.write("</div>");}};
return S;},true);
sap.ui.predefine('sap/m/SelectionDetailsRenderer',['sap/ui/core/Renderer','sap/m/ButtonRenderer'],function(R,B){"use strict";var S=R.extend(B);
S.render=function(r,c){var b=c.getAggregation("_button");r.write("<div");r.writeControlData(c);r.write(">");r.renderControl(b);r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/Shell',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/ShellRenderer',"sap/ui/util/Mobile","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,C,c,S,M,L,q){"use strict";var T=c.TitleLevel;
var a=C.extend("sap.m.Shell",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},logo:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},showLogout:{type:"boolean",group:"Behavior",defaultValue:true},headerRightText:{type:"string",group:"Data",defaultValue:null},appWidthLimited:{type:"boolean",group:"Appearance",defaultValue:true},backgroundColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},homeIcon:{type:"object",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:T.H1}},defaultAggregation:"app",aggregations:{app:{type:"sap.ui.core.Control",multiple:false}},events:{logout:{}}}});
a.prototype.init=function(){sap.ui.getCore().attachThemeChanged(q.proxy(function(){var $=this.$("hdr");if($.length){$.find(".sapMShellLogo").remove();var h=S.getLogoImageHtml(this);$.prepend(q(h));}},this));M.init({statusBar:"default",hideBrowser:true});};
a.prototype.onAfterRendering=function(){var r=this.getDomRef().parentNode,$;if(r&&!r._sapui5_heightFixed){r._sapui5_heightFixed=true;while(r&&r!==document.documentElement){$=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}}this.$("content").css("height","");};
a.prototype.ontap=function(e){if(e.target.className&&e.target.className.indexOf&&e.target.className.indexOf("sapMShellHeaderLogout")>-1){this.fireLogout();}};
a.prototype.setTitle=function(t){this.$("hdrTxt").text(t);this.setProperty("title",t,true);return this;};
a.prototype.setHeaderRightText=function(t){this.setProperty("headerRightText",t,true);if(!t){t="";}this.$("hdrRightTxt").text(t).css("display",(!!t?"inline":"none"));return this;};
a.prototype.setAppWidthLimited=function(b){this.$().toggleClass("sapMShellAppWidthLimited",b);this.setProperty("appWidthLimited",b,true);return this;};
a.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for Shell.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
a.prototype.setHomeIcon=function(i){this.setProperty("homeIcon",i,true);M.setIcons(i);return this;};
return a;});
sap.ui.predefine('sap/m/ShellRenderer',['sap/ui/core/library','sap/m/library','sap/ui/Device',"sap/base/security/encodeXML"],function(c,l,D,e){"use strict";var B=l.BackgroundHelper;var T=c.TitleLevel;var S={};
S.render=function(r,C){var t=(C.getTitleLevel()===T.Auto)?T.H1:C.getTitleLevel();r.write("<div");r.writeControlData(C);r.addClass("sapMShell");if(C.getAppWidthLimited()){r.addClass("sapMShellAppWidthLimited");}B.addBackgroundColorStyles(r,C.getBackgroundColor(),C.getBackgroundImage(),"sapMShellGlobalOuterBackground");r.writeClasses();r.writeStyles();var s=C.getTooltip_AsString();if(s){r.writeAttributeEscaped("title",s);}r.write(">");B.renderBackgroundImageTag(r,C,["sapContrastPlus","sapMShellBG","sapUiGlobalBackgroundImageForce"],C.getBackgroundImage(),C.getBackgroundRepeat(),C.getBackgroundOpacity());r.write("<div class='sapMShellBrandingBar'></div>");r.write("<div class='sapMShellCentralBox'>");var a="",b="";if(!C.getBackgroundImage()){a="sapMShellBackgroundColorOnlyIfDefault";b="sapUiGlobalBackgroundImageOnlyIfDefault";}r.write("<header class='sapMShellHeader "+a+"' id='"+C.getId()+"-hdr'>");r.write("<div class='"+b+"'></div>");r.write(S.getLogoImageHtml(C));if(C.getTitle()){r.write("<"+t);r.write(" id='"+C.getId()+"-hdrTxt' class='sapMShellHeaderText'>");r.writeEscaped(C.getTitle());r.write("</"+t+">");}r.write("<span class='sapMShellHeaderRight'>");r.write("<span id='"+C.getId()+"-hdrRightTxt' ");if(!C.getHeaderRightText()){r.writeAttribute("style","display:none;");}r.write("class='sapMShellHeaderRightText'>"+e(C.getHeaderRightText())+"</span>");if(C.getShowLogout()){var d=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.write("<a id='"+C.getId()+"-logout' tabindex='0' role='button' class='sapMShellHeaderLogout'>"+d.getText("SHELL_LOGOUT")+"</a>");}r.write("</span></header>");r.write("<div class='sapMShellContent sapMShellGlobalInnerBackground' id='"+C.getId()+"-content' data-sap-ui-root-content='true'>");r.renderControl(C.getApp());r.write("</div></div></div>");};
S.getLogoImageHtml=function(C){var i=C.getLogo();if(!i){jQuery.sap.require("sap.ui.core.theming.Parameters");i=sap.ui.core.theming.Parameters._getThemeImage();}var r="";if(i){var R=sap.ui.getCore().getLibraryResourceBundle("sap.m");r="<div class='sapMShellLogo'>";if(D.browser.msie){r+="<span class='sapMShellLogoImgAligner'></span>";}r+="<img id='"+C.getId()+"-logo' class='sapMShellLogoImg' src='";r+=e(i);r+="' alt='";r+=R.getText("SHELL_ARIA_LOGO");r+="' /></div>";}return r;};
return S;},true);
sap.ui.predefine('sap/m/SimpleFixFlex',['sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/base/Log','./SimpleFixFlexRenderer'],function(C,R,L){"use strict";
var S=C.extend("sap.m.SimpleFixFlex",{metadata:{library:"sap.m",aggregations:{fixContent:{type:"sap.ui.core.Control",multiple:false},flexContent:{type:"sap.ui.core.Control",multiple:true}},properties:{fitParent:{type:"boolean",group:"Appearance",defaultValue:true}}}});
S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION=200;S.FIX_AREA_CHARACTERS_ABOVE_RECOMMENDED_WARNING="It is recommended to use less than "+S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION+" characters as a value state text.";
S.prototype.onBeforeRendering=function(){this._deregisterFixContentResizeHandler();var f=this.getFixContent();if(f&&f.isA("sap.m.Text")&&f.getText().length>S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION){L.warning(S.FIX_AREA_CHARACTERS_ABOVE_RECOMMENDED_WARNING,"",this.getId());}};
S.prototype.onAfterRendering=function(){if(this.getFitParent()){this._registerFixContentResizeHandler();}};
S.prototype._registerFixContentResizeHandler=function(){var f=this.getFixContent();if(!this._sResizeListenerId&&f&&f.getDomRef()){this._sResizeListenerId=R.register(f.getDomRef(),this._onFixContentResize.bind(this));this._onFixContentResize();}};
S.prototype._deregisterFixContentResizeHandler=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
S.prototype._onFixContentResize=function(){var $=this.$(),a=this.getFixContent().$(),f=a.get(0);if(!f){return;}$.css("padding-top",f.clientHeight);a.addClass("sapUiSimpleFixFlexFixedWrap");};
S.prototype.exit=function(){this._deregisterFixContentResizeHandler();};
return S;});
sap.ui.predefine('sap/m/SimpleFixFlexRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){var f=c.getFixContent();r.write('<div');r.addClass('sapUiSimpleFixFlex');r.writeControlData(c);r.writeClasses();r.write('>');if(f){r.renderControl(f.addStyleClass('sapUiSimpleFixFlexFixed'));}this.renderFlexContentContainer(r,c);r.write('</div>');};
S.renderFlexContentContainer=function(r,c){var f=c.getFlexContent();r.write('<div');r.addClass('sapUiSimpleFixFlexFlexContentContainer');r.writeClasses();r.write('>');if(f){r.write('<div');r.addClass('sapUiSimpleFixFlexFlexContent');r.writeClasses();r.write('>');f.forEach(function(c){r.renderControl(c);});r.write('</div>');}r.write('</div>');};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendar',['./library','./PlanningCalendarHeader','./SegmentedButtonItem',"./SinglePlanningCalendarWeekView",'./SinglePlanningCalendarGrid','./SinglePlanningCalendarMonthGrid','./SinglePlanningCalendarRenderer','sap/base/Log','sap/ui/core/Control','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/format/DateFormat','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/DateRange','sap/ui/base/ManagedObjectObserver',"sap/ui/thirdparty/jquery"],function(l,P,S,a,b,c,d,L,C,I,R,D,e,f,M,q){"use strict";var g=l.PlanningCalendarStickyMode;var H="_sHeaderResizeHandlerId";var h=4;var j="--item";
var k=C.extend("sap.m.SinglePlanningCalendar",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:""},startDate:{type:"object",group:"Data"},startHour:{type:"int",group:"Data",defaultValue:0},endHour:{type:"int",group:"Data",defaultValue:24},fullDay:{type:"boolean",group:"Data",defaultValue:true},stickyMode:{type:"sap.m.PlanningCalendarStickyMode",group:"Behavior",defaultValue:g.None},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action",forwarding:{getter:"_getHeader",aggregation:"actions"}},appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",forwarding:{getter:"_getCurrentGrid",aggregation:"appointments"}},views:{type:"sap.m.SinglePlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate",forwarding:{getter:"_getCurrentGrid",aggregation:"specialDates"}},_header:{type:"sap.m.PlanningCalendarHeader",multiple:false,visibility:"hidden"},_grid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_mvgrid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedView:{type:"sap.m.SinglePlanningCalendarView",multiple:false},legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},headerDateSelect:{parameters:{date:{type:"object"}}},startDateChange:{parameters:{date:{type:"object"}}},cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},moreLinkPress:{parameters:{date:{type:"object"}}},viewChange:{}}}});
k.prototype.init=function(){var o=this.getId();this._oRB=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oDefaultView=new a({key:"DEFAULT_INNER_WEEK_VIEW_CREATED_FROM_CONTROL",title:""});this.setAssociation("selectedView",this._oDefaultView);this.setAggregation("_header",this._createHeader());this.setAggregation("_grid",new b(o+"-Grid"));this.setAggregation("_mvgrid",new c(o+"-GridMV"));this._attachHeaderEvents();this._attachGridEvents();this._attachDelegates();this.setStartDate(new Date());};
k.prototype.onBeforeRendering=function(){this._toggleStickyClasses();};
k.prototype.onAfterRendering=function(){var o=this._getHeader();this._adjustColumnHeadersTopOffset();this.toggleStyleClass("sapMSinglePCActionsHidden",!o._getActionsToolbar().getVisible());this._registerResizeHandler(H,o,this._onHeaderResize.bind(this));};
k.prototype.exit=function(){if(this._oDefaultView){this._oDefaultView.destroy();this._oDefaultView=null;}if(this._afterRenderFocusCell){this.removeDelegate(this._afterRenderFocusCell);this._afterRenderFocusCell=null;}this._deRegisterResizeHandler(H);};
k.prototype._onHeaderResize=function(E){if(E.oldSize.height===E.size.height){return this;}this.toggleStyleClass("sapMSinglePCActionsHidden",!this._getHeader()._getActionsToolbar().getVisible());this._adjustColumnHeadersTopOffset();return this;};
k.prototype.setTitle=function(t){this._getHeader().setTitle(t);return this.setProperty("title",t);};
k.prototype.setStartDate=function(o){this.setProperty("startDate",o);this._alignColumns();return this;};
k.prototype.setStartHour=function(i){this.getAggregation("_grid").setStartHour(i);this.setProperty("startHour",i);return this;};
k.prototype.setEndHour=function(i){this.getAggregation("_grid").setEndHour(i);this.setProperty("endHour",i);return this;};
k.prototype.setFullDay=function(F){this.getAggregation("_grid").setFullDay(F);this.setProperty("fullDay",F);return this;};
k.prototype.setEnableAppointmentsDragAndDrop=function(E){this.getAggregation("_grid").setEnableAppointmentsDragAndDrop(E);this.getAggregation("_mvgrid").setEnableAppointmentsDragAndDrop(E);return this.setProperty("enableAppointmentsDragAndDrop",E,true);};
k.prototype.setEnableAppointmentsResize=function(E){this.getAggregation("_grid").setEnableAppointmentsResize(E);return this.setProperty("enableAppointmentsResize",E,true);};
k.prototype.setEnableAppointmentsCreate=function(E){this.getAggregation("_grid").setEnableAppointmentsCreate(E);return this.setProperty("enableAppointmentsCreate",E,true);};
k.prototype._toggleStickyClasses=function(){var s=this.getStickyMode();this.toggleStyleClass("sapMSinglePCStickyAll",s===g.All);this.toggleStyleClass("sapMSinglePCStickyNavBarAndColHeaders",s===g.NavBarAndColHeaders);return this;};
k.prototype._adjustColumnHeadersTopOffset=function(){var s=this.getStickyMode(),G=this.getAggregation("_grid"),o=G&&G._getColumnHeaders(),t;if(!o||!o.getDomRef()){return this;}switch(s){case g.All:t=this._getHeader().$().outerHeight();break;case g.NavBarAndColHeaders:t=this._getHeader()._getNavigationToolbar().$().outerHeight();break;default:t="auto";break;}o.$().css("top",t);o._setTopPosition(t);return this;};
k.prototype.addView=function(v){var V,o=this._getHeader(),s=v.getId()+j,i;if(!v){return this;}if(this._isViewKeyExisting(v.getKey())){L.error("There is an existing view with the same key.",this);return this;}this.addAggregation("views",v);V=o._getOrCreateViewSwitch();i=new S(s,{key:v.getKey(),text:v.getTitle()});V.addItem(i);this._observeViewTitle(v);if(this._getSelectedView().getKey()===this._oDefaultView.getKey()){this.setAssociation("selectedView",v);}this._alignView();if(this.getViews().length>h){o._convertViewSwitchToSelect();}return this;};
k.prototype.insertView=function(v,p){var V,o=this._getHeader(),s=v.getId()+j,i;if(!v){return this;}if(this._isViewKeyExisting(v.getKey())){L.error("There is an existing view with the same key.",this);return this;}this.insertAggregation("views",v,p);V=o._getOrCreateViewSwitch();i=new S(s,{key:v.getKey(),text:v.getTitle()});V.insertItem(i,p);this._observeViewTitle(v);if(this._getSelectedView().getKey()===this._oDefaultView.getKey()){this.setAssociation("selectedView",v);}this._alignView();if(this.getViews().length>h){o._convertViewSwitchToSelect();}return this;};
k.prototype.removeView=function(v){if(!v){return this;}var o=this._getHeader(),V=o._getOrCreateViewSwitch(),m=V.getItems(),n=this._getSelectedView(),p=v.getKey(),r,i;if(this.getViews().length===1){this._disconnectAndDestroyViewsObserver();}else{this._oViewsObserver.unobserve(v,{properties:["title"]});}for(i=0;i<m.length;i++){r=m[i];if(r.getKey()===p){V.removeItem(r);break;}}this.removeAggregation("views",v);if(p===n.getKey()){this.setAssociation("selectedView",this.getViews()[0]||this._oDefaultView);}this._alignView();if(this.getViews().length<=h){o._convertViewSwitchToSegmentedButton();}return this;};
k.prototype.removeAllViews=function(){var v=this._getHeader()._getOrCreateViewSwitch();this._disconnectAndDestroyViewsObserver();v.removeAllItems();this.setAssociation("selectedView",this._oDefaultView);this._alignView();return this.removeAllAggregation("views");};
k.prototype.destroyViews=function(){var v=this._getHeader()._getOrCreateViewSwitch();this._disconnectAndDestroyViewsObserver();v.destroyItems();this.setAssociation("selectedView",this._oDefaultView);this._alignView();return this.destroyAggregation("views");};
k.prototype._viewsObserverCallbackFunction=function(o){sap.ui.getCore().byId(o.object.getId()+j).setText(o.current);};
k.prototype._getViewsObserver=function(){if(!this._oViewsObserver){this._oViewsObserver=new M(this._viewsObserverCallbackFunction);}return this._oViewsObserver;};
k.prototype._observeViewTitle=function(v){this._getViewsObserver().observe(v,{properties:["title"]});};
k.prototype._disconnectAndDestroyViewsObserver=function(){if(this._oViewsObserver){this._oViewsObserver.disconnect();this._oViewsObserver.destroy();this._oViewsObserver=null;}};
k.prototype.setSelectedView=function(v){var p=this._getCurrentGrid();this.setAssociation("selectedView",v);this._transferAggregations(p);this._alignColumns();this._adjustColumnHeadersTopOffset();this._getHeader()._getOrCreateViewSwitch().setSelectedKey(v.getKey());return this;};
k.prototype.getSelectedAppointments=function(){return this.getAggregation("_grid").getSelectedAppointments();};
k.prototype.setLegend=function(v){var o,s,i;this.setAssociation("legend",v);this.getAggregation("_grid").setAssociation("legend",v);this.getAggregation("_mvgrid").setAssociation("legend",v);s=this.getLegend();if(s){this.getAggregation("_grid")._sLegendId=s;this.getAggregation("_mvgrid")._sLegendId=s;i=sap.ui.getCore().byId(s);}if(i){o=new M(function(m){this.invalidate();}.bind(this));o.observe(i,{destroy:true});}return this;};
k.prototype._alignView=function(){this._switchViewButtonVisibility();this._alignColumns();return this;};
k.prototype._createHeader=function(){var o=new P(this.getId()+"-Header");o.getAggregation("_actionsToolbar").addAriaLabelledBy(I.getStaticId("sap.m","SPC_ACTIONS_TOOLBAR"));o.getAggregation("_navigationToolbar").addAriaLabelledBy(I.getStaticId("sap.m","SPC_NAVIGATION_TOOLBAR"));return o;};
k.prototype._isViewKeyExisting=function(K){return this.getViews().some(function(v){return v.getKey()===K;});};
k.prototype._getSelectedView=function(){var s,v=this.getViews(),m=sap.ui.getCore().byId(this.getAssociation("selectedView")).getKey();for(var i=0;i<v.length;i++){if(m===v[i].getKey()){s=v[i];break;}}return s||this._oDefaultView;};
k.prototype._switchViewButtonVisibility=function(){var s=this._getHeader()._getOrCreateViewSwitch(),v=s.getItems().length>1;s.setProperty("visible",v);return this;};
k.prototype._attachHeaderEvents=function(){var o=this._getHeader();o.attachEvent("viewChange",this._handleViewChange,this);o.attachEvent("pressPrevious",this._handlePressArrow,this);o.attachEvent("pressToday",this._handlePressToday,this);o.attachEvent("pressNext",this._handlePressArrow,this);o.attachEvent("dateSelect",this._handleCalendarPickerDateSelect,this);o._getOrCreateViewSwitch().attachEvent("selectionChange",this._handleViewSwitchChange,this);return this;};
k.prototype._attachDelegates=function(){this._afterRenderFocusCell={onAfterRendering:function(){if(this._sGridCellFocusSelector){q(this._sGridCellFocusSelector).focus();this._sGridCellFocusSelector=null;}}.bind(this)};this.getAggregation("_grid").addDelegate(this._afterRenderFocusCell);this.getAggregation("_mvgrid").addDelegate(this._afterRenderFocusCell);};
k.prototype._attachGridEvents=function(){var G=this.getAggregation("_grid"),o=this.getAggregation("_mvgrid");var i=function(E){this.fireHeaderDateSelect({date:E.getSource().getDate()});};var m=function(E){this.fireAppointmentSelect({appointment:E.getParameter("appointment"),appointments:E.getParameter("appointments")});};var n=function(E){this.fireAppointmentDrop({appointment:E.getParameter("appointment"),startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate"),copy:E.getParameter("copy")});};var p=function(E){this.fireAppointmentResize({appointment:E.getParameter("appointment"),startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var r=function(E){this.fireAppointmentCreate({startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var s=function(E){this.fireEvent("cellPress",{startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var t=function(E){this.fireEvent("moreLinkPress",{date:E.getParameter("date")});};var u=function(E){var G=this.getAggregation("_grid"),F=G._getDateFormatter(),N=this._getSelectedView().getScrollEntityCount()-G._getColumns()+1,w=new Date(E.getParameter("startDate")),x=E.getParameter("fullDay"),y=this.getStartDate();if(E.getParameter("next")){w.setDate(w.getDate()+N);y=new Date(y.setDate(y.getDate()+this._getSelectedView().getScrollEntityCount()));this.setStartDate(y);}else{w.setDate(w.getDate()-N);y=new Date(y.setDate(y.getDate()-this._getSelectedView().getScrollEntityCount()));this.setStartDate(y);}this._sGridCellFocusSelector=x?"[data-sap-start-date='"+F.format(w)+"'].sapMSinglePCBlockersColumn":"[data-sap-start-date='"+F.format(w)+"'].sapMSinglePCRow";};var v=function(E){var w=new Date(E.getParameter("startDate")),x=e.fromLocalJSDate(w),N;x.setDate(x.getDate()+E.getParameter("offset"));N=x.toLocalJSDate();this.setStartDate(N);this._sGridCellFocusSelector="[sap-ui-date='"+x.valueOf()+"'].sapMSPCMonthDay";};G._getColumnHeaders().attachEvent("select",i,this);G.attachEvent("appointmentSelect",m,this);o.attachEvent("appointmentSelect",m,this);G.attachEvent("appointmentDrop",n,this);o.attachEvent("appointmentDrop",n,this);G.attachEvent("appointmentResize",p,this);G.attachEvent("appointmentCreate",r,this);G.attachEvent("cellPress",s,this);o.attachEvent("cellPress",s,this);o.attachEvent("moreLinkPress",t,this);G.attachEvent("borderReached",u,this);o.attachEvent("borderReached",v,this);return this;};
k.prototype._handleViewChange=function(){this.fireViewChange();};
k.prototype._handlePressArrow=function(E){this._applyArrowsLogic(E.getId()==="pressPrevious");this._adjustColumnHeadersTopOffset();};
k.prototype._handlePressToday=function(){var s=this._getSelectedView().calculateStartDate(new Date());this.setStartDate(s);this.fireStartDateChange({date:s});this._adjustColumnHeadersTopOffset();};
k.prototype._handleViewSwitchChange=function(E){var p=this._getCurrentGrid();this.setAssociation("selectedView",E.getParameter("item"));this._transferAggregations(p);this._alignColumns();this._adjustColumnHeadersTopOffset();};
k.prototype._transferAggregations=function(p){var n=this._getCurrentGrid(),A,s,i;if(p.getId()!==n.getId()){A=p.removeAllAggregation("appointments",true);for(i=0;i<A.length;i++){n.addAggregation("appointments",A[i],true);}s=p.removeAllAggregation("specialDates",true);for(i=0;i<s.length;i++){n.addAggregation("specialDates",s[i],true);}}};
k.prototype._handleCalendarPickerDateSelect=function(){var s=this._getHeader().getStartDate(),o;o=this._getSelectedView().calculateStartDate(new Date(s.getTime()));this.setStartDate(o);if(!this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){this.getAggregation("_grid")._getColumnHeaders().setDate(s);}this.fireStartDateChange({date:o});this._adjustColumnHeadersTopOffset();};
k.prototype._updateCalendarPickerSelection=function(){var r=this._getFirstAndLastRangeDate(),s;s=new f({startDate:r.oStartDate.toLocalJSDate(),endDate:r.oEndDate.toLocalJSDate()});this._getHeader().getAggregation("_calendarPicker").removeAllSelectedDates();this._getHeader().getAggregation("_calendarPicker").addSelectedDate(s);};
k.prototype._formatPickerText=function(){var r=this._getFirstAndLastRangeDate(),s=r.oStartDate.toLocalJSDate(),E=r.oEndDate.toLocalJSDate(),o=D.getDateInstance({format:"yMMMMd"}),i=o.format(s);if(s.getTime()!==E.getTime()){i+=" - "+o.format(E);}return i;};
k.prototype._applyArrowsLogic=function(B){var o=e.fromLocalJSDate(this.getStartDate()||new Date()),O=B?-1:1,n=this._getSelectedView().getScrollEntityCount(this.getStartDate(),O),s;if(B){n*=-1;}o.setDate(o.getDate()+n);s=o.toLocalJSDate();this.setStartDate(s);this.fireStartDateChange({date:s});};
k.prototype._getFirstAndLastRangeDate=function(){var s=this._getSelectedView(),o=this._getHeader().getStartDate()||new Date(),i=s.getEntityCount()-1,m,n;m=e.fromLocalJSDate(s.calculateStartDate(new Date(o.getTime())));n=new e(m);n.setDate(m.getDate()+i);return{oStartDate:m,oEndDate:n};};
k.prototype._alignColumns=function(){var o=this._getHeader(),G=this.getAggregation("_grid"),i=this.getAggregation("_mvgrid"),v=this._getSelectedView(),m=this.getStartDate()||new Date(),V=v.calculateStartDate(new Date(m.getTime())),n=e.fromLocalJSDate(V);o.setStartDate(V);o.setPickerText(this._formatPickerText(n));this._updateCalendarPickerSelection();G.setStartDate(V);i.setStartDate(V);G._setColumns(v.getEntityCount());this._setColumnHeaderVisibility();};
k.prototype._setColumnHeaderVisibility=function(){var v;if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){return;}v=!this._getSelectedView().isA("sap.m.SinglePlanningCalendarDayView");this.getAggregation("_grid")._getColumnHeaders().setVisible(v);this.toggleStyleClass("sapMSinglePCHiddenColHeaders",!v);};
k.prototype._getHeader=function(){return this.getAggregation("_header");};
k.prototype._getCurrentGrid=function(){if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){return this.getAggregation("_mvgrid");}else{return this.getAggregation("_grid");}};
k.prototype._registerResizeHandler=function(s,o,i){if(!this[s]){this[s]=R.register(o,i);}return this;};
k.prototype._deRegisterResizeHandler=function(s){if(this[s]){R.deregister(this[s]);this[s]=null;}return this;};
return k;});
sap.ui.predefine('sap/m/SinglePlanningCalendarDayView',['./library','./SinglePlanningCalendarView'],function(l,S){"use strict";
var a=S.extend("sap.m.SinglePlanningCalendarDayView",{metadata:{library:"sap.m"}});
a.prototype.getEntityCount=function(){return 1;};
a.prototype.getScrollEntityCount=function(){return 1;};
a.prototype.calculateStartDate=function(s){return s;};
return a;});
sap.ui.predefine('sap/m/SinglePlanningCalendarGrid',['./SinglePlanningCalendarUtilities','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/Locale','sap/ui/core/InvisibleText','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate','sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo','sap/ui/core/dnd/DragDropInfo','sap/ui/unified/library','sap/ui/unified/CalendarAppointment','sap/ui/unified/calendar/DatesRow','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/events/KeyCodes','./SinglePlanningCalendarGridRenderer','sap/ui/Device','sap/ui/core/delegate/ItemNavigation',"sap/ui/thirdparty/jquery",'./PlanningCalendarLegend'],function(S,C,L,a,I,D,U,b,c,d,u,e,f,g,h,K,k,l,m,q,P){"use strict";var R=69,n=48,B=34,o=25,H=3600000/2,O=60*1000,M=86400000,p=7,F=0,r=24;
var s=C.extend("sap.m.SinglePlanningCalendarGrid",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},startHour:{type:"int",group:"Data",defaultValue:0},endHour:{type:"int",group:"Data",defaultValue:24},fullDay:{type:"boolean",group:"Data",defaultValue:true},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},_columnHeaders:{type:"sap.ui.unified.calendar.DatesRow",multiple:false,visibility:"hidden"},_intervalPlaceholders:{type:"sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}},_blockersPlaceholders:{type:"sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true,associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}}}}});
s.prototype.init=function(){var i=new Date(),j=new f(this.getId()+"-columnHeaders",{showDayNamesLine:false,showWeekNumbers:false,startDate:i}).addStyleClass("sapMSinglePCColumnHeader"),w=(60-i.getSeconds())*1000,T=this._getCoreLocaleData().getTimePattern("medium");this.setAggregation("_columnHeaders",j);this.setStartDate(i);this._setColumns(7);this._configureBlockersDragAndDrop();this._configureAppointmentsDragAndDrop();this._configureAppointmentsResize();this._configureAppointmentsCreate();this._oUnifiedRB=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");this._oFormatStartEndInfoAria=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY 'at' "+T});this._oFormatAriaFullDayCell=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY"});this._sLegendId=undefined;setTimeout(this._updateRowHeaderAndNowMarker.bind(this),w);};
s.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
s.prototype.onBeforeRendering=function(){var A=this._createAppointmentsMap(this.getAppointments()),i=this.getStartDate(),j=g.fromLocalJSDate(i),w=this._getColumns();this._oVisibleAppointments=this._calculateVisibleAppointments(A.appointments,this.getStartDate(),w);this._oAppointmentsToRender=this._calculateAppointmentsLevelsAndWidth(this._oVisibleAppointments);this._aVisibleBlockers=this._calculateVisibleBlockers(A.blockers,j,w);this._oBlockersToRender=this._calculateBlockersLevelsAndWidth(this._aVisibleBlockers);if(this._iOldColumns!==w||this._oOldStartDate!==i){this._createBlockersDndPlaceholders(i,w);this._createAppointmentsDndPlaceholders(i,w);}};
s.prototype.onmousedown=function(E){var i=E.target.classList;this._isResizeHandleBottomMouseDownTarget=i.contains("sapMSinglePCAppResizeHandleBottom");this._isResizeHandleTopMouseDownTarget=i.contains("sapMSinglePCAppResizeHandleTop");};
s.prototype._isResizingPerformed=function(){return this._isResizeHandleBottomMouseDownTarget||this._isResizeHandleTopMouseDownTarget;};
s.prototype._configureBlockersDragAndDrop=function(){this.addDragDropConfig(new d({sourceAggregation:"appointments",targetAggregation:"_blockersPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()){E.preventDefault();return false;}var i=function(){var $=q(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");});};i();}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),x=function(){var $=q(i.getIndicator()),y=A.$().outerHeight(),z=A.$().outerWidth(),G=j.$().closest(".sapMSinglePCBlockersColumns").get(0).getBoundingClientRect(),J=j.getDomRef().getBoundingClientRect(),N=(J.left+z)-(G.left+G.width);if(w){$.css("min-height",y);$.css("min-width",Math.min(z,z-N));}else{$.css("min-height",i.getDropControl().$().outerHeight());$.css("min-width",i.getDropControl().$().outerWidth());}};if(!i.getIndicator()){setTimeout(x,0);}else{x();}}.bind(this),drop:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=j.getDate().getJSDate(),x,y=E.getParameter("browserEvent"),z=(y.metaKey||y.ctrlKey),G=this.isAllDayAppointment(A.getStartDate(),A.getEndDate());x=new Date(w);if(G){x.setMilliseconds(A.getEndDate().getTime()-A.getStartDate().getTime());}this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(G&&A.getStartDate().getTime()===w.getTime()){return;}this.fireAppointmentDrop({appointment:A,startDate:w,endDate:x,copy:z});}.bind(this)}));};
s.prototype._configureAppointmentsDragAndDrop=function(){this.addDragDropConfig(new d({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()||this._isResizingPerformed()){E.preventDefault();return false;}var i=function(){var $=q(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");});};i();}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),x=function(){var $=q(i.getIndicator()),y=A.$().outerHeight(),G=j.$().closest(".sapMSinglePCColumn").get(0).getBoundingClientRect(),z=i.getDropControl().getDomRef().getBoundingClientRect(),J=(z.top+y)-(G.top+G.height);if(w){$.css("min-height",2*i.getDropControl().$().outerHeight());}else{$.css("min-height",Math.min(y,y-J));}};if(!i.getIndicator()){setTimeout(x,0);}else{x();}}.bind(this),drop:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=j.getDate().getJSDate(),x,y=E.getParameter("browserEvent"),z=(y.metaKey||y.ctrlKey),G=this.isAllDayAppointment(A.getStartDate(),A.getEndDate());x=new Date(w);if(G){x.setHours(x.getHours()+1);}else{x.setMilliseconds(A.getEndDate().getTime()-A.getStartDate().getTime());}this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(!G&&A.getStartDate().getTime()===w.getTime()){return;}this.fireAppointmentDrop({appointment:A,startDate:w,endDate:x,copy:z});}.bind(this)}));};
s.prototype._configureAppointmentsResize=function(){var i=new d({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsResize()||!this._isResizingPerformed()){E.preventDefault();return;}var j=E.getParameter("dragSession"),$=this.$().find(".sapMSinglePCOverlay"),w=q(j.getIndicator()),x=j.getDragControl().$();if(this._isResizeHandleBottomMouseDownTarget){j.setData("bottomHandle","true");}if(this._isResizeHandleTopMouseDownTarget){j.setData("topHandle","true");}w.addClass("sapUiDnDIndicatorHide");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");},0);q(document).one("dragend",function(){var A=j.getComplexData("appointmentStartingBoundaries");$.removeClass("sapMSinglePCOverlayDragging");w.removeClass("sapUiDnDIndicatorHide");x.css({top:A.top,height:A.height,"z-index":"auto",opacity:1});});if(!l.browser.msie&&!l.browser.edge){E.getParameter("browserEvent").dataTransfer.setDragImage(t(),0,0);}}.bind(this),dragEnter:function(E){var j=E.getParameter("dragSession"),A=j.getDragControl().$().get(0),w=j.getDropControl().getDomRef(),x=j.getComplexData("appointmentStartingBoundaries"),y=function(){var $=q(j.getIndicator());$.addClass("sapUiDnDIndicatorHide");},T,z,G,V,J;if(!x){x={top:A.offsetTop,bottom:A.offsetTop+A.getBoundingClientRect().height,height:A.getBoundingClientRect().height};j.setComplexData("appointmentStartingBoundaries",x);}V=j.getData("bottomHandle")?x.top:x.bottom;T=Math.min(V,w.offsetTop);z=Math.max(V,w.offsetTop+w.getBoundingClientRect().height);G=z-T;J={top:T,height:G,"z-index":1,opacity:0.8};j.getDragControl().$().css(J);if(!j.getIndicator()){setTimeout(y,0);}else{y();}},drop:function(E){var j=E.getParameter("dragSession"),A=j.getDragControl(),w=this.indexOfAggregation("_intervalPlaceholders",j.getDropControl()),x=j.getComplexData("appointmentStartingBoundaries"),y;y=this._calcResizeNewHoursAppPos(A.getStartDate(),A.getEndDate(),w,j.getData("bottomHandle"));this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");q(j.getIndicator()).removeClass("sapUiDnDIndicatorHide");A.$().css({top:x.top,height:x.height,"z-index":"auto",opacity:1});if(A.getEndDate().getTime()===y.endDate.getTime()&&A.getStartDate().getTime()===y.startDate.getTime()){return;}this.fireAppointmentResize({appointment:A,startDate:y.startDate,endDate:y.endDate});}.bind(this)});this.addDragDropConfig(i);};
s.prototype._configureAppointmentsCreate=function(){this.addDragDropConfig(new d({targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsCreate()){E.preventDefault();return;}var $=this.$().find(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");q(".sapUiAppCreate").remove();q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");});if(!l.browser.msie&&!l.browser.edge){E.getParameter("browserEvent").dataTransfer.setDragImage(t(),0,0);}}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),j=i.getDropControl(),w=j.getDomRef(),x=w.offsetHeight,y=w.offsetTop,z=y,A=w.getBoundingClientRect().left,G=A,J=j.$().parents(".sapMSinglePCColumn").get(0),$=q(".sapUiAppCreate");if(!$.get(0)){$=q("<div></div>").addClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");$.appendTo(J);}q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");if(!i.getComplexData("startingRectsDropArea")){i.setComplexData("startingRectsDropArea",{top:y,left:A});i.setComplexData("startingDropDate",j.getDate());}else{z=i.getComplexData("startingRectsDropArea").top;G=i.getComplexData("startingRectsDropArea").left;}if(A!==G){E.preventDefault();return false;}j.$().closest(".sapMSinglePCColumn").find(".sapMSinglePCAppointments").addClass("sapUiDnDDragging");$.css({top:Math.min(z,y)+2,height:Math.abs(z-y)+x-4,left:3,right:3,"z-index":2});i.setIndicatorConfig({display:"none"});},drop:function(E){var i=E.getParameter("dragSession"),j=i.getDropControl(),T=30*60*1000,w=i.getComplexData("startingDropDate").getTime(),x=j.getDate().getJSDate().getTime(),y=Math.min(w,x),z=Math.max(w,x)+T;this.fireAppointmentCreate({startDate:new Date(y),endDate:new Date(z)});q(".sapUiAppCreate").remove();q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");}.bind(this)}));};
s.prototype._calcResizeNewHoursAppPos=function(A,i,j,w){var x=new Date(this.getStartDate().getFullYear(),this.getStartDate().getMonth(),this.getStartDate().getDate()),y=30*60*1000,z=x.getTime()+j*y,E=z+y,V=w?A.getTime():i.getTime(),G=Math.min(V,z),J=Math.max(V,E);return{startDate:new Date(G),endDate:new Date(J)};};
s.prototype._adjustAppointmentsHeightforCompact=function(i,j,w){var A,$,x,y,z,E,G,J,N=this._getRowHeight(),Q=this;if(this._oAppointmentsToRender[i]){this._oAppointmentsToRender[i].oAppointmentsList.getIterator().forEach(function(T){A=T.getData();$=q("div[data-sap-day='"+i+"'].sapMSinglePCColumn #"+A.getId());x=A.getStartDate();y=A.getEndDate();G=j.getTime()>x.getTime();J=w.getTime()<y.getTime();z=G?0:Q._calculateTopPosition(x);E=J?0:Q._calculateBottomPosition(y);$.css("top",z);$.css("bottom",E);$.find(".sapUiCalendarApp").css("min-height",N/2-3);});}};
s.prototype._adjustBlockersHeightforCompact=function(){var i=this._getBlockersToRender().iMaxlevel,j=(i+1)*this._getBlockerRowHeight(),w=this._getColumns()===1?j+p:j,x=this._getBlockerRowHeight();if(i>0){w=w+3;}this.$().find(".sapMSinglePCBlockersColumns").css("height",w);this._oBlockersToRender.oBlockersList.getIterator().forEach(function(y){y.getData().$().css("top",x*y.level+1);});};
s.prototype._adjustBlockersHeightforCozy=function(){var i=this._getBlockersToRender()&&this._getBlockersToRender().iMaxlevel,j;if(this._getColumns()===1){j=(i+1)*this._getBlockerRowHeight();this.$().find(".sapMSinglePCBlockersColumns").css("height",j+p);}};
s.prototype.onAfterRendering=function(){var j=this._getColumns(),w=this.getStartDate(),x=this._getRowHeight();if(x===n){for(var i=0;i<j;i++){var y=new g(w.getFullYear(),w.getMonth(),w.getDate()+i),z=this._getDateFormatter().format(y.toLocalJSDate()),A=new U(y.getYear(),y.getMonth(),y.getDate(),this._getVisibleStartHour()),E=new U(y.getYear(),y.getMonth(),y.getDate(),this._getVisibleEndHour(),59,59);this._adjustAppointmentsHeightforCompact(z,A,E);}this._adjustBlockersHeightforCompact();}else{this._adjustBlockersHeightforCozy();}this._updateRowHeaderAndNowMarker();_.call(this);};
s.prototype._appFocusHandler=function(E,i){var T=sap.ui.getCore().byId(E.target.id);if(T&&T.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});this._focusCellWithKeyboard(T,i);E.preventDefault();}};
s.prototype._cellFocusHandler=function(E,i){var G=E.target,j=this._getDateFormatter(),w;if(G.classList.contains("sapMSinglePCRow")||G.classList.contains("sapMSinglePCBlockersColumn")){w=j.parse(G.getAttribute("data-sap-start-date"));if(this._isBorderReached(w,i)){this.fireEvent("borderReached",{startDate:w,next:i===K.ARROW_RIGHT,fullDay:G.classList.contains("sapMSinglePCBlockersColumn")});}}};
s.prototype.onsapup=function(E){this._appFocusHandler(E,K.ARROW_UP);};
s.prototype.onsapdown=function(E){this._appFocusHandler(E,K.ARROW_DOWN);};
s.prototype.onsapright=function(E){this._appFocusHandler(E,K.ARROW_RIGHT);this._cellFocusHandler(E,K.ARROW_RIGHT);};
s.prototype.onsapleft=function(E){this._appFocusHandler(E,K.ARROW_LEFT);this._cellFocusHandler(E,K.ARROW_LEFT);};
s.prototype.setStartDate=function(i){this._oOldStartDate=this.getStartDate();this.getAggregation("_columnHeaders").setStartDate(i);return this.setProperty("startDate",i);};
s.prototype.applyFocusInfo=function(w){var V=this._getVisibleBlockers(),x=this._getVisibleAppointments(),y=Object.keys(x),z,i,j;for(i=0;i<V.length;++i){if(V[i].getId()===w.id){V[i].focus();return this;}}for(i=0;i<y.length;++i){z=x[y[i]];for(j=0;j<z.length;++j){if(z[j].getId()===w.id){z[j].focus();return this;}}}return this;};
s.prototype.getSelectedAppointments=function(){return this.getAppointments().filter(function(A){return A.getSelected();});};
s.prototype._toggleAppointmentSelection=function(A,j){var w=[],x,y,i;if(j){x=this.getAppointments();for(i=0,y=x.length;i<y;i++){if((!A||x[i].getId()!==A.getId())&&x[i].getSelected()){x[i].setProperty("selected",false,true);w.push(x[i]);q('[data-sap-ui='+x[i].getId()+']').attr("aria-selected","false").find(".sapUiCalendarApp").removeClass("sapUiCalendarAppSel");}}}if(A){A.setProperty("selected",!A.getSelected(),true);w.push(A);q('[data-sap-ui='+A.getId()+']').attr("aria-selected",A.getSelected()).find(".sapUiCalendarApp").toggleClass("sapUiCalendarAppSel",A.getSelected());}return w;};
s.prototype._isBorderReached=function(i,j){var G=g.fromLocalJSDate(this.getStartDate()),w=new g(G.getYear(),G.getMonth(),G.getDate()+this._getColumns()-1),T=g.fromLocalJSDate(i),x=j===K.ARROW_LEFT&&T.isSame(G),y=j===K.ARROW_RIGHT&&T.isSame(w);return x||y;};
s.prototype._focusCellWithKeyboard=function(A,i){var j=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),w=this._getDateFormatter(),x=new Date(A.getStartDate().getFullYear(),A.getStartDate().getMonth(),A.getStartDate().getDate(),A.getStartDate().getHours()),G=new Date(this.getStartDate().getFullYear(),this.getStartDate().getMonth(),this.getStartDate().getDate(),this.getStartDate().getHours());if(x<G){x=G;}if(this._isBorderReached(x,i)){this.fireEvent("borderReached",{startDate:x,next:i===K.ARROW_RIGHT,fullDay:j});return;}switch(i){case K.ARROW_UP:if(!j){x.setHours(x.getHours()-1);}break;case K.ARROW_DOWN:if(!j){x.setHours(x.getHours()+1);}break;case K.ARROW_LEFT:x.setDate(x.getDate()-1);break;case K.ARROW_RIGHT:x.setDate(x.getDate()+1);break;default:}if(j&&i!==K.ARROW_DOWN){q("[data-sap-start-date='"+w.format(x)+"'].sapMSinglePCBlockersColumn").focus();}else{q("[data-sap-start-date='"+w.format(x)+"'].sapMSinglePCRow").focus();}};
s.prototype.ontap=function(E){this._fireSelectionEvent(E);};
s.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this._fireSelectionEvent(E);E.preventDefault();}};
s.prototype._fireSelectionEvent=function(E){var A=E.srcControl,G=E.target;if(E.target.classList.contains("sapMSinglePCRow")||E.target.classList.contains("sapMSinglePCBlockersColumn")){this.fireEvent("cellPress",{startDate:this._getDateFormatter().parse(G.getAttribute("data-sap-start-date")),endDate:this._getDateFormatter().parse(G.getAttribute("data-sap-end-date"))});this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});}else if(A&&A.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:A,appointments:this._toggleAppointmentSelection(A,!(E.ctrlKey||E.metaKey))});}};
s.prototype._getVisibleStartHour=function(){return(this.getFullDay()||!this.getStartHour())?F:this.getStartHour();};
s.prototype._getVisibleEndHour=function(){return((this.getFullDay()||!this.getEndHour())?r:this.getEndHour())-1;};
s.prototype._isVisibleHour=function(i){var j=this.getStartHour(),E=this.getEndHour();if(!this.getStartHour()){j=F;}if(!this.getEndHour()){E=r;}return j<=i&&i<E;};
s.prototype._shouldHideRowHeader=function(i){var j=new Date().getHours(),w=h._areCurrentMinutesLessThan(15)&&j===i,x=h._areCurrentMinutesMoreThan(45)&&j===i-1;return w||x;};
s.prototype._parseDateStringAndHours=function(i,j){var w=this._getDateFormatter().parse(i);if(j){w.setHours(j);}return w;};
s.prototype._getDateFormatter=function(){if(!(this._oDateFormat instanceof D)){this._oDateFormat=D.getDateTimeInstance({pattern:"YYYYMMdd-HHmm"});}return this._oDateFormat;};
s.prototype._formatTimeAsString=function(i){var j=this._getHoursPattern()+":mm",w=D.getDateTimeInstance({pattern:j},new a(this._getCoreLocaleId()));return w.format(i);};
s.prototype._addAMPM=function(i){var A=this._getAMPMFormat();return" "+A.format(i);};
s.prototype._calculateTopPosition=function(i){var j=i.getHours()-this._getVisibleStartHour(),w=i.getMinutes(),x=this._getRowHeight();return Math.floor((x*j)+(x/60)*w);};
s.prototype._calculateBottomPosition=function(i){var j=this._getVisibleEndHour()+1-i.getHours(),w=i.getMinutes(),x=this._getRowHeight();return Math.floor((x*j)-(x/60)*w);};
s.prototype._updateRowHeaderAndNowMarker=function(){var i=new Date();this._updateNowMarker(i);this._updateRowHeaders(i);setTimeout(this._updateRowHeaderAndNowMarker.bind(this),O);};
s.prototype._updateNowMarker=function(i){var $=this.$("nowMarker"),j=this.$("nowMarkerText"),w=this.$("nowMarkerAMPM"),x=!this._isVisibleHour(i.getHours());$.toggleClass("sapMSinglePCNowMarkerHidden",x);$.css("top",this._calculateTopPosition(i)+"px");j.text(this._formatTimeAsString(i));w.text(this._addAMPM(i));j.append(w);};
s.prototype._updateRowHeaders=function(i){var $=this.$(),j=i.getHours(),N=j+1;$.find(".sapMSinglePCRowHeader").removeClass("sapMSinglePCRowHeaderHidden");if(this._shouldHideRowHeader(j)){$.find(".sapMSinglePCRowHeader"+j).addClass("sapMSinglePCRowHeaderHidden");}else if(this._shouldHideRowHeader(N)){$.find(".sapMSinglePCRowHeader"+N).addClass("sapMSinglePCRowHeaderHidden");}};
s.prototype._createAppointmentsMap=function(A){var i=this;return A.reduce(function(j,w){var x=w.getStartDate(),y=w.getEndDate(),z,E,G;if(!x||!y){return j;}if(!i.isAllDayAppointment(x,y)){z=g.fromLocalJSDate(x);E=g.fromLocalJSDate(y);while(z.isSameOrBefore(E)){G=i._getDateFormatter().format(z.toLocalJSDate());if(!j.appointments[G]){j.appointments[G]=[];}j.appointments[G].push(w);z.setDate(z.getDate()+1);}}else{j.blockers.push(w);}return j;},{appointments:{},blockers:[]});};
s.prototype._calculateVisibleAppointments=function(A,j,w){var V={},x,y,z;for(var i=0;i<w;i++){x=new g(j.getFullYear(),j.getMonth(),j.getDate()+i);y=this._getDateFormatter().format(x.toLocalJSDate());z=this._isAppointmentFitInVisibleHours(x);if(A[y]){V[y]=A[y].filter(z,this).sort(this._sortAppointmentsByStartHourCallBack);}}return V;};
s.prototype._isAppointmentFitInVisibleHours=function(i){return function(A){var j=A.getStartDate().getTime(),w=A.getEndDate().getTime(),x=(new U(i.getYear(),i.getMonth(),i.getDate(),this._getVisibleStartHour())).getTime(),y=(new U(i.getYear(),i.getMonth(),i.getDate(),this._getVisibleEndHour(),59,59)).getTime();var z=j<x&&w>y,E=j>=x&&j<y,G=w>x&&w<=y;return z||E||G;};};
s.prototype._calculateAppointmentsLevelsAndWidth=function(V){var i=this;return Object.keys(V).reduce(function(A,j){var w=0,x=new S.list(),y=V[j];y.forEach(function(z){var E=new S.node(z),G=z.getStartDate().getTime();if(x.getSize()===0){x.add(E);return;}x.getIterator().forEach(function(J){var N=true,Q=J.getData(),T=Q.getStartDate().getTime(),W=Q.getEndDate().getTime(),X=W-T;if(X<H){W=W+(H-X);}if(G>=T&&G<W){E.level++;w=Math.max(w,E.level);}if(J.next&&J.next.level===E.level){N=false;}if(G>=W&&N){this.interrupt();}});x.insertAfterLevel(E.level,E);});A[j]={oAppointmentsList:i._calculateAppointmentsWidth(x),iMaxLevel:w};return A;},{});};
s.prototype._calculateAppointmentsWidth=function(A){A.getIterator().forEach(function(i){var j=i.getData(),w=i.level,x=i.level,y=j.getStartDate().getTime(),z=j.getEndDate().getTime(),E=z-y;if(E<H){z=z+(H-E);}new S.iterator(A).forEach(function(G){var J=G.getData(),N=G.level,Q=J.getStartDate().getTime(),T=J.getEndDate().getTime(),V=T-Q;if(V<H){T=T+(H-V);}if(x>=N){return;}if(y>=Q&&y<T||z>Q&&z<T||y<=Q&&z>=T){i.width=N-x;this.interrupt();return;}if(w<N){w=N;i.width++;}});});return A;};
s.prototype._calculateVisibleBlockers=function(i,j,w){var x=new g(j.getYear(),j.getMonth(),j.getDate()+w-1),y=this._isBlockerVisible(j,x);return i.filter(y).sort(this._sortAppointmentsByStartHourCallBack);};
s.prototype._isBlockerVisible=function(V,i){return function(A){var j=g.fromLocalJSDate(A.getStartDate()),w=g.fromLocalJSDate(A.getEndDate());var x=j.isBefore(V)&&w.isAfter(i),y=h._isBetween(j,V,i,true),E=h._isBetween(w,V,i,true);return x||y||E;};};
s.prototype._calculateBlockersLevelsAndWidth=function(V){var i=0,j=new S.list();V.forEach(function(w){var x=new S.node(w),y=g.fromLocalJSDate(w.getStartDate()),z=g.fromLocalJSDate(w.getEndDate());x.width=h._daysBetween(z,y);if(j.getSize()===0){j.add(x);return;}j.getIterator().forEach(function(A){var E=true,G=A.getData(),J=g.fromLocalJSDate(G.getStartDate()),N=g.fromLocalJSDate(G.getEndDate());if(y.isSameOrAfter(J)&&y.isSameOrBefore(N)){x.level++;i=Math.max(i,x.level);}if(A.next&&A.next.level===x.level){E=false;}if(y.isSameOrAfter(N)&&E){this.interrupt();}});j.insertAfterLevel(x.level,x);},this);return{oBlockersList:j,iMaxlevel:i};};
s.prototype._sortAppointmentsByStartHourCallBack=function(A,i){return A.getStartDate().getTime()-i.getStartDate().getTime()||i.getEndDate().getTime()-A.getEndDate().getTime();};
s.prototype._getVisibleAppointments=function(){return this._oVisibleAppointments;};
s.prototype._getAppointmentsToRender=function(){return this._oAppointmentsToRender;};
s.prototype._getVisibleBlockers=function(){return this._aVisibleBlockers;};
s.prototype._getBlockersToRender=function(){return this._oBlockersToRender;};
s.prototype._setColumns=function(i){this._iOldColumns=this._iColumns;this._iColumns=i;this.getAggregation("_columnHeaders").setDays(i);this.invalidate();return this;};
s.prototype._getColumns=function(){return this._iColumns;};
s.prototype._getRowHeight=function(){return this._isCompact()?n:R;};
s.prototype._getBlockerRowHeight=function(){return this._isCompact()?o:B;};
s.prototype._isCompact=function(){var i=this.getDomRef();while(i&&i.classList){if(i.classList.contains("sapUiSizeCompact")){return true;}i=i.parentNode;}return false;};
s.prototype._getCoreLocaleId=function(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
s.prototype._getCoreLocaleData=function(){var i,j;if(!this._oLocaleData){i=this._getCoreLocaleId();j=new a(i);this._oLocaleData=L.getInstance(j);}return this._oLocaleData;};
s.prototype._hasAMPM=function(){var i=this._getCoreLocaleData();return i.getTimePattern("short").search("a")>=0;};
s.prototype._getHoursFormat=function(){var i=this._getCoreLocaleId();if(!this._oHoursFormat||this._oHoursFormat.oLocale.toString()!==i){var j=new a(i),w=this._getHoursPattern();this._oHoursFormat=D.getTimeInstance({pattern:w},j);}return this._oHoursFormat;};
s.prototype._getHoursPattern=function(){return this._hasAMPM()?"h":"H";};
s.prototype._getAMPMFormat=function(){var i=this._getCoreLocaleId(),j=new a(i);if(!this._oAMPMFormat||this._oAMPMFormat.oLocale.toString()!==i){this._oAMPMFormat=D.getTimeInstance({pattern:"a"},j);}return this._oAMPMFormat;};
s.prototype._getColumnHeaders=function(){return this.getAggregation("_columnHeaders");};
s.prototype._getAppointmentAnnouncementInfo=function(A){var i=this._oUnifiedRB.getText("CALENDAR_START_TIME"),E=this._oUnifiedRB.getText("CALENDAR_END_TIME"),j=this._oFormatStartEndInfoAria.format(A.getStartDate()),w=this._oFormatStartEndInfoAria.format(A.getEndDate()),x=i+": "+j+"; "+E+": "+w;return x+"; "+P.findLegendItemForItem(sap.ui.getCore().byId(this._sLegendId),A);};
s.prototype.enhanceAccessibilityState=function(i,A){if(i.getId()===this._getColumnHeaders().getId()){A.labelledby=I.getStaticId("sap.m","PLANNINGCALENDAR_DAYS");}};
s.prototype._getCellStartEndInfo=function(i,E){var j=this._oUnifiedRB.getText("CALENDAR_START_TIME"),w=this._oUnifiedRB.getText("CALENDAR_END_TIME"),x=!E;if(x){return j+": "+this._oFormatAriaFullDayCell.format(i)+"; ";}return j+": "+this._oFormatStartEndInfoAria.format(i)+"; "+w+": "+this._oFormatStartEndInfoAria.format(E);};
s.prototype.isAllDayAppointment=function(A,i){var j=A.getHours()===0,w=A.getMinutes()===0,x=A.getSeconds()===0,y=A.getMilliseconds()===0,z=j&&w&&x&&y,E=false;if(z){E=this._isEndTime0000(A,i);}return E;};
s.prototype._isEndTime0000=function(A,i){return(i.getTime()-A.getTime())%M===0;};
s.prototype._createBlockersDndPlaceholders=function(j,w){this.destroyAggregation("_blockersPlaceholders");for(var i=0;i<w;i++){var x=new U(j.getFullYear(),j.getMonth(),j.getDate()+i);var y=new v({date:x});this.addAggregation("_blockersPlaceholders",y,true);}};
s.prototype._createAppointmentsDndPlaceholders=function(w,x){var y=this._getVisibleStartHour(),E=this._getVisibleEndHour();this._dndPlaceholdersMap={};this.destroyAggregation("_intervalPlaceholders");for(var i=0;i<x;i++){var z=new g(w.getFullYear(),w.getMonth(),w.getDate()+i);if(!this._dndPlaceholdersMap[z]){this._dndPlaceholdersMap[z]=[];}for(var j=y;j<=E;j++){var A=this._dndPlaceholdersMap[z],Y=z.getYear(),G=z.getMonth(),J=z.getDate();A.push(this._createAppointmentsDndPlaceHolder(new U(Y,G,J,j)));A.push(this._createAppointmentsDndPlaceHolder(new U(Y,G,J,j,30)));}}};
s.prototype._createAppointmentsDndPlaceHolder=function(i){var j=new v({date:i});this.addAggregation("_intervalPlaceholders",j,true);return j;};
function t(){var $=q("<span></span>").addClass("sapUiCalAppResizeGhost");$.appendTo(document.body);setTimeout(function(){$.remove();},0);return $.get(0);}
var v=C.extend("sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",{
metadata:{properties:{date:{type:"object",group:"Data"}}},
renderer:function(i,j){i.write("<div");i.writeControlData(j);i.addClass("sapMSinglePCPlaceholder");i.writeClasses();i.write("></div>");}
});
function _(){var i=this.getDomRef(),j=this.$().find(".sapMSinglePCBlockersColumn").toArray();this._aGridCells=Array.prototype.concat(j);for(var w=0;w<=this._getVisibleEndHour();++w){j=this.$().find("div[data-sap-hour='"+w+"']").toArray();this._aGridCells=this._aGridCells.concat(j);}if(!this._oItemNavigation){this._oItemNavigation=new m();this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(i);this._oItemNavigation.setItemDomRefs(this._aGridCells);this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"],saphome:["alt","meta"],sapend:["meta"]});this._oItemNavigation.setTableMode(true,true).setColumns(this._getColumns());this._oItemNavigation.setPageSize(this._aGridCells.length);}
return s;});
sap.ui.predefine('sap/m/SinglePlanningCalendarGridRenderer',['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/core/InvisibleText','./PlanningCalendarLegend','sap/ui/unified/library'],function(C,a,U,I,P,u){"use strict";var v=2;var A=2;var b=1;var c=u.CalendarDayType;var S={apiVersion:2};
S.render=function(r,o){r.openStart("div",o);r.class("sapMSinglePCGrid");r.openEnd();r.renderControl(o.getAggregation("_columnHeaders"));this.renderBlockersContainer(r,o);r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCGridContent");r.openEnd();this.renderRowHeaders(r,o);this.renderNowMarker(r,o);this.renderColumns(r,o);r.close("div");r.close("div");};
S.renderBlockersContainer=function(r,o){var d=o._getColumns(),m=o._getBlockersToRender().iMaxlevel,s=o.getStartDate(),e=(m+1)*o._getBlockerRowHeight()+3,f=o._getDateFormatter(),g=o.getSpecialDates(),h=C.fromLocalJSDate(s),D=o._getColumnHeaders()._getDateTypes(h),t,l;r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCBlockersRow");r.openEnd();r.openStart("div");r.attr("role","row");r.class("sapMSinglePCBlockersColumns");if(g&&o._getColumns()===1){if(D&&D[0]){t=D[0];r.class("sapUiCalItem"+t.type);l=P.findLegendItemForItem(sap.ui.getCore().byId(o._sLegendId),t);}r.class("sapMSpecialDaysInDayView");}r.style("height",e+"px");r.openEnd();this.renderDndPlaceholders(r,o,o.getAggregation("_blockersPlaceholders"));for(var i=0;i<d;i++){var j=new C(s.getFullYear(),s.getMonth(),s.getDate()+i);r.openStart("div");r.attr("role","gridcell");r.attr("data-sap-start-date",f.format(j.toLocalJSDate()));r.attr("data-sap-end-date",f.format(j.toLocalJSDate()));r.attr("aria-labelledby",I.getStaticId("sap.m","SPC_BLOCKERS")+" "+"fullDay-"+f.format(j.toLocalJSDate())+"-Descr");r.class("sapMSinglePCBlockersColumn");r.attr("tabindex",-1);if(j.isSame(new C())){r.class("sapMSinglePCBlockersColumnToday");}if(a._isWeekend(j,o._getCoreLocaleData())){r.class("sapMSinglePCBlockersColumnWeekend");}r.openEnd();r.openStart("span","fullDay-"+f.format(j.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(j.toLocalJSDate()));if(o._sLegendId&&l){r.text(l);}r.close("span");r.close("div");}this.renderBlockers(r,o);r.close("div");r.close("div");};
S.renderBlockers=function(r,o){var t=this,B=o._getBlockersToRender().oBlockersList;r.openStart("div");r.attr("role","grid");r.attr("aria-labelledby",I.getStaticId("sap.m","SPC_BLOCKERS"));r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.openEnd();B.getIterator().forEach(function(d){t.renderBlockerAppointment(r,o,d);});r.close("div");};
S.renderBlockerAppointment=function(r,o,B){var g=C.fromLocalJSDate(o.getStartDate()),d=B.getData(),e=C.fromLocalJSDate(d.getStartDate()),f=C.fromLocalJSDate(d.getEndDate()),s=a._daysBetween(e,g),E=a._daysBetween(f,g),i=o._getColumns(),R=o._getBlockerRowHeight(),h=B.level,j=B.width,t=d.getTooltip_AsString(),T=d.getType(),k=d.getColor(),l=d.getTitle(),m=d.getText(),n=d.getIcon(),p=d.getId(),q={role:"gridcell",labelledby:{value:I.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:!!d.getSelected()},w=o.getAriaLabelledBy(),L=s*(100/i),x=(i-E-1)*(100/i),y=sap.ui.getCore().getConfiguration().getRTL(),z;if(w.length>0){q["labelledby"].value=q["labelledby"].value+" "+w.join(" ");}if(l){q["labelledby"].value=q["labelledby"].value+" "+p+"-Title";}q["labelledby"].value=q["labelledby"].value+" "+p+"-Descr";if(m){q["labelledby"].value=q["labelledby"].value+" "+p+"-Text";}if(d.getTentative()){q["labelledby"].value=q["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}r.openStart("div",d);r.attr("data-sap-level",h);r.attr("data-sap-width",j);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(d,q);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!k&&T!==c.None){r.class("sapUiCalendarApp"+T);}if(k){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",k);}else{r.style("border-left-color",k);}}r.style("top",R*h+1+"px");r.style(y?"right":"left",Math.max(L,0)+"%");r.style(y?"left":"right",Math.max(x,0)+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(d.getSelected()){r.class("sapUiCalendarAppSel");}if(d.getTentative()){r.class("sapUiCalendarAppTent");}if(n){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(k){r.style("background-color",d._getCSSColorForBackground(k));}r.openEnd();if(L<0){z=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",z,{title:null});}if(n){z=["sapUiCalendarAppIcon"];var D={};D["id"]=p+"-Icon";D["title"]=null;r.icon(n,z,D);}if(l){r.openStart("span",p+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(l,true);r.close("span");}if(x<0){z=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",z,{title:null});}r.openStart("span",p+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(d));r.close("span");r.close("div");r.close("div");r.close("div");};
S.renderRowHeaders=function(r,o){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),d=new Date(),h=o._getHoursFormat(),f=o._getAMPMFormat();r.openStart("div");r.class("sapMSinglePCRowHeaders");r.openEnd();for(var i=s;i<=e;i++){d.setHours(i);r.openStart("span");r.class("sapMSinglePCRowHeader");r.class("sapMSinglePCRowHeader"+i);if(o._shouldHideRowHeader(i)){r.class("sapMSinglePCRowHeaderHidden");}r.openEnd();r.text(h.format(d));if(o._hasAMPM()){r.openStart("span");r.class("sapMSinglePCRowHeaderAMPM");r.openEnd();r.text(" "+f.format(d));r.close("span");}r.close("span");}r.close("div");};
S.renderColumns=function(r,o){var d=o._getColumns(),s=o.getStartDate(),e=o._getAppointmentsToRender();r.openStart("div");r.attr("role","grid");r.attr("aria-labelledby",I.getStaticId("sap.m","SPC_APPOINTMENTS"));r.class("sapMSinglePCColumns");r.openEnd();for(var i=0;i<d;i++){var f=new C(s.getFullYear(),s.getMonth(),s.getDate()+i),F=o._getDateFormatter(),D=F.format(f.toLocalJSDate());r.openStart("div");r.attr("data-sap-day",D);r.class("sapMSinglePCColumn");if(f.isSame(new C())){r.class("sapMSinglePCColumnToday");}if(a._isWeekend(f,o._getCoreLocaleData())){r.class("sapMSinglePCColumnWeekend");}r.openEnd();this.renderDndPlaceholders(r,o,o._dndPlaceholdersMap[f]);this.renderRows(r,o,D);this.renderAppointments(r,o,e[D],f);r.close("div");}r.close("div");};
S.renderDndPlaceholders=function(r,o,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();p.forEach(r.renderControl);r.close("div");};
S.renderRows=function(r,o,d){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),f=o._getDateFormatter(),g,h;for(var i=s;i<=e;i++){g=o._parseDateStringAndHours(d,i);h=new Date(g.getFullYear(),g.getMonth(),g.getDate(),g.getHours()+1);r.openStart("div");r.class("sapMSinglePCRow");if(!o._isVisibleHour(i)){r.class("sapMSinglePCNonWorkingRow");}r.attr("data-sap-hour",i);r.attr("data-sap-start-date",f.format(g));r.attr("data-sap-end-date",f.format(h));r.attr("aria-labelledby",f.format(g)+"-Descr");r.attr("tabindex",-1);r.openEnd();r.openStart("span",f.format(g)+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(g,h));r.close("span");r.close("div");}};
S.renderAppointments=function(r,o,d,e){var t=this;if(d){r.openStart("div");r.class("sapMSinglePCAppointments");r.class("sapUiCalendarRowVisFilled");r.openEnd();d.oAppointmentsList.getIterator().forEach(function(f){var m=d.iMaxLevel,l=f.level,w=f.width,g=f.getData();t.renderAppointment(r,o,m,l,w,g,e);});r.close("div");}};
S.renderAppointment=function(r,o,m,i,d,e,f){var g=C.fromLocalJSDate(o.getStartDate()),G=new C(g),R=o._getRowHeight(),h=new U(f.getYear(),f.getMonth(),f.getDate(),o._getVisibleStartHour()),j=new U(f.getYear(),f.getMonth(),f.getDate(),o._getVisibleEndHour(),59,59),k=e.getStartDate(),l=e.getEndDate(),n=C.fromLocalJSDate(k),p=C.fromLocalJSDate(l),t=e.getTooltip_AsString(),T=e.getType(),s=e.getColor(),q=e.getTitle(),w=e.getText(),x=e.getIcon(),y=e.getId(),L=this._getLineClamp(k,l),z={role:"gridcell",labelledby:{value:I.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:!!e.getSelected()},B=o.getAriaLabelledBy(),D=h.getTime()>k.getTime(),E=j.getTime()<l.getTime(),F=D?0:o._calculateTopPosition(k),H=E?0:o._calculateBottomPosition(l),J=100/(m+1),K,M,N,O,Q;G.setDate(G.getDate()+o._getColumns()-1);K=a._daysBetween(n,g);M=a._daysBetween(G,p);N=f.isSame(g);O=f.isSame(G);if(B.length>0){z["labelledby"].value=z["labelledby"].value+" "+B.join(" ");}if(q){z["labelledby"].value=z["labelledby"].value+" "+y+"-Title";}z["labelledby"].value=z["labelledby"].value+" "+y+"-Descr";if(w){z["labelledby"].value=z["labelledby"].value+" "+y+"-Text";}if(e.getTentative()){z["labelledby"].value=z["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}r.openStart("div",e);r.attr("data-sap-level",i);r.attr("data-sap-width",d);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(e,z);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!s&&T!==c.None){r.class("sapUiCalendarApp"+T);}if(s){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",s);}else{r.style("border-left-color",s);}}r.style("top",F+"px");r.style("bottom",H+"px");r.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",J*i+"%");r.style("width",J*d+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");r.style("min-height",(R-(v+A+b))/2+"px");if(e.getSelected()){r.class("sapUiCalendarAppSel");}if(e.getTentative()){r.class("sapUiCalendarAppTent");}if(x){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(s){r.style("background-color",e._getCSSColorForBackground(s));}r.openEnd();if(N&&K<0){Q=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",Q,{title:null});}if(x){Q=["sapUiCalendarAppIcon"];var V={};V["id"]=y+"-Icon";V["title"]=null;r.icon(x,Q,V);}r.openStart("div");r.class("sapUiCalendarAppTitleWrapper");r.class("sapUiSPCAppLineClamp"+L);r.openEnd();if(q){r.openStart("span",y+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(q,true);r.close("span");}if(w){r.openStart("span",y+"-Text");r.class("sapUiCalendarAppText");r.openEnd();r.text(w,true);r.close("span");}r.close("div");if(O&&M<0){Q=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",Q,{title:null});}r.openStart("span",y+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(e));r.close("span");r.close("div");if(o.getEnableAppointmentsResize()&&!D&&!E){this.renderResizeHandles(r);}r.close("div");r.close("div");};
S.renderNowMarker=function(r,o){var d=new Date();r.openStart("div",o.getId()+"-nowMarker");r.style("top",o._calculateTopPosition(d)+"px");r.class("sapMSinglePCNowMarker");if(!o._isVisibleHour(d.getHours())){r.class("sapMSinglePCNowMarkerHidden");}r.openEnd();r.openStart("span",o.getId()+"-nowMarkerText");r.class("sapMSinglePCNowMarkerText");r.openEnd();r.text(o._formatTimeAsString(d));if(o._hasAMPM()){r.openStart("span",o.getId()+"-nowMarkerAMPM");r.class("sapMSinglePCNowMarkerAMPM");r.openEnd();r.text(o._addAMPM(d));r.close("span");}r.close("span");r.close("div");};
S.renderResizeHandles=function(r){r.openStart("span");r.class("sapMSinglePCAppResizeHandleBottom");r.openEnd();r.close("span");r.openStart("span");r.class("sapMSinglePCAppResizeHandleTop");r.openEnd();r.close("span");};
S._getLineClamp=function(o,d){var m=a._minutesBetween(o,d);if(m>=51&&m<69){return"2";}else if(m>=69&&m<90){return"3";}else if(m>=90&&m<110){return"4";}else if(m>=110&&m<130){return"5";}else if(m>=130&&m<150){return"6";}else if(m>=150&&m<170){return"7";}else if(m>=170&&m<190){return"8";}else if(m>=190){return"9";}else{return"1";}};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarMonthGrid',['sap/ui/core/Control','sap/ui/core/format/DateFormat','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/LocaleData','sap/ui/core/Locale','sap/ui/core/delegate/ItemNavigation','sap/ui/core/dnd/DragDropInfo','sap/ui/core/CustomData','sap/ui/events/KeyCodes','sap/base/Log','sap/ui/core/Core','./Link','./PlanningCalendarLegend','./SinglePlanningCalendarMonthGridRenderer'],function(C,D,c,d,L,e,I,f,g,K,h,l,m,P,S){"use strict";var A=1.5625;var n=1.5;var o=2.125;var p=1.75;
var q=C.extend("sap.m.SinglePlanningCalendarMonthGrid",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},_appsPlaceholders:{type:"sap.m.SinglePlanningCalendarMonthGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true,associations:{legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},moreLinkPress:{parameters:{date:{type:"object"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}}}}});
q.prototype.init=function(){this._aLinks=[];this._handleMorePress=this._handleMorePress.bind(this);this._oDateFormat=D.getDateTimeInstance({pattern:"YYYYMMdd"});this._oFormatAriaApp=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY 'at' "+this._getCoreLocaleData().getTimePattern("medium")});this._oFormatAriaFullDayCell=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY"});this.setStartDate(new Date());this._configureAppointmentsDragAndDrop();};
q.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}for(var i=0;i<this._aLinks.length;i++){if(this._aLinks[i]){this._aLinks[i].destroy();}}delete this._aLinks;};
q.prototype.onBeforeRendering=function(){var s=this.getStartDate();this._oAppointmentsToRender=this._calculateAppointmentsNodes(s);this._createAppointmentsDndPlaceholders(s);};
q.prototype.onAfterRendering=function(){this._initItemNavigation();};
q.prototype._getColumns=function(){return 7;};
q.prototype._getRows=function(){return 6;};
q.prototype._getDateFormatter=function(){return this._oDateFormat;};
q.prototype._getAppointmetsForADay=function(a){return this._oAppointmentsToRender.filter(function(b){return b.start.valueOf()===a.valueOf();});};
q.prototype._getPreviousAppointmetsForADay=function(a){return this._oAppointmentsToRender.filter(function(b){return b.start.valueOf()<a.valueOf()&&b.end.valueOf()>=a.valueOf();}).map(function(b){var i={data:b.data,start:b.start,end:b.end,len:b.len,level:b.level,width:b.width};i.width-=d._daysBetween(a,b.start);i.hasPrevious=true;return i;},this);};
q.prototype.ontap=function(E){this._fireSelectionEvent(E);};
q.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this._fireSelectionEvent(E);E.preventDefault();}};
q.prototype._fireSelectionEvent=function(E){var t=E.srcControl,$=jQuery(E.target).eq(0),a=$.closest('.sapMSPCMonthDay').eq(0),i=$.length&&$[0].classList.contains("sapMLnk"),T,s,b;if(t&&t.isA("sap.m.SinglePlanningCalendarMonthGrid")&&a&&!i){T=parseInt(a.attr("sap-ui-date"));s=new Date(T);s=new Date(s.getFullYear(),s.getMonth(),s.getDate());b=new Date(s);b.setDate(b.getDate()+1);this.fireEvent("cellPress",{startDate:s,endDate:b});this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});}else if(t&&t.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:t,appointments:this._toggleAppointmentSelection(t,!(E.ctrlKey||E.metaKey))});}};
q.prototype._toggleAppointmentSelection=function(a,R){var b=[],j,k,i;if(R){j=this.getAppointments();for(i=0,k=j.length;i<k;i++){if((!a||j[i].getId()!==a.getId())&&j[i].getSelected()){j[i].setProperty("selected",false,true);b.push(j[i]);jQuery('[data-sap-ui='+j[i].getId()+']').attr("aria-selected","false").find(".sapUiCalendarApp").removeClass("sapUiCalendarAppSel");}}}if(a){a.setProperty("selected",!a.getSelected(),true);b.push(a);jQuery('[data-sap-ui='+a.getId()+']').attr("aria-selected",a.getSelected()).find(".sapUiCalendarApp").toggleClass("sapUiCalendarAppSel",a.getSelected());}return b;};
q.prototype._getMoreLink=function(a,b,i){var M=l.getLibraryResourceBundle("sap.m").getText("SPC_MORE_LINK",[a.toString()]),j=new m({text:M,press:this._handleMorePress}).addCustomData(new g({key:"date",value:b.valueOf().toString(),writeToDom:true}));if(this._aLinks[i]){this._aLinks[i].destroy();}this._aLinks[i]=j;return j;};
q.prototype._handleMorePress=function(E){var t=parseInt(E.getSource().getCustomData()[0].getValue()),a=new Date(t);a=new Date(a.getFullYear(),a.getMonth(),a.getDate());this.fireEvent("moreLinkPress",{date:a});};
q.prototype._getCoreLocaleData=function(){var s=l.getConfiguration().getFormatSettings().getFormatLocale().toString(),a=new e(s);return L.getInstance(a);};
q.prototype._getCells=function(){return this._getVisibleDays(this.getStartDate());};
q.prototype._getVerticalLabels=function(){var a=this._getVisibleDays(this.getStartDate()),b=this._getColumns(),R=[],s=l.getConfiguration().getFormatLocale().toString(),j=this._getCoreLocaleData();for(var i=0;i<this._getRows();i++){R.push(d.calculateWeekNumber(a[i*b].toUTCJSDate(),a[i*b].getYear(),s,j));}return R;};
q.prototype._getVisibleDays=function(s){var a,b,j,k,F,t,v=[];if(!s){return v;}a=c.fromLocalJSDate(s);t=this._getCoreLocaleData().getFirstDayOfWeek();F=new c(a);F.setDate(1);k=F.getDay()-t;if(k<0){k=7+k;}if(k>0){F.setDate(1-k);}b=new c(F);for(var i=0;i<this._getColumns()*this._getRows();i++){j=new c(b);v.push(j);b.setDate(b.getDate()+1);}return v;};
q.prototype._getAppointmentsToRender=function(){return this._oAppointmentsToRender;};
q.prototype._calculateAppointmentsNodes=function(s){var v=this._getVisibleDays(s),F=v[0],t=v[v.length-1],u=this.getAppointments().filter(function(a){var b=a.getStartDate()&&a.getEndDate();if(!b){h.warning("Appointment "+a.getId()+" has no start or no end date. It is ignored.");}return b;}).map(function(a){var b=c.fromLocalJSDate(a.getStartDate()),z=c.fromLocalJSDate(a.getEndDate());return{data:a,start:b,end:z,len:d._daysBetween(z,b)};}).filter(function(a){return d._isBetween(a.start,F,t,true)||d._isBetween(a.end,F,t,true);}).sort(function compare(a,b){return a.start.valueOf()-b.start.valueOf();}),V=[],w,x,E,y,i,j,k;for(i=0;i<v.length;i++){V.push([]);}for(i=0;i<u.length;i++){w=u[i];x=d._daysBetween(w.start,v[0]);E=x+w.len;x=x>0?x:0;E=E<v.length?E:v.length-1;w.width=w.len+1;y=V[x].indexOf(true);if(y===-1){y=V[x].length;}w.level=y;for(j=x;j<=E;j++){V[j][y]=false;for(k=0;k<y;k++){if(V[j][k]===undefined){V[j][k]=true;}}}}this._aAppsLevelsPerDay=V;return u;};
q.prototype._getMoreCountPerCell=function(a){var b=this._aAppsLevelsPerDay[a];var M=this._getMaxAppointments();var j=0;var s=0;if(b.length<=M){return 0;}for(var i=0;i<b.length;i++){if(!b[i]){j++;}if(i<M-1){s++;}}return j-s;};
q.prototype._configureAppointmentsDragAndDrop=function(){this.addDragDropConfig(new f({sourceAggregation:"appointments",targetAggregation:"_appsPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()){E.preventDefault();return false;}var H=function(){var O=jQuery(".sapMSinglePCOverlay");setTimeout(function(){O.addClass("sapMSinglePCOverlayDragging");});jQuery(document).one("dragend",function(){O.removeClass("sapMSinglePCOverlayDragging");});};H();}.bind(this),dragEnter:function(E){var a=E.getParameter("dragSession"),b=function(){var i=jQuery(a.getIndicator());i.css("min-height",a.getDropControl().$().outerHeight());i.css("min-width",a.getDropControl().$().outerWidth());};if(!a.getIndicator()){setTimeout(b,0);}else{b();}},drop:function(E){var a=E.getParameter("dragSession"),b=a.getDragControl(),i=a.getDropControl(),j=i.getDate(),k=c.fromLocalJSDate(b.getStartDate()),s=c.fromLocalJSDate(b.getEndDate()),O=d._daysBetween(j,k),t=new c(k),u=new c(s),B=E.getParameter("browserEvent"),v=(B.metaKey||B.ctrlKey);t.setDate(t.getDate()+O);u.setDate(u.getDate()+O);this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(k.valueOf()===j.valueOf()){return;}this.fireAppointmentDrop({appointment:b,startDate:t.toLocalJSDate(),endDate:u.toLocalJSDate(),copy:v});}.bind(this)}));};
q.prototype._initItemNavigation=function(){var R=this.getDomRef();this._aGridCells=this.$().find(".sapMSPCMonthDay").toArray();if(!this._oItemNavigation){this._oItemNavigation=new I();this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._itemNavigationBorderReached,this);}this._oItemNavigation.setRootDomRef(R);this._oItemNavigation.setItemDomRefs(this._aGridCells);this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"],saphome:["alt","meta"],sapend:["meta"]});this._oItemNavigation.setTableMode(false).setColumns(this._getColumns(),true);this._oItemNavigation.setPageSize(this._aGridCells.length);};
q.prototype._itemNavigationBorderReached=function(E){var G,F,i=E.getParameter("event"),O;if(i.target.classList.contains("sapMSPCMonthDay")){G=i.target;F=parseInt(G.getAttribute("sap-ui-date"));switch(i.keyCode){case K.ARROW_LEFT:O=-1;break;case K.ARROW_UP:O=-this._getColumns();break;case K.ARROW_RIGHT:O=1;break;case K.ARROW_DOWN:O=this._getColumns();break;default:break;}this.fireEvent("borderReached",{startDate:F,offset:O});}};
q.prototype._createAppointmentsDndPlaceholders=function(s){var a=this._getVisibleDays(s);this.destroyAggregation("_appsPlaceholders");for(var i=0;i<a.length;i++){var b=new r({date:a[i]});this.addAggregation("_appsPlaceholders",b,true);}};
var r=C.extend("sap.m.SinglePlanningCalendarMonthGrid._internal.IntervalPlaceholder",{
metadata:{properties:{date:{type:"object",group:"Data"}}},
renderer:function(R,a){R.write("<div");R.writeControlData(a);R.addClass("sapMSinglePCPlaceholder");R.writeClasses();R.write("></div>");}
});
q.prototype._getCellStartInfo=function(s){var a=l.getLibraryResourceBundle("sap.ui.unified").getText("CALENDAR_START_TIME");return a+": "+this._oFormatAriaFullDayCell.format(s)+"; ";};
q.prototype._getAppointmentAnnouncementInfo=function(a){var u=l.getLibraryResourceBundle("sap.ui.unified"),s=u.getText("CALENDAR_START_TIME"),E=u.getText("CALENDAR_END_TIME"),F=this._oFormatAriaApp.format(a.getStartDate()),b=this._oFormatAriaApp.format(a.getEndDate()),i=s+": "+F+"; "+E+": "+b;return i+"; "+P.findLegendItemForItem(l.byId(this._sLegendId),a);};
q.prototype._getMaxAppointments=function(){return this._isCompact()?4:3;};
q.prototype._getDensitySizes=function(){return this._isCompact()?{appHeight:A,cellHeaderHeight:n}:{appHeight:o,cellHeaderHeight:p};};
q.prototype._isCompact=function(){var a=this.getDomRef()||(this.getParent()&&this.getParent().getDomRef&&this.getParent().getDomRef()||(this.getParent()&&this.getParent().getRootNode&&this.getParent().getRootNode()));while(a&&a.classList){if(a.classList.contains("sapUiSizeCompact")){return true;}a=a.parentNode;}return false;};
return q;});
sap.ui.predefine('sap/m/SinglePlanningCalendarMonthGridRenderer',['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/Month','sap/ui/core/date/UniversalDate','./PlanningCalendarLegend','sap/ui/core/InvisibleText','sap/ui/core/Core','sap/ui/unified/library'],function(C,a,M,U,P,I,b,u){"use strict";var c=u.CalendarDayType;var S={apiVersion:2};
S.render=function(r,o){var l=o._getCoreLocaleData();var d=o._getDensitySizes();r.openStart("div",o);r.class("sapMSinglePCGrid");r.class("sapMSPCMonthGrid");r.openEnd();this.renderDayNames(r,o,l);r.openStart("div");r.class("sapMSinglePCGridContent");r.openEnd();this.renderCells(r,o,l,d);r.close("div");r.close("div");};
S.renderCells=function(r,o,l,d){var e=o._getCells(),v=o._getVerticalLabels(),f=o._getColumns(),m=[],A=[],g,D,h,p,k=[],n,w,i,j;for(i=0;i<o._getRows();i++){w=0;r.openStart("div");r.attr("role","grid");r.class("sapMSPCMonthWeek");r.openEnd();r.openStart("div");r.class("sapMSPCMonthWeekNumber");r.openEnd();r.text(v[i]);r.close("div");for(j=0;j<f;j++){g=i*f+j;D=e[g];h=o._getAppointmetsForADay(D);p=o._getPreviousAppointmetsForADay(D);k.push(p);n=o._getMoreCountPerCell(g);m.push(n);A.push(h);w=Math.max(w,o._aAppsLevelsPerDay[g].length);}r.openStart("div");r.class("sapMSPCMonthDays");r.class("sapMSPCMonthDaysMax"+w);r.openEnd();for(j=0;j<f;j++){g=i*f+j;D=e[g];this.renderDay(r,o,D,l,m[g],g);}r.openStart("div");r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.openEnd();for(j=0;j<f;j++){g=i*f+j;D=e[g];if(j===0){this.renderAppointments(r,o,k[g],j,m[g],d);}this.renderAppointments(r,o,A[g],j,m[g],d);}r.close("div");r.close("div");r.close("div");}};
S.renderDay=function(r,o,d,l,m,i){var s=o.getSpecialDates(),D=M.prototype._getDateTypes.call(o,d),f=o._getDateFormatter(),t,L;r.openStart("div");r.class("sapMSPCMonthDay");if(a._isWeekend(d,l)){r.class("nonWorkingTimeframe");}if(s){if(D&&D[0]){t=D[0];r.class("sapUiCalendarSpecialDay"+t.type);L=P.findLegendItemForItem(b.byId(o._sLegendId),t);}}r.attr("sap-ui-date",d.valueOf().toString());r.attr("tabindex",-1);r.attr("aria-labelledby",f.format(d.toLocalJSDate())+"-Descr");r.openEnd();this.renderDndPlaceholder(r,o.getAggregation("_appsPlaceholders")[i]);r.openStart("div");r.class("specialDateIndicator");r.openEnd();r.close("div");r.openStart("div");r.class("sapMSPCMonthDayNumber");r.openEnd();r.text(d.getDate());r.close("div");if(m){r.openStart("div");r.class("sapMSPCMonthLnkMore");r.openEnd();r.renderControl(o._getMoreLink(m,d,i));r.close("div");}r.openStart("span",f.format(d.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartInfo(d.toLocalJSDate()));if(o._sLegendId&&L){r.text(L);}r.close("span");r.close("div");};
S.renderAppointments=function(r,o,d,e,m,D){var f=o._getMaxAppointments(),g=m?f-2:f-1;for(var i=0;i<d.length;i++){if(d[i].level<=g){this.renderAppointment(r,o,d[i],e,D);}}};
S.renderAppointment=function(r,o,d,i,D){var A=d.data,w=d.width,l=d.level,e=o._getColumns(),t=A.getTooltip_AsString(),T=A.getType(),s=A.getColor(),f=A.getTitle(),g=A.getText(),h=A.getIcon(),j=A.getId(),m={role:"gridcell",labelledby:{value:I.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:!!A.getSelected()},R=e-i-w,k=b.getConfiguration().getRTL(),n,B=b.getConfiguration().getTheme().indexOf("_hc")?2:1;R=R<0?0:R;if(f){m["labelledby"].value=m["labelledby"].value+" "+j+"-Title";}m["labelledby"].value=m["labelledby"].value+" "+j+"-Descr";if(g){m["labelledby"].value=m["labelledby"].value+" "+j+"-Text";}if(A.getTentative()){m["labelledby"].value=m["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}r.openStart("div",A);r.attr("data-sap-level",l);r.attr("data-sap-width",w);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(A,m);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!s&&T!==c.None){r.class("sapUiCalendarApp"+T);}if(s){if(b.getConfiguration().getRTL()){r.style("border-right-color",s);}else{r.style("border-left-color",s);}}r.style(k?"right":"left","calc("+(i*100)/e+"% + "+B+"px)");r.style(k?"left":"right","calc("+(R*100)/e+"% + "+B+"px)");r.style("top",(l*D.appHeight+D.cellHeaderHeight)+"rem");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(A.getSelected()){r.class("sapUiCalendarAppSel");}if(A.getTentative()){r.class("sapUiCalendarAppTent");}if(h){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(s){r.style("background-color",A._getCSSColorForBackground(s));}r.openEnd();if(d.hasPrevious<0){n=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",n,{title:null});}if(h){n=["sapUiCalendarAppIcon"];var p={};p["id"]=j+"-Icon";p["title"]=null;r.icon(h,n,p);}if(f){r.openStart("span",j+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(f,true);r.close("span");}if(d.hasNext<0){n=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",n,{title:null});}r.openStart("span",j+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(A));r.close("span");r.close("div");r.close("div");r.close("div");};
S.renderDayNames=function(r,o,l){var f=l.getFirstDayOfWeek(),s=o.getId(),d,e=b.getConfiguration().getCalendarType(),w=l.getDaysStandAlone("abbreviated",e),W=l.getDaysStandAlone("wide",e),D;r.openStart("div",s+"-Names");r.class("sapMSPCMonthDayNames");r.openEnd();for(var i=0;i<7;i++){D=(i+f)%7;d=s+"-WH"+D;r.openStart("div",d);r.class("sapUiCalWH");if(i===0){r.class("sapUiCalFirstWDay");}r.accessibilityState(null,{role:"columnheader",label:W[D]});r.openEnd();r.text(w[D%7]);r.close("div");}r.close("div");};
S.renderDndPlaceholder=function(r,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();r.renderControl(p);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarMonthView',['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate'],function(l,S,C,a){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarMonthView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 1;};
b.prototype.getScrollEntityCount=function(s,o){var n=a.fromLocalJSDate(s),m=s.getMonth()+o,i=o>0?1:-1;n.setMonth(m);while((m+12)%12!==n.getMonth()){n.setDate(n.getDate()-i);}return Math.abs(C._daysBetween(n,a.fromLocalJSDate(s)));};
b.prototype.calculateStartDate=function(s){return C.getFirstDateOfMonth(s).getJSDate();};
return b;});
sap.ui.predefine('sap/m/SinglePlanningCalendarRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){var h=c._getHeader(),g=c._getCurrentGrid();r.write("<div");r.writeControlData(c);r.writeAccessibilityState({role:"region",roledescription:c._oRB.getText("SPC_CONTROL_NAME"),labelledby:{value:h.getId()+"-Title "+g.getId()+"-nowMarkerText",append:true}});r.addClass("sapMSinglePC");r.writeClasses(c);r.write(">");r.renderControl(h);r.renderControl(g);r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarUtilities',[],function(){'use strict';
function A(d){this.data=d;this.level=0;this.width=1;this.prev=null;this.next=null;}
A.prototype.hasNext=function(){return this.next!==null;};
A.prototype.hasPrev=function(){return this.prev!==null;};
A.prototype.getData=function(){return this.data;};
function a(){this.head=null;this.tail=null;this.size=0;this.iterator=new b(this);}
a.prototype.getHeadNode=function(){return this.head;};
a.prototype.getTailNode=function(){return this.tail;};
a.prototype.getSize=function(){return this.size;};
a.prototype.isEmpty=function(){return this.getSize()===0;};
a.prototype.createNewNode=function(d){return new A(d);};
a.prototype.getIterator=function(){return this.iterator;};
a.prototype.indexOf=function(n,c){this.iterator.reset();var C,i=0;while(this.iterator.hasNext()){C=this.iterator.next();if(c(C)){return i;}i++;}return-1;};
a.prototype.add=function(d){var n=d;if(!(d instanceof A)){n=this.createNewNode(d);}if(this.isEmpty()){this.head=this.tail=n;}else{this.tail.next=n;n.prev=this.tail;this.tail=n;}this.size++;return true;};
a.prototype.insertFirst=function(d){if(this.isEmpty()){this.add(d);}else{var n=d;if(!(d instanceof A)){n=this.createNewNode(d);}n.next=this.head;this.head.prev=n;this.head=n;this.size++;return true;}};
a.prototype.insertAt=function(i,d){var c=this.getHeadNode(),p=0,n=d;if(!(d instanceof A)){n=this.createNewNode(d);}if(i<0){return false;}if(i===0){return this.insertFirst(d);}if(i>this.getSize()-1){return this.add(d);}while(p<i){c=c.next;p++;}c.prev.next=n;n.prev=c.prev;c.prev=n;n.next=c;this.size++;return true;};
a.prototype.insertAfterLevel=function(l,n){var i=this.indexOf(n,function(c){var L=c.level===l;if(c.next&&c.next.level===l){L=false;}return L;}),s=this.getSize();if(i+1===s||i===-1){return this.add(n);}else{return this.insertAt(i+1,n);}};
function b(l){this.list=l;this.stopIterationFlag=false;this.currentNode=null;}
b.prototype.next=function(){var c=this.currentNode;if(this.currentNode!==null){this.currentNode=this.currentNode.next;}return c;};
b.prototype.hasNext=function(){return this.currentNode!==null;};
b.prototype.reset=function(){this.currentNode=this.list.getHeadNode();return this;};
b.prototype.forEach=function(c,t){var C;t=t||this;this.reset();while(this.hasNext()&&!this.stopIterationFlag){C=this.next();c.call(t,C);}this.stopIterationFlag=false;};
b.prototype.interrupt=function(){this.stopIterationFlag=true;return this;};
return{iterator:b,node:A,list:a};});
sap.ui.predefine('sap/m/SinglePlanningCalendarView',['./library','sap/base/Log','sap/ui/core/Element'],function(l,L,E){"use strict";
var S=E.extend("sap.m.SinglePlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data"},title:{type:"string",group:"Appereance"}}}});
S.prototype.getEntityCount=function(){L.warning("This method should be implemented in one of the inherited classes.",this);};
S.prototype.getScrollEntityCount=function(){L.warning("This method should be implemented in one of the inherited classes.",this);};
S.prototype.calculateStartDate=function(d){L.warning("This method should be implemented in one of the inherited classes.",this);};
return S;});
sap.ui.predefine('sap/m/SinglePlanningCalendarWeekView',['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils'],function(l,S,C,a){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarWeekView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 7;};
b.prototype.getScrollEntityCount=function(){return 7;};
b.prototype.calculateStartDate=function(s){var c=C.fromLocalJSDate(s),o=a._getFirstDateOfWeek(c);return o.toLocalJSDate();};
return b;});
sap.ui.predefine('sap/m/SinglePlanningCalendarWorkWeekView',['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/LocaleData'],function(l,S,C,a,L){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarWorkWeekView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 5;};
b.prototype.getScrollEntityCount=function(){return 7;};
b.prototype.calculateStartDate=function(s){var c=C.fromLocalJSDate(s),o=a._getFirstDateOfWeek(c),d=this._getFormatSettingsLocaleData();if(o.getDay()===d.getWeekendEnd()){o.setDate(o.getDate()+1);}return o.toLocalJSDate();};
b.prototype._getFormatSettingsLocaleData=function(){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale());};
return b;});
sap.ui.predefine('sap/m/SlideTile',['./library','sap/ui/core/Control','sap/m/GenericTile','sap/ui/Device','sap/ui/core/Icon','./SlideTileRenderer',"sap/ui/events/KeyCodes","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery"],function(l,C,G,D,I,S,K,P,q){"use strict";var T=l.TileSizeBehavior;
var a=C.extend("sap.m.SlideTile",{metadata:{library:"sap.m",properties:{displayTime:{type:"int",group:"Appearance",defaultValue:5000},transitionTime:{type:"int",group:"Appearance",defaultValue:500},scope:{type:"sap.m.GenericTileScope",group:"Misc",defaultValue:"Display"},sizeBehavior:{type:"sap.m.TileSizeBehavior",defaultValue:T.Responsive},width:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.GenericTile",multiple:true,singularName:"tile",bindable:"bindable"},_pausePlayIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{press:{parameters:{scope:{type:"sap.m.GenericTileScope"},action:{type:"string"},domRef:{type:"any"}}}}}});
a.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_pausePlayIcon",new I({id:this.getId()+"-pause-play-icon",src:"sap-icon://media-pause",color:"#ffffff",size:"1rem",noTabStop:true}),true);};
a.prototype.onBeforeRendering=function(){G.prototype._initScopeContent.call(this,"sapMST");var A=this.getScope()===l.GenericTileScope.Actions;for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].showActionsView(A);}if(this._iCurrentTile>=0){this._iLastTile=this._iCurrentTile;}this._bNeedInvalidate=false;this._stopAnimation();this._sWidth=this._sHeight=undefined;this._iCurrentTile=this._iPreviousTile=undefined;};
a.prototype.onAfterRendering=function(){this._setupResizeClassHandler();var c=this.getTiles().length,s=this.getScope();this._removeGTFocus();this._iCurrAnimationTime=0;this._bAnimationPause=false;if(this._iLastTile>=0&&c>1){this._scrollToTile(this._iLastTile);}else{this._scrollToNextTile();}if(c>1&&s===l.GenericTileScope.Display){this._startAnimation();}if(s===l.GenericTileScope.Actions&&this._iCurrentTile>=0&&this._hasNewsContent(this._iCurrentTile)){this.addStyleClass("sapMSTDarkBackground");}};
a.prototype.exit=function(){this._stopAnimation();if(this._oMoreIcon){this._oMoreIcon.destroy();}if(this._oRemoveButton){this._oRemoveButton.destroy();}};
a.prototype.ontap=function(e){var s=this.getScope();this.$().focus();if(s===l.GenericTileScope.Actions){var p=this._getEventParams(e);this.firePress(p);e.preventDefault();}};
a.prototype.ontouchstart=function(e){if(this.getScope()===l.GenericTileScope.Display){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}else{this.addStyleClass("sapMSTHvr");}}};
a.prototype.ontouchend=function(e){this.removeStyleClass("sapMSTHvr");};
a.prototype.ontouchcancel=function(e){if(this.hasStyleClass("sapMSTIconPressed")){this.removeStyleClass("sapMSTIconPressed");}else{this.removeStyleClass("sapMSTHvr");}};
a.prototype.onkeydown=function(e){if(this.getScope()===l.GenericTileScope.Display){if(P.events.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeydown(e);}}};
a.prototype.onkeyup=function(e){var p;if(this.getScope()===l.GenericTileScope.Display){if(P.events.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeyup(e);return;}if(P.events.sapspace.fnCheck(e)){this._toggleAnimation();}if(e.which===K.B&&this._bAnimationPause){this._scrollToNextTile(true,true);}if(e.which===K.F&&this._bAnimationPause){this._scrollToNextTile(true,false);}}else if(this.getScope()===l.GenericTileScope.Actions){if(P.events.sapselect.fnCheck(e)){this.firePress(this._getEventParams(e));e.preventDefault();}else if(P.events.sapdelete.fnCheck(e)||P.events.sapbackspace.fnCheck(e)){p={scope:this.getScope(),action:G._Action.Remove,domRef:this._oRemoveButton.getPopupAnchorDomRef()};this.firePress(p);e.preventDefault();}}};
a.prototype.onsapspace=function(e){e.preventDefault();};
a.prototype.onmouseup=function(e){if(this.getScope()===l.GenericTileScope.Display){if(this.hasStyleClass("sapMSTIconPressed")){this._toggleAnimation();this.removeStyleClass("sapMSTIconPressed");}}};
a.prototype.onmousedown=function(e){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}};
a.prototype.setScope=function(v){if(this.getScope()!==v){if(v===l.GenericTileScope.Actions){this.setProperty("scope",v,true);this._bNeedInvalidate=true;this._stopAnimation(this._bNeedInvalidate);}else{this.setProperty("scope",v);}this._setTilePressState();}return this;};
a.prototype._setupResizeClassHandler=function(){var c=function(){if(this.getSizeBehavior()===T.Small||window.matchMedia("(max-width: 374px)").matches){this.$().addClass("sapMTileSmallPhone");}else{this.$().removeClass("sapMTileSmallPhone");}}.bind(this);q(window).resize(c);c();};
a.prototype._isFocusInsideST=function(){return this.$()[0]===document.activeElement||this.$().find(document.activeElement).length;};
a.prototype._removeGTFocus=function(){for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].$().removeAttr("tabindex");}};
a.prototype._toggleAnimation=function(){if(this.getTiles().length>1){if(this._bAnimationPause){this._startAnimation();}else{this._stopAnimation();}}this._updatePausePlayIcon();};
a.prototype._stopAnimation=function(n){this._iCurrAnimationTime+=Date.now()-this._iStartTime;clearTimeout(this._sTimerId);if(this._iCurrentTile!=undefined){var w=this.$("wrapper-"+this._iCurrentTile);w.stop();}if(this._iPreviousTile!=undefined){var W=this.$("wrapper-"+this._iPreviousTile);W.stop();}this._bAnimationPause=true;if(this._iCurrAnimationTime>this.getDisplayTime()){this._scrollToNextTile(true);}else{if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}if(n){this.invalidate();}}};
a.prototype._startAnimation=function(){var d=this.getDisplayTime()-this._iCurrAnimationTime;clearTimeout(this._sTimerId);this._sTimerId=setTimeout(function(){this._scrollToNextTile();}.bind(this),d);this._iStartTime=Date.now();this._bAnimationPause=false;};
a.prototype._scrollToTile=function(t){if(t>=0){var w=this.$("wrapper-"+t);var d=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";this._changeSizeTo(t);w.css(d,"0rem");this._iCurrentTile=t;if(this.getTiles()[t]){this._setAriaDescriptor();}this._updateTilesIndicator();}};
a.prototype._scrollToNextTile=function(p,b){var t=this._iCurrAnimationTime-this.getDisplayTime(),f,n,w,W,s,c,d,e,g,o;t=this.getTransitionTime()-(t>0?t:0);f=t===this.getTransitionTime();if(f){if(b){n=this._getPreviousTileIndex(this._iCurrentTile);}else{n=this._getNextTileIndex(this._iCurrentTile);}this._iPreviousTile=this._iCurrentTile;this._iCurrentTile=n;}W=this.$("wrapper-"+this._iCurrentTile);g=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";if(q.isNumeric(this._iPreviousTile)){w=this.$("wrapper-"+this._iPreviousTile);s=w.css("width");c=parseFloat(W.css("width"));d=parseFloat(s);e=d<c;if(e){this._changeSizeTo(this._iCurrentTile);}if(f){W.css(g,s);}o={};if(b){o[g]=s;}else{o[g]="-"+s;}w.animate(o,{duration:t,done:function(){if(!e){this._changeSizeTo(this._iCurrentTile);}w.css(g,"");}.bind(this)});if(b){o[g]="-"+s;W.animate(o,0);}o[g]="0rem";W.animate(o,{duration:t,done:function(){this._iCurrAnimationTime=0;if(this._bNeedInvalidate){this.invalidate();}if(!p){this._startAnimation();}}.bind(this)});}else{this._changeSizeTo(this._iCurrentTile);W.css(g,"0rem");}if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}this._updateTilesIndicator();};
a.prototype._setAriaDescriptor=function(){var t,s,b,c;s=this.getScope();b=this.getTiles();c=b[this._iCurrentTile];t=c._getAriaText().replace(/\s/g," ");if(s===l.GenericTileScope.Actions){t=this._oRb.getText("GENERICTILE_ACTIONS_ARIA_TEXT")+"\n"+t;}else if(b.length>1&&s===l.GenericTileScope.Display){t+="\n"+this._oRb.getText("SLIDETILE_MULTIPLE_CONTENT")+"\n"+this._oRb.getText("SLIDETILE_TOGGLE_SLIDING");if(this._bAnimationPause){t+="\n"+this._oRb.getText("SLIDETILE_SCROLL_BACK")+"\n"+this._oRb.getText("SLIDETILE_SCROLL_FORWARD");}}t+="\n"+this._oRb.getText("SLIDETILE_ACTIVATE");this.$().attr("aria-label",t);};
a.prototype._changeSizeTo=function(t){var o=this.getTiles()[t];if(!o){return;}if(this._sFrameType){this.$().removeClass(this._sFrameType);}if(this._sSize){this.$().removeClass(this._sSize);}this.$().addClass(o.getFrameType()).addClass(o.getSize());this._sFrameType=o.getFrameType();this._sSize=o.getSize();};
a.prototype._getPreviousTileIndex=function(t){if(t>0){return t-1;}else{return this.getTiles().length-1;}};
a.prototype._getNextTileIndex=function(t){if(t+1<this.getTiles().length){return t+1;}else{return 0;}};
a.prototype._updateTilesIndicator=function(){var $;for(var i=0;i<this.getTiles().length;i++){$=this.$("tileIndicator-"+i);if(i===this._iCurrentTile){$.addClass("sapMSTActive");}else{$.removeClass("sapMSTActive");}}};
a.prototype._updatePausePlayIcon=function(){if(this._bAnimationPause){this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-play");this.$().removeClass("sapMSTPauseIcon");}else{this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-pause");this.$().addClass("sapMSTPauseIcon");}};
a.prototype._setTilePressState=function(){var t=this.getTiles(),b=this.getScope()===l.GenericTileScope.Display;for(var i=0;i<t.length;i++){t[i].setPressEnabled(b);}};
a.prototype._hasNewsContent=function(t){var b=this.getTiles()[t].getTileContent();for(var i=0;i<b.length;i++){if(b[i]._getContentType()==="News"){return true;}}return false;};
a.prototype._getEventParams=G.prototype._getEventParams;return a;});
sap.ui.predefine('sap/m/SlideTileRenderer',['./library',"sap/base/security/encodeCSS"],function(l,e){"use strict";var G=l.GenericTileScope;var S={};
S.render=function(r,c){var t=c.getTooltip_AsString(),s=c.getScope(),a=e("sapMSTScope"+s),L;r.write("<div");r.writeControlData(c);r.addClass("sapMST");r.addClass(a);if(!this._bAnimationPause){r.addClass("sapMSTPauseIcon");}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex","0");r.writeAttribute("role","presentation");r.write(">");L=c.getTiles().length;if(L>1&&s===G.Display){this._renderPausePlayIcon(r,c);this._renderTilesIndicator(r,c);}this._renderTiles(r,c,L);if(s===G.Actions){this._renderActionsScope(r,c);}r.write("<div");r.addClass("sapMSTFocusDiv");r.writeClasses();r.writeAttribute("id",c.getId()+"-focus");r.write(">");r.write("</div>");r.write("</div>");};
S._renderTiles=function(r,c,L){r.write("<div");r.addClass("sapMSTOverflowHidden");r.writeClasses();r.write(">");for(var i=0;i<L;i++){r.write("<div");r.writeAttribute("id",c.getId()+"-wrapper-"+i);r.addClass("sapMSTWrapper");r.writeClasses();r.write(">");r.renderControl(c.getTiles()[i]);r.write("</div>");}r.write("</div>");};
S._renderTilesIndicator=function(r,c){var p=c.getTiles().length;r.write("<div");r.writeAttribute("id",c.getId()+"-tilesIndicator");r.addClass("sapMSTBulleted");r.writeClasses();r.write(">");for(var i=0;i<p;i++){r.write("<span");r.writeAttribute("id",c.getId()+"-tileIndicator-"+i);r.write(">");r.write("</span>");}r.write("</div>");};
S._renderPausePlayIcon=function(r,c){if(c.getTiles().length>1){r.write("<div");r.addClass("sapMSTIconClickTapArea");r.writeClasses();r.write(">");r.write("</div>");r.write("<div");r.addClass("sapMSTIconDisplayArea");r.writeClasses();r.write(">");r.write("</div>");r.write("<div");r.addClass("sapMSTIconNestedArea");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_pausePlayIcon"));r.write("</div>");}};
S._renderActionsScope=function(r,c){r.renderControl(c._oRemoveButton);r.renderControl(c._oMoreIcon);};
return S;},true);
sap.ui.predefine('sap/m/Slider',['sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/core/ResizeHandler','sap/base/Log','./library','./SliderTooltipContainer','./SliderTooltip','./SliderUtilities','./SliderRenderer','./ResponsiveScale',"sap/ui/thirdparty/jquery"],function(C,E,I,c,R,l,a,S,b,d,e,f,q){"use strict";var t=a.touch;
var g=C.extend("sap.m.Slider",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},step:{type:"float",group:"Data",defaultValue:1},progress:{type:"boolean",group:"Misc",defaultValue:true},value:{type:"float",group:"Data",defaultValue:0},showHandleTooltip:{type:"boolean",group:"Appearance",defaultValue:true},showAdvancedTooltip:{type:"boolean",group:"Appearance",defaultValue:false},inputsAsTooltips:{type:"boolean",group:"Appearance",defaultValue:false},enableTickmarks:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"scale",aggregations:{_tooltipContainer:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},scale:{type:"sap.m.IScale",multiple:false,singularName:"scale"},_defaultScale:{type:"sap.m.ResponsiveScale",multiple:false,visibility:"hidden"},_defaultTooltips:{type:"sap.m.SliderTooltipBase",multiple:true,visibility:"hidden"},customTooltips:{type:"sap.m.SliderTooltipBase",multiple:true},_handlesLabels:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}},liveChange:{parameters:{value:{type:"float"}}}},designtime:"sap/m/designtime/Slider.designtime"}});
E.apply(g.prototype,[true]);
g.prototype._getUsedScale=function(){if(!this.getEnableTickmarks()){return;}return this.getAggregation('scale')||this.getAggregation('_defaultScale');};
g.prototype._syncScaleUsage=function(){var h=this.getEnableTickmarks(),u=this.getAggregation('scale'),D=this.getAggregation("_defaultScale");if((D&&!h)||(u&&D)){this.destroyAggregation("_defaultScale",true);}if(h&&!u&&!D){this.setAggregation("_defaultScale",new f(),true);}};
g.prototype._showTooltipsIfNeeded=function(){if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype._convertValueToRtlMode=function(v){return this.getMax()-v+this.getMin();};
g.prototype._recalculateStyles=function(){var s=this.$();this._fSliderWidth=s.width();this._fSliderPaddingLeft=parseFloat(s.css("padding-left"));this._fSliderOffsetLeft=s.offset().left;this._fHandleWidth=this.$("handle").width();};
g.prototype._validateProperties=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),h=false,i=false;if(m>=M){h=true;i=true;l.warning("Warning: "+"Property wrong min: "+m+" >= max: "+M+" on ",this);}if(s<=0){l.warning("Warning: "+"The step could not be negative on ",this);}if(s>(M-m)&&!h){i=true;l.warning("Warning: "+"Property wrong step: "+s+" > max: "+M+" - "+"min: "+m+" on ",this);}return i;};
g.prototype._getPercentOfValue=function(v){return d.getPercentOfValue(v,this.getMin(),this.getMax());};
g.prototype._getValueOfPercent=function(p){var m=this.getMin(),v=(p*(this.getMax()-m)/100)+m,n=this.toFixed(v,this.getDecimalPrecisionOfNumber(this.getStep()));return Number(n);};
g.prototype._validateStep=function(s){if(typeof s==="undefined"){return 1;}if(typeof s!=="number"){l.warning('Warning: "iStep" needs to be a number',this);return 0;}if((Math.floor(s)===s)&&isFinite(s)){return s;}l.warning('Warning: "iStep" needs to be a finite interger',this);return 0;};
g.prototype._handleSliderResize=function(o){var s=this._getUsedScale();if(this.getEnableTickmarks()&&s&&s.handleResize){s.handleResize(o);}if(this.getShowAdvancedTooltip()){this._handleTooltipContainerResponsiveness();}};
g.prototype._handleTooltipContainerResponsiveness=function(){this.getAggregation("_tooltipContainer").setWidth(this.$().width()+"px");};
g.prototype.getDecimalPrecisionOfNumber=function(v){if(Math.floor(v)===v){return 0;}var V=v.toString(),i=V.indexOf("."),h=V.indexOf("e-"),j=h!==-1,k=i!==-1;if(j){var m=+V.slice(h+2);if(k){return m+V.slice(i+1,h).length;}return m;}if(k){return V.length-i-1;}return 0;};
g.prototype.toFixed=function(n,D){if(D===undefined){D=this.getDecimalPrecisionOfNumber(n);}if(D>20){D=20;}else if(D<0){D=0;}return n.toFixed(D)+"";};
g.prototype.setDomValue=function(n){var D=this.getDomRef(),s=this._formatValueByCustomElement(n),T=this.getAggregation("_tooltipContainer");if(!D){return;}var p=Math.max(this._getPercentOfValue(+n),0)+"%",h=this.getDomRef("handle");if(!!this.getName()){this.getDomRef("input").setAttribute("value",s);}if(this.getProgress()){this.getDomRef("progress").style.width=p;}h.style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=p;if(this.getShowAdvancedTooltip()&&T.getDomRef()){this.updateAdvancedTooltipDom(n);}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=s;}this._updateHandleAriaAttributeValues(h,n,s);};
g.prototype._updateHandleAriaAttributeValues=function(h,v,s){if(this._isElementsFormatterNotNumerical(v)){h.setAttribute("aria-valuenow",v);h.setAttribute("aria-valuetext",s);}else{h.setAttribute("aria-valuenow",s);h.removeAttribute("aria-valuetext");}};
g.prototype._formatValueByCustomElement=function(v,p){var s=this._getUsedScale(),T=this.getUsedTooltips()[0],F=""+v;if(p==='slider'){return F;}if(this.getEnableTickmarks()&&s&&s.getLabel){F=""+s.getLabel(v,this);}if(p==='scale'){return F;}if(this.getShowAdvancedTooltip()&&T&&T.getLabel){F=""+T.getLabel(v,this);}return F;};
g.prototype._isElementsFormatterNotNumerical=function(v){var V=this._formatValueByCustomElement(v);return isNaN(V);};
g.prototype.updateAdvancedTooltipDom=function(n){var T=this.getUsedTooltips();this.updateTooltipsPositionAndState(T[0],parseFloat(n));};
g.prototype.getUsedTooltips=function(){var h=this.getCustomTooltips(),D=this.getAggregation("_defaultTooltips")||[];return h.length?h:D;};
g.prototype.updateTooltipsPositionAndState=function(T,v){var o=this.getAggregation("_tooltipContainer");T.setValue(v);o.repositionTooltips(this.getMin(),this.getMax());};
g.prototype.getClosestHandleDomRef=function(){return this.getDomRef("handle");};
g.prototype._increaseValueBy=function(i){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v+(i||1));n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}};
g.prototype._decreaseValueBy=function(D){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v-(D||1));n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}};
g.prototype._getLongStep=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),L=(M-m)/10,i=(M-m)/s;return i>10?L:s;};
g.prototype._fireChangeAndLiveChange=function(p){this.fireChange(p);this.fireLiveChange(p);};
g.prototype.handleTooltipChange=function(o){var n=parseFloat(o.getParameter("value"));this.setValue(n);this._fireChangeAndLiveChange({value:n});};
g.prototype._registerResizeHandler=function(){if(!this._parentResizeHandler){setTimeout(function(){this._parentResizeHandler=R.register(this,this._handleSliderResize.bind(this));}.bind(this),0);}};
g.prototype._deregisterResizeHandler=function(){if(this._parentResizeHandler){R.deregister(this._parentResizeHandler);this._parentResizeHandler=null;}};
g.prototype.init=function(){var s;this._iActiveTouchId=-1;this._bSetValueFirstCall=true;this._fValueBeforeFocus=0;this._parentResizeHandler=null;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTooltipContainer=null;s=new I({text:this._oResourceBundle.getText("SLIDER_HANDLE")});this.addAggregation("_handlesLabels",s);};
g.prototype.exit=function(){if(this._oResourceBundle){this._oResourceBundle=null;}this._deregisterResizeHandler();};
g.prototype.onBeforeRendering=function(){var h=this._validateProperties();if(!h){this.setValue(this.getValue());this._sProgressValue=Math.max(this._getPercentOfValue(this.getValue()),0)+"%";}if(this.getShowAdvancedTooltip()){this.initAndSyncTooltips(["leftTooltip"]);}this._deregisterResizeHandler();this._syncScaleUsage();};
g.prototype.forwardProperties=function(p,o){p.forEach(function(P){o.setProperty(P,this.getProperty(P),true);},this);};
g.prototype.forwardPropertiesToDefaultTooltips=function(T){var D=this.getAggregation("_defaultTooltips")||[];for(var i=0;i<T;i++){this.forwardProperties(["min","max","step"],D[i]);D[i].setProperty("width",this._getMaxTooltipWidth()+"px",true);D[i].setProperty("editable",this.getInputsAsTooltips(),true);}};
g.prototype.associateCustomTooltips=function(T){this.destroyAggregation("_defaultTooltips",true);this._oTooltipContainer.removeAllAssociation("associatedTooltips",true);for(var i=0;i<T;i++){this._oTooltipContainer.addAssociation("associatedTooltips",this.getCustomTooltips()[i],true);}};
g.prototype.assignDefaultTooltips=function(T){var D=this.getAggregation("_defaultTooltips")||[];if(D.length===0){this._oTooltipContainer.removeAllAssociation("associatedTooltips",true);T.forEach(function(i){this.initDefaultTooltip(i);},this);}this.forwardProperties(["enabled"],this._oTooltipContainer);this.forwardPropertiesToDefaultTooltips(T.length);};
g.prototype.initAndSyncTooltips=function(T){var h=this.getCustomTooltips(),i=h.length,m=T.length;this.initTooltipContainer();if(i<m){this.assignDefaultTooltips(T);}else{if(i>m){l.warning("Warning: More than "+m+" Custom Tooltips are provided. Only the first will be used.");}this.associateCustomTooltips(m);}};
g.prototype.initDefaultTooltip=function(i){var T=new b(this.getId()+"-"+i,{change:this.handleTooltipChange.bind(this)});this.getAggregation("_tooltipContainer").addAssociation("associatedTooltips",T,true);this.addAggregation("_defaultTooltips",T,true);};
g.prototype.initTooltipContainer=function(){if(!this._oTooltipContainer){this._oTooltipContainer=new S();this.setAggregation("_tooltipContainer",this._oTooltipContainer,true);}};
g.prototype._getMaxTooltipWidth=function(){var A=[Math.abs(this.getMin()),Math.abs(this.getMax())],r=A[0]>A[1]?0:1;return((A[r].toString()).length+this.getDecimalPrecisionOfNumber(this.getStep())+1)*d.CONSTANTS.CHARACTER_WIDTH_PX;};
g.prototype.onAfterRendering=function(){if(this.getShowAdvancedTooltip()){this._recalculateStyles();this._handleTooltipContainerResponsiveness();}this._handleSliderResize({control:this});this._registerResizeHandler();};
g.prototype.ontouchstart=function(o){var m=this.getMin(),T=o.targetTouches[0],n,h=this.getRenderer().CSS_CLASS,s="."+h;o.setMarked();if(o.target.className.indexOf("sapMInput")===-1){o.preventDefault();}this.focus();if(t.countContained(o.touches,this.getId())>1||!this.getEnabled()||o.button||(o.srcControl!==this)){return;}this._iActiveTouchId=T.identifier;q(document).on("touchend"+s+" touchcancel"+s+" mouseup"+s,this._ontouchend.bind(this)).on(o.originalEvent.type==="touchstart"?"touchmove"+s:"touchmove"+s+" mousemove"+s,this._ontouchmove.bind(this));var N=this.getClosestHandleDomRef();if(T.target!==N){setTimeout(N["focus"].bind(N),0);}this._recalculateStyles();this._fDiffX=this._fSliderPaddingLeft;this._fInitialValue=this.getValue();this.$("inner").addClass(h+"Pressed");if(T.target===this.getDomRef("handle")){this._fDiffX=(T.pageX-q(N).offset().left)+this._fSliderPaddingLeft-(this._fHandleWidth/2);}else{n=(((T.pageX-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(sap.ui.getCore().getConfiguration().getRTL()){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(this._fInitialValue!==n){this.fireLiveChange({value:n});}}};
g.prototype._ontouchmove=function(o){o.setMarked();o.preventDefault();if(o.isMarked("delayedMouseEvent")||!this.getEnabled()||o.button){return;}var m=this.getMin(),v=this.getValue(),T=t.find(o.changedTouches,this._iActiveTouchId),p=T?T.pageX:o.pageX,n=(((p-this._fDiffX-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(sap.ui.getCore().getConfiguration().getRTL()){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(v!==n){this.fireLiveChange({value:n});}};
g.prototype._ontouchend=function(o){var h=this.getRenderer().CSS_CLASS,s="."+h;o.setMarked();if(o.isMarked("delayedMouseEvent")||!this.getEnabled()||o.button){return;}q(document).off(s);var v=this.getValue();this.$("inner").removeClass(h+"Pressed");if(this._fInitialValue!==v){this.fireChange({value:v});}};
g.prototype.onfocusin=function(o){this._fValueBeforeFocus=this.getValue();if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);this._setAriaControls();this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype._setAriaControls=function(){var T=this.getUsedTooltips()[0],h=this.getFocusDomRef();if(this.getInputsAsTooltips()&&T&&T.getDomRef()){h.setAttribute("aria-controls",T.getId());}};
g.prototype.onfocusout=function(o){if(!this.getShowAdvancedTooltip()){return;}var s=q.contains(this.getDomRef(),o.relatedTarget),T=q.contains(this.getAggregation("_tooltipContainer").getDomRef(),o.relatedTarget);if(s||T){return;}this.getAggregation("_tooltipContainer").hide();};
g.prototype.onmouseover=function(o){var T,h;if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);h=this.getAggregation("_tooltipContainer");T=q.contains(h.getDomRef(),document.activeElement);this._setAriaControls();if(T){return;}this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype.onmouseout=function(o){if(!this.getShowAdvancedTooltip()){return;}var T=this.getAggregation("_tooltipContainer").getDomRef(),s=this.getDomRef(),h=q.contains(s,document.activeElement),i=q.contains(T,document.activeElement);if(!T||h||i){return;}if(q.contains(this.getDomRef(),o.toElement)||(s===o.toElement)){return;}if(q.contains(this.getAggregation("_tooltipContainer").getDomRef(),o.toElement)){return;}this.getAggregation("_tooltipContainer").hide();};
g.prototype.onkeydown=function(o){var T=this.getUsedTooltips();if(o.keyCode===d.CONSTANTS.F2_KEYCODE&&T[0]&&this.getInputsAsTooltips()){T[0].focus();}};
g.prototype.onsapincrease=function(o){var v,n;o.preventDefault();o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapincreasemodifiers=function(o){if(o.altKey){return;}o.preventDefault();o.stopPropagation();o.setMarked();this._increaseValueBy(this._getLongStep());this._showTooltipsIfNeeded();};
g.prototype.onsapdecrease=function(o){var v,n;o.preventDefault();o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapdecreasemodifiers=function(o){if(o.altKey){return;}o.preventDefault();o.stopPropagation();o.setMarked();this._decreaseValueBy(this._getLongStep());this._showTooltipsIfNeeded();};
g.prototype.onsapplus=function(o){var v,n;o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapminus=function(o){var v,n;o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapescape=function(){this.setValue(this._fValueBeforeFocus);};
g.prototype.onsappageup=g.prototype.onsapincreasemodifiers;g.prototype.onsappagedown=g.prototype.onsapdecreasemodifiers;
g.prototype.onsaphome=function(o){o.setMarked();var m=this.getMin();o.preventDefault();if(this.getEnabled()&&this.getValue()>m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}this._showTooltipsIfNeeded();};
g.prototype.onsapend=function(o){o.setMarked();var m=this.getMax();o.preventDefault();if(this.getEnabled()&&this.getValue()<m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}this._showTooltipsIfNeeded();};
g.prototype.getFocusDomRef=function(){return this.getDomRef("handle");};
g.prototype.stepUp=function(s){return this.setValue(this.getValue()+(this._validateStep(s)*this.getStep()),{snapValue:false});};
g.prototype.stepDown=function(s){return this.setValue(this.getValue()-(this._validateStep(s)*this.getStep()),{snapValue:false});};
g.prototype.setValue=function(n,o){if(this._bSetValueFirstCall){this._bSetValueFirstCall=false;return this.setProperty("value",n,true);}var m=this.getMin(),M=this.getMax(),s=this.getStep(),v=this.getValue(),N,h=true,i;if(o){h=!!o.snapValue;}if(typeof n!=="number"||!isFinite(n)){return this;}i=Math.abs((n-m)%s);if(h&&(i!==0)){n=i*2>=s?n+s-i:n-i;}if(n<m){n=m;}else if(n>M){n=M;}N=this.toFixed(n,this.getDecimalPrecisionOfNumber(s));n=Number(N);this.setProperty("value",n,true);if(v!==this.getValue()){this.setDomValue(N);}return this;};
return g;});
sap.ui.predefine('sap/m/SliderRenderer',['./SliderUtilities',"sap/ui/core/InvisibleText"],function(S,I){"use strict";var a={};a.CSS_CLASS="sapMSlider";
a.render=function(r,s){var e=s.getEnabled(),t=s.getTooltip_AsString(),C=a.CSS_CLASS,b=s.getAriaLabelledBy().reduce(function(A,i){return A+" "+i;},"");r.write("<div");this.addClass(r,s);if(!e){r.addClass(C+"Disabled");}r.addStyle("width",s.getWidth());r.writeClasses();r.writeStyles();r.writeControlData(s);if(t&&s.getShowHandleTooltip()){r.writeAttributeEscaped("title",s._formatValueByCustomElement(t));}r.write(">");r.write('<div');r.writeAttribute("id",s.getId()+"-inner");this.addInnerClass(r,s);if(!e){r.addClass(C+"InnerDisabled");}r.writeClasses();r.writeStyles();r.write(">");if(s.getProgress()){this.renderProgressIndicator(r,s,b);}this.renderHandles(r,s,b);r.write("</div>");if(s.getEnableTickmarks()){this.renderTickmarks(r,s);}else{this.renderLabels(r,s);}if(s.getName()){this.renderInput(r,s);}s.getAggregation("_handlesLabels").forEach(r.renderControl,r);r.write("</div>");};
a.renderProgressIndicator=function(r,s){r.write("<div");r.writeAttribute("id",s.getId()+"-progress");this.addProgressIndicatorClass(r,s);r.addStyle("width",s._sProgressValue);r.writeClasses();r.writeStyles();r.write(' aria-hidden="true"></div>');};
a.renderHandles=function(r,s,f){this.renderHandle(r,s,{id:s.getId()+"-handle",forwardedLabels:f});};
a.renderHandle=function(r,s,o){var e=s.getEnabled();r.write("<span");if(o&&(o.id!==undefined)){r.writeAttributeEscaped("id",o.id);}if(s.getShowHandleTooltip()&&!s.getShowAdvancedTooltip()){this.writeHandleTooltip(r,s);}if(s.getInputsAsTooltips()){r.writeAttribute("aria-describedby",I.getStaticId("sap.m","SLIDER_INPUT_TOOLTIP"));}this.addHandleClass(r,s);r.addStyle(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",s._sProgressValue);this.writeAccessibilityState(r,s,o);r.writeClasses();r.writeStyles();if(e){r.writeAttribute("tabindex","0");}r.write("></span>");};
a.writeHandleTooltip=function(r,s){r.writeAttribute("title",s._formatValueByCustomElement(s.toFixed(s.getValue())));};
a.renderInput=function(r,s){r.write('<input type="text"');r.writeAttribute("id",s.getId()+"-input");r.addClass(a.CSS_CLASS+"Input");if(!s.getEnabled()){r.write("disabled");}r.writeClasses();r.writeAttributeEscaped("name",s.getName());r.writeAttribute("value",s._formatValueByCustomElement(s.toFixed(s.getValue())));r.write("/>");};
a.writeAccessibilityState=function(r,s,o){var f=s.getValue(),n=s._isElementsFormatterNotNumerical(f),b=s._formatValueByCustomElement(f),v;if(s._getUsedScale()&&!n){v=b;}else{v=s.toFixed(f);}r.writeAccessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:v,labelledby:{value:(o.forwardedLabels+" "+s.getAggregation("_handlesLabels")[0].getId()).trim()}});if(n){r.writeAccessibilityState(s,{valuetext:b});}};
a.renderTickmarks=function(r,s){var i,t,T,l,f,b,c,o=s._getUsedScale();if(!s.getEnableTickmarks()||!o){return;}b=Math.abs(s.getMin()-s.getMax());c=s.getStep();l=o.getTickmarksBetweenLabels();t=o.calcNumberOfTickmarks(b,c,S.CONSTANTS.TICKMARKS.MAX_POSSIBLE);T=s._getPercentOfValue(this._calcTickmarksDistance(t,s.getMin(),s.getMax(),c));r.write("<ul class=\""+a.CSS_CLASS+"Tickmarks\">");this.renderTickmarksLabel(r,s,s.getMin());r.write("<li class=\""+a.CSS_CLASS+"Tick\" style=\"width: "+T+"%;\"></li>");for(i=1;i<t-1;i++){if(l&&(i%l===0)){f=i*T;this.renderTickmarksLabel(r,s,s._getValueOfPercent(f));}r.write("<li class=\""+a.CSS_CLASS+"Tick\" style=\"width: "+T+"%;\"></li>");}this.renderTickmarksLabel(r,s,s.getMax());r.write("<li class=\""+a.CSS_CLASS+"Tick\" style=\"width: 0;\"></li>");r.write("</ul>");};
a.renderTickmarksLabel=function(r,s,v){var o=s._getPercentOfValue(v);var l=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";var V;v=s.toFixed(v,s.getDecimalPrecisionOfNumber(s.getStep()));V=s._formatValueByCustomElement(v,'scale');r.write("<li class=\""+a.CSS_CLASS+"TickLabel\"");r.addStyle(l,(o+"%"));r.writeStyles();r.write(">");r.write("<div class=\""+a.CSS_CLASS+"Label\">");r.writeEscaped(V);r.write("</div>");r.write("</li>");};
a._calcTickmarksDistance=function(t,s,e,f){var b=Math.abs(s-e),m=Math.floor(b/f),i=Math.ceil(m/t);return s+(i*f);};
a.addClass=function(r,s){r.addClass(a.CSS_CLASS);};
a.addInnerClass=function(r,s){r.addClass(a.CSS_CLASS+"Inner");};
a.addProgressIndicatorClass=function(r,s){r.addClass(a.CSS_CLASS+"Progress");};
a.addHandleClass=function(r,s){r.addClass(a.CSS_CLASS+"Handle");};
a.renderLabels=function(r,s){s.getAggregation("_handlesLabels").forEach(r.renderControl,r);};
return a;},true);
sap.ui.predefine('sap/m/SliderTooltip',['./library','./SliderUtilities','./SliderTooltipBase','sap/ui/core/Control','sap/ui/core/library','./delegate/ValueStateMessage','./SliderTooltipRenderer'],function(L,S,a,C,c,V,b){"use strict";var d=c.ValueState;
var e=a.extend("sap.m.SliderTooltip",{metadata:{library:"sap.m",properties:{value:{type:"float",group:"Data",defaultValue:0,bindable:"bindable"},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},editable:{type:"boolean",defaultValue:false},step:{type:"float",group:"Data",defaultValue:1},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:d.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}}}}});
e.prototype.init=function(){this._oValueStateMessage=new V(this);this._fLastValidValue=0;};
e.prototype.getValueStateText=function(){return"";};
e.prototype.getFocusDomRef=function(){return this.$("input");};
e.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
e.prototype.setValue=function(v){v=this.validateProperty("value",v);a.prototype.setValue.call(this,v);return this.setProperty("value",v,true);};
e.prototype.sliderValueChanged=function(v){if(this.getDomRef()){this.getFocusDomRef().val(v);}this._fLastValidValue=v;this.setValueState(d.None);};
e.prototype.setEditable=function(E){E=this.validateProperty("editable",E);if(this.getDomRef()){this.getFocusDomRef().toggleClass(S.CONSTANTS.TOOLTIP_CLASS+"NotEditable");}return this.setProperty("editable",E,true);};
e.prototype.setValueState=function(v){var E,o;v=this.validateProperty("valueState",v);this.setProperty("valueState",v,true);E=(v===d.Error);o=this.getDomRef()&&E;this._oValueStateMessage[o?"open":"close"]();this.$().toggleClass(S.CONSTANTS.TOOLTIP_CLASS+"ErrorState",E);return this;};
e.prototype.onfocusout=function(E){var v=parseFloat(this.getFocusDomRef().val());this._validateValue(v);};
e.prototype.onsapenter=function(E){var v=parseFloat(this.getFocusDomRef().val());this._validateValue(v);};
e.prototype.onsapescape=function(E){this.sliderValueChanged(this._fLastValidValue);this.setValueState(d.None);};
e.prototype._validateValue=function(v){if(this._isValueValid(v)){this.sliderValueChanged(v);this.fireChange({value:v});}else{this.setValueState(d.Error);}};
e.prototype._isValueValid=function(v){return!(isNaN(v)||v<this.getMin()||v>this.getMax());};
return e;});
sap.ui.predefine('sap/m/SliderTooltipBase',['sap/ui/core/Control','./library','./SliderTooltipBaseRenderer'],function(C,L,S){"use strict";
var a=C.extend("sap.m.SliderTooltipBase",{metadata:{library:"sap.m"}});
a.prototype.init=function(){this.fValue=0;};
a.prototype.setValue=function(v){this.fValue=v;this.sliderValueChanged(v);};
a.prototype.getValue=function(){return this.fValue;};
a.prototype.sliderValueChanged=function(v){};
return a;});
sap.ui.predefine('sap/m/SliderTooltipBaseRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={};S.CSS_CLASS="sapMSliderTooltip";
S.render=function(r,c){r.write("<div");r.writeControlData(c);r.writeClasses();r.write(">");this.renderTooltipContent(r,c);r.write("</div>");};
S.renderTooltipContent=function(r,c){};
return S;},true);
sap.ui.predefine('sap/m/SliderTooltipContainer',['./library','./SliderUtilities','sap/ui/core/Control','sap/ui/core/Popup','./SliderTooltipContainerRenderer',"sap/ui/thirdparty/jquery"],function(L,S,C,P,a,q){"use strict";
var b=C.extend("sap.m.SliderTooltipContainer",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"0px"}},associations:{associatedTooltips:{type:"sap.m.SliderTooltipBase",multiple:true}}}});
b.prototype.init=function(){this.oPopup=new P();this.oPopup.setShadow(false);this.oPopup.setAutoClose(false);this._scrollListener=this._getScrollListener();this._bClosedFromOverflow=false;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype._handleTabNavigation=function(e){var p=this._oParentSlider instanceof sap.m.RangeSlider;e.preventDefault();this[p?"_handleRangeSliderF2":"_handleSliderF2"].apply(this,arguments);};
b.prototype._handleSliderF2=function(){this._oParentSlider.focus();};
b.prototype._handleRangeSliderF2=function(e){var h=this._oParentSlider._getHandleForTooltip(e.srcControl);q(h).focus();};
b.prototype.onsaptabnext=b.prototype._handleTabNavigation;b.prototype.onsaptabprevious=b.prototype._handleTabNavigation;
b.prototype.onkeydown=function(e){if(e.keyCode===S.CONSTANTS.F2_KEYCODE){this._handleTabNavigation(e);}};
b.prototype.show=function(c){this.oPopup.setContent(this);this._$ParentSlider=c.$();this._oParentSlider=c;this.oPopup.open(0,P.Dock.BeginTop,P.Dock.BeginTop,this._$ParentSlider,'0 -24','flip');document.addEventListener("scroll",this._scrollListener,true);};
b.prototype._getScrollListener=function(){return function(){clearTimeout(this._scrollDebounce);this._scrollDebounce=setTimeout(this.repositionTooltips.bind(this),0);}.bind(this);};
b.prototype.hide=function(){this.oPopup.close();document.removeEventListener("scroll",this._scrollListener,true);};
b.prototype.repositionTooltips=function(){var p=this._oParentSlider instanceof sap.m.RangeSlider,t=this._oParentSlider.getUsedTooltips(),T=this.getAssociatedTooltipsAsControls()[0].$().outerHeight(true);if(this.getDomRef()){this[p?"_positionRangeTooltips":"_positionTooltip"].call(this,t,arguments[0],arguments[1]);this.getDomRef().style["top"]=(this._$ParentSlider.offset().top-T)+"px";this._handleOverflow();}};
b.prototype._positionTooltip=function(t,m,M){var T=this._getTooltipPosition(t[0].getValue(),m,M),A=this._bRtl?"right":"left";if(T){this.getDomRef().children[0].style[A]=T;}};
b.prototype._handleOverflow=function(){var p=this.getDomRef(),s,c;if(p){s=S.getElementScrollableParent(this._$ParentSlider[0].parentNode);c=S.isScrolledIntoView(this._$ParentSlider[0],s);if(!c){this._bClosedFromOverflow=true;this.hide();}}};
b.prototype._positionRangeTooltips=function(t,m,M){var r=this._bRtl,A=r?"right":"left",s=r?"left":"right",R=this._oParentSlider.getRange(),f=S.getPercentOfValue(R[0]>R[1]?R[1]:R[0],m,M),e=S.getPercentOfValue(R[0]>R[1]?R[0]:R[1],m,M),T=this.getAssociatedTooltipsAsControls()[0].$().outerWidth(),i=S.getPercentOfValue(+(t[0].getValue()),m,M),E=S.getPercentOfValue(+(t[1].getValue()),m,M),p=this._oParentSlider.$("progress"),c=this.$("container"),d=this._$ParentSlider.width(),o=false,g=T-S.CONSTANTS.TOOLTIP_SIDE_PADDING,h=(((g+S.CONSTANTS.CHARACTER_WIDTH_PX)/2)/d)*100,j=f-(h)-(h*2-(e-f))/2,k={"min-width":(2*T)+(S.CONSTANTS.TOOLTIP_BORDER*2)+"px"},l;k[A]="calc("+i+"%"+" - "+((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";k[s]="calc("+(100-E)+"% "+"- "+(T-((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH-S.CONSTANTS.TOOLTIP_BORDER))+"px)";if(p.outerWidth()<=(T/2)+(T-S.CONSTANTS.HANDLE_HALF_WIDTH)){k[A]="calc("+j+"%"+" + "+S.CONSTANTS.HANDLE_HALF_WIDTH+"px)";o=true;}c.css(k);l=this._$ParentSlider.offset();if((c.offset().left+c.outerWidth())>(l.left+this._$ParentSlider.outerWidth())){k=this[r?"_getStickedToStart":"_getStickedToEnd"].call(this,k,A,s,o);}if((c.offset().left<=l.left)){k=this[r?"_getStickedToEnd":"_getStickedToStart"].call(this,k,A,s,o);}c.css(k);};
b.prototype._getStickedToStart=function(c,A){c[A]="0";return c;};
b.prototype._getStickedToEnd=function(c,A,s,o){var t=this.getAssociatedTooltipsAsControls()[0].$().outerWidth();c[s]="calc(0% - "+(2*S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";if(o){c[A]="calc(100% - "+(t+(t-2*S.CONSTANTS.HANDLE_HALF_WIDTH))+"px)";}return c;};
b.prototype._getTooltipPosition=function(t,m,M){var p=S.getPercentOfValue(+(t),m,M),T=this.getAssociatedTooltipsAsControls()[0].$().outerWidth(),s=this._$ParentSlider.outerWidth(),f=(100*S.CONSTANTS.SLIDER_SIDE_PADDING)/s,c=((100*T)/s);if(p+f<(c/2)){return"0";}else if(p-f>100-(c/2)){return"calc(100% - "+(T-(S.CONSTANTS.HANDLE_HALF_WIDTH*2))+"px)";}else{return"calc("+p+"% - "+((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";}};
b.prototype.setWidth=function(w){if(this.getDomRef()){this.$().width(w);}return this.setProperty("width",w,true);};
b.prototype.getAssociatedTooltipsAsControls=function(){var A=this.getAssociation("associatedTooltips")||[];return A.map(function(t){return sap.ui.getCore().byId(t);});};
b.prototype.onmouseout=function(e){var s=q.contains(this._oParentSlider.getDomRef(),document.activeElement),c=q.contains(this.getDomRef(),document.activeElement),t=q.contains(this._oParentSlider.getDomRef(),e.toElement),T=q.contains(this.getDomRef(),e.toElement);if(s||c||t||T){return;}this.hide();};
b.prototype.onfocusout=function(e){if(q.contains(this._$ParentSlider[0],e.relatedTarget)||q.contains(this.getDomRef(),e.relatedTarget)){return;}if(this._bClosedFromOverflow){this._oParentSlider.focus();this._bClosedFromOverflow=false;}this.hide();};
b.prototype.onBeforeRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype.exit=function(){this._oParentSlider=null;this._$ParentSlider=null;document.removeEventListener("scroll",this._scrollListener,true);};
return b;});
sap.ui.predefine('sap/m/SliderTooltipContainerRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={},C={MAIN_CLASS:"sapMSliderTooltipContainer"};
S.render=function(r,c){var t=c.getAssociatedTooltipsAsControls();r.write("<div");r.writeControlData(c);r.addStyle("width",c.getWidth());r.writeStyles();r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-container");r.addStyle("left","0%");r.addStyle("right","0%");r.addClass(C.MAIN_CLASS);if(!c.getEnabled()){r.addClass(C.MAIN_CLASS+"Disabled");}r.writeClasses();r.writeStyles();r.write(">");if(t&&t.length){t.forEach(function(T){r.renderControl(T);});}r.write("</div>");r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/SliderTooltipRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={};S.CSS_CLASS="sapMSliderTooltip";
S.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass(S.CSS_CLASS);if(!c.getEditable()){r.addClass(S.CSS_CLASS+"NonEditableWrapper");}r.writeClasses();if(c.getWidth()){r.addStyle("width",c.getWidth());}r.writeStyles();r.write(">");this.renderTooltipElement(r,c);r.write("</div>");};
S.renderTooltipElement=function(r,c){var a=sap.ui.getCore().getConfiguration().getAccessibility();r.write('<input ');r.addClass(S.CSS_CLASS+"Input");if(!c.getEditable()){r.addClass(S.CSS_CLASS+"NonEditable");}if(a){r.writeAccessibilityState(c,{});}r.writeClasses();r.writeAttribute("tabindex","-1");r.writeAttributeEscaped("value",c.getValue());r.writeAttributeEscaped("type","number");r.writeAttributeEscaped("step",c.getStep());r.writeAttributeEscaped("id",c.getId()+"-input");r.write("/>");};
return S;},true);
sap.ui.predefine('sap/m/SliderUtilities',function(){"use strict";var S={};S.CONSTANTS={CHARACTER_WIDTH_PX:8,F2_KEYCODE:113,RANGE_MOVEMENT_THRESHOLD:32,HANDLE_CLASS:"sapMSliderHandle",RANGE_SLIDER_NAME:"sap.m.RangeSlider",TOOLTIP_CLASS:"sapMSliderTooltip",SLIDER_SIDE_PADDING:17,TOOLTIP_SIDE_PADDING:8,HANDLE_HALF_WIDTH:16,TOOLTIP_BORDER:1,FOLLOW_OF_TOLERANCE:24,TICKMARKS:{MAX_POSSIBLE:101,MIN_SIZE:{SMALL:8,WITH_LABEL:80}}};
S.getPercentOfValue=function(v,m,M){return((v-m)/(M-m))*100;};
S.getElementScrollableParent=function(d){if(!d){return document.body;}if(d.scrollHeight>=d.clientHeight){return d;}return this.getElementScrollableParent(d.parentNode);};
S.isScrolledIntoView=function(e,c){if(!(e||e.getBoundingClientRect)||!(c||c.getBoundingClientRect)){return false;}var C=c.getBoundingClientRect(),o=C.top,E=e.getBoundingClientRect().top,b=(o-this.CONSTANTS.FOLLOW_OF_TOLERANCE)>E,a=(o+C.height-this.CONSTANTS.FOLLOW_OF_TOLERANCE)<E;if(b||a){return false;}return true;};
return S;});
sap.ui.predefine('sap/m/SplitApp',['./SplitContainer','./library','sap/ui/Device','./SplitAppRenderer',"sap/ui/util/Mobile","sap/ui/thirdparty/jquery"],function(S,l,D,a,M,q){"use strict";
var b=S.extend("sap.m.SplitApp",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null}},events:{orientationChange:{parameters:{landscape:{type:"boolean"}}}},designtime:"sap/m/designtime/SplitApp.designtime"}});
b.prototype.init=function(){if(S.prototype.init){S.prototype.init.apply(this,arguments);}this.addStyleClass("sapMSplitApp");M.init({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});};
b.prototype.onBeforeRendering=function(){if(S.prototype.onBeforeRendering){S.prototype.onBeforeRendering.apply(this,arguments);}M.init({homeIcon:this.getHomeIcon()});};
b.prototype.onAfterRendering=function(){if(S.prototype.onAfterRendering){S.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;if(r&&!r._sapui5_heightFixed){r._sapui5_heightFixed=true;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}}};
b.prototype._onOrientationChange=function(){this.fireOrientationChange({landscape:D.orientation.landscape});};
return b;});
sap.ui.predefine('sap/m/SplitAppRenderer',['./SplitContainerRenderer','sap/ui/core/Renderer','sap/m/library'],function(S,R,l){"use strict";var B=l.BackgroundHelper;var a={};var a=R.extend(S);
a.renderAttributes=function(r,c){B.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
a.renderBeforeContent=function(r,c){B.renderBackgroundImageTag(r,c,"sapMSplitContainerBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return a;},true);
sap.ui.predefine('sap/m/SplitButton',['./library','sap/ui/core/Control','./Button','./ButtonRenderer','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/ui/core/InvisibleText','./SplitButtonRenderer',"sap/ui/events/KeyCodes"],function(l,C,B,a,E,I,c,D,b,S,K){"use strict";var T=c.TextDirection;var d=l.ButtonType;
var e=C.extend("sap.m.SplitButton",{metadata:{interfaces:["sap.m.IOverflowToolbarContent"],library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:d.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},aggregations:{_textButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{},arrowPress:{}}}});
E.call(e.prototype);
e.prototype.onAfterRendering=function(){var $=this._getTextButton().$(),f=this._getArrowButton().$();$.attr("tabindex","-1");f.attr("tabindex","-1");$.removeAttr("title");f.removeAttr("title");$.removeAttr("aria-describedby");f.removeAttr("aria-describedby");};
e.prototype._handleAction=function(i){if(i){this.fireArrowPress();}else{this.firePress();}};
e.prototype.setArrowState=function(i){var A=this.getAggregation("_arrowButton");if(!A){return;}if(i){A.$().addClass('sapMSBActive');}else{A.$().removeClass('sapMSBActive');}};
e.prototype._getTextButton=function(){var o=this.getAggregation("_textButton");if(!o){o=new B({width:'100%',icon:this.getIcon(),text:this.getText(),press:this._handleAction.bind(this,false)}).addStyleClass('sapMSBText');if(D.browser.msie){o.addStyleClass('sapMSBTextIE');}this.setAggregation("_textButton",o);}return o;};
e.prototype._getArrowButton=function(){var o=this.getAggregation("_arrowButton");if(!o){o=new B({icon:"sap-icon://slim-arrow-down",press:this._handleAction.bind(this,true)}).addStyleClass("sapMSBArrow");this.setAggregation("_arrowButton",o);}return o;};
e.prototype.setProperty=function(p,v,s){if(p==="type"&&(v===d.Up||v===d.Back||v===d.Unstyled)){return this;}var r=C.prototype.setProperty.apply(this,arguments);if(p==="activeIcon"||p==="iconDensityAware"||p==="textDirection"){B.prototype.setProperty.apply(this._getTextButton(),arguments);}else if(p==="text"||p==="type"||p==="icon"){var f="set"+_(p);B.prototype[f].call(this._getTextButton(),v);if(p==="type"){B.prototype[f].call(this._getArrowButton(),v);}}return r;};
function _(t){return t.charAt(0).toUpperCase()+t.slice(1);}
e.prototype.onkeydown=function(o){if(o.which===K.SPACE){o.preventDefault();}if(o.which===K.ENTER){this._getTextButton().firePress({});}};
e.prototype.onkeyup=function(o){if(o.which===K.SPACE){this._getTextButton().firePress({});}};
e.prototype.onsapup=function(o){this._getArrowButton().firePress();};
e.prototype.onsapdown=function(o){this._getArrowButton().firePress();};
e.prototype.onsapupmodifiers=function(o){this._getArrowButton().firePress();};
e.prototype.onsapdownmodifiers=function(o){this._getArrowButton().firePress();};
e.prototype.onsapshow=function(o){this._getArrowButton().firePress();o.preventDefault();};
e.prototype.getButtonTypeAriaLabelId=function(){var s=this._getTextButton().getType();return a.getButtonTypeAriaLabelId(s);};
e.prototype.getTitleAttributeValue=function(){var t=this.getTooltip_AsString(),i=I.getIconInfo(this.getIcon()),r;if(t||(i&&i.text&&!this.getText())){r=t||i.text;}return r;};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,propsUnrelatedToSize:["enabled","type","icon","activeIcon"],autoCloseEvents:["press"]};return o;};
return e;});
sap.ui.predefine('sap/m/SplitButtonRenderer',["sap/m/library","sap/ui/core/InvisibleText"],function(l,I){"use strict";var B=l.ButtonType;var S={};S.CSS_CLASS="sapMSB";
S.render=function(r,b){var w=b.getWidth(),t=b.getType(),e=b.getEnabled(),T=b.getTitleAttributeValue();r.write("<div");r.writeControlData(b);r.addClass(S.CSS_CLASS);if(b.getIcon()){r.addClass(S.CSS_CLASS+"HasIcon");}if(t===B.Accept||t===B.Reject||t===B.Emphasized||t===B.Transparent){r.addClass(S.CSS_CLASS+t);}r.writeClasses();this.writeAriaAttributes(r,b);r.writeAttribute("tabindex",e?"0":"-1");if(T){r.writeAttributeEscaped("title",T);}if(w!=""||w.toLowerCase()==="auto"){r.addStyle("width",w);r.writeStyles();}r.write(">");r.write("<div");r.addClass("sapMSBInner");if(!e){r.addClass("sapMSBInnerDisabled");}r.writeClasses();r.write(">");r.renderControl(b._getTextButton());r.renderControl(b._getArrowButton());r.write("</div>");r.write("</div>");};
S.writeAriaAttributes=function(r,b){var a={};this.writeAriaRole(b,a);this.writeAriaLabelledBy(b,a);r.writeAccessibilityState(b,a);};
S.writeAriaRole=function(b,a){a["role"]="group";};
S.writeAriaLabelledBy=function(b,a){var A="",o=b.getButtonTypeAriaLabelId();if(b.getText()){A+=b._getTextButton().getId()+"-content";A+=" ";}if(o){A+=o;A+=" ";}A+=I.getStaticId("sap.m","SPLIT_BUTTON_DESCRIPTION");A+=" "+I.getStaticId("sap.m","SPLIT_BUTTON_KEYBOARD_HINT");a["labelledby"]={value:A,append:true};};
return S;},true);
sap.ui.predefine('sap/m/SplitContainer',['./library','sap/ui/base/DataType','sap/ui/core/Control','sap/ui/core/IconPool','sap/m/semantic/SemanticPage','sap/ui/core/InvisibleText','sap/ui/Device','sap/ui/base/ManagedObject','sap/m/NavContainer','sap/m/Popover','sap/m/Button','./SplitContainerRenderer',"sap/ui/dom/containsOrEquals","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,D,C,I,S,a,b,M,N,P,B,c,d,L,q){"use strict";var e=l.ButtonType;var f=l.PlacementType;var g=l.SplitAppMode;
var h=C.extend("sap.m.SplitContainer",{metadata:{library:"sap.m",properties:{defaultTransitionNameDetail:{type:"string",group:"Appearance",defaultValue:"slide"},defaultTransitionNameMaster:{type:"string",group:"Appearance",defaultValue:"slide"},mode:{type:"sap.m.SplitAppMode",group:"Appearance",defaultValue:g.ShowHideMode},masterButtonText:{type:"string",group:"Appearance",defaultValue:null},masterButtonTooltip:{type:"string",group:"Appearance",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1}},aggregations:{masterPages:{type:"sap.ui.core.Control",multiple:true,singularName:"masterPage"},detailPages:{type:"sap.ui.core.Control",multiple:true,singularName:"detailPage"},_navMaster:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navDetail:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navPopover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},associations:{initialDetail:{type:"sap.ui.core.Control",multiple:false},initialMaster:{type:"sap.ui.core.Control",multiple:false}},events:{masterNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterMasterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},masterButton:{},beforeMasterOpen:{},afterMasterOpen:{},beforeMasterClose:{},afterMasterClose:{},detailNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterDetailNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}},designtime:"sap/m/designtime/SplitContainer.designtime"}});
h.prototype.init=function(){var t=this;if(sap.ui.getCore().getConfiguration().getAccessibility()&&!h._sAriaPopupLabelId){h._sAriaPopupLabelId=new a({text:''}).toStatic().getId();}this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aMasterPages=[];this._aDetailPages=[];if(!b.system.phone){this._oMasterNav=new N(this.getId()+"-Master",{width:"",navigate:function(E){t._handleNavigationEvent(E,false,true);},afterNavigate:function(E){t._handleNavigationEvent(E,true,true);t._updateMasterButtonTooltip();}});this._oDetailNav=new N(this.getId()+"-Detail",{width:"",navigate:function(E){t._handleNavigationEvent(E,false,false);},afterNavigate:function(E){t._handleNavigationEvent(E,true,false);}});this.setAggregation("_navMaster",this._oMasterNav,true);this.setAggregation("_navDetail",this._oDetailNav,true);this._createShowMasterButton();this._oPopOver=new P(this.getId()+"-Popover",{placement:f.Bottom,showHeader:false,contentWidth:"320px",contentHeight:"600px",beforeOpen:function(){t.fireBeforeMasterOpen();},beforeClose:function(){t.fireBeforeMasterClose();},afterOpen:function(){t.fireAfterMasterOpen();t._bMasterisOpen=true;},afterClose:function(){t._afterHideMasterAnimation();}}).addStyleClass("sapMSplitContainerPopover");if(h._sAriaPopupLabelId){this._oPopOver.addAriaLabelledBy(h._sAriaPopupLabelId);}this.setAggregation("_navPopover",this._oPopOver,true);}else{this._oMasterNav=this._oDetailNav=new N({width:"",navigate:function(E){t._handleNavigationEvent(E,false,true);},afterNavigate:function(E){t._handleNavigationEvent(E,true,true);}});this.setAggregation("_navMaster",this._oMasterNav,true);}this._oldIsLandscape=b.orientation.landscape;this._bMasterisOpen=false;var t=this;var p=function(r,n,s){return function(o,A,j){r.apply(t[n],arguments);if(A==="pages"&&t[s]&&t[s].indexOf(o)!==-1){t._removePageFromArray(t[s],o);}};};var m=this._oMasterNav._removeChild;this._oMasterNav._removeChild=p(m,"_oMasterNav","_aMasterPages");if(this._oDetailNav){var i=this._oDetailNav._removeChild;this._oDetailNav._removeChild=p(i,"_oDetailNav","_aDetailPages");}};
h.prototype.onBeforeRendering=function(){if(this._fnResize){b.resize.detachHandler(this._fnResize);}if(this._bMasterisOpen&&(this._portraitHide()||this._hideMode())){this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._bMasterisOpen=false;}this._updateMasterButtonTooltip();};
h.prototype.exit=function(){if(this._fnResize){b.resize.detachHandler(this._fnResize);}delete this._aMasterPages;delete this._aDetailPages;if(this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn=null;}};
h.prototype.onAfterRendering=function(){if(!b.system.phone&&this._oPopOver&&this._oPopOver.isOpen()){this._oPopOver.close();}if(!this._fnResize){this._fnResize=q.proxy(this._handleResize,this);}b.resize.attachHandler(this._fnResize);if(b.os.windows&&b.browser.internet_explorer){this._oMasterNav.$().append('<iframe class="sapMSplitContainerMasterBlindLayer" src="about:blank"></iframe>');}setTimeout(function(){this._oMasterNav.removeStyleClass("sapMSplitContainerNoTransition");}.bind(this),0);};
h.prototype.applySettings=function(s,o){C.prototype.applySettings.call(this,s,o);this._updateMasterInitialPage();};
h.prototype.ontouchstart=function(E){if(!b.system.phone){this._bIgnoreSwipe=(E.originalEvent&&E.originalEvent._sapui_handledByControl);}};
h.prototype.onswiperight=function(E){if(b.support.touch===false){return;}if((b.system.tablet||(b.os.windows&&b.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe&&!this._bDetailNavButton){this.showMaster();}};
h.prototype.ontap=function(E){if(b.system.phone){return;}var i=true,$=q(E.target).closest(".sapMSplitContainerDetail, .sapMSplitContainerMaster"),m=E.srcControl.getMetadata();if($.length>0&&$.hasClass("sapMSplitContainerDetail")){i=false;}if(((!this._oldIsLandscape&&this.getMode()=="ShowHideMode")||this.getMode()=="HideMode")&&!i&&!d(this._oShowMasterBtn.getDomRef(),E.target)&&(!m.getEvent("tap")||!m.getEvent("press"))){this.hideMaster();}};
h.prototype.onswipeleft=function(E){if((b.system.tablet||(b.os.windows&&b.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe){this.hideMaster();}};
h.prototype._onMasterButtonTap=function(E){if(b.system.phone){return;}if(!this._oldIsLandscape){if(this.getMode()=="PopoverMode"){if(!this._oPopOver.isOpen()){this._oPopOver.openBy(this._oShowMasterBtn,true);}else{this._oPopOver.close();}}else{this.showMaster();}}else{if(this.getMode()==="HideMode"){this.showMaster();}}};
h.prototype.to=function(p,t,i,T){if(this._oMasterNav.getPage(p)){this._oMasterNav.to(p,t,i,T);}else{this._oDetailNav.to(p,t,i,T);}};
h.prototype.backToPage=function(p,i,t){if(this._oMasterNav.getPage(p)){this._oMasterNav.backToPage(p,i,t);}else{this._oDetailNav.backToPage(p,i,t);}};
h.prototype.insertPreviousPage=function(p,t,i){if(this._oMasterNav.getPage(p)){this._oMasterNav.insertPreviousPage(p,t,i);}else{this._oDetailNav.insertPreviousPage(p,t,i);}return this;};
h.prototype.toMaster=function(p,t,i,T){this._oMasterNav.to(p,t,i,T);};
h.prototype.backMaster=function(i,t){this._oMasterNav.back(i,t);};
h.prototype.backMasterToPage=function(p,i,t){this._oMasterNav.backToPage(p,i,t);};
h.prototype.toDetail=function(p,t,i,T){this._oDetailNav.to(p,t,i,T);};
h.prototype.backDetail=function(i,t){this._oDetailNav.back(i,t);};
h.prototype.backDetailToPage=function(p,i,t){this._oDetailNav.backToPage(p,i,t);};
h.prototype.backToTopMaster=function(i,t){this._oMasterNav.backToTop(i,t);};
h.prototype.backToTopDetail=function(i,t){this._oDetailNav.backToTop(i,t);};
h.prototype.addMasterPage=function(p){if(this._hasPageInArray(this._aMasterPages,p)){return;}if(this._oMasterNav===this._oDetailNav&&this._oDetailNav.getPages()&&this._oDetailNav.getPages().indexOf(p)!==-1){this._removePageFromArray(this._aDetailPages,p);}this._oMasterNav.insertPage(p,this._aMasterPages.length);this._aMasterPages.push(p);return this;};
h.prototype.addDetailPage=function(p){var t=this,r=this._getRealPage(p);if(this._hasPageInArray(this._aDetailPages,p)){return;}p.addDelegate({onBeforeShow:function(){if(r){if(!b.system.phone){if(t._needShowMasterButton()){t._setMasterButton(r);}}}}});if(r){r.addDelegate({onBeforeRendering:function(){if(!b.system.phone&&(t._oDetailNav.getCurrentPage()===r)){if(!r.getShowNavButton()&&t._needShowMasterButton()){t._setMasterButton(r,true);}else{t._removeMasterButton(r);}}}});if(!b.system.phone){if(!r._setCustomHeaderInSC){r._setCustomHeaderInSC=r.setCustomHeader;}r.setCustomHeader=function(H){this._setCustomHeaderInSC.apply(this,arguments);if(H&&t._needShowMasterButton()){t._setMasterButton(r);}return this;};if(!r._setShowNavButtonInSC){r._setShowNavButtonInSC=r.setShowNavButton;}r.setShowNavButton=function(s){this._setShowNavButtonInSC.apply(this,arguments);if(!s&&t._needShowMasterButton()){t._setMasterButton(r);}else{t._removeMasterButton(r,true);}return this;};}}if(this._oMasterNav===this._oDetailNav&&this._oMasterNav.getPages()&&this._oMasterNav.getPages().indexOf(p)!==-1){this._removePageFromArray(this._aMasterPages,p);}this._oDetailNav.addPage(p);this._aDetailPages.push(p);return this;};
h.prototype.getMasterPages=function(){return this._aMasterPages.slice();};
h.prototype.getDetailPages=function(){return this._aDetailPages.slice();};
h.prototype.indexOfMasterPage=function(p){return this._indexOfMasterPage(p);};
h.prototype.indexOfDetailPage=function(p){return this._indexOfDetailPage(p);};
h.prototype.insertMasterPage=function(p,i,s){return this._insertPage(this._aMasterPages,"masterPages",p,i,s);};
h.prototype.removeMasterPage=function(p,s){return this._removePage(this._aMasterPages,"masterPages",p,s);};
h.prototype.removeAllMasterPages=function(s){this._aMasterPages=[];return this.removeAllAggregation("masterPages",s);};
h.prototype.insertDetailPage=function(p,i,s){return this._insertPage(this._aDetailPages,"detailPages",p,i,s);};
h.prototype._restoreMethodsInPage=function(p){if(b.system.phone){return;}var r=this._getRealPage(p);if(r){if(r._setCustomHeaderInSC){r.setCustomHeader=r._setCustomHeaderInSC;delete r._setCustomHeaderInSC;}if(r._setShowNavButtonInSC){r.setShowNavButton=r._setShowNavButtonInSC;delete r._setShowNavButtonInSC;}}};
h.prototype.removeDetailPage=function(p,s){this._restoreMethodsInPage(p);return this._removePage(this._aDetailPages,"detailPages",p,s);};
h.prototype.removeAllDetailPages=function(s){var p=this.getDetailPages();for(var i=0;i<p.length;i++){this._restoreMethodsInPage(p[i]);}this._aDetailPages=[];return this.removeAllAggregation("detailPages",s);};
h.prototype.addPage=function(p,m){if(m){return this.addMasterPage(p);}else{return this.addDetailPage(p);}};
h.prototype.showMaster=function(){var t=this,_=this._getRealPage(this._oDetailNav.getCurrentPage());function i(){this._oPopOver.detachAfterOpen(i,this);this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}if(this._portraitPopover()){if(!this._oPopOver.isOpen()){this._oPopOver.attachAfterOpen(i,this);this.fireBeforeMasterOpen();this._oPopOver.openBy(this._oShowMasterBtn,true);this._bMasterOpening=true;}}else if((this._portraitHide()||this._hideMode())&&(!this._bMasterisOpen||this._bMasterClosing)){this._oMasterNav.$().one("webkitTransitionEnd transitionend",q.proxy(this._afterShowMasterAnimation,this));this.fireBeforeMasterOpen();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",true);this._oMasterNav.getDomRef().offsetHeight;this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",false);this._bMasterOpening=true;t._removeMasterButton(_);if(b.browser.webkit){var m=this._oMasterNav;window.setTimeout(function(){m.$().css("box-shadow","none");window.setTimeout(function(){m.$().css("box-shadow","");},50);},0);}}return this;};
h.prototype.hideMaster=function(){if(this._portraitPopover()){if(this._oPopOver.isOpen()){this._oPopOver.close();this._bMasterClosing=true;}}else if((this._portraitHide()||this._hideMode())&&(this._bMasterisOpen||this._oMasterNav.$().hasClass("sapMSplitContainerMasterVisible"))){this._oMasterNav.$().one("webkitTransitionEnd transitionend",q.proxy(this._afterHideMasterAnimation,this));this.fireBeforeMasterClose();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.getDomRef().offsetHeight;this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterClosing=true;}return this;};
h.prototype._afterShowMasterAnimation=function(){if(this._portraitHide()||this._hideMode()){this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}};
h.prototype._afterHideMasterAnimation=function(){var o=this._getRealPage(this._oDetailNav.getCurrentPage());this._setMasterButton(o);this._bMasterClosing=false;this._bMasterisOpen=false;if(d(this._oMasterNav.getDomRef(),document.activeElement)){document.activeElement.blur();}this.fireAfterMasterClose();};
h.prototype.getCurrentMasterPage=function(){return this._oMasterNav.getCurrentPage();};
h.prototype.getCurrentDetailPage=function(){return this._oDetailNav.getCurrentPage();};
h.prototype.getCurrentPage=function(m){if(m){return this.getCurrentMasterPage();}else{return this.getCurrentDetailPage();}};
h.prototype.getPreviousPage=function(m){if(m){return this._oMasterNav.getPreviousPage();}else{return this._oDetailNav.getPreviousPage();}};
h.prototype.getMasterPage=function(p){return this._oMasterNav.getPage(p);};
h.prototype.getDetailPage=function(p){return this._oDetailNav.getPage(p);};
h.prototype.getPage=function(p,m){if(m){return this.getMasterPage(p);}else{return this.getDetailPage(p);}};
h.prototype.isMasterShown=function(){if(b.system.phone){var o=this._oMasterNav.getCurrentPage();return this._indexOfMasterPage(o)!==-1;}else{var m=this.getMode();switch(m){case g.StretchCompressMode:return true;case g.HideMode:return this._bMasterisOpen;case g.PopoverMode:case g.ShowHideMode:return b.orientation.landscape||this._bMasterisOpen;default:return false;}}};
h.prototype.setInitialMaster=function(p){this._oMasterNav.setInitialPage(p);this.setAssociation('initialMaster',p,true);return this;};
h.prototype.setInitialDetail=function(p){if(!b.system.phone){this._oDetailNav.setInitialPage(p);}this.setAssociation('initialDetail',p,true);return this;};
h.prototype.setDefaultTransitionNameDetail=function(t){this.setProperty("defaultTransitionNameDetail",t,true);this._oDetailNav.setDefaultTransitionName(t);return this;};
h.prototype.setDefaultTransitionNameMaster=function(t){this.setProperty("defaultTransitionNameMaster",t,true);this._oMasterNav.setDefaultTransitionName(t);return this;};
h.prototype.setMasterButtonText=function(t){if(!b.system.phone){if(!t){t=this._rb.getText("SplitContainer_NAVBUTTON_TEXT");}this._oShowMasterBtn.setText(t);}this.setProperty("masterButtonText",t,true);return this;};
h.prototype.setMode=function(m){var o=this.getMode();if(o===m){return this;}this.setProperty("mode",m,true);if(!b.system.phone&&this.getDomRef()){if(o==="HideMode"&&this._oldIsLandscape){this._removeMasterButton(this._oDetailNav.getCurrentPage());}var $=this.$();if(m!=="PopoverMode"&&this._oPopOver.getContent().length>0){this._updateMasterPosition("landscape");}else if(m=="PopoverMode"){if(!this._oldIsLandscape){if(this._oPopOver.getContent().length===0){this._updateMasterPosition("popover");}this._setMasterButton(this._oDetailNav.getCurrentPage());}$.toggleClass("sapMSplitContainerShowHide",false);$.toggleClass("sapMSplitContainerStretchCompress",false);$.toggleClass("sapMSplitContainerHideMode",false);$.toggleClass("sapMSplitContainerPopover",true);}if(m=="StretchCompressMode"){$.toggleClass("sapMSplitContainerShowHide",false);$.toggleClass("sapMSplitContainerPopover",false);$.toggleClass("sapMSplitContainerHideMode",false);$.toggleClass("sapMSplitContainerStretchCompress",true);this._removeMasterButton(this._oDetailNav.getCurrentPage());}if(m=="ShowHideMode"){$.toggleClass("sapMSplitContainerPopover",false);$.toggleClass("sapMSplitContainerStretchCompress",false);$.toggleClass("sapMSplitContainerHideMode",false);$.toggleClass("sapMSplitContainerShowHide",true);if(!b.orientation.landscape){this._setMasterButton(this._oDetailNav.getCurrentPage());}}if(m==="HideMode"){$.toggleClass("sapMSplitContainerPopover",false);$.toggleClass("sapMSplitContainerStretchCompress",false);$.toggleClass("sapMSplitContainerShowHide",false);$.toggleClass("sapMSplitContainerHideMode",true);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterisOpen=false;this._setMasterButton(this._oDetailNav.getCurrentPage());}}return this;};
h.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for SplitContainer.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
h.prototype._updateMasterInitialPage=function(){if(this.getMode()==="HideMode"&&b.system.phone&&this._aDetailPages){this._oMasterNav.setInitialPage(this.getInitialDetail()?this.getInitialDetail():(this.getInitialMaster()||this._aDetailPages[0]));}};
h.prototype._indexOfMasterPage=function(p){return this._aMasterPages.indexOf(p);};
h.prototype._indexOfDetailPage=function(p){return this._aDetailPages.indexOf(p);};
h.prototype._insertPage=function(p,A,o,j,s){this.insertAggregation(A,o,j,s);var i;if(j<0){i=0;}else if(j>p.length){i=p.length;}else{i=j;}var O=(p?Array.prototype.indexOf.call(p,o):-1);p.splice(i,0,o);if(O!=-1){this._removePageFromArray(p,o);}return this;};
h.prototype._removePage=function(p,A,o,s){var r=this.removeAggregation(A,o,s);if(r){this._removePageFromArray(p,r);}return r;};
h.prototype._removePageFromArray=function(p,o){var i=(p?Array.prototype.indexOf.call(p,o):-1);if(i!=-1){p.splice(i,1);if(p===this._aDetailPages){this._restoreMethodsInPage(o);}}};
h.prototype._handleNavigationEvent=function(E,A,m){var s=(A?"After":"")+(m?"Master":"Detail")+"Navigate",i;s=s.charAt(0).toLowerCase()+s.slice(1);i=this.fireEvent(s,E.mParameters,true);if(!i){E.preventDefault();}};
h.prototype._handleResize=function(){var i=b.orientation.landscape,_=this._oDetailNav.getCurrentPage(),m=this.getMode();if(this._oldIsLandscape!==i){this._oldIsLandscape=i;if(!b.system.phone){this.$().toggleClass("sapMSplitContainerPortrait",!i);if(m==="HideMode"){return;}if(m==="ShowHideMode"){if(i){this.fireBeforeMasterOpen();}else{this.fireBeforeMasterClose();}}if(m==="ShowHideMode"||m==="PopoverMode"){this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",i);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",!i);}if(m==="ShowHideMode"){if(i){this._bMasterisOpen=true;this.fireAfterMasterOpen();}else{this._bMasterisOpen=false;this.fireAfterMasterClose();}}if(m=="PopoverMode"){if(this._oPopOver.isOpen()){this._oPopOver.attachAfterClose(this._handlePopClose,this);this._oPopOver.close();}else{this._handlePopClose();}}_=this._getRealPage(_);if(!this._oldIsLandscape&&m!="StretchCompressMode"){this._setMasterButton(_);}else{this._removeMasterButton(_);}}if(this._onOrientationChange){this._onOrientationChange();}}};
h.prototype._handlePopClose=function(E){this._oPopOver.detachAfterClose(this._handlePopClose,this);if(this._oldIsLandscape){this._updateMasterPosition("landscape");}else{this._updateMasterPosition("popover");}};
h.prototype._getRealPage=function(p){var r=p,i;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.m.MessagePage){return r;}if(r instanceof S){return r;}if(r instanceof sap.ui.core.mvc.View){i=r.getContent();if(i.length===1){r=i[0];continue;}}else if(r instanceof N){r=r.getCurrentPage();continue;}r=null;}return r;};
h.prototype._updateMasterPosition=function(p){var t=this;if(p=="popover"){this.removeAggregation("_navMaster",this._oMasterNav,true);this._oMasterNav.$().remove();this._oPopOver.addContent(this._oMasterNav);this._bMasterisOpen=false;}if(p=="landscape"){var r=function(){t._oPopOver.removeAggregation("content",t._oMasterNav,false);t.setAggregation("_navMaster",t._oMasterNav,true);var $=t.$();if($[0]){var i=sap.ui.getCore().createRenderManager();i.renderControl(t._oMasterNav.addStyleClass("sapMSplitContainerMaster"));i.flush($[0],false,(t.$("BG")[0])?1:0);i.destroy();}};if(this._oPopOver.isOpen()){var A=function(){this._oPopOver.detachAfterClose(A,this);this._bMasterisOpen=false;r();};this._oPopOver.attachAfterClose(A,this);this._oPopOver.close();}else{r();}}};
h.prototype._portraitHide=function(){if(!this._oldIsLandscape&&!b.system.phone&&this.getMode()==="ShowHideMode"){return true;}else{return false;}};
h.prototype._portraitPopover=function(){if(!this._oldIsLandscape&&!b.system.phone&&this.getMode()==="PopoverMode"){return true;}else{return false;}};
h.prototype._hideMode=function(){return this.getMode()==="HideMode"&&!b.system.phone;};
h.prototype._needShowMasterButton=function(){return(this._portraitHide()||this._hideMode()||this._portraitPopover())&&(!this._bMasterisOpen||this._bMasterClosing);};
h.prototype._updateMasterButtonTooltip=function(){if(!this._oShowMasterBtn){return;}var t=this.getMasterButtonTooltip();if(t){this._oShowMasterBtn.setTooltip(t);return;}var p=this._oMasterNav.getCurrentPage();if(p&&p.getTitle){var T=p.getTitle();if(T){T=T.replace(/[_0-9]+$/,'');t=this._rb.getText('SPLITCONTAINER_NAVBUTTON_TOOLTIP',T);}}if(!t){t=this._rb.getText('SPLITCONTAINER_NAVBUTTON_DEFAULT_TOOLTIP');}this._oShowMasterBtn.setTooltip(t);};
h.prototype._createShowMasterButton=function(){if(this._oShowMasterBtn&&!this._oShowMasterBtn.bIsDestroyed){return;}this._oShowMasterBtn=new B(this.getId()+"-MasterBtn",{icon:I.getIconURI("menu2"),tooltip:this.getMasterButtonTooltip(),type:e.Default,press:q.proxy(this._onMasterButtonTap,this)}).addStyleClass("sapMSplitContainerMasterBtn");};
h.prototype._setMasterButton=function(p,j,s){if(!p){return;}if(typeof j==='boolean'){s=j;j=undefined;}p=this._getRealPage(p);if(!p){return;}var H=h._getHeaderButtonAggregation(p),k=H.sAggregationName,m=H.aAggregationContent;for(var i=0;i<m.length;i++){if(m[i]instanceof sap.m.Button&&m[i].getVisible()&&(m[i].getType()==e.Back||(m[i].getType()==e.Up&&m[i]!==this._oShowMasterBtn))){this._bDetailNavButton=true;return;}}this._bDetailNavButton=false;var o=p._getAnyHeader();var n=false;for(var i=0;i<m.length;i++){if(m[i]===this._oShowMasterBtn){n=true;}}if(!n){this._createShowMasterButton();this._updateMasterButtonTooltip();this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");if(o){o.insertAggregation(k,this._oShowMasterBtn,0,s);}}else{this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnHide",false);this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnShow",true);}if(j){j(p);}this.fireMasterButton({show:true});};
h._getHeaderButtonAggregation=function(p){var H=p._getAnyHeader(),A,s;if(!H){return;}if(H.getContentLeft){A=H.getContentLeft();s="contentLeft";}if(H.getContent){A=H.getContent();s="content";}return{aAggregationContent:A,sAggregationName:s};};
h.prototype._removeMasterButton=function(p,j,n){if(!p){return;}var t=this,H=this._oShowMasterBtn.$().is(":hidden"),o;if(typeof j==="boolean"){n=j;j=undefined;}if(!H&&!n){p=this._getRealPage(p);if(!p){return;}o=p._getAnyHeader();if(o){var k=h._getHeaderButtonAggregation(p).aAggregationContent;for(var i=0;i<k.length;i++){if(k[i]===this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn.$().parent().bind("webkitAnimationEnd animationend",function(){q(this).unbind("webkitAnimationEnd animationend");t._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(j){j(p);}});break;}}}this.fireMasterButton({show:false});}else{this._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(j){j(p);}if(!H){this.fireMasterButton({show:false});}}};
h.prototype._callMethodInManagedObject=function(F,A){var i=Array.prototype.slice.call(arguments);if(A==="masterPages"){if(F==="indexOfAggregation"){return this._indexOfMasterPage.apply(this,i.slice(2));}else{return this._callNavContainerMethod(F,this._oMasterNav,i);}}else if(A==="detailPages"){if(F==="indexOfAggregation"){return this._indexOfDetailPage.apply(this,i.slice(2));}else{return this._callNavContainerMethod(F,this._oDetailNav,i);}}else{return M.prototype[F].apply(this,i.slice(1));}};
h.prototype._callNavContainerMethod=function(F,n,A){A[1]="pages";A=A.slice(1);var r=h._mFunctionMapping[F];if(r){A.shift();F=r;}return n[F].apply(n,A);};
h.prototype._hasPageInArray=function(i,p){return i.some(function(A){return p&&(p===A);});};
h.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
h.prototype.setAggregation=function(A,o,s){this._callMethodInManagedObject("setAggregation",A,o,s);return this;};
h.prototype.getAggregation=function(A,o){return this._callMethodInManagedObject("getAggregation",A,o);};
h.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
h.prototype.insertAggregation=function(A,o,i,s){this._callMethodInManagedObject("insertAggregation",A,o,i,s);return this;};
h.prototype.addAggregation=function(A,o,s){this._callMethodInManagedObject("addAggregation",A,o,s);return this;};
h.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
h.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
h.prototype.destroyAggregation=function(A,s){this._callMethodInManagedObject("destroyAggregation",A,s);return this;};
h._mFunctionMapping={"getAggregation":"getPage","addAggregation":"addPage","insertAggregation":"insertPage","removeAggregation":"removePage","removeAllAggregation":"removeAllPages"};return h;});
sap.ui.predefine('sap/m/SplitContainerRenderer',["sap/ui/Device"],function(D){"use strict";var S={};
S.render=function(r,c){var m=c.getMode();r.write("<div");r.writeControlData(c);r.addClass("sapMSplitContainer");if(this.renderAttributes){this.renderAttributes(r,c);}if(!D.system.phone){if(D.orientation.portrait){r.addClass("sapMSplitContainerPortrait");}switch(m){case"ShowHideMode":r.addClass("sapMSplitContainerShowHide");break;case"StretchCompress":r.addClass("sapMSplitContainerStretchCompress");break;case"PopoverMode":r.addClass("sapMSplitContainerPopover");break;case"HideMode":r.addClass("sapMSplitContainerHideMode");break;}}r.writeClasses();r.writeStyles();var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}r.write(">");if(this.renderBeforeContent){this.renderBeforeContent(r,c);}if(!D.system.phone){c._bMasterisOpen=false;if((D.orientation.landscape&&(m!=="HideMode"))||D.orientation.portrait&&(m==="StretchCompress")){c._oMasterNav.addStyleClass("sapMSplitContainerMasterVisible");c._bMasterisOpen=true;}else{c._oMasterNav.addStyleClass("sapMSplitContainerMasterHidden sapMSplitContainerNoTransition");}if(c.getMode()==="PopoverMode"&&D.orientation.portrait){c._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(c._oDetailNav);if(c._oPopOver.getContent().length===0){c._oPopOver.addAggregation("content",c._oMasterNav,true);}}else{c._oMasterNav.addStyleClass("sapMSplitContainerMaster");r.renderControl(c._oMasterNav);c._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(c._oDetailNav);}}else{c._oMasterNav.addStyleClass("sapMSplitContainerMobile");r.renderControl(c._oMasterNav);}r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/StandardListItem',["sap/ui/core/library","sap/ui/core/IconPool","sap/ui/Device","./library","./ListItemBase","./Image","./StandardListItemRenderer"],function(c,I,D,l,L,a,S){"use strict";var T=c.TextDirection;var V=c.ValueState;
var b=L.extend("sap.m.StandardListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconInset:{type:"boolean",group:"Appearance",defaultValue:true},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},adaptTitleSize:{type:"boolean",group:"Appearance",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},infoTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},wrapping:{type:"boolean",group:"Behavior",defaultValue:false}},designtime:"sap/m/designtime/StandardListItem.designtime"}});
b.prototype.exit=function(){if(this._oImage){this._oImage.destroy("KeepDom");}L.prototype.exit.apply(this,arguments);};
b.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oImage&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oImage.destroy("KeepDom");this._oImage=undefined;}return this;};
b.prototype._getImage=function(){var i=this._oImage;if(i){i.setSrc(this.getIcon());if(i.setDensityAware){i.setDensityAware(this.getIconDensityAware());}}else{i=I.createControlByURI({id:this.getId()+"-img",src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false},a).setParent(this,null,true);}var s=this.getIconInset()?"sapMSLIImg":"sapMSLIImgNoInset";i.addStyleClass(i instanceof a?s:s+"Icon",true);this._oImage=i;return this._oImage;};
b.prototype._activeHandlingInheritor=function(){if(this._oImage){var A=this.getActiveIcon();A&&this._oImage.setSrc(A);}};
b.prototype._inactiveHandlingInheritor=function(){if(this._oImage){this._oImage.setSrc(this.getIcon());}};
b.prototype.getContentAnnouncement=function(B){var A="",i=this.getInfoState(),t,s="",d,e="",o,f;if(this.getWrapping()){o=this.getDomRef("titleButton");f=this.getDomRef("descriptionButton");t=this._bTitleTextExpanded?this.getTitle():this._getCollapsedText(this.getTitle());d=this._bDescriptionTextExpanded?this.getDescription():this._getCollapsedText(this.getDescription());if(o){s=o.textContent+" "+B.getText("ACC_CTR_TYPE_BUTTON");}if(f){e=f.textContent+" "+B.getText("ACC_CTR_TYPE_BUTTON");}A+=t+" "+s+" "+d+" "+e+" ";}else{A+=this.getTitle()+" "+this.getDescription()+" ";}A+=this.getInfo()+" ";if(i!="None"&&i!=this.getHighlight()){A+=B.getText("LIST_ITEM_STATE_"+i.toUpperCase());}return A;};
b.prototype.ontap=function(e){this._checkExpandCollapse(e);if(!e.isMarked()){return L.prototype.ontap.apply(this,arguments);}};
b.prototype.onsapspace=function(e){this._checkExpandCollapse(e,true);if(!e.isMarked()){return L.prototype.onsapspace.apply(this,arguments);}};
b.prototype._checkExpandCollapse=function(e,p){var t=e.target,i=t&&t.id;if(i&&i===this.getId()+"-titleButton"){if(p){e.preventDefault();}e.setMarked();return this._toggleExpandCollapse("title",this._bTitleTextExpanded);}if(i&&i===this.getId()+"-descriptionButton"){if(p){e.preventDefault();}e.setMarked();return this._toggleExpandCollapse("description",this._bDescriptionTextExpanded);}};
b.prototype._toggleExpandCollapse=function(w,t){var o=this.getDomRef(w+"Text"),d=this.getDomRef(w+"ThreeDots"),B=this.getDomRef(w+"Button"),s=w==="title"?this.getTitle():this.getDescription(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!t){o.textContent=s;d.textContent=" ";B.textContent=r.getText("TEXT_SHOW_LESS");t=true;}else{o.textContent=this._getCollapsedText(s);d.textContent=" ... ";B.textContent=r.getText("TEXT_SHOW_MORE");t=false;}if(w==="title"){this._bTitleTextExpanded=t;}else{this._bDescriptionTextExpanded=t;}};
b.prototype._getCollapsedText=function(t){var m=D.system.phone?100:300;return t.substr(0,m);};
return b;});
sap.ui.predefine('sap/m/StandardListItemRenderer',["sap/ui/core/library","sap/ui/core/Core","sap/ui/core/Renderer","sap/ui/core/IconPool","sap/ui/Device","./library","./ListItemBaseRenderer"],function(c,C,R,I,D,l,L){"use strict";var T=c.TextDirection;var S=R.extend(L);S.apiVersion=2;
S.renderLIAttributes=function(r,o){var i=o.getIcon(),t=o.getTitle();r.class("sapMSLI");if(i&&!I.isIconURI(i)){r.class("sapMSLIThumbnail");}if(!o.getIconInset()){r.class("sapMSLINoIconInset");}if(t&&o.getDescription()){r.class("sapMSLIWithDescription");}if(t&&!o.getAdaptTitleSize()){r.class("sapMSLINoTitleAdapt");}if(t&&o.getWrapping()){r.class("sapMSLIWrapping");}};
S.renderLIContent=function(r,o){var i=o.getInfo(),t=o.getTitle(),d=o.getDescription(),a=o.getAdaptTitleSize(),s=!t&&i;if(o.getIcon()){r.renderControl(o._getImage());}r.openStart("div").class("sapMSLIDiv");if((!d&&a&&i)||s){r.class("sapMSLIInfoMiddle");}r.openEnd();this.renderTitleWrapper(r,o);if(t&&d){this.renderDescription(r,o);}if(s&&!o.getWrapping()){this.renderInfo(r,o);}r.close("div");};
S.renderTitleWrapper=function(r,o){var t=o.getTitleTextDirection(),s=o.getTitle(),d=o.getDescription(),i=o.getInfo(),w=o.getWrapping(),b=!s&&i;r.openStart("div");if(!b&&d){r.class("sapMSLITitle");}else{r.class("sapMSLITitleOnly");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(w){this.renderWrapping(r,o,"title");if(s&&i&&!d){this.renderInfo(r,o);}}else{this.renderTitle(r,o);}r.close("div");if(i&&!d&&!w&&!b){this.renderInfo(r,o);}};
S.renderTitle=function(r,o){r.text(o.getTitle());};
S.renderDescription=function(r,o){var w=o.getWrapping(),d=o.getDescription(),i=o.getInfo();r.openStart("div").class("sapMSLIDescription");if(i){r.class("sapMSLIDescriptionAndInfo");}r.openEnd();if(i){r.openStart("div").class("sapMSLIDescriptionText").openEnd();if(w){this.renderWrapping(r,o,"description");this.renderInfo(r,o);}else{r.text(d);}r.close("div");if(!w){this.renderInfo(r,o);}}else if(w){this.renderWrapping(r,o,"description");}else{r.text(d);}r.close("div");};
S.renderInfo=function(r,o){var i=o.getInfoTextDirection();r.openStart("div",o.getId()+"-info");if(i!==T.Inherit){r.attr("dir",i.toLowerCase());}r.class("sapMSLIInfo");r.class("sapMSLIInfo"+o.getInfoState());r.openEnd();r.text(o.getInfo());r.close("div");};
S.renderExpandCollapse=function(r,o,w){var i=o.getId(),t=w=="title"?true:false,b=t?o._bTitleTextExpanded:o._bDescriptionTextExpanded,a=C.getLibraryResourceBundle("sap.m");r.openStart("span",i+"-"+w+"ThreeDots").openEnd();r.text(b?" ":" ... ");r.close("span");r.openStart("span",t?i+"-titleButton":i+"-descriptionButton").class("sapMSLIExpandCollapse");r.attr("tabindex","0").attr("role","button").attr("aria-live","polite");r.openEnd();r.text(a.getText(b?"TEXT_SHOW_LESS":"TEXT_SHOW_MORE"));r.close("span");};
S.renderWrapping=function(r,o,w){var i=o.getId(),t=w=="title"?true:false,s=t?o.getTitle():o.getDescription(),b=t?o._bTitleTextExpanded:o._bDescriptionTextExpanded,m=D.system.phone?100:300;r.openStart("span",i+"-"+w+"Text").attr("aria-live","polite").openEnd();if(!b){var a=o._getCollapsedText(s);r.text(a);}else if(t){this.renderTitle(r,o);}else{r.text(o.getDescription());}r.close("span");if(s.length>m){this.renderExpandCollapse(r,o,w);}};
return S;},true);
sap.ui.predefine('sap/m/StandardTile',['./Tile','./library','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','./StandardTileRenderer'],function(T,l,I,c,D,S){"use strict";var a=l.ImageHelper;var b=l.StandardTileType;var V=c.ValueState;
var d=T.extend("sap.m.StandardTile",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},type:{type:"sap.m.StandardTileType",group:"Misc",defaultValue:b.None},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}}}});
d.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
d.prototype.ontap=function(){if(D.browser.msie){this.focus();}T.prototype.ontap.apply(this,arguments);};
d.prototype.getIcon=function(){if(!this.getProperty("icon")&&this.getType()==="Create"){return I.getIconURI("add");}else{return this.getProperty("icon");}};
d.prototype._getImage=function(){var i=this.getId()+"-img";var s=D.system.phone?"1.3rem":"2rem";var p={src:this.getIcon(),height:s,width:s,size:s,densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=a.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
return d;});
sap.ui.predefine('sap/m/StandardTileRenderer',['./TileRenderer','sap/ui/core/ValueStateSupport','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library'],function(T,V,R,l,c){"use strict";var a=c.ValueState;var S=l.StandardTileType;var b=R.extend(T);
b._renderContent=function(r,t){var i=t.getInfoState();r.write("<div");r.addClass("sapMStdTileTopRow");r.writeClasses();r.write(">");if(t.getIcon()){r.write("<div");r.addClass("sapMStdTileIconDiv");switch(t.getType()){case S.Monitor:r.addClass("sapMStdIconMonitor");break;case S.Create:r.addClass("sapMStdIconCreate");break;}r.writeClasses();r.write(">");r.renderControl(t._getImage());r.write("</div>");}if(t.getNumber()){r.write("<div");r.addClass("sapMStdTileNumDiv");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",t.getId()+"-number");var n=t.getNumber().length;if(n<5){r.addClass("sapMStdTileNum");}else if(n<8){r.addClass("sapMStdTileNumM");}else{r.addClass("sapMStdTileNumS");}r.writeClasses();r.write(">");r.writeEscaped(t.getNumber());r.write("</div>");if(t.getNumberUnit()){r.write("<div");r.writeAttribute("id",t.getId()+"-numberUnit");r.addClass("sapMStdTileNumUnit");r.writeClasses();r.write(">");r.writeEscaped(t.getNumberUnit());r.write("</div>");}r.write("</div>");}r.write("</div>");r.write("<div");r.addClass("sapMStdTileBottomRow");if(t.getType()===S.Monitor){r.addClass("sapMStdTileMonitorType");}r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",t.getId()+"-title");r.addClass("sapMStdTileTitle");r.writeClasses();r.write(">");if(t.getTitle()){r.writeEscaped(t.getTitle());}r.write("</div>");if(t.getInfo()){r.write("<div");r.writeAttribute("id",t.getId()+"-info");r.addClass("sapMStdTileInfo");r.addClass("sapMStdTileInfo"+i);r.writeClasses();if(i!=a.None){r.writeAccessibilityState(t,{ariaDescribedBy:{value:t.getId()+"-sapSRH",append:true}});}r.write(">");if(t.getInfo()){r.writeEscaped(t.getInfo());}r.write("</div>");}if(i!=a.None){r.write("<span");r.writeAttributeEscaped("id",t.getId()+"-sapSRH");r.addClass("sapUiInvisibleText");r.writeClasses();r.writeAccessibilityState({hidden:false});r.write(">");r.writeEscaped(V.getAdditionalText(i));r.write("</span>");}r.write("</div>");};
return b;},true);
sap.ui.predefine('sap/m/StandardTreeItem',['./TreeItemBase','./library','sap/ui/core/IconPool','./Image','./StandardTreeItemRenderer'],function(T,l,I,a,S){"use strict";
var b=T.extend("sap.m.StandardTreeItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null}}}});
b.prototype._getIconControl=function(){var u=this.getIcon();if(this._oIconControl){this._oIconControl.setSrc(u);return this._oIconControl;}this._oIconControl=I.createControlByURI({id:this.getId()+"-icon",src:u,useIconTooltip:false,noTabStop:true},a).setParent(this,null,true).addStyleClass("sapMSTIIcon");return this._oIconControl;};
b.prototype.getContentAnnouncement=function(){return this.getTitle();};
b.prototype.exit=function(){T.prototype.exit.apply(this,arguments);this.destroyControls(["Icon"]);};
b.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oIconControl&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oIconControl.destroy("KeepDom");this._oIconControl=undefined;}return this;};
return b;});
sap.ui.predefine('sap/m/StandardTreeItemRenderer',["./TreeItemBaseRenderer","sap/ui/core/Renderer"],function(T,R){"use strict";var S=R.extend(T);S.apiVersion=2;
S.renderLIContent=function(r,l){if(l.getIcon()){r.renderControl(l._getIconControl());}r.text(l.getTitle());};
S.renderLIAttributes=function(r,l){T.renderLIAttributes.apply(this,arguments);r.class("sapMSTI");};
return S;},true);
sap.ui.predefine('sap/m/StepInput',["sap/ui/core/Icon","./Input","./InputBase","./InputRenderer","sap/ui/core/Control","sap/ui/core/IconPool",'sap/ui/core/LabelEnablement','sap/ui/core/message/MessageMixin','sap/ui/model/ValidateException','sap/ui/Device',"sap/ui/core/library","sap/ui/core/Renderer","sap/m/library","./StepInputRenderer","sap/ui/events/KeyCodes","sap/base/Log"],function(I,a,b,c,C,d,L,M,V,D,e,R,l,S,K,f){"use strict";var g=l.InputType;var T=e.TextAlign;var h=e.ValueState;var j=l.StepInputValidationMode;var k=l.StepInputStepModeType;
var m=C.extend("sap.m.StepInput",{
metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/StepInput.designtime",properties:{min:{type:"float",group:"Data"},max:{type:"float",group:"Data"},step:{type:"float",group:"Data",defaultValue:1},stepMode:{type:"sap.m.StepInputStepModeType",group:"Data",defaultValue:k.AdditionAndSubtraction},largerStep:{type:"float",group:"Data",defaultValue:2},value:{type:"float",group:"Data",defaultValue:0},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},required:{type:"boolean",group:"Misc",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Dimension"},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:h.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},enabled:{type:"boolean",group:"Behavior",defaultValue:true},displayValuePrecision:{type:"int",group:"Data",defaultValue:0},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.End},validationMode:{type:"sap.m.StepInputValidationMode",group:"Misc",defaultValue:j.FocusOut}},aggregations:{_input:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{change:{parameters:{value:{type:"string"}}}},dnd:{draggable:false,droppable:true}},
constructor:function(i,s){C.prototype.constructor.apply(this,arguments);if(this.getEditable()){this._getOrCreateDecrementButton();this._getOrCreateIncrementButton();}if(typeof i!=="string"){s=i;}if(s&&s.value===undefined){this.setValue(this._getDefaultValue(undefined,s.max,s.min));}}
});
var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");m.STEP_INPUT_INCREASE_BTN_TOOLTIP=o.getText("STEP_INPUT_INCREASE_BTN");m.STEP_INPUT_DECREASE_BTN_TOOLTIP=o.getText("STEP_INPUT_DECREASE_BTN");m.INITIAL_WAIT_TIMEOUT=500;m.ACCELLERATION=0.8;m.MIN_WAIT_TIMEOUT=50;m.INITIAL_SPEED=120;m._TOLERANCE=10;var F=["enabled","editable","name","placeholder","required","valueStateText","description","fieldWidth","textAlign"];var N=R.extend(c);
N.writeInnerAttributes=function(r,i){var s=i.getParent();r.writeAttribute("type",i.getType().toLowerCase());if(sap.ui.getCore().getConfiguration().getRTL()){r.writeAttribute("dir","ltr");}r.writeAccessibilityState(s);};
N.getAccessibilityState=function(i){var A=c.getAccessibilityState(i),s=i.getParent(),q=s._getMin(),r=s._getMax(),t=s.getValue(),u=s.getDescription(),v=s.getAriaLabelledBy(),w=L.getReferencingLabels(s),x=s.getAriaDescribedBy().join(" "),y;A["role"]="spinbutton";A["valuenow"]=t;if(u){v.push(s._getInput().getId()+"-descr");}y=w.concat(v).join(" ");if(typeof q==="number"){A["valuemin"]=q;}if(typeof r==="number"){A["valuemax"]=r;}if(x){A["describedby"]=x;}if(y){A["labelledby"]=y;}return A;};
var n=a.extend("sap.m.internal.NumericInput",{
metadata:{library:"sap.m"},
constructor:function(i,s){return a.apply(this,arguments);},
renderer:N
});
n.prototype.onBeforeRendering=function(){b.prototype.onBeforeRendering.call(this);this._deregisterEvents();};
n.prototype.setValue=function(v){a.prototype.setValue.apply(this,arguments);if(this.getDomRef()){document.getElementById(this.getId()+"-inner").setAttribute("aria-valuenow",v);}return this;};
M.call(m.prototype);
m.prototype.init=function(){this._iRealPrecision=0;this._attachChange();this._bPaste=false;this._onmousewheel=this._onmousewheel.bind(this);};
m.prototype.onBeforeRendering=function(){var i=this._getMin(),q=this._getMax(),v=this.getAggregation("_input")._$input.val()||this.getValue(),E=this.getEditable();this._iRealPrecision=this._getRealValuePrecision();this._getInput().setValue(this._getFormatedValue(v));this._getInput().setValueState(this.getValueState());this._getInput().setTooltip(this.getTooltip());this._getOrCreateDecrementButton().setVisible(E);this._getOrCreateIncrementButton().setVisible(E);this._disableButtons(v,q,i);this.$().unbind(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);};
m.prototype.onAfterRendering=function(){this.$().bind(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);};
m.prototype.exit=function(){this.$().unbind(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);};
m.prototype.setProperty=function(P,v,s){C.prototype.setProperty.call(this,P,v,s);if(F.indexOf(P)>-1){this._getInput().setProperty(P,this.getProperty(P),s);}return this;};
m.prototype.setValidationMode=function(v){if(this.getValidationMode()!==v){switch(v){case j.FocusOut:this._detachLiveChange();break;case j.LiveChange:this._attachLiveChange();break;}this.setProperty("validationMode",v);}return this;};
m.prototype.setMin=function(i){if(i!==undefined&&!this._validateOptionalNumberProperty("min",i)){return this;}return this.setProperty("min",i);};
m.prototype.setMax=function(i){if(i!==undefined&&!this._validateOptionalNumberProperty("max",i)){return this;}return this.setProperty("max",i);};
m.prototype._validateOptionalNumberProperty=function(i,v){if(this._isNumericLike(v)){return true;}f.error("The value of property '"+i+"' must be a number");return false;};
m.prototype.setDisplayValuePrecision=function(i){var v;if(p(i)){v=parseInt(i);}else{v=0;f.warning(this+": ValuePrecision ("+i+") is not correct. It should be a number between 0 and 20! Setting the default ValuePrecision:0.");}return this.setProperty("displayValuePrecision",v);};
m.prototype._getIncrementButton=function(){var i=this._getInput().getAggregation("_endIcon");return i?i[0]:null;};
m.prototype._getDecrementButton=function(){var i=this._getInput().getAggregation("_beginIcon");return i?i[0]:null;};
m.prototype._createIncrementButton=function(){var t=this;var i=this._getInput().addEndIcon({src:d.getIconURI("add"),id:this.getId()+"-incrementBtn",noTabStop:true,press:this._handleButtonPress.bind(this,true),tooltip:m.STEP_INPUT_INCREASE_BTN_TOOLTIP});i.getEnabled=function(){return!this._shouldDisableIncrementButton(this.getValue(),this._getMax());}.bind(this);i.addEventDelegate({onAfterRendering:function(){i.$().attr("tabindex","-1");t._attachEvents(i,true);}});return i;};
m.prototype._createDecrementButton=function(){var t=this;var i=this._getInput().addBeginIcon({src:d.getIconURI("less"),id:this.getId()+"-decrementBtn",noTabStop:true,press:this._handleButtonPress.bind(this,false),tooltip:m.STEP_INPUT_DECREASE_BTN_TOOLTIP});i.getEnabled=function(){return!this._shouldDisableDecrementButton(this.getValue(),this._getMin());}.bind(this);i.addEventDelegate({onAfterRendering:function(){i.$().attr("tabindex","-1");t._attachEvents(i,false);}});return i;};
m.prototype._getInput=function(){if(!this.getAggregation("_input")){var i=new n({id:this.getId()+"-input",textAlign:this.getTextAlign(),type:g.Number,editable:this.getEditable(),enabled:this.getEnabled(),description:this.getDescription(),fieldWidth:this.getFieldWidth(),liveChange:this._inputLiveChangeHandler});this.setAggregation("_input",i);}return this.getAggregation("_input");};
m.prototype._handleButtonPress=function(i){var q=this._calculateNewValue(1,i);this._btndown=undefined;this.setValue(q.value);if(this._sOldValue!==this.getValue()){this._verifyValue();this.fireChange({value:this.getValue()});}this.$().focus();return this;};
m.prototype._disableButtons=function(v,i,q){if(!this._isNumericLike(v)){return;}var r=this._getIncrementButton(),s=this._getDecrementButton(),t=this._shouldDisableDecrementButton(v,q),u=this._shouldDisableIncrementButton(v,i);s&&s.toggleStyleClass("sapMStepInputIconDisabled",t);r&&r.toggleStyleClass("sapMStepInputIconDisabled",u);return this;};
m.prototype._shouldDisableDecrementButton=function(v,i){var q=this._isNumericLike(i),E=this.getEnabled(),r=q&&i>=v;return E?r:true;};
m.prototype._shouldDisableIncrementButton=function(v,i){var q=this._isNumericLike(i),E=this.getEnabled(),r=q&&i<=v;return E?r:true;};
m.prototype._verifyValue=function(){var i=this._getMin(),q=this._getMax(),v=parseFloat(this._getInput().getValue()),r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core"),B=this.getBinding("value"),s=B&&B.getType&&B.getType(),t=s&&s.oConstraints.maximum,u=s&&s.oConstraints.minimum,w,x=[],H=false,E;if(!this._isNumericLike(v)){return;}E=this;do{H=E.hasListeners("validationError");E=E.getEventingParent();}while(E&&!H);if(this._isNumericLike(q)&&v>q){if(H&&t){return;}w=r.getText("EnterNumberMax",[q]);x.push("maximum");}else if(this._isNumericLike(i)&&v<i){if(H&&u){return;}w=r.getText("EnterNumberMin",[i]);x.push("minimum");}else if(this._areFoldChangeRequirementsFulfilled()&&(v%this.getStep()!==0)){w=r.getText("Float.Invalid");}if(!w){this.setProperty("valueState",h.None,true);this._getInput().setValueState(h.None);return;}if(H){this.fireValidationError({element:this,exception:new V(w,x),id:this.getId(),message:w,property:"value"});}else{this.setProperty("valueState",h.Error,true);this._getInput().setValueState(h.Error);this._getInput().setValueStateText(w);}};
m.prototype.setValue=function(v){var r;if(v==undefined){v=0;}this._sOldValue=this.getValue();if(!this._validateOptionalNumberProperty("value",v)){return this;}this._getInput().setValue(this._getFormatedValue(v));this._disableButtons(this._getInput().getValue(),this._getMax(),this._getMin());r=this.setProperty("value",parseFloat(v),true);this._iRealPrecision=this._getRealValuePrecision();return r;};
m.prototype._getFormatedValue=function(v){var P=this.getDisplayValuePrecision(),i,s;if(v==undefined){v=this.getValue();}if(P<=0){return parseFloat(v).toFixed(0);}s=v.toString().split(".");if(s.length===2){i=s[1].length;if(i>P){return parseFloat(v).toFixed(P);}return s[0]+"."+this._padZeroesRight(s[1],P);}else{return v.toString()+"."+this._padZeroesRight("0",P);}};
m.prototype._padZeroesRight=function(v,q){var r="",s=v.length;for(var i=s;i<q;i++){r=r+"0";}r=v+r;return r;};
m.prototype.onsappageup=function(E){this._applyValue(this._calculateNewValue(this.getLargerStep(),true).displayValue);this._verifyValue();E.preventDefault();};
m.prototype.onsappagedown=function(E){this._applyValue(this._calculateNewValue(this.getLargerStep(),false).displayValue);this._verifyValue();E.preventDefault();};
m.prototype.onsappageupmodifiers=function(E){if(this._isNumericLike(this._getMax())&&!(E.ctrlKey||E.metaKey||E.altKey)&&E.shiftKey){this._applyValue(this._getMax());}};
m.prototype.onsappagedownmodifiers=function(E){if(this._isNumericLike(this._getMin())&&!(E.ctrlKey||E.metaKey||E.altKey)&&E.shiftKey){this._applyValue(this._getMin());}};
m.prototype.onsapup=function(E){E.preventDefault();this._applyValue(this._calculateNewValue(1,true).displayValue);this._verifyValue();};
m.prototype.onsapdown=function(E){E.preventDefault();this._applyValue(this._calculateNewValue(1,false).displayValue);this._verifyValue();};
m.prototype._onmousewheel=function(E){var i=this.getDomRef().contains(document.activeElement);if(i){E.preventDefault();var O=E.originalEvent,q=O.detail?(-O.detail>0):(O.wheelDelta>0);this._applyValue(this._calculateNewValue(1,q).displayValue);this._verifyValue();}};
m.prototype.onkeydown=function(E){var v=false;this._bPaste=(E.ctrlKey||E.metaKey)&&(E.which===K.V);if(E.which===K.ARROW_UP&&!E.altKey&&E.shiftKey&&(E.ctrlKey||E.metaKey)){this._applyValue(this._getMax());v=true;}if(E.which===K.ARROW_DOWN&&!E.altKey&&E.shiftKey&&(E.ctrlKey||E.metaKey)){this._applyValue(this._getMin());v=true;}if(E.which===K.ARROW_UP&&!(E.ctrlKey||E.metaKey||E.altKey)&&E.shiftKey){E.preventDefault();this._applyValue(this._calculateNewValue(this.getLargerStep(),true).displayValue);v=true;}if(E.which===K.ARROW_DOWN&&!(E.ctrlKey||E.metaKey||E.altKey)&&E.shiftKey){E.preventDefault();this._applyValue(this._calculateNewValue(this.getLargerStep(),false).displayValue);v=true;}if(E.which===K.ARROW_UP&&(E.ctrlKey||E.metaKey)){E.preventDefault();this._applyValue(this._calculateNewValue(1,true).displayValue);v=true;}if(E.which===K.ARROW_DOWN&&(E.ctrlKey||E.metaKey)){E.preventDefault();this._applyValue(this._calculateNewValue(1,false).displayValue);v=true;}if(E.which===K.ARROW_UP&&E.altKey){E.preventDefault();this._applyValue(this._calculateNewValue(1,true).displayValue);v=true;}if(E.which===K.ARROW_DOWN&&E.altKey){E.preventDefault();this._applyValue(this._calculateNewValue(1,false).displayValue);v=true;}if(v){this._verifyValue();}};
m.prototype.onsapescape=function(E){this._getInput().onsapescape(E);};
m.prototype._attachLiveChange=function(){this._getInput().attachLiveChange(this._liveChange,this);};
m.prototype._detachLiveChange=function(){this._getInput().detachLiveChange(this._liveChange,this);};
m.prototype._attachChange=function(){this._getInput().attachChange(this._change,this);};
m.prototype._liveChange=function(){this._verifyValue();this._disableButtons(this._getInput().getValue(),this._getMax(),this._getMin());};
m.prototype._change=function(E){this._sOldValue=this.getValue();this.setValue(this._getDefaultValue(this._getInput().getValue(),this._getMax(),this._getMin()));if(this._sOldValue!==this.getValue()&&!this._isButtonFocused()){this._verifyValue();this.fireChange({value:this.getValue()});}};
m.prototype._applyValue=function(i){if(!this.getEditable()||!this.getEnabled()){return;}this.getAggregation("_input")._$input.val(this._getFormatedValue(i));};
m.prototype._calculateNewValue=function(s,i){var q=this.getStep(),r=this._getMax(),t=this._getMin(),u=this.getValue(),v=parseFloat(this._getDefaultValue(this._getInput().getValue(),r,t)),w=i?1:-1,x=Math.abs(q)*Math.abs(s),y=v+w*x,z,A,B=this.getDisplayValuePrecision();if(B>0){z=this._sumValues(v,x,w,B);}else{z=y;}if(this._areFoldChangeRequirementsFulfilled()){y=z=A=this._calculateClosestFoldValue(v,x,w);}else{A=this._sumValues(u,x,w,this._iRealPrecision);}if(this._isNumericLike(r)&&y>=r){A=r;z=r;}if(this._isNumericLike(t)&&y<=t){A=t;z=t;}return{value:A,displayValue:z};};
m.prototype._getRealValuePrecision=function(){var s=this.getValue().toString().split("."),i=this.getStep().toString().split("."),q,r;q=(!s[1])?0:s[1].length;r=(!i[1])?0:i[1].length;return(q>r)?q:r;};
m.prototype._getOrCreateDecrementButton=function(){return this._getDecrementButton()||this._createDecrementButton();};
m.prototype._getOrCreateIncrementButton=function(){return this._getIncrementButton()||this._createIncrementButton();};
m.prototype._inputLiveChangeHandler=function(E){var v=this.getParent()._restrictCharsWhenDecimal(E);this.setProperty("value",v?v:E.getParameter("newValue"),true);};
m.prototype._restrictCharsWhenDecimal=function(E){var i=E.getParameter("value").indexOf("."),q=this.getDisplayValuePrecision(),v;if(i>0&&q>0){var s=E.getParameter("value"),r=s.split('.')[1],t=r?r.length:0,u=E.getSource().getProperty("value"),w=s.split('.')[0],x=u.substring(u.indexOf('.')+1,u.length);if(!this._bPaste){if(t>q){v=w+"."+x;this._showWrongValueVisualEffect();}}else{if(s.indexOf(".")){v=s.split('.')[0]+"."+r.substring(0,q);}this._bPaste=false;}}this._getInput().updateDomValue(v);return v;};
m.prototype._showWrongValueVisualEffect=function(){var O=this.getValueState(),i=this._getInput();if(O===h.Error){return;}i.setValueState(h.Error);setTimeout(i["setValueState"].bind(i,O),1000);};
m.prototype._getDefaultValue=function(v,i,q){if(v!==""&&v!==undefined){return this._getInput().getValue();}if(this._isNumericLike(q)&&q>0){return q;}else if(this._isNumericLike(i)&&i<0){return i;}else{return 0;}};
m.prototype._isNumericLike=function(v){return!isNaN(v)&&v!==null&&v!=="";};
m.prototype._isInteger=function(v){return v===parseInt(v);};
m.prototype._isButtonFocused=function(){return document.activeElement===this._getIncrementButton().getDomRef()||document.activeElement===this._getDecrementButton().getDomRef();};
m.prototype._sumValues=function(v,i,s,P){var q=Math.pow(10,P),r=parseInt((v*q).toFixed(10)),t=parseInt((i*q).toFixed(10));return(r+(s*t))/q;};
m.prototype._areFoldChangeRequirementsFulfilled=function(){return this.getStepMode()===k.Multiple&&this.getDisplayValuePrecision()===0&&this._isInteger(this.getStep())&&this._isInteger(this.getLargerStep());};
m.prototype._calculateClosestFoldValue=function(v,s,i){var r=Math.floor(v),q=s;do{r+=i;q--;}while(r%s!==0&&q);if(r%s!==0){f.error("Wrong next/previous value "+r+" for "+v+", step: "+s+" and sign: "+i,this);}return r;};
function p(v){return(typeof(v)==='number')&&!isNaN(v)&&v>=0&&v<=20;}
m.prototype._calcWaitTimeout=function(){this._speed*=m.ACCELLERATION;this._waitTimeout=((this._waitTimeout-this._speed)<m.MIN_WAIT_TIMEOUT?m.MIN_WAIT_TIMEOUT:(this._waitTimeout-this._speed));return this._waitTimeout;};
m.prototype._spinValues=function(i){var t=this;if(this._btndown){this._spinTimeoutId=setTimeout(function(){if(t._btndown){var q=t._calculateNewValue(1,i);t.setValue(q.value);t._verifyValue();if(!t._getIncrementButton().getEnabled()||!t._getDecrementButton().getEnabled()){_.call(t);t.fireChange({value:t.getValue()});}t._spinValues(i);}},t._calcWaitTimeout());}};
m.prototype._attachEvents=function(B,i){var t=this;var E={onmousedown:function(q){if(q.button===0&&!t._btndown){t._waitTimeout=m.INITIAL_WAIT_TIMEOUT;t._speed=m.INITIAL_SPEED;t._btndown=true;t._spinValues(i);}},onmouseup:function(q){if(t._btndown){_.call(t);}},onmouseout:function(q){if(t._btndown){_.call(t);t.fireChange({value:t.getValue()});}},oncontextmenu:function(q){q.stopImmediatePropagation(true);if(q.originalEvent&&q.originalEvent.cancelable){q.preventDefault();}q.stopPropagation();}};B.addDelegate(E,true);};
m.prototype._getMin=function(){var B=this.getBinding("value"),i=B&&B.getType&&B.getType(),s=i&&i.oConstraints.minimum;return s?parseFloat(s):this.getMin();};
m.prototype._getMax=function(){var B=this.getBinding("value"),i=B&&B.getType&&B.getType(),s=i&&i.oConstraints.maximum;return s?parseFloat(s):this.getMax();};
m.prototype.getIdForLabel=function(){return this.getAggregation("_input").getIdForLabel();};
function _(){if(this._btndown){this._btndown=undefined;clearTimeout(this._spinTimeoutId);this._waitTimeout=500;this._speed=120;}}
return m;});
sap.ui.predefine('sap/m/StepInputRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var i=c._getInput(),w=c.getWidth(),e=c.getEnabled(),E=c.getEditable(),v=c.getValueState();r.openStart("div",c);if(e&&E){r.attr("tabindex","-1");}r.style("width",w);r.class("sapMStepInput");r.class("sapMStepInput-CTX");!e&&r.class("sapMStepInputReadOnly");!E&&r.class("sapMStepInputNotEditable");if(v==="Error"||v==="Warning"){r.class("sapMStepInput"+v);}r.openEnd();r.renderControl(i);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/Suggest',['jquery.sap.global','./Toolbar','./Button','./SuggestionsList','./SuggestionItem','sap/ui/Device','sap/m/library','sap/ui/core/Core'],function(q,T,B,S,a,D,l,C){"use strict";var P=l.PlacementType;
function b(i){var p=i,c,d,e,u=D.system.phone,s=this;q.sap.require(u?"sap.m.Dialog":"sap.m.Popover");function o(E){var k=E.srcControl;var v;if(k instanceof a){v=k.getSuggestionText();s._suggestionItemTapped=true;c.close();window.setTimeout(function(){i.setValue(v);i.fireSearch({query:v,suggestionItem:k,refreshButtonPressed:false,clearButtonPressed:false});},0);}}function f(){var k,m,n,r,t,v;n=new(sap.ui.require('sap/m/SearchField'))({liveChange:function(E){var w=E.getParameter("newValue");i.setValue(w);i.fireLiveChange({newValue:w});i.fireSuggest({suggestValue:w});s.update();},search:function(E){if(!E.getParameter("clearButtonPressed")){k.close();}}});v=new B({icon:"sap-icon://decline",press:function(){s._cancelButtonTapped=true;k._oCloseTrigger=true;k.close();i.setValue(m);}});r=new T({content:[n,v]});t=new B({text:C.getLibraryResourceBundle("sap.m").getText("MSGBOX_OK"),press:function(){k.close();}});k=new(sap.ui.require('sap/m/Dialog'))({stretch:true,customHeader:r,content:h(),beginButton:t,beforeOpen:function(){m=i.getValue();n.setValue(m);},afterClose:function(E){if(!s._cancelButtonTapped&&!s._suggestionItemTapped){i.fireSearch({query:i.getValue(),refreshButtonPressed:false,clearButtonPressed:false});}}});k.addEventDelegate({ontap:o},i);return k;}function g(){var k=s._oPopover=new(sap.ui.require('sap/m/Popover'))({showArrow:false,showHeader:false,horizontalScrolling:false,placement:P.Vertical,offsetX:0,offsetY:0,initialFocus:p,bounce:false,afterOpen:function(){i.$("I").attr("aria-autocomplete","list").attr("aria-haspopup","true");},beforeClose:function(){i.$("I").attr("aria-haspopup","false").removeAttr("aria-activedecendant");},content:h()}).addStyleClass("sapMSltPicker").addStyleClass("sapMSltPicker-CTX");k.open=function(){return this.openBy(p);};k.addEventDelegate({onAfterRendering:s.setPopoverMinWidth.bind(s),ontap:o},i);return k;}function h(){if(!d){d=new S({parentInput:p});}return d;}function j(){if(c===undefined){c=u?f():g();}return c;}this.setPopoverMinWidth=function(){var k=s._oPopover.getDomRef();if(k){var w=(i.$().outerWidth()/parseFloat(l.BaseFontSize))+"rem";k.style.minWidth=w;}};this.destroy=function(){if(c){c.close();c.destroy();c=null;}if(d){d.destroy();d=null;}};this.close=function(){if(!u&&this.isOpen()){c.close();}};this.open=function(){if(!this.isOpen()){this.setSelected(-1);this._suggestionItemTapped=false;this._cancelButtonTapped=false;j().open();}};this.update=function(){var d=h();window.clearTimeout(e);if(this.isOpen()){e=window.setTimeout(d.update.bind(d),50);}};this.isOpen=function(){return!!c&&c.isOpen();};this.getSelected=function(){return h().getSelectedItemIndex();};this.setSelected=function(k,r){return h().selectByIndex(k,r);};}
return b;},true);
sap.ui.predefine('sap/m/SuggestionItem',['./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(l,I,a){"use strict";
var S=I.extend("sap.m.SuggestionItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:""},description:{type:"string",group:"Data",defaultValue:""}}}});
a.insertFontFaceStyle();
function r(R,t,s){var i;if(t){i=t.toUpperCase().indexOf(s.toUpperCase());if(i>-1){R.writeEscaped(t.slice(0,i));R.write("<b>");R.writeEscaped(t.slice(i,i+s.length));R.write("</b>");t=t.substring(i+s.length);}R.writeEscaped(t);}}
S.prototype.render=function(R,i,s,b){var c=R;var t=i.getText();var d=i.getIcon();var e="";var f=i.getDescription();var p=i.getParent();var g=p&&p.getSuggestionItems&&p.getSuggestionItems()||[];var h=g.indexOf(i);s=s||"";c.write("<li");c.writeElementData(i);c.addClass("sapMSuLI");c.addClass("sapMSelectListItem");c.addClass("sapMSelectListItemBase");c.addClass("sapMSelectListItemBaseHoverable");c.writeAttribute("role","option");c.writeAttribute("aria-posinset",h+1);c.writeAttribute("aria-setsize",g.length);if(b){c.addClass("sapMSelectListItemBaseSelected");c.writeAttribute("aria-selected","true");if(p){p.$("I").attr("aria-activedecendant",i.getId());}}else{c.writeAttribute("aria-selected","false");}c.writeClasses();c.write(">");if(d){c.writeIcon(d,"sapMSuggestionItemIcon",{});}if(t){r(c,t,s);e=" ";}if(f){c.write(e+"<i>");r(c,f,s);c.write("</i>");}c.write("</li>");};
S.prototype.getSuggestionText=function(){return this.getText();};
S.prototype.invalidate=function(){return undefined;};
return S;});
sap.ui.predefine('sap/m/SuggestionsList',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var S=C.extend("sap.m.SuggestionsList",{
metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"}},associations:{parentInput:{type:"sap.ui.core.Control",multiple:false,singularName:"parentInput"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}},
renderer:{render:function(r,L){r.write("<ul");r.writeControlData(L);r.addClass("sapMSuL");r.addClass("sapMSelectList");r.writeClasses();r.writeAccessibilityState({role:"listbox","multiselectable":"false"});r.addStyle("width",L.getWidth());r.addStyle("max-width",L.getMaxWidth());r.writeStyles();r.write(">");this.renderItems(r,L);r.write("</ul>");},renderItems:function(r,L){var s;var a=L.getSelectedItemIndex();try{s=sap.ui.getCore().byId(L.getParentInput()).getValue();}catch(e){s="";}L.getItems().forEach(function(i,b){i.render(r,i,s,b===a);});}}
});
S.prototype.init=function(){this._iSelectedItem=-1;};
S.prototype.onBeforeRendering=function(){this.$().off();};
S.prototype.onAfterRendering=function(){this.$().on("mousedown",function(e){e.preventDefault();});};
S.prototype.getItems=function(){try{return sap.ui.getCore().byId(this.getParentInput()).getSuggestionItems();}catch(e){return[];}};
S.prototype.update=function(){var r;var d=this.getDomRef();if(d){r=sap.ui.getCore().createRenderManager();this.getRenderer().renderItems(r,this);r.flush(d);r.destroy();}return this;};
S.prototype.selectByIndex=function(i,r){var a=this.getItems();var b;var c;var d;var p=sap.ui.getCore().byId(this.getParentInput());var e="aria-activedecendant";if(isNaN(parseInt(i))){i=-1;r=false;}if((!a.length)||(r&&i===0)||(!r&&i<0)){b=-1;}else{if(r){if(this._iSelectedItem<0){b=(i<0?a.length:-1)+i;}else{b=this._iSelectedItem+i;}}else{b=i;}b=Math.min(Math.max(b,0),a.length-1);}this._iSelectedItem=b;if(a.length){this.$().children("li").removeClass("sapMSelectListItemBaseSelected").attr("aria-selected","false").eq(b).addClass("sapMSelectListItemBaseSelected").attr("aria-selected","true");}if(p){if(b>=0){c=p.getSuggestionItems()[b];if(c){d=c.getId();this._scrollToItem(c);}}if(d){p.$("I").attr(e,d);}else{p.$("I").removeAttr(e);}}return this._iSelectedItem;};
S.prototype._scrollToItem=function(i){var p=this.getParent().$().find(".sapMPopoverCont")[0],P,I,t,b;if(!i||!i.getDomRef()||!p){return;}I=i.getDomRef().getBoundingClientRect();P=p.getBoundingClientRect();t=P.top-I.top;b=I.bottom-P.bottom;if(t>0){p.scrollTop=Math.max(p.scrollTop-t,0);}else if(b>0){p.scrollTop=p.scrollTop+b;}};
S.prototype.getSelectedItemIndex=function(){return this._iSelectedItem;};
return S;});
sap.ui.predefine('sap/m/SuggestionsPopover',['sap/ui/Device','sap/ui/base/EventProvider','sap/ui/core/InvisibleText','sap/ui/core/ListItem','sap/ui/core/ResizeHandler','sap/ui/core/ValueStateSupport','sap/m/library','sap/ui/core/library','sap/m/Bar','sap/m/Toolbar','sap/m/Button','sap/m/ToggleButton','sap/m/ColumnListItem','sap/m/GroupHeaderListItem','sap/ui/core/SeparatorItem','sap/m/Dialog','sap/m/DisplayListItem','sap/m/List','sap/m/Popover','sap/m/StandardListItem','sap/m/Table','sap/m/Title','sap/m/Text','sap/ui/core/IconPool','sap/m/SimpleFixFlex',"sap/base/security/encodeXML","sap/ui/events/KeyCodes"],function(D,E,I,L,R,V,l,c,B,T,a,b,C,G,S,d,e,f,P,g,h,j,k,m,n,o,K){"use strict";var p=l.ListMode;var q=l.PlacementType;var r=l.ListType;var s=l.ListSeparators;var t="sapMSuggestionsPopover",u="sapUiNoContentPadding";var v=c.ValueState;
var w=E.extend("sap.m.SuggestionsPopover",{
constructor:function(i){E.apply(this,arguments);this._oInput=i;this._bUseDialog=D.system.phone;this._iPopupListSelectedIndex=-1;this._sPopoverContentWidth=null;this._bEnableHighlighting=true;this._bIsInputIncrementalType=false;this._bAutocompleteEnabled=false;this._sTypedInValue='';this._sOldValueState=v.None;this._oInput.addEventDelegate({onsapup:function(x){this._onsaparrowkey(x,"up",1);},onsapdown:function(x){this._onsaparrowkey(x,"down",1);},onsappageup:function(x){this._onsaparrowkey(x,"up",5);},onsappagedown:function(x){this._onsaparrowkey(x,"down",5);},onsaphome:function(x){if(this._oList){this._onsaparrowkey(x,"up",this._oList.getItems().length);}},onsapend:function(x){if(this._oList){this._onsaparrowkey(x,"down",this._oList.getItems().length);}},onsapright:this._onsapright},this);},
destroy:function(){if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}if(this._oList){this._oList.destroy();this._oList=null;}if(this._oSuggestionTable){this._oSuggestionTable.destroy();this._oSuggestionTable=null;}this._oProposedItem=null;this._oInputDelegate=null;if(this._oPickerValueStateText){this._oPickerValueStateText.destroy();this._oPickerValueStateText=null;}}
});
w.M_EVENTS={SELECTION_CHANGE:"selectionChange"};
w._wordStartsWithValue=function(i,x){var y;if(!i||!x||typeof i!=="string"||typeof x!=="string"){return false;}while(i){if(typeof x==="string"&&x!==""&&i.toLowerCase().indexOf(x.toLowerCase())===0){return true;}y=i.indexOf(' ');if(y===-1){break;}i=i.substring(y+1);}return false;};
w._DEFAULTFILTER=function(i,x){if(x instanceof L&&w._wordStartsWithValue(x.getAdditionalText(),i)){return true;}return w._wordStartsWithValue(x.getText(),i);};
w._DEFAULTFILTER_TABULAR=function(x,y){var z=y.getCells(),i=0;for(;i<z.length;i++){if(z[i].getText){if(w._wordStartsWithValue(z[i].getText(),x)){return true;}}}return false;};
w._DEFAULTRESULT_TABULAR=function(x){var y=x.getCells(),i=0;for(;i<y.length;i++){if(y[i].getText){return y[i].getText();}}return"";};
w.prototype.isOpen=function(){return this._oPopover&&this._oPopover.isOpen();};
w.prototype.setInputLabels=function(i){this._fnInputLabels=i;};
w.prototype._getInputLabels=function(){return this._fnInputLabels();};
w.prototype.updatePickerHeaderTitle=function(){var i=sap.ui.getCore().getLibraryResourceBundle("sap.m"),x=this.getPickerTitle(),y,z;if(!x){return;}z=this._getInputLabels();if(z.length){y=z[0];if(y&&(typeof y.getText==="function")){x.setText(y.getText());}}else{x.setText(i.getText("COMBOBOX_PICKER_TITLE"));}return x;};
w.prototype.getPickerTitle=function(){return this._oPopover.getCustomHeader().getContentMiddle()[0];};
w.prototype.getOkButton=function(){var i=this._oPopover&&this._oPopover.getBeginButton();return i||null;};
w.prototype.getCancelButton=function(){var i=this._oPopover&&this._oPopover.getCustomHeader()&&this._oPopover.getCustomHeader().getContentRight()[0];return i||null;};
w.prototype.getFilterSelectedButton=function(){var i=this._oPopover&&this._oPopover.getSubHeader()&&this._oPopover.getSubHeader().getContent()[1];return i||null;};
w.prototype._createFilterSelectedButton=function(){var i=m.getIconURI("multiselect-all");return new b({icon:i});};
w.prototype._createSuggestionPopup=function(O){O=O||[];var i=this._oInput,x=this,M=i._oRb;this._oPopover=!this._bUseDialog?(new P(i.getId()+"-popup",{showArrow:false,placement:q.VerticalPreferredBottom,showHeader:false,initialFocus:i,horizontalScrolling:true})):(new d(i.getId()+"-popup",{beginButton:new a(i.getId()+"-popup-closeButton",{text:M.getText("SUGGESTIONSPOPOVER_CLOSE_BUTTON")}),stretch:true,customHeader:new B(i.getId()+"-popup-header",{contentMiddle:new j(),contentRight:new a({icon:m.getIconURI("decline")})}),subHeader:this.createSubHeaderContent(O),horizontalScrolling:false,initialFocus:this._oPopupInput,beforeOpen:function(){x.updatePickerHeaderTitle();},afterClose:function(){i.focus();l.closeKeyboard();}}));this._registerAutocomplete();this._oPopover.addStyleClass(t);this._oPopover.addStyleClass(u);this._oPopover.addAriaLabelledBy(I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES"));if(!this._bUseDialog){this._overwritePopover();}if(this._oList){this._oPopover.addContent(this._oList);}};
w.prototype.createSubHeaderContent=function(O){var i=[this._oPopupInput];if(O.showSelectedButton){i.push(this._createFilterSelectedButton());}return new T({content:i});};
w.prototype._createSuggestionPopupContent=function(i,x){var y=this._oInput;if(!x&&!i){this._oList=new f(y.getId()+"-popup-list",{showNoData:false,mode:p.SingleSelectMaster,rememberSelections:false,width:"100%",showSeparators:s.None,busyIndicatorDelay:0});this._oList.addEventDelegate({onAfterRendering:function(){var F,H;if(!this._bEnableHighlighting){return;}F=this._oList.$().find('.sapMDLILabel, .sapMSLITitleOnly, .sapMDLIValue');H=(this._sTypedInValue||this._oInput.getValue()).toLowerCase();this.highlightSuggestionItems(F,H);}.bind(this)});}else{this._oList=this._getSuggestionsTable();}this._oSimpleFixFlex=this._createSimpleFixFlex();if(this._oPopover){if(this._bUseDialog){this._oPopover.addAggregation("content",this._oSimpleFixFlex,true);var z=this._oPopover.$("scrollCont")[0];if(z){var A=sap.ui.getCore().createRenderManager();A.renderControl(this._oSimpleFixFlex);A.flush(z);A.destroy();}}else{this._oPopover.addContent(this._oSimpleFixFlex);}}};
w.prototype._destroySuggestionPopup=function(){if(this._oPopover){if(this._oList instanceof h){this._oPopover.removeAllContent();}this._oPopover.destroy();this._oPopover=null;}if(this._oList instanceof f){this._oList.destroy();this._oList=null;}if(this._oPickerValueStateText){this._oPickerValueStateText.destroy();this._oPickerValueStateText=null;}this._getInput().removeEventDelegate(this._oInputDelegate,this);};
w.prototype._overwritePopover=function(){var i=this._oInput;this._oPopover.open=function(){this.openBy(i,false,true);};this._oPopover.oPopup.setAnimations(function($,x,O){O();},function($,x,y){y();});};
w.prototype._resizePopup=function(){var i=this._oInput;if(this._oList&&this._oPopover){if(this._sPopoverContentWidth){this._oPopover.setContentWidth(this._sPopoverContentWidth);}else{this._oPopover.setContentWidth((i.$().outerWidth())+"px");}setTimeout(function(){if(this._oPopover&&this._oPopover.isOpen()&&this._oPopover.$().outerWidth()<i.$().outerWidth()){this._oPopover.setContentWidth((i.$().outerWidth())+"px");}}.bind(this),0);}};
w.prototype._registerResize=function(){if(!this._bUseDialog){this._sPopupResizeHandler=R.register(this._oInput,this._resizePopup.bind(this));}};
w.prototype._deregisterResize=function(){if(this._sPopupResizeHandler){this._sPopupResizeHandler=R.deregister(this._sPopupResizeHandler);}};
w.prototype._onsaparrowkey=function(i,x,y){var z=this._oInput,A,F=z.$("inner");if(i.isMarked()){return;}if(i.isMarked()){return;}if(!z.getEnabled()||!z.getEditable()){return;}if(x!=="up"&&x!=="down"){return;}if(this._bIsInputIncrementalType){i.setMarked();}if(!this._oPopover||!this._oPopover.isOpen()){return;}i.preventDefault();i.stopPropagation();var H=false,J=this._oList,M=J.getItems(),N=this._iPopupListSelectedIndex,O,Q=N;if(x==="up"&&N===0){return;}if(x=="down"&&N===M.length-1){return;}var U;if(y>1){if(x=="down"&&N+y>=M.length){x="up";y=1;M[N].setSelected(false);U=N;N=M.length-1;H=true;}else if(x=="up"&&N-y<0){x="down";y=1;M[N].setSelected(false);U=N;N=0;H=true;}}if(N===-1){N=0;if(this._isSuggestionItemSelectable(M[N])){Q=N;H=true;}else{x="down";}}if(x==="down"){while(N<M.length-1&&(!H||!this._isSuggestionItemSelectable(M[N]))){M[N].setSelected(false);N=N+y;H=true;y=1;if(U===N){break;}}}else{while(N>0&&(!H||!M[N].getVisible()||!this._isSuggestionItemSelectable(M[N]))){M[N].setSelected(false);N=N-y;H=true;y=1;if(U===N){break;}}}if(!this._isSuggestionItemSelectable(M[N])){if(Q>=0){M[Q].setSelected(true).updateAccessibilityState();F.attr("aria-activedescendant",M[Q].getId());}return;}else{A=M[N];A.setSelected(true).updateAccessibilityState();if(A.isA("sap.m.GroupHeaderListItem")){F.removeAttr("aria-activedescendant");}else{F.attr("aria-activedescendant",M[N].getId());}}if(D.system.desktop){this._scrollToItem(N);}this._oLastSelectedHeader&&this._oLastSelectedHeader.removeStyleClass("sapMInputFocusedHeaderGroup");if(C&&M[N]instanceof C){O=z._getInputValue(z._fnRowResultFilter(M[N]));}else{if(M[N].isA("sap.m.GroupHeaderListItem")){O="";M[N].addStyleClass("sapMInputFocusedHeaderGroup");this._oLastSelectedHeader=M[N];}else if(M[N]instanceof e){O=z._getInputValue(M[N].getLabel());}else{O=z._getInputValue(M[N].getTitle());}}this._iPopupListSelectedIndex=N;this._bSuggestionItemChanged=true;this.fireEvent(w.M_EVENTS.SELECTION_CHANGE,{newValue:O});};
w.prototype._isSuggestionItemSelectable=function(i){var x=this._hasTabularSuggestions()||i.getType()!==r.Inactive||i.isA("sap.m.GroupHeaderListItem");return i.getVisible()&&x;};
w.prototype._hasTabularSuggestions=function(){if(!this._oSuggestionTable){return;}return!!(this._oSuggestionTable.getColumns()&&this._oSuggestionTable.getColumns().length);};
w.prototype.setOkPressHandler=function(H){var O=this.getOkButton();O&&O.attachPress(H);return O;};
w.prototype.setCancelPressHandler=function(H){var i=this.getCancelButton();i&&i.attachPress(H);};
w.prototype.setShowSelectedPressHandler=function(H){var F=this.getFilterSelectedButton();F&&F.attachPress(H);return F;};
w.prototype._scrollToItem=function(i){var x=this._oPopover,y=this._oList,z,A,F,H,J;if(!(x instanceof P)||!y){return;}z=x.getScrollDelegate();if(!z){return;}var M=y.getItems()[i],N=M&&M.getDomRef();if(!N){return;}A=x.getDomRef("cont").getBoundingClientRect();F=N.getBoundingClientRect();H=A.top-F.top;J=F.bottom-A.bottom;if(H>0){z.scrollTo(z._scrollX,Math.max(z._scrollY-H,0));}else if(J>0){z.scrollTo(z._scrollX,z._scrollY+J);}};
w.prototype._getSuggestionsTable=function(){var i=this._oInput;if(i._bIsBeingDestroyed){return this._oSuggestionTable;}if(!this._oSuggestionTable){this._oSuggestionTable=new h(i.getId()+"-popup-table",{mode:p.SingleSelectMaster,showNoData:false,showSeparators:s.None,width:"100%",enableBusyIndicator:false,rememberSelections:false,itemPress:function(x){if(D.system.desktop){i.focus();}this._bSuggestionItemTapped=true;var y=x.getParameter("listItem");i.setSelectionRow(y,true);}.bind(this)});this._oSuggestionTable.addEventDelegate({onAfterRendering:function(){var x,y;if(!i.getEnableSuggestionsHighlighting()){return;}x=this._oSuggestionTable.$().find('tbody .sapMLabel');y=(this._sTypedInValue||this._oInput.getValue()).toLowerCase();this.highlightSuggestionItems(x,y);}.bind(this)});if(this._bUseDialog){this._oSuggestionTable.addStyleClass("sapMInputSuggestionTableHidden");}this._oSuggestionTable.updateItems=function(){h.prototype.updateItems.apply(i,arguments);i._refreshItemsDelayed();return i;};}i._oSuggestionTable=this._oSuggestionTable;return this._oSuggestionTable;};
w.prototype._createHighlightedText=function(i,x,W){var y,z,A,N,F,H=i?i.innerText:"",J="";if(!w._wordStartsWithValue(H,x)){return o(H);}x=x.toLowerCase();A=x.length;while(w._wordStartsWithValue(H,x)){y=H.toLowerCase();z=y.indexOf(x);z=(z>0)?y.indexOf(' '+x)+1:z;F=H.substring(0,z);H=H.substring(z);J+=o(F);F=H.substring(0,A);H=H.substring(A);J+='<span class="sapMInputHighlight">'+o(F)+'</span>';N=H.indexOf(" ");N=N===-1?H.length:N;F=H.substring(0,N);H=H.substring(N);J+=o(F);if(!W){break;}}if(H){J+=o(H);}return J;};
w.prototype._createSimpleFixFlex=function(){var i=this._oInput.getId()+"-simplefixflex";return new n({id:i,fixContent:this._getPickerValueStateText(),flexContent:this._oList});};
w.prototype.highlightSuggestionItems=function(x,y,W){var i;if(!this._bEnableHighlighting||(!x&&!x.length)){return;}for(i=0;i<x.length;i++){x[i].innerHTML=this._createHighlightedText(x[i],y,W);}};
w.prototype._registerAutocomplete=function(){var i=this._oPopover,U=this._getInput(),x=this._bUseDialog;if(x){i.addEventDelegate({ontap:function(){if(!this._bSuggestionItemTapped&&this._sProposedItemText){U.setValue(this._sProposedItemText);this._sProposedItemText=null;}}},this);}else{i.attachAfterOpen(this._handleTypeAhead,this);}i.attachAfterOpen(this._setSelectedSuggestionItem,this);i.attachAfterClose(this._finalizeAutocomplete,this);this._oInputDelegate={onkeydown:function(y){this._bDoTypeAhead=this._bAutocompleteEnabled&&(y.which!==K.BACKSPACE)&&(y.which!==K.DELETE);},oninput:this._handleTypeAhead};U.addEventDelegate(this._oInputDelegate,this);};
w.prototype._handleTypeAhead=function(){var x=this._getInput(),y=x.getValue();this._oProposedItem=null;this._sProposedItemText=null;this._sTypedInValue=y;if(!this._bDoTypeAhead||y===""){return;}if(!this._oPopover.isOpen()||y.length<this._oInput.getStartSuggestion()){return;}if(document.activeElement!==x.getFocusDomRef()){return;}var z=y.toLowerCase(),A=this._hasTabularSuggestions(),F=A?this._oInput.getSuggestionRows():this._oInput.getSuggestionItems(),H,N,J,i;F=F.filter(function(M){return!(M.isA("sap.ui.core.SeparatorItem")||M.isA("sap.m.GroupHeaderListItem"));});H=F.length;for(i=0;i<H;i++){J=A?this._oInput._fnRowResultFilter(F[i]):F[i].getText();if(J.toLowerCase().indexOf(z)===0){this._oProposedItem=F[i];N=J;break;}}this._sProposedItemText=N;if(N){N=this._formatTypedAheadValue(N);if(!x.isComposingCharacter()){x.updateDomValue(N);}if(D.system.desktop){x.selectText(y.length,N.length);}else{setTimeout(function(){x.selectText(y.length,N.length);},0);}}};
w.prototype._setSelectedSuggestionItem=function(){var F;if(this._oList){F=this._oList.getItems();for(var i=0;i<F.length;i++){if((F[i]._oItem||F[i])===this._oProposedItem){F[i].setSelected(true);break;}}}};
w.prototype._getInput=function(){return this._bUseDialog?this._oPopupInput:this._oInput;};
w.prototype._finalizeAutocomplete=function(){if(this._oInput.isComposingCharacter()){return;}if(!this._bAutocompleteEnabled){return;}if(!this._bSuggestionItemTapped&&!this._bSuggestionItemChanged&&this._oProposedItem){if(this._hasTabularSuggestions()){this._oInput.setSelectionRow(this._oProposedItem,true);}else{this._oInput.setSelectionItem(this._oProposedItem,true);}}if(this._oProposedItem&&document.activeElement===this._oInput.getFocusDomRef()){var i=this._oInput.getValue().length;this._oInput.selectText(i,i);}this._resetTypeAhead();};
w.prototype._resetTypeAhead=function(){this._oProposedItem=null;this._sProposedItemText=null;this._sTypedInValue='';this._bSuggestionItemTapped=false;this._bSuggestionItemChanged=false;};
w.prototype._formatTypedAheadValue=function(N){return this._sTypedInValue.concat(N.substring(this._sTypedInValue.length,N.length));};
w.prototype._onsapright=function(){var i=this._oInput,x=i.getValue();if(!this._bAutocompleteEnabled){return;}if(this._sTypedInValue!==x){this._sTypedInValue=x;i.fireLiveChange({value:x,newValue:x});}};
w.prototype.updateValueState=function(i,x,y){var z=y&&i!==v.None;x=x||V.getAdditionalText(i);if(this._oPopupInput){this._oPopupInput.setValueState(i);}this._setValueStateText(x);this._showValueStateText(z);this._alignValueStateStyles(i);return this;};
w.prototype._getPickerValueStateText=function(){if(!this._oPickerValueStateText){this._oPickerValueStateText=new k({width:"100%"});}return this._oPickerValueStateText;};
w.prototype._showValueStateText=function(i){if(this._oPickerValueStateText){this._oPickerValueStateText.setVisible(i);}};
w.prototype._setValueStateText=function(i){var x;x=this._getPickerValueStateText();if(x){x.setText(i);if(this._oSimpleFixFlex){this._oSimpleFixFlex.setFixContent(this._oPickerValueStateText);}}};
w.prototype._alignValueStateStyles=function(i){var x=t+"ValueState",O=t+this._sOldValueState+"State",y=t+i+"State";if(this._oPickerValueStateText){this._oPickerValueStateText.addStyleClass(x);this._oPickerValueStateText.removeStyleClass(O);this._oPickerValueStateText.addStyleClass(y);}this._sOldValueState=i;};
w.prototype.addFlexContent=function(i){if(this._oSimpleFixFlex){this._oSimpleFixFlex.addFlexContent(i);}};
return w;});
sap.ui.predefine('sap/m/Support',['sap/ui/thirdparty/jquery','sap/ui/Device',"sap/base/security/encodeXML","sap/base/util/isPlainObject"],function(q,D,e,a){"use strict";var S=(function($,d){var b,s,c,l,t=0,m=3000,h=2,f=3,r=1,o={},g={btnStart:"startE2ETrace",selLevel:"logLevelE2ETrace",taContent:"outputE2ETrace",infoText:"Ent-to-End trace is running in the background."+" Navigate to the URL that you would like to trace."+" The result of the trace will be shown in dialog after the trace is terminated.",infoDuration:5000},j={dvLoadedLibs:"LoadedLibs",dvLoadedModules:"LoadedModules"},w;function k(i,v,E,F,G){i.push("<tr class='sapUiSelectable'><td class='sapUiSupportTechInfoBorder sapUiSelectable'><label class='sapUiSupportLabel sapUiSelectable'>",e(F),"</label><br>");var H=G;if(q.isFunction(G)){H=G(i)||"";}i.push(e(H));i.push("</td></tr>");}function n(E,F,G,H,I){k(E,F,G,H,function(E){E.push("<table class='sapMSupportTable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody>");q.each(I,function(i,v){var J="";if(v!==undefined&&v!==null){if(typeof(v)=="string"||typeof(v)=="boolean"||(Array.isArray(v)&&v.length==1)){J=v;}else if((Array.isArray(v)||a(v))&&window.JSON){J=window.JSON.stringify(v);}}k(E,false,false,i,""+J);});E.push("</tbody></table>");});}function p(F){o={version:F.commonInformation.version,build:F.commonInformation.buildTime,change:F.commonInformation.lastChange,useragent:F.commonInformation.userAgent,docmode:F.commonInformation.documentMode,debug:F.commonInformation.debugMode,bootconfig:F.configurationBootstrap,config:F.configurationComputed,loadedlibs:F.loadedLibraries,modules:F.loadedModules,uriparams:F.URLParameters,appurl:F.commonInformation.applicationHREF};var E=["<table class='sapUiSelectable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody class='sapUiSelectable'>"];k(E,true,true,"SAPUI5 Version",function(i){i.push(o.version," (built at ",o.build,", last change ",o.change,")");});k(E,true,true,"User Agent",function(i){i.push(o.useragent,(o.docmode?", Document Mode '"+o.docmode+"'":""));});k(E,true,true,"Debug Sources",function(i){i.push((o.debug?"ON":"OFF"));});k(E,true,true,"Application",o.appurl);n(E,true,true,"Configuration (bootstrap)",o.bootconfig);n(E,true,true,"Configuration (computed)",o.config);n(E,true,true,"URI Parameters",o.uriparams);k(E,true,true,"End-to-End Trace",function(i){i.push("<label class='sapUiSupportLabel'>Trace Level:</label>","<select id='"+u(g.selLevel)+"' class='sapUiSupportTxtFld' >","<option value='low'>LOW</option>","<option value='medium' selected>MEDIUM</option>","<option value='high'>HIGH</option>","</select>");i.push("<button id='"+u(g.btnStart)+"' class='sapUiSupportBtn'>Start</button>");i.push("<div class='sapUiSupportDiv'>");i.push("<label class='sapUiSupportLabel'>XML Output:</label>");i.push("<textarea id='"+u(g.taContent)+"' class='sapUiSupportTxtArea sapUiSelectable' readonly ></textarea>");i.push("</div>");});k(E,true,true,"Loaded Libraries",function(G){G.push("<ul class='sapUiSelectable'>");q.each(o.loadedlibs,function(i,v){if(v&&(typeof(v)==="string"||typeof(v)==="boolean")){G.push("<li class='sapUiSelectable'>",i+" "+v,"</li>");}});G.push("</ul>");});k(E,true,true,"Loaded Modules",function(i){i.push("<div class='sapUiSupportDiv sapUiSelectable' id='"+u(j.dvLoadedModules)+"'></div>");});E.push("</tbody></table>");return new sap.ui.core.HTML({content:E.join("").replace(/\{/g,"&#123;").replace(/\}/g,"&#125;")});}function u(i){return b.getId()+"-"+i;}function x(v,E){var F="Modules";var G=0,H=[];G=E.length;q.each(E.sort(),function(i,J){H.push(new sap.m.Label({text:" - "+J}).addStyleClass("sapUiSupportPnlLbl"));});var I=new sap.m.Panel({expandable:true,expanded:false,headerToolbar:new sap.m.Toolbar({design:sap.m.ToolbarDesign.Transparent,content:[new sap.m.Label({text:F+" ("+G+")",design:sap.m.LabelDesign.Bold})]}),content:H});I.placeAt(u(v),"only");}function y(){if(b.traceXml){b.$(g.taContent).text(b.traceXml);}if(b.e2eLogLevel){b.$(g.selLevel).val(b.e2eLogLevel);}x(j.dvLoadedModules,o.modules);b.$(g.btnStart).one("tap",function(){b.e2eLogLevel=b.$(g.selLevel).val();b.$(g.btnStart).addClass("sapUiSupportRunningTrace").text("Running...");b.traceXml="";b.$(g.taContent).text("");sap.ui.core.support.trace.E2eTraceLib.start(b.e2eLogLevel,function(i){b.traceXml=i;});sap.m.MessageToast.show(g.infoText,{duration:g.infoDuration});b.close();});}function z(){if(b){return b;}var i=sap.ui.requireSync("sap/m/Dialog");var v=sap.ui.requireSync("sap/m/Button");sap.ui.requireSync("sap/ui/core/HTML");sap.ui.requireSync("sap/m/MessageToast");sap.ui.requireSync("sap/ui/core/support/trace/E2eTraceLib");b=new i({title:"Technical Information",horizontalScrolling:true,verticalScrolling:true,stretch:D.system.phone,buttons:[new v({text:"Close",press:function(){b.close();}})],afterOpen:function(){S.off();},afterClose:function(){S.on();}}).addStyleClass("sapMSupport");return b;}function A(E){if(E.touches){var i=E.touches.length;if(D.browser.mobile&&(D.browser.name===D.browser.BROWSER.INTERNET_EXPLORER||D.browser.name===D.browser.BROWSER.EDGE)){w=i;}if(i>f){d.removeEventListener('touchend',B);return;}switch(i){case h:s=Date.now();d.addEventListener('touchend',B);break;case f:if(s){t=Date.now()-s;l=E.touches[i-1].identifier;}break;}}}function B(E){var i=D.browser.mobile&&(D.browser.name===D.browser.BROWSER.INTERNET_EXPLORER||D.browser.name===D.browser.BROWSER.EDGE)&&w==f;d.removeEventListener('touchend',B);if(t>m&&(E.touches.length===h||i)&&E.changedTouches.length===r&&E.changedTouches[0].identifier===l){t=0;s=0;C();}}function C(){sap.ui.require(['sap/ui/core/support/ToolsAPI'],function(T){var i=z();i.removeAllAggregation("content");i.addAggregation("content",p(T.getFrameworkInformation()));b.open();y();});}return({on:function(){if(!c&&"ontouchstart"in d){c=true;d.addEventListener("touchstart",A);}return this;},off:function(){if(c){c=false;d.removeEventListener("touchstart",A);}return this;},open:function(){C();},isEventRegistered:function(){return c;}}).on();}(q,document));return S;},true);
sap.ui.predefine('sap/m/Switch',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/theming/Parameters','sap/ui/events/KeyCodes','./SwitchRenderer',"sap/base/assert"],function(l,C,E,I,P,K,S,a){"use strict";var t=l.touch;var c=l.SwitchType;
var d=C.extend("sap.m.Switch",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{state:{type:"boolean",group:"Misc",defaultValue:false},customTextOn:{type:"string",group:"Misc",defaultValue:""},customTextOff:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Data",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.SwitchType",group:"Appearance",defaultValue:c.Default}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{state:{type:"boolean"}}}},designtime:"sap/m/designtime/Switch.designtime"}});
I.insertFontFaceStyle();E.apply(d.prototype,[true]);
d.prototype._slide=function(p){if(p>d._OFFPOSITION){p=d._OFFPOSITION;}else if(p<d._ONPOSITION){p=d._ONPOSITION;}if(this._iCurrentPosition===p){return;}this._iCurrentPosition=p;this.getDomRef("inner").style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=p+"px";this._setTempState(Math.abs(p)<d._SWAPPOINT);};
d.prototype._resetSlide=function(){this.getDomRef("inner").style.cssText="";};
d.prototype._setTempState=function(b){if(this._bTempState===b){return;}this._bTempState=b;this.getDomRef("handle").setAttribute("data-sap-ui-swt",b?this._sOn:this._sOff);};
d.prototype._getInvisibleElement=function(){return this.$("invisible");};
d.prototype.getInvisibleElementId=function(){return this.getId()+"-invisible";};
d.prototype.getInvisibleElementText=function(s){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var T="";switch(this.getType()){case c.Default:if(s){T=this.getCustomTextOn().trim()||b.getText("SWITCH_ON");}else{T=this.getCustomTextOff().trim()||b.getText("SWITCH_OFF");}break;case c.AcceptReject:if(s){T=b.getText("SWITCH_ARIA_ACCEPT");}else{T=b.getText("SWITCH_ARIA_REJECT");}break;}return T;};
d._ONPOSITION=Number(P.get("_sap_m_Switch_OnPosition"));d._OFFPOSITION=Number(P.get("_sap_m_Switch_OffPosition"));d._SWAPPOINT=Math.abs((d._ONPOSITION-d._OFFPOSITION)/2);
d.prototype.onBeforeRendering=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sOn=this.getCustomTextOn()||r.getText("SWITCH_ON");this._sOff=this.getCustomTextOff()||r.getText("SWITCH_OFF");};
d.prototype.ontouchstart=function(e){var T=e.targetTouches[0],b=this.getRenderer().CSS_CLASS,s=this.$("inner");e.setMarked();if(t.countContained(e.touches,this.getId())>1||!this.getEnabled()||e.button){return;}this._iActiveTouchId=T.identifier;this._bTempState=this.getState();this._iStartPressPosX=T.pageX;this._iPosition=s.position().left;this._bDragging=false;setTimeout(this["focus"].bind(this),0);this.$("switch").addClass(b+"Pressed");};
d.prototype.ontouchmove=function(e){e.setMarked();e.preventDefault();var T,p,f=t;if(!this.getEnabled()||e.button){return;}a(f.find(e.touches,this._iActiveTouchId),"missing touchend");T=f.find(e.changedTouches,this._iActiveTouchId);if(!T||Math.abs(T.pageX-this._iStartPressPosX)<6){return;}this._bDragging=true;p=((this._iStartPressPosX-T.pageX)*-1)+this._iPosition;if(sap.ui.getCore().getConfiguration().getRTL()){p=-p;}this._slide(p);};
d.prototype.ontouchend=function(e){e.setMarked();var T,f=t;if(!this.getEnabled()||e.button){return;}a(this._iActiveTouchId!==undefined,"expect to already be touching");T=f.find(e.changedTouches,this._iActiveTouchId);if(T){a(!f.find(e.touches,this._iActiveTouchId),"touchend still active");if(!this._updateStateAndNotify()){this.$("switch").removeClass(this.getRenderer().CSS_CLASS+"Pressed");this._resetSlide();}}};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype._handleSpaceOrEnter=function(e){if(this.getEnabled()){e.setMarked();if(!this._bDragging){this._updateStateAndNotify();}}};
d.prototype.onsapspace=function(e){e.preventDefault();};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE){this._handleSpaceOrEnter(e);}};
d.prototype.onsapenter=d.prototype._handleSpaceOrEnter;
d.prototype._updateStateAndNotify=function(){var s=this.getState(),b;this.setState(this._bDragging?this._bTempState:!s);b=s!==this.getState();if(b){this.fireChange({state:this.getState()});}this._bDragging=false;return b;};
d.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=this.getState(),D=s?b.getText("ACC_CTR_STATE_CHECKED")+" "+this.getInvisibleElementText(s):b.getText("ACC_CTR_STATE_NOT_CHECKED")+" "+this.getInvisibleElementText(s);return{role:"checkbox",type:b.getText("ACC_CTR_TYPE_CHECKBOX"),description:D.trim(),focusable:this.getEnabled(),enabled:this.getEnabled()};};
return d;});
sap.ui.predefine('sap/m/SwitchRenderer',["sap/ui/Device","sap/m/library"],function(D,l){"use strict";var S=l.SwitchType;var a={apiVersion:2};a.CSS_CLASS="sapMSwt";
a.render=function(r,s){var b=s.getState(),c=b?s._sOn:s._sOff,t=s.getTooltip_AsString(),e=s.getEnabled(),n=s.getName(),A=sap.ui.getCore().getConfiguration().getAccessibility(),d=sap.ui.getCore().getConfiguration().getAnimation(),C=a.CSS_CLASS;r.openStart("div",s);r.class(C+"Cont");if(!e){r.class(C+"ContDisabled");}if(e){r.attr("tabindex","0");}if(t){r.attr("title",t);}if(A){this.writeAccessibilityState(r,s);}r.openEnd();r.openStart("div",s.getId()+"-switch");r.attr("aria-hidden","true");r.class(C);if(d){r.class(C+"Trans");}r.class(b?C+"On":C+"Off");r.class(C+s.getType());if(D.system.desktop&&e){r.class(C+"Hoverable");}if(!e){r.class(C+"Disabled");}if(s._sOn===" "&&s._sOff===" "){r.class(C+"NoLabel");}r.openEnd();r.openStart("div",s.getId()+"-inner");r.class(C+"Inner");r.openEnd();this.renderText(r,s);this.renderHandle(r,s,c);r.close("div");r.close("div");if(n){this.renderCheckbox(r,s,c);}if(A){this.renderInvisibleElement(r,s,{id:s.getInvisibleElementId(),text:s.getInvisibleElementText(b)});}r.close("div");};
a.renderText=function(r,s){var C=a.CSS_CLASS,d=s.getType()===S.Default;r.openStart("div",s.getId()+"-texton");r.class(C+"Text");r.class(C+"TextOn");r.openEnd();r.openStart("span");r.class(C+"Label");r.class(C+"LabelOn");r.openEnd();if(d){r.text(s._sOn);}r.close("span");r.close("div");r.openStart("div",s.getId()+"-textoff");r.class(C+"Text");r.class(C+"TextOff");r.openEnd();r.openStart("span");r.class(C+"Label");r.class(C+"LabelOff");r.openEnd();if(d){r.text(s._sOff);}r.close("span");r.close("div");};
a.renderHandle=function(r,s,b){var C=a.CSS_CLASS;r.openStart("div",s.getId()+"-handle");r.attr("data-sap-ui-swt",b);r.class(C+"Handle");r.openEnd();r.close("div");};
a.renderCheckbox=function(r,s,b){r.voidStart("input",s.getId()+"-input");r.attr("type","checkbox");r.attr("name",s.getName());r.attr("value",b);if(s.getState()){r.attr("checked","checked");}if(!s.getEnabled()){r.attr("disabled","disabled");}r.voidEnd();};
a.writeAccessibilityState=function(r,s){var A=s.getAriaLabelledBy(),m;if(A){A={value:s.getInvisibleElementId(),append:true};}m={role:"checkbox",checked:s.getState(),labelledby:A};r.accessibilityState(s,m);};
a.renderInvisibleElement=function(r,s,o){r.openStart("span",o.id);r.attr("aria-hidden","true");r.class("sapUiInvisibleText");r.openEnd();r.text(o.text);r.close("span");};
return a;},true);
sap.ui.predefine('sap/m/TabContainer',['./library','sap/ui/core/Control','sap/ui/core/IconPool','./TabContainerRenderer','./TabStrip','./TabStripItem','./Button'],function(l,C,I,T,a,b,B){"use strict";var c=l.ButtonType;var P=l.PageBackgroundDesign;
var d=C.extend("sap.m.TabContainer",{
metadata:{library:"sap.m",properties:{showAddNewButton:{type:"boolean",group:"Misc",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:P.List}},aggregations:{items:{type:"sap.m.TabContainerItem",multiple:true,singularName:"item",bindable:"bindable"},_addNewButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_tabStrip:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.m.TabContainerItem",multiple:false}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},addNewButtonPress:{}},designtime:"sap/m/designtime/TabContainer.designtime",dnd:{draggable:false,droppable:true}},
constructor:function(i,s){var S=[];if(!s&&typeof i==='object'){s=i;}if(s&&Array.isArray(s['items'])){S=s['items'];delete s['items'];}C.prototype.constructor.apply(this,arguments);var o=new a(this.getId()+"--tabstrip",{hasSelect:true,itemSelect:function(e){var f=e.getParameter("item"),g=this._fromTabStripItem(f);this.setSelectedItem(g,e);}.bind(this),itemClose:function(e){var f=e.getParameter("item"),r=this._fromTabStripItem(f);e.preventDefault();if(this.fireItemClose({item:r})){if(!this.getBinding("items")){this.removeItem(r);}}}.bind(this)});this.setAggregation("_tabStrip",o,true);if(s&&s['showAddNewButton']){this.setShowAddNewButton(true);}S.forEach(function(e){this.addItem(e);},this);this.data("sap-ui-fastnavgroup","true",true);}
});
var t={"name":"text","additionalText":"additionalText","icon":"icon","iconTooltip":"iconTooltip","modified":"modified"};
d.prototype.onBeforeRendering=function(){if(this.getSelectedItem()){return;}this._setDefaultTab();};
d.prototype._getAddNewTabButton=function(){var o=this.getAggregation("_addNewButton");var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!o){o=new B({type:c.Transparent,tooltip:r.getText("TABCONTAINER_ADD_NEW_TAB"),icon:I.getIconURI("add"),press:function(){this.getParent().getParent().fireAddNewButtonPress();}});o.addStyleClass("sapMTSAddNewTabBtn");this.setAggregation("_addNewButton",o,true);}return o;};
d.prototype._getTabStrip=function(){return this.getAggregation("_tabStrip");};
d.prototype._fromTabStripItem=function(i){var e=this.getItems()||[],f=e.length,g=0;for(;g<f;g++){if(e[g].getId()===i.getKey()){return e[g];}}return null;};
d.prototype._toTabStripItem=function(i){var e=0,k=i,o,f,g=this._getTabStrip();if(!g){return null;}o=g.getItems();f=o.length;if(typeof i==="object"){k=i.getId();}for(;e<f;e++){if(o[e].getKey()===k){return o[e];}}return null;};
d.prototype._getSelectedItemContent=function(){var o=this._getTabStrip(),s=this.getSelectedItem(),S=sap.ui.getCore().byId(s),e=this._toTabStripItem(S);if(o){o.setSelectedItem(e);}return S?S.getContent():null;};
d.prototype._moveToNextItem=function(s){if(!this._getTabStrip()._oItemNavigation){return;}var i=this.getItems().length,e=this._getTabStrip()._oItemNavigation.getFocusedIndex(),n=i===e?--e:e,N=this.getItems()[n],f=function(){if(this._getTabStrip()._oItemNavigation){this._getTabStrip()._oItemNavigation.focusItem(n);}};if(s){this.setSelectedItem(N);this.fireItemSelect({item:N});}if(document.activeElement.classList.contains('sapMTabStripSelectListItemCloseBtn')){setTimeout(f.bind(this),0);}};
d.prototype._attachItemPropertyChanged=function(o){o.attachItemPropertyChanged(function(e){var p=e['mParameters'].propertyKey;if(t[p]){p=t[p];var f=this._toTabStripItem(e.getSource());var m="set"+p.substr(0,1).toUpperCase()+p.substr(1);f&&f[m](e['mParameters'].propertyValue);}}.bind(this));};
d.prototype.removeItem=function(i){var e;if(typeof i==="undefined"||i===null){return null;}i=this.removeAggregation("items",i);e=i.getId()===this.getSelectedItem();this._getTabStrip().removeItem(this._toTabStripItem(i));this._moveToNextItem(e);return i;};
d.prototype.addAggregation=function(A,o,s){if(A==='items'){this._attachItemPropertyChanged(o);}return C.prototype.addAggregation.call(this,A,o,s);};
d.prototype.insertAggregation=function(A,o,i,s){if(A==='items'){this._attachItemPropertyChanged(o);}return C.prototype.insertAggregation.call(this,A,o,i,s);};
d.prototype.addItem=function(i){this.addAggregation("items",i,false);this._getTabStrip().addItem(new b({key:i.getId(),text:i.getName(),additionalText:i.getAdditionalText(),icon:i.getIcon(),iconTooltip:i.getIconTooltip(),modified:i.getModified(),tooltip:i.getTooltip()}));return this;};
d.prototype.destroyItems=function(){this._getTabStrip().destroyItems();this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
d.prototype.insertItem=function(i,e){this._getTabStrip().insertItem(new b({key:i.getId(),text:i.getName(),additionalText:i.getAdditionalText(),icon:i.getIcon(),iconTooltip:i.getIconTooltip(),modified:i.getModified(),tooltip:i.getTooltip()}),e);return this.insertAggregation("items",i,e);};
d.prototype.removeAllItems=function(){this._getTabStrip().removeAllItems();this.setSelectedItem(null);return this.removeAllAggregation("items");};
d.prototype.setAddButton=function(o){return this._getTabStrip().setAddButton(o);};
d.prototype.getAddButton=function(){return this._getTabStrip().getAddButton();};
d.prototype.setShowAddNewButton=function(s){this.setProperty("showAddNewButton",s,true);var o=this._getTabStrip();if(o){o.setAddButton(s?this._getAddNewTabButton():null);}return this;};
d.prototype.setSelectedItem=function(s,e){if(this.fireItemSelect({item:s})){var o=this._getTabStrip();if(s&&o){o.setSelectedItem(this._toTabStripItem(s));this._rerenderContent(s.getContent());}d.prototype.setAssociation.call(this,"selectedItem",s,true);return this;}if(e){e.preventDefault();}return this;};
d.prototype._rerenderContent=function(o){var $=this.$("content"),r;if(!o||($.length<=0)){return;}r=sap.ui.getCore().createRenderManager();for(var i=0;i<o.length;i++){r.renderControl(o[i]);}r.flush($[0]);r.destroy();};
d.prototype._setDefaultTab=function(){var f=this.getItems()[0]||null;this.setSelectedItem(f);return f;};
return d;});
sap.ui.predefine('sap/m/TabContainerItem',['sap/ui/core/Element','sap/ui/core/IconPool','./TabStripItem','./library'],function(E,I,T,l){"use strict";
var a=E.extend("sap.m.TabContainerItem",{metadata:{library:"sap.ui.core",properties:{name:{type:"string",group:"Misc",defaultValue:""},additionalText:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},key:{type:"string",group:"Data",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,defaultValue:null},_image:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{itemPropertyChanged:{parameters:{itemChanged:{type:"sap.m.TabContainerItem"},propertyKey:{type:"string"},propertyValue:{type:"any"}}}},dnd:{draggable:true,droppable:false}}});
a.prototype.setProperty=function(n,v,s){if(n==="modified"){s=true;}this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return E.prototype.setProperty.call(this,n,v,s);};
a.prototype.setIcon=function(i){return T.prototype._setIcon.call(this,i,true);};
a.prototype._getImage=function(){return this.getAggregation("_image");};
return a;});
sap.ui.predefine('sap/m/TabContainerRenderer',[],function(){"use strict";var T={};
T.render=function(r,c){var t=c._getTabStrip(),s=c._getSelectedItemContent();r.write("<div ");r.writeControlData(c);r.addClass("sapMTabContainer");r.writeClasses();r.write(">");if(t){r.renderControl(t);}r.write("<div id='"+c.getId()+"-containerContent' ");r.addClass("sapMTabContainerContent");if(c.getBackgroundDesign()){r.class("sapMTabContainerContent"+c.getBackgroundDesign());}r.writeClasses();r.write(">");r.write("<div id='"+this.getContentDomId(c)+"' class='sapMTabContainerInnerContent'");r.writeAccessibilityState(c,this.getTabContentAccAttributes(c));r.write(">");if(s){s.forEach(function(C){r.renderControl(C);});}r.write("</div>");r.write("</div>");r.write("</div>");};
T.getTabContentAccAttributes=function(c){var s=c.getSelectedItem(),t,a={role:"tabpanel"};if(s){t=c._toTabStripItem(s);if(t){a["aria-labelledby"]=t.getId();}}return a;};
T.getContentDomId=function(c){return c.getId()+"-content";};
return T;},true);
sap.ui.predefine('sap/m/TabStrip',['sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/base/ManagedObject','sap/ui/core/delegate/ScrollEnablement','./AccButton','./TabStripItem','sap/m/Select','sap/m/SelectList','sap/ui/Device','sap/ui/core/Renderer','sap/ui/core/ResizeHandler','sap/m/library','sap/ui/core/Icon','sap/m/Image','sap/m/SelectRenderer','sap/m/SelectListRenderer','./TabStripRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL"],function(C,I,a,M,S,A,T,b,c,D,R,d,l,e,f,g,h,i,L,q){"use strict";var j=l.SelectType;var B=l.ButtonType;
var k=C.extend("sap.m.TabStrip",{
metadata:{library:"sap.m",properties:{hasSelect:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{items:{type:"sap.m.TabStripItem",multiple:true,singularName:"item"},addButton:{type:"sap.m.Button",multiple:false,singularName:"addButton"},_select:{type:'sap.m.Select',multiple:false,visibility:"hidden"},_rightArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"},_leftArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:'sap.m.TabStripItem',group:"Misc"}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPress:{parameters:{item:{type:"sap.m.TabStripItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}}}},
constructor:function(v,s){var H=false;if(!s&&typeof v==='object'){s=v;}if(s){H=s['hasSelect'];delete s['hasSelect'];}M.prototype.constructor.apply(this,arguments);this.setProperty('hasSelect',H,true);}
});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");k.ICON_BUTTONS={LeftArrowButton:"slim-arrow-left",RightArrowButton:"slim-arrow-right",DownArrowButton:"slim-arrow-down",AddButton:"add"};k.SELECT_ITEMS_ID_SUFFIX='-SelectItem';k.SCROLL_SIZE=320;k.MIN_DRAG_OFFSET=D.support.touch?15:5;k.SCROLL_ANIMATION_DURATION=sap.ui.getCore().getConfiguration().getAnimation()?500:0;
k.prototype.init=function(){this._bDoScroll=!D.system.phone;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._iCurrentScrollLeft=0;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(!D.system.phone){this._oScroller=new S(this,this.getId()+"-tabs",{horizontal:true,vertical:false,nonTouchScrolling:true});}};
k.prototype.exit=function(){this._bRtl=null;this._iCurrentScrollLeft=null;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._removeItemNavigation();};
k.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
k.prototype.onAfterRendering=function(){if(this._oScroller){this._oScroller.setIconTabBar(this,q.proxy(this._handleOverflowButtons,this),null);}this._addItemNavigation();if(!D.system.phone){this._oScroller._$Container=this.$("tabsContainer");this._adjustScrolling();if(this.getSelectedItem()){if(!sap.ui.getCore().isThemeApplied()){sap.ui.getCore().attachThemeChanged(this._handleInititalScrollToItem,this);}else{this._handleInititalScrollToItem();}}this._sResizeListenerId=d.register(this.getDomRef(),q.proxy(this._adjustScrolling,this));}};
k.prototype._handleInititalScrollToItem=function(){var $=sap.ui.getCore().byId(this.getSelectedItem());if($&&$.$().length>0){this._scrollIntoView($,500);}sap.ui.getCore().detachThemeChanged(this._handleInititalScrollToItem,this);};
k.prototype.getFocusDomRef=function(){var t=sap.ui.getCore().byId(this.getSelectedItem());if(!t){return null;}return t.getDomRef();};
k.prototype.applyFocusInfo=function(F){if(F.focusDomRef){q(F.focusDomRef).focus();}};
k.prototype._addItemNavigation=function(){var H=this.getDomRef("tabsContainer"),s=this.getItems(),t=[];s.forEach(function(u){var v=u.getDomRef();q(v).attr("tabindex","-1");t.push(v);});if(!this._oItemNavigation){this._oItemNavigation=new a();}this._oItemNavigation.setRootDomRef(H);this._oItemNavigation.setItemDomRefs(t);this._oItemNavigation.setCycling(false);this._oItemNavigation.setPageSize(5);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this.addDelegate(this._oItemNavigation);};
k.prototype._checkScrolling=function(){var t=this.getDomRef("tabs"),s=t&&(t.scrollWidth>this.getDomRef("tabsContainer").offsetWidth);this.$().toggleClass("sapMTSScrollable",s);return s;};
k.prototype._handleOverflowButtons=function(){var t=this.getDomRef("tabs"),s=this.getDomRef("tabsContainer"),u,v,w,x=false,y=false,z=this._checkScrolling();if(z&&!this.getAggregation("_rightArrowButton")&&!this.getAggregation("_leftArrowButton")){this._getLeftArrowButton();this._getRightArrowButton();var E=sap.ui.getCore().createRenderManager();this.getRenderer().renderRightOverflowButtons(E,this,true);this.getRenderer().renderLeftOverflowButtons(E,this,true);E.destroy();}if(z&&t&&s){if(this._bRtl){u=q(s).scrollLeftRTL();}else{u=s.scrollLeft;}v=t.scrollWidth;w=s.clientWidth;if(Math.abs(v-w)===1){v=w;}if(u>0){if(this._bRtl){y=true;}else{x=true;}}if((v>w)&&(u+w<v)){if(this._bRtl){x=true;}else{y=true;}}this.$().toggleClass("sapMTSScrollBack",x).toggleClass("sapMTSScrollForward",y);}else{this.$().toggleClass("sapMTSScrollBack",false).toggleClass("sapMTSScrollForward",false);}};
k.prototype._adjustScrolling=function(){this._iMaxOffsetLeft=Math.abs(this.$("tabsContainer").width()-this.$("tabs").width());this._handleOverflowButtons();};
k.prototype._getLeftArrowButton=function(){return this._getArrowButton("_leftArrowButton",r.getText("TABSTRIP_SCROLL_BACK"),k.ICON_BUTTONS.LeftArrowButton,-k.SCROLL_SIZE);};
k.prototype._getRightArrowButton=function(){return this._getArrowButton("_rightArrowButton",r.getText("TABSTRIP_SCROLL_FORWARD"),k.ICON_BUTTONS.RightArrowButton,k.SCROLL_SIZE);};
k.prototype._getArrowButton=function(s,t,u,v){var w=this.getAggregation(s),x=this;if(!w){w=new A({type:B.Transparent,icon:I.getIconURI(u),tooltip:t,tabIndex:"-1",ariaHidden:"true",press:function(E){x._scroll(v,k.SCROLL_ANIMATION_DURATION);}});this.setAggregation(s,w,true);}return w;};
k.prototype._removeItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
k.prototype._scroll=function(s,t){var u=this.getDomRef("tabsContainer").scrollLeft,v=D.browser.internet_explorer||D.browser.edge,w;if(this._bRtl&&!v){w=u-s;if(D.browser.firefox){if(w<-this._iMaxOffsetLeft){w=-this._iMaxOffsetLeft;}if(w>0){w=0;}}}else{w=u+s;if(w<0){w=0;}if(w>this._iMaxOffsetLeft){w=this._iMaxOffsetLeft;}}this._oScroller.scrollTo(w,0,t);this._iCurrentScrollLeft=w;};
k.prototype._scrollIntoView=function(s,t){var $=this.$("tabs"),u=s.$(),v=$.innerWidth()-$.width(),w=u.outerWidth(true),x=u.position().left-v/2,y=this.getDomRef("tabsContainer"),z=y.scrollLeft,E=this.$("tabsContainer").width(),N=z,F=D.browser.internet_explorer||D.browser.edge;if(x<0||x>E-w){if(this._bRtl&&D.browser.firefox){if(x<0){N+=x+w-E;}else{N+=x;}}else if(this._bRtl&&F){if(x<0){N-=x;}else{N-=x+w-E;}}else{if(x<0){N+=x;}else{N+=x+w-E;}}this._iCurrentScrollLeft=N;this._oScroller.scrollTo(N,0,t);}};
k.prototype._createSelect=function(t){var s,u,v,w={type:D.system.phone?j.Default:j.IconOnly,autoAdjustWidth:true,maxWidth:D.system.phone?"100%":"2.5rem",icon:I.getIconURI(k.ICON_BUTTONS.DownArrowButton),tooltip:r.getText("TABSTRIP_OPENED_TABS"),change:function(E){u=E.getParameters()['selectedItem'];v=this._findTabStripItemFromSelectItem(u);if(v instanceof T){this._activateItem(v,E);}}.bind(this)};s=new n(w).addStyleClass("sapMTSOverflowSelect");this._addItemsToSelect(s,t);return s;};
k.prototype.onsapselect=function(E){E.setMarked();E.preventDefault();if(E.srcControl instanceof T){this._activateItem(E.srcControl,E);}};
k.prototype.onsapdelete=function(E){var s=q("#"+E.target.id).control(0),t=s.getId()===this.getSelectedItem(),u=function(){this._moveToNextItem(t);};this._removeItem(s,u);};
k.prototype._moveToNextItem=function(s){if(!this._oItemNavigation){return;}var t=this.getItems().length,u=this._oItemNavigation.getFocusedIndex(),N=t===u?--u:u,v=this.getItems()[N],F=function(){if(this._oItemNavigation){this._oItemNavigation.focusItem(N);}};if(s){this.setSelectedItem(v);this.fireItemPress({item:v});}setTimeout(F.bind(this),0);};
k.prototype._activateItem=function(s,E){if(this.fireItemSelect({item:s})){if(!this.getSelectedItem()||this.getSelectedItem()!==s.getId()){this.setSelectedItem(s);}this.fireItemPress({item:s});}else if(E&&!E.isDefaultPrevented()){E.preventDefault();}};
k.prototype.addAggregation=function(s,O,t){if(s==='items'){this._handleItemsAggregation(['addAggregation',O,t],true);}return C.prototype.addAggregation.call(this,s,O,t);};
k.prototype.insertAggregation=function(s,O,t,u){if(s==='items'){this._handleItemsAggregation(['insertAggregation',O,t,u],true);}return C.prototype.insertAggregation.call(this,s,O,t,u);};
k.prototype.removeAggregation=function(s,O,t){if(s==='items'){this._handleItemsAggregation(['removeAggregation',O,t]);}return C.prototype.removeAggregation.call(this,s,O,t);};
k.prototype.removeAllAggregation=function(s,t){if(s==='items'){this._handleItemsAggregation(['removeAllAggregation',null,t]);}return C.prototype.removeAllAggregation.call(this,s,t);};
k.prototype.destroyAggregation=function(s,t){if(s==='items'){this._handleItemsAggregation(['destroyAggregation',t]);}return C.prototype.destroyAggregation.call(this,s,t);};
k.prototype.setSelectedItem=function(s){if(!s){return this;}if(s.$().length>0){this._scrollIntoView(s,500);}this._updateAriaSelectedAttributes(this.getItems(),s);this._updateSelectedItemClasses(s.getId());if(this.getHasSelect()){var t=this._findSelectItemFromTabStripItem(s);this.getAggregation('_select').setSelectedItem(t);}return this.setAssociation("selectedItem",s,true);};
k.prototype.setProperty=function(P,v,s){var t;t=C.prototype.setProperty.call(this,P,v,s);if(P==='hasSelect'){if(v){if(!this.getAggregation('_select')){t=this.setAggregation('_select',this._createSelect(this.getItems()));}}else{t=this.destroyAggregation('_select');}}return t;};
k.prototype._attachItemEventListeners=function(O){if(O instanceof T){var E=['itemClosePressed','itemPropertyChanged'];E.forEach(function(s){s=s.charAt(0).toUpperCase()+s.slice(1);O['detach'+s](this['_handle'+s]);O['attach'+s](this['_handle'+s].bind(this));},this);}};
k.prototype._detachItemEventListeners=function(O){if(!O||typeof O!=='object'||!(O instanceof T)){var s=this.getItems();s.forEach(function(t){if(typeof t!=='object'||!(t instanceof T)){return;}return this._detachItemEventListeners(t);}.bind(this));}};
k.prototype._handleItemPropertyChanged=function(E){var s=this._findSelectItemFromTabStripItem(E.getSource());var P=E['mParameters'].propertyKey;var t="set"+P.substr(0,1).toUpperCase()+P.substr(1);s[t](E['mParameters'].propertyValue);};
k.prototype._handleItemClosePressed=function(E){this._removeItem(E.getSource());};
k.prototype._removeItem=function(s,t){var u;if(!(s instanceof T)){L.error('Expecting instance of a TabStripSelectItem, given: ',s);}if(s.getId().indexOf(k.SELECT_ITEMS_ID_SUFFIX)!==-1){u=this._findTabStripItemFromSelectItem(s);}else{u=s;}if(this.fireItemClose({item:u})){this.removeAggregation('items',u);this._moveToNextItem(s.getId()===this.getSelectedItem());if(t){t.call(this);}}};
k.prototype._handleItemsAggregation=function(s,t){var u='items',F=s[0],O=s[1],N=[u];s.forEach(function(v,w){if(w>0){N.push(v);}});if(t){this._attachItemEventListeners(O);}else{this._detachItemEventListeners(O);}if(u!=="items"){return this;}if(this.getHasSelect()){this._handleSelectItemsAggregation(N,t,F,O);}return this;};
k.prototype._handleSelectItemsAggregation=function(s,t,F,O){var u=this.getAggregation('_select'),v;if(F==='destroyAggregation'&&!u){return;}if(O===null||typeof O!=='object'){return u[F]['apply'](u,s);}if(t){v=this._createSelectItemFromTabStripItem(O);}else{v=this._findSelectItemFromTabStripItem(O);}s.forEach(function(w,x){if(typeof w==='object'){s[x]=v;}});return u[F]['apply'](u,s);};
k.prototype._addItemsToSelect=function(s,t){t.forEach(function(u){var v=this._createSelectItemFromTabStripItem(u);s.addAggregation('items',v);if(u.getId()===this.getSelectedItem()){s.setSelectedItem(v);}},this);};
k.prototype._createSelectItemFromTabStripItem=function(t){var s;if(!t&&!(t instanceof sap.m.TabContainerItem)){L.error('Expecting instance of "sap.m.TabContainerItem": instead of '+t+' given.');return;}s=new T({id:t.getId()+k.SELECT_ITEMS_ID_SUFFIX,text:t.getText(),additionalText:t.getAdditionalText(),icon:t.getIcon(),iconTooltip:t.getIconTooltip(),modified:t.getModified(),itemClosePressed:function(E){this._handleItemClosePressed(E);}.bind(this)});s.addEventDelegate({ontap:function(E){var u=E.srcControl;if(E.target.id===u.getParent().getId()+"-img"){E.srcControl=u=u.getParent();}if((u instanceof A||u instanceof e)){this.fireItemClosePressed({item:this});}}},s);return s;};
k.prototype._findTabStripItemFromSelectItem=function(t){var s,u=t.getId().replace(k.SELECT_ITEMS_ID_SUFFIX,''),v=this.getItems();for(s=0;s<v.length;s++){if(v[s].getId()===u){return v[s];}}};
k.prototype._findSelectItemFromTabStripItem=function(t){var s,u,v=t.getId()+k.SELECT_ITEMS_ID_SUFFIX;if(this.getHasSelect()){u=this.getAggregation('_select').getItems();for(s=0;s<u.length;s++){if(u[s].getId()===v){return u[s];}}}};
k.prototype._updateAriaSelectedAttributes=function(s,t){var u;s.forEach(function(v){u="false";if(v.$()){if(t&&t.getId()===v.getId()){u="true";}v.$().attr("aria-selected",u);}});};
k.prototype._updateSelectedItemClasses=function(s){if(this.$("tabs")){this.$("tabs").children(".sapMTabStripItemSelected").removeClass("sapMTabStripItemSelected");q("#"+s).addClass("sapMTabStripItemSelected");}};
k.prototype.changeItemState=function(v,s){var $;var t=this.getItems();t.forEach(function(u){if(v===u.getId()){$=q(u.$());if(s===true&&!$.hasClass(T.CSS_CLASS_MODIFIED)){$.addClass(T.CSS_CLASS_MODIFIED);}else{$.removeClass(T.CSS_CLASS_MODIFIED);}}});};
k.prototype.ontouchstart=function(E){var t=q(E.target).control(0);if(t instanceof T||t instanceof A||t instanceof e||t instanceof f||t instanceof n){this._oTouchStartX=E.changedTouches[0].pageX;}};
k.prototype.ontouchend=function(E){var t,s;if(!this._oTouchStartX){return;}t=q(E.target).control(0);if(E.target.id===t.getParent().getId()+"-img"){t=t.getParent();}s=Math.abs(E.changedTouches[0].pageX-this._oTouchStartX);if(s<k.MIN_DRAG_OFFSET){if(t instanceof T){this._activateItem(t,E);}else if(t instanceof A){if(t&&t.getParent&&t.getParent()instanceof T){t=t.getParent();this._removeItem(t);}}else if(t instanceof e){if(t&&t.getParent&&t.getParent().getParent&&t.getParent().getParent()instanceof T){t=t.getParent().getParent();this._removeItem(t);}}this._oTouchStartX=null;}};
k.prototype.destroyItems=function(){this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
var m=R.extend(g);
var n=b.extend("sap.m.internal.TabStripSelect",{
metadata:{library:"sap.m"},
renderer:m
});
n.prototype.onAfterRendering=function(){b.prototype.onAfterRendering.apply(this,arguments);this.$().attr("tabindex","-1");};
n.prototype.onAfterRenderingPicker=function(){var P=this.getPicker();b.prototype.onAfterRenderingPicker.call(this);if(D.system.phone){return;}P.setOffsetX(Math.round(sap.ui.getCore().getConfiguration().getRTL()?this.getPicker().$().width()-this.$().width():this.$().width()-this.getPicker().$().width()));P.setOffsetY(this.$().parents().hasClass('sapUiSizeCompact')?2:3);P._calcPlacement();};
n.prototype.createList=function(){this._oList=new p({width:"100%"}).attachSelectionChange(this.onSelectionChange,this).addEventDelegate({ontap:function(E){this.close();}},this);return this._oList;};
n.prototype.setValue=function(v){b.prototype.setValue.apply(this,arguments);this.$("label").toggleClass("sapMTSOverflowSelectLabelModified",this.getSelectedItem()&&this.getSelectedItem().getProperty("modified"));return this;};
n.prototype._getValueIcon=function(){return null;};
var o=R.extend(h);
o.renderItem=function(s,t,u,v){s.write("<li");s.writeElementData(u);s.addClass(h.CSS_CLASS+"ItemBase");s.addClass(h.CSS_CLASS+"Item");s.addClass("sapMTSOverflowSelectListItem");if(u.getProperty("modified")){s.addClass("sapMTSOverflowSelectListItemModified");}if(D.system.desktop){s.addClass(h.CSS_CLASS+"ItemBaseHoverable");}if(u===t.getSelectedItem()){s.addClass(h.CSS_CLASS+"ItemBaseSelected");}s.writeAttribute("tabindex",0);s.writeClasses();this.writeItemAccessibilityState.apply(this,arguments);s.write(">");s.write('<div class=\"sapMSelectListItemText\">');if(u.getIcon()){s.renderControl(u._getImage());}s.write("<div");s.addClass("sapMTSTexts");s.writeClasses();s.write(">");this.renderItemText(s,u.getAdditionalText(),T.CSS_CLASS_TEXT);this.renderItemText(s,u.getText(),T.CSS_CLASS_LABEL);s.write("</div>");s.write('</div>');s.renderControl(u.getAggregation('_closeButton'));s.write("</li>");};
o.renderItemText=function(s,t,u){s.write("<div class='"+u+"'>");s.writeEscaped(t.slice(0,(D.system.phone?t.length:T.DISPLAY_TEXT_MAX_LENGTH)));if(!D.system.phone&&t.length>T.DISPLAY_TEXT_MAX_LENGTH){s.write('...');}s.write("</div>");};
var p=c.extend("sap.m.internal.TabStripSelectList",{
metadata:{library:"sap.m"},
renderer:o
});
return k;});
sap.ui.predefine('sap/m/TabStripItem',["./library","sap/ui/core/Item","sap/ui/base/ManagedObject","sap/ui/core/IconPool","./AccButton"],function(l,I,M,a,A){"use strict";var B=l.ButtonType;var b=l.ImageHelper;
var T=I.extend("sap.m.TabStripItem",{metadata:{library:"sap.m",properties:{additionalText:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_closeButton:{type:"sap.m.Button",multiple:false},_image:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{itemClosePressed:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPropertyChanged:{parameters:{itemChanged:{type:'sap.m.TabStripItem'},propertyKey:{type:"string"},propertyValue:{type:"any"}}}}}});
T.DISPLAY_TEXT_MAX_LENGTH=25;T.CSS_CLASS="sapMTabStripItem";T.CSS_CLASS_LABEL="sapMTabStripItemLabel";T.CSS_CLASS_MODIFIED_SYMBOL="sapMTabStripItemModifiedSymbol";T.CSS_CLASS_TEXT="sapMTabStripItemAddText";T.CSS_CLASS_BUTTON="sapMTabStripItemButton";T.CSS_CLASS_MODIFIED="sapMTabStripItemModified";T.CSS_CLASS_SELECTED="sapMTabStripItemSelected";T.CSS_CLASS_STATE="sapMTabStripSelectListItemModified";T.CSS_CLASS_STATE_INVISIBLE="sapMTabStripSelectListItemModifiedInvisible";T.CSS_CLASS_CLOSE_BUTTON='sapMTabStripSelectListItemCloseBtn';T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE='sapMTabStripSelectListItemCloseBtnInvisible';
T.prototype.init=function(){var o=new A({type:B.Transparent,icon:a.getIconURI("decline"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("TABSTRIP_ITEM_CLOSE_BTN"),tabIndex:"-1",ariaHidden:"true"}).addStyleClass(T.CSS_CLASS_CLOSE_BUTTON);this.setAggregation('_closeButton',o);};
T.prototype.setProperty=function(n,v,s){if(n==='modified'){s=true;}M.prototype.setProperty.call(this,n,v,s);if(this.getParent()&&this.getParent().changeItemState){this.getParent().changeItemState(this.getId(),v);}this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return this;};
T.prototype.setIcon=function(i){return this._setIcon(i);};
T.prototype._setIcon=function(i,s){var p,c=['sapMTabContIcon'],o=this.getAggregation("_image"),d=this.getId()+"-img";if(!i){this.setProperty("icon",i,s);if(o){this.destroyAggregation("_image");}return this;}if(this.getIcon()!==i){this.setProperty("icon",i,s);p={src:i,id:d,tooltip:this.getIconTooltip()};o=b.getImageControl(d,o,undefined,p,c);this.setAggregation("_image",o,s);}return this;};
T.prototype._getImage=function(){return this.getAggregation("_image");};
return T;});
sap.ui.predefine('sap/m/TabStripRenderer',['./TabStripItem','sap/ui/Device','sap/ui/core/InvisibleText'],function(T,D,I){"use strict";var a={};a.LEFT_OVERRFLOW_BTN_CLASS_NAME="sapMTSLeftOverflowButtons";a.RIGHT_OVERRFLOW_BTN_CLASS_NAME="sapMTSRightOverflowButtons";
a.render=function(r,c){if(!c.getVisible()){return;}this.beginTabStrip(r,c);if(D.system.phone===true){this.renderTouchArea(r,c);}else{r.write("<div id='"+c.getId()+"-leftOverflowButtons' class='"+this.LEFT_OVERRFLOW_BTN_CLASS_NAME+"'>");if(c.getAggregation("_leftArrowButton")){this.renderLeftOverflowButtons(r,c,false);}r.write("</div>");this.beginTabsContainer(r,c);this.renderItems(r,c);this.endTabsContainer(r);r.write("<div id='"+c.getId()+"-rightOverflowButtons' class='"+this.RIGHT_OVERRFLOW_BTN_CLASS_NAME+"'>");if(c.getAggregation("_rightArrowButton")){this.renderRightOverflowButtons(r,c,false);}r.write("</div>");this.renderTouchArea(r,c);}this.endTabStrip(r);};
a.renderItems=function(r,c){var i=c.getItems(),s=c.getSelectedItem();i.forEach(function(o){var d=s&&s===o.getId();this.renderItem(r,c,o,d);},this);};
a.renderItem=function(r,c,i,s){var t=i.getTooltip(),d=g(i),m=i.getModified();r.write("<div id='"+i.getId()+"'");r.addClass(T.CSS_CLASS);if(m){r.addClass(T.CSS_CLASS_MODIFIED);}if(s){r.addClass(T.CSS_CLASS_SELECTED);}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}r.writeElementData(i);r.writeAccessibilityState(i,b(i,c,sap.ui.getCore().byId(c.getSelectedItem())));r.write(">");if(i.getIcon()){r.renderControl(i._getImage());}r.write("<div");r.addClass("sapMTSTexts");r.writeClasses();r.write(">");r.write("<div id='"+d+"-addText' class='"+T.CSS_CLASS_TEXT+"'>");this.renderItemText(r,i.getAdditionalText());r.write("</div>");r.write("<div id='"+d+"-text' class='"+T.CSS_CLASS_LABEL+"'>");this.renderItemText(r,i.getText());if(m){r.write("<span id='"+d+"-symbol'");r.addClass(T.CSS_CLASS_MODIFIED_SYMBOL);r.writeClasses();r.writeAttribute("role","presentation");r.writeAttribute("aria-hidden","true");r.write("/>");}r.write("</div>");r.write("</div>");this.renderItemCloseButton(r,i);r.write("</div>");};
a.renderItemText=function(r,i){if(i.length>T.DISPLAY_TEXT_MAX_LENGTH){r.writeEscaped(i.slice(0,T.DISPLAY_TEXT_MAX_LENGTH));r.write('...');}else{r.writeEscaped(i);}};
a.renderItemCloseButton=function(r,i){r.write("<div class='sapMTSItemCloseBtnCnt'>");r.renderControl(i.getAggregation("_closeButton"));r.write("</div>");};
a.beginTabStrip=function(r,c){r.write("<div");r.addClass("sapMTabStrip");r.addClass("sapContrastPlus");r.writeControlData(c);r.writeClasses();r.write(">");};
a.endTabStrip=function(r){r.write("</div>");};
a.beginTabsContainer=function(r,c){r.write("<div id='"+c.getId()+"-tabsContainer' class='sapMTSTabsContainer'>");r.write("<div id='"+c.getId()+"-tabs'  class='sapMTSTabs'");r.writeAccessibilityState(c,{role:"tablist"});r.write(">");};
a.endTabsContainer=function(r){r.write("</div>");r.write("</div>");};
a.renderLeftOverflowButtons=function(r,c,f){r.renderControl(c.getAggregation("_leftArrowButton"));if(f){r.flush(c.$("leftOverflowButtons")[0]);}};
a.renderRightOverflowButtons=function(r,c,f){r.renderControl(c.getAggregation("_rightArrowButton"));if(f){r.flush(c.$("rightOverflowButtons")[0]);}};
a.renderTouchArea=function(r,c){r.write("<div id='"+c.getId()+"-touchArea'  class='sapMTSTouchArea'>");r.renderControl(c.getAggregation('_select'));r.renderControl(c.getAddButton());r.write("</div>");};
function g(i){return i.getId()+"-label";}
function b(i,t,s){var c=t.getItems(),d=c.indexOf(i),o=t.getParent(),A={role:"tab"},e=I.getStaticId("sap.m","TABSTRIP_ITEM_CLOSABLE")+" ";e+=I.getStaticId("sap.m",i.getModified()?"TABSTRIP_ITEM_MODIFIED":"TABSTRIP_ITEM_NOT_MODIFIED");A["describedby"]=e;A["posinset"]=d+1;A["setsize"]=c.length;A["labelledby"]=g(i)+"-addText "+g(i)+"-text";if(o&&o.getRenderer&&o.getRenderer().getContentDomId){A["controls"]=o.getRenderer().getContentDomId(o);}if(s&&s.getId()===i.getId()){A["selected"]="true";}else{A["selected"]="false";}return A;}
return a;},true);
sap.ui.predefine('sap/m/Table',["sap/ui/Device","./library","./ListBase","./ListItemBase","./CheckBox","./TableRenderer","sap/base/Log","sap/ui/core/ResizeHandler","sap/ui/core/util/PasteHelper","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/m/ListBaseRenderer","sap/ui/dom/jquery/Selectors"],function(D,l,L,a,C,T,b,R,P,K,q,c){"use strict";var d=l.ListKeyboardMode;var e=l.ListGrowingDirection;var B=l.BackgroundDesign;var f=l.PopinLayout;var S=l.ScreenSizes;
var g=L.extend("sap.m.Table",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Translucent},fixedLayout:{type:"boolean",group:"Behavior",defaultValue:true},showOverlay:{type:"boolean",group:"Appearance",defaultValue:false},alternateRowColors:{type:"boolean",group:"Appearance",defaultValue:false},popinLayout:{type:"sap.m.PopinLayout",group:"Appearance",defaultValue:f.Block},contextualWidth:{type:"string",group:"Behavior",defaultValue:"Inherit"}},aggregations:{columns:{type:"sap.m.Column",multiple:true,singularName:"column",dnd:{draggable:true,droppable:true,layout:"Horizontal"}}},events:{beforeOpenContextMenu:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ColumnListItem"},column:{type:"sap.m.Column"}}},paste:{allowPreventDefault:true,parameters:{data:{type:"string[][]"}}}},designtime:"sap/m/designtime/Table.designtime"}});
g.prototype.sNavItemClass="sapMListTblRow";
g.prototype.init=function(){this._iItemNeedsColumn=0;L.prototype.init.call(this);};
g.prototype.setContextualWidth=function(w){var o=this.getContextualWidth();if(w==o){return this;}if(typeof w==="number"){this._sContextualWidth=w+"px";this._sContextualWidth=this._sContextualWidth.toLowerCase();}else{var h=w.toLowerCase(),W=S[h];if(W){this._sContextualWidth=W+"px";}else{this._sContextualWidth=w;}}var i=this._validateContextualWidth(this._sContextualWidth);this._iLastContextualWidth=o;if(i){this.setProperty("contextualWidth",w);}else{return this;}if(this._iLastContextualWidth.toLowerCase()==="auto"){this._deregisterResizeHandler();}if(this._sContextualWidth.toLowerCase()==="auto"){this._registerResizeHandler();}else{this._applyContextualWidth(this._sContextualWidth);}return this;};
g.prototype._validateContextualWidth=function(w){if(!w){return;}if(typeof w!="string"){throw new Error('expected string for property "contextualWidth" of '+this);}if(w.toLowerCase()==="auto"||w.toLowerCase()==="inherit"){return true;}if(!/^\d+(\.\d+)?(px)$/i.test(w)){throw new Error('invalid CSS size("px", "Auto", "auto", Inherit", "inherit" required) or sap.m.ScreenSize enumeration for property "contextualWidth" of '+this);}return true;};
g.prototype._applyContextualWidth=function(w){w=parseFloat(w)||0;if(w){this._applyContextualSettings({contextualWidth:w});}};
g.prototype._onResize=function(p){this._applyContextualWidth(p.size.width);};
g.prototype._registerResizeHandler=function(){if(!this._iResizeHandlerId){var t=this;window.requestAnimationFrame(function(){t._iResizeHandlerId=R.register(t,t._onResize.bind(t));});}};
g.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
g.prototype.onBeforeRendering=function(){L.prototype.onBeforeRendering.call(this);this._applyContextualWidth(this._sContextualWidth);this._ensureColumnsMedia();this._notifyColumns("ItemsRemoved");};
g.prototype._ensureColumnsMedia=function(){this.getColumns().forEach(function(o){if(o._bShouldAddMedia){o._addMedia();}});};
g.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this.updateSelectAllCheckbox();this._renderOverlay();};
g.prototype._renderOverlay=function(){var $=this.$(),h=$.find(".sapMTableOverlay"),s=this.getShowOverlay();if(s&&h.length===0){h=q("<div>").addClass("sapUiOverlay sapMTableOverlay").css("z-index","1");$.append(h);}else if(!s){h.remove();}};
g.prototype.setShowOverlay=function(s){this.setProperty("showOverlay",s,true);this._renderOverlay();return this;};
g.prototype.exit=function(){L.prototype.exit.call(this);if(this._selectAllCheckBox){this._selectAllCheckBox.destroy();this._selectAllCheckBox=null;}};
g.prototype.destroyItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.destroyItems.apply(this,arguments);};
g.prototype.removeAllItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.removeAllItems.apply(this,arguments);};
g.prototype.removeSelections=function(){L.prototype.removeSelections.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
g.prototype.selectAll=function(){L.prototype.selectAll.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
g.prototype.getColumns=function(s){var h=this.getAggregation("columns",[]);if(s){h.sort(function(i,j){return i.getOrder()-j.getOrder();});}return h;};
g.prototype.onAfterPageLoaded=function(){this.updateSelectAllCheckbox();if(this.getAlternateRowColors()){var $=this.$("tblBody").removeClass();$.addClass(this._getAlternateRowColorsClass());}L.prototype.onAfterPageLoaded.apply(this,arguments);};
g.prototype.shouldRenderItems=function(){var h=this.getColumns().some(function(o){return o.getVisible();});if(!h){b.warning("No visible columns found in "+this);}return h;};
g.prototype.onItemTypeColumnChange=function(i,n){this._iItemNeedsColumn+=(n?1:-1);if(this._iItemNeedsColumn==1&&n){this._setTypeColumnVisibility(true);}else if(this._iItemNeedsColumn==0){this._setTypeColumnVisibility(false);}};
g.prototype.onItemSelectedChange=function(i,s){L.prototype.onItemSelectedChange.apply(this,arguments);setTimeout(function(){this.updateSelectAllCheckbox();}.bind(this),0);};
g.prototype.getTableDomRef=function(){return this.getDomRef("listUl");};
g.prototype.getItemsContainerDomRef=function(){return this.getDomRef("tblBody");};
g.prototype.setNavigationItems=function(i){var h=this.$("tblHeader");var F=this.$("tblFooter");var r=this.$("tblBody").children(".sapMLIB");var I=h.add(r).add(F).get();i.setItemDomRefs(I);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==e.Upwards){i.setFocusedIndex(I.length-1);}else{i.setFocusedIndex(h[0]?1:0);}}};
g.prototype.checkGrowingFromScratch=function(){if(this.hasPopin()){return false;}return this.getColumns().some(function(o){return o.getVisible()&&o.getMergeDuplicates();});};
g.prototype.onColumnPress=function(o){this.bActiveHeaders&&this.fireEvent("columnPress",{column:o});};
g.prototype.onColumnResize=function(o){if(!this.hasPopin()&&!this._mutex){var h=this.getColumns().some(function(j){return j.isPopin();});if(!h){o.setDisplayViaMedia(this.getTableDomRef());return;}}this._dirty=this._getMediaContainerWidth()||window.innerWidth;if(!this._mutex){var i=this._getMediaContainerWidth()||window.innerWidth;this._mutex=true;this.rerender();setTimeout(function(){if(this._dirty!=i){this._dirty=0;this.rerender();}this._mutex=false;}.bind(this),200);}};
g.prototype.setTableHeaderVisibility=function(h){if(!this.getDomRef()){return;}var $=this.$("tblHeader"),H=!$.hasClass("sapMListTblHeaderNone"),v=$.find(".sapMListTblCell:visible"),i=v.eq(0);if(v.length==1){i.width("");}else{v.each(function(){this.style.width=this.getAttribute("data-sap-width")||"";});}this._colCount=v.length+3+!!c.ModeOrder[this.getMode()];this.$("tblBody").find(".sapMGHLICell").attr("colspan",this.getColSpan());this.$("nodata-text").attr("colspan",this.getColCount());if(this.getFixedLayout()){this._forceStyleChange();}if(!h&&H){$[0].className="sapMListTblRow sapMListTblHeader";this._headerHidden=false;}else if(h&&!H&&!v.length){$[0].className="sapMListTblHeaderNone";this._headerHidden=true;}};
g.prototype._forceStyleChange=function(){if(D.browser.msie||D.browser.edge){var t=this.getTableDomRef().style;t.listStyleType="circle";window.setTimeout(function(){t.listStyleType="none";},0);}};
g.prototype._setTypeColumnVisibility=function(v){q(this.getTableDomRef()).toggleClass("sapMListTblHasNav",v);};
g.prototype._notifyColumns=function(A,p,v){this.getColumns().forEach(function(o){o["on"+A](p,v);});};
g.prototype._getSelectAllCheckbox=function(){if(this.bPreventMassSelection){return;}return this._selectAllCheckBox||(this._selectAllCheckBox=new C({id:this.getId("sa"),activeHandling:false}).addStyleClass("sapMLIBSelectM").setParent(this,null,true).attachSelect(function(){if(this._selectAllCheckBox.getSelected()){this.selectAll(true);}else{this.removeSelections(false,true);}},this).setTabIndex(-1));};
g.prototype.updateSelectAllCheckbox=function(){if(this._selectAllCheckBox&&this.getMode()==="MultiSelect"){var i=this.getItems(),s=this.getSelectedItems().length,h=i.filter(function(I){return I.isSelectable();}).length;this._selectAllCheckBox.setSelected(i.length>0&&s==h);}};
g.prototype.enhanceAccessibilityState=function(E,A){if(E==this._selectAllCheckBox){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");A.label=o.getText("TABLE_CHECKBOX_SELECT_ALL");}};
g.prototype.getColSpan=function(){return(this._colCount||1)-2;};
g.prototype.getColCount=function(){return(this._colCount||0);};
g.prototype.hasPopin=function(){return!!this._hasPopin;};
g.prototype.isHeaderRowEvent=function(E){var h=this.$("tblHeader");return!!q(E.target).closest(h,this.getTableDomRef()).length;};
g.prototype.isFooterRowEvent=function(E){var F=this.$("tblFooter");return!!q(E.target).closest(F,this.getTableDomRef()).length;};
g.prototype.getAccessibilityType=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TABLE");};
g.prototype.getAccessibilityDescription=function(){return L.prototype.getAccessibilityDescription.call(this)+" "+this.getFooterText();};
g.prototype._setHeaderAnnouncement=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m"),A=o.getText("ACC_CTR_TYPE_HEADER_ROW")+" ";if(this.isAllSelectableSelected()){A+=o.getText("LIST_ALL_SELECTED");}this.getColumns(true).forEach(function(h,i){if(!h.getVisible()){return;}var H=h.getHeader();if(H&&H.getVisible()){A+=a.getAccessibilityText(H)+" ";}});this.updateInvisibleText(A);};
g.prototype._setFooterAnnouncement=function(){var A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_FOOTER_ROW")+" ";this.getColumns(true).forEach(function(o,i){if(!o.getVisible()){return;}var F=o.getFooter();if(F&&F.getVisible()){var h=o.getHeader();if(h&&h.getVisible()){A+=a.getAccessibilityText(h)+" ";}A+=a.getAccessibilityText(F)+" ";}});this.updateInvisibleText(A);};
g.prototype.onsapspace=function(E){if(E.isMarked()){return;}if(E.target.id==this.getId("tblHeader")){E.preventDefault();if(this._selectAllCheckBox){this._selectAllCheckBox.setSelected(!this._selectAllCheckBox.getSelected()).fireSelect();E.setMarked();}}};
g.prototype.onsaptabnext=function(E){if(E.isMarked()||this.getKeyboardMode()==d.Edit){return;}var r=q();if(E.target.id==this.getId("nodata")){r=this.$("nodata");}else if(this.isHeaderRowEvent(E)){r=this.$("tblHeader");}else if(this.isFooterRowEvent(E)){r=this.$("tblFooter");}var o=r.find(":sapTabbable").get(-1)||r[0];if(E.target===o){this.forwardTab(true);E.setMarked();}};
g.prototype.onsaptabprevious=function(E){if(E.isMarked()||this.getKeyboardMode()==d.Edit){return;}var t=E.target.id;if(t==this.getId("nodata")||t==this.getId("tblHeader")||t==this.getId("tblFooter")){this.forwardTab(false);}else if(t==this.getId("trigger")){this.focusPrevious();E.preventDefault();}};
g.prototype.onfocusin=function(E){var t=E.target;if(t.id===this.getId("tblHeader")){this._setHeaderAnnouncement();}else if(t.id===this.getId("tblFooter")){this._setFooterAnnouncement();}if(this._bThemeChanged){this._bThemeChanged=false;this._forceStyleChange();}L.prototype.onfocusin.call(this,E);};
g.prototype.onThemeChanged=function(){L.prototype.onThemeChanged.call(this);this._bThemeChanged=true;};
g.prototype._getAlternateRowColorsClass=function(){if(this.isGrouped()){return"sapMListTblAlternateRowColorsGrouped";}if(this.hasPopin()){return"sapMListTblAlternateRowColorsPopin";}return"sapMListTblAlternateRowColors";};
g.prototype.onpaste=function(E){if(E.isMarked()||(/^(input|textarea)$/i.test(E.target.tagName))){return;}var h=P.getPastedDataAs2DArray(E.originalEvent);if(!h||h.length===0||h[0].length===0){return;}this.firePaste({data:h});};
g.prototype.onkeydown=function(E){L.prototype.onkeydown.apply(this,arguments);if(D.browser.msie&&E.ctrlKey&&E.which===K.V){this.onpaste(E);}};
g.prototype.ondragenter=function(E){var o=E.dragSession;if(!o||!o.getDropControl()||!o.getDropControl().isA("sap.m.Column")){return;}o.setIndicatorConfig({height:this.getTableDomRef().clientHeight});};
return g;});
sap.ui.predefine('sap/m/TablePersoController',['./TablePersoDialog','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectRegistry',"sap/ui/core/syncStyleClass","sap/base/Log","sap/ui/thirdparty/jquery"],function(T,M,d,s,L,q){"use strict";
var e=M.extend("sap.m.TablePersoController",{
constructor:function(i,S){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",defaultValue:"20rem",since:"1.22"},"componentName":{type:"string",since:"1.20.2"},"hasGrouping":{type:"boolean",defaultValue:false,since:"1.22"},"showSelectAll":{type:"boolean",defaultValue:true,since:"1.22"},"showResetAll":{type:"boolean",defaultValue:true,since:"1.22"}},aggregations:{"_tablePersoDialog":{type:"sap.m.TablePersoDialog",multiple:false,visibility:"hidden"},"persoService":{type:"Object",multiple:false}},associations:{"table":{type:"sap.m.Table",multiple:false},"tables":{type:"sap.m.Table",multiple:true}},events:{personalizationsDone:{}},library:"sap.m"}
});
d.apply(e,{onDuplicate:function(i,o,n){if(o._sapui_candidateForDestroy){L.debug("destroying dangling template "+o+" when creating new object with same ID");o.destroy();}else{var m="adding TablePersoController with duplicate id '"+i+"'";if(sap.ui.getCore().getConfiguration().getNoDuplicateIds()){L.error(m);throw new Error("Error: "+m);}else{L.warning(m);}}}});
e.prototype.init=function(){this._schemaProperty="_persoSchemaVersion";this._schemaVersion="1.0";this._oPersonalizations=null;this._mDelegateMap={};this._mTablePersMap={};this._mInitialTableStateMap={};this._triggersPersDoneEvent=true;};
e.prototype.exit=function(){this._callFunctionForAllTables(q.proxy(function(t){t.removeDelegate(this._mDelegateMap[t]);t._hasTablePersoController=function(){return false;};},this));delete this._mDelegateMap;delete this._mTablePersMap;delete this._mInitialTableStateMap;};
e.prototype.activate=function(){this._callFunctionForAllTables(this._rememberInitialTableStates);this._callFunctionForAllTables(this._createAndAddDelegateForTable);return this;};
e.prototype.getTablePersoDialog=function(){return this.getAggregation("_tablePersoDialog");};
e.prototype.applyPersonalizations=function(t){var r=this.getPersoService().getPersData();var a=this;r.done(function(p){if(p){a._adjustTable(p,t);}});r.fail(function(){L.error("Problem reading persisted personalization data.");});};
e.prototype._createAndAddDelegateForTable=function(t){if(!this._mDelegateMap[t]){var o={onBeforeRendering:function(){this.applyPersonalizations(t);if(!this.getAggregation("_tablePersoDialog")){this._createTablePersoDialog(t);}}.bind(this)};t.addDelegate(o);o.onBeforeRendering();this._mDelegateMap[t]=o;var a=this;t._hasTablePersoController=function(){return!!a._mDelegateMap[this];};}};
e.prototype._createTablePersoDialog=function(t){var o=new T(t.getId()+"-PersoDialog",{persoDialogFor:t,persoMap:this._getPersoColumnMap(t),columnInfoCallback:this._tableColumnInfo.bind(this),initialColumnState:this._mInitialTableStateMap[t],contentWidth:this.getContentWidth(),contentHeight:this.getContentHeight(),hasGrouping:this.getHasGrouping(),showSelectAll:this.getShowSelectAll(),showResetAll:this.getShowResetAll()});this.setAggregation("_tablePersoDialog",o);o.attachConfirm(q.proxy(function(){this._oPersonalizations=o.retrievePersonalizations();this._callFunctionForAllTables(this._personalizeTable);this.savePersonalizations();this.firePersonalizationsDone();},this));};
e.prototype._adjustTable=function(D,t){if(D&&D.hasOwnProperty(this._schemaProperty)&&D[this._schemaProperty]===this._schemaVersion){this._oPersonalizations=D;if(t){this._personalizeTable(t);}else{this._callFunctionForAllTables(this._personalizeTable);}}};
e.prototype._personalizeTable=function(t){var p=this._getPersoColumnMap(t);if(!!p&&!!this._oPersonalizations){var D=false;for(var c=0,a=this._oPersonalizations.aColumns.length;c<a;c++){var n=this._oPersonalizations.aColumns[c];var o=p[n.id];if(!o){o=sap.ui.getCore().byId(n.id);if(o){L.info("Migrating personalization persistence id of column "+n.id);n.id=p[o];D=true;}}if(o){o.setVisible(n.visible);o.setOrder(n.order);}else{L.warning("Personalization could not be applied to column "+n.id+" - not found!");}}if(D){this.savePersonalizations();}t.invalidate();}};
e.prototype.savePersonalizations=function(){var b=this._oPersonalizations;b[this._schemaProperty]=this._schemaVersion;var w=this.getPersoService().setPersData(b);w.done(function(){});w.fail(function(){L.error("Problem persisting personalization data.");});};
e.prototype.refresh=function(){var r=function(o){this._mTablePersMap={};o.invalidate();};this._callFunctionForAllTables(r);var t=this.getAggregation("_tablePersoDialog");if(t){t.setPersoMap(this._getPersoColumnMap(sap.ui.getCore().byId(t.getPersoDialogFor())));}};
e.prototype.openDialog=function(){var t=this.getAggregation("_tablePersoDialog");if(t){s("sapUiSizeCompact",t.getPersoDialogFor(),t._oDialog);t.open();}else{L.warning("sap.m.TablePersoController: trying to open TablePersoDialog before TablePersoService has been activated.");}};
e.prototype.setContentWidth=function(w){this.setProperty("contentWidth",w,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setContentWidth(w);}return this;};
e.prototype.setContentHeight=function(h){this.setProperty("contentHeight",h,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setContentHeight(h);}return this;};
e.prototype.setHasGrouping=function(h){this.setProperty("hasGrouping",h,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setHasGrouping(h);}return this;};
e.prototype.setShowSelectAll=function(S){this.setProperty("showSelectAll",S,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setShowSelectAll(S);}return this;};
e.prototype.setShowResetAll=function(S){this.setProperty("showResetAll",S,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setShowResetAll(S);}return this;};
e.prototype.setComponentName=function(c){this.setProperty("componentName",c,true);return this;};
e.prototype._getMyComponentName=function(c){if(this.getComponentName()){return this.getComponentName();}if(c===null){return"empty_component";}var m=c.getMetadata();if(c.getMetadata().getStereotype()==="component"){return m._sComponentName;}return this._getMyComponentName(c.getParent());};
e.prototype._callFunctionForAllTables=function(t){var o=sap.ui.getCore().byId(this.getAssociation("table"));if(o){t.call(this,o);}var a=this.getAssociation("tables");if(a){for(var i=0,l=this.getAssociation("tables").length;i<l;i++){o=sap.ui.getCore().byId(this.getAssociation("tables")[i]);t.call(this,o);}}};
e.prototype._isStatic=function(i){var u=sap.ui.getCore().getConfiguration().getUIDPrefix();var r=new RegExp("^"+u);return!r.test(i);};
e.prototype._getPersoColumnMap=function(t){var r=this._mTablePersMap[t];if(!r){r={};var E=function(i){var l=i.lastIndexOf("-");return i.substring(l+1);};var a=E.call(this,t.getId());if(!this._isStatic(a)){L.error("Table "+t.getId()+" must have a static id suffix. Otherwise personalization can not be persisted.");r=null;return null;}var n;var c=this._getMyComponentName(t);var b=this;t.getColumns().forEach(function(N){if(r){var f=N.getId();var g=E.call(b,f);if(!b._isStatic(g)){L.error("Suffix "+g+" of table column "+f+" must be static. Otherwise personalization can not be persisted for its table.");r=null;return null;}n=c+"-"+a+"-"+g;r[N]=n;r[n]=N;}});this._mTablePersMap[t]=r;}return r;};
e.prototype._rememberInitialTableStates=function(t){this._mInitialTableStateMap[t]=this._tableColumnInfo(t,this._getPersoColumnMap(t));};
e.prototype._tableColumnInfo=function(t,p){if(p){var c=t.getColumns(),C=[],P=this.getPersoService();c.forEach(function(o){var a=null;if(P.getCaption){a=P.getCaption(o);}var g=null;if(P.getGroup){g=P.getGroup(o);}if(!a){var b=o.getHeader();if(b.getText&&b.getText()){a=b.getText();}else if(b.getTitle&&b.getTitle()){a=b.getTitle();}if(!a){a=o.getId();L.warning("Please 'getCaption' callback implentation in your TablePersoProvider for column "+o+". Table personalization uses column id as fallback value.");}}C.push({text:a,order:o.getOrder(),visible:o.getVisible(),id:p[o],group:g});});C.sort(function(a,b){return a.order-b.order;});return C;}return null;};
return e;});
sap.ui.predefine('sap/m/TablePersoDialog',['./Button','./Dialog','./InputListItem','./List','./Toolbar','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectRegistry','sap/base/Log','sap/m/library','sap/ui/Device','sap/ui/model/Sorter','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/json/JSONModel','sap/m/CheckBox','sap/m/SearchField','sap/m/ScrollContainer',"sap/ui/thirdparty/jquery"],function(B,D,I,L,T,M,a,b,l,c,S,F,d,J,C,e,f,q){"use strict";var g=l.ButtonType;var h=l.ToolbarDesign;var j=l.ListMode;
var k=M.extend("sap.m.TablePersoDialog",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",since:"1.22"},"persoMap":{type:"object"},"columnInfoCallback":{type:"object",since:"1.22"},"initialColumnState":{type:"object",since:"1.22"},"hasGrouping":{type:"boolean",since:"1.22"},"showSelectAll":{type:"boolean",since:"1.22"},"showResetAll":{type:"boolean",since:"1.22"}},aggregations:{"persoService":{type:"Object",multiple:false,deprecated:true}},associations:{"persoDialogFor":"sap.m.Table"},events:{confirm:{},cancel:{}},library:"sap.m"}
});
a.apply(k,{onDuplicate:function(i,o,n){if(o._sapui_candidateForDestroy){b.debug("destroying dangling template "+o+" when creating new object with same ID");o.destroy();}else{var m="adding TablePersoDialog with duplicate id '"+i+"'";if(sap.ui.getCore().getConfiguration().getNoDuplicateIds()){b.error(m);throw new Error("Error: "+m);}else{b.warning(m);}}}});
k.prototype.init=function(){var t=this,m=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oP13nModel=new J();this._oP13nModel.setSizeLimit(Number.MAX_VALUE);this._fnUpdateCheckBoxes=q.proxy(function(E){var s=E.getParameter('selected'),o=this._oP13nModel.getData();if(E.getSource().getId()===this._getSelectAllCheckboxId()){o.aColumns.forEach(function(n){n.visible=s;});}else{var i=!o.aColumns.some(function(n){return!n.visible;});o.oHeader.visible=i;}this._oP13nModel.setData(o);},this);this._oColumnItemTemplate=new I(this.getId()+"-li",{label:"{Personalization>text}",content:new C(this.getId()+"-cb",{selected:"{Personalization>visible}",select:this._fnUpdateCheckBoxes})}).addStyleClass("sapMPersoDialogLI");this._oButtonUp=new B(this.getId()+"-buttonUp",{icon:"sap-icon://arrow-top",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_UP'),press:function(){t._moveItem(-1);}});this._oButtonDown=new B(this.getId()+"-buttonDown",{icon:"sap-icon://arrow-bottom",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_DOWN'),press:function(){t._moveItem(1);}});this._fnHandleResize=function(){if(t._oDialog){var $=t._oDialog.$("cont");var i=t._oDialog.$("scroll");if($.children().length>0){var n=$.children()[0].clientHeight;var p=i[0].clientHeight-n;var H=t.getShowSelectAll()?t._oSelectAllToolbar.$().outerHeight():0;t._oScrollContainer.setHeight((n-H-p)+'px');}}};this._fnUpdateArrowButtons=function(u){var i=true,n=true,v=t._oSearchField.getValue(),o=t._oList.getItems().length;if(!!v||t._oList.getSelectedItems().length===0){n=false;i=false;}else{if(t._oList.getItems()[0].getSelected()){n=false;if(u&&t._oButtonDown.getDomRef()){t._oButtonDown.getDomRef().focus();}}if(t._oList.getItems()[o-1].getSelected()){i=false;if(u&&t._oButtonUp.getDomRef()){t._oButtonUp.getDomRef().focus();}}}t._oButtonUp.setEnabled(n);t._oButtonDown.setEnabled(i);};this._fnListUpdateFinished=function(){var n=t._oList.$().find('.sapMCb'),o=n.length;for(var i=0;i<o;i++){var $=q(n[i]).parent(),s=$.siblings(),p=s.length==1?q(s[0]):null;if(p){$=$.detach();$[0].className='sapMLIBSelectM';$.insertBefore(p);}}if(t._sLastSelectedItemId){var r=function(u){var R=(u.getBindingContext('Personalization')&&u.getBindingContext('Personalization').getProperty('id')===t._sLastSelectedItemId);if(R){t._oList.setSelectedItem(u);}return R;};t._oList.getItems().some(r);t._sLastSelectedItemId=null;if(t._fnUpdateArrowButtons){t._fnUpdateArrowButtons.call(this);}}};this._fnAfterDialogOpen=function(){t._fnUpdateArrowButtons.call(t);};this._fnAfterScrollContainerRendering=function(){t._oScrollContainer.$().attr('tabindex','-1');};this._oList=new L(this.getId()+"-colList",{includeItemInSelection:true,noDataText:this._oRb.getText('PERSODIALOG_NO_DATA'),mode:j.SingleSelectMaster,selectionChange:function(){this._fnUpdateArrowButtons.call(this);}.bind(this),updateFinished:this._fnListUpdateFinished});this._oList.addDelegate({onAfterRendering:this._fnListUpdateFinished});this._oSearchField=new e(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),i=(v?300:0);clearTimeout(m);if(i){m=setTimeout(function(){t._executeSearch();},i);}else{t._executeSearch();}},search:function(){t._executeSearch();}});this._oScrollContainer=new f({horizontal:false,vertical:true,content:[this._oList],width:'100%'});this._oScrollContainer.addDelegate({onAfterRendering:this._fnAfterScrollContainerRendering});this._resetAllButton=new B(this.getId()+"-buttonUndo",{icon:"sap-icon://undo",tooltip:this._oRb.getText('PERSODIALOG_UNDO'),press:function(){this._resetAll();}.bind(this)}).addStyleClass("sapMPersoDialogResetBtn");this._oSelectAllCheckbox=new C(this._getSelectAllCheckboxId(),{selected:"{Personalization>/oHeader/visible}",select:this._fnUpdateCheckBoxes,text:"{Personalization>/oHeader/text}"}).addStyleClass("sapMPersoDialogSelectAllCb");this._oSelectAllToolbar=new T(this.getId()+"-toolbarSelAll",{active:false,design:h.Transparent,content:[this._oSelectAllCheckbox,this._resetAllButton]}).addStyleClass("sapMPersoDialogFixedBar");this._oDialog=new D(this.getId()+"-Dialog",{title:this._oRb.getText("PERSODIALOG_COLUMNS_TITLE"),stretch:c.system.phone,horizontalScrolling:false,verticalScrolling:false,initialFocus:(c.system.desktop?this._oList:null),content:[this._oSelectAllToolbar,this._oScrollContainer],subHeader:new T(this.getId()+"-toolbar",{active:false,content:[this._oButtonUp,this._oButtonDown,this._oSearchField]}),leftButton:new B(this.getId()+"-buttonOk",{text:this._oRb.getText("PERSODIALOG_OK"),press:function(){t._oDialog.close();t._oSearchField.setValue("");t._oSelectAllToolbar.setVisible(true);c.resize.detachHandler(t._fnHandleResize);t.fireConfirm();},type:g.Emphasized}),rightButton:new B(this.getId()+"-buttonCancel",{text:this._oRb.getText("PERSODIALOG_CANCEL"),press:function(){t._oDialog.close();t._oSearchField.setValue("");t._oSelectAllToolbar.setVisible(true);c.resize.detachHandler(t._fnHandleResize);t.fireCancel();}}),afterOpen:this._fnAfterDialogOpen}).addStyleClass("sapMPersoDialog");};
k.prototype.retrievePersonalizations=function(){return this._oP13nModel.getData();};
k.prototype.open=function(){var s=null;if(this.getHasGrouping()){s=[new S('group',false,true)];}this._readCurrentSettingsFromTable();this._oDialog.setModel(this._oP13nModel,"Personalization");this._oList.bindAggregation("items",{path:"Personalization>/aColumns",sorter:s,template:this._oColumnItemTemplate});if(!this._oList.getSelectedItem()){var i=this._oList.getItems();if(this.getHasGrouping()){i=i.filter(function(o){return o.getMetadata().getName()!="sap.m.GroupHeaderListItem";});}if(i.length>0){this._sLastSelectedItemId=i[0].getBindingContext('Personalization').getProperty('id');}}this._fnUpdateArrowButtons.call(this);this._oDialog.open();this._fnHandleResize.call(this);c.resize.attachHandler(this._fnHandleResize);};
k.prototype.setContentHeight=function(H){this.setProperty("contentHeight",H,true);this._oDialog.setContentHeight(H);return this;};
k.prototype.setContentWidth=function(w){this.setProperty("contentWidth",w,true);this._oDialog.setContentWidth(w);return this;};
k.prototype.exit=function(){this._oRb=null;this._oP13nModel=null;if(this._oColumnItemTemplate){this._oColumnItemTemplate.destroy();this._oColumnItemTemplate=null;}if(this._oSelectAllToolbar){this._oSelectAllToolbar.destroy();this._oSelectAllToolbar=null;}if(this._oList){this._oList.destroy();this._oList=null;}if(this._oSearchField){this._oSearchField.destroy();this._oSearchField=null;}if(this._oScrollContainer){this._oScrollContainer.destroy();this._oScrollContainer=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oButtonDown){this._oButtonDown.destroy();this._oButtonDown=null;}if(this._oButtonUp){this._oButtonUp.destroy();this._oButtonUp=null;}};
k.prototype._resetAll=function(){if(this.getInitialColumnState()){var i=q.extend(true,[],this.getInitialColumnState()),t=this;var o=this._oList.getSelectedItem();this._sLastSelectedItemId=o&&o.getBindingContext('Personalization')&&o.getBindingContext('Personalization').getProperty('id');if(this._mColumnCaptions){i.forEach(function(m){m.text=t._mColumnCaptions[m.id];});}this._oP13nModel.getData().aColumns=i;this._oP13nModel.getData().oHeader.visible=!this.getInitialColumnState().some(function(m){return!m.visible;});this._oP13nModel.updateBindings();sap.ui.getCore().applyChanges();}};
k.prototype._moveItem=function(i){var s=this._oList.getSelectedItem();if(!s){return;}var o=this._oP13nModel.getData();var m=s.getBindingContext("Personalization").getPath().split("/").pop()*1;var n=m+i;if(n<0||n>=o.aColumns.length){return;}var t=o.aColumns[n];o.aColumns[n]=o.aColumns[m];o.aColumns[n].order=n;o.aColumns[m]=t;o.aColumns[m].order=m;this._oList.removeSelections(true);this._oP13nModel.updateBindings();var p=this._oList.getItems()[n];this._oList.setSelectedItem(p,true);sap.ui.getCore().applyChanges();if(p.getDomRef()){var E=p.$().position().top,r=18,v=this._oScrollContainer.$().height(),V=this._oScrollContainer.$().offset().top-this._oList.$().offset().top,u=V+v;if(E<V){this._oScrollContainer.scrollTo(0,Math.max(0,V-v+r));}else if(E+r>u){this._oScrollContainer.scrollTo(0,E);}}this._fnUpdateArrowButtons.call(this,true);};
k.prototype._readCurrentSettingsFromTable=function(){var t=sap.ui.getCore().byId(this.getPersoDialogFor()),i=this,m=this.getColumnInfoCallback().call(this,t,this.getPersoMap());this._oP13nModel.setData({aColumns:m,oHeader:{text:this._oRb.getText("PERSODIALOG_SELECT_ALL"),visible:!m.some(function(o){return!o.visible;}),id:this._getSelectAllCheckboxId()}});this._mColumnCaptions={};m.forEach(function(o){i._mColumnCaptions[o.id]=o.text;});};
k.prototype._getSelectAllCheckboxId=function(){return this.getId()+'_SelectAll';};
k.prototype._executeSearch=function(){var v=this._oSearchField.getValue(),o=new F("text",d.Contains,v),i=this._oList.getBinding("items");this._oSelectAllToolbar.setVisible(!v&&this.getShowSelectAll());i.filter([o]);this._fnUpdateArrowButtons.call(this);return this;};
k.prototype.setHasGrouping=function(H){this.setProperty("hasGrouping",H,true);var o=this._oDialog.getSubHeader();if(!H){if(o.getContent().length===1){o.insertContent(this._oButtonDown,0);o.insertContent(this._oButtonUp,0);}}else{o.removeContent(this._oButtonUp);o.removeContent(this._oButtonDown);}return this;};
k.prototype.setShowSelectAll=function(s){this.setProperty("showSelectAll",s,true);this._oSelectAllToolbar.setVisible(s);this._fnHandleResize.call(this);return this;};
k.prototype.setShowResetAll=function(s){this.setProperty("showResetAll",s,true);this._resetAllButton.setVisible(s);return this;};
return k;});
sap.ui.predefine('sap/m/TablePersoProvider',['sap/ui/base/ManagedObject',"sap/base/Log"],function(M,L){"use strict";
var T=M.extend("sap.m.TablePersoProvider",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{"abstract":true,library:"sap.m"}
});
T.prototype.init=function(){L.warning("This is the abstract base class for a TablePersoProvider. Do not create instances of this class, but use a concrete sub class instead.");L.debug("TablePersoProvider init");};
T.prototype.getPersData=function(){L.debug("TablePersoProvider getPersData");};
T.prototype.setPersData=function(b){L.debug("TablePersoProvider setPersData");};
T.prototype.delPersData=function(){L.debug("TablePersoProvider delPersData");};
T.prototype.getCaption=function(c){return null;};
T.prototype.getGroup=function(c){return null;};
T.prototype.resetPersData=function(){L.debug("TablePersoProvider resetPersData");};
return T;});
sap.ui.predefine('sap/m/TableRenderer',["sap/ui/core/Renderer","sap/ui/core/Core","./library","./ListBaseRenderer","./ColumnListItemRenderer"],function(R,C,l,L,a){"use strict";var b=l.ListKeyboardMode;var T=R.extend(L);T.apiVersion=2;var r=C.getConfiguration().getRTL();T.columnAlign={left:r?"flex-end":"flex-start",center:"center",right:r?"flex-start":"flex-end"};
T.renderColumns=function(c,t,d){var i=0,h=0,e=false,f=false,m=t.getMode(),M=L.ModeOrder[m],g="sapMListTbl",j=t.getId("tbl"),k=(d=="Head")?"th":"td",n="t"+d.toLowerCase(),o=t.getColumns(),p=function(s,u,A){c.openStart(k,u&&j+u);if(k==="th"){c.class("sapMTableTH");c.attr("role",A?"presentation":"columnheader");}else if(A){c.attr("role","presentation");}A&&c.attr("aria-hidden","true");c.class(g+s);c.openEnd();c.close(k);i++;};if(d=="Head"){var F=o.reduce(function(s,u,O){u.setIndex(-1);u.setInitialOrder(O);u.setForcedColumn(false);return(u.getCalculatedMinScreenWidth()<s.getCalculatedMinScreenWidth())?u:s;},o[0]);var H=o.filter(function(s){return s.getVisible()&&!s.isPopin()&&!s.isHidden();}).length;if(!H&&F){F.setForcedColumn(true);H=1;}var q=o.every(function(s){return!s.getHeader()||!s.getHeader().getVisible()||!s.getVisible()||s.isPopin()||s.isHidden();});}c.openStart(n).openEnd();c.openStart("tr",t.addNavSection(j+d+"er"));c.attr("tabindex",-1);if(q){c.class("sapMListTblHeaderNone");}else{c.class("sapMListTblRow").class("sapMLIBFocusable").class("sapMListTbl"+d+"er");a.addLegacyOutlineClass.call(a,c);}c.openEnd();p("HighlightCol",d+"Highlight",true);if(M==-1){if(m=="MultiSelect"&&d=="Head"&&!q){c.openStart("th");c.class("sapMTableTH");c.attr("aria-hidden","true");c.class(g+"SelCol");c.attr("role","presentation");c.openEnd();c.renderControl(t._getSelectAllCheckbox());c.close("th");i++;}else{p("SelCol","",true);}}t.getColumns(true).forEach(function(s,u){if(!s.getVisible()){return;}if(s.isPopin()){e=true;return;}if(s.isHidden()){h++;}var v=s["get"+d+"er"](),w=(H==1)?"":s.getWidth(),x=s.getStyleClass(true),y=s.getCssAlign();if(d=="Head"){c.openStart(k,s);c.class("sapMTableTH");c.attr("role","columnheader");var S=s.getSortIndicator().toLowerCase();S!=="none"&&c.attr("aria-sort",S);}else{c.openStart(k);}x&&c.class(x);c.class(g+"Cell");c.class(g+d+"erCell");c.attr("data-sap-width",s.getWidth());c.style("width",w);if(y&&d!=="Head"){c.style("text-align",y);}c.openEnd();if(v){if(d==="Head"){c.openStart("div");c.class("sapMColumnHeader");if(t.bActiveHeaders){c.attr("tabindex",0);c.attr("role","button");c.attr("aria-haspopup","dialog");c.class("sapMColumnHeaderActive");}if(y){c.style("justify-content",T.columnAlign[y]);c.style("text-align",y);}c.openEnd();c.renderControl(v.addStyleClass("sapMColumnHeaderContent"));c.close("div");}else{c.renderControl(v);}}if(d=="Head"&&!f){f=!!s.getFooter();}c.close(k);s.setIndex(i++);});p("NavCol",d+"Nav",!t._iItemNeedsColumn);if(M==1){p("SelCol","",true);}p("NavigatedCol",d+"Navigated",true);c.close("tr");c.close(n);if(d=="Head"){t._hasPopin=e;t._colCount=i-h;t._hasFooter=f;t._headerHidden=q;}};
T.renderContainerAttributes=function(c,o){c.attr("role","application");c.attr("aria-labelledby",this.getAriaAnnouncement("TABLE_CONTAINER_ROLE_DESCRIPTION"));c.class("sapMListTblCnt");L.renderContainerAttributes.apply(this,arguments);};
T.renderListStartAttributes=function(c,o){c.openStart("table",o.getId("listUl"));c.class("sapMListTbl");if(o.getFixedLayout()===false){c.style("table-layout","auto");}if(o._iItemNeedsColumn){c.class("sapMListTblHasNav");}};
T.getAriaRole=function(c){return"";};
T.getAriaLabelledBy=function(c){var p=L.getAriaLabelledBy.call(this,c);var s=this.getAriaAnnouncement("TABLE_ROLE_DESCRIPTION");if(p&&s){return p+" "+s;}return s||p;};
T.renderListHeadAttributes=function(c,o){this.renderColumns(c,o,"Head");c.openStart("tbody",o.addNavSection(o.getId("tblBody")));c.class("sapMListItems");c.class("sapMTableTBody");if(o.getAlternateRowColors()){c.class(o._getAlternateRowColorsClass());}if(o.hasPopin()){c.class("sapMListTblHasPopin");}c.openEnd();};
T.renderListEndAttributes=function(c,o){c.close("tbody");o._hasFooter&&this.renderColumns(c,o,"Foot");c.close("table");};
T.renderNoData=function(c,o){c.openStart("tr",o.getId("nodata"));c.attr("tabindex",o.getKeyboardMode()==b.Navigation?-1:0);c.class("sapMLIB").class("sapMListTblRow").class("sapMLIBTypeInactive");a.addFocusableClasses.call(a,c);if(!o._headerHidden||(!o.getHeaderText()&&!o.getHeaderToolbar())){c.class("sapMLIBShowSeparator");}c.openEnd();c.openStart("td",o.getId("nodata-text"));c.attr("colspan",o.getColCount());c.class("sapMListTblCell").class("sapMListTblCellNoData");c.openEnd();c.text(o.getNoDataText(true));c.close("td");c.close("tr");};
return T;},true);
sap.ui.predefine('sap/m/TableSelectDialog',['./Button','./Dialog','./SearchField','./Table','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/Device','sap/ui/base/ManagedObject','sap/m/Toolbar','sap/m/Label','sap/m/BusyIndicator','sap/m/Bar','sap/ui/core/theming/Parameters','sap/m/Title','./TableSelectDialogRenderer','sap/base/Log'],function(B,D,S,T,l,a,C,b,M,c,L,d,e,P,f,g,h){"use strict";var j=l.ListMode;var k=l.ButtonType;var m=l.TitleAlignment;
var n=C.extend("sap.m.TableSelectDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:true},growingThreshold:{type:"int",group:"Misc",defaultValue:null},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showClearButton:{type:"boolean",group:"Behavior",defaultValue:false},confirmButtonText:{type:"string",group:"Appearance"},draggable:{type:"boolean",group:"Behavior",defaultValue:false},resizable:{type:"boolean",group:"Behavior",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:m.Auto}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ColumnListItem",multiple:true,singularName:"item",bindable:"bindable"},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},columns:{type:"sap.m.Column",multiple:true,singularName:"column",bindable:"bindable"}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"string"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}}});
n.prototype.init=function(){var t=this,i=0,r=null;r=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(r);t._fireConfirmAndUpdateSelection();};this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T(this.getId()+"-table",{growing:t.getGrowing(),growingScrollToLoad:t.getGrowing(),mode:j.SingleSelectMaster,modeAnimationOn:false,sticky:[l.Sticky.InfoToolbar,l.Sticky.ColumnHeaders],infoToolbar:new c({visible:false,active:false,content:[new L({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:function(E){if(t._oDialog){if(!t.getMultiSelect()){t._oDialog.attachAfterClose(r);t._oDialog.close();}else{t._updateSelectionIndicator();}}}});this._oTable.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oTable.getInfoToolbar().$().attr('aria-live','polite');}});this._table=this._oTable;this._oBusyIndicator=new d(this.getId()+"-busyIndicator").addStyleClass("sapMTableSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),q=(v?300:0);clearTimeout(i);if(q){i=setTimeout(function(){t._executeSearch(v,false,"liveChange");},q);}else{t._executeSearch(v,false,"liveChange");}},search:function(E){var v=E.getSource().getValue(),q=E.getParameter("clearButtonPressed");t._executeSearch(v,q,"search");}});this._searchField=this._oSearchField;this._oSubHeader=new e(this.getId()+"-subHeader",{contentMiddle:[this._searchField]});var o=new e(this.getId()+"-dialog-header",{contentMiddle:[new f(this.getId()+"-dialog-title",{level:"H2"})]});this._setupBarTitleAlignment(o,this.getId()+"_customHeader");this._oDialog=new D(this.getId()+"-dialog",{customHeader:o,stretch:b.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oTable],endButton:this._getCancelButton(),initialFocus:((b.system.desktop&&this._oSearchField)?this._oSearchField:null),draggable:this.getDraggable()&&b.system.desktop,resizable:this.getResizable()&&b.system.desktop});this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);var p=this._oDialog.onsapescape;this._oDialog.onsapescape=function(E){if(p){p.call(t._oDialog,E);}t._onCancel();};this._oDialog._iVMargin=8*(parseInt(P.get("sapUiFontSize"))||16);this._sSearchFieldValue="";this._bFirstRequest=true;this._iTableUpdateRequested=0;this._oDialog.getProperty=function(N){if(N!=="title"){return C.prototype.getProperty.call(this,N);}return this.getCustomHeader().getAggregation("contentMiddle")[0].getText();}.bind(this._oDialog);};
n.prototype.exit=function(){this._oTable=null;this._oSearchField=null;this._oSubHeader=null;this._oClearButton=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iTableUpdateRequested=null;this._bFirstRequest=false;this._bInitBusy=false;this._bFirstRender=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._aInitiallySelectedItems=null;this._table=null;this._searchField=null;this._dialog=null;};
n.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;this._bFirstRender=false;}return this;};
n.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}return this;};
n.prototype.open=function(s){if(!this.getParent()&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._bFirstRequest=true;this._sSearchFieldValue="";this._oSearchField.setValue(s);this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._aInitiallySelectedItems=this._oTable.getSelectedItems();this._updateSelectionIndicator();return this;};
n.prototype.setGrowing=function(v){this._oTable.setGrowing(v);this._oTable.setGrowingScrollToLoad(v);this.setProperty("growing",v,true);return this;};
n.prototype.setGrowingThreshold=function(v){this._oTable.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
n.prototype.setDraggable=function(v){this._setInteractionProperty(v,"draggable",this._oDialog.setDraggable);return this;};
n.prototype.setResizable=function(v){this._setInteractionProperty(v,"resizable",this._oDialog.setResizable);return this;};
n.prototype._setInteractionProperty=function(v,p,i){this.setProperty(p,v,true);if(!b.system.desktop&&v){h.warning(p+" property works only on desktop devices!");return;}if(b.system.desktop&&this._oDialog){i.call(this._oDialog,v);}};
n.prototype.setBusy=function(i){this._oSearchField.setEnabled(!i);this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
n.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
n.prototype.setBusyIndicatorDelay=function(v){this._oTable.setBusyIndicatorDelay(v);this._oDialog.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
n.prototype.setMultiSelect=function(i){this.setProperty("multiSelect",i,true);if(i){this._oTable.setMode(j.MultiSelect);this._oTable.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oTable.setMode(j.SingleSelectMaster);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.destroyBeginButton();delete this._oOkButton;}return this;};
n.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.getCustomHeader().getAggregation("contentMiddle")[0].setText(t);return this;};
n.prototype.setConfirmButtonText=function(t){this.setProperty("confirmButtonText",t,true);this._oOkButton&&this._oOkButton.setText(t||this._oRb.getText("SELECT_CONFIRM_BUTTON"));return this;};
n.prototype.setNoDataText=function(N){this._oTable.setNoDataText(N);return this;};
n.prototype.getNoDataText=function(){return this._oTable.getNoDataText();};
n.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
n.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
n.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
n.prototype.setContentHeight=function(H){this._oDialog.setContentHeight(H);return this;};
n.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
n.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
n.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
n.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
n.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
n.prototype.setShowClearButton=function(v){this.setProperty("showClearButton",v,true);if(v){var o=this._oDialog.getCustomHeader();o.addContentRight(this._getClearButton());this._oClearButton.setVisible(v);}else if(this._oClearButton){this._oClearButton.setVisible(v);}return this;};
n.prototype._setModel=n.prototype.setModel;
n.prototype.setModel=function(o,s){var A=Array.prototype.slice.call(arguments);this._setBusy(false);this._bInitBusy=false;this._iTableUpdateRequested+=1;this._oTable.attachUpdateStarted(this._updateStarted,this);this._oTable.attachUpdateFinished(this._updateFinished,this);this._oTable.setModel(o,s);n.prototype._setModel.apply(this,A);this._updateSelectionIndicator();return this;};
n.getMetadata().forwardAggregation("items",{getter:function(){return this._oTable;},aggregation:"items",forwardBinding:true});n.getMetadata().forwardAggregation("columns",{getter:function(){return this._oTable;},aggregation:"columns",forwardBinding:true});
n.prototype._executeSearch=function(v,i,E){var t=this._oTable,o=(t?t.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(this._oDialog.isOpen()&&((s&&E==="liveChange")||E==="search")){this._sSearchFieldValue=v;if(o){this._iTableUpdateRequested+=1;if(E==="search"){this.fireSearch({value:v,itemsBinding:o,clearButtonPressed:i});}else if(E==="liveChange"){this.fireLiveChange({value:v,itemsBinding:o});}}else{if(E==="search"){this.fireSearch({value:v,clearButtonPressed:i});}else if(E==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
n.prototype._setBusy=function(i){if(this._iTableUpdateRequested){if(i){this._oSearchField.setEnabled(false);this._oTable.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oSearchField.setEnabled(true);this._oTable.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
n.prototype._updateStarted=function(E){if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iTableUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
n.prototype._updateFinished=function(E){this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}if(b.system.desktop){if(this._oTable.getItems()[0]){this._oDialog.setInitialFocus(this._oTable.getItems()[0]);}else{this._oDialog.setInitialFocus(this._oSearchField);}if(this._bFirstRequest){var F=this._oTable.getItems()[0];if(!F){F=this._oSearchField;}if(F.getFocusDomRef()){F.getFocusDomRef().focus();}}}this._bFirstRequest=false;this._iTableUpdateRequested=0;};
n.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{type:k.Emphasized,text:this.getConfirmButtonText()||this._oRb.getText("SELECT_CONFIRM_BUTTON"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
n.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(){t._onCancel();}});}return this._oCancelButton;};
n.prototype._getClearButton=function(){if(!this._oClearButton){this._oClearButton=new B(this.getId()+"-clear",{text:this._oRb.getText("TABLESELECTDIALOG_CLEARBUTTON"),press:function(){this._removeSelection();this._updateSelectionIndicator();this._oDialog.focus();}.bind(this)});}return this._oClearButton;};
n.prototype._onCancel=function(E){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t.fireCancel();};t._resetSelection();this._oDialog.attachAfterClose(A);this._oDialog.close();};
n.prototype._updateSelectionIndicator=function(){var s=this._oTable.getSelectedContextPaths(true).length,i=this._oTable.getInfoToolbar();if(this.getShowClearButton()&&this._oClearButton){this._oClearButton.setEnabled(s>0);}i.setVisible(!!s);i.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
n.prototype._fireConfirmAndUpdateSelection=function(){var p={selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems};Object.defineProperty(p,"selectedContexts",{get:this._oTable.getSelectedContexts.bind(this._oTable,true)});this.fireConfirm(p);this._updateSelection();};
n.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._removeSelection();}};
n.prototype._removeSelection=function(){this._oTable.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;};
n.prototype._resetSelection=function(){var i=0;if(!this.bIsDestroyed){var o=this._oTable.getBinding("items");if(o&&o.aFilters&&o.aFilters.length){o.filter([]);}this._oTable.removeSelections();for(;i<this._aInitiallySelectedItems.length;i++){this._oTable.setSelectedItem(this._aInitiallySelectedItems[i]);}}};
a.mixInto(n.prototype);return n;});
sap.ui.predefine('sap/m/TableSelectDialogRenderer',[],function(){"use strict";var T={};
T.render=function(r,c){};
return T;},true);
sap.ui.predefine('sap/m/Text',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/library','sap/ui/Device','sap/m/HyphenationSupport',"./TextRenderer"],function(l,C,a,c,D,H,T){"use strict";var b=c.TextAlign;var d=c.TextDirection;var W=l.WrappingType;
var e=a.extend("sap.m.Text",{metadata:{interfaces:["sap.ui.core.IShrinkable","sap.ui.core.IFormContent","sap.m.IHyphenation"],library:"sap.m",properties:{text:{type:"string",defaultValue:'',bindable:"bindable"},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},wrapping:{type:"boolean",group:"Appearance",defaultValue:true},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxLines:{type:"int",group:"Appearance",defaultValue:null},renderWhitespace:{type:"boolean",group:"Appearance",defaultValue:false}},designtime:"sap/m/designtime/Text.designtime"}});
e.prototype.normalLineHeight=1.2;e.prototype.cacheLineHeight=true;e.prototype.ellipsis='...';e.hasNativeLineClamp=("webkitLineClamp"in document.documentElement.style);
e.setNodeValue=function(o,n){n=n||"";var f=o.childNodes;if(f.length===1&&f[0].nodeType===window.Node.TEXT_NODE){f[0].nodeValue=n;}else{o.textContent=n;}};
e.prototype.getText=function(n){var t=this.getProperty("text");if(n){return t.replace(/\r\n|\n\r|\r/g,"\n");}return t;};
e.prototype.onAfterRendering=function(){if(this.getVisible()&&this.hasMaxLines()&&!this.canUseNativeLineClamp()){if(C.isThemeApplied()){this.clampHeight();}else{C.attachThemeChanged(this._handleThemeLoad,this);}}};
e.prototype._handleThemeLoad=function(){this.clampHeight();C.detachThemeChanged(this._handleThemeLoad,this);};
e.prototype.hasMaxLines=function(){return(this.getWrapping()&&this.getMaxLines()>1);};
e.prototype.getTextDomRef=function(){if(!this.getVisible()){return null;}if(this.hasMaxLines()){return this.getDomRef("inner");}return this.getDomRef();};
e.prototype.canUseNativeLineClamp=function(){if(!e.hasNativeLineClamp){return false;}if(this.getTextDirection()==d.RTL){return false;}if(this.getTextDirection()==d.Inherit&&C.getConfiguration().getRTL()){return false;}return true;};
e.prototype.getLineHeight=function(o){if(this.cacheLineHeight&&this._fLineHeight){return this._fLineHeight;}o=o||this.getTextDomRef();if(!o){return 0;}var s=window.getComputedStyle(o),L=s.lineHeight,f;if(/px$/i.test(L)){f=parseFloat(L);}else if(/^normal$/i.test(L)){f=parseFloat(s.fontSize)*this.normalLineHeight;}else{f=parseFloat(s.fontSize)*parseFloat(L);}if(!D.browser.firefox){f=Math.floor(f);}if(this.cacheLineHeight&&f){this._fLineHeight=f;}return f;};
e.prototype.getClampHeight=function(o){o=o||this.getTextDomRef();return this.getMaxLines()*this.getLineHeight(o);};
e.prototype.clampHeight=function(o){o=o||this.getTextDomRef();if(!o){return 0;}var m=this.getClampHeight(o);if(m){o.style.maxHeight=m+"px";}return m;};
e.prototype.clampText=function(o,s,E){o=o||this.getTextDomRef();if(!o){return;}var i;var t=this.getText(true);var m=this.getClampHeight(o);s=s||0;E=E||t.length;e.setNodeValue(o,t.slice(0,E));if(o.scrollHeight>m){var S=o.style,h=S.height,f=this.ellipsis,g=f.length;S.height=m+"px";while((E-s)>g){i=(s+E)>>1;e.setNodeValue(o,t.slice(0,i-g)+f);if(o.scrollHeight>m){E=i;}else{s=i;}}if(o.scrollHeight>m&&s>0){i=s;o.textContent=t.slice(0,i-g)+f;}S.height=h;}return i;};
e.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
e.prototype.getTextsToBeHyphenated=function(){return{"main":this.getText(true)};};
e.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.getTextDomRef()};};
H.mixInto(e.prototype);return e;});
sap.ui.predefine('sap/m/TextArea',['./InputBase','./Text','sap/ui/core/ResizeHandler','./library','sap/ui/core/library','sap/ui/events/KeyCodes','sap/ui/Device',"sap/base/security/encodeXML",'./TextAreaRenderer',"sap/ui/thirdparty/jquery"],function(I,T,R,l,c,K,D,a,b,q){"use strict";var W=c.Wrapping;
var d=I.extend("sap.m.TextArea",{metadata:{library:"sap.m",designtime:"sap/m/designtime/TextArea.designtime",properties:{rows:{type:"int",group:"Appearance",defaultValue:2},cols:{type:"int",group:"Appearance",defaultValue:20},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},maxLength:{type:"int",group:"Behavior",defaultValue:0},showExceededText:{type:"boolean",group:"Behavior",defaultValue:false},wrapping:{type:"sap.ui.core.Wrapping",group:"Behavior",defaultValue:W.None},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{_counter:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{liveChange:{parameters:{value:{type:"string"}}}},dnd:{draggable:false,droppable:true}}});
d.prototype.init=function(){var C;I.prototype.init.call(this);this.sResizeListenerId=null;this._bPasteIsTriggered=false;C=new T(this.getId()+'-counter',{}).addStyleClass("sapMTextAreaCounter").setVisible(false);this.setAggregation("_counter",C);};
d.prototype.setShowExceededText=function(v){var C=this.getAggregation("_counter"),V;if(v){if(this.getAriaLabelledBy().indexOf(C.getId())<0){this.addAriaLabelledBy(C.getId());}}else{C=this.getAggregation("_counter");C&&this.removeAriaLabelledBy(C.getId());V=this.getValue();if(this.getMaxLength()){V=V.substring(0,this.getMaxLength());this.setValue(V);}}C.setVisible(v);this.setProperty("showExceededText",v);this._updateMaxLengthAttribute();return this;};
d.prototype.exit=function(){I.prototype.exit.call(this);q(window).off("resize.sapMTextAreaGrowing");this._detachResizeHandler();};
d.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.call(this);var C=this.getAggregation("_counter");if((this.getMaxLength()<=0||!this.getShowExceededText())&&C.getVisible()){C.setVisible(false);}this._detachResizeHandler();};
d.prototype.onAfterRendering=function(){I.prototype.onAfterRendering.call(this);if(this.getGrowing()){this._sResizeListenerId=R.register(this,this._resizeHandler.bind(this));if(this.getGrowingMaxLines()>0){this._setGrowingMaxHeight();}this._adjustContainerDimensions();}this._updateMaxLengthAttribute();if(!D.support.touch){return;}var t=this.$("inner");if(this._behaviour.INSIDE_SCROLLABLE_WITHOUT_FOCUS){t.on("touchstart",q.proxy(this._onTouchStart,this));t.on("touchmove",q.proxy(this._onTouchMove,this));}else if(this._behaviour.PAGE_NON_SCROLLABLE_AFTER_FOCUS){t.on("touchmove",function(e){if(t.is(":focus")){e.stopPropagation();}});}};
d.prototype._setGrowingMaxHeight=function(){var h=this.getDomRef('hidden'),C=sap.ui.getCore(),L=C.getLoadedLibraries(),f,m,s;if(!L||!L['sap.m']){C.attachThemeChanged(this._setGrowingMaxHeight.bind(this));return;}C.detachThemeChanged(this._setGrowingMaxHeight);s=window.getComputedStyle(h);f=this._getLineHeight();m=(f*this.getGrowingMaxLines())+parseFloat(s.getPropertyValue("padding-top"))+parseFloat(s.getPropertyValue("border-top-width"))+parseFloat(s.getPropertyValue("border-bottom-width"));if(D.browser.firefox){m+=parseFloat(s.getPropertyValue("padding-bottom"));}h.style.maxHeight=m+"px";};
d.prototype._getLineHeight=function(){var t=this.getFocusDomRef(),s;if(!t){return;}s=window.getComputedStyle(t);return isNaN(parseFloat(s.getPropertyValue("line-height")))?1.4*parseFloat(s.getPropertyValue("font-size")):parseFloat(s.getPropertyValue("line-height"));};
d.prototype._resizeHandler=function(e){this._adjustContainerDimensions();};
d.prototype._detachResizeHandler=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
d.prototype.onsapenter=function(e){e.setMarked();};
d.prototype.onValueRevertedByEscape=function(v){if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this.fireLiveChange({value:v,newValue:v});};
d.prototype.getValue=function(){var t=this.getFocusDomRef();return t?t.value:this.getProperty("value");};
d.prototype.setValue=function(v){I.prototype.setValue.call(this,v);this._handleShowExceededText();if(this.getGrowing()){this._adjustContainerDimensions();}return this;};
d.prototype.onsapnext=function(e){e.setMarked();};
d.prototype.onsapprevious=function(e){e.setMarked();};
d.prototype.oninput=function(e){I.prototype.oninput.call(this,e);if(this._bPasteIsTriggered){this._bPasteIsTriggered=false;this._selectExceededText();}if(e.isMarked("invalid")){return;}var t=this.getFocusDomRef(),v=t.value,s=this.getShowExceededText(),m=this.getMaxLength();if(!s&&m&&v.length>m){v=v.substring(0,m);t.value=v;}if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this._handleShowExceededText();if(this.getGrowing()){this._adjustContainerDimensions();}this.fireLiveChange({value:v,newValue:v});};
d.prototype.onpaste=function(e){if(this.getShowExceededText()){this._bPasteIsTriggered=true;}};
d.prototype.setGrowing=function(g){this.setProperty("growing",g);if(this.getGrowing()){q(window).on("resize.sapMTextAreaGrowing",this._updateOverflow.bind(this));}else{q(window).off("resize.sapMTextAreaGrowing");}return this;};
d.prototype._adjustContainerDimensions=function(){var t=this.getFocusDomRef(),h=this.getDomRef("hidden"),H,n;if(!t||!h){return;}h.style.width="";if(this.getGrowing()&&!this.getWidth()&&this.getCols()!==20){h.style.width=(this.getCols()*0.5)+"rem";}H=h.style["min-height"];n=this.getRows()*this._getLineHeight()+"px";if(!H||n!==H){h.style["min-height"]=n;}h.innerHTML=a(t.value)+'&nbsp;';this._updateOverflow();};
d.prototype._updateOverflow=function(){var t=this.getFocusDomRef(),h=this.getDomRef("hidden"),m;if(t){m=parseFloat(window.getComputedStyle(h)["max-height"]);t.style.overflowY=(h.scrollHeight>m)?"auto":"";}};
d.prototype._getInputValue=function(v){v=(v===undefined)?this.$("inner").val()||"":v.toString();if(this.getMaxLength()>0&&!this.getShowExceededText()){v=v.substring(0,this.getMaxLength());}return v.replace(/\r\n/g,"\n");};
d.prototype._selectExceededText=function(){var v=this.getValue().length;if(v>this.getMaxLength()){this.selectText(this.getMaxLength(),v);}};
d.prototype._updateMaxLengthAttribute=function(){var t=this.getFocusDomRef();if(!t){return;}if(this.getShowExceededText()){t.removeAttribute("maxlength");this._handleShowExceededText();}else{this.getMaxLength()&&t.setAttribute("maxlength",this.getMaxLength());}};
d.prototype._handleShowExceededText=function(){var C=this.getAggregation("_counter"),m=this.getMaxLength(),s;if(!this.getDomRef()||!this.getShowExceededText()||!m){return;}s=this._getCounterValue();C.setText(s);};
d.prototype._maxLengthIsExceeded=function(v){var r=false;if(this.getMaxLength()>0&&this.getShowExceededText()&&this.getValue().length>this.getMaxLength()){r=true;}return r;};
d.prototype._getCounterValue=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),C=this.getMaxLength()-this.getValue().length,e=(C<0?true:false),m="TEXTAREA_CHARACTER"+(Math.abs(C)===1?"":"S")+"_"+(e?"EXCEEDED":"LEFT");return B.getText(m,[Math.abs(C)]);};
d.prototype._behaviour=(function(o){return{INSIDE_SCROLLABLE_WITHOUT_FOCUS:o.os.ios||o.os.blackberry||o.browser.chrome,PAGE_NON_SCROLLABLE_AFTER_FOCUS:o.os.android&&o.os.version>=4.1};}(D));
d.prototype._onTouchStart=function(e){var t=e.touches[0];this._iStartY=t.pageY;this._iStartX=t.pageX;this._bHorizontalScroll=undefined;e.setMarked("swipestartHandled");};
d.prototype._onTouchMove=function(e){var t=this.getFocusDomRef(),p=e.touches[0].pageY,s=t.scrollTop,f=s<=0,B=s+t.clientHeight>=t.scrollHeight,g=this._iStartY>p,G=this._iStartY<p,o=f&&G||B&&g;if(this._bHorizontalScroll===undefined){this._bHorizontalScroll=Math.abs(this._iStartY-p)<Math.abs(this._iStartX-e.touches[0].pageX);}if(this._bHorizontalScroll||!o){e.setMarked();}};
var _=D.os.windows_phone&&(/MSAppHost/i).test(navigator.appVersion);
d.prototype.onfocusin=function(e){var s,$=this.$();I.prototype.onfocusin.apply(this,arguments);function f(){q(window).scrollTop(0);s.scrollTop($.offset().top-s.offset().top+s.scrollTop());}if(_&&$.height()+$.offset().top>260){for(s=$.parent();s[0];s=s.parent()){if(s.css("overflow-y")=="auto"){s.children().last().css("padding-bottom",q(window).height()+"px");window.setTimeout(f,100);return;}}}};
d.prototype.onkeyup=function(e){if(e.keyCode===K.ENTER){e.setMarked("enterKeyConsumedAsContent");}};
return d;});
sap.ui.predefine('sap/m/TextAreaRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/Device','sap/ui/core/library',"sap/base/security/encodeXML"],function(R,I,D,c,e){"use strict";var W=c.Wrapping;var T={};var T=R.extend(I);
T.addOuterClasses=function(r,C){r.addClass("sapMTextArea");if(C.getShowExceededText()){r.addClass("sapMTextAreaWithCounter");}if(C.getHeight()){r.addClass("sapMTextAreaWithHeight");}};
T.addOuterStyles=function(r,C){C.getHeight()&&r.addStyle("height",C.getHeight());};
T.writeDecorations=function(r,C){var o=C.getAggregation("_counter");r.renderControl(o);};
T.openInputTag=function(r,C){r.write("<textarea");r.writeAttribute("id",C.getId()+"-"+this.getInnerSuffix());};
T.endInputTag=function(r,C){r.writeClasses();r.writeStyles();r.write(">");};
T.closeInputTag=function(r,C){r.write("</textarea>");};
T.prependInnerContent=function(r,C){if(C.getGrowing()){r.write("<div");r.addClass("sapMTextAreaMirror");r.writeClasses();r.writeAttribute("id",C.getId()+'-hidden');r.write("></div>");}};
T.writeInnerValue=function(){};
T.writeInnerContent=function(r,C){var v=C.getValue();v=e(v);r.write(v);};
T.addInnerClasses=function(r,C){r.addClass("sapMTextAreaInner");if(C.getGrowing()){r.addClass("sapMTextAreaGrow");}};
T.getAriaRole=function(C){return"";};
T.writeInnerAttributes=function(r,C){if(C.getWrapping()!=W.None){r.writeAttribute("wrap",C.getWrapping());}r.writeAttribute("rows",C.getRows());r.writeAttribute("cols",C.getCols());};
return T;},true);
sap.ui.predefine('sap/m/TextRenderer',['sap/ui/core/Renderer','sap/ui/core/library','sap/m/HyphenationSupport','./library'],function(R,c,H,m){"use strict";var T=c.TextDirection;var W=m.WrappingType;var a={apiVersion:2};
a.render=function(r,t){var w=t.getWidth(),s=t.getText(true),b=t.getTextDirection(),d=t.getTooltip_AsString(),n=t.getMaxLines(),e=t.getWrapping(),f=t.getWrappingType(),g=t.getTextAlign(),h=t.getRenderWhitespace();r.openStart("span",t);r.class("sapMText");r.class("sapUiSelectable");if(!e||n==1){r.class("sapMTextNoWrap");}else if(e&&f!==W.Hyphenated){if(s&&s.length>0&&!/\s/.test(s)){r.class("sapMTextBreakWord");}}w?r.style("width",w):r.class("sapMTextMaxWidth");if(b!==T.Inherit){r.attr("dir",b.toLowerCase());}d&&r.attr("title",d);if(g){g=R.getTextAlign(g,b);if(g){r.style("text-align",g);}}if(h){var i=e?"sapMTextRenderWhitespaceWrap":"sapMTextRenderWhitespace";r.class(i);}H.writeHyphenationClass(r,t);r.openEnd();if(t.hasMaxLines()){this.renderMaxLines(r,t);}else{this.renderText(r,t);}r.close("span");};
a.renderMaxLines=function(r,t){r.openStart("span");r.attr("id",t.getId()+"-inner");r.class("sapMTextMaxLine");if(t.canUseNativeLineClamp()){r.class("sapMTextLineClamp");r.style("-webkit-line-clamp",t.getMaxLines());}r.openEnd();this.renderText(r,t);r.close("span");};
a.renderText=function(r,t){var s=H.getTextForRender(t,"main");r.text(s);};
return a;},true);
sap.ui.predefine('sap/m/Tile',['./library','sap/ui/core/InvisibleText','sap/ui/core/Control','sap/ui/Device','./TileRenderer',"sap/ui/thirdparty/jquery"],function(l,I,C,D,T,q){"use strict";
var a=C.extend("sap.m.Tile",{metadata:{library:"sap.m",properties:{removable:{type:"boolean",group:"Misc",defaultValue:true}},events:{press:{}}}});
a.prototype.init=function(){if(D.system.desktop){var o=q.proxy(function(e){if(e.srcControl===this&&!e.isMarked()){this.ontap();e.stopPropagation();}},this);this.onsapspace=o;this.onsapenter=o;}};
a.prototype.onAfterRendering=function(){if(this._rendered&&!this._bIsDragged&&this.getParent()instanceof sap.m.TileContainer){this.setPos(this._posX,this._posY);}this._rendered=true;};
a.prototype.setPos=function(x,y){this._posX=x=Math.floor(x);this._posY=y=Math.floor(y);if(!this._rendered){return;}var o=this.getDomRef();if("webkitTransform"in o.style){this.$().css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("transform"in o.style){this.$().css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){this.$().css('msTransform','translate('+x+'px,'+y+'px)');}else if("MozTransform"in o.style){this.$().css('-moz-transform','translate3d('+x+'px,'+y+'px,0)');}if(this._invisible){this.$().css("visibility","");delete this._invisible;}};
a.prototype.setSize=function(w,h){this._width=w;this._height=h;};
a.prototype.isEditable=function(i){var o=this._bIsEditable;if(i===true||i===false){this._bIsEditable=i;}if(o!=i&&this.$()){this.$().attr("aria-describedBy",i?I.getStaticId("sap.m","TILE_REMOVE_BY_DEL_KEY"):null);}return this._bIsEditable;};
a.prototype.isDragged=function(i){if(!this._bIsEditable){return;}if(i===true||i===false){var o=this.$();o.toggleClass("sapMTileDrag",i);this._bIsDragged=i;}return this._bIsDragged;};
a.prototype.ontouchstart=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",true);this._clientX=e.clientX;this._clientY=e.clientY;}};
a.prototype.ontouchend=function(){if(!this.isEditable()){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}};
Object.defineProperty(a.prototype,"_parentPreventsTapEvent",{get:function(){var p=this.getParent();while(p){if(p._bAvoidChildTapEvent||(p instanceof a&&p.isEditable())){return true;}p=p.getParent();}return false;}});
a.prototype.ontouchmove=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){if(Math.abs(e.clientX-this._clientX)>30||Math.abs(e.clientY-this._clientY)>10){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}}};
a.prototype.ontap=function(){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.firePress({});}};
a.prototype.setVisible=function(v){this.setProperty("visible",v);if(!v){this._rendered=false;}if(this.getParent()&&this.getParent()instanceof sap.m.TileContainer){this.getParent().invalidate();}return this;};
a.prototype._setVisible=function(v){this._invisible=!v;return this;};
return a;});
sap.ui.predefine('sap/m/TileContainer',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/ResizeHandler','./TileContainerRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Selectors"],function(l,C,I,D,R,T,L,q){"use strict";
var a=C.extend("sap.m.TileContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},editable:{type:"boolean",group:"Misc",defaultValue:null},allowAdd:{type:"boolean",group:"Misc",defaultValue:null}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.Tile",multiple:true,singularName:"tile"}},events:{tileMove:{parameters:{tile:{type:"sap.m.Tile"},newIndex:{type:"int"}}},tileDelete:{parameters:{tile:{type:"sap.m.Tile"}}},tileAdd:{}}}});
I.insertFontFaceStyle();a.prototype._bRtl=sap.ui.getCore().getConfiguration().getRTL();
a.prototype.init=function(){this._iCurrentTileStartIndex=0;this._oDim=null;this._iScrollLeft=0;this._iScrollGap=0;if(!D.system.desktop){this._iScrollGap=0;}this.bAllowTextSelection=false;this._oDragSession=null;this._oTouchSession=null;this._bAvoidChildTapEvent=false;this._iEdgeShowStart=D.system.phone?10:20;if(D.system.phone){this._iTriggerScrollOffset=10;}else if(D.system.desktop){this._iTriggerScrollOffset=-40;}else{this._iTriggerScrollOffset=20;}this._iCurrentFocusIndex=-1;if(D.system.desktop||D.system.combi){var o=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var F=this._iCurrentTileStartIndex===this._iCurrentFocusIndex?0:this._iCurrentTileStartIndex;var t=E.ctrlKey?F:r;var m=this._getVisibleTiles()[t];if(!!m){this._findTile(m.$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),O=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var m=r+this._iMaxTilesX<t.length?r+this._iMaxTilesX-1:t.length-1;var n=this._iCurrentTileStartIndex+this._iMaxTiles<t.length?this._iCurrentTileStartIndex+this._iMaxTiles-1:t.length-1;var p=n===this._iCurrentFocusIndex?t.length-1:n;var s=E.ctrlKey?p:m;if(t.length>0){this._findTile(t[s].$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),f=q.proxy(function(E){var t=this._getVisibleTiles();if(t.length>0){var n=this._iCurrentFocusIndex-this._iMaxTiles>=0?this._iCurrentFocusIndex-this._iMaxTiles:0;var N=t[n];if(!!N){this._renderTilesInTheSamePage(n,t);this._findTile(N.$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),d=q.proxy(function(E){var t=this._getVisibleTiles(),m=t.length;if(m>0){var n=this._iCurrentFocusIndex+this._iMaxTiles<m?this._iCurrentFocusIndex+this._iMaxTiles:m-1;var N=t[n];if(!!N){this._renderTilesInTheSamePage(n,t);this._findTile(N.$()).focus();E.stopPropagation();}this._handleAriaActiveDescendant();}},this),e=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex+1<t.length?this._iCurrentFocusIndex+1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(!!N){if(n<this._iCurrentTileStartIndex+this._iMaxTiles){this._findTile(N.$()).focus();}else{this._renderTilesInTheSamePage(n,t);this.scrollIntoView(N,true,t);var m=this;setTimeout(function(){m._findTile(N.$()).focus();},400);}}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),g=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex-1>=0?this._iCurrentFocusIndex-1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(!!N){if(n>=this._iCurrentTileStartIndex){this._findTile(N.$()).focus();}else{this._renderTilesInTheSamePage(n,t);this.scrollIntoView(N,true,t);var m=this;setTimeout(function(){m._findTile(N.$()).focus();},400);}}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),i=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex+this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M>m)&&!!N){this._findTile(N.$()).focus();}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),j=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex-this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M<m)&&!!N){this._findTile(N.$()).focus();}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().focus();}this._handleAriaActiveDescendant();E.stopPropagation();}},this),k=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0&&this.getEditable()){var m=t[this._iCurrentFocusIndex];if(m.getRemovable()){this.deleteTile(m);t=this._getVisibleTiles();if(this._iCurrentFocusIndex===t.length){if(t.length!==0){t[this._iCurrentFocusIndex-1].$().focus();}else{this._findNextTabbable().focus();}}else{t[this._iCurrentFocusIndex].$().focus();}this._handleAriaActiveDescendant();}E.stopPropagation();}},this);this.onsaphome=o;this.onsaphomemodifiers=o;this.onsapend=O;this.onsapendmodifiers=O;this.onsapright=this._bRtl?g:e;this.onsaprightmodifiers=this._bRtl?g:e;this.onsapleft=this._bRtl?e:g;this.onsapleftmodifiers=this._bRtl?e:g;this.onsapup=j;this.onsapupmodifiers=j;this.onsapdown=i;this.onsapdownmodifiers=i;this.onsappageup=f;this.onsappagedown=d;this.onsapdelete=k;this.data("sap-ui-fastnavgroup","true",true);}if(D.system.tablet||D.system.phone){this._fnOrientationChange=function(E){if(this.getDomRef()){this._oTileDimensionCalculator.calc();}}.bind(this);}this._oTileDimensionCalculator=new b(this);this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._oPagesInfo=(function(r){var m,n,p,s,P=false,t=r;return{setCurrentPage:function(u){p=m;m=u;},setCount:function(u){s=n;n=u;},setPagerCreated:function(u){P=u;},syncOldToCurrentValues:function(){s=n;p=m;},reset:function(){s=undefined;p=undefined;n=undefined;m=undefined;P=false;},getCurrentPage:function(){return m;},getCount:function(){return n;},getOldCurrentPage:function(){return p;},getOldCount:function(){return s;},isPagerCreated:function(){return P;},currentPageIsLast:function(){return t?(m===0):(m===n-1);},currentPageIsFirst:function(){return t?(m===n-1):(m===0);},oldCurrentPageIsLast:function(){if(isNaN(p)){return false;}return t?(p===0):(p===s-1);},oldCurrentPageIsFirst:function(){if(isNaN(p)){return false;}return t?(p===s-1):(p===0);},currentPageIsLastChanged:function(){return this.currentPageIsLast()!==this.oldCurrentPageIsLast();},currentPageIsFirstChanged:function(){return this.currentPageIsFirst()!==this.oldCurrentPageIsFirst();},currentPageRelativePositionChanged:function(){return this.currentPageIsFirstChanged()||this.currentPageIsLastChanged();},pageCountChanged:function(){return n!==s;},currentPageChanged:function(){return m!==p;}};}(this._bRtl));this._iMaxTiles=1;};
a.prototype._findNextTabbable=function(){var r=this.$();var t=q.merge(q.merge(r.nextAll(),r.parents().nextAll()).find(':sapTabbable').addBack(':sapTabbable'),q.merge(r.parents().prevAll(),r.prevAll()).find(':sapTabbable').addBack(':sapTabbable'));return t.first();};
a.prototype.onBeforeRendering=function(){var t=this.getTiles(),d=t.length;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._oPagesInfo.reset();for(var i=0;i<d;i++){t[i]._rendered=false;}};
a.prototype.onAfterRendering=function(){var v=[];this._sResizeListenerId=R.register(this.getDomRef().parentElement,q.proxy(this._resize,this));this._oDim=this._calculateDimension();this._applyDimension();this.$().toggleClass("sapMTCEditable",this.getEditable()===true);if(this._bRenderFirstPage){this._bRenderFirstPage=false;v=this._getVisibleTiles();this._updateTileDimensionInfoAndPageSize(v);if(this.getTiles().length===1){this._update(false,v);}else if(this._iMaxTiles!==Infinity&&this._iMaxTiles){this._renderTiles(v,0,this._iMaxTiles-1);}}else{this._update(true);}if(D.system.desktop||D.system.combi){var t=v||this._getVisibleTiles();if(t.length>0&&this._mFocusables&&this._mFocusables[t[0].getId()]){this._mFocusables[t[0].getId()].eq(0).attr('tabindex','0');}}if(D.system.tablet||D.system.phone){D.orientation.attachHandler(this._fnOrientationChange,this);}};
a.prototype.setEditable=function(v){var t=this._getVisibleTiles();this.setProperty("editable",v,true);var e=this.getEditable();this.$().toggleClass("sapMTCEditable",e);for(var i=0;i<t.length;i++){var o=t[i];if(o instanceof sap.m.Tile){o.isEditable(e);}}return this;};
a.prototype.updateTiles=function(){this.destroyTiles();this.updateAggregation('tiles');};
a.prototype._applyDimension=function(){var d=this._getDimension(),$=this.$(),t,o=10,e=this.$("scrl"),s,f,p=this.$("pager").outerHeight();e.css({width:d.outerwidth+"px",height:(d.outerheight-p)+"px"});t=$.position();s=e.position();f=e.outerHeight();if(D.system.phone){o=2;}else if(D.system.desktop){o=0;}this.$("blind").css({top:(s.top+o)+"px",left:(s.left+o)+"px",right:"auto",width:(e.outerWidth()-o)+"px",height:(f-o)+"px"});this.$("rightedge").css({top:(t.top+o)+"px",right:o+"px",left:"auto",height:(f-o)+"px"});this.$("leftedge").css({top:(t.top+o)+"px",left:(t.left+o)+"px",right:"auto",height:(f-o)+"px"});};
a.prototype._resize=function(){if(this._oDragSession){return;}setTimeout(q.proxy(function(){var v=this._getVisibleTiles(),t=v.length,d=this._iCurrentTileStartIndex,o=this._oDim,n,N,e;this._oPagesInfo.reset();this._oDim=this._calculateDimension();this._updateTileDimensionInfoAndPageSize(v);if(o.width!==this._oDim.width||o.height!==this._oDim.height){for(var i=0;i<t;i++){if(v[i]._rendered){v[i]._rendered=false;v[i].$().remove();}}n=this._getPageNumberForTile(d);N=n*this._iMaxTiles;e=N+this._iMaxTiles-1;this._renderTiles(v,N,e);}},this),0);};
a.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._fnOrientationChange,this);}delete this._oPagesInfo;};
a.prototype._update=function(A,v){if(!this.getDomRef()){return;}if(!this.getVisible()){return;}v=v||this._getVisibleTiles();this._oTileDimensionCalculator.calc(v);this._updateTilePositions(v);if(!this._oDragSession){this.scrollIntoView(this._iCurrentTileStartIndex||0,A,v);}};
a.prototype.getPageFirstTileIndex=function(){return this._iCurrentTileStartIndex||0;};
a.prototype.moveTile=function(t,n){if(!isNaN(t)){t=this._getVisibleTiles()[t];}if(!t){L.info("No Tile to move");return this;}this.deleteTile(t);this.insertTile(t,n);return this;};
a.prototype.addTile=function(t){this.insertTile(t,this.getTiles().length);return this;};
a.prototype.insertTile=function(t,i){var d=this,v;t.isEditable(this.getEditable());if(D.system.desktop||D.system.combi){t.addEventDelegate({"onAfterRendering":function(){if(!d._mFocusables){d._mFocusables={};}d._mFocusables[this.getId()]=this.$().find("[tabindex!='-1']").addBack().filter(d._isFocusable);d._mFocusables[this.getId()].attr('tabindex','-1');}},t);var o=function(e){var i=d._getVisibleTiles().indexOf(this),E=Math.floor(i/d._iMaxTiles),p=E-d._oPagesInfo.getCurrentPage();var P=d._iCurrentFocusIndex>=0?d._iCurrentFocusIndex:0;var V=d._getVisibleTiles();var f=V[P];if(f){d._mFocusables[f.getId()].attr("tabindex","-1");d._mFocusables[this.getId()].attr("tabindex","0");}if(p!=0){d.scrollIntoView(i,null,V);}d._handleAriaActiveDescendant();d._iCurrentFocusIndex=i;};t.addEventDelegate({"onfocusin":o},t);}if(this.getDomRef()){this.insertAggregation("tiles",t,i,true);v=this._getVisibleTiles();if(!this._oDragSession){if(t.getVisible()&&(v.length===1||this._getPageNumberForTile(i)<=this._oPagesInfo.getCurrentPage())){this._renderTile(t,i);this._update(false,v);}else{this._oPagesInfo.setCount(Math.ceil(v.length/this._iMaxTiles));this._updatePager();}}else{this._update(false,v);}if(D.system.desktop||D.system.combi){this._updateTilesTabIndex(v);}}else{this.insertAggregation("tiles",t,i);v=this._getVisibleTiles();}if(t.getVisible()){c.call(this,i,v.length,v);h.call(this,v);}return this;};
a.prototype._updateTilesTabIndex=function(v){v=v||this._getVisibleTiles();if(v.length&&v.length>0){for(var i=0;i<v.length;i++){if(v[i].$().attr("tabindex")==="0"){return;}}}v[0].$().attr("tabindex","0");};
a.prototype._isFocusable=function(i,e){var d=!isNaN(q(e).attr("tabindex"));var n=e.nodeName.toLowerCase();if(n==="area"){var m=e.parentNode,f=m.name,g;if(!e.href||!f||m.nodeName.toLowerCase()!=="map"){return false;}g=q("img[usemap='#"+f+"']")[0];return!!g;}return(/input|select|textarea|button|object/.test(n)?!e.disabled:n=="a"?e.href||d:d);};
a.prototype.deleteTile=function(t){var v=this._getVisibleTiles(),d=this._indexOfVisibleTile(t,v);if(this.getDomRef()){v.splice(d,1);this.removeAggregation("tiles",t,true);if(!this._oDragSession){if(t.getDomRef()){t.getDomRef().parentNode.removeChild(t.getDomRef());}if(D.system.desktop||D.system.combi){if(this._mFocusables&&this._mFocusables[t.getId()]){delete this._mFocusables[t.getId()];}}}if(v.length===0){this._oPagesInfo.reset();}else if(t.getVisible()&&d>=0&&this._getPageNumberForTile(d)<=this._oPagesInfo.getCurrentPage()){this._renderTilesInTheSamePage(this._oPagesInfo.getCurrentPage()*this._iMaxTiles,v);}this._update(false);}else{this.removeAggregation("tiles",t,false);v=this._getVisibleTiles();}c.call(this,d,v.length);h.call(this,v);return this;};
a.prototype.removeTile=a.prototype.deleteTile;
a.prototype.removeAllTiles=function(){var t=this.getTiles().length-1;for(var i=t;i>=0;i--){var o=this.getTiles()[i];this.deleteTile(o);}return this;};
a.prototype.destroyTiles=function(){if(this.getDomRef()){var t=this.getTiles();this.removeAllAggregation("tiles",true);this._oPagesInfo.reset();this._update();for(var i=0;i<t.length;i++){var d=t[i];d.destroy();}}else{this.destroyAggregation("tiles",false);}return this;};
a.prototype.rerender=function(){if(!this._oDragSession||this._oDragSession.bDropped){C.prototype.rerender.apply(this);}};
a.prototype.scrollLeft=function(){var s=0,v=this._getVisibleTiles();if(this._bRtl){s=this._iCurrentTileStartIndex+this._iMaxTiles;}else{s=this._iCurrentTileStartIndex-this._iMaxTiles;}this._renderTiles(v,s,s+this._iMaxTiles-1);this.scrollIntoView(s,null,v);};
a.prototype.scrollRight=function(){var s=0,v=this._getVisibleTiles();if(this._bRtl){s=this._iCurrentTileStartIndex-this._iMaxTiles;}else{s=this._iCurrentTileStartIndex+this._iMaxTiles;}this._renderTiles(v,s,s+this._iMaxTiles-1);this.scrollIntoView(s,null,v);};
a.prototype._renderTilesInTheSamePage=function(t,d){var i=this._getPageNumberForTile(t),f=i*this._iMaxTiles,e=f+this._iMaxTiles-1;this._renderTiles(d,f,e);};
a.prototype._renderTiles=function(t,s,e){var n=false,i;for(i=s;i<=e;i++){if(t[i]&&!t[i]._rendered){this._renderTile(t[i],i);n=true;}}if(n){this._update(false,t);if(D.system.desktop||D.system.combi){this._updateTilesTabIndex();}}};
a.prototype.scrollIntoView=function(t,A,v){var i=this._getContentDimension().outerwidth,d=t,e=this.getTiles();if(isNaN(t)){d=this.indexOfAggregation("tiles",t);}if(!e[d]||!e[d].getVisible()){return;}v=v||this._getVisibleTiles();d=this._indexOfVisibleTile(e[d]);if(!!d&&d>=0){this._renderTilesInTheSamePage(d,v);}this._applyPageStartIndex(d,v);this._oPagesInfo.setCurrentPage(Math.floor(this._iCurrentTileStartIndex/this._iMaxTiles));if(this._bRtl){this._scrollTo((this._oPagesInfo.getCount()-this._oPagesInfo.getCurrentPage())*i,A);}else{this._scrollTo(this._oPagesInfo.getCurrentPage()*i,A);}this._updatePager();};
a.prototype._updateTilePositions=function(v){var d=this._getDimension();if(d.height===0){return;}v=v||this._getVisibleTiles();if(v.length===0){this._oPagesInfo.setCount(0);this._updatePager();return;}this._applyPageStartIndex(this._iCurrentTileStartIndex,v);this._applyDimension();var o=this._getContentDimension();this._oPagesInfo.setCount(Math.ceil(v.length/this._iMaxTiles));var t=this._oTileDimensionCalculator.getLastCalculatedDimension();for(var i=0;i<v.length;i++){if(!v[i]._rendered||v[i].isDragged()){continue;}var p=Math.floor(i/this._iMaxTiles),e=v[i],f=(p*o.outerwidth)+this._iOffsetX+i%this._iMaxTilesX*t.width,g=this._iOffsetY+Math.floor(i/this._iMaxTilesX)*t.height-(p*this._iMaxTilesY*t.height);if(this._bRtl){f=(this._oPagesInfo.getCount()-p)*o.outerwidth-this._iOffsetX-(i%this._iMaxTilesX+1)*t.width;}e.setPos(f,g);e.setSize(t.width,t.height);}};
a.prototype._findTile=function($){if($.hasClass('sapMTile')||$.hasClass('sapMCustomTile')){return $;}else{return $.find('.sapMTile')||$.find('.sapMCustomTile');}};
a.prototype._updatePager=function(){var p,s,S,H,P=false;if(!this._oPagesInfo.pageCountChanged()&&!this._oPagesInfo.currentPageChanged()){return;}p=this.$("pager")[0];s=this.$("leftscroller")[0];S=this.$("rightscroller")[0];if(this._oPagesInfo.getCount()==undefined||this._oPagesInfo.getCount()<=1){p.innerHTML="";S.style.right="-100px";s.style.left="-100px";s.style.display="none";S.style.display="none";this._oPagesInfo.setPagerCreated(false);return;}if(!this._oPagesInfo.isPagerCreated()){H=[""];for(var i=0;i<this._oPagesInfo.getCount();i++){H.push("");}p.innerHTML=H.join("<span></span>");p.style.display="block";p.childNodes[0].className="sapMTCActive";this._oPagesInfo.setPagerCreated(true);P=true;}else if(this._oPagesInfo.pageCountChanged()){if(this._oPagesInfo.getCount()-this._oPagesInfo.getOldCount()<0){p.removeChild(p.lastChild);}else{p.appendChild(document.createElement("span"));}}if(this._oPagesInfo.currentPageChanged()){p.childNodes[this._oPagesInfo.getCurrentPage()].className="sapMTCActive";if(p.childNodes[this._oPagesInfo.getOldCurrentPage()]){p.childNodes[this._oPagesInfo.getOldCurrentPage()].className="";}if(this._oPagesInfo.getCurrentPage()>=1){p.childNodes[0].className="";}}if(D.system.desktop&&(P||this._oPagesInfo.currentPageRelativePositionChanged())){if(this._bRtl){S.style.left="auto";s.style.right="auto";}S.style.right=this._oPagesInfo.currentPageIsLast()?"-100px":"1rem";s.style.left=this._oPagesInfo.currentPageIsFirst()?"-100px":"1rem";S.style.display=this._oPagesInfo.currentPageIsLast()?"none":"block";s.style.display=this._oPagesInfo.currentPageIsFirst()?"none":"block";}this._oPagesInfo.syncOldToCurrentValues();};
a.prototype._getContentDimension=function(){if(!this.getDomRef()){return;}var s=this.$("scrl");return{width:s.width(),height:s.height()-20,outerheight:s.outerHeight()-20,outerwidth:s.outerWidth()};};
a.prototype._getDimension=function(){if(!this._oDim){this._oDim=this._calculateDimension();}return this._oDim;};
a.prototype._calculatePageSize=function(v){var d,t;v=v||this._getVisibleTiles();t=v.length;if(t===0){return;}d=q.extend({},this._getDimension());if(d.height===0){return;}if(D.system.desktop){d.width-=45*2;}var o=this._oTileDimensionCalculator.getLastCalculatedDimension(),p=this.$("pager")[0].offsetHeight,m=Math.max(Math.floor(d.width/o.width),1),M=Math.max(Math.floor((d.height-p)/o.height),1),n=(t<m)?t:m,N=(t/n<M)?Math.ceil(t/n):M;this._iMaxTiles=m*M;this._iMaxTilesX=m;this._iMaxTilesY=M;this._iOffsetX=Math.floor((d.width-(o.width*n))/2);if(D.system.desktop){this._iOffsetX+=45;}this._iOffsetY=Math.floor((d.height-p-(o.height*N))/2);};
a.prototype._getTilesFromPosition=function(x,y){if(!this._getVisibleTiles().length){return[];}x=x+this._iScrollLeft;var t=this._getVisibleTiles(),r=[];for(var i=0;i<t.length;i++){var o=t[i],d={top:o._posY,left:o._posX,width:o._width,height:o._height};if(!t[i].isDragged()&&y>d.top&&y<d.top+d.height&&x>d.left&&x<d.left+d.width){r.push(t[i]);}}return r;};
a.prototype._applyPageStartIndex=function(i,v){var o=this._getDimension();if(o.height===0){return;}v=v||this._getVisibleTiles();this._calculatePageSize(v);var d=v.length;if(i<0){i=0;}else if(i>d-1){i=d-1;}var e=Math.floor(i/this._iMaxTiles||0);this._iCurrentTileStartIndex=e*(this._iMaxTiles||0);L.info("current index "+this._iCurrentTileStartIndex);};
a.prototype._scrollTo=function(s,A){if(A!==false){A=true;}this._applyTranslate(this.$("cnt"),-s,0,A);if(this._bRtl){this._iScrollLeft=s-this._getContentDimension().outerwidth;}else{this._iScrollLeft=s;}};
a.prototype._applyTranslate=function(d,x,y,A){var o=d[0];this.$("cnt").toggleClass("sapMTCAnim",A);if("webkitTransform"in o.style){d.css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("MozTransform"in o.style){d.css('-moz-transform','translate('+x+'px,'+y+'px)');}else if("transform"in o.style){d.css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){d.css('-ms-transform','translate('+x+'px,'+y+'px)');}};
a.prototype._initTouchSession=function(e){if(e.type=="touchstart"){var t=e.targetTouches[0];this._oTouchSession={dStartTime:new Date(),fStartX:t.pageX,fStartY:t.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:t.pageX-e.target.offsetLeft};}else{this._oTouchSession={dStartTime:new Date(),fStartX:e.pageX,fStartY:e.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:e.pageX-e.target.offsetLeft};}};
a.prototype._initDragSession=function(e){while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}var i=this.indexOfAggregation("tiles",e.srcControl);if(e.type=="touchstart"){this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.targetTouches[0].pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.targetTouches[0].pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.targetTouches[0].pageX,iDiffY:e.targetTouches[0].pageY};}else{this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.pageX,iDiffY:e.pageY};}};
a.prototype.onclick=function(e){var p=this.$("pager")[0];if(e.target.id==this.getId()+"-leftscroller"||e.target.parentNode.id==this.getId()+"-leftscroller"){this.scrollLeft();}else if(e.target.id==this.getId()+"-rightscroller"||e.target.parentNode.id==this.getId()+"-rightscroller"){this.scrollRight();}else if(e.target==p&&D.system.desktop){if(e.offsetX<p.offsetWidth/2){this.scrollLeft();}else{this.scrollRight();}}};
a.prototype.ontouchstart=function(e){e.setMarked();if(e.targetTouches.length>1||this._oTouchSession){return;}while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}if(e.srcControl instanceof sap.m.Tile&&this.getEditable()){if(e.target.className!="sapMTCRemove"){this._initDragSession(e);this._initTouchSession(e);this._oDragSession.oTile.isDragged(true);}else{this._initTouchSession(e);}this._bAvoidChildTapEvent=true;}else{this._initTouchSession(e);}q(document).on("touchmove mousemove",q.proxy(this._onmove,this));q(document).on("touchend touchcancel mouseup",q.proxy(this._onend,this));};
a.prototype._onmove=function(e){if(document.selection&&document.selection.clear){document.selection.clear();}if(e.isMarked("delayedMouseEvent")){return;}if(e.targetTouches&&e.targetTouches.length>1){return;}if(!e.targetTouches){e.targetTouches=[{pageX:e.pageX,pageY:e.pageY}];}var t=this._oTouchSession;t.fDiffX=t.fStartX-e.targetTouches[0].pageX;t.fDiffY=t.fStartY-e.targetTouches[0].pageY;if(this._oDragSession){if(Math.abs(t.fDiffX)>5){if(!this._oDragSession.bStarted){this._oDragSession.bStarted=true;this._onDragStart(e);}else{this._onDrag(e);}this._bAvoidChildTapEvent=true;}}else if(t){var d=this._getContentDimension().outerwidth;var n=-this._iScrollLeft-t.fDiffX;if(n>this._iScrollGap){return;}else if(n<-(((this._oPagesInfo.getCount()-1)*d)+this._iScrollGap)){return;}if(this._bRtl){n=n-d;}var v=this._getVisibleTiles();var N=this._iCurrentTileStartIndex+this._iMaxTiles;var i=N+this._iMaxTiles-1;this._renderTiles(v,N,i);this._applyTranslate(this.$("cnt"),n,0,false);}};
a.prototype._onend=function(e){if(e.isMarked("delayedMouseEvent")){return;}q(document).off("touchend touchcancel mouseup",this._onend);q(document).off("touchmove mousemove",this._onmove);if(this._oDragSession){this._onDrop(e);delete this._oTouchSession;return;}if(!this._oTouchSession){return;}var t=this._oTouchSession,d=new Date(),f=(d-t.dStartTime<600),r=this._bRtl?-1:1;if(f){var p=this.$("pager")[0];if(Math.abs(t.fDiffX)>30){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}else if(e.target==p&&!D.system.desktop){if((t.iOffsetX-p.offsetWidth/2)*r<0){this.scrollLeft();}else{this.scrollRight();}this._bAvoidChildTapEvent=true;}else if(e.target.className=="sapMTCRemove"){if(e.type==="touchend"||(e.type==="mouseup"&&e.button===0)){this.fireTileDelete({tile:t.oControl});}}}else{var o=this._getContentDimension();if(Math.abs(t.fDiffX)>o.outerwidth/2){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}}this._update();delete this._oDragSession;delete this._oTouchSession;var g=this;setTimeout(function(){g._bAvoidChildTapEvent=false;},100);};
a.prototype._onDragStart=function(e){this.$().append(this._oDragSession.oTileElement);this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;this._oDragSession.oTile.setPos(this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,this._oDragSession.iDiffY-this._oDragSession.iOffsetTop);this.$("blind").css("display","block");};
a.prototype._onDrag=function(e){if(!this._oTouchSession){clearTimeout(this.iScrollTimer);this._oDragSession=null;this.iScrollTimer=null;this._bTriggerScroll=false;return;}this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;var o=this._getContentDimension(),t=this._oDragSession.iDiffY-this._oDragSession.iOffsetTop,i=this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,m=t+(this._oDragSession.oTileElement.offsetHeight/2),d=i+(this._oDragSession.oTileElement.offsetWidth/2),s=i+this._oDragSession.oTileElement.offsetWidth-this._iTriggerScrollOffset>o.width,S=i<-this._iTriggerScrollOffset,n=o.width-(i+this._oDragSession.oTileElement.offsetWidth),N=i;this._oDragSession.oTile.setPos(i,t);this._oDragSession.oTile.$().css("clip","auto");var r=this.$("rightedge")[0];if(i+this._oDragSession.oTile._width>r.offsetLeft+r.offsetWidth&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1){var f=r.offsetLeft+r.offsetWidth-i-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)-2;this._oDragSession.oTile.$().css("clip","rect(-25px,"+f+"px,"+(this._oDragSession.oTile._height+20)+"px,-25px)");}var g=this.$("leftedge")[0];if(i<g.offsetLeft+2+((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)&&this._oPagesInfo.getCurrentPage()>0){var j=g.offsetLeft+4-i-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2);this._oDragSession.oTile.$().css("clip","rect(-25px,"+this._oDragSession.oTile._width+"px,"+(this._oDragSession.oTile._height+20)+"px,"+j+"px)");}if(n<this._iEdgeShowStart&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1){var O=(this._iEdgeShowStart-n)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("rightedge").css("opacity",""+O);}else{this.$("rightedge").css("opacity","0.01");}if(N<this._iEdgeShowStart&&this._oPagesInfo.getCurrentPage()>0){var O=(this._iEdgeShowStart-N)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("leftedge").css("opacity",""+O);}else{this.$("leftedge").css("opacity","0.01");}var k;if(this._bRtl){k=s&&this._oPagesInfo.getCurrentPage()>0||S&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1;}else{k=S&&this._oPagesInfo.getCurrentPage()>0||s&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1;}if(k){if(this._bTriggerScroll){S?this.scrollLeft():this.scrollRight();}else{var p=this;if(!this.iScrollTimer){this.iScrollTimer=setInterval(function(){p._bTriggerScroll=true;p._onDrag(e);p._bTriggerScroll=false;},1000);}}return;}else{if(this.iScrollTimer){clearTimeout(this.iScrollTimer);this._bTriggerScroll=false;this.iScrollTimer=null;}}var H=this._getTilesFromPosition(d,m);if(H&&H.length>0){var u=H[0],v={top:u._posY,left:u._posX,width:u._width,height:u._height};var w=this.indexOfAggregation("tiles",u);if(d+this._iScrollLeft<((v.left+v.width)/2)&&(w%this._iMaxTilesX)!=0){w--;}this._oDragSession.iIndex=w;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}else if(this._oPagesInfo.getCurrentPage()==this._oPagesInfo.getCount()-1){var x=this._getVisibleTiles(),y=x[x.length-1];if(y&&d>y._posX-this._iScrollLeft&&m>y._posY){this._oDragSession.iIndex=x.length-1;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}}};
a.prototype._onDrop=function(e){if(this._oDragSession){var t=this._oDragSession.oTile,i=this._oDragSession.iIndex;this._oDragSession.oTile.isDragged(false);if(this._oDragSession.iOldIndex!=this._oDragSession.iIndex){this.fireTileMove({tile:t,newIndex:i});}this.$("blind").css("display","block");if(this._oDragSession.bStarted){this._oDragSession.oTile.setPos(this._oDragSession.oTile._posX+this._iScrollLeft,this._oDragSession.oTile._posY);}this._oDragSession.oTile.$().css("clip","auto");this.$("rightedge").css("opacity","0.01");this.$("leftedge").css("opacity","0.01");this.$("cnt").append(this._oDragSession.oTileElement);delete this._oDragSession;this.moveTile(t,i);this.scrollIntoView(t,false);if(D.system.desktop||D.system.combi){this._findTile(t.$()).focus();}this._handleAriaActiveDescendant();this.$("blind").css("display","none");}};
a.prototype._handleAriaActiveDescendant=function(){var A=q(document.activeElement).control(0);if(A instanceof sap.m.Tile&&A.getParent()===this){this.getDomRef().setAttribute("aria-activedescendant",A.getId());}};
a.prototype._renderTile=function(t,i){var r=sap.ui.getCore().createRenderManager(),o=this.$("cnt")[0];r.renderControl(t);r.flush(o,false,i);r.destroy();};
a.prototype.onThemeChanged=function(){if(this.getDomRef()){this.invalidate();}};
a.prototype._calculateDimension=function(){var d=this.$();if(!d){return;}return{width:d.width(),height:d.height(),outerheight:d.outerHeight(),outerwidth:d.outerWidth()};};
a.prototype._getVisibleTiles=function(){var r=[],t=this.getTiles();for(var i=0,d=t.length;i<d;i++){if(t[i].mProperties["visible"]){r.push(t[i]);}}return r;};
a.prototype._indexOfVisibleTile=function(t,d){var i,e;d=d||this._getVisibleTiles();e=d.length;for(i=0;i<e;i++){if(d[i]===t){return i;}}return-1;};
a.prototype._updateTileDimensionInfoAndPageSize=function(v){v=v||this._getVisibleTiles();this._oTileDimensionCalculator.calc(v);this._calculatePageSize(v);};
a.prototype._getPageNumberForTile=function(t){return Math.floor((t/this._iMaxTiles)||0);};
var b=function(t){this._oDim=null;this._oTileContainer=t;};
b.prototype.calc=function(v){var V,t;if(!this._oTileContainer.getDomRef()){return;}V=v||this._oTileContainer._getVisibleTiles();if(V.length){t=V[0];for(var i=0,d=V.length;i<d;i++){if(V[i]._rendered){t=V[i];break;}}this._oDim={width:Math.round(t.$().outerWidth(true)),height:Math.round(t.$().outerHeight(true))};}return this._oDim;};
b.prototype.getLastCalculatedDimension=function(){return this._oDim;};
function h(v){var t,i,o;v=v||this._getVisibleTiles();t=v.length;for(i=0;i<t;i++){o=v[i];if(o._rendered&&o.getDomRef()){o.getDomRef().setAttribute("aria-setsize",t);}}}
function c(s,e,v){var i,t=null;v=v||this._getVisibleTiles();for(i=s;i<e;i++){t=v[i];if(t){t.$().attr('aria-posinset',this._indexOfVisibleTile(t,v)+1);}}}
return a;});
sap.ui.predefine('sap/m/TileContainerRenderer',[],function(){"use strict";var T={};T.DEFAULT_TILES_TO_RENDER=1;
T.render=function(r,c){var i=c.getId();r.write("<div tabindex=\"-1\"");r.writeControlData(c);r.addStyle("height",c.getHeight());r.addStyle("width",c.getWidth());r.writeStyles();r.addClass("sapMTC");r.writeClasses();r.writeAccessibilityState(c,{role:"listbox",multiSelectable:false,activeDescendant:c.getTiles().length>0?c.getTiles()[0].getId():""});r.write(" >");r.write("<div id=\""+i+"-scrl\" class=\"sapMTCScrl\" style=\"height:0px;");if(!c.bRtl){r.write(" overflow: hidden;");}r.write("\">");r.write("<div id=\""+i+"-blind\" class=\"sapMTCBlind\"></div>");r.write("<div id=\""+i+"-cnt\" class=\"sapMTCCnt sapMTCAnim\" style=\"height:0px; width:0px;\" role=\"group\">");this.renderTiles(c,r);r.write("</div>");r.write("</div>");r.write("<div id=\""+i+"-pager\" class=\"sapMTCPager\">");r.write("</div>");r.write("<div id=\""+i+"-leftedge\" class=\"sapMTCEdgeLeft\"></div>");r.write("<div id=\""+i+"-rightedge\" class=\"sapMTCEdgeRight\"></div>");r.write("<div id=\""+i+"-leftscroller\" class=\"sapMTCScroller sapMTCLeft\" tabindex=\"-1\"><div class=\"sapMTCInner\" ></div></div>");r.write("<div id=\""+i+"-rightscroller\" class=\"sapMTCScroller sapMTCRight\" tabindex=\"-1\"><div class=\"sapMTCInner\" ></div></div>");r.write("</div>");};
T.renderTiles=function(t,r){var a=t.getTiles(),i=0,R=0,m;if(!a.length){return;}m=this._getCountOfTilesToRender(t,a);if(m===T.DEFAULT_TILES_TO_RENDER){t._bRenderFirstPage=true;}do{if(a[i]&&a[i].getVisible()){a[i]._setVisible(false);r.renderControl(a[i]);R++;}i++;}while(R!==m&&(i<a.length));};
T._getCountOfTilesToRender=function(t,a){if(t._iMaxTiles){return t._iMaxTiles;}if(a.length>T.DEFAULT_TILES_TO_RENDER){return T.DEFAULT_TILES_TO_RENDER;}return a.length;};
return T;},true);
sap.ui.predefine('sap/m/TileContent',['./library','sap/ui/core/Control','./TileContentRenderer'],function(l,C,T){"use strict";
var a=C.extend("sap.m.TileContent",{metadata:{library:"sap.m",properties:{"footer":{type:"string",group:"Appearance",defaultValue:null},"footerColor":{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},"size":{type:"sap.m.Size",group:"Appearance",defaultValue:"Auto"},"unit":{type:"string",group:"Data",defaultValue:null},"disabled":{type:"boolean",group:"Behavior",defaultValue:false},"frameType":{type:"sap.m.FrameType",group:"Appearance",defaultValue:"Auto"}},defaultAggregation:"content",aggregations:{"content":{type:"sap.ui.core.Control",multiple:false,bindable:"bindable"}}}});
a.prototype.init=function(){this._bRenderFooter=true;this._bRenderContent=true;};
a.prototype.onBeforeRendering=function(){if(this.getContent()&&this._oDelegate){if(this.getDisabled()){this.getContent().addDelegate(this._oDelegate);}else{this.getContent().removeDelegate(this._oDelegate);}}};
a.prototype.onAfterRendering=function(){var c=this.getContent();if(c){var t=this.$();if(!t.attr("title")){var s=c.getTooltip_AsString();var b=t.find("*");b.removeAttr("title");if(s&&s.trim().length!==0){if(this._getFooterText().trim()!==0){s=s+"\n"+this._getFooterText();}t.attr("title",s);}}}};
a.prototype._getContentType=function(){if(this.getContent()){var c=this.getContent().getMetadata().getName();if(c==="sap.m.NewsContent"||c==="sap.suite.ui.commons.NewsContent"){return"News";}}};
a.prototype._getFooterText=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var f=this.getFooter();var u=this.getUnit();if(u){if(f){if(sap.ui.getCore().getConfiguration().getRTL()){return r.getText('TILECONTENT_FOOTER_TEXT',[f,u]);}else{return r.getText('TILECONTENT_FOOTER_TEXT',[u,f]);}}else{return u;}}else{return f;}};
a.prototype.getAltText=function(){var A="";var i=true;var c=this.getContent();if(c){if(c.getAltText){A+=c.getAltText();i=false;}else if(c.getTooltip_AsString()){A+=c.getTooltip_AsString();i=false;}}if(this.getUnit()){A+=(i?"":"\n")+this.getUnit();i=false;}if(this.getFooter()){A+=(i?"":"\n")+this.getFooter();}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var A="";if(typeof t==="string"||t instanceof String){return t;}A=this.getAltText();return A?A:"";};
a.prototype.setRenderFooter=function(v){this._bRenderFooter=v;return this;};
a.prototype.setRenderContent=function(v){this._bRenderContent=v;return this;};
return a;});
sap.ui.predefine('sap/m/TileContentRenderer',["sap/base/security/encodeCSS"],function(e){"use strict";var T={};
T.render=function(r,c){var t=c.getTooltip_AsString();var C=c._getContentType();if(C){C=e(C);}var f=e("sapMFrameType"+c.getFrameType());r.write("<div");r.writeControlData(c);r.addClass("sapMTileCnt");r.addClass(C);r.addClass(f);if(t.trim()){r.writeAttributeEscaped("title",t);}r.writeClasses();r.write(">");this._renderContent(r,c);this._renderFooter(r,c);r.write("</div>");};
T._renderContent=function(r,c){if(!c._bRenderContent){return;}var C=c.getContent();if(C){r.write("<div");r.addClass("sapMTileCntContent");r.writeClasses();r.writeAttribute("id",c.getId()+"-content");r.write(">");if(!C.hasStyleClass("sapMTcInnerMarker")){C.addStyleClass("sapMTcInnerMarker");}r.renderControl(C);r.write("</div>");}};
T._renderFooter=function(r,c){if(!c._bRenderFooter){return;}var C="sapMTileCntFooterTextColor"+c.getFooterColor();var t=c.getTooltip_AsString();var f=c._getFooterText(r,c);r.write("<div");r.addClass("sapMTileCntFtrTxt");r.addClass(e(C));r.writeClasses();r.writeAttribute("id",c.getId()+"-footer-text");if(t.trim()){r.writeAttributeEscaped("title",t);}r.write(">");r.writeEscaped(f);r.write("</div>");};
return T;},true);
sap.ui.predefine('sap/m/TileRenderer',[],function(){"use strict";var T={};
T.render=function(r,c){var t,v;r.write("<div tabindex=\"0\"");r.writeControlData(c);r.addClass("sapMTile");r.addClass("sapMPointer");r.writeClasses();if(c._invisible){r.addStyle("visibility","hidden");r.writeStyles();}var s=c.getTooltip_AsString();if(s){r.writeAttributeEscaped("title",s);}if(c.getParent()instanceof sap.m.TileContainer){t=c.getParent();v=t._getVisibleTiles();r.writeAccessibilityState(c,{role:"option",posinset:t._indexOfVisibleTile(c,v)+1,setsize:v.length});}r.write(">");if(c.getRemovable()){r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCRemove\"></div>");}else{r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCNoRemove\"></div>");}r.write("<div class=\"sapMTileContent\">");this._renderContent(r,c);r.write("</div></div>");};
T._renderContent=function(r,c){};
return T;},true);
sap.ui.predefine('sap/m/TimePicker',['./InputBase','./DateTimeField','./MaskInputRule','./ResponsivePopover','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./TimePickerSliders','./MaskEnabler','sap/ui/Device','sap/ui/core/format/DateFormat','sap/ui/core/Locale','sap/m/library','sap/ui/core/LocaleData','./TimePickerRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/InvisibleText",'./Button',"sap/ui/thirdparty/jquery"],function(I,D,M,R,E,a,T,b,c,d,L,l,e,f,K,g,h,B,q){"use strict";var P=l.PlacementType,j=l.TimePickerMaskMode,k=l.ButtonType,m=1;
var n=D.extend("sap.m.TimePicker",{metadata:{library:"sap.m",designtime:"sap/m/designtime/TimePicker.designtime",properties:{localeId:{type:"string",group:"Data"},title:{type:"string",group:"Misc",defaultValue:null},minutesStep:{type:"int",group:"Misc",defaultValue:m},secondsStep:{type:"int",group:"Misc",defaultValue:m},placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null},maskMode:{type:"sap.m.TimePickerMaskMode",group:"Misc",defaultValue:j.On},support2400:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"},_picker:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},dnd:{draggable:false,droppable:true}}});
a.insertFontFaceStyle();E.call(n.prototype,true);b.call(n.prototype);var o={Short:"short",Medium:"medium",Long:"long"},p={Hour:"hour",Minute:"minute",Second:"second"},r='-';
n.prototype.init=function(){D.prototype.init.apply(this,arguments);b.init.apply(this,arguments);this.setDisplayFormat(t());this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._bValid=false;this._sUsedDisplayPattern=null;this._sUsedValuePattern=null;this._oDisplayFormat=null;this._sValueFormat=null;this._oPopoverKeydownEventDelegate=null;this._rPlaceholderRegEx=new RegExp(r,'g');this._sLastChangeValue=null;var i=this.addEndIcon({id:this.getId()+"-icon",src:this.getIconSrc(),noTabStop:true,title:""});this._bShouldClosePicker=false;i.addEventDelegate({onmousedown:function(u){this._bShouldClosePicker=this.isOpen();}},this);i.attachPress(function(){this.toggleOpen(this._bShouldClosePicker);},this);};
n.prototype.onBeforeRendering=function(){D.prototype.onBeforeRendering.apply(this,arguments);var v=this._getValueHelpIcon();if(v){v.setProperty("visible",this.getEditable(),true);}};
n.prototype.exit=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}b.exit.apply(this,arguments);this._removePickerEvents();this._oResourceBundle=null;this._bValid=false;this._sUsedDisplayPattern=null;this._oDisplayFormat=null;this._oPopoverKeydownEventDelegate=null;this._sUsedValuePattern=null;this._sValueFormat=null;this._sLastChangeValue=null;};
n.prototype.getIconSrc=function(){return a.getIconURI("time-entry-request");};
n.prototype.isOpen=function(){return this._getPicker()&&this._getPicker().isOpen();};
n.prototype.toggleOpen=function(O){this[O?"_closePicker":"_openPicker"]();};
n.prototype.onfocusin=function(i){var u=this._getPicker();var v=this._isIconClicked(i);b.onfocusin.apply(this,arguments);if(u&&u.isOpen()&&!v){this._closePicker();}};
n.prototype._isIconClicked=function(i){return q(i.target).hasClass("sapUiIcon")||q(i.target).hasClass("sapMInputBaseIconContainer");};
n.prototype.onBeforeOpen=function(){var S=this._getSliders(),i=this.getDateValue(),u=this._$input.val(),F=this.getValueFormat(),v=F.indexOf("HH"),w=F.indexOf("H");S.setValue(u);if(this._shouldSetInitialFocusedDateValue()){i=this.getInitialFocusedDateValue();}S._setTimeValues(i,T._isHoursValue24(u,v,w));S.collapseAll();this.$().addClass(I.ICON_PRESSED_CSS_CLASS);};
n.prototype.onAfterOpen=function(){var S=this._getSliders();if(S){S.openFirstSlider();this._handleAriaOnExpandCollapse();}};
n.prototype.onAfterClose=function(){this.$().removeClass(I.ICON_PRESSED_CSS_CLASS);this._handleAriaOnExpandCollapse();};
n.prototype._getValueHelpIcon=function(){var v=this.getAggregation("_endIcon");return v&&v[0];};
n.prototype._handleInputChange=function(v){var i,u,w,F=this.getValueFormat(),x=F.indexOf("HH"),y=F.indexOf("H");v=v||this._$input.val();u=v;w=T._isHoursValue24(u,x,y);this._bValid=true;if(v!==""){i=this._parseValue(T._isHoursValue24(v,x,y)?T._replace24HoursWithZero(v,x,y):v,true);if(!i){this._bValid=false;}else{v=this._formatValue(i);}}u=this.getSupport2400()&&w?"24:"+v.replace(/[0-9]/g,"0").slice(0,-3):v;this.updateDomValue(u);if(i){u=v=this._formatValue(i,true);}this.setProperty("value",u,true);this._lastValue=v;if(this._bValid){this.setProperty("dateValue",i,true);}this.fireChangeEvent(u,{valid:this._bValid});return true;};
n.prototype.onChange=function(i){var v=i?i.value:null;if(this.getEditable()&&this.getEnabled()){return this._handleInputChange(v);}return false;};
n.prototype.setMinutesStep=function(i){var S=this._getSliders();i=Math.max(m,i||m);if(S){S.setMinutesStep(i);}return this.setProperty("minutesStep",i,true);};
n.prototype.setSecondsStep=function(i){var S=this._getSliders();i=Math.max(m,i||m);if(S){S.setSecondsStep(i);}return this.setProperty("secondsStep",i,true);};
n.prototype.setTitle=function(i){var S=this._getSliders();if(S){S.setLabelText(i);}this.setProperty("title",i,true);return this;};
n.prototype._handleDateValidation=function(i){if(!i){this._bValid=false;g.warning("Value can not be converted to a valid date",this);}else{this._bValid=true;this.setProperty("dateValue",i,true);var v=this._formatValue(i);if(this.isActive()){this.updateDomValue(v);}else{this.setProperty("value",v,true);this._lastValue=v;this._sLastChangeValue=v;}}};
n.prototype.setSupport2400=function(S){var i=this._getSliders();this.setProperty("support2400",S,true);if(i){i.setSupport2400(S);}this._initMask();return this;};
n.prototype.setDisplayFormat=function(i){var S=this._getSliders();this.setProperty("displayFormat",i,true);this._initMask();if(S){S.setDisplayFormat(i);}var u=this.getDateValue();if(!u){return this;}var O=this._formatValue(u);this.updateDomValue(O);this._lastValue=O;return this;};
n.prototype.setValue=function(v){var i,O,F=this.getValueFormat(),u=F.indexOf("HH"),w=F.indexOf("H"),S=this._getSliders();v=this.validateProperty("value",v);this._initMask();b.setValue.call(this,v);this._sLastChangeValue=v;this._bValid=true;if(v){i=this._parseValue(T._isHoursValue24(v,u,w)?T._replace24HoursWithZero(v,u,w):v);if(!i){this._bValid=false;g.warning("Value can not be converted to a valid date",this);}}if(this._bValid){this.setProperty("dateValue",i,true);}if(i&&!this.getSupport2400()){O=this._formatValue(i);}else{O=v;}if(S){S.setValue(v);}this.updateDomValue(O);this._lastValue=O;return this;};
n.prototype.setDateValue=function(v){this._initMask();return D.prototype.setDateValue.apply(this,arguments);};
n.prototype.setTooltip=function(v){var i=this.getDomRef(),u;this._refreshTooltipBaseDelegate(v);this.setAggregation("tooltip",v,true);if(!i){return this;}u=this.getTooltip_AsString();if(u){i.setAttribute("title",u);}else{i.removeAttribute("title");}return this;};
n.prototype.setLocaleId=function(i){var C=this.getValue(),S=this._getSliders();this.setProperty("localeId",i,true);this._initMask();this._oDisplayFormat=null;this._sValueFormat=null;if(C){this.setValue(C);}if(S){S.setLocaleId(i);}return this;};
n.prototype._getDefaultDisplayStyle=function(){return o.Medium;};
n.prototype._getDefaultValueStyle=function(){return o.Medium;};
n.prototype._getLocale=function(){var i=this.getLocaleId();return i?new L(i):sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();};
n.prototype._getFormatterInstance=function(F,i,u,C,v){var w=this._getLocale();if(i===o.Short||i===o.Medium||i===o.Long){F=d.getTimeInstance({style:i,strictParsing:true,relative:u},w);}else{F=d.getTimeInstance({pattern:i,strictParsing:true,relative:u},w);}if(v){this._sUsedDisplayPattern=i;this._oDisplayFormat=F;}else{this._sUsedValuePattern=i;this._sValueFormat=F;}return F;};
n.prototype._getFormat=function(){var F=this._getDisplayFormatPattern();if(!F){F=o.Medium;}if(Object.keys(o).indexOf(F)!==-1){F=t();}return F;};
n.prototype.onsappageup=function(i){this._increaseTime(1,p.Hour);i.preventDefault();};
n.prototype.onsappageupmodifiers=function(i){if(!(i.ctrlKey||i.metaKey||i.altKey)&&i.shiftKey){this._increaseTime(1,p.Minute);}if(!i.altKey&&i.shiftKey&&(i.ctrlKey||i.metaKey)){this._increaseTime(1,p.Second);}i.preventDefault();};
n.prototype.onsappagedown=function(i){this._increaseTime(-1,p.Hour);i.preventDefault();};
n.prototype.onsappagedownmodifiers=function(i){if(!(i.ctrlKey||i.metaKey||i.altKey)&&i.shiftKey){this._increaseTime(-1,p.Minute);}if(!i.altKey&&i.shiftKey&&(i.ctrlKey||i.metaKey)){this._increaseTime(-1,p.Second);}i.preventDefault();};
n.prototype.onkeydown=function(i){var u=K,v=i.which||i.keyCode,A=i.altKey,w;if(v===u.F4||(A&&(v===u.ARROW_UP||v===u.ARROW_DOWN))){w=this._getPicker()&&this._getPicker().isOpen();if(!w){this._openPicker();}else{this._closePicker();}i.preventDefault();}else{b.onkeydown.call(this,i);}};
n.prototype._getPicker=function(){return this.getAggregation("_picker");};
n.prototype._removePickerEvents=function(){var i,u=this._getPicker();if(u){i=u.getAggregation("_popup");if(typeof this._oPopoverKeydownEventDelegate==='function'){i.removeEventDelegate(this._oPopoverKeydownEventDelegate);}}};
n.prototype._openPicker=function(){var i=this._getPicker(),S;if(!i){i=this._createPicker(this._getDisplayFormatPattern());}i.open();S=this._getSliders();setTimeout(S._updateSlidersValues.bind(S),0);return i;};
n.prototype._closePicker=function(){var i=this._getPicker();if(i){i.close();}else{g.warning("There is no picker to close.");}return i;};
n.prototype._createPicker=function(F){var i=this,u,v,w,O,C,x,y=this.getAggregation("_endIcon")[0],z=this._getLocale().getLanguage();w=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=w.getText("TIMEPICKER_SET");C=w.getText("TIMEPICKER_CANCEL");x=this.getTitle();v=new R(i.getId()+"-RP",{showCloseButton:false,showHeader:false,horizontalScrolling:false,verticalScrolling:false,placement:P.VerticalPreferedBottom,beginButton:new B({text:O,type:k.Emphasized,press:q.proxy(this._handleOkPress,this)}),endButton:new B({text:C,press:q.proxy(this._handleCancelPress,this)}),content:[new T(this.getId()+"-sliders",{support2400:this.getSupport2400(),displayFormat:F,valueFormat:this.getValueFormat(),labelText:x?x:"",localeId:z,minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep()})._setShouldOpenSliderAfterRendering(true)],contentHeight:n._PICKER_CONTENT_HEIGHT,ariaLabelledBy:h.getStaticId("sap.m","TIMEPICKER_SET_TIME")});u=v.getAggregation("_popup");if(u.setShowArrow){u.setShowArrow(false);}u.oPopup.setAutoCloseAreas([y]);v.addStyleClass(this.getRenderer().CSS_CLASS+"DropDown").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachAfterClose(this.onAfterClose,this);v.open=function(){return this.openBy(i);};if(c.system.desktop){this._oPopoverKeydownEventDelegate={onkeydown:function(A){var G=K,H=A.which||A.keyCode,J=A.altKey;if((J&&(H===G.ARROW_UP||H===G.ARROW_DOWN))||H===G.F4){this._handleOkPress(A);this.focus();A.preventDefault();}}};u.addEventDelegate(this._oPopoverKeydownEventDelegate,this);u._afterAdjustPositionAndArrowHook=function(){i._getSliders()._onOrientationChanged();};}this.setAggregation("_picker",v,true);return v;};
n.prototype._getSliders=function(){var i=this._getPicker();if(!i){return null;}return i.getContent()[0];};
n.prototype._handleOkPress=function(i){var u=this._getSliders().getTimeValues(),v=this._formatValue(u);if(this.getSupport2400()){v=this._getSliders().getValue();}this.updateDomValue(v);this._handleInputChange();this._closePicker();};
n.prototype._handleCancelPress=function(i){this._closePicker();};
n.prototype._getLocaleBasedPattern=function(i){return e.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(i);};
n.prototype._parseValue=function(v,i){if(i){v=this._oTimeSemanticMaskHelper.stripValueOfLeadingSpaces(v);v=v.replace(this._rPlaceholderRegEx,'');}return D.prototype._parseValue.call(this,v,i);};
n.prototype._formatValue=function(i,v){var V=D.prototype._formatValue.apply(this,arguments),F=this.getValueFormat(),u=F.indexOf("HH"),w=F.indexOf("H");if(i){if(!v&&this._oTimeSemanticMaskHelper){V=this._oTimeSemanticMaskHelper.formatValueWithLeadingTrailingSpaces(V);}}if(this.getSupport2400()&&T._isHoursValue24(this.getValue(),u,w)&&T._replaceZeroHoursWith24(V,u,w)===this.getValue()){V=this.getValue();}return V;};
n.prototype._handleAriaOnExpandCollapse=function(){this.getFocusDomRef().setAttribute("aria-expanded",this._getPicker().isOpen());};
n.prototype._increaseTime=function(N,u){var O=this.getDateValue(),i,v;if(O&&this.getEditable()&&this.getEnabled()){i=new Date(O.getTime());switch(u){case p.Hour:i.setHours(i.getHours()+N);v=60*60*1000;break;case p.Minute:i.setMinutes(i.getMinutes()+N);v=60*1000;break;case p.Second:v=1000;i.setSeconds(i.getSeconds()+N);}if(N<0&&i.getTime()-O.getTime()!==N*v){i=new Date(O.getTime()+N*v);}this.setDateValue(i);this.fireChangeEvent(this.getValue(),{valid:true});}};
n.prototype._initMask=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}this._oTimeSemanticMaskHelper=new s(this);};
n.prototype._isMaskEnabled=function(){return this.getMaskMode()===j.On;};
n.prototype._shouldSetInitialFocusedDateValue=function(){if(!this._isValidValue()){return true;}return!this.getValue()&&!!this.getInitialFocusedDateValue();};
n.prototype._isValidValue=function(){return this._bValid;};
n.prototype.fireChangeEvent=function(v,i){if(v){v=v.trim();}if(v!==this._sLastChangeValue){this._sLastChangeValue=v;I.prototype.fireChangeEvent.call(this,v,i);}};
var s=function(u){var v=u._getDisplayFormatPattern(),w,A,x=u._getLocale(),i;if(u._checkStyle(v)){w=e.getInstance(x).getTimePattern(v);}else{v=v.replace(/'/g,"");w=v;}this._oTimePicker=u;this.aOriginalAmPmValues=e.getInstance(x).getDayPeriods("abbreviated");this.aAmPmValues=this.aOriginalAmPmValues.slice(0);this.iAmPmValueMaxLength=Math.max(this.aAmPmValues[0].length,this.aAmPmValues[1].length);for(i=0;i<this.aAmPmValues.length;i++){while(this.aAmPmValues[i].length<this.iAmPmValueMaxLength){this.aAmPmValues[i]+=" ";}}this.b24H=v.indexOf("H")!==-1;this.bLeadingZero=v.indexOf("HH")!==-1||v.indexOf("hh")!==-1;this.sLeadingChar=this.bLeadingZero?"0":" ";this.sAlternativeLeadingChar=this.bLeadingZero?" ":"0";this.sLeadingRegexChar=this.bLeadingZero?"0":"\\s";u.setPlaceholderSymbol(r);w=w.replace(/hh/ig,"h").replace(/h/ig,"h9");if(this.b24H){A="["+this.sLeadingRegexChar+"012]";}else{A="["+this.sLeadingRegexChar+"1]";}this._maskRuleHours=new M({maskFormatSymbol:"h",regex:A});u.addRule(this._maskRuleHours);this.iHourNumber1Index=w.indexOf("h9");this.iHourNumber2Index=this.iHourNumber1Index!==-1?this.iHourNumber1Index+1:-1;this.iMinuteNumber1Index=w.indexOf("mm");w=w.replace(/mm/g,"59");this.iSecondNumber1Index=w.indexOf("ss");w=w.replace(/ss/g,"59");this._maskRuleMinSec=new M({maskFormatSymbol:"5",regex:"[0-5]"});u.addRule(this._maskRuleMinSec);this.aAllowedHours=J.call(this,this.b24H,this.sLeadingChar);this.aAllowedMinutesAndSeconds=N.call(this);this.iAmPmChar1Index=w.indexOf("a");this.iAfterAmPmValueIndex=-1;if(this.iAmPmChar1Index!==-1){this.iAfterAmPmValueIndex=this.iAmPmChar1Index+this.iAmPmValueMaxLength;var C=this.iAmPmValueMaxLength-"a".length;this.shiftIndexes(C);var y=65;var z="";var F="";var G="";for(i=0;i<this.iAmPmValueMaxLength;i++){F="[";if(this.aAmPmValues[0][i]){F+=this.aAmPmValues[0][i];}else{F+="\\s";}if(this.aAmPmValues[1][i]!==this.aAmPmValues[0][i]){if(this.aAmPmValues[1][i]){F+=this.aAmPmValues[1][i];}else{F+="\\s";}}F+="]";G=String.fromCharCode(y++);z+=G;this._maskRuleChars=new M({maskFormatSymbol:G,regex:F});u.addRule(this._maskRuleChars);}w=w.replace(/a/g,z);}u.setMask(w);function H(S,O,Q){var U=[],V,i;for(i=S;i<=O;i++){V=i.toString();if(i<10){V=Q+V;}U.push(V);}return U;}function J(O,Q){var S=O?0:1,U=this._oTimePicker.getSupport2400()?24:23,V=O?U:12;return H(S,V,Q);}function N(){return H(0,59,"0");}};
s.prototype.replaceChar=function(C,u,v){var A=u-this.iAmPmChar1Index,w,x,y,S,z,F,i;if(u===this.iHourNumber1Index&&this.sAlternativeLeadingChar===C){if(this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else{return this.sLeadingChar;}}else if(u===this.iHourNumber1Index&&!this._oTimePicker._isCharAllowed(C,u)&&this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else if(u===this.iHourNumber2Index&&this.aAllowedHours.indexOf(v[this.iHourNumber1Index]+C)===-1){return"";}else if((u===this.iMinuteNumber1Index||u===this.iSecondNumber1Index)&&!this._oTimePicker._isCharAllowed(C,u)&&this.aAllowedMinutesAndSeconds.indexOf("0"+C)!==-1){return"0"+C;}else if(A>=0&&u<this.iAfterAmPmValueIndex){w=v.slice(this.iAmPmChar1Index,u);x=this.aAmPmValues[0].slice(0,A);y=this.aAmPmValues[1].slice(0,A);z=this.aAmPmValues[0].slice(A,this.iAfterAmPmValueIndex);F=this.aAmPmValues[1].slice(A,this.iAfterAmPmValueIndex);S=(x===y);var G="";for(i=A;i<this.iAmPmValueMaxLength;i++){if(this.aAmPmValues[0][i]===this.aAmPmValues[1][i]){G+=this.aAmPmValues[0][i];}else{break;}}if(i===this.iAmPmValueMaxLength||i!==A){return G;}else{if(!S){if(w===x){return z;}else if(w===y){return F;}else{return C;}}else{if(this.aAmPmValues[0][A].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[0]===w+z){return z;}else if(this.aAmPmValues[1][A].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[1]===w+F){return F;}else{return C;}}}}else{return C;}};
s.prototype.formatValueWithLeadingTrailingSpaces=function(v){var i=this._oTimePicker.getMask().length;if(this.aOriginalAmPmValues[0]!==this.aAmPmValues[0]){v=v.replace(this.aOriginalAmPmValues[0],this.aAmPmValues[0]);}if(this.aOriginalAmPmValues[1]!==this.aAmPmValues[1]){v=v.replace(this.aOriginalAmPmValues[1],this.aAmPmValues[1]);}while(i>v.length){v=[v.slice(0,this.iHourNumber1Index)," ",v.slice(this.iHourNumber1Index)].join('');}return v;};
s.prototype.stripValueOfLeadingSpaces=function(v){if(v[this.iHourNumber1Index]===" "){v=[v.slice(0,this.iHourNumber1Index),v.slice(this.iHourNumber1Index+1)].join('');}return v;};
s.prototype.shiftIndexes=function(i){if(this.iAmPmChar1Index<this.iHourNumber1Index){this.iHourNumber1Index+=i;this.iHourNumber2Index+=i;}if(this.iAmPmChar1Index<this.iMinuteNumber1Index){this.iMinuteNumber1Index+=i;}if(this.iAmPmChar1Index<this.iSecondNumber1Index){this.iSecondNumber1Index+=i;}};
s.prototype.destroy=function(){if(this._maskRuleHours){this._maskRuleHours.destroy();this._maskRuleHours=null;}if(this._maskRuleMinSec){this._maskRuleMinSec.destroy();this._maskRuleMinSec=null;}if(this._maskRuleChars){this._maskRuleChars.destroy();this._maskRuleChars=null;}};
n.prototype._feedReplaceChar=function(C,i,u){return this._oTimeSemanticMaskHelper.replaceChar(C,i,u);};
n.prototype._getAlteredUserInputValue=function(v){return v?this._formatValue(this._parseValue(v),true):v;};
n.prototype.getAccessibilityInfo=function(){var i=this.getRenderer();var u=I.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var w=this.getDateValue();if(w){v=this._formatValue(w);}}q.extend(true,u,{role:i.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TIMEINPUT"),description:[v,i.getLabelledByAnnouncement(this),i.getDescribedByAnnouncement(this)].join(" ").trim(),autocomplete:"none",expanded:false,haspopup:true,owns:this.getId()+"-sliders"});return u;};
function t(){var i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),u=e.getInstance(i);return u.getTimePattern(o.Medium);}
n._PICKER_CONTENT_HEIGHT="25rem";return n;});
sap.ui.predefine('sap/m/TimePickerRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/core/library'],function(R,I,c){"use strict";var V=c.ValueState;var T=R.extend(I);T.apiVersion=2;T.CSS_CLASS="sapMTimePicker";
T.addOuterClasses=function(r,C){r.class(T.CSS_CLASS);};
T.writeDecorations=function(r,C){var o=C._oResourceBundle,t=o.getText("TIMEPICKER_SCREENREADER_TAG");r.openStart("span",C.getId()+"-descr");r.style("visibility","hidden");r.style("display","none");r.openEnd();r.text(t);r.close("span");};
T.writeInnerValue=function(r,C){r.attr("value",C._formatValue(C.getDateValue()));};
T.getAriaRole=function(){return"combobox";};
T.getLabelledByAnnouncement=function(C){return C._getPlaceholder()||"";};
T.getAccessibilityState=function(C){var a=this.getAriaLabelledBy(C),A=this.getAriaDescribedBy(C),m=C.getAccessibilityInfo();if(C.getValueState()===V.Error){m.invalid=true;}if(a){m.labelledby={value:a.trim(),append:true};}if(A){m.describedby={value:A.trim(),append:true};}return m;};
T.getAriaDescribedBy=function(C){var o=C.getId()+"-descr ";if(this.getDescribedByAnnouncement(C)){o+=C.getId()+"-describedby";}return o;};
return T;},true);
sap.ui.predefine('sap/m/TimePickerSlider',['sap/ui/core/Control','./TimePickerSliderRenderer','sap/ui/core/IconPool','sap/ui/Device',"sap/ui/events/KeyCodes","sap/m/Button","sap/ui/thirdparty/jquery"],function(C,T,I,D,K,B,q){"use strict";
var a=C.extend("sap.m.TimePickerSlider",{
metadata:{library:"sap.m",properties:{selectedValue:{type:"string",defaultValue:null},isCyclic:{type:"boolean",defaultValue:true},label:{type:"string",defaultValue:null},isExpanded:{type:"boolean",defaultValue:false}},aggregations:{items:{type:"sap.m.VisibleItem",multiple:true,singularName:"item"},_arrowUp:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowDown:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{expanded:{},collapsed:{}}},
renderer:T.render
});
var S=sap.ui.getCore().getConfiguration().getAnimation()?200:0;var M=50;var L=32;var A=32;
a.prototype.init=function(){this._bIsDrag=null;this._selectionOffset=0;this._mousedown=false;this._dragSession=null;this._iSelectedItemIndex=-1;this._animatingSnap=false;this._iSelectedIndex=-1;this._animating=false;this._intervalId=null;this._maxScrollTop=null;this._minScrollTop=null;this._marginTop=null;this._marginBottom=null;this._bOneTimeValueSelectionAnimation=false;this._bEnabled=true;if(D.system.desktop){this._fnHandleTypeValues=t.call(this);}this._initArrows();};
a.prototype.exit=function(){var s=this._getSliderContainerDomRef();if(s){s.stop();}if(this._intervalId){clearInterval(this._intervalId);this._intervalId=null;}};
a.prototype.onAfterRendering=function(){if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}this._attachEvents();};
a.prototype.onThemeChanged=function(e){this.invalidate();};
a.prototype.fireTap=function(e){var s,i,d;if(!this.getIsExpanded()){if(D.system.desktop){this.focus();}else{this.setIsExpanded(true);}}else{s=e.srcElement||e.originalTarget;if(s&&s.tagName.toLowerCase()==="li"){i=q(s).text();d=F.call(this,i);this._iClickedIndex=Array.prototype.slice.call(s.parentElement.children).indexOf(s);this._bOneTimeValueSelectionAnimation=true;this.setSelectedValue(d);this._fireSelectedValueChange(d);}else{this._addSelectionStyle();this.focus();}}};
a.prototype.setSelectedValue=function(v){var i=f(this._getVisibleItems(),function(E){return E.getKey()===v;}),d=this,e,s,g,h;if(i===-1){return this;}if(this.getDomRef()){s=this._getSliderContainerDomRef();g=this._getItemHeightInPx();h=this._getContentRepeat();if(i*g>=this._selectionOffset){e=this._getVisibleItems().length*Math.floor(h/2)+i;}else{e=this._getVisibleItems().length*Math.ceil(h/2)+i;}if(this._bOneTimeValueSelectionAnimation){s.scrollTop((e-this._iClickedIndex+this._iSelectedItemIndex)*g-this._selectionOffset);this._animatingSnap=true;s.animate({scrollTop:e*g-this._selectionOffset},S,'linear',function(){s.clearQueue();d._animatingSnap=false;d._bOneTimeValueSelectionAnimation=false;});}else{s.scrollTop(e*g-this._selectionOffset);}this._removeSelectionStyle();this._iSelectedItemIndex=e;this._addSelectionStyle();}return this.setProperty("selectedValue",v,true);};
a.prototype.setIsExpanded=function(v,s){this.setProperty("isExpanded",v,true);if(!this.getDomRef()){return this;}var $=this.$();if(v){$.addClass("sapMTPSliderExpanded");if(D.system.phone){setTimeout(function(){this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}.bind(this),0);}else{this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}}else{this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}$.removeClass("sapMTPSliderExpanded");this._updateMargins(v);if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}if(!s){this.fireCollapsed({ctrl:this});}}return this;};
a.prototype.onfocusin=function(e){if(D.system.desktop&&!this.getIsExpanded()){this.setIsExpanded(true);}};
a.prototype.onfocusout=function(e){var s=e.relatedTarget?e.relatedTarget.id:null,d=[this.getAggregation("_arrowUp").getId(),this.getAggregation("_arrowDown").getId()];if(s&&d.indexOf(s)!==-1){return;}if(D.system.desktop&&this.getIsExpanded()){this.setIsExpanded(false);}};
a.prototype._onmousewheel=function(e){var O,d,w;e.preventDefault();e.stopPropagation();if(!this.getIsExpanded()||this._intervalId){return false;}O=e.originalEvent;d=O.detail?(-O.detail>0):(O.wheelDelta>0);w=O.detail?(-O.detail/3):(O.wheelDelta/120);if(!w){return false;}this._handleWheelScroll(d,w);};
a.prototype._handleWheelScroll=function(d,w){var r=d?Math.ceil:Math.floor,R;if(!this._aWheelDeltas){this._aWheelDeltas=[];}this._aWheelDeltas.push(w);if(!this._bWheelScrolling){this._bWheelScrolling=true;this._intervalId=setInterval(function(){if(!this._aWheelDeltas.length){clearInterval(this._intervalId);this._intervalId=null;this._bWheelScrolling=false;}else{R=this._aWheelDeltas[0];this._aWheelDeltas=[];R=r(R);if(R){this._offsetSlider(R);}}}.bind(this),150);}return false;};
a.prototype.onsappageup=function(e){if(this.getIsExpanded()){var i=this._getVisibleItems()[0],v=i.getKey();this.setSelectedValue(v);this._fireSelectedValueChange(v);}};
a.prototype.onsappagedown=function(e){if(this.getIsExpanded()){var l=this._getVisibleItems()[this._getVisibleItems().length-1],v=l.getKey();this.setSelectedValue(v);this._fireSelectedValueChange(v);}};
a.prototype.onsapup=function(e){if(this.getIsExpanded()){this._offsetValue(-1);}};
a.prototype.onsapdown=function(e){if(this.getIsExpanded()){this._offsetValue(1);}};
a.prototype.onkeydown=function(e){var k=e.which||e.keyCode,d=K;if(k>=d.NUMPAD_0&&k<=d.NUMPAD_9){k=this._convertNumPadToNumKeyCode(k);}if((k>=d.A&&k<=d.Z)||(k>=d.DIGIT_0&&k<=d.DIGIT_9)){this._fnHandleTypeValues(e.timeStamp,k);}};
a.prototype._getSliderContainerDomRef=function(){return this.$().find(".sapMTimePickerSlider");};
a.prototype._getContentRepeat=function(){var i;if(this.getIsCyclic()){i=Math.ceil(M/this._getVisibleItems().length);i=Math.max(i,3);}else{i=1;}return i;};
a.prototype._getItemHeightInPx=function(){return this.$("content").find("li:not(.TPSliderItemHidden)")[0].getBoundingClientRect().height;};
a.prototype._updateSelectionFrameLayout=function(){var $,i,d,e,s=this.$().offset(),g=s?s.top:0,h=this.$().parents(".sapMTimePickerContainer").offset(),j=h?h.top:0;if(this.getDomRef()){e=this._getItemHeightInPx();$=this.$().find(".sapMTPPickerSelectionFrame");d=g-j;i=(this.$().height()-e+L)/2+d;$.css("top",i);if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}}};
a.prototype._updateStepAndValue=function(n,s){var v=0,$,i;for(i=0;i<this.getItems().length;i++){if(i%s!==0&&i!==n){this.getItems()[i].setVisible(false);}else{this.getItems()[i].setVisible(true);v++;}}if(v>2&&v<13&&this.getDomRef()){$=this.$().find(".sapMTimePickerSlider");$.className="";q($).addClass("sapMTimePickerSlider SliderValues"+v.toString());}this.setIsCyclic(v>2);this.setSelectedValue(n.toString());};
a.prototype._updateMargins=function(i){var d=this._getItemHeightInPx(),$,v,V,e,g,h,m,j;if(this.getDomRef()){d=this._getItemHeightInPx();$=this.$().find(".SliderValues3,.SliderValues4,.SliderValues5,.SliderValues6,.SliderValues7,.SliderValues8,.SliderValues9,.SliderValues10,.SliderValues11,.SliderValues12");if(!$.length){return;}if(i){v=this._getVisibleItems().length;V=d*Math.floor(v/2);e=d*Math.ceil(v/2);h=this.$().parents().hasClass('sapUiSizeCompact')?A:0;g=(this.$().height()-d+L)/2;m=g-V-L-h;j=this.$().height()-g-e-h;m=Math.max(m,0);j=Math.max(j,0);}else{m=0;j=0;}$.css("margin-top",m);$.css("margin-bottom",j);}};
a.prototype._updateDynamicLayout=function(i){this._updateMargins(i);this._updateSelectionFrameLayout();};
a.prototype._getSelectionFrameTopOffset=function(){var $=this._getSliderContainerDomRef().find(".sapMTPPickerSelectionFrame"),d=$.offset();return d.top;};
a.prototype._animateScroll=function(s){var $=this._getSliderContainerDomRef(),p=$.scrollTop(),d=25,e=$.height(),g=this.$("content").height(),i=200,h=e+i,j=this._getContentRepeat(),k=this.getIsCyclic(),l=0.9,m=0.05,n=this;this._intervalId=setInterval(function(){n._animating=true;p=p-s*d;if(k){p=n._getUpdatedCycleScrollTop(e,g,p,h,j);}else{if(p>n._maxScrollTop){p=n._maxScrollTop;s=0;}if(p<n._minScrollTop){p=n._minScrollTop;s=0;}}$.scrollTop(p);s*=l;if(Math.abs(s)<m){var r=n._getItemHeightInPx();var O=n._selectionOffset?(n._selectionOffset%r):0;var u=Math.round((p+O)/r)*r-O;clearInterval(n._intervalId);n._intervalId=null;n._animating=null;n._iSelectedIndex=Math.round((p+n._selectionOffset)/r);n._animatingSnap=true;$.animate({scrollTop:u},S,'linear',function(){$.clearQueue();n._animatingSnap=false;if($.css("visibility")==="visible"){n._scrollerSnapped(n._iSelectedIndex);}});}},d);};
a.prototype._stopAnimation=function(){if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}};
a.prototype._startDrag=function(p){if(!this._dragSession){this._dragSession={};this._dragSession.positions=[];}this._dragSession.pageY=p;this._dragSession.startTop=this._getSliderContainerDomRef().scrollTop();};
a.prototype._doDrag=function(p,d){if(this._dragSession){this._dragSession.offsetY=p-this._dragSession.pageY;this._dragSession.positions.push({pageY:p,timeStamp:d});if(this._dragSession.positions.length>20){this._dragSession.positions.splice(0,10);}if(this._bIsDrag){this._getSliderContainerDomRef().scrollTop(this._dragSession.startTop-this._dragSession.offsetY);}}};
a.prototype._endDrag=function(p,d){if(this._dragSession){var O,e;for(var i=this._dragSession.positions.length-1;i>=0;i--){O=d-this._dragSession.positions[i].timeStamp;e=p-this._dragSession.positions[i].pageY;if(O>100){break;}}var s=(e/O);if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}this._dragSession=null;this._animateScroll(s);}};
a.prototype._afterExpandCollapse=function(){var s=this.getSelectedValue(),d=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset(),i,l,g,h;this._selectionOffset=d-e.top;if(!this.getIsCyclic()){l=this.$("content");h=this._getItemHeightInPx();g=this.$().height();if(this.getIsExpanded()){this._minScrollTop=0;this._marginTop=d-e.top;this._maxScrollTop=h*(this._getVisibleItems().length-1);i=$.height();this._marginBottom=i-this._marginTop-h;if(this._marginBottom<0){this._marginBottom=g-this._marginTop-h;}l.css("margin-top",this._marginTop);l.css("margin-bottom",this._marginBottom);}else{this._marginBottom=g-h;l.css("margin-top",0);l.css("margin-bottom",this._marginBottom);}this._selectionOffset=0;}if(!this.getIsExpanded()){this._selectionOffset=0;}this.$().attr('aria-expanded',this.getIsExpanded());this.setSelectedValue(s);};
a.prototype._getUpdatedCycleScrollTop=function(i,d,e,g,h){var j=d-e-i;while(j<g){e=e-d/h;j=d-e-i;}while(e<g){e=e+d/h;}return e;};
a.prototype._scrollerSnapped=function(i){var s=i,d=this._getVisibleItems().length,n;while(s>=d){s=s-d;}if(!this.getIsCyclic()){s=i;}n=this._getVisibleItems()[s].getKey();this.setSelectedValue(n);this._fireSelectedValueChange(n);};
a.prototype._updateScroll=function(){var s=this.getSelectedValue();if(s!==this._getVisibleItems()[0].getKey()&&this._getSliderContainerDomRef().scrollTop()+(this._selectionOffset?this._selectionOffset:0)===0){this.setSelectedValue(s);this._fireSelectedValueChange(s);}};
a.prototype._addSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)"),s=$.eq(this._iSelectedItemIndex).text(),d,e;if(!s){return;}e=s;if(e&&e.length>1&&e.indexOf('0')===0){e=e.substring(1);}$.eq(this._iSelectedItemIndex).addClass("sapMTimePickerItemSelected");d=document.getElementById(this.getId()+"-valDescription");if(d.innerHTML!==e){d.innerHTML=e;}};
a.prototype._removeSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)");$.eq(this._iSelectedItemIndex).removeClass("sapMTimePickerItemSelected");};
a.prototype._attachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(b,this),false);document.addEventListener("touchend",q.proxy(c,this),false);e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(b,this),false);document.addEventListener("mouseup",q.proxy(c,this),false);}else{if(D.system.phone||D.system.tablet){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(b,this),false);document.addEventListener("touchend",q.proxy(c,this),false);}else{e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(b,this),false);document.addEventListener("mouseup",q.proxy(c,this),false);}}};
a.prototype._detachEvents=function(){var e=this.getDomRef();if(D.system.combi){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(b,this),false);document.removeEventListener("touchend",q.proxy(c,this),false);e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(b,this),false);document.removeEventListener("mouseup",q.proxy(c,this),false);}else{if(D.system.phone||D.system.tablet){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(b,this),false);document.removeEventListener("touchend",q.proxy(c,this),false);}else{e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(b,this),false);document.removeEventListener("mouseup",q.proxy(c,this),false);}}};
a.prototype._offsetValue=function(i){var s=this._getSliderContainerDomRef(),d,e=this._getItemHeightInPx(),g,h,j=this.getIsCyclic(),k=this;this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}h=this._iSelectedItemIndex+i;d=s.scrollTop();g=d+i*e;if(!j){if(h<0||h>=this._getVisibleItems().length){return;}if(g>this._maxScrollTop){g=this._maxScrollTop;}if(g<this._minScrollTop){g=this._minScrollTop;}}this._animatingSnap=true;this._animatingTargetIndex=h;s.animate({scrollTop:g},S,'linear',function(){s.clearQueue();k._animatingSnap=false;k._animatingTargetIndex=null;if(s.css("visibility")==="visible"){k._scrollerSnapped(h);}});};
a.prototype._offsetSlider=function(O){var s=this._getSliderContainerDomRef().scrollTop(),d=this,$=d._getSliderContainerDomRef().height(),e=d.$("content").height(),i=200,g=$+i,h=d._getContentRepeat(),j=d.getIsCyclic(),k=d._getItemHeightInPx();s=s-O*k;if(j){s=d._getUpdatedCycleScrollTop($,e,s,g,h);}else{if(s>d._maxScrollTop){s=d._maxScrollTop;}if(s<d._minScrollTop){s=d._minScrollTop;}}d._getSliderContainerDomRef().scrollTop(s);d._iSelectedIndex=Math.round((s+d._selectionOffset)/k);d._scrollerSnapped(d._iSelectedIndex);};
a.prototype._initArrows=function(){var d=this,e,g;e=new B({icon:I.getIconURI("slim-arrow-up"),press:function(E){d._offsetValue(-1);},type:'Transparent'});e.addEventDelegate({onAfterRendering:function(){e.$().attr("tabindex",-1);}});this.setAggregation("_arrowUp",e);g=new B({icon:I.getIconURI("slim-arrow-down"),press:function(E){d._offsetValue(1);},type:'Transparent'});g.addStyleClass("sapMTimePickerItemArrowDown");g.addEventDelegate({onAfterRendering:function(){g.$().attr("tabindex",-1);}});this.setAggregation("_arrowDown",g);};
a.prototype._convertNumPadToNumKeyCode=function(k){var d=K;if(k>=d.NUMPAD_0&&k<=d.NUMPAD_9){k-=48;}return k;};
function f(d,p){if(d==null){throw new TypeError('findIndex called with null or undefined array');}if(typeof p!=='function'){throw new TypeError('predicate must be a function');}var l=d.length;var e=arguments[1];var v;for(var i=0;i<l;i++){v=d[i];if(p.call(e,v,i,d)){return i;}}return-1;}
var o=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;this._bIsDrag=false;if(!this.getIsExpanded()){return;}this._stopAnimation();this._startDrag(p);if(!D.system.desktop){e.preventDefault();}this._mousedown=true;};var b=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;if(!this._mousedown||!this.getIsExpanded()){return;}if(!this._bIsDrag&&this._dragSession&&this._dragSession.positions.length){var d=this._dragSession.positions.some(function(g){return Math.abs(g.pageY-p)>5;});if(d){this._bIsDrag=true;}}this._doDrag(p,e.timeStamp);this._mousedown=true;};var c=function(e){var p=e.changedTouches&&e.changedTouches.length?e.changedTouches[0].pageY:e.pageY;if(this._bIsDrag===false){this.fireTap(e);this._dragSession=null;}this._bIsDrag=true;if(!this.getIsExpanded()){this._dragSession=null;return;}this._endDrag(p,e.timeStamp);this._mousedown=false;};var F=function(s){var i=this._getVisibleItems();var d=f(i,function(e){return e.getText()===s;});return i[d].getKey();};var t=function(){var l=-1,i=-1,w=1000,s="",d=function(e,k){var m;if(l+w<e){s="";}else{if(i!==-1){clearTimeout(i);i=-1;}}s+=String.fromCharCode(k).toLowerCase();m=this._getVisibleItems().filter(function(g){return g.getKey().indexOf(s)===0;});if(m.length>1){i=setTimeout(function(){this.setSelectedValue(s);s="";i=-1;}.bind(this),w);}else if(m.length===1){this.setSelectedValue(m[0].getKey());s="";}else{s="";}l=e;};return d;};
a.prototype._getVisibleItems=function(){return this.getItems().filter(function(i){return i.getVisible();});};
a.prototype._setEnabled=function(e){this._bEnabled=e;if(e){this.$().removeClass("sapMTPDisabled");this.$().attr("tabindex",0);}else{this.$().addClass("sapMTPDisabled");this.$().attr("tabindex",-1);}return this;};
a.prototype._getEnabled=function(e){return this._bEnabled;};
a.prototype._fireSelectedValueChange=function(v){this.fireEvent("_selectedValueChange",{value:v});};
return a;});
sap.ui.predefine('sap/m/TimePickerSliderRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){var i,R,n=c._getContentRepeat(),I=c.getItems(),C=c.getLabel();r.openStart("div",c);r.attr("tabindex","0");r.class("sapMTPColumn");if(c.getIsExpanded()){r.class("sapMTPSliderExpanded");}if(!c.getIsCyclic()){r.class("sapMTimePickerSliderShort");}if(!c._getEnabled()){r.class("sapMTPDisabled");}r.accessibilityState(c,{role:"list",labelledby:{value:c.getId()+"-label",append:true},describedby:{value:c.getId()+"-valDescription",append:true}});r.openEnd();r.openStart("div",c.getId()+"-label");r.class("sapMTimePickerLabel");r.openEnd();r.text(C);r.close("div");r.openStart("div",c.getId()+"-valDescription");r.attr('aria-hidden','false');r.attr('aria-live','assertive');r.class("sapUiInvisibleText");r.openEnd();r.close("div");r.openStart("div");r.class("sapMTimePickerItemArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowUp"));r.close("div");r.openStart("div");r.class("sapMTimePickerSlider");T.addItemValuesCssClass(r,c);r.attr("unselectable","on");r.openEnd();r.openStart("div");r.class("sapMTPPickerSelectionFrame");r.openEnd();r.close("div");r.openStart("ul",c.getId()+"-content");r.attr("unselectable","on");r.openEnd();for(R=1;R<=n;R++){for(i=0;i<I.length;i++){r.openStart("li");r.class("sapMTimePickerItem");if(!I[i].getVisible()){r.class("TPSliderItemHidden");}r.accessibilityState(c);r.attr("unselectable","on");r.openEnd();r.text(I[i].getText());r.close("li");}}r.close("ul");r.close("div");r.openStart("div");r.class("sapMTimePickerItemArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowDown"));r.close("div");r.close("div");};
T.addItemValuesCssClass=function(r,c){var v=c.getItems().filter(function(i){return i.getVisible();}).length;if(v>2&&v<13){r.class("SliderValues"+v.toString());}};
return T;},false);
sap.ui.predefine('sap/m/TimePickerSliders',['sap/ui/core/library','sap/ui/core/Control','sap/ui/model/type/Date','sap/ui/model/odata/type/ODataType','sap/ui/core/format/DateFormat','./TimePickerSlidersRenderer','./TimePickerSlider','./VisibleItem','sap/ui/core/LocaleData','sap/ui/Device','sap/ui/core/Locale','./TimePickerSlidersRenderer',"sap/ui/thirdparty/jquery"],function(c,C,S,O,D,a,T,V,L,b,d,e,q){"use strict";var f=1,g=c.CalendarType;
var h=C.extend("sap.m.TimePickerSliders",{metadata:{library:"sap.m",properties:{localeId:{type:"string",group:"Data"},displayFormat:{name:"displayFormat",type:"string",group:"Appearance"},labelText:{name:"labelText",type:"string"},minutesStep:{type:"int",group:"Misc",defaultValue:f},secondsStep:{type:"int",group:"Misc",defaultValue:f},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"},value:{type:"string",group:"Data",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},support2400:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_columns:{type:"sap.m.TimePickerSlider",multiple:true,visibility:"hidden"}},events:{change:{parameters:{value:{type:"string"}}}}}});
h.prototype.init=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),p=o.getDayPeriods("abbreviated"),i=o.getTimePattern("medium");this._fnLayoutChanged=q.proxy(this._onOrientationChanged,this);b.resize.attachHandler(this._fnLayoutChanged);this._sAM=p[0];this._sPM=p[1];this._onSliderExpanded=this._onSliderExpanded.bind(this);this._onSliderCollapsed=this._onSliderCollapsed.bind(this);this.setDisplayFormat(i);this._setTimeValues();this._iMinutes;this._iSeconds;};
h.prototype.exit=function(){this.$().off(!!b.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);b.resize.detachHandler(this._fnOrientationChanged);};
h.prototype.onAfterRendering=function(){this.$().off(!!b.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this.$().on(!!b.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this._onmousewheel,this));this.$().on('selectstart',F);if(this._getShouldOpenSliderAfterRendering()){if(b.system.desktop){this._getFirstSlider().setIsExpanded(true);}}};
h.prototype.setLocaleId=function(l){var o,p;l=this.validateProperty("localeId",l);this.setProperty("localeId",l,true);if(l){o=new d(l);p=L.getInstance(o).getDayPeriods("abbreviated");this._sAM=p[0];this._sPM=p[1];this._destroyColumns();this._setupLists();}return this;};
h.prototype.setSupport2400=function(i){this.setProperty("support2400",i,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setDisplayFormat=function(i){this.setProperty("displayFormat",i,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setMinutesStep=function(v){v=Math.max(f,v||f);this.setProperty("minutesStep",v,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setSecondsStep=function(v){v=Math.max(f,v||f);this.setProperty("secondsStep",v,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setValue=function(v){var H=this._getHoursSlider(),i=this._getValueFormatPattern(),I=i.indexOf("HH"),j=i.indexOf("H"),k=H&&H.getSelectedValue()==="24",l=h._isHoursValue24(v,I,j);if(k&&this._isFormatSupport24()&&!l){v=h._replaceZeroHoursWith24(v,I,j);}v=this.validateProperty("value",v);this.setProperty("value",v,true);var o;if(v){o=this._parseValue(l?h._replace24HoursWithZero(v,I,j):v);}if(o){this._setTimeValues(o,l);}return this;};
h.prototype.getTimeValues=function(){var H=this._getHoursSlider(),m=this._getMinutesSlider(),o=this._getSecondsSlider(),i=this._getFormatSlider(),j=null,A=null,k=new Date();if(H){j=parseInt(H.getSelectedValue());}if(i){A=i.getSelectedValue();}if(A==="am"&&j===12){j=0;}else if(A==="pm"&&j!==12){j+=12;}if(j!==null){k.setHours(j.toString());}if(m){k.setMinutes(m.getSelectedValue());}if(o){k.setSeconds(o.getSelectedValue());}return k;};
h.prototype.collapseAll=function(){var i=this.getAggregation("_columns");if(i){for(var I=0;I<i.length;I++){if(i[I].getIsExpanded()){i[I].setIsExpanded(false);}}}return this;};
h.prototype.openFirstSlider=function(){var o=this._getFirstSlider();o.setIsExpanded(true);o.focus();return this;};
h.prototype._setTimeValues=function(o,H){var i=this._getHoursSlider(),m=this._getMinutesSlider(),j=this._getSecondsSlider(),k=this._getFormatSlider(),l,A=null;o=o||new Date();if(o&&q.type(o)!=="date"){throw new Error("Date must be a JavaScript date object; "+this);}if(!H){var v=this._formatValue(o,true);this.setProperty("value",v,true);l=o.getHours();}else{l=24;}if(k){A=l>=12?"pm":"am";l=(l>12)?l-12:l;l=(l===0?12:l);}i&&i.setSelectedValue(l.toString());m&&m._updateStepAndValue(o.getMinutes(),this.getMinutesStep());j&&j._updateStepAndValue(o.getSeconds(),this.getSecondsStep());k&&k.setSelectedValue(A);if(H){this._disableSlider(m);m&&m.setSelectedValue("0");this._disableSlider(j);j&&j.setSelectedValue("0");}else{this._enableSlider(m);this._enableSlider(j);}};
h.prototype._updateSlidersValues=function(){var i=this.getAggregation("_columns");if(i){for(var I=0;I<i.length;I++){i[I]._updateScroll();}}};
h.prototype.onsaphome=function(E){var n=this._getFirstSlider(),o=this._getCurrentSlider();if(o&&document.activeElement===o.getDomRef()&&this._isSliderEnabled(n)){n.focus();}};
h.prototype.onsapend=function(E){var n=this._getLastSlider(),o=this._getCurrentSlider();if(o&&document.activeElement===o.getDomRef()&&this._isSliderEnabled(n)){n.focus();}};
h.prototype.onsapleft=function(E){var n,o=this._getCurrentSlider(),i=-1,N=-1,j=this.getAggregation("_columns");if(o&&document.activeElement===o.getDomRef()){i=j.indexOf(o);N=i>0?i-1:j.length-1;n=j[N];if(this._isSliderEnabled(n)){n.focus();}}};
h.prototype.onsapright=function(E){var n,o=this._getCurrentSlider(),i=-1,N=-1,j=this.getAggregation("_columns");if(o&&document.activeElement===o.getDomRef()){i=j.indexOf(o);N=i<j.length-1?i+1:0;n=j[N];if(this._isSliderEnabled(n)){n.focus();}}};
h.prototype._onmousewheel=function(E){var i=this._getCurrentSlider();if(i){i._onmousewheel(E);}};
h.prototype._onOrientationChanged=function(){var j=this.getAggregation("_columns");if(!j){return;}for(var i=0;i<j.length;i++){if(j[i].getIsExpanded()){j[i]._updateSelectionFrameLayout();}}};
h.prototype._generatePickerListValues=function(i,t,j,l){var v=[],k;for(var I=i;I<=t;I+=1){if(I<10&&l){k="0"+I.toString();}else{k=I.toString();}var o=new V({key:I.toString(),text:k});if(I%j!==0){o.setVisible(false);}v.push(o);}return v;};
h.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
h.prototype._getDisplayFormatPattern=function(){var p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
h.prototype._getValueFormatPattern=function(){var p=this._getBoundValueTypePattern()||this.getValueFormat()||"medium";if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
h.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(p);};
h.prototype._destroyColumns=function(){var i=this.getAggregation("_columns");if(i){this.destroyAggregation("_columns");}};
h.prototype._setupLists=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),l=r.getText("TIMEPICKER_LBL_HOURS"),i=r.getText("TIMEPICKER_LBL_MINUTES"),j=r.getText("TIMEPICKER_LBL_SECONDS"),k=r.getText("TIMEPICKER_LBL_AMPM"),m=this.getMinutesStep(),n=this.getSecondsStep(),o=this._getDisplayFormatPattern();if(o===undefined){return;}var H=false,p=false,t,u;if(o.indexOf("HH")!==-1){H=true;t=0;u=this.getSupport2400()?24:23;p=true;}else if(o.indexOf("H")!==-1){H=true;t=0;u=this.getSupport2400()?24:23;}else if(o.indexOf("hh")!==-1){H=true;t=1;u=12;p=true;}else if(o.indexOf("h")!==-1){H=true;t=1;u=12;}if(H){this.addAggregation("_columns",new T(this.getId()+"-listHours",{items:this._generatePickerListValues(t,u,1,p),expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:l}).attachEvent("_selectedValueChange",this._handleHoursChange,this));}if(o.indexOf("m")!==-1){var v=this._generatePickerListValues(0,59,m,true);this.addAggregation("_columns",new T(this.getId()+"-listMins",{items:v,expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:i}));}if(o.indexOf("s")!==-1){var v=this._generatePickerListValues(0,59,n,true);this.addAggregation("_columns",new T(this.getId()+"-listSecs",{items:v,expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:j}));}if(o.indexOf("a")!==-1){this.addAggregation("_columns",new T(this.getId()+"-listFormat",{items:[{key:"am",text:this._sAM},{key:"pm",text:this._sPM}],expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:k,isCyclic:false}).addStyleClass("sapMTimePickerSliderShort"));}var w,x=this.getValue();if(x){w=this._parseValue(x);}if(w){this._setTimeValues(w);}};
h.prototype._getCurrentSlider=function(){var j=this.getAggregation("_columns");if(j){for(var i=0;i<j.length;i++){if(j[i].getIsExpanded()){return j[i];}}}return null;};
h.prototype._getHoursSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listHours")||null;};
h.prototype._getMinutesSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listMins")||null;};
h.prototype._getSecondsSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listSecs")||null;};
h.prototype._getFormatSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listFormat")||null;};
h.prototype._getFirstSlider=function(){return this.getAggregation("_columns")[0]||null;};
h.prototype._getLastSlider=function(){var i=this.getAggregation("_columns");return i[i.length-1]||null;};
h.prototype._parseValue=function(v){return this._getFormatter().parse(v);};
h.prototype._isSliderEnabled=function(o){return o._getEnabled();};
h.prototype._getFormatter=function(){var p=this._getBoundValueTypePattern(),r=false,B=this.getBinding("value"),i;if(B&&B.oType&&B.oType.oOutputFormat){r=!!B.oType.oOutputFormat.oFormatOptions.relative;i=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){p=this.getValueFormat()||"medium";i=g.Gregorian;}if(!i){i=sap.ui.getCore().getConfiguration().getCalendarType();}return this._getFormatterInstance(p,r,i);};
h.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),o=B&&B.getType&&B.getType();if(o instanceof S){return o.getOutputPattern();}if(o instanceof O&&o.oFormat){return o.oFormat.oFormatOptions.pattern;}return undefined;};
h.prototype._getFormatterInstance=function(p,r,i,j){var o;if(this._checkStyle(p)){o=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:i});}else{o=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:i});}return o;};
h.prototype._getFormatInstance=function(A,i){return D.getTimeInstance(A);};
h.prototype._formatValue=function(o){if(o){return this._getFormatter().format(o);}return"";};
h.prototype._onSliderExpanded=function(E){var j=this.getAggregation("_columns");for(var i=0;i<j.length;i++){if(j[i]!==E.oSource&&j[i].getIsExpanded()){j[i].setIsExpanded(false);}}};
h.prototype._onSliderCollapsed=function(E){var o=this.getTimeValues();this.setValue(this._formatValue(o,true));this.fireChange({value:this.getValue()});};
h.prototype._getShouldOpenSliderAfterRendering=function(){return this._shouldOpenSliderAfterRendering;};
h.prototype._setShouldOpenSliderAfterRendering=function(i){this._shouldOpenSliderAfterRendering=i;return this;};
h.prototype._isFormatSupport24=function(){var i=this._getDisplayFormatPattern();return i.indexOf("HH")!==-1||i.indexOf("H")!==-1;};
h.prototype._disableSlider=function(o){if(o){o._setEnabled(false);}return this;};
h.prototype._enableSlider=function(o){if(o){o._setEnabled(true);}return this;};
h.prototype._handleHoursChange=function(E){var v=E.getParameter("value"),m=this._getMinutesSlider(),o=this._getSecondsSlider();if(this.getSupport2400()){if(v==="24"){if(m&&m._getEnabled()){this._iMinutes=m.getSelectedValue();this._disableSlider(m);m.setSelectedValue("0");}if(o&&o._getEnabled()){this._iSeconds=o.getSelectedValue();this._disableSlider(o);o.setSelectedValue("0");}}else{if(m&&!m._getEnabled()){this._enableSlider(m);m.setSelectedValue(this._iMinutes);}if(o&&!o._getEnabled()){this._enableSlider(o);o.setSelectedValue(this._iSeconds);}}}};
h._replaceZeroHoursWith24=function(v,i,I){var H=2,j=i;if(i===-1){H=1;j=I;}return v.substr(0,j)+"24"+v.substr(j+H);};
h._replace24HoursWithZero=function(v,i,I){var H=2,j=i;if(i===-1){H=1;j=I;}return v.substr(0,j)+s(0,H)+v.substr(j+2);};
h._isHoursValue24=function(v,i,I){if(i===-1&&I===-1){return false;}var j=i;if(i===-1){j=I;}return v.substr(j,2)==="24";};
function s(j,k){var r="";for(var i=0;i<k;i++){r+=j;}return r;}
function F(){return false;}
return h;});
sap.ui.predefine('sap/m/TimePickerSlidersRenderer',["sap/ui/Device"],function(D){"use strict";var T={apiVersion:2};
T.render=function(r,c){var s=c.getAggregation("_columns"),l=c.getLabelText()||"",R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),S,b=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",c);r.class("sapMTimePickerContainer");r.style("width",c.getWidth());r.style("height",c.getHeight());r.accessibilityState(c,{label:(l+" "+R.getText("TIMEPICKER_SCREENREADER_TAG")).trim()});r.openEnd();if(!D.system.desktop){r.openStart("div",c.getId()+"-label");r.class("sapMTimePickerContainerLabel");r.openEnd();r.style("display","block");r.text(l);r.close("div");}if(b){for(S=s.length-1;S>=0;S--){r.renderControl(s[S]);}}else{for(S=0;S<s.length;S++){r.renderControl(s[S]);}}r.close("div");};
return T;},true);
sap.ui.predefine('sap/m/Title',['sap/ui/core/Control','./library','sap/ui/core/library','./TitleRenderer',"sap/m/HyphenationSupport"],function(C,l,c,T,H){"use strict";var a=c.TextAlign;var b=c.TitleLevel;var W=l.WrappingType;
var d=C.extend("sap.m.Title",{metadata:{library:"sap.m",interfaces:["sap.ui.core.IShrinkable","sap.m.IHyphenation"],properties:{text:{type:"string",group:"Appearance",defaultValue:null},level:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:b.Auto},titleStyle:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:b.Auto},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:a.Initial},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal}},associations:{title:{type:"sap.ui.core.Title",multiple:false}},designtime:"sap/m/designtime/Title.designtime"}});
d.prototype._getTitle=function(){var t=this.getTitle();if(t){var o=sap.ui.getCore().byId(t);if(o&&o instanceof sap.ui.core.Title){return o;}}return null;};
d.prototype._onTitleChanged=function(){this.invalidate();};
d.prototype.setTitle=function(t){var e=this;var o=this._getTitle();if(o){o.invalidate=o.__sapui5_title_originvalidate;o.exit=o.__sapui5_title_origexit;delete o.__sapui5_title_origexit;delete o.__sapui5_title_originvalidate;}this.setAssociation("title",t);var n=this._getTitle();if(n){n.__sapui5_title_originvalidate=n.invalidate;n.__sapui5_title_origexit=n.exit;n.exit=function(){e._onTitleChanged();if(this.__sapui5_title_origexit){this.__sapui5_title_origexit.apply(this,arguments);}};n.invalidate=function(){e._onTitleChanged();this.__sapui5_title_originvalidate.apply(this,arguments);};}return this;};
d.prototype.getAccessibilityInfo=function(){var t=this._getTitle()||this;return{role:"heading",description:t.getText(),focusable:false};};
d.prototype.getTextsToBeHyphenated=function(){var t=this._getTitle();return{"main":t?t.getText():this.getText()};};
d.prototype.getDomRefsForHyphenatedTexts=function(){var D;if(!this._getTitle()){D={"main":this.getDomRef("inner")};}return D;};
H.mixInto(d.prototype);return d;});
sap.ui.predefine('sap/m/TitleAlignmentMixin',['sap/ui/core/theming/Parameters','sap/m/library'],function(P,l){"use strict";var T={};var a=l.TitleAlignment;var _=function(B,k){if(!this._oTitleAlignmentBarInstances){this._oTitleAlignmentBarInstances={};}this._oTitleAlignmentBarInstances[k]=B;this._determineTitleAlignment(B);};var b=function(){this._determineTitleAlignment();};var c=function(){this._titleAlignmentThemeChangedDelegate={onThemeChanged:this._titleAlignmentThemeChangedHandler};this.addEventDelegate(this._titleAlignmentThemeChangedDelegate,this);};var d=function(){this.removeEventDelegate(this._titleAlignmentThemeChangedDelegate);};var e=function(B){var t=P.get("sapMTitleAlignment");var C=this.getTitleAlignment();if(C===a.Auto){C=t===undefined?a.Center:t;}if(!B){if(this._oTitleAlignmentBarInstances){for(var k in this._oTitleAlignmentBarInstances){f(this._oTitleAlignmentBarInstances[k]);}}}else{f(B);}function f(B){B.removeStyleClass("sapMBarTitleStart");if(C===a.Start){B.addStyleClass("sapMBarTitleStart");}}};var s=function(A){this.setProperty("titleAlignment",A,true);this._determineTitleAlignment();if(this._oTitleAlignmentBarInstances){for(var k in this._oTitleAlignmentBarInstances){this._oTitleAlignmentBarInstances[k].invalidate();}}return this;};
T.mixInto=function(C){C._setupBarTitleAlignment=_;C._titleAlignmentThemeChangedHandler=b;C._attachTitleAlignmentEventDelegate=c;C._detachTitleAlignmentEventDelegate=d;C._determineTitleAlignment=e;C.setTitleAlignment=s;var i=C.init;C.init=function(I){if(!this._oTitleAlignmentBarInstances){this._oTitleAlignmentBarInstances={};}var r=i.apply(this,arguments);this._attachTitleAlignmentEventDelegate();return r;};var E=C.exit;C.exit=function(I){var r=E.apply(this,arguments);this._detachTitleAlignmentEventDelegate();delete this._oTitleAlignmentBarInstances;return r;};};
return T;});
sap.ui.predefine('sap/m/TitlePropagationSupport',[],function(){"use strict";return function(a,g){if(!this.isA("sap.ui.core.Element")){return;}this._propagateTitleIdToChildControl=function(){var A=this.getMetadata().getAggregation(a),c=A&&A.get(this),t=g&&g.call(this),i;if(!sap.ui.getCore().getConfiguration().getAccessibility()||!t||!c||c.length===0){return false;}i=c[0];if(i&&i._suggestTitleId&&i.isA(["sap.ui.layout.form.SimpleForm","sap.ui.layout.form.Form","sap.ui.comp.smartform.SmartForm"])){i._suggestTitleId(t);return true;}return false;};this._initTitlePropagationSupport=function(){this.addEventDelegate({onBeforeRendering:this._propagateTitleIdToChildControl.bind(this)});};};},false);
sap.ui.predefine('sap/m/TitleRenderer',["sap/ui/core/library","sap/m/HyphenationSupport"],function(c,H){"use strict";var T=c.TextAlign;var a=c.TitleLevel;var b={apiVersion:2};
b.render=function(r,t){var A=t._getTitle(),l=(A?A.getLevel():t.getLevel())||a.Auto,d=l==a.Auto,s=d?"div":l.toLowerCase(),e=H.getTextForRender(t,"main");r.openStart(s,t);r.class("sapMTitle");r.class("sapMTitleStyle"+(t.getTitleStyle()||a.Auto));r.class(t.getWrapping()?"sapMTitleWrap":"sapMTitleNoWrap");r.class("sapUiSelectable");var w=t.getWidth();if(!w){r.class("sapMTitleMaxWidth");}else{r.style("width",w);}var f=t.getTextAlign();if(f&&f!=T.Initial){r.class("sapMTitleAlign"+f);}if(t.getParent()instanceof sap.m.Toolbar){r.class("sapMTitleTB");}var g=A?A.getTooltip_AsString():t.getTooltip_AsString();if(g){r.attr("title",g);}if(d){r.attr("role","heading");r.attr("aria-level","2");}H.writeHyphenationClass(r,t);r.openEnd();r.openStart("span");r.attr("id",t.getId()+"-inner");r.openEnd();r.text(e);r.close("span");r.close(s);};
return b;},true);
sap.ui.predefine('sap/m/ToggleButton',['./Button','./library','sap/ui/core/EnabledPropagator','./ToggleButtonRenderer',"sap/ui/events/KeyCodes"],function(B,l,E,T,K){"use strict";
var a=B.extend("sap.m.ToggleButton",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ToggleButton.designtime",properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}},events:{press:{parameters:{pressed:{type:"boolean"}}}}}});
E.call(a.prototype);
a.prototype.ontap=function(e){e.setMarked();if(this.getEnabled()){this.setPressed(!this.getPressed());this.firePress({pressed:this.getPressed()});}};
a.prototype.setPressed=function(p){p=!!p;if(p!=this.getPressed()){this.setProperty("pressed",p,true);this.$().attr("aria-pressed",p);this.$("inner").toggleClass("sapMToggleBtnPressed",p&&!this._isUnstyled());}return this;};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER){this.ontap(e);}};
a.prototype.onkeyup=function(e){if(e.which===K.SPACE||e.which===K.ENTER){e.setMarked();}if(e.which===K.SPACE){this.ontap(e);}};
a.prototype.getAccessibilityInfo=function(){var i=B.prototype.getAccessibilityInfo.apply(this,arguments);if(this.getPressed()){i.description=((i.description||"")+" "+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_STATE_PRESSED")).trim();}return i;};
return a;});
sap.ui.predefine('sap/m/ToggleButtonRenderer',['./ButtonRenderer','sap/ui/core/Renderer'],function(B,R){"use strict";var T=R.extend(B);
T.renderAccessibilityAttributes=function(r,t,a){a["pressed"]=t.getPressed();};
T.renderButtonAttributes=function(r,t){if(t.getPressed()&&!t._isUnstyled()){r.addClass("sapMToggleBtnPressed");}};
return T;},true);
sap.ui.predefine('sap/m/Token',['./library','sap/ui/core/Control','./Tokenizer','sap/ui/core/library','sap/ui/core/Icon','./TokenRenderer','sap/ui/core/InvisibleText','sap/ui/events/KeyCodes','sap/ui/core/theming/Parameters','sap/ui/core/Core'],function(l,C,T,c,I,a,b,K,P,d){"use strict";var e=c.TextDirection;
var f=C.extend("sap.m.Token",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Misc",defaultValue:false},key:{type:"string",group:"Misc",defaultValue:""},text:{type:"string",group:"Misc",defaultValue:""},editable:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:e.Inherit},editableParent:{type:"boolean",group:"Behavior",defaultValue:true,visibility:"hidden"}},aggregations:{deleteIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{"delete":{},press:{},select:{},deselect:{}}}});
f.prototype.init=function(){var t=this,s=P.get("_sap_m_Token_Sys_Cancel_Icon")==="true",S=s?"sap-icon://sys-cancel":"sap-icon://decline";this._deleteIcon=new I({id:t.getId()+"-icon",src:S,noTabStop:true,press:this._tokenIconPress.bind(this)});this._deleteIcon.addStyleClass("sapMTokenIcon");this.setAggregation("deleteIcon",this._deleteIcon);this._deleteIcon.setUseIconTooltip(false);};
f.prototype.ontouchstart=function(E){if(E.target.id===this.getId()+"-icon"){E.preventDefault();}};
f.prototype._getTooltip=function(o,E){var t=o.getTooltip_AsString(),D=d.getLibraryResourceBundle("sap.m").getText("TOKEN_ARIA_DELETABLE");if(E&&!t){return D;}return t;};
f.prototype._onTokenPress=function(E){var s=this.getSelected(),g=E.ctrlKey||E.metaKey,S=E.shiftKey,n=true,p;if(g||(E.which===K.SPACE)){n=!s;}this.setSelected(n);this.firePress();if(s!=n){if(n){this.fireSelect();}else{this.fireDeselect();}}p=this.getParent();if(p instanceof T){p._onTokenSelect(this,g,S);}if(this.getSelected()){this.focus();}};
f.prototype._tokenIconPress=function(E){var p=this.getParent();if(!p.getEnabled()){return;}this.fireDelete({token:this});if(p.isA("sap.m.Tokenizer")){p._onTokenDelete(this);}E.preventDefault();};
f.prototype._changeSelection=function(s){if(this.getSelected()==s){return;}this.setSelected(s);if(s){this.fireSelect();}else{this.fireDeselect();}};
f.prototype.ontap=function(E){if(E.target.id==this._deleteIcon.getId()){E.setMark("tokenDeletePress",true);return;}this._onTokenPress(E);};
f.prototype.onsapfocusleave=function(E){if(this.getParent()instanceof T){return;}this.setSelected(false);};
f.prototype.onsapbackspace=function(E){this._deleteToken(E);};
f.prototype.onsapdelete=function(E){this._deleteToken(E);};
f.prototype._deleteToken=function(E){if(this.getParent()instanceof T){return;}if(this.getEditable()){this.fireDelete({token:this});}E.preventDefault();};
f.prototype.onsapspace=function(E){this._onTokenPress(E);if(E){E.preventDefault();E.stopPropagation();}};
f.prototype.onkeydown=function(E){if((E.ctrlKey||E.metaKey)&&E.which===K.SPACE){this.onsapspace(E);E.preventDefault();}};
return f;});
sap.ui.predefine('sap/m/TokenRenderer',["sap/ui/core/library","sap/ui/core/InvisibleText"],function(c,I){"use strict";var T=c.TextDirection;var a={apiVersion:2};
a.render=function(r,C){var t=C._getTooltip(C,C.getEditable()&&C.getProperty("editableParent")),A=[],o={role:"option"};r.openStart("div",C).attr("tabindex","-1").class("sapMToken");if(C.getSelected()){r.class("sapMTokenSelected");}if(!C.getEditable()){r.class("sapMTokenReadOnly");}if(t){r.attr("title",t);}A.push(I.getStaticId("sap.m","TOKEN_ARIA_LABEL"));if(C.getEditable()&&C.getProperty("editableParent")){A.push(I.getStaticId("sap.m","TOKEN_ARIA_DELETABLE"));}if(C.getSelected()){A.push(I.getStaticId("sap.m","TOKEN_ARIA_SELECTED"));}o.describedby={value:A.join(" "),append:true};r.accessibilityState(C,o);r.openEnd();a._renderInnerControl(r,C);if(C.getEditable()){r.renderControl(C._deleteIcon);}r.close("div");};
a._renderInnerControl=function(r,C){var t=C.getTextDirection();r.openStart("span").class("sapMTokenText");if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();var b=C.getText();if(b){r.text(b);}r.close("span");};
return a;},true);
sap.ui.predefine('sap/m/Tokenizer',['./library','sap/ui/core/Control','sap/ui/core/delegate/ScrollEnablement','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','./TokenizerRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/EnabledPropagator","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(l,C,S,D,I,R,T,c,K,L,E,q){"use strict";
var a=C.extend("sap.m.Tokenizer",{metadata:{library:"sap.m",properties:{editable:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"}},defaultAggregation:"tokens",aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},_tokensInfo:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{allowPreventDefault:true,parameters:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");E.apply(a.prototype,[true]);
a.prototype.init=function(){this.bAllowTextSelection=false;this._oTokensWidthMap={};this._oIndicator=null;this._bAdjustable=false;this._aTokenValidators=[];this._oScroller=new S(this,this.getId()+"-scrollContainer",{horizontal:true,vertical:false,nonTouchScrolling:true});if(sap.ui.getCore().getConfiguration().getAccessibility()){var A=new I({text:r.getText("TOKENIZER_ARIA_CONTAIN_TOKEN")});this.setAggregation("_tokensInfo",A);}};
a.prototype._handleNMoreIndicatorPress=function(f){this._fnOnNMorePress=f;};
a.prototype._hasMoreIndicator=function(){var d=this.$();return!!d.length&&this.$().find(".sapMHiddenToken").length>0;};
a.prototype._adjustTokensVisibility=function(){if(!this.getDomRef()){return;}var t=parseInt(this.getMaxWidth()),b=this._getVisibleTokens().reverse(),i=b.length,d,f,e,F=-1;b.some(function(o,g){t=t-this._oTokensWidthMap[o.getId()];if(t<=0){F=g;return true;}else{f=t;}}.bind(this));if(F>-1){for(e=0;e<i;e++){if(e>=F){b[e].addStyleClass("sapMHiddenToken");}else{b[e].removeStyleClass("sapMHiddenToken");}}this._handleNMoreIndicator(i-F);d=this._oIndicator.width();if(d>=f){F=F-1;this._handleNMoreIndicator(i-F);b[F].addStyleClass("sapMHiddenToken");}}else{this._showAllTokens();}};
a.prototype._handleNMoreIndicator=function(h){if(!this.getDomRef()){return this;}if(h){var s="MULTIINPUT_SHOW_MORE_TOKENS";if(h===this._getVisibleTokens().length){this.$().css("overflow","visible");if(h===1){s="TOKENIZER_SHOW_ALL_ITEM";}else{s="TOKENIZER_SHOW_ALL_ITEMS";}}this._oIndicator.removeClass("sapUiHidden");this._oIndicator.html(r.getText(s,h));}else{this.$().css("overflow","hidden");this._oIndicator.addClass("sapUiHidden");}return this;};
a.prototype._getVisibleTokens=function(){return this.getTokens().filter(function(t){return t.getVisible();});};
a.prototype._showAllTokens=function(){this._handleNMoreIndicator(0);this._getVisibleTokens().forEach(function(t){t.removeStyleClass("sapMHiddenToken");});};
a.prototype.getScrollDelegate=function(){return this._oScroller;};
a.prototype.scrollToEnd=function(){var d=this.getDomRef(),t;if(!d){return;}if(!this._sResizeHandlerId){t=this;this._sResizeHandlerId=R.register(d,function(){t.scrollToEnd();});}var s=this.$().find(".sapMTokenizerScrollContainer")[0];d.scrollLeft=s.scrollWidth;};
a.prototype.setMaxWidth=function(w){this.setProperty("maxWidth",w,true);this.$().css("max-width",this.getMaxWidth());if(this.getDomRef()&&this._getAdjustable()){this._adjustTokensVisibility();}return this;};
a.prototype._getIndicatorVisibility=function(){return this._oIndicator&&!this._oIndicator.hasClass("sapUiHidden");};
a.prototype._setAdjustable=function(A){this._bAdjustable=A;};
a.prototype._getAdjustable=function(){return this._bAdjustable;};
a.prototype.setPixelWidth=function(n){if(typeof n!=="number"){L.warning("Tokenizer.setPixelWidth called with invalid parameter. Expected parameter of type number.");return;}this.setWidth(n+"px");if(this._oScroller){this._oScroller.refresh();}};
a.prototype.scrollToStart=function(){var d=this.getDomRef();if(!d){return;}this._deactivateScrollToEnd();d.scrollLeft=0;};
a.prototype._deactivateScrollToEnd=function(){this._deregisterResizeHandler();};
a.prototype.getScrollWidth=function(){if(!this.getDomRef()){return 0;}return this.$().children(".sapMTokenizerScrollContainer")[0].scrollWidth;};
a.prototype.onBeforeRendering=function(){this._setTokensAria();this._deregisterResizeHandler();};
a.prototype.onAfterRendering=function(){var t=this.getTokens(),b=t.length;this.scrollToEnd();this._oIndicator=this.$().find(".sapMTokenizerIndicator");for(var i=0;i<b;i++){var o=t[i].getDomRef();if(o){o.setAttribute("aria-posinset",i+1);o.setAttribute("aria-setsize",b);}}if(this._getAdjustable()){this._useCollapsedMode(this._hasMoreIndicator(),true);}};
a.prototype.onThemeChanged=function(){if(!this._getAdjustable()){return;}this.getTokens().forEach(function(t){if(t.getDomRef()&&!t.$().hasClass("sapMHiddenToken")){this._oTokensWidthMap[t.getId()]=t.$().outerWidth(true);}}.bind(this));this._adjustTokensVisibility();};
a.prototype._useCollapsedMode=function(b,s){var p=this.getParent(),t=this._getVisibleTokens();if(!t.length){return;}if(b){this._adjustTokensVisibility();}else{this._showAllTokens();}if(!s){p._syncInputWidth&&setTimeout(p["_syncInputWidth"].bind(p,this),0);}};
a.prototype.invalidate=function(o){var p=this.getParent();if(p instanceof sap.m.MultiInput){p.invalidate(o);}else{C.prototype.invalidate.call(this,o);}};
a.prototype.onsapfocusleave=function(e){if(document.activeElement==this.getDomRef()||!this._checkFocus()){this._changeAllTokensSelection(false);this._oSelectionOrigin=null;}};
a.prototype.isAllTokenSelected=function(){if(this._getVisibleTokens().length===this.getSelectedTokens().length){return true;}return false;};
a.prototype.onkeydown=function(e){var s;if(!this.getEnabled()){return;}if(e.which===K.TAB){this._changeAllTokensSelection(false);}if((e.ctrlKey||e.metaKey)&&e.which===K.A){this._iSelectedToken=this.getSelectedTokens().length;s=this.getSelectedTokens().length<this._getVisibleTokens().length;if(this._getVisibleTokens().length>0){this.focus();this._changeAllTokensSelection(s);e.preventDefault();e.stopPropagation();}}if((e.ctrlKey||e.metaKey)&&(e.which===K.C||e.which===K.INSERT)){this._copy();}if(((e.ctrlKey||e.metaKey)&&e.which===K.X)||(e.shiftKey&&e.which===K.DELETE)){if(this.getEditable()){this._cut();}else{this._copy();}}};
a.prototype.onsappreviousmodifiers=function(e){this.onsapprevious(e);};
a.prototype.onsapnextmodifiers=function(e){this.onsapnext(e);};
a.prototype.onsaphomemodifiers=function(e){this._selectRange(false);};
a.prototype.onsapendmodifiers=function(e){this._selectRange(true);};
a.prototype._selectRange=function(f){var o={},t=this._getVisibleTokens(),F=q(document.activeElement).control()[0],b=t.indexOf(F);if(!F||!F.isA("sap.m.Token")){return;}if(f){o.start=b;o.end=t.length-1;}else{o.start=0;o.end=b;}if(o.start<o.end){for(var i=o.start;i<=o.end;i++){t[i].setSelected(true);}}};
a.prototype._copy=function(){var s=this.getSelectedTokens(),b="",t,d=function(e){if(e.clipboardData){e.clipboardData.setData('text/plain',b);}else{e.originalEvent.clipboardData.setData('text/plain',b);}e.preventDefault();};for(var i=0;i<s.length;i++){t=s[i];b+=(i>0?"\r\n":"")+t.getText();}if(!b){return;}if(D.browser.msie&&window.clipboardData){window.clipboardData.setData("text",b);}else{document.addEventListener('copy',d);document.execCommand('copy');document.removeEventListener('copy',d);}};
a.prototype._cut=function(){var s=this,b=s.getSelectedTokens(),d="",e=[],f,t,g=function(o){if(o.clipboardData){o.clipboardData.setData('text/plain',d);}else{o.originalEvent.clipboardData.setData('text/plain',d);}o.preventDefault();};f=s.fireTokenUpdate({addedTokens:[],removedTokens:e,type:a.TokenUpdateType.Removed});for(var i=0;i<b.length;i++){t=b[i];d+=(i>0?"\r\n":"")+t.getText();if(f&&t.getEditable()){s.removeToken(t);e.push(t);t.destroy();}}if(!d){return;}if(D.browser.msie&&window.clipboardData){window.clipboardData.setData("text",d);}else{document.addEventListener('cut',g);document.execCommand('cut');document.removeEventListener('cut',g);}};
a.prototype.onsapbackspace=function(e){var s=this.getSelectedTokens();if(!this.getEnabled()){return;}if(s.length<2){this.onsapprevious(e);}else{this._focusUnselectedToken(e);}this._handleKeyboardDelete(e);e.setMarked();};
a.prototype._focusUnselectedToken=function(e){var s=this.getSelectedTokens(),t=this._getVisibleTokens(),i,o;if(e.keyCode===K.DELETE){i=t.indexOf(s[s.length-1]);o=t[i+1];}if(e.keyCode===K.BACKSPACE){i=t.indexOf(s[0]);o=t[i-1];}if(o){o.focus();}else{e.setMarked("forwardFocusToParent");this.focus();}};
a.prototype.onsapdelete=function(e){var s;if(!this.getEnabled()){return;}s=this.getSelectedTokens();if(s.length<2){this.onsapnext(e);}else{this._focusUnselectedToken(e);}this._handleKeyboardDelete(e);e.setMarked();};
a.prototype._handleKeyboardDelete=function(e){var t;if(this.getEditable()){t=q(e.target).control()[0];if(t&&t.isA("sap.m.Token")){this.handleTokenDeletion(t);}this._removeSelectedTokens();if(!this._getVisibleTokens().length){e.setMarked("forwardFocusToParent");}}};
a.prototype._ensureTokenVisible=function(t){if(!t||!t.getDomRef()||!this.getDomRef()){return;}var i=this.$().offset().left,b=this.$().width(),d=t.$().offset().left,e=t.$().width();if(this._getVisibleTokens().indexOf(t)==0){this.$().scrollLeft(0);return;}if(d<i){this.$().scrollLeft(this.$().scrollLeft()-i+d);}if(d-i+e>b){this.$().scrollLeft(this.$().scrollLeft()+(d-i+e-b));}};
a.prototype.onsapprevious=function(e){var t=this._getVisibleTokens(),i=t.length;if(i===0){return;}var f=q(document.activeElement).control()[0];var b=f?t.indexOf(f):-1;if(b==0){e.setMarked("forwardFocusToParent");return;}var d,g;if(b>0){d=t[b-1];d.focus();}else{d=t[t.length-1];d.focus();}if(e.shiftKey){g=t[b];d.setSelected(true);g.setSelected(true);}this._deactivateScrollToEnd();this._ensureTokenVisible(d);e.setMarked();e.preventDefault();};
a.prototype.onsapnext=function(e){var t=this._getVisibleTokens(),i=t.length;if(i===0){return;}var f=q(document.activeElement).control()[0];var b=f?t.indexOf(f):-1;if(b<i-1){var n=t[b+1],d=t[b];n.focus();if(e.shiftKey){n.setSelected(true);d.setSelected(true);}this._ensureTokenVisible(n);}else{e.setMarked("forwardFocusToParent");return;}this._deactivateScrollToEnd();e.setMarked();e.preventDefault();};
a.prototype.addValidator=function(v){if(typeof(v)==="function"){this._aTokenValidators.push(v);}};
a.prototype.removeValidator=function(v){var i=this._aTokenValidators.indexOf(v);if(i!==-1){this._aTokenValidators.splice(i,1);}};
a.prototype.removeAllValidators=function(){this._aTokenValidators=[];};
a.prototype._validateToken=function(p,v){var t=p.token;var s;if(t&&t.getText()){s=t.getText();}else{s=p.text;}var V=p.validationCallback;var o=p.suggestionObject;var i,b,d;if(!v){v=this._aTokenValidators;}d=v.length;if(d===0){if(!t&&V){V(false);}return t;}for(i=0;i<d;i++){b=v[i];t=b({text:s,suggestedToken:t,suggestionObject:o,asyncCallback:this._getAsyncValidationCallback(v,i,s,o,V)});if(!t){if(V){V(false);}return null;}if(t===a.WaitForAsyncValidation){return null;}}return t;};
a.prototype._getAsyncValidationCallback=function(v,V,i,s,f){var t=this,A;return function(o){if(o){v=v.slice(V+1);o=t._validateToken({text:i,token:o,suggestionObject:s,validationCallback:f},v);A=t._addUniqueToken(o,f);if(A){t.fireTokenUpdate({addedTokens:[o],removedTokens:[],type:a.TokenUpdateType.Added});}}else{if(f){f(false);}}};};
a.prototype.addValidateToken=function(p){var t=this._validateToken(p);this._addUniqueToken(t,p.validationCallback);};
a.prototype._addValidateToken=function(p){var t=this._validateToken(p),A=this._addUniqueToken(t,p.validationCallback);if(A){this.fireTokenUpdate({addedTokens:[t],removedTokens:[],type:a.TokenUpdateType.Added});}};
a.prototype._addUniqueToken=function(t,v){if(!t){return false;}var b=this._tokenExists(t);if(b){var p=this.getParent();if(p instanceof sap.m.MultiInput&&v){v(false);}return false;}this.addToken(t);if(v){v(true);}this.fireTokenChange({addedTokens:[t],removedTokens:[],type:a.TokenChangeType.TokensChanged});return true;};
a.prototype._parseString=function(s){return s.split(/\r\n|\r|\n/g);};
a.prototype._checkFocus=function(){return this.getDomRef()&&c(this.getDomRef(),document.activeElement);};
a.prototype._tokenExists=function(t){var b=this.getTokens();if(!(b&&b.length)){return false;}var k=t.getKey();if(!k){return false;}var d=b.length;for(var i=0;i<d;i++){var e=b[i];var f=e.getKey();if(f===k){return true;}}return false;};
a.prototype.addToken=function(t,s){var p=this.getParent();t.setProperty("editableParent",this.getEditable());if(p instanceof sap.m.MultiInput){if(p.getMaxTokens()!==undefined&&p.getTokens().length>=p.getMaxTokens()){return this;}}this.addAggregation("tokens",t,s);this.fireTokenChange({token:t,type:a.TokenChangeType.Added});t.addEventDelegate({onAfterRendering:function(){if(sap.ui.getCore().isThemeApplied()&&t.getDomRef()&&!t.$().hasClass("sapMHiddenToken")){this._oTokensWidthMap[t.getId()]=t.$().outerWidth(true);}}.bind(this)});return this;};
a.prototype.removeToken=function(t){t=this.removeAggregation("tokens",t);this._bScrollToEndIsActive=true;this.fireTokenChange({token:t,type:a.TokenChangeType.Removed});return t;};
a.prototype.setTokens=function(t){var o=this.getTokens();this.removeAllTokens(false);var i;for(i=0;i<t.length;i++){this.addToken(t[i],true);}this.invalidate();this.fireTokenChange({addedTokens:t,removedTokens:o,type:a.TokenChangeType.TokensChanged});};
a.prototype.removeAllTokens=function(f){var t=this.getTokens();var b=this.removeAllAggregation("tokens");if(typeof(f)==="boolean"&&!f){return b;}this.fireTokenChange({addedTokens:[],removedTokens:t,type:a.TokenChangeType.TokensChanged});this.fireTokenChange({tokens:t,type:a.TokenChangeType.RemovedAll});return b;};
a.prototype.updateTokens=function(){this.destroyTokens();this.updateAggregation("tokens");};
a.prototype._removeSelectedTokens=function(){var t=this.getSelectedTokens();if(t.length===0){return this;}this.handleTokenDeletion(t);this._doSelect();return this;};
a.prototype.handleTokenDeletion=function(t){var e,i,o,b=[];b=b.concat(t);e=this.fireTokenUpdate({addedTokens:[],removedTokens:b,type:a.TokenUpdateType.Removed});if(!e){return;}for(i=0;i<b.length;i++){o=b[i];if(o.getEditable()){o.destroy();}}this.scrollToEnd();this.fireTokenChange({addedTokens:[],removedTokens:b,type:a.TokenChangeType.TokensChanged});};
a.prototype.selectAllTokens=function(s){if(s===undefined){s=true;}var t=this._getVisibleTokens(),b=t.length,i;for(i=0;i<b;i++){t[i].setSelected(s);}this._doSelect();return this;};
a.prototype._changeAllTokensSelection=function(s,b){var t=this._getVisibleTokens(),d=t.length,e,i;for(i=0;i<d;i++){e=t[i];if(e!==b){e._changeSelection(s);}}this._doSelect();return this;};
a.prototype.getSelectedTokens=function(){var s=[],t=this._getVisibleTokens(),i,b,d=t.length;for(i=0;i<d;i++){b=t[i];if(b.getSelected()){s.push(b);}}return s;};
a.prototype._onTokenDelete=function(t){if(t&&this.getEditable()&&this.getEnabled()){var e=this.fireTokenUpdate({addedTokens:[],removedTokens:[t],type:a.TokenUpdateType.Removed});if(!e){return;}delete this._oTokensWidthMap[t.getId()];t.destroy();this.fireTokenChange({addedTokens:[],removedTokens:[t],type:a.TokenChangeType.TokensChanged});}};
a.prototype._onTokenSelect=function(t,b,s){var d=this._getVisibleTokens(),o,i;if(s){var f=this._getFocusedToken();if(!f){this._oSelectionOrigin=null;return;}if(this._oSelectionOrigin){f=this._oSelectionOrigin;}else{this._oSelectionOrigin=f;}var F=this.indexOfToken(f),e=this.indexOfToken(t),m=Math.min(F,e),M=Math.max(F,e);for(i=0;i<d.length;i++){o=d[i];if(i>=m&&i<=M){o._changeSelection(true);}else if(!b){o._changeSelection(false);}}return;}this._oSelectionOrigin=null;if(b){return;}this._oSelectionOrigin=t;for(i=0;i<d.length;i++){o=d[i];if(o!==t){o._changeSelection(false);}}};
a.prototype._getFocusedToken=function(){var f=sap.ui.getCore().byId(document.activeElement.id);if(!f||!(f instanceof sap.m.Token)||this.indexOfToken(f)==-1){return null;}return f;};
a.prototype.onsaphome=function(e){this._getVisibleTokens()[0].focus();this.scrollToStart();e.preventDefault();};
a.prototype.onsapend=function(e){var t=this._getVisibleTokens(),o=t[t.length-1];if(o.getDomRef()!==document.activeElement){o.focus();this.scrollToEnd();e.stopPropagation();}else{e.setMarked("forwardFocusToParent");}e.preventDefault();};
a.prototype.onclick=function(e){var f;f=q(e.target).hasClass("sapMTokenizerIndicator")||(e.target===this.getFocusDomRef());if(!this.getEnabled()){return;}if(f){this._fnOnNMorePress&&this._fnOnNMorePress(e);}};
a.prototype.ontouchstart=function(e){e.setMarked();if(D.browser.chrome&&window.getSelection()){window.getSelection().removeAllRanges();}};
a.prototype.exit=function(){this._deregisterResizeHandler();};
a.prototype._deregisterResizeHandler=function(){if(this._sResizeHandlerId){R.deregister(this._sResizeHandlerId);delete this._sResizeHandlerId;}};
a.prototype._setTokensAria=function(){var t=this._getVisibleTokens().length,i,s="";if(sap.ui.getCore().getConfiguration().getAccessibility()){i=this.getAggregation("_tokensInfo");switch(t){case 0:s=r.getText("TOKENIZER_ARIA_CONTAIN_TOKEN");break;case 1:s=r.getText("TOKENIZER_ARIA_CONTAIN_ONE_TOKEN");break;default:s=r.getText("TOKENIZER_ARIA_CONTAIN_SEVERAL_TOKENS",t);break;}i.setText(s);}};
a.prototype._doSelect=function(){if(this._checkFocus()&&this._bCopyToClipboardSupport){var f=document.activeElement;var s=window.getSelection();s.removeAllRanges();if(this.getSelectedTokens().length){var o=document.createRange();o.selectNodeContents(this.getDomRef("clip"));s.addRange(o);}if(window.clipboardData&&f.id==this.getId()+"-clip"&&this.getDomRef()){this.getDomRef().focus();}}};
a.prototype.getReverseTokens=function(){return!!this._reverseTokens;};
a.prototype.setReverseTokens=function(b){this._reverseTokens=b;};
a.prototype.setEditable=function(e){var t=this.getTokens();t.forEach(function(o){o.setProperty("editableParent",e);});this.setProperty("editable",e);return this;};
a.prototype.getTokensInfoId=function(){return this.getAggregation("_tokensInfo").getId();};
a.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};a.TokenUpdateType={Added:"added",Removed:"removed"};a.WaitForAsyncValidation="sap.m.Tokenizer.WaitForAsyncValidation";return a;});
sap.ui.predefine('sap/m/TokenizerRenderer',['sap/ui/Device','sap/ui/core/InvisibleText'],function(D,I){"use strict";var T={apiVersion:2};
T.render=function(r,c){if(c.getParent()&&(c.getParent()instanceof sap.m.MultiInput||c.getParent()instanceof sap.m.MultiComboBox)){r.openStart("div",c);}else{r.openStart("div",c).attr("tabindex","0");}r.class("sapMTokenizer");if(!c.getEditable()){r.class("sapMTokenizerReadonly");}if(!c.getEnabled()){r.class("sapMTokenizerDisabled");}var t=c.getTokens();if(!t.length){r.class("sapMTokenizerEmpty");}r.style("max-width",c.getMaxWidth());var p=c.getWidth();if(p){r.style("width",p);}var a={role:"listbox",readonly:null};a.labelledby={value:I.getStaticId("sap.m","TOKENIZER_ARIA_LABEL"),append:true};r.accessibilityState(c,a);r.openEnd();r.renderControl(c.getAggregation("_tokensInfo"));c._bCopyToClipboardSupport=false;if((D.system.desktop||D.system.combi)&&t.length){r.openStart("div",c.getId()+"-clip").class("sapMTokenizerClip");if(window.clipboardData){r.attr("contenteditable","true");r.attr("tabindex","-1");}r.openEnd();r.unsafeHtml("&nbsp");r.close("div");c._bCopyToClipboardSupport=true;}r.openStart("div");r.attr("id",c.getId()+"-scrollContainer");r.class("sapMTokenizerScrollContainer");r.openEnd();T._renderTokens(r,c);r.close("div");T._renderIndicator(r,c);r.close("div");};
T._renderTokens=function(r,c){var i=0,t=c.getTokens(),l=t.length;if(c.getReverseTokens()){for(i=l-1;i>-1;i--){r.renderControl(t[i]);}}else{for(i=0;i<l;i++){r.renderControl(t[i]);}}};
T._renderIndicator=function(r,c){r.openStart("span");r.class("sapMTokenizerIndicator");r.class("sapUiHidden");r.openEnd().close("span");};
return T;},true);
sap.ui.predefine('sap/m/Toolbar',['./BarInPageEnabler','./ToolbarLayoutData','./ToolbarSpacer','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator',"sap/ui/events/KeyCodes",'./ToolbarRenderer'],function(B,T,a,l,C,E,K,b){"use strict";var c=l.ToolbarDesign,d=l.ToolbarStyle;
var e=C.extend("sap.m.Toolbar",{metadata:{interfaces:["sap.ui.core.Toolbar","sap.m.IBar"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},active:{type:"boolean",group:"Behavior",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''},design:{type:"sap.m.ToolbarDesign",group:"Appearance",defaultValue:c.Auto},style:{type:"sap.m.ToolbarStyle",group:"Appearance",defaultValue:d.Standard}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{parameters:{srcControl:{type:"sap.ui.core.Control"}}}},designtime:"sap/m/designtime/Toolbar.designtime"}});
E.call(e.prototype);e.shrinkClass="sapMTBShrinkItem";
e.isRelativeWidth=function(w){return/^([-+]?\d+%|auto|inherit|)$/i.test(w);};
e.getOrigWidth=function(i){var o=sap.ui.getCore().byId(i);if(!o||!o.getWidth){return"";}return o.getWidth();};
e.checkShrinkable=function(o,s){if(o instanceof a){return this.isRelativeWidth(o.getWidth());}s=s||this.shrinkClass;o.removeStyleClass(s);var w=this.getOrigWidth(o.getId());if(!this.isRelativeWidth(w)){return;}var L=o.getLayoutData();if(L instanceof T){return L.getShrinkable()&&o.addStyleClass(s);}if(w.indexOf("%")>0||o.getMetadata().isInstanceOf("sap.ui.core.IShrinkable")){return o.addStyleClass(s);}var D=o.getDomRef();if(D&&(D.firstChild||{}).nodeType==3){return o.addStyleClass(s);}};
e.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this._oContentDelegate={onAfterRendering:this._onAfterContentRendering};};
e.prototype.onAfterRendering=function(){this._checkContents();};
e.prototype.onLayoutDataChange=function(){this.rerender();};
e.prototype.addContent=function(o){this.addAggregation("content",o);this._onContentInserted(o);return this;};
e.prototype.insertContent=function(o,i){this.insertAggregation("content",o,i);this._onContentInserted(o);return this;};
e.prototype.removeContent=function(v){v=this.removeAggregation("content",v);this._onContentRemoved(v);return v;};
e.prototype.removeAllContent=function(){var f=this.removeAllAggregation("content")||[];f.forEach(this._onContentRemoved,this);return f;};
e.prototype.ontap=function(o){if(this.getActive()&&!o.isMarked()){o.setMarked();this.firePress({srcControl:o.srcControl});}};
e.prototype.onsapenter=function(o){if(this.getActive()&&o.srcControl===this&&!o.isMarked()){o.setMarked();this.firePress({srcControl:this});}};
e.prototype.onsapspace=function(o){if(o.srcControl===this){o.preventDefault();}};
e.prototype.onkeyup=function(o){if(o.which===K.SPACE){this.onsapenter(o);}};
e.prototype.ontouchstart=function(o){this.getActive()&&o.setMarked();};
e.prototype._checkContents=function(){this.getContent().forEach(function(o){e.checkShrinkable(o);});};
e.prototype._onContentInserted=function(o){if(o){o.attachEvent("_change",this._onContentPropertyChanged,this);o.addEventDelegate(this._oContentDelegate,o);}};
e.prototype._onContentRemoved=function(o){if(o){o.detachEvent("_change",this._onContentPropertyChanged,this);o.removeEventDelegate(this._oContentDelegate,o);}};
e.prototype._onAfterContentRendering=function(){var L=this.getLayoutData();if(L instanceof T){L.applyProperties();}};
e.prototype._onContentPropertyChanged=function(o){if(o.getParameter("name")!="width"){return;}var f=o.getSource();var p=f.getWidth().indexOf("%")>0;f.toggleStyleClass(e.shrinkClass,p);};
e.prototype._getAccessibilityRole=function(){var r=this._getRootAccessibilityRole();if(this.getActive()){r="button";}return r;};
e.prototype.setDesign=function(D,s){if(!s){return this.setProperty("design",D);}this._sAutoDesign=this.validateProperty("design",D);return this;};
e.prototype.getActiveDesign=function(){var D=this.getDesign();if(D!=c.Auto){return D;}return this._sAutoDesign||D;};
e.prototype.getTitleControl=function(){var f=sap.ui.require("sap/m/Title");if(!f){return;}var g=this.getContent();for(var i=0;i<g.length;i++){var o=g[i];if(o instanceof f&&o.getVisible()){return o;}}};
e.prototype.getTitleId=function(){var t=this.getTitleControl();return t?t.getId():"";};
e.prototype.isContextSensitive=B.prototype.isContextSensitive;e.prototype.setHTMLTag=B.prototype.setHTMLTag;e.prototype.getHTMLTag=B.prototype.getHTMLTag;e.prototype.applyTagAndContextClassFor=B.prototype.applyTagAndContextClassFor;e.prototype._applyContextClassFor=B.prototype._applyContextClassFor;e.prototype._applyTag=B.prototype._applyTag;e.prototype._getContextOptions=B.prototype._getContextOptions;e.prototype._setRootAccessibilityRole=B.prototype._setRootAccessibilityRole;e.prototype._getRootAccessibilityRole=B.prototype._getRootAccessibilityRole;e.prototype._setRootAriaLevel=B.prototype._setRootAriaLevel;e.prototype._getRootAriaLevel=B.prototype._getRootAriaLevel;return e;});
sap.ui.predefine('sap/m/ToolbarLayoutData',['./library','sap/ui/core/LayoutData'],function(l,L){"use strict";
var T=L.extend("sap.m.ToolbarLayoutData",{metadata:{library:"sap.m",properties:{shrinkable:{type:"boolean",group:"Behavior",defaultValue:false},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}}}});
T.prototype.getParentStyle=function(){var p=this.getParent();if(!p||!p.getDomRef){return{};}var d=p.getDomRef();return d?d.style:{};};
T.prototype.applyProperties=function(){var s=this.getParentStyle();s.minWidth=this.getMinWidth();s.maxWidth=this.getMaxWidth();return this;};
return T;});
sap.ui.predefine('sap/m/ToolbarRenderer',['./BarInPageEnabler'],function(B){"use strict";var T={apiVersion:2};T.render=B.prototype.render;
T.decorateRootElement=function(r,t){var a;r.class("sapMTB");if(!t.getAriaLabelledBy().length){a=t.getTitleId();}r.accessibilityState(t,{role:t._getAccessibilityRole(),labelledby:a});r.class("sapMTBNewFlex");if(t.getActive()){r.class("sapMTBActive");r.attr("tabindex","0");}else{r.class("sapMTBInactive");}r.class("sapMTB"+t.getStyle());r.class("sapMTB-"+t.getActiveDesign()+"-CTX");r.style("width",t.getWidth());r.style("height",t.getHeight());};
T.renderBarContent=function(r,t){t.getContent().forEach(function(c){B.addChildClassTo(c,t);r.renderControl(c);});};
T.shouldAddIBarContext=function(c){return false;};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSeparator',['./library','sap/ui/core/Control','./ToolbarSeparatorRenderer'],function(l,C,T){"use strict";
var a=C.extend("sap.m.ToolbarSeparator",{metadata:{library:"sap.m",interfaces:["sap.m.IOverflowToolbarContent"]}});
a.CLASSNAME_OVERFLOW_TOOLBAR="sapMTBSeparatorOverflowToolbar";
a.prototype._onBeforeEnterOverflow=function(c){c.addStyleClass(a.CLASSNAME_OVERFLOW_TOOLBAR);};
a.prototype._onAfterExitOverflow=function(c){c.removeStyleClass(a.CLASSNAME_OVERFLOW_TOOLBAR);};
a.prototype.getOverflowToolbarConfig=function(){var c={canOverflow:true};c.onBeforeEnterOverflow=this._onBeforeEnterOverflow;c.onAfterExitOverflow=this._onAfterExitOverflow;return c;};
return a;});
sap.ui.predefine('sap/m/ToolbarSeparatorRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){r.openStart("div",c);r.class("sapMTBSeparator");r.accessibilityState(c,{role:"separator"});r.openEnd();r.close("div");};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSpacer',['./library','sap/ui/core/Control','./ToolbarSpacerRenderer'],function(l,C,T){"use strict";
var a=C.extend("sap.m.ToolbarSpacer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''}}}});
return a;});
sap.ui.predefine('sap/m/ToolbarSpacerRenderer',[],function(){"use strict";var T={apiVersion:2};T.flexClass="sapMTBSpacerFlex";
T.render=function(r,c){r.openStart("div",c);r.class("sapMTBSpacer");var w=c.getWidth();if(w){r.style("width",w);}else{r.class(T.flexClass);}r.openEnd().close("div");};
return T;},true);
sap.ui.predefine('sap/m/Tree',['./ListBase','./library','sap/ui/model/ClientTreeBindingAdapter','sap/ui/model/TreeBindingCompatibilityAdapter','./TreeRenderer',"sap/base/Log","sap/base/assert"],function(L,l,C,T,a,b,c){"use strict";
var d=L.extend("sap.m.Tree",{metadata:{library:"sap.m",events:{toggleOpenState:{parameters:{itemIndex:{type:"int"},itemContext:{type:"object"},expanded:{type:"boolean"}}}}}});
d.prototype.isTreeBinding=function(n){return(n=="items");};
d.prototype.getBinding=function(n){n=n||"items";var B=L.prototype.getBinding.call(this,n);if(B&&n==="items"&&!B.getLength){if(B.isA("sap.ui.model.odata.v2.ODataTreeBinding")){B.applyAdapterInterface();}else if(B.isA("sap.ui.model.ClientTreeBinding")){C.apply(B);}else if(B.isA("sap.ui.model.odata.ODataTreeBinding")){T(B,this);}else{b.error("TreeBinding is not supported for the "+this);}}return B;};
d.prototype.updateAggregation=function(n){if(n!="items"){return L.prototype.updateAggregation.apply(this,arguments);}var B=this.getBindingInfo("items"),o=this.getBinding("items"),f=B.factory,e;function u(g,e){var h=g.getItems()||[],j,k;if(h.length>e.length){for(var i=e.length;i<h.length;i++){g.removeItem(h[i]);h[i].destroy("KeepDom");}}for(var i=0;i<e.length;i++){j=e[i];k=h[i];if(k){k.setBindingContext(j,B.model);}else{k=f(g.getId()+"-"+i,j);k.setBindingContext(j,B.model);g.addItem(k);}}}e=o.getContexts(0);if(!B.template){this.destroyItems();}u(this,e);};
d.prototype.validateAggregation=function(A,o,m){var r=L.prototype.validateAggregation.apply(this,arguments);if(A==="items"&&!o.isA("sap.m.TreeItemBase")){throw new Error(o+" is not a valid items aggregation of "+this+". Items aggregation in Tree control only supports TreeItemBase-based objects, e.g. StandardTreeItem.");}return r;};
d.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);this._bInvalidated=true;};
d.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.apply(this,arguments);this._bInvalidated=false;};
d.prototype._updateDeepestLevel=function(i){if(i.getLevel()+1>this.getDeepestLevel()){this._iDeepestLevel=i.getLevel()+1;}};
d.prototype.onItemExpanderPressed=function(i,e){var I=this.indexOfItem(i);var B=this.getBindingInfo("items");var o=i&&i.getBindingContext(B.model);if(B&&o){var E=i.getExpanded();var f;this._updateDeepestLevel(i);var g=this.getBinding("items");if(e==undefined){g.toggleIndex(I);}else if(e){g.expand(I);}else{g.collapse(I);}f=g.isExpanded(I);if(E!==f&&!i.isLeaf()){this.fireToggleOpenState({itemIndex:I,itemContext:o,expanded:f});}}};
d.prototype.setGrowing=function(){b.error("Growing feature of "+this+" is not supported!");return this;};
d.prototype.setGrowingThreshold=function(){b.error("GrowingThreshold of "+this+" is not supported!");return this;};
d.prototype.setGrowingTriggerText=function(){b.error("GrowingTriggerText of "+this+" is not supported!");return this;};
d.prototype.setGrowingScrollToLoad=function(){b.error("GrowingScrollToLoad of "+this+" is not supported!");return this;};
d.prototype.setGrowingDirection=function(){b.error("GrowingDirection of "+this+" is not supported!");return this;};
d.prototype.expandToLevel=function(i){var B=this.getBinding("items");c(B&&B.expandToLevel,"Tree.expandToLevel is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(B&&B.expandToLevel&&B.getNumberOfExpandedLevels){if(B.getNumberOfExpandedLevels()>i){B.collapseToLevel(0);}B.expandToLevel(i);}return this;};
d.prototype.getNumberOfExpandedLevel=function(){return this.getBinding("items").getNumberOfExpandedLevels();};
d.prototype.getDeepestLevel=function(){if(this._iDeepestLevel===undefined){this._iDeepestLevel=this.getNumberOfExpandedLevel();}return this._iDeepestLevel;};
d.prototype.collapseAll=function(){var B=this.getBinding("items");c(B&&B.expandToLevel,"Tree.collapseAll is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(B){B.collapseToLevel(0);}return this;};
d.prototype._sortHelper=function(p){var i=[];if(typeof p==="number"){i.push(p);}else if(Array.isArray(p)){i=p.sort().reverse();}return i;};
d.prototype._removeLeaf=function(s){var I=null,e,f=[];for(var i=0;i<s.length;i++){e=s[i];I=this.getItems()[e];if(I&&!I.isLeaf()){f.push(e);}}return f;};
d.prototype._preExpand=function(p){var i=this._sortHelper(p);i=this._removeLeaf(i);return i;};
d.prototype.expand=function(p){var B=this.getBinding("items");if(B&&B.expand){var I=this._preExpand(p),o;if(I.length>0){for(var i=0;i<I.length-1;i++){o=this.getItems()[I[i]];this._updateDeepestLevel(o);B.expand(I[i],true);}o=this.getItems()[I[I.length-1]];this._updateDeepestLevel(o);B.expand(I[I.length-1],false);}}return this;};
d.prototype.collapse=function(p){var B=this.getBinding("items");if(B&&B.collapse){var I=this._preExpand(p);for(var i=0;i<I.length-1;i++){B.collapse(I[i],true);}B.collapse(I[I.length-1],false);}return this;};
d.prototype.getAccessibilityType=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TREE");};
d.prototype.getAccessbilityPosition=function(i){var s,p,n=i.getItemNodeContext();if(n.parent){s=n.parent.children.length;}if(n.positionInParent!=undefined){p=n.positionInParent+1;}return{setSize:s,posInset:p};};
d.prototype.onItemLongDragOver=function(i){var I=this.indexOfItem(i);this._updateDeepestLevel(i);this.getBinding("items").expand(I);};
d.prototype.isGrouped=function(){return false;};
return d;});
sap.ui.predefine('sap/m/TreeItemBase',['./ListItemBase','./library','sap/ui/core/IconPool','sap/ui/core/Icon','./TreeItemBaseRenderer','sap/ui/events/KeyCodes'],function(L,l,I,a,T,K){"use strict";var b=l.ListMode;
var c=L.extend("sap.m.TreeItemBase",{metadata:{library:"sap.m"}});
c.prototype.ExpandedIconURI=I.getIconURI("navigation-down-arrow");c.prototype.CollapsedIconURI=I.getIconURI("navigation-right-arrow");
c.prototype.getTree=function(){var p=this.getParent();if(p&&p.isA("sap.m.Tree")){return p;}};
c.prototype.getList=c.prototype.getTree;c.prototype.informTree=c.prototype.informList;
c.prototype.getItemNodeContext=function(){var t=this.getTree();var n=null;var B=t?t.getBinding("items"):null;if(t&&B){B=t.getBinding("items");n=B.getNodeByIndex(t.indexOfItem(this));}return n;};
c.prototype.getParentNode=function(){if(this.isTopLevel()){return;}var t=this.getTree(),n=this.getLevel(),p=null,i=t.indexOfItem(this)-1,d=t.getItems(),e;while(i>=0){e=d[i].getLevel();if(e===n-1){p=d[i];break;}i--;}return p;};
c.prototype.getParentNodeContext=function(){return this.getItemNodeContext().parent;};
c.prototype.isLeaf=function(){var t=this.getTree(),n=this.getItemNodeContext();return n?!t.getBinding("items").nodeHasChildren(n):false;};
c.prototype.isTopLevel=function(){return(this.getLevel()===0);};
c.prototype.getLevel=function(){return(this.getItemNodeContext()||{}).level;};
c.prototype.getExpanded=function(){var t=this.getTree();if(!t){return false;}var i=t.indexOfItem(this);var B=t.getBinding("items");return(B&&B.isExpanded(i));};
c.prototype.setSelected=function(s){L.prototype.setSelected.apply(this,arguments);var t=this.getTree();var B=t?t.getBinding("items"):null;var i=-1;if(t&&B){i=t.indexOfItem(this);if(t.getMode()===b.SingleSelect){B.setSelectedIndex(i);}if(t.getMode()===b.MultiSelect){if(s){B.addSelectionInterval(i,i);}else{B.removeSelectionInterval(i,i);}}}return this;};
c.prototype._getExpanderControl=function(){var s=this.CollapsedIconURI;if(this.getExpanded()){s=this.ExpandedIconURI;}if(this._oExpanderControl){this._oExpanderControl.setSrc(s);return this._oExpanderControl;}this._oExpanderControl=new a({id:this.getId()+"-expander",src:s,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMTreeItemBaseExpander").attachPress(function(e){this.informTree("ExpanderPressed");},this);return this._oExpanderControl;};
c.prototype._updateItem=function(){if(this._bInvalidated){return;}var t=this.getTree();if(t&&t._bInvalidated){return;}if(this._oExpanderControl){var s=this.CollapsedIconURI;if(this.getExpanded()){s=this.ExpandedIconURI;}this._oExpanderControl.setSrc(s);var $=this.$();if(!this.isLeaf()){$.removeClass("sapMTreeItemBaseLeaf");$.attr("aria-expanded",this.getExpanded());}else{$.addClass("sapMTreeItemBaseLeaf");$.removeAttr("aria-expanded");}$.toggleClass("sapMTreeItemBaseChildren",!this.isTopLevel());$.attr("aria-level",this.getLevel()+1);var i=this._getPadding(),S=sap.ui.getCore().getConfiguration().getRTL()?"paddingRight":"paddingLeft";$.css(S,i+"rem");}};
c.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);this._bInvalidated=true;};
c.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.apply(this,arguments);this._bInvalidated=false;};
c.prototype.setBindingContext=function(){L.prototype.setBindingContext.apply(this,arguments);this._updateItem();return this;};
c.prototype._getPadding=function(){var t=this.getTree(),n=this.getLevel(),i=0,d;if(t){d=t.getDeepestLevel();}if(d<n){t._iDeepestLevel=n;d=t._iDeepestLevel;}if(d<2){i=n*1.5;}else if(d===2){i=n*1;}else if(d<6){i=n*0.5;}else{i=n*0.25;}return i;};
c.prototype.onsapplus=function(e){this.informTree("ExpanderPressed",true);};
c.prototype.onsapminus=function(e){this.informTree("ExpanderPressed",false);};
c.prototype.onsapright=function(e){if(e.srcControl!==this||this.isLeaf()){return;}if(!this.getExpanded()){this.informTree("ExpanderPressed",true);}else{e.keyCode=K.ARROW_DOWN;}};
c.prototype.onsapleft=function(e){if(e.srcControl!==this||this.isTopLevel()&&!this.getExpanded()){return;}if(!this.isLeaf()){if(this.getExpanded()){this.informTree("ExpanderPressed",false);}else{this.getParentNode().focus();}}else{this.getParentNode().focus();}};
c.prototype.onsapbackspace=function(e){if(e.srcControl!==this){return;}if(!this.isTopLevel()){this.getParentNode().focus();}};
c.prototype.getAccessibilityType=function(B){return B.getText("ACC_CTR_TYPE_TREEITEM");};
c.prototype.exit=function(){L.prototype.exit.apply(this,arguments);this.destroyControls(["Expander"]);};
c.prototype.onlongdragover=function(e){this.informTree("LongDragOver");};
return c;});
sap.ui.predefine('sap/m/TreeItemBaseRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var T=R.extend(L);T.apiVersion=2;
T.renderLIAttributes=function(r,l){r.class("sapMTreeItemBase");if(!l.isTopLevel()){r.class("sapMTreeItemBaseChildren");}if(l.isLeaf()){r.class("sapMTreeItemBaseLeaf");}else{r.attr("aria-expanded",l.getExpanded());}var i=l._getPadding();if(sap.ui.getCore().getConfiguration().getRTL()){r.style("padding-right",i+"rem");}else{r.style("padding-left",i+"rem");}};
T.renderContentFormer=function(r,l){this.renderHighlight(r,l);this.renderExpander(r,l);this.renderMode(r,l,-1);};
T.renderExpander=function(r,l){var e=l._getExpanderControl();if(e){r.renderControl(e);}};
T.getAriaRole=function(l){return"treeitem";};
T.getAccessibilityState=function(l){var a=L.getAccessibilityState.call(this,l);a.level=l.getLevel()+1;if(!l.isLeaf()){a.expanded=l.getExpanded();}return a;};
return T;},true);
sap.ui.predefine('sap/m/TreeRenderer',['sap/ui/core/Renderer','./ListBaseRenderer'],function(R,L){"use strict";var T=R.extend(L);T.apiVersion=2;
T.getAriaRole=function(c){return"tree";};
return T;},true);
sap.ui.predefine('sap/m/UploadCollection',["./library","sap/m/library","sap/m/MessageBox","sap/m/Dialog","sap/ui/core/Control","sap/ui/core/Icon","sap/ui/core/IconPool","sap/m/Image","sap/m/Text","sap/m/Title","sap/m/Button","sap/m/List","sap/m/BusyIndicator","sap/m/StandardListItem","sap/ui/unified/FileUploaderParameter","sap/ui/unified/FileUploader","sap/ui/core/format/FileSizeFormat","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/m/ObjectAttribute","sap/m/UploadCollectionItem","sap/m/UploadCollectionParameter","sap/m/UploadCollectionToolbarPlaceholder","sap/ui/core/HTML","sap/m/CustomListItem","sap/ui/core/ResizeHandler","sap/ui/Device","./UploadCollectionRenderer","sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/dom/jquery/selectText"],function(L,M,a,D,C,I,b,c,T,d,B,f,g,S,F,h,k,O,l,m,U,n,o,H,p,R,q,r,Q,K,s){"use strict";
var t=C.extend("sap.m.UploadCollection",{
constructor:function(i,j){var u;if(j&&j.instantUpload!==undefined){if(j.instantUpload===false){u=j.instantUpload;}delete j.instantUpload;}else if(i&&i.instantUpload!==undefined){if(i.instantUpload===false){u=i.instantUpload;}delete i.instantUpload;}if(j&&j.mode===L.ListMode.MultiSelect&&u===false){j.mode=L.ListMode.None;s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}else if(i&&i.mode===L.ListMode.MultiSelect&&u===false){i.mode=L.ListMode.None;s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}try{C.apply(this,arguments);if(u===false){this.bInstantUpload=u;this._oFormatDecimal=k.getInstance({binaryFilesize:true,maxFractionDigits:1,maxIntegerDigits:3});}}catch(e){this.destroy();throw e;}},
metadata:{library:"sap.m",properties:{fileType:{type:"string[]",group:"Data",defaultValue:null},maximumFilenameLength:{type:"int",group:"Data",defaultValue:null},maximumFileSize:{type:"float",group:"Data",defaultValue:null},mimeType:{type:"string[]",group:"Data",defaultValue:null},multiple:{type:"boolean",group:"Behavior",defaultValue:false},noDataText:{type:"string",group:"Appearance",defaultValue:null},noDataDescription:{type:"string",group:"Appearance",defaultValue:null},sameFilenameAllowed:{type:"boolean",group:"Behavior",defaultValue:false},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:"All"},uploadEnabled:{type:"boolean",group:"Behavior",defaultValue:true},uploadUrl:{type:"string",group:"Data",defaultValue:"../../../upload"},instantUpload:{type:"boolean",group:"Behavior",defaultValue:true},numberOfAttachmentsText:{type:"string",group:"Appearance",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:"None"},uploadButtonInvisible:{type:"boolean",group:"Appearance",defaultValue:false},terminationEnabled:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.UploadCollectionItem",multiple:true,singularName:"item",bindable:"bindable"},headerParameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"headerParameter"},parameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"parameter"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false,forwarding:{idSuffix:"-list",aggregation:"infoToolbar"}},_list:{type:"sap.m.List",multiple:false,visibility:"hidden"},_noDataIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_dragDropIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_dragDropText:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{change:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileDeleted:{parameters:{documentId:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},filenameLengthExceed:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileRenamed:{parameters:{documentId:{type:"string"},fileName:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},fileSizeExceed:{parameters:{documentId:{type:"string"},fileSize:{type:"string"},files:{type:"object[]"}}},typeMissmatch:{parameters:{documentId:{type:"string"},fileType:{type:"string"},mimeType:{type:"string"},files:{type:"object[]"}}},uploadComplete:{parameters:{readyStateXHR:{type:"string"},response:{type:"string"},status:{type:"string"},files:{type:"object[]"}}},uploadTerminated:{parameters:{fileName:{type:"string"},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},beforeUploadStarts:{parameters:{fileName:{type:"string"},addHeaderParameter:{type:"function",parameters:{headerParameter:{type:"sap.m.UploadCollectionParameter"}}},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},selectionChange:{parameters:{selectedItem:{type:"sap.m.UploadCollectionItem"},selectedItems:{type:"sap.m.UploadCollectionItem[]"},selected:{type:"boolean"}}}}}
});
t._uploadingStatus="uploading";t._displayStatus="display";t._toBeDeletedStatus="toBeDeleted";t._pendingUploadStatus="pendingUploadStatus";t._placeholderCamera="sap-icon://card";t._markerMargin=8;if(q.system.phone){t._resizeTimeoutInterval=500;}else{t._resizeTimeoutInterval=100;}
t.prototype.init=function(){t.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._headerParamConst={requestIdName:"requestId"+Q.now(),fileNameRequestIdName:"fileNameRequestId"+Q.now()};this._requestIdValue=0;this._iFUCounter=0;this._oList=new f(this.getId()+"-list",{selectionChange:[this._handleSelectionChange,this]});this.setAggregation("_list",this._oList,true);this._oList.addStyleClass("sapMUCList");this.setAggregation("_noDataIcon",new I(this.getId()+"-no-data-icon",{src:"sap-icon://document",size:"6rem",noTabStop:true}),true);this.setAggregation("_dragDropIcon",new I(this.getId()+"-drag-drop-icon",{src:"sap-icon://upload-to-cloud",size:"4rem",noTabStop:true}),true);this.setAggregation("_dragDropText",new T(this.getId()+"-drag-drop-text",{text:this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR")}),true);this._iUploadStartCallCounter=0;this.aItems=[];this._aDeletedItemForPendingUpload=[];this._aFileUploadersForPendingUpload=[];this._aFilesFromDragAndDropForPendingUpload=[];this._iFileUploaderPH=null;this._oListEventDelegate=null;this._oItemToUpdate=null;this._sReziseHandlerId=null;};
t.prototype.setFileType=function(e){if(!e){return this;}if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change fileType at runtime.");}else{var j=e.length;for(var i=0;i<j;i++){e[i]=e[i].toLowerCase();}if(this.getFileType()!==e){this.setProperty("fileType",e,true);this._getFileUploader().setFileType(e);}}return this;};
t.prototype.setMaximumFilenameLength=function(i){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change maximumFilenameLength at runtime.");}else if(this.getMaximumFilenameLength()!==i){this.setProperty("maximumFilenameLength",i,true);this._getFileUploader().setMaximumFilenameLength(i);}return this;};
t.prototype.setMaximumFileSize=function(i){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change maximumFileSize at runtime.");}else if(this.getMaximumFileSize()!==i){this.setProperty("maximumFileSize",i,true);this._getFileUploader().setMaximumFileSize(i);}return this;};
t.prototype.setMimeType=function(e){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change mimeType at runtime.");}else if(this.getMimeType()!==e){this.setProperty("mimeType",e,true);this._getFileUploader().setMimeType(e);}return this;};
t.prototype.setMultiple=function(e){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change multiple at runtime.");}else if(this.getMultiple()!==e){this.setProperty("multiple",e);this._getFileUploader().setMultiple(e);}return this;};
t.prototype.setShowSeparators=function(e){if(this.getShowSeparators()!==e){this.setProperty("showSeparators",e);this._oList.setShowSeparators(e);}return this;};
t.prototype.setUploadEnabled=function(u){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change uploadEnabled at runtime.");}else if(this.getUploadEnabled()!==u){this.setProperty("uploadEnabled",u);this._getFileUploader().setEnabled(u);}return this;};
t.prototype.setUploadUrl=function(u){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change uploadUrl at runtime.");}else if(this.getUploadUrl()!==u){this.setProperty("uploadUrl",u);this._getFileUploader().setUploadUrl(u);}return this;};
t.prototype.setInstantUpload=function(){s.error("It is not supported to change the behavior at runtime.");return this;};
t.prototype.setMode=function(e){if(e===L.ListMode.Delete){this._oList.setMode(L.ListMode.None);s.info("sap.m.ListMode.Delete is not supported by UploadCollection. Value has been resetted to 'None'");}else if(e===L.ListMode.MultiSelect&&!this.getInstantUpload()){this._oList.setMode(L.ListMode.None);s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Pending Upload. Value has been resetted to 'None'");}else{this._oList.setMode(e);}return this;};
t.prototype.getMode=function(){return this._oList.getMode();};
t.prototype.getToolbar=function(){return this._oHeaderToolbar;};
t.prototype.getNoDataText=function(){var N=this.getProperty("noDataText");N=N||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_TEXT");return N;};
t.prototype.getNoDataDescription=function(){var N=this.getProperty("noDataDescription");N=N||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_DESCRIPTION");return N;};
t.prototype.setUploadButtonInvisible=function(u){if(this.getUploadButtonInvisible()===u){return this;}this.setProperty("uploadButtonInvisible",u,true);if(this.getInstantUpload()){this._getFileUploader().setVisible(!u);}else{this._setFileUploaderVisibility(u);}if(this._bDragDropEnabled){this._unbindDragEnterLeave();this._bDragDropEnabled=false;}else{this._bindDragEnterLeave();}return this;};
t.prototype.getInternalRequestHeaderNames=function(){return[this._headerParamConst.fileNameRequestIdName,this._headerParamConst.requestIdName];};
t.prototype.upload=function(){if(this.getInstantUpload()){s.error("Not a valid API call. 'instantUpload' should be set to 'false'.");}var e=this._aFileUploadersForPendingUpload.length;for(var i=0;i<e;i++){this._iUploadStartCallCounter=0;if(this._aFileUploadersForPendingUpload[i].getValue()){this._aFileUploadersForPendingUpload[i].upload();}}if(this._aFilesFromDragAndDropForPendingUpload.length>0){this._oFileUploader._sendFilesFromDragAndDrop(this._aFilesFromDragAndDropForPendingUpload);this._aFilesFromDragAndDropForPendingUpload=[];}};
t.prototype.getSelectedItems=function(){var e=this._oList.getSelectedItems();return this._getUploadCollectionItemsByListItems(e);};
t.prototype.getSelectedItem=function(){var e=this._oList.getSelectedItem();if(e){return this._getUploadCollectionItemByListItem(e);}return null;};
t.prototype.setSelectedItemById=function(i,e){this._oList.setSelectedItemById(i+"-cli",e);this._setSelectedForItems([this._getUploadCollectionItemById(i)],e);return this;};
t.prototype.setSelectedItem=function(u,e){return this.setSelectedItemById(u.getId(),e);};
t.prototype.selectAll=function(){var e=this._oList.selectAll();if(e.getItems().length!==this.getItems().length){s.info("Internal 'List' and external 'UploadCollection' are not in sync.");}this._setSelectedForItems(this.getItems(),true);return this;};
t.prototype.downloadItem=function(u,e){if(!this.getInstantUpload()){s.info("Download is not possible on Pending Upload mode");return false;}else{return u.download(e);}};
t.prototype.openFileDialog=function(i){if(this._oFileUploader){if(i){if(!this._oFileUploader.getMultiple()){this._oItemToUpdate=i;this._oFileUploader.$().find("input[type=file]").trigger("click");}else{s.warning("Version Upload cannot be used in multiple upload mode");}}else{this._oFileUploader.$().find("input[type=file]").trigger("click");}}return this;};
t.prototype.removeAggregation=function(A,v,e){var i,j,u;if(!this.getInstantUpload()&&A==="items"&&v){i=v._internalFileIdWithinDragDropArray;if(i){j=this._aFilesFromDragAndDropForPendingUpload.indexOf(i);if(j!==-1){this._aFilesFromDragAndDropForPendingUpload.splice(j,1);}}else if(Q.isNumeric(v)){u=this.getItems();this._aDeletedItemForPendingUpload.push(u[v]);}else{this._aDeletedItemForPendingUpload.push(v);}}return C.prototype.removeAggregation.apply(this,arguments);};
t.prototype.removeAllAggregation=function(A,e){if(!this.getInstantUpload()&&A==="items"){if(this._aFileUploadersForPendingUpload){for(var i=0;i<this._aFileUploadersForPendingUpload.length;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=[];}}return C.prototype.removeAllAggregation.apply(this,arguments);};
t.prototype.onBeforeRendering=function(){this._RenderManager=this._RenderManager||sap.ui.getCore().createRenderManager();var i,e;if(this._oListEventDelegate){this._oList.removeEventDelegate(this._oListEventDelegate);this._oListEventDelegate=null;}this._deregisterSizeHandler();this._unbindDragEnterLeave();j.bind(this)();if(!this.getInstantUpload()){this.aItems=this.getItems();this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setHeaderToolbar(this._oHeaderToolbar);return;}if(this.aItems.length>0){e=this.aItems.length;var u=[];for(i=0;i<e;i++){if(this.aItems[i]&&this.aItems[i]._status===t._uploadingStatus){u.push(this.aItems[i]);}else if(this.aItems[i]&&this.aItems[i]._status!==t._uploadingStatus&&this.aItems[i]._percentUploaded===100&&this.getItems().length===0){u.push(this.aItems[i]);}}if(u.length!==0){this.aItems=[];this.aItems=this.getItems();this.aItems=u.concat(this.aItems);}else{this.aItems=this.getItems();}}else{this.aItems=this.getItems();}this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setAggregation("headerToolbar",this._oHeaderToolbar,true);if(this.sErrorState!=="Error"){if(this.getUploadEnabled()!==this._oFileUploader.getEnabled()){this._oFileUploader.setEnabled(this.getUploadEnabled());}}else{this._oFileUploader.setEnabled(false);}if(this.sDeletedItemId){Q(document.activeElement).blur();}function j(){if(this.bInstantUpload===false){this.setProperty("instantUpload",this.bInstantUpload,true);delete this.bInstantUpload;}}};
t.prototype.onAfterRendering=function(){this._bindDragEnterLeave();if(this.getInstantUpload()){if(this.aItems||(this.aItems===this.getItems())){if(this.editModeItem){var $=Q(document.getElementById(this.editModeItem+"-ta_editFileName-inner"));if($){var i=this.editModeItem;if(!q.os.ios){$.focus(function(){$.selectText(0,$.val().length);});}$.focus();this._oListEventDelegate={onclick:function(e){this._handleClick(e,i);}.bind(this)};this._oList.addDelegate(this._oListEventDelegate);}}else if(this.sFocusId){this._setFocusToLineItem(this.sFocusId);this.sFocusId=null;}else if(this.sDeletedItemId){this._setFocusAfterDeletion();}}}else if(this.sFocusId){this._setFocusToLineItem(this.sFocusId);this.sFocusId=null;}};
t.prototype.exit=function(){var i,P,e;this._unbindDragEnterLeave();if(this._$RootNode){this._$RootNode=null;}if(this._oFileUploader){this._oFileUploader.destroy();this._oFileUploader=null;}if(this._oHeaderToolbar){this._oHeaderToolbar.destroy();this._oHeaderToolbar=null;}if(this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle.destroy();this._oNumberOfAttachmentsTitle=null;}if(this._RenderManager){this._RenderManager.destroy();}if(this._aFileUploadersForPendingUpload){P=this._aFileUploadersForPendingUpload.length;for(i=0;i<P;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=null;}for(i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===t._uploadingStatus){e=this.aItems.splice(i,1)[0];if(e.destroy){e.destroy();}}}this._deregisterSizeHandler();};
t.prototype._bindDragEnterLeave=function(){this._bDragDropEnabled=this._isDragAndDropAllowed();if(!this._bDragDropEnabled){return;}if(!this._oDragDropHandler){this._oDragDropHandler={dragEnterUIArea:this._onDragEnterUIArea.bind(this),dragLeaveUIArea:this._onDragLeaveUIArea.bind(this),dragOverUIArea:this._onDragOverUIArea.bind(this),dropOnUIArea:this._onDropOnUIArea.bind(this),dragEnterUploadCollection:this._onDragEnterUploadCollection.bind(this),dragLeaveUploadCollection:this._onDragLeaveUploadCollection.bind(this),dragOverUploadCollection:this._onDragOverUploadCollection.bind(this),dropOnUploadCollection:this._onDropOnUploadCollection.bind(this)};}this._$RootNode=Q(document.body);this._$RootNode.bind("dragenter",this._oDragDropHandler.dragEnterUIArea);this._$RootNode.bind("dragleave",this._oDragDropHandler.dragLeaveUIArea);this._$RootNode.bind("dragover",this._oDragDropHandler.dragOverUIArea);this._$RootNode.bind("drop",this._oDragDropHandler.dropOnUIArea);this._$DragDropArea=this.$("drag-drop-area");this.$().bind("dragenter",this._oDragDropHandler.dragEnterUploadCollection);this.$().bind("dragleave",this._oDragDropHandler.dragLeaveUploadCollection);this.$().bind("dragover",this._oDragDropHandler.dragOverUploadCollection);this.$().bind("drop",this._oDragDropHandler.dropOnUploadCollection);};
t.prototype._unbindDragEnterLeave=function(){if(!this._bDragDropEnabled&&!this._oDragDropHandler){return;}if(this._$RootNode){this._$RootNode.unbind("dragenter",this._oDragDropHandler.dragEnterUIArea);this._$RootNode.unbind("dragleave",this._oDragDropHandler.dragLeaveUIArea);this._$RootNode.unbind("dragover",this._oDragDropHandler.dragOverUIArea);this._$RootNode.unbind("drop",this._oDragDropHandler.dropOnUIArea);}this.$().unbind("dragenter",this._oDragDropHandler.dragEnterUploadCollection);this.$().unbind("dragleave",this._oDragDropHandler.dragLeaveUploadCollection);this.$().unbind("dragover",this._oDragDropHandler.dragOverUploadCollection);this.$().unbind("drop",this._oDragDropHandler.dropOnUploadCollection);};
t.prototype._onDragEnterUIArea=function(e){if(!this._checkForFiles(e)){return;}this._oLastEnterUIArea=e.target;this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");this._adjustDragDropIcon();};
t.prototype._onDragOverUIArea=function(e){e.preventDefault();if(!this._checkForFiles(e)){return;}this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");};
t.prototype._onDragLeaveUIArea=function(e){if(this._oLastEnterUIArea===e.target){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
t.prototype._onDropOnUIArea=function(e){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");};
t.prototype._onDragEnterUploadCollection=function(e){if(!this._checkForFiles(e)){return;}if(e.target===this._$DragDropArea[0]){this._$DragDropArea.addClass("sapMUCDropIndicator");this._adjustDragDropIcon();this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DROP_FILE_INDICATOR"));}};
t.prototype._onDragOverUploadCollection=function(e){e.preventDefault();};
t.prototype._onDragLeaveUploadCollection=function(e){if(e.target===this._$DragDropArea[0]){this._$DragDropArea.removeClass("sapMUCDropIndicator");this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR"));}};
t.prototype._checkForFiles=function(e){var j=e.originalEvent.dataTransfer.types;if(j){for(var i=0;i<j.length;i++){if(j[i]==="Files"){return true;}}}return false;};
t.prototype._isDragAndDropAllowed=function(){return this.getUploadEnabled()&&!this.getUploadButtonInvisible();};
t.prototype._onDropOnUploadCollection=function(e){if(!this._checkForFiles(e)){e.preventDefault();return;}if(e.target===this._$DragDropArea[0]){e.preventDefault();this._$DragDropArea.removeClass("sapMUCDropIndicator");this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR"));var j=e.originalEvent.dataTransfer.files;if(j.length>1&&!this.getMultiple()){var u=this._oRb.getText("UPLOADCOLLECTION_MULTIPLE_FALSE");a.error(u);return;}if(!this._oFileUploader._areFilesAllowed(j)){return;}if(!this.getInstantUpload()){for(var i=0;i<j.length;i++){this._oFileUploader.fireChange({files:[j[i]],fromDragDrop:true});this._aFilesFromDragAndDropForPendingUpload.push(j[i]);}}else{this._oFileUploader.fireChange({files:j});this._oFileUploader._sendFilesFromDragAndDrop(j);}}};
t.prototype._adjustDragDropIcon=function(){if(this._$DragDropArea[0].offsetHeight<160){this.getAggregation("_dragDropIcon").$().hide();}};
t.prototype._deregisterSizeHandler=function(){q.orientation.detachHandler(this._onResize,this);R.deregister(this._sReziseHandlerId);};
t.prototype._hideFileUploaders=function(){var e,i;if(!this.getInstantUpload()){e=this._oHeaderToolbar.getContent().length;if(this._aFileUploadersForPendingUpload.length){for(i=0;i<e;i++){if(this._oHeaderToolbar.getContent()[i]instanceof h){if(i===this._iFileUploaderPH&&this._bFocusFileUploader){this._oHeaderToolbar.getContent()[i].$().find("button").focus();}else{this._oHeaderToolbar.getContent()[i].$().hide();}}}}}};
t.prototype._truncateFileName=function(e){if(!e){return;}if(e._status==="Edit"){e._oListItem.$().find(".sapMUCObjectMarkerContainer").attr("style","display: none");return;}var j=0;var u=e.getMarkers();var v;for(var i=0;i<u.length;i++){j=j+u[i].$().width()+t._markerMargin;}if(j>0){var $=e._oFileNameLink.$();if($){v="max-width: calc(100% - "+j+"px)";if($.attr("style")!==v){$.attr("style",v);}}}};
t.prototype._getListHeader=function(e){var j,i;this._setNumberOfAttachmentsTitle(e);if(!this._oHeaderToolbar){if(!!this._oFileUploader&&!this.getInstantUpload()){this._oFileUploader.destroy();}j=this._getFileUploader();this._oHeaderToolbar=this.getAggregation("toolbar");if(!this._oHeaderToolbar){this._oHeaderToolbar=new O(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new l(),j]}).addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=2;}else{this._oHeaderToolbar.addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=this._getFileUploaderPlaceHolderPosition(this._oHeaderToolbar);if(this._oHeaderToolbar&&this._iFileUploaderPH>-1){this._setFileUploaderInToolbar(j);}else{s.info("A place holder of type 'sap.m.UploadCollectionPlaceholder' needs to be provided.");}}}else if(!this.getInstantUpload()){var P=this._aFileUploadersForPendingUpload.length;for(i=P-1;i>=0;i--){if(this._aFileUploadersForPendingUpload[i].getId()===this._oFileUploader.getId()){j=this._getFileUploader();this._oHeaderToolbar.insertAggregation("content",j,this._iFileUploaderPH,true);break;}}}};
t.prototype._getFileUploaderPlaceHolderPosition=function(e){for(var i=0;i<e.getContent().length;i++){if(e.getContent()[i]instanceof o){return i;}}return-1;};
t.prototype._setFileUploaderInToolbar=function(e){this._oHeaderToolbar.getContent()[this._iFileUploaderPH].setVisible(false);this._oHeaderToolbar.insertContent(e,this._iFileUploaderPH);};
t.prototype._mapItemToListItem=function(i){if(!i||(this._oItemToUpdate&&i.getId()===this._oItemToUpdate.getId())){return null;}var e,j,u,v,w,x,$,y,z;e=i.getId();j=i._status;u=i.getFileName();if(j===t._uploadingStatus){v=new g({id:e+"-ia_indicator"});v.addStyleClass("sapMUCloadingIcon");}else{z=this._createIcon(i,e,u);}x=e+"-container";$=Q(document.getElementById(x));if($){$.remove();$=null;}y=new H({content:"<span id="+x+" class='sapMUCTextButtonContainer'></span>",afterRendering:this._renderContent.bind(this,i,x)});w=new p(e+"-cli",{content:[v,z,y],selected:i.getSelected()});w._oUploadCollectionItem=i;w._status=j;w.addStyleClass("sapMUCItem");w.setTooltip(i.getTooltip_Text());i._oListItem=w;return w;};
t.prototype._renderContent=function(e,j){var u,i,A,v,w,P,x,y,z,E,G;P=e._percentUploaded;x=e.getAllAttributes();y=e.getStatuses();G=e.getMarkers();u=e.getId();A=x.length;v=y.length;w=G.length;E=e._status;z=this._RenderManager;z.write("<div class=\"sapMUCTextContainer ");if(E==="Edit"){z.write("sapMUCEditMode ");}z.write("\" >");z.renderControl(this._getFileNameControl(e));if(E===t._uploadingStatus){z.renderControl(this._createProgressLabel(e,P));}else{if(w>0){z.write("<div class=\"sapMUCObjectMarkerContainer\">");for(i=0;i<w;i++){z.renderControl(G[i].addStyleClass("sapMUCObjectMarker"));}z.write("</div>");}if(A>0){z.write("<div class=\"sapMUCAttrContainer\">");for(i=0;i<A;i++){x[i].addStyleClass("sapMUCAttr");z.renderControl(x[i]);if((i+1)<A){z.write("<div class=\"sapMUCSeparator\">&nbsp&#x00B7&#160</div>");}}z.write("</div>");}if(v>0){z.write("<div class=\"sapMUCStatusContainer\">");for(i=0;i<v;i++){y[i].detachBrowserEvent("hover");z.renderControl(y[i]);if((i+1)<v){z.write("<div class=\"sapMUCSeparator\">&nbsp&#x00B7&#160</div>");}}z.write("</div>");}}z.write("</div>");this._renderButtons(z,e,E,u);z.flush(Q(document.getElementById(j))[0],true);this._truncateFileName(e);this._sReziseHandlerId=R.register(this,this._onResize.bind(this));q.orientation.attachHandler(this._onResize,this);};
t.prototype._renderButtons=function(e,j,u,v){var w,x;w=this._getButtons(j,u,v);if(w){x=w.length;}if(x>0){e.write("<div class=\"sapMUCButtonContainer\">");for(var i=0;i<x;i++){if((i+1)<x){w[i].addStyleClass("sapMUCFirstButton");}e.renderControl(w[i]);}e.write("</div>");}};
t.prototype._getFileNameControl=function(i){var e,j,u,v,w,x,y,V,z,A,E;v=i.getFileName();w=i.getId();x=i._status;if(x!=="Edit"){e=i._getFileNameLink?i._getFileNameLink():i._getControl("sap.m.Link",{id:w+"-ta_filenameHL",press:[i,this._onItemPressed,this]},"FileNameLink");e.setEnabled(this._getItemPressEnabled(i));e.addStyleClass("sapMUCFileName");e.setModel(i.getModel());e.setText(v);i._oFileNameLink=e;return e;}else{j=t._splitFilename(v);y=this.getMaximumFilenameLength();V="None";z=false;u=j.name;if(i.errorState==="Error"){z=true;V="Error";u=i.changedFileName;if(u.length===0){E=this._oRb.getText("UPLOADCOLLECTION_TYPE_FILENAME");}else{E=this._oRb.getText("UPLOADCOLLECTION_EXISTS");}}A=i._getFileNameEditBox?i._getFileNameEditBox():i._getControl("sap.m.Input",{id:w+"-ta_editFileName",type:L.InputType.Text},"FileNameEditBox");A.addStyleClass("sapMUCEditBox");A.setModel(i.getModel());A.setValue(u);A.setValueState(V);A.setFieldWidth("75%");A.setValueStateText(E);A.setDescription(j.extension);A.setShowValueStateMessage(z);if((y-j.extension.length)>0){A.setProperty("maxLength",y-j.extension.length,true);}return A;}};
t.prototype._getItemPressEnabled=function(i){return i._getPressEnabled()&&this.sErrorState!=="Error";};
t.prototype._onItemPressed=function(e,i){if(i.hasListeners("press")){i.firePress();}else if(this.sErrorState!=="Error"&&Q.trim(i.getProperty("url"))){this._triggerLink(e,i);}};
t.prototype._createProgressLabel=function(i,e){var P,j=i.getId();P=i._getProgressLabel?i._getProgressLabel():i._getControl("sap.m.Label",{id:j+"-ta_progress"},"ProgressLabel").addStyleClass("sapMUCProgress");P.setText(this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[e]));return P;};
t.prototype._createIcon=function(i,e,j){var u,v,w,x;u=i.getThumbnailUrl();if(u){w=b.createControlByURI({id:e+"-ia_imageHL",src:this._getThumbnail(u,j),decorative:false},c).addStyleClass("sapMUCItemImage sapMUCItemIcon");w.setAlt(this._getAriaLabelForPicture(i));}else{v=this._getThumbnail(undefined,j);w=new I(e+"-ia_iconHL",{src:v,decorative:false,useIconTooltip:false});w.setAlt(this._getAriaLabelForPicture(i));if(this.sErrorState!=="Error"&&Q.trim(i.getProperty("url"))){x="sapMUCItemIcon";}else{x="sapMUCItemIconInactive";}if(v===t._placeholderCamera){if(this.sErrorState!=="Error"&&Q.trim(i.getProperty("url"))){x=x+" sapMUCItemPlaceholder";}else{x=x+" sapMUCItemPlaceholderInactive";}}w.addStyleClass(x);}if(this._getItemPressEnabled(i)){w.attachPress(i,this._onItemPressed,this);}return w;};
t.prototype._getButtons=function(i,e,j){var u,v,w,x,y,E,z;u=[];if(!this.getInstantUpload()){x="deleteButton";y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);return u;}if(e==="Edit"){v=i._getOkButton?i._getOkButton():i._getControl("sap.m.Button",{id:j+"-okButton",text:this._oRb.getText("UPLOADCOLLECTION_RENAMEBUTTON_TEXT"),type:L.ButtonType.Transparent},"OkButton").addStyleClass("sapMUCOkBtn");w=i._getCancelButton?i._getCancelButton():i._getControl("sap.m.Button",{id:j+"-cancelButton",text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),type:L.ButtonType.Transparent},"CancelButton").addStyleClass("sapMUCCancelBtn");u.push(v);u.push(w);}else if(e===t._uploadingStatus){x="terminateButton";y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);}else{E=i.getEnableEdit();if(this.sErrorState==="Error"){E=false;}if(i.getVisibleEdit()){z=i._getEditButton?i._getEditButton():i._getControl("sap.m.Button",{id:j+"-editButton",icon:"sap-icon://edit",type:L.ButtonType.Standard,tooltip:this._oRb.getText("UPLOADCOLLECTION_EDITBUTTON_TEXT"),press:[i,this._handleEdit,this]},"EditButton").addStyleClass("sapMUCEditBtn");z.setEnabled(E);z.setVisible(i.getVisibleEdit());u.push(z);}x="deleteButton";if(i.getVisibleDelete()){y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);}}return u;};
t.prototype._createDeleteButton=function(i,e,j,u){var E,v,G,w,x,V,P;E=j.getEnableDelete();if(u==="Error"){E=false;}if(e==="deleteButton"){G="DeleteButton";x=j._getDeleteButton;w=this._oRb.getText("UPLOADCOLLECTION_DELETEBUTTON_TEXT");V=j.getVisibleDelete();P=[this,this._handleDelete,this];}else{G="TerminateButton";x=j._getTerminateButton;w=this._oRb.getText("UPLOADCOLLECTION_TERMINATEBUTTON_TEXT");V=this.getTerminationEnabled();P=[j,this._handleTerminate,this];}v=x?x():j._getControl("sap.m.Button",{id:i+"-"+e,icon:"sap-icon://sys-cancel",type:L.ButtonType.Standard,press:P},G).addStyleClass("sapMUCDeleteBtn");v.setVisible(V);v.setEnabled(E);v.setTooltip(w);return v;};
t.prototype._fillList=function(i){var e=this,j=i.length-1,u=this.getBinding("items"),G=false,v,w=this.getBindingInfo("items")?this.getBindingInfo("items").model:undefined,x=this.getBindingInfo("items")?this.getBindingInfo("items").groupHeaderFactory:null;var y=function(A){return A.getBindingContext(w)?u.getGroup(A.getBindingContext(w)):null;};var z=function(A){return y(A)&&y(A).key;};Q.each(i,function(A,E){if(u&&u.isGrouped()&&E){if(!G||v!==z(E)){if(x){e._oList.addItemGroup(y(E),x(y(E)),true);}else if(y(E)){e._oList.addItemGroup(y(E),null,true);}G=true;v=z(E);}}if(!E._status){E._status=t._displayStatus;}else if(e.getInstantUpload()&&e._oItemForDelete&&e._oItemForDelete._status===t._toBeDeletedStatus&&E.getDocumentId()===e._oItemForDelete.documentId){return false;}if(!E._percentUploaded&&E._status===t._uploadingStatus){E._percentUploaded=0;}var J=e._mapItemToListItem(E);if(J){if(A===0&&j===0){J.addStyleClass("sapMUCListSingleItem");}else if(A===0){J.addStyleClass("sapMUCListFirstItem");}else if(A===j){J.addStyleClass("sapMUCListLastItem");}else{J.addStyleClass("sapMUCListItem");}e._oList.addAggregation("items",J,true);E.attachEvent("selected",e._handleItemSetSelected,e);}return true;});};
t.prototype._clearList=function(){if(this._oList){this._oList.destroyAggregation("items",true);}};
t.prototype._setNumberOfAttachmentsTitle=function(e){var i=e||0;var j;if(this._oItemToUpdate){i--;}if(this.getNumberOfAttachmentsText()){j=this.getNumberOfAttachmentsText();}else{j=this._oRb.getText("UPLOADCOLLECTION_ATTACHMENTS",[i]);}if(!this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle=new d(this.getId()+"-numberOfAttachmentsTitle",{text:j});}else{this._oNumberOfAttachmentsTitle.setText(j);}};
t.prototype._setFileUploaderVisibility=function(u){var e=this._oHeaderToolbar.getContent();if(e){var P=e[this._iFileUploaderPH];if(P instanceof h){P.setVisible(!u);}}};
t.prototype._handleDelete=function(e){var P=e.getParameters();var j=this.getItems();var u=P.id.split("-deleteButton")[0];var v;var w;var x="";var y;var z;for(var i=0;i<j.length;i++){if(j[i].sId===u){w=i;v={documentId:j[i].getDocumentId(),_iLineNumber:w};break;}}if(j[w].hasListeners("deletePress")){j[w].fireDeletePress();return;}this.sDeletedItemId=u;if(Q(document.getElementById(this.sId)).hasClass("sapUiSizeCompact")){x="sapUiSizeCompact";}if(this.editModeItem){this._handleOk(e,this.editModeItem,true);if(this.sErrorState==="Error"){return;}}if(j[w]&&j[w].getEnableDelete()){y=j[w].getFileName();if(!y){z=this._oRb.getText("UPLOADCOLLECTION_DELETE_WITHOUT_FILENAME_TEXT");}else{z=this._oRb.getText("UPLOADCOLLECTION_DELETE_TEXT",y);}this._oItemForDelete=v;a.show(z,{title:this._oRb.getText("UPLOADCOLLECTION_DELETE_TITLE"),actions:[a.Action.OK,a.Action.CANCEL],onClose:this._onCloseMessageBoxDeleteItem.bind(this),dialogId:"messageBoxDeleteFile",styleClass:x});}};
t.prototype._onCloseMessageBoxDeleteItem=function(e){var j=this.getItems();var u;if(this.getInstantUpload()){for(var i=0;i<j.length;i++){if(j[i].getDocumentId()===this._oItemForDelete.documentId){u=j[i];}}}else{u=j[this._oItemForDelete._iLineNumber];}if(e===a.Action.OK){this._oItemForDelete._status=t._toBeDeletedStatus;if(this.getInstantUpload()){this.fireFileDeleted({documentId:this._oItemForDelete.documentId,item:u});this._oItemForDelete=null;}else{if(this.aItems.length===1){if(!this.getUploadButtonInvisible()){this.sFocusId=this._oFileUploader.$().find(":button")[0].id;}}else if(this._oItemForDelete._iLineNumber<this.aItems.length-1){this.sFocusId=this.aItems[this._oItemForDelete._iLineNumber+1].getId()+"-cli";}else{this.sFocusId=this.aItems[0].getId()+"-cli";}this._aDeletedItemForPendingUpload.push(u);this.aItems.splice(this._oItemForDelete._iLineNumber,1);this.removeAggregation("items",u,false);}}};
t.prototype._handleTerminate=function(e,j){var u,v;u=new f({items:[new S({title:j.getFileName(),icon:this._getIconFromFilename(j.getFileName())})]});v=new D({id:this.getId()+"deleteDialog",title:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TITLE"),content:[new T({text:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TEXT")}),u],buttons:[new B({text:this._oRb.getText("UPLOADCOLLECTION_OKBUTTON_TEXT"),press:[w,this]}),new B({text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),press:function(){v.close();}})],afterClose:function(){v.destroy();}}).open();function w(){var A=false;for(var i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===t._uploadingStatus&&this.aItems[i]._requestIdName===j._requestIdName){this.aItems[i]._status=t._toBeDeletedStatus;this._oItemForDelete=this.aItems[i];A=true;break;}else if(j.getFileName()===this.aItems[i].getFileName()&&this.aItems[i]._status===t._displayStatus){this.aItems[i]._status=t._toBeDeletedStatus;this._oItemForDelete=this.aItems[i];this.fireFileDeleted({documentId:this.aItems[i].getDocumentId(),item:this.aItems[i]});break;}}if(A){this._getFileUploader().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(j.getFileName())+this._oItemForDelete._requestIdName);}v.close();this.invalidate();}};
t.prototype._handleEdit=function(e,j){var i,u=j.getId(),v=this.aItems.length;if(this.editModeItem){this._handleOk(e,this.editModeItem,false);}if(this.sErrorState!=="Error"){for(i=0;i<v;i++){if(this.aItems[i].getId()===u){this.aItems[i]._status="Edit";break;}}j._status="Edit";this.editModeItem=e.getSource().getId().split("-editButton")[0];this.invalidate();}};
t.prototype._handleClick=function(e,i){var $=Q(e.target).closest("button");var j="";if($.length){j=$.prop("id");}if(j.lastIndexOf("editButton")===-1){if(j.lastIndexOf("cancelButton")!==-1){this._handleCancel(e,i);}else if(e.target.id.lastIndexOf("ia_imageHL")<0&&e.target.id.lastIndexOf("ia_iconHL")<0&&e.target.id.lastIndexOf("deleteButton")<0&&e.target.id.lastIndexOf("ta_editFileName-inner")<0){if(e.target.id.lastIndexOf("cli")>0){this.sFocusId=e.target.id;}this._handleOk(e,i,true);}}};
t.prototype._handleOk=function(e,i,j){var E=document.getElementById(i+"-ta_editFileName-inner");var N;var u=t._findById(i,this.aItems);var v=u.getProperty("fileName");var w=t._splitFilename(v);var x=sap.ui.getCore().byId(i+"-ta_editFileName");var y=u.errorState;var z=u.changedFileName;if(E!==null){N=E.value.replace(/^\s+/,"");}this.sFocusId=i+"-cli";if(!N||N.length===0){if(E!==null){this._setErrorStateOnItem(this,u,N,z,y);}return;}u._status=t._displayStatus;if(w.name===N){this._removeErrorStateFromItem(this,u);if(j){this.invalidate();}return;}if(this.getSameFilenameAllowed()){this._removeErrorStateFromItem(this,u);this._oItemForRename=u;this._onEditItemOk.bind(this)(N+w.extension);return;}if(t._checkDoubleFileName(N+w.extension,this.aItems)){x.setProperty("valueState","Error",true);this._setErrorStateOnItem(this,u,N,z,y);}else{x.setProperty("valueState","None",true);u.changedFileName=null;this._removeErrorStateFromItem(this,u);if(j){this.invalidate();}this._oItemForRename=u;this._onEditItemOk.bind(this)(N+w.extension);}};
t.prototype._setErrorStateOnItem=function(e,i,N,j,E){i._status="Edit";i.errorState="Error";e.sErrorState="Error";i.changedFileName=N;if(E!=="Error"||j!==N){e.invalidate();}};
t.prototype._removeErrorStateFromItem=function(e,i){i.errorState=null;e.sErrorState=null;e.editModeItem=null;};
t.prototype._onEditItemOk=function(N){if(this._oItemForRename){this._oItemForRename.setFileName(N);this.fireFileRenamed({documentId:this._oItemForRename.getProperty("documentId"),fileName:N,item:this._oItemForRename});}delete this._oItemForRename;};
t.prototype._handleCancel=function(e,i){var j=t._findById(i,this.aItems);j._status=t._displayStatus;j.errorState=null;j.changedFileName=j._getFileNameEditBox().getValue();this.sFocusId=this.editModeItem+"-cli";this.sErrorState=null;this.editModeItem=null;this.invalidate();};
t.prototype._onChange=function(e){if(e){var j,u=e.getParameter("files").length,i,v,w,x,A;if(u===0){return;}this._oFileUploader.removeAllAggregation("headerParameters",true);this.removeAllAggregation("headerParameters",true);this._oFileUploader.removeAllAggregation("parameters",true);this.removeAllAggregation("parameters",true);this.fireChange({getParameter:function(z){if(z){return e.getParameter(z);}return null;},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:e.getParameter("files")});var P=this.getAggregation("parameters");if(P){Q.each(P,function(z,E){var G=new F({name:E.getProperty("name"),value:E.getProperty("value")});this._oFileUploader.addParameter(G);}.bind(this));}if(!this.getInstantUpload()){this._bFocusFileUploader=true;w=t._pendingUploadStatus;}else{w=t._uploadingStatus;}this._requestIdValue++;j=this._requestIdValue.toString();var y=this.getAggregation("headerParameters");if(!this.getInstantUpload()){this._aFileUploadersForPendingUpload.push(this._oFileUploader);}for(i=0;i<u;i++){v=new U({fileName:e.getParameter("files")[i].name});if(e.getParameter("fromDragDrop")){v._internalFileIdWithinDragDropArray=e.getParameter("files")[i];}v._status=w;v._internalFileIndexWithinFileUploader=i+1;v._requestIdName=j;if(!this.getInstantUpload()){v.setAssociation("fileUploader",this._oFileUploader,true);x=this._oFormatDecimal.format(e.getParameter("files")[i].size);A=new m({text:x});v.insertAggregation("attributes",A,true);this.insertItem(v);}else{v._percentUploaded=0;}this.aItems.unshift(v);}if(y){Q.each(y,function(z,E){this._oFileUploader.addHeaderParameter(new F({name:E.getProperty("name"),value:E.getProperty("value")}));}.bind(this));}this._oFileUploader.addHeaderParameter(new F({name:this._headerParamConst.requestIdName,value:j}));}};
t.prototype._onFilenameLengthExceed=function(e){var i={name:e.getParameter("fileName")};var j=[i];this.fireFilenameLengthExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:j});};
t.prototype._onFileSizeExceed=function(e){var i={name:e.getParameter("fileName"),fileSize:e.getParameter("fileSize")};this.fireFileSizeExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:[i]});};
t.prototype._onTypeMissmatch=function(e){var i={name:e.getParameter("fileName"),fileType:e.getParameter("fileType"),mimeType:e.getParameter("mimeType")};var j=[i];this.fireTypeMissmatch({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:j});};
t.prototype._onUploadTerminated=function(e){var i;var j=this._getRequestId(e);var u=e.getParameter("fileName");var v=this.aItems.length;for(i=0;i<v;i++){if(this.aItems[i]&&this.aItems[i].getFileName()===u&&this.aItems[i]._requestIdName===j&&(this.aItems[i]._status===t._uploadingStatus||this.aItems[i]._status===t._toBeDeletedStatus)){if(this.getItems()&&this.getItems()[i]===this.aItems[i]){this.removeItem(i);}this.aItems.splice(i,1);break;}}this.fireUploadTerminated({fileName:u,getHeaderParameter:this._getHeaderParameterWithinEvent.bind(e)});};
t.prototype._onUploadComplete=function(e){if(e){var i,j=this._getRequestId(e),u=e.getParameter("fileName"),v=e.getParameter("id"),w,x,y,z=A();w=this.aItems.length;y=[t._uploadingStatus,t._pendingUploadStatus];for(i=0;i<w;i++){if((!j||this.aItems[i]._requestIdName===j)&&this.aItems[i].getProperty("fileName")===u&&(y.indexOf(this.aItems[i]._status)>=0)){if(z&&this.aItems[i]._status!==t._pendingUploadStatus){this.aItems[i]._percentUploaded=100;this.aItems[i]._status=t._displayStatus;}x=this.aItems.splice(i,1)[0];if(x.destroy){x.destroy();}this._oItemToUpdate=null;break;}}for(i=0;i<this._aFileUploadersForPendingUpload.length;i++){if(this._aFileUploadersForPendingUpload[i].getId()===v){this._aFileUploadersForPendingUpload[i].clear();break;}}this.fireUploadComplete({getParameter:e.getParameter,getParameters:e.getParameters,mParameters:e.getParameters(),files:[{fileName:e.getParameter("fileName")||u,responseRaw:e.getParameter("responseRaw"),reponse:e.getParameter("response"),response:e.getParameter("response"),status:e.getParameter("status"),headers:e.getParameter("headers")}]});}this.invalidate();function A(){var E=e.getParameter("status").toString()||"200";return E[0]==="2"||E[0]==="3";}};
t.prototype._onUploadProgress=function(e){if(!e||!this.getInstantUpload()){return;}var u=e.getParameter("fileName"),P,j=Math.round(e.getParameter("loaded")/e.getParameter("total")*100),v=this._getRequestId(e),w=this.aItems.length,x,$,y;if(j===100){P=this._oRb.getText("UPLOADCOLLECTION_UPLOAD_COMPLETED");}else{P=this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[j]);}for(var i=0;i<w;i++){y=this.aItems[i];if(y.getProperty("fileName")===u&&y._requestIdName===v&&y._status===t._uploadingStatus){x=y._getProgressLabel?y._getProgressLabel():y._getControl("sap.m.Label",{id:y.getId()+"-ta_progress"},"ProgressLabel");if(x){x.setText(P);y._percentUploaded=j;$=Q(document.getElementById(y.getId()+"-ia_indicator"));if(j===100){$.attr("aria-label",P);}else{$.attr("aria-valuenow",j);}break;}}}};
t.prototype._getRequestId=function(e){var i;i=e.getParameter("requestHeaders");if(!i){return null;}for(var j=0;j<i.length;j++){if(i[j].name===this._headerParamConst.requestIdName){return i[j].value;}}return null;};
t.prototype._getFileUploader=function(){var u=this.getInstantUpload();if(!u||!this._oFileUploader){var e=this.getInstantUpload()?this._oRb.getText("UPLOADCOLLECTION_UPLOAD"):this._oRb.getText("UPLOADCOLLECTION_ADD");this._iFUCounter=this._iFUCounter+1;this._oFileUploader=new h(this.getId()+"-"+this._iFUCounter+"-uploader",{buttonOnly:true,buttonText:e,tooltip:e,iconOnly:true,enabled:this.getUploadEnabled(),fileType:this.getFileType(),icon:"sap-icon://add",iconFirst:false,style:"Transparent",maximumFilenameLength:this.getMaximumFilenameLength(),maximumFileSize:this.getMaximumFileSize(),mimeType:this.getMimeType(),multiple:this.getMultiple(),name:"uploadCollection",uploadOnChange:u,sameFilenameAllowed:true,uploadUrl:this.getUploadUrl(),useMultipart:false,sendXHR:true,change:[this._onChange,this],filenameLengthExceed:[this._onFilenameLengthExceed,this],fileSizeExceed:[this._onFileSizeExceed,this],typeMissmatch:[this._onTypeMissmatch,this],uploadAborted:[this._onUploadTerminated,this],uploadComplete:[this._onUploadComplete,this],uploadProgress:[this._onUploadProgress,this],uploadStart:[this._onUploadStart,this],visible:!this.getUploadButtonInvisible()});}return this._oFileUploader;};
t.prototype._onUploadStart=function(e){var j,i,u,P,v,G;this._iUploadStartCallCounter++;P=e.getParameter("requestHeaders").length;for(i=0;i<P;i++){if(e.getParameter("requestHeaders")[i].name===this._headerParamConst.requestIdName){u=e.getParameter("requestHeaders")[i].value;break;}}v=e.getParameter("fileName");j={name:this._headerParamConst.fileNameRequestIdName,value:this._encodeToAscii(v)+u};e.getParameter("requestHeaders").push(j);for(i=0;i<this._aDeletedItemForPendingUpload.length;i++){if(this._aDeletedItemForPendingUpload[i].getAssociation("fileUploader")===e.oSource.sId&&this._aDeletedItemForPendingUpload[i].getFileName()===v&&this._aDeletedItemForPendingUpload[i]._internalFileIndexWithinFileUploader===this._iUploadStartCallCounter){e.getSource().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(v)+u);return;}}this.fireBeforeUploadStarts({fileName:v,addHeaderParameter:w,getHeaderParameter:x.bind(this)});if(Array.isArray(G)){for(i=0;i<G.length;i++){if(e.getParameter("requestHeaders")[i].name===G[i].getName()){e.getParameter("requestHeaders")[i].value=G[i].getValue();}}}else if(G instanceof n){for(i=0;i<e.getParameter("requestHeaders").length;i++){if(e.getParameter("requestHeaders")[i].name===G.getName()){e.getParameter("requestHeaders")[i].value=G.getValue();break;}}}function w(y){var j={name:y.getName(),value:y.getValue()};e.getParameter("requestHeaders").push(j);}function x(y){G=this._getHeaderParameterWithinEvent.bind(e)(y);return G;}};
t.prototype._getIconFromFilename=function(e){var i=t._splitFilename(e).extension;if(Q.type(i)==="string"){i=i.toLowerCase();}switch(i){case".bmp":case".jpg":case".jpeg":case".png":return t._placeholderCamera;case".csv":case".xls":case".xlsx":return"sap-icon://excel-attachment";case".doc":case".docx":case".odt":return"sap-icon://doc-attachment";case".pdf":return"sap-icon://pdf-attachment";case".ppt":case".pptx":return"sap-icon://ppt-attachment";case".txt":return"sap-icon://document-text";default:return"sap-icon://document";}};
t.prototype._getThumbnail=function(e,i){if(e){return e;}else{return this._getIconFromFilename(i);}};
t.prototype._triggerLink=function(e,i){if(this.editModeItem){this._handleOk(e,this.editModeItem,true);if(this.sErrorState==="Error"){return;}this.sFocusId=e.getParameter("id");}M.URLHelper.redirect(i.getProperty("url"),true);};
t.prototype.onkeydown=function(e){switch(e.keyCode){case K.F2:this._handleF2(e);break;case K.ESCAPE:this._handleESC(e);break;case K.DELETE:this._handleDEL(e);break;case K.ENTER:this._handleENTER(e);break;default:return;}e.setMarked();};
t.prototype._setFocusAfterDeletion=function(){var i=this.aItems.length;var e;if(i===0){this._oFileUploader.focus();}else{var j=this.sDeletedItemId.split("-").pop();if(j<=i-1){e=this.sDeletedItemId+"-cli";}else{e=this.aItems[this.aItems.length-1].sId+"-cli";}this._setFocusToLineItem(e);}this.sDeletedItemId=null;};
t.prototype._setFocusToLineItem=function(i){Q(document.getElementById(i)).focus();};
t.prototype._handleENTER=function(e){var i,j,u,v;if(this.editModeItem){i=e.target.id.split(this.editModeItem).pop();}else{i=e.target.id.split("-").pop();}switch(i){case"-ta_editFileName-inner":case"-okButton":this._handleOk(e,this.editModeItem,true);break;case"-cancelButton":e.preventDefault();this._handleCancel(e,this.editModeItem);break;case"-ia_iconHL":case"-ia_imageHL":v=this.editModeItem.split("-").pop();M.URLHelper.redirect(this.aItems[v].getProperty("url"),true);break;case"ia_iconHL":case"ia_imageHL":case"cli":j=e.target.id.split(i)[0]+"ta_filenameHL";u=sap.ui.getCore().byId(j);if(u.getEnabled()){v=e.target.id.split("-")[2];M.URLHelper.redirect(this.aItems[v].getProperty("url"),true);}break;default:break;}};
t.prototype._handleDEL=function(e){if(!this.editModeItem){var i=e.target.id.slice(0,-4),j=sap.ui.getCore().byId(i),u=j&&j._getDeleteButton&&j._getDeleteButton();if(u){u.firePress();}}};
t.prototype._handleESC=function(e){if(this.editModeItem){this.sFocusId=this.editModeItem+"-cli";this.aItems[this.editModeItem.split("-").pop()]._status=t._displayStatus;this._handleCancel(e,this.editModeItem);}};
t.prototype._handleF2=function(e){var i=sap.ui.getCore().byId(e.target.id);if(i!==undefined){if(i._status===t._displayStatus){var j=Q(document.getElementById(e.target.id));var u=j.find("[id$='-editButton']");var E=sap.ui.getCore().byId(u[0].id);if(E.getEnabled()){if(this.editModeItem){this._handleClick(e,this.editModeItem);}if(this.sErrorState!=="Error"){E.firePress();}}}else{this._handleClick(e,this.editModeItem);}}else if(e.target.id.search(this.editModeItem)===0){this._handleOk(e,this.editModeItem,true);}};
t._checkDoubleFileName=function(e,j){if(j.length===0||!e){return false;}var u=j.length;e=e.replace(/^\s+/,"");for(var i=0;i<u;i++){if(e===j[i].getProperty("fileName")){return true;}}return false;};
t._splitFilename=function(e){var i={};var N=e.split(".");if(N.length===1){i.extension="";i.name=N.pop();return i;}i.extension="."+N.pop();i.name=N.join(".");return i;};
t.prototype._getAriaLabelForPicture=function(i){var e;e=(i.getAriaLabelForPicture()||i.getFileName());return e;};
t.prototype._getHeaderParameterWithinEvent=function(e){var u=[];var j=this.getParameter("requestHeaders");var P=j.length;var i;if(j&&e){for(i=0;i<P;i++){if(j[i].name===e){return new n({name:j[i].name,value:j[i].value});}}return null;}else if(j){for(i=0;i<P;i++){u.push(new n({name:j[i].name,value:j[i].value}));}return u;}};
t.prototype._encodeToAscii=function(v){var e="";for(var i=0;i<v.length;i++){e=e+v.charCodeAt(i);}return e;};
t.prototype._onResize=function(){var e=this._oList.getItems();for(var i=0;i<e.length;i++){var j=e[i];setTimeout(function(){var u=this._truncateFileName.bind(this);if(typeof u==="string"||u instanceof String){u=this[u];}u.apply(this,[j._oUploadCollectionItem]||[]);}.bind(this),t._resizeTimeoutInterval);}};
t.prototype._getUploadCollectionItemByListItem=function(e){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===e.getId().replace("-cli","")){return A[i];}}return null;};
t.prototype._getUploadCollectionItemById=function(u){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===u){return A[i];}}return null;};
t.prototype._getUploadCollectionItemsByListItems=function(e){var u=[];var v=this.getItems();if(e){for(var i=0;i<e.length;i++){for(var j=0;j<v.length;j++){if(e[i].getId().replace("-cli","")===v[j].getId()){u.push(v[j]);break;}}}return u;}return null;};
t.prototype._setSelectedForItems=function(u,e){if(this.getMode()!==L.ListMode.MultiSelect&&e){var v=this.getItems();for(var j=0;j<v.length;j++){v[j].setSelected(false);}}for(var i=0;i<u.length;i++){u[i].setSelected(e);}};
t.prototype._handleItemSetSelected=function(e){var i=e.getSource();if(i instanceof U){var j=this._getListItemById(i.getId()+"-cli");if(j){j.setSelected(i.getSelected());}}};
t.prototype._handleSelectionChange=function(e){var i=e.getParameter("listItem");var j=e.getParameter("selected");var u=this._getUploadCollectionItemsByListItems(e.getParameter("listItems"));var v=this._getUploadCollectionItemByListItem(i);if(v&&i&&u){this.fireSelectionChange({selectedItem:v,selectedItems:u,selected:j});v.setSelected(i.getSelected());}};
t.prototype._getListItemById=function(e){var i=this._oList.getItems();return t._findById(e,i);};
t._findById=function(e,j){for(var i=0;i<j.length;i++){if(j[i].getId()===e){return j[i];}}return null;};
return t;});
sap.ui.predefine('sap/m/UploadCollectionItem',["./library","sap/ui/core/Element","sap/m/ObjectAttribute","sap/ui/core/util/File","sap/ui/Device","sap/base/Log","sap/base/util/ObjectPath","sap/ui/thirdparty/jquery"],function(l,E,O,F,D,L,a,q){"use strict";
var U=E.extend("sap.m.UploadCollectionItem",{metadata:{library:"sap.m",properties:{contributor:{type:"string",group:"Data",defaultValue:null},documentId:{type:"string",group:"Misc",defaultValue:null},fileName:{type:"string",group:"Misc",defaultValue:null},fileSize:{type:"float",group:"Misc",defaultValue:null},mimeType:{type:"string",group:"Misc",defaultValue:null},thumbnailUrl:{type:"string",group:"Misc",defaultValue:null},uploadedDate:{type:"string",group:"Misc",defaultValue:null},url:{type:"string",group:"Misc",defaultValue:null},enableEdit:{type:"boolean",group:"Behavior",defaultValue:true},enableDelete:{type:"boolean",group:"Behavior",defaultValue:true},visibleEdit:{type:"boolean",group:"Behavior",defaultValue:true},visibleDelete:{type:"boolean",group:"Behavior",defaultValue:true},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null},selected:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,bindable:"bindable"},_propertyAttributes:{type:"sap.m.ObjectAttribute",multiple:true,visibility:"hidden"},statuses:{type:"sap.m.ObjectStatus",multiple:true,bindable:"bindable"},markers:{type:"sap.m.ObjectMarker",multiple:true,bindable:"bindable"}},associations:{fileUploader:{type:"sap.ui.unified.FileUploader",multiple:false}},events:{press:{},deletePress:{}}}});
U.prototype.init=function(){this._mDeprecatedProperties={};this._aManagedInstances=[];};
U.prototype.exit=function(){for(var i=0;i<this._aManagedInstances.length;i++){this._aManagedInstances[i].destroy();}};
U.prototype.setContributor=function(c){if(this.getContributor()!==c){this.setProperty("contributor",c,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setUploadedDate=function(u){if(this.getUploadedDate()!==u){this.setProperty("uploadedDate",u,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setFileSize=function(f){if(this.getFileSize()!==f){this.setProperty("fileSize",f,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setSelected=function(s){if(this.getSelected()!==s){this.setProperty("selected",s,true);this.fireEvent("selected");}return this;};
U.prototype.download=function(b){if(D.browser.name==="sf"){b=false;}if(!this.getUrl()){L.warning("Items to download do not have a URL.");return false;}else if(b){var f=this.getFileName();var o=this._splitFileName(f,false);var d=null;var x=new window.XMLHttpRequest();x.open("GET",this.getUrl());if(o.extension!=="csv"){x.responseType="blob";}x.onload=function(){var s=o.extension;f=o.name;d=x.response;F.save(d,f,s,this.getMimeType(),'utf-8');}.bind(this);x.send();return true;}else{l.URLHelper.redirect(this.getUrl(),true);return true;}};
U.prototype._splitFileName=function(f,w){var r={};var R=/(?:\.([^.]+))?$/;var b=R.exec(f);r.name=f.slice(0,f.indexOf(b[0]));if(w){r.extension=b[0];}else{r.extension=b[1];}return r;};
U.prototype._updateDeprecatedProperties=function(){var p=["uploadedDate","contributor","fileSize"];this.removeAllAggregation("_propertyAttributes",true);q.each(p,function(i,n){var v=this.getProperty(n),A=this._mDeprecatedProperties[n];if(q.type(v)==="number"&&!!v||!!v){if(!A){A=new O({active:false});this._mDeprecatedProperties[n]=A;this.addAggregation("_propertyAttributes",A,true);A.setText(v);}else{A.setText(v);this.addAggregation("_propertyAttributes",A,true);}}else if(A){A.destroy();delete this._mDeprecatedProperties[n];}}.bind(this));this.invalidate();};
U.prototype.getAllAttributes=function(){return this.getAggregation("_propertyAttributes",[]).concat(this.getAttributes());};
U.prototype._getControl=function(n,s,g){var c=a.get(n||""),i=new c(s);this._aManagedInstances.push(i);if(g){this["_get"+g]=function(){return i;};}return i;};
U.prototype._getPressEnabled=function(){return this.hasListeners("press")||!!q.trim(this.getUrl());};
return U;});
sap.ui.predefine('sap/m/UploadCollectionParameter',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var U=E.extend("sap.m.UploadCollectionParameter",{metadata:{library:"sap.m",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
return U;});
sap.ui.predefine('sap/m/UploadCollectionRenderer',['./ListItemBaseRenderer'],function(L){"use strict";var U={};
U.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMUC");r.writeClasses();r.write(">");this.renderDragDropOverlay(r,c);this.renderList(r,c);r.write("</div>");};
U.renderNoData=function(r,c){var u=c.getParent();r.write("<li");r.writeAttribute("tabindex",0);r.writeAttribute("id",u._oList.getId("nodata"));r.addClass("sapMLIB sapMUCNoDataPage");L.addFocusableClasses.call(L,r);r.writeClasses();r.write(">");r.renderControl(u.getAggregation("_noDataIcon"));r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-text");r.addClass("sapMUCNoDataText");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataText());r.write("</div>");if(u.getUploadEnabled()){r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-description");r.addClass("sapMUCNoDataDescription");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataDescription());r.write("</div>");}r.write("</li>");};
U.renderDragDropOverlay=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-drag-drop-area");r.addClass("sapMUCDragDropOverlay");r.addClass("sapMUCDragDropOverlayHide");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMUCDragDropIndicator");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_dragDropIcon"));r.renderControl(c.getAggregation("_dragDropText"));r.write("</div>");r.write("</div>");};
U.renderList=function(r,c){var o=c._oList.getRenderer().renderNoData;c._oList.getRenderer().renderNoData=this.renderNoData;r.renderControl(c._oList);c._oList.getRenderer().renderNoData=o;};
return U;},true);
sap.ui.predefine('sap/m/UploadCollectionToolbarPlaceholder',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var U=C.extend("sap.m.UploadCollectionToolbarPlaceholder",{metadata:{library:"sap.m",properties:{}}});
return U;});
sap.ui.predefine('sap/m/VBox',['./FlexBox','./library',"./VBoxRenderer"],function(F,l,V){"use strict";
var a=F.extend("sap.m.VBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/VBox.designtime"}});
return a;});
sap.ui.predefine('sap/m/VBoxRenderer',['./FlexBoxRenderer'],function(F){"use strict";var V={apiVersion:2};
V.render=function(r,c){F.render.apply(this,[r,c]);};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsCustomItem',['./ViewSettingsItem','sap/ui/base/ManagedObject','./library'],function(V,M,l){"use strict";
var a=V.extend("sap.m.ViewSettingsCustomItem",{metadata:{library:"sap.m",properties:{filterCount:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{customControl:{type:"sap.ui.core.Control",multiple:false}}}});
a.prototype.exit=function(){if(this._control&&!this._control.getParent()){this._control.destroy();delete this._control;}};
a.prototype.setCustomControl=function(c){this._control=c;return this;};
a.prototype.getCustomControl=function(){return this._control;};
a.prototype.setFilterCount=function(v){this.setProperty("filterCount",v,true);return this;};
a.prototype.setSelected=function(v){this.setProperty("selected",v,true);return this;};
a.prototype.clone=function(i,L,o){var c=M.prototype.clone.apply(this,arguments);c._control=this._control.clone();return c;};
return a;});
sap.ui.predefine('sap/m/ViewSettingsCustomTab',['./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(l,I){"use strict";
var V=I.extend("sap.m.ViewSettingsCustomTab",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://competitor"},title:{type:"string",defaultValue:""}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
V.prototype.init=function(){this._aTabContents=[];};
V.prototype.exit=function(){this._aTabContents.forEach(function(c,i){c.destroy();delete this._aTabContents[i];},this);};
return V;});
sap.ui.predefine('sap/m/ViewSettingsDialog',['./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/IconPool','./Toolbar','./CheckBox','./SearchField','./List','./StandardListItem','./Dialog','./Button','./Label','./NavContainer','./Bar','./SegmentedButton','./Page','./ViewSettingsItem','sap/ui/base/ManagedObject','sap/ui/base/EventProvider','sap/ui/Device','sap/ui/core/InvisibleText','./ViewSettingsDialogRenderer',"sap/m/GroupHeaderListItem","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,T,C,I,a,b,S,L,c,D,B,d,N,e,f,P,V,M,E,g,h,m,G,n,q){"use strict";var o=l.ListMode;var p=l.ListType;var r=l.StringFilterOperator;var s=l.TitleAlignment;var t="-list-item";
var u=C.extend("sap.m.ViewSettingsDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Behavior",defaultValue:null},sortDescending:{type:"boolean",group:"Behavior",defaultValue:false},groupDescending:{type:"boolean",group:"Behavior",defaultValue:false},filterSearchOperator:{type:"sap.m.StringFilterOperator",group:"Behavior",defaultValue:r.StartsWith},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:s.Auto}},aggregations:{sortItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"sortItem",bindable:"bindable"},groupItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"groupItem",bindable:"bindable"},filterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"filterItem",bindable:"bindable"},presetFilterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"presetFilterItem",bindable:"bindable"},customTabs:{type:"sap.m.ViewSettingsCustomTab",multiple:true,singularName:"customTab",bindable:"bindable"}},associations:{selectedSortItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedGroupItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedPresetFilterItem:{type:"sap.m.ViewSettingsItem",multiple:false}},events:{confirm:{parameters:{sortItem:{type:"sap.m.ViewSettingsItem"},sortDescending:{type:"boolean"},groupItem:{type:"sap.m.ViewSettingsItem"},groupDescending:{type:"boolean"},presetFilterItem:{type:"sap.m.ViewSettingsItem"},filterItems:{type:"sap.m.ViewSettingsItem[]"},filterKeys:{type:"object",deprecated:true},filterCompoundKeys:{type:"object"},filterString:{type:"string"}}},cancel:{},resetFilters:{},reset:{},filterDetailPageOpened:{parameters:{parentFilterItem:{type:"sap.m.ViewSettingsFilterItem"}}}}}});
u.prototype.init=function(){var j=this.getId();this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sDialogWidth="350px";this._sDialogHeight="434px";this._bAppendedToUIArea=false;this._showSubHeader=false;this._filterDetailList=undefined;this._vContentPage=-1;this._oContentItem=null;this._oPreviousState={};this._sCustomTabsButtonsIdPrefix='-custom-button-';this._sTitleLabelId=j+"-title";this._sFilterDetailTitleLabelId=j+"-detailtitle";this._aggregationToListItems("sortItems",{text:{listProp:"title"},selected:{}},{tooltip:{}},{type:p.Active},{mode:o.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(k){var Q=k.getParameter('listItem'),R=this.getSortItems(),U=this._getVSItem(Q),i;U.setProperty('selected',k.getParameter('selected'),true,false);this.setAssociation('selectedSortItem',U,true);for(i=0;i<R.length;i++){if(U!==R[i]){R[i].setProperty('selected',false,true,false);}}this._checkResetStatus();}.bind(this)});};
u.prototype.exit=function(){this._rb=null;this._sDialogWidth=null;this._sDialogHeight=null;this._bAppendedToUIArea=null;this._showSubHeader=null;this._vContentPage=null;this._oContentItem=null;this._oPreviousState=null;this._sortContent=null;this._groupContent=null;this._filterContent=null;this._sCustomTabsButtonsIdPrefix=null;this._fnFilterSearchCallback=null;if(this._bAppendedToUIArea&&this._dialog){var i=sap.ui.getCore().getStaticAreaRef();i=sap.ui.getCore().getUIArea(i);i.removeContent(this._dialog,true);}if(this._dialog){this._dialog.destroy();this._dialog=null;}if(this._navContainer){this._navContainer.destroy();this._navContainer=null;}if(this._titleLabel){this._titleLabel.destroy();this._titleLabel=null;}if(this._page1){this._page1.destroy();this._page1=null;}if(this._header){this._header.destroy();this._header=null;}if(this._resetButton){this._resetButton.destroy();this._resetButton=null;}if(this._subHeader){this._subHeader.destroy();this._subHeader=null;}if(this._segmentedButton){this._segmentedButton.destroy();this._segmentedButton=null;}if(this._sortButton){this._sortButton.destroy();this._sortButton=null;}if(this._groupButton){this._groupButton.destroy();this._groupButton=null;}if(this._filterButton){this._filterButton.destroy();this._filterButton=null;}if(this._sortList){this._sortList.destroy();this._sortList=null;}if(this._ariaSortListInvisibleText){this._ariaSortListInvisibleText.destroy();this._ariaSortListInvisibleText=null;}if(this._sortOrderList){this._sortOrderList.destroy();this._sortOrderList=null;this._ariaSortOrderInvisibleText.destroy();this._ariaSortOrderInvisibleText=null;}if(this._oGroupingNoneItem){this._oGroupingNoneItem.destroy();this._oGroupingNoneItem=null;}if(this._groupList){this._groupList.destroy();this._groupList=null;this._ariaGroupListInvisibleText.destroy();this._ariaGroupListInvisibleText=null;}if(this._groupOrderList){this._groupOrderList.destroy();this._groupOrderList=null;this._ariaGroupOrderInvisibleText.destroy();this._ariaGroupOrderInvisibleText=null;}if(this._presetFilterList){this._presetFilterList.destroy();this._presetFilterList=null;}if(this._filterList){this._filterList.destroy();this._filterList=null;}if(this._page2){this._page2.destroy();this._page2=null;}if(this._detailTitleLabel){this._detailTitleLabel.destroy();this._detailTitleLabel=null;}if(this._filterDetailList){this._filterDetailList.destroy();this._filterDetailList=null;}if(this._oStringFilter){this._oStringFilter=null;}};
u.prototype._aggregationToListItems=function(i,j,k,Q,R){var U=this._getListType(i),W="_"+U+"List";if(!this.mToList){this.mToList={};}this.mToList[U]={"itemPropertyMap":j,"itemAggregationMap":k,"listItemOptions":Q,"listOptions":R,"listName":W};};
u.prototype._getListType=function(i){return i.replace('Items','');};
u.prototype._createList=function(i){var j=this.getId()+"-"+i+"list",k=new L(j,this.mToList[i].listOptions),Q=this._createGroupHeaderItem(i);k.addItem(Q);this[this.mToList[i].listName]=k;return k;};
u.prototype._createGroupHeaderItem=function(i){return new G({title:this._rb.getText("VIEWSETTINGS_"+i.toUpperCase()+"_OBJECT")});};
u.prototype._getList=function(i){if(!this.mToList||!this.mToList[i]){return;}return this[this.mToList[i].listName];};
u.prototype._createListItem=function(i,j){var k=this.mToList[i].listItemOptions,Q=this.mToList[i].itemPropertyMap,R=this.mToList[i].itemAggregationMap,U,W;for(var X in Q){if(Q.hasOwnProperty(X)){U=Q[X].listProp||X;k[U]=this._createListItemPropertyValue(i,X,j);}}for(var Y in R){if(R.hasOwnProperty(Y)){k[Y]=j.getAggregation(Y);}}W=new c(k).data('item',j);return W;};
u.prototype._createListItemPropertyValue=function(i,j,k){var Q=k.getMetadata().getAllProperties()[j].get(k),R=this.mToList[i].itemPropertyMap[j].fn;return R?R(Q):Q;};
u.prototype._getListItem=function(i,j){var k=this._getList(i).getItems().filter(function(Q){return Q.data('item')===j;});return k.length?k[0]:null;};
u.prototype._getVSItem=function(i){return i.data('item');};
u.prototype.addCustomTab=function(i){var j=i.getId();if(j==='sort'||j==='filter'||j==='group'){throw'Id "'+j+'" is reserved and cannot be used as custom tab id.';}this.addAggregation('customTabs',i);return this;};
u.prototype.invalidate=function(){if(this._dialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._dialog.invalidate(arguments);}};
u.prototype.addStyleClass=function(){var i=this._getDialog();i.addStyleClass.apply(i,arguments);return this;};
u.prototype.removeStyleClass=function(){var i=this._getDialog();i.removeStyleClass.apply(i,arguments);return this;};
u.prototype.toggleStyleClass=function(){var i=this._getDialog();i.toggleStyleClass.apply(i,arguments);return this;};
u.prototype.hasStyleClass=function(){var i=this._getDialog();return i.hasStyleClass.apply(i,arguments);};
u.prototype.getDomRef=function(){if(this._dialog){return this._dialog.getDomRef.apply(this._dialog,arguments);}else{return null;}};
u.prototype.setTitle=function(i){this._getTitleLabel().setText(i);this.setProperty("title",i,true);return this;};
u.prototype.addAggregation=function(i,j,k){C.prototype.addAggregation.apply(this,arguments);var Q=this._getListType(i);if(this.mToList[Q]){var R=this._createListItem(Q,j);var U=this._getList(Q);if(!U){U=this._createList(Q);}else if(!U.getItems().length){U.addItem(this._createGroupHeaderItem(Q));}U.addItem(R);this._attachItemPropertyChange(Q,j);}else{this._attachItemEventHandlers(i,j);}return this;};
u.prototype.insertAggregation=function(i,j,k,Q){C.prototype.insertAggregation.apply(this,arguments);var R=this._getListType(i);if(this.mToList[R]){var U=this._createListItem(R,j);var W=this._getList(R);if(!W){W=this._createList(R);W.insertItem(U,k);}else if(!W.getItems().length){W.addItem(this._createGroupHeaderItem(R));W.insertItem(U,k+1);}else{W.insertItem(U,k);}this._attachItemPropertyChange(R,j);}else{this._attachItemEventHandlers(i,j);}return this;};
u.prototype.removeAggregation=function(i,j,k){z.call(this,i,j);var R=C.prototype.removeAggregation.apply(this,arguments);var Q=this._getListType(i);if(this.mToList[Q]){var U=this._getListItem(Q,R);var W=this._getList(Q);var X=W.removeItem(U);X.destroy();this._detachItemPropertyChange(R);}return R;};
u.prototype.removeAllAggregation=function(i,j){z.call(this);var R=C.prototype.removeAllAggregation.apply(this,arguments);var k=this._getListType(i);if(this.mToList[k]){var Q=this._getList(k);if(Q){var U=Q.removeAllItems();U.forEach(function(W){W.destroy();});}R.forEach(function(W){this._detachItemPropertyChange(W);},this);}return R;};
u.prototype.destroyAggregation=function(i,j){z.call(this);C.prototype.destroyAggregation.apply(this,arguments);var k=this._getListType(i);if(this.mToList[k]){var Q=this._getList(k);if(Q){Q.destroyItems();}}return this;};
u.prototype._detachItemPropertyChange=function(i){delete E.getEventList(i)["itemPropertyChanged"];};
u.prototype._attachItemPropertyChange=function(i,j){j.attachEvent('itemPropertyChanged',function fnHandleItemPropertyChanged(k){var Q,R,U,W,X,Y;Q=this._getListItem(i,j);R=k.getParameter('propertyKey');if(!this.mToList[i].itemPropertyMap[R]){return;}U=this.mToList[i].itemPropertyMap[R].listProp||R;W=k.getParameter('propertyValue');X=this.mToList[i].itemPropertyMap[R].fn;Y=X?X(W):W;Q.getMetadata().getAllProperties()[U].set(Q,Y);},this);};
u.prototype._attachItemEventHandlers=function(i,j){if(i!=='groupItems'&&i!=='filterItems'){return this;}var k=i.replace('Items','');k=k.charAt(0).toUpperCase()+k.slice(1);j.attachEvent('itemPropertyChanged',function(i,Q){if(i==='filterItems'&&Q.getParameter('changedItem').getParent().getMetadata().getName()==='sap.m.ViewSettingsFilterItem'){if(Q.getParameter('propertyKey')!=='selected'){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}else{if(this._filterDetailList){var R=this._filterDetailList.getItems();R.forEach(function(U){if(U.data('item').getId()===Q.getParameter('changedItem').getId()){U.setSelected(Q.getParameter('propertyValue'));}});this._updateSelectAllCheckBoxState();}}this._updateFilterCounters();}else{if(typeof this['_init'+k+'Content']==='function'){this['_init'+k+'Content']();}if(typeof this['_init'+k+'Items']==='function'){this['_init'+k+'Items']();}}}.bind(this,i));j.attachEvent('filterDetailItemsAggregationChange',function(Q){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}.bind(this));return this;};
u.prototype._setFilterDetailTitle=function(i){var j=this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")+" "+i.getText();this._getDetailTitleLabel().setText(j);this._toggleDialogTitle(this._sFilterDetailTitleLabelId);};
u.prototype._toggleDialogTitle=function(i){var j=this._getDialog(),k=j.getAriaLabelledBy(),Q=[this._sTitleLabelId,this._sFilterDetailTitleLabelId];if(Q.indexOf(i)===-1&&k.indexOf(i)>-1){return this;}for(var R in Q){j.removeAriaLabelledBy(Q[R]);}j.addAriaLabelledBy(i);return this;};
u.prototype.updateAggregation=function(i){C.prototype.updateAggregation.apply(this,arguments);if(i!=='groupItems'&&i!=='filterItems'){return this;}var j=i.replace('Items','');j=j.charAt(0).toUpperCase()+j.slice(1);if(typeof this['_init'+j+'Content']==='function'){this['_init'+j+'Content']();}if(typeof this['_init'+j+'Items']==='function'){this['_init'+j+'Items']();}};
u.prototype.addSortItem=function(i){this.addAggregation("sortItems",i);if(i.getSelected()){this.setSelectedSortItem(i);}return this;};
u.prototype.addGroupItem=function(i){this.addAggregation("groupItems",i);if(i.getSelected()){this.setSelectedGroupItem(i);}return this;};
u.prototype.addPresetFilterItem=function(i){this.addAggregation("presetFilterItems",i);if(i.getSelected()){this.setSelectedPresetFilterItem(i);}return this;};
u.prototype.setSelectedSortItem=function(j){var k=this.getSortItems(),i=0,Q=x(j,k,"Could not set selected sort item. Item is not found: '"+j+"'");if(y(Q)){for(i=0;i<k.length;i++){if(k[i].getId()!==Q.getId()){k[i].setProperty('selected',false,true);}}if(Q.getProperty('selected')!==true){Q.setProperty('selected',true,true);}if(this._getDialog().isOpen()){this._updateListSelection(this._sortList,Q);}this.setAssociation("selectedSortItem",Q,true);}return this;};
u.prototype.setSelectedGroupItem=function(j){var k=this.getGroupItems(),i=0,Q=x(j,k,"Could not set selected group item. Item is not found: '"+j+"'");if(!Q&&!j){Q=this._oGroupingNoneItem;}if(y(Q)){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}Q.setProperty('selected',true,true);if(this._getDialog().isOpen()){this._updateListSelection(this._groupList,Q);}this.setAssociation("selectedGroupItem",Q,true);}return this;};
u.prototype.setSelectedPresetFilterItem=function(j){var k=this.getPresetFilterItems(),i=0,Q=x(j,k,"Could not set selected preset filter item. Item is not found: '"+j+"'");if(y(Q)||Q===null){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}if(Q!==null){Q.setProperty('selected',true,true);}this._clearSelectedFilters();this.setAssociation("selectedPresetFilterItem",Q,true);}return this;};
u.prototype.open=function(i){if(!this.getParent()&&!this._bAppendedToUIArea){var j=sap.ui.getCore().getStaticAreaRef();j=sap.ui.getCore().getUIArea(j);j.addContent(this._getDialog(),true);this._bAppendedToUIArea=true;}if(i&&this._vContentPage===3){setTimeout(this._getNavContainer()["to"].bind(this._getNavContainer(),this._getPage1().getId(),"show"),0);}this._initDialogContent(i);this._oPreviousState={sortItem:sap.ui.getCore().byId(this.getSelectedSortItem()),sortDescending:this.getSortDescending(),groupItem:sap.ui.getCore().byId(this.getSelectedGroupItem()),groupDescending:this.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(this.getSelectedPresetFilterItem()),filterKeys:this.getSelectedFilterKeys(),filterCompoundKeys:this.getSelectedFilterCompoundKeys(),navPage:this._getNavContainer().getCurrentPage(),contentPage:this._vContentPage,contentItem:this._oContentItem};if(!this._oInitialState){this._oInitialState={sortItem:this.getSelectedSortItem(),sortDescending:this.getSortDescending(),groupItem:this.getSelectedGroupItem(),groupDescending:this.getGroupDescending(),presetFilterItem:this.getSelectedPresetFilterItem()};}if(g.system.desktop){this._getDialog().attachEventOnce("afterOpen",function(){var k=this._getNavContainer().getCurrentPage(),$;if(k){$=k.$("cont").firstFocusableDomRef();if($){if(q($).hasClass('sapMListUl')){var Q=q($).find('.sapMLIB');Q.length&&Q[0].focus();return;}$.focus();}}},this);}this._checkResetStatus();this._getDialog().open();return this;};
u.prototype.getSelectedFilterItems=function(){var k=[],Q=this.getFilterItems(),R,U=true,i=0,j;for(;i<Q.length;i++){if(Q[i]instanceof sap.m.ViewSettingsCustomItem){if(Q[i].getSelected()){k.push(Q[i]);}}else if(Q[i]instanceof sap.m.ViewSettingsFilterItem){R=Q[i].getItems();U=Q[i].getMultiSelect();for(j=0;j<R.length;j++){if(R[j].getSelected()){k.push(R[j]);if(!U){break;}}}}}return k;};
u.prototype.getSelectedFilterString=function(){var k="",Q,R=this.getSelectedPresetFilterItem(),U=this.getFilterItems(),W,X=true,i=0,j;if(R){k=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+sap.ui.getCore().byId(R).getText());}else{for(;i<U.length;i++){if(U[i]instanceof sap.m.ViewSettingsCustomItem){if(U[i].getSelected()){k+=U[i].getText()+", ";}}else if(U[i]instanceof sap.m.ViewSettingsFilterItem){W=U[i].getItems();X=U[i].getMultiSelect();Q="";for(j=0;j<W.length;j++){if(W[j].getSelected()){Q+=W[j].getText()+", ";if(!X){break;}}}Q=Q.substring(0,Q.length-2);if(Q){Q=" ("+Q+")";k+=U[i].getText()+Q+", ";}}}k=k.substring(0,k.length-2);if(k){k=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+k);}}return k;};
u.prototype.getSelectedFilterKeys=function(){var j={},k=this.getSelectedFilterItems(),i=0;for(;i<k.length;i++){j[k[i].getKey()]=k[i].getSelected();}return j;};
u.prototype.getSelectedFilterCompoundKeys=function(){var j={},k=this.getSelectedFilterItems(),i,Q,R,U;for(i=0;i<k.length;i++){U=k[i];if(U instanceof sap.m.ViewSettingsCustomItem){Q=U.getKey();j[Q]=U.getSelected();}else{Q=U.getKey();R=U.getParent().getKey();if(!j[R]){j[R]={};}j[R][Q]=U.getSelected();}}return j;};
u.prototype.setSelectedFilterKeys=function(Q){var R=this.getFilterItems(),U={},W,X,i,j,k;if(Object.keys(Q).length){this._clearPresetFilter();}for(var Y in Q){W=null;if(Q.hasOwnProperty(Y)){for(i=0;i<R.length;i++){if(R[i]instanceof sap.m.ViewSettingsCustomItem){if(R[i].getKey()===Y){W=R[i];R[i].setProperty('selected',Q[Y],true);}}else if(R[i]instanceof sap.m.ViewSettingsFilterItem){U=R[i].getItems();X=R[i].getMultiSelect();for(j=0;j<U.length;j++){if(U[j].getKey()===Y){W=U[j];if(!X){for(k=0;k<U.length;k++){U[k].setProperty('selected',false,true);}}break;}}}if(W){break;}}if(W===null){n.warning('Cannot set state for key "'+Y+'" because there is no filter with these keys');continue;}W.setProperty('selected',Q[Y],true);}}return this;};
u.prototype.setSelectedFilterCompoundKeys=function(i){var j=this.getFilterItems();var k=function(j,$,Y){if(!$.hasOwnProperty(Y)){return;}var Z=w(j,Y);return Z;};if(Object.keys(i).length){this._clearPresetFilter();}for(var Q in i){var R=k(j,i,Q);if(!R){n.warning('No filter with key "'+Q);continue;}if(R instanceof sap.m.ViewSettingsCustomItem){R.setProperty('selected',i[Q],true);}else if(R instanceof sap.m.ViewSettingsFilterItem){var U=i[Q];var W=R.getItems();var X=R.getMultiSelect();for(var Y in U){var Z=k(W,U,Y);if(!Z){n.warning('No filter with key "'+Y);continue;}if(!X){W.forEach(function($){$.setProperty('selected',false,true);});}Z.setProperty('selected',U[Y],true);}}}return this;};
u.prototype._checkResetStatus=function(){var i=false,j=this.getSelectedFilterItems();if(this.getAggregation("customTabs").length>0){i=true;}else{if(this._oInitialState){if(j.length>0){i=true;}if((this._oInitialState.sortItem&&this._oInitialState.sortItem!==this.getSelectedSortItem())||this._oInitialState.sortDescending!==this.getSortDescending()){i=true;}if((this._oInitialState.groupItem&&this._oInitialState.groupItem!==this.getSelectedGroupItem())||this._oInitialState.groupDescending!==this.getGroupDescending()){i=true;}if(this._oInitialState.presetFilterItem!==undefined&&this.getSelectedPresetFilterItem()!==null){i=true;}}}if(this._resetButton){this._resetButton.setEnabled(i);}if(this._detailResetButton){this._detailResetButton.setEnabled(i);}};
u.prototype._globalReset=function(){this.clearFilters();this._oInitialState.sortItem!==undefined&&this.setSelectedSortItem(sap.ui.getCore().byId(this._oInitialState.sortItem));this.setSortDescending(this._oInitialState.sortDescending);this._updateListSelection(this._sortOrderList,this._oInitialState.sortDescending);this._oInitialState.groupItem!==undefined&&this.setSelectedGroupItem(sap.ui.getCore().byId(this._oInitialState.groupItem));this.setGroupDescending(this._oInitialState.groupDescending);this._updateListSelection(this._groupOrderList,this._oInitialState.groupDescending);this._checkResetStatus();this.fireReset();};
u.prototype._getDialog=function(){var i=this;if(this._dialog===undefined){this._dialog=new D(this.getId()+"-dialog",{ariaLabelledBy:this._sTitleLabelId,showHeader:false,stretch:g.system.phone,verticalScrolling:true,horizontalScrolling:false,contentWidth:this._sDialogWidth,contentHeight:this._sDialogHeight,content:this._getNavContainer(),titleAlignment:this.getTitleAlignment(),beginButton:new B(this.getId()+"-acceptbutton",{text:this._rb.getText("VIEWSETTINGS_ACCEPT"),type:sap.m.ButtonType.Emphasized}).attachPress(this._onConfirm,this),endButton:new B(this.getId()+"-cancelbutton",{text:this._rb.getText("VIEWSETTINGS_CANCEL")}).attachPress(this._onCancel,this)}).addStyleClass("sapMVSD");this.addDependent(this._dialog);var j=this._dialog.onsapescape;this._dialog.onsapescape=function(k){if(j){j.call(i._dialog,k);}i._onCancel();};this._dialog.onsapentermodifiers=function(k){if(k.shiftKey&&!k.ctrlKey&&!k.altKey){i._pressBackButton();}};}return this._dialog;};
u.prototype._getNavContainer=function(){if(this._navContainer===undefined){this._navContainer=new N(this.getId()+'-navcontainer',{pages:[]});}return this._navContainer;};
u.prototype._getTitleLabel=function(){if(this._titleLabel===undefined){this._titleLabel=new d(this._sTitleLabelId,{text:this._rb.getText("VIEWSETTINGS_TITLE")}).addStyleClass("sapMVSDTitle");}return this._titleLabel;};
u.prototype._getResetButton=function(){if(!this._resetButton){this._resetButton=new B(this.getId()+"-resetbutton",{press:function(){this._globalReset();}.bind(this),text:this._rb.getText("VIEWSETTINGS_RESET")});}return this._resetButton;};
u.prototype._getDetailResetButton=function(){if(this._detailResetButton===undefined){this._detailResetButton=new B(this.getId()+"-detailresetbutton",{press:function(){this._globalReset();}.bind(this),text:this._rb.getText("VIEWSETTINGS_RESET")});}return this._detailResetButton;};
u.prototype._getDetailTitleLabel=function(){if(this._detailTitleLabel===undefined){this._detailTitleLabel=new d(this.getId()+"-detailtitle",{text:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")}).addStyleClass("sapMVSDTitle");}return this._detailTitleLabel;};
u.prototype._getHeader=function(){if(this._header===undefined){this._header=new e({contentMiddle:[this._getTitleLabel()]}).addStyleClass("sapMVSDBar");}this._setupBarTitleAlignment(this._header,this.getId()+'_header');return this._header;};
u.prototype._getSubHeader=function(){if(this._subHeader===undefined){this._subHeader=new e({contentLeft:[this._getSegmentedButton()]}).addStyleClass("sapMVSDBar");}return this._subHeader;};
u.prototype._getSegmentedButton=function(){var j=this,k=this.getCustomTabs(),Q=k.length,i=0;if(this._segmentedButton===undefined){this._segmentedButton=new f({select:function(R){var U=R.getParameter('id');if(U===j.getId()+"-sortbutton"){j._switchToPage(0);}else if(U===j.getId()+"-groupbutton"){j._switchToPage(1);}else if(U===j.getId()+"-filterbutton"){j._switchToPage(2);}else{for(i=0;i<Q;i++){var W=k[i],X=j.getId()+j._sCustomTabsButtonsIdPrefix+W.getId();if(!j._isEmptyTab(W)&&U===X){j._switchToPage(W.getId());break;}}}n.info('press event segmented: '+R.getParameter('id'));}}).addStyleClass("sapMVSDSeg");this._segmentedButton._bPreventWidthRecalculationOnAfterRendering=true;}return this._segmentedButton;};
u.prototype._getSortButton=function(){if(this._sortButton===undefined){this._sortButton=new B(this.getId()+"-sortbutton",{icon:I.getIconURI("sort"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});}return this._sortButton;};
u.prototype._getGroupButton=function(){if(this._groupButton===undefined){this._groupButton=new B(this.getId()+"-groupbutton",{icon:I.getIconURI("group-2"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});}return this._groupButton;};
u.prototype._getFilterButton=function(){if(this._filterButton===undefined){this._filterButton=new B(this.getId()+"-filterbutton",{icon:I.getIconURI("filter"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_FILTER")});}return this._filterButton;};
u.prototype._getPage1=function(i){if(this._page1===undefined&&!i){this._page1=new P(this.getId()+'-page1',{title:this._rb.getText("VIEWSETTINGS_TITLE"),customHeader:this._getHeader()});this._getNavContainer().addPage(this._page1);}return this._page1;};
u.prototype._getPage2=function(){var i,j,k;if(this._page2===undefined){j=new B(this.getId()+"-backbutton",{icon:I.getIconURI("nav-back"),press:[this._pressBackButton,this]});k=this._getDetailResetButton();i=new e({contentLeft:[j],contentMiddle:[this._getDetailTitleLabel()],contentRight:[k]}).addStyleClass("sapMVSDBar");this._setupBarTitleAlignment(i,this.getId()+"_page2_header");this._page2=new P(this.getId()+'-page2',{title:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY"),customHeader:i});this._getNavContainer().addPage(this._page2);}return this._page2;};
u.prototype._initFilterDetailItems=function(k){if(!(k instanceof sap.m.ViewSettingsFilterItem)){return;}var Q;var R=k.getMultiSelect();var U=k.getItems();var W=this;if(this._filterDetailList){this._filterDetailList.destroy();}this._getPage2().removeAllAggregation('content');this._filterDetailList=new L({mode:(R?o.MultiSelect:o.SingleSelectLeft),includeItemInSelection:true,selectionChange:function(X){var Y,Z=X.getParameter("listItems"),$,i=0,_;W._clearPresetFilter();if(R){this._updateSelectAllCheckBoxState();}if(Z.length>1&&R){$=k.getItems();for(;i<$.length;i++){for(var j=0;j<Z.length;j++){if($[i].getKey()===Z[j].getCustomData()[0].getValue().getKey()){$[i].setProperty('selected',Z[j].getSelected(),true);}}}}else{Y=X.getParameter("listItem").data("item");if(!k.getMultiSelect()){$=k.getItems();for(;i<$.length;i++){if($[i].getId()!==Y.getId()){$[i].setProperty('selected',false,true);}}}_=X.getParameter("listItem").getSelected();if(Y.getProperty('selected')!==_){Y.setProperty('selected',_,true);}}this._checkResetStatus();}.bind(this)});for(var i=0;i<U.length;i++){Q=new c({title:M.escapeSettingsValue(U[i].getText()),type:p.Active,selected:U[i].getSelected(),tooltip:U[i].getTooltip()}).data("item",U[i]);this._filterDetailList.addItem(Q);}this._filterSearchField=this._getFilterSearchField(this._filterDetailList);this._getPage2().addContent(this._filterSearchField.addStyleClass('sapMVSDFilterSearchField'));this._getPage2().getCustomHeader().addStyleClass('sapMVSDBarWithSearch');if(R){this._selectAllCheckBox=this._createSelectAllCheckbox(U,this._filterDetailList);if(this._filterDetailList.getItems().length===0){this._selectAllCheckBox.setEnabled(false);}this._filterDetailList.setHeaderToolbar(new a({content:[this._selectAllCheckBox]}).addStyleClass('sapMVSDFilterHeaderToolbar'));}this._getPage2().addContent(this._filterDetailList);};
u.prototype._initSortContent=function(){if(this._sortContent){return;}this._vContentPage=-1;this._ariaSortOrderInvisibleText=new h(this.getId()+"-sortOrderLabel",{text:this._rb.getText("VIEWSETTINGS_SORT_DIRECTION")});this._sortOrderList=new L(this.getId()+"-sortorderlist",{mode:o.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(i){this.setProperty('sortDescending',i.getParameter("listItem").data("item"),true);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaSortOrderInvisibleText});this._sortOrderList.addItem(new G({title:this._rb.getText("VIEWSETTINGS_SORT_BY")}));this._sortOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._sortOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaSortListInvisibleText=new h(this.getId()+"-sortListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});this._sortList.addAriaLabelledBy(this._ariaSortListInvisibleText);this._sortContent=[this._ariaSortOrderInvisibleText,this._sortOrderList,this._ariaSortListInvisibleText,this._sortList];};
u.prototype._initGroupItems=function(){var i,j,k=this.getGroupItems(),Q=this._rb.getText("VIEWSETTINGS_GROUP_OBJECT");this._groupList.destroyItems();if(!!k.length){this._groupList.addItem(new G({title:Q}));k.forEach(function(R){i=new c({id:R.getId()+t,title:M.escapeSettingsValue(R.getText()),type:p.Active,selected:R.getSelected(),tooltip:R.getTooltip()}).data("item",R);this._groupList.addItem(i);},this);if(!this._oGroupingNoneItem||this._oGroupingNoneItem.bIsDestroyed){j=!!this.getSelectedGroupItem();this._oGroupingNoneItem=new V({text:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!j,itemPropertyChanged:function(){this._initGroupContent();this._initGroupItems();}.bind(this)});!j&&this.setAssociation("selectedGroupItem",this._oGroupingNoneItem,true);}i=new c({id:this._oGroupingNoneItem.getId()+t,title:this._oGroupingNoneItem.getText(),type:p.Active,selected:this._oGroupingNoneItem.getSelected()}).data("item",this._oGroupingNoneItem);this._groupList.addItem(i);}};
u.prototype._initGroupContent=function(){var i=this._rb.getText("VIEWSETTINGS_GROUP_BY");if(this._groupContent){return;}this._vContentPage=-1;this._ariaGroupOrderInvisibleText=new h(this.getId()+"-groupOrderLabel",{text:this._rb.getText("VIEWSETTINGS_GROUP_DIRECTION")});this._groupOrderList=new L(this.getId()+"-grouporderlist",{mode:o.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(j){this.setProperty('groupDescending',j.getParameter("listItem").data("item"),true);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaGroupOrderInvisibleText});this._groupOrderList.addItem(new G({title:i}));this._groupOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._groupOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaGroupListInvisibleText=new h(this.getId()+"-groupListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});this._groupList=new L(this.getId()+"-grouplist",{mode:o.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(j){var k=j.getParameter("listItem").data("item");this.setSelectedGroupItem(k);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaGroupListInvisibleText});this._groupContent=[this._ariaGroupOrderInvisibleText,this._groupOrderList,this._ariaGroupListInvisibleText,this._groupList];};
u.prototype._initFilterItems=function(){var i,j,k,Q=this,R=this._rb.getText("VIEWSETTINGS_FILTER_BY");this._presetFilterList.destroyItems();i=this.getPresetFilterItems();if(i.length){i.forEach(function(U){k=new c({id:U.getId()+t,title:M.escapeSettingsValue(U.getText()),type:p.Active,selected:U.getSelected(),tooltip:U.getTooltip()}).data("item",U);this._presetFilterList.addItem(k);},this);}if(i.length){k=new c({id:this._presetFilterList.getId()+"-none"+t,title:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!!this.getSelectedPresetFilterItem()});this._presetFilterList.addItem(k);}this._filterList.destroyItems();j=this.getFilterItems();this._filterList.addItem(new G({title:R}));if(j.length){j.forEach(function(U){k=new c({id:U.getId()+t,title:M.escapeSettingsValue(U.getText()),type:p.Active,tooltip:U.getTooltip(),press:(function(U){return function(W){if(Q._navContainer.getCurrentPage().getId()!==Q.getId()+'-page2'){Q._switchToPage(3,U);Q._prevSelectedFilterItem=this;setTimeout(Q._navContainer["to"].bind(Q._navContainer,Q.getId()+'-page2',"slide"),0);}if(g.system.desktop&&Q._filterDetailList&&Q._filterDetailList.getItems()[0]){Q._getNavContainer().attachEventOnce("afterNavigate",function(){Q._filterDetailList.getItems()[0].focus();});}};}(U))}).data("item",U);this._filterList.addItem(k);},this);}};
u.prototype._initFilterContent=function(){if(this._filterContent){return;}this._vContentPage=-1;this._presetFilterList=new L(this.getId()+"-predefinedfilterlist",{mode:o.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(i){var j=i.getParameter("listItem").data("item");if(j){j.setProperty('selected',i.getParameter("listItem").getSelected(),true);}this.setAssociation("selectedPresetFilterItem",j,true);this._clearSelectedFilters();this._checkResetStatus();}.bind(this)});this._filterList=new L(this.getId()+"-filterlist",{});this._filterContent=[this._presetFilterList,this._filterList];};
u.prototype._initDialogContent=function(i){var j=!!this.getSortItems().length,k=!!this.getGroupItems().length,Q=!!this.getPresetFilterItems().length,R=!!this.getFilterItems().length;if(j){this._initSortContent();}if(k){this._initGroupContent();this._initGroupItems();}if(Q||R){this._initFilterContent();this._initFilterItems();}this._updateDialogState(i);this._updateListSelections();};
u.prototype._getTabButton=function(i,j){var k=j+i.getId(),Q=sap.ui.getCore().byId(k);if(Q){return Q;}else{return new B({id:k,icon:i.getIcon(),tooltip:i.getTooltip()});}};
u.prototype._updateDialogState=function(i){var j=!!this.getSortItems().length,k=!!this.getGroupItems().length,Q=!!this.getPresetFilterItems().length,R=!!this.getFilterItems().length,U=!!this.getCustomTabs().length,W=this._getSegmentedButton(),X=null,Y=false,Z={"sort":0,"group":1,"filter":2};W.removeAllButtons();if(this._filterContent){this._presetFilterList.setVisible(true);this._filterList.setVisible(true);}if(j){W.addButton(this._getSortButton());}if(Q||R){W.addButton(this._getFilterButton());if(!Q){this._presetFilterList.setVisible(false);}if(!R){this._filterList.setVisible(false);}}if(k){W.addButton(this._getGroupButton());}if(U){this.getCustomTabs().forEach(function(_){if(!this._isEmptyTab(_)){var a1=this.getId()+this._sCustomTabsButtonsIdPrefix,b1=this._getTabButton(_,a1);W.addButton(b1);}}.bind(this));}this._showSubHeader=this._hasSubHeader();if(i===undefined&&this._vContentPage!==-1){i=this._vContentPage;switch(i){case 0:i='sort';break;case 1:i='group';break;case 2:i='filter';break;}}if(i===this._vContentPage&&this._vContentPage===3){this._vContentPage=-1;this._switchToPage(3,this._oContentItem);}else{i=this._determineValidPageId(i);for(var $ in Z){if(i===$){Y=true;X=this.getId()+'-'+i+'button';i=Z[$];break;}}if(!Y){X=this.getId()+this._sCustomTabsButtonsIdPrefix+i;}this._getSegmentedButton().setSelectedButton(X);this._switchToPage(i);if(this._getNavContainer().getCurrentPage()!==this._getPage1()){this._getNavContainer().to(this._getPage1().getId());}}};
u.prototype._determineValidPageId=function(i){var j='sort',k=false,Q=[];Q=this._fetchValidPagesIds();if(Q.length){j=Q[0];}else{n.warning('No available pages to load - missing items.');}if(!i){i=j;}else{Q.filter(function(R){if(R===i){k=true;return false;}return true;});if(!k){i=j;}}return i;};
u.prototype._fetchValidPagesIds=function(){var i,j=this.getCustomTabs(),k=j.length,Q=[];var R=['sort','filter','group'];R.forEach(function(W){if(this._isValidPredefinedPageId(W)){Q.push(W);}},this);for(i=0;i<k;i++){var U=j[i];if(!this._isEmptyTab(U)){Q.push(U.getId());}}return Q;};
u.prototype._isEmptyTab=function(i){return!(i.getContent().length||this._vContentPage===i.getId()&&this._getPage1().getContent().length);};
u.prototype._isValidPredefinedPageId=function(i){if(!i){n.warning('Missing mandatory parameter.');return false;}var j=false;switch(i){case'sort':j=!!this.getSortItems().length;break;case'filter':j=!!this.getFilterItems().length||!!this.getPresetFilterItems().length;break;case'group':j=!!this.getGroupItems().length;break;}return j;};
u.prototype._pressBackButton=function(){var i=this;if(this._vContentPage===3){this._updateFilterCounters();this._getNavContainer().attachEvent("afterNavigate",function(){if(i._prevSelectedFilterItem){i._prevSelectedFilterItem.focus();}});setTimeout(this._getNavContainer()['back'].bind(this._getNavContainer()),0);this._switchToPage(2);this._segmentedButton.setSelectedButton(this._filterButton);}};
u.prototype.setModel=function(i,j){if(this._vContentPage===3&&this._oContentItem){v.call(this);}return M.prototype.setModel.call(this,i,j);};
u.prototype.removeFilterItem=function(i){var j="";if(this._vContentPage===3&&this._oContentItem){if(typeof(i)==="object"){j=i.getId();}else if(typeof(i)==="string"){j=i;}else if(typeof(i)==="number"){j=this.getFilterItems()[i].getId();}if(this._oContentItem.getId()===j){v.call(this);}}return this.removeAggregation('filterItems',i);};
u.prototype.removeAllFilterItems=function(){if(this._vContentPage===3&&this._oContentItem){v.call(this);}return this.removeAllAggregation('filterItems');};
u.prototype.setFilterSearchCallback=function(i){this._fnFilterSearchCallback=i;return this;};
u.prototype._switchToPage=function(W,j){var i=0,k=this._getTitleLabel(),Q=this._getHeader(),R=this._getSubHeader();this._checkResetStatus();this._getPage2().getCustomHeader().removeStyleClass('sapMVSDBarWithSearch');if(A.call(this)){z.call(this);}Q.removeAllContentRight();R.removeAllContentRight();this._vContentPage=W;this._oContentItem=j;if(W!==3){this._getPage1().removeAllAggregation("content",true);this._addResetButtonToPage1();}else if(W===3){this._getPage2().removeAllAggregation("content",true);}if(this.getTitle()){k.setText(this.getTitle());}else{k.setText(this._rb.getText("VIEWSETTINGS_TITLE"));}this._toggleDialogTitle(this._sTitleLabelId);switch(W){case 1:if(!this._showSubHeader&&!this.getTitle()){k.setText(this._rb.getText("VIEWSETTINGS_TITLE_GROUP"));}for(;i<this._groupContent.length;i++){this._getPage1().addContent(this._groupContent[i]);}break;case 2:if(!this._showSubHeader&&!this.getTitle()){k.setText(this._rb.getText("VIEWSETTINGS_TITLE_FILTER"));}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();for(;i<this._filterContent.length;i++){this._getPage1().addContent(this._filterContent[i]);}break;case 3:this._setFilterDetailTitle(j);if(j instanceof sap.m.ViewSettingsCustomItem&&j.getCustomControl()){this._clearPresetFilter();this._getPage2().addContent(j.getCustomControl());}else if(j instanceof sap.m.ViewSettingsFilterItem&&j.getItems()){this._initFilterDetailItems(j);}break;case 0:if(!this._getPage1().getSubHeader()&&!this.getTitle()){k.setText(this._rb.getText("VIEWSETTINGS_TITLE_SORT"));}if(this._sortContent){for(;i<this._sortContent.length;i++){this._getPage1().addContent(this._sortContent[i]);}}break;default:this._getPage1().removeAllAggregation("content",true);var U="VIEWSETTINGS_TITLE";var X=this.getCustomTabs();if(X.length<2){U=X[0].getTitle();}if(!this._getPage1().getSubHeader()&&!this.getTitle()){k.setText(U);}X.forEach(function(Y){if(Y.getId()===W){Y.getContent().forEach(function(Z){this._getPage1().addContent(Z);},this);}},this);break;}if(W===3){this.fireFilterDetailPageOpened({parentFilterItem:j});}};
u.prototype._createSelectAllCheckbox=function(i,j){var k=false;if(i&&i.length!==0){k=i.every(function(R){return R.getSelected();});}var Q=new b({text:this._rb.getText("COLUMNSPANEL_SELECT_ALL"),selected:k,select:function(R){var U=R.getParameter('selected');j.getItems().filter(function(W){return W.getVisible();}).forEach(function(W){var X=W.data("item");X.setSelected(U);});this._checkResetStatus();}.bind(this)});return Q;};
u.prototype._updateSelectAllCheckBoxState=function(){var i=false,j=this._filterDetailList.getItems(),k=[];if(!this._selectAllCheckBox){return;}if(j&&j.length!==0){k=j.filter(function(Q){return Q.getVisible();});}if(k.length!==0){this._selectAllCheckBox.setEnabled(true);i=k.every(function(Q){return Q.getSelected();});}else{this._selectAllCheckBox.setEnabled(false);}this._selectAllCheckBox.setSelected(i);};
u.prototype._getFilterSearchField=function(i){var j=new S({liveChange:function(k){var Q=k.getParameter('newValue'),R=this._getStringFilter();i.getItems().forEach(function(U){var W=R(Q,U.getTitle());U.setVisible(W);});this._updateSelectAllCheckBoxState();}.bind(this)});return j;};
u.prototype._getStringFilter=function(){if(this._fnFilterSearchCallback){return this._fnFilterSearchCallback;}if(!this._oStringFilter||this._oStringFilter.sOperator!==this.getFilterSearchOperator()){this._oStringFilter=new F(this.getFilterSearchOperator());}return this._oStringFilter.filter.bind(this._oStringFilter);};
u.prototype._updateListSelections=function(){this._updateListSelection(this._sortList,sap.ui.getCore().byId(this.getSelectedSortItem()));this._updateListSelection(this._sortOrderList,this.getSortDescending());this._updateListSelection(this._groupList,sap.ui.getCore().byId(this.getSelectedGroupItem()));this._updateListSelection(this._groupOrderList,this.getGroupDescending());this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();};
u.prototype._updateListSelection=function(j,k){var Q,i=0,R;if(!j){return false;}Q=j.getItems();j.removeSelections();for(;i<Q.length;i++){R=Q[i].isA("sap.m.GroupHeaderListItem");if(!R&&(Q[i].data("item")===k||Q[i].data("item")===null)){j.setSelectedItem(Q[i],(k&&k.getSelected?k.getSelected():true));return true;}}return false;};
u.prototype._updateFilterCounters=function(){var k=(this._filterList?this._filterList.getItems():[]),Q,R,U=0,i=0,j;for(;i<k.length;i++){Q=k[i].data("item");U=0;if(Q){if(Q instanceof sap.m.ViewSettingsCustomItem){U=Q.getFilterCount();}else if(Q instanceof sap.m.ViewSettingsFilterItem){U=0;R=Q.getItems();for(j=0;j<R.length;j++){if(R[j].getSelected()){U++;}}}}k[i].setCounter(U);}};
u.prototype._clearSelectedFilters=function(){var k=this.getFilterItems(),Q,i=0,j;for(;i<k.length;i++){if(k[i]instanceof sap.m.ViewSettingsFilterItem){Q=k[i].getItems();for(j=0;j<Q.length;j++){Q[j].setProperty('selected',false,true);}}k[i].setProperty('selected',false,true);}if(this._vContentPage===2&&this._getDialog().isOpen()){this._updateFilterCounters();}};
u.prototype._clearPresetFilter=function(){if(this.getSelectedPresetFilterItem()){this.setSelectedPresetFilterItem(null);}};
u.prototype._calculateNumberOfPages=function(){var i=0,j=!!this.getSortItems().length,k=!!this.getGroupItems().length,Q=!!this.getPresetFilterItems().length,R=!!this.getFilterItems().length;if(j){i++;}if(Q||R){i++;}if(k){i++;}this.getCustomTabs().forEach(function(U){if(!this._isEmptyTab(U)){i++;}},this);return i;};
u.prototype._hasSubHeader=function(){return!(this._calculateNumberOfPages()<2);};
function v(){this._vContentPage=2;this._oContentItem=null;this._navContainer.to(this._getPage1().getId(),"show");}
function w(j,k){var i,Q;for(i=0;i<j.length;i++){if(j[i].getKey()===k){Q=j[i];break;}}return Q;}
function x(i,j,k){var Q;if(typeof i==="string"){Q=w(j,i);if(!Q){n.error(k);}}else{Q=i;}return Q;}
function y(i){return i&&i instanceof sap.m.ViewSettingsItem;}
u.prototype._onConfirm=function(i){var j=this._getDialog(),k=this,Q=function(){var R,U,W=k.getSelectedGroupItem();if(!k._oGroupingNoneItem||W!=k._oGroupingNoneItem.getId()){U=sap.ui.getCore().byId(W);}k._toggleDialogTitle(k._sTitleLabelId);R={sortItem:sap.ui.getCore().byId(k.getSelectedSortItem()),sortDescending:k.getSortDescending(),groupItem:U,groupDescending:k.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(k.getSelectedPresetFilterItem()),filterItems:k.getSelectedFilterItems(),filterKeys:k.getSelectedFilterKeys(),filterCompoundKeys:k.getSelectedFilterCompoundKeys(),filterString:k.getSelectedFilterString()};k._dialog.detachAfterClose(Q);k.fireConfirm(R);};j.attachAfterClose(Q);j.close();};
u.prototype._onCancel=function(i){var j=this,k=this._getDialog(),Q=function(){j._toggleDialogTitle(j._sTitleLabelId);j.setSelectedSortItem(j._oPreviousState.sortItem);j.setSortDescending(j._oPreviousState.sortDescending);j.setSelectedGroupItem(j._oPreviousState.groupItem);j.setGroupDescending(j._oPreviousState.groupDescending);j.setSelectedPresetFilterItem(j._oPreviousState.presetFilterItem);j._clearSelectedFilters();j.setSelectedFilterCompoundKeys(j._oPreviousState.filterCompoundKeys);if(j._navContainer.getCurrentPage()!==j._oPreviousState.navPage){setTimeout(j._navContainer["to"].bind(j._navContainer,j._oPreviousState.navPage.getId(),"show"),0);}j._switchToPage(j._oPreviousState.contentPage,j._oPreviousState.contentItem);j._dialog.detachAfterClose(Q);j.fireCancel();};k.attachAfterClose(Q);k.close();};
u.prototype.clearFilters=function(){this._clearSelectedFilters();this._clearPresetFilter();this.fireResetFilters();this._updateFilterCounters();if(this._vContentPage===3){setTimeout(this._getNavContainer()['to'].bind(this._getNavContainer(),this._getPage1().getId()),0);this._switchToPage(2);this._getSegmentedButton().setSelectedButton(this._getFilterButton());}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));return this;};
u.prototype._addResetButtonToPage1=function(){var i=this._getHeader(),j=this._getSubHeader(),R=this._getResetButton();if(this._showSubHeader){if(!this._getPage1().getSubHeader()){this._getPage1().setSubHeader(j);}}else{if(this._getPage1().getSubHeader()){this._getPage1().setSubHeader();}}i.addContentRight(R);};
u.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
function z(i,j){if(!this._getPage1(true)){return;}if(i==='customTabs'&&j){if(j.getMetadata().getName()===this.getMetadata().getManagedAggregation(i).type&&this._vContentPage===j.getId()){var k=this._getPage1().getContent();k.forEach(function(Q){j.addAggregation('content',Q,true);});}}else if(!i&&!j){var k=this._getPage1().getContent();this.getCustomTabs().forEach(function(j){if(this._vContentPage===j.getId()){k.forEach(function(Q){j.addAggregation('content',Q,true);});}},this);}}
function A(){var i=[-1,0,1,2,3];return(this._getPage1().getContent().length&&i.indexOf(this._vContentPage)===-1);}
u.prototype.setBusy=function(i){this._getDialog().setBusy(i);return this;};
var F=function(i){this.sOperator=i||r.StartsWith;switch(this.sOperator){case r.Equals:this.fnOperator=H;break;case r.Contains:this.fnOperator=J;break;case r.StartsWith:this.fnOperator=K;break;case r.AnyWordStartsWith:this.fnOperator=O;break;default:n.warning("Unknown string compare operator. Use values from sap.m.StringFilterOperator. Default operator should be used.");this.fnOperator=J;break;}};
F.prototype.filter=function(Q,i){if(!Q){return true;}if(!i){return false;}i=i.toLowerCase();Q=Q.toLowerCase();return this.fnOperator(Q,i);};
function H(Q,i){return i===Q;}
function J(Q,i){return i.indexOf(Q)>-1;}
function K(Q,i){return i.indexOf(Q)===0;}
function O(Q,i){var j=new RegExp(".*\\b"+Q+".*");return j.test(i);}
T.mixInto(u.prototype);return u;});
sap.ui.predefine('sap/m/ViewSettingsDialogRenderer',[],function(){"use strict";var V={};
V.render=function(r,c){};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsFilterItem',['./ViewSettingsItem','./library','sap/ui/base/ManagedObject'],function(V,l,M){"use strict";
var a=V.extend("sap.m.ViewSettingsFilterItem",{metadata:{library:"sap.m",properties:{multiSelect:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{items:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{filterDetailItemsAggregationChange:{}}}});
a.prototype._handleNewAggregationEvents=function(o){o.attachEvent('itemPropertyChanged',function(e){this.fireItemPropertyChanged({changedItem:e.getParameter('changedItem'),propertyKey:e.getParameter('propertyKey'),propertyValue:e.getParameter('propertyValue')});}.bind(this));this.fireFilterDetailItemsAggregationChange({item:o});};
a.prototype.addAggregation=function(A,o,s){M.prototype.addAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.insertAggregation=function(A,o,i,s){M.prototype.insertAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.removeAggregation=function(A,o,s){M.prototype.removeAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.removeAllAggregation=function(A,s){M.prototype.removeAllAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.destroyAggregation=function(A,s){M.prototype.destroyAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
return a;});
sap.ui.predefine('sap/m/ViewSettingsItem',['./library','sap/ui/core/Item','sap/ui/base/ManagedObject'],function(l,I,M){"use strict";
var V=I.extend("sap.m.ViewSettingsItem",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Behavior",defaultValue:false}},events:{itemPropertyChanged:{parameters:{changedItem:{type:'sap.m.ViewSettingsItem'},propertyKey:{type:"string"},propertyValue:{type:"any"}}}}}});
V.prototype.setSelected=function(v){V.prototype.setProperty.call(this,"selected",v,true);return this;};
V.prototype.setProperty=function(n,v,s,f){M.prototype.setProperty.apply(this,arguments);f=f===undefined?true:f;if(f){this.fireItemPropertyChanged({changedItem:this,propertyKey:n,propertyValue:v});}};
return V;});
sap.ui.predefine('sap/m/VisibleItem',['./library','sap/ui/core/Item',"sap/ui/thirdparty/jquery"],function(l,I,q){"use strict";
var V=I.extend("sap.m.VisibleItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Behavior",defaultValue:true}}}});
V.prototype._getRefs=function(){var p=this.getParent(),$,t=this;if(p&&p.$("content")){$=p.$("content").find("li").filter(function(){return q(this).html()===t.getText();});}return $;};
V.prototype.setVisible=function(v){if(this.getVisible()===v){return;}var $=this._getRefs();if($){if(v){$.removeClass('TPSliderItemHidden');}else{$.addClass('TPSliderItemHidden');}}return this.setProperty('visible',v,true);};
return V;});
sap.ui.predefine('sap/m/WizardProgressNavigator',["./library","sap/ui/core/Control","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ItemNavigation","sap/ui/Device","sap/m/ActionSheet","./WizardProgressNavigatorRenderer","./Button","sap/ui/thirdparty/jquery"],function(l,C,R,I,D,A,W,B,q){"use strict";
var a=C.extend("sap.m.WizardProgressNavigator",{metadata:{properties:{stepCount:{type:"int",group:"Data",defaultValue:3},stepTitles:{type:"string[]",group:"Appearance",defaultValue:[]},stepIcons:{type:"sap.ui.core.URI[]",group:"Appearance",defaultValue:[]},varyingStepCount:{type:"boolean",group:"Appearance",defaultValue:false}},events:{stepChanged:{parameters:{current:{type:"int"}}}}}});
a.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,MIN_STEP_WIDTH_NO_TITLE:64,MIN_STEP_WIDTH_WITH_TITLE:200};a.TEXT={SELECTED:"WIZARD_PROG_NAV_SELECTED",PROCESSED:"WIZARD_PROG_NAV_PROCESSED",STEP:"WIZARD_PROG_NAV_STEP_TITLE",OPTIONAL_STEP:"WIZARD_STEP_OPTIONAL_STEP_TEXT"};
a.prototype.init=function(){this._iCurrentStep=1;this._iActiveStep=1;this._aCachedSteps=[];this._aStepOptionalIndication=[];this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oActionSheet=new A();this._createAnchorNavigation();};
a.prototype.onBeforeRendering=function(){if(this.getStepCount()!==this.getStepIcons().filter(String).length){this.setStepIcons([]);}if(this.getStepCount()!==this.getStepTitles().filter(String).length){this.setStepTitles([]);}};
a.prototype.onAfterRendering=function(){var $,z=this._iActiveStep-1,Z=this._iCurrentStep-1;this._cacheDOMElements();this._updateStepZIndex();this._updateAnchorNavigation(z);this._updateStepActiveAttribute(z);this._removeAnchorAriaDisabledAttribute(z);this._updateStepCurrentAttribute(Z);this._updateAnchorAriaLabelAttribute(Z);this._updateOpenSteps();R.register(this.getDomRef(),this._updateOpenSteps.bind(this));if(D.os.name===D.os.OS.IOS){$=this.$().find(".sapMWizardProgressNavStep").css("display","block");setTimeout($["css"].bind($,"display",""),0);}};
a.prototype.ontap=function(e){if(this._isGroupAtStart(e.target)){return this._showActionSheet(e.target,true);}if(this._isGroupAtEnd(e.target)){return this._showActionSheet(e.target,false);}if(!this._isAnchor(e.target)||!this._isOpenStep(e.target)||!this._isActiveStep(this._getStepNumber(e.target))){return;}this._updateCurrentStep(this._getStepNumber(e.target));this.fireStepChanged({current:this._getStepNumber(e.target)});};
a.prototype.onsapspace=function(e){if(this._onEnter){this._onEnter(e,this._oAnchorNavigation.getFocusedIndex());}this.ontap(e);};
a.prototype.onsapenter=a.prototype.onsapspace;
a.prototype.exit=function(){R.deregisterAllForControl(this.getId());this.removeDelegate(this._oAnchorNavigation);this._oAnchorNavigation.destroy();this._oAnchorNavigation=null;this._oActionSheet.destroy();this._oActionSheet=null;this._iCurrentStep=null;this._iActiveStep=null;this._aCachedSteps=null;this._aStepOptionalIndication=null;};
a.prototype.getCurrentStep=function(){return this._iCurrentStep;};
a.prototype.getProgress=function(){return this._iActiveStep;};
a.prototype.previousStep=function(){var c=this.getCurrentStep();if(c<2){return this;}return this._moveToStep(c-1);};
a.prototype.nextStep=function(){return this._moveToStep(this.getCurrentStep()+1);};
a.prototype.incrementProgress=function(){return this._moveToStep(this.getProgress()+1);};
a.prototype.discardProgress=function(i){if(i<=0||i>this._iActiveStep){return this;}this._updateCurrentStep(i,this._iCurrentStep);this._updateStepActiveAttribute(i-1,this._iActiveStep-1);this._addAnchorAriaDisabledAttribute(i-1);this._updateAnchorNavigation(i-1);this._iCurrentStep=i;this._iActiveStep=i;};
a.prototype._setOnEnter=function(c){this._onEnter=c;};
a.prototype._createAnchorNavigation=function(){var t=this;this._oAnchorNavigation=new I();this._oAnchorNavigation.setCycling(false);this._oAnchorNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this._oAnchorNavigation.attachEvent("AfterFocus",function(p){var e=p.mParameters.oEvent;if(!e||!e.relatedTarget||q(e.relatedTarget).hasClass(W.CLASSES.ANCHOR)){return;}t._oAnchorNavigation.focusItem(t._iCurrentStep-1);});this.addDelegate(this._oAnchorNavigation);};
a.prototype._cacheDOMElements=function(){var d=this.getDomRef();this._aCachedSteps=d.querySelectorAll("."+W.CLASSES.STEP);};
a.prototype._updateStepZIndex=function(){var z=this._iCurrentStep-1,s=this._aCachedSteps.length,Z=a.CONSTANTS.MAXIMUM_STEPS;for(var i=0;i<s;i++){if(i<=z){this._aCachedSteps[i].style.iZIndex=0;}else{this._aCachedSteps[i].style.iIndex=Z;Z-=1;}}};
a.prototype._updateAnchorNavigation=function(b){var n=this.getDomRef(),f=[];for(var i=0;i<=b;i++){if(this._aCachedSteps[i]){f.push(this._aCachedSteps[i].children[0]);}}this._oAnchorNavigation.setRootDomRef(n);this._oAnchorNavigation.setItemDomRefs(f);this._oAnchorNavigation.setPageSize(b);this._oAnchorNavigation.setFocusedIndex(b);};
a.prototype._updateStepActiveAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.ACTIVE_STEP);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.ACTIVE_STEP,true);}};
a.prototype._updateStepCurrentAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.CURRENT_STEP);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.CURRENT_STEP,true);}};
a.prototype._addAnchorAriaDisabledAttribute=function(b){var s=this._aCachedSteps.length,o;for(var i=b+1;i<s;i++){o=this._aCachedSteps[i].children[0];o.setAttribute(W.ATTRIBUTES.ARIA_DISABLED,true);o.removeAttribute(W.ATTRIBUTES.ARIA_LABEL);}};
a.prototype._removeAnchorAriaDisabledAttribute=function(i){if(this._aCachedSteps[i]){this._aCachedSteps[i].children[0].removeAttribute(W.ATTRIBUTES.ARIA_DISABLED);}};
a.prototype._updateAnchorAriaLabelAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].children[0].setAttribute(W.ATTRIBUTES.ARIA_LABEL,this._oResourceBundle.getText(a.TEXT.PROCESSED));}if(this._aCachedSteps[n]){this._aCachedSteps[n].children[0].setAttribute(W.ATTRIBUTES.ARIA_LABEL,this._oResourceBundle.getText(a.TEXT.SELECTED));}};
a.prototype._moveToStep=function(n){var s=this.getStepCount(),o=this.getCurrentStep();if(n>s){return this;}if(n>this._iActiveStep){this._updateActiveStep(n);}return this._updateCurrentStep(n,o);};
a.prototype._updateActiveStep=function(n,o){var z=n-1,Z=(o||this._iActiveStep)-1;this._iActiveStep=n;this._updateAnchorNavigation(z);this._removeAnchorAriaDisabledAttribute(z);this._updateStepActiveAttribute(z,Z);};
a.prototype._updateCurrentStep=function(n,o){var z=n-1,Z=(o||this.getCurrentStep())-1;this._iCurrentStep=n;this._updateStepZIndex();this._updateOpenSteps();this._updateStepCurrentAttribute(z,Z);this._updateAnchorAriaLabelAttribute(z,Z);return this;};
a.prototype._updateOpenSteps=function(){var w=this.$().width(),c=this._iCurrentStep-1,b=0,d=true,s=this.getStepTitles().length?Math.floor(w/a.CONSTANTS.MIN_STEP_WIDTH_WITH_TITLE):Math.floor(w/a.CONSTANTS.MIN_STEP_WIDTH_NO_TITLE);[].forEach.call(this._aCachedSteps,function(e){e.setAttribute(W.ATTRIBUTES.OPEN_STEP,false);e.setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,false);e.setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,false);});if(this._aCachedSteps[c]){this._aCachedSteps[c].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);}for(var i=1;i<s;i++){if(d){b+=1;}if(d&&this._aCachedSteps[c+b]){this._aCachedSteps[c+b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d=!d;}else if(!d&&this._aCachedSteps[c-b]){this._aCachedSteps[c-b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d=!d;}else if(this._aCachedSteps[c+b+1]){b+=1;this._aCachedSteps[c+b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d=true;}else if(this._aCachedSteps[c-b]){this._aCachedSteps[c-b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);b+=1;d=false;}}for(i=0;i<this._aCachedSteps.length;i++){if(this._aCachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"&&this._aCachedSteps[i-1]&&this._aCachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"){this._aCachedSteps[i-1].setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,true);}if(this._aCachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"&&this._aCachedSteps[i-1]&&this._aCachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"){this._aCachedSteps[i].setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,true);break;}}};
a.prototype._isGroupAtStart=function(d){var $=q(d).closest("."+W.CLASSES.STEP);var s=this._getStepNumber($);return $.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true"&&s>1;};
a.prototype._isGroupAtEnd=function(d){var $=q(d).closest("."+W.CLASSES.STEP);var s=this._getStepNumber($);return $.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true"&&s<this._aCachedSteps.length;};
a.prototype._showActionSheet=function(d,b){var f=b?0:this._getStepNumber(d)-1;var t=b?this._getStepNumber(d):this._aCachedSteps.length;var s,T;this._oActionSheet.removeAllButtons();for(var i=f;i<t;i++){s=this.getStepIcons()[i];T=this._aCachedSteps[i].childNodes[0].getAttribute("title");this._oActionSheet.addButton(new B({width:"200px",text:T,icon:s,enabled:this._iActiveStep>=(i+1),press:function(c){this._moveToStep(c);this.fireStepChanged({current:c});}.bind(this,i+1)}));}this._oActionSheet.openBy(d);};
a.prototype._isAnchor=function(d){return d.className.indexOf(W.CLASSES.ANCHOR)!==-1;};
a.prototype._isOpenStep=function(d){var $=q(d).closest("."+W.CLASSES.STEP);return $.attr(W.ATTRIBUTES.OPEN_STEP)==="true"||($.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&$.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true")||($.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&$.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true");};
a.prototype._isActiveStep=function(s){return s<=this._iActiveStep;};
a.prototype._getStepNumber=function(d){var $=q(d).closest("."+W.CLASSES.STEP).attr(W.ATTRIBUTES.STEP);return parseInt($);};
return a;});
sap.ui.predefine('sap/m/WizardProgressNavigatorRenderer',[],function(){"use strict";var C={NAVIGATION:"sapMWizardProgressNav",LIST:"sapMWizardProgressNavList",LIST_VARYING:"sapMWizardProgressNavListVarying",LIST_NO_TITLES:"sapMWizardProgressNavListNoTitles",STEP:"sapMWizardProgressNavStep",ANCHOR:"sapMWizardProgressNavAnchor",ANCHOR_CIRCLE:"sapMWizardProgressNavAnchorCircle",ANCHOR_TITLE:"sapMWizardProgressNavAnchorTitle",ANCHOR_TITLE_OPTIONAL_TITLE:"sapMWizardProgressNavAnchorTitleOptional",ANCHOR_TITLE_OPTIONAL_LABEL:"sapMWizardProgressNavAnchorLabelOptional",ANCHOR_ICON:"sapMWizardProgressNavAnchorIcon",ANCHOR_TITLE_CONTAINER:"sapMWizardProgressNavAnchorTitleContainer"};var A={STEP:"data-sap-ui-wpn-step",STEP_COUNT:"data-sap-ui-wpn-step-count",CURRENT_STEP:"data-sap-ui-wpn-step-current",ACTIVE_STEP:"data-sap-ui-wpn-step-active",OPEN_STEP:"data-sap-ui-wpn-step-open",OPEN_STEP_PREV:"data-sap-ui-wpn-step-open-prev",OPEN_STEP_NEXT:"data-sap-ui-wpn-step-open-next",ARIA_LABEL:"aria-label",ARIA_DISABLED:"aria-disabled"};var W={CLASSES:C,ATTRIBUTES:A},r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
W.render=function(R,c){this.startNavigator(R,c);this.renderList(R,c);this.endNavigator(R);};
W.startNavigator=function(R,c){var w=r.getText("WIZARD_LABEL");R.write("<nav");R.writeControlData(c);R.addClass(C.NAVIGATION+" sapContrastPlus");R.writeClasses();R.writeAttribute(A.STEP_COUNT,c.getStepCount());R.writeAccessibilityState({"role":"navigation","label":w});R.write(">");};
W.renderList=function(R,c){this.startList(R,c);this.renderSteps(R,c);this.endList(R);};
W.startList=function(R,c){var s=c.getStepTitles();R.write("<ul");if(c.getVaryingStepCount()){R.addClass(C.LIST_VARYING);}else{R.addClass(C.LIST);}if(!s.length){R.addClass(C.LIST_NO_TITLES);}R.writeAccessibilityState({"role":"list"});R.writeClasses();R.write(">");};
W.renderSteps=function(R,c){var s=c.getStepCount(),S=c.getStepTitles(),a=c._aStepOptionalIndication,b=c.getStepIcons(),o=r.getText("WIZARD_STEP_OPTIONAL_STEP_TEXT");for(var i=1;i<=s;i++){var l=a[i-1]?o:"";this.startStep(R,i);this.renderAnchor(R,c,i,S[i-1],b[i-1],l);this.endStep(R);}};
W.startStep=function(R,s){R.write("<li");R.writeAttribute("class",C.STEP);R.writeAttribute(A.STEP,s);R.writeAccessibilityState({"role":"listitem"});R.write(">");};
W.renderAnchor=function(R,c,s,S,i,o){var a=c._aCachedSteps,b=a[s];R.write("<a tabindex='-1' ");if(!b||!!parseInt(b.style.zIndex)){R.write("aria-disabled='true'");}R.writeAttribute("class",C.ANCHOR);this.writeAnchorTooltip(R,S,o,s);R.write(">");this.renderAnchorCircle(R,i,s);if(S){this.renderAnchorTitle(R,S,o);}R.write("</a>");};
W.renderAnchorCircle=function(R,i,s){R.write("<span");R.writeAttribute("class",C.ANCHOR_CIRCLE);R.write(">");if(i){R.writeIcon(i,[C.ANCHOR_ICON],{title:null});}else{R.write(s);}R.write("</span>");};
W.writeAnchorTooltip=function(R,s,o,S){var a=r.getText("WIZARD_PROG_NAV_STEP_TITLE"),t;if(s){t=S+". "+s;}else{t=a+" "+S;}if(o){t+=" ("+o+")";}R.writeAttributeEscaped("title",t);};
W.renderAnchorTitle=function(R,s,o){R.write("<span");R.writeAttribute("class",C.ANCHOR_TITLE_CONTAINER);R.write(">");R.write("<span");R.addClass(C.ANCHOR_TITLE);if(o){R.addClass(C.ANCHOR_TITLE_OPTIONAL_TITLE);}R.writeClasses();R.write(">");R.writeEscaped(s);R.write("</span>");if(o){R.write("<span");R.writeAttribute("class",C.ANCHOR_TITLE_OPTIONAL_LABEL);R.write(">");R.writeEscaped("("+o+")");R.write("</span>");}R.write("</span>");};
W.endStep=function(R){R.write("</li>");};
W.endList=function(R){R.write("</ul>");};
W.endNavigator=function(R){R.write("</nav>");};
return W;},true);
sap.ui.predefine('sap/m/WizardRenderer',[],function(){"use strict";var W={};
W.render=function(r,w){this.startWizard(r,w);this.renderProgressNavigator(r,w);this.renderWizardSteps(r,w);this.endWizard(r);};
W.startWizard=function(r,w){var s=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("WIZARD_LABEL");r.write("<div");r.writeControlData(w);r.addClass("sapMWizard");r.addClass("sapMWizardBg"+w.getBackgroundDesign());r.writeClasses();r.addStyle("width",w.getWidth());r.addStyle("height",w.getHeight());r.writeAccessibilityState({"label":s});r.writeStyles();r.write(">");};
W.renderProgressNavigator=function(r,w){r.renderControl(w.getAggregation("_progressNavigator"));};
W.renderWizardSteps=function(r,w){r.write("<section class='sapMWizardStepContainer'");r.writeAttribute("id",w.getId()+"-step-container");r.write(">");var R=this._getStepsRenderingOrder(w);R.forEach(r.renderControl,r);r.write("</section>");};
W.endWizard=function(r){r.write("</div>");};
W._getStepsRenderingOrder=function(w){if(!w.getEnableBranching()){return w.getSteps();}var s=w.getSteps().slice(),i,r,j,S;var c=function(a,i,r){var o=sap.ui.getCore().byId(a);if(s.indexOf(o)<s.indexOf(r)){var b=s.indexOf(o),t=s[b];s[b]=r;s[i]=t;i=0;}return i;};for(i=0;i<s.length;i++){r=s[i];S=r.getSubsequentSteps();if(S.length<1&&r.getNextStep()){S=[r.getNextStep()];}for(j=0;j<S.length;j++){i=c(S[j],i,r);}}return s;};
return W;},true);
sap.ui.predefine('sap/m/WizardStep',["./library","sap/ui/core/Control","sap/ui/core/InvisibleText","./WizardStepRenderer","./Button","./TitlePropagationSupport","sap/base/Log"],function(l,C,I,W,B,T,L){"use strict";
var a=C.extend("sap.m.WizardStep",{metadata:{properties:{title:{type:"string",group:"appearance",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},validated:{type:"boolean",group:"Behavior",defaultValue:true},optional:{type:"boolean",group:"Appearance",defaultValue:false}},events:{complete:{parameters:{}},activate:{parameters:{}}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{subsequentSteps:{type:"sap.m.WizardStep",multiple:true,singularName:"subsequentStep"},nextStep:{type:"sap.m.WizardStep",multiple:false}}}});
var b=l.ButtonType;T.call(a.prototype,"content",function(){return this.getId()+"-title";});
a.prototype.init=function(){this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oNumberInvisibleText=new I({id:this.getId()+"-NumberedTitle"}).toStatic();this._createNextButton();this._initTitlePropagationSupport();};
a.prototype._createNextButton=function(){this._oNextButton=new B(this.getId()+"-nextButton",{text:this._oResourceBundle.getText("WIZARD_STEP")+2,type:b.Emphasized,press:this._complete.bind(this)}).addStyleClass("sapMWizardNextButtonVisible");this.setAggregation("_nextButton",this._oNextButton);};
a.prototype.setWizardContext=function(s){["bLast","bReviewStep","sButtonText","bParentAllowsButtonShow"].forEach(function(p){if(typeof s[p]!=="undefined"){this[p]=s[p];}}.bind(this));this._oNextButton.setText(this.sButtonText);this.setLast(this.bLast);this.setButtonVisibility();};
a.prototype._getNumberInvisibleText=function(){return this._oNumberInvisibleText;};
a.prototype._setNumberInvisibleText=function(n){return this._oNumberInvisibleText.setText(this._oResourceBundle.getText("WIZARD_STEP")+n+" "+this.getTitle());};
a.prototype.setValidated=function(v){this.setProperty("validated",v,true);this.setButtonVisibility();return this;};
a.prototype.setNextStep=function(v){this.setAssociation("nextStep",v,true);var p=this._getWizardParent();if(p!==null){p._checkCircularReference(this._getNextStepReference());p._updateProgressNavigator();}return this;};
a.prototype.setVisible=function(v){this.setProperty("visible",v,true);L.warning("Don't use the set visible method for wizard steps. If you need to show/hide steps based on some condition - use the branching property of the Wizard instead.");return this;};
a.prototype._isLeaf=function(){if(this.getNextStep()===null&&this.getSubsequentSteps().length===0){return true;}return false;};
a.prototype._isBranched=function(){return this.getSubsequentSteps().length>1;};
a.prototype._getNextStepReference=function(){if(this.getNextStep()!==null){return sap.ui.getCore().byId(this.getNextStep());}if(this.getSubsequentSteps().length===1){return sap.ui.getCore().byId(this.getSubsequentSteps()[0]);}return null;};
a.prototype._containsSubsequentStep=function(s){return this.getSubsequentSteps().some(function(S){return S===s;});};
a.prototype._getWizardParent=function(){var p=this.getParent();while(!(p instanceof sap.m.Wizard)){if(p===null){return null;}p=p.getParent();}return p;};
a.prototype.setLast=function(c){this.bLast=c;this.toggleStyleClass("sapMWizardLastActivatedStep",c);this.setButtonVisibility();};
a.prototype.setButtonVisibility=function(){var s=this.getValidated()&&this.bParentAllowsButtonShow&&this.bLast;if(typeof s==='undefined'){return;}this.displayButton(s);};
a.prototype.displayButton=function(s){this._oNextButton.toggleStyleClass("sapMWizardNextButtonHidden",!s);this._oNextButton.toggleStyleClass("sapMWizardNextButtonVisible",s);this._oNextButton.setVisible(s);};
a.prototype._activate=function(){this.setLast(true);this.addStyleClass("sapMWizardStepActivated");this.fireActivate();};
a.prototype._deactivate=function(){this.removeStyleClass("sapMWizardStepActivated");};
a.prototype._complete=function(){this.setLast(this.bReviewStep||false);this.fireComplete();};
a.prototype.exit=function(){this._oNumberInvisibleText.destroy();this._oNumberInvisibleText=null;};
return a;});
sap.ui.predefine('sap/m/WizardStepRenderer',function(){"use strict";var W={};
W.render=function(r,s){this.startWizardStep(r,s);this.renderWizardStepTitle(r,s);this.renderContent(r,s);this.endWizardStep(r);};
W.startWizardStep=function(r,s){r.write("<div");r.writeAccessibilityState(s,{"labelledby":s._getNumberInvisibleText().getId(),"role":"region"});r.writeControlData(s);r.addClass("sapMWizardStep");r.writeClasses();r.write(">");};
W.renderWizardStepTitle=function(r,s){r.write("<h3 class='sapMWizardStepTitle' id='"+this.getTitleId(s)+"'>");r.writeEscaped(s.getTitle());r.write("</h3>");};
W.getTitleId=function(s){return s.getId()+"-Title";};
W.renderContent=function(r,s){s.getContent().forEach(r.renderControl,r);r.renderControl(s.getAggregation("_nextButton"));};
W.endWizardStep=function(r){r.write("</div>");};
return W;},true);
sap.ui.predefine('sap/m/changeHandler/AddTableColumn',["sap/ui/fl/changeHandler/ChangeHandlerMediator","sap/base/Log"],function(C,L){"use strict";var A={};var a="columns";var b="cells";var I="items";
A.applyChange=function(c,t,p){var m=p.modifier;var v=p.view;var o=p.appComponent;var d=c.getDefinition();var e=c.getContent();var g=function(h){return h&&h.content&&h.content.createFunction;};var f=function(e,h){return e.newFieldSelector&&(e.newFieldIndex!==undefined)&&e.bindingPath&&e.oDataServiceVersion&&!!g(h);};return C.getChangeHandlerSettings({"scenario":"addODataField","oDataServiceVersion":e.oDataServiceVersion}).then(function(h){if(e&&f(e,h)){var T=m.getBindingTemplate(t,I,v);var i=m.createControl('sap.m.Text',o,v,e.newFieldSelector.id+'--column',{text:"{/#"+e.entityType+"/"+e.bindingPath+"/@sap:label}"});if(T){var j={"appComponent":p.appComponent,"view":p.view,"fieldSelector":e.newFieldSelector.id+'--field',"bindingPath":e.bindingPath};var k=g(h);var s=k(m,j);m.insertAggregation(T,b,s,e.newFieldIndex,v);m.updateAggregation(t,I);c.setRevertData(e.newFieldSelector.id+'--field');}var l=m.createControl('sap.m.Column',o,v,e.newFieldSelector);m.insertAggregation(l,'header',i,0,v);m.insertAggregation(t,a,l,e.newFieldIndex,v);return true;}else{L.error("Change does not contain sufficient information to be applied or ChangeHandlerMediator could not be retrieved: ["+d.layer+"]"+d.namespace+"/"+d.fileName+"."+d.fileType);}});};
A.revertChange=function(c,t,p){var m=p.modifier;var v=p.view;var o=p.appComponent;var d=c.getContent();var T=m.getBindingTemplate(t,I);if(T){m.removeAggregation(T,b,m.bySelector(c.getRevertData(),o,v));m.updateAggregation(t,I);}m.removeAggregation(t,a,m.bySelector(d.newFieldSelector,o,v));c.resetRevertData();return true;};
A.completeChangeContent=function(c,s,p){var o=p.appComponent;var d=c.getDefinition();if(!d.content){d.content={};}if(s.parentId){c.addDependentControl(s.parentId,"targetTable",p);}else{throw new Error("oSpecificChangeInfo.parentId attribute required");}if(s.bindingPath){d.content.bindingPath=s.bindingPath;}else{throw new Error("oSpecificChangeInfo.bindingPath attribute required");}if(s.oDataInformation.entityType){d.content.entityType=s.oDataInformation.entityType;}else{throw new Error("oSpecificChangeInfo.entityType attribute required");}if(s.newControlId){d.content.newFieldSelector=p.modifier.getSelector(s.newControlId,o);}else{throw new Error("oSpecificChangeInfo.newControlId attribute required");}if(s.index===undefined){throw new Error("oSpecificChangeInfo.targetIndex attribute required");}else{d.content.newFieldIndex=s.index;}if(s.oDataServiceVersion===undefined){throw new Error("oSpecificChangeInfo.oDataServiceVersion attribute required");}else{d.content.oDataServiceVersion=s.oDataServiceVersion;}};
return A;},true);
sap.ui.predefine('sap/m/changeHandler/ChangeLinkTarget',function(){"use strict";var C={};
C.applyChange=function(c,o,p){var m=p.modifier,a=c.getDefinition(),t=a.content,r={target:m.getProperty(o,"target")};m.setProperty(o,"target",t);c.setRevertData(r);return true;};
C.revertChange=function(c,o,p){var m=p.modifier,r=c.getRevertData(),t=r.target;m.setProperty(o,"target",t);return true;};
C.completeChangeContent=function(c,s,p){return true;};
return C;});
sap.ui.predefine('sap/m/changeHandler/CombineButtons',["sap/base/util/uid","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(u,J,C){"use strict";var a={};
a.applyChange=function(c,o,p){if(p.modifier.targets!=="jsControlTree"){throw new Error("Combine buttons change can't be applied on XML tree");}var b=c.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var s=m.bySelector(b.content.combineButtonSelectors[0],A,v);var P=m.getParent(s);var i;var d;var B;var I=sap.ui.getCore().getConfiguration().getRTL();var M;var e;var f=[];var g="";var h="";var O="";var r={parentAggregation:"",insertIndexes:[]};var j=[];B=b.content.combineButtonSelectors.map(function(k){return m.bySelector(k,A,v);});d=m.getParentAggregationName(B[0],P);r.parentAggregation=d;i=m.findIndexInParentAggregation(s);M=m.createControl("sap.m.Menu",A,v,b.content.menuIdSelector);B.forEach(function(k,l){var n;var q;var S=b.content.buttonsIdForSave[l];var t=m.getProperty(k,"text");q=m.createControl("sap.m.MenuItem",A,v,S);r.insertIndexes[l]=m.findIndexInParentAggregation(k);m.attachEvent(q,"press","sap.m.changeHandler.CombineButtons.pressHandler",{selector:m.getSelector(k,A),appComponentId:A.getId()});var w="$sap.m.flexibility.CombineButtonsModel";var x=m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModel'}),{object:k,name:w});m.insertAggregation(q,"dependents",x,0,v);m.bindProperty(q,"text",w+">/text");m.bindProperty(q,"icon",w+">/icon");m.bindProperty(q,"enabled",w+">/enabled");m.bindProperty(q,"visible",w+">/visible");m.bindAggregation(q,"customData",{path:w+">/customData",template:m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},S,{id:S.id+'-customData'}),{key:"{ path: '"+w+">key' }",value:"{ path: '"+w+">value' }"}),templateShareable:false},v);if(t){I?f.unshift(t):f.push(t);}S.id=S.id+"-originalButtonId";n=m.createControl("sap.ui.core.CustomData",A,v,S);m.setProperty(n,"key","originalButtonId");m.setProperty(n,"value",m.getId(k));m.removeAggregation(P,d,k);m.insertAggregation(P,"dependents",k,0,v);m.insertAggregation(k,"customData",n,0,v);m.insertAggregation(M,"items",q,l,v);var w="$sap.m.flexibility.MenuButtonModel"+l;j[l]=m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModelMenuItem'}),{object:q,name:w});g=g+O+"${"+w+">/enabled}";h=h+O+"${"+w+">/visible}";O=" || ";});e=m.createControl("sap.m.MenuButton",A,v,b.content.menuButtonIdSelector,{visible:"{= "+h+"}",enabled:"{= "+g+"}"});j.forEach(function(k){m.insertAggregation(e,"dependents",k,0,v);});m.setProperty(e,"text",f.join("/"));m.insertAggregation(e,"menu",M,0,v);m.insertAggregation(P,d,e,i,v);c.setRevertData(r);return true;};
a.revertChange=function(c,o,p){var m=p.modifier;var v=p.view;var r=c.getRevertData();var b=c.getDefinition();var P=r.parentAggregation;var M=m.bySelector(b.content.menuButtonIdSelector,p.appComponent,v);var d=m.getParent(M);var B=b.content.combineButtonSelectors.slice().reverse();var e;m.removeAggregation(d,P,M);m.destroy(M);for(var i=0,l=B.length;i<l;i++){e=m.bySelector(B[i],p.appComponent,v);m.getAggregation(e,"customData").some(function(f){if(m.getProperty(f,"key")==="originalButtonId"){m.destroy(f);return true;}});m.insertAggregation(d,P,e,r.insertIndexes[l-i-1],v);}c.resetRevertData();return true;};
a.completeChangeContent=function(c,s,p){var m=p.modifier;var A=p.appComponent;var o=c.getDefinition();var b=s.combineElementIds;if(b&&b.length>1){c.addDependentControl(b,"combinedButtons",p);o.content.combineButtonSelectors=b.map(function(d){return m.getSelector(d,A);});o.content.menuButtonIdSelector=m.getSelector(A.createId(u()),A);o.content.menuIdSelector=m.getSelector(A.createId(u()),A);o.content.buttonsIdForSave=b.map(function(){return m.getSelector(A.createId(u()),A);});}else{throw new Error("Combine buttons action cannot be completed: oSpecificChangeInfo.combineElementIds attribute required");}};
a.pressHandler=function(e,p){var b=J.bySelector(p.selector,C.get(p.appComponentId));b.firePress();};
return a;},true);
sap.ui.predefine('sap/m/changeHandler/MoveTableColumns',["sap/base/Log","sap/ui/thirdparty/jquery"],function(L,q){"use strict";var M={};var S="source";var T="target";var a="movedElements";var C="columns";var b="cells";var I="items";
function _(c,r,p,i){var m=p.modifier,v=p.view,A=p.appComponent,o=c.getContent(),t=c.getDependentControl(S,p),d=c.getDependentControl(T,p),e=m.getAggregation(d,C),s=function(R,g,h){var j=m.getAggregation(R,b);if(!j){L.warning("Aggregation cells to move not found");return;}if(g<0||g>=j.length){L.warning("Move cells in table item called with invalid index: "+g);return;}var k=j[g];m.removeAggregation(R,b,k);m.insertAggregation(R,b,k,h,v);},f=function(g,h){m.getAggregation(d,I).forEach(function(j){if(m.getControlType(j)==="sap.m.GroupHeaderListItem"){return;}s(j,g,h);});};if(t!==d){L.warning("Moving columns between different tables is not yet supported.");return false;}o.movedElements.forEach(function(g){var h=m.bySelector(g.selector,A,v),j,k,l,n,u;if(!h){u=g.selector&&g.selector.id;L.warning("The table column with id: '"+u+"' stored in the change is not found and the move operation cannot be applied");return;}l=e.indexOf(h);n=g.sourceIndex;k=q.isFunction(i)&&i(l);k=q.isNumeric(k)?k:g.targetIndex;if(l!==k){j=l;}else{j=n;}m.removeAggregation(d,C,h);m.insertAggregation(d,C,h,k,v);var w=m.getBindingTemplate(d,I);if(w){s(w,j,k);m.updateAggregation(d,I);}else{f(j,k);}},this);return true;}
M.applyChange=function(c,r,p){var R=[];_(c,r,p,function(i){R.unshift({index:i});});c.setRevertData(R);};
M.revertChange=function(c,r,p){var R=c.getRevertData();_(c,r,p,function(){var i=R.shift();return i&&i.index;});c.resetRevertData();};
M.completeChangeContent=function(c,s,p){var m=p.modifier,A=p.appComponent,d=c.getDefinition(),o=m.bySelector(s.source.id,A),t=m.bySelector(s.target.id,A),e={aggregation:s.source.aggregation,type:m.getControlType(o)},f={aggregation:s.target.aggregation,type:m.getControlType(t)};d.content={movedElements:[]};s.movedElements.forEach(function(E){var g=E.element||m.bySelector(E.id,A);d.content.movedElements.push({selector:m.getSelector(g,A),sourceIndex:E.sourceIndex,targetIndex:E.targetIndex});});c.addDependentControl(s.source.id,S,p,e);c.addDependentControl(s.target.id,T,p,f);c.addDependentControl(s.movedElements.map(function(g){return g.id;}),a,p);};
return M;},true);
sap.ui.predefine('sap/m/changeHandler/SplitMenuButton',["sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(J,C){"use strict";var S={};var a="sourceControl";
S.applyChange=function(c,o,p){if(p.modifier.targets!=="jsControlTree"){throw new Error("Split change can't be applied on XML tree");}var b=c.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var s=c.getDependentControl(a,p);var M=m.getAggregation(s,"menu");var d=m.getAggregation(M,"items");var P=m.getParent(s);var e=m.getParentAggregationName(s,P);var i=m.findIndexInParentAggregation(s);var n=b.content.newElementIds;var r={parentAggregation:e,insertIndex:i,insertedButtons:[]};d.forEach(function(f,g){var h=n[g];var B=m.createControl("sap.m.Button",A,v,h);r.insertedButtons.push(h);var j="$sap.m.flexibility.SplitButtonsModel";var k=m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},h,{id:h.id+'-managedObjectModel'}),{object:f,name:j});m.insertAggregation(B,"dependents",k,0,v);m.bindProperty(B,"text",j+">/text");m.bindProperty(B,"icon",j+">/icon");m.bindProperty(B,"enabled",j+">/enabled");m.bindProperty(B,"visible",j+">/visible");m.bindAggregation(B,"customData",{path:j+">/customData",template:m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},h,{id:h.id+'-customData'}),{key:{path:j+">key"},value:{path:j+">value"}}),templateShareable:false});m.attachEvent(B,"press","sap.m.changeHandler.SplitMenuButton.pressHandler",{selector:m.getSelector(f,A),appComponentId:A.getId()});m.insertAggregation(P,e,B,i+g,v);});m.removeAggregation(P,e,s);m.insertAggregation(P,"dependents",s,0,v);c.setRevertData(r);return true;};
S.revertChange=function(c,o,p){var m=p.modifier;var r=c.getRevertData();var s=c.getDependentControl(a,p);var A=p.appComponent;var v=p.view;var P=m.getParent(s);var b=r.parentAggregation;var i=r.insertIndex;var I=r.insertedButtons.map(function(d){return m.bySelector(d,A,v);});I.forEach(function(B){m.removeAggregation(P,b,B);m.destroy(B);});m.insertAggregation(P,b,s,i,v);c.resetRevertData();return true;};
S.completeChangeContent=function(c,s,p){var m=p.modifier;var A=p.appComponent;var o=c.getDefinition();if(!s.newElementIds){throw new Error("Split of MenuButton cannot be applied : oSpecificChangeInfo.newElementIds attribute required");}if(!s.sourceControlId){throw new Error("Split of MenuButton cannot be applied : oSpecificChangeInfo.sourceControlId attribute required");}c.addDependentControl(s.sourceControlId,a,p);o.content.sourceSelector=m.getSelector(s.sourceControlId,A);o.content.newElementIds=s.newElementIds.map(function(e){return m.getSelector(e,A);});};
S.pressHandler=function(e,p){var m=J.bySelector(p.selector,C.get(p.appComponentId));m.firePress();};
return S;},true);
sap.ui.predefine('sap/m/delegate/DateNavigation',['sap/ui/base/EventProvider','sap/ui/core/date/UniversalDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/library'],function(E,U,C,a,u){"use strict";var P=u.CalendarIntervalType;
var D=E.extend("sap.m.delegate.DateNavigation",{constructor:function(){E.apply(this,arguments);this._unit=P.Day;this._start=new Date();this._step=1;}});
D.HOURS24=1000*3600*24;
D.prototype.setUnit=function(p){this._unit=p;};
D.prototype.setStart=function(d){this._start=d;};
D.prototype.setStep=function(s){this._step=s;};
D.prototype.setCurrent=function(d){this._current=d;};
D.prototype.getUnit=function(){return this._unit;};
D.prototype.getStart=function(){return this._start;};
D.prototype.getStep=function(){return this._step;};
D.prototype.getCurrent=function(){return this._current;};
D.prototype.getEnd=function(){var c=C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Day:case P.Week:case P.OneMonth:c.setUTCDate(c.getUTCDate()+this.getStep()-1);break;case P.Hour:c.setUTCHours(c.getUTCHours()+this.getStep()-1);break;case P.Month:c.setUTCMonth(c.getUTCMonth()+this.getStep()-1);break;default:break;}return C._createLocalDate(c,true);};
D.prototype.next=function(){var n=C._createUniversalUTCDate(this.getStart(),undefined,true);var N=this.getCurrent()?C._createUniversalUTCDate(this.getCurrent(),undefined,true):C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Hour:N.setUTCHours(N.getUTCHours()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCHours(n.getUTCHours()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Week:case P.Day:N.setUTCDate(N.getUTCDate()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCDate(n.getUTCDate()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Month:N.setUTCMonth(N.getUTCMonth()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.OneMonth:N.setUTCMonth(N.getUTCMonth()+1,1);this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()+1,1);this.setStart(C._createLocalDate(n,true));break;default:break;}};
D.prototype.previous=function(){var n=C._createUniversalUTCDate(this.getStart(),undefined,true);var N=this.getCurrent()?C._createUniversalUTCDate(this.getCurrent(),undefined,true):C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Hour:N.setUTCHours(N.getUTCHours()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCHours(n.getUTCHours()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Week:case P.Day:N.setUTCDate(N.getUTCDate()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCDate(n.getUTCDate()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Month:N.setUTCMonth(N.getUTCMonth()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.OneMonth:N.setUTCMonth(N.getUTCMonth()-1,1);this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()-1,1);this.setStart(C._createLocalDate(n,true));break;default:break;}};
D.prototype.toDate=function(t){var n,c,h,N=C._createUniversalUTCDate(t,undefined,true),o=C._createUTCDate(t,true);this.setCurrent(t);switch(this.getUnit()){case P.OneMonth:if(C.monthsDiffer(this.getStart(),t)){var f=C.getFirstDateOfMonth(o);this.setStart(C._createLocalDate(f,true));}break;case P.Day:c=C._createUniversalUTCDate(this.getStart(),undefined,true);c.setUTCDate(c.getUTCDate()+this.getStep());if(t.valueOf()>=c.valueOf()){h=1+Math.ceil((t.valueOf()-c.valueOf())/(D.HOURS24));n=C._createUniversalUTCDate(this.getStart(),undefined,true);n.setUTCDate(n.getUTCDate()+h);this.setStart(C._createLocalDate(n,true));}else if(t.valueOf()<this.getStart().valueOf()){n=C._createUniversalUTCDate(t,undefined,true);this.setStart(C._createLocalDate(n,true));}break;case P.Month:c=C._createUniversalUTCDate(this.getStart());c.setUTCMonth(c.getUTCMonth()+this.getStep());if(N.getTime()>=c.valueOf()){h=1+C._monthsBetween(t,C._createLocalDate(c,true));n=C._createUniversalUTCDate(this.getStart(),undefined,true);n.setUTCMonth(n.getUTCMonth()+h);this.setStart(C._createLocalDate(n,true));}else if(t.valueOf()<this.getStart().valueOf()){n=C._createUniversalUTCDate(t,undefined,true);this.setStart(C._createLocalDate(n,true));}break;case P.Week:var T=C.getFirstDateOfWeek(o);if(this.getStart().valueOf()!==T.valueOf()){this.setStart(C._createLocalDate(T,true));}break;case P.Hour:c=this.getEnd(this.getStart());var b=C._createUniversalUTCDate(c,undefined,true);if(N.getTime()<C._createUniversalUTCDate(this.getStart(),undefined,true).getTime()||N.getTime()>b.getTime()){this.setStart(t);}break;default:break;}};
return D;});
sap.ui.predefine('sap/m/delegate/ValueStateMessage',['sap/ui/Device','sap/ui/base/Object','sap/ui/core/ValueStateSupport','sap/ui/core/Popup','sap/ui/core/library',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Aria"],function(D,B,V,P,c,q){"use strict";var a=c.ValueState;
var b=B.extend("sap.m.delegate.ValueState",{constructor:function(C){B.apply(this,arguments);this._oControl=C;this._oPopup=null;}});
b.prototype.open=function(){var C=this._oControl,p=this.getPopup(),m=this.createDom(),d=P.Dock,$=q(C.getDomRefForValueStateMessage());if(!C||!p||!m){return;}p.setContent(m);p.close(0);if(p.getContent()){p.getContent().style.maxWidth=C.getDomRef().offsetWidth+"px";}else{p.getContent().style.maxWidth="";}p.open(this.getOpenDuration(),d.BeginTop,d.BeginBottom,C.getDomRefForValueStateMessage(),null,null,D.system.phone?true:P.CLOSE_ON_SCROLL);var e=q(m);if($.offset().top<e.offset().top){e.addClass("sapMValueStateMessageBottom");}else{e.addClass("sapMValueStateMessageTop");}q(C.getFocusDomRef()).addAriaDescribedBy(this.getId());};
b.prototype.close=function(){var C=this._oControl,p=this._oPopup;if(p){p.close(0);}if(C){q(C.getFocusDomRef()).removeAriaDescribedBy(this.getId());}};
b.prototype.getId=function(){var C=this._oControl;if(!C){return"";}return(typeof C.getValueStateMessageId==="function")?C.getValueStateMessageId():C.getId()+"-message";};
b.prototype.getOpenDuration=function(){var C=this._oControl;if(!C){return 0;}return(C.iOpenMessagePopupDuration===undefined)?0:C.iOpenMessagePopupDuration;};
b.prototype.createPopup=function(i){i=i||this.getId();if(this._oPopup){return this._oPopup;}this._oPopup=new P(document.createElement("span"),false,false,false);this._oPopup.attachClosed(function(){q(document.getElementById(i)).remove();});this._oPopup.attachOpened(function(){var d=this._oPopup.getContent();if(d&&this._oControl){d.style.zIndex=this._getCorrectZIndex();}}.bind(this));return this._oPopup;};
b.prototype.getPopup=function(){if(!this._oControl){return null;}return this.createPopup();};
b.prototype.createDom=function(){var C=this._oControl;if(!C){return null;}var s=C.getValueState(),t=C.getValueStateText()||V.getAdditionalText(C),d="sapMValueStateMessage sapMValueStateMessage"+s,r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(s===a.Success||s===a.None){d="sapUiInvisibleText";t="";}var i=this.getId();var m=document.createElement("div");m.id=i;m.className=d;m.setAttribute("role","tooltip");m.setAttribute("aria-live","assertive");var A=document.createElement("span");A.id=i+"hidden";var I=D.browser.msie;if(I){A.className="sapUiHidden";A.setAttribute("aria-hidden","true");}else{A.className="sapUiPseudoInvisibleText";}if(s!==a.None){A.appendChild(document.createTextNode(r.getText("INPUTBASE_VALUE_STATE_"+s.toUpperCase())));}var T=document.createElement("span");T.id=i+"-text";if(!C.isA('sap.m.Select')&&I){T.setAttribute("aria-hidden","true");}T.appendChild(document.createTextNode(t));m.appendChild(A);m.appendChild(T);return m;};
b.prototype.destroy=function(){if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}this._oControl=null;};
b.prototype._getCorrectZIndex=function(){var p=this._oControl.$().parents().filter(function(){var z=q(this).css('z-index');return z&&z!=='auto'&&z!=='0';});if(!p.length){return 1;}var h=0;p.each(function(){var z=parseInt(q(this).css('z-index'));if(z>h){h=z;}});return h+1;};
return b;});
sap.ui.predefine('sap/m/flexibility/Bar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/flexibility/Button.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"unhideControl":"default"};},false);
sap.ui.predefine('sap/m/flexibility/CheckBox.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XCKL"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/Dialog.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"})};});
sap.ui.predefine('sap/m/flexibility/IconTabFilter.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTBS"})};});
sap.ui.predefine('sap/m/flexibility/InputListItem.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"label",translationTextType:"XBLI"}),"unhideControl":"default","moveControls":"default"};},false);
sap.ui.predefine('sap/m/flexibility/Label.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XFLD"}),"unhideControl":"default"};},false);
sap.ui.predefine('sap/m/flexibility/Link.flexibility',["sap/m/changeHandler/ChangeLinkTarget"],function(C){"use strict";return{"hideControl":"default","unhideControl":"default","changeLinkTarget":{"changeHandler":C,"layers":{"CUSTOMER":false}}};});
sap.ui.predefine('sap/m/flexibility/MenuButton.flexibility',["sap/m/changeHandler/SplitMenuButton","sap/ui/fl/changeHandler/BaseRename"],function(S,B){"use strict";return{"splitMenuButton":S,"rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XFLD"})};},true);
sap.ui.predefine('sap/m/flexibility/OverflowToolbar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/flexibility/Page.flexibility',["sap/ui/fl/changeHandler/BaseRename","sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(B,C,S){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};});
sap.ui.predefine('sap/m/flexibility/Panel.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"headerText",translationTextType:"XGRP"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Popover.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"})};});
sap.ui.predefine('sap/m/flexibility/RadioButton.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/StandardListItem.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"unhideControl":"default","moveControls":"default"};},false);
sap.ui.predefine('sap/m/flexibility/Table.flexibility',["sap/m/changeHandler/MoveTableColumns","sap/m/changeHandler/AddTableColumn"],function(M,A){"use strict";return{"hideControl":"default","unhideControl":"default","moveTableColumns":M,"addTableColumn":A};},true);
sap.ui.predefine('sap/m/flexibility/Text.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTXT"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Title.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTIT"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Toolbar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/ios7',["sap/ui/core/IntervalTrigger","sap/ui/thirdparty/jquery","sap/ui/base/EventProvider","sap/ui/Device"],function(I,q,E,D){"use strict";
var _=E.extend("sap.m._Ios7",{constructor:function(){var b=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";E.apply(this);if(!b){return;}this._bIntervallAttached=false;this._bInputIsOpen=false;this._bNavigationBarEventFired=false;var a=window.orientation===90||window.orientation===-90;if(a){this._attachNavigationBarPolling();}D.orientation.attachHandler(this._onOrientationChange,this);this._onFocusin=q.proxy(this._onFocusin,this);document.addEventListener("focusin",this._onFocusin,true);this._onFocusout=q.proxy(this._onFocusout,this);document.addEventListener("focusout",this._onFocusout,true);}});
_.prototype.getNavigationBarHeight=function(){if(!this._bNavigationBarEventFired){return 0;}return this._iNavigationBarHeight;};
_.prototype._attachNavigationBarPolling=function(){if(!D.system.phone||this._bIntervallAttached){return;}I.addListener(this._detectNavigationBar,this);this._bIntervallAttached=true;};
_.prototype._detachNavigationBarPolling=function(){if(!D.system.phone||!this._bIntervallAttached){return;}I.removeListener(this._detectNavigationBar,this);this._bIntervallAttached=false;};
_.prototype._detectNavigationBar=function(){var h=window.outerHeight-window.innerHeight;if(h===0||this._bInputIsOpen||this._bNavigationBarEventFired){this._iPreviousHeight=null;return;}if(this._iPreviousHeight===window.innerHeight){window.scrollTo(0,0);var n=window.outerHeight-window.innerHeight;if(h!==n){return;}this._iNavigationBarHeight=h;this._bNavigationBarEventFired=true;this.fireEvent("navigationBarShownInLandscape",{barHeight:h});this._detachNavigationBarPolling();this._iPreviousHeight=null;}else{this._iPreviousHeight=window.innerHeight;}};
_.prototype.destroy=function(){E.prototype.destroy.apply(this,arguments);document.removeEventListener("focusin",this._onFocusin,true);document.removeEventListener("focusout",this._onFocusout,true);};
_.prototype._onFocusin=function(e){var t=e.target.tagName;if(!_._rTagRegex.test(t)){return;}this._inputTarget=e.target;this._detachNavigationBarPolling();this._bInputIsOpen=true;this.fireEvent("inputOpened");};
_._rTagRegex=/INPUT|TEXTAREA|SELECT/;
_.prototype._onFocusout=function(e){var t=e.srcElement.tagName,r=e.relatedTarget,R=(r&&(r.getAttribute("readonly")===null)&&(r.getAttribute("disabled")===null))?r.tagName:"";if(_._rTagRegex.test(t)&&!_._rTagRegex.test(R)){window.scrollTo(0,0);if(window.orientation===90||window.orientation===-90){this._attachNavigationBarPolling();}this._bInputIsOpen=false;this.fireEvent("inputClosed");}};
_.prototype._onOrientationChange=function(e){var b=e.landscape;window.scrollTo(0,0);this._bNavigationBarEventFired=false;if(this._bInputIsOpen&&this._inputTarget&&this._inputTarget.blur){this._inputTarget.blur();}else if(b){this._attachNavigationBarPolling();}else if(!b){this._detachNavigationBarPolling();}};
var i=new _();return i;},true);
sap.ui.predefine('sap/m/library',['sap/ui/Device','sap/ui/base/DataType','sap/ui/base/EventProvider','sap/ui/core/Control','sap/base/util/ObjectPath','sap/ui/core/library',"sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/base/assert","sap/base/Log","sap/base/util/defineLazyProperty","sap/base/security/encodeCSS",'./Support'],function(D,a,E,C,O,b,d,q,e,L,f,g){"use strict";sap.ui.getCore().initLibrary({name:"sap.m",version:"1.72.0",dependencies:["sap.ui.core"],designtime:"sap/m/designtime/library.designtime",types:["sap.m.BackgroundDesign","sap.m.BarDesign","sap.m.BreadcrumbsSeparatorStyle","sap.m.ButtonType","sap.m.CarouselArrowsPlacement","sap.m.DateTimeInputType","sap.m.DeviationIndicator","sap.m.DialogRoleType","sap.m.DialogType","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignContent","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FlexWrap","sap.m.FrameType","sap.m.GenericTagDesign","sap.m.GenericTagValueState","sap.m.GenericTileMode","sap.m.GenericTileScope","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabDensityMode","sap.m.IconTabFilterDesign","sap.m.IconTabHeaderMode","sap.m.ImageMode","sap.m.InputTextFormatMode","sap.m.InputType","sap.m.LabelDesign","sap.m.LightBoxLoadingStates","sap.m.LinkConversion","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.ObjectHeaderPictureShape","sap.m.ObjectMarkerType","sap.m.ObjectMarkerVisibility","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.PageBackgroundDesign","sap.m.PanelAccessibleRole","sap.m.PDFViewerDisplayType","sap.m.PlacementType","sap.m.PlanningCalendarBuiltInView","sap.m.PlanningCalendarStickyMode","sap.m.PopinDisplay","sap.m.PopinLayout","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectionDetailsActionLevel","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.Size","sap.m.SplitAppMode","sap.m.StandardTileType","sap.m.StepInputStepModeType","sap.m.StepInputValidationMode","sap.m.Sticky","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.TileSizeBehavior","sap.m.TimePickerMaskMode","sap.m.TitleAlignment","sap.m.ToolbarDesign","sap.m.ToolbarStyle","sap.m.UploadState","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.VerticalPlacementType","sap.m.WrappingType","sap.m.semantic.SemanticRuleSetType"],interfaces:["sap.m.IBar","sap.m.IBreadcrumbs","sap.m.IconTab","sap.m.IScale","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer","sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent","sap.m.IHyphenation"],controls:["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnHeaderPopover","sap.m.ColumnListItem","sap.m.ColorPalette","sap.m.ColorPalettePopover","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.CustomTreeItem","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeField","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTag","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.HeaderContainer","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabHeader","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageView","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiEditField","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.PlanningCalendarLegend","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.OverflowToolbarToggleButton","sap.m.P13nColumnsPanel","sap.m.P13nGroupPanel","sap.m.P13nSelectionPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PDFViewer","sap.m.PlanningCalendar","sap.m.PlanningCalendarHeader","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewBase","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectList","sap.m.SelectionDetails","sap.m.Shell","sap.m.SimpleFixFlex","sap.m.SinglePlanningCalendar","sap.m.SinglePlanningCalendarGrid","sap.m.SinglePlanningCalendarMonthGrid","sap.m.Slider","sap.m.SliderTooltip","sap.m.SliderTooltipBase","sap.m.SliderTooltipContainer","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.TimePickerSliders","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.upload.UploadSet","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.Wizard","sap.m.WizardStep","sap.m.semantic.DetailPage","sap.m.semantic.SemanticPage","sap.m.semantic.ShareMenuPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage"],elements:["sap.m.Column","sap.m.ColumnPopoverActionItem","sap.m.ColumnPopoverCustomItem","sap.m.ColumnPopoverItem","sap.m.ColumnPopoverSortItem","sap.m.FlexItemData","sap.m.FeedListItemAction","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessageItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nGroupItem","sap.m.P13nSortItem","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.ResponsiveScale","sap.m.SegmentedButtonItem","sap.m.SelectionDetailsItem","sap.m.SelectionDetailsItemLine","sap.m.SinglePlanningCalendarDayView","sap.m.SinglePlanningCalendarWeekView","sap.m.SinglePlanningCalendarWorkWeekView","sap.m.SinglePlanningCalendarView","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.TabStripItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.upload.Uploader","sap.m.upload.UploadSetItem","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.semantic.AddAction","sap.m.semantic.CancelAction","sap.m.semantic.DeleteAction","sap.m.semantic.DiscussInJamAction","sap.m.semantic.EditAction","sap.m.semantic.FavoriteAction","sap.m.semantic.FilterAction","sap.m.semantic.FilterSelect","sap.m.semantic.FlagAction","sap.m.semantic.ForwardAction","sap.m.semantic.GroupAction","sap.m.semantic.GroupSelect","sap.m.semantic.MainAction","sap.m.semantic.MessagesIndicator","sap.m.semantic.MultiSelectAction","sap.m.semantic.NegativeAction","sap.m.semantic.OpenInAction","sap.m.semantic.PositiveAction","sap.m.semantic.PrintAction","sap.m.semantic.SaveAction","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticControl","sap.m.semantic.SemanticSelect","sap.m.semantic.SemanticToggleButton","sap.m.semantic.SendEmailAction","sap.m.semantic.SendMessageAction","sap.m.semantic.ShareInJamAction","sap.m.semantic.SortAction","sap.m.semantic.SortSelect"],extensions:{flChangeHandlers:{"sap.m.ActionSheet":{"moveControls":"default"},"sap.m.Bar":"sap/m/flexibility/Bar","sap.m.Button":"sap/m/flexibility/Button","sap.m.CheckBox":"sap/m/flexibility/CheckBox","sap.m.ColumnListItem":{"hideControl":"default","unhideControl":"default"},"sap.m.CustomListItem":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.DatePicker":{"hideControl":"default","unhideControl":"default"},"sap.m.Dialog":"sap/m/flexibility/Dialog","sap.m.FlexBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.HBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.IconTabBar":{"moveControls":"default"},"sap.m.IconTabFilter":"sap/m/flexibility/IconTabFilter","sap.m.Image":{"hideControl":"default","unhideControl":"default"},"sap.m.Input":{"hideControl":"default","unhideControl":"default"},"sap.m.InputBase":{"hideControl":"default","unhideControl":"default"},"sap.m.InputListItem":"sap/m/flexibility/InputListItem","sap.m.Label":"sap/m/flexibility/Label","sap.m.MultiInput":{"hideControl":"default","unhideControl":"default"},"sap.m.ListItemBase":{"hideControl":"default","unhideControl":"default"},"sap.m.Link":"sap/m/flexibility/Link","sap.m.List":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.ListBase":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.MaskInput":{"hideControl":"default","unhideControl":"default"},"sap.m.MenuButton":"sap/m/flexibility/MenuButton","sap.m.OverflowToolbar":"sap/m/flexibility/OverflowToolbar","sap.m.Page":"sap/m/flexibility/Page","sap.m.Panel":"sap/m/flexibility/Panel","sap.m.Popover":"sap/m/flexibility/Popover","sap.m.RadioButton":"sap/m/flexibility/RadioButton","sap.m.RatingIndicator":{"hideControl":"default","unhideControl":"default"},"sap.m.RangeSlider":{"hideControl":"default","unhideControl":"default"},"sap.m.ScrollContainer":{"hideControl":"default","moveControls":"default","unhideControl":"default"},"sap.m.Slider":{"hideControl":"default","unhideControl":"default"},"sap.m.StandardListItem":"sap/m/flexibility/StandardListItem","sap.m.Table":"sap/m/flexibility/Table","sap.m.Column":{"hideControl":"default","unhideControl":"default"},"sap.m.Text":"sap/m/flexibility/Text","sap.m.Title":"sap/m/flexibility/Title","sap.m.Toolbar":"sap/m/flexibility/Toolbar","sap.m.VBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"}},"sap.ui.support":{publicRules:true,internalRules:true}}});var t=sap.m;t.BackgroundDesign={Solid:"Solid",Transparent:"Transparent",Translucent:"Translucent"};t.BarDesign={Auto:"Auto",Header:"Header",SubHeader:"SubHeader",Footer:"Footer"};t.BreadcrumbsSeparatorStyle={Slash:"Slash",BackSlash:"BackSlash",DoubleSlash:"DoubleSlash",DoubleBackSlash:"DoubleBackSlash",GreaterThan:"GreaterThan",DoubleGreaterThan:"DoubleGreaterThan"};t.ButtonType={Default:"Default",Back:"Back",Accept:"Accept",Reject:"Reject",Transparent:"Transparent",Ghost:"Ghost",Up:"Up",Unstyled:"Unstyled",Emphasized:"Emphasized"};t.CarouselArrowsPlacement={Content:"Content",PageIndicator:"PageIndicator"};t.PlanningCalendarBuiltInView={Hour:"Hour",Day:"Day",Month:"Month",Week:"Week",OneMonth:"One Month"};t.DateTimeInputType={Date:"Date",DateTime:"DateTime",Time:"Time"};t.DialogType={Standard:"Standard",Message:"Message"};t.DialogRoleType={Dialog:"dialog",AlertDialog:"alertdialog"};t.DeviationIndicator={Up:"Up",Down:"Down",None:"None"};t.DraftIndicatorState={Clear:"Clear",Saving:"Saving",Saved:"Saved"};t.FacetFilterListDataType={Date:"Date",DateTime:"DateTime",Time:"Time",Integer:"Integer",Float:"Float",String:"String",Boolean:"Boolean"};t.FacetFilterType={Simple:"Simple",Light:"Light"};t.FlexAlignItems={Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};t.FlexAlignSelf={Auto:"Auto",Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};t.FlexDirection={Row:"Row",Column:"Column",RowReverse:"RowReverse",ColumnReverse:"ColumnReverse",Inherit:"Inherit"};t.FlexJustifyContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Inherit:"Inherit"};t.FlexWrap={NoWrap:"NoWrap",Wrap:"Wrap",WrapReverse:"WrapReverse"};t.FlexAlignContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Stretch:"Stretch",Inherit:"Inherit"};t.FlexRendertype={Div:"Div",List:"List",Bare:"Bare"};t.FrameType={OneByOne:"OneByOne",TwoByOne:"TwoByOne",TwoThirds:"TwoThirds",Auto:"Auto"};t.LinkConversion={None:"None",ProtocolOnly:"ProtocolOnly",All:"All"};t.InputTextFormatMode={Value:"Value",Key:"Key",ValueKey:"ValueKey",KeyValue:"KeyValue"};t.GenericTagDesign={Full:"Full",StatusIconHidden:"StatusIconHidden"};t.GenericTagValueState={None:"None",Error:"Error"};t.GenericTileMode={ContentMode:"ContentMode",HeaderMode:"HeaderMode",LineMode:"LineMode"};t.GenericTileScope={Display:"Display",Actions:"Actions"};t.TileSizeBehavior={Responsive:"Responsive",Small:"Small"};t.HeaderLevel={H1:"H1",H2:"H2",H3:"H3",H4:"H4",H5:"H5",H6:"H6"};t.IBarHTMLTag={Div:"Div",Header:"Header",Footer:"Footer"};t.IconTabHeaderMode={Standard:"Standard",Inline:"Inline"};t.IconTabDensityMode={Inherit:"Inherit",Compact:"Compact",Cozy:"Cozy"};t.IconTabFilterDesign={Horizontal:"Horizontal",Vertical:"Vertical"};t.ImageMode={Image:"Image",Background:"Background"};t.Size={XS:"XS",S:"S",M:"M",L:"L",Auto:"Auto",Responsive:"Responsive"};t.ValueColor={Neutral:"Neutral",Good:"Good",Critical:"Critical",Error:"Error"};t.ValueCSSColor=a.createType('sap.m.ValueCSSColor',{isValid:function(v){var r=t.ValueColor.hasOwnProperty(v);if(r){return r;}else{r=b.CSSColor.isValid(v);if(r){return r;}else{var P=sap.ui.requireSync("sap/ui/core/theming/Parameters");return b.CSSColor.isValid(P.get(v));}}}},a.getType('string'));t.InputType={Text:"Text",Date:"Date",Datetime:"Datetime",DatetimeLocale:"DatetimeLocale",Email:"Email",Month:"Month",Number:"Number",Tel:"Tel",Time:"Time",Url:"Url",Week:"Week",Password:"Password"};t.LabelDesign={Bold:"Bold",Standard:"Standard"};t.ListHeaderDesign={Standard:"Standard",Plain:"Plain"};t.ListMode={None:"None",SingleSelect:"SingleSelect",SingleSelectLeft:"SingleSelectLeft",SingleSelectMaster:"SingleSelectMaster",MultiSelect:"MultiSelect",Delete:"Delete"};t.ListKeyboardMode={Navigation:"Navigation",Edit:"Edit"};t.ListGrowingDirection={Downwards:"Downwards",Upwards:"Upwards"};t.ListSeparators={All:"All",Inner:"Inner",None:"None"};t.ListType={Inactive:"Inactive",Detail:"Detail",Navigation:"Navigation",Active:"Active",DetailAndActive:"DetailAndActive"};t.SelectListKeyboardNavigationMode={None:"None",Delimited:"Delimited"};t.LoadState={Loading:"Loading",Loaded:"Loaded",Failed:"Failed",Disabled:"Disabled"};t.MenuButtonMode={Regular:"Regular",Split:"Split"};t.OverflowToolbarPriority={NeverOverflow:"NeverOverflow",Never:"Never",High:"High",Low:"Low",Disappear:"Disappear",AlwaysOverflow:"AlwaysOverflow",Always:"Always"};t.ObjectHeaderPictureShape={Circle:"Circle",Square:"Square"};t.P13nPanelType={sort:"sort",filter:"filter",group:"group",columns:"columns",dimeasure:"dimeasure",selection:"selection"};t.PageBackgroundDesign={Standard:"Standard",List:"List",Solid:"Solid",Transparent:"Transparent"};t.PanelAccessibleRole={Complementary:"Complementary",Form:"Form",Region:"Region"};t.PDFViewerDisplayType={Auto:"Auto",Embedded:"Embedded",Link:"Link"};t.PlacementType={Left:"Left",Right:"Right",Top:"Top",Bottom:"Bottom",Vertical:"Vertical",VerticalPreferedTop:"VerticalPreferedTop",VerticalPreferredTop:"VerticalPreferredTop",VerticalPreferedBottom:"VerticalPreferedBottom",VerticalPreferredBottom:"VerticalPreferredBottom",Horizontal:"Horizontal",HorizontalPreferedRight:"HorizontalPreferedRight",HorizontalPreferredRight:"HorizontalPreferredRight",HorizontalPreferedLeft:"HorizontalPreferedLeft",HorizontalPreferredLeft:"HorizontalPreferredLeft",PreferredLeftOrFlip:"PreferredLeftOrFlip",PreferredRightOrFlip:"PreferredRightOrFlip",PreferredTopOrFlip:"PreferredTopOrFlip",PreferredBottomOrFlip:"PreferredBottomOrFlip",Auto:"Auto"};t.QuickViewGroupElementType={phone:"phone",mobile:"mobile",email:"email",link:"link",text:"text",pageLink:"pageLink"};t.VerticalPlacementType={Top:"Top",Bottom:"Bottom",Vertical:"Vertical"};t.PopinDisplay={Block:"Block",Inline:"Inline",WithoutHeader:"WithoutHeader"};t.PopinLayout={Block:"Block",GridSmall:"GridSmall",GridLarge:"GridLarge"};t.Sticky={ColumnHeaders:"ColumnHeaders",HeaderToolbar:"HeaderToolbar",InfoToolbar:"InfoToolbar"};t.RatingIndicatorVisualMode={Full:"Full",Half:"Half"};t.ScreenSize={Phone:"Phone",Tablet:"Tablet",Desktop:"Desktop",XXSmall:"XXSmall",XSmall:"XSmall",Small:"Small",Medium:"Medium",Large:"Large",XLarge:"XLarge",XXLarge:"XXLarge"};t.SelectionDetailsActionLevel={Item:"Item",List:"List",Group:"Group"};t.SelectType={Default:"Default",IconOnly:"IconOnly"};t.SplitAppMode={ShowHideMode:"ShowHideMode",StretchCompressMode:"StretchCompressMode",PopoverMode:"PopoverMode",HideMode:"HideMode"};t.StandardTileType={Create:"Create",Monitor:"Monitor",None:"None"};t.semantic=t.semantic||{};t.semantic.SemanticRuleSetType={Classic:"Classic",Optimized:"Optimized"};t.ObjectMarkerType={Flagged:"Flagged",Favorite:"Favorite",Draft:"Draft",Locked:"Locked",Unsaved:"Unsaved",LockedBy:"LockedBy",UnsavedBy:"UnsavedBy"};t.ObjectMarkerVisibility={IconOnly:"IconOnly",TextOnly:"TextOnly",IconAndText:"IconAndText"};t.SwipeDirection={LeftToRight:"LeftToRight",RightToLeft:"RightToLeft",BeginToEnd:"BeginToEnd",EndToBegin:"EndToBegin",Both:"Both"};t.SwitchType={Default:"Default",AcceptReject:"AcceptReject"};t.ToolbarDesign={Auto:"Auto",Transparent:"Transparent",Info:"Info",Solid:"Solid"};t.ToolbarStyle={Standard:"Standard",Clear:"Clear"};t.TimePickerMaskMode={On:"On",Off:"Off"};t.StringFilterOperator={Equals:"Equals",Contains:"Contains",StartsWith:"StartsWith",AnyWordStartsWith:"AnyWordStartsWith"};t.LightBoxLoadingStates={Loading:"LOADING",Loaded:"LOADED",TimeOutError:"TIME_OUT_ERROR",Error:"ERROR"};t.StepInputValidationMode={FocusOut:"FocusOut",LiveChange:"LiveChange"};t.StepInputStepModeType={AdditionAndSubtraction:"AdditionAndSubtraction",Multiple:"Multiple"};t.UploadState={Complete:"Complete",Error:"Error",Ready:"Ready",Uploading:"Uploading"};t.WrappingType={Normal:"Normal",Hyphenated:"Hyphenated"};t.PlanningCalendarStickyMode={None:"None",All:"All",NavBarAndColHeaders:"NavBarAndColHeaders"};t.TitleAlignment={Auto:"Auto",Start:"Start",Center:"Center"};sap.ui.lazyRequire("sap.m.MessageToast","show");sap.ui.lazyRequire("sap.m.routing.RouteMatchedHandler");sap.ui.lazyRequire("sap.m.routing.Router");sap.ui.lazyRequire("sap.m.routing.Target");sap.ui.lazyRequire("sap.m.routing.TargetHandler");sap.ui.lazyRequire("sap.m.routing.Targets");if(D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf"){sap.ui.requireSync("sap/m/ios7");}if(/sap-ui-xx-formfactor=compact/.test(location.search)){q("html").addClass("sapUiSizeCompact");t._bSizeCompact=true;}if(/sap-ui-xx-formfactor=condensed/.test(location.search)){q("html").addClass("sapUiSizeCondensed");t._bSizeCondensed=true;}
t.getInvalidDate=function(){return null;};
t.getLocale=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();t.getLocale=function(){return l;};return l;};
t.getLocaleData=function(){var l=sap.ui.requireSync("sap/ui/core/LocaleData").getInstance(t.getLocale());t.getLocaleData=function(){return l;};return l;};
t.isDate=function(v){return v&&Object.prototype.toString.call(v)=="[object Date]"&&!isNaN(v);};
t.getIScroll=function(c){if(typeof window.iScroll!="function"||!(c instanceof C)){return;}var p,s;for(p=c;p=p.oParent;){s=p.getScrollDelegate?p.getScrollDelegate()._scroller:null;if(s&&s instanceof window.iScroll){return s;}}};
t.getScrollDelegate=function(o,G){if(!(o instanceof C)){return;}var U=sap.ui.require("sap/ui/core/UIComponent");function h(c){if(!c){return;}return G&&U&&(c instanceof U)?c.oContainer:c.oParent;}for(var p=o;p=h(p);){if(p&&typeof p.getScrollDelegate=="function"){return p.getScrollDelegate();}}};
t.ScreenSizes={phone:240,tablet:600,desktop:1024,xxsmall:240,xsmall:320,small:480,medium:560,large:768,xlarge:960,xxlarge:1120};f(t,"BaseFontSize",function(){t.BaseFontSize=q(document.documentElement).css("font-size")||"16px";return t.BaseFontSize;});
t.closeKeyboard=function(){var c=document.activeElement;if(!D.system.desktop&&c&&/(INPUT|TEXTAREA)/i.test(c.tagName)){c.blur();}};
t.touch=t.touch||{};
t.touch.find=function(T,o){var i,c;if(!T){return;}if(o&&typeof o.identifier!=="undefined"){o=o.identifier;}else if(typeof o!=="number"){e(false,'sap.m.touch.find(): oTouch must be a touch object or a number');return;}c=T.length;for(i=0;i<c;i++){if(T[i].identifier===o){return T[i];}}};
t.touch.countContained=function(T,v){var i,c=0,h,j,$;if(!T){return 0;}if(v instanceof Element){v=q(v);}else if(typeof v==="string"){v=q(document.getElementById(v));}else if(!(v instanceof q)){e(false,'sap.m.touch.countContained(): vElement must be a jQuery object or Element reference or a string');return 0;}j=v.children().length;h=T.length;for(i=0;i<h;i++){$=q(T[i].target);if((j===0&&$.is(v))||(v[0].contains($[0]))){c++;}}return c;};
t.URLHelper=(function(){function i(v){return v&&Object.prototype.toString.call(v)=="[object String]";}function c(T){if(!i(T)){return"";}return T.replace(/[^0-9\+\*#]/g,"");}function h(T){if(!i(T)){return"";}T=T.split(/\r\n|\r|\n/g).join("\r\n");return encodeURIComponent(T);}return q.extend(new E(),{normalizeTel:function(T){return"tel:"+c(T);},normalizeSms:function(T){return"sms:"+c(T);},normalizeEmail:function(s,S,B,j,k){var p=[],u="mailto:",l=encodeURIComponent;i(s)&&(u+=l(q.trim(s)));i(S)&&p.push("subject="+l(S));i(B)&&p.push("body="+h(B));i(k)&&p.push("bcc="+l(q.trim(k)));i(j)&&p.push("cc="+l(q.trim(j)));if(p.length){u+="?"+p.join("&");}return u;},redirect:function(u,n){e(i(u),this+"#redirect: URL must be a string");this.fireEvent("redirect",u);if(!n){window.location.href=u;}else{var w=window.open(u,"_blank");if(!w){L.error(this+"#redirect: Could not open "+u);if(D.os.windows_phone||(D.browser.edge&&D.browser.mobile)){L.warning("URL will be enforced to open in the same window as a fallback from a known Windows Phone system restriction. Check the documentation for more information.");window.location.href=u;}}}},attachRedirect:function(F,l){return this.attachEvent("redirect",F,l);},detachRedirect:function(F,l){return this.detachEvent("redirect",F,l);},triggerTel:function(T){this.redirect(this.normalizeTel(T));},triggerSms:function(T){this.redirect(this.normalizeSms(T));},triggerEmail:function(s,S,B,j,k){this.redirect(this.normalizeEmail.apply(0,arguments));},toString:function(){return"sap.m.URLHelper";}});}());t.BackgroundHelper={addBackgroundColorStyles:function(r,B,s,c){r.addClass(c||"sapUiGlobalBackgroundColor");if(B&&!a.getType("sap.ui.core.CSSColor").isValid(B)){L.warning(B+" is not a valid sap.ui.core.CSSColor type");B="";}if(B||s){r.addStyle("background-image","none");r.addStyle("filter","none");}if(B){r.addStyle("background-color",B);}},renderBackgroundImageTag:function(r,c,v,B,R,o){r.write("<div id='"+c.getId()+"-BG' ");if(Array.isArray(v)){for(var i=0;i<v.length;i++){r.addClass(v[i]);}}else{r.addClass(v);}r.addClass("sapUiGlobalBackgroundImage");if(B){r.addStyle("display","block");r.addStyle("background-image","url("+g(B)+")");r.addStyle("background-repeat",R?"repeat":"no-repeat");if(!R){r.addStyle("background-size","cover");r.addStyle("background-position","center");}else{r.addStyle("background-position","left top");}}if(o!==1){if(o>1){o=1;}r.addStyle("opacity",o);}r.writeClasses(false);r.writeStyles();r.write("></div>");}};t.ImageHelper=(function(){function c(o,p,v){if(v!==undefined){var s=o['set'+d(p)];if(typeof(s)==="function"){s.call(o,v);return true;}}return false;}var i={getImageControl:function(I,o,p,P,h,j){e(P.src,"sap.m.ImageHelper.getImageControl: mProperties do not contain 'src'");if(o&&(o.getSrc()!=P.src)){o.destroy();o=undefined;}if(o&&(o instanceof sap.m.Image||o instanceof sap.ui.core.Icon)){for(var m in P){c(o,m,P[m]);}}else{var n=sap.ui.require("sap/m/Image")||sap.ui.requireSync("sap/m/Image");var s=Object.assign({},P,{id:I});o=sap.ui.core.IconPool.createControlByURI(s,n);o.setParent(p,null,true);}if(j){for(var l=0,r=j.length;l!==r;l++){o.removeStyleClass(j[l]);}}if(h){for(var k=0,u=h.length;k!==u;k++){o.addStyleClass(h[k]);}}return o;}};return i;}());t.PopupHelper={calcPercentageSize:function(p,B){if(typeof p!=="string"){L.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+p+"isn't with type string");return null;}if(p.indexOf("%")<=0){L.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+p+"is not a percentage string (for example '25%')");return null;}var P=parseFloat(p)/100,c=parseFloat(B);return Math.floor(P*c)+"px";}};t.InputODataSuggestProvider=(function(){var _=function(o){var h=o.getSource();var v=h.data(h.getId()+"-#valueListAnnotation");var m=h.getModel();var i=h.getBinding("value");var s=m.resolve(i.getPath(),i.getContext());if(!v){return;}var r=o.getParameter("selectedRow");q.each(r.getCells(),function(j,k){var l=k.getBinding("text");q.each(v.outParameters,function(K,n){if(!n.displayOnly&&n.value==l.getPath()){var V=l.getValue();var p=m.resolve(K,i.getContext());if(V&&p!==s){m.setProperty(p,V);}}});});return true;};var c=function(o,r){var M=o.getModel();var h=M.oMetadata;var p=M.resolve(o.getBindingPath("value"),o.getBindingContext());var v={};v.searchSupported=false;v.collectionPath="";v.outParameters={};v.inParameters={};v.selection=[];var A=M.getProperty(p+"/#com.sap.vocabularies.Common.v1.ValueList");if(!A){return false;}var P=p.substr(p.lastIndexOf('/')+1);v.inProperty=P;q.each(A.record,function(i,l){q.each(l,function(j,n){if(n.property==="SearchSupported"&&n.bool){v.searchSupported=true;}if(n.property==="CollectionPath"){v.collectionPath=n.string;}if(n.property==="Parameters"){q.each(n.collection.record,function(k,R){if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterIn"){var s;q.each(R.propertyValue,function(m,u){if(u.property==="LocalDataProperty"){s=u.propertyPath;}});q.each(R.propertyValue,function(m,u){if(u.property==="ValueListProperty"){v.inParameters[s]={value:u.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterInOut"){var s;q.each(R.propertyValue,function(m,u){if(u.property==="LocalDataProperty"){s=u.propertyPath;}});q.each(R.propertyValue,function(m,u){if(u.property==="ValueListProperty"){v.outParameters[s]={value:u.string};v.inParameters[s]={value:u.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterOut"){var s;q.each(R.propertyValue,function(m,u){if(u.property==="LocalDataProperty"){s=u.propertyPath;}});q.each(R.propertyValue,function(m,u){if(u.property==="ValueListProperty"){v.outParameters[s]={value:u.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterDisplayOnly"){var s;q.each(R.propertyValue,function(m,u){if(u.property==="ValueListProperty"){v.outParameters[u.string]={value:u.string,displayOnly:true};}});}});}});});v.resultEntity=h._getEntityTypeByPath("/"+v.collectionPath);v.listItem=new sap.m.ColumnListItem();q.each(v.outParameters,function(k,i){v.listItem.addCell(new sap.m.Text({text:"{"+i.value+"}",wrapping:false}));o.addSuggestionColumn(new sap.m.Column({header:new sap.m.Text({text:"{/#"+v.resultEntity.name+"/"+i.value+"/@sap:label}",wrapping:false})}));v.selection.push(i.value);});o.data(o.getId()+"-#valueListAnnotation",v);if(r){o.attachSuggestionItemSelected(_);}};var I={suggest:function(o,r,R,l){var v,h=o.getSource();r=r===undefined?true:r;R=R===undefined?true:R;if(!h.data(h.getId()+"-#valueListAnnotation")){c(h,R);}v=h.data(h.getId()+"-#valueListAnnotation");if(!v){return;}var i=function(o){var B=this.getLength();if(B&&B<=l){h.setShowTableSuggestionValueHelp(false);}else{h.setShowTableSuggestionValueHelp(true);}};if(v.searchSupported){var F=[];var s,j={};if(r){q.each(v.inParameters,function(k,m){if(k==v.inProperty){s=m.value;}else if(r){var V=h.getModel().getProperty(k,h.getBinding("value").getContext());if(V){F.push(new sap.ui.model.Filter(m.value,sap.ui.model.FilterOperator.StartsWith,V));}}});}j.search=o.getParameter("suggestValue");if(v.inParameters.length){if(s){j["search-focus"]=s;}else{e(false,'no search-focus defined');}}h.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,length:l,filters:F,parameters:{select:v.selection.join(','),custom:j},events:{dataReceived:i},template:v.listItem});}else{var F=[];q.each(v.inParameters,function(k,m){if(k==v.inProperty){F.push(new sap.ui.model.Filter(m.value,sap.ui.model.FilterOperator.StartsWith,o.getParameter("suggestValue")));}else if(r){var V=h.getModel().getProperty(k,h.getBinding("value").getContext());if(V){F.push(new sap.ui.model.Filter(m.value,sap.ui.model.FilterOperator.StartsWith,V));}}});h.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,filters:F,template:v.listItem,length:l,parameters:{select:v.selection.join(',')},events:{dataReceived:i}});}}};return I;}());O.set("sap.ui.layout.form.FormHelper",{createLabel:function(T,i){return new sap.m.Label(i,{text:T});},createButton:function(i,p,c){var h=this;var _=function(j){var o=new j(i,{type:t.ButtonType.Transparent});o.attachEvent('press',p,h);c.call(h,o);};var B=sap.ui.require("sap/m/Button");if(B){_(B);}else{sap.ui.require(["sap/m/Button"],_);}},setButtonContent:function(B,T,s,i,I){B.setText(T);B.setTooltip(s);B.setIcon(i);B.setActiveIcon(I);},addFormClass:function(){return"sapUiFormM";},setToolbar:function(T){var o=this.getToolbar();if(o&&o.setDesign){o.setDesign(o.getDesign(),true);}if(T&&T.setDesign){T.setDesign(sap.m.ToolbarDesign.Transparent,true);}return T;},bArrowKeySupport:false,bFinal:true});O.set("sap.ui.unified.FileUploaderHelper",{createTextField:function(i){var T=new sap.m.Input(i);return T;},setTextFieldContent:function(T,w){T.setWidth(w);},createButton:function(){var B=new sap.m.Button();return B;},addFormClass:function(){return"sapUiFUM";},bFinal:true});O.set("sap.ui.unified.ColorPickerHelper",{isResponsive:function(){return true;},factory:{createLabel:function(c){return new sap.m.Label(c);},createInput:function(i,c){return new sap.m.InputBase(i,c);},createSlider:function(i,c){return new sap.m.Slider(i,c);},createRadioButtonGroup:function(c){return new sap.m.RadioButtonGroup(c);},createRadioButtonItem:function(c){return new sap.m.RadioButton(c);},createButton:function(i,c){return new sap.m.Button(i,c);}},bFinal:true});O.set("sap.ui.table.TableHelper",{createLabel:function(c){return new sap.m.Label(c);},createTextView:function(c){return new sap.m.Label(c);},addTableClass:function(){return"sapUiTableM";},bFinal:true});O.set("sap.ui.layout.GridHelper",{getLibrarySpecificClass:function(){return"";},bFinal:true});if(D.os.blackberry||D.os.android&&D.os.version>=4){q(window).on("resize",function(){var A=document.activeElement;var T=A?A.tagName:"";if(T=="INPUT"||T=="TEXTAREA"){setTimeout(function(){A.scrollIntoViewIfNeeded();},0);}});}if(!Number.MAX_SAFE_INTEGER){Number.MAX_SAFE_INTEGER=Math.pow(2,53)-1;}return t;});
sap.ui.predefine('sap/m/routing/RouteMatchedHandler',['sap/ui/base/Object','./TargetHandler','./Router',"sap/base/Log"],function(B,T,M,L){"use strict";
var R=B.extend("sap.m.routing.RouteMatchedHandler",{constructor:function(r,c){if(r instanceof M){L.warning("A sap.m.routing.Router is used together with an sap.m.routing.RouteMatchedHandler (deprecated)."+"The RoutematchedHandler is not taking over triggering the navigations, the Router will do it.",this);return;}this._oTargetHandler=new T(c);r._oTargetHandler=this._oTargetHandler;r.attachRouteMatched(this._onHandleRouteMatched,this);r.attachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oTargets=r.getTargets();if(this._oTargets){this._oTargets.attachDisplay(this._onHandleDisplay,this);}this._oRouter=r;}});
R.prototype.destroy=function(){if(this._oRouter){this._oRouter.detachRouteMatched(this._onHandleRouteMatched,this);this._oRouter.detachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oRouter=null;}if(this._oTargets){this._oTargets.detachDisplay(this._onHandleRouteMatched,this);this._oTargets=null;}return this;};
R.prototype.setCloseDialogs=function(c){this._oTargetHandler.setCloseDialogs(c);return this;};
R.prototype.getCloseDialogs=function(){return this._oTargetHandler.getCloseDialogs();};
R.prototype._handleRoutePatternMatched=function(e){var t=+e.getParameter("config").viewLevel;this._oTargetHandler.navigate({viewLevel:t,navigationIdentifier:e.getParameter("name"),askHistory:true});};
R.prototype._onHandleRouteMatched=function(e){var p=e.getParameters(),c=p.config;if(!this._oRouter.getRoute(p.name)._oTarget){return;}this._oTargetHandler.addNavigation({targetControl:p.targetControl,eventData:p.arguments,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
R.prototype._onHandleDisplay=function(e){var p=e.getParameters(),c=p.config;this._oTargetHandler.addNavigation({targetControl:p.control,eventData:p.data,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
return R;});
sap.ui.predefine('sap/m/routing/Router',['sap/ui/core/routing/Router','./TargetHandler','./Targets'],function(R,T,a){"use strict";
var M=R.extend("sap.m.routing.Router",{
constructor:function(){this._oTargetHandler=new T();R.prototype.constructor.apply(this,arguments);},
destroy:function(){R.prototype.destroy.apply(this,arguments);this._oTargetHandler.destroy();this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_createTargets:function(c,t){return new a({views:this._oViews,config:c,targets:t,targetHandler:this._oTargetHandler});},
fireRouteMatched:function(A){var r=this.getRoute(A.name),t;if(r._oTarget){t=r._oTarget._oOptions;this._oTargetHandler.addNavigation({navigationIdentifier:A.name,transition:t.transition,transitionParameters:t.transitionParameters,eventData:A.arguments,targetControl:A.targetControl,view:A.view,preservePageInSplitContainer:t.preservePageInSplitContainer});}return R.prototype.fireRouteMatched.apply(this,arguments);},
fireRoutePatternMatched:function(A){var r=A.name,o=this.getRoute(r),v;if(o._oTarget){if(this._oTargets&&this._oTargets._oLastDisplayedTarget){v=this._oTargets._getViewLevel(this._oTargets._oLastDisplayedTarget);}this._oTargetHandler.navigate({navigationIdentifier:r,viewLevel:v,askHistory:true});}return R.prototype.fireRoutePatternMatched.apply(this,arguments);}
});
return M;});
sap.ui.predefine('sap/m/routing/Target',['sap/ui/core/routing/Target','./async/Target','./sync/Target',"sap/base/Log","sap/base/util/UriParameters"],function(T,a,s,L,U){"use strict";
var M=T.extend("sap.m.routing.Target",{constructor:function(o,v,p,t){this._oTargetHandler=t;function c(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTarget");return true;}return false;}if(o._async===undefined){o._async=c();}T.prototype.constructor.apply(this,arguments);var b=o._async?a:s;this._super={};for(var f in b){this._super[f]=this[f];this[f]=b[f];}}});
return M;});
sap.ui.predefine('sap/m/routing/TargetHandler',['sap/m/InstanceManager','sap/m/NavContainer','sap/m/SplitContainer','sap/ui/base/Object','sap/ui/core/routing/History','sap/ui/Device',"sap/base/Log"],function(I,N,S,B,H,D,L){"use strict";
var T=B.extend("sap.m.routing.TargetHandler",{constructor:function(c){this._aQueue=[];this._oNavigationOrderPromise=Promise.resolve();if(c===undefined){this._bCloseDialogs=true;}else{this._bCloseDialogs=!!c;}}});
T.prototype.setCloseDialogs=function(c){this._bCloseDialogs=!!c;return this;};
T.prototype.getCloseDialogs=function(){return this._bCloseDialogs;};
T.prototype.addNavigation=function(p){this._aQueue.push(p);};
T.prototype.navigate=function(d){var r=this._createResultingNavigations(d.navigationIdentifier),c=false,b=this._getDirection(d),n;while(r.length){n=this._applyNavigationResult(r.shift().oParams,b);c=c||n;}if(c){this._closeDialogs();}};
T.prototype._chainNavigation=function(n){this._oNavigationOrderPromise=this._oNavigationOrderPromise.then(n);return this._oNavigationOrderPromise;};
T.prototype._getDirection=function(d){var t=d.viewLevel,h=H.getInstance(),b=false;if(d.direction==="Backwards"){b=true;}else if(isNaN(t)||isNaN(this._iCurrentViewLevel)||t===this._iCurrentViewLevel){if(d.askHistory){b=h.getDirection()==="Backwards";}}else{b=t<this._iCurrentViewLevel;}this._iCurrentViewLevel=t;return b;};
T.prototype._createResultingNavigations=function(n){var i,f,c,C,o,r=[],v,b,a,p,R;while(this._aQueue.length){f=false;c=this._aQueue.shift();C=c.targetControl;b=C instanceof S;a=C instanceof N;v=c.view;o={oContainer:C,oParams:c,bIsMasterPage:(b&&!!C.getMasterPage(v.getId()))};p=b&&c.preservePageInSplitContainer&&C.getCurrentPage(o.bIsMasterPage)&&n!==c.navigationIdentifier;if(!(a||b)||!v){continue;}for(i=0;i<r.length;i++){R=r[i];if(R.oContainer!==C){continue;}if(a||D.system.phone){r.splice(i,1);r.push(o);f=true;break;}if(R.bIsMasterPage===o.bIsMasterPage){if(p){break;}r.splice(i,1);r.push(o);f=true;break;}}if(C instanceof S&&!D.system.phone){o.bIsMasterPage=!!C.getMasterPage(v.getId());}if(!f){if(!!C.getCurrentPage(o.bIsMasterPage)&&p){continue;}r.push(o);}}return r;};
T.prototype._applyNavigationResult=function(p,b){var t=p.targetControl,P,a=p.eventData,s=p.transition||"",o=p.transitionParameters,v=p.view.getId(),n=t instanceof S&&!!t.getMasterPage(v);if(t.getDomRef()&&t.getCurrentPage(n).getId()===v){L.info("navigation to view with id: "+v+" is skipped since it already is displayed by its targetControl","sap.m.routing.TargetHandler");return false;}L.info("navigation to view with id: "+v+" the targetControl is "+t.getId()+" backwards is "+b);if(b){P=t.getPreviousPage(n);if(!P||P.getId()!==v){t.insertPreviousPage(v,s,a);}t.backToPage(v,a,o);}else{t.to(v,s,a,o);}return true;};
T.prototype._closeDialogs=function(){if(!this._bCloseDialogs){return;}if(I.hasOpenPopover()){I.closeAllPopovers();}if(I.hasOpenDialog()){I.closeAllDialogs();}if(I.hasOpenLightBox()){I.closeAllLightBoxes();}};
return T;});
sap.ui.predefine('sap/m/routing/Targets',['sap/ui/core/routing/Targets','./TargetHandler','./Target','./async/Targets','./sync/Targets',"sap/base/Log","sap/base/util/UriParameters"],function(T,a,b,c,s,L,U){"use strict";
var M=T.extend("sap.m.routing.Targets",{
constructor:function(o){if(!o.config){o.config={_async:false};}function d(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTargets");return true;}return false;}if(o.config._async===undefined){o.config._async=(o.config.async===undefined)?d():o.config.async;}if(o.targetHandler){this._oTargetHandler=o.targetHandler;}else{this._oTargetHandler=new a();this._bHasOwnTargetHandler=true;}T.prototype.constructor.apply(this,arguments);var e=o.config._async?c:s;this._super={};for(var f in e){this._super[f]=this[f];this[f]=e[f];}},
destroy:function(){T.prototype.destroy.apply(this,arguments);if(this._bHasOwnTargetHandler){this._oTargetHandler.destroy();}this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_constructTarget:function(o,p){return new b(o,this.getViews(),p,this._oTargetHandler);},
_getViewLevel:function(t){var v;do{v=t._oOptions.viewLevel;if(v!==undefined){return v;}t=t._oParent;}while(t);return v;}
});
return M;});
sap.ui.predefine('sap/m/routing/async/Target',[],function(){"use strict";return{_place:function(d){var p=this._super._place.apply(this,arguments),t=this;return this._oTargetHandler._chainNavigation(function(){return p.then(function(v){t._oTargetHandler.addNavigation({navigationIdentifier:t._oOptions._name,transition:t._oOptions.transition,transitionParameters:t._oOptions.transitionParameters,eventData:d,targetControl:v.control,view:v.view,preservePageInSplitContainer:t._oOptions.preservePageInSplitContainer});if(d){delete d.routeConfig;}return v;});});}};},true);
sap.ui.predefine('sap/m/routing/async/Targets',[],function(){"use strict";return{_display:function(){var v,n;this._oLastDisplayedTarget=null;var p=this._super._display.apply(this,arguments);return p.then(function(V){if(this._oLastDisplayedTarget){v=this._getViewLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({viewLevel:v,navigationIdentifier:n,askHistory:true});return V;}.bind(this));},_displaySingleTarget:function(t){var T=this.getTarget(t.name);return this._super._displaySingleTarget.apply(this,arguments).then(function(v){if(T){this._oLastDisplayedTarget=T;}return v;}.bind(this));}};},true);
sap.ui.predefine('sap/m/routing/sync/Target',[],function(){"use strict";return{_place:function(p,d){var r=this._super._place.apply(this,arguments);this._oTargetHandler.addNavigation({navigationIdentifier:this._oOptions._name,transition:this._oOptions.transition,transitionParameters:this._oOptions.transitionParameters,eventData:d,targetControl:r.oTargetControl,view:r.oTargetParent,preservePageInSplitContainer:this._oOptions.preservePageInSplitContainer});if(d){delete d.routeConfig;}return r;}};},true);
sap.ui.predefine('sap/m/routing/sync/Targets',[],function(){"use strict";return{_display:function(){var v,n;this._oLastDisplayedTarget=null;var r=this._super._display.apply(this,arguments);if(this._oLastDisplayedTarget){v=this._getViewLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({viewLevel:v,navigationIdentifier:n,askHistory:true});return r;},_displaySingleTarget:function(n){var t=this.getTarget(n);if(t){this._oLastDisplayedTarget=t;}return this._super._displaySingleTarget.apply(this,arguments);}};},true);
sap.ui.predefine('sap/m/semantic/AddAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var A=S.extend("sap.m.semantic.AddAction",{metadata:{library:"sap.m"}});
return A;});
sap.ui.predefine('sap/m/semantic/CancelAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var C=S.extend("sap.m.semantic.CancelAction",{metadata:{library:"sap.m"}});
return C;});
sap.ui.predefine('sap/m/semantic/DeleteAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DeleteAction",{metadata:{library:"sap.m"}});
return D;});
sap.ui.predefine('sap/m/semantic/DetailPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/library"],function(S,a,b,l){"use strict";var c=l.semantic.SemanticRuleSetType;
var D=S.extend("sap.m.semantic.DetailPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/semantic/DetailPage.designtime"},
renderer:b.render
});
D.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_DETAIL_PAGE_TITLE"));};
D.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return this;}return S.prototype.setAggregation.call(this,A,o,s);};
D.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
D.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
D.prototype.getSemanticRuleSet=function(){return c.Classic;};
return D;});
sap.ui.predefine('sap/m/semantic/DiscussInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DiscussInJamAction",{metadata:{library:"sap.m"}});
return D;});
sap.ui.predefine('sap/m/semantic/EditAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var E=S.extend("sap.m.semantic.EditAction",{metadata:{library:"sap.m"}});
return E;});
sap.ui.predefine('sap/m/semantic/FavoriteAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FavoriteAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/FilterAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;});
sap.ui.predefine('sap/m/semantic/FilterSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;});
sap.ui.predefine('sap/m/semantic/FlagAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FlagAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/ForwardAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.ForwardAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/FullscreenPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer"],function(S,a,b){"use strict";
var F=S.extend("sap.m.semantic.FullscreenPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}}},
renderer:b.render
});
F.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return;}S.prototype.setAggregation.call(this,A,o,s);};
F.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
F.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
return F;});
sap.ui.predefine('sap/m/semantic/GroupAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;});
sap.ui.predefine('sap/m/semantic/GroupSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;});
sap.ui.predefine('sap/m/semantic/MainAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MainAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return M;});
sap.ui.predefine('sap/m/semantic/MasterPage',["sap/m/semantic/SemanticPage","sap/m/semantic/SemanticPageRenderer","sap/m/library"],function(S,a,l){"use strict";var b=l.semantic.SemanticRuleSetType;
var M=S.extend("sap.m.semantic.MasterPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},multiSelectAction:{type:"sap.m.semantic.MultiSelectAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},sort:{type:"sap.m.semantic.ISort",multiple:false},filter:{type:"sap.m.semantic.IFilter",multiple:false},group:{type:"sap.m.semantic.IGroup",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false}}},
renderer:a.render
});
M.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_MASTER_PAGE_TITLE"));};
M.prototype.getSemanticRuleSet=function(){return b.Classic;};
return M;});
sap.ui.predefine('sap/m/semantic/MessagesIndicator',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MessagesIndicator",{metadata:{library:"sap.m"}});
return M;});
sap.ui.predefine('sap/m/semantic/MultiSelectAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MultiSelectAction",{metadata:{library:"sap.m"}});
var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");M._PRESSED_STATE_TO_ICON_MAP={"true":"sap-icon://sys-cancel","false":"sap-icon://multi-select"};M._ACC_TOOLTIP_TO_ICON_MAP={"true":b.getText("SEMANTIC_CONTROL_MULTI_SELECT_CANCEL"),"false":b.getText("SEMANTIC_CONTROL_MULTI_SELECT")};
M.prototype._setPressed=function(p,s){var i=M._PRESSED_STATE_TO_ICON_MAP[p];var I=M._ACC_TOOLTIP_TO_ICON_MAP[p];this._getControl().setIcon(i);this._getControl().setTooltip(I);};
return M;});
sap.ui.predefine('sap/m/semantic/NegativeAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var N=S.extend("sap.m.semantic.NegativeAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return N;});
sap.ui.predefine('sap/m/semantic/OpenInAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var O=S.extend("sap.m.semantic.OpenInAction",{metadata:{library:"sap.m"}});
return O;});
sap.ui.predefine('sap/m/semantic/PositiveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PositiveAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/m/semantic/PrintAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PrintAction",{metadata:{library:"sap.m"}});
return P;});
sap.ui.predefine('sap/m/semantic/SaveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SaveAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/Segment',['sap/ui/base/Metadata',"sap/base/Log"],function(M,L){"use strict";var S=M.createClass("sap.m.semantic.Segment",{constructor:function(C,o,s,f){if(!o){L.error("missing argumment: constructor expects a container reference",this);return;}C||(C=[]);this._aContent=C;this._oContainer=o;this._sContainerAggregationName=s;this._fnSortFunction=f;}});
S.prototype.getStartIndex=function(){return 0;};
S.prototype.getEndIndex=function(){return this.getStartIndex()+this._aContent.length;};
S.prototype.getContent=function(){return this._aContent;};
S.prototype.indexOfContent=function(C){return this._aContent.indexOf(C);};
S.prototype.addContent=function(C,s){if(this._fnSortFunction){var i=this._matchSortToInsertIndex(C);if(typeof i!=='undefined'){this._insertContent(C,i,s);return C;}}var a=this.getEndIndex(),l=this._aContent.length,A="insert"+c(this._sContainerAggregationName);this._oContainer[A](C,a,s);this._aContent.splice(l,0,C);return C;};
S.prototype.insertContent=function(C,i,s){if(this._fnSortFunction){var I=this._matchSortToInsertIndex(C);if(typeof I!=='undefined'){this._insertContent(C,I,s);return C;}}return this._insertContent(C,i,s);};
S.prototype.removeContent=function(C,s){var l=this._aContent.indexOf(C),a="remove"+c(this._sContainerAggregationName);if(l>-1){this._aContent.splice(l,1);return this._oContainer[a](C,s);}};
S.prototype.removeAllContent=function(s){var r=[],g=this._oContainer.getAggregation(this._sContainerAggregationName),a=this.getStartIndex(),e=this.getEndIndex(),A="remove"+c(this._sContainerAggregationName);for(var i=a;i<e;i++){var I=this._oContainer[A](g[i],s);if(I){r.push(I);}}this._aContent=[];return r;};
S.prototype.destroy=function(s){var r=this.removeAllContent(s);for(var i=0;i<r.length;i++){r[i].destroy(s);}};
S.prototype._insertContent=function(C,i,s){var I=Math.min(this.getStartIndex()+i,this.getEndIndex()),a="insert"+c(this._sContainerAggregationName);I=Math.max(I,0);this._oContainer[a](C,I,s);this._aContent.splice(i,0,C);return C;};
S.prototype._matchSortToInsertIndex=function(C){for(var i=0;i<this._aContent.length;i++){if(this._fnSortFunction(C,this._aContent[i])<=0){return i;}}};
function c(n){return n.charAt(0).toUpperCase()+n.substring(1);}
return S;},false);
sap.ui.predefine('sap/m/semantic/SegmentedContainer',['sap/m/semantic/Segment','sap/ui/base/Metadata',"sap/base/Log"],function(S,M,L){"use strict";var a=M.createClass("sap.m.semantic.SegmentedContainer",{constructor:function(c,C){if(!c){L.error("missing argumment: constructor expects a container reference",this);return;}this._oContainer=c;C||(C="content");this._sContainerAggregationName=C;this._aSegments=[];}});
a.prototype.addSection=function(o){if(!o||!o.sTag){L.error("missing argumment: section options expected",this);return;}if(o.aContent){var c=o.aContent;var l=c.length;for(var i=0;i<l;i++){this._oContainer.addAggregation(this._sContainerAggregationName,c[i]);}}var s=new S(c,this._oContainer,this._sContainerAggregationName,o.fnSortFunction);s.sTag=o.sTag;var b=this._aSegments;s.getStartIndex=function(){var d=0;var e=b.indexOf(this);if(e>0){var p=e-1;while(p>=0){d+=b[p].getContent().length;p--;}}return d;};this._aSegments.push(s);};
a.prototype.getSection=function(t){var s;this._aSegments.forEach(function(b){if(b.sTag===t){s=b;}});return s;};
a.prototype.destroy=function(s){this._oContainer.destroy(s);this.aSegments=null;};
a.prototype.getContainer=function(){return this._oContainer;};
return a;},false);
sap.ui.predefine('sap/m/semantic/SemanticButton',['sap/m/semantic/SemanticControl','sap/m/Button','sap/m/semantic/SemanticOverflowToolbarButton',"sap/ui/thirdparty/jquery"],function(S,B,a,q){"use strict";
var b=S.extend("sap.m.semantic.SemanticButton",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true}},events:{press:{}}}});
b.prototype._getControl=function(){var c=this.getAggregation('_control');if(!c){var C=this._getConfiguration()&&this._getConfiguration().constraints==="IconOnly"?a:B;var n=this._createInstance(C);n.applySettings(this._getConfiguration().getSettings());if(typeof this._getConfiguration().getEventDelegates==="function"){n.addEventDelegate(this._getConfiguration().getEventDelegates(n));}this.setAggregation('_control',n,true);c=this.getAggregation('_control');}return c;};
b.prototype._createInstance=function(c){return new c({id:this.getId()+"-button",press:q.proxy(this.firePress,this)});};
return b;});
sap.ui.predefine('sap/m/semantic/SemanticConfiguration',["sap/ui/base/Metadata","sap/m/library","sap/m/OverflowToolbarLayoutData","sap/ui/core/IconPool","sap/ui/core/InvisibleText"],function(M,l,O,I,a){"use strict";var B=l.ButtonType;var P=l.PlacementType;var S=l.semantic.SemanticRuleSetType;var b=l.OverflowToolbarPriority;var c=M.createClass("sap.m.semantic.SemanticConfiguration",{});c.prototype._PositionInPage={headerLeft:"headerLeft",headerRight:"headerRight",headerMiddle:"headerMiddle",footerLeft:"footerLeft",footerRight_IconOnly:"footerRight_IconOnly",footerRight_TextOnly:"footerRight_TextOnly",shareMenu:"shareMenu"};c._PageMode={display:"display",edit:"edit",multimode:"multimode"};
c.isKnownSemanticType=function(t){return c.getConfiguration(t)!=undefined;};
c.getConfiguration=function(t){return c._oTypeConfigs[t];};
c.getSettings=function(t){return c._oTypeConfigs[t].getSettings();};
c.getPositionInPage=function(t){return c._oTypeConfigs[t].position;};
c.getSequenceOrderIndex=function(t){return c._oTypeConfigs[t].order;};
c.getAriaId=function(t){return c._oTypeConfigs[t].getSettings().ariaLabelledBy;};
c.getShareMenuConfig=function(r){switch(r){case S.Classic:return{baseButtonPlacement:P.Bottom,actionSheetPlacement:P.Top};case S.Optimized:return{baseButtonPlacement:P.Top,actionSheetPlacement:P.Bottom};}};
c._oTypeConfigs=(function(){var t={},o=sap.ui.getCore().getLibraryResourceBundle("sap.m");t["sap.m.semantic.MultiSelectAction"]={position:c.prototype._PositionInPage.headerRight,getSettings:function(){return{icon:I.getIconURI("multi-select"),tooltip:o.getText("SEMANTIC_CONTROL_MULTI_SELECT")};}};t["sap.m.semantic.MainAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:B.Emphasized,layoutData:new O({priority:b.NeverOverflow})};},order:0};t["sap.m.semantic.EditAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,triggers:c._PageMode.edit,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_EDIT"),type:B.Emphasized,layoutData:new O({priority:b.NeverOverflow})};},order:1};t["sap.m.semantic.SaveAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,triggers:c._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_SAVE"),type:B.Emphasized,layoutData:new O({priority:b.NeverOverflow})};},order:3};t["sap.m.semantic.DeleteAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,triggers:c._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_DELETE"),layoutData:new O({priority:b.NeverOverflow})};},order:4};t["sap.m.semantic.PositiveAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:B.Accept,layoutData:new O({priority:b.NeverOverflow})};},order:5};t["sap.m.semantic.NegativeAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:B.Reject,layoutData:new O({priority:b.NeverOverflow})};},order:6};t["sap.m.semantic.CancelAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,triggers:c._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_CANCEL")};},order:7};t["sap.m.semantic.ForwardAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_FORWARD")};},order:8};t["sap.m.semantic.OpenInAction"]={position:c.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_OPEN_IN")};},order:9};t["sap.m.semantic.AddAction"]={position:c.prototype._PositionInPage.footerRight_IconOnly,triggers:c._PageMode.edit,getSettings:function(){return{icon:I.getIconURI("add"),text:o.getText("SEMANTIC_CONTROL_ADD"),tooltip:o.getText("SEMANTIC_CONTROL_ADD")};},order:0,constraints:"IconOnly"};t["sap.m.semantic.FavoriteAction"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("favorite"),text:o.getText("SEMANTIC_CONTROL_FAVORITE"),tooltip:o.getText("SEMANTIC_CONTROL_FAVORITE")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.FlagAction"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("flag"),text:o.getText("SEMANTIC_CONTROL_FLAG"),tooltip:o.getText("SEMANTIC_CONTROL_FLAG")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.ISort"]={position:c.prototype._PositionInPage.footerRight_IconOnly,order:3};t["sap.m.semantic.IFilter"]={position:c.prototype._PositionInPage.footerRight_IconOnly,order:4};t["sap.m.semantic.IGroup"]={position:c.prototype._PositionInPage.footerRight_IconOnly,order:5};t["sap.m.semantic.SortAction"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("sort"),text:o.getText("SEMANTIC_CONTROL_SORT"),tooltip:o.getText("SEMANTIC_CONTROL_SORT")};},constraints:"IconOnly"};t["sap.m.semantic.SortSelect"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("sort"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_SORT")};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":true});}.bind(C)};},constraints:"IconOnly"};t["sap.m.semantic.FilterAction"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("filter"),text:o.getText("SEMANTIC_CONTROL_FILTER"),tooltip:o.getText("SEMANTIC_CONTROL_FILTER")};},constraints:"IconOnly"};t["sap.m.semantic.FilterSelect"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("filter"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_FILTER")};},constraints:"IconOnly"};t["sap.m.semantic.GroupAction"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("group-2"),text:o.getText("SEMANTIC_CONTROL_GROUP"),tooltip:o.getText("SEMANTIC_CONTROL_GROUP")};},constraints:"IconOnly"};t["sap.m.semantic.GroupSelect"]={position:c.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("group-2"),type:"IconOnly",autoAdjustWidth:true};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":true});}.bind(C)};},constraints:"IconOnly"};t["saveAsTileAction"]={position:c.prototype._PositionInPage.shareMenu,order:0,constraints:"IconOnly"};t["pagingAction"]={position:c.prototype._PositionInPage.headerRight};t["sap.m.semantic.DiscussInJamAction"]={position:c.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("discussion-2"),text:o.getText("SEMANTIC_CONTROL_DISCUSS_IN_JAM")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.ShareInJamAction"]={position:c.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("share-2"),text:o.getText("SEMANTIC_CONTROL_SHARE_IN_JAM")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.SendMessageAction"]={position:c.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("discussion"),text:o.getText("SEMANTIC_CONTROL_SEND_MESSAGE")};},order:3,constraints:"IconOnly"};t["sap.m.semantic.SendEmailAction"]={position:c.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("email"),text:o.getText("SEMANTIC_CONTROL_SEND_EMAIL")};},order:4,constraints:"IconOnly"};t["sap.m.semantic.PrintAction"]={position:c.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("print"),text:o.getText("SEMANTIC_CONTROL_PRINT")};},order:5,constraints:"IconOnly"};t["sap.m.semantic.MessagesIndicator"]={position:c.prototype._PositionInPage.footerLeft,getSettings:function(){var T=a.getStaticId("sap.m","SEMANTIC_CONTROL_MESSAGES_INDICATOR");return{icon:I.getIconURI("message-popup"),text:{path:"message>/",formatter:function(m){return m.length||0;}},tooltip:o.getText("SEMANTIC_CONTROL_MESSAGES_INDICATOR"),ariaLabelledBy:T,type:B.Emphasized,visible:{path:"message>/",formatter:function(m){return m&&m.length>0;}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new O({priority:b.NeverOverflow})};}};t["draftIndicator"]={position:c.prototype._PositionInPage.footerLeft,getSettings:function(){return{layoutData:new O({shrinkable:false})};},order:1};return t;})();return c;},false);
sap.ui.predefine('sap/m/semantic/SemanticControl',["sap/m/semantic/SemanticConfiguration","sap/ui/base/ManagedObject","sap/ui/core/Element","sap/ui/thirdparty/jquery"],function(S,M,E,q){"use strict";
var a=E.extend("sap.m.semantic.SemanticControl",{metadata:{library:"sap.m","abstract":true,properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_control:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
a.prototype.setProperty=function(k,v,s){M.prototype.setProperty.call(this,k,v,true);this._applyProperty(k,v,s);return this;};
a.prototype.updateAggregation=function(n){this._getControl().updateAggregation(n);};
a.prototype.refreshAggregation=function(n){this._getControl().refreshAggregation(n);};
a.prototype.setAggregation=function(A,o,s){if(A==='_control'){return M.prototype.setAggregation.call(this,A,o,s);}return this._getControl().setAggregation(A,o,s);};
a.prototype.getAggregation=function(A,d){if(A==='_control'){return M.prototype.getAggregation.call(this,A,d);}return this._getControl().getAggregation(A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._getControl().indexOfAggregation(A,o);};
a.prototype.insertAggregation=function(A,o,i,s){return this._getControl().insertAggregation(A,o,i,s);};
a.prototype.addAggregation=function(A,o,s){return this._getControl().addAggregation(A,o,s);};
a.prototype.removeAggregation=function(A,o,s){return this._getControl().removeAggregation(A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._getControl().removeAllAggregation(A,s);};
a.prototype.destroyAggregation=function(A,s){return this._getControl().destroyAggregation(A,s);};
a.prototype.bindAggregation=function(n,b){return this._getControl().bindAggregation(n,b);};
a.prototype.unbindAggregation=function(n,s){return this._getControl().unbindAggregation(n,s);};
a.prototype.clone=function(i,l){var c=E.prototype.clone.apply(this,arguments);var p=this._getControl().clone(i,l);c.setAggregation('_control',p);return c;};
a.prototype.destroy=function(){var r=E.prototype.destroy.apply(this,arguments);if(this.getAggregation("_control")){this.getAggregation("_control").destroy();}return r;};
a.prototype.getPopupAnchorDomRef=function(){return this._getControl().getDomRef();};
a.prototype.getDomRef=function(s){return this._getControl().getDomRef(s);};
a.prototype.addEventDelegate=function(d,t){q.each(d,function(e,c){if(typeof c==='function'){var p=function(o){o.srcControl=this;c.call(t,o);}.bind(this);d[e]=p;}}.bind(this));this._getControl().addEventDelegate(d,t);return this;};
a.prototype.removeEventDelegate=function(d){this._getControl().removeEventDelegate(d);return this;};
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
a.prototype._onPageStateChanged=function(e){this._updateState(e.sId);};
a.prototype._updateState=function(s){if(this._getConfiguration()&&this._getControl()){var o=this._getConfiguration().states[s];if(o){this._getControl().applySettings(o);}}};
a.prototype._applyProperty=function(k,v,s){var b="set"+this._capitalize(k);this._getControl()[b](v,s);};
a.prototype._capitalize=function(n){return n.charAt(0).toUpperCase()+n.slice(1);};
return a;});
sap.ui.predefine('sap/m/semantic/SemanticOverflowToolbarButton',['sap/m/OverflowToolbarButton','sap/m/ButtonRenderer'],function(O,B){"use strict";
var S=O.extend("sap.m.semantic.SemanticOverflowToolbarButton",{
metadata:{library:"sap.m"},
renderer:B.render
});
S.prototype._getTooltip=function(){var t=O.prototype._getTooltip.call(this);if(!t&&!this._bInOverflow&&this.getText()){t=this.getText();}return t;};
return S;});
sap.ui.predefine('sap/m/semantic/SemanticPage',['sap/m/semantic/SegmentedContainer','sap/m/semantic/SemanticConfiguration','sap/m/Button','sap/m/Title','sap/m/Page','sap/m/OverflowToolbar','sap/m/ToolbarSpacer','sap/m/Bar','sap/ui/core/CustomData','sap/ui/base/ManagedObject','sap/m/PageAccessibleLandmarkInfo','sap/ui/base/ManagedObjectObserver','sap/ui/core/Control','sap/ui/core/library','sap/m/library',"./SemanticPageRenderer","sap/base/Log","sap/ui/thirdparty/jquery"],function(S,a,B,T,P,O,b,c,C,M,d,e,f,g,l,h,L,q){"use strict";var i=l.ButtonType;var j=l.PageBackgroundDesign;var k=l.semantic.SemanticRuleSetType;var m=g.TitleLevel;
var n=f.extend("sap.m.semantic.SemanticPage",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:m.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false},semanticRuleSet:{type:"sap.m.semantic.SemanticRuleSetType",group:"Misc",defaultValue:k.Classic},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:j.Standard}},defaultAggregation:"content",aggregations:{subHeader:{type:"sap.m.IBar",multiple:false},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",forwarding:{getter:"_getPage",aggregation:"content"}},customHeaderContent:{type:"sap.m.Button",multiple:true,singularName:"customHeaderContent"},customFooterContent:{type:"sap.m.Button",multiple:true,singularName:"customFooterContent"},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false,forwarding:{getter:"_getPage",aggregation:"landmarkInfo"}},_page:{type:"sap.m.Page",multiple:false,visibility:"hidden"}},events:{navButtonPress:{}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/semantic/SemanticPage.designtime"}});
n.prototype.init=function(){this._oHeaderObserver=new e(n.prototype._updateHeaderVisibility.bind(this));this._currentMode=a._PageMode.display;this._getPage().setCustomHeader(this._getInternalHeader());this._getPage().setFooter(new O(this.getId()+"-footer"));this.setLandmarkInfo(new d());this._getPage().setShowHeader(false);};
n.prototype.exit=function(){if(this._oInternalHeader){this._oInternalHeader.destroy();this._oInternalHeader=null;}if(this._oWrappedFooter){this._oWrappedFooter.destroy();this._oWrappedFooter=null;}if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}if(this._oHeaderObserver){this._oHeaderObserver.disconnect();this._oHeaderObserver=null;}this._oPositionsMap=null;};
n.prototype.setSubHeader=function(p,r){this._getPage().setSubHeader(p,r);return this;};
n.prototype.getSubHeader=function(){return this._getPage().getSubHeader();};
n.prototype.destroySubHeader=function(p){this._getPage().destroySubHeader(p);return this;};
n.prototype.getShowSubHeader=function(){return this._getPage().getShowSubHeader();};
n.prototype.setShowSubHeader=function(p,r){this._getPage().setShowSubHeader(p,r);this.setProperty("showSubHeader",p,true);return this;};
n.prototype.getShowFooter=function(){return this._getPage().getShowFooter();};
n.prototype.setShowFooter=function(p,r){this._getPage().setShowFooter(p,r);this.setProperty("showFooter",p,true);return this;};
n.prototype.setFloatingFooter=function(F,p){this._getPage().setFloatingFooter(F,p);this.setProperty("floatingFooter",F,true);return this;};
n.prototype.setTitle=function(t){var p=this._getTitle();if(p){p.setText(t);if(!p.getParent()){this._getInternalHeader().addContentMiddle(p);}}this.setProperty("title",t,true);return this;};
n.prototype.setTitleLevel=function(t){this.setProperty("titleLevel",t,true);this._getTitle().setLevel(t);return this;};
n.prototype.setShowNavButton=function(p){var r=this._getNavButton();if(r){r.setVisible(p);if(!r.getParent()){this._getInternalHeader().addContentLeft(r);}}this.setProperty("showNavButton",p,true);return this;};
n.prototype.setEnableScrolling=function(E){this._getPage().setEnableScrolling(E);this.setProperty("enableScrolling",E,true);return this;};
n.prototype.setBackgroundDesign=function(p){this.setProperty("backgroundDesign",p,true);this._getPage().setBackgroundDesign(p);return this;};
n.prototype.getCustomFooterContent=function(){return this._getSegmentedFooter().getSection("customRight").getContent();};
n.prototype.addCustomFooterContent=function(p,r){this._getSegmentedFooter().getSection("customRight").addContent(p,r);return this;};
n.prototype.indexOfCustomFooterContent=function(p){return this._getSegmentedFooter().getSection("customRight").indexOfContent(p);};
n.prototype.insertCustomFooterContent=function(p,I,r){this._getSegmentedFooter().getSection("customRight").insertContent(p,I,r);return this;};
n.prototype.removeCustomFooterContent=function(p,r){return this._getSegmentedFooter().getSection("customRight").removeContent(p,r);};
n.prototype.removeAllCustomFooterContent=function(p){return this._getSegmentedFooter().getSection("customRight").removeAllContent(p);};
n.prototype.destroyCustomFooterContent=function(p){var r=this.getCustomFooterContent();if(!r){return this;}if(p){this.iSuppressInvalidate++;}this._getSegmentedFooter().getSection("customRight").destroy(p);if(!this.isInvalidateSuppressed()){this.invalidate();}if(p){this.iSuppressInvalidate--;}return this;};
n.prototype.getCustomHeaderContent=function(){return this._getSegmentedHeader().getSection("customRight").getContent();};
n.prototype.addCustomHeaderContent=function(p,r){this._getSegmentedHeader().getSection("customRight").addContent(p,r);return this;};
n.prototype.indexOfCustomHeaderContent=function(p){return this._getSegmentedHeader().getSection("customRight").indexOfContent(p);};
n.prototype.insertCustomHeaderContent=function(p,I,r){this._getSegmentedHeader().getSection("customRight").insertContent(p,I,r);return this;};
n.prototype.removeCustomHeaderContent=function(p,r){return this._getSegmentedHeader().getSection("customRight").removeContent(p,r);};
n.prototype.removeAllCustomHeaderContent=function(p){return this._getSegmentedHeader().getSection("customRight").removeAllContent(p);};
n.prototype.destroyCustomHeaderContent=function(p){var r=this.getCustomHeaderContent();if(!r){return this;}if(p){this.iSuppressInvalidate++;}this._getSegmentedHeader().getSection("customRight").destroy(p);if(!this.isInvalidateSuppressed()){this.invalidate();}if(p){this.iSuppressInvalidate--;}return this;};
n.prototype.setAggregation=function(A,p,r){var t=this.mAggregations[A];if(t===p){return this;}p=this.validateAggregation(A,p,false);var u=this.getMetadata().getManagedAggregation(A).type;if(a.isKnownSemanticType(u)){if(t){this._stopMonitor(t);this._removeFromInnerAggregation(t._getControl(),a.getPositionInPage(u),r);}if(p){this._initMonitor(p);this._addToInnerAggregation(p._getControl(),a.getPositionInPage(u),a.getSequenceOrderIndex(u),r);}return M.prototype.setAggregation.call(this,A,p,true);}return M.prototype.setAggregation.call(this,A,p,r);};
n.prototype.destroyAggregation=function(A,p){var r=this.getMetadata().getAggregations()[A];if(r&&a.isKnownSemanticType(r.type)){var t=M.prototype.getAggregation.call(this,A);if(t){this._stopMonitor(t);if(!t._getControl().bIsDestroyed){this._removeFromInnerAggregation(t._getControl(),a.getPositionInPage(r.type),p);}}}return M.prototype.destroyAggregation.call(this,A,t,p);};
n.prototype._updateHeaderVisibility=function(){var H=this._getInternalHeader();var E=(H.getContentLeft().length===0)&&(H.getContentMiddle().length===0)&&(H.getContentRight().length===0);this._getPage().setShowHeader(!E);};
n.prototype._getTitle=function(){if(!this._oTitle){this._oTitle=new T(this.getId()+"-title",{text:this.getTitle()});}return this._oTitle;};
n.prototype._getNavButton=function(){if(!this._oNavButton){this._oNavButton=new B(this.getId()+"-navButton",{type:i.Up,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT"),press:q.proxy(this.fireNavButtonPress,this)});}return this._oNavButton;};
n.prototype._initMonitor=function(p){var r=p._getConfiguration();if(r.triggers){p.attachEvent("press",this._updateCurrentMode,this);}var t=r.states,u=this;if(t){q.each(a._PageMode,function(v,w){if(t[v]){u.attachEvent(v,p._onPageStateChanged,p);}});}};
n.prototype._stopMonitor=function(p){p.detachEvent("press",this._updateCurrentMode,this);var r=p._getConfiguration();var t=r.states,u=this;if(t){q.each(a._PageMode,function(v,w){if(t[v]){u.detachEvent(v,p._onPageStateChanged,p);}});}};
n.prototype._updateCurrentMode=function(E){var p=E.oSource._getConfiguration();if(typeof p.triggers==='string'){this._currentMode=p.triggers;}else{var r=p.triggers.length;if(r&&r>0){for(var I=0;I<r;I++){var t=p.triggers[I];if(t&&(t.inState===this._currentMode)){this._currentMode=t.triggers;break;}}}}this.fireEvent(this._currentMode);};
n.prototype._removeFromInnerAggregation=function(p,r,t){var u=this._getSemanticPositionsMap()[r];if(u&&u.oContainer&&u.sAggregation){u.oContainer["remove"+o(u.sAggregation)](p,t);}};
n.prototype._addToInnerAggregation=function(p,r,t,u){if(!p||!r){return;}var v=this._getSemanticPositionsMap()[r];if(!v||!v.oContainer||!v.sAggregation){return;}if(typeof t!=='undefined'){p.addCustomData(new C({key:"sortIndex",value:t}));}return v.oContainer["add"+o(v.sAggregation)](p,u);};
n.prototype._getSemanticPositionsMap=function(p,r){if(!this._oPositionsMap){this._oPositionsMap={};this._oPositionsMap[a.prototype._PositionInPage.headerLeft]={oContainer:this._getInternalHeader(),sAggregation:"contentLeft"};this._oPositionsMap[a.prototype._PositionInPage.headerRight]={oContainer:this._getSegmentedHeader().getSection("semanticRight"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.headerMiddle]={oContainer:this._getInternalHeader(),sAggregation:"contentMiddle"};this._oPositionsMap[a.prototype._PositionInPage.footerLeft]={oContainer:this._getSegmentedFooter().getSection("semanticLeft"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_IconOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_IconOnly"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_TextOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_TextOnly"),sAggregation:"content"};}return this._oPositionsMap;};
n.prototype._getPage=function(){var p=this.getAggregation("_page");if(!p){this.setAggregation("_page",new P(this.getId()+"-page"));p=this.getAggregation("_page");}return p;};
n.prototype._getInternalHeader=function(){if(!this._oInternalHeader){this._oInternalHeader=new c(this.getId()+"-intHeader");if(this._oHeaderObserver){this._oHeaderObserver.observe(this._oInternalHeader,{aggregations:["contentLeft","contentMiddle","contentRight"]});}}return this._oInternalHeader;};
n.prototype._getAnyHeader=function(){return this._getInternalHeader();};
n.prototype._getSegmentedHeader=function(){if(!this._oWrappedHeader){var H=this._getInternalHeader();if(!H){L.error("missing page header",this);return null;}this._oWrappedHeader=new S(H,"contentRight");this._oWrappedHeader.addSection({sTag:"customRight"});this._oWrappedHeader.addSection({sTag:"semanticRight"});}return this._oWrappedHeader;};
n.prototype._getSegmentedFooter=function(){if(!this._oWrappedFooter){var F=this._getPage().getFooter();if(!F){L.error("missing page footer",this);return null;}this._oWrappedFooter=new S(F);this._oWrappedFooter.addSection({sTag:"semanticLeft"});this._oWrappedFooter.addSection({sTag:"spacer",aContent:[new b()]});this._oWrappedFooter.addSection({sTag:"semanticRight_TextOnly",fnSortFunction:s});this._oWrappedFooter.addSection({sTag:"customRight"});this._oWrappedFooter.addSection({sTag:"semanticRight_IconOnly",fnSortFunction:s});}return this._oWrappedFooter;};
function o(N){return N.substring(0,1).toUpperCase()+N.substring(1);}
function s(p,r){var t=p.data("sortIndex");var u=r.data("sortIndex");if((typeof t==='undefined')||(typeof u==='undefined')){L.warning("sortIndex missing",this);return null;}return(t-u);}
return n;});
sap.ui.predefine('sap/m/semantic/SemanticPageRenderer',[],function(){"use strict";var S={};
S.render=function(r,o){r.write("<div");r.writeControlData(o);r.addClass("sapMSemanticPage");r.writeClasses();r.write(">");r.renderControl(o._getPage());r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/semantic/SemanticSelect',['sap/m/semantic/SemanticControl','sap/m/Select',"sap/base/Log"],function(S,a,L){"use strict";
var b=S.extend("sap.m.semantic.SemanticSelect",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:""}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
b.prototype.setProperty=function(p,v,s){if(!this.getMetadata().getProperties()[p]&&!b.getMetadata().getProperties()[p]&&!S.getMetadata().getProperties()[p]){L.error("unknown property: "+p,this);return this;}S.prototype.setProperty.call(this,p,v,s);};
b.prototype.getSelectedItem=function(){return this._getControl().getSelectedItem();};
b.prototype.setSelectedItem=function(i){this._getControl().setSelectedItem(i);this.setSelectedKey(this._getControl().getSelectedKey());return this;};
b.prototype.getItemAt=function(i){return this._getControl().getItemAt(i);};
b.prototype._getControl=function(){var c=this.getAggregation('_control');if(!c){this.setAggregation('_control',new a({id:this.getId()+"-select",change:this._onInnerSelectChange.bind(this)}),true);c=this.getAggregation('_control');c.applySettings(this._getConfiguration().getSettings());if(typeof this._getConfiguration().getEventDelegates==="function"){c.addEventDelegate(this._getConfiguration().getEventDelegates(c));}}return c;};
b.prototype._onInnerSelectChange=function(e){var s=e.getSource().getSelectedItem();this.setSelectedItem(s);this.fireChange({selectedItem:s});};
return b;});
sap.ui.predefine('sap/m/semantic/SemanticToggleButton',['sap/m/semantic/SemanticButton','sap/m/library',"sap/ui/events/KeyCodes"],function(S,l,K){"use strict";var B=l.ButtonType;
var a=S.extend("sap.m.semantic.SemanticToggleButton",{metadata:{library:"sap.m","abstract":true,properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}}}});
a.prototype._onTap=function(e){e.setMarked();if(this.getEnabled()){this.setPressed(!this.getPressed());this.firePress({pressed:this.getPressed()});}};
a.prototype._onKeydown=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._onTap(e);}};
a.prototype._onAfterRendering=function(){var t=this._getControl().getType(),p=t===B.Emphasized;this.$().attr("aria-pressed",p);};
a.prototype._applyProperty=function(p,v,s){if(p==='pressed'){this._setPressed(v,s);}else{S.prototype._applyProperty.apply(this,arguments);}};
a.prototype._setPressed=function(p,s){var b=p?B.Emphasized:B.Default;this._getControl().setType(b,s);};
a.prototype._createInstance=function(c){var i=new c({id:this.getId()+"-toggleButton"});i.addEventDelegate({ontap:this._onTap,onkeydown:this._onKeydown,onAfterRendering:this._onAfterRendering},this);return i;};
return a;});
sap.ui.predefine('sap/m/semantic/SendEmailAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendEmailAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/SendMessageAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendMessageAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/ShareInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.ShareInJamAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/ShareMenu',['sap/ui/base/Metadata','sap/ui/base/ManagedObjectObserver','sap/m/library','sap/m/Button','sap/m/OverflowToolbarLayoutData','sap/ui/core/IconPool','sap/m/OverflowToolbarButton',"sap/base/Log"],function(M,a,l,B,O,I,b,L){"use strict";var c=l.OverflowToolbarPriority;var S=M.createClass("sap.m.semantic.ShareMenu",{constructor:function(A){if(!A){L.error("missing argumment: constructor expects an actionsheet reference",this);return;}this._oActionSheet=A;this._oContentObserver=new a(this._updateShareBtnVisibility.bind(this));this._setMode(S._Mode.initial);}});S._Mode={initial:"initial",button:"button",actionSheet:"actionSheet"};
S.prototype.getBaseButton=function(){return this._oBaseButton;};
S.prototype.getAggregation=function(n){if(n==="content"){return this.getContent();}};
S.prototype.addAggregation=function(n,o,s){if(n==="content"){return this.addContent(o,s);}};
S.prototype.insertAggregation=function(n,o,i,s){if(n==="content"){return this.insertContent(o,i,s);}};
S.prototype.indexOfAggregation=function(n,o){if(n==="content"){return this.indexOfContent(o);}};
S.prototype.removeAggregation=function(n,o,s){if(n==="content"){return this.removeContent(o,s);}};
S.prototype.removeAllAggregation=function(n,s){if(n==="content"){return this.removeAllContent(s);}};
S.prototype.getContent=function(){var m=this._getMode();if(m===S._Mode.initial){return[];}else if(m===S._Mode.button){return[this._oBaseButton];}else{return this._oActionSheet.getAggregation("buttons")||[];}};
S.prototype.addContent=function(o,s){var m=this._getMode();this._observeButton(o);if(m===S._Mode.initial){this._setMode(S._Mode.button,s,o);return this;}if(m===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(o);this._oActionSheet.addButton(o,s);this._updateShareBtnVisibility();return this;};
S.prototype.insertContent=function(o,i,s){var m=this._getMode();this._observeButton(o);if(m===S._Mode.initial){this._setMode(S._Mode.button,s,o);return this;}if(m===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(o);this._oActionSheet.insertButton(o,i,s);this._updateShareBtnVisibility();return this;};
S.prototype.indexOfContent=function(o){if((this._getMode()===S._Mode.button)&&(o===this._oBaseButton)){return 0;}if(this._getMode()===S._Mode.actionSheet){return this._oActionSheet.indexOfAggregation("buttons",o);}return-1;};
S.prototype.removeContent=function(o,s){var r,m=this._getMode();if(m===S._Mode.actionSheet){r=this._oActionSheet.removeButton(o,s);this._postProcessOverflowToolbarButton(o);this._unobserveButton(o);if(r){if(this._oActionSheet.getAggregation("buttons").length===1){this._setMode(S._Mode.button,s);}}this._updateShareBtnVisibility();return r;}if(m===S._Mode.button){var d=this._oBaseButton;this._setMode(S._Mode.initial,s);return d;}return r;};
S.prototype.removeAllContent=function(s){var r;if(this._getMode()===S._Mode.actionSheet){r=this._oActionSheet.removeAllButtons(s);r.forEach(function(o){this._postProcessOverflowToolbarButton(o);this._unobserveButton(o);},this);this._updateShareBtnVisibility();}else if(this._getMode()===S._Mode.button){r=[this._oBaseButton];}this._setMode(S._Mode.initial,s);return r;};
S.prototype.destroy=function(s){this._oActionSheet.destroy(s);if(this._oShareMenuBtn){this._oShareMenuBtn.destroy(s);this._oShareMenuBtn=null;}if(this._oContentObserver){this._oContentObserver.disconnect();this._oContentObserver=null;}};
S.prototype._setBaseButton=function(o,s){if(this._oBaseButton===o){return this;}var d=this._oBaseButton;this._oBaseButton=o;if(d){var p=d.getParent(),P=d.sParentAggregationName;if(p){p.removeAggregation(P,d,s);p.addAggregation(P,this._oBaseButton,s);}}return this;};
S.prototype._getMode=function(){return this._mode;};
S.prototype._setMode=function(m,s,o){if(!S._Mode[m]){L.error("unknown shareMenu mode "+m,this);return this;}if(this._mode===m){return this;}if(S._Mode.initial===m){this._setBaseButton(this._getShareMenuButton().applySettings({visible:false}));this._mode=S._Mode.initial;return this;}if(m===S._Mode.button){if(this._mode===S._Mode.initial){this._setBaseButton(o);}else if(this._mode===S._Mode.actionSheet){var d=this._oActionSheet.getAggregation("buttons")[0];this._oActionSheet.removeButton(d,s);this._postProcessOverflowToolbarButton(d);this._setBaseButton(d);}this._mode=S._Mode.button;return this;}if(m===S._Mode.actionSheet){var e=this._oBaseButton;this._setBaseButton(this._getShareMenuButton().applySettings({visible:true}));if(e){this._preProcessOverflowToolbarButton(e);this._oActionSheet.addButton(e,s);}this._mode=S._Mode.actionSheet;}return this;};
S.prototype._getShareMenuButton=function(){if(!this._oShareMenuBtn){var t=this;this._oShareMenuBtn=new B(this._oActionSheet.getParent().getId()+"-shareButton",{icon:I.getIconURI("action"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_CONTROL_ACTION_SHARE"),layoutData:new O({priority:c.NeverOverflow}),press:function(){t._oActionSheet.openBy(t._oShareMenuBtn);}});this._oShareMenuBtn.addEventDelegate({onAfterRendering:function(){t._oShareMenuBtn.$().attr("aria-haspopup",true);}});}return this._oShareMenuBtn;};
S.prototype._getVisibleContent=function(){return this.getContent().filter(function(o){return o.getVisible();});};
S.prototype._updateShareBtnVisibility=function(){var v=this._getVisibleContent(),t=v.length>0;this._getShareMenuButton().setVisible(t);};
S.prototype._preProcessOverflowToolbarButton=function(o){if(o instanceof b){o._bInOverflow=true;}};
S.prototype._postProcessOverflowToolbarButton=function(o){if(o instanceof b){delete o._bInOverflow;}};
S.prototype._observeButton=function(o){this._oContentObserver.observe(o,{properties:["visible"]});};
S.prototype._unobserveButton=function(o){this._oContentObserver.unobserve(o,{properties:["visible"]});};
return S;},false);
sap.ui.predefine('sap/m/semantic/ShareMenuPage',["sap/m/semantic/SemanticPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/semantic/SegmentedContainer","sap/m/semantic/ShareMenu","sap/m/ActionSheet","sap/m/library"],function(S,a,b,c,d,A,l){"use strict";var P=l.PlacementType;
var e=S.extend("sap.m.semantic.ShareMenuPage",{
metadata:{library:"sap.m",aggregations:{customShareMenuContent:{type:"sap.m.Button",multiple:true,singularName:"customShareMenuContent"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/semantic/ShareMenuPage.designtime"},
renderer:b.render
});
e.prototype._getSemanticPositionsMap=function(C,o){if(!this._oPositionsMap){this._oPositionsMap=S.prototype._getSemanticPositionsMap.apply(this,arguments);this._oPositionsMap[a.prototype._PositionInPage.shareMenu]={oContainer:this._getSegmentedShareMenu().getSection("semantic"),sAggregation:"content"};}return this._oPositionsMap;};
e.prototype.exit=function(){S.prototype.exit.apply(this,arguments);if(this._oSegmentedShareMenu){this._oSegmentedShareMenu.destroy();this._oSegmentedShareMenu=null;}};
e.prototype.getCustomShareMenuContent=function(){return this._getSegmentedShareMenu().getSection("custom").getContent();};
e.prototype.addCustomShareMenuContent=function(B,s){this._getSegmentedShareMenu().getSection("custom").addContent(B,s);return this;};
e.prototype.indexOfCustomShareMenuContent=function(B){return this._getSegmentedShareMenu().getSection("custom").indexOfContent(B);};
e.prototype.insertCustomShareMenuContent=function(B,i,s){this._getSegmentedShareMenu().getSection("custom").insertContent(B,i,s);return this;};
e.prototype.removeCustomShareMenuContent=function(B,s){return this._getSegmentedShareMenu().getSection("custom").removeContent(B,s);};
e.prototype.removeAllCustomShareMenuContent=function(s){return this._getSegmentedShareMenu().getSection("custom").removeAllContent(s);};
e.prototype.destroyCustomShareMenuContent=function(s){var C=this.getCustomShareMenuContent();if(!C){return this;}if(s){this.iSuppressInvalidate++;}this._getSegmentedShareMenu().getSection("custom").destroy();if(!this.isInvalidateSuppressed()){this.invalidate();}if(s){this.iSuppressInvalidate--;}return this;};
e.prototype.setSemanticRuleSet=function(n){var o=this.getSemanticRuleSet();if(o===n){return this;}this.setProperty("semanticRuleSet",n,true);var O=a.getShareMenuConfig(o),s=this._getShareBaseButtonContainer(O.baseButtonPlacement).getSection("shareMenu");if(s){this._moveShareMenu(O,a.getShareMenuConfig(this.getSemanticRuleSet()));}return this;};
e.prototype._moveShareMenu=function(o,n){var O=this._getShareBaseButtonContainer(o.baseButtonPlacement).getSection("shareMenu"),f=O&&O.removeAllContent(),g=f.length&&f[0];this._placeShareMenu(g,n);};
e.prototype._getActionSheet=function(){var o=this.getAggregation("_actionSheet");if(!o){this.setAggregation("_actionSheet",new A(),true);o=this.getAggregation("_actionSheet");}return o;};
e.prototype._getSegmentedShareMenu=function(){if(!this._oSegmentedShareMenu){var s=new d(this._getActionSheet());var o=s.getBaseButton();if(s&&o){this._oSegmentedShareMenu=new c(s);this._oSegmentedShareMenu.addSection({sTag:"custom"});this._oSegmentedShareMenu.addSection({sTag:"semantic"});this._placeShareMenu(o,a.getShareMenuConfig(this.getSemanticRuleSet()));}}return this._oSegmentedShareMenu;};
e.prototype._placeShareMenu=function(s,o){var f=o.baseButtonPlacement,v=o.actionSheetPlacement;var D=this._getShareBaseButtonContainer(f),g=D.getSection("shareMenu");if(!g){D.addSection({sTag:"shareMenu"});g=D.getSection("shareMenu");}if(s){g.addContent(s);}this._getActionSheet().setPlacement(v);};
e.prototype._getShareBaseButtonContainer=function(B){return(B===P.Bottom)?this._getSegmentedFooter():this._getSegmentedHeader();};
return e;});
sap.ui.predefine('sap/m/semantic/SortAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;});
sap.ui.predefine('sap/m/semantic/SortSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;});
sap.ui.predefine('sap/m/upload/UploadSet',["sap/ui/core/Control","sap/ui/core/Icon","sap/ui/events/KeyCodes","sap/base/Log","sap/base/util/deepEqual","sap/m/library","sap/m/Button","sap/m/Dialog","sap/m/List","sap/m/MessageBox","sap/m/OverflowToolbar","sap/m/StandardListItem","sap/m/Text","sap/m/ToolbarSpacer","sap/ui/unified/FileUploader","sap/m/upload/UploadSetItem","sap/m/upload/Uploader","sap/m/upload/UploadSetRenderer"],function(C,I,K,L,d,M,B,D,a,b,O,S,T,c,F,U,e,R){"use strict";
var f=C.extend("sap.m.upload.UploadSet",{metadata:{library:"sap.m",properties:{fileTypes:{type:"string[]",defaultValue:null},maxFileNameLength:{type:"int",defaultValue:null},maxFileSize:{type:"float",defaultValue:null},mediaTypes:{type:"string[]",defaultValue:null},noDataText:{type:"string",defaultValue:null},noDataDescription:{type:"string",defaultValue:null},instantUpload:{type:"boolean",defaultValue:true},showIcons:{type:"boolean",defaultValue:true},terminationEnabled:{type:"boolean",defaultValue:true},uploadEnabled:{type:"boolean",defaultValue:true},uploadUrl:{type:"string",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.upload.UploadSetItem",multiple:true,singularName:"item"},incompleteItems:{type:"sap.m.upload.UploadSetItem",multiple:true,singularName:"incompleteItem"},headerFields:{type:"sap.ui.core.Item",multiple:true,singularName:"headerField"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},uploader:{type:"sap.m.upload.Uploader",multiple:false}},events:{afterItemAdded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},beforeItemAdded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeItemRemoved:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeItemEdited:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeUploadStarts:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},uploadCompleted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},beforeUploadTermination:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},uploadTerminated:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileTypeMismatch:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileNameLengthExceeded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileSizeExceeded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},mediaTypeMismatch:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},selectionChanged:{parameters:{items:{type:"sap.m.upload.UploadSetItem[]"}}}}}});
var g=M.UploadState;
f.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=null;this._oNoDataIcon=new I(this.getId()+"-no-data-icon",{src:"sap-icon://document",size:"6rem",noTabStop:true});this._oEditedItem=null;this._oItemToBeDeleted=null;this._mListItemIdToItemMap={};this._$Body=null;this._$DragDropArea=null;this._oLastEnteredTarget=null;};
f.prototype.exit=function(){this._unbindDragAndDrop();this._oNoDataIcon.destroy();this._oNoDataIcon=null;};
f.prototype.onBeforeRendering=function(){this._unbindDragAndDrop();};
f.prototype.onAfterRendering=function(){var i;if(this._oEditedItem){i=this._oEditedItem._getFileNameEdit().$("inner");if(i){i.focus(function(){i.selectText(0,i.val().length);});i.focus();}}this._bindDragAndDrop();};
f.prototype.onkeydown=function(E){var l,i;if(this._oEditedItem&&this._oEditedItem._getFileNameEdit().$("inner")[0]===E.target){i=this._oEditedItem;}else if(E.target){l=sap.ui.getCore().byId(E.target.id);if(l){i=this._mListItemIdToItemMap[l.getId()];}}if(!i){return;}switch(E.keyCode){case K.F2:if(i._bInEditMode){this._handleItemEditConfirmation(E,i);}else{this._handleItemEdit(E,i);}break;case K.ESCAPE:this._handleItemEditCancelation(E,i);break;case K.DELETE:this._handleItemDelete(E,i);break;case K.ENTER:if(i===this._oEditedItem){this._handleItemEditConfirmation(E,i);}else{i._handleFileNamePressed();}break;default:return;}};
f.prototype.getToolbar=function(){if(!this._oToolbar){this._oToolbar=this.getAggregation("toolbar");if(!this._oToolbar){this._oToolbar=new O(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new c(),this.getDefaultFileUploader()]});this.addDependent(this._oToolbar);}else{this._oToolbar.addContent(this.getDefaultFileUploader());}}return this._oToolbar;};
f.prototype.getNoDataText=function(){var n=this.getProperty("noDataText");n=n||this._oRb.getText("UPLOAD_SET_NO_DATA_TEXT");return n;};
f.prototype.getNoDataDescription=function(){var n=this.getProperty("noDataDescription");n=n||this._oRb.getText("UPLOAD_SET_NO_DATA_DESCRIPTION");return n;};
f.prototype.setToolbar=function(t){this.setAggregation("toolbar",t);this.getToolbar();return this;};
f.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.call(this,A,o,s);if(o&&(A==="items"||A==="incompleteItems")){this._projectToNewListItem(o);this._refreshInnerListStyle();}};
f.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.call(this,A,o,i,s);if(o&&(A==="items"||A==="incompleteItems")){this._projectToNewListItem(o,i||0);this._refreshInnerListStyle();}};
f.prototype.removeAggregation=function(A,o,s){var l;C.prototype.removeAggregation.call(this,A,o,s);if(o&&(A==="items"||A==="incompleteItems")){l=o._getListItem();var i=this.getList().removeAggregation("items",l,s);if(i){i.destroy();}this._refreshInnerListStyle();}};
f.prototype.removeAllAggregation=function(A,s){if(A==="items"){this.getItems().forEach(function(i){this.getList().removeAggregation("items",i._getListItem(),s);}.bind(this));}else if(A==="incompleteItems"){this.getIncompleteItems().forEach(function(i){this.getList().removeAggregation("items",i._getListItem(),s);}.bind(this));}C.prototype.removeAllAggregation.call(this,A,s);};
f.prototype.destroyAggregation=function(A,s){if(A==="items"||A==="incompleteItems"){this.removeAllAggregation(A,s);}if(this.getList().getItems().length===0){this.getList().destroyAggregation("items",s);}C.prototype.destroyAggregation.call(this,A,s);};
f.prototype.setFileTypes=function(n){var t=n||null;if(typeof t==="string"){t=t.split(",");}t=(t||[]).map(function(s){return s?s.toLowerCase():"";});if(!d(this.getFileTypes(),t)){this.setProperty("fileTypes",t,true);this._checkRestrictions();}return this;};
f.prototype.setMaxFileNameLength=function(n){if(this.getMaxFileNameLength()!==n){this.setProperty("maxFileNameLength",n,true);this._checkRestrictions();}return this;};
f.prototype.setMaxFileSize=function(n){if(this.getMaxFileSize()!==n){this.setProperty("maxFileSize",n,true);this._checkRestrictions();}return this;};
f.prototype.setMediaTypes=function(n){var t=n||null;if(typeof t==="string"){t=t.split(",");}t=(t||[]).map(function(s){return s?s.toLowerCase():"";});if(!d(this.getMediaTypes(),t)){this.setProperty("mediaTypes",t,true);this._checkRestrictions();}return this;};
f.prototype.setShowIcons=function(s){if(s!==this.getShowIcons()){this._getAllItems().forEach(function(i){i._getIcon().setVisible(s);});this.setProperty("showIcons",s,false);}return this;};
f.prototype.setTerminationEnabled=function(E){if(E!==this.getTerminationEnabled()){this._getAllItems().forEach(function(i){if(i.getUploadState()===g.Uploading){i._getTerminateButton().setVisible(E);}});this.setProperty("terminationEnabled",E,false);}return this;};
f.prototype.setUploadEnabled=function(E){if(E!==this.getUploadEnabled()){this.getDefaultFileUploader().setEnabled(E);this.setProperty("uploadEnabled",E,false);}return this;};
f.prototype.getList=function(){if(!this._oList){this._oList=new a(this.getId()+"-list",{selectionChange:[this._handleSelectionChange,this],headerToolbar:this.getToolbar()});this._oList.addStyleClass("sapMUCList");this.addDependent(this._oList);}return this._oList;};
f.prototype.upload=function(){if(!this.getUploadEnabled()){L.warning("Upload is currently disabled for this upload set.");return;}this.getIncompleteItems().forEach(function(i){this._uploadItemIfGoodToGo(i);}.bind(this));};
f.prototype.uploadItem=function(i){this._uploadItemIfGoodToGo(i);};
f.prototype.getDefaultFileUploader=function(){var t;if(!this._oFileUploader){this._oFileUploader=new F(this.getId()+"-uploader",{buttonOnly:true,buttonText:t,tooltip:t,iconOnly:true,enabled:this.getUploadEnabled(),icon:"sap-icon://add",iconFirst:false,style:"Transparent",name:"uploadSetFileUploader",sameFilenameAllowed:true,useMultipart:false,sendXHR:true,change:[this._onFileUploaderChange,this],uploadStart:[this._onUploadStarted,this],uploadProgress:[this._onUploadProgressed,this],uploadComplete:[this._onUploadCompleted,this],uploadAborted:[this._onUploadAborted,this]});}return this._oFileUploader;};
f.prototype.registerUploaderEvents=function(u){u.attachUploadStarted(this._onUploadStarted.bind(this));u.attachUploadProgressed(this._onUploadProgressed.bind(this));u.attachUploadCompleted(this._onUploadCompleted.bind(this));u.attachUploadAborted(this._onUploadAborted.bind(this));};
f.prototype._onFileUploaderChange=function(E){var o=E.getParameter("files");this._processNewFileObjects(o);};
f.prototype._onUploadStarted=function(E){var i=E.getParameter("item");i.setUploadState(g.Uploading);};
f.prototype._onUploadProgressed=function(E){var i=E.getParameter("item"),p=Math.round(E.getParameter("loaded")/E.getParameter("total")*100);i.setProgress(p);};
f.prototype._onUploadCompleted=function(E){var i=E.getParameter("item");i.setProgress(100);i.setUploadState(g.Complete);this.fireUploadCompleted({item:i});};
f.prototype._onUploadAborted=function(E){var i=E.getParameter("item");i.setUploadState(g.Error);this.fireUploadTerminated({item:i});};
f.prototype._handleItemEdit=function(E,i){if(this._oEditedItem){this._handleItemEditConfirmation(E,this._oEditedItem);}if(!this._oEditedItem){if(this.fireBeforeItemEdited({item:i})){this._oEditedItem=i;this._oEditedItem._setInEditMode(true);}}};
f.prototype._handleItemRestart=function(E,i){i.setUploadState(g.Ready);this._uploadItemIfGoodToGo(i);};
f.prototype._handleItemEditConfirmation=function(E,i){var o=i._getFileNameEdit(),n,N,s=i.getFileName(),h=U._splitFileName(s);n=o.getValue().trim();if(!n||n.length===0){i._setContainsError(true);return;}if(h.name!==n){N=n+"."+h.extension;i.setFileName(N);}i._setContainsError(false);i._setInEditMode(false);this._oEditedItem=null;};
f.prototype._handleItemEditCancelation=function(E,i){i._setContainsError(false);i._setInEditMode(false);this._oEditedItem=null;};
f.prototype._handleItemDelete=function(E,i){var m;if(this._oEditedItem){this._handleItemEditConfirmation(E,this._oEditedItem);if(this._oEditedItem){return;}}if(!i.fireRemovePressed({item:i})){return;}if(!this.fireBeforeItemRemoved({item:i})){return;}if(!i.getFileName()){m=this._oRb.getText("UPLOAD_SET_DELETE_WITHOUT_FILE_NAME_TEXT");}else{m=this._oRb.getText("UPLOAD_SET_DELETE_TEXT",i.getFileName());}this._oItemToBeDeleted=i;b.show(m,{id:this.getId()+"-deleteDialog",title:this._oRb.getText("UPLOAD_SET_DELETE_TITLE"),actions:[b.Action.OK,b.Action.CANCEL],onClose:this._handleClosedDeleteDialog.bind(this),dialogId:"messageBoxDeleteFile",styleClass:this.hasStyleClass("sapUiSizeCompact")?"sapUiSizeCompact":""});};
f.prototype._handleClosedDeleteDialog=function(A){if(A!==b.Action.OK){return;}this.removeItem(this._oItemToBeDeleted);this.removeIncompleteItem(this._oItemToBeDeleted);this._oItemToBeDeleted=null;};
f.prototype._handleTerminateRequest=function(h,i){var o=new a({items:[new S({title:i.getFileName(),icon:i._getIcon().getSrc()})]}),j=new D({id:this.getId()+"-teminateDialog",title:this._oRb.getText("UPLOAD_SET_TERMINATE_TITLE"),content:[new T({text:this._oRb.getText("UPLOAD_SET_TERMINATE_TEXT")}),o],buttons:[new B({text:this._oRb.getText("UPLOAD_SET_OKBUTTON_TEXT"),press:[k,this]}),new B({text:this._oRb.getText("UPLOAD_SET_CANCEL_BUTTON_TEXT"),press:function(){j.close();}})],afterClose:function(){j.destroy();}});j.open();function k(){if(i.getUploadState()===g.Uploading){if(this.fireBeforeUploadTermination({item:i})){this._handleUploadTermination(i);}}else if(i.getUploadState()===g.Complete){this.removeItem(i);}j.close();this.invalidate();}};
f.prototype._handleUploadTermination=function(i){this._getActiveUploader().terminateItem(i);};
f.prototype._handleSelectionChange=function(E){var l=E.getParameter("listItems"),i=[];l.forEach(function(o){i.push(this._mListItemIdToItemMap[o.getId()]);}.bind(this));this.fireSelectionChanged({items:i});};
f.prototype._onDragEnterSet=function(E){if(E.target===this._$DragDropArea[0]){this._$DragDropArea.addClass("sapMUCDropIndicator");}};
f.prototype._onDragLeaveSet=function(E){if(E.target===this._$DragDropArea[0]){this._$DragDropArea.removeClass("sapMUCDropIndicator");}};
f.prototype._onDragOverSet=function(E){E.preventDefault();};
f.prototype._onDropOnSet=function(E){var o;E.preventDefault();if(E.target===this._$DragDropArea[0]){this._$DragDropArea.removeClass("sapMUCDropIndicator");this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");o=E.originalEvent.dataTransfer.files;this._processNewFileObjects(o);}};
f.prototype._onDragEnterBody=function(E){this._oLastEnteredTarget=E.target;this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");};
f.prototype._onDragLeaveBody=function(E){if(this._oLastEnteredTarget===E.target){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
f.prototype._onDragOverBody=function(E){E.preventDefault();this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");};
f.prototype._onDropOnBody=function(E){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");};
f.prototype._getAllItems=function(){return this.getItems().concat(this.getIncompleteItems());};
f.prototype._refreshInnerListStyle=function(){var m=this.getList().length-1;this._oList.getItems().forEach(function(l,i){l.removeStyleClass("sapMUCListSingleItem").removeStyleClass("sapMUCListFirstItem").removeStyleClass("sapMUCListLastItem").removeStyleClass("sapMUCListItem");if(i===0&&m===0){l.addStyleClass("sapMUCListSingleItem");}else if(i===0){l.addStyleClass("sapMUCListFirstItem");}else if(i===m){l.addStyleClass("sapMUCListLastItem");}else{l.addStyleClass("sapMUCListItem");}});};
f.prototype._processNewFileObjects=function(o){var h=[],j;for(var i=0;i<o.length;i++){h.push(o[i]);}h.forEach(function(k){j=new U({fileName:k.name,uploadState:g.Ready});j._setFileObject(k);if(!this.fireBeforeItemAdded({item:j})){return;}this.insertIncompleteItem(j);this.fireAfterItemAdded({item:j});if(this.getInstantUpload()){this._uploadItemIfGoodToGo(j);}}.bind(this));};
f.prototype._projectToNewListItem=function(i,h){var l=i._getListItem();this._mListItemIdToItemMap[l.getId()]=i;if(h||h===0){this.getList().insertAggregation("items",l,h,true);}else{this.getList().addAggregation("items",l,true);}this._checkRestrictionsForItem(i);};
f.prototype._getImplicitUploader=function(){if(!this._oUploader){this._oUploader=new e();this._oUploader.setUploadUrl(this.getUploadUrl());this.registerUploaderEvents(this._oUploader);this.addDependent(this._oUploader);}return this._oUploader;};
f.prototype._getActiveUploader=function(){return this.getUploader()||this._getImplicitUploader();};
f.prototype._uploadItemIfGoodToGo=function(i){if(i.getUploadState()===g.Ready&&!i._isRestricted()){if(this.fireBeforeUploadStarts({item:i})){this._getActiveUploader().uploadItem(i,this.getHeaderFields());}}};
f.prototype._getDragDropHandlers=function(){if(!this._oDragDropHandlers){this._oDragDropHandlers={body:{"dragenter":this._onDragEnterBody.bind(this),"dragleave":this._onDragLeaveBody.bind(this),"dragover":this._onDragOverBody.bind(this),"drop":this._onDropOnBody.bind(this)},set:{"dragenter":this._onDragEnterSet.bind(this),"dragleave":this._onDragLeaveSet.bind(this),"dragover":this._onDragOverSet.bind(this),"drop":this._onDropOnSet.bind(this)}};}return this._oDragDropHandlers;};
f.prototype._bindDragAndDrop=function(){this._$Body=jQuery(document.body);Object.keys(this._getDragDropHandlers().body).forEach(function(E){this._$Body.on(E,this._getDragDropHandlers().body[E]);}.bind(this));this._$DragDropArea=this.$("drag-drop-area");Object.keys(this._getDragDropHandlers().set).forEach(function(E){this.$().on(E,this._getDragDropHandlers().set[E]);}.bind(this));};
f.prototype._unbindDragAndDrop=function(){if(this._$Body){Object.keys(this._getDragDropHandlers().body).forEach(function(E){this._$Body.off(E,this._getDragDropHandlers().body[E]);}.bind(this));}Object.keys(this._getDragDropHandlers().set).forEach(function(E){this.$().off(E,this._getDragDropHandlers().set[E]);}.bind(this));};
f.prototype._checkRestrictions=function(){this.getItems().forEach(function(i){this._checkRestrictionsForItem(i);}.bind(this));this.getIncompleteItems().forEach(function(i){this._checkRestrictionsForItem(i);}.bind(this));};
f.prototype._checkRestrictionsForItem=function(i){i._checkTypeRestriction(this.getFileTypes());i._checkNameLengthRestriction(this.getMaxFileNameLength());i._checkSizeRestriction(this.getMaxFileSize());i._checkMediaTypeRestriction(this.getMediaTypes());};
return f;});
sap.ui.predefine('sap/m/upload/UploadSetItem',["sap/base/Log","sap/ui/core/library","sap/ui/core/Element","sap/ui/core/Icon","sap/ui/core/IconPool","sap/ui/core/HTML","sap/ui/core/util/File","sap/m/library","sap/m/BusyIndicator","sap/m/Button","sap/m/CustomListItem","sap/m/Image","sap/m/Input","sap/m/Label","sap/m/Link","sap/m/ProgressIndicator","sap/m/VBox","sap/m/HBox"],function(L,C,E,I,a,H,F,M,B,b,c,d,e,f,g,P,V,h){"use strict";
var U=E.extend("sap.m.upload.UploadSetItem",{metadata:{library:"sap.m",properties:{enabledRemove:{type:"boolean",defaultValue:true},enabledEdit:{type:"boolean",defaultValue:true},fileName:{type:"string",defaultValue:null},mediaType:{type:"string",defaultValue:null},thumbnailUrl:{type:"string",defaultValue:null},uploadState:{type:"sap.m.UploadState",defaultValue:null},url:{type:"string",defaultValue:null},visibleRemove:{type:"boolean",defaultValue:true},visibleEdit:{type:"boolean",defaultValue:true}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"},statuses:{type:"sap.m.ObjectStatus",multiple:true,singularName:"status"}},events:{openPressed:{item:{type:"sap.m.upload.UploadSetItem"},allowPreventDefault:true},removePressed:{item:{type:"sap.m.upload.UploadSetItem"},allowPreventDefault:true}}}});
var i=M.UploadState,j=M.FlexJustifyContent,k=C.ValueState;
var D=H.extend("sap.m.upload.DynamicItemContent",{
metadata:{library:"sap.m",properties:{item:{type:"sap.m.upload.UploadSetItem"}}},
renderer:{render:function(r,o){var l=o.getItem();r.write("<div class=\"sapMUCTextContainer ");if(this._bInEditMode){r.write("sapMUCEditMode ");}r.write("\" >");r.write("<div style=\"display:flex;\">");r.renderControl(l._bInEditMode?l._getFileNameEdit():l._getFileNameLink());l._renderMarkers(r);r.write("</div>");l._renderAttributes(r);l._renderStatuses(r);r.write("</div>");l._renderStateAndProgress(r);l._renderButtons(r);}}
});
U.DYNAMIC_CONTENT_SEPARATOR="<div class=\"sapMUCSeparator\">&nbsp&#x00B7&#160</div>";U.MEGABYTE=1048576;U.IMAGE_FILE_ICON="sap-icon://card";
U.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oListItem=null;this._oIcon=null;this._oFileNameLink=null;this._oFileNameEdit=null;this._oDynamicContent=null;this._oRestartButton=null;this._oEditButton=null;this._oDeleteButton=null;this._oTerminateButton=null;this._oConfirmRenameButton=null;this._oCancelRenameButton=null;this._oProgressBox=null;this._oProgressIndicator=null;this._oStateLabel=null;this._oProgressLabel=null;this._oFileObject=null;this._fFileSize=null;this._bInEditMode=false;this._bContainsError=false;this._bFileTypeRestricted=false;this._bNameLengthRestricted=false;this._bSizeRestricted=false;this._bMediaTypeRestricted=false;};
U.prototype.setFileName=function(s){var o;if(this.getFileName()!==s){this.setProperty("fileName",s,true);if(this.getParent()){this._getFileNameLink().setText(s);o=U._splitFileName(s);this._getFileNameEdit().setValue(o.name);this._checkNameLengthRestriction(this.getParent().getMaxFileNameLength());this._checkTypeRestriction(this.getParent().getFileTypes());}}return this;};
U.prototype.setUploadState=function(u){var o=this._getProgressIndicator(),s=this._getStateLabel(),l=(u!==i.Complete),m=(u===i.Uploading);this.setProperty("uploadState",u,true);o.setVisible(l);s.setVisible(l);this._getProgressLabel().setVisible(l);switch(u){case i.Complete:o.setState(k.None);s.setText("");break;case i.Error:o.setState(k.Error);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_ERROR_STATE"));break;case i.Ready:o.setState(k.None);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_READY_STATE"));break;case i.Uploading:o.setState(k.Information);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_UPLOADING_STATE"));break;}if(this.getParent()){this._getRestartButton().setVisible(u===i.Error);this._getEditButton().setVisible(!m);this._getDeleteButton().setVisible(!m);this._getTerminateButton().setVisible(this.getParent().getTerminationEnabled()&&m);}return this;};
U.prototype.setEnabledRemove=function(l){if(this.getEnabledRemove()!==l){this.setProperty("enabledRemove",l,true);if(this.getParent()){this._getDeleteButton().setEnabled(l);}}return this;};
U.prototype.setVisibleRemove=function(v){if(this.getVisibleRemove()!==v){this.setProperty("visibleRemove",v,true);if(this.getParent()){this._getDeleteButton().setVisible(v);}}return this;};
U.prototype.setEnabledEdit=function(l){if(this.getEnabledEdit()!==l){this.setProperty("enabledEdit",l,true);if(this.getParent()){this._getEditButton().setEnabled(l);}}return this;};
U.prototype.setVisibleEdit=function(v){if(this.getVisibleEdit()!==v){this.setProperty("visibleEdit",v,true);if(this.getParent()){this._getEditButton().setVisible(v);}}return this;};
U.prototype.getFileObject=function(){return this._oFileObject;};
U.prototype.getListItem=function(){return this._getListItem();};
U.prototype.setProgress=function(p){var $;this._getProgressLabel().setText(p+"%");$=this.$("-busyIndicator");if(p===100){$.attr("aria-label",this._oRb.getText("UPLOAD_SET_UPLOAD_COMPLETED"));}else{$.attr("aria-valuenow",p);}this._getProgressIndicator().setPercentValue(p);return this;};
U.prototype.download=function(A){var p=this.getParent();if(!p){L.warning("Download cannot proceed without a parent association.");return false;}return p._getActiveUploader().downloadItem(this,[],A);};
U.prototype._handleFileNamePressed=function(){if(this.fireOpenPressed({item:this})){M.URLHelper.redirect(this.getUrl(),true);}};
U.prototype._getListItem=function(){if(!this._oListItem){this._oListItem=new c(this.getId()+"-listItem",{content:[this._getIcon(),this._getDynamicContent()]});this._oListItem.addStyleClass("sapMUCItem");}return this._oListItem;};
U.prototype._setFileObject=function(o){this._oFileObject=o;if(o){this._fFileSize=o.size/U.MEGABYTE;this.setMediaType(o.type);}else{this._fFileSize=null;this.setMediaType(null);}if(this.getParent()){this._checkSizeRestriction(this.getParent().getMaxFileSize());this._checkMediaTypeRestriction(this.getParent().getMediaTypes());}};
U.prototype._getIcon=function(){if(!this._oIcon){if(this.getThumbnailUrl()){this._oIcon=a.createControlByURI({id:this.getId()+"-thumbnail",src:this.getThumbnailUrl(),decorative:false},d);this._oIcon.addStyleClass("sapMUCItemImage sapMUCItemIcon");}else{this._oIcon=new I(this.getId()+"-icon",{src:this._getIconByFileType()});this._oIcon.addStyleClass("sapMUCItemIcon");}this.addDependent(this._oIcon);}return this._oIcon;};
U.prototype._getIconByFileType=function(){var s=U._splitFileName(this.getFileName()).extension;if(!s){return"";}switch(s.toLowerCase()){case"bmp":case"jpg":case"jpeg":case"png":return U.IMAGE_FILE_ICON;case"csv":case"xls":case"xlsx":return"sap-icon://excel-attachment";case"doc":case"docx":case"odt":return"sap-icon://doc-attachment";case"pdf":return"sap-icon://pdf-attachment";case"ppt":case"pptx":return"sap-icon://ppt-attachment";case"txt":return"sap-icon://document-text";default:return"sap-icon://document";}};
U.prototype._getFileNameLink=function(){if(!this._oFileNameLink){this._oFileNameLink=new g({id:this.getId()+"-fileNameLink",text:this.getFileName(),press:[this,this._handleFileNamePressed,this]});this._oFileNameLink.addStyleClass("sapMUCFileName");this._oFileNameLink.addStyleClass("sapMUSFileName");this.addDependent(this._oFileNameLink);}this._oFileNameLink.setEnabled(!!this.getUrl());return this._oFileNameLink;};
U.prototype._getDynamicContent=function(){if(!this._oDynamicContent){this._oDynamicContent=new D({item:this});this.addDependent(this._oDynamicContent);}return this._oDynamicContent;};
U.prototype._getRestartButton=function(){var p=this.getParent();if(!this._oRestartButton){this._oRestartButton=new b({id:this.getId()+"-restartButton",icon:"sap-icon://refresh",type:M.ButtonType.Standard,visible:this.getUploadState()===i.Error,tooltip:this._oRb.getText("UPLOAD_SET_RESTART_BUTTON_TEXT"),press:[this,p._handleItemRestart,p]});this.addDependent(this._oRestartButton);}return this._oRestartButton;};
U.prototype._getEditButton=function(){var p=this.getParent();if(!this._oEditButton){this._oEditButton=new b({id:this.getId()+"-editButton",icon:"sap-icon://request",type:M.ButtonType.Standard,enabled:this.getEnabledEdit(),visible:this.getVisibleEdit(),tooltip:this._oRb.getText("UPLOAD_SET_EDIT_BUTTON_TEXT"),press:[this,p._handleItemEdit,p]});this._oEditButton.addStyleClass("sapMUCEditBtn");this.addDependent(this._oEditButton);}return this._oEditButton;};
U.prototype._getFileNameEdit=function(){var s;if(!this._oFileNameEdit){s=U._splitFileName(this.getFileName());this._oFileNameEdit=new e({id:this.getId()+"-fileNameEdit",type:M.InputType.Text});this._oFileNameEdit.addStyleClass("sapMUCEditBox");this._oFileNameEdit.setFieldWidth("75%");this._oFileNameEdit.setDescription(s.extension);this._updateFileNameEdit();this.addDependent(this._oFileNameEdit);}return this._oFileNameEdit;};
U.prototype._updateFileNameEdit=function(){var o=this._getFileNameEdit();if(this._bContainsError){o.setValueState(k.Error);o.setValueStateText("");o.setShowValueStateMessage(true);}else{o.setValueState(k.None);if(o.getValue().length===0){o.setValueStateText(this._oRb.getText("UPLOAD_SET_TYPE_FILE_NAME"));}else{o.setValueStateText(this._oRb.getText("UPLOAD_SET_FILE_NAME_EXISTS"));}o.setShowValueStateMessage(false);}};
U.prototype._setInEditMode=function(l){if(l&&!this._bInEditMode){var s=U._splitFileName(this.getFileName());this._getFileNameEdit().setValue(s.name);}this._bInEditMode=l;this._setContainsError(false);this.invalidate();};
U.prototype._getContainsError=function(){return this._bContainsError;};
U.prototype._setContainsError=function(l){this._bContainsError=l;this._updateFileNameEdit();};
U._splitFileName=function(s,w){var r={};var R=/(?:\.([^.]+))?$/;var l=R.exec(s);r.name=s.slice(0,s.indexOf(l[0]));if(w){r.extension=l[0];}else{r.extension=l[1];}return r;};
U.prototype._getDeleteButton=function(){var p=this.getParent();if(!this._oDeleteButton){this._oDeleteButton=new b({id:this.getId()+"-deleteButton",icon:"sap-icon://sys-cancel",type:M.ButtonType.Standard,enabled:this.getEnabledRemove(),visible:this.getVisibleRemove(),tooltip:this._oRb.getText("UPLOAD_SET_DELETE_BUTTON_TEXT"),press:[this,p._handleItemDelete,p]});this._oDeleteButton.addStyleClass("sapMUCDeleteBtn");this.addDependent(this._oDeleteButton);}return this._oDeleteButton;};
U.prototype._getTerminateButton=function(){var p=this.getParent();if(!this._oTerminateButton){this._oTerminateButton=new b({id:this.getId()+"-terminateButton",icon:"sap-icon://stop",type:M.ButtonType.Standard,visible:p.getTerminationEnabled()&&this.getUploadState()===i.Uploading,tooltip:this._oRb.getText("UPLOAD_SET_TERMINATE_BUTTON_TEXT"),press:[this,p._handleTerminateRequest,p]});this._oTerminateButton.addStyleClass("sapMUCDeleteBtn");this.addDependent(this._oTerminateButton);}return this._oTerminateButton;};
U.prototype._getConfirmRenameButton=function(){var p=this.getParent();if(!this._oConfirmRenameButton){this._oConfirmRenameButton=new b({id:this.getId()+"-okButton",text:this._oRb.getText("UPLOAD_SET_RENAME_BUTTON_TEXT"),type:M.ButtonType.Transparent,press:[this,p._handleItemEditConfirmation,p]});this._oConfirmRenameButton.addStyleClass("sapMUCOkBtn");this.addDependent(this._oConfirmRenameButton);}return this._oConfirmRenameButton;};
U.prototype._getCancelRenameButton=function(){var p=this.getParent();if(!this._oCancelRenameButton){this._oCancelRenameButton=new b({id:this.getId()+"-cancelButton",text:this._oRb.getText("UPLOAD_SET_CANCEL_BUTTON_TEXT"),type:M.ButtonType.Transparent,press:[this,p._handleItemEditCancelation,p]});this._oCancelRenameButton.addStyleClass("sapMUCCancelBtn");this.addDependent(this._oCancelRenameButton);}return this._oCancelRenameButton;};
U.prototype._getProgressBox=function(){if(!this._oProgressBox){this._oProgressBox=new V({id:this.getId()+"-progressBox",items:[this._getProgressIndicator(),new h({justifyContent:j.SpaceBetween,items:[this._getStateLabel(),this._getProgressLabel()]})],width:"20%"});this._oProgressBox.addStyleClass("sapMUSProgressBox");this.addDependent(this._oProgressBox);}return this._oProgressBox;};
U.prototype._getProgressIndicator=function(){if(!this._oProgressIndicator){this._oProgressIndicator=new P({id:this.getId()+"-progressIndicator",percentValue:0,state:k.Information,visible:this.getUploadState()!==i.Complete});this._oProgressIndicator.addStyleClass("sapMUSProgressIndicator");}return this._oProgressIndicator;};
U.prototype._getStateLabel=function(){if(!this._oStateLabel){this._oStateLabel=new f({id:this.getId()+"-stateLabel",text:"Pending",visible:this.getUploadState()!==i.Complete});}return this._oStateLabel;};
U.prototype._getProgressLabel=function(){if(!this._oProgressLabel){this._oProgressLabel=new f({id:this.getId()+"-progressLabel",visible:this.getUploadState()!==i.Complete});this.setProgress(0);this.addDependent(this._oProgressLabel);}return this._oProgressLabel;};
U.prototype._renderAttributes=function(r){var l=this.getAttributes().length-1;if(this.getAttributes().length>0){r.write("<div class=\"sapMUCAttrContainer\">");this.getAttributes().forEach(function(A,m){r.renderControl(A.addStyleClass("sapMUCAttr"));if(m<l){r.write(U.DYNAMIC_CONTENT_SEPARATOR);}});r.write("</div>");}};
U.prototype._renderMarkers=function(r){if(this.getMarkers().length>0){r.write("<div class=\"sapMUSObjectMarkerContainer\">");this.getMarkers().forEach(function(m){r.renderControl(m.addStyleClass("sapMUCObjectMarker"));});r.write("</div>");}};
U.prototype._renderStatuses=function(r){var l=this.getStatuses().length-1;if(this.getStatuses().length>0){r.write("<div class=\"sapMUCStatusContainer\">");this.getStatuses().forEach(function(s,m){r.renderControl(s);if(m<l){r.write(U.DYNAMIC_CONTENT_SEPARATOR);}});r.write("</div>");}};
U.prototype._renderStateAndProgress=function(r){r.renderControl(this._getProgressBox());};
U.prototype._renderButtons=function(r){var l;if(this._bInEditMode){l=[this._getConfirmRenameButton(),this._getCancelRenameButton()];}else{l=[this._getRestartButton(),this._getEditButton(),this._getDeleteButton(),this._getTerminateButton()];}if(l.length>0){r.write("<div class=\"sapMUCButtonContainer\">");l.forEach(function(o,m){if(m<(l.length-1)){o.addStyleClass("sapMUCFirstButton");}r.renderControl(o);});r.write("</div>");}};
U.prototype._checkTypeRestriction=function(t){var o=U._splitFileName(this.getFileName()),r=(!!this.getFileName()&&!!t&&(t.length>0)&&o.extension&&t.indexOf(o.extension.toLowerCase())===-1);if(r!==this._bFileTypeRestricted){this._bFileTypeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileTypeMismatch({item:this});}}};
U.prototype._checkNameLengthRestriction=function(m){var r=(m&&!!this.getFileName()&&this.getFileName().length>m);if(r!==this._bNameLengthRestricted){this._bNameLengthRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileNameLengthExceeded({item:this});}}};
U.prototype._checkSizeRestriction=function(m){var r=(m&&this._fFileSize>m);if(r!==this._bSizeRestricted){this._bSizeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileSizeExceeded({item:this});}}};
U.prototype._checkMediaTypeRestriction=function(t){var r=(!!t&&(t.length>0)&&!!this.getMediaType()&&t.indexOf(this.getMediaType())===-1);if(r!==this._bMediaTypeRestricted){this._bMediaTypeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireMediaTypeMismatch({item:this});}}};
U.prototype._isRestricted=function(){return this._bFileTypeRestricted||this._bNameLengthRestricted||this._bSizeRestricted||this._bMediaTypeRestricted;};
return U;});
sap.ui.predefine('sap/m/upload/UploadSetRenderer',['sap/m/ListItemBaseRenderer'],function(L){"use strict";var U={};
U.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMUC");r.writeClasses();r.write(">");this.renderDragDropOverlay(r,c);this.renderList(r,c);r.write("</div>");};
U.renderDragDropOverlay=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-drag-drop-area");r.addClass("sapMUCDragDropOverlay");r.addClass("sapMUCDragDropOverlayHide");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMUCDragDropIndicator");r.writeClasses();r.write(">");r.write("</div>");r.write("</div>");};
U.renderList=function(r,c){var o=c.getList().getRenderer().renderNoData;c.getList().getRenderer().renderNoData=this.renderNoData;r.renderControl(c.getList());c.getList().getRenderer().renderNoData=o;};
U.renderNoData=function(r,c){var u=c.getParent();r.write("<li");r.writeAttribute("tabindex",0);r.writeAttribute("id",u.getList().getId("nodata"));r.addClass("sapMLIB sapMUCNoDataPage");L.addFocusableClasses.call(L,r);r.writeClasses();r.write(">");r.renderControl(u._oNoDataIcon);r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-text");r.addClass("sapMUCNoDataText");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataText());r.write("</div>");if(u.getUploadEnabled()){r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-description");r.addClass("sapMUCNoDataDescription");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataDescription());r.write("</div>");}r.write("</li>");};
return U;});
sap.ui.predefine('sap/m/upload/Uploader',["sap/base/Log","sap/m/library","sap/ui/core/Element","sap/ui/core/util/File","sap/ui/Device","sap/ui/core/Item","sap/m/upload/UploadSetItem"],function(L,M,E,F,D,H,U){"use strict";
var a=E.extend("sap.m.upload.Uploader",{metadata:{library:"sap.m",publicMethods:["uploadItem","terminateItem","downloadItem"],properties:{uploadUrl:{type:"string",defaultValue:null},downloadUrl:{type:"string",defaultValue:null}},events:{uploadStarted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},uploadProgressed:{parameters:{item:{type:"sap.m.upload.UploadSetItem"},loaded:{type:"long"},total:{type:"long"}}},uploadCompleted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},uploadAborted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}}}}});
a.prototype.init=function(){this._mRequestHandlers={};};
a.uploadFile=function(f,u,h){var x=new window.XMLHttpRequest();return new Promise(function(r,b){x.open("POST",u,true);if((D.browser.edge||D.browser.internet_explorer)&&f.type&&x.readyState===1){x.setRequestHeader("Content-Type",f.type);}if(h){h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});}x.onreadystatechange=function(){if(this.readyState===window.XMLHttpRequest.DONE){if(this.status===200){r(this);}else{b(this);}}};x.send(f);});};
a.prototype.uploadItem=function(i,h){var x=new window.XMLHttpRequest(),f=i.getFileObject(),t=this,r={xhr:x,item:i};x.open("POST",this.getUploadUrl(),true);if((D.browser.edge||D.browser.internet_explorer)&&f.type&&x.readyState===1){x.setRequestHeader("Content-Type",f.type);}if(h){h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});}x.upload.addEventListener("progress",function(e){t.fireUploadProgressed({item:i,loaded:e.loaded,total:e.total,aborted:false});});x.onreadystatechange=function(){var o=t._mRequestHandlers[i.getId()];if(this.readyState===window.XMLHttpRequest.DONE&&!o.aborted){t.fireUploadCompleted({item:i});}};this._mRequestHandlers[i.getId()]=r;x.send(i.getFileObject());this.fireUploadStarted({item:i});};
a.prototype.terminateItem=function(i){var h=this._mRequestHandlers[i.getId()],t=this;h.xhr.onabort=function(){h.aborted=false;t.fireUploadAborted({item:i});};h.aborted=true;h.xhr.abort();};
a.prototype.downloadItem=function(i,h,A){var u=this.getDownloadUrl()||i.getUrl();if(D.browser.name==="sf"){A=false;}if(!i.getUrl()){L.warning("Items to download do not have a URL.");return false;}else if(A){var b=null,x=new window.XMLHttpRequest();x.open("GET",u);h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});x.responseType="blob";x.onload=function(){var f=i.getFileName(),s=U._splitFileName(f,false);b=x.response;F.save(b,s.name,s.extension,i.getMediaType(),"utf-8");};x.send();return true;}else{M.URLHelper.redirect(u,true);return true;}};
return a;});
sap.ui.predefine('sap/m/Wizard',["sap/m/library","sap/ui/core/Control","sap/ui/core/Core","sap/ui/core/delegate/ScrollEnablement","./WizardProgressNavigator","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/Device","./WizardRenderer","sap/ui/dom/containsOrEquals","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,a,S,W,R,D,b,c,L,q){"use strict";var d=l.PageBackgroundDesign;
var e=C.extend("sap.m.Wizard",{metadata:{library:"sap.m",designtime:"sap/m/designtime/Wizard.designtime",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},showNextButton:{type:"boolean",group:"Behavior",defaultValue:true},finishButtonText:{type:"string",group:"Appearance",defaultValue:"Review"},enableBranching:{type:"boolean",group:"Behavior",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:d.Standard}},defaultAggregation:"steps",aggregations:{steps:{type:"sap.m.WizardStep",multiple:true,singularName:"step"},_progressNavigator:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{
/**
					 * This association controls the current activated step of the wizard (meaning the last step)
					 * For example if we have A->B->C->D steps, we are on step A and we setCurrentStep(C) A,B and C are going to be activated. D will still remain unvisited.
					 * The parameter needs to be a Wizard step that is part of the current Wizard
					 * @since 1.50
					 */
currentStep:{type:"sap.m.WizardStep",multiple:false}},events:{stepActivate:{parameters:{index:{type:"int"}}},complete:{parameters:{}}},dnd:{draggable:false,droppable:true}}});
e.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,ANIMATION_TIME:300,SCROLL_OFFSET:16};R.call(e.prototype,{header:{suffix:"progressNavigator"},content:{suffix:"step-container"}});
e.prototype.init=function(){this._iStepCount=0;this._aStepPath=[];this._bScrollLocked=false;this._oScroller=this._initScrollEnablement();this._oResourceBundle=a.getLibraryResourceBundle("sap.m");this._fnHandleNextButtonPressListener=this._handleNextButtonPress.bind(this);this._initProgressNavigator();this._initResponsivePaddingsEnablement();};
e.prototype.onBeforeRendering=function(){var s=this._getStartingStep();if(!this._isMinStepCountReached()||this._isMaxStepCountExceeded()){L.error("The Wizard is supposed to handle from 3 to 8 steps.");}this._saveInitialValidatedState();if(s&&this._aStepPath.indexOf(s)<0){this._activateStep(s);s._setNumberInvisibleText(1);}};
e.prototype.onAfterRendering=function(){if(!this.getCurrentStep()){this.setAssociation("currentStep",this._getStartingStep(),true);}var s=this._getCurrentStepInstance();this._activateAllPreceedingSteps(s);this._attachScrollHandler();};
e.prototype.exit=function(){var o=this.getDomRef("step-container");if(o){o.onscroll=null;}this._oScroller.destroy();this._oScroller=null;this._aStepPath=null;this._iStepCount=null;this._bScrollLocked=null;this._oResourceBundle=null;this._fnHandleNextButtonPressListener=null;};
e.prototype.validateStep=function(s){if(!this._containsStep(s)){L.error("The wizard does not contain this step");return this;}s.setValidated(true);return this;};
e.prototype.invalidateStep=function(s){if(!this._containsStep(s)){L.error("The wizard does not contain this step");return this;}s.setValidated(false);return this;};
e.prototype.nextStep=function(){var i=this._getProgressNavigator().getProgress()-1;var o=this._aStepPath[i];this.validateStep(o);o._complete();return this;};
e.prototype.previousStep=function(){var p=this._getProgressNavigator().getProgress()-2;if(p>=0){this.discardProgress(this._aStepPath[p]);}return this;};
e.prototype.getProgress=function(){return this._getProgressNavigator().getProgress();};
e.prototype.getProgressStep=function(){return this._aStepPath[this.getProgress()-1];};
e.prototype.goToStep=function(s,f){if(!this.getVisible()||this._aStepPath.indexOf(s)<0){return this;}s._setNumberInvisibleText(this.getProgress());var t=this,m={scrollTop:this._getStepScrollOffset(s)},A={queue:false,duration:e.CONSTANTS.ANIMATION_TIME,start:function(){t._bScrollLocked=true;},complete:function(){t._bScrollLocked=false;var p=t._getProgressNavigator();if(!p){return;}p._updateCurrentStep(t._aStepPath.indexOf(s)+1);if(f||f===undefined){t._focusFirstStepElement(s);}}};q(this.getDomRef("step-container")).animate(m,A);return this;};
e.prototype.discardProgress=function(s,p){var P=this.getProgress(),f=this._aStepPath,I=this._aStepPath.indexOf(s),o=this._aStepPath[I],g=I+1;if(g>P||g<=0){L.warning("The given step is either not yet reached, or is not present in the wizard control.");return this;}this._getProgressNavigator().discardProgress(g,true);this._updateProgressNavigator();this._restoreInitialValidatedState(g);for(var i=g;i<f.length;i++){f[i]._deactivate();if(f[i].getSubsequentSteps().length>1){f[i].setNextStep(null);}}this.setAssociation("currentStep",s);o.setWizardContext({sButtonText:this._getNextButtonText(),bLast:true});if(s.getSubsequentSteps().length>1&&!p){s.setNextStep(null);}f.splice(g);return this;};
e.prototype.setCurrentStep=function(s){var o=(typeof s==="string")?a.byId(s):s;if(!this.getEnableBranching()){this.setAssociation("currentStep",s,true);}if(o&&this._isStepReachable(o)){this._activateAllPreceedingSteps(o);}else{L.error("The given step could not be set as current step.");}return this;};
e.prototype.setShowNextButton=function(v){this.setProperty("showNextButton",v,true);this.getSteps().forEach(function(s){s.setWizardContext({bParentAllowsButtonShow:v});});return this;};
e.prototype.setFinishButtonText=function(v){this.setProperty("finishButtonText",v,true);return this;};
e.prototype.getFinishButtonText=function(){if(this.getProperty("finishButtonText")==="Review"){return this._oResourceBundle.getText("WIZARD_FINISH");}else{return this.getProperty("finishButtonText");}};
e.prototype.addStep=function(w){if(this._isMaxStepCountExceeded()){L.error("The Wizard is supposed to handle up to 8 steps.");return this;}w.setWizardContext({bParentAllowsButtonShow:this.getShowNextButton()});w.attachComplete(this._fnHandleNextButtonPressListener);this._incrementStepCount();return this.addAggregation("steps",w);};
e.prototype.setBackgroundDesign=function(B){var s=this.getBackgroundDesign();this.setProperty("backgroundDesign",B,true);this.$().removeClass("sapMWizardBg"+s).addClass("sapMWizardBg"+this.getBackgroundDesign());return this;};
e.prototype.insertStep=function(w,i){throw new Error("Dynamic step insertion is not yet supported.");};
e.prototype.removeStep=function(w){throw new Error("Dynamic step removal is not yet supported.");};
e.prototype.removeAllSteps=function(){this._resetStepCount();return this.removeAllAggregation("steps").map(function(s){s.detachComplete(this._fnHandleNextButtonPressListener);return s;},this);};
e.prototype.destroySteps=function(){this._resetStepCount();return this.destroyAggregation("steps");};
e.prototype._activateAllPreceedingSteps=function(s){if(this._aStepPath.indexOf(s)>=0){this.discardProgress(s,true);return;}while(this.getProgressStep()!==s){this.nextStep();}};
e.prototype._isNextStepDetermined=function(s,p){if(!this.getEnableBranching()){return true;}s=s||this._getCurrentStepInstance();return this._getNextStep(s,p)!==null;};
e.prototype._isStepReachable=function(s){if(this.getEnableBranching()){var o=this._getStartingStep();while(o!==s){o=o._getNextStepReference();if(o==null){return false;}}this.setAssociation("currentStep",s);return true;}else{return this.getSteps().indexOf(s)>=0;}};
e.prototype._initScrollEnablement=function(){return new S(this,null,{scrollContainerId:this.getId()+"-step-container",horizontal:false,vertical:true});};
e.prototype._initProgressNavigator=function(){var t=this,p=new W(this.getId()+"-progressNavigator",{stepChanged:this._handleStepChanged.bind(this)});p._setOnEnter(function(E,s){var o=t._aStepPath[s];setTimeout(function(){this._focusFirstStepElement(o);}.bind(t),e.CONSTANTS.ANIMATION_TIME);});this.setAggregation("_progressNavigator",p);};
e.prototype._handleNextButtonPress=function(){var p=this._getProgressNavigator(),P=p.getProgress(),s=this.isStepFinal();if(s){this.fireComplete();}else{var o=this.getProgressStep();if(!this._isNextStepDetermined(o,P)){throw new Error("The wizard is in branching mode, and the nextStep association is not set.");}p.incrementProgress();this._handleStepActivated(p.getProgress());this._handleStepChanged(p.getProgress());}};
e.prototype._getStepScrollOffset=function(s){var i=this._oScroller.getScrollTop(),p=this._getCurrentStepInstance(),n=this._getNextButton(),A=0,f=0;if(s&&s.$()&&s.$().position()){f=s.$().position().top||0;}if(!D.system.phone&&p&&n&&!c(p.getDomRef(),n.getDomRef())){A=n.$().outerHeight();}return(i+f)-(e.CONSTANTS.SCROLL_OFFSET+A);};
e.prototype._focusFirstStepElement=function(s){var $=s.$();if($&&$.firstFocusableDomRef()){$.firstFocusableDomRef().focus();}};
e.prototype._handleStepChanged=function(E){var p=((typeof E==="number")?E:E.getParameter("current"))-2,P=this._aStepPath[p],s=this._getNextStep(P,p),f=D.system.desktop?true:false;this.goToStep(s,f);};
e.prototype._handleStepActivated=function(i){var p=i-2,P=this._aStepPath[p],n=this._getNextStep(P,p);this._activateStep(n);this._updateProgressNavigator();this.fireStepActivate({index:i});this.setAssociation("currentStep",this.getProgressStep(),true);this.getProgressStep().setWizardContext({bLast:true,bReviewStep:this.isStepFinal(),sButtonText:this._getNextButtonText()});};
e.prototype._isMaxStepCountExceeded=function(){var s=this._getStepCount();if(this.getEnableBranching()){return false;}return s>=e.CONSTANTS.MAXIMUM_STEPS;};
e.prototype._isMinStepCountReached=function(){var s=this._getStepCount();return s>=e.CONSTANTS.MINIMUM_STEPS;};
e.prototype._getStepCount=function(){return this._iStepCount;};
e.prototype._incrementStepCount=function(){this._iStepCount+=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
e.prototype._decrementStepCount=function(){this._iStepCount-=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
e.prototype._resetStepCount=function(){this._iStepCount=0;this._getProgressNavigator().setStepCount(this._getStepCount());};
e.prototype._getProgressNavigator=function(){return this.getAggregation("_progressNavigator");};
e.prototype._saveInitialValidatedState=function(){if(this._aInitialValidatedState){return;}this._aInitialValidatedState=this.getSteps().map(function(s){return s.getValidated();});};
e.prototype._restoreInitialValidatedState=function(I){var s=this._aStepPath,A=this.getSteps();for(var i=I;i<s.length;i++){var o=s[i],f=A.indexOf(o),g=this._aInitialValidatedState[f];o.setValidated(g);}};
e.prototype._getNextStep=function(s,p){if(!this.getEnableBranching()){return this.getSteps()[p+1];}if(p<0){return this._getStartingStep();}var n=s._getNextStepReference();if(n===null){throw new Error("The wizard is in branching mode, and no next step is defined for "+"the current step, please set one.");}if(!this._containsStep(n)){throw new Error("The next step that you have defined is not part of the wizard steps aggregation."+"Please add it to the wizard control.");}var f=s.getSubsequentSteps();if(f.length>0&&!s._containsSubsequentStep(n.getId())){throw new Error("The next step that you have defined is not contained inside the subsequentSteps"+" association of the current step.");}return n;};
e.prototype.isStepFinal=function(){var s,i=this._getStepCount(),p=this.getProgress();if(this.getEnableBranching()){s=this._aStepPath[this._aStepPath.length-1]._isLeaf();}else{s=p===i;}return s;};
e.prototype._getNextButtonText=function(){if(this.isStepFinal()){return this.getFinishButtonText();}else{return this._oResourceBundle.getText("WIZARD_STEP")+" "+(this.getProgress()+1);}};
e.prototype._getNextButton=function(){var s=this._getCurrentStepInstance();if(s){return s.getAggregation("_nextButton");}else{return null;}};
e.prototype._updateProgressNavigator=function(){var p=this._getProgressNavigator(),o=this._getStartingStep(),A=this.getSteps(),s=[o.getTitle()],f=[o.getIcon()],g=[o.getOptional()],i=1;if(this.getEnableBranching()){while(!o._isLeaf()&&o._getNextStepReference()!==null){i++;o=o._getNextStepReference();s.push(o.getTitle());g.push(o.getOptional());f.push(o.getIcon());}p.setVaryingStepCount(o._isBranched());p.setStepCount(i);}else{s=A.map(function(h){return h.getTitle();});g=A.map(function(h){return h.getOptional();});f=A.map(function(h){return h.getIcon();});}p.setStepTitles(s);p._aStepOptionalIndication=g;p.setStepIcons(f);};
e.prototype._getStartingStep=function(){return this.getSteps()[0];};
e.prototype._attachScrollHandler=function(){var o=this.getDomRef("step-container");o.onscroll=this._scrollHandler.bind(this);};
e.prototype._scrollHandler=function(E){if(this._bScrollLocked){return;}var s=E.target.scrollTop,p=this._getProgressNavigator(),o=this._aStepPath[p.getCurrentStep()-1].getDomRef();if(!o){return;}var i=o.clientHeight,f=o.offsetTop,g=100;if(s+g>=f+i&&p._isActiveStep(p._iCurrentStep+1)){p.nextStep();}while(s+g<=f){p.previousStep();o=this._aStepPath[p.getCurrentStep()-1].getDomRef();if(!o){return;}f=o.offsetTop;}};
e.prototype._getCurrentStepInstance=function(){return a.byId(this.getCurrentStep());};
e.prototype._containsStep=function(s){return this.getSteps().some(function(o){return o===s;});};
e.prototype._checkCircularReference=function(s){if(this._aStepPath.indexOf(s)>=0){throw new Error("The step that you are trying to activate has already been visited. You are creating "+"a loop inside the wizard.");}};
e.prototype._activateStep=function(s){this._checkCircularReference(s);this._aStepPath.push(s);s._activate();};
return e;});
sap.ui.require.preload({
	"sap/m/MultiEditField.control.xml":'<core:FragmentDefinition xmlns:m="sap.m" xmlns:core="sap.ui.core" type="XML"><m:Select id="select" width="100%" items="{$this&gt;items}" change="_handleSelectionChange"><m:items><core:Item text="{$this&gt;text}" key="{$this&gt;key}" id="itemTemplate"/></m:items></m:Select></core:FragmentDefinition>',
	"sap/m/manifest.json":'{"_version":"1.9.0","sap.app":{"id":"sap.m","type":"library","embeds":[],"applicationVersion":{"version":"1.72.0"},"title":"The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.","description":"The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.","ach":"CA-UI5-CTR","resources":"resources.json","offline":true},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.72","libs":{"sap.ui.core":{"minVersion":"1.72.0"},"sap.ui.layout":{"minVersion":"1.72.0","lazy":true},"sap.ui.unified":{"minVersion":"1.72.0","lazy":true}}},"library":{"i18n":"messagebundle.properties","content":{"controls":["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnHeaderPopover","sap.m.ColumnListItem","sap.m.ColorPalette","sap.m.ColorPalettePopover","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.CustomTreeItem","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeField","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTag","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.HeaderContainer","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabHeader","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageView","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiEditField","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.PlanningCalendarLegend","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.OverflowToolbarToggleButton","sap.m.P13nColumnsPanel","sap.m.P13nGroupPanel","sap.m.P13nSelectionPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PDFViewer","sap.m.PlanningCalendar","sap.m.PlanningCalendarHeader","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewBase","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectList","sap.m.SelectionDetails","sap.m.Shell","sap.m.SimpleFixFlex","sap.m.SinglePlanningCalendar","sap.m.SinglePlanningCalendarGrid","sap.m.SinglePlanningCalendarMonthGrid","sap.m.Slider","sap.m.SliderTooltip","sap.m.SliderTooltipBase","sap.m.SliderTooltipContainer","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.TimePickerSliders","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.upload.UploadSet","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.Wizard","sap.m.WizardStep","sap.m.semantic.DetailPage","sap.m.semantic.SemanticPage","sap.m.semantic.ShareMenuPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage"],"elements":["sap.m.Column","sap.m.ColumnPopoverActionItem","sap.m.ColumnPopoverCustomItem","sap.m.ColumnPopoverItem","sap.m.ColumnPopoverSortItem","sap.m.FlexItemData","sap.m.FeedListItemAction","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessageItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nGroupItem","sap.m.P13nSortItem","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.ResponsiveScale","sap.m.SegmentedButtonItem","sap.m.SelectionDetailsItem","sap.m.SelectionDetailsItemLine","sap.m.SinglePlanningCalendarDayView","sap.m.SinglePlanningCalendarWeekView","sap.m.SinglePlanningCalendarWorkWeekView","sap.m.SinglePlanningCalendarView","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.TabStripItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.upload.Uploader","sap.m.upload.UploadSetItem","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.semantic.AddAction","sap.m.semantic.CancelAction","sap.m.semantic.DeleteAction","sap.m.semantic.DiscussInJamAction","sap.m.semantic.EditAction","sap.m.semantic.FavoriteAction","sap.m.semantic.FilterAction","sap.m.semantic.FilterSelect","sap.m.semantic.FlagAction","sap.m.semantic.ForwardAction","sap.m.semantic.GroupAction","sap.m.semantic.GroupSelect","sap.m.semantic.MainAction","sap.m.semantic.MessagesIndicator","sap.m.semantic.MultiSelectAction","sap.m.semantic.NegativeAction","sap.m.semantic.OpenInAction","sap.m.semantic.PositiveAction","sap.m.semantic.PrintAction","sap.m.semantic.SaveAction","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticControl","sap.m.semantic.SemanticSelect","sap.m.semantic.SemanticToggleButton","sap.m.semantic.SendEmailAction","sap.m.semantic.SendMessageAction","sap.m.semantic.ShareInJamAction","sap.m.semantic.SortAction","sap.m.semantic.SortSelect"],"types":["sap.m.BackgroundDesign","sap.m.BarDesign","sap.m.BreadcrumbsSeparatorStyle","sap.m.ButtonType","sap.m.CarouselArrowsPlacement","sap.m.DateTimeInputType","sap.m.DeviationIndicator","sap.m.DialogRoleType","sap.m.DialogType","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignContent","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FlexWrap","sap.m.FrameType","sap.m.GenericTagDesign","sap.m.GenericTagValueState","sap.m.GenericTileMode","sap.m.GenericTileScope","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabDensityMode","sap.m.IconTabFilterDesign","sap.m.IconTabHeaderMode","sap.m.ImageMode","sap.m.InputTextFormatMode","sap.m.InputType","sap.m.LabelDesign","sap.m.LightBoxLoadingStates","sap.m.LinkConversion","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.ObjectHeaderPictureShape","sap.m.ObjectMarkerType","sap.m.ObjectMarkerVisibility","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.PageBackgroundDesign","sap.m.PanelAccessibleRole","sap.m.PDFViewerDisplayType","sap.m.PlacementType","sap.m.PlanningCalendarBuiltInView","sap.m.PlanningCalendarStickyMode","sap.m.PopinDisplay","sap.m.PopinLayout","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectionDetailsActionLevel","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.Size","sap.m.SplitAppMode","sap.m.StandardTileType","sap.m.StepInputStepModeType","sap.m.StepInputValidationMode","sap.m.Sticky","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.TileSizeBehavior","sap.m.TimePickerMaskMode","sap.m.TitleAlignment","sap.m.ToolbarDesign","sap.m.ToolbarStyle","sap.m.UploadState","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.VerticalPlacementType","sap.m.WrappingType","sap.m.semantic.SemanticRuleSetType"],"interfaces":["sap.m.IBar","sap.m.IBreadcrumbs","sap.m.IconTab","sap.m.IScale","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer","sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent","sap.m.IHyphenation"]}}}}',
/*!
 * OpenUI5
 * (c) Copyright 2009-2019 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
	"sap/m/SelectionDetailsFacade.js":function(){
}
},"sap/m/library-preload"
);
//# sourceMappingURL=library-preload.js.map